unit DInputFPC;

{$I SWITCHES.INC}

interface

uses
	windows, DirectDraw, DirectInput;


// IDirectInputEffect interface methods

function IDirectInputEffect_QueryInterface(idd : IDirectInputEffect; const IID : TGUID; var obj) : HRESULT; stdcall;
function IDirectInputEffect_AddRef(idd : IDirectInputEffect) : Longint; stdcall;
function IDirectInputEffect_Release(idd : IDirectInputEffect) : Longint; stdcall;
function IDirectInputEffect_Initialize(idd : IDirectInputEffect; hinst : THandle; dwVersion : DWORD; const rguid : TGUID) : HResult; stdcall;
function IDirectInputEffect_GetEffectGuid(idd : IDirectInputEffect; var pguid : TGUID) : HResult; stdcall;
function IDirectInputEffect_GetParameters(idd : IDirectInputEffect; var peff : TDIEffect; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputEffect_SetParameters(idd : IDirectInputEffect; var peff : TDIEffect; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputEffect_Start(idd : IDirectInputEffect; dwIterations : DWORD; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputEffect_Stop(idd : IDirectInputEffect) : HResult; stdcall;
function IDirectInputEffect_GetEffectStatus(idd : IDirectInputEffect; var pdwFlags : DWORD) : HResult; stdcall;
function IDirectInputEffect_Download(idd : IDirectInputEffect) : HResult; stdcall;
function IDirectInputEffect_Unload(idd : IDirectInputEffect) : HResult; stdcall;
function IDirectInputEffect_Escape(idd : IDirectInputEffect; var pesc : TDIEffEscape) : HResult; stdcall;

// IDirectInputDeviceA interface methods

function IDirectInputDeviceA_QueryInterface(idd : IDirectInputDeviceA; const IID : TGUID; var obj) : HRESULT; stdcall;
function IDirectInputDeviceA_AddRef(idd : IDirectInputDeviceA) : Longint; stdcall;
function IDirectInputDeviceA_Release(idd : IDirectInputDeviceA) : Longint; stdcall;
function IDirectInputDeviceA_GetCapabilities(idd : IDirectInputDeviceA; var lpDIDevCaps : TDIDevCaps) : HResult; stdcall;
function IDirectInputDeviceA_EnumObjects(idd : IDirectInputDeviceA; lpCallback : TDIEnumDeviceObjectsCallbackA; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDeviceA_GetProperty(idd : IDirectInputDeviceA; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
function IDirectInputDeviceA_SetProperty(idd : IDirectInputDeviceA; rguidProp : PGUID; const pdiph : TDIPropHeader) : HResult; stdcall;
function IDirectInputDeviceA_Acquire(idd : IDirectInputDeviceA) : HResult; stdcall;
function IDirectInputDeviceA_Unacquire(idd : IDirectInputDeviceA) : HResult; stdcall;
function IDirectInputDeviceA_GetDeviceState(idd : IDirectInputDeviceA; cbData : DWORD; lpvData : Pointer) : HResult; stdcall;
function IDirectInputDeviceA_GetDeviceData(idd : IDirectInputDeviceA; cbObjectData : DWORD; rgdod : PDIDeviceObjectData; var pdwInOut : DWORD; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDeviceA_SetDataFormat(idd : IDirectInputDeviceA; var lpdf : TDIDataFormat) : HResult; stdcall;
function IDirectInputDeviceA_SetEventNotification(idd : IDirectInputDeviceA; hEvent : THandle) : HResult; stdcall;
function IDirectInputDeviceA_SetCooperativeLevel(idd : IDirectInputDeviceA; hwnd : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDeviceA_GetObjectInfo(idd : IDirectInputDeviceA; var pdidoi : TDIDeviceObjectInstanceA; dwObj : DWORD; dwHow : DWORD) : HResult; stdcall;
function IDirectInputDeviceA_GetDeviceInfo(idd : IDirectInputDeviceA; var pdidi : TDIDeviceInstanceA) : HResult; stdcall;
function IDirectInputDeviceA_RunControlPanel(idd : IDirectInputDeviceA; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDeviceA_Initialize(idd : IDirectInputDeviceA; hinst : THandle; dwVersion : DWORD; const rguid : TGUID) : HResult; stdcall;

// IDirectInputDeviceW interface methods

function IDirectInputDeviceW_QueryInterface(idd : IDirectInputDeviceW; const IID : TGUID; var obj) : HRESULT; stdcall;
function IDirectInputDeviceW_AddRef(idd : IDirectInputDeviceW) : Longint; stdcall;
function IDirectInputDeviceW_Release(idd : IDirectInputDeviceW) : Longint; stdcall;
function IDirectInputDeviceW_GetCapabilities(idd : IDirectInputDeviceW; var lpDIDevCaps : TDIDevCaps) : HResult; stdcall;
function IDirectInputDeviceW_EnumObjects(idd : IDirectInputDeviceW; lpCallback : TDIEnumDeviceObjectsCallbackW; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDeviceW_GetProperty(idd : IDirectInputDeviceW; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
function IDirectInputDeviceW_SetProperty(idd : IDirectInputDeviceW; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
function IDirectInputDeviceW_Acquire(idd : IDirectInputDeviceW) : HResult; stdcall;
function IDirectInputDeviceW_Unacquire(idd : IDirectInputDeviceW) : HResult; stdcall;
function IDirectInputDeviceW_GetDeviceState(idd : IDirectInputDeviceW; cbData : DWORD; lpvData : Pointer) : HResult; stdcall;
function IDirectInputDeviceW_GetDeviceData(idd : IDirectInputDeviceW; cbObjectData : DWORD; rgdod : PDIDeviceObjectData; var pdwInOut : DWORD; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDeviceW_SetDataFormat(idd : IDirectInputDeviceW; var lpdf : TDIDataFormat) : HResult; stdcall;
function IDirectInputDeviceW_SetEventNotification(idd : IDirectInputDeviceW; hEvent : THandle) : HResult; stdcall;
function IDirectInputDeviceW_SetCooperativeLevel(idd : IDirectInputDeviceW; hwnd : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDeviceW_GetObjectInfo(idd : IDirectInputDeviceW; var pdidoi : TDIDeviceObjectInstanceW; dwObj : DWORD; dwHow : DWORD) : HResult; stdcall;
function IDirectInputDeviceW_GetDeviceInfo(idd : IDirectInputDeviceW; var pdidi : TDIDeviceInstanceW) : HResult; stdcall;
function IDirectInputDeviceW_RunControlPanel(idd : IDirectInputDeviceW; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDeviceW_Initialize(idd : IDirectInputDeviceW; hinst : THandle; dwVersion : DWORD; const rguid : TGUID) : HResult; stdcall;

// IDirectInputDevice2A interface methods

function IDirectInputDevice2A_QueryInterface(idd : IDirectInputDevice2A; const IID : TGUID; var obj) : HRESULT; stdcall;
function IDirectInputDevice2A_AddRef(idd : IDirectInputDevice2A) : Longint; stdcall;
function IDirectInputDevice2A_Release(idd : IDirectInputDevice2A) : Longint; stdcall;
function IDirectInputDevice2A_GetCapabilities(idd : IDirectInputDevice2A; var lpDIDevCaps : TDIDevCaps) : HResult; stdcall;
function IDirectInputDevice2A_EnumObjects(idd : IDirectInputDevice2A; lpCallback : TDIEnumDeviceObjectsCallbackA; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice2A_GetProperty(idd : IDirectInputDevice2A; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
function IDirectInputDevice2A_SetProperty(idd : IDirectInputDevice2A; rguidProp : PGUID; const pdiph : TDIPropHeader) : HResult; stdcall;
function IDirectInputDevice2A_Acquire(idd : IDirectInputDevice2A) : HResult; stdcall;
function IDirectInputDevice2A_Unacquire(idd : IDirectInputDevice2A) : HResult; stdcall;
function IDirectInputDevice2A_GetDeviceState(idd : IDirectInputDevice2A; cbData : DWORD; lpvData : Pointer) : HResult; stdcall;
function IDirectInputDevice2A_GetDeviceData(idd : IDirectInputDevice2A; cbObjectData : DWORD; rgdod : PDIDeviceObjectData; var pdwInOut : DWORD; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice2A_SetDataFormat(idd : IDirectInputDevice2A; var lpdf : TDIDataFormat) : HResult; stdcall;
function IDirectInputDevice2A_SetEventNotification(idd : IDirectInputDevice2A; hEvent : THandle) : HResult; stdcall;
function IDirectInputDevice2A_SetCooperativeLevel(idd : IDirectInputDevice2A; hwnd : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice2A_GetObjectInfo(idd : IDirectInputDevice2A; var pdidoi : TDIDeviceObjectInstanceA; dwObj : DWORD; dwHow : DWORD) : HResult; stdcall;
function IDirectInputDevice2A_GetDeviceInfo(idd : IDirectInputDevice2A; var pdidi : TDIDeviceInstanceA) : HResult; stdcall;
function IDirectInputDevice2A_RunControlPanel(idd : IDirectInputDevice2A; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice2A_Initialize(idd : IDirectInputDevice2A; hinst : THandle; dwVersion : DWORD; const rguid : TGUID) : HResult; stdcall;
function IDirectInputDevice2A_CreateEffect(idd : IDirectInputDevice2A; const rguid : TGUID; lpeff : PDIEffect; var ppdeff : IDirectInputEffect; punkOuter : IUnknown) : HResult; stdcall;
function IDirectInputDevice2A_EnumEffects(idd : IDirectInputDevice2A; lpCallback : TDIEnumEffectsCallbackA; pvRef : pointer; dwEffType : DWORD) : HResult; stdcall;
function IDirectInputDevice2A_GetEffectInfo(idd : IDirectInputDevice2A; pdei : TDIEffectInfoA; const rguid : TGUID) : HResult; stdcall;
function IDirectInputDevice2A_GetForceFeedbackState(idd : IDirectInputDevice2A; var pdwOut : DWORD) : HResult; stdcall;
function IDirectInputDevice2A_SendForceFeedbackCommand(idd : IDirectInputDevice2A; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice2A_EnumCreatedEffectObjects(idd : IDirectInputDevice2A; lpCallback : TDIEnumCreatedEffectObjectsCallback; pvRef : pointer; fl : DWORD) : HResult; stdcall;
function IDirectInputDevice2A_Escape(idd : IDirectInputDevice2A; var pesc : TDIEffEscape) : HResult; stdcall;
function IDirectInputDevice2A_Poll(idd : IDirectInputDevice2A) : HResult; stdcall;
function IDirectInputDevice2A_SendDeviceData(idd : IDirectInputDevice2A; cbObjectData : DWORD; var rgdod : TDIDeviceObjectData; var pdwInOut : DWORD; fl : DWORD) : HResult; stdcall;

// IDirectInputDevice2W interface methods

function IDirectInputDevice2W_QueryInterface(idd : IDirectInputDevice2W; const IID : TGUID; var obj) : HRESULT; stdcall;
function IDirectInputDevice2W_AddRef(idd : IDirectInputDevice2W) : Longint; stdcall;
function IDirectInputDevice2W_Release(idd : IDirectInputDevice2W) : Longint; stdcall;
function IDirectInputDevice2W_GetCapabilities(idd : IDirectInputDevice2W; var lpDIDevCaps : TDIDevCaps) : HResult; stdcall;
function IDirectInputDevice2W_EnumObjects(idd : IDirectInputDevice2W; lpCallback : TDIEnumDeviceObjectsCallbackW; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice2W_GetProperty(idd : IDirectInputDevice2W; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
function IDirectInputDevice2W_SetProperty(idd : IDirectInputDevice2W; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
function IDirectInputDevice2W_Acquire(idd : IDirectInputDevice2W) : HResult; stdcall;
function IDirectInputDevice2W_Unacquire(idd : IDirectInputDevice2W) : HResult; stdcall;
function IDirectInputDevice2W_GetDeviceState(idd : IDirectInputDevice2W; cbData : DWORD; lpvData : Pointer) : HResult; stdcall;
function IDirectInputDevice2W_GetDeviceData(idd : IDirectInputDevice2W; cbObjectData : DWORD; rgdod : PDIDeviceObjectData; var pdwInOut : DWORD; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice2W_SetDataFormat(idd : IDirectInputDevice2W; var lpdf : TDIDataFormat) : HResult; stdcall;
function IDirectInputDevice2W_SetEventNotification(idd : IDirectInputDevice2W; hEvent : THandle) : HResult; stdcall;
function IDirectInputDevice2W_SetCooperativeLevel(idd : IDirectInputDevice2W; hwnd : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice2W_GetObjectInfo(idd : IDirectInputDevice2W; var pdidoi : TDIDeviceObjectInstanceW; dwObj : DWORD; dwHow : DWORD) : HResult; stdcall;
function IDirectInputDevice2W_GetDeviceInfo(idd : IDirectInputDevice2W; var pdidi : TDIDeviceInstanceW) : HResult; stdcall;
function IDirectInputDevice2W_RunControlPanel(idd : IDirectInputDevice2W; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice2W_Initialize(idd : IDirectInputDevice2W; hinst : THandle; dwVersion : DWORD; const rguid : TGUID) : HResult; stdcall;
function IDirectInputDevice2W_CreateEffect(idd : IDirectInputDevice2W; const rguid : TGUID; lpeff : PDIEffect; var ppdeff : IDirectInputEffect; punkOuter : IUnknown) : HResult; stdcall;
function IDirectInputDevice2W_EnumEffects(idd : IDirectInputDevice2W; lpCallback : TDIEnumEffectsCallbackW; pvRef : pointer; dwEffType : DWORD) : HResult; stdcall;
function IDirectInputDevice2W_GetEffectInfo(idd : IDirectInputDevice2W; pdei : TDIEffectInfoW; const rguid : TGUID) : HResult; stdcall;
function IDirectInputDevice2W_GetForceFeedbackState(idd : IDirectInputDevice2W; var pdwOut : DWORD) : HResult; stdcall;
function IDirectInputDevice2W_SendForceFeedbackCommand(idd : IDirectInputDevice2W; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice2W_EnumCreatedEffectObjects(idd : IDirectInputDevice2W; lpCallback : TDIEnumCreatedEffectObjectsCallback; pvRef : pointer; fl : DWORD) : HResult; stdcall;
function IDirectInputDevice2W_Escape(idd : IDirectInputDevice2W; var pesc : TDIEffEscape) : HResult; stdcall;
function IDirectInputDevice2W_Poll(idd : IDirectInputDevice2W) : HResult; stdcall;
function IDirectInputDevice2W_SendDeviceData(idd : IDirectInputDevice2W; cbObjectData : DWORD; var rgdod : TDIDeviceObjectData; var pdwInOut : DWORD; fl : DWORD) : HResult; stdcall;

// IDirectInputDevice7W interface methods

function IDirectInputDevice7W_QueryInterface(idd : IDirectInputDevice7W; const IID : TGUID; var obj) : HRESULT; stdcall;
function IDirectInputDevice7W_AddRef(idd : IDirectInputDevice7W) : Longint; stdcall;
function IDirectInputDevice7W_Release(idd : IDirectInputDevice7W) : Longint; stdcall;
function IDirectInputDevice7W_GetCapabilities(idd : IDirectInputDevice7W; var lpDIDevCaps : TDIDevCaps) : HResult; stdcall;
function IDirectInputDevice7W_EnumObjects(idd : IDirectInputDevice7W; lpCallback : TDIEnumDeviceObjectsCallbackW; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice7W_GetProperty(idd : IDirectInputDevice7W; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
function IDirectInputDevice7W_SetProperty(idd : IDirectInputDevice7W; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
function IDirectInputDevice7W_Acquire(idd : IDirectInputDevice7W) : HResult; stdcall;
function IDirectInputDevice7W_Unacquire(idd : IDirectInputDevice7W) : HResult; stdcall;
function IDirectInputDevice7W_GetDeviceState(idd : IDirectInputDevice7W; cbData : DWORD; lpvData : Pointer) : HResult; stdcall;
function IDirectInputDevice7W_GetDeviceData(idd : IDirectInputDevice7W; cbObjectData : DWORD; rgdod : PDIDeviceObjectData; var pdwInOut : DWORD; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice7W_SetDataFormat(idd : IDirectInputDevice7W; var lpdf : TDIDataFormat) : HResult; stdcall;
function IDirectInputDevice7W_SetEventNotification(idd : IDirectInputDevice7W; hEvent : THandle) : HResult; stdcall;
function IDirectInputDevice7W_SetCooperativeLevel(idd : IDirectInputDevice7W; hwnd : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice7W_GetObjectInfo(idd : IDirectInputDevice7W; var pdidoi : TDIDeviceObjectInstanceW; dwObj : DWORD; dwHow : DWORD) : HResult; stdcall;
function IDirectInputDevice7W_GetDeviceInfo(idd : IDirectInputDevice7W; var pdidi : TDIDeviceInstanceW) : HResult; stdcall;
function IDirectInputDevice7W_RunControlPanel(idd : IDirectInputDevice7W; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice7W_Initialize(idd : IDirectInputDevice7W; hinst : THandle; dwVersion : DWORD; const rguid : TGUID) : HResult; stdcall;
function IDirectInputDevice7W_CreateEffect(idd : IDirectInputDevice7W; const rguid : TGUID; lpeff : PDIEffect; var ppdeff : IDirectInputEffect; punkOuter : IUnknown) : HResult; stdcall;
function IDirectInputDevice7W_EnumEffects(idd : IDirectInputDevice7W; lpCallback : TDIEnumEffectsCallbackW; pvRef : pointer; dwEffType : DWORD) : HResult; stdcall;
function IDirectInputDevice7W_GetEffectInfo(idd : IDirectInputDevice7W; pdei : TDIEffectInfoW; const rguid : TGUID) : HResult; stdcall;
function IDirectInputDevice7W_GetForceFeedbackState(idd : IDirectInputDevice7W; var pdwOut : DWORD) : HResult; stdcall;
function IDirectInputDevice7W_SendForceFeedbackCommand(idd : IDirectInputDevice7W; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice7W_EnumCreatedEffectObjects(idd : IDirectInputDevice7W; lpCallback : TDIEnumCreatedEffectObjectsCallback; pvRef : pointer; fl : DWORD) : HResult; stdcall;
function IDirectInputDevice7W_Escape(idd : IDirectInputDevice7W; var pesc : TDIEffEscape) : HResult; stdcall;
function IDirectInputDevice7W_Poll(idd : IDirectInputDevice7W) : HResult; stdcall;
function IDirectInputDevice7W_SendDeviceData(idd : IDirectInputDevice7W; cbObjectData : DWORD; var rgdod : TDIDeviceObjectData; var pdwInOut : DWORD; fl : DWORD) : HResult; stdcall;
function IDirectInputDevice7W_EnumEffectsInFile(idd : IDirectInputDevice7W; const lpszFileName : PChar; pec : TEnumEffectsInFileCallback; pvRef : Pointer; dwFlags : DWord) : HResult; stdcall;
function IDirectInputDevice7W_WriteEffectToFile(idd : IDirectInputDevice7W; const lpszFileName : PChar; dwEntries : DWord; const rgDIFileEft : PDIFileEffect; dwFlags : DWord) : HResult; stdcall;

// IDirectInputDevice7A interface methods

function IDirectInputDevice7A_QueryInterface(idd : IDirectInputDevice7A; const IID : TGUID; var obj) : HRESULT; stdcall;
function IDirectInputDevice7A_AddRef(idd : IDirectInputDevice7A) : Longint; stdcall;
function IDirectInputDevice7A_Release(idd : IDirectInputDevice7A) : Longint; stdcall;
function IDirectInputDevice7A_GetCapabilities(idd : IDirectInputDevice7A; var lpDIDevCaps : TDIDevCaps) : HResult; stdcall;
function IDirectInputDevice7A_EnumObjects(idd : IDirectInputDevice7A; lpCallback : TDIEnumDeviceObjectsCallbackA; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice7A_GetProperty(idd : IDirectInputDevice7A; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
function IDirectInputDevice7A_SetProperty(idd : IDirectInputDevice7A; rguidProp : PGUID; const pdiph : TDIPropHeader) : HResult; stdcall;
function IDirectInputDevice7A_Acquire(idd : IDirectInputDevice7A) : HResult; stdcall;
function IDirectInputDevice7A_Unacquire(idd : IDirectInputDevice7A) : HResult; stdcall;
function IDirectInputDevice7A_GetDeviceState(idd : IDirectInputDevice7A; cbData : DWORD; lpvData : Pointer) : HResult; stdcall;
function IDirectInputDevice7A_GetDeviceData(idd : IDirectInputDevice7A; cbObjectData : DWORD; rgdod : PDIDeviceObjectData; var pdwInOut : DWORD; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice7A_SetDataFormat(idd : IDirectInputDevice7A; var lpdf : TDIDataFormat) : HResult; stdcall;
function IDirectInputDevice7A_SetEventNotification(idd : IDirectInputDevice7A; hEvent : THandle) : HResult; stdcall;
function IDirectInputDevice7A_SetCooperativeLevel(idd : IDirectInputDevice7A; hwnd : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice7A_GetObjectInfo(idd : IDirectInputDevice7A; var pdidoi : TDIDeviceObjectInstanceA; dwObj : DWORD; dwHow : DWORD) : HResult; stdcall;
function IDirectInputDevice7A_GetDeviceInfo(idd : IDirectInputDevice7A; var pdidi : TDIDeviceInstanceA) : HResult; stdcall;
function IDirectInputDevice7A_RunControlPanel(idd : IDirectInputDevice7A; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice7A_Initialize(idd : IDirectInputDevice7A; hinst : THandle; dwVersion : DWORD; const rguid : TGUID) : HResult; stdcall;
function IDirectInputDevice7A_CreateEffect(idd : IDirectInputDevice7A; const rguid : TGUID; lpeff : PDIEffect; var ppdeff : IDirectInputEffect; punkOuter : IUnknown) : HResult; stdcall;
function IDirectInputDevice7A_EnumEffects(idd : IDirectInputDevice7A; lpCallback : TDIEnumEffectsCallbackA; pvRef : pointer; dwEffType : DWORD) : HResult; stdcall;
function IDirectInputDevice7A_GetEffectInfo(idd : IDirectInputDevice7A; pdei : TDIEffectInfoA; const rguid : TGUID) : HResult; stdcall;
function IDirectInputDevice7A_GetForceFeedbackState(idd : IDirectInputDevice7A; var pdwOut : DWORD) : HResult; stdcall;
function IDirectInputDevice7A_SendForceFeedbackCommand(idd : IDirectInputDevice7A; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputDevice7A_EnumCreatedEffectObjects(idd : IDirectInputDevice7A; lpCallback : TDIEnumCreatedEffectObjectsCallback; pvRef : pointer; fl : DWORD) : HResult; stdcall;
function IDirectInputDevice7A_Escape(idd : IDirectInputDevice7A; var pesc : TDIEffEscape) : HResult; stdcall;
function IDirectInputDevice7A_Poll(idd : IDirectInputDevice7A) : HResult; stdcall;
function IDirectInputDevice7A_SendDeviceData(idd : IDirectInputDevice7A; cbObjectData : DWORD; var rgdod : TDIDeviceObjectData; var pdwInOut : DWORD; fl : DWORD) : HResult; stdcall;
function IDirectInputDevice7A_EnumEffectsInFile(idd : IDirectInputDevice7A; const lpszFileName : PChar; pec : TEnumEffectsInFileCallback; pvRef : Pointer; dwFlags : DWord) : HResult; stdcall;
function IDirectInputDevice7A_WriteEffectToFile(idd : IDirectInputDevice7A; const lpszFileName : PChar; dwEntries : DWord; const rgDIFileEft : PDIFileEffect; dwFlags : DWord) : HResult; stdcall;

// IDirectInputW interface methods

function IDirectInputW_QueryInterface(idd : IDirectInputW; const IID : TGUID; var obj) : HRESULT; stdcall;
function IDirectInputW_AddRef(idd : IDirectInputW) : Longint; stdcall;
function IDirectInputW_Release(idd : IDirectInputW) : Longint; stdcall;
function IDirectInputW_CreateDevice(idd : IDirectInputW; const rguid : TGUID; var lplpDirectInputDevice : IDirectInputDeviceW; pUnkOuter : IUnknown) : HResult; stdcall;
function IDirectInputW_EnumDevices(idd : IDirectInputW; dwDevType : DWORD; lpCallback : TDIEnumDevicesCallbackW; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputW_GetDeviceStatus(idd : IDirectInputW; const rguidInstance : TGUID) : HResult; stdcall;
function IDirectInputW_RunControlPanel(idd : IDirectInputW; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputW_Initialize(idd : IDirectInputW; hinst : THandle; dwVersion : DWORD) : HResult; stdcall;

// IDirectInputA interface methods

function IDirectInputA_QueryInterface(idd : IDirectInputA; const IID : TGUID; var obj) : HRESULT; stdcall;
function IDirectInputA_AddRef(idd : IDirectInputA) : Longint; stdcall;
function IDirectInputA_Release(idd : IDirectInputA) : Longint; stdcall;
function IDirectInputA_CreateDevice(idd : IDirectInputA; const rguid : TGUID; var lplpDirectInputDevice : IDirectInputDeviceA; pUnkOuter : IUnknown) : HResult; stdcall;
function IDirectInputA_EnumDevices(idd : IDirectInputA; dwDevType : DWORD; lpCallback : TDIEnumDevicesCallbackA; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputA_GetDeviceStatus(idd : IDirectInputA; const rguidInstance : TGUID) : HResult; stdcall;
function IDirectInputA_RunControlPanel(idd : IDirectInputA; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInputA_Initialize(idd : IDirectInputA; hinst : THandle; dwVersion : DWORD) : HResult; stdcall;

// IDirectInput2W interface methods

function IDirectInput2W_QueryInterface(idd : IDirectInput2W; const IID : TGUID; var obj) : HRESULT; stdcall;
function IDirectInput2W_AddRef(idd : IDirectInput2W) : Longint; stdcall;
function IDirectInput2W_Release(idd : IDirectInput2W) : Longint; stdcall;
function IDirectInput2W_CreateDevice(idd : IDirectInput2W; const rguid : TGUID; var lplpDirectInputDevice : IDirectInputDeviceW; pUnkOuter : IUnknown) : HResult; stdcall;
function IDirectInput2W_EnumDevices(idd : IDirectInput2W; dwDevType : DWORD; lpCallback : TDIEnumDevicesCallbackW; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
function IDirectInput2W_GetDeviceStatus(idd : IDirectInput2W; const rguidInstance : TGUID) : HResult; stdcall;
function IDirectInput2W_RunControlPanel(idd : IDirectInput2W; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInput2W_Initialize(idd : IDirectInput2W; hinst : THandle; dwVersion : DWORD) : HResult; stdcall;
function IDirectInput2W_FindDevice(idd : IDirectInput2W; const rguidClass : TGUID; ptszName : PWideChar; var pguidInstance : TGUID) : HResult; stdcall;

// IDirectInput2A interface methods

function IDirectInput2A_QueryInterface(idd : IDirectInput2A; const IID : TGUID; var obj) : HRESULT; stdcall;
function IDirectInput2A_AddRef(idd : IDirectInput2A) : Longint; stdcall;
function IDirectInput2A_Release(idd : IDirectInput2A) : Longint; stdcall;
function IDirectInput2A_CreateDevice(idd : IDirectInput2A; const rguid : TGUID; var lplpDirectInputDevice : IDirectInputDeviceA; pUnkOuter : IUnknown) : HResult; stdcall;
function IDirectInput2A_EnumDevices(idd : IDirectInput2A; dwDevType : DWORD; lpCallback : TDIEnumDevicesCallbackA; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
function IDirectInput2A_GetDeviceStatus(idd : IDirectInput2A; const rguidInstance : TGUID) : HResult; stdcall;
function IDirectInput2A_RunControlPanel(idd : IDirectInput2A; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInput2A_Initialize(idd : IDirectInput2A; hinst : THandle; dwVersion : DWORD) : HResult; stdcall;
function IDirectInput2A_FindDevice(idd : IDirectInput2A; const rguidClass : TGUID; ptszName : PAnsiChar; var pguidInstance : TGUID) : HResult; stdcall;

// IDirectInput7W interface methods

function IDirectInput7W_QueryInterface(idd : IDirectInput7W; const IID : TGUID; var obj) : HRESULT; stdcall;
function IDirectInput7W_AddRef(idd : IDirectInput7W) : Longint; stdcall;
function IDirectInput7W_Release(idd : IDirectInput7W) : Longint; stdcall;
function IDirectInput7W_CreateDevice(idd : IDirectInput7W; const rguid : TGUID; var lplpDirectInputDevice : IDirectInputDeviceW; pUnkOuter : IUnknown) : HResult; stdcall;
function IDirectInput7W_EnumDevices(idd : IDirectInput7W; dwDevType : DWORD; lpCallback : TDIEnumDevicesCallbackW; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
function IDirectInput7W_GetDeviceStatus(idd : IDirectInput7W; const rguidInstance : TGUID) : HResult; stdcall;
function IDirectInput7W_RunControlPanel(idd : IDirectInput7W; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInput7W_Initialize(idd : IDirectInput7W; hinst : THandle; dwVersion : DWORD) : HResult; stdcall;
function IDirectInput7W_FindDevice(idd : IDirectInput7W; const rguidClass : TGUID; ptszName : PWideChar; var pguidInstance : TGUID) : HResult; stdcall;
function IDirectInput7W_CreateDeviceEx(idd : IDirectInput7W; const rguid , riid : TGUID; var lplpDirectInputDevice; pUnkOuter : IUnknown) : HResult; stdcall;

// IDirectInput7A interface methods

function IDirectInput7A_QueryInterface(idd : IDirectInput7A; const IID : TGUID; var obj) : HRESULT; stdcall;
function IDirectInput7A_AddRef(idd : IDirectInput7A) : Longint; stdcall;
function IDirectInput7A_Release(idd : IDirectInput7A) : Longint; stdcall;
function IDirectInput7A_CreateDevice(idd : IDirectInput7A; const rguid : TGUID; var lplpDirectInputDevice : IDirectInputDeviceA; pUnkOuter : IUnknown) : HResult; stdcall;
function IDirectInput7A_EnumDevices(idd : IDirectInput7A; dwDevType : DWORD; lpCallback : TDIEnumDevicesCallbackA; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
function IDirectInput7A_GetDeviceStatus(idd : IDirectInput7A; const rguidInstance : TGUID) : HResult; stdcall;
function IDirectInput7A_RunControlPanel(idd : IDirectInput7A; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
function IDirectInput7A_Initialize(idd : IDirectInput7A; hinst : THandle; dwVersion : DWORD) : HResult; stdcall;
function IDirectInput7A_FindDevice(idd : IDirectInput7A; const rguidClass : TGUID; ptszName : PAnsiChar; var pguidInstance : TGUID) : HResult; stdcall;
function IDirectInput7A_CreateDeviceEx(idd : IDirectInput7A; const rguid , riid : TGUID; var lplpDirectInputDevice; pUnkOuter : IUnknown) : HResult; stdcall;

implementation


// IDirectInputEffect interface methods

function IDirectInputEffect_QueryInterface(idd : IDirectInputEffect; const IID : TGUID; var obj) : HRESULT; stdcall;
begin
	result := idd^^.QueryInterface(idd, IID, obj);
end;

function IDirectInputEffect_AddRef(idd : IDirectInputEffect) : Longint; stdcall;
begin
	result := idd^^.AddRef(idd);
end;

function IDirectInputEffect_Release(idd : IDirectInputEffect) : Longint; stdcall;
begin
	result := idd^^.Release(idd);
end;

function IDirectInputEffect_Initialize(idd : IDirectInputEffect; hinst : THandle; dwVersion : DWORD; const rguid : TGUID) : HResult; stdcall;
begin
	result := idd^^.Initialize(idd, hinst, dwVersion, rguid);
end;

function IDirectInputEffect_GetEffectGuid(idd : IDirectInputEffect; var pguid : TGUID) : HResult; stdcall;
begin
	result := idd^^.GetEffectGuid(idd, pguid);
end;

function IDirectInputEffect_GetParameters(idd : IDirectInputEffect; var peff : TDIEffect; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetParameters(idd, peff, dwFlags);
end;

function IDirectInputEffect_SetParameters(idd : IDirectInputEffect; var peff : TDIEffect; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.SetParameters(idd, peff, dwFlags);
end;

function IDirectInputEffect_Start(idd : IDirectInputEffect; dwIterations : DWORD; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.Start(idd, dwIterations, dwFlags);
end;

function IDirectInputEffect_Stop(idd : IDirectInputEffect) : HResult; stdcall;
begin
	result := idd^^.Stop(idd);
end;

function IDirectInputEffect_GetEffectStatus(idd : IDirectInputEffect; var pdwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetEffectStatus(idd, pdwFlags);
end;

function IDirectInputEffect_Download(idd : IDirectInputEffect) : HResult; stdcall;
begin
	result := idd^^.Download(idd);
end;

function IDirectInputEffect_Unload(idd : IDirectInputEffect) : HResult; stdcall;
begin
	result := idd^^.Unload(idd);
end;

function IDirectInputEffect_Escape(idd : IDirectInputEffect; var pesc : TDIEffEscape) : HResult; stdcall;
begin
	result := idd^^.Escape(idd, pesc);
end;


// IDirectInputDeviceA interface methods

function IDirectInputDeviceA_QueryInterface(idd : IDirectInputDeviceA; const IID : TGUID; var obj) : HRESULT; stdcall;
begin
	result := idd^^.QueryInterface(idd, IID, obj);
end;

function IDirectInputDeviceA_AddRef(idd : IDirectInputDeviceA) : Longint; stdcall;
begin
	result := idd^^.AddRef(idd);
end;

function IDirectInputDeviceA_Release(idd : IDirectInputDeviceA) : Longint; stdcall;
begin
	result := idd^^.Release(idd);
end;

function IDirectInputDeviceA_GetCapabilities(idd : IDirectInputDeviceA; var lpDIDevCaps : TDIDevCaps) : HResult; stdcall;
begin
	result := idd^^.GetCapabilities(idd, lpDIDevCaps);
end;

function IDirectInputDeviceA_EnumObjects(idd : IDirectInputDeviceA; lpCallback : TDIEnumDeviceObjectsCallbackA; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumObjects(idd, @lpCallback, pvRef, dwFlags);
end;

function IDirectInputDeviceA_GetProperty(idd : IDirectInputDeviceA; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
begin
	result := idd^^.GetProperty(idd, rguidProp, pdiph);
end;

function IDirectInputDeviceA_SetProperty(idd : IDirectInputDeviceA; rguidProp : PGUID; const pdiph : TDIPropHeader) : HResult; stdcall;
begin
	result := idd^^.SetProperty(idd, rguidProp, pdiph);
end;

function IDirectInputDeviceA_Acquire(idd : IDirectInputDeviceA) : HResult; stdcall;
begin
	result := idd^^.Acquire(idd);
end;

function IDirectInputDeviceA_Unacquire(idd : IDirectInputDeviceA) : HResult; stdcall;
begin
	result := idd^^.Unacquire(idd);
end;

function IDirectInputDeviceA_GetDeviceState(idd : IDirectInputDeviceA; cbData : DWORD; lpvData : Pointer) : HResult; stdcall;
begin
	result := idd^^.GetDeviceState(idd, cbData, lpvData);
end;

function IDirectInputDeviceA_GetDeviceData(idd : IDirectInputDeviceA; cbObjectData : DWORD; rgdod : PDIDeviceObjectData; var pdwInOut : DWORD; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetDeviceData(idd, cbObjectData, rgdod, pdwInOut, dwFlags);
end;

function IDirectInputDeviceA_SetDataFormat(idd : IDirectInputDeviceA; var lpdf : TDIDataFormat) : HResult; stdcall;
begin
	result := idd^^.SetDataFormat(idd, lpdf);
end;

function IDirectInputDeviceA_SetEventNotification(idd : IDirectInputDeviceA; hEvent : THandle) : HResult; stdcall;
begin
	result := idd^^.SetEventNotification(idd, hEvent);
end;

function IDirectInputDeviceA_SetCooperativeLevel(idd : IDirectInputDeviceA; hwnd : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.SetCooperativeLevel(idd, hwnd, dwFlags);
end;

function IDirectInputDeviceA_GetObjectInfo(idd : IDirectInputDeviceA; var pdidoi : TDIDeviceObjectInstanceA; dwObj : DWORD; dwHow : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetObjectInfo(idd, pdidoi, dwObj, dwHow);
end;

function IDirectInputDeviceA_GetDeviceInfo(idd : IDirectInputDeviceA; var pdidi : TDIDeviceInstanceA) : HResult; stdcall;
begin
	result := idd^^.GetDeviceInfo(idd, pdidi);
end;

function IDirectInputDeviceA_RunControlPanel(idd : IDirectInputDeviceA; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.RunControlPanel(idd, hwndOwner, dwFlags);
end;

function IDirectInputDeviceA_Initialize(idd : IDirectInputDeviceA; hinst : THandle; dwVersion : DWORD; const rguid : TGUID) : HResult; stdcall;
begin
	result := idd^^.Initialize(idd, hinst, dwVersion, rguid);
end;


// IDirectInputDeviceW interface methods

function IDirectInputDeviceW_QueryInterface(idd : IDirectInputDeviceW; const IID : TGUID; var obj) : HRESULT; stdcall;
begin
	result := idd^^.QueryInterface(idd, IID, obj);
end;

function IDirectInputDeviceW_AddRef(idd : IDirectInputDeviceW) : Longint; stdcall;
begin
	result := idd^^.AddRef(idd);
end;

function IDirectInputDeviceW_Release(idd : IDirectInputDeviceW) : Longint; stdcall;
begin
	result := idd^^.Release(idd);
end;

function IDirectInputDeviceW_GetCapabilities(idd : IDirectInputDeviceW; var lpDIDevCaps : TDIDevCaps) : HResult; stdcall;
begin
	result := idd^^.GetCapabilities(idd, lpDIDevCaps);
end;

function IDirectInputDeviceW_EnumObjects(idd : IDirectInputDeviceW; lpCallback : TDIEnumDeviceObjectsCallbackW; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumObjects(idd, @lpCallback, pvRef, dwFlags);
end;

function IDirectInputDeviceW_GetProperty(idd : IDirectInputDeviceW; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
begin
	result := idd^^.GetProperty(idd, rguidProp, pdiph);
end;

function IDirectInputDeviceW_SetProperty(idd : IDirectInputDeviceW; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
begin
	result := idd^^.SetProperty(idd, rguidProp, pdiph);
end;

function IDirectInputDeviceW_Acquire(idd : IDirectInputDeviceW) : HResult; stdcall;
begin
	result := idd^^.Acquire(idd);
end;

function IDirectInputDeviceW_Unacquire(idd : IDirectInputDeviceW) : HResult; stdcall;
begin
	result := idd^^.Unacquire(idd);
end;

function IDirectInputDeviceW_GetDeviceState(idd : IDirectInputDeviceW; cbData : DWORD; lpvData : Pointer) : HResult; stdcall;
begin
	result := idd^^.GetDeviceState(idd, cbData, lpvData);
end;

function IDirectInputDeviceW_GetDeviceData(idd : IDirectInputDeviceW; cbObjectData : DWORD; rgdod : PDIDeviceObjectData; var pdwInOut : DWORD; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetDeviceData(idd, cbObjectData, rgdod, pdwInOut, dwFlags);
end;

function IDirectInputDeviceW_SetDataFormat(idd : IDirectInputDeviceW; var lpdf : TDIDataFormat) : HResult; stdcall;
begin
	result := idd^^.SetDataFormat(idd, lpdf);
end;

function IDirectInputDeviceW_SetEventNotification(idd : IDirectInputDeviceW; hEvent : THandle) : HResult; stdcall;
begin
	result := idd^^.SetEventNotification(idd, hEvent);
end;

function IDirectInputDeviceW_SetCooperativeLevel(idd : IDirectInputDeviceW; hwnd : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.SetCooperativeLevel(idd, hwnd, dwFlags);
end;

function IDirectInputDeviceW_GetObjectInfo(idd : IDirectInputDeviceW; var pdidoi : TDIDeviceObjectInstanceW; dwObj : DWORD; dwHow : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetObjectInfo(idd, pdidoi, dwObj, dwHow);
end;

function IDirectInputDeviceW_GetDeviceInfo(idd : IDirectInputDeviceW; var pdidi : TDIDeviceInstanceW) : HResult; stdcall;
begin
	result := idd^^.GetDeviceInfo(idd, pdidi);
end;

function IDirectInputDeviceW_RunControlPanel(idd : IDirectInputDeviceW; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.RunControlPanel(idd, hwndOwner, dwFlags);
end;

function IDirectInputDeviceW_Initialize(idd : IDirectInputDeviceW; hinst : THandle; dwVersion : DWORD; const rguid : TGUID) : HResult; stdcall;
begin
	result := idd^^.Initialize(idd, hinst, dwVersion, rguid);
end;


// IDirectInputDevice2A interface methods

function IDirectInputDevice2A_QueryInterface(idd : IDirectInputDevice2A; const IID : TGUID; var obj) : HRESULT; stdcall;
begin
	result := idd^^.QueryInterface(idd, IID, obj);
end;

function IDirectInputDevice2A_AddRef(idd : IDirectInputDevice2A) : Longint; stdcall;
begin
	result := idd^^.AddRef(idd);
end;

function IDirectInputDevice2A_Release(idd : IDirectInputDevice2A) : Longint; stdcall;
begin
	result := idd^^.Release(idd);
end;

function IDirectInputDevice2A_GetCapabilities(idd : IDirectInputDevice2A; var lpDIDevCaps : TDIDevCaps) : HResult; stdcall;
begin
	result := idd^^.GetCapabilities(idd, lpDIDevCaps);
end;

function IDirectInputDevice2A_EnumObjects(idd : IDirectInputDevice2A; lpCallback : TDIEnumDeviceObjectsCallbackA; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumObjects(idd, @lpCallback, pvRef, dwFlags);
end;

function IDirectInputDevice2A_GetProperty(idd : IDirectInputDevice2A; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
begin
	result := idd^^.GetProperty(idd, rguidProp, pdiph);
end;

function IDirectInputDevice2A_SetProperty(idd : IDirectInputDevice2A; rguidProp : PGUID; const pdiph : TDIPropHeader) : HResult; stdcall;
begin
	result := idd^^.SetProperty(idd, rguidProp, pdiph);
end;

function IDirectInputDevice2A_Acquire(idd : IDirectInputDevice2A) : HResult; stdcall;
begin
	result := idd^^.Acquire(idd);
end;

function IDirectInputDevice2A_Unacquire(idd : IDirectInputDevice2A) : HResult; stdcall;
begin
	result := idd^^.Unacquire(idd);
end;

function IDirectInputDevice2A_GetDeviceState(idd : IDirectInputDevice2A; cbData : DWORD; lpvData : Pointer) : HResult; stdcall;
begin
	result := idd^^.GetDeviceState(idd, cbData, lpvData);
end;

function IDirectInputDevice2A_GetDeviceData(idd : IDirectInputDevice2A; cbObjectData : DWORD; rgdod : PDIDeviceObjectData; var pdwInOut : DWORD; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetDeviceData(idd, cbObjectData, rgdod, pdwInOut, dwFlags);
end;

function IDirectInputDevice2A_SetDataFormat(idd : IDirectInputDevice2A; var lpdf : TDIDataFormat) : HResult; stdcall;
begin
	result := idd^^.SetDataFormat(idd, lpdf);
end;

function IDirectInputDevice2A_SetEventNotification(idd : IDirectInputDevice2A; hEvent : THandle) : HResult; stdcall;
begin
	result := idd^^.SetEventNotification(idd, hEvent);
end;

function IDirectInputDevice2A_SetCooperativeLevel(idd : IDirectInputDevice2A; hwnd : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.SetCooperativeLevel(idd, hwnd, dwFlags);
end;

function IDirectInputDevice2A_GetObjectInfo(idd : IDirectInputDevice2A; var pdidoi : TDIDeviceObjectInstanceA; dwObj : DWORD; dwHow : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetObjectInfo(idd, pdidoi, dwObj, dwHow);
end;

function IDirectInputDevice2A_GetDeviceInfo(idd : IDirectInputDevice2A; var pdidi : TDIDeviceInstanceA) : HResult; stdcall;
begin
	result := idd^^.GetDeviceInfo(idd, pdidi);
end;

function IDirectInputDevice2A_RunControlPanel(idd : IDirectInputDevice2A; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.RunControlPanel(idd, hwndOwner, dwFlags);
end;

function IDirectInputDevice2A_Initialize(idd : IDirectInputDevice2A; hinst : THandle; dwVersion : DWORD; const rguid : TGUID) : HResult; stdcall;
begin
	result := idd^^.Initialize(idd, hinst, dwVersion, rguid);
end;

function IDirectInputDevice2A_CreateEffect(idd : IDirectInputDevice2A; const rguid : TGUID; lpeff : PDIEffect; var ppdeff : IDirectInputEffect; punkOuter : IUnknown) : HResult; stdcall;
begin
	result := idd^^.CreateEffect(idd, rguid, lpeff, ppdeff, punkOuter);
end;

function IDirectInputDevice2A_EnumEffects(idd : IDirectInputDevice2A; lpCallback : TDIEnumEffectsCallbackA; pvRef : pointer; dwEffType : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumEffects(idd, @lpCallback, pvRef, dwEffType);
end;

function IDirectInputDevice2A_GetEffectInfo(idd : IDirectInputDevice2A; pdei : TDIEffectInfoA; const rguid : TGUID) : HResult; stdcall;
begin
	result := idd^^.GetEffectInfo(idd, pdei, rguid);
end;

function IDirectInputDevice2A_GetForceFeedbackState(idd : IDirectInputDevice2A; var pdwOut : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetForceFeedbackState(idd, pdwOut);
end;

function IDirectInputDevice2A_SendForceFeedbackCommand(idd : IDirectInputDevice2A; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.SendForceFeedbackCommand(idd, dwFlags);
end;

function IDirectInputDevice2A_EnumCreatedEffectObjects(idd : IDirectInputDevice2A; lpCallback : TDIEnumCreatedEffectObjectsCallback; pvRef : pointer; fl : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumCreatedEffectObjects(idd, @lpCallback, pvRef, fl);
end;

function IDirectInputDevice2A_Escape(idd : IDirectInputDevice2A; var pesc : TDIEffEscape) : HResult; stdcall;
begin
	result := idd^^.Escape(idd, pesc);
end;

function IDirectInputDevice2A_Poll(idd : IDirectInputDevice2A) : HResult; stdcall;
begin
	result := idd^^.Poll(idd);
end;

function IDirectInputDevice2A_SendDeviceData(idd : IDirectInputDevice2A; cbObjectData : DWORD; var rgdod : TDIDeviceObjectData; var pdwInOut : DWORD; fl : DWORD) : HResult; stdcall;
begin
	result := idd^^.SendDeviceData(idd, cbObjectData, rgdod, pdwInOut, fl);
end;


// IDirectInputDevice2W interface methods

function IDirectInputDevice2W_QueryInterface(idd : IDirectInputDevice2W; const IID : TGUID; var obj) : HRESULT; stdcall;
begin
	result := idd^^.QueryInterface(idd, IID, obj);
end;

function IDirectInputDevice2W_AddRef(idd : IDirectInputDevice2W) : Longint; stdcall;
begin
	result := idd^^.AddRef(idd);
end;

function IDirectInputDevice2W_Release(idd : IDirectInputDevice2W) : Longint; stdcall;
begin
	result := idd^^.Release(idd);
end;

function IDirectInputDevice2W_GetCapabilities(idd : IDirectInputDevice2W; var lpDIDevCaps : TDIDevCaps) : HResult; stdcall;
begin
	result := idd^^.GetCapabilities(idd, lpDIDevCaps);
end;

function IDirectInputDevice2W_EnumObjects(idd : IDirectInputDevice2W; lpCallback : TDIEnumDeviceObjectsCallbackW; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumObjects(idd, @lpCallback, pvRef, dwFlags);
end;

function IDirectInputDevice2W_GetProperty(idd : IDirectInputDevice2W; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
begin
	result := idd^^.GetProperty(idd, rguidProp, pdiph);
end;

function IDirectInputDevice2W_SetProperty(idd : IDirectInputDevice2W; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
begin
	result := idd^^.SetProperty(idd, rguidProp, pdiph);
end;

function IDirectInputDevice2W_Acquire(idd : IDirectInputDevice2W) : HResult; stdcall;
begin
	result := idd^^.Acquire(idd);
end;

function IDirectInputDevice2W_Unacquire(idd : IDirectInputDevice2W) : HResult; stdcall;
begin
	result := idd^^.Unacquire(idd);
end;

function IDirectInputDevice2W_GetDeviceState(idd : IDirectInputDevice2W; cbData : DWORD; lpvData : Pointer) : HResult; stdcall;
begin
	result := idd^^.GetDeviceState(idd, cbData, lpvData);
end;

function IDirectInputDevice2W_GetDeviceData(idd : IDirectInputDevice2W; cbObjectData : DWORD; rgdod : PDIDeviceObjectData; var pdwInOut : DWORD; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetDeviceData(idd, cbObjectData, rgdod, pdwInOut, dwFlags);
end;

function IDirectInputDevice2W_SetDataFormat(idd : IDirectInputDevice2W; var lpdf : TDIDataFormat) : HResult; stdcall;
begin
	result := idd^^.SetDataFormat(idd, lpdf);
end;

function IDirectInputDevice2W_SetEventNotification(idd : IDirectInputDevice2W; hEvent : THandle) : HResult; stdcall;
begin
	result := idd^^.SetEventNotification(idd, hEvent);
end;

function IDirectInputDevice2W_SetCooperativeLevel(idd : IDirectInputDevice2W; hwnd : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.SetCooperativeLevel(idd, hwnd, dwFlags);
end;

function IDirectInputDevice2W_GetObjectInfo(idd : IDirectInputDevice2W; var pdidoi : TDIDeviceObjectInstanceW; dwObj : DWORD; dwHow : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetObjectInfo(idd, pdidoi, dwObj, dwHow);
end;

function IDirectInputDevice2W_GetDeviceInfo(idd : IDirectInputDevice2W; var pdidi : TDIDeviceInstanceW) : HResult; stdcall;
begin
	result := idd^^.GetDeviceInfo(idd, pdidi);
end;

function IDirectInputDevice2W_RunControlPanel(idd : IDirectInputDevice2W; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.RunControlPanel(idd, hwndOwner, dwFlags);
end;

function IDirectInputDevice2W_Initialize(idd : IDirectInputDevice2W; hinst : THandle; dwVersion : DWORD; const rguid : TGUID) : HResult; stdcall;
begin
	result := idd^^.Initialize(idd, hinst, dwVersion, rguid);
end;

function IDirectInputDevice2W_CreateEffect(idd : IDirectInputDevice2W; const rguid : TGUID; lpeff : PDIEffect; var ppdeff : IDirectInputEffect; punkOuter : IUnknown) : HResult; stdcall;
begin
	result := idd^^.CreateEffect(idd, rguid, lpeff, ppdeff, punkOuter);
end;

function IDirectInputDevice2W_EnumEffects(idd : IDirectInputDevice2W; lpCallback : TDIEnumEffectsCallbackW; pvRef : pointer; dwEffType : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumEffects(idd, @lpCallback, pvRef, dwEffType);
end;

function IDirectInputDevice2W_GetEffectInfo(idd : IDirectInputDevice2W; pdei : TDIEffectInfoW; const rguid : TGUID) : HResult; stdcall;
begin
	result := idd^^.GetEffectInfo(idd, pdei, rguid);
end;

function IDirectInputDevice2W_GetForceFeedbackState(idd : IDirectInputDevice2W; var pdwOut : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetForceFeedbackState(idd, pdwOut);
end;

function IDirectInputDevice2W_SendForceFeedbackCommand(idd : IDirectInputDevice2W; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.SendForceFeedbackCommand(idd, dwFlags);
end;

function IDirectInputDevice2W_EnumCreatedEffectObjects(idd : IDirectInputDevice2W; lpCallback : TDIEnumCreatedEffectObjectsCallback; pvRef : pointer; fl : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumCreatedEffectObjects(idd, @lpCallback, pvRef, fl);
end;

function IDirectInputDevice2W_Escape(idd : IDirectInputDevice2W; var pesc : TDIEffEscape) : HResult; stdcall;
begin
	result := idd^^.Escape(idd, pesc);
end;

function IDirectInputDevice2W_Poll(idd : IDirectInputDevice2W) : HResult; stdcall;
begin
	result := idd^^.Poll(idd);
end;

function IDirectInputDevice2W_SendDeviceData(idd : IDirectInputDevice2W; cbObjectData : DWORD; var rgdod : TDIDeviceObjectData; var pdwInOut : DWORD; fl : DWORD) : HResult; stdcall;
begin
	result := idd^^.SendDeviceData(idd, cbObjectData, rgdod, pdwInOut, fl);
end;


// IDirectInputDevice7W interface methods

function IDirectInputDevice7W_QueryInterface(idd : IDirectInputDevice7W; const IID : TGUID; var obj) : HRESULT; stdcall;
begin
	result := idd^^.QueryInterface(idd, IID, obj);
end;

function IDirectInputDevice7W_AddRef(idd : IDirectInputDevice7W) : Longint; stdcall;
begin
	result := idd^^.AddRef(idd);
end;

function IDirectInputDevice7W_Release(idd : IDirectInputDevice7W) : Longint; stdcall;
begin
	result := idd^^.Release(idd);
end;

function IDirectInputDevice7W_GetCapabilities(idd : IDirectInputDevice7W; var lpDIDevCaps : TDIDevCaps) : HResult; stdcall;
begin
	result := idd^^.GetCapabilities(idd, lpDIDevCaps);
end;

function IDirectInputDevice7W_EnumObjects(idd : IDirectInputDevice7W; lpCallback : TDIEnumDeviceObjectsCallbackW; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumObjects(idd, @lpCallback, pvRef, dwFlags);
end;

function IDirectInputDevice7W_GetProperty(idd : IDirectInputDevice7W; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
begin
	result := idd^^.GetProperty(idd, rguidProp, pdiph);
end;

function IDirectInputDevice7W_SetProperty(idd : IDirectInputDevice7W; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
begin
	result := idd^^.SetProperty(idd, rguidProp, pdiph);
end;

function IDirectInputDevice7W_Acquire(idd : IDirectInputDevice7W) : HResult; stdcall;
begin
	result := idd^^.Acquire(idd);
end;

function IDirectInputDevice7W_Unacquire(idd : IDirectInputDevice7W) : HResult; stdcall;
begin
	result := idd^^.Unacquire(idd);
end;

function IDirectInputDevice7W_GetDeviceState(idd : IDirectInputDevice7W; cbData : DWORD; lpvData : Pointer) : HResult; stdcall;
begin
	result := idd^^.GetDeviceState(idd, cbData, lpvData);
end;

function IDirectInputDevice7W_GetDeviceData(idd : IDirectInputDevice7W; cbObjectData : DWORD; rgdod : PDIDeviceObjectData; var pdwInOut : DWORD; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetDeviceData(idd, cbObjectData, rgdod, pdwInOut, dwFlags);
end;

function IDirectInputDevice7W_SetDataFormat(idd : IDirectInputDevice7W; var lpdf : TDIDataFormat) : HResult; stdcall;
begin
	result := idd^^.SetDataFormat(idd, lpdf);
end;

function IDirectInputDevice7W_SetEventNotification(idd : IDirectInputDevice7W; hEvent : THandle) : HResult; stdcall;
begin
	result := idd^^.SetEventNotification(idd, hEvent);
end;

function IDirectInputDevice7W_SetCooperativeLevel(idd : IDirectInputDevice7W; hwnd : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.SetCooperativeLevel(idd, hwnd, dwFlags);
end;

function IDirectInputDevice7W_GetObjectInfo(idd : IDirectInputDevice7W; var pdidoi : TDIDeviceObjectInstanceW; dwObj : DWORD; dwHow : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetObjectInfo(idd, pdidoi, dwObj, dwHow);
end;

function IDirectInputDevice7W_GetDeviceInfo(idd : IDirectInputDevice7W; var pdidi : TDIDeviceInstanceW) : HResult; stdcall;
begin
	result := idd^^.GetDeviceInfo(idd, pdidi);
end;

function IDirectInputDevice7W_RunControlPanel(idd : IDirectInputDevice7W; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.RunControlPanel(idd, hwndOwner, dwFlags);
end;

function IDirectInputDevice7W_Initialize(idd : IDirectInputDevice7W; hinst : THandle; dwVersion : DWORD; const rguid : TGUID) : HResult; stdcall;
begin
	result := idd^^.Initialize(idd, hinst, dwVersion, rguid);
end;

function IDirectInputDevice7W_CreateEffect(idd : IDirectInputDevice7W; const rguid : TGUID; lpeff : PDIEffect; var ppdeff : IDirectInputEffect; punkOuter : IUnknown) : HResult; stdcall;
begin
	result := idd^^.CreateEffect(idd, rguid, lpeff, ppdeff, punkOuter);
end;

function IDirectInputDevice7W_EnumEffects(idd : IDirectInputDevice7W; lpCallback : TDIEnumEffectsCallbackW; pvRef : pointer; dwEffType : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumEffects(idd, @lpCallback, pvRef, dwEffType);
end;

function IDirectInputDevice7W_GetEffectInfo(idd : IDirectInputDevice7W; pdei : TDIEffectInfoW; const rguid : TGUID) : HResult; stdcall;
begin
	result := idd^^.GetEffectInfo(idd, pdei, rguid);
end;

function IDirectInputDevice7W_GetForceFeedbackState(idd : IDirectInputDevice7W; var pdwOut : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetForceFeedbackState(idd, pdwOut);
end;

function IDirectInputDevice7W_SendForceFeedbackCommand(idd : IDirectInputDevice7W; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.SendForceFeedbackCommand(idd, dwFlags);
end;

function IDirectInputDevice7W_EnumCreatedEffectObjects(idd : IDirectInputDevice7W; lpCallback : TDIEnumCreatedEffectObjectsCallback; pvRef : pointer; fl : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumCreatedEffectObjects(idd, @lpCallback, pvRef, fl);
end;

function IDirectInputDevice7W_Escape(idd : IDirectInputDevice7W; var pesc : TDIEffEscape) : HResult; stdcall;
begin
	result := idd^^.Escape(idd, pesc);
end;

function IDirectInputDevice7W_Poll(idd : IDirectInputDevice7W) : HResult; stdcall;
begin
	result := idd^^.Poll(idd);
end;

function IDirectInputDevice7W_SendDeviceData(idd : IDirectInputDevice7W; cbObjectData : DWORD; var rgdod : TDIDeviceObjectData; var pdwInOut : DWORD; fl : DWORD) : HResult; stdcall;
begin
	result := idd^^.SendDeviceData(idd, cbObjectData, rgdod, pdwInOut, fl);
end;

function IDirectInputDevice7W_EnumEffectsInFile(idd : IDirectInputDevice7W; const lpszFileName : PChar; pec : TEnumEffectsInFileCallback; pvRef : Pointer; dwFlags : DWord) : HResult; stdcall;
begin
	result := idd^^.EnumEffectsInFile(idd, lpszFileName, @pec, pvRef, dwFlags);
end;

function IDirectInputDevice7W_WriteEffectToFile(idd : IDirectInputDevice7W; const lpszFileName : PChar; dwEntries : DWord; const rgDIFileEft : PDIFileEffect; dwFlags : DWord) : HResult; stdcall;
begin
	result := idd^^.WriteEffectToFile(idd, lpszFileName, dwEntries, rgDIFileEft, dwFlags);
end;


// IDirectInputDevice7A interface methods

function IDirectInputDevice7A_QueryInterface(idd : IDirectInputDevice7A; const IID : TGUID; var obj) : HRESULT; stdcall;
begin
	result := idd^^.QueryInterface(idd, IID, obj);
end;

function IDirectInputDevice7A_AddRef(idd : IDirectInputDevice7A) : Longint; stdcall;
begin
	result := idd^^.AddRef(idd);
end;

function IDirectInputDevice7A_Release(idd : IDirectInputDevice7A) : Longint; stdcall;
begin
	result := idd^^.Release(idd);
end;

function IDirectInputDevice7A_GetCapabilities(idd : IDirectInputDevice7A; var lpDIDevCaps : TDIDevCaps) : HResult; stdcall;
begin
	result := idd^^.GetCapabilities(idd, lpDIDevCaps);
end;

function IDirectInputDevice7A_EnumObjects(idd : IDirectInputDevice7A; lpCallback : TDIEnumDeviceObjectsCallbackA; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumObjects(idd, @lpCallback, pvRef, dwFlags);
end;

function IDirectInputDevice7A_GetProperty(idd : IDirectInputDevice7A; rguidProp : PGUID; var pdiph : TDIPropHeader) : HResult; stdcall;
begin
	result := idd^^.GetProperty(idd, rguidProp, pdiph);
end;

function IDirectInputDevice7A_SetProperty(idd : IDirectInputDevice7A; rguidProp : PGUID; const pdiph : TDIPropHeader) : HResult; stdcall;
begin
	result := idd^^.SetProperty(idd, rguidProp, pdiph);
end;

function IDirectInputDevice7A_Acquire(idd : IDirectInputDevice7A) : HResult; stdcall;
begin
	result := idd^^.Acquire(idd);
end;

function IDirectInputDevice7A_Unacquire(idd : IDirectInputDevice7A) : HResult; stdcall;
begin
	result := idd^^.Unacquire(idd);
end;

function IDirectInputDevice7A_GetDeviceState(idd : IDirectInputDevice7A; cbData : DWORD; lpvData : Pointer) : HResult; stdcall;
begin
	result := idd^^.GetDeviceState(idd, cbData, lpvData);
end;

function IDirectInputDevice7A_GetDeviceData(idd : IDirectInputDevice7A; cbObjectData : DWORD; rgdod : PDIDeviceObjectData; var pdwInOut : DWORD; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetDeviceData(idd, cbObjectData, rgdod, pdwInOut, dwFlags);
end;

function IDirectInputDevice7A_SetDataFormat(idd : IDirectInputDevice7A; var lpdf : TDIDataFormat) : HResult; stdcall;
begin
	result := idd^^.SetDataFormat(idd, lpdf);
end;

function IDirectInputDevice7A_SetEventNotification(idd : IDirectInputDevice7A; hEvent : THandle) : HResult; stdcall;
begin
	result := idd^^.SetEventNotification(idd, hEvent);
end;

function IDirectInputDevice7A_SetCooperativeLevel(idd : IDirectInputDevice7A; hwnd : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.SetCooperativeLevel(idd, hwnd, dwFlags);
end;

function IDirectInputDevice7A_GetObjectInfo(idd : IDirectInputDevice7A; var pdidoi : TDIDeviceObjectInstanceA; dwObj : DWORD; dwHow : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetObjectInfo(idd, pdidoi, dwObj, dwHow);
end;

function IDirectInputDevice7A_GetDeviceInfo(idd : IDirectInputDevice7A; var pdidi : TDIDeviceInstanceA) : HResult; stdcall;
begin
	result := idd^^.GetDeviceInfo(idd, pdidi);
end;

function IDirectInputDevice7A_RunControlPanel(idd : IDirectInputDevice7A; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.RunControlPanel(idd, hwndOwner, dwFlags);
end;

function IDirectInputDevice7A_Initialize(idd : IDirectInputDevice7A; hinst : THandle; dwVersion : DWORD; const rguid : TGUID) : HResult; stdcall;
begin
	result := idd^^.Initialize(idd, hinst, dwVersion, rguid);
end;

function IDirectInputDevice7A_CreateEffect(idd : IDirectInputDevice7A; const rguid : TGUID; lpeff : PDIEffect; var ppdeff : IDirectInputEffect; punkOuter : IUnknown) : HResult; stdcall;
begin
	result := idd^^.CreateEffect(idd, rguid, lpeff, ppdeff, punkOuter);
end;

function IDirectInputDevice7A_EnumEffects(idd : IDirectInputDevice7A; lpCallback : TDIEnumEffectsCallbackA; pvRef : pointer; dwEffType : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumEffects(idd, @lpCallback, pvRef, dwEffType);
end;

function IDirectInputDevice7A_GetEffectInfo(idd : IDirectInputDevice7A; pdei : TDIEffectInfoA; const rguid : TGUID) : HResult; stdcall;
begin
	result := idd^^.GetEffectInfo(idd, pdei, rguid);
end;

function IDirectInputDevice7A_GetForceFeedbackState(idd : IDirectInputDevice7A; var pdwOut : DWORD) : HResult; stdcall;
begin
	result := idd^^.GetForceFeedbackState(idd, pdwOut);
end;

function IDirectInputDevice7A_SendForceFeedbackCommand(idd : IDirectInputDevice7A; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.SendForceFeedbackCommand(idd, dwFlags);
end;

function IDirectInputDevice7A_EnumCreatedEffectObjects(idd : IDirectInputDevice7A; lpCallback : TDIEnumCreatedEffectObjectsCallback; pvRef : pointer; fl : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumCreatedEffectObjects(idd, @lpCallback, pvRef, fl);
end;

function IDirectInputDevice7A_Escape(idd : IDirectInputDevice7A; var pesc : TDIEffEscape) : HResult; stdcall;
begin
	result := idd^^.Escape(idd, pesc);
end;

function IDirectInputDevice7A_Poll(idd : IDirectInputDevice7A) : HResult; stdcall;
begin
	result := idd^^.Poll(idd);
end;

function IDirectInputDevice7A_SendDeviceData(idd : IDirectInputDevice7A; cbObjectData : DWORD; var rgdod : TDIDeviceObjectData; var pdwInOut : DWORD; fl : DWORD) : HResult; stdcall;
begin
	result := idd^^.SendDeviceData(idd, cbObjectData, rgdod, pdwInOut, fl);
end;

function IDirectInputDevice7A_EnumEffectsInFile(idd : IDirectInputDevice7A; const lpszFileName : PChar; pec : TEnumEffectsInFileCallback; pvRef : Pointer; dwFlags : DWord) : HResult; stdcall;
begin
	result := idd^^.EnumEffectsInFile(idd, lpszFileName, @pec, pvRef, dwFlags);
end;

function IDirectInputDevice7A_WriteEffectToFile(idd : IDirectInputDevice7A; const lpszFileName : PChar; dwEntries : DWord; const rgDIFileEft : PDIFileEffect; dwFlags : DWord) : HResult; stdcall;
begin
	result := idd^^.WriteEffectToFile(idd, lpszFileName, dwEntries, rgDIFileEft, dwFlags);
end;


// IDirectInputW interface methods

function IDirectInputW_QueryInterface(idd : IDirectInputW; const IID : TGUID; var obj) : HRESULT; stdcall;
begin
	result := idd^^.QueryInterface(idd, IID, obj);
end;

function IDirectInputW_AddRef(idd : IDirectInputW) : Longint; stdcall;
begin
	result := idd^^.AddRef(idd);
end;

function IDirectInputW_Release(idd : IDirectInputW) : Longint; stdcall;
begin
	result := idd^^.Release(idd);
end;

function IDirectInputW_CreateDevice(idd : IDirectInputW; const rguid : TGUID; var lplpDirectInputDevice : IDirectInputDeviceW; pUnkOuter : IUnknown) : HResult; stdcall;
begin
	result := idd^^.CreateDevice(idd, rguid, lplpDirectInputDevice, pUnkOuter);
end;

function IDirectInputW_EnumDevices(idd : IDirectInputW; dwDevType : DWORD; lpCallback : TDIEnumDevicesCallbackW; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumDevices(idd, dwDevType, @lpCallback, pvRef, dwFlags);
end;

function IDirectInputW_GetDeviceStatus(idd : IDirectInputW; const rguidInstance : TGUID) : HResult; stdcall;
begin
	result := idd^^.GetDeviceStatus(idd, rguidInstance);
end;

function IDirectInputW_RunControlPanel(idd : IDirectInputW; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.RunControlPanel(idd, hwndOwner, dwFlags);
end;

function IDirectInputW_Initialize(idd : IDirectInputW; hinst : THandle; dwVersion : DWORD) : HResult; stdcall;
begin
	result := idd^^.Initialize(idd, hinst, dwVersion);
end;


// IDirectInputA interface methods

function IDirectInputA_QueryInterface(idd : IDirectInputA; const IID : TGUID; var obj) : HRESULT; stdcall;
begin
	result := idd^^.QueryInterface(idd, IID, obj);
end;

function IDirectInputA_AddRef(idd : IDirectInputA) : Longint; stdcall;
begin
	result := idd^^.AddRef(idd);
end;

function IDirectInputA_Release(idd : IDirectInputA) : Longint; stdcall;
begin
	result := idd^^.Release(idd);
end;

function IDirectInputA_CreateDevice(idd : IDirectInputA; const rguid : TGUID; var lplpDirectInputDevice : IDirectInputDeviceA; pUnkOuter : IUnknown) : HResult; stdcall;
begin
	result := idd^^.CreateDevice(idd, rguid, lplpDirectInputDevice, pUnkOuter);
end;

function IDirectInputA_EnumDevices(idd : IDirectInputA; dwDevType : DWORD; lpCallback : TDIEnumDevicesCallbackA; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumDevices(idd, dwDevType, @lpCallback, pvRef, dwFlags);
end;

function IDirectInputA_GetDeviceStatus(idd : IDirectInputA; const rguidInstance : TGUID) : HResult; stdcall;
begin
	result := idd^^.GetDeviceStatus(idd, rguidInstance);
end;

function IDirectInputA_RunControlPanel(idd : IDirectInputA; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.RunControlPanel(idd, hwndOwner, dwFlags);
end;

function IDirectInputA_Initialize(idd : IDirectInputA; hinst : THandle; dwVersion : DWORD) : HResult; stdcall;
begin
	result := idd^^.Initialize(idd, hinst, dwVersion);
end;


// IDirectInput2W interface methods

function IDirectInput2W_QueryInterface(idd : IDirectInput2W; const IID : TGUID; var obj) : HRESULT; stdcall;
begin
	result := idd^^.QueryInterface(idd, IID, obj);
end;

function IDirectInput2W_AddRef(idd : IDirectInput2W) : Longint; stdcall;
begin
	result := idd^^.AddRef(idd);
end;

function IDirectInput2W_Release(idd : IDirectInput2W) : Longint; stdcall;
begin
	result := idd^^.Release(idd);
end;

function IDirectInput2W_CreateDevice(idd : IDirectInput2W; const rguid : TGUID; var lplpDirectInputDevice : IDirectInputDeviceW; pUnkOuter : IUnknown) : HResult; stdcall;
begin
	result := idd^^.CreateDevice(idd, rguid, lplpDirectInputDevice, pUnkOuter);
end;

function IDirectInput2W_EnumDevices(idd : IDirectInput2W; dwDevType : DWORD; lpCallback : TDIEnumDevicesCallbackW; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumDevices(idd, dwDevType, @lpCallback, pvRef, dwFlags);
end;

function IDirectInput2W_GetDeviceStatus(idd : IDirectInput2W; const rguidInstance : TGUID) : HResult; stdcall;
begin
	result := idd^^.GetDeviceStatus(idd, rguidInstance);
end;

function IDirectInput2W_RunControlPanel(idd : IDirectInput2W; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.RunControlPanel(idd, hwndOwner, dwFlags);
end;

function IDirectInput2W_Initialize(idd : IDirectInput2W; hinst : THandle; dwVersion : DWORD) : HResult; stdcall;
begin
	result := idd^^.Initialize(idd, hinst, dwVersion);
end;

function IDirectInput2W_FindDevice(idd : IDirectInput2W; const rguidClass : TGUID; ptszName : PWideChar; var pguidInstance : TGUID) : HResult; stdcall;
begin
	result := idd^^.FindDevice(idd, rguidClass, ptszName, pguidInstance);
end;


// IDirectInput2A interface methods

function IDirectInput2A_QueryInterface(idd : IDirectInput2A; const IID : TGUID; var obj) : HRESULT; stdcall;
begin
	result := idd^^.QueryInterface(idd, IID, obj);
end;

function IDirectInput2A_AddRef(idd : IDirectInput2A) : Longint; stdcall;
begin
	result := idd^^.AddRef(idd);
end;

function IDirectInput2A_Release(idd : IDirectInput2A) : Longint; stdcall;
begin
	result := idd^^.Release(idd);
end;

function IDirectInput2A_CreateDevice(idd : IDirectInput2A; const rguid : TGUID; var lplpDirectInputDevice : IDirectInputDeviceA; pUnkOuter : IUnknown) : HResult; stdcall;
begin
	result := idd^^.CreateDevice(idd, rguid, lplpDirectInputDevice, pUnkOuter);
end;

function IDirectInput2A_EnumDevices(idd : IDirectInput2A; dwDevType : DWORD; lpCallback : TDIEnumDevicesCallbackA; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumDevices(idd, dwDevType, @lpCallback, pvRef, dwFlags);
end;

function IDirectInput2A_GetDeviceStatus(idd : IDirectInput2A; const rguidInstance : TGUID) : HResult; stdcall;
begin
	result := idd^^.GetDeviceStatus(idd, rguidInstance);
end;

function IDirectInput2A_RunControlPanel(idd : IDirectInput2A; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.RunControlPanel(idd, hwndOwner, dwFlags);
end;

function IDirectInput2A_Initialize(idd : IDirectInput2A; hinst : THandle; dwVersion : DWORD) : HResult; stdcall;
begin
	result := idd^^.Initialize(idd, hinst, dwVersion);
end;

function IDirectInput2A_FindDevice(idd : IDirectInput2A; const rguidClass : TGUID; ptszName : PAnsiChar; var pguidInstance : TGUID) : HResult; stdcall;
begin
	result := idd^^.FindDevice(idd, rguidClass, ptszName, pguidInstance);
end;


// IDirectInput7W interface methods

function IDirectInput7W_QueryInterface(idd : IDirectInput7W; const IID : TGUID; var obj) : HRESULT; stdcall;
begin
	result := idd^^.QueryInterface(idd, IID, obj);
end;

function IDirectInput7W_AddRef(idd : IDirectInput7W) : Longint; stdcall;
begin
	result := idd^^.AddRef(idd);
end;

function IDirectInput7W_Release(idd : IDirectInput7W) : Longint; stdcall;
begin
	result := idd^^.Release(idd);
end;

function IDirectInput7W_CreateDevice(idd : IDirectInput7W; const rguid : TGUID; var lplpDirectInputDevice : IDirectInputDeviceW; pUnkOuter : IUnknown) : HResult; stdcall;
begin
	result := idd^^.CreateDevice(idd, rguid, lplpDirectInputDevice, pUnkOuter);
end;

function IDirectInput7W_EnumDevices(idd : IDirectInput7W; dwDevType : DWORD; lpCallback : TDIEnumDevicesCallbackW; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumDevices(idd, dwDevType, @lpCallback, pvRef, dwFlags);
end;

function IDirectInput7W_GetDeviceStatus(idd : IDirectInput7W; const rguidInstance : TGUID) : HResult; stdcall;
begin
	result := idd^^.GetDeviceStatus(idd, rguidInstance);
end;

function IDirectInput7W_RunControlPanel(idd : IDirectInput7W; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.RunControlPanel(idd, hwndOwner, dwFlags);
end;

function IDirectInput7W_Initialize(idd : IDirectInput7W; hinst : THandle; dwVersion : DWORD) : HResult; stdcall;
begin
	result := idd^^.Initialize(idd, hinst, dwVersion);
end;

function IDirectInput7W_FindDevice(idd : IDirectInput7W; const rguidClass : TGUID; ptszName : PWideChar; var pguidInstance : TGUID) : HResult; stdcall;
begin
	result := idd^^.FindDevice(idd, rguidClass, ptszName, pguidInstance);
end;

function IDirectInput7W_CreateDeviceEx(idd : IDirectInput7W; const rguid , riid : TGUID; var lplpDirectInputDevice; pUnkOuter : IUnknown) : HResult; stdcall;
begin
	result := idd^^.CreateDeviceEx(idd, rguid, riid, lplpDirectInputDevice, pUnkOuter);
end;


// IDirectInput7A interface methods

function IDirectInput7A_QueryInterface(idd : IDirectInput7A; const IID : TGUID; var obj) : HRESULT; stdcall;
begin
	result := idd^^.QueryInterface(idd, IID, obj);
end;

function IDirectInput7A_AddRef(idd : IDirectInput7A) : Longint; stdcall;
begin
	result := idd^^.AddRef(idd);
end;

function IDirectInput7A_Release(idd : IDirectInput7A) : Longint; stdcall;
begin
	result := idd^^.Release(idd);
end;

function IDirectInput7A_CreateDevice(idd : IDirectInput7A; const rguid : TGUID; var lplpDirectInputDevice : IDirectInputDeviceA; pUnkOuter : IUnknown) : HResult; stdcall;
begin
	result := idd^^.CreateDevice(idd, rguid, lplpDirectInputDevice, pUnkOuter);
end;

function IDirectInput7A_EnumDevices(idd : IDirectInput7A; dwDevType : DWORD; lpCallback : TDIEnumDevicesCallbackA; pvRef : Pointer; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.EnumDevices(idd, dwDevType, @lpCallback, pvRef, dwFlags);
end;

function IDirectInput7A_GetDeviceStatus(idd : IDirectInput7A; const rguidInstance : TGUID) : HResult; stdcall;
begin
	result := idd^^.GetDeviceStatus(idd, rguidInstance);
end;

function IDirectInput7A_RunControlPanel(idd : IDirectInput7A; hwndOwner : HWND; dwFlags : DWORD) : HResult; stdcall;
begin
	result := idd^^.RunControlPanel(idd, hwndOwner, dwFlags);
end;

function IDirectInput7A_Initialize(idd : IDirectInput7A; hinst : THandle; dwVersion : DWORD) : HResult; stdcall;
begin
	result := idd^^.Initialize(idd, hinst, dwVersion);
end;

function IDirectInput7A_FindDevice(idd : IDirectInput7A; const rguidClass : TGUID; ptszName : PAnsiChar; var pguidInstance : TGUID) : HResult; stdcall;
begin
	result := idd^^.FindDevice(idd, rguidClass, ptszName, pguidInstance);
end;

function IDirectInput7A_CreateDeviceEx(idd : IDirectInput7A; const rguid , riid : TGUID; var lplpDirectInputDevice; pUnkOuter : IUnknown) : HResult; stdcall;
begin
	result := idd^^.CreateDeviceEx(idd, rguid, riid, lplpDirectInputDevice, pUnkOuter);
end;


begin
end.
