// Test MOS forms program

Program Forms;

Uses
     Classes,
     MosBase,
     MosColors,
     MosCrt,
     MosDialogs,
     MosForms,
     MosGadgets,
     MosStrings,
     MosText;

Type

//****************************************************************************
//****************************************************************************
//****************************************************************************

TMainForm = Class(TForm)
   Private
      fButtonOk      :TButton;          // Validation button
      fButtonClose   :TButton;          // Close window button

   Public
      Constructor Create(AOwner:TComponent); Override;

   Published
      Procedure FormCreate     (Sender:TObject);
      Procedure FormActivate   (Sender:TObject);
      Procedure FormClose      (Sender:TObject; Var Action:TCloseAction);
      Procedure FormCloseQuery (Sender:TObject; Var CanClose:Boolean);
      Procedure FormDeactivate (Sender:TObject);
      Procedure FormHide       (Sender:TObject);
      Procedure FormMouseMove  (Sender:TObject; Shift:TShiftState; X,Y:Integer);
      Procedure FormPaint      (Sender:TObject);
      Procedure FormShow       (Sender:TObject);

      Procedure FormExtended   (Sender:TObject);
      Procedure FormMoved      (Sender:TObject);
      Procedure FormMoving     (Sender:TObject; Var aLeft,aTop:Integer);
      Procedure FormSized      (Sender:TObject);
      Procedure FormSizing     (Sender:TObject; Var aWidth,aHeight:Integer);
      Procedure FormSwapped    (Sender:TObject);
      Procedure FormTest       (Sender:TObject);
   End;

//****************************************************************************
//****************************************************************************
//****************************************************************************

//TAssistantForm = Class(TMainForm);  // Hritage. Les composants du parent sont dj grs...

//****************************************************************************
//****************************************************************************
//****************************************************************************

TAutoActiveForm = Class(TForm)
   Public
      Constructor Create(AOwner:TComponent); Override;
End;

//****************************************************************************
//****************************************************************************
//****************************************************************************

Var MainForm       :TMainForm;
    AutoActiveForm :TForm;
//    AssistantForm  :TAssistantForm;

//****************************************************************************
//****************************************************************************
//****************************************************************************

Constructor TAutoActiveForm.Create(AOwner:TComponent);
Begin
   Inherited;

   AutoActivate := TRUE;
   FullHandle   := TRUE;

   AfterCreate;                                // Needed to activate some events if exists
End;

//****************************************************************************
//****************************************************************************
//****************************************************************************

Procedure TMainForm.FormCloseQuery(Sender:TObject; Var CanClose:Boolean);
Var Num:Integer;
Begin
   Sender := Sender;                           // To avoid warnings

   Num := 2;
   If Req_Dialog('FormCloseQuery','OnCloseQuery request|Do you want to quit application ?','_TRUE|_FALSE',Num) = 2 Then
   Begin
      CanClose := FALSE;
   End;
End;

Procedure TMainForm.FormClose(Sender:TObject; Var Action:TCloseAction);
Var Num:Integer;
Begin
   Sender := Sender;                           // To avoid warnings

   Num := 2;
   If Req_Dialog('FormClose','OnClose request|Choose the result you want to return to Event','CA_Free|CA_None',Num) = 2 Then
   Begin
      Action := CANone;
   End;
End;

Procedure TMainForm.FormMoved(Sender:TObject);
Begin
   Sender := Sender;                           // To avoid warnings
   ShowMessage('FormMoved');
End;

Procedure TMainForm.FormMoving(Sender:TObject; Var aLeft,aTop:Integer);
Begin
   Sender := Sender;                           // To avoid warnings
   Display(000,000,-1,'Window is moving...');
   Display(000,010,-1,'Left = ' + Str_I2S(aLeft));
   Display(000,020,-1,'Top  = ' + Str_I2S(aTop));
End;

Procedure TMainForm.FormSizing(Sender:TObject; Var aWidth,aHeight:Integer);
Begin
   Sender := Sender;                           // To avoid warnings
   Display(000,000,-1,'Window is sizing...');
   Display(000,010,-1,'Width  = ' + Str_I2S(aWidth));
   Display(000,020,-1,'Height = ' + Str_I2S(aHeight));
End;

Procedure TMainForm.FormMouseMove(Sender:TObject; Shift:TShiftState; X,Y:Integer);
Begin
   Sender := Sender;                           // To avoid warnings
   Shift := Shift;
   Display(000,000,-1,'Mouse is moving over the window...');
   Display(000,010,-1,'Pos (' + Str_I2S(X) + ',' + Str_I2S(Y) + ')');
//   Display(000,020,-1,'Shift = ' + String(Shift));
End;

Procedure TMainForm.FormSized(Sender:TObject);
Begin
   Sender := Sender;                           // To avoid warnings
   ShowMessage('FormSized');
End;

Procedure TMainForm.FormExtended(Sender:TObject);
Begin
   Sender := Sender;                           // To avoid warnings
   ShowMessage('FormExtended');
End;

Procedure TMainForm.FormSwapped(Sender:TObject);
Begin
   Sender := Sender;                           // To avoid warnings
   ShowMessage('FormSwapped');
End;

Procedure TMainForm.FormTest(Sender:TObject);
Begin
   Sender := Sender;                           // To avoid warnings
//   ShowMessage('FormTest');

   If Button_GetMsg(fButtonOk,1) = CMSelected Then
   Begin
      ShowMessage('fButtonOk GetMsg: Change the window background color and title caption...');
{      CloseButton      := Not CloseButton;
      SwapButton       := Not SwapButton;
      SizeButton       := Not SizeButton;
      ExtendedButton   := Not ExtendedButton;}

      Color   := CLRed;
      Caption := 'My new title';

//      Activated := TRUE;
//      Transparent := TRUE;
   End;
   If Button_GetMsg(fButtonClose,1) = CMSelected Then Close;
End;

Procedure TMainForm.FormShow(Sender:TObject);
Begin
   Sender := Sender;                           // To avoid warnings
   ShowMessage('FormShow');
End;

Procedure TMainForm.FormPaint(Sender:TObject);
Begin
   Sender := Sender;                           // To avoid warnings
   ShowMessage('FormPaint');

   Button(010,010,100,-1, CLTextButton,CLBgButton,$0010,fButtonClose,'_Close Window');
   Button(050,050,100,-1, CLTextButton,CLBgButton,$0010,fButtonOk,   '_Ok');
End;

Procedure TMainForm.FormActivate(Sender:TObject);
Begin
   Sender := Sender;                           // To avoid warnings
   ShowMessage('FormActivate');
End;

Procedure TMainForm.FormDeactivate(Sender:TObject);
Begin
   Sender := Sender;                           // To avoid warnings
   ShowMessage('FormDeactivate');
End;

Procedure TMainForm.FormHide(Sender:TObject);
Begin
   Sender := Sender;                           // To avoid warnings
   ShowMessage('FormHide');
End;

Procedure TMainForm.FormCreate(Sender:TObject);
Begin
   Sender := Sender;                           // To avoid warnings
   ShowMessage('FormCreate');

   Caption          := 'Window caption';
   Color            := CLBlue;
   CanMove          := TRUE;
//   Locked           := TRUE;
   LimitToScreen    := FALSE;
   Activated        := TRUE;
   Transparent      := FALSE;

   CloseButton      := FALSE;
   SwapButton       := TRUE;
   SizeButton       := TRUE;
   ExtendedButton   := TRUE;

   ShowTitle        := TRUE;
   ShowBorders      := TRUE;
End;

Constructor TMainForm.Create(AOwner:TComponent);
Begin
   Inherited;

   OnActivate   := @FormActivate;
   OnCreate     := @FormCreate;                // Events assignation
   OnClose      := @FormClose;
   OnCloseQuery := @FormCloseQuery;
   OnDeactivate := @FormDeactivate;
   OnHide       := @FormHide;
   OnMouseMove  := @FormMouseMove;
   OnPaint      := @FormPaint;
   OnShow       := @FormShow;

   OnExtended   := @FormExtended;
   OnMoved      := @FormMoved;
   OnMoving     := @FormMoving;
   OnSized      := @FormSized;
   OnSizing     := @FormSizing;
   OnSwapped    := @FormSwapped;
   OnTest       := @FormTest;

   AfterCreate;                                // Needed to activate some events
End;

//****************************************************************************
//****************************************************************************
//****************************************************************************

Procedure TestForm1;                           // Manage the MainForm test
Begin
{   MainForm := TMainForm.Create(NIL);
   Try
      MainForm.ShowModal;                      // Display and manage the form
   Finally
      MainForm.Free;
   End;
}
//****************************************************************************

   AutoActiveForm := TAutoActiveForm.Create(NIL);
   Try
      AutoActiveForm.ShowModal;                // Display and manage the form
   Finally
      AutoActiveForm.Free;
   End;

//****************************************************************************

{   AssistantForm := TAssistantForm.Create(NIL);
   Try
      AssistantForm.ShowModal;                 // Display and manage the form
   Finally
      AssistantForm.Free;
   End;}
End;

//****************************************************************************

Begin
   TApplication.Initialize;             // Initialise all for application
   Application.Run;                     // Run application

   TestForm1;                           // Check for the Form1

   Application.Close;                   // Restore all for application
End.
