{   * * * LUFT NUR IM PROTECTED MODE - ONLY FOR PROTECTED MODE * * *

                  ------------------------------------
                                GXFONT
                  ------------------------------------
                                v1.00
                  ------------------------------------

VERSION HISTORY

Version 1.00
  + Loader for MS-FNT-Files
  + Font-Management and Output-Functions

                       --------------------------
}

UNIT gxfont;

INTERFACE

{$I GXGLOBAL.PPI}

TYPE TFontHandle=longint;

     TCharInfo=RECORD
       width:word;
       offset:word;
     END;

     PFontHeader=^TFontHeader;
     TFontHeader=RECORD
       dfVersion:word;
       dfSize:longint;
       dfCopyright:array[1..60] of char;
       dfType:word;
       dfPoints:smallint;
       dfVertRes:smallint;
       dfHorizRes:smallint;
       dfAscent:smallint;
       dfInternalLeading:smallint;
       dfExternalLeading:smallint;

       dfItalic:byte;
       dfUnderline:byte;
       dfStrikeOut:byte;
       dfWeight:smallint;
       dfCharSet:byte;
       dfPixWidth:smallint;
       dfPixHeight:smallint;
       dfPitchAndFamily:byte;
       dfAvgWidth:smallint;
       dfMaxWidth:smallint;
       dfFirstChar:byte;
       dfLastChar:byte;
       dfDefaultChar:byte;
       dfBreakChar:byte;
       dfWidthBytes:smallint;
       dfDevice:byte;
       dfFace:byte;
       dfBitsPointer:smallint;
       dfBitsOffset:smallint;
       dfReserved:smallint;
       dfFlags:smallint;
       dfAspace:byte;
       dfBspace:byte;
       dfCspace:byte;
       dfColorpoints:word;
       dfReserved1:smallint;
       dfCharTable:array[0..255] of TCharInfo;
     END;

FUNCTION LoadFont(Datei:string):TFontHandle;
PROCEDURE outtext(nr:TFontHandle;x,y:longint;s:string;f:longint);
FUNCTION textlength(nr:TFontHandle;s:string):smallint;
FUNCTION textheight(nr:TFontHandle;s:string):smallint;
FUNCTION charheight(nr:TFontHandle):smallint;
FUNCTION RemoveFont(nr:TFontHandle):TFontHandle;

IMPLEMENTATION

USES gxcrtext,graphix;

TYPE PFontInfo=^TFontInfo;
     TFontInfo=RECORD
       FontPtr:PFontHeader;
       FontSize:longint;
     END;

CONST ASCIItoANSI:array[0..255] of byte=
        ($00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$A4,
         $10,$11,$12,$13,$B6,$A7,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
         $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,
         $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F,
         $40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F,
         $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$5B,$5C,$5D,$5E,$5F,
         $60,$61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F,
         $70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$7B,$7C,$7D,$7E,$7F,

         $C7,$FC,$E9,$E2,$E4,$E0,$E5,$E7,$EA,$EB,$E8,$EF,$EE,$EC,$C4,$C5,
         $C9,$E6,$C6,$F4,$F6,$F2,$FB,$F9,$FF,$D6,$DC,$A2,$A3,$A5,$20,$20,
         $E1,$ED,$F3,$FA,$F1,$D1,$AA,$BA,$BF,$A9,$AC,$BD,$BC,$A1,$AB,$BB,
         $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB,$BC,$BD,$BE,$BF,
         $C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF,
         $D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF,
         $E0,$DF,$E2,$E3,$E4,$E5,$B5,$E7,$E8,$E9,$EA,$EB,$EC,$F8,$EE,$EF,
         $F0,$B1,$F2,$F3,$F4,$F5,$F6,$F7,$B0,$F9,$FA,$FB,$B3,$B2,$FE,$FF);

CONST MaxFonts=255;

VAR FontList:array[1..MaxFonts] of PFontInfo;

FUNCTION LoadFont(Datei:string):TFontHandle;
VAR f:file;
    i,io:longint;
BEGIN
  i:=0;
  IF (checkfile(Datei)=0) THEN
    BEGIN
      REPEAT
        inc(i);
      UNTIL (FontList[i]=nil) OR (i>=MaxFonts);
      IF (FontList[i]=nil) THEN
        BEGIN
          assign(f,Datei);
          reset(f,1);
          new(FontList[i]);
          WITH FontList[i]^ DO
            BEGIN
              FontSize:=filesize(f);
              getmem(FontPtr,FontSize);
              blockread(f,FontPtr^,FontSize,io);
            END;
          close(f);
        END;
    END;
  LoadFont:=i;
END;

PROCEDURE outtext(nr:TFontHandle;x,y:longint;s:string;f:longint);
VAR i,ch:byte;
    xd,yd,xp,xs,xe,ys,ye,xps,xdb:longint;
    charofs,fontofs:longint;
BEGIN
  xp:=x;
  fontofs:=longint(FontList[nr]^.FontPtr);
  WITH FontList[nr]^.FontPtr^ DO
    BEGIN
      yd:=dfPixHeight;
      FOR i:=1 TO ord(s[0]) DO
        BEGIN
          ch:=ASCIItoANSI[ord(s[i])];
          CASE ch OF
            10:inc(y,dfPixheight);
            13:xp:=x;
            ELSE
              BEGIN
                IF (ch>=dfFirstChar) AND (ch<=dfLastChar) THEN
                  dec(ch,dfFirstChar) ELSE ch:=dfDefaultChar;
                WITH dfCharTable[ch] DO
                  BEGIN
                    charofs:=fontofs+offset;
                    xd:=width;
                    xdb:=(xd-1) SHR 3;
                  END;
                ASM
                  MOV ECX,xdb
                  INC ECX
                  MOV EDX,f
                  MOV EDI,xp
                  MOV ESI,charofs

                @loop1:
                  PUSH ECX

                  MOV ECX,yd
                  MOV EBX,y
                @loop2:
                  PUSH ECX
                  LODSB
                  MOV ECX,8

                  PUSH EDI
                @loop3:
                  SHL AL,1
                  JNC @keinpunkt
                  PUSHAD
                  PUSH EDX
                  PUSH EBX
                  PUSH EDI
                  CALL putpixel
                  POPAD
                @keinpunkt:
                  INC EDI
                  LOOP @loop3
                  POP EDI

                  POP ECX
                  INC EBX
                  LOOP @loop2
                  POP ECX
                  ADD EDI,8
                  LOOP @loop1
                END;
                inc(xp,xd);
              END;
          END;
        END;
    END;
END;

FUNCTION textlength(nr:TFontHandle;s:string):smallint;
VAR i,ch:byte;
    xd1,xd2:smallint;
BEGIN
  xd1:=0;
  xd2:=0;
  WITH FontList[nr]^.FontPtr^ DO
    BEGIN
      FOR i:=1 TO ord(s[0]) DO
        BEGIN
          ch:=ASCIItoANSI[ord(s[i])];
          IF (ch=13) THEN
            BEGIN
              IF (xd1>xd2) THEN xd2:=xd1;
              xd1:=0;
            END;
          IF (ch>=dfFirstChar) AND (ch<=dfLastChar) THEN
            dec(ch,dfFirstChar)
          ELSE
            ch:=dfDefaultChar;
          inc(xd1,dfCharTable[ch].width);
       END;
    END;
  IF (xd1>xd2) THEN xd2:=xd1;
  textlength:=xd2;
END;

FUNCTION textheight(nr:TFontHandle;s:string):smallint;
VAR i:byte;
    yd:smallint;
BEGIN
  yd:=charheight(nr);
  WITH FontList[nr]^.FontPtr^ DO
    FOR i:=1 TO ord(s[0]) DO
      IF (s[i]=#10) THEN
        inc(yd,charheight(nr));
  textheight:=yd;
END;

FUNCTION charheight(nr:TFontHandle):smallint;
BEGIN
  charheight:=FontList[nr]^.FontPtr^.dfPixHeight;
END;

FUNCTION RemoveFont(nr:TFontHandle):TFontHandle;
BEGIN
  WITH FontList[nr]^ DO
    freemem(FontPtr,FontSize);
  Dispose(FontList[nr]);
  FontList[nr]:=nil;
  RemoveFont:=0;
END;

VAR i:word;

BEGIN
  FOR i:=1 TO MaxFonts DO
    FontList[i]:=nil;
END.