UNIT gximgdrw;

INTERFACE

{$I GXGLOBAL.PPI}

USES gxtypes,gxbase,graphix;

VAR iputpixel:putpixelproc;
    igetpixel:getpixelproc;
    iline,ilineXOR:lineproc;
    ilineH,ilineH_solid,ilineH_pattern:lineHproc;
    ilineV,ilineV_solid,ilineV_pattern:lineVproc;
    ibar,ibar_solid,ibar_pattern:barproc;
    ibarXOR,ibarXOR_solid,ibarXOR_pattern:barproc;
    imoverect:moverectproc;
    icaptureimage:captureimageproc;
    igetimage:getimageproc;
    iputimage:putimageproc;
    iputimageC:putimageproc;
    iputimagepart:putimagepartproc;
    iputimagepartC:putimagepartproc;
    izoomimage:zoomimageproc;
    izoomimageC:zoomimageproc;

PROCEDURE SetOutputImage(img:pimage);

IMPLEMENTATION

VAR vx1,vy1,vx2,vy2:longint;
    bytperline:longint;
    lfboffs,drawoffset:longint;

PROCEDURE SetOutputImage(img:pimage);
BEGIN
  lfboffs:=longint(img);
  drawoffset:=imagedatastart;
  vx1:=0;
  vy1:=0;
  vx2:=img^.width-1;
  vy2:=img^.width-1;
  bytperline:=img^.bytesperline;
END;

{$I GRAPHIXL.PPI}
{$I GRAPHIXM.PPI}

PROCEDURE SetProcs(col:longint);
BEGIN
  CASE col OF
    ig_col8:
      BEGIN
        iputpixel:=@putpixelL8;
        igetpixel:=@getpixelL8;
        iline:=@lineL8;
        ilineXOR:=@lineXORL8;
        ilineH:=@lineHL8;
        ilineH_solid:=@lineHL8;
        ilineH_pattern:=@lineH_patternL8;
        ilineV:=@lineVL8;
        ilineV_solid:=@lineVL8;
        ilineV_pattern:=@lineV_patternL8;
        ibar:=@barL8;
        ibar_solid:=@barL8;
        ibar_pattern:=@bar_patternL8;
        ibarXOR:=@barXORL8;
        ibarXOR_solid:=@barXORL8;
        ibarXOR_pattern:=@barXOR_patternL8;
        imoverect:=@moverectL8;
        icaptureimage:=@captureimageL8;
        igetimage:=@getimageL8;
        iputimage:=@putimageL8;
        iputimageC:=@putimageCL8;
        iputimagepart:=@putimagepartL8;
        iputimagepartC:=@putimagepartCL8;
        izoomimage:=@zoomimageL8;
        izoomimageC:=@zoomimageCL8;
        IF MMXavail THEN
          BEGIN
            ilineH:=@lineHLM8;
            ibar:=@barLM8;
            imoverect:=@moverectLM8;
            igetimage:=@getimageLM8;
            iputimage:=@putimageLM8;
          END;
      END;
    ig_col15:
      BEGIN
        iputpixel:=@putpixelL16;
        igetpixel:=@getpixelL16;
        iline:=@lineL16;
        ilineXOR:=@lineXORL16;
        ilineH:=@lineHL16;
        ilineH_solid:=@lineHL16;
        ilineH_pattern:=@lineH_patternL16;
        ilineV:=@lineVL16;
        ilineV_solid:=@lineVL16;
        ilineV_pattern:=@lineV_patternL16;
        ibar:=@barL16;
        ibar_solid:=@barL16;
        ibar_pattern:=@bar_patternL16;
        ibarXOR:=@barXORL16;
        ibarXOR_solid:=@barXORL16;
        ibarXOR_pattern:=@barXOR_patternL16;
        imoverect:=@moverectL16;
        icaptureimage:=@captureimageL16;
        igetimage:=@getimageL16;
        iputimage:=@putimageL16;
        iputimageC:=@putimageCL16;
        iputimagepart:=@putimagepartL16;
        iputimagepartC:=@putimagepartCL16;
        izoomimage:=@zoomimageL16;
        izoomimageC:=@zoomimageCL16;
        IF MMXavail THEN
          BEGIN
            ilineH:=@lineHLM16;
            ibar:=@barLM16;
            imoverect:=@moverectLM16;
            igetimage:=@getimageLM16;
            iputimage:=@putimageLM16;
          END;
       END;
    ig_col16:
      BEGIN
        iputpixel:=@putpixelL16;
        igetpixel:=@getpixelL16;
        iline:=@lineL16;
        ilineXOR:=@lineXORL16;
        ilineH:=@lineHL16;
        ilineH_solid:=@lineHL16;
        ilineH_pattern:=@lineH_patternL16;
        ilineV:=@lineVL16;
        ilineV_solid:=@lineVL16;
        ilineV_pattern:=@lineV_patternL16;
        ibar:=@barL16;
        ibar_solid:=@barL16;
        ibar_pattern:=@bar_patternL16;
        ibarXOR:=@barXORL16;
        ibarXOR_solid:=@barXORL16;
        ibarXOR_pattern:=@barXOR_patternL16;
        imoverect:=@moverectL16;
        icaptureimage:=@captureimageL16;
        igetimage:=@getimageL16;
        iputimage:=@putimageL16;
        iputimageC:=@putimageCL16;
        iputimagepart:=@putimagepartL16;
        iputimagepartC:=@putimagepartCL16;
        izoomimage:=@zoomimageL16;
        izoomimageC:=@zoomimageCL16;
        IF MMXavail THEN
          BEGIN
            ilineH:=@lineHLM16;
            ibar:=@barLM16;
            imoverect:=@moverectLM16;
            igetimage:=@getimageLM16;
            iputimage:=@putimageLM16;
          END;
      END;
    ig_col24:
      BEGIN
        iputpixel:=@putpixelL24;
        igetpixel:=@getpixelL24;
        iline:=@lineL24;
        ilineXOR:=@lineXORL24;
        ilineH:=@lineHL24;
        ilineH_solid:=@lineHL24;
        ilineH_pattern:=@lineH_patternL24;
        ilineV:=@lineVL24;
        ilineV_solid:=@lineVL24;
        ilineV_pattern:=@lineV_patternL24;
        ibar:=@barL24;
        ibar_solid:=@barL24;
        ibar_pattern:=@bar_patternL24;
        ibarXOR:=@barXORL24;
        ibarXOR_solid:=@barXORL24;
        ibarXOR_pattern:=@barXOR_patternL24;
        imoverect:=@moverectL24;
        icaptureimage:=@captureimageL24;
        igetimage:=@getimageL24;
        iputimage:=@putimageL24;
        iputimageC:=@putimageCL24;
        iputimagepart:=@putimagepartL24;
        iputimagepartC:=@putimagepartCL24;
        izoomimage:=@zoomimageL24;
        izoomimageC:=@zoomimageCL24;
        IF MMXavail THEN
          BEGIN
            ilineH:=@lineHLM24;
            ibar:=@barLM24;
            imoverect:=@moverectLM24;
            igetimage:=@getimageLM24;
            iputimage:=@putimageLM24;
          END;
      END;
    ig_col32:
      BEGIN
        iputpixel:=@putpixelL32;
        igetpixel:=@getpixelL32;
        iline:=@lineL32;
        ilineXOR:=@lineXORL32;
        ilineH:=@lineHL32;
        ilineH_solid:=@lineHL32;
        ilineH_pattern:=@lineH_patternL32;
        ilineV:=@lineVL32;
        ilineV_solid:=@lineVL32;
        ilineV_pattern:=@lineV_patternL32;
        ibar:=@barL32;
        ibar_solid:=@barL32;
        ibar_pattern:=@bar_patternL32;
        ibarXOR:=@barXORL32;
        ibarXOR_solid:=@barXORL32;
        ibarXOR_pattern:=@barXOR_patternL32;
        imoverect:=@moverectL32;
        icaptureimage:=@captureimageL32;
        igetimage:=@getimageL32;
        iputimage:=@putimageL32;
        iputimageC:=@putimageCL32;
        iputimagepart:=@putimagepartL32;
        iputimagepartC:=@putimagepartCL32;
        izoomimage:=@zoomimageL32;
        izoomimageC:=@zoomimageCL32;
        IF MMXavail THEN
          BEGIN
            ilineH:=@lineHLM32;
            ibar:=@barLM32;
            imoverect:=@moverectLM32;
            igetimage:=@getimageLM32;
            iputimage:=@putimageLM32;
          END;
      END;
  END;
END;

PROCEDURE InitGXIMGDRW;
BEGIN
  SetProcs(gxcurcol);
END;

BEGIN
  RegisterGXUnit(@InitGXIMGDRW);
END.

