{ͻ
                              UNIT MosBlankers                              
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 31.01.1998                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: Blankers Management.                                         
  AUTONOMOUS.: Partial                                                      
  UNIT SIZE..: 86 Lines and (1.872 Bytes compiled)                          
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosBlankers;

{$Mode Objfpc}

INTERFACE

{|Screen blanker|}
Procedure Screen_Blanker;                {*Manage the Screen Blanker*}
Procedure Screen_BlankerInit;            {*Reinitialise the Screen Blanker*}
Procedure Execute_Blanker(Blanker:String; Module:Byte); {*External Blanker Execution*}

IMPLEMENTATION

Uses
     Dos,
     Windows,
     MosBase,
     MosConfig,
     MosCPUInstructions,
     MosCrt,
     MosDisks,
     MosErrors,
     MosExecute,
     MosFiles,
     MosKeyboard,
     MosMouse;

{*----------------------------- Dbut Library ------------------------------*}

{ͻ
                         PROCEDURE Execute_Blanker                          
 ͹
  IN.....: Blanker (STRING) = Filename for the blanker.                     
           Module (BYTE) = A byte to specify execution or parameter.        
                  BLK_Execute   : Execute Blanker                           
                  BLK_Parameter : Parameter Blanker                         
  OUT....: /                                                                
  EXPLAIN: Execute an external screen blanker.                              
  NB.....: The blanker must be in the "SYSTEM\BLANKERS" directory.          
 ͼ}

Procedure Execute_Blanker(Blanker:String; Module:Byte);
Var Param:String;

Begin
Blanker:=Sys.GetPath(SP_BLANKERS)+Blanker;

If Not File_TestExist(Blanker) Then    {*Blanker Introuvable*}
   Begin Error(690); Exit; End;

If Module=BLK_Execute   Then Param:='';
If Module=BLK_Parameter Then Param:='-PAR';

{P:=FExpand(FSearch(ParamStr(0),GetEnv('PATH')));}
{P:=Copy(P,1,Length(P)-3)+'INI';}          {*Construit Nom du ".INI"*}
{Param:=Param+' -INI='+P;
gotoxy(1,1); writeln(Param,'  '); readkey;}

Log.Add('Executing screen blanker ('+Blanker+')',2);

Save_Config(Sys.GetPath(SP_TEMP)+'MOS.TMP');
Execute(Blanker,Param+' -LMP -HOME -INI='+Sys.GetPath(SP_TEMP)+'MOS.TMP',$117C); {*Execute Blanker*}
File_Erase(Sys.GetPath(SP_TEMP)+'MOS.TMP');
Kbd_PurgeBuffer;
End;

{*------------------------------- BLANKERS ---------------------------------*}

{ͻ
                        PROCEDURE Screen_BlankerInit                        
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Reinit the Screen Blanker timer.                                 
 ͼ}

Procedure Screen_BlankerInit;                   {*Reinitialise le Screen Blanker*}
Var Hu      :Word;
    X,Y     :Word;
    Ga,Mi,Dr:Boolean;
Begin
GetTime(SbH,SbM,SbS,Hu);                        {*Rinit Compteur Temps*}
Mse_Get(X,Y,Ga,Mi,Dr);
PosMouse.X:=X; PosMouse.Y:=Y;
End;

{ͻ
                          PROCEDURE Screen_Blanker                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Manage the Screen Blanker.                                       
  NB.....: This procedure musn't called by user (automatically call).       
 ͼ}

Procedure Screen_Blanker;
Var X,Y     :Word;
    Ga,Mi,Dr:Boolean;
    H,M,S,Hu:Word;                              {*Obtention du Temps*}
    Temps   :Integer;                           {*Temps Ecoul*}
{T1,T2:String;}

Begin
If BTST(Id_Scr1,7) Then Exit;                   {*Screen Blanker Activated Yet*}

If Sys.ScreenBlanker[1]<>'(' Then               {*Screen Blanker Dfinit ?*}
   Begin
   GetTime(H,M,S,Hu);
   Temps:=(S-SbS)+(M-SbM)*60+(H-SbH)*3600;      {*Calcul du Temps*}
{gotoxy(1,2); writeln(Temps,' ',Sys.ScreenBlankerDelay,' ');
Str(Temps,T1); Str(Sys.ScreenBlankerDelay,T2);
gotoxy(1,2); Display(0,0,-1,0,T1+' '+T2+' ');}

   If (Temps Div 60)>=Sys.ScreenBlankerDelay Then
      Begin
      Screen_BlankerInit;                       // Rinitialise Timer
      Execute_Blanker(Sys.ScreenBlanker,BLK_Execute); // Appel Blanker
      Screen_BlankerInit;                       // Rinitialise Timer
      End;

   Mse_Get(X,Y,Ga,Mi,Dr);
   If (Keypressed) Or                           // Touche Clavier Frappe
      (Mse_Clicked(0)) Or                       // Boutons Souris Presss
      (X<>PosMouse.X) Or (Y<>PosMouse.Y) Or     // Souris Dplace
      (Kbd_GetKeyDown(VK_SHIFT)) Or             // Touches Spciales
      (Kbd_GetKeyDown(VK_CONTROL)) Or
      (Kbd_GetKeyDown(VK_MENU))
      Then Screen_BlankerInit;
   End;
End;

{*-------------------------- PROGRAMME PRINCIPAL ---------------------------*}

Begin
End.

{
Specifications Techniques :

- STRUCTURE :
   * Module Blanker
   * Module Paramtrage
   * Le fichier doit tre un excutable portant le suffixe .BLK
     Il sera renomm en .EXE avant son excution
   * Le fichier doit se trouver dans le rpertoire BLANKERS
     du rpertoire SYSTEME.

- APPEL :
   * A l'appel, l'cran et la palette courante sur les 256 couleurs sera sauvegarde.

- SORTIE :
   * Sortie par appuie d'une touche ou boutons souris ou dplacement souris
}
