{ͻ
                               UNIT MosCards                                
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 26.12.1998                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: Playing Cards management Unit.                               
  AUTONOMOUS.: Partial                                                      
  UNIT SIZE..: 521 Lines and (13.248 Bytes compiled)                        
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosCards;

{$Mode Objfpc}

INTERFACE

Const
    P_Recto='RECTO\';                   {*Cards paths in Cards directory*}
    P_Verso='VERSO\';

Type TCard=Record                       {*Card record*}
    Num                :Byte;           {*Card number (1 to 52)*}
    Value              :Byte;           {*1 to 13 : 1=As, 13=King*}
    Color              :Byte;           {*1=Carreau, 2=Pique, 3=Coeur, 4=Trfle*}
    Ident              :String[10];     {*Identificator (Variable)*}
    Px,Py              :Integer;        {*X,Y Position*}
    FName              :String[12];     {*Attached Filename for BMP*}
    Visible            :Boolean;        {*Card is visible ?*}
    Movable            :Boolean;        {*Card is movable*}
    Recto              :Boolean;        {*Side of card to display*}
    End;

    TCards=Record                       {*Game cards record*}
    Max_Cards          :Integer;        {*52 Cards Max*}
    Verso              :String[12];     {*Verso File to use*}
    Cards              :Array[1..52] of TCard;{*Array of cards*}
    End;

{*------------------------ Fonctions et Procdures -------------------------*}

{|Cards parameters functions|}
Function  Card_DefineBack    (    Px,Py:Integer; FName:String):String;    {*Requester to define a card back*}

{|Cards management functions|}
Procedure Card_Define        (Var C:TCards; Num,Px,Py:Integer; Visible,Movable,Recto:Boolean); {*Define a card parameters*}
Function  Card_GetFileName   (    C:TCards; Num:Integer):String;          {*Get the attached filename for a card*}

Function  Card_GetIdent      (    C:TCards; Num:Integer):String;          {*Return "Ident" field for a card*}
Function  Card_GetRecto      (    C:TCards; Num:Integer):Boolean;         {*Return "Recto" field for a card*}
Procedure Card_Mix           (Var C:TCards);                              {*Mix the game*}
Procedure Card_NewGame       (Var C:TCards);                              {*Build a new game with cards*}
Procedure Card_SetMaximum    (Var C:TCards; Max:Integer);                 {*Define 32 or 52 cards game*}
Procedure Card_SetRecto      (Var C:TCards; Num:Integer; Recto:Boolean);  {*Define the "Recto" field*}
Procedure Card_SetIdent      (Var C:TCards; Num:Integer; Ident:String);   {*Define the "Ident" field*}
Procedure Card_SetPosition   (Var C:TCards; Num,Px,Py:Integer);           {*Define new card position*}
Procedure Card_SetMovable    (Var C:TCards; Num:Integer; Movable:Boolean);{*Define if the card is movable*}
Procedure Card_SetHide       (Var C:TCards; Num:Integer; State:Boolean);  {*Define if the card is visible*}
Procedure Card_Hide          (    C:TCards; Num:Integer);                 {*Hide the card on screen*}
Procedure Card_Display       (    C:TCards; Num:Integer);                 {*Display the card on screen*}
Procedure Card_Toggle        (    C:TCards; Num:Integer);                 {*Display the card toggled*}
Function  Card_TestMouseOver (    C:TCards; Num:Integer):Boolean;         {*Test if mouse is over a card*}

{*----------------------------- Dbut Library ------------------------------*}

IMPLEMENTATION

Uses
     SysUtils,
     MosBase,
     MosColors,
     MosConfig,
     MosErrors,
     MosFiles,
     MosGadgets,
     MosGraph,
     MosImages,
     MosList,
     MosMouse,
     MosStrings,
     MosText,
     MosTools,
     MosWindows;

{ͻ
                          FUNCTION Card_DefineBack                          
 ͹
  IN.....: Px,Py (INTEGER) = X,Y position for the Requester.                
           FName (STRING) = Card back filename in use.                      
  OUT....: (STRING) = Return the filename to use as the card back.          
  EXPLAIN: Call a requester to select an image for the card back            
           and return the selected image filename.                          
 ͼ}

Function Card_DefineBack(Px,Py:Integer; FName:String):String;
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flags*}
    But1,But2,But3:TButton;
    NewFName      :String;
    Qtt           :Integer;
    L             :TList;
    LName         :String;
    Num           :Integer;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_EXAMPLE;               {*Define Example*}
Begin
Mse_Hide;
BMP_ShowTransparency(059,014,059+70,014+96, 0,0,Sys.GetPath(SP_CARDS)+P_Verso+NewFName,$0080,CLTransparency);
Mse_Show;
End;

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
Button (LaF*4-1, HaF*12-2, LaF*14+5,-1, CLTextButton,CLBGButton,$00E0,But1,'_PREVIOUS');
Button (LaF*20-1,HaF*12-2, LaF*14+5,-1, CLTextButton,CLBGButton,$01E0,But2,'_NEXT');
Button (LaF*11-1, W1.Y2-W1.Y1-HaF1-HaF-16, LaF*16,-1, CLTextButton,CLBGButton,$0010,But3,'_OK');
Display(LaF*4-1, HaF*14-4, CLText,'CARDS BACK FOUND : '+Str_FillZero(Qtt,2));

REDRAW_EXAMPLE;                         {*Define Example*}
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+LaF*39,Py+HaF1+HaF*18+6,$5199,'DEFINE CARDS BACK',W1) Then Exit;
Win_Sup(100,050,250,200,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

LName:=Sys.GetPath(SP_TEMP)+'PCV01.LIS';
File_GetDirectory(Sys.GetPath(SP_CARDS)+P_Verso+'V*.BMP', LName);
List_Define(L,'',';',000,000,100,100, 200,CLWhite,CLWHite,$1BED);
List_Load(L,LName);                     {*Construit la liste*}
Qtt:=List_GetQttItems(L);
Num:=List_GetItemIndice(L,FName,1);     {*Get the position of Verso Card*}
NewFName:=List_GetStringCell(L,Num,1);

REDRAW_FRAME;                           {*Display Window Content*}
XOk:=No; XCancel:=No;                   {*Init Exit Flags*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                     {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then
      Begin
      Dec(Num);
      If Num<1 Then Num:=Qtt;
      NewFName:=List_GetStringCell(L,Num,1);
      REDRAW_EXAMPLE;                   {*Define Example*}
      End;
   If Button_GetMsg(But2,1)=CMSelected Then
      Begin
      Inc(Num);
      If Num>Qtt Then Num:=1;
      NewFName:=List_GetStringCell(L,Num,1);
      REDRAW_EXAMPLE;                   {*Define Example*}
      End;

   If Button_GetMsg(But3,1)=CMSelected Then XOk:=TRUE;
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;            {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flags*}

Win_Done(W1);                           {*Close Window if Needs*}
File_Erase(LName);                      {*Dtruit le fichier temporaire*}
If XCancel Then Card_DefineBack:=FName
           Else Card_DefineBack:=NewFName;
List_Done(L);
End;

{ͻ
                         FUNCTION Card_GetFileName                          
 ͹
  IN.....: C (TCard) = Pointer to the TCard structure.                      
           Num (INTEGER) = The card number (1 to 52).                       
  OUT....: (STRING) = Return the card filename corresponding to "Num".      
  EXPLAIN: Return the filename corresponding to a required card.            
 ͼ}

Function Card_GetFileName(C:TCards; Num:Integer):String;
Var Pref:Char;
Begin
Card_GetFileName:='';                   {*De base...*}
If (Num<1) Or (Num>C.Max_Cards) Then Exit;
Case Num Of                             {*Get Lettre du Prfixe*}
   01..13 : Pref:='A';
   14..26 : Pref:='B';
   27..39 : Pref:='C';
   40..52 : Pref:='D';
   End;
                                        {*Return Card Filename*}
Card_GetFileName:=Pref+Str_FillZero(((Num-1) Mod 13)+1,2)+'.BMP';
End;

{ͻ
                           PROCEDURE Card_Define                            
 ͹
  IN.....: C (TCard) = Pointer to the TCard structure.                      
           Num (INTEGER) = The card number (1 to 52).                       
           Px,Py (INTEGER) = X,Y Position for the card.                     
           Visible (BOOLEAN) = TRUE if the card is visible.                 
           Movable (BOOLEAN) = TRUE if the card is movable.                 
           Recto (BOOLEAN) = TRUE if the card side displayed is the Recto.  
  OUT....: /                                                                
  EXPLAIN: Define a card with all the required parameters.                  
  SEEALSO: Card_SetRecto, Card_SetIdent, Card_Position, Card_SetMovable     
 ͼ}

Procedure Card_Define(Var C:TCards; Num,Px,Py:Integer; Visible,Movable,Recto:Boolean);
Begin
If (Num<1) Or (Num>C.Max_Cards) Then Exit;
C.Cards[Num].Num:=Num;                  {*Define all the needed parameters*}
C.Cards[Num].Ident:='';

C.Cards[Num].Px:=Px;
C.Cards[Num].Py:=Py;
C.Cards[Num].Visible:=Visible;
C.Cards[Num].Movable:=Movable;
C.Cards[Num].Recto:=Recto;
C.Cards[Num].FName:=Card_GetFileName(C,Num);
Case Num of
   01..13 : Begin C.Cards[Num].Value:=Num-13*0; C.Cards[Num].Color:=1; End;
   14..26 : Begin C.Cards[Num].Value:=Num-13*1; C.Cards[Num].Color:=2; End;
   27..39 : Begin C.Cards[Num].Value:=Num-13*2; C.Cards[Num].Color:=3; End;
   40..52 : Begin C.Cards[Num].Value:=Num-13*3; C.Cards[Num].Color:=4; End;
   End;

End;

{ͻ
                           PROCEDURE Card_SetHide                           
 ͹

  IN.....: C (TCard) = Pointer to the TCard structure.                      
           Num (INTEGER) = The card number (1 to 52).                       
           State (BOOLEAN) = TRUE if the card needs to be hide.             

  OUT....: /                                                                
  EXPLAIN: Modify a card parameter and display a gain the card.             
  SEEALSO: Card_Define                                                      
 ͼ}

Procedure Card_SetHide(Var C:TCards; Num:Integer; State:Boolean);
Begin
If (Num<1) Or (Num>C.Max_Cards) Then Exit;
C.Cards[Num].Visible:=State;
End;

{ͻ
                         PROCEDURE Card_SetMovable                          
 ͹
  IN.....: C (TCard) = Pointer to the TCard structure.                      
           Num (INTEGER) = The card number (1 to 52).                       
           Movable (BOOLEAN) = TRUE if the card needs to be movable.        
  OUT....: /                                                                
  EXPLAIN: Modify a card parameter.                                         
  SEEALSO: Card_Define                                                      
 ͼ}


Procedure Card_SetMovable(Var C:TCards; Num:Integer; Movable:Boolean);
Begin
If (Num<1) Or (Num>C.Max_Cards) Then Exit;
C.Cards[Num].Movable:=Movable;
End;

{ͻ
                           FUNCTION Card_GetIdent                           
 ͹
  IN.....: C (TCard) = Pointer to the TCard structure.                      
           Num (INTEGER) = The card number (1 to 52).                       
  OUT....: (STRING) = Return the "Ident" field for a card.                  
  EXPLAIN: Get a card parameter.                                            
  SEEALSO: Card_SetIdent                                                    
 ͼ}

Function Card_GetIdent(C:TCards; Num:Integer):String;
Begin
If (Num<1) Or (Num>C.Max_Cards) Then Exit;
Card_GetIdent:=C.Cards[Num].Ident;

End;


{ͻ
                          PROCEDURE Card_SetIdent                           
 ͹
  IN.....: C (TCard) = Pointer to the TCard structure.                      
           Num (INTEGER) = The card number (1 to 52).                       
           Ident (STRING) = Set a new value for the "Ident" field card.     
  OUT....: /                                                                
  EXPLAIN: Modify a card parameter.                                         
  SEEALSO: Card_GetIdent                                                    
 ͼ}

Procedure Card_SetIdent(Var C:TCards; Num:Integer; Ident:String);
Begin
If (Num<1) Or (Num>C.Max_Cards) Then Exit;
C.Cards[Num].Ident:=Ident;
End;

{ͻ
                         PROCEDURE Card_SetMaximum                          
 ͹
  IN.....: C (TCard) = Pointer to the TCard structure.                      
           Max (INTEGER) = Define the maximum cards quantity.               
              Authorised values are 32 and 52.                              
  OUT....: /                                                                
  EXPLAIN: Modify a card parameter.                                         
 ͼ}

Procedure Card_SetMaximum(Var C:TCards; Max:Integer);
Begin
If (Max<>32) And (Max<>52) Then Exit;
C.Max_Cards:=Max;
End;

{ͻ
                          PROCEDURE Card_SetRecto                           
 ͹
  IN.....: C (TCard) = Pointer to the TCard structure.                      
           Num (INTEGER) = The card number (1 to 52).                       
           Recto (BOOLEAN) = Define the card side to show (TRUE = Recto).   
  OUT....: /                                                                
  EXPLAIN: Modify a card parameter.                                         
  SEEALSO: Card_GetRecto                                                    
 ͼ}

Procedure Card_SetRecto(Var C:TCards; Num:Integer; Recto:Boolean);
Begin
If (Num<1) Or (Num>C.Max_Cards) Then Exit;
C.Cards[Num].Recto:=Recto;
End;

{ͻ
                           FUNCTION Card_GetRecto                           
 ͹
  IN.....: C (TCard) = Pointer to the TCard structure.                      
           Num (INTEGER) = The card number (1 to 52).                       
  OUT....: (BOOLEAN) = Return TRUE if the card if on the Recto.             
  EXPLAIN: Get a card parameter.                                            

  SEEALSO: Card_SetRecto                                                    
 ͼ}

Function Card_GetRecto(C:TCards; Num:Integer):Boolean;
Begin

If (Num<1) Or (Num>C.Max_Cards) Then Exit;
Card_GetRecto:=C.Cards[Num].Recto;
End;

{ͻ
                         PROCEDURE Card_SetPosition                         
 ͹
  IN.....: C (TCard) = Pointer to the TCard structure.                      
           Num (INTEGER) = The card number (1 to 52).                       
           Px,Py (INTEGER) = Define the card X,Y position.                  
  OUT....: /                                                                
  EXPLAIN: Modify a card parameter.                                         
  SEEALSO: Card_Define                                                      
 ͼ}

Procedure Card_SetPosition(Var C:TCards; Num,Px,Py:Integer);
Begin
If (Num<1) Or (Num>C.Max_Cards) Then Exit;
C.Cards[Num].Px:=Px;
C.Cards[Num].Py:=Py;

End;


{ͻ
                           PROCEDURE Card_NewGame                           
 ͹

  IN.....: C (TCard) = Pointer to the TCard structure.                      
  OUT....: /                                                                
  EXPLAIN: Define a new card set using current parameters.                  
           Define each card using the Card_Define function.                 
  SEEALSO: Card_Mix                                                         
 ͼ}

Procedure Card_NewGame(Var C:TCards);
Var Num,Px,Py:Integer;
Begin
Px:=0; Py:=0;                           {*De Base...*}
For Num:=1 to C.Max_Cards do
   Begin
{   C.Cards[Num].Num:=Num;}
   Card_Define(C,Num,Px,Py,TRUE,FALSE,TRUE);
   Inc(Px,12);
   End;
End;

{ͻ
                             PROCEDURE Card_Mix                             
 ͹
  IN.....: C (TCard) = Pointer to the TCard structure.                      
  OUT....: /                                                                
  EXPLAIN: Mix the card set.                                                
  SEEALSO: Card_NewGame                                                     
 ͼ}

Procedure Card_Mix(Var C:TCards);
Var A,I1,I2    :Integer;
    CTemp      :TCard;
    Xt1,Yt1,Xt2,Yt2:Integer;
Begin
Randomize;
For A:=1 to 200 do                      {*200 mlanges !*}
   Begin
      Repeat                            {*Get two Cards Indices*}
      I1:=Random(C.Max_Cards)+1;
      I2:=Random(C.Max_Cards)+1;
      Until I1<>I2;
   CTemp:=C.Cards[I1];                  {*Swap Two cards*}
   Xt1:=C.Cards[I1].Px; Yt1:=C.Cards[I1].Py;
   Xt2:=C.Cards[I2].Px; Yt2:=C.Cards[I2].Py;
   C.Cards[I1]:=C.Cards[I2];
   C.Cards[I2]:=CTemp;
   C.Cards[I1].Px:=Xt1; C.Cards[I1].Py:=Yt1;{*Restore Good Position*}
   C.Cards[I2].Px:=Xt2; C.Cards[I2].Py:=Yt2;
   End;
End;

{ͻ
                           PROCEDURE Card_Display                           
 ͹
  IN.....: C (TCard) = Pointer to the TCard structure.                      
           Num (INTEGER) = The card number (1 to 52).                       
  OUT....: /                                                                
  EXPLAIN: Display a card using self parameters.                            
  SEEALSO: Card_Toggle, Card_Hide                                           
 ͼ}

Procedure Card_Display(C:TCards; Num:Integer);
Var FName:String;
    Id:Word;
Begin
If (Num<1) Or (Num>C.Max_Cards) Then Exit;
If Not C.Cards[Num].Visible Then Exit;
If C.Cards[Num].Recto Then Begin FName:=P_Recto+C.Cards[Num].FName; Id:=$0080; End
                      Else Begin FName:=P_Verso+C.Verso; Id:=$00A0; End;
Mse_Hide;
BMP_ShowTransparency
  (C.Cards[Num].Px-1,
   C.Cards[Num].Py-6,
   C.Cards[Num].Px-1+70,
   C.Cards[Num].Py-6+96,0,0,Sys.GetPath(SP_CARDS)+FName,Id,CLTransparency);
Mse_Show;
End;

{ͻ
                           PROCEDURE Card_Toggle                            
 ͹
  IN.....: C (TCard) = Pointer to the TCard structure.                      
           Num (INTEGER) = The card number (1 to 52).                       
  OUT....: /                                                                
  EXPLAIN: Display a card and toggle it by XOR mode the card surface.       
           Allow you to do like if you make a card selection.               
  SEEALSO: Card_Display, Card_Hide                                          
 ͼ}

Procedure Card_Toggle(C:TCards; Num:Integer);
Var P:TCoordinates;
Begin
If (Num<1) Or (Num>C.Max_Cards) Then Exit;
If Not C.Cards[Num].Visible Then Exit;

VESA_SetWriteMode(XORPut);
P.X1:=C.Cards[Num].Px;
P.Y1:=C.Cards[Num].Py-5;
P.X2:=C.Cards[Num].Px+70-2;
P.Y2:=C.Cards[Num].Py+96-8;

Bevel (P.X1,P.Y1,P.X2,P.Y2,CLWinBg);    {*Display Toggle*}

Mse_Hide;
VESA_PutPixel(P.X1,P.Y1,0); VESA_PutPixel(P.X2,P.Y1, CLBlack);
VESA_PutPixel(P.X1,P.Y2,0); VESA_PutPixel(P.X2,P.Y2, CLBlack);
VESA_SetWriteMode(NormalPut);
Mse_Show;
End;

{ͻ
                            PROCEDURE Card_Hide                             

 ͹
  IN.....: C (TCard) = Pointer to the TCard structure.                      
           Num (INTEGER) = The card number (1 to 52).                       
  OUT....: /                                                                
  EXPLAIN: Hide a card.                                                     
  SEEALSO: Card_Toggle, Card_Display                                        
 ͼ}

Procedure Card_Hide(C:TCards; Num:Integer);
Begin
If (Num<1) Or (Num>C.Max_Cards) Then Exit;
Bevel (C.Cards[Num].Px,
       C.Cards[Num].Py,
       C.Cards[Num].Px+70,
       C.Cards[Num].Py+95, CLCursor);

End;

{ͻ
                        FUNCTION Card_TestMouseOver                         
 ͹
  IN.....: C (TCard) = Pointer to the TCard structure.                      
           Num (INTEGER) = The card number (1 to 52).                       
  OUT....: (BOOLEAN) = TRUE if the mouse is over the card surface.          

  EXPLAIN: Test if the mouse is over a card and return result.              
 ͼ}

Function Card_TestMouseOver(C:TCards; Num:Integer):Boolean;
Var X1,Y1,X2,Y2:Integer;

Begin
Card_TestMouseOver:=FALSE;              {*De Base...*}
If (Num<1) Or (Num>C.Max_Cards) Then Exit;

X1:=C.Cards[Num].Px+T_Clip.X1-1; Y1:=C.Cards[Num].Py+T_Clip.Y1-6;
X2:=X1+71; Y2:=Y1+96;
If Mse_TestBox(X1,Y1,X2,Y2,10) Then Card_TestMouseOver:=TRUE;

End;



{*-------------------------- PROGRAMME PRINCIPAL ---------------------------*}

Begin
End.
