{ͻ
                               UNIT MosChart                                
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 26.12.1998                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: Graphic Assistant Tools Unit.                                
  AUTONOMOUS.: Partial                                                      
  UNIT SIZE..: 395 Lines and (10.288 Bytes compiled)                        
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosChart;                           {*Playing Cards Management Unit*}

{$Mode Objfpc}

INTERFACE

Const
   GT_HISTORYGRAME       =1;            {*Graphic type definition*}

Type TGraphic=Record                    {*2D/3D Graphics Structure*}
   X1,Y1,X2,Y2          :Integer;       {*Box to display the whole graphic*}
   Gx1,Gy1,Gx2,Gy2      :Integer;       {*Box to display strictly graphic*}
   FName                :String;        {*File to store data*}
   Title                :String;        {*Graphic title*}
   XTitle,YTitle        :String;        {*X,Y graphic title*}
   Font_Type            :String[12];    {*Font type and size*}
   Font_Size            :Byte;
   Sep                  :Char;          {*Data separator*}
   Style                :Byte;          {*Graphic type*}
   Area_Style           :String[12];    {*Fichier Texture pour Fill*}
   Line_Size            :Byte;          {*Line size to draw*}
   Line_Color           :Longint;       {*The line color*}
   First_Color          :Longint;       {*First color to fill items*}
   First_Column         :Integer;       {*What first column number to get data*}
   First_Line           :Integer;       {*What first line number to get data*}
   Last_Color           :Longint;       {*Last color to use to fill items*}
   Pen_Color            :Longint;       {*The pen color*}
   Title_Color          :Longint;       {*The title pen color*}
   Bg_Color             :Longint;       {*Graphic background color*}
   Id                   :Word;          {*Bits configuration*}
       {  0  0001 :  * 1 = Use 3D design to draw if possible}
       {  1  0002 :  1 = Display graphic titles informations = Lgendes}
       {  2  0004 :  * 1 = Display horizontal axes}
       {  3  0008 :  * 1 = Display vertical axes}
       {  4  0010 :  1 = Display the main graphic box}
       {  5  0020 :  1 = Use all the colors to fill items}
       {  6  0040 :  1 = Use shade colors to fill items}
       {  7  0080 :  1 = Display X values}
       {  8  0100 :  1 = Display Y values}
       {  9  0200 :  1 = Use proportionnal colors}

   VMin,VMax            :Extended;      {*Min and Max values*} {MIC}
   Qtt_Data             :Integer;       {*Values quantity*} {MIC}
   Size_Block           :Real;          {*Taille X d'un bloc item*} {MIC}
   Espacement           :Integer;       {*Espacement en pixels*} {MIC}
   End;

{*------------------------ Fonctions et Procdures -------------------------*}

{|Define and build Graphics|}
Function  Graph_Define       (Var G:TGraphic; X1,Y1,X2,Y2,Column,Style:Integer; Id:Word; FName:String):Boolean;
Procedure Graph_DefineTitles (Var G:TGraphic; Title,XTitle,YTitle:String);
Procedure Graph_DefineColors (Var G:TGraphic; Bg_Color,Pen_Color,Title_Color,First_Color,Last_Color:Longint);
Procedure Graph_DefineMore   (Var G:TGraphic; FType:String; FSize,First_Line,Espacement:Integer);
Procedure Graph_SetType      (Var G:TGraphic; GfxType:Byte);
Function  Graph_BuildData    (Var G:TGraphic):Boolean;

{|Graphics display functions|}
Procedure Graph_Display_HIS  (Const G:TGraphic);
Procedure Graph_Display      (Const G:TGraphic);
Procedure Graph_DisplayInfo  (Const G:TGraphic);

{Procedure Graph_DisplayAxes}

{*----------------------------- Dbut Library ------------------------------*}

IMPLEMENTATION

Uses
     MosBase,
     MosColors,
     MosConfig,
     MosCPUInstructions,
     MosFiles,
     MosGraph,
     MosStrings,
     MosText,
     MosTools;

{ͻ
                           FUNCTION Graph_Define                            
 ͹
  IN.....: G (TGraphic) = Pointer to the Graphic structure.                 
           X1,Y1,X2,Y2 (INTEGER) = Box to display graphic.                  
           Column (INTEGER) = Column number to get data.                    
           Style (INTEGER) = Graphic type. See array below :                
                                                                            
           Id (WORD) = Bits definition for the Graphic.                     
                                                                            
           FName (STRING) = Filename wher data are stored.                  
  OUT....: (BOOLEAN) = TRUE if Ok, else FALSE if an error occured.          
  EXPLAIN: Define parameters for the Graphic.                               
  SEEALSO: Graph_Display                                                    
 ͼ}

Function Graph_Define(Var G:TGraphic; X1,Y1,X2,Y2,Column,Style:Integer; Id:Word; FName:String):Boolean;
Begin
Graph_Define:=TRUE;                     {*De base...*}
Log.Add('Create new Graph',2);
Coord_BoxCorrect(X1,Y1,X2,Y2);          {*Verify coherence*}
G.X1:=X1; G.Y1:=Y1; G.X2:=X2; G.Y2:=Y2;
G.First_Column:=Column;
G.Style:=Style;
G.Id:=Id;
G.FName:=FName;                         {*Store data Filename*}
If Not File_TestExist(FName) Then Graph_Define:=FALSE;

G.Title:='';                            {*Donnes dfinies de base*}
G.XTitle:=''; G.YTitle:='';
G.Sep:=';';
G.Font_Type:=Sys.FontCurrent;
G.Font_Size:=Sys.FontCurrentSize;
G.Area_Style:='';                       {*Pas de fichiers BMP Texture*}
G.Line_Size:=1;
G.Line_Color:=CLBlack;                  {*Black line to draw*}
G.First_Color:=VESA_SetRGBColor(224,172,096);
G.First_Line:=1;
G.First_Column:=2;
G.Last_Color:=VESA_SetRGBColor(172,052,000);
G.Pen_Color:=CLText;
G.Title_Color:=CLWhite;
G.Bg_Color:=CLGrey;
G.Espacement:=10;                       {*10 pixels d'espace*}
End;

{ͻ
                        PROCEDURE Graph_DefineTitles                        
 ͹
  IN.....: G (TGraphic) = Pointer to the Graphic structure.                 
           Title (STRING) = The main Graphic title.                         
           XTitle (STRING) = The X title.                                   
           YTitle (STRING) = The Y data title.                              
  OUT....: /                                                                
  EXPLAIN: Define all the graphic titles.                                   
           The graphic size is reduced to let place for the title phrase.   
  NB.....: If you don't want titles, just put empty strings.                
  SEEALSO: Graph_Define                                                     
 ͼ}

Procedure Graph_DefineTitles (Var G:TGraphic; Title,XTitle,YTitle:String);
Begin
G.Title:=Title;                         {*Donnes dfinies de base*}
G.XTitle:=XTitle;
G.YTitle:=YTitle;
End;

{ͻ
                        PROCEDURE Graph_DefineColors                        
 ͹
  IN.....: G (TGraphic) = Pointer to the Graphic structure.                 
           Bg_Color (LONGINT) = Define the background color.                
           Pen_Color (LONGINT) = Define the pen color.                      
           Title_Color (LONGINT) = The titles color.                        
           First_Color (LONGINT) = The first color to fill bars.            
           Last_Color (LONGINT) = The last color to fill bars.              
  OUT....: /                                                                
  EXPLAIN: Define all the graphic colors.                                   
  SEEALSO: Graph_Define                                                     
 ͼ}

Procedure Graph_DefineColors(Var G:TGraphic; Bg_Color,Pen_Color,Title_Color,First_Color,Last_Color:Longint);
Begin
G.Bg_Color:=Bg_Color;
G.Pen_Color:=Pen_Color;
G.Title_Color:=Title_Color;
G.First_Color:=First_Color;
G.Last_Color:=Last_Color;
End;

{ͻ
                         PROCEDURE Graph_DefineMore                         
 ͹
  IN.....: G (TGraphic) = Pointer to the Graphic structure.                 
           Font_Type (STRING) = Used font to display values.                
           Font_Size (INTEGER) = The font size.                             
           First_Line (INTEGER) = First line to read values in the datafile.
           Espacement (INTEGER) = Space between each bar (in pixels).       
  OUT....: /                                                                
  EXPLAIN: Define more graphic parameters.                                  
  SEEALSO: Graph_Define                                                     
 ͼ}

Procedure Graph_DefineMore(Var G:TGraphic; FType:String; FSize,First_Line,Espacement:Integer);
Begin
G.Font_Type:=FType;
G.Font_Size:=FSize;
G.First_Line:=First_Line;
G.Espacement:=Espacement;
End;

{ͻ
                          PROCEDURE Graph_SetType                           
 ͹
  IN.....: G (TGraphic) = Pointer to the Graphic structure.                 
           GfxType (BYTE) = Graphic type : See the "Graph_Define function". 
  OUT....: /                                                                
  EXPLAIN: Define the graphic type.                                         
  SEEALSO: Graph_Define                                                     
 ͼ}

Procedure Graph_SetType(Var G:TGraphic; GfxType:Byte);
Begin
G.Style:=GfxType;
End;

{ͻ
                          FUNCTION Graph_BuildData                          
 ͹
  IN.....: G (TGraphic) = Pointer to the Graphic structure.                 
  OUT....: (BOOLEAN) = TRUE if the build has been don, else FALSE.          
  EXPLAIN: Build inner parameters for the Graphic.                          
  SEEALSO: Graph_Display                                                    
 ͼ}

Function Graph_BuildData(Var G:TGraphic):Boolean;
Var A,Column,Code:Integer;
    VInit,VTemp,VMin,VMax:Extended;
    St,SValue:String;

Begin
Graph_BuildData:=FALSE;                 {*De Base*}

Font_Set(G.Font_Type,G.Font_Size);      {*Adjust Inner box coordinates*}
G.Gx1:=G.X1; G.Gy1:=G.Y1; G.Gx2:=G.X2; G.Gy2:=G.Y2;
If BTST(G.Id,1) Then Dec(G.Gx2,LaF*20); {*Display Lgende*}
If BTST(G.Id,7) Then Dec(G.Gy2,HaF+6);  {*Display X Values*}
If BTST(G.Id,8) Then Inc(G.Gy1,HaF+6);  {*Display Y Values*}
If G.Title<>''  Then Inc(G.Gy1,HaF+6);  {*Display Title*}
If G.XTitle<>'' Then Dec(G.Gy2,HaF+6);  {*Display X Title*}
If G.YTitle<>'' Then Begin Inc(G.Gx1,LaF*2+10); Dec(G.Gx2,LaF*2+10); End; {*Display Y Title*}

If G.First_Line<=0 Then G.First_Line:=1;
G.Qtt_Data:=File_CountLines(G.FName)-G.First_Line+1;
If G.Qtt_Data<=0 Then Exit;             {*Erreur lecture des donnes*}
Column:=G.First_Column;
G.Size_Block:=((G.Gx2-G.Gx1+G.Espacement)-G.Qtt_Data*G.Espacement) / Real(G.Qtt_Data);

St:=File_GetLine(G.FName,G.First_Line); {*Lit la premire ligne*}
SValue:=Str_Get(St,Column,G.Sep);
Val(SValue,VInit,Code);                 {*Get the first value*}
VMin:=VInit;VMax:=VInit;

For A:=G.First_Line+1 to G.Qtt_Data do  {*Lecture des lignes*}
   Begin
   St:=File_GetLine(G.FName,A);         {*Lit une ligne*}
   SValue:=Str_Get(St,Column,G.Sep);
   Val(SValue,VTemp,Code);              {*Transforme to Value*}
   If Code=0 Then Begin
      If VTemp>VMax Then VMax:=VTemp;   {*Store Max and Min*}
      If VTemp<VInit Then VMin:=VTemp;
      End;
   End;
G.VMax:=VMax; G.VMin:=VMin;             {*Save values*}
End;

{ͻ
                        PROCEDURE Graph_DisplayInfo                         
 ͹
  IN.....: G (TGraphic) = Pointer to the Graphic structure.                 
  OUT....: /                                                                
  EXPLAIN: Display the Graphic informations (Scales, title...).             
  SEEALSO: Graph_Display                                                    
 ͼ}

Procedure Graph_DisplayInfo(Const G:TGraphic);
Var Text1:TText;
Begin
If BTST(G.Id,4) Then Bevel (G.X1,G.Y1,G.X2,G.Y2, G.Bg_Color,BLRaisedLine,BLNoLine,Yes);
                                        {*Titles*}
If G.Title<>''  Then Display((G.X1+(G.X2-G.X1) Div 2)-VESA_TextWidth(G.Title)  Div 2, G.Y1+2,G.Title_Color,G.Font_Type,G.Font_Size,G.Title);
If G.XTitle<>'' Then Display((G.Gx1+(G.Gx2-G.Gx1) Div 2)-VESA_TextWidth(G.XTitle) Div 2, G.Y2-HaF-4,G.Title_Color,G.Font_Type,G.Font_Size,G.XTitle);
Font_SetDirection(1);
{If G.YTitle<>'' Then Display(G.X1+3,(G.Gy1+(G.Gy2-G.Gy1) Div 2)-VESA_TextWidth(G.YTitle) Div 2, G.Title_Color,G.YTitle);}










If G.YTitle<>'' Then
   Begin
   Display_Define(Text1,G.X1+3,(G.Gy1+(G.Gy2-G.Gy1) Div 2)-VESA_TextWidth(G.YTitle) Div 2,
                  G.BG_Color,G.Title_Color,G.Font_Type,G.Font_Size,TJOnLeft,$0033,G.YTitle);
   Text1.Font.Direction:=TDVertical;

   Display_Draw(Text1);
   End;
Font_SetDirection(0);
End;

{ͻ
                        PROCEDURE Graph_Display_HIS                         
 ͹
  IN.....: G (TGraphic) = Pointer to the Graphic structure.                 
  OUT....: /                                                                
  EXPLAIN: Display the Historygrame Graphic.                                
  SEEALSO: Graph_Display                                                    
 ͼ}

Procedure Graph_Display_HIS(Const G:TGraphic);

Var Line,Column,Code,CValue,Px:Longint;
    X1,Y1,X2,Y2,VTemp:Extended;
    St,SValue:String;

Begin
If G.Qtt_Data<=0 Then Exit;             {*Erreur lecture des donnes*}
Column:=G.First_Column;
Graph_DisplayInfo(G);                   {*Display Graphic Informations*}

X2:=G.Gx1-G.Espacement;                 {*X de base*}

For Line:=G.First_Line to G.First_Line+G.Qtt_Data-1 do
   Begin
   St:=File_GetLine(G.FName,Line);      {*Lit la ligne courrante*}
   SValue:=Str_Get(St,Column,G.Sep);

   Val(SValue,VTemp,Code);              {*Transforme to Value*}
   If Code<>0 Then VTemp:=0;
   X1:=X2+G.Espacement;                 {*Calcule next coordonnes*}
   Y1:=G.Gy2-(G.Gy2-G.Gy1)*(VTemp/G.VMax);
   X2:=X1+G.Size_Block;
   Y2:=G.Gy2;

   If BTST(G.Id,9) Then                 {*Proportional Colors*}
      Begin
      End;

CValue:=Col_GetShadeColor(G.Qtt_Data,Line-G.First_Line,G.First_Color,G.Last_Color);

   If BTST(G.Id,6)                      {*Display Shade of Filled Bar*}
      Then Display_Shade(Round(X1),Round(Y1),Round(X2),Round(Y2), G.First_Color,G.Last_Color,1)
      Else Bevel (Round(X1),Round(Y1),Round(X2),Round(Y2), CValue,BLRaisedLine,BLNoLine,Yes);

   If BTST(G.Id,7) Then                 {*Display X Values*}
      Begin

      SValue:=Str_Get(St,1,G.Sep);
      Px:=Round(X1+1+(G.Size_Block/2.0)-(VESA_TextWidth(SValue)/2.0));
      Display(Px,Round(Y2)+3,G.Pen_Color,'LITT.CHR',4,SValue);
      End;
   If BTST(G.Id,8) Then                 {*Display Y Values*}

      Begin
      SValue:=Str_Get(St,Column,G.Sep);
      Px:=Round(X1+1+(G.Size_Block/2.0)-(VESA_TextWidth(SValue)/2.0));
      Display(Px,Round(Y1)-HaF-3,G.Pen_Color,'LITT.CHR',4,SValue);
      End;

   If BTST(G.Id,5) Then Begin           {*Calcule next Color*}

      Inc(CValue);
      If CValue>G.Last_Color Then CValue:=G.First_Color;
      End;
   End;
End;

{ͻ
                          PROCEDURE Graph_Display                           
 ͹
  IN.....: G (TGraphic) = Pointer to the Graphic structure.                 
  OUT....: /                                                                
  EXPLAIN: Display the Graphic.                                             
  SEEALSO: Graph_Define                                                     
 ͼ}


Procedure Graph_Display(Const G:TGraphic);
Begin
Case G.Style of                         {*En fonction du type de Graphe*}
   GT_HISTORYGRAME : Graph_Display_HIS(G);
   End;
Font_Set(Sys.FontMain,Sys.FontMainSize);{*Restore Current Font*}
End;

{*-------------------------- Programme Principal ---------------------------*}

Begin
End.

- Les Assistants Graphiques:
  2 * Barres (horizontale)
  3 * Aires
  4 * Courbes
  5 * Secteurs
  6 * Spheres
  7 * Anneaux
  8 * Radard
  9 * Nuage de points
 10 * Aire 3D (Extention de 2D)
 11 * Barres 3D (Extention de 2D)
 12 * Historigrammes 3D (Extention de 2D)
 13 * Courbes 3D (Extention de 2D)
 14 * Secteurs 3D
 15 * Surfaces 3D
 16 * Combinaison
