{ͻ
                            UNIT MosColorDialogs                            
 ͹
  CREATOR....: PLANAS Jean-Pierre                                           
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 21.01.1999                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: Color Requesters.                                            
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 502 Lines and (15.920 Bytes compiled)                        
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosColorDialogs;

{$Mode Objfpc}

INTERFACE

{|Color and palette requesters|}
Function  Req_SelectColor(Px,Py:Integer; Selected,FirstColor,LastColor:Longint; PalFile,Title:String):Longint; {*Display a palette and select color*}
Function  Req_GetRGBColor(Px,Py:Integer; PrevColor:Longint; Tab,AvailableTabs:Word; Title:String):Longint; {*RGB color picker*}

{*----------------------------- Debut Library ------------------------------*}

IMPLEMENTATION

Uses
      SysUtils,
      MosBase,
      MosColors,
      MosConfig,
      MosCrt,
      MosDialogs,
      MosDirectory,
      MosErrors,
      MosFiles,
      MosGadgets,
      MosGraph,
      MosImages,
      MosList,
      MosMouse,
      MosStrings,
      MosTab,
      MosText,
      MosTools,
      MosWindows;

{ͻ
                          FUNCTION Req_GetRGBColor                          
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on  screen.                 
           PrevColor (LONGINT) = Previous RGB color to modify.              
           Tab (WORD) = Tab number to activate (1 <-> 3).                   
                    1 = Picker selector                                     
                    2 = Sliders selector                                    
                    3 = Palette manager                                     
           AvailableTabs (WORD) = Select enable Tabs using bits.            
           Title (STRING) = Requester window title.                         
  OUT....: (LONGINT) = Return RGB color value.                              
  EXPLAIN: Display a palette requester that allow you to select a color     
           using a color picker or sliders or a palette manager.            
 ͼ}

Function Req_GetRGBColor(Px,Py:Integer; PrevColor:Longint; Tab,AvailableTabs:Word; Title:String):Longint;
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flags*}
    Ong1          :TTabs;               {*Tabs Tab*}
    But1,But2     :TButton;             {*Button structure*}
    CurCol,                             {*Current color button*}
    B1,B2,B3,B4,
    B5,B6,B7,B8   :TButton;             {*Commands buttons*}
    HintPrevCol   :TButton;             {*Used only to display hints*}
    HintCurCol    :TButton;             {*Used only to display hints*}
    C1,C2         :Longint;             {*Colors for Shade*}
    ThinColor1    :Longint;             {*Color 1 for thin shade in palettes manager*}
    ThinColor2    :Longint;             {*Color 2 for thin shade in palettes manager*}
    Is1,Is2,Is3,
    Is4,Is5,Is6   :TInputSlider;        {*Current Color information*}
    In1           :TInputText;          {*HTML value*}
    SlR,SlG,SlB   :TSlider;             {*RGB Sliders*}
    MZ1,MZ2       :TMouseZone;
    C             :TCoordinates;
    PCombo        :TCombo;              {*Combo to select palettes*}
    Res2          :Integer;             {*Combo selected result*}
    VR,VG,VB,VH,VS,VV:Longint;
    V1,V2,V3      :Byte;                {*Temporary values for cast compatibility*}
    VHtml         :String;
    PreSelectedColor:Longint;           {*Preselected color*}
    SelectedColor :Longint;             {*Current selected color*}
    Xm,Ym         :Word;
    XOld,YOld     :Word;
    LPal          :TList;               {*List palette*}
    LRes          :Longint;             {*List result*}
    PalettesPath,
    CurrentPalette:String;              {*Current used palette*}
    FSize         :Longint;
    St            :String;              {*Temporary string*}
    Num           :Integer;             {*For Dialog requester*}

{*************************** DISPLAY RGB SLIDERS ****************************}

Procedure REDRAW_RGBSLIDERS;            {*Display RGB Sliders*}
Begin
Win_Clip(Yes,W1);
SlR.Value:=VR;
SlR.ShapeShadeCol1:=VESA_SetRGBColor($FF,VG,VB);
SlR.ShapeShadeCol2:=VESA_SetRGBColor($00,VG,VB);
Slider_Refresh(SlR);

SlG.Value:=VG;
SlG.ShapeShadeCol1:=VESA_SetRGBColor(VR,$FF,VB);
SlG.ShapeShadeCol2:=VESA_SetRGBColor(VR,$00,VB);
Slider_Refresh(SlG);

SlB.Value:=VB;
SlB.ShapeShadeCol1:=VESA_SetRGBColor(VR,VG,$FF);
SlB.ShapeShadeCol2:=VESA_SetRGBColor(VR,VG,$00);
Slider_Refresh(SlB);
End;

{************************** DISPLAY INPUT SLIDERS ***************************}

Procedure REDRAW_RGBVALUES;             {*Display RGB Values*}
Begin
Win_Clip(Yes,W1);
InputSlider(429,029,30,CLSky,CLSalmon,0,0,255,1,VR,$0000,Is1);
InputSlider(429,044,30,CLSky,CLSalmon,0,0,255,1,VG,$0000,Is2);
InputSlider(429,059,30,CLSky,CLSalmon,0,0,255,1,VB,$0000,Is3);

Button (385,153,037,030,0,0,$0024, HintCurCol, '', MPArrow, Language.Loc(766));
Button (432,153,037,030,0,0,$0024, HintPrevCol,'', MPArrow, Language.Loc(767));
End;

Procedure REDRAW_HSVVALUES;             {*Display HSV Values*}
Begin
Win_Clip(Yes,W1);
{Calculer ici les HSV  partir des RGB}
InputSlider(429,079,30,CLSky,CLSalmon,0,0,255,1,VH,$0000,Is4);
InputSlider(429,094,30,CLSky,CLSalmon,0,0,255,1,VS,$0000,Is5);
InputSlider(429,109,30,CLSky,CLSalmon,0,0,255,1,VV,$0000,Is6);
End;

Procedure REDRAW_HTMLVALUE;             {*Display HTML Value*}
Begin
Win_Clip(Yes,W1);
VHtml:='#'+Str_L2H(VR,2)+Str_L2H(VG,2)+Str_L2H(VB,2);
InputText(419,129,50,6,CLSky,CLGrey,1,$1426,In1,VHtml);
End;

{*************************** DISPLAY SELECTED COLOR *************************}

Procedure REDRAW_SELECTEDCOLOR;         {*Redraw Selected Color*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
Button (432,153,037,030,CLTextButton,SelectedColor,$0020, CurCol,'', MPArrow, Language.Loc(766));
End;

{************************* DISPLAY COLOR INFORMATION ************************}

Procedure REDRAW_SHADEBOX;              {*Redraw Shade Box*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
Display_ShadeBox(130,70,240,180,PreSelectedColor);
End;

{********************* DISPLAY CURRENT COLOR INFORMATION ********************}

Procedure REDRAW_COLORINFOS;            {*Display color information*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
REDRAW_RGBVALUES;                       {*Display RGB Values*}
REDRAW_HSVVALUES;                       {*Display HSV Values*}
REDRAW_HTMLVALUE;                       {*Display HTML Value*}
End;

{**************************** DISPLAY COLOR ZONE ****************************}

Procedure REDRAW_COLORZONE;
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
Bevel_Title (374,014,479,189, CLLightGrey,CLBlack,BLLoweredLine,BLRaisedLine,
             TJOnLeft,TJOnTop,Yes,'LITT.CHR',4,$0063,Language.Loc(100));
Display (377,030,050,CLText, Str_Get(Language.Loc(101),1,'|'),TJOnRight);
Display (377,045,050,CLText, Str_Get(Language.Loc(101),2,'|'),TJOnRight);
Display (377,060,050,CLText, Str_Get(Language.Loc(101),3,'|'),TJOnRight);
Display (377,080,050,CLText, Str_Get(Language.Loc(101),4,'|'),TJOnRight);
Display (377,095,050,CLText, Str_Get(Language.Loc(101),5,'|'),TJOnRight);
Display (377,110,050,CLText, Str_Get(Language.Loc(101),6,'|'),TJOnRight);
Display (391,130,    CLText, Str_Get(Language.Loc(101),7,'|'));

Bevel   (385,153,422,183,PrevColor,BLRaisedLine,BLNoLine,Yes);
End;

{********************** DISPLAY THIN SHADE AND BUTTONS **********************}

Procedure DISPLAY_THINSHADE;
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
Button (129,153,037,30, CLTextButton,ThinColor1,$0020,B3,'');
Button (317,153,037,30, CLTextButton,ThinColor2,$0020,B4,'');
Display_Shade(173-1,159-6,310-1,189-6,ThinColor1,ThinColor2,0);
End;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
BMP_Show(019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_crgb.bmp',$0080);

Tabs_Define    (Ong1,119,014,365,189, Ong1.No, CLLightGrey,CLLightGrey,$0014,AvailableTabs,Language.Loc(102),'','');
Tabs_Draw      (Ong1);

Button (115,204, 100,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
Button (282,204, 100,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));

Case Ong1.No of
   1: Begin
      C1:=VESA_SetRGBColor($FF,$00,$00); C2:=VESA_SetRGBColor($FF,$00,$FF);
      Display_Shade(130,38,164,60,C1,C2,0);
      C1:=VESA_SetRGBColor($FF,$00,$FF); C2:=VESA_SetRGBColor($00,$00,$FF);
      Display_Shade(165,38,197,60,C1,C2,0);
      C1:=VESA_SetRGBColor($00,$00,$FF); C2:=VESA_SetRGBColor($00,$FF,$FF);
      Display_Shade(198,38,231,60,C1,C2,0);
      C1:=VESA_SetRGBColor($00,$FF,$FF); C2:=VESA_SetRGBColor($00,$FF,$00);
      Display_Shade(232,38,267,60,C1,C2,0);
      C1:=VESA_SetRGBColor($00,$FF,$00); C2:=VESA_SetRGBColor($FF,$FF,$00);
      Display_Shade(268,38,299,60,C1,C2,0);
      C1:=VESA_SetRGBColor($FF,$FF,$00); C2:=VESA_SetRGBColor($FF,$00,$00);
      Display_Shade(300,38,354,60,C1,C2,0);

      REDRAW_SHADEBOX;                  {*Display Shade Box*}

      C.X1:=130; C.Y1:=38; C.X2:=354; C.Y2:=60;
      MseZone(MZ1,C,1,MPTarget,'');     {*Define a mouse zone*}
      C.X1:=130; C.Y1:=70; C.X2:=240; C.Y2:=180;
      MseZone(MZ2,C,1,MPEyeDrop,'');
      End;

   2: Begin
      Slider (SlR,140,050,130, 255,025, SlR.Value, COVertical,SSNone,SSShade,$0000, CTBox,  BPOposed,Yes, $0000,0, C1,C2, CLLightGrey, '','','','');
      Slider (SlG,170,050,130, 255,025, SlG.Value, COVertical,SSNone,SSShade,$0000, CTBox,  BPOposed,Yes, $0000,0, C1,C2, CLLightGrey, '','','','');
      Slider (SlB,200,050,130, 255,025, SlB.Value, COVertical,SSNone,SSShade,$0000, CTBox,  BPOposed,Yes, $0000,0, C1,C2, CLLightGrey, '','','','');
      Display    (145,035,CLText, Str_Get(Language.Loc(103),1,'|'));
      Display    (175,035,CLText, Str_Get(Language.Loc(103),2,'|'));
      Display    (205,035,CLText, Str_Get(Language.Loc(103),3,'|'));
      REDRAW_RGBSLIDERS;                {*Display RGB Sliders*}
      End;

   3: Begin
      Combo  (129,036,109, CLSky,CLSalmon, CLDataZone,$00F9,PCombo.Selected,PCombo);
      Button (129,057,109,-1, CLTextButton,CLBgButton,$0000,B1,'_CREATE PALETTE');
      Button (129,072,109,-1, CLTextButton,CLBgButton,$0000,B2,'REMOVE _PALETTE');
      Button (129,087,109,-1, CLTextButton,CLBgButton,$0000,B8,'_VIEW PALETTE');
      Button (129,102,109,-1, CLTextButton,CLBgButton,$0000,B5,'_ADD COLOR');
      Button (129,117,109,-1, CLTextButton,CLBgButton,$0000,B6,'_REMOVE COLOR');
      Button (129,132,109,-1, CLTextButton,CLBgButton,$0000,B7,'ADD _SHADE');
      C.X1:=173-1; C.Y1:=159-6; C.X2:=310-1; C.Y2:=189-6;
      MseZone(MZ1,C,1,MPEyeDrop,'');    {*Define a mouse zone*}
      DISPLAY_THINSHADE;                {*Display thin shade and buttons*}
      List_Show(LPal);                  {*Display List*}
      End;
   End;

Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{********************** LOAD PALETTE AND SET IT IN LIST *********************}

Function GET_COLORFROMLIST(A:Longint; Var VRGB:String):Longint;
Var St:String;
    R,G,B:Byte;
Begin
St:=List_GetStringCell(LPal,A,1);
R:=Str_S2L(Str_Get(St,1,' '));
G:=Str_S2L(Str_Get(St,2,' '));
B:=Str_S2L(Str_Get(St,3,' '));
VRGB:=Str_FillZero(R,3)+' '+Str_FillZero(G,3)+' '+Str_FillZero(B,3);
GET_COLORFROMLIST:=VESA_SetRGBColor(R,G,B);
End;

{********************** LOAD PALETTE AND SET IT IN LIST *********************}

Procedure FILL_LISTWITHPALETTE;
Var A:Integer;
    NewColor:Longint;
    VRGB:String;
Begin
List_Reset(LPal);
List_Load(LPal,CurrentPalette);
List_DeleteItem(LPal,1);                {*Delete Header*}
List_DeleteItem(LPal,1);
List_DeleteItem(LPal,1);
For A:=List_MinItem to List_GetQttItems(LPal) do
   Begin                                {*Define each color*}
   NewColor:=GET_COLORFROMLIST(A,VRGB);
   List_SetBkColorItem(LPal,A,NewColor);
   List_SetStringCell(LPal,A,1,VRGB);
   End;
List_SetPosition(LPal,List_GetQttItems(LPal));
End;

{***************** CREATE A HEADER FOR A JASC PALETTE FILE ******************}

Procedure Create_JASCFileHeader(FName:String);
Begin
If Not File_TestExist(FName) Then
   Begin                                {*Create palette if not exist*}
   File_AppendString(FName,'JASC-PAL');
   File_AppendString(FName,'0100');
   File_AppendString(FName,'0');
   End;
End;

{*************** ADD A VALUE IN THE JASC PALETTE FILE COUNTER ***************}

Procedure Update_ColorCounterInJASCFile(ValueToAdd:Integer);
Var Qtt:Integer;
Begin
St:=File_GetLine(CurrentPalette,3);     {*Add color in DB system palette*}
Qtt:=Str_S2L(St); Qtt:=Qtt+ValueToAdd;
If Qtt<0 Then Qtt:=0;
File_ReplaceLine(CurrentPalette, Str_L2S(Qtt), 3);
End;

{************************** ADD SHADE IN DATABASE ***************************}

Procedure ADD_SHADEINDB;
Var St:String;
    QttColors,TmpCol:Longint;
    A:Integer;
    Num:Integer;
    R,G,B:Byte;                         {*RGB values*}

Begin
Num:=3;                                 {*Ask for colors quantity*}
QttColors:=256;
Req_Value(Language.Loc(1),Language.Loc(104),Language.Loc(165),1,256,QttColors,Num);
If Num<>1 Then Exit;                    {*Cancel saving !*}

For A:=1 to QttColors do                {*Save each color in file*}
   Begin                                {*Get a RGB color in shade*}
   TmpCol:=Col_GetShadeColor(QttColors,A,ThinColor1,ThinColor2);
   VESA_GetRGBColor(TmpCol,R,G,B);      {*Get RGB values for the color*}
   St:=Str_FillZero(R,3)+' '+Str_FillZero(G,3)+' '+Str_FillZero(B,3);
   File_AppendString(CurrentPalette,St);
   End;

Update_ColorCounterInJASCFile(QttColors);{*Update counter*}

FILL_LISTWITHPALETTE;                   {*Update list...*}
Win_Clip(Yes,W1);
List_Show(LPal);                        {*Display List*}
End;

{************************* ADD A COLOR IN DATABASE **************************}

Procedure ADD_COLORINDB;
Var St:String;
Begin
Update_ColorCounterInJASCFile(1);       {*Update counter +1*}

St:=Str_FillZero(VR,3)+' '+Str_FillZero(VG,3)+' '+Str_FillZero(VB,3);
File_AppendString(CurrentPalette,St);

FILL_LISTWITHPALETTE;                   {*Update list...*}
List_Show(LPal);                        {*Display List*}
End;

{*********************** REMOVE A COLOR FROM DATABASE ***********************}

Procedure DEL_COLORINDB;
Var St:String;
    Num:Integer;
    Tagged,ItemPos:Longint;
Begin
If Not File_TestExist(CurrentPalette) Then Exit; {*Data base file not found*}
Tagged:=List_GetTaggedItem(LPal);
If Tagged<=0 Then                       {*No color selected*}
   Begin
   Num:=1;
   Req_Dialog(Language.Loc(1),Language.Loc(166),'   _OK   ',Num);
   Exit;
   End;

St:=List_GetStringCell(LPal,Tagged,1);

ItemPos:=File_TestString(CurrentPalette,St,$0001,1);
If ItemPos<=0 Then
   Begin
   Num:=1;
   Req_Dialog(Language.Loc(1),Language.Loc(167),'   _OK   ',Num);
   Exit;
   End;
File_DeleteLine(CurrentPalette,ItemPos);{*Delete color*}

Update_ColorCounterInJASCFile(-1);      {*Update counter -1*}

Win_Clip(Yes,W1);
List_DeleteItem(LPal,Tagged);           {*Delete item in list*}
List_SetPosition(LPal,Tagged);
List_Show(LPal);                        {*Display list again*}
LPal.Pos_Item:=0;
End;

{***************************** MAIN PROCEDURE *******************************}

Procedure DISPLAY_NEWDEFINEDVALUE;
Begin
PreSelectedColor:=VESA_SetRGBColor(VR,VG,VB);
SelectedColor:=PreSelectedColor;

REDRAW_SELECTEDCOLOR;
REDRAW_HSVVALUES;                       {*Display HSV Values*}
REDRAW_HTMLVALUE;                       {*Display HTML Value*}

Case Ong1.No of                         {*Display result depending Tab*}
   1: Begin
      REDRAW_SHADEBOX;
      End;
   2: Begin
      REDRAW_RGBSLIDERS;                {*Display RGB Sliders*}
      End;
   3: Begin
      Delay(10);                        {*Ralentis display*}
      End;
   End;
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
Log.Add('Call SelectRGBColor Request',1);

If Not Win_Init(Px,Py,Px+500,Py+HaF1+230,$51F9,Title,W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

Ong1.No:=Tab;                           {*1er Tabs*}
PreSelectedColor:=PrevColor;
SelectedColor:=PreSelectedColor;
ThinColor1:=SelectedColor;              {*Colors for thin shade in palettes manager*}
ThinColor2:=SelectedColor;
VESA_GetRGBColor(SelectedColor,V1,V2,V3);
VR:=V1; VG:=V2; VB:=V3;
VH:=0; VS:=0; VV:=0;
VHtml:='#000000';
XOk:=No; XCancel:=No;                   {*Init Exit Flags*}
XOld:=0; YOld:=0;
PalettesPath:=Sys.GetPath(SP_PALETTES);
Combo_Init(PCombo);
PCombo.Selected:=1;
File_GetDirectory(PalettesPath+'*.PAL',Sys.GetPath(SP_TEMP)+PCombo.ListName);
CurrentPalette:=PalettesPath+Combo_GetItem(1,PCombo);
List_Define(LPal,'RGB ',';',249,036,354,136, 1000, CLDataZone,CLDataZone,$1301);
List_SetColumnAttr(LPal,1,84, Text_Center);
List_SetColumnAttr(LPal,2,15, Text_Center);

FILL_LISTWITHPALETTE;                   {*Load palette and set in list*}

REDRAW_FRAME;                           {*Display Window Content*}
REDRAW_COLORZONE;                       {*Display Color Zone*}
REDRAW_COLORINFOS;                      {*Display Color Information*}
REDRAW_SELECTEDCOLOR;                   {*Redraw Selected Color*}

Repeat
Try

If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes;       {*Ok*}
   If Button_GetMsg(But2,1)=CMSelected Then XCancel:=Yes;   {*Cancel*}

   Mse_GetPos(Xm,Ym);

   Button_GetMsg(HintPrevCol,1);        // Just to manage hints
   Button_GetMsg(HintCurCol,1);

   If InputSlider_GetMsg(Is1,VR)=CMModified Then DISPLAY_NEWDEFINEDVALUE;
   If InputSlider_GetMsg(Is2,VG)=CMModified Then DISPLAY_NEWDEFINEDVALUE;
   If InputSlider_GetMsg(Is3,VB)=CMModified Then DISPLAY_NEWDEFINEDVALUE;

   If Tabs_GetMsg(Ong1,1)=CMSelected Then REDRAW_FRAME;

   Case Ong1.No of
      1: Begin
         If Button_GetMsg(CurCol,1)=CMSelected Then DISPLAY_NEWDEFINEDVALUE; {*Test current color button*}

         If (MseZone_GetMsg(MZ1)=CMSelected) And ((Xm<>XOld) Or (Ym<>YOld)) Then
            Begin                       {*Teste Bande Spectre*}
            XOld:=Xm; YOld:=Ym;
            Win_Clip(No,W1);
            Mse_Hide;
            PreSelectedColor:=VESA_GetPixel(Xm,Ym);
            SelectedColor:=PreSelectedColor;
            Mse_Show;
            Win_Clip(Yes,W1);
            VESA_GetRGBColor(PreSelectedColor,V1,V2,V3);
            VR:=V1; VG:=V2; VB:=V3;
            REDRAW_COLORINFOS;          {*Display Color Information*}
            REDRAW_SHADEBOX;            {*Display Shade Box*}
            REDRAW_SELECTEDCOLOR;       {*Display selected color*}
            End;

         If (MseZone_GetMsg(MZ2)=CMSelected) And ((Xm<>XOld) Or (Ym<>YOld)) Then
            Begin                       {*Teste Box Dgrad*}
            XOld:=Xm; YOld:=Ym;
            Win_Clip(No,W1);
            Mse_Hide;
            SelectedColor:=VESA_GetPixel(Xm,Ym);
            Mse_Show;
            Win_Clip(Yes,W1);
            VESA_GetRGBColor(SelectedColor,V1,V2,V3);
            VR:=V1; VG:=V2; VB:=V3;
            REDRAW_COLORINFOS;          {*Display Color Information*}
            REDRAW_SELECTEDCOLOR;       {*Display selected color*}
            End;
	 End;

      2: Begin                          {*RGB Sliders*}
         If (Slider_GetMsg(SlR)=CMModified) Or (Slider_GetMsg(SlG)=CMModified) Or (Slider_GetMsg(SlB)=CMModified) Then
            Begin
            VR:=SlR.Value;
            VG:=SlG.Value;
            VB:=SlB.Value;
            DISPLAY_NEWDEFINEDVALUE;
            REDRAW_COLORINFOS;          {*Display Color Information*}
            End;
	 End;

      3: Begin
         If (MseZone_GetMsg(MZ1)=CMSelected) And ((Xm<>XOld) Or (Ym<>YOld)) Then
            Begin                       {*Teste Bande Spectre*}
            XOld:=Xm; YOld:=Ym;
            Win_Clip(No,W1);
            Mse_Hide;
            SelectedColor:=VESA_GetPixel(Xm,Ym);
            Mse_Show;
            Win_Clip(Yes,W1);
            VESA_GetRGBColor(SelectedColor,V1,V2,V3);
            VR:=V1; VG:=V2; VB:=V3;
            REDRAW_COLORINFOS;          {*Display Color Information*}
            REDRAW_SELECTEDCOLOR;       {*Display selected color*}
            End;

         If Button_GetMsg(B1,1)=CMSelected Then
            Begin                       {*Create new palette*}
            St:='.pal';
            Req_FileManager(100,120,250, Str_Get(Language.Loc(1751),1,'|'),Str_Get(Language.Loc(1751),2,'|'),'*.PAL',0,PalettesPath,St,FSize);
            If St<>'' Then
               Begin
               Create_JASCFileHeader(PalettesPath+St);
               CurrentPalette:=PalettesPath+St;
               Combo_AddItem (St,PCombo);
               Combo_SetItem (PCombo, Combo_GetItemIndex(St,PCombo));
               Win_Clip(Yes,W1);
               List_Reset(LPal);
               List_Show(LPal);
               End;
            End;
         If Button_GetMsg(B2,1)=CMSelected Then
            Begin                       {*Remove current palette*}
            Num:=3;
            Req_Dialog(Language.Loc(1), Str_Get(Language.Loc(1752),1,'|'),Str_Get(Language.Loc(1752),2,'|'),Num);
            If Num=1 Then
               Begin
               File_Erase(CurrentPalette);
               Combo_DelItem(Combo_GetSelectedItem(PCombo), PCombo);
               Combo_SetItem(PCombo,1);
               CurrentPalette:=PalettesPath+Combo_GetSelectedItem(PCombo);
               FILL_LISTWITHPALETTE;    {*Load palette and set in list*}
               Win_Clip(Yes,W1);
               List_Show(LPal);
               End;
            End;

         If Button_GetMsg(B3,1)=CMSelected Then
            Begin                       {*Display thin shade (Button 1)*}
            ThinColor1:=SelectedColor;
            DISPLAY_THINSHADE;
            End;
         If Button_GetMsg(B4,1)=CMSelected Then
            Begin                       {*Display thin shade (Button 2)*}
            ThinColor2:=SelectedColor;
            DISPLAY_THINSHADE;
            End;

         If Button_GetMsg(B5,1)=CMSelected Then ADD_COLORINDB; {*Add color in DB*}
         If Button_GetMsg(B6,1)=CMSelected Then DEL_COLORINDB; {*Remove color from DB*}
         If Button_GetMsg(B7,1)=CMSelected Then ADD_SHADEINDB; {*Add shade in DB*}
         If Button_GetMsg(B8,1)=CMSelected Then
            Begin                       {*View current palette*}
            SelectedColor:=Req_SelectColor(W1.X1+20,W1.Y1+30,1,CLBlack,CLBlack,CurrentPalette,Language.Loc(1753));
            VESA_GetRGBColor(SelectedColor,V1,V2,V3);
            VR:=V1; VG:=V2; VB:=V3;
            REDRAW_COLORINFOS;          {*Display Color Information*}
            REDRAW_SELECTEDCOLOR;       {*Display selected color*}
            End;

         LRes:=List_Test(LPal);         {*Check List selection*}
         If LRes>0 Then
            Begin
            SelectedColor:=GET_COLORFROMLIST(LRes,St); {*St garbage*}
            VESA_GetRGBColor(SelectedColor,V1,V2,V3);
            VR:=V1; VG:=V2; VB:=V3;
            REDRAW_COLORINFOS;          {*Display Color Information*}
            REDRAW_SELECTEDCOLOR;       {*Display selected color*}
            End;

         If Combo_GetMsg(PCombo)=CMSelected Then
            Begin                       {*ComboBox selected*}
            Res2:=Combo_GetSelected(PCombo);
            CurrentPalette:=PalettesPath+Combo_GetItem(Res2,PCombo);
            FILL_LISTWITHPALETTE;       {*Load palette and set in list*}
            Win_Clip(Yes,W1);
            List_Show(LPal);            {*Display List*}
            End;
	 End;
      End;

   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;     {*Window Closed   => Exit*}
If Even=CMMoved  Then
   Begin                                {*Window Moved    => Display Content*}
   REDRAW_FRAME;                        {*Display Window Content*}
   REDRAW_COLORZONE;                    {*Display Color Zone*}
   REDRAW_COLORINFOS;                   {*Display color information*}
   REDRAW_SELECTEDCOLOR;                {*Redraw Selected Color*}
   End;

Except
  On E:Exception do HandleException(e);
End;

Until (XOk) Or (XCancel);               {*Exit Flags*}

If XOk Then Req_GetRGBColor:=SelectedColor {*Return values*}
       Else Req_GetRGBColor:=PrevColor;

Combo_Done(PCombo);                     {*Kill ComboBox*}
Win_Done(W1);                           {*Close Window if Needs*}
End;

{ͻ
                          FUNCTION Req_SelectColor                          
 ͹
  IN.....: Px,Py (INTEGER) = Requester position.                            
           Selected (LONGINT) = Initial selected color index (1 to 256).    
           FirstColor (LONGINT) = First RGB color for shade.                
           LastColor (LONGINT) = Last RGB color for shade.                  
           PalFile (STRING) = JASC-PAL color palette file (optional).       
           Title (STRING) = Title requester.                                
  OUT....: (LONGINT) = Return the selected RGB color value.                 
  EXPLAIN: Display a palette requester and allow you to select a color.     
 ͼ}

Function Req_SelectColor(Px,Py:Integer; Selected,FirstColor,LastColor:Longint; PalFile,Title:String):Longint;
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    XOk,XCancel   :Boolean;             {*Flag de Sortie*}
    But1          :TButton;             {*Structure Boutons*}
    Pal1          :TColorPalette;       {*Structure Palette*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);                       {*Clipping de la Fentre*}
Button (090,248,070,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
If PalFile<>'' Then ColorPalette(Pal1,015,010,11,11,3,16,PalFile,Selected,BLRaisedLine,$0000,MPHand)
               Else ColorPalette(Pal1,015,010,11,11,3,16,FirstColor,LastColor,256,Selected,BLRaisedLine,$0000,MPHand);
Win_Clip(No,W1);                        {*Restore le Clipping Normal*}
End;

{************************** PROCEDURE PRINCIPALE ****************************}

Begin
Log.Add('Call Select Color Request',1);

If (PalFile<>'') And (Not File_TestExist(PalFile)) Then Exit; {*Unknown palette file*}

If Not Win_Init(Px,Py,Px+259,Py+HaF1+274,$51D9,Title,W1) Then Exit;
Win_Sup(100,50,250,200,59,50,639,349,0,CLWinBorder,$0A10,W1); {*Supplment*}
Win_Draw(W1);                           {*Affiche la Fentre*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
XOk:=FALSE; XCancel:=FALSE;             {*Init Flags de Sortie*}

Repeat
try

try
;
If Win_Ready(W1) Then                   {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Personnels*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If (ColorPalette_GetMsg(Pal1)=CMSelected) Or (Button_GetMsg(But1,1)=CMSelected) Then XOk:=TRUE;
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then XCancel:=TRUE;    {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Flags de Sortie*}

Win_Done(W1);                           {*Supprime Fentre*}

Req_SelectColor:=ColorPalette_GetSelected(Pal1);
End;

{*-------------------------- PROGRAMME PRINCIPAL ---------------------------*}

Begin
End.
