{ͻ
                               UNIT MosColors                               
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 31.01.1998                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: MOS colors management.                                       
  AUTONOMOUS.: Yes                                                          
  UNIT SIZE..: 714 Lines and (20.064 Bytes compiled)                        
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosColors;

{$Mode Objfpc}

INTERFACE

Const
     CLBlack              = 0;          {*Colors value definition*}
     CLGrey               = 8684676;
     CLGreen              = 7120936;
     CLFlamand            = 5279920;
     CLEmerald            = 43176;
     CLPaper              = 13161676;
     CLMauve              = 11055300;
     CLLightGrey          = 11053224;
     CLDarkGrey           = 6055012;
     CLBlue               = 6586584;
     CLLightGreen         = 11852908;
     CLLightBlue          = 5570559;
     CLSky                = 10540287;
     CLSalmon             = 16767140;
     CLOrange             = 16751684;
     CLWhite              = 16777215;
     CLRed                = 16711680;
     CLYellow             = 16776960;
     CLSkin               = 15644828;
     CLLagoon             = 64222;
     CLChampagne          = 15653821;
     CLPink               = 15900365;
     CLBrightGrey         = 12763842;
     CLLightYellow        = 16777184;
     CLMediumBlue         = 8760809;
     CLGreenGrass         = 5667661;
     CLPureGreen          = 65280;

Var
     CLBgInfo             :Longint;     {*Background information box*}
     CLBgCard             :Longint;     {*Card background*}
     CLToggle             :Longint;     {*Toggle item*}
     CLTransparency       :Longint;     {*Transparency color (Green)*}
     CLTextTitle          :Longint;     {*Title text color*}
     CLText               :Longint;     {*Main text color*}
     CLShadow             :Longint;     {*Text shadow*}
     CLBackground         :Longint;     {*Screen desktop background*}
     CLWinBg              :Longint;     {*Windows background*}
     CLLineUp             :Longint;     {*Line on light*}
     CLLineDown           :Longint;     {*Line in shadow*}
     CLWinBorder          :Longint;     {*Windows border*}
     CLCursor             :Longint;     {*Cursors background*}
     CLBgButton           :Longint;     {*Buttons background*}
     CLTextButton         :Longint;     {*Buttons text*}
     CLDataZone           :Longint;     {*Composant data zone*}

{|Save and restore palette|}
Function  Col_SavePalette(FName:String):Boolean;     {*Save the system Palette*}
Function  Col_LoadPalette(FName:String):Boolean;     {*Load a system Palette*}

{|Colors modification|}
Function  Col_GetShadeColor(QttColors,WantedColor,FirstColor,LastColor:Longint):Longint; {*Get a RGB color in shade*}
Function  Col_SetSaturation(Color:Longint; Factor:Integer):Longint; {*Reduce / Expand the RGB color values*}
Function  Col_GetNegative  (Color:Longint):Longint;  {*Return the negative color*}
Function  Col_GetGrey      (Color:Longint):Longint;  {*Return the grey color*}
Procedure Col_SetZoneToGrey(fX1,fY1,fX2,fY2:Integer);{*Modify screen zone to set grey*}

{|Conversion functions|}
Procedure HSV_To_RGB(H,S,V:Real; Var R,G,B:Real);    {*Convert HSV to RGB format color*}
Procedure RGB_To_HSV(R,G,B:Real; Var H,S,V:Real);    {*Convert RGB to HSV format color*}
Procedure YCrCb_To_RGB(Y,Cr,Cb:Real; Var R,G,B:Real);{*Convert YCrCb to RGB format color*}
Procedure RGB_To_YCrCb(R,G,B:Real; Var Y,Cr,Cb:Real);{*Convert RGB to YCrCb format color*}

{|Initialisations|}
Procedure Init_SetColorsValues;

IMPLEMENTATION

Uses
     IniFiles,
     MosBase,
     MosConfig,
     MosGraph,
     MosMouse,
     MosStrings;

{*----------------- Colors initialisations files management ----------------*}

{ͻ
                          FUNCTION Col_SavePalette                          
 ͹
  IN.....: FName (STRING) = The palette filename.                           
  OUT....: (BOOLEAN) = TRUE if Ok else FALSE if an error occured.           
  EXPLAIN: Save the system MOS palette into a file.                         
 ͼ}

Function Col_SavePalette(FName:String):Boolean;
Var Ini:TIniFile;
    Section:String;

Function GetRGBString(Col:Longint):String;
Var R,G,B:Byte;
Begin
VESA_GetRGBColor(Col,R,G,B);
GetRGBString:=Str_FillZero(R,3)+','+Str_FillZero(G,3)+','+Str_FillZero(B,3);
End;

Begin
Log.Add('Saving palette ('+FName+')',2);

Col_SavePalette:=TRUE;                  {*Save Ok*}
Ini_Init(Ini,FName);
Section:='Interface colors';

Ini_SaveKey(Ini,Section,'Text',GetRGBString(CLText));
Ini_SaveKey(Ini,Section,'TextTitle',GetRGBString(CLTextTitle));
Ini_SaveKey(Ini,Section,'TextButton',GetRGBString(CLTextButton));
Ini_SaveKey(Ini,Section,'Background',GetRGBString(CLBackground));
Ini_SaveKey(Ini,Section,'BackgroundCard',GetRGBString(CLBgCard));
Ini_SaveKey(Ini,Section,'BackgroundInfo',GetRGBString(CLBgInfo));
Ini_SaveKey(Ini,Section,'BackgroundButton',GetRGBString(CLBgButton));
Ini_SaveKey(Ini,Section,'BackgroundWindow',GetRGBString(CLWinBg));
Ini_SaveKey(Ini,Section,'Shadow',GetRGBString(CLShadow));
Ini_SaveKey(Ini,Section,'LineUp',GetRGBString(CLLineUp));
Ini_SaveKey(Ini,Section,'LineDown',GetRGBString(CLLineDown));
Ini_SaveKey(Ini,Section,'WindowBorder',GetRGBString(CLWinBorder));
Ini_SaveKey(Ini,Section,'Cursor',GetRGBString(CLCursor));
Ini_SaveKey(Ini,Section,'DataZone',GetRGBString(CLDataZone));
Ini_SaveKey(Ini,Section,'Toggle',GetRGBString(CLToggle));
Ini_SaveKey(Ini,Section,'Transparency',GetRGBString(CLTransparency));

Ini_SaveKey(Ini,Section,'Panel shade col1',GetRGBString(Sys.PanelShadeCol1));
Ini_SaveKey(Ini,Section,'Panel shade col2',GetRGBString(Sys.PanelShadeCol2));
Ini_SaveKey(Ini,Section,'Window inactive col1',GetRGBString(Sys.WinInactiveCol1));
Ini_SaveKey(Ini,Section,'Window inactive col2',GetRGBString(Sys.WinInactiveCol2));
Ini_SaveKey(Ini,Section,'Window active col1',GetRGBString(Sys.WinActiveCol1));
Ini_SaveKey(Ini,Section,'Window active col2',GetRGBString(Sys.WinActiveCol2));
Ini_SaveKey(Ini,Section,'Window image transparency',GetRGBString(Sys.WindowImageTransp));

Ini_Done(Ini);
End;

{ͻ
                          FUNCTION Col_LoadPalette                          
 ͹
  IN.....: FName (STRING) = The palette filename.                           
  OUT....: (BOOLEAN) = TRUE if Ok else FALSE if an error occured.           
  EXPLAIN: Load a system MOS palette and apply colors.                      
 ͼ}

Function Col_LoadPalette(FName:String):Boolean;
Var Ini:TIniFile;
    Section:String;

Function GetLongintRGB(St:String):Longint;
Begin
GetLongintRGB:=VESA_SetRGBColor(Str_S2L(Str_Get(St,1,',')), Str_S2L(Str_Get(St,2,',')), Str_S2L(Str_Get(St,3,',')));
End;

Begin
Col_LoadPalette:=TRUE;
Log.Add('Loading palette ('+FName+')',2);
Ini_Init(Ini,FName);
Section:='Interface colors';

CLText      :=GetLongintRGB(Ini_LoadKey(Ini,Section,'Text',''));
CLTextTitle :=GetLongintRGB(Ini_LoadKey(Ini,Section,'TextTitle',''));
CLTextButton:=GetLongintRGB(Ini_LoadKey(Ini,Section,'TextButton',''));
CLBackground:=GetLongintRGB(Ini_LoadKey(Ini,Section,'Background',''));
CLBgCard    :=GetLongintRGB(Ini_LoadKey(Ini,Section,'BackgroundCard',''));
CLBgInfo    :=GetLongintRGB(Ini_LoadKey(Ini,Section,'BackgroundInfo',''));
CLBgButton  :=GetLongintRGB(Ini_LoadKey(Ini,Section,'BackgroundButton',''));
CLWinBg     :=GetLongintRGB(Ini_LoadKey(Ini,Section,'BackgroundWindow',''));
CLShadow    :=GetLongintRGB(Ini_LoadKey(Ini,Section,'Shadow',''));
CLLineUp    :=GetLongintRGB(Ini_LoadKey(Ini,Section,'LineUp',''));
CLLineDown  :=GetLongintRGB(Ini_LoadKey(Ini,Section,'LineDown',''));
CLWinBorder :=GetLongintRGB(Ini_LoadKey(Ini,Section,'WindowBorder',''));
CLCursor    :=GetLongintRGB(Ini_LoadKey(Ini,Section,'Cursor',''));
CLDataZone  :=GetLongintRGB(Ini_LoadKey(Ini,Section,'DataZone',''));
CLToggle    :=GetLongintRGB(Ini_LoadKey(Ini,Section,'Toggle',''));
CLTransparency:=GetLongintRGB(Ini_LoadKey(Ini,Section,'Transparency',''));

Sys.PanelShadeCol1   :=GetLongintRGB(Ini_LoadKey(Ini,Section,'Panel shade col1',''));
Sys.PanelShadeCol2   :=GetLongintRGB(Ini_LoadKey(Ini,Section,'Panel shade col2',''));
Sys.WinInactiveCol1  :=GetLongintRGB(Ini_LoadKey(Ini,Section,'Window inactive col1',''));
Sys.WinInactiveCol2  :=GetLongintRGB(Ini_LoadKey(Ini,Section,'Window inactive col2',''));
Sys.WinActiveCol1    :=GetLongintRGB(Ini_LoadKey(Ini,Section,'Window active col1',''));
Sys.WinActiveCol2    :=GetLongintRGB(Ini_LoadKey(Ini,Section,'Window active col2',''));
Sys.WindowImageTransp:=GetLongintRGB(Ini_LoadKey(Ini,Section,'Window image transparency',''));

Ini_Done(Ini);
End;

{*--------------------------- Colors functions -----------------------------*}

{ͻ
                        PROCEDURE Col_SetZoneToGrey                         
 ͹
  IN.....: fX1,fY1,fX2,Y2 (Integer) = Box coordinates.                      
  OUT....: /                                                                
  EXPLAIN: Set the screen box to grey colors.                               
 ͼ}

Procedure Col_SetZoneToGrey(fX1,fY1,fX2,fY2:Integer);
Var X,Y:Integer;
    MyColor:Longint;
Begin
Mse_Hide;
For X:=fX1 to fX2 do
   For Y:=fY1 to fY2 do
      Begin
      MyColor:=Col_GetGrey(VESA_GetPixel(X,Y));
      VESA_PutPixel(X,Y,MyColor);
      End;
Mse_Show;
End;

{ͻ
                            FUNCTION Col_GetGrey                            
 ͹
  IN.....: Colors (LONGINT) = RGB color.                                    
  OUT....: (LONGINT) = The grey color.                                      
  EXPLAIN: Return the corresponding grey RGB Color.                         
 ͼ}

Function Col_GetGrey(Color:Longint):Longint;
Var R,G,B:Byte;
    Moy:Byte;
Begin
VESA_GetRGBColor(Color,R,G,B);
Moy:=(R+G+B) Div 3;
Col_GetGrey:=VESA_SetRGBColor(Moy,Moy,Moy); {*Return color value*}
End;

{ͻ
                          FUNCTION Col_GetNegative                          
 ͹
  IN.....: Colors (LONGINT) = RGB color.                                    
  OUT....: (LONGINT) = The negative color.                                  
  EXPLAIN: Return the negative RGB Color.                                   
 ͼ}

Function Col_GetNegative(Color:Longint):Longint;
Var R,G,B:Byte;
Begin
VESA_GetRGBColor(Color,R,G,B);
Col_GetNegative:=VESA_SetRGBColor(255-R,255-G,255-B); {*Return color value*}
End;

{ͻ
                         FUNCTION Col_SetSaturation                         
 ͹
  IN.....: Colors (LONGINT) = Quantity of colors in the shade.              
           Factor (INTEGER) = Multiplicity factor using percents (0 to x).  
  OUT....: (LONGINT) = The modified color.                                  
  EXPLAIN: Reduce / expand the RGB color values as saturation / contrast.   
  EXAMPLE: Col_SetSaturation(CLRed,50)   // Return a dark red (half reduce).
 ͼ}

Function Col_SetSaturation(Color:Longint; Factor:Integer):Longint;
Var R,G,B:Byte;
    T:Longint;
Begin
Col_SetSaturation:=Color;
If Factor<0 Then Exit;                  {*Invalid parameter !*}

VESA_GetRGBColor(Color,R,G,B);
T:=R; T:=Round(T*Factor/100.0);         {*Apply percentage*}
If T>255 Then T:=255;
R:=T;
T:=G; T:=Round(T*Factor/100.0);
If T>255 Then T:=255;
G:=T;
T:=B; T:=Round(T*Factor/100.0);
If T>255 Then T:=255;
B:=T;
Col_SetSaturation:=VESA_SetRGBColor(R,G,B);{*Return color value*}
End;

{ͻ
                         FUNCTION Col_GetShadeColor                         
 ͹
  IN.....: QttColors (LONGINT) = Quantity of colors in the shade.           
           WantedColor (LONGINT) = The wanted ranked color (1 to Qtt).      
           FirstColor,LastColor (LONGINT) = First and last RGB color to use.
  OUT....: (LONGINT) = The ranked RGB color.                                
  EXPLAIN: Get a ranked RGB color among the QttColor spreaded in a shade.   
 ͼ}

Function Col_GetShadeColor(QttColors,WantedColor,FirstColor,LastColor:Longint):Longint;
Var R,G,B,R1,G1,B1,R2,G2,B2:Byte;       {*Colors components*}

Begin
Col_GetShadeColor:=FirstColor;          {*De base si erreur*}
If QttColors<=1 Then Exit;              {*Pas assez de couleurs !*}
If (WantedColor<1) Or (WantedColor>QttColors) Then Exit; {*Out of range !*}

VESA_GetRGBColor(FirstColor,R1,G1,B1);  {*Get RGB components*}
VESA_GetRGBColor(LastColor, R2,G2,B2);

R:=R1+(R2-R1)*WantedColor Div (QttColors);
G:=G1+(G2-G1)*WantedColor Div (QttColors);
B:=B1+(B2-B1)*WantedColor Div (QttColors);
Col_GetShadeColor:=VESA_SetRgbColor(R,G,B); {*Return color*}
End;

{*---------------------------- Conversion functions ------------------------*}

{ͻ
                            PROCEDURE HSV_To_RGB                            
 ͹
  IN.....: H,S,V (REAL) = HSV values for the color.                         
  OUT....: R,G,B (REAL) = RGB values for the color.                         
  EXPLAIN: Convert the HSV values in RGB values for a color.                
  NB.....: from the source GIF.PAS, self extracted from the sources of      
           Persistence Of Vision (POV), refered by                          
           "Computer Graphics", Donald Hearn & M. Pauline Baker, p. 304.    
 ͼ}

Procedure HSV_To_RGB(H,S,V:Real; Var R,G,B:Real);
Var Zone:Byte; F:Real;
Begin
If H=360 Then H:=0;
Zone:=Trunc(H/60);
F:=H/60-Zone;
Case Zone of
  0: Begin r:=v; g:=v*(1-s*(1-f)); b:=v*(1-s); End;
  1: Begin r:=v*(1-s*f); g:=v; b:=v*(1-s); End;
  2: Begin r:=v*(1-s); g:=v; b:=v*(1-s*(1-f)); End;
  3: Begin r:=v*(1-s); g:=v*(1-s*f); b:=v; End;
  4: Begin r:=v*(1-s*(1-f)); g:=v*(1-s); b:=v; End;
  5: Begin r:=v; g:=v*(1-s); b:=v*(1-s*f); End;
  Else Begin r:=0; g:=0; b:=0; End;
End;
End;

{ͻ
                            PROCEDURE RGB_To_HSV                            
 ͹
  IN.....: R,G,B (REAL) = RGB values for the color.                         
  OUT....: H,S,V (REAL) = HSV values for the color.                         
  EXPLAIN: Convert the RGB values in HSV values for a color.                
 ͼ}

Procedure RGB_To_HSV(R,G,B:Real; Var H,S,V:Real);
Var M:Real;
Begin
If r>g Then Begin
  If r>b Then v:=r Else v:=b;
  If g<b Then m:=g Else m:=b;
  End Else Begin
  If g>b Then v:=g Else v:=b;
  If r<b Then m:=r Else m:=b
  end;
                                        {*En fait V:=Max(r,g,b) M:=Min(r,g,b)*}
If v<>0 Then s:=(v-m)/v Else s:=0;      {*Calcul saturation*}
If s<>0 Then Begin                      {*Calcul de l'angle*}
  If v=r Then If m=g Then h:=5+(v-b)/(v-m) Else h:=1-(v-g)/(v-m)
  Else If v=g Then If m=b Then h:=1+(v-r)/(v-m) Else h:=3-(v-b)/(v-m)
  Else If v=b Then If m=r Then h:=3+(v-g)/(v-m) Else h:=5-(v-r)/(v-m);
  h:=h*60; If h=360 Then h:=0;
  End Else Begin                        {*Noir*}
  h:=0; s:=0;
  End;
End;

{ͻ
                           PROCEDURE YCrCb_To_RGB                           
 ͹
  IN.....: Y,Cr,Cb (REAL) = YCrCb values for the color.                     
  OUT....: R,G,B (REAL) = RGB values for the color.                         
  EXPLAIN: Convert the YCrCb values in RGB values for a color.              
 ͼ}

Procedure YCrCb_To_RGB(Y,Cr,Cb:Real; Var R,G,B:Real);
Begin
R:=Y+1.402*Cr;
B:=Y+1.772*Cb;
G:=(Y-0.299*R-0.114*B)/0.587;
End;

{ͻ
                           PROCEDURE RGB_To_YCrCb                           
 ͹
  IN.....: R,G,B (REAL) = RGB values for the color.                         
  OUT....: Y,Cr,Cb (REAL) = YCrCb values for the color.                     
  EXPLAIN: Convert the RGB values in YCrCb values for a color.              
 ͼ}

Procedure RGB_To_YCrCb(R,G,B:Real; Var Y,Cr,Cb:Real);
Begin
Y:=0.299*R+0.587*G+0.114*B;             {*Luminance de 0  1*}
Cr:=(R-Y)/1.402;                        {*Chrominance rouge normalise de -0.5  0.5*}
Cb:=(B-Y)/1.772;                        {*Chrominance bleue normalise de -0.5  0.5*}
End;

{*---------------------------------- Colors --------------------------------*}

{ͻ
                       PROCEDURE Init_SetColorsValues                       
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Initialise colors values depending the graphic mode.             
 ͼ}

Procedure Init_SetColorsValues;
Begin
   CLBgInfo             := CLLightYellow;
   CLToggle             := CLMediumBlue;
   CLBgCard             := CLGreenGrass;
   CLTransparency       := CLPureGreen;
   CLLineDown           := CLBlack;
   CLText               := CLBlack;
   CLTextButton         := CLBlack;
   CLBackground         := CLGrey;
   CLWinBorder          := CLPaper;
   CLWinBg              := CLLightGrey;
   CLBgButton           := CLLightGrey;
   CLCursor             := CLLightGrey;
   CLShadow             := CLDarkGrey;
   CLTextTitle          := CLWhite;
   CLLineUp             := CLWhite;
   CLDataZone           := CLWhite;
End;

{*-------------------------- PROGRAMME PRINCIPAL ---------------------------*}

Begin
End.
