{ͻ
                               UNIT MosConfig                               
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 09.06.1999                                                   
  COUNTRY....: Perpignan - ASI Informatique                                 
  DESCRIPTION: Sections, logfile, language, system and user object.         
               Global constantes, variables and structures description.     
  AUTONOMOUS.: Yes                                                          
  UNIT SIZE..: 1.257 Lines and (53.808 Bytes compiled)                      
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosConfig;

{$Mode Objfpc}

INTERFACE

Uses
     Classes,
     IniFiles;

{****************************************************************************}

Const

   Yes               = TRUE;            {*Boolean values*}
   No                = FALSE;

   LFEnglish         = 'ENG';           {*Languages Id definition*}
   LFFrancais        = 'FRA';
   LFEspanol         = 'ESP';
   LFPortuguese      = 'POR';
   LFNihon           = 'NIH';

      Win_Max        =25;               {*Maximum stack of 25 windows*}
      Max_AS         =10;               {*Maximum numbers of action sounds*}
      Max_Pointer    =29;               {*Mouse pointers quantity*}
      Max_Ico        =6;                {*Icones files quantity*}
      Speed_Zoom     =60;               {*Speed for zoom window*}

      MBNone         =0;                {*Mouse buttons actions*}
      MBLeft         =1;                {*Left button clicked*}
      MBCenter       =2;                {*Center button clicked*}
      MBRight        =3;                {*Right button clicked*}
      MBIgnore       =10;               {*Ignore mouse buttons*}

      G_Button    =1;                   {*Id Gadget Button*}
      G_InputText =2;                   {*Id Gadget InputText*}
      G_Tabs      =3;                   {*Id Gadget Tabs*}
      G_Taquet    =4;                   {*Id Gadget Taquet*}

{!}      M_Extention =1;                   {*File detection method*}
{!}      M_Header    =2;

      SP_MAIN     =1;                   {*Define System paths*}
      SP_FONTS    =2;
      SP_ICONS    =3;
      SP_IMAGES   =4;
      SP_SOUNDS   =5;
      SP_BUFFER   =6;
      SP_TOOLS    =7;
      SP_BOOT     =8;
      SP_TEMP     =9;
      SP_DATAS    =10;
      SP_BLANKERS =11;
      SP_SNAPSHOTS=12;
      SP_PALETTES =13;
      SP_PATTERNS =14;
      SP_TEXTURES =15;
      SP_BUTTONS  =16;
      SP_MEDIAS   =17;
      SP_CARDS    =18;
      SP_THEMES   =19;
      SP_PROCESS  =20;
      SP_ANIMS    =21;
      SP_INSTALL  =22;
      SP_POINTERS =23;
      SP_DBASE    =24;
      SP_LOG      =25;

      SP_LASTDIR  =25;                  {*Must be equal to the last directory*}

      FR_MultiSelection =0;             {*File Requester Modes (Bits)*}
      FR_Directory      =1;
      FR_DeleteFiles    =2;
      FR_RenameFiles    =3;
      FR_Attributes     =4;
      FR_Applications   =5;
      FR_User           =6;

      C_Init         =1;                {*Various utilisations*}
      C_Execute      =2;

      BLK_Execute  =1;                  {*Screen Blankers module*}
      BLK_Parameter=2;

      LED_Scroll  =016;                 {*Bit Scroll-Lock*}
      LED_Num     =032;                 {*Bit Num-Lock*}
      LED_Caps    =064;                 {*Bit Caps-Lock*}
      KEY_Ins     =128;                 {*Bit Insert*}

      B_AND       =0;                   {*Boolean OR or AND*}
      B_OR        =1;

      TSep      :Array[1..3] of String[1]=(':','/','');{*Time Separator (":" "/" " ")*}

{****************************************************************************}

{|Keys management|}
Function  Ini_Init            (Var Ini:TIniFile; FName:String):Boolean;                       {*Open (Read/Write) an INI file*}
Function  Ini_Done            (Var Ini:TIniFile):Boolean;                                     {*Validate modifications or close*}
Function  Ini_LoadKey         (Var Ini:TIniFile; Section,Key:String; Value:Longint):Longint;  {*Get an integer key value*}
Function  Ini_LoadKey         (Var Ini:TIniFile; Section,Key:String; Value:String):String;    {*Get a string key value*}
Function  Ini_LoadKey         (Var Ini:TIniFile; Section,Key:String; Value:Boolean):Boolean;  {*Get a boolean key value*}
Procedure Ini_SaveKey         (Var Ini:TIniFile; Section,Key:String; Value:Longint);          {*Save an integer key value*}
Procedure Ini_SaveKey         (Var Ini:TIniFile; Section,Key:String; Value:String);           {*Save a string key value*}
Procedure Ini_SaveKey         (Var Ini:TIniFile; Section,Key:String; Value:Boolean);          {*Save a boolean key value*}
Function  Ini_RemoveKey       (Var Ini:TIniFile; Section,Key:String):Boolean;                 {*Remove a key*}
Function  Ini_UpdateKey       (Var Ini:TIniFile; Section,Key:String; VIncDec:Longint):Boolean;{*Update a numeric key value*}
Function  Ini_UpdateKey       (FName:String; Section,Key:String; VIncDec:Longint):Boolean;    {*Update a numeric key value*}
Function  Ini_LoadKey         (FName,Section,Key:String):String;                              {*Get a string key value from file*}
Function  Ini_RemoveSection   (Var Ini:TIniFile; Section:String):Boolean;                     {*Remove a section*}
Function  Ini_CountSections   (FName:String):Integer;                                         {*Count how many sections in file*}

{|Configurations files management|}
Function  Load_Config(Name:String):Boolean;   {*Load MOS or software configuration*}
Function  Save_Config(Name:String):Boolean;   {*Save MOS or software configuration*}

Type                                    {*Define types and classes*}

{****************************************************************************}

TCoordinates = Record                   {*Coordinates structure*}
   X1,Y1,X2,Y2       :Integer;
   End;

{****************************************************************************}

TDisplayRegister = (                    {*Display register requester*}
   RRNoDisplay,
   RRToDisplay,
   RRDisplaying);

TRefreshMode = (                        {*Mouse pointer refresh mode*}
   RMHideAlways,
   RMHideOver,
   RMShowAlways);

TFileTypeDetection = (                  {*File detection method*}
   FDNone,
   FDSuffix,
   FDHeader);

TDesktopStyle = (                       {*Desktop screen style*}
   DSNone,
   DSGraphic,
   DSPattern);

TDisplayPosition = (                    {*Display Image method*}
   DIClient,
   DICenter,
   DIStretch,
   DIMosaic);

{****************************************************************************}
{*** TLogFile Class                                                       ***}
{****************************************************************************}

TLogFile = Class(TObject)               {*LogFile management class*}
   Private
      fFileName         :String;        {*Log filename*}
      fLevel            :Byte;          {*Log level*}
      fCount            :Longint;       {*Lignes added in Log file*}

   Protected
      Function    AddLine(Line:String):Boolean; {*Add a Log line*}
      Function    AddLineLevel(Line:String; pLevel:Byte):Boolean; {*Add a Log line with level*}

   Public
      Property FileName :String  Read fFileName;
      Property Count    :Longint Read fCount;
      Property Level    :Byte    Read fLevel     Write fLevel;

      Constructor Create(pFileName:String); {*Create TLogFile component*}
      Function    Erase:Boolean;            {*Erase the Log file*}
      Function    Add(Line:String):Boolean; {*Append a line in the Log file*}
      Function    Add(Line:String; pLevel:Byte):Boolean;{*Append with Log level*}
   End;

{****************************************************************************}
{*** TLocale Class                                                        ***}
{****************************************************************************}

TLocale = Class(TStringList)            {*TLocale management class*}
   Protected
      Function    GetIndex(IdLan:String):Longint;       {*Get index of a language Id*}

   Public
      Function    GetErrorFile(IdLan:String):String;    {*Get error locale filename*}
      Function    GetLocaleFile(IdLan:String):String;   {*Get locale filename*}
      Function    GetAppLocaleFile(IdLan:String):String;{*Get application locale filename*}
      Procedure   SetLocaleFile(IdLan,FileName:String); {*Set locale filename*}
   End;

{****************************************************************************}
{*** TLanguage Class                                                      ***}
{****************************************************************************}

TLanguage = Class(TStringList)          {*TLanguage management class*}
   Private
      fCode             :String;        {*Language code Id*}
      fLoaded           :Boolean;       {*File loaded in memory or no*}
      fFileLines        :Longint;       {*Count lines from file*}
      fDefaultText      :String;        {*Default text to store when not found*}

      Function    GetFileName:String;         {*Get the Locale filename*}
      Function    GetErrorName:String;        {*Get the Locale errors filename*}

   Public
      Constructor Create;                     {*Create TLanguage component*}
      Procedure   SetLanguage(LanId:String);  {*Select new language*}
      Procedure   SetDefaultText(D:String);   {*Set default text*}
      Procedure   SetLoc(Index:Longint; Phrase:String); {*Set new locale line*}
      Function    AddLoc(Phrase:String):Longint; {*Add a text at the first free place*}
      Function    GetFreeLoc:Longint;         {*Return the first free line*}
      Function    Loc(Index:Longint):String;  {*Get a text from the Locale file*}
      Function    GetCountFree:Longint;       {*Count free Id labels in file*}
      Procedure   LoadFromFile(Const pFileName:String); {*Method to load locale files*}
      Procedure   LoadLanguage;               {*Load locale into memory*}
      Procedure   SaveLanguage;               {*Save locale in file*}
      Procedure   RemoveLanguage;             {*Remove locale file from memory*}

      Property Code        :String    Read fCode         Write SetLanguage;
      Property CountFree   :Longint   Read GetCountFree;
      Property FileName    :String    Read GetFileName;
      Property FileLines   :Longint   Read fFileLines;
      Property ErrorName   :String    Read GetErrorName;
      Property DefaultText :String    Read fDefaultText  Write SetDefaultText;

{!} {Temporaire. A virer ds que la localisation est en place} Property Loaded      :Boolean   Read fLoaded Write floaded;
{      Property Loaded      :Boolean   Read fLoaded;}
   End;

{****************************************************************************}
{*** TUser Class                                                          ***}
{****************************************************************************}

TUser = Class(TObject)                  {*TUser class*}
   Private
      fName             :String;        {*Name and surname*}
      fChecksum         :Longint;       {*Checksum user name*}

   Protected
      Procedure SetName(N:String);      {*Set customer name*}

   Public
      Property Name     :String    Read fName       Write SetName;
      Property Checksum :Longint   Read fChecksum;

      Constructor Create;               {*Create new object*}
      Function    GetChecksum:Longint;  {*Calcule the filename checksum*}
      Procedure   CheckIntegrity;       {*Check if MOS has been cracked*}
   End;

{****************************************************************************}
{*** TSystem Class                                                        ***}
{****************************************************************************}

TSoundFileTemp  = Array[1..Max_AS] of ShortString;

{ TSystem }

TSystem = Class(TObject)                {*TSystem class*}
   Private
      fEnableTasksManager:Boolean;      {*Enable/disable tasks manager*}
      fDisplayRegister  :TDisplayRegister; {*Need to display register requester*}
      fRefreshMode      :TRefreshMode;  {*Mouse pointer refresh mode*}
      fFileTypeDetection:TFileTypeDetection; {*File detection method*}
      fRefreshScreen    :Byte;          {*Refresh screen level (0=No refresh)*}
      fDirectory        :String;        {*System directory definition*}
      fSystemFound      :Boolean;       {*System directory found*}
      fTempDirectory    :ShortString;   {*Temporary drawer "C:\TEMP"*}
      fDisplayHints     :Boolean;       {*Display Hints's interface*}
      fGfxMode          :Shortint;      {*Current graphic mode*}
      fOldGfxMode       :Shortint;      {*Previous graphic mode*}
      fInitialMemory    :Longint;       {*Initial memory*}
      fTimeBelt         :Shortint;      {*Time belt number*}
      fTimeSeparator    :Byte;          {*Time separator definition*}
      fDemoFile         :ShortString;   {*File to play or record demo*}
      fTag              :Longint;       {*Reserved value for users*}

      fLogFileBackup    :String;        {*Log filename in System\Log drawer*}

      fOnMouseZone      :Boolean;       {*Mouse is over a special zone*}
      fComponentActivated:Boolean;      {*A component is activated somewhere*}
      fSlidersActivated :Integer;       {*Count Sliders that has been activated*}
      fButtonsActivated :Integer;       {*Count how many buttons are currently activated*}

      fImgCheckYes      :String;        {*Component Check tagged image*}
      fImgCheckNo       :String;        {*Component Check non tagged image*}
      fImgRadioYes      :String;        {*Component Radio tagged image*}
      fImgRadioNo       :String;        {*Component Radio non tagged image*}
      fImgCycler        :String;        {*Component Cycler image*}
      fImgBevel         :String;        {*MOS Bevel left image*}
      fImgError         :String;        {*Error BMP displaying image*}
      fImgBomb          :String;        {*Dialog requester icon*}
      fImgInformation   :String;        {*Dialog requester icon*}
      fImgQuestion      :String;        {*Dialog requester icon*}
      fImgStop          :String;        {*Dialog requester icon*}
      fImgWarning       :String;        {*Dialog requester icon*}
      fImgSliderUpNo    :String;        {*Slider up no pressed*}
      fImgSliderUpYes   :String;        {*Slider up pressed*}
      fImgSliderDownNo  :String;        {*Slider down no pressed*}
      fImgSliderDownYes :String;        {*Slider down pressed*}
      fImgSliderLeftNo  :String;        {*Slider left no pressed*}
      fImgSliderLeftYes :String;        {*Slider left pressed*}
      fImgSliderRightNo :String;        {*Slider right no pressed*}
      fImgSliderRightYes:String;        {*Slider right pressed*}

      fDesktopImage     :String;        {*Gfx to display as background screen*}
      fDesktopStyle     :TDesktopStyle; {*Desktop screen style*}
      fDesktopPattern   :Byte;          {*Pattern number for screen*}
      fDesktopDisplayStyle:TDisplayPosition;{*Desktop image style displayed*}
      fBootImage        :String;        {*Gfx to display at boot*}
      fWindowImage      :String;        {*Gfx to display as window background*}
      fWindowImageTransp:Longint;       {*Window image transparency*}
      fWindowBgStyle    :Byte;          {*Background windows style: 0=Nothing, 1=Pattern*}
      fWindowBgPattern  :Byte;          {*Pattern number for window background*}

      fSetGrid          :Boolean;       {*Set grid On/Off*}
      fGridStepX        :Shortint;      {*Grid offset X*}
      fGridStepY        :ShortInt;      {*Grid offset Y*}

      fSoundFile        :TSoundFileTemp;{Array[1..Max_AS] of ShortString; *Sounds When Actions*}
      fAudioSBVolume    :Byte;          {*Sound Blaster Volume*}
      fAudioCDVolume    :Byte;          {*Audio CD Volume*}

      fSetMouseBlanker  :Boolean;       {*Mouse blanker activation*}
      fScreenBlanker    :ShortString;   {*Screen blanker file*}
      fScreenVisible    :Boolean;       {*Screen state (On/Off)*}
      fScreenBlankerDelay:Byte;         {*Screen blanker delay for activation*}
      fMouseDblClickDelay:Integer;      {*Double click value*}
      fMouseClickDelay  :Integer;       {*Mouse delay value*}
      fMouseSpeed       :Byte;          {*Mouse speed*}

      fCursorBlinkSpeed :Word;          {*Speed for cursor blink*}
      fCursorShape      :Byte;          {*Cursor shape*}
      fSpeedKeyRate     :Byte;          {*Speed Key Rate*}
      fSpeedKeyDelay    :Byte;          {*Speed Key Delay*}
      fNumLockState     :Boolean;       {*Initial NumLock state*}

      fPanelShadeCol1   :Longint;       {*Panel color 1*}
      fPanelShadeCol2   :Longint;       {*Panel color 2*}
      fWinInactiveCol1  :Longint;       {*Window inactive color 1*}
      fWinInactiveCol2  :Longint;       {*Window inactive color 2*}
      fWinActiveCol1    :Longint;       {*Window active color 1*}
      fWinActiveCol2    :Longint;       {*Window active color 2*}

      fWinOpenCount     :Integer;       {*Numbers of openned windows*}
      fWinMoved         :Boolean;       {*A window is moved somewhere*}
      fWinSized         :Boolean;       {*A window is sized somewhere*}
      fWinToRefresh     :Byte;          {*Windows number to modify*}
      fWinToSwap        :Byte;          {*Num de Fentre devant tre Swappe*}
      fWinFirstToSwap   :Byte;          {*Num 1ere Window  Swapper*}
      fWinInnerFlag     :Boolean;       {*Inner flag. Multi-use*}
      fWinActionType    :Byte;          {*Window action type*}
      fWinCurrentCoord  :TCoordinates;  {*Current window coordinates*}

      fNetLoginName     :String;        {*Name for Network Login*}
      fNetEnableNetMsg  :Boolean;       {*Display Network Messages*}
      fNetEnableUserMsg :Boolean;       {*Display User Messages*}
      fNetDisplayLogin  :Boolean;       {*Login at Boot*}
      fNetReceivedMsg   :Word;          {*Number of received messages*}
      fNetSentMsg       :Word;          {*Number of sent messages*}
      fNetSignMsg       :Boolean;       {*Sign messages or no*}
      fNetDoBeep        :Boolean;       {*Beep when a message arrive*}

      fFontDirection    :Byte;          {*Direction of the current font*}
      fFontMain         :ShortString;   {*Font 1 filename*}
      fFontMainSize     :Byte;          {*Font 1 size*}
      fFontMenu         :ShortString;   {*Font 2 filename*}
      fFontMenuSize     :Byte;          {*Font 2 size*}
      fFontWinTitle     :ShortString;   {*Font 3 filename*}
      fFontWinTitleSize :Byte;          {*Font 3 size*}
      fFontHint         :ShortString;   {*Font 4 filename*}
      fFontHintSize     :Byte;          {*Font 4 size*}
      fFontCurrent      :ShortString;   {*Current Font filename*}
      fFontCurrentSize  :Byte;          {*Current Font size*}
      fFontPrevious     :ShortString;   {*Previous Font filename*}
      fFontPreviousSize :Byte;          {*Previous Font size*}
      fFontPreviousDirection:Byte;          {*Previous Font direction*}

      fBootPwdTestCount :Byte;          {*Nombre d'essais pour le Password*}
      fBootPwd          :String;        {*String pour le Password*}
      fAskForBootPwd    :Boolean;       {*Password at Boot or No*}

      fCommandCount     :Byte;          {*Gadgets "InputText" created*}
      fCommandSearchPos :Byte;          {*Compteur de Recherche de Prcdent InputText*}
      fButtonPressed    :Boolean;       {*A Button is pressed somewhere*}
      fRadioId          :Byte;          {*Bits pour Gestion Multiple Radio*}
      fRadioBoxGroup    :Byte;          {*Radio Box Demandeur Group*}
      fLightBoxActivated:Boolean;       {*Light Box is activated*}
      fLightBoxMinSize  :Integer;       {*Minimum size for the Light Box*}
      fLightBoxMinSized :Boolean;       {*Minimal size reached for Light Box*}
   Public
      SoundFile: TSoundFileTemp;
      (*
      function GetSoundFile(Index: Integer): ShortString;
      procedure SetSoundFile(Index: Integer; AValue: ShortString);
      *)
      function GetWinCurrentCoord: TCoordinates;
      procedure SetWinCurrentCoord(value: TCoordinates);
      Property EnableTasksManager:Boolean       Read fEnableTasksManager Write fEnableTasksManager;
      Property DisplayRegister:TDisplayRegister Read fDisplayRegister Write fDisplayRegister;
      Property RefreshMode:TRefreshMode   Read fRefreshMode Write fRefreshMode;
      Property FileTypeDetection:TFileTypeDetection Read fFileTypeDetection Write fFileTypeDetection;
      Property RefreshScreen:byte Read fRefreshScreen Write fRefreshScreen;
      Property Directory:String Read fDirectory Write fDirectory;
      Property SystemFound:Boolean Read fSystemFound Write fSystemFound;
      Property TempDirectory:ShortString Read fTempDirectory Write fTempDirectory;
      Property DisplayHints:Boolean Read fDisplayHints Write fDisplayHints;
      Property GfxMode:Shortint Read fGfxMode Write fGfxMode;
      Property OldGfxMode:Shortint Read fOldGfxMode Write fOldGfxMode;
      Property InitialMemory:Longint Read fInitialMemory Write fInitialMemory;
      Property TimeBelt:Shortint Read fTimeBelt Write fTimeBelt;
      Property TimeSeparator:Byte               Read fTimeSeparator      Write fTimeSeparator;
      Property DemoFile:ShortString Read fDemoFile Write fDemoFile;
      Property Tag:Longint Read fTag Write fTag;

      Property LogFileBackup:String Read fLogFileBackup Write fLogFileBackup;

      Property OnMouseZone:Boolean Read fOnMouseZone Write fOnMouseZone;
      Property ComponentActivated:Boolean Read fComponentActivated Write fComponentActivated;
      Property SlidersActivated:Integer Read fSlidersActivated Write fSlidersActivated;
      Property ButtonsActivated:Integer Read fButtonsActivated Write fButtonsActivated;

      Property ImgCheckYes:String Read fImgCheckYes Write fImgCheckYes;
      Property ImgCheckNo:String Read fImgCheckNo Write fImgCheckNo;
      Property ImgRadioYes:String Read fImgRadioYes Write fImgRadioYes;
      Property ImgRadioNo:String Read fImgRadioNo Write fImgRadioNo;
      Property ImgCycler:String Read fImgCycler Write fImgCycler;
      Property ImgBevel:String Read fImgBevel Write fImgBevel;
      Property ImgError:String Read fImgError Write fImgError;
      Property ImgBomb:String Read fImgBomb Write fImgBomb;
      Property ImgInformation:String Read fImgInformation Write fImgInformation;
      Property ImgQuestion:String Read fImgQuestion Write fImgQuestion;
      Property ImgStop:String Read fImgStop Write fImgStop;
      Property ImgWarning:String Read fImgWarning Write fImgWarning;
      Property ImgSliderUpNo:String Read fImgSliderUpNo Write fImgSliderUpNo;
      Property ImgSliderUpYes:String Read fImgSliderUpYes Write fImgSliderUpYes;
      Property ImgSliderDownNo:String Read fImgSliderDownNo Write fImgSliderDownNo;
      Property ImgSliderDownYes:String Read fImgSliderDownYes Write fImgSliderDownYes;
      Property ImgSliderLeftNo:String Read fImgSliderLeftNo Write fImgSliderLeftNo;
      Property ImgSliderLeftYes:String Read fImgSliderLeftYes Write fImgSliderLeftYes;
      Property ImgSliderRightNo:String Read fImgSliderRightNo Write fImgSliderRightNo;
      Property ImgSliderRightYes:String Read fImgSliderRightYes Write fImgSliderRightYes;

      Property DesktopImage:String Read fDesktopImage Write fDesktopImage;
      Property DesktopStyle:TDesktopStyle Read fDesktopStyle Write fDesktopStyle;
      Property DesktopPattern:Byte Read fDesktopPattern Write fDesktopPattern;
      Property DesktopDisplayStyle:TDisplayPosition Read fDesktopDisplayStyle Write fDesktopDisplayStyle;
      Property BootImage:String Read fBootImage Write fBootImage;
      Property WindowImage:String Read fWindowImage Write fWindowImage;
      Property WindowImageTransp:Longint Read fWindowImageTransp Write fWindowImageTransp;
      Property WindowBgStyle:Byte Read fWindowBgStyle Write fWindowBgStyle;
      Property WindowBgPattern:Byte Read fWindowBgPattern Write fWindowBgPattern;

      Property SetGrid:Boolean Read fSetGrid Write fSetGrid;
      Property GridStepX:Shortint Read fGridStepX Write fGridStepX;
      Property GridStepY:Shortint Read fGridStepY Write fGridStepY;

      //Property SoundFile[Index: Integer]: ShortString Read GetSoundFile Write SetSoundFile;
      Property AudioSBVolume:Byte Read fAudioSBVolume Write fAudioSBVolume;
      Property AudioCDVolume:Byte Read fAudioCDVolume Write fAudioCDVolume;

      Property SetMouseBlanker:Boolean Read fSetMouseBlanker Write fSetMouseBlanker;
      Property ScreenBlanker:ShortString Read fScreenBlanker Write fScreenBlanker;
      Property ScreenVisible:Boolean Read fScreenVisible Write fScreenVisible;
      Property ScreenBlankerDelay:Byte Read fScreenBlankerDelay Write fScreenBlankerDelay;
      Property MouseDblClickDelay:Integer Read fMouseDblClickDelay Write fMouseDblClickDelay;
      Property MouseClickDelay:Integer Read fMouseClickDelay Write fMouseClickDelay;
      Property MouseSpeed:Byte                  Read fMouseSpeed         Write fMouseSpeed;

      Property CursorBlinkSpeed:Word Read fCursorBlinkSpeed Write fCursorBlinkSpeed;
      Property CursorShape:Byte Read fCursorShape Write fCursorShape;
      Property SpeedKeyRate:Byte Read fSpeedKeyRate Write fSpeedKeyRate;
      Property SpeedKeyDelay:Byte Read fSpeedKeyDelay Write fSpeedKeyDelay;
      Property NumLockState:Boolean Read fNumLockState Write fNumLockState;

      Property PanelShadeCol1:Longint Read fPanelShadeCol1 Write fPanelShadeCol1;
      Property PanelShadeCol2:Longint Read fPanelShadeCol2 Write fPanelShadeCol2;
      Property WinInactiveCol1:Longint Read fWinInactiveCol1 Write fWinInactiveCol1;
      Property WinInactiveCol2:Longint Read fWinInactiveCol2 Write fWinInactiveCol2;
      Property WinActiveCol1:Longint Read fWinActiveCol1 Write fWinActiveCol1;
      Property WinActiveCol2:Longint Read fWinActiveCol2 Write fWinActiveCol2;

      Property WinOpenCount:Integer Read fWinOpenCount Write fWinOpenCount;
      Property WinMoved:Boolean Read fWinMoved Write fWinMoved;
      Property WinSized:Boolean Read fWinSized Write fWinSized;
      Property WinToRefresh:Byte Read fWinToRefresh Write fWinToRefresh;
      Property WinToSwap:Byte Read fWinToSwap Write fWinToSwap;
      Property WinFirstToSwap:Byte Read fWinFirstToSwap Write fWinFirstToSwap;
      Property WinInnerFlag:Boolean Read fWinInnerFlag Write fWinInnerFlag;
      Property WinActionType:Byte Read fWinActionType Write fWinActionType;
      Property WinCurrentCoord:TCoordinates Read GetWinCurrentCoord Write SetWinCurrentCoord;

      Property NetLoginName:String Read fNetLoginName Write fNetLoginName;
      Property NetEnableNetMsg:Boolean Read fNetEnableNetMsg Write fNetEnableNetMsg;
      Property NetEnableUserMsg:Boolean Read fNetEnableUserMsg Write fNetEnableUserMsg;
      Property NetDisplayLogin:Boolean Read fNetDisplayLogin Write fNetDisplayLogin;
      Property NetReceivedMsg:Word Read fNetReceivedMsg Write fNetReceivedMsg;
      Property NetSentMsg:Word Read fNetSentMsg Write fNetSentMsg;
      Property NetSignMsg:Boolean Read fNetSignMsg Write fNetSignMsg;
      Property NetDoBeep:Boolean Read fNetDoBeep Write fNetDoBeep;

      Property FontDirection:Byte Read fFontDirection Write fFontDirection;
      Property FontPreviousDirection:Byte Read fFontPreviousDirection Write fFontPreviousDirection;

      Property FontMain:ShortString Read fFontMain Write fFontMain;
      Property FontMainSize:Byte Read fFontMainSize Write fFontMainSize;
      Property FontMenu:ShortString Read fFontMenu Write fFontMenu;
      Property FontMenuSize:Byte Read fFontMenuSize Write fFontMenuSize;
      Property FontWinTitle:ShortString Read fFontWinTitle Write fFontWinTitle;
      Property FontWinTitleSize:Byte Read fFontWinTitleSize Write fFontWinTitleSize;
      Property FontHint:ShortString Read fFontHint Write fFontHint;
      Property FontHintSize:Byte Read fFontHintSize Write fFontHintSize;
      Property FontCurrent:ShortString Read fFontCurrent Write fFontCurrent;
      Property FontCurrentSize:Byte Read fFontCurrentSize Write fFontCurrentSize;
      Property FontPrevious:ShortString Read fFontPrevious Write fFontPrevious;
      Property FontPreviousSize:Byte Read fFontPreviousSize Write fFontPreviousSize;

      Property BootPwdTestCount:Byte Read fBootPwdTestCount Write fBootPwdTestCount;
      Property BootPwd:String Read fBootPwd Write fBootPwd;
      Property AskForBootPwd:Boolean Read fAskForBootPwd Write fAskForBootPwd;

      Property CommandCount:Byte Read fCommandCount Write fCommandCount;
      Property CommandSearchPos:Byte Read fCommandSearchPos Write fCommandSearchPos;
      Property ButtonPressed:Boolean Read fButtonPressed Write fButtonPressed;
      Property RadioId:Byte Read fRadioId Write fRadioId;
      Property RadioBoxGroup:Byte Read fRadioBoxGroup Write fRadioBoxGroup;
      Property LightBoxActivated:Boolean Read fLightBoxActivated Write fLightBoxActivated;
      Property LightBoxMinSize:Integer Read fLightBoxMinSize Write fLightBoxMinSize;
      Property LightBoxMinSized:Boolean Read fLightBoxMinSized Write fLightBoxMinSized;

      Constructor Create;               {*Create a TMessage class*}
      Function    TestHigherVersion(Version:String):Boolean; {*Test is sustem version is higher than application version*}
      Function    TestDefined:Boolean;  {*Test if system directory is defined*}
      Function    GetPath(Path:Byte):String; {*Get the path or a subpath for the system directory*}
      Function    GetVersion:String;    {*Get the installed system version*}
   End;

{****************************************************************************}

Type

   TString1=String[1];                  {*String 1*}

   ShortString=String[12];              {*String 12 = Short filename*}

   TMREComponent=Record                 {*Record Component*}
   Panel        :Byte;                  {*Component panel number*}
   Number       :Integer;               {*Component number in panel*}

   Tool         :String[32];            {*It's a component ! Trivial no !*}
   CClass       :String[64];            {*Component class*}
   Name         :String[64];            {*Component name*}
   SName        :String[16];            {*Component short name*}
   CType        :String[64];            {*Component TType*}
   Variable     :String[32];            {*Component variable declaration*}
   Resize       :Boolean;               {*Component can be sized by editor*}

   Visual       :Boolean;               {*Component has a visual part*}
   Picture      :String[128];           {*Component picture*}
   Description  :String[32];            {*Component description*}
   Version      :String[8];             {*Component version*}
   Date         :String[10];            {*Component creation date*}
   Revision     :String[32];            {*Component revision date*}
   Bugs         :String[64];            {*Component known bugs*}
   Coder        :String[64];            {*Component coder name*}
   Comments     :String[128];           {*Component miscellaneous comments*}

   ETool        :TString1;              {*Field attributes*}
   EClass       :TString1;              {*Field attributes*}
   EName        :TString1;              {*Field attributes*}
   ESName       :TString1;              {*Field attributes*}
   ECType       :TString1;              {*Field attributes*}
   EVariable    :TString1;              {*Field attributes*}
   EResize      :TString1;              {*Field attributes*}
   EVisual      :TString1;              {*Field attributes*}
   EPicture     :TString1;              {*Field attributes*}
   EDescription :TString1;              {*Field attributes*}
   EVersion     :TString1;              {*Field attributes*}
   EDate        :TString1;              {*Field attributes*}
   ERevision    :TString1;              {*Field attributes*}
   EBugs        :TString1;              {*Field attributes*}
   ECoder       :TString1;              {*Field attributes*}
   EComments    :TString1;              {*Field attributes*}
   End;

   TColor=Record                        {*Color structure*}
   R,G,B        :Byte;                  {*RGB values of a color*}
   End;

   TProcess=Record                      {*Process structure*}
   PId          :Word;                  {*Process Id*}
   FName        :String;                {*Process filename to store infotmation*}
   AppName      :String;                {*Application path and filename*}
   AppParameters:String;                {*Application parameters*}
   End;

   TErrorSystem=Record                  {*Errors / Exceptions structure*}
   NError       :Integer;               {*Current Error Id*}
   QttErrors    :Integer;               {*Quantity of errors during session*}
   LastError    :Integer;               {*Last generated error*}
   Level        :Byte;                  {*Error level to intercept*}
   End;

{****************************************************************************}

Var
{A nettoyer, restructurer, dbordliser}
   P_Current    :ShortString;           {*Current mouse pointer*}
   Actual_Pointer:ShortString;          {*Forme du TPointer Actuel*}
{Fin}

   MOS_Errors   :TErrorSystem;          {*The MOS System Errors Manager*}
   T_Clip       :TCoordinates;          {*Window clipping*}

   SbH,SbM,SbS  :Word;                  {*H/M/S pour Screen Blanker*}
   WPMx,WPMy    :Word;                  {*Window mouse position (X,Y)*}
   Syb          :Integer;               {*Standard Y Size for buttons*}
   LaF,HaF      :Byte;                  {*Width and Height for current font*}
   LaF1,HaF1    :Byte;                  {*Width and Height for window title font*}

   MPArrow              :ShortString;   {*Id for Arrow pointer*}
   MPAudio              :ShortString;   {*Id for Piano pointer*}
   MPBusy               :ShortString;   {*Id for Busy pointer*}
   MPDrag               :ShortString;   {*Id for Drag and Drop pointer*}
   MPEyeDrop            :ShortString;   {*Id for Eyedrop pointer*}
   MPForbiden           :ShortString;   {*Id for Forbiden pointer*}
   MPHand               :ShortString;   {*Id for Hand pointer*}
   MPHead               :ShortString;   {*Id for Dead Head pointer*}
   MPHelp               :ShortString;   {*Id for Help pointer*}
   MPHourGlass          :ShortString;   {*Id for Hourglass pointer*}
   MPLetter             :ShortString;   {*Id for Letter pointer*}
   MPMove               :ShortString;   {*Id for Move pointer*}
   MPMoveDown           :ShortString;   {*Id for Move Down pointer*}
   MPMoveLD             :ShortString;   {*Id for Move Left and Down pointer*}
   MPMoveLeft           :ShortString;   {*Id for Move Left pointer*}
   MPMoveLU             :ShortString;   {*Id for Move Left and Up pointer*}
   MPMoveRD             :ShortString;   {*Id for Move Right and Down pointer*}
   MPMoveRight          :ShortString;   {*Id for Move Right pointer*}
   MPMoveRU             :ShortString;   {*Id for Move Right pointer*}
   MPMoveUp             :ShortString;   {*Id for Move Up pointer*}
   MPMoveX              :ShortString;   {*Id for Horizontal move pointer*}
   MPMoveY              :ShortString;   {*Id for Vertical move pointer*}
   MPSizeLR             :ShortString;   {*Id for Size Left and Right pointer*}
   MPSizeLUDR           :ShortString;   {*Id for Size Left Up and Down Right pointer*}
   MPSizeRUDL           :ShortString;   {*Id for Size Right Up and Down Left pointer*}
   MPSizeUD             :ShortString;   {*Id for Size Up Down pointer*}
   MPTarget             :ShortString;   {*Id for Target pointer*}
   MPText               :ShortString;   {*Id for Text pointer*}
   MPWarning            :ShortString;   {*Id for Warning pointer*}

   ID_Sys1      :Word;                  {*Bus pour Systme interne de MOS*} {MIC}
      { Bit Num     Utilisation} {MIC}
      {  0  0001    L'app  t lance sur un support sur lequel on NE PEUT PAS crire !} {MIC}
      {  1  0002    Rpertoire temporaire sur disque  t cr} {MIC}
      {  2  0004    Cannot create process information file} {MIC}
      {  3  0008    Process selection window is oppened} {MIC}
      {  4  0010 :  1 = Image Palette yet defined (Display image in list)} {MIC}
      {  5  0020    .INI not found} {MIC}
      {  6  0040    WD specified by user} {MIC}

   ID_Err1      :Word;                 {*Bus pour Errors et Gestion Errors*} {MIC}
      { Bit Num     Utilisation} {MIC}
      {  0  0001 S  Affichage des Erreurs de MOS} {MIC}
      {  1  0002    Intercept Break / Reset} {MIC}
      {  2  0004    Use Sampled Sound} {MIC}
      {  3  0008    On est dans le CTRL-Break Requester => Stop CTRL-Break} {MIC}
      {  4  0010    On est dans le Reset Requester => Stop Reset} {MIC}
      {  5  0020    On est en train de traiter une Erreur...} {MIC}
      {  6  0040    Impossible de trouver les ".LOC" si le bit est mis...} {MIC}

   ID_Scr1      :Word;                 {*Bus pour Gestion Graphique*} {MIC}
      {  0  0001    Free} {MIC}
      {  1  0002    Free} {MIC}
      {  2  0004 O  Cirrus Logic has been Defined} {MIC}
      {  3  0008    A Window is clipped Somewhere...} {MIC}
      {  4  0010    Free} {MIC}
      {  5  0020    Free} {MIC}
      {  6  0040    Free} {MIC}
      {  7  0080    On est dans un Screen Blanker => Disable SB Mannager} {MIC}

   ID_Msg1      :Word;                 {*Bus de Transfert de Msg Gnraux*} {MIC}
      { Bit Num     Utilisation} {MIC}
      {  0  0001    Menu Vars will be refreshed (SYSTEM Request modified)} {MIC}
      {  1  0002    Current Window will be refreshed (Font Changed)} {MIC}
      {  2  0004    Un Slider est modifi quelque part...} {MIC}
      {  3  0008    Le Pointeur Souris passe now sur un Gadget InputText...} {MIC}
      {  4  0010    Free} {MIC}
      {  5  0020    Pas de Driver Souris en Mmoire...!} {MIC}
      {  6  0040    Free} {MIC}
      {  7  0080    Initialisation File ".INI" not found...} {MIC}
      {  8  0100    No Sound Parameter: Pas de sons dans MOS...} {MIC}
      {  9  0200    MODE: Dmo = Enregistrement Actuel ou Visu d'une Dmo.} {MIC}
      { 10  0400    0=Lecture de la demo       Si le bit 9 est activ} {MIC}
      {             1=Enregistrement de Dmo   Si le bit 9 est activ} {MIC}
      { 11  0800    0=Play WAV on Speaker else on SB} {MIC}
      { 12  1000    Est Appell  partir d'un autre Programme MOS} {MIC}
      { 13  2000    Rseau NOVELL Prsent...} {MIC}
      { 14  4000    Mode Debug...} {MIC}

   ID_Gad1      :Word;                 {*Bus de Transfert de Msg Gadgets*} {MIC}
      {  0  0001    Demande d'activation du prochain gadget InputText} {MIC}
      {  1  0002    Demande d'activation du prcdent gadget InputText} {MIC}
      {  2  0004    Gestion du menu par Clavier = TRUE, FALSE = Souris} {MIC}
      {  3  0008    RMB activ sur fentre prvue pour RMB} {MIC}
      {  4  0010    LMB et RMB inverss. Individus Gaucher} {MIC}
      {  5  0020    Le Pointeur Souris passe sur un gadget Bouton} {MIC}
      {  6  0040    Le Pointeur Souris passe sur un gadget Tabs} {MIC}
      {  7  0080    Il y a un gadget Info Box affich quelque part} {MIC}
      {  8  0100    Le Pointeur Souris passe sur un gadget Taquet} {MIC}
      {  9  0200    Window Moved => Pointeur Souris Move} {MIC}
      { 10  0400    Window Desactived => Pointeur Souris Busy} {MIC}
      { 11  0800    User Pointer => Inactive others Pointers} {MIC}
      { 12  1000    Mouse Pointer over a List Title} {MIC}
      { 13  2000    Le Pointeur Souris passe sur un gadget Cycler} {MIC}
      { 14  4000    Gadget Canvas Activated} {MIC}
      { 15  8000    Free} {MIC}

{*----------------------------- Debut Library ------------------------------*}

IMPLEMENTATION

Uses
     Dos,
     MosBase,
     MosColors,
     MosCPUInstructions,
     MosCrt,
     MosDisks,
     MosMemory,
     MosErrors,
     MosFiles,
     MosStrings,
     MosTime;

{*---------------------------- Keys management -----------------------------*}

{ͻ
                             FUNCTION Ini_Init                              
 ͹
  IN.....: Ini (TInitFile) = Pointer to Ini object.                         
           FName (STRING) = The initialisation file name.                   
  OUT....: (BOOLEAN) = TRUE if opening Ok.                                  
  EXPLAIN: Open for read or write and initialisation file.                  
  SEEALSO: Ini_Done                                                         
 ͼ}

Function Ini_Init(Var Ini:TIniFile; FName:String):Boolean;
Begin
Ini_Init:=No;
If Not File_TestWritable(FName) Then Exit; {*File not accesible !*}

Ini:=TIniFile.Create(FName);
Ini_Init:=Yes;
End;

{ͻ
                             FUNCTION Ini_Done                              
 ͹
  IN.....: Ini (TInitFile) = Pointer to Ini object.                         
  OUT....: (BOOLEAN) = TRUE if validation Ok.                               
  EXPLAIN: Validate modifications or close the Ini file.                    
  SEEALSO: Ini_Init                                                         
 ͼ}

Function Ini_Done(Var Ini:TIniFile):Boolean; {*Validate modifications or close*}
Begin
Ini.Destroy;
Ini_Done:=Yes;
End;

{ͻ
                            FUNCTION Ini_LoadKey                            
 ͹
  IN.....: Ini (TInitFile) = Pointer to Ini object.                         
           Section (STRING) = Section to access ([] are set automatically). 
           Key (STRING) = Key to access.                                    
           Value (LONGINT) = Default key value.                             
  OUT....: (LONGINT) = Returned key value reading from file.                
  EXPLAIN: Get a key from a section in a specified configuration file.      
  SEEALSO: Ini_SaveKey                                                      
 ͼ}

Function Ini_LoadKey(Var Ini:TIniFile; Section,Key:String; Value:Longint):Longint;         {*Get an integer key value*}
Begin
Ini_LoadKey:=Ini.ReadInteger(Section,Key,Value);
End;

{ͻ
                            FUNCTION Ini_LoadKey                            
 ͹
  IN.....: Ini (TInitFile) = Pointer to Ini object.                         
           Section (STRING) = Section to access ([] are set automatically). 
           Key (STRING) = Key to access.                                    
           Value (STRING) = Default key value.                              
  OUT....: (STRING) = Returned key value reading from file.                 
  EXPLAIN: Get a key from a section in a specified configuration file.      
  SEEALSO: Ini_SaveKey                                                      
 ͼ}

Function Ini_LoadKey(Var Ini:TIniFile; Section,Key:String; Value:String):String;          {*Get a string key value*}
Begin
Ini_LoadKey:=Ini.ReadString(Section,Key,Value);
End;

{ͻ
                            FUNCTION Ini_LoadKey                            
 ͹
  IN.....: Ini (TInitFile) = Pointer to Ini object.                         
           Section (STRING) = Section to access ([] are set automatically). 
           Key (STRING) = Key to access.                                    
           Value (BOOLEAN) = Default key value.                             
  OUT....: (BOOLEAN) = Returned key value reading from file.                
  EXPLAIN: Get a key from a section in a specified configuration file.      
  SEEALSO: Ini_SaveKey                                                      
 ͼ}

Function Ini_LoadKey(Var Ini:TIniFile; Section,Key:String; Value:Boolean):Boolean;         {*Get a boolean key value*}
Begin
Ini_LoadKey:=Ini.ReadBool(Section,Key,Value);
End;

{ͻ
                           PROCEDURE Ini_SaveKey                            
 ͹
  IN.....: Ini (TInitFile) = Pointer to Ini object.                         
           Section (STRING) = Section to access ([] are set automatically). 
           Key (STRING) = Key to access.                                    
           Value (LONGINT) = Default key value.                             
  OUT....: /                                                                
  EXPLAIN: Save a key in a section in a specified configuration file.       
  SEEALSO: Ini_LoadKey                                                      
 ͼ}

Procedure Ini_SaveKey(Var Ini:TIniFile; Section,Key:String; Value:Longint);  {*Save an integer key value*}
Begin
Ini.WriteInteger(Section,Key,Value);
End;

{ͻ
                           PROCEDURE Ini_SaveKey                            
 ͹
  IN.....: Ini (TInitFile) = Pointer to Ini object.                         
           Section (STRING) = Section to access ([] are set automatically). 
           Key (STRING) = Key to access.                                    
           Value (STRING) = Default key value.                              
  OUT....: /                                                                
  EXPLAIN: Save a key in a section in a specified configuration file.       
  SEEALSO: Ini_LoadKey                                                      
 ͼ}

Procedure Ini_SaveKey(Var Ini:TIniFile; Section,Key:String; Value:String);   {*Save a string key value*}
Begin
Ini.WriteString(Section,Key,Value);
End;

{ͻ
                           PROCEDURE Ini_SaveKey                            
 ͹
  IN.....: Ini (TInitFile) = Pointer to Ini object.                         
           Section (STRING) = Section to access ([] are set automatically). 
           Key (STRING) = Key to access.                                    
           Value (BOOLEAN) = Default key value.                             
  OUT....: /                                                                
  EXPLAIN: Save a key in a section in a specified configuration file.       
  SEEALSO: Ini_LoadKey                                                      
 ͼ}

Procedure Ini_SaveKey(Var Ini:TIniFile; Section,Key:String; Value:Boolean);  {*Save a boolean key value*}
Begin
Ini.WriteBool(Section,Key,Value);
End;

{ͻ
                           FUNCTION Ini_RemoveKey                           
 ͹
  IN.....: Ini (TInitFile) = Pointer to Ini object.                         
           Section (STRING) = Section to access ([] are set automatically). 
           Key (STRING) = Key to access.                                    
  OUT....: (BOOLEAN) = TRUE if action done without any problems.            
  EXPLAIN: Remove a key from a section in a specified configuration file.   
  SEEALSO: Ini_LoadKey, Ini_SaveKey                                         
 ͼ}

Function Ini_RemoveKey(Var Ini:TIniFile; Section,Key:String):Boolean;
Begin
Ini.DeleteKey(Section,Key);
Ini_RemoveKey:=Yes;
End;

{ͻ
                         FUNCTION Ini_RemoveSection                         
 ͹
  IN.....: Ini (TInitFile) = Pointer to Ini object.                         
           Section (STRING) = Section to access ([] are set automatically). 
  OUT....: (BOOLEAN) = TRUE if action done without any problems.            
  EXPLAIN: Remove a section in a specified configuration file.              
  SEEALSO: Ini_LoadKey, Ini_SaveKey                                         
 ͼ}

Function Ini_RemoveSection(Var Ini:TIniFile; Section:String):Boolean;
Begin
Ini.EraseSection(Section);
Ini_RemoveSection:=Yes;
End;

{ͻ
                           FUNCTION Ini_UpdateKey                           
 ͹
  IN.....: Ini (TInitFile) = Pointer to Ini object.                         
           Section (STRING) = Section to access ([] are set automatically). 
           Key (STRING) = Key to access.                                    
           VIncDec (LONGINT) = Value to add or dec for the key.             
  OUT....: (BOOLEAN) = TRUE if action done without any problems.            
  EXPLAIN: Update a key value for a specified configuration file.           
  NB.....: If the key don't exist or value not defined, the key is created  
           and the value is initialised to the VIncDec value.               
  SEEALSO: Ini_LoadKey, Ini_SaveKey                                         
 ͼ}

Function Ini_UpdateKey(Var Ini:TIniFile; Section,Key:String; VIncDec:Longint):Boolean;
Var Value:Longint;
Begin
Value:=Ini_LoadKey(Ini,Section,Key,0);
Value:=Value+VIncDec;
Ini_SaveKey(Ini,Section,Key,Value);
Ini_UpdateKey:=Yes;
End;

{ͻ
                           FUNCTION Ini_UpdateKey                           
 ͹
  IN.....: FName (STRING) = Initialisation filename.                        
           Section (STRING) = Section to access ([] are set automatically). 
           Key (STRING) = Key to access.                                    
           VIncDec (LONGINT) = Value to add or dec for the key.             
  OUT....: (BOOLEAN) = TRUE if action done without any problems.            
  EXPLAIN: Update a key value for a specified configuration file.           
  NB.....: If the key don't exist or value not defined, the key is created  
           and the value is initialised to the VIncDec value.               
  SEEALSO: Ini_LoadKey, Ini_SaveKey                                         
 ͼ}

Function Ini_UpdateKey(FName:String; Section,Key:String; VIncDec:Longint):Boolean;
Var Ini:TIniFile;
Begin
Ini_UpdateKey:=No;
If Not Ini_Init(Ini,FName) Then Exit;

Ini_UpdateKey(Ini,Section,Key,VIncDec);
Ini_Done(Ini);
Ini_UpdateKey:=Yes;
End;

{ͻ
                            FUNCTION Ini_LoadKey                            
 ͹
  IN.....: FName (STRING) = Initialisation filename.                        
           Section (STRING) = Section to access ([] are set automatically). 
           Key (STRING) = Key to access.                                    
  OUT....: (STRING) = String key value else '' if any problem occurs.       
  EXPLAIN: Load a string key from a specified configuration file.           
  NB.....: If the key don't exist the function return ''.                   
  SEEALSO: Ini_LoadKey, Ini_SaveKey                                         
 ͼ}

Function Ini_LoadKey(FName,Section,Key:String):String;
Var Ini:TIniFile;
Begin
Ini_LoadKey:='';
If Not Ini_Init(Ini,FName) Then Exit;

Ini_LoadKey:=Ini_LoadKey(Ini,Section,Key,'');
Ini_Done(Ini);
End;

{ͻ
                         FUNCTION Ini_CountSections                         
 ͹
  IN.....: FName (STRING) = Path and file name to use.                      
  OUT....: (INTEGER) = Number of sections in file.                          
  EXPLAIN: Count how many sections are in configuration file.               
  SEEALSO: Ini_AddSection, Ini_RemoveSection                                
 ͼ}

Function Ini_CountSections(FName:String):Integer;
Begin
Ini_CountSections:=File_CountString(FName,'[',$0000);
End;

{*--------------------- Configurations files management --------------------*}

{ͻ
                            FUNCTION Load_Config                            
 ͹
  IN.....: FName (STRING) = Name of the Config file to load an initialise.  
  OUT....: (BOOLEAN) = TRUE if OK, FALSE if there is an error               
  EXPLAIN: Load a .INI file of MOS configuration.                           
  SEEALSO: Save_Config                                                      
 ͼ}

Function Load_Config(Name:String):Boolean;
Var Ini:TIniFile;                       {*Object TIniFile*}
    Section,St:String;
    A:Integer;
    Bool:Boolean;
    L:Longint;

Begin
Load_Config:=No;                        {*De Base*}
If Not Ini_Init(Ini,Name) Then Exit;    {*Error*}

If Ini_LoadKey(Ini,'Startup Sequence','Type','')<>'MSTF382I' Then
   Begin                                {*File Error !*}
   Ini_Done(Ini);
   If File_TestString(Name,'Startup-Sequence File',1,$0001)>0 Then
      Begin
      Log.Add('    Old MOS initialisation file format');
      Exit;
      End;
   Log.Add('    Not a MOS initialisation file');
   Exit;
   End;

Section:='Application';
Application.Name     :=Ini_LoadKey(Ini,Section,'Name',Application.Name);
Application.Version  :=Ini_LoadKey(Ini,Section,'Version',Application.Version);
Application.Copyright:=Ini_LoadKey(Ini,Section,'Copyright',Application.Copyright);
Application.Author   :=Ini_LoadKey(Ini,Section,'Creator',Application.Author);
Application.Date     :=Ini_LoadKey(Ini,Section,'Date',Application.Date);

Section:='System';
Sys.GfxMode        :=Ini_LoadKey(Ini,Section,'Graphic mode',Sys.GfxMode);
Sys.BootImage      :=Ini_LoadKey(Ini,Section,'Boot image',Sys.BootImage);
Sys.DesktopImage   :=Ini_LoadKey(Ini,Section,'Desktop image',Sys.DesktopImage);
l:=Ini_LoadKey(Ini,Section,'Desktop style',l);
Sys.DesktopStyle   :=TDesktopStyle(l);
l:=Ini_LoadKey(Ini,Section,'Desktop display style',l);
Sys.DesktopDisplayStyle:=TDisplayPosition(l);
Sys.DesktopPattern :=Ini_LoadKey(Ini,Section,'Desktop pattern',Sys.DesktopPattern);
Sys.WindowImage    :=Ini_LoadKey(Ini,Section,'Window image',Sys.WindowImage);
Sys.WindowBgStyle  :=Ini_LoadKey(Ini,Section,'Window background style',Sys.WindowBgStyle);
Sys.WindowBgPattern:=Ini_LoadKey(Ini,Section,'Window background pattern',Sys.WindowBgPattern);
Sys.Directory      :=Ini_LoadKey(Ini,Section,'Directory',Sys.Directory);
Sys.Directory:=Dsk_ValideDirectory(Sys.Directory);

Section:='Locale';
Language.Code := Ini_LoadKey(Ini,Section,'Language',Language.Code);

Section:='Mouse';
Sys.SetMouseBlanker   :=Ini_LoadKey(Ini,Section,'Blanker',Sys.SetMouseBlanker);
Sys.MouseDblClickDelay:=Ini_LoadKey(Ini,Section,'Doubleclick delay',Sys.MouseDblClickDelay);
Sys.MouseClickDelay   :=Ini_LoadKey(Ini,Section,'Click delay',Sys.MouseClickDelay);
Sys.MouseSpeed        :=Ini_LoadKey(Ini,Section,'Speed',Sys.MouseSpeed);
Bool                  :=Ini_LoadKey(Ini,Section,'Exchange buttons',BTST(Id_Gad1,4));
If Bool Then BSET(Id_Gad1,4) Else BCLR(Id_Gad1,4);

Section:='Pointers';
MPArrow    :=Ini_LoadKey(Ini,Section,'Arrow',MPArrow);
MPBusy     :=Ini_LoadKey(Ini,Section,'Busy',MPBusy);
MPDrag     :=Ini_LoadKey(Ini,Section,'Drag',MPDrag);
MPEyeDrop  :=Ini_LoadKey(Ini,Section,'EyeDrop',MPEyeDrop);
MPForbiden :=Ini_LoadKey(Ini,Section,'Forbiden',MPForbiden);
MPHand     :=Ini_LoadKey(Ini,Section,'Hand',MPHand);
MPHead     :=Ini_LoadKey(Ini,Section,'Head',MPHead);
MPHelp     :=Ini_LoadKey(Ini,Section,'Help',MPHelp);
MPHourGlass:=Ini_LoadKey(Ini,Section,'HourGlass',MPHourGlass);
MPLetter   :=Ini_LoadKey(Ini,Section,'Letter',MPLetter);
MPMove     :=Ini_LoadKey(Ini,Section,'Move',MPMove);
MPMoveDown :=Ini_LoadKey(Ini,Section,'MoveDown',MPMoveDown);
MPMoveLD   :=Ini_LoadKey(Ini,Section,'MoveLeftDown',MPMoveLD);
MPMoveLeft :=Ini_LoadKey(Ini,Section,'MoveLeft',MPMoveLeft);
MPMoveLU   :=Ini_LoadKey(Ini,Section,'MoveLeftUp',MPMoveLU);
MPMoveRD   :=Ini_LoadKey(Ini,Section,'MoveRightDown',MPMoveRD);
MPMoveRight:=Ini_LoadKey(Ini,Section,'MoveRight',MPMoveRight);
MPMoveRU   :=Ini_LoadKey(Ini,Section,'MoveRightUp',MPMoveRU);
MPMoveUp   :=Ini_LoadKey(Ini,Section,'MoveUp',MPMoveUp);
MPMoveX    :=Ini_LoadKey(Ini,Section,'MoveHorizontal',MPMoveX);
MPMoveY    :=Ini_LoadKey(Ini,Section,'MoveVertical',MPMoveY);
MPAudio    :=Ini_LoadKey(Ini,Section,'CDAudio',MPAudio);
MPSizeLR   :=Ini_LoadKey(Ini,Section,'SizeLeftRight',MPSizeLR);
MPSizeLUDR :=Ini_LoadKey(Ini,Section,'SizeLeftUpDownRight',MPSizeLUDR);
MPSizeRUDL :=Ini_LoadKey(Ini,Section,'SizeRightUpDownLeft',MPSizeRUDL);
MPSizeUD   :=Ini_LoadKey(Ini,Section,'SizeUpDown',MPSizeUD);
MPTarget   :=Ini_LoadKey(Ini,Section,'Target',MPTarget);
MPText     :=Ini_LoadKey(Ini,Section,'Text',MPText);
MPWarning  :=Ini_LoadKey(Ini,Section,'Warning',MPWarning);
P_Current  :=MPArrow;

Section:='Blankers';
Sys.ScreenBlanker     :=Ini_LoadKey(Ini,Section,'Screen blanker',Sys.ScreenBlanker);
Sys.ScreenBlankerDelay:=Ini_LoadKey(Ini,Section,'Screen blanker delay',Sys.ScreenBlankerDelay);

Section:='Keyboard';
Sys.CursorBlinkSpeed:=Ini_LoadKey(Ini,Section,'Cursor blink',Sys.CursorBlinkSpeed);
Sys.CursorShape     :=Ini_LoadKey(Ini,Section,'Cursor type',Sys.CursorShape);
Sys.SpeedKeyRate    :=Ini_LoadKey(Ini,Section,'Key rate',Sys.SpeedKeyRate);
Sys.SpeedKeyDelay   :=Ini_LoadKey(Ini,Section,'Key delay',Sys.SpeedKeyDelay);

Section:='Fonts';
St:=Ini_LoadKey(Ini,Section,'Main',Sys.FontMain+','+Str_L2S(Sys.FontMainSize));
Sys.FontMain:=Str_Get(St,1,','); Sys.FontMainSize:=Str_S2L(Str_Get(St,2,','));
St:=Ini_LoadKey(Ini,Section,'Win title',Sys.FontWinTitle+','+Str_L2S(Sys.FontWinTitleSize));
Sys.FontWinTitle:=Str_Get(St,1,','); Sys.FontWinTitleSize:=Str_S2L(Str_Get(St,2,','));
St:=Ini_LoadKey(Ini,Section,'Menu',Sys.FontMenu+','+Str_L2S(Sys.FontMenuSize));
Sys.FontMenu:=Str_Get(St,1,','); Sys.FontMenuSize:=Str_S2L(Str_Get(St,2,','));
St:=Ini_LoadKey(Ini,Section,'Hint',Sys.FontHint+','+Str_L2S(Sys.FontHintSize));
Sys.FontHint:=Str_Get(St,1,','); Sys.FontHintSize:=Str_S2L(Str_Get(St,2,','));

Section:='Miscellaneous';
Sys.TimeSeparator  :=Ini_LoadKey(Ini,Section,'Time separator',Sys.TimeSeparator);
Sys.TimeBelt       :=Ini_LoadKey(Ini,Section,'Time belt',Sys.TimeBelt);
Sys.LightBoxMinSize:=Ini_LoadKey(Ini,Section,'Box min size',Sys.LightBoxMinSize);
Sys.SetGrid        :=Ini_LoadKey(Ini,Section,'Enable grid',Sys.SetGrid);
St                 :=Ini_LoadKey(Ini,Section,'Grid steps',Str_L2S(Sys.GridStepX)+','+Str_L2S(Sys.GridStepY));
Sys.GridStepX:=Str_S2L(Str_Get(St,1,',')); Sys.GridStepY:=Str_S2L(Str_Get(St,2,','));
Sys.DisplayHints   :=Ini_LoadKey(Ini,Section,'Display hints',Sys.DisplayHints);
Bool               :=Ini_LoadKey(Ini,Section,'Hook exceptions',BTST(Id_Err1,1));
If Bool Then BSET(Id_Err1,1) Else BCLR(Id_Err1,1);
Bool               :=Ini_LoadKey(Ini,Section,'Use sampled sound',BTST(Id_Err1,2));
If Bool Then BSET(Id_Err1,2) Else BCLR(Id_Err1,2);
Sys.Tag            :=Ini_LoadKey(Ini,Section,'Tag',Sys.Tag);

Section:='Sounds';
Sys.AudioSBVolume:=Ini_LoadKey(Ini,Section,'Volume SB',Sys.AudioSBVolume);
Sys.AudioCDVolume:=Ini_LoadKey(Ini,Section,'Volume CD',Sys.AudioCDVolume);

Section:='Sound actions';
For A:=1 to Max_AS do                   {*Sounds When Actions*}
   Sys.SoundFile[A] :=Ini_LoadKey(Ini,Section,'Sound '+Str_L2S(A),Sys.SoundFile[A]);

Section:='Security';
Sys.AskForBootPwd   :=Ini_LoadKey(Ini,Section,'Use password',Sys.AskForBootPwd);
Sys.BootPwdTestCount:=Ini_LoadKey(Ini,Section,'Try count',Sys.BootPwdTestCount);
Sys.BootPwd         :=Ini_LoadKey(Ini,Section,'Password',Sys.BootPwd);

Section:='Networks';
Sys.NetLoginName    :=Ini_LoadKey(Ini,Section,'User name',Sys.NetLoginName);
Sys.NetEnableNetMsg :=Ini_LoadKey(Ini,Section,'Enable system messages',Sys.NetEnableNetMsg);
Sys.NetEnableUserMsg:=Ini_LoadKey(Ini,Section,'Enable user messages',Sys.NetEnableUserMsg);
Sys.NetSignMsg      :=Ini_LoadKey(Ini,Section,'Sign messages',Sys.NetSignMsg);
Sys.NetDisplayLogin :=Ini_LoadKey(Ini,Section,'Login at boot',Sys.NetDisplayLogin);

Section:='Skins';
Sys.ImgCheckYes      :=Ini_LoadKey(Ini,Section,'Check tagged',Sys.ImgCheckYes);
Sys.ImgCheckNo       :=Ini_LoadKey(Ini,Section,'Check untagged',Sys.ImgCheckNo);
Sys.ImgRadioYes      :=Ini_LoadKey(Ini,Section,'Radio tagged',Sys.ImgRadioYes);
Sys.ImgRadioNo       :=Ini_LoadKey(Ini,Section,'Radio untagged',Sys.ImgRadioNo);
Sys.ImgCycler        :=Ini_LoadKey(Ini,Section,'Cycler',Sys.ImgCycler);
Sys.ImgBevel         :=Ini_LoadKey(Ini,Section,'Bevel title',Sys.ImgBevel);
Sys.ImgError         :=Ini_LoadKey(Ini,Section,'Image error',Sys.ImgError);
Sys.ImgBomb          :=Ini_LoadKey(Ini,Section,'Dialog bomb',Sys.ImgBomb);
Sys.ImgInformation   :=Ini_LoadKey(Ini,Section,'Dialog information',Sys.ImgInformation);
Sys.ImgQuestion      :=Ini_LoadKey(Ini,Section,'Dialog question',Sys.ImgQuestion);
Sys.ImgStop          :=Ini_LoadKey(Ini,Section,'Dialog stop',Sys.ImgStop);
Sys.ImgWarning       :=Ini_LoadKey(Ini,Section,'Dialog warning',Sys.ImgWarning);
Sys.ImgSliderUpNo    :=Ini_LoadKey(Ini,Section,'Slider up',Sys.ImgSliderUpNo);
Sys.ImgSliderUpYes   :=Ini_LoadKey(Ini,Section,'Slider up pressed',Sys.ImgSliderUpYes);
Sys.ImgSliderDownNo  :=Ini_LoadKey(Ini,Section,'Slider down',Sys.ImgSliderDownNo);
Sys.ImgSliderDownYes :=Ini_LoadKey(Ini,Section,'Slider down pressed',Sys.ImgSliderDownYes);
Sys.ImgSliderLeftNo  :=Ini_LoadKey(Ini,Section,'Slider left',Sys.ImgSliderLeftNo);
Sys.ImgSliderLeftYes :=Ini_LoadKey(Ini,Section,'Slider left pressed',Sys.ImgSliderLeftYes);
Sys.ImgSliderRightNo :=Ini_LoadKey(Ini,Section,'Slider right',Sys.ImgSliderRightNo);
Sys.ImgSliderRightYes:=Ini_LoadKey(Ini,Section,'Slider right pressed',Sys.ImgSliderRightYes);

Ini_Done(Ini);

Sys.SystemFound := Sys.TestDefined;

//Col_LoadPalette(Name);                   {*Load palette colors*}

//Else Error(531);                         {*Config Program non Trouve*}

Result := Yes;                          {*Fichier de Conf Correctement Lu*}
End;

{ͻ
                            FUNCTION Save_Config                            
 ͹
  IN.....: Name (STRING) = Path + Name of the file to save.                 
  OUT....: (BOOLEAN) = TRUE if OK, FALSE if there is an error               
  EXPLAIN: Save the configuration (parameters) of MOS or another program.   
 ͼ}

Function Save_Config(Name:String):Boolean;
Var Ini:TIniFile;                       {*Object TIniFile*}
    Section:String;
    A:Integer;

Begin
Save_Config:=No;                        {*De Base...*}
If Name='' Then Exit;
If Not Dsk_TestWritableDrive(Copy(Dsk_GetHome,1,1)) Then
   Begin Error(534); Exit; End;         {*Support CDRom ou Autre*}

If Not Ini_Init(Ini,Name) Then Exit;    {*Exit*}

Section:='Startup Sequence';
Ini_SaveKey(Ini,Section,'Type','MSTF382I');
Ini_SaveKey(Ini,Section, Application.MOSName, Application.MOSVersion);

Section:='Application';
Ini_SaveKey(Ini,Section,'Name',Application.Name);
Ini_SaveKey(Ini,Section,'Version',Application.Version);
Ini_SaveKey(Ini,Section,'Copyright',Application.Copyright);
Ini_SaveKey(Ini,Section,'Creator',Application.Author);
Ini_SaveKey(Ini,Section,'Date',Application.Date);

Section:='System';
Ini_SaveKey(Ini,Section,'Graphic mode',Sys.GfxMode);
Ini_SaveKey(Ini,Section,'Boot image',Sys.BootImage);
Ini_SaveKey(Ini,Section,'Desktop image',Sys.DesktopImage);
Ini_SaveKey(Ini,Section,'Desktop style',longint(Sys.DesktopStyle));
Ini_SaveKey(Ini,Section,'Desktop display style',longint(Sys.DesktopDisplayStyle));
Ini_SaveKey(Ini,Section,'Desktop pattern',Sys.DesktopPattern);
Ini_SaveKey(Ini,Section,'Window image',Sys.WindowImage);
Ini_SaveKey(Ini,Section,'Window background style',Sys.WindowBgStyle);
Ini_SaveKey(Ini,Section,'Window background pattern',Sys.WindowBgPattern);
Ini_SaveKey(Ini,Section,'Directory',Sys.Directory);

Section:='Locale';
Ini_SaveKey(Ini,Section,'Language',Language.Code);
{For A:=1 to Max_LocaleFile do
   Ini_SaveKey(Ini,Section,'Locale file '+Str_L2S(A),Sys.LocaleFile[A]);}

Section:='Mouse';
Ini_SaveKey(Ini,Section,'Blanker',Sys.SetMouseBlanker);
Ini_SaveKey(Ini,Section,'Doubleclick delay',Sys.MouseDblClickDelay);
Ini_SaveKey(Ini,Section,'Click delay',Sys.MouseClickDelay);
Ini_SaveKey(Ini,Section,'Speed',Sys.MouseSpeed);
Ini_SaveKey(Ini,Section,'Exchange buttons',BTST(Id_Gad1,4));

Section:='Pointers';
Ini_SaveKey(Ini,Section,'Arrow',MPArrow);
Ini_SaveKey(Ini,Section,'Busy',MPBusy);
Ini_SaveKey(Ini,Section,'Drag',MPDrag);
Ini_SaveKey(Ini,Section,'EyeDrop',MPEyeDrop);
Ini_SaveKey(Ini,Section,'Forbiden',MPForbiden);
Ini_SaveKey(Ini,Section,'Hand',MPHand);
Ini_SaveKey(Ini,Section,'Head',MPHead);
Ini_SaveKey(Ini,Section,'Help',MPHelp);
Ini_SaveKey(Ini,Section,'HourGlass',MPHourGlass);
Ini_SaveKey(Ini,Section,'Letter',MPLetter);
Ini_SaveKey(Ini,Section,'Move',MPMove);
Ini_SaveKey(Ini,Section,'MoveDown',MPMoveDown);
Ini_SaveKey(Ini,Section,'MoveLeftDown',MPMoveLD);
Ini_SaveKey(Ini,Section,'MoveLeft',MPMoveLeft);
Ini_SaveKey(Ini,Section,'MoveLeftUp',MPMoveLU);
Ini_SaveKey(Ini,Section,'MoveRightDown',MPMoveRD);
Ini_SaveKey(Ini,Section,'MoveRight',MPMoveRight);
Ini_SaveKey(Ini,Section,'MoveRightUp',MPMoveRU);
Ini_SaveKey(Ini,Section,'MoveUp',MPMoveUp);
Ini_SaveKey(Ini,Section,'MoveHorizontal',MPMoveX);
Ini_SaveKey(Ini,Section,'MoveVertical',MPMoveY);
Ini_SaveKey(Ini,Section,'CDAudio',MPAudio);
Ini_SaveKey(Ini,Section,'SizeLeftRight',MPSizeLR);
Ini_SaveKey(Ini,Section,'SizeLeftUpDownRight',MPSizeLUDR);
Ini_SaveKey(Ini,Section,'SizeRightUpDownLeft',MPSizeRUDL);
Ini_SaveKey(Ini,Section,'SizeUpDown',MPSizeUD);
Ini_SaveKey(Ini,Section,'Target',MPTarget);
Ini_SaveKey(Ini,Section,'Text',MPText);
Ini_SaveKey(Ini,Section,'Warning',MPWarning);

Section:='Blankers';
Ini_SaveKey(Ini,Section,'Screen blanker',Sys.ScreenBlanker);
Ini_SaveKey(Ini,Section,'Screen blanker delay',Sys.ScreenBlankerDelay);

Section:='Keyboard';
Ini_SaveKey(Ini,Section,'Cursor blink',Sys.CursorBlinkSpeed);
Ini_SaveKey(Ini,Section,'Cursor type',Sys.CursorShape);
Ini_SaveKey(Ini,Section,'Key rate',Sys.SpeedKeyRate);
Ini_SaveKey(Ini,Section,'Key delay',Sys.SpeedKeyDelay);

Section:='Fonts';
Ini_SaveKey(Ini,Section,'Main',Sys.FontMain+','+Str_L2S(Sys.FontMainSize));
Ini_SaveKey(Ini,Section,'Win title',Sys.FontWinTitle+','+Str_L2S(Sys.FontWinTitleSize));
Ini_SaveKey(Ini,Section,'Menu',Sys.FontMenu+','+Str_L2S(Sys.FontMenuSize));
Ini_SaveKey(Ini,Section,'Hint',Sys.FontHint+','+Str_L2S(Sys.FontHintSize));

Section:='Miscellaneous';
Ini_SaveKey(Ini,Section,'Time separator',Sys.TimeSeparator);
Ini_SaveKey(Ini,Section,'Time belt',Sys.TimeBelt);
Ini_SaveKey(Ini,Section,'Box min size',Sys.LightBoxMinSize);
Ini_SaveKey(Ini,Section,'Enable grid',Sys.SetGrid);
Ini_SaveKey(Ini,Section,'Grid steps',Str_L2S(Sys.GridStepX)+','+Str_L2S(Sys.GridStepY));
Ini_SaveKey(Ini,Section,'Display hints',Sys.DisplayHints);
Ini_SaveKey(Ini,Section,'Hook exceptions',BTST(Id_Err1,1));
Ini_SaveKey(Ini,Section,'Use sampled sound',BTST(Id_Err1,2));
Ini_SaveKey(Ini,Section,'Tag',Sys.Tag);

Section:='Sounds';
Ini_SaveKey(Ini,Section,'Volume SB',Sys.AudioSBVolume);
Ini_SaveKey(Ini,Section,'Volume CD',Sys.AudioCDVolume);

Section:='Sound actions';
For A:=1 to Max_AS do                   {*Sounds When Actions*}
   Ini_SaveKey(Ini,Section,'Sound '+Str_L2S(A),Sys.SoundFile[A]);

Section:='Security';
Ini_SaveKey(Ini,Section,'Use password',Sys.AskForBootPwd);
Ini_SaveKey(Ini,Section,'Try count',Sys.BootPwdTestCount);
Ini_SaveKey(Ini,Section,'Password',Sys.BootPwd);

Section:='Networks';
Ini_SaveKey(Ini,Section,'User name',Sys.NetLoginName);
Ini_SaveKey(Ini,Section,'Enable system messages',Sys.NetEnableNetMsg);
Ini_SaveKey(Ini,Section,'Enable user messages',Sys.NetEnableUserMsg);
Ini_SaveKey(Ini,Section,'Sign messages',Sys.NetSignMsg);
Ini_SaveKey(Ini,Section,'Login at boot',Sys.NetDisplayLogin);

Section:='Skins';
Ini_SaveKey(Ini,Section,'Check tagged',Sys.ImgCheckYes);
Ini_SaveKey(Ini,Section,'Check untagged',Sys.ImgCheckNo);
Ini_SaveKey(Ini,Section,'Radio tagged',Sys.ImgRadioYes);
Ini_SaveKey(Ini,Section,'Radio untagged',Sys.ImgRadioNo);
Ini_SaveKey(Ini,Section,'Cycler',Sys.ImgCycler);
Ini_SaveKey(Ini,Section,'Bevel title',Sys.ImgBevel);
Ini_SaveKey(Ini,Section,'Image error',Sys.ImgError);
Ini_SaveKey(Ini,Section,'Dialog bomb',Sys.ImgBomb);
Ini_SaveKey(Ini,Section,'Dialog information',Sys.ImgInformation);
Ini_SaveKey(Ini,Section,'Dialog question',Sys.ImgQuestion);
Ini_SaveKey(Ini,Section,'Dialog stop',Sys.ImgStop);
Ini_SaveKey(Ini,Section,'Dialog warning',Sys.ImgWarning);
Ini_SaveKey(Ini,Section,'Slider up',Sys.ImgSliderUpNo);
Ini_SaveKey(Ini,Section,'Slider up pressed',Sys.ImgSliderUpYes);
Ini_SaveKey(Ini,Section,'Slider down',Sys.ImgSliderDownNo);
Ini_SaveKey(Ini,Section,'Slider down pressed',Sys.ImgSliderDownYes);
Ini_SaveKey(Ini,Section,'Slider left',Sys.ImgSliderLeftNo);
Ini_SaveKey(Ini,Section,'Slider left pressed',Sys.ImgSliderLeftYes);
Ini_SaveKey(Ini,Section,'Slider right',Sys.ImgSliderRightNo);
Ini_SaveKey(Ini,Section,'Slider right pressed',Sys.ImgSliderRightYes);

Col_SavePalette(Name);                  {*Save palette colors*}

Ini_Done(Ini);
Save_Config:=True;                      {*Fichier de Conf Sauv OK*}
//   Else Error(531);
End;

{*----------------------------- Log management -----------------------------*}

{****************************************************************************}
{*** TLogFile Class                                                       ***}
{****************************************************************************}

Constructor TLogFile.Create(pFileName:String);
Begin
Inherited Create;

fFileName := pFileName;
fLevel    := 1;                         {*Level 1*}
fCount    := 0;
End;

Function TLogFile.Erase:Boolean;
Begin
Result := File_Erase(fFileName);
fCount := 0;
End;

Function TLogFile.Add(Line:String):Boolean;
Begin
Result := AddLineLevel(Line, fLevel);
End;

Function TLogFile.Add(Line:String; pLevel:Byte):Boolean;
Begin
Result := AddLineLevel(Line, pLevel);
End;

Function TLogFile.AddLine(Line:String):Boolean;
Var St1:String;
Begin
If Pos('---',Line) = 0 Then
   Begin
   If Not Assigned(Application) Then    {*Application not yet created*}
      Begin
      Line:='(B) ' + Line;
      End
   Else
      Case Application.State of         {*Add state program code*}
         ASBoot:  Line:='(B) ' + Line;
         ASRun:   Line:='(R) ' + Line;
         ASClose: Line:='(E) ' + Line;
            Else  Line:='(B) ' + Line;
         End;
   End;

If fLevel > 0 Then
   Begin                                {*Append in Log file*}
   St1 := Str_DelSub(Time_GetSTime(1),':');
   File_AppendString(fFileName,'['+St1+'] '+Line);
   Inc(fCount);
   Result := Yes;
   End
   Else Result := No;                   {*Not added in Log file*}
End;

Function TLogFile.AddLineLevel(Line:String; pLevel:Byte):Boolean;
Begin
If pLevel > fLevel Then Exit;           {*Not the right level*}

AddLineLevel := AddLine(Line);

(*If (Sys.DoLog>0) And (Sys.LogFileBackup='') And (Sys.SystemFound) Then
   Begin
   Sys.LogFileBackup := Sys.GetPath(SP_LOG)+File_StrSplit(Get_AppName,$0007)+'.LOG';
   Log.Create(Sys.LogFileBackup);
   End;
If Sys.LogFileBackup <> '' Then AddLineLevel := AddLine({Sys.LogFileBackup,}Line);*)
End;

{****************************************************************************}
{*** TLanguage Class                                                      ***}
{****************************************************************************}

Constructor TLanguage.Create;
Begin
Inherited Create;

fCode        := '';                     {*Define English as default*}
fLoaded      := No;                     {*Currently not loaded*}
fDefaultText := '?';                    {*Text to set if line not defined*}
End;

Procedure TLanguage.SetLanguage(LanId:String);
Begin
If LanId = fCode Then Exit;
fCode := LanId;

RemoveLanguage;                         {*Remove current language*}
LoadLanguage;                           {*Load new language*}
End;

Function TLanguage.Loc(Index:Longint):String;
Begin
If Index > Count - 1 Then Result := fDefaultText
                     Else Result := Copy(Strings[Index], 6, 255);
End;

Procedure TLanguage.SetLoc(Index:Longint; Phrase:String);
Begin
Strings[Index] := Str_FillZero(Index,4) + ' '+ Phrase;
End;

Function TLanguage.GetFreeLoc:Longint;
Var Loop             :Longint;
Begin
For Loop := 0 to Count - 1 do
   Begin
   If Loc(Loop) = fDefaultText Then
      Begin
      Result := Loop;                   {*Found free place*}
      Exit;
      End;
   End;
Result := -1;                           {*Not found !*}
End;

Function TLanguage.AddLoc(Phrase:String):Longint;
Var Index            :Longint;
Begin
Index := GetFreeLoc;                    {*Get the first free line*}
If Index >= 0 Then
   Begin                                {*Free line found*}
   SetLoc(Index, Phrase);
   Result := Index;
   End
Else
   Begin                                {*Create new line*}
   Add('');
   SetLoc(Count-1, Phrase);
   Result := Count-1;
   End;
End;

Procedure TLanguage.LoadFromFile(Const pFileName:String);
Var Fil1             :TextFile;
    Loop             :Longint;
    St               :String;
    NewLabel         :String;
    Index            :Longint;
    Pn               :Longint;
    CodeTest         :Word;

Begin
AssignText(Fil1,pFileName);

fFileLines := 0;                        {*Zero lines loaded*}

Try
   Reset(Fil1);
Except
   Exit;
End;

While Not Eof(Fil1) do
   Begin
   Readln(Fil1,St);                     {*Read new line from file*}
   fFileLines := fFileLines + 1;        {*Inc line count*}

   Pn := Pos(' ',Copy(St,3,255))+1;
   Val(Copy(St,1,Pn), Index, CodeTest); {*Looking for index label*}
   NewLabel := Str_FillZero(Index,4) +' '+ Copy(St,Pn+2,256);

   If (Index>0) And (CodeTest=0) And (Pn>1) Then
      Begin
      If Count - 1 < Index Then         {*Must add blank lines to complete*}
         Begin
         For Loop := Count to Index do
            Begin
            Add(Str_FillZero(Loop,4) + ' '+ fDefaultText);
            End;
         End;
{      If Index = 1 Then
         Begin
         Writeln(NewLabel);
         Writeln('Count = ',Count);
         Writeln('Lines = ',Lines);
         Readkey;
         End;}
      Strings[Index] := NewLabel;       {*Index is in ranges*}
      End                               {*End "Index > 0"*}
   End;                                 {*End "While Not Eof"*}
End;

Procedure TLanguage.SaveLanguage;
Begin
SaveToFile(FileName);
End;

Procedure TLanguage.LoadLanguage;
Var MyFile           :String;

Begin
MyFile := Sys.GetPath(SP_DATAS) + Filename;
If File_TestExist(MyFile) Then LoadFromFile(MyFile);
If Count > 0 Then fLoaded := Yes;
End;

Procedure TLanguage.RemoveLanguage;
Var Loop             :Longint;
Begin
For Loop := 0 to Count - 1 do
   Begin
   Delete(0);
   End;
fLoaded := No;
fFileLines := 0;                        {*Zero lines loaded*}
End;

Function TLanguage.GetFileName:String;
Begin
Result := Locale.GetLocaleFile(fCode);
End;

Function TLanguage.GetErrorName:String;
Begin
Result := Locale.GetErrorFile(fCode);
End;

Procedure TLanguage.SetDefaultText(D:String);
Begin
If D = fDefaultText Then Exit;
fDefaultText := D;
{Add code to replace default text}
End;

Function TLanguage.GetCountFree:Longint;
Var Loop             :Longint;
    Qtt              :Longint;

Begin
Qtt := 0;
For Loop := 0 to Count - 1 do
   Begin
   If Loc(Loop) = fDefaultText Then Inc(Qtt);
   End;
Result := Qtt;
End;

{****************************************************************************}
{*** TLocale Class                                                        ***}
{****************************************************************************}

Function TLocale.GetIndex(IdLan:String):Longint;
Var Loop             :Integer;
    St               :String;

Begin
For Loop := 0 to Count - 1 do
   Begin
   St := Strings[Loop];
   If Str_Get(St,1,';') = IdLan Then
      Begin
      Result := Loop;
      Exit;
      End;
   End;
Result := -1;
End;

Function TLocale.GetLocaleFile(IdLan:String):String;
Var Index            :Longint;
Begin
Result := '';
Index := GetIndex(IdLan);
If Index < 0 Then Exit;
Result := Str_Get(Strings[Index],2,';')
End;

Function TLocale.GetErrorFile(IdLan:String):String;
Var Index            :Longint;
    St               :String;
Begin
Result := '';
Index := GetIndex(IdLan);
If Index < 0 Then Exit;
St := Str_Get(Strings[Index],2,';');
Result := File_StrSplit(St,$0004)+'.ERR';
End;

Function TLocale.GetAppLocaleFile(IdLan:String):String;
Begin
Result := File_StrSplit(Application.ExeName, $0004) + '.' + IdLan;
End;

Procedure TLocale.SetLocaleFile(IdLan, FileName:String);
Var Index            :Longint;
Begin
Index := GetIndex(IdLan);
If Index < 0 Then Exit;
Str_Put(Strings[Index], FileName, 2, ';')
End;
(*
function TSystem.GetSoundFile(Index: Integer): ShortString;
begin
  Result := fSoundFile[Index];
end;

procedure TSystem.SetSoundFile(Index: Integer; AValue: ShortString);
begin
  if fSoundFile[Index] <> AValue then fSoundFile[Index] := AValue;
end;
*)
{****************************************************************************}
{*** TSystem Class                                                        ***}
{****************************************************************************}
(*
function TSystem.GetSoundFile(Index: Integer): ShortString;
begin
  Result := fSoundFile[Index];
end;

procedure TSystem.SetSoundFile(Index: Integer; AValue: ShortString);
begin
  if fSoundFile[Index] <> AValue then fSoundFile[Index] := AValue;
end;
*)
function TSystem.GetWinCurrentCoord: TCoordinates;
begin
  Result := fWinCurrentCoord;
end;

procedure TSystem.SetWinCurrentCoord(value: TCoordinates);
begin
  fWinCurrentCoord := value;
end;

constructor TSystem.Create;
Var A                :Integer;          {*For loops*}

Begin
Inherited Create;

fSetMouseBlanker:=FALSE;              {*Mouse Blanker Off*}
fScreenBlanker:='(NONE)';             {*Screen Blanker Off*}
fScreenBlankerDelay:=4;               {*4 Minutes de Delais pour le Sys.ScreenBlanker*}
fScreenVisible:=Yes;                  {*Etat de l'cran On=Affich*}
fTimeSeparator:=1;                    {*Time Separator = ":"*}
fMouseDblClickDelay:=25;              {*Definition Double Click*}
fMouseClickDelay:=50;                 {*Definition Mouse Delay*}
fMouseSpeed:=8;                       {*Vitesse Souris*}
fCursorBlinkSpeed:=20;                {*Vitesse Clignotement Curseur*}
fCursorShape:=1;                      {*Type de Curseur (Forme)*}
fSpeedKeyRate:=32;                    {*Speed Key Rate=32*}
fSpeedKeyDelay:=1;                    {*Speed Key Delay=1*}
fLightBoxActivated:=False;            {*Light-Box non Initialise*}
fDisplayHints:=Yes;                   {*Display all Hints*}
fRadioId:=$0;                         {*Bits pour Gestion Multiple Radio*}
fRadioBoxGroup:=0;                    {*Radio Box Demandeur Group...*}
fLightBoxMinSize:=10;                 {*Size Minimale du Light-Box*}
fSetGrid:=False;                      {*Pas de Grille*}
fGridStepX:=10;  fGridStepY:=5;        {*Offsets Grille*}
fInitialMemory:=MemAvail;             {*Keep Initial Memory Size*}
If fInitialMemory<64*1024 Then
   Begin
   { Error(519);} {*Pas assez de mmoire normale*}
   End;
fWinOpenCount:=0;                     {*Pas de Fentres pour l'instant*}
fWinMoved:=False;                     {*Pas de Fentre Bouge*}
fWinSized:=False;                     {*Pas de Fentre Size*}
fWinToSwap:=0;                        {*Pas de Fentre Swape*}
fRefreshScreen:=0;                    {*No refresh needed*}

fSlidersActivated:=0;                 {*No slider has been activated*}
fButtonsActivated:=0;                 {*No buttons has been activated*}

fWinFirstToSwap:=0;                   {*Interne.Pas de 1ere Window Swappe*}
fWinInnerFlag:=False;                 {*Interne. Multiusages*}
fCommandCount:=0;                     {*Nombre de "Commands" 0 de Base*}
fCommandSearchPos:=0;                 {*Compteur Search "Command" = 0*}
fWinActionType:=0;                    {*Pas de Fentre Modifies*}
fWinInactiveCol1:=8026746;            {*Windows inactive colors*}
fWinInactiveCol2:=11316396;
fWinActiveCol1  :=2918604;            {*Windows active colors*}
fWinActiveCol2  :=5566716;
fPanelShadeCol1 :=9727963;
fPanelShadeCol2 :=8436965;

fGfxMode:=12;                         {*Set Mode Graphique No X*}
fOldGfxMode:=fGfxMode;                {*Est gal au Mode Graphique Initial*}

fImgCheckYes          :='Bsm_chkt.bmp'; {*Components design images*}
fImgCheckNo           :='Bsm_chkn.bmp';
fImgRadioYes          :='Bsm_radt.bmp';
fImgRadioNo           :='Bsm_radn.bmp';
fImgCycler            :='Bsm_cycl.bmp';
fImgBevel             :='Bsm_beve.bmp';
fImgError             :='Bsm_erro.bmp';
fImgBomb              :='Bsm_bomb.bmp';
fImgInformation       :='Bsm_info.bmp';
fImgQuestion          :='Bsm_ques.bmp';
fImgStop              :='Bsm_stop.bmp';
fImgWarning           :='Bsm_warn.bmp';
fImgSliderUpNo        :='BSM_SLUN.BMP';
fImgSliderUpYes       :='BSM_SLUT.BMP';
fImgSliderDownNo      :='BSM_SLDN.BMP';
fImgSliderDownYes     :='BSM_SLDT.BMP';
fImgSliderLeftNo      :='BSM_SLLN.BMP';
fImgSliderLeftYes     :='BSM_SLLT.BMP';
fImgSliderRightNo     :='BSM_SLRN.BMP';
fImgSliderRightYes    :='BSM_SLRT.BMP';

fDesktopImage:='';                    {*Pas de path d'image de fond*}
fWindowImage:='';                     {*No window image*}
fWindowImageTransp:=65280;            {*Green color for transparency*}
fDesktopStyle := DSNone;              {*Style de fond d'cran: 1=Pattern, 2=Gfx*}
fDesktopPattern:=1;                   {*Numro du pattern en fond de Screen*}
fDeskTopDisplayStyle := DICenter;     {*Display desktop image method*}
fWindowBgStyle:=1;                    {*Style de fond de fentre: 0=Rien, 1=Pattern*}
fWindowBgPattern:=1;                  {*Numro du pattern en fond de Fentre*}
For A:=1 to Max_AS do fSoundFile[A]:=''; {*Pas de Sounds pour Action*}
fAudioSBVolume:=64;                   {*Volume Sound Blaster*}
fAudioCDVolume:=40;                   {*Volume CD Audio*}
fBootPwdTestCount:=3;                 {*Nombre d'essais pour le Password*}

fBootPwd:='';                         {*String pour le Password*}
fAskForBootPwd:=No;                   {*No Password at Boot*}
fTimeBelt:=+1;                        {*Numro du Fuseau Horaire Courrant*}
fNetLoginName:='UNKNOWN';             {*Name for Network Login*}
fNetEnableNetMsg:=Yes;                {*Display Network Messages*}
fNetEnableUserMsg:=Yes;               {*Display User Messages*}
fNetDisplayLogin:=No;                 {*Login at Boot*}
fNetReceivedMsg:=0;                   {*Pas de Messages Reus*}
fNetSentMsg:=0;                       {*Pas de Messages Envoys*}
fNetSignMsg:=Yes;                     {*On Signe tous les Messages Envoys*}
fNetDoBeep:=Yes;                      {*Beep WhBeep_Modulosg Arrive...*}
fDirectory:='';                       {*Rpertoire de Travail*}
fSystemFound:=No;                     {*System yet not found*}
fBootImage:='';                       {*Pas de Gfx when Boot*}
fFileTypeDetection := FDHeader;       {*Dtection des fichiers par Header*}
fTag:=0;                              {*Reserved for user define*}
fFontDirection:=0;                    {*Direction d'criture Horizontale*}
fFontMain:='LITT.CHR';                {*Valeur de la Fonte Courante*}
fFontMainSize:=4;
fFontWinTitle:='MODN.CHR';            {*Fonte Titre des Fentres*}
fFontWinTitleSize:=4;
fFontMenu:='ITAL.CHR';                {*Fonte Pour les Menus*}
fFontMenuSize:=4;
fFontHint:='LITT.CHR';                {*Font Hints*}
fFontHintSize:=4;
fFontCurrent:=fFontMain;           {*Set Current Font*}
fFontCurrentSize:=fFontMainSize;
fFontPrevious:=fFontMain;          {*Set Previous Font*}
fFontPreviousSize:=fFontMainSize;
fFontPreviousDirection:=fFontDirection;
fEnableTasksManager:=Yes;             {*Gre les tches*}
fRefreshMode := RMHideAlways;
End;

{ͻ
                        FUNCTION TSystem.TestDefined                        
 ͹
  IN.....: /                                                                
  OUT....: (BOOLEAN) = TRUE : System directory defined.                     
  EXPLAIN: Return TRUE if the system directory is correctly defined.        
 ͼ}

function TSystem.TestDefined: Boolean;
Begin
Result := File_TestExist(Sys.GetPath(SP_DATAS) + Locale.GetLocaleFile('ENG'));
End;

{ͻ
                         FUNCTION TSystem.GetPath                           
 ͹
  IN.....: Path (BYTE) = Path number (Using labels)                         
               SP_MAIN     =  1 : Main directory                            
               SP_FONTS    =  2 : Font Directory (*.CHR)                    
               SP_ICONS    =  3 : Icons Directory (*.ICO)                   
               SP_IMAGES   =  4 : Images Directory (*.BMP)                  
               SP_SOUNDS   =  5 : Sounds Directory (*.WAV)                  
               SP_BUFFER   =  6 : Buffer for Copy/Cut/Paste  (*.BUF)        
               SP_TOOLS    =  7 : Tools Directory (*.EXE + Misc)            
               SP_BOOT     =  8 : Boot tools Directory                      
               SP_TEMP     =  9 : Temporary Directory                       
               SP_DATAS    = 10 : Datas system (*.*)                        
               SP_BLANKERS = 11 : Screen Blankers Directory (*.EXE + Misc)  
               SP_SNAPSHOTS= 12 : Screenshots Directory (*.BMP)             
               SP_PALETTES = 13 : Palettes Directory (*.PAL)                
               SP_PATTERNS = 14 : Patterns Directory (*.PAT)                
               SP_TEXTURES = 15 : Textures Directory (*.BMP)                
               SP_BUTTONS  = 16 : Images for button (*.BMP)                 
               SP_MEDIAS   = 17 : CD and other multimedia datas             
               SP_CARDS    = 18 : Games card set recto & verso (*.BMP)      
               SP_THEMES   = 19 : MOS design themes (*.INI)                 
               SP_PROCESS  = 20 : MOS process information (*.PID)           
               SP_ANIMS    = 21 : MOS animations (*.BMP, *.GIF)             
               SP_INSTALL  = 22 : MOS software installation (*.MIF)         
               SP_POINTERS = 23 : Mouse pointers (*.CUR)                    
               SP_DBASE    = 24 : Data Base files (*.DAT, *.DB)             
               SP_LOG      = 25 : Log files (*.LOG)                         
  OUT....: (STRING) = Expanded Path.                                        
  EXPLAIN: Return the localisation of the "SYSTEM" directory.               
 ͼ}

function TSystem.GetPath(Path: Byte): String;{*Renvois le Path en Entier*}
Var MainPath,SubPath:String;

Begin
Case Path of                            {*Dfinition des Paths Systmes*}
    SP_MAIN     :SubPath:='';
    SP_FONTS    :SubPath:='FONTS\';
    SP_ICONS    :SubPath:='ICONS\';
    SP_IMAGES   :SubPath:='IMAGES\';
    SP_SOUNDS   :SubPath:='SOUNDS\';
    SP_TOOLS    :SubPath:='TOOLS\';
    SP_BOOT     :SubPath:='BOOT\';
    SP_TEMP     :SubPath:='TEMP\';
    SP_DATAS    :SubPath:='DATAS\';
    SP_BLANKERS :SubPath:='BLANKERS\';
    SP_SNAPSHOTS:SubPath:='SNAPSHOT\';
    SP_PALETTES :SubPath:='PALETTES\';
    SP_PATTERNS :SubPath:='PATTERNS\';
    SP_TEXTURES :SubPath:='TEXTURES\';
    SP_BUTTONS  :SubPath:='BUTTONS\';
    SP_MEDIAS   :SubPath:='MEDIAS\';
    SP_CARDS    :SubPath:='CARDS\';
    SP_THEMES   :SubPath:='THEMES\';
    SP_PROCESS  :SubPath:='PROCESS\';
    SP_ANIMS    :SubPath:='ANIMS\';
    SP_INSTALL  :SubPath:='INSTALL\';
    SP_POINTERS :SubPath:='POINTERS\';
    SP_DBASE    :SubPath:='DBASE\';
    SP_BUFFER   :SubPath:='BUFFER\';
    SP_LOG      :SubPath:='LOG\';
    Else
       Begin
//       Error(684);                      {*Unknown path ?*}
       Result := SubPath;
       Exit;
       End;
    End;

MainPath:=Sys.Directory;
If BTST(Id_Sys1,0) Then                 {*On est sur le disque dur !*}
   Begin
   If (Path=SP_PROCESS) Or (Path=SP_TEMP) Or (Path=SP_SNAPSHOTS) Then MainPath:=Sys.TempDirectory;
   End;

Result := FExpand(MainPath+SubPath);    {*Send result*}
End;

{ͻ
                     FUNCTION TSystem.TestHigherVersion                     
 ͹
  IN.....: Version (STRING) = The minimum required version.                 
           Support the following formats :                                  
              v3.10, 3.10, 3.1, v3.1, v3.1, 3.10 or either combination.   
  OUT....: (BOOLEAN) = TRUE or FALSE.                                       
  EXPLAIN: Return TRUE if the installed MOS system version is equal         
           or higher than the required version given in parameter.          
  EXAMPLE: If Not TestHigherVersion('3.10') Then Exit;                      
 ͼ}

function TSystem.TestHigherVersion(Version: String): Boolean;
Var AVer,SVer:String;
    ANum,SNum,Num:Integer;
Begin
SVer := GetVersion;                     {*MOS System Version*}
Delete(SVer,Pos('.',SVer),1);
If Length(SVer)<=2 Then SVer:=SVer+'0';
Val(SVer,SNum,Num);
                                        {*Application Version*}
If Lower(Version[1])='v' Then AVer:=Copy(Version,2,4) Else AVer:=Version;
Num:=Pos('',AVer);
If Num>0 Then Delete(AVer,Num,1);
Delete(AVer,Pos('.',AVer),1);
If Length(AVer)<=2 Then AVer:=AVer+'0';
Val(AVer,ANum,Num);
                                        {*Return the Result*}
If SNum<ANum Then Result := No Else
                  Result := Yes;
End;

{ͻ
                         FUNCTION TSystem.GetVersion                        
 ͹
  IN.....: /                                                                
  OUT....: (STRING) = The MOS system version.                               
  EXPLAIN: Return the installed MOS system version.                         
  EXAMPLE: Writeln(Get_SystemVersion);             Return '3.1'             
 ͼ}

function TSystem.GetVersion: String;
Begin
Result := Str_Get(File_GetLine(Sys.GetPath(SP_DATAS)+'Version.txt',1),2,'v');
End;

{****************************************************************************}
{*** TUser Class                                                          ***}
{****************************************************************************}

Constructor TUser.Create;
Begin
Inherited Create;

fName     := 'All users';
fChecksum := 1578;

{      Registered_User = 'Development Team';}      {*IdNum = 1578*} {MIC}
{      Registered_User = 'Demo Version';}          {*IdNum = 1163*} {MIC}
{      Registered_User = 'Lo SHIANG';}            {*IdNum = 0791*} {MIC}
{      Registered_User = 'Mohamed MEHIRA';}        {*IdNum = 1169*} {MIC}
{      Registered_User = 'Dirk VERWIEBE';}         {*IdNum = 1027*} {MIC}
{      Registered_User = 'Braham BENHABRI';}       {*IdNum = 1190*} {MIC}
{      Registered_User = 'STEPHANO Frdric';}     {*IdNum = 1504*} {MIC}
{      Registered_User = 'DELMAS Sonia';}          {*IdNum = *} {MIC}
{      Registered_User = 'T''JAMPENS Emmanuel';}   {*IdNum = 1501*} {MIC}
{      Registered_User = 'HINDERER Sbastien';}    {*IdNum = 1580*} {MIC}
{      Registered_User = 'BALAGUE Jean-Claude';}   {*IdNum = 1546*} {MIC}
{      Registered_User = 'Jrgen SCHMIDTKE';}      {*IdNum = 1331*} {MIC}
{      Registered_User = 'Steven McALLISTER';}     {*IdNum = 1445*} {MIC}
{      Registered_User = 'ARDIN Jean-Pierre';}     {*IdNum = 1440*} {MIC}
{      Registered_User = 'WAILLIEZ Andr';}        {*IdNum = 1160*} {MIC}
{      Registered_User = 'FILLON Olivier';}        {*IdNum = 1214*} {MIC}
{      Registered_User = 'BOUTELLIER Dominique';}  {*IdNum = 1730*} {MIC}
{      Registered_User = 'LOPES Miguel';}          {*IdNum = 1030*} {MIC}
{      Registered_User = 'SROKOSZ Piotr';}         {*IdNum = 1129*} {MIC}
{      Registered_User = 'ORCIL Yves';}            {*IdNum = 832*}  {MIC}
{      Registered_User = 'DEROSIAUX Patrick';}     {*IdNum = 1442*} {MIC}
{      Registered_User = 'MAUREL Fabien';}         {*IdNum = 1067*} {MIC}
{      Registered_User = 'ERARD Stphane';}        {*IdNum = 1251*} {MIC}
{      Registered_User = 'BOUSSAC Gilles';}        {*IdNum = 1168*} {MIC}
{      Registered_User = 'MERKEN Marco';}          {*IdNum = 980*}  {MIC}
{      Registered_User = 'Marwan AL-Azzawi';}      {*IdNum = 980*}  {MIC}
End;

{ͻ
                       FUNCTION TProtect.GetChecksum                        
 ͹
  IN.....: /                                                                
  OUT....: (Longint) = Calculated checksum.                                 
  EXPLAIN: Test if MOS user Name have been modified (CheckSum)              
 ͼ}

Function TUser.GetChecksum:Longint;
Var A,Som:Word;
Begin
Som:=0;
For A:=1 to Length(fName) do Inc(Som,Ord(fName[A]));
Result := Som;
End;

Procedure TUser.CheckIntegrity;
Begin
                   {Checksum obsolete now. MOS is in GPL}
{
If GetChecksum <> fChecksum Then
   Begin
   Writeln('Cracked !');
   Log.Add('    Cracked !');
   Halt(66);
   End;}
End;

Procedure TUser.SetName(N:String);
Begin
If N = fName Then Exit;
fName := Name;
fChecksum := GetChecksum;
End;

{*-------------------------- PROGRAMME PRINCIPAL ---------------------------*}

Begin
End.
