{ͻ
                              UNIT MosConvert                               
 ͹
  CREATOR....: Anonymous. Integrated by CHEVEAU Frdric                    
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 11.01.1999                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: Miscellaneous values conversions unit.                       
  AUTONOMOUS.: Yes                                                          
  UNIT SIZE..: 721 Lines and (10.672 Bytes compiled)                        
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosConvert;                           {*Playing Cards Management Unit*}

{$Mode Objfpc}

INTERFACE

{|Temperature conversions|}
Function  Conv_FahrToCent(FahrTemp:Extended):Extended;        {*Convert Farheneight to Centigrade degrees*}
Function  Conv_CentToFahr(CentTemp: Extended): Extended;      {*Convert Centigrade to Farheneight degrees*}
Function  Conv_KelvToCent(KelvTemp: Extended): Extended;      {*Convert Kelvin to Centigrade degrees*}
Function  Conv_CentToKelv(CentTemp: Extended): Extended;      {*Convert Centigrade to Kelvin degrees*}

{|Linear measurement conversions|}
Procedure Conv_InchToFtIn(Inches: Extended; Var Ft,Ins: Extended); {*Convert Inch to FeetInch*}
Function  Conv_FtInToInch(ft,ins: Extended): Extended;        {*Convert FeetInch to Inch*}
Function  Conv_InchToYard(Inches: Extended): Extended;        {*Convert Inch to Yard*}
Function  Conv_YardToInch(Yards: Extended): Extended;         {*Convert Yard to Inch*}
Function  Conv_InchToMile(Inches: Extended): Extended;        {*Convert Inch to Mile*}
Function  Conv_MileToInch(Miles: Extended): Extended;         {*Convert Mile to Inch*}
Function  Conv_InchToNautMile(Inches: Extended): Extended;    {*Convert Inch to Nautique*}
Function  Conv_NautMileToInch(NautMiles: Extended): Extended; {*Convert Nautique to Inch*}
Function  Conv_InchToMeter(Inches: Extended): Extended;       {*Convert Inch to Meter*}
Function  Conv_MeterToInch(Meters: Extended): Extended;       {*Convert Meter to Inch*}
{Function  Conv_KilometerToUA(Kilometer: Extended): Extended;}  {*Convert Kilometer to UA*}
{Function  Conv_UAToKilometer(UA: Extended): Extended;       }  {*Convert UA to Kilometer*}
{Function  Conv_KilometerToAl(Kilometer: Extended): Extended;}  {*Convert Kilometer to Yearslight*}
{Function  Conv_AlToKilometer(Al: Extended): Extended;       }  {*Convert Yearslight to Kilometer*}
{Function  Conv_AlToParsec(Al: Extended): Extended;          }  {*Convert Yearslight to Parsec*}
{Function  Conv_ParsecToAl(Parsec: Extended): Extended;      }  {*Convert Parsec to Yearslight*}

{|Area conversions|}
Function  Conv_SqInchToSqFeet(SqInches: Extended): Extended;  {*Convert Square Inch to Square Feet*}
Function  Conv_SqFeetToSqInch(SqFeet: Extended): Extended;    {*Convert Square Feet to Square Inch*}
Function  Conv_SqInchToSqYard(SqInches: Extended): Extended;  {*Convert Square Inch to Square Yard*}
Function  Conv_SqYardToSqInch(SqYards: Extended): Extended;   {*Convert Square Yard to Square Inch*}
Function  Conv_SqInchToSqMile(SqInches: Extended): Extended;  {*Convert Square Inch to Square Mile*}
Function  Conv_SqMileToSqInch(SqMiles: Extended): Extended;   {*Convert Square Mile to Square Inch*}
Function  Conv_SqInchToAcre(SqInches: Extended): Extended;    {*Convert Square Inch to Acre*}
Function  Conv_AcreToSqInch(Acres: Extended): Extended;       {*Convert Acre to Square Inch*}
Function  Conv_SqInchToSqMeter(SqInches: Extended): Extended; {*Convert Square Inch to Square Meter*}
Function  Conv_SqMeterToSqInch(SqMeters: Extended): Extended; {*Convert Square Meter to Square Inch*}

{|Volume conversions|}
Function  Conv_CuInchToCuFeet(CuInches: Extended): Extended;  {*Convert Cubic Inch to Cubic Feet*}
Function  Conv_CuFeetToCuInch(CuFeet: Extended): Extended;    {*Convert Cubic Feet to Cubic Inch*}
Function  Conv_CuInchToCuYard(CuInches: Extended): Extended;  {*Convert Cubic Inch to Cubic Yard*}
Function  Conv_CuYardToCuInch(CuYards: Extended): Extended;   {*Convert Cubic Yard to Cubic Inch*}
Function  Conv_CuInchToCuMeter(CuInches: Extended): Extended; {*Convert Cubic Inch to Cubic Meter*}
Function  Conv_CuMeterToCuInch(CuMeters: Extended): Extended; {*Convert Cubic Meter to Cubic Inch*}

{|Liquid measurement conversions|}
Function  Conv_FluidOzToPint(FluidOz: Extended): Extended;    {*Convert FluidOz to Pint*}
Function  Conv_PintToFluidOz(Pints: Extended): Extended;      {*Convert Pint to FluidOz*}
Function  Conv_FluidOzToImpPint(FluidOz: Extended): Extended; {*Convert FluidOz to ImpPint*}
Function  Conv_ImpPintToFluidOz(ImpPints: Extended): Extended;{*Convert ImpPint to FluidOz*}
Function  Conv_FluidOzToGals(FluidOz: Extended): Extended;    {*Convert FluidOz to Gals*}
Function  Conv_GalsToFluidOz(Gals: Extended): Extended;       {*Convert Gals to FluidOz*}
Function  Conv_FluidOzToImpGals(FluidOz: Extended): Extended; {*Convert FluidOz to ImpGals*}










Function  Conv_ImpGalsToFluidOz(ImpGals: Extended): Extended; {*Convert ImpGals to FluidOz*}
Function  Conv_FluidOzToCuMeter(FluidOz: Extended): Extended; {*Convert FluidOz to Cubic Meter*}
Function  Conv_CuMeterToFluidOz(CuMeters: Extended): Extended;{*Convert Cubic Meter to FluidOz*}

{|Weight conversions|}
Procedure Conv_OunceToLbOz(Ounces: Extended; Var Lb,Oz: Extended);{*Convert Ounce to LbOz*}
Function  Conv_LbOzToOunce(lb,oz: Extended): Extended;        {*Convert LbOz to Ounce*}

Function  Conv_OunceToTon(Ounces: Extended): Extended;        {*Convert Ounce to Ton*}
Function  Conv_TonToOunce(Tons: Extended): Extended;          {*Convert Ton to Ounce*}
Function  Conv_OunceToLongTon(Ounces: Extended): Extended;    {*Convert Ounce to LongTon *}
Function  Conv_LongTonToOunce(LongTons: Extended): Extended;  {*Convert LongTon to Ounce*}
Function  Conv_OunceToGram(Ounces: Extended): Extended;       {*Convert Ounce to Gram*}
Function  Conv_GramToOunce(Grams: Extended): Extended;        {*Convert Gram to Ounce*}

{*----------------------------- Dbut Library ------------------------------*}

IMPLEMENTATION

{ͻ
                          FUNCTION Conv_FahrToCent                          
 ͹
  IN.....: FahrTemp (EXTENDED) = Initial value to convert.                  
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Fahreneight to Centigrade degree.                        
 ͼ}

Function Conv_FahrToCent(FahrTemp: Extended): Extended;
Begin
Conv_FahrToCent:=(FahrTemp+40.0)*(5.0/9.0)-40.0;
End;

{ͻ
                          FUNCTION Conv_CentToFahr                          
 ͹
  IN.....: FahrTemp (EXTENDED) = Initial value to convert.                  
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Centigrade to Farhenight degree.                         

 ͼ}

Function Conv_CentToFahr(CentTemp: Extended): Extended;
Begin
Conv_CentToFahr:=(CentTemp+40.0)*(9.0/5.0)-40.0;
End;

{ͻ
                          FUNCTION Conv_KelvToCent                          
 ͹
  IN.....: FahrTemp (EXTENDED) = Initial value to convert.                  
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Kelvin to Centigrade degree.                             
 ͼ}


Function Conv_KelvToCent(KelvTemp: Extended): Extended;
Begin
Conv_KelvToCent:=KelvTemp-273.16;
End;

{ͻ
                          FUNCTION Conv_CentToKelv                          
 ͹
  IN.....: FahrTemp (EXTENDED) = Initial value to convert.                  
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Centigrade to Kelvin degree.                             
 ͼ}

Function Conv_CentToKelv(CentTemp: Extended): Extended;
Begin
Conv_CentToKelv:=CentTemp+273.16;
End;

{ͻ
                         PROCEDURE Conv_InchToFtIn                          
 ͹
  IN.....: Inches (EXTENDED) = Initial value to convert.                    
  OUT....: Ft,Ins (EXTENDED) = Return the converted value.                  
  EXPLAIN: Convert Inches to Feet Inches.                                   
 ͼ}

Procedure Conv_InchToFtIn(Inches: Extended; Var Ft,Ins: Extended);
Begin
Ft:=Int(Inches/12.0);
Ins:=Inches-Ft*12.0;
End;

{ͻ
                          FUNCTION Conv_FtInToInch                          
 ͹
  IN.....: Ft,Ins (EXTENDED) = Initial values to convert.                   
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Feet Inches to Feet.                                     
 ͼ}

Function Conv_FtInToInch(Ft,Ins: Extended): Extended;
Begin
Conv_FtInToInch:=Ft*12.0+ins;
End;

{ͻ
                          FUNCTION Conv_InchToYard                          

 ͹
  IN.....: Inches (EXTENDED) = Initial value to convert.                    
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Inches to Yards.                                         
 ͼ}

Function Conv_InchToYard(Inches: Extended): Extended;
Begin
Conv_InchToYard:=Inches/36.0;
End;


{ͻ
                          FUNCTION Conv_YardToInch                          
 ͹
  IN.....: Yards (EXTENDED) = Initial value to convert.                     
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Yards to Inches.                                         
 ͼ}

Function Conv_YardToInch(Yards: Extended): Extended;
Begin
Conv_YardToInch:=Yards*36.0;
End;

{ͻ
                          FUNCTION Conv_InchToMile                          
 ͹
  IN.....: Inches (EXTENDED) = Initial value to convert.                    
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Inches to Miles.                                         
 ͼ}

Function Conv_InchToMile(Inches: Extended): Extended;

Begin
Conv_InchToMile:=Inches/63360.0;
End;

{ͻ
                          FUNCTION Conv_MileToInch                          
 ͹
  IN.....: Miles (EXTENDED) = Initial value to convert.                     
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Miles to Inches.                                         
 ͼ}

Function Conv_MileToInch(Miles: Extended): Extended;
Begin
Conv_MileToInch:=Miles*63360.0;
End;

{ͻ
                        FUNCTION Conv_InchToNautMile                        
 ͹
  IN.....: Inches (EXTENDED) = Initial value to convert.                    

  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Inches to Nautic Miles.                                  
 ͼ}

Function Conv_InchToNautMile(Inches: Extended): Extended;
Begin
Conv_InchToNautMile:=Inches/72960.0;
End;

{ͻ
                        FUNCTION Conv_NautMileToInch                        
 ͹
  IN.....: NautMiles (EXTENDED) = Initial value to convert.                 
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Nautic Miles to Inches.                                  
 ͼ}

Function Conv_NautMileToInch(NautMiles: Extended): Extended;
Begin
Conv_NautMileToInch:=NautMiles*72960.0;

End;


{ͻ
                         FUNCTION Conv_InchToMeter                          
 ͹

  IN.....: Inches (EXTENDED) = Initial value to convert.                    
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Inches to Meters.                                        
 ͼ}

Function Conv_InchToMeter(Inches: Extended): Extended;
Begin
Conv_InchToMeter:=Inches*0.0254;
End;

{ͻ
                         FUNCTION Conv_MeterToInch                          
 ͹
  IN.....: Meters (EXTENDED) = Initial value to convert.                    
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Meters to Inches.                                        
 ͼ}

Function Conv_MeterToInch(Meters: Extended): Extended;
Begin
Conv_MeterToInch:=Meters/0.0254;
End;

{ͻ
                        FUNCTION Conv_SqInchToSqFeet                        

 ͹
  IN.....: SqInches (EXTENDED) = Initial value to convert.                  
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Square Inches to Square Feets.                           
 ͼ}

Function Conv_SqInchToSqFeet(SqInches: Extended): Extended;
Begin
Conv_SqInchToSqFeet:=SqInches/144.0;
End;

{ͻ
                        FUNCTION Conv_SqFeetToSqInch                        
 ͹
  IN.....: SqFeet (EXTENDED) = Initial value to convert.                    
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Square Feets to Square Inches.                           
 ͼ}

Function Conv_SqFeetToSqInch(SqFeet: Extended): Extended;
Begin
Conv_SqFeetToSqInch:=SqFeet*144.0;
End;

{ͻ
                        FUNCTION Conv_SqInchToSqYard                        
 ͹
  IN.....: SqInches (EXTENDED) = Initial value to convert.                  
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Square Inches to Square Yards.                           
 ͼ}

Function Conv_SqInchToSqYard(SqInches: Extended): Extended;
Begin
Conv_SqInchToSqYard:=SqInches/1296.0;
End;

{ͻ
                        FUNCTION Conv_SqYardToSqInch                        
 ͹
  IN.....: SqYard (EXTENDED) = Initial value to convert.                    
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Square Yards to Square Inches.                           
 ͼ}

Function Conv_SqYardToSqInch(SqYards: Extended): Extended;
Begin
Conv_SqYardToSqInch:=SqYards*1296.0;
End;

{ͻ
                        FUNCTION Conv_SqInchToSqMile                        
 ͹
  IN.....: SqInches (EXTENDED) = Initial value to convert.                  
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Square Inches to Square Miles.                           
 ͼ}

Function Conv_SqInchToSqMile(SqInches: Extended): Extended;
Begin
Conv_SqInchToSqMile:=SqInches/4.0144896E9;
End;

{ͻ
                        FUNCTION Conv_SqMileToSqInch                        
 ͹
  IN.....: SqMiles (EXTENDED) = Initial value to convert.                   
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Square Miles to Square Inches.                           
 ͼ}

Function Conv_SqMileToSqInch(SqMiles: Extended): Extended;

Begin
Conv_SqMileToSqInch:=SqMiles*4.0144896E9;
End;

{ͻ
                         FUNCTION Conv_SqInchToAcre                         
 ͹
  IN.....: SqInches (EXTENDED) = Initial value to convert.                  
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Square Inches to Acre.                                   
 ͼ}

Function Conv_SqInchToAcre(SqInches: Extended): Extended;
Begin
Conv_SqInchToAcre:=SqInches/6272640.0;
End;

{ͻ
                         FUNCTION Conv_AcreToSqInch                         
 ͹
  IN.....: Acres (EXTENDED) = Initial value to convert.                     
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Acres to Square Inches.                                  
 ͼ}


Function Conv_AcreToSqInch(Acres: Extended): Extended;
Begin
Conv_AcreToSqInch:=Acres*6272640.0;
End;

{ͻ
                       FUNCTION Conv_SqInchToSqMeter                        
 ͹
  IN.....: SqInches (EXTENDED) = Initial value to convert.                  
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Square Inches to Square Meters.                          
 ͼ}

Function Conv_SqInchToSqMeter(SqInches: Extended): Extended;
Begin
Conv_SqInchToSqMeter:=SqInches/1550.016;
End;

{ͻ
                       FUNCTION Conv_SqMeterToSqInch                        
 ͹
  IN.....: SqMeters (EXTENDED) = Initial value to convert.                  
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Square Meters to Square Inches.                          
 ͼ}

Function Conv_SqMeterToSqInch(SqMeters: Extended): Extended;
Begin
Conv_SqMeterToSqInch:=SqMeters*1550.016;
End;

{ͻ
                        FUNCTION Conv_CuInchToCuFeet                        
 ͹
  IN.....: CuInches (EXTENDED) = Initial value to convert.                  
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Cubic Inches to Cubic Feets.                             
 ͼ}

Function Conv_CuInchToCuFeet(CuInches: Extended): Extended;
Begin
Conv_CuInchToCuFeet:=CuInches/1728.0;
End;

{ͻ
                        FUNCTION Conv_CuFeetToCuInch                        
 ͹
  IN.....: CuFeet (EXTENDED) = Initial value to convert.                    
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Cubic Feets to Cubic Inches.                             
 ͼ}

Function Conv_CuFeetToCuInch(CuFeet: Extended): Extended;
Begin
Conv_CuFeetToCuInch:=CuFeet*1728.0;
End;

{ͻ
                        FUNCTION Conv_CuInchToCuYard                        
 ͹
  IN.....: CuInches (EXTENDED) = Initial value to convert.                  
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Cubic Inches to Cubic Yards.                             
 ͼ}

Function Conv_CuInchToCuYard(CuInches: Extended): Extended;
Begin
Conv_CuInchToCuYard:=CuInches/46656.0;
End;

{ͻ
                        FUNCTION Conv_CuYardToCuInch                        
 ͹
  IN.....: CuYards (EXTENDED) = Initial value to convert.                   
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Cubic Yards to Cubic Inches.                             
 ͼ}



Function Conv_CuYardToCuInch(CuYards: Extended): Extended;
Begin
Conv_CuYardToCuInch:=CuYards*46656.0;
End;

{ͻ
                       FUNCTION Conv_CuInchToCuMeter                        

 ͹
  IN.....: CuInches (EXTENDED) = Initial value to convert.                  
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Cubic Inches to Cubic Meters.                            
 ͼ}

Function Conv_CuInchToCuMeter(CuInches: Extended): Extended;
Begin
Conv_CuInchToCuMeter:=CuInches/61022.592;
End;

{ͻ
                       FUNCTION Conv_CuMeterToCuInch                        
 ͹
  IN.....: CuMeters (EXTENDED) = Initial value to convert.                  
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Cubic Meters to Cubic Inches.                            
 ͼ}

Function Conv_CuMeterToCuInch(CuMeters: Extended): Extended;
Begin
Conv_CuMeterToCuInch:=CuMeters*61022.592;
End;

{ͻ

                        FUNCTION Conv_FluidOzToPint                         
 ͹
  IN.....: FluidOz (EXTENDED) = Initial value to convert.                   

  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert FluidOz to Pints.                                        
 ͼ}

Function Conv_FluidOzToPint(FluidOz: Extended): Extended;
Begin
Conv_FluidOzToPint:=FluidOz/16.0;
End;

{ͻ
                        FUNCTION Conv_PintToFluidOz                         

 ͹
  IN.....: Pints (EXTENDED) = Initial value to convert.                     
  OUT....: (EXTENDED) = Return the converted value.                         

  EXPLAIN: Convert Pints to FluidOz.                                        
 ͼ}

Function Conv_PintToFluidOz(Pints: Extended): Extended;
Begin
Conv_PintToFluidOz:=Pints*16.0;
End;


{ͻ
                       FUNCTION Conv_FluidOzToImpPint                       
 ͹
  IN.....: FluidOz (EXTENDED) = Initial value to convert.                   
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert FluidOz to Imp Pints.                                    
 ͼ}

Function Conv_FluidOzToImpPint(FluidOz: Extended): Extended;
Begin
Conv_FluidOzToImpPint:=FluidOz/20.0;
End;

{ͻ
                       FUNCTION Conv_ImpPintToFluidOz                       
 ͹
  IN.....: ImpPints (EXTENDED) = Initial value to convert.                  
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Imp Pints to FluidOz.                                    
 ͼ}

Function Conv_ImpPintToFluidOz(ImpPints: Extended): Extended;

Begin
Conv_ImpPintToFluidOz:=ImpPints*20.0;
End;

{ͻ
                        FUNCTION Conv_FluidOzToGals                         
 ͹
  IN.....: FluidOz (EXTENDED) = Initial value to convert.                   
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert FluidOz to Galons.                                       
 ͼ}

Function Conv_FluidOzToGals(FluidOz: Extended): Extended;
Begin
Conv_FluidOzToGals:=FluidOz/128.0;
End;

{ͻ
                        FUNCTION Conv_GalsToFluidOz                         
 ͹
  IN.....: Gals (EXTENDED) = Initial value to convert.                      
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Gals to FluidOz.                                         
 ͼ}

Function Conv_GalsToFluidOz(Gals: Extended): Extended;
Begin
Conv_GalsToFluidOz:=Gals*128.0;
End;

{ͻ
                       FUNCTION Conv_FluidOzToImpGals                       
 ͹
  IN.....: FluidOz (EXTENDED) = Initial value to convert.                   
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert FluidOz to Imp Galons.                                   
 ͼ}

Function Conv_FluidOzToImpGals(FluidOz: Extended): Extended;
Begin

Conv_FluidOzToImpGals:=FluidOz/160.0;
End;

{ͻ
                       FUNCTION Conv_ImpGalsToFluidOz                       
 ͹
  IN.....: ImpGals (EXTENDED) = Initial value to convert.                   
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Imp Gals to FluidOz.                                     
 ͼ}

Function Conv_ImpGalsToFluidOz(ImpGals: Extended): Extended;
Begin
Conv_ImpGalsToFluidOz:=ImpGals*160.0;
End;

{ͻ
                       FUNCTION Conv_FluidOzToCuMeter                       
 ͹
  IN.....: FluidOz (EXTENDED) = Initial value to convert.                   

  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert FluidOz to Cubic Meters.                                 
 ͼ}

Function Conv_FluidOzToCuMeter(FluidOz: Extended): Extended;
Begin
Conv_FluidOzToCuMeter:=FluidOz/33820.0;
End;

{ͻ
                       FUNCTION Conv_CuMeterToFluidOz                       
 ͹
  IN.....: CuMeter (EXTENDED) = Initial value to convert.                   
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Cubic Metere to FluidOz.                                 
 ͼ}

Function Conv_CuMeterToFluidOz(CuMeters: Extended): Extended;
Begin
Conv_CuMeterToFluidOz:=CuMeters*33820.0;

End;

{ͻ
                         PROCEDURE Conv_OunceToLbOz                         
 ͹
  IN.....: Ounces (EXTENDED) = Initial value to convert.                    
  OUT....: Lb,Oz (EXTENDED) = Return the converted values.                  
  EXPLAIN: Convert Ounces to Lb Oz.                                         
 ͼ}

Procedure Conv_OunceToLbOz(Ounces: Extended; Var Lb,Oz: Extended);
Begin
Lb:=INT(Ounces/16.0);
Oz:=Ounces-Lb*16.0;
End;

{ͻ
                         FUNCTION Conv_LbOzToOunce                          
 ͹
  IN.....: Lb,Oz (EXTENDED) = Initial values to convert.                    
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Lb Oz to Ounces.                                         
 ͼ}

Function Conv_LbOzToOunce(Lb,Oz: Extended): Extended;
Begin
Conv_LbOzToOunce:=Lb*16.0+Oz;
End;

{ͻ
                          FUNCTION Conv_OunceToTon                          

 ͹
  IN.....: Ounces (EXTENDED) = Initial value to convert.                    
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Ounces to Tons.                                          
 ͼ}

Function Conv_OunceToTon(Ounces: Extended): Extended;
Begin
Conv_OunceToTon:=Ounces/32000.0;
End;

{ͻ
                          FUNCTION Conv_TonToOunce                          
 ͹
  IN.....: Tons (EXTENDED) = Initial value to convert.                      
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Tons to Ounces.                                          
 ͼ}

Function Conv_TonToOunce(Tons: Extended): Extended;
Begin
Conv_TonToOunce:=Tons*32000.0;
End;

{ͻ
                        FUNCTION Conv_OunceToLongTon                        
 ͹
  IN.....: Ounces (EXTENDED) = Initial value to convert.                    

  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Ounces to Long Tons.                                     
 ͼ}

Function Conv_OunceToLongTon(Ounces: Extended): Extended;

Begin
Conv_OunceToLongTon:=Ounces/35840.0;
End;

{ͻ
                        FUNCTION Conv_LongTonToOunce                        
 ͹
  IN.....: LongTons (EXTENDED) = Initial value to convert.                  
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Long Tons to Ounces.                                     
 ͼ}

Function Conv_LongTonToOunce(LongTons: Extended): Extended;
Begin
Conv_LongTonToOunce:=LongTons*35840.0;
End;


{ͻ
                         FUNCTION Conv_OunceToGram                          
 ͹
  IN.....: Ounces (EXTENDED) = Initial value to convert.                    
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Ounces to Grams.                                         
 ͼ}

Function Conv_OunceToGram(Ounces: Extended): Extended;
Begin
Conv_OunceToGram:=Ounces*28.35;
End;

{ͻ
                         FUNCTION Conv_GramToOunce                          
 ͹
  IN.....: Grams (EXTENDED) = Initial value to convert.                     
  OUT....: (EXTENDED) = Return the converted value.                         
  EXPLAIN: Convert Grams to Ounces.                                         
 ͼ}

Function Conv_GramToOunce(Grams: Extended): Extended;
Begin
Conv_GramToOunce:=Grams/28.35;
End;


{*-------------------------- PROGRAMME PRINCIPAL ---------------------------*}

Begin
End.

