{ͻ
                           UNIT MosCPUInstructions                          
 ͹
  CREATOR....: PLANAS Jean-Pierre                                           
  UPDATED BY.: PLANAS Jean-Pierre                                           
  CREATED THE: 01.08.1999                                                   
  COUNTRY....: Perpignan - (FRANCE)                                         
  DESCRIPTION: New CPU Instructions.                                        
  AUTONOMOUS.: Yes                                                          
  UNIT SIZE..: 194 Lines and (2.768 Bytes compiled)                         
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosCPUInstructions;

{$Mode ObjFpc}

INTERFACE

Type TPByte = ^Byte;

{|Asm bits procedures|}
Procedure BSET(Var W:Word; B:Byte);	       {*Set a Bit 'B'*}
Procedure BCLR(Var W:Word; B:Byte);            {*Clear a Bit 'B'*}
Procedure BCHG(Var W:Word; B:Byte);            {*Exchange a Bit 'B'*}
Function  BTST (W:Word; B:Byte):Boolean;       {*Test a Bit 'B'*}
Procedure Rol(Var W:Word;Var F:Boolean);       {*Rotate bits left*}
Procedure Ror(Var W:Word;Var F:Boolean);       {*Rotate bits rigth*}

{|Peek/Poke memory|}
Function  Peek(P:Pointer):Byte;                 {*Same as Basic Peek*}
Procedure Poke(P:Pointer;Value:Byte);           {*Same as Basic Poke*}

{|Pointers management|}
Procedure Incp(Var P:Pointer;W:LongInt); {*Increment a pointer*}
Procedure Decp(Var P:Pointer;W:LongInt); {*Decrement a pointer*}

{|Miscellaneous|}
Procedure Exg(Var A,B:Integer);                {*Echange Both Values*}
Function  Set_Even(L:longint):longint;   {*Convert the longint to an even longint*}
Function  Max(A,B:LongInt):LongInt; {*Get max from 2 number*}
Function  Min(A,B:LongInt):LongInt; {*Get min from 2 number*}
Procedure FillWord(Var X; Count : Word; Value : Word); {*Like FillChar but for Words*}

IMPLEMENTATION

{*----------------------------- Asm bits procedure -------------------------*}

{ͻ
                               PROCEDURE BSET                               
 ͹
  IN.....: W (WORD) = Word Register to manage bits.                         
           B (BYTE) = Bit number to operate (0 to 15).                      
  OUT....: /                                                                
  NB.....: ASM68000 function (Origin).                                      
  EXPLAIN: Set the bit "B" of the "W" variable.                             
  SEEALSO: BCLR, BCHG, BTST                                                 
 ͼ}

Procedure BSET (Var W:Word; B:Byte);              {*Set a Bit 'B'*}
Begin
W:=W Or (1 shl B){Puiss(2,B)};
End;

{ͻ
                               PROCEDURE BCLR                               
 ͹
  IN.....: W (WORD) = Word Register to manage bits.                         
           B (BYTE) = Bit number to operate (0 to 15).                      
  OUT....: /                                                                
  NB.....: ASM68000 function (Origin).                                      
  EXPLAIN: Clear the bit "B" of the "W" variable.                           
  SEEALSO: BSET, BCHG, BTST                                                 
 ͼ}

Procedure BCLR (Var W:Word; B:Byte);              {*Clear a Bit 'B'*}
Begin
W:=W And ($FFFF-(1 shl B));
End;

{ͻ
                               FUNCTION BTST                                
 ͹
  IN.....: W (WORD) = Word Register to manage bits.                         
           B (BYTE) = Bit number to operate (0 to 15).                      
  OUT....: (BOOLEAN) = Bit set if TRUE else FALSE.                          
  NB.....: ASM68000 function (Origin).                                      
  EXPLAIN: Test the bit "B" of the "W" variable.                            
  SEEALSO: BCLR, BCHG, BSET                                                 
 ͼ}

Function BTST (W:Word; B:Byte):Boolean;           {*Test a Bit 'B'*}
Begin
If (W And (1 shl B))=(1 shl B) Then BTST:=True Else BTST:=False;
End;

{ͻ
                               PROCEDURE BCHG                               
 ͹
  IN.....: W (WORD) = Word Register to manage bits.                         
           B (BYTE) = Bit number to operate (0 to 15).                      
  OUT....: /                                                                
  NB.....: ASM68000 function (Origin).                                      
  EXPLAIN: Swap the bit value of the bit "B" for the "W" variable.          
  SEEALSO: BCLR, BSET, BTST                                                 
 ͼ}

Procedure BCHG (Var W:Word; B:Byte);              {*Exchange a Bit 'B'*}
Begin
If BTST(W,B) Then BCLR(W,B) Else BSET(W,B);
End;

{ͻ
                               PROCEDURE ROL                                
 ͹
  IN.....: W (WORD) = Input Word                                            
           F (BOOLEAN) = Input Flag                                         
  OUT....: W (WORD) = Output word                                           
           F (BOOLEAN) = OutPut Flag                                        
  EXPLAIN: Make a left rotation of bit (using flag) on a word.              
  EXAMPLE: W:=$FFFF;B:=False;                                               
           Rol(W,B);       W=$FFFE;  B= True                                
  SEEALSO: Ror                                                              
 ͼ}
Procedure Rol(Var W:Word;Var F:Boolean);
Var B:Boolean;
Begin
B:=BTST(W,15);
W:=W Shl 1;
If F Then BSET(W,0);
F:=B;
End;

{ͻ
                               PROCEDURE ROR                                
 ͹
  IN.....: W (WORD) = Input Word                                            
           F (BOOLEAN) = Input Flag                                         
  OUT....: W (WORD) = Output word                                           
           F (BOOLEAN) = OutPut Flag                                        
  EXPLAIN: Make a Right rotation of bit (using flag) on a word.             
  EXAMPLE: W:=$FFFF;B:=False;                                               
           Ror(W,B);       W=$7FFF;  B= True                                
  SEEALSO: Rol                                                              
 ͼ}
Procedure Ror(Var W:Word;Var F:Boolean);
Var B:Boolean;
Begin
B:=BTST(W,0);
W:=W Shr 1;
If F Then BSET(W,15);
F:=B;
End;

{*--------------------------- Peek/Poke memory -----------------------------*}

{ͻ
                               FUNCTION Peek                                
 ͹
  IN.....: P (Pointer) = Adress in memory                                   
  OUT....: (BYTE) = Value of the byte at this address.                      
  EXPLAIN: Return the value of the byte at this address.                    
  SEEALSO: Poke                                                             
 ͼ}

Function Peek(P:Pointer):Byte;
Var P2:TPByte;
Begin                                           {*Equivalent Basic du Peek*}
P2:=P;
PEEK:=P2^;
End;

{ͻ
                               PROCEDURE Poke                               
 ͹
  IN.....: P (Pointer) = Adress in memory                                   
           Value (BYTE) = Value of the byte to put at this address.         
  OUT....: /                                                                
  EXPLAIN: Put a the value byte at this address.                            
  SEEALSO: Peek                                                             
 ͼ}

Procedure Poke(P:Pointer;Value:Byte);
Var P2:TPByte;
Begin                                            {*Equivalent Basic du Poke*}
P2:=P;
P2^:=Value;
End;

{*----------------------------- Pointers management ------------------------*}

{ͻ
                               PROCEDURE INCP                               
 ͹
  IN.....: P (POINTER) = Pointer to increment                               
           W (LONGINT) = Quantity of bytes to increment P                   
  OUT....: P (POINTER) = P+W bytes.                                         
  EXPLAIN: Increment the pointer P of W bytes.                              
  EXAMPLE: P='00FA0010';Incp(P,$100);Result : P='00FA0110'.                 
  BUGS...: If P+W>FFFFFFFF ...                                              
 ͼ}
Procedure Incp(Var P:Pointer;W:LongInt);
Var P_b:TPByte;         {*Pointer on 1 byte*}
Begin
P_b:=P;
Inc(P_b,W);
P:=P_b;
End;

{ͻ
                               PROCEDURE DECP                               
 ͹
  IN.....: P (POINTER) = Pointer to decrement                               
           W (LONGINT) = Quantity of bytes to decrement P                   
  OUT....: P (POINTER) = P+W bytes.                                         
  EXPLAIN: Decrement the pointer P of W bytes.                              
  EXAMPLE: P='00FA0110';Decp(P,$100);Result : P='00FA0010'.                 
  BUGS...: If P-W<00000000 ...                                              
 ͼ}
Procedure Decp(Var P:Pointer;W:LongInt);
Var P_b:TPByte;          {*Pointer on 1 byte*}
Begin

P_b:=P;
Dec(P_b,W);
P:=P_b;
End;

{*--------------------------- Miscellaneous --------------------------------*}

{ͻ
                               PROCEDURE Exg                                
 ͹
  IN.....: A,B (INTEGER): The 2 integer variables to exchange.              
  OUT....: A,B (INTEGER): The 2 integer variables exchanged.                
  EXPLAIN: Exchange the contain of the 2 integer.                           
 ͼ}

Procedure Exg(Var A,B:Integer);
Var X:Integer;
Begin
X:=A;
A:=B;
B:=X;
End;

{ͻ
                             FUNCTION SET_EVEN                              
 ͹
  IN.....: L : (LONGINT) = a number                                         
  OUT....: (LONGINT) an even number                                         
  EXPLAIN: If L is even, the return is L, else the return is L+1.           
  EXAMPLE: Set_Even(3)=4                                                    
           Set_Even(4)=4                                                    
           Set_Even(10001)=10002                                            
 ͼ}

Function Set_Even(L:longint):longint;
Begin
 if l mod 2=0 then Set_Even:=l else Set_Even:=l+1;
End;

{ͻ
                                FUNCTION MAX                                
 ͹
  IN.....: A,B (LongInt) = 2 numbers                                        
  OUT....: (LongInt) = The maximun of this 2 numbers                        
  EXPLAIN: /                                                                
  SEEALSO: Min                                                              
 ͼ}
Function Max(A,B:LongInt):LongInt;
Begin
If A>B Then Max:=A Else Max:=B;
End;

{ͻ
                                FUNCTION MIN                                
 ͹
  IN.....: A,B (LongInt) = 2 numbers                                        
  OUT....: (LongInt) = The minimum of this 2 numbers                        
  EXPLAIN: /                                                                
  SEEALSO: Max                                                              
 ͼ}
Function Min(A,B:LongInt):LongInt;
Begin
If A<B Then Min:=A Else Min:=B;
End;

{ͻ
                             PROCEDURE FILLWORD                             
 ͹
  IN.....: X (UNTYPED) = Variable to fill                                   
           Count (WORD) = How many time you want to make the copy           
           Value (WORD) = Value to fill X.                                  
  OUT....: X (UNTYPED).                                                     
  EXPLAIN: Same as FillChar but with Words.                                 
           Count = Number of byte of X variable / 2                         
  EXAMPLE: S:String[79];                                                    
           FillWord(S,40,0);                                                
 ͼ}
PROCEDURE FillWord(Var X; Count : Word; Value : Word);
Var i:Word;
    P:^Word;
Begin
P:=@X;
For i:=1 to Count do
  Begin
  P^:=Value;
  Inc(P);
  End;
End;

{*----------------------- Programme Principal ------------------------------*}

BEGIN
END.
