{ͻ
                                UNIT MosCrt                                 
 ͹
  CREATOR....: PLANAS Jean-Pierre                                           
  UPDATED BY.: PLANAS Jean-Pierre                                           
  CREATED THE: 28.04.1997                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: Replace all the Turbo pascal CRT unit.                       
  AUTONOMOUS.: Yes                                                          
  UNIT SIZE..: 501 Lines and (7.152 Bytes compiled)                         
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosCrt;
{$MODE objfpc}

INTERFACE

Uses Crt,
     GxCrText,
     GxCrt,
     GxDd;

Const BW40          = 0;            { 40x25 B/W on Color Adapter }
      CO40          = 1;            { 40x25 Color on Color Adapter }
      BW80          = 2;            { 80x25 B/W on Color Adapter }
      CO80          = 3;            { 80x25 Color on Color Adapter }
      Mono          = 7;            { 80x25 on Monochrome Adapter }
      Font8x8       = 256;          { Add-in for ROM font }
      { Foreground and background color constants }
      Black         = 0;
      Blue          = 1;
      Green         = 2;
      Cyan          = 3;
      Red           = 4;
      Magenta       = 5;
      Brown         = 6;
      LightGray     = 7;
      { Foreground color constants }
      DarkGray      = 8;
      LightBlue     = 9;
      LightGreen    = 10;
      LightCyan     = 11;
      LightRed      = 12;
      LightMagenta  = 13;
      Yellow        = 14;
      White         = 15;
      { Add-in for blinking }
      Blink         = 128;

Type
     TextFile = Text;                     {*Delphi compatibility*}

{|KeyBoard|}
Function  KeyPressed: Boolean;            {*Test if a key is pressed*}
Function  ReadKey: Char;                  {*Read a key*}

{|Screen Position|}
Procedure GotoXY(X,Y: Byte);              {*Put the cursor on X,Y*}
Function  WhereX: Byte;                   {*Get current cursor X position*}
Function  WhereY: Byte;                   {*Get current cursor Y position*}
Procedure Window(X1, Y1, X2, Y2 : byte);  {*Set the text window*}

{|Screen actions|}
Procedure ClrScr;                         {*Clear the screen*}
Procedure ClrEol;                         {*Clear the end of the line*}
Procedure InsLine;                        {*Insert a line*}
Procedure DelLine;                        {*Delete a line*}

{|Colors|}
Procedure TextBackground(Color : Byte);   {*Set Background color*}
Procedure TextColor(Color : Byte);        {*Set Text color*}

{|Vides modes|}
Procedure TextMode (Mode : Byte);         {*Set a text video mode*}
Procedure LowVideo;                       {*Selects low intensity characters.*}
Procedure HighVideo;                      {*Selects high intensity characters.*}
Procedure NormVideo;                      {*Selects normal intensity characters.*}

{|Sound|}
Procedure Sound(Hz: Word);                {*Play a sound*}
Procedure NoSound;                        {*Stop the sound*}

{|Wait|}
Procedure Delay (MS : Word);              {*Wait*}

{|Redirection|}
Procedure AssignCrt(var F:Text);          {*Associate a text file with the CRT window*}
Procedure AssignText(var F:Text; FileName:String); {*Assign a text file*}

IMPLEMENTATION

{--------------------------------KeyBoard------------------------------------}
Function  KeyPressed: Boolean;            {*Test if a key is pressed*}
Begin
KeyPressed:=gxcrt.KeyPressed;
End;

Function  ReadKey: Char;                  {*Read a key*}
Begin
Readkey:=gxcrt.ReadKey;
End;

{------------------------------Screen Position-------------------------------}
Procedure GotoXY(X,Y: Byte);              {*Put the cursor on X,Y*}
Begin
crt.GotoXY(X,Y);
End;
Function  WhereX: Byte;                   {*Get current cursor X position*}
Begin
WhereX:=crt.WhereX;
End;
Function  WhereY: Byte;                   {*Get current cursor Y position*}
Begin
WhereY:=crt.WhereY;
End;
Procedure Window(X1, Y1, X2, Y2 : byte);  {*Set the text window*}
Begin
crt.Window(X1, Y1, X2, Y2 );
End;

{-------------------------------Screen actions-------------------------------}
Procedure ClrScr;                         {*Clear the screen*}
Begin
crt.ClrScr;
End;
Procedure ClrEol;                         {*Clear the end of the line*}
Begin
crt.ClrEol;
End;
Procedure InsLine;                        {*Insert a line*}
Begin
crt.InsLine;
End;
Procedure DelLine;                        {*Delete a line*}
Begin
crt.DelLine;
End;

{-----------------------------------Colors-----------------------------------}
Procedure TextBackground(Color : Byte);   {*Set Background color*}
Begin
crt.TextBackground(Color);
End;
Procedure TextColor(Color : Byte);        {*Set Text color*}
Begin
crt.TextColor(Color);
End;

{--------------------------------Video modes---------------------------------}
Procedure TextMode (Mode : Byte);         {*Set a text video mode*}
Begin
crt.TextMode (Mode);
End;
Procedure LowVideo;                       {*Selects low intensity characters.*}
Begin
crt.LowVideo;
End;
Procedure HighVideo;                      {*Selects high intensity characters.*}
Begin
crt.HighVideo;
End;
Procedure NormVideo;                      {*Selects normal intensity characters.*}
Begin
crt.NormVideo;
End;

{-----------------------------------Sound------------------------------------}
Procedure Sound(Hz: Word);                {*Play a sound*}
Begin
crt.Sound(Hz);
End;
Procedure NoSound;                        {*Stop the sound*}
Begin
crt.NoSound;
End;

{-----------------------------------Wait-------------------------------------}
Procedure Delay (MS : Word);              {*Wait*}
Begin
crt.Delay (MS);
End;

{---------------------------------Redirection--------------------------------}
Procedure AssignCrt(var F: Text);       {*Associate a text file with the CRT window*}
Begin
crt.AssignCrt(F);
End;

Procedure AssignText(var F: Text; FileName:String); {*Assign a text file*}
Begin
Assign(F, FileName);                    {*Call the classic assign function*}
End;

Begin
End.
