{ͻ
                               UNIT MosDebug                                
 ͹
  CREATOR....: PLANAS Jean-Pierre                                           
  UPDATED BY.: PLANAS Jean-Pierre                                           
  CREATED THE: 19.02.1998                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: Help for debugging (Write important information).            
  AUTONOMOUS.: Yes                                                          
  UNIT SIZE..: 260 Lines and (6.384 Bytes compiled)                         
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

{$ASMMODE intel}
{$MODE objfpc}

UNIT MosDebug;

INTERFACE

Procedure Done_Debug;                      {*Show debug informations*}
(*Procedure Disp_xy(x,y:Word;St:String); {MIC}
Procedure Disp_Clr;                    {MIC}

Procedure Disp_(St:String);            {MIC}*)

IMPLEMENTATION

Uses
     Dos,
     MosBase,
     MosMemory,
     MosConfig,
     MosCPUInstructions,
     MosCrt,
     MosDisks,
     MosStrings;

{*-------------------------- Library Beginning -----------------------------*}

Var Qtt_Mem_Avail:Longint;
    Qtt_Drv_Space:Longint;
    Current_Drv:Byte;

{ͻ
                          PROCEDURE Done_DebMemory                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test memory for debug information.                               
 ͼ}

Procedure Done_DebMemory;
Var S1,S2:String;
Begin
Str(Qtt_Mem_Avail,S1);
S1:=Str_Format(S1,'.',3);
Str(MemAvail,S2);
S2:=Str_Format(S2,'.',3);
If Qtt_Mem_Avail<>MemAvail Then TextColor(Red)
                           Else TextColor(LightGray);
Writeln('Free memory                : ',S1:14,S2:14,'    Bytes');
End;

{ͻ
                        PROCEDURE Done_DebDiskSpace                         


 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test free disk space for debug information.                      
 ͼ}

Procedure Done_DebDiskSpace;
Var S1,S2:String;
Begin
Str(Qtt_Drv_Space,S1);
S1:=Str_Format(S1,'.',3);

Str(Diskfree(Current_Drv),S2);
S2:=Str_Format(S2,'.',3);
If Diskfree(Current_Drv)<>Qtt_Drv_Space Then TextColor(Red)
                              Else TextColor(LightGray);
Writeln('Free disk space (',Chr(Current_Drv+64),':)       : ',S1:14,S2:14,'    Bytes');
End;

{ͻ
                        PROCEDURE Done_DebOpenedWin                         
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test openened windows for debug information.                     
 ͼ}

Procedure Done_DebOpenedWin;
Begin
If Sys.WinOpenCount<>0 Then TextColor(Red)
                    Else TextColor(LightGray);
Writeln('Opened left windows        :              0',Sys.WinOpenCount:14);
End;

{ͻ
                            PROCEDURE DONE_DEBUG                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Show miscellaneous information about memory and disk.            
           Must be set at the end of the program.                           
 ͼ}

Procedure Done_Debug;
Var FName:String;
Begin
If Not BTST(Id_Msg1,14) Then Exit;      {*Not in Debug mode*}
Log.Add('Close Debug mode');
Log.Add('    Begining');

Writeln;
Writeln('                                     Before           Now');

Done_DebMemory;                         {*Test free memory*}
Done_DebDiskSpace;                      {*Test disk space*}
Done_DebOpenedWin;                      {*Test opened windows*}

Log.Add('    Ending');
{*Fill Stats file*}
FName:=Sys.GetPath(SP_DATAS)+'STATS.DAT';
Ini_UpdateKey(FName, 'System','Debugged programs',+1);

End;
(*
Procedure Disp_xy(x,y:Word;St:String);
Var i:Word;
Begin
For i:=1 to length(St) do Mem[$B0000+(y-1)*160+(x-1)*2+(i-1)*2]:=ord(St[i]);
End;

Procedure Disp_Clr;
Var i,j:integer;
Begin
For i:=1 to 80 do
 For j:=1 to 24 do Disp_xy(i,j,' ');
End;

Procedure Disp_(St:String);
Var i:Word;
Begin
For i:=1 to length(St) do Mem[$B0000+(i-1)*2]:=ord(St[i]);
End;*)

{*----------------------------- MAIN PROGRAM -------------------------------*}

Begin
Qtt_Mem_Avail  :=MemAvail;
Current_Drv:=Dsk_GetCurrentDrv;
Qtt_Drv_Space:=Diskfree(Current_Drv);
End.
