{ͻ
                               UNIT MosDialogs                              
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 15.12.1993                                                   
  COUNTRY....: Montpellier - IUT (FRANCE)                                   
  DESCRIPTION: Communications and Information Requesters Management.        
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 844 Lines and (25.536 Bytes compiled)                        
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosDialogs;

{$Mode Objfpc}

INTERFACE

Function  ShowMessage(Caption:String):Integer; {*Equal to the Delphi ShowMessage dialog*}
Procedure FunctionNotImplemented;

Function  Req_Dialog(Name,TXT,GAD:String; Var NUM:Integer):Integer;                            {*Dialog/Select Requester*}
Procedure Req_String(Name,TXT,GAD:String; NbCar,Size:Integer; Var Cin:String; Var NUM:Integer);{*String Input Requester*}
Procedure Req_Value(Name,TXT,GAD:String; BMin,BMax:Longint; Var Vai:Longint; Var NUM:Integer); {*Value Input Requester*}
Function  Req_List(Px,Py:Integer; Id:Word; Name,Title:String; Sep:Char; List:String):Longint;
Function  Req_BitsList(Px,Py:Integer; Id:Word; Title,DataSource,BitsIn:String; Sep:Char):String;
Procedure Req_Graphic(X1,Y1,X2,Y2:Integer; Bg_Color,Pen_Color,Title_Color,First_Color,Last_Color:Longint;
          First_Line,Espacement:Integer; Id:Word; WTitle,GTitle,XTitle,YTitle,FName:String);

{*----------------------------- Debut Library ------------------------------*}

IMPLEMENTATION

Uses
     SysUtils,
     MosBase,
     MosChart,
     MosColors,
     MosConfig,
     MosCPUInstructions,
     MosErrors,
     MosFiles,
     MosGadgets,
     MosGraph,
     MosImages,
     MosList,
     MosMouse,
     MosStrings,
     MosText,
     MosTools,
     MosWindows;

Type TDialog=Record
     TT:Array[1..20]of String[80];       {*Tableau des Textes*}
     GA       :String;                   {*Tableau des Gadgets*}
     NBT,NBG  :Word;                     {*Nombre de Textes et de Gadgets*}
     WinMax   :Integer;                  {*Taille Maximun de la Fenetre*}
     Wx1,Wy1,Wx2,Wy2:Integer;            {*Coordones du Screen a Ouvrir*}
     TG: Array[1..10] Of TButton;        {*Def Struct of Buttons Graphique*}
     Style    :Byte;                     {*Style Requester: 0=Ez, 1=String, 2=Value*}
     Size     :Integer;                  {*Taille en Pixels du Command_Resquest*}
     NbCar    :Byte;                     {*Nb de Char du Command_Request*}
     Pass     :Boolean;                  {*Mode Password=True*}
     NIco     :Byte;                     {*Numro de l'icne Associ*}
     Co1      :TInputText;               {*Structure pour Command_Request*}
     Cin      :String;                   {*String Interne pour Command_Request*}
     End;

{ͻ
                       PROCEDURE FunctionNotImplemented                     
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Dispaly a dialog box to explain that the requested function      
           is not implemented yet. The user can developpe it.               
 ͼ}

Procedure FunctionNotImplemented;
Var Num:Integer;
Begin
   Num := 1;
   Req_Dialog(Application.Name, Language.Loc(1756), '   _OK   ', Num);
End;

{ͻ
                            FUNCTION ShowMessage                            
 ͹
  IN.....: Txt (STRING) = Text to display in requester.                     
  OUT....: Result (INTEGER) = Index of the clicked Button.                  
  EXPLAIN: Equal to the Delphi ShowMessage dialog.                          
  EXAMPLE: ShowMessage('Hello world!');                                     
 ͼ}

Function ShowMessage(Caption:String):Integer;
Var Num:Integer;
Begin
   Num := 4;
   Req_Dialog(Application.Name, Caption, '   _OK   ', Num);
   Result := Num;
End;

{ͻ
                      CALCULE DATAS POUR EZ_REQUESTG                        
 ͼ}

Procedure MAKE_DATAS_REQUESTG(Name,Txt,Gad:String; Var EZR:TDialog);
Var A        :Integer;
    Pos      :Integer;                  {*Position dans les Strings*}
    SomT     :Integer;                  {*Longueur des Txt et des Gadgets*}
    Stem     :String;                   {*Char de Segmentation des Strings*}
    Id       :String[2];                {*Pour Valeurs Id*}
    DMX,DMY  :Integer;                  {*Delta Position Souris*}
    X,Y      :Word;                     {*Pour Position Souris*}
    Ga,Mi,Dr :Boolean;                  {*Status Boutons Souris*}
    O_Nbt    :Integer;                  {*Optimisations*}

Begin
For A:=1 to 10 do EZR.TT[A]:='';        {*Clear Tableau (by Fraggy)*}
EZR.GA:='';

If Copy(Txt,1,1)='#' Then Begin         {*Rcupre Id dans Txt*}
   Id:=Copy(Txt,1,2);
   Txt:=Copy(Txt,3,Length(Txt)-2);      {*Enlve Id du Txt*}
   End Else Id:='';                     {*Pas d'Id*}
A:=1; Pos:=1; SomT:=0;                  {*Scission des Textes et set in Tab*}

If Length(Txt)=255 Then Txt[255]:='|';  {*Rajoute Char de Fin*}
If Copy(Txt,Length(Txt),1)<>'|' Then Txt:=Txt+'|';{*Rajoute Char de Fin*}

Repeat
   Repeat
   Stem:=Copy(Txt,Pos,1); Inc(Pos,1);
   Inc(SomT,1);
   If Stem<>'|' Then EZR.TT[A]:=EZR.TT[A]+Stem;
   Until Stem='|';
Inc(A,1);                               {*Next Phrase*}
Until SomT>=Length(Txt);
EZR.NBT:=A-1; EZR.WinMax:=Length(EZR.TT[1]);{*Nombre de Phrases*}
For A:=2 to EZR.NBT do
    If Length(EZR.TT[A])>EZR.WinMax Then EZR.WinMax:=Length(EZR.TT[A]);
(*
A:=1; Pos:=1; SomT:=0;                  {*Scission des Gadgets et set in Tab*}
If Copy(Gad,Length(Gad),1)<>'|' Then Gad:=Gad+'|';{*Rajoute Char de Fin*}
Repeat
   Repeat
   Stem:=Copy(Gad,Pos,1); Inc(Pos,1);
   Inc(SomT,1);
   If Stem<>'|' Then EZR.GA[A]:=EZR.GA[A]+Stem;
   Until Stem='|';
Inc(A,1);                               {*Next Text Gadget*}
Until SomT>=Length(Gad);
EZR.NBG:=A-1;                           {*Nombre de Gadgets*}
*)

{SR}{EZR.NBG:=Str_Split(Gad,'|',EZR.GA);}  {*Stocke Textes Buttons...*}
If Gad[Length(Gad)]='|' Then SetLength(Gad,Length(Gad)-1);
EZR.NBG:=Str_Count(Gad,'|');  {*Stocke Textes Buttons...*}
EZR.GA:=Gad;
SomT:=0;
For A:=1 to EZR.NBG do Begin
   SomT:=SomT+Length(Str_Get(EZR.GA,A,'|'))+4; End;{*Calcule Taille Hz des Gadgets*}
If SomT-4>EZR.WinMax Then EZR.WinMax:=SomT;
Font_Set(Sys.FontWinTitle,Sys.FontWinTitleSize);    {*Fonte Title Window*}
If Length(Name)+3>EZR.WinMax Then EZR.WinMax:=Length(Name)+3;
Font_Set(Sys.FontMain,Sys.FontMainSize);      {*Fonte Gnrale*}

EZR.WinMax:=EZR.WinMax*(LaF+1)+30;      {*Calcule Coordonnes Screen*}
If (EZR.Style=1) Or (EZR.STYLE=2) Then
   If EZR.Size+20>EZR.WinMax Then EZR.WinMax:=EZR.Size+20;
O_Nbt:=((EZR.NBT+1)*HaF+HaF1) Div 2;    {*Optimisations*}
If (O_Nbt<27) Then O_Nbt:=27;           {*Taille Y Min...*}
If (EZR.NIco>=1) And (EZR.NIco<=Max_Ico) Then
   EZR.WinMax:=EZR.WinMax+80;           {*2 Icnes en plus...*}
EZR.Wx1:=(VESA_GetMaxX Div 2)-(EZR.WinMax Div 2);

EZR.Wx2:=(VESA_GetMaxX Div 2)+(EZR.WinMax Div 2);
EZR.Wy1:=(VESA_GetMaxY Div 2)-O_Nbt-20;      {130,190}
EZR.Wy2:=(VESA_GetMaxY Div 2)+O_Nbt+22;
If (Id='#0') Or (Id='#1') Then Begin    {*Centr sur Souris*}
   Mse_Get(X,Y,Ga,Mi,Dr);             {*Position Souris*}

   DMX:=(VESA_GetMaxX Div 2)-X; DMY:=(VESA_GetMaxY Div 2)-Y;
   EZR.Wx1:=EZR.Wx1-DMX;                {*Recalcule Position X*}
   EZR.Wx2:=EZR.Wx2-DMX;
   If Id='#0' Then Begin EZR.Wy1:=EZR.Wy1-DMY; EZR.Wy2:=EZR.Wy2-DMY; End;{*Centr Centre Souris*}
   If Id='#1' Then Begin A:=EZR.Wy2-EZR.Wy1; EZR.Wy2:=Y+(HaF Shr 1)+6; EZR.Wy1:=EZR.Wy2-A; End;{*Centr Ligne Gadget*}
   End;
If (EZR.Style=1) Or (EZR.Style=2) Then EZR.Wy2:=EZR.Wy2+HaF+10;{*Add Place pour String*}
End;

{ͻ
                       DESSINE LES BOX DU REQUESTER                         
 ͼ}

Procedure DRAW_BOX_REQUESTG(Mode:Boolean; Var E:TDialog; W:TWindow);
Var A,Px,Py,Med:Integer;
    Haut:Byte;                           {*Hauteur Barre pour Txt (Fnt)*}
    Offset:Byte;                         {*A Sub to Bevel Box for String*}
    IDC:Word;

Begin
Haut:=HaF1+4;                            {*Hauteur Box pour Fonte*}
If E.Style=0 Then Offset:=0;
If (E.Style=1) Or (E.Style=2) Then
   Begin
   If Mode=Yes Then IDC:=$21 Else IDC:=$20;
   If E.Style=2 Then IDC:=IDC+$100;      {*Affiche Chiffres Uniquement*}

   If E.Pass Then IDC:=IDC+$80;          {*Mode Password*}
   Offset:=HaF+10;
   Med:=(W.X2+W.X1) Div 2;
   InputText(Med-(E.Size Div 2),E.Wy2-HaF*2-20,E.Size,E.NbCar, CLMauve,CLSky,1,IDC,E.Co1,E.Cin);
   End;
Bevel (E.Wx1+10, E.Wy1+Haut+6, E.Wx2-10, E.Wy2-HaF-15-Offset, CLLightGrey,BLLoweredLine,BLNoLine,Yes);

For A:=1 to E.NBT do Begin
    Px:=(E.Wx2-E.Wx1) Div 2+E.Wx1+2-(Length(E.TT[A])*(LaF+1) Div 2);{*Pos X*}
    Py:=E.Wy1+17+(A-1)*HaF+HaF1;                                    {*Pos Y*}
    HText(Px,Py, CLText,E.TT[A]);       {*Define and display hypertext*}
    End;                                {*Aff Txt en Window*}
End;

{ͻ
               DESSINE LES GADGETS DU REQUESTER EN GRAPHIQUE                
 ͼ}

Procedure DRAW_GADGETSG(Var E:TDialog; W:TWindow);
Var  SomT     :Integer;                 {*Longueur des Txt et des Gadgets*}

     NBG      :Word;                    {*Nombre de Textes*}
     Wy2      :Word;                    {*Coordones du Screen a Ouvrir*}
     A,I      :Integer;                 {*Boucle*}
     O_l      :Integer;                 {*Optimisations*}
     IdBut    :Word;                    {*Id Buttons*}
     IcoName  :String;
Begin
NBG:=E.NBG;                             {*Recupere Parametres Record*}
Wy2:=E.Wy2;

SomT:=0;
For A:=1 to NBG do Begin                {*Calcule Taille Hz des Gadgets*}
    SomT:=SomT+Length(Str_Get(E.GA,A,'|'))*(LaF+1)+20;
    End;

A:=(E.Wx2-E.Wx1) Div 2+2-(SomT Div 2);  {*Pos X*}

Win_Clip(Yes,W);

For I:=1 to NBG do Begin                {*Aff Gadgets*}
   O_l:=Length(Str_Get(E.GA,I,'|'))*(LaF+1)+20;
   If I=1 Then IdBut:=$0110 Else IdBut:=$0000;
   Button(A, E.Wy2-E.Wy1-HaF1-HaF-16, O_l-8, -1, CLTextButton,CLBgButton,IdBut,E.TG[I],Str_Get(E.GA,I,'|'));
   A:=A+O_l;
   End;

Wy2:=(E.Wy1+E.Wy2) Div 2 -HaF-4;        {*Calcule Pos Y des Icnes*}

If E.Style>0 Then Wy2:=Wy2-HaF;

Case E.NIco of                          {*Select icon file*}
   1: IcoName:=Sys.ImgWarning;
   2: IcoName:=Sys.ImgStop;
   3: IcoName:=Sys.ImgQuestion;
   4: IcoName:=Sys.ImgInformation;
   5: IcoName:=Sys.ImgBomb;

   Else IcoName:='';
   End;

BMP_ShowTransparency(E.Wx1+LaF*4-E.Wx1-6, 011, E.Wx1+LaF*4+38-E.Wx1-6, 11+38, 0,0,
   Sys.GetPath(SP_BUTTONS)+IcoName, $0080, CLTransparency);
BMP_ShowTransparency(E.Wx2-LaF*10-E.Wx1-3, 011, E.Wx2-LaF*10+38-E.Wx1-3, 11+38, 0,0,
   Sys.GetPath(SP_BUTTONS)+IcoName, $0080, CLTransparency);

Win_Clip(No,W);
End;

{ͻ
                TEST DES GADGETS DES REQUESTERS GRAPHIQUES                  
 ͼ}

Procedure TEST_GADGETSG(Var NUM:Integer; Var EZR:TDialog; Var W:TWindow);
Var    NBG      :Word;                  {*Nombre de Textes*}
       I        :Integer;               {*Loop*}
Begin

NBG:=EZR.NBG;                           {*Recupre Parametres Record*}

Win_Clip(Yes,W);                        {*Clip Window*}
For I:=1 to NBG do                      {*Gadgets Normaux*}
   If Button_GetMsg(EZR.TG[I],1)=CMSelected Then NUM:=I;

Win_Clip(No,W);                         {*Clip Window*}
End;

{ͻ
                            FUNCTION Req_Dialog                             
 ͹
  IN.....: Name (STRING) = Window name.                                     
           Txt (STRING) = Text to display in requester.                     
           Gad (STRING) = Buttons and text buttons.                         
           Num (INTEGER) = Icon number to display :                         
                 1 = Warning icon                                           
                 2 = Stop icon                                              
                 3 = Question icon                                          
                 4 = Information icon                                       
                 5 = Bomb icon                                              
                 6 = Novell icon                                            
  OUT....: Num (INTEGER) = Number of the selected Button.                   
                   0    = Close requester Button                            
                   1..n = Users defined buttons                             
  EXPLAIN: Manage an EZ_Requester.                                          
           It's a common dialog requester that able you to select           
           a predicate by pressing a Button.                                
  EXAMPLE: Nam:='EZ REQUEST';                                               
           Txt:='Ok for the|gadget test';                                   
           Gad:='Ok|Cancel|Restore|';                                       
           EZ_RequestG(Nam,Txt,Gad,Num);                                    
  NB.....: Texts and buttons texts must be separated by '|'.                
           Maximum 10 buttons available for this Requester.                 
  NB2....: Using the "#0" in the "Txt" string => The requester is on mouse. 
 ͼ}

Function Req_Dialog(NAME,TXT,GAD:String; Var NUM:Integer):Integer;
Var  E  :TDialog;                          {*Type EZ_Requester*}
     W  :TWindow;                          {*Structure Window*}
     Even:Byte;                            {*Evenement Window*}
     Id :Word;                             {*IDCMP de la Fentre*}


Begin
Log.Add('Call Dialog request',1);
E.NIco:=NUM;                               {*Numro de l'Icne Associ*}
If Num=3 Then Play_SoundAction(7);              {*Play Sampled Sound*}
If Id_Err1 And $20<>$20 Then               {*On ne Traite plus l'Erreur*}
   Begin
   If Num=4 Then Play_SoundAction(8);           {*Play Sampled Sound*}
   If Num=1 Then Play_SoundAction(9);           {*Play Sampled Sound*}
   End;

NUM:=-1;                                   {*Flag de Sortie*}
E.Style:=0;                                {*Style EZ_Requester*}
E.Pass:=False;                             {*De Base sans PassWord*}
Mse_SetPointer(P_Current);                 {*Pointer to be Current*}
If Id_Err1 And $20=$20 Then Id:=$55D9 Else Id:=$51D9;{*Si Erreur => Lock TWindow*}
MAKE_DATAS_REQUESTG(Name,Txt,Gad,E);       {*Calcule Window Size*}
If Not Win_Init(E.Wx1,E.Wy1,E.Wx2,E.Wy2,Id,Name,W) Then Exit; {*Init Window*}
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0010,W); {*Suplement Window*}
E.Wx1:=W.X1; E.Wy1:=W.Y1;                  {*Change Coord Window if Modified*}
E.Wx2:=W.X2; E.Wy2:=W.Y2;
Mse_Hide;
Win_Draw(W);                               {*Draw Window*}
DRAW_BOX_REQUESTG(False,E,W);              {*Draw Text into*}
DRAW_GADGETSG(E,W);                        {*Draw Gadgets*}
Mse_Show;

Repeat
If Win_Ready(W) Then TEST_GADGETSG(NUM,E,W);{*Fentre OK ?*}

Even:=Win_Test(W);                      {*Evenements Window*}
   If Even=CMClosed Then NUM:=0;        {*Gere Window = Gadgets + Active*}
   If Even=CMMoved Then                 {*Test Dplacement Window*}
      Begin
      E.Wx1:=W.X1; E.Wy1:=W.Y1;
      E.Wx2:=W.X2; E.Wy2:=W.Y2;
      Mse_Hide;
      DRAW_BOX_REQUESTG(False,E,W);     {*Draw Text into*}
      DRAW_GADGETSG(E,W);               {*Draw Gadgets*}

      Mse_Show;
      End;
Until NUM<>-1;
Req_Dialog:=Num;                        {*Send result*}

Win_Done(W);                            {*Destroy Window*}
End;

{ͻ
                            PROCEDURE Req_Value                             
 ͹
  IN.....: Name (STRING) = Window name.                                     
           Txt (STRING) = Text to display in requester.                     
           Gad (STRING) = Buttons and text buttons.                         
           BMin (LONGINT)= Minimal value available.                         
           BMax (LONGINT)= Maximal value available.                         
           Vai (LONGINT) = Icon number to display.                          
           Num (INTEGER) = Icon number to display :                         
                 1 = Warning icon                                           
                 2 = Stop icon                                              
                 3 = Question icon                                          
                 4 = Information icon                                       
                 5 = Bomb icon                                              
                 6 = Novell icon                                            
  OUT....: Vai (LONGINT) = Value (Modified).                                
           Num (INTEGER) = Number of the selected Button.                   
                   0    = Close requester Button                            
                   1..n = Users defined buttons                             
  EXPLAIN: Manage a "Value_Requester".                                      
           Enable user to input a value (only numbers allowed).             
  EXAMPLE: Name:='VALUE REQUEST';                                           
           Txt:='Please input a value|Range is -10 +10';                    
           Gad:='Ok|Retry|Cancel|';                                         
           Req_Value(Name,Txt,Gad,-10,+10,Vai,Num);                         
  NB.....: Texts and buttons texts must be separated by '|'.                
           Maximum 10 buttons available for this Requester.                 
 ͼ}

Procedure Req_Value(Name,TXT,GAD:String; BMin,BMax:Longint; Var Vai:Longint; Var NUM:Integer);
Var  E   :TDialog;                         {*Type EZ_Requester*}
     W   :TWindow;                         {*Structure Window*}
     Even:Byte;                            {*Evenement Window*}
     Cin:String;                           {*Pour conversion du Nombre*}
     Code:Integer;                         {*Code Erreur conversion Nombre*}
     Save:String;                          {*Variable pour Sauvegarder Cin*}

Begin
Log.Add('Call Value request',1);
E.NIco:=NUM;                               {*Numro de l'Icne Associ*}
Str(Vai,Cin);
E.Style:=2;                                {*Style Value_Requester*}
E.Size:=80;                                {*Size Arbitraire*}
E.NbCar:=15;                               {*15 Char Maximum*}
E.Pass:=False;                             {*De Base sans PassWord*}
E.Cin:=Cin;
MAKE_DATAS_REQUESTG(Name,Txt,Gad,E);       {*Calcule Window Size*}
If Not Win_Init(E.Wx1,E.Wy1,E.Wx2,E.Wy2,$51D9,Name,W) Then Exit;{*Init Window*}
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0050,W); {*Suplement Window*}
E.Wx1:=W.X1; E.Wy1:=W.Y1;                  {*Change Coord Window if Modified*}
E.Wx2:=W.X2; E.Wy2:=W.Y2;
Mse_Hide;
Win_Draw(W);                               {*Draw Window*}
DRAW_BOX_REQUESTG(True,E,W);               {*Draw Text into*}
DRAW_GADGETSG(E,W);                        {*Draw Gadgets*}
Mse_Show;
NUM:=-1;                                   {*Flag de Sortie*}

Repeat
If Win_Ready(W) Then                    {*Window is Ready ?*}
   Begin
   TEST_GADGETSG(NUM,E,W);

   Save:=E.Cin;
   If InputText_GetMsg(E.Co1,E.Cin)=CMModified Then {*Value_Requester*}
      Begin
      Val(E.Cin,Vai,Code);                 {*Calcule Valeur Modifie*}
      If Vai<BMin Then Begin Win_Rename(Language.Loc(97),W); Play_Beep;
	 E.Cin:=Save; DRAW_BOX_REQUESTG(Yes,E,W); {DRAW_GADGETSG(E);} End;
      If Vai>BMax Then Begin Win_Rename(Language.Loc(98),W); Play_Beep;
	 E.Cin:=Save; DRAW_BOX_REQUESTG(Yes,E,W); {DRAW_GADGETSG(E);} End;
      If Code<>0 Then Begin Win_Rename(Language.Loc(99),W); Play_Beep;
	 E.Cin:=Save; DRAW_BOX_REQUESTG(Yes,E,W); {DRAW_GADGETSG(E);} End;
      If (Vai>=BMin) And (Vai<=BMax) And (Code=0) Then Begin Win_Rename(Name,W);
	 DRAW_BOX_REQUESTG(No,E,W); {DRAW_GADGETSG(E);} End;
      End;
   End;

Even:=Win_Test(W);                    {*Evenements Window*}
   If Even=CMClosed Then NUM:=0;                  {*Exit String RequestG*}
   If Even=CMMoved Then                          {*Test Dplacement Window*}
      Begin
      E.Wx1:=W.X1; E.Wy1:=W.Y1;
      E.Wx2:=W.X2; E.Wy2:=W.Y2;
      Mse_Hide;
      DRAW_BOX_REQUESTG(True,E,W);         {*Draw Text into*}
      DRAW_GADGETSG(E,W);                  {*Draw Gadgets*}
      Mse_Show;
      End;
Until NUM<>-1;                             {*Sortie*}
Val(E.Cin,Vai,Code);                       {*Renvois Valeur Modifie*}

Win_Done(W);                            {*Destroy Window*}
End;

{ͻ
                            PROCEDURE Req_String                            
 ͹
  IN.....: Name (STRING) = Window name.                                     
           Txt (STRING) = Text to display in requester.                     
           Gad (STRING) = Buttons and text buttons.                         
           NbCar (INTEGER) = Maximum caracters to input.                    
           Size (INTEGER) = Horizontal size in pixel for the input box.     
           Cin (STRING) = String Input / Ouput.                             
              If the first caracter is a $, then the requester is in        
              password mode (No caracters displayed).                       
           Num (INTEGER) = Icon number to display :                         
                 1 = Warning icon                                           
                 2 = Stop icon                                              
                 3 = Question icon                                          
                 4 = Information icon                                       
                 5 = Bomb icon                                              
                 6 = Novell icon                                            
  OUT....: Num (INTEGER) = Number of the selected Button.                   
                   0    = Close requester Button                            
                   1..n = Users defined buttons                             
           Cin (STRING) = String Input / Ouput.                             
  EXPLAIN: Manage a "String_Requester".                                     
           Enable user to input a string (or a password).                   
  EXAMPLE: Name:='STRING REQUEST';                                          
           Txt:='Please input a password||keys will not be displayed';      
           Gad:='Ok|Hold|Cancel';                                           
           Req_String(Name,Txt,Gad,40,120,Cin,Num);                         
  NB.....: Texts and buttons texts must be separated by '|'.                
           Maximum 10 buttons available for this Requester.                 
 ͼ}

Procedure Req_String(Name,TXT,GAD:String; NbCar,Size:Integer; Var Cin:String; Var NUM:Integer);
Var  E   :TDialog;                         {*Type EZ_Requester*}
     W   :TWindow;                         {*Structure Window*}
     Even:Byte;                            {*Evenement Window*}

Begin
Log.Add('Call String request',1);
E.NIco:=NUM;                               {*Numro de l'Icne Associ*}
E.Style:=1;                                {*Style String_Requester*}
E.Size:=Size;
If NbCar>255 Then NbCar:=255;              {*Test Maximum...*}
E.NbCar:=NbCar;                            {*Nb de Char Maximum*}
E.Pass:=False;
If Cin[1]='$' Then Begin                   {*Mode Mot de Passe ?*}
   Delete(Cin,1,1); E.Cin:=Cin; E.Pass:=True;
   End Else E.Cin:=Cin;
MAKE_DATAS_REQUESTG(Name,Txt,Gad,E);       {*Calcule Window Size*}
If Not Win_Init(E.Wx1,E.Wy1,E.Wx2,E.Wy2,$51D9,Name,W) Then Exit;{*Init Window*}
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0050,W); {*Suplement Window*}

E.Wx1:=W.X1; E.Wy1:=W.Y1;                  {*Change Coord Window if Modified*}
E.Wx2:=W.X2; E.Wy2:=W.Y2;
Mse_Hide;
Win_Draw(W);                               {*Draw Window*}
DRAW_BOX_REQUESTG(True,E,W);               {*Draw Text into*}
DRAW_GADGETSG(E,W);                        {*Draw Gadgets*}
Mse_Show;
NUM:=-1;                                   {*Flag de Sortie*}

Repeat
If Win_Ready(W) Then                    {*Window is Ready ?*}
   Begin
   TEST_GADGETSG(NUM,E,W);
   InputText_GetMsg(E.Co1,E.Cin);            {*Co_RequestG String-Line*}
   End;

Even:=Win_Test(W);                    {*Evenements Window*}

   If Even=CMClosed Then NUM:=0;                  {*Exit String RequestG*}
   If Even=CMMoved Then                          {*Test Dplacement Window*}
      Begin
      E.Wx1:=W.X1; E.Wy1:=W.Y1;
      E.Wx2:=W.X2; E.Wy2:=W.Y2;
      Mse_Hide;

      DRAW_BOX_REQUESTG(True,E,W);         {*Draw Text into*}
      DRAW_GADGETSG(E,W);                  {*Draw Gadgets*}
      Mse_Show;
      End;
Until NUM<>-1;                             {*Sortie*}
Cin:=E.Cin;                                {*Renvois String Modifi*}

Win_Done(W);                            {*Destroy Window*}
End;

{ͻ
                           FUNCTION Req_BitsList                            
 ͹
  IN.....: Px,Py (INTEGER) = Requester position.                            
           Id (WORD) = Bits configuration.                                  
               Bit 0  $0001 : 1 = Put requester in the screen center.       
               Bit 1  $0002 : 1 = Maximise window size for full list.       
           Title (STRING) = Window title.                                   
           DataSource (STRING) = Path and list filename.                    
              Structure of the datafile :                                   
                  Column   Type      Description                            
                     1     Byte      Bit number (0 to 15)                   
                     2     HexWord   Hexadecimal word bit value (0 to $FFFF)
                     3     Boolean   ('E'=Editable, '-'=Non editable)       
                     4     Boolean   ( 1 =Tagged, 0=Untagged )              
                     5     String    Bit description                        
              Line Exemple: '00;$0001;E;0;This is the bit 0'                
           BitsIn (STRING) = List bits to initialise:                       
              Must be an hexadecimal string[4]. Ex: '4A6B'                  
           Sep (CHAR) = List column separator.                              
  OUT....: (STRING) = List bits defined (4 Chars). Ex: '10FA'               
  EXPLAIN: Display a list of bits in a window and allow user to modify      
           the bits values. Tagged bits are returned in a 4 chars string.   
  NB.....: If the cancel button is pressed, requester return initial value. 
 ͼ}

Function Req_BitsList(Px,Py:Integer; Id:Word; Title,DataSource,BitsIn:String; Sep:Char):String;
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    XOk,XCancel   :Boolean;             {*Flag de Sortie*}
    But1          :TButton;             {*Structure Boutons*}
    L             :TList;               {*Structure List*}
    Half,HalfT    :Integer;             {*Half size of title*}
    A,B,Code      :Integer;             {*Window Coordinates*}
    LastRes,Res   :Longint;             {*Rsultat Liste Clicke*}
    IBitsIn       :Word;                {*Bits pour surcharge de la dfinition*}
    PrevBits      :String;              {*Previous defined bits*}
    BitVal        :Integer;             {*Numro du bit*}
    VTemp         :Word;                {*Valeur pour calcul temporaire*}
    St            :String;              {*Title List Temp*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Button (Half-LaF*8, W1.Y2-W1.Y1-HaF1-HaF-10, LaF*16,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
List_Show(L);                           {*Display the List*}
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Log.Add('Call BitList request',1);

Req_BitsList:=BitsIn;                   {*Fichier Introuvable*}
If Not File_TestExist(DataSource) Then
   Begin
   Error(790); Exit;
   End;

PrevBits:=BitsIn;                       {*Pour Cancel*}
Half :=(VESA_TextWidth(File_GetLongString(DataSource)) Div 2)+30;
HalfT:=(VESA_TextWidth(Title) Div 2)+56;
If HalfT>Half Then Half:=HalfT;
If Half<LaF*20 Then Half:=LaF*20;
If Half>VESA_GetMaxX Div 2 Then Half:=VESA_GetMaxX Div 2;
If BTST(Id,0) Then Begin
   Px:=(VESA_GetMaxX Div 2)-Half;       {*Window coordinates*}
   Py:=(VESA_GetMaxY Div 2)-HaF*10;
   End;

If Not Win_Init(Px,Py,Px+Half*2,Py+HaF1+HaF*7+3+File_CountLines(DataSource)*(HaF+2),$51F9,Title,W1) Then Exit;
If Not Win_Sup(100,50,250,200,59,50,410,250,0,CLWinBorder,$0A10,W1) Then Exit;
Win_Draw(W1);                           {*Affiche la Fentre*}

St:=Language.Loc(61);
List_Define(L,Str_Get(St,1,';')+Sep+Str_Get(St,2,';')+Sep+'E'+Sep+'T'+Sep+Str_Get(St,3,';'),
            Sep,20, 20, W1.X2-W1.X1-20, W1.Y2-W1.Y1-HaF1-HaF*4+3, 130, CLWhite,CLSky,$1649);
List_SetIdMore(L,$000A);                {*No ENTER, F5*}
List_Load(L,DataSource);                {*Load the History*}
List_AdjustColumn(L,2);
List_AdjustColumn(L,5);
List_SetColumnAttr(L,1,35,Text_Center);
List_HideColumn(L,3,TRUE);              {*Hide column 3 and 4*}
List_HideColumn(L,4,TRUE);
For A:=1 to List_GetQttItems(L) do
   Begin
   If List_GetStringCell(L,A,3)='-' Then List_SetIdItem(L,A,$0001);
   If List_GetStringCell(L,A,4)='1' Then List_SetBkColorItem(L,A,CLLightGrey);
   End;
If BitsIn<>'' Then                      {*Bits de dfinitions (Surcharge)*}
   Begin
   IBitsIn:=Str_H2L(BitsIn);
   For A:=0 to 15 do If BTST(IBitsIn,A) Then
      Begin                             {*Tag wanted bits by user*}
      For B:=1 to 16 do
         Begin
         Val(List_GetStringCell(L,B,1),VTemp,Code);
         If A=VTemp Then List_SetBkColorItem(L,B,CLLightGrey);
         End;
      End;
   End;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
XOk:=FALSE; XCancel:=FALSE;             {*Init Flag de Sortie*}


Repeat
try
;
If Win_Ready(W1) Then                   {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Personnels*}
   Win_Clip(Yes,W1);
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=TRUE; {*Exit => Ok*}
   Res:=List_Test(L);                   {*Test de la Liste*}
   If Res<>0 Then LastRes:=Res;
   If (List_TestMouseOnList(L)=1) And (Mse_TestDoubleClick) Then
      Begin
      If List_GetColorLine(L,LastRes)<>7 Then List_SetBkColorItem(L,LastRes,CLLightGrey)
                                         Else List_SetBkColorItem(L,LastRes,CLWhite);
      List_ShowItem(L,LastRes);         {*Display modified item*}
      End;
   Win_Clip(No,W1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then XCancel:=True;           {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Flag de Sortie*}

Win_Done(W1);                           {*Supprime Fentre*}
If XCancel Then Req_BitsList:=PrevBits
   Else Begin                           {*Renvois rsultat*}
   IBitsIn:=0;
   For A:=0 to 15 do If List_GetColorLine(L,A+1)=CLLightGrey Then
      Begin
      Val(List_GetStringCell(L,A+1,1),BitVal,Code);
      BSET(IBitsIn,BitVal);
      End;
   Req_BitsList:=Str_L2H(IBitsIn,4);
   End;
List_Done(L);                           {*Supprime la Liste*}
End;

{ͻ
                             FUNCTION Req_List                              
 ͹
  IN.....: Px,Py (INTEGER) = Requester position.                            
           Id (WORD) = Bits configuration.                                  
               Bit 0  $0001 : 1 = Put requester in the screen center.       
               Bit 1  $0002 : 1 = Maximise window size for full list.       
           Name (STRING) = Title requester.                                 
           Title (STRING) = List title.                                     
           Sep (CHAR) = List separator.                                     
           List (TList) = Path and list filename.                           
  OUT....: (LONGINT) = Position in list of the selected item.               
  EXPLAIN: Display a list in a window. List is loaded from a list file.     
 ͼ}

Function Req_List(Px,Py:Integer; Id:Word; Name,Title:String; Sep:Char; List:String):Longint;
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    XOk           :Boolean;             {*Flag de Sortie*}
    But1          :TButton;             {*Structure Boutons*}
    L             :TList;               {*Structure List*}
    Half,HalfT    :Integer;             {*Half size of title*}
    Res           :Longint;             {*Rsultat Liste Clicke*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Button (Half-040, W1.Y2-W1.Y1-HaF1-026,080, -1, CLTextButton,CLBgButton,$0110,But1,'_OK');
List_Show(L);                           {*Display the List*}
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Log.Add('Call List request',1);

Half :=(VESA_TextWidth(File_GetLongString(List)) Div 2)+30;
HalfT:=(VESA_TextWidth(Title) Div 2)+56;
If HalfT>Half Then Half:=HalfT;
If Half<100 Then Half:=100;
If Half>VESA_GetMaxX Div 2 Then Half:=VESA_GetMaxX Div 2;
If BTST(Id,0) Then Begin
   Px:=(VESA_GetMaxX Div 2) - Half;     {*Window coordinates*}
   Py:=(VESA_GetMaxY Div 2) - 100;
   End;

If Not Win_Init(Px,Py,Px+Half*2,Py+HaF1+220,$51F9,Name,W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWInBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                           {*Affiche la Fentre*}

List_Define(L,Title,Sep,019,014,W1.X2-W1.X1-022, W1.Y2-W1.Y1-HaF1-043, 1000, CLWhite,CLSky,$130D);
List_SetIdMore(L,$0008);                {*No ENTER*}
List_Load(L,List);                      {*Load the History*}
List_AdjustColumns(L);

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
XOk:=FALSE;                             {*Init Flag de Sortie*}

Repeat
try

If Win_Ready(W1) Then                   {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Personnels*}
   Win_Clip(Yes,W1);
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=TRUE;      {*Exit*}
   Res:=List_Test(L);                   {*Test de la Liste*}
   If (List_TestMouseOnList(L)=1) And (Mse_TestDoubleClick) Then XOk:=TRUE;
   Win_Clip(No,W1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then XOk:=True;               {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until XOk;                              {*Flag de Sortie*}

Win_Done(W1);                           {*Supprime Fentre*}
List_Done(L);                           {*Supprime la Liste*}
Req_List:=Res;                          {*Renvois rsultat*}
End;

{ͻ
                           PROCEDURE Req_Graphic                            
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Requester coordinates.                   
           Bg_Color (LONGINT) = Define the background color.                
           Pen_Color (LONGINT) = Define the pen color.                      
           Title_Color (LONGINT) = The titles color.                        
           First_Color (LONGINT) = The first color to fill bars.            
           Last_Color (LONGINT) = The last color to fill bars.              
           First_Line (INTEGER) = First line to read values in the datafile.
           Espacement (INTEGER) = Space between each bar (in pixels).       
           Id (WORD) = Bits configuration (See "Graph_Define" function).    
           WTitle (STRING) = The window title.                              
           GTitle (STRING) = The main Graphic title.                        
           XTitle (STRING) = The X title.                                   
           YTitle (STRING) = The Y data title.                              
           FName (STRING) = The data filename.                              
  OUT....: /                                                                
  EXPLAIN: Display a bar graphic in window using a data file value.         
 ͼ}

Procedure Req_Graphic(X1,Y1,X2,Y2:Integer;Bg_Color,Pen_Color,Title_Color,First_Color,Last_Color:Longint;
          First_Line,Espacement:Integer; Id:Word; WTitle,GTitle,XTitle,YTitle,FName:String);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flags*}
    G             :TGraphic;
    But1          :TButton;
    Cyc1,Cyc2,Cyc3:TCycler;
    TName         :String;              {*Noms fichier*}
    CTri,STri     :Byte;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_GRAPH;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
Graph_Define(G,019,014,W1.X2-W1.X1-21,W1.Y2-W1.Y1-HaF1-HaF-32, 2,GT_HISTORYGRAME,Id,TName);

Graph_DefineTitles(G,GTitle,XTitle,YTitle);
Graph_DefineColors(G,Bg_Color,Pen_Color,Title_Color,First_Color,Last_Color);
Graph_DefineMore(G,'MODN.CHR',4,First_Line,Espacement);
Graph_BuildData(G);                     {*Prcalcule le Graphe*}
Graph_Display(G);
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}

Button(027, W1.Y2-W1.Y1-HaF1-HaF-19, 21,21, CLTextButton,CLBgButton,$0278,But1,
       Sys.GetPath(SP_BUTTONS)+'BP_04A.BMP|'+Sys.GetPath(SP_BUTTONS)+'BP_04B.BMP');
Cycler(049, W1.Y2-W1.Y1-HaF1-HaF-19, 21, Cyc1.CyclVal, CLTextButton,CLBgButton,$8278,Cyc1,
       Sys.GetPath(SP_BUTTONS)+'BP_07A.BMP|'+Sys.GetPath(SP_BUTTONS)+'BP_07B.BMP');
Cycler(071, W1.Y2-W1.Y1-HaF1-HaF-19, 21, Cyc2.CyclVal, CLTextButton,CLBgButton,$8278,Cyc2,
       Sys.GetPath(SP_BUTTONS)+'BP_05A.BMP|'+Sys.GetPath(SP_BUTTONS)+'BP_06A.BMP');
Cycler(093, W1.Y2-W1.Y1-HaF1-HaF-19, 21, Cyc3.CyclVal, CLTextButton,CLBgButton,$8278,Cyc3,
       Sys.GetPath(SP_BUTTONS)+'BP_08A.BMP|'+Sys.GetPath(SP_BUTTONS)+'BP_08B.BMP');

REDRAW_GRAPH;                           {*Define Graphique*}

Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
Log.Add('Call Graphic request',1);

If Not File_TestExist(FName) Then Exit; {*Fichier introuvable !*}
TName:=File_BuildNextName(Sys.GetPath(SP_TEMP)+'EZGRA.LIS', FEValue);
If File_Copy(FName,TName)>0 Then Exit;  {*Impossible de crer le fichier*}

If Not Win_Init(X1,Y1,X2,Y2,$51FD,WTitle,W1) Then Exit;
Win_Sup(100,50,250,200,430,244,VESA_GetMaxX,VESA_GetMaxY,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

Cyc1.CyclVal:=1;
Cyc2.CyclVal:=1;
Cyc3.CyclVal:=1;
CTri:=1;                                {*Colonne 1*}
STri:=Sort_AZ;                          {*Sens AZ*}

REDRAW_FRAME;                           {*Display Window Content*}
XOk:=No; XCancel:=No;                   {*Init Exit Flags*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then

      Begin
      File_Copy(FName,TName);           {*No sort*}
      REDRAW_GRAPH;
      End;
   If Cycler_GetMsg(Cyc1,1)=CMSelected Then
      Begin
      If Cyc1.CyclVal=1 Then CTri:=1 Else CTri:=2;
      File_Sort(TName,CTri,STri,CTri,';');  {*Sort by Values*}
      REDRAW_GRAPH;
      End;
   If Cycler_GetMsg(Cyc2,1)=CMSelected Then
      Begin
      If Cyc2.CyclVal=1 Then STri:=Sort_AZ Else STri:=Sort_ZA;
      File_Sort(TName,CTri,STri,CTri,';');  {*Sort Direction*}
      REDRAW_GRAPH;
      End;
   If Cycler_GetMsg(Cyc3,1)=CMSelected Then {*Proportional Colors*}
      Begin
      If Cyc3.CyclVal=2 Then BSET(Id,9) Else BCLR(Id,9);
      REDRAW_GRAPH;
      End;

   Win_Clip(No,W1);                     {*Clipping Window*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;            {*Window Closed   => Exit*}
If Even=CMResized Then REDRAW_FRAME;            {*Window Resized  => Display Content*}
If Even=CMMoved Then REDRAW_FRAME;            {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flags*}

Win_Done(W1);                           {*Close Window if Needs*}
File_Erase(TName);                      {*Delete File Temporary File*}
End;

{*------------------------ PAS DE PROG PRINCIPAL ---------------------------*}

Begin
End.
