{ͻ
                              UNIT MosDirectory                             
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 15.12.1993                                                   
  COUNTRY....: Montpellier - IUT (FRANCE)                                   
  DESCRIPTION: Directory and File Management.                               
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 1.552 Lines and (48.688 Bytes compiled)                      
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosDirectory;

{$Mode Objfpc}

(*File Requester: Bit Lock in drawer qui empche de sortir du drawer pr-slectionn.*)

INTERFACE

Uses
     MosList;

Type

TBrowse=Record                          {*File Selector structure*}
   List                 :TList;         {*List to display files*}
   IdComportement       :Word;
   IdFunctions          :Word;          {*Define gadget functions*}
   IdLook               :Word;          {*Define gadget visual aspect*}
   IdColumns            :Word;          {*Define displayed columns*}
   CurrentPath          :String;        {*Current path*}
   CurrentFile          :String;        {*Current file*}
   Mask                 :String;        {*Current mask*}
   ConfigFile           :String;        {*Default config file to use*}

   LockDrawer           :Boolean;       {*Locked in current drawer (cannot browse)*}
   End;

Procedure Req_XCopy          (Px,Py:Integer; Id:Word; Title,Source,Target:String); {*Copy requester*}
Procedure Req_FileInformation(Px,Py:Integer; FName,Title:String); {*Display file information*}
Procedure Req_FileManager    (X1,Y1,Sv:Integer; Name,OkBut,Mask:String; Style:Byte; Var DirSel,FilSel:String; Var Size:Longint); {*Select a File/Path*}

//Procedure Browse           (Var Df:TBrowse; X1,Y1,X2,Y2:Integer; IdFunctions,IdLook,IdColumns:Word; Location,Mask:String); {*Create a default File selector*}
//Procedure Browse           (Var Df:TBrowse; X1,Y1,X2,Y2:Integer; Color1,Color2:Longint; IdFunctions,IdLook,IdColumns:Word; Location,Mask:String); {*Create a custom File selector*}
Procedure Browse_Define    (Var Df:TBrowse; X1,Y1,X2,Y2:Integer; Color1,Color2:Longint; IdFunctions,IdLook,IdColumns:Word; Location,Mask:String); {*Define a File selector*}
Procedure Browse_Done      (    Df:TBrowse);         {*Terminate the File selector*}
Function  Browse_LoadConfig(Var Df:TBrowse):Boolean; {*Load default configuration for the File selector*}
Function  Browse_SaveConfig(    Df:TBrowse):Boolean; {*Save default configuration of the File selector*}
Procedure Browse_Draw      (    Df:TBrowse);         {*Draw the File Selector*}
Procedure Browse_Refresh   (    Df:TBrowse);         {*Refresh the File Selector*}
Procedure Browse_Update    (Var Df:TBrowse);         {*Update list of the File Selector*}
Function  Browse_GetMsg    (Var Df:TBrowse):Byte;    {*Get messages from File selector*}

{*----------------------------- Dbut Library ------------------------------*}

IMPLEMENTATION

Uses
     Dos,
     IniFiles,
     SysUtils,
     Windows,
     MosBase,
     MosColors,
     MosConfig,
     MosCPUInstructions,
     MosDialogs,
     MosDisks,
     MosErrors,
     MosExecute,             // To delete when the Show_Gfx function will be transfered in MosImages.pas
     MosFiles,
     MosFilesTree,
     MosGadgets,
     MosGraph,
     MosGraphics,
     MosImages,
     MosKeyboard,
     MosMemory,
     MosMouse,
     MosSound,
     MosStrings,
     MosTab,
     MosTasks,
     MosText,
     MosTools,
     MosWindows;

{ͻ
                       PROCEDURE Req_FileInformation                        
 ͹
  IN.....: Px,Py (INTEGER) = X,Y coordinates for the requester.             
           FName (STRING) = Filename to get information.                    
           Title (STRING) = Requester title.                                
  OUT....: /                                                                
  EXPLAIN: Get and display information on a file depending the filetype.    
  EXAMPLE: Req_FileInformation(100,50,'TOTO.EXE','Information');            
 ͼ}

Procedure Req_FileInformation(Px,Py:Integer; FName,Title:String);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flag*}
    But1,But2     :TButton;             {*Buttons Structure*}
    Tab1          :TTabs;               {*Tab structure*}
    LabelTabs     :String;              {*Tab labels*}
    Inf           :TFileInfo;           {*Get file information*}
    R1,R2,R3,R4   :TCheckBox;           {*File attributes*}
    Attributes    :Word;                {*Attributes result*}
    F             :Text;
    Compression   :String;              {*Compression*}
    IHSize,IVSize :Word;
    Colors        :Longint;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
Tabs (008,008,290,268,Tab1.No, CLLightGrey,CLLightGrey,$0014,Tab1,LabelTabs);

Case Tab1.No of                         {*Display Tabs components*}
   1: Begin
      Show_Icon(020,040,Get_FileIcon(FName,M_Extention));
      Display(060,034,CLText,'Name:     '+Inf.Name);
      Display(060,045,CLText,'DOS Name: '+Inf.DOSName);
      Display(060,056,CLText,'Drawer:   '+Inf.Path);
      Tool_line(012,076,285,076,1,1);
      Display(020,087,CLText,'Type:      '+Inf.FileDescription);
      Display(020,098,CLText,'Size:      '+Inf.Size);
      Display(020,109,CLText,'Real size: '+Inf.RealSize);
      Tool_line(012,135,285,135,1,1);
      Display(020,145,CLText,'Created:   '+Inf.Created);
      Display(020,156,CLText,'Modified:  '+Inf.Modified);
      Display(020,167,CLText,'Used:      '+Inf.Used);
      Tool_line(012,190,285,190,1,1);
      Display(020,200,CLText,'Attributes:');
      RadioBox(100,200, 1,$0010,0,0,R1.Status,R1,'Archive');
      RadioBox(100,215, 1,$0010,0,0,R2.Status,R2,'Read only');
      RadioBox(100,230, 1,$0010,0,0,R3.Status,R3,'Hidden');
      RadioBox(100,245, 1,$0010,0,0,R4.Status,R4,'System');
      End;
   2: Begin
      If Inf.FileType=1 Then
         Begin                          {*Program file*}
         Display(020,034,CLText,'Program: ');
         Tool_line(012,087,285,087,1,1);
         End;
      If Inf.FileType=2 Then
         Begin                          {*Image file*}
         BMP_GetInfo(FName,IHSize,IVSize,Colors);
         Compression:='';
         Display(020,034,CLText,'Horizontal size: '+Str_Format(Str_L2S(IHSize),' ',3));
         Display(020,045,CLText,'Vertical size:   '+Str_Format(Str_L2S(IVSize),' ',3));
         Display(020,056,CLText,'Color depth:     '+Str_L2S(Colors));
         Display(020,067,CLText,'Compression:     '+Compression);
         Tool_line(012,087,285,087,1,1);
         BMP_Show(040,100,260,255, 0,0,FName,$00A0);
         End;
      End;
   End;

Button (060,274,080,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
Button (160,274,080,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
Log.Add('Call FileInformation Request',1);
If Not Get_FileInformation(FName,Inf) Then Exit; {*Get informations about the file*}

If Not Win_Init(Px,Py,Px+300,Py+HaF1+300,$51D9,Title,W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBg,$0A50,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

LabelTabs:='_General';
If Inf.FileType>0 Then LabelTabs:=LabelTabs+'|_'+Inf.FileTypeString;

Tab1.No:=1;
If Inf.AttrArchive  Then R1.Status:=Yes Else R1.Status:=No;
If Inf.AttrReadOnly Then R2.Status:=Yes Else R2.Status:=No;
If Inf.AttrHidden   Then R3.Status:=Yes Else R3.Status:=No;
If Inf.AttrSystem   Then R4.Status:=Yes Else R4.Status:=No;

REDRAW_FRAME;                           {*Display Window Content*}
XOk:=No; XCancel:=No;                   {*Init Exit Flag*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes;
   If Button_GetMsg(But2,1)=CMSelected Then XCancel:=Yes;
   If Tabs_GetMsg(Tab1,1)=CMSelected Then REDRAW_FRAME;
   RadioBox_GetMsg(R1,1);
   RadioBox_GetMsg(R2,1);
   RadioBox_GetMsg(R3,1);
   RadioBox_GetMsg(R4,1);
   Win_Clip(No,W1);                     {*Clipping Window*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;     {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flag*}

Win_Done(W1);                           {*Close Window if Needs*}

If XOk Then                             {*Validate modifications*}
   Begin
   Attributes:=0;
   If R1.Status Then Attributes:=Attributes Or Archive;
   If R2.Status Then Attributes:=Attributes Or ReadOnly;
   If R3.Status Then Attributes:=Attributes Or Hidden;
   If R4.Status Then Attributes:=Attributes Or SysFile;
   Assign(F,FName);
   SetFAttr(F,Attributes);
   End;
End;

{ͻ
                            PROCEDURE Req_XCopy                             
 ͹
  IN.....: Px,Py (INTEGER) = X,Y coordinates for the requester.             
           Id (WORD) = Options bits : (None)                                
           Title (STRING) = Title requester.                                
           Source (STRING) = Source directory to copy.                      
           Target (STRING) = Target directory.                              
           Name (STRING) : Name of the file to change the attributes.       
  OUT....: /                                                                
  EXPLAIN: Call a XCopy Requester and copy recursively a source directory   
           to a target directory.                                           
  EXAMPLE: Req_XCopy(100,50,$0000,'COPYING...','C:\DOS','D:\DOSBACK');      
 ͼ}

Type ListFiles=Record
     Qte:LongInt;
     T:TArray;
     End;

Var LF:ListFiles;

Procedure LFFileDoer(x:PathStr);
Begin
Inc(LF.Qte);
Array_Put(LF.T,LF.Qte,x);
End;

Procedure Init_ListFiles(Source:String;Recurse:Boolean);
Var Total:Longint;
    S:String;
Begin
LF.Qte:=0;
Total:=File_Count(Source,Recurse);
Array_Init(LF.T,1,Total,S,Sizeof(S));

File_Find(Source,Recurse,@LFFileDoer);
End;

Procedure Kill_ListFiles;
Begin
Array_Done(LF.T);
End;

Procedure Req_XCopy(Px,Py:Integer; Id:Word; Title,Source,Target:String);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Window Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flags*}
    But1,But2     :TButton;             {*Buttons Structures*}
    IdBp          :Word;                {*Id des Bar Progress*}
    Pc            :Integer;             {*Position dans la Copie pour les icones*}
    Res           :Integer;             {*EZ dialog*}
    Num           :Integer;             {*Returned Error*}
    Action        :Integer;             {*Action automatique*}
    Cp,Total      :Longint;
    A             :TAnimate;            {*Animation structure*}
    SMask,SPath,T,TPath,TMask:String;
    i:longint;
    S:String;

{************************ DISPLAY COPY INFORMATION **************************}

Procedure REDRAW_INFOS(Mode:Byte);      {*Draw copy information*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}

{St:=Str_FillZero(Pc,2);
FName:=Sys.GetPath(SP_ANIMS)+'COPY_'+St+'.BMP';
BMP_Show(20,10,20+256,10+53,0,0,FName,$0080);}
Anim_GetMsg(A);                         {*Display animation*}

Bar_Progress(20,70,300,82, CLLightBlue,100*Cp Div Total,IdBp);
If Mode=0 Then Display(19,102, CLText,Language.Loc(1712))
   Else Begin

   Display(019,102, CLText,Language.Loc(1711)+TPath+Str_Spaces(38));
   Display(019,092, CLText,Language.Loc(1710)+TMask+Str_Spaces(38));
   End;
IdBp:=$0000;

Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Var WSx,WSy:Integer;
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
WSx:=W1.X2-W1.X1; WSy:=W1.Y2-W1.Y1-HaF1-HaF-10;

Tool_Line(WSx, WSy-14, 0, WSy-14, 0,1);

Button (WSx-LaF*48-1, WSy-6, LaF*20,-1, CLTextButton,CLBgButton,$0170,But1,Str_Get(Language.Loc(1722),1,'|'));
Button (WSx-LaF*24-1, WSy-6, LaF*20,-1, CLTextButton,CLBgButton,$0070,But2,Str_Get(Language.Loc(1722),2,'|'));
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{************************ PROBLEME LORS DE LA COPIE *************************}

Procedure XCopyError(E:Integer);        {*Erreur de creation de rpertoire*}
Var Num:Integer;
    St:String;
Begin
XCancel:=TRUE;
St:='';
Num:=4;
Case E of
   00 : St:=Language.Loc(1717);
   01 : St:=Language.Loc(1718);
   02 : St:=Language.Loc(1719);
   03 : St:=Language.Loc(1720);
   04 : St:=Language.Loc(1721);
   End;
Req_Dialog(Language.Loc(1716),St,'   _OK   ',Num);
End;

{***************************** MAIN PROCEDURE *******************************}

Var TT:String;
Begin
Log.Add('Call XCopy Request',1);

// To avoid warnings !
Id := Id;

If Not Win_Init(Px,Py,Px+LaF*64+3,Py+HaF1+HaF*16,$51F9,Title,W1) Then Exit;
If Not Win_Sup(100,50,250,200,79,60,639,479,0,CLLightGrey,$0A40,W1) Then Exit;
Win_Draw(W1);                           {*Display Window*}

Anim(A,019,004,019+256,004+53, 0,0,Sys.GetPath(SP_ANIMS)+'COPY_',$0080);

REDRAW_FRAME;                           {*Display Window Content*}
XOk:=No; XCancel:=No;                   {*Init Exit Flags*}
Pc:=0; IdBp:=$0001;

Action:=0;                              {*Pas d'action automatique de base*}

File_Split(Source,SPath,SMask);
If SPath[length(SPath)]<>'\' then SPath:=SPath+'\';
If SMask='' Then SMask:='*.*';

Cp:=0; Total:=1;
REDRAW_INFOS(0);                        {*Draw copy information*}
Total:=File_Count(Str_CorrectPath(SPath+SMask),True); {*Nombre total de fichiers a copier*}

Init_ListFiles(Source,true);
i:=1;

if LF.QTE>1 then
Repeat
try


Array_Get(LF.T,i,s);
inc (i);

T:=File_TargetFileName(Spath,Target,S);
File_Split(T,TPath,TMask);

{BUG}If False Then XCopyError(0);            {*Pas de place disponible*}
{*Mettre les bonnes valeur dans les champs*}

If File_TestExist(T) Then               {*Problme ! => Question*}
   If (Action=0) Or (Action=2) Or (Action=4) Then
      Begin
      Num:=3;
      Req_Dialog(Language.Loc(1713),Language.Loc(1714),Language.Loc(1715),Num);
      Case Num of
         00 : XCancel:=TRUE;
         01 : Action:=1;
         02 : Action:=2;
         03 : Action:=3;
         04 : Action:=4;
         05 : XCancel:=TRUE;
         End;
      End;

If (Not XCancel) And (Not Dsk_Mkdir(TPath)) Then XCopyError(1);{*Erreur de creation de rpertoire*}
If Not XCancel Then                     {*ERREUR !*}
   Begin

   If (Action<>3) And (Action<>4) Then
      Begin
      TT:=File_SetMask(SPath,S,T);
      Dsk_Mkdir(File_StrSplit(TT,3));
      Res:=File_Copy(S,TT);
      If Res>=2 Then XCopyError(Res);
      End;
   End;

Inc(Cp);
If (Action=2) Or (Action=4) Then Action:=0;{*Demande Again le Requester*}

If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                     {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XCancel:=TRUE;
   If Button_GetMsg(But2,1)=CMSelected Then {*Button "PAUSE"*}
      Begin
      But2.TCT:=Str_Get(Language.Loc(1723),1,'|');
      Button_Draw(But2);
         Repeat                         {*Attends que l'on presse reprise...*}
         Until Button_GetMsg(But2,1)=CMSelected;
      But2.TCT:=Str_Get(Language.Loc(1723),2,'|');
      Button_Draw(But2);
      End;
   REDRAW_INFOS(1);                     {*Display information*}
   Inc(Pc); If Pc>25 Then Pc:=0;        {*Next Position...*}
   Win_Clip(No,W1);                    {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;            {*Window Closed   => Exit*}
If Even=CMMoved Then Begin IdBp:=$0001; REDRAW_FRAME; End; {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel) Or (i>LF.QTE);{*Exit Flags*}

kill_ListFiles;
Repeat
Win_Test(W1);                           {*Get Windows Evens*}
Until Not W1.FlgM;
Win_Done(W1);                           {*Close Window if Needs*}
End;

{****************************************************************************}
{********************* CREATION ET GESTION DU DIRECTORY *********************}
{****************************************************************************}

{ͻ
                         PROCEDURE Req_FileManager                          
 ͹
  IN.....: X,Y (INTEGER) : X,Y coordinates of the window.                   
           Sv  (INTEGER) : Vertical size of the window.                     
           Name (STRING) : Title of the window.                             
           OkBut(STRING) : Name for the 'OK' gadget.                        
           Mask (STRING) : File ask for the directory.                      
           Style  (BYTE) : Type of requester .                              
                     0      All uses (Select a file only)                   
                     1      Select a directory only                         
                     2      Delete file(s)                                  
                     3      Rename file(s)                                  
                     4      Change attributes of file(s)                    
                     5      Viewer of pictures                              
                     6      Playing of sounds.                              
           DirSel (STRING) : Directory were begin the search. ('' if none)  
           FilSel (STRING) : First file purposed. ('' if none)              
  OUT....: DirSel (STRING) : Directory selected.                            
           FilSel (STRING) : File Selected.                                 
           Size (LONGINT)  : Size of the selected file.                     
  EXPLAIN: Display and manage a requester of type "File requester'          
           Return the nae of file selected, else a '' string if canceled    
  EXAMPLE: Req_FileManager(9,30,280,'LOAD','_OK','*.*',0,DirSel,FilSel,Size)
 ͼ}

Const Max_Files=2000;                   {*Qtt de Files+Drawers Grables*}
Const Max_Root=26;                      {*Maximum d'Items dans le Root*}

Type SDir=Record
     BOk,BVo,BPa,BCa,BGe:TButton;          {*Boutons du Requester*}
     BAl,BMa,BTo:TButton;                  {* "  " *}
     CShow      :TCycler;                  {*Bouton Cycler*}
     S1         :TSlider;                 {*Slider du Requester*}
     Cor1,Cor2,Cor3:TInputText;             {*Structure Co-Requestg*}
     Cin1,Cin2,Cin3:String;             {*String Gadgets*}
     Name,OkBut :String;                {*Nom Requester et Nom Gadget "Ok"*}
     Mask       :String[80];            {*Masque du Directory*}
{SR} TMask      :String;                {*Tableau des Labels de Mask*}
     Style      :Byte;                  {*Requester All/Directories/Delete*}

     FList      :Integer;               {*Premier Elment de la Liste Affich*}
     PList      :Integer;               {*Position dans la Liste des Objets*}
     LList      :Integer;               {*Longueur de la Liste*}
     OldItem    :Integer;               {*Pos in List du Last Item Selectionn*}
     Tagged     :Integer;               {*Nombre d'items Taggs pour Mode 2 et Plus*}
     NB_Files,NB_Direct:Longint;        {*Nb de Files et de Drawers*}
     TRoot      :Array[1..Max_Root]of String[37];{*Stockage String du Root*}
     Flg_Root   :Boolean;               {*True = Display Devices*}

     TBN:Array[1..Max_Files] Of String[8];     {*Tableau Stockage Files/Dirs*}
     TBS:Array[1..Max_Files] Of String[3];     {*Tableau Stockage Suffixes*}
     TBL:Array[1..Max_Files] Of Longint;       {*Tableau Stockage Sizes*}
     TBF:Array[1..Max_Files] Of Byte;          {*Tableau Flags et Tags*}
     End;

{********************** AFFICHE LE NOMBRE DE "SELECTED" **************************}

Procedure DISPLAY_QTT_SELECTED(Var W:TWindow; Var D:SDir);
Var St:String;
Begin
If (D.Style<2) Or (D.Style>6) Then Exit;
Str(D.Tagged,St);                       {*Raffiche Items dans Window*}
Bevel  (W.X1+LaF+1,W.Y2-19-HaF1-HaF*2,W.X1+LaF*20,W.Y2-15-HaF1-HaF, ClLightGRey,BLLoweredLine,BLNoLine,Yes);
Display(W.X1+LaF*2+2,W.Y2-18-HaF1-HaF*2, CLText,Language.Loc(751)+' '+St);
End;

{ͻ
                        PROCEDURE DRAW_DIR (INTERNE)                        
 ͹
  IN.....: W = (TWindow): Structure Window.                                 
           D = (SDIR): Structure Directory.                                 
           OkBut = (STRING): String devant tre mis a la place du "OK".     
  EXPLAIN: Dessine les Gadgets et Elements dans le requester.               
 ͼ}

Procedure DRAW_DIR(Var W:TWindow; Var D:SDir; OkBut:String);
Var Off:Byte;                                      {*Dcalage pour Style>=2*}
    Py2:Integer;
Begin
If (D.Style>=2) And (D.Style<=6) Then Off:=HaF+6 Else Off:=0;{*Set Offset pour Dcalage*}

Py2:=W.Y2-HaF1-Off;                    {*Optimisations*}
Mse_Hide;
Bevel   (W.X1+LaF, W.Y1+HaF1+8, W.X2-LaF*2-20, Py2-HaF*4-37,  CLLightGrey,BLRaisedLine,BLNoLine,Yes); {*Box Principale*}
Bevel   (W.X1+LaF*19-1, Py2-HaF*4-33, W.X2-LaF, Py2-HaF*3-31, CLLightGrey,BLRaisedLine,BLLoweredLine,Yes);{*Stats*}
Display (W.X1+LaF+2, Py2-HaF*4-32, CLText,Language.Loc(6));

InputText(W.X1+LaF*10+2,Py2-HaF*4-33, LaF*8-2, 5, CLLightGrey,CLSky,0,$26,D.Cor1,D.Cin1);{*Pattern*}
InputText(W.X1+LaF*5,   Py2-HaF*3-26, LaF*37, 30, CLLightGrey,CLSky,0,$26,D.Cor2,D.Cin2);{*Drawer*}
InputText(W.X1+LaF,     Py2-HaF*2-19, LaF*33, 12, CLLightGrey,CLSky,0,$27,D.Cor3,D.Cin3);{*File*}

Bevel (W.X1+LaF+1, Py2-HaF*3-24, W.X1+LaF*4, Py2-HaF*2-26, CLLightGrey,BLLoweredLine,BLNoLine,Yes); {*Carr Activate*}

Win_Clip(Yes,W);
Cycler(LaF*35-1, (W.Y2-W.Y1)-HaF1*2-HaF*4+1-Off-6, LaF*14,D.CShow.CyclVal, CLTextButton,CLBgButton,$0,D.CShow,D.Mask);{*Show XXX*}
Win_Clip(FALSE,W);

Button(W.X1+LaF*43, Py2-HaF*3-27, W.X2-W.X1-LaF*44,-1, CLTextButton,CLBgButton,$0,D.BGe,Language.Loc(10));{*Bouton 'GET'*}
Button(W.X1+LaF,    Py2-HaF-12+Off, LaF*12,-1,  CLTextButton,CLBgButton,$0,D.BOk,OkBut);    {*Bouton 'Ok'*}
Button(W.X1+LaF*14, Py2-HaF-12+Off, LaF*13,-1,  CLTextButton,CLBgButton,$0,D.BVo,Language.Loc(11));  {*Bouton 'VOLUMES'*}
Button(W.X1+LaF*28, Py2-HaF-12+Off, LaF*12,-1,  CLTextButton,CLBgButton,$0,D.BPa,Language.Loc(12));  {*Bouton 'PARENT'*}
Button(W.X1+LaF*41, Py2-HaF-12+Off, LaF*12-2,-1,CLTextButton,CLBgButton,$0,D.BCa,Language.Loc(13));{*Bouton 'CANCEL'*}
If (D.Style>=2) And (D.Style<=6) Then Begin
   DISPLAY_QTT_SELECTED(W,D);                           {*Affiche "Slected"*}
   Button(W.X1+LaF*21, Py2-19-HaF*2+Off,LaF*8,   -1, CLTextButton,CLBgButton,$0,D.BAl,Language.Loc(14));{*Bouton 'ALL'*}
   Button(W.X1+LaF*30, Py2-19-HaF*2+Off,LaF*10,  -1, CLTextButton,CLBgButton,$0,D.BMa,Language.Loc(15));{*Bouton 'MATCH'*}
   Button(W.X1+LaF*41, Py2-19-HaF*2+Off,LaF*12-2,-1, CLTextButton,CLBgButton,$0,D.BTo,Language.Loc(16));{*Bouton 'TOGGLE'*}
   End;

If D.Style=1 Then Begin                                 {*Freeze Gadgets*}
   Cycler_Freeze(Yes,D.CShow);                          {*For Requester Type 1*}
   InPutText_Freeze(Yes,D.Cor1);
   InPutText_Freeze(Yes,D.Cor3);
   End;
Mse_Show;
End;

Procedure DRAW_SLIDER_ONDIR(Tot,IAff,Psl:Integer; Var W:TWindow; Var D:SDir);{*Affiche le Slider*}
Var Off:Byte;                                      {*Dcalage pour Style=2/3/4*}
    Tr,Ar:Word;                                    {*Taille et Aff Rel*}
Begin
If (D.Style>=2) And (D.Style<=6) Then Off:=HaF+6 Else Off:=0;{*Set Offset pour Dcalage*}

IAff:=IAff-1;                                      {*Recalcule Tot et IAff*}
If Tot>IAff+1 Then Begin                           {*en fonction du Maximum*}
   Tr:=Tot-IAff;
   Ar:=((Tot-IAff)*IAff) Div Tot;
   End Else Begin
   Tr:=Tot; Ar:=Tot;
   If Tr=0 Then Begin Tr:=1; Ar:=1; End;           {*Correction Liste Vide*}
   End;

{gotoxy(1,1); Writeln('T=',Tot,' A=',IAff,'   ');
gotoxy(1,2); Writeln('Tr=',Tr,' Ar=',Ar,'   ');}

Slider(D.S1, W.X2-LaF-19,W.Y1+HaF1+8, W.Y2-W.Y1-HaF1-HaF*6-35-Off, Tr,Ar, Psl, COVertical,SSBox,SSColor,$0000,CTBox,BPOposed,Yes,$0008,CLLightGrey,0,0,CLLightGrey,'','',MPArrow,'');
End;

{ͻ
                       PROCEDURE TOGGLE_ITEM (INTERNE)                      
 ͼ}

Procedure TOGGLE_ITEM(Var W:TWindow; Var D:SDir);
Var B:Integer;
    Off,StyOff:Byte;                            {*Dcalage pour Style=2/3/4*}
    O_S1,O_X1,O_Y1:Integer;                     {*Optimisations*}

Begin
If D.OldItem=D.PList Then Exit;                 {*On est sur le mme Elment*}
If (D.Style>=2) And (D.Style<=6) Then Off:=HaF+6 Else Off:=0; {*Set Offset pour Dcalage*}
O_S1:=W.Y1+HaF1+5+(D.PList-D.FList+1)*HaF;      {*Optimisations*}

If O_S1>=W.Y2-HaF1-HaF*5-40-Off Then Exit;      {*Sortie du Box de la Window*}
If O_S1<=W.Y1+HaF1+8 Then Exit;                 {*Sortie du Box de la Window*}

VESA_SetColor(CLLineUp);
VESA_SetWriteMode(XorPut);
Mse_Hide;
O_X1:=W.X1+LaF; O_Y1:=W.Y1+HaF1;                {*Optimisations*}
If (D.OldItem<>-1) And (D.Style<=1) Then        {*Style 0, 1*}
   For B:=O_Y1+7+(D.OldItem-D.FList+1)*HaF to O_Y1+6+(D.OldItem-D.FList+1+1)*HaF Do
       VESA_Line(O_X1+1, B, W.X2-LaF*2-21, B);      {*Clear Last Bar*}
If D.Style<=1 Then StyOff:=1 Else StyOff:=0;    {*Taille Y de la Barre Toggle*}
For B:=O_Y1+7+(D.PList-D.FList+1)*HaF to O_Y1+5+StyOff+(D.PList-D.FList+1+1)*HaF Do
    VESA_Line(O_X1+1, B, W.X2-LaF*2-21, B);          {*Draw New Xor Bar*}
Mse_Show;
D.OldItem:=D.PList;                             {*Pass Old Item Position*}
VESA_SetWriteMode(NormalPut);
If (D.Style>=2) And (D.Style<=6) Then           {*Type "DELETE"/"RENAME"/"ATTRIB"*}
   If D.TBF[D.PList] And $80<>$80
      Then Begin D.TBF[D.PList]:=D.TBF[D.PList] Or $80; Inc(D.Tagged); End{*Set Bit Tagged*}
      Else Begin D.TBF[D.PList]:=D.TBF[D.PList] And ($FF-$80); Dec(D.Tagged); End;{*Clear Bit Tagget*}

If D.TBL[D.PList]<>0 Then Begin                 {*It's a File !!!*}

   D.Cin3:=D.TBN[D.PList]+'.'+D.TBS[D.PList];
   InputText(O_X1, W.Y2-HaF1-HaF*2-19-Off,LaF*33,12, CLLightGrey,CLSky,0,$26+$40,D.Cor3,D.Cin3);{*File*}
   End;
If (D.Style>=2) And (D.Style<=6) Then DISPLAY_QTT_SELECTED(W,D);{*Affiche Items "Selected"*}

End;



{ͻ
                    PROCEDURE AFFICHAGE DES STATISTIQUES                    
 ͼ}


Procedure DISPLAY_STATS(Var W:TWindow; Var D:SDir);
Var St1,St2:String;
    Off:Byte;                                   {*Dcalage pour Style=2/3/4*}
    O_Y2:Integer;                               {*Optimisations*}
Begin
If (D.Style>=2) And (D.Style<=6) Then Off:=HaF+6 Else Off:=0;{*Set Offset Dcalage*}
If D.Flg_Root=True
   Then Begin St1:=Language.Loc(17)+' '; St2:=Language.Loc(18)+' '; End
   Else Begin St1:=Language.Loc(19)+' '; St2:=Language.Loc(20)+' '; End;
O_Y2:=W.Y2-HaF1-HaF*4-32-Off;                   {*Optimisations*}

Bevel    (W.X1+LaF*19-1, O_Y2-1, W.X2-LaF, O_Y2+HaF+3, CLLightGrey,BLRaisedLine,BLLoweredLine,Yes);{*Stats*}
Display(W.X1+LaF*20, O_Y2, CLText, St1+Str_L2S(D.NB_Files)+'   '+St2+Str_L2S(D.NB_Direct));
End;

{ͻ
                   PROCEDURE SEARCH_POS_INLIST (INTERNE)                    
 ͹
  IN.....: Name (STRING): Nom du fichier demand.                           
           W = (TWindow): Structure Window.                                 
           D = (SDIR): Structure Directory.                                 
  EXPLAIN: Recherche dans la liste stocke en mmoire le nom de fichier     
           demand au dpart dans "Name". et modifie les paramtres de      
           dbut, fin et pos dans liste.                                    
  NB.....: Appell au lancement du requester et quand Resize Ou Extend Wind.
 ͼ}

Procedure SEARCH_POS_INLIST(Var W:TWindow; Var D:SDir);
Var A,B:Integer;
    IAff:Word;
    Off:Byte;                                   {*Dcalage pour Style=2/3/4*}
Begin
If (D.Style>=2) And (D.Style<=6) Then Off:=HaF+6 Else Off:=0;{*Set Offset Dcalage*}
IAff:=(W.Y2-HaF1-HaF*4-38-Off-(W.Y1+HaF1+8)) Div HaF -1;

For A:=1 to D.LList do                          {*Parcours Liste et Search FileName*}
   If D.TBN[A]+'.'+D.TBS[A]=D.Cin3 Then Begin   {*Found*}
      B:=A;
      If D.LList-B+1<IAff+1 Then B:=D.LList-IAff+1;{*Correct Fin Liste dpasse*}
      If B<1 Then B:=1;                         {*Correct Borne Ngative*}
      D.FList:=B; D.PList:=A;                   {*Save Values*}
      End;

DRAW_SLIDER_ONDIR(D.LList,IAff,D.PList,W,D);    {*Redraw Slider on Window*}
End;

{ͻ
                    PROCEDURE GET_ROOT_DEVICES (INTERNE)                    
 ͹
  IN.....: PList (INTEGER): Position dans la liste de Elments.             
           W = (TWindow): Structure Window.                                 
           D = (SDIR): Structure Directory.                                 
 ͼ}

Procedure GET_ROOT_DEVICES(Var W:TWindow; Var D:SDir);
Var A,B   :Integer;
    IAff  :Integer;
    VolName:String;                             {*Labels Partitions*}
    Off:Byte;                                   {*Dcalage pour Style=2/3/4*}
    O_X1,O_Y2:Integer;                          {*Optimisations*}

Procedure GET_INFO_ON_DEVICE;                   {*Affiche Device*}
Var DName,ESP,
    St,Phrase:String;                           {*String Miscellaneous*}
    NOCD:Boolean;                               {*Dtection CD-ROM*}
Begin
If {Dsk_TestPhysicDevice(Chr(B+64))=}True then    {*Test Assign or No*}
  Begin
  DName:=Language.Loc(21);
  Inc(D.NB_Files);
  End     {*CD-ROM ou Assign ?*}
Else
  Begin
  If Test_CDROM(Chr(A+96)) Then DName:=': (CD-ROM)'
                           Else DName:=Language.Loc(22);
  Inc(D.NB_Direct);
  End;

ESP:='                               ';                {*Pour Tabulation*}
Phrase:='';                                            {*Init to NULL*}
D.TBN[B]:=Chr(A+64)+':';                               {*Stock Device Name*}
NOCD:=Not Test_CDROM(Chr(A+96));


If (A>2) And (NOCD) Then Str(DiskFree(A) Div 1024,St)
                    Else St:='000';
Phrase:=Phrase+St;
If (A>2) And (NOCD) Then Str(Round(100*(DiskFree(A) / Real(DiskSize(A)))),St)
                    Else St:='000';

If A>2 Then Phrase:=St+Language.Loc(23)
       Else Phrase:=Phrase+' Kb = '+St+Language.Loc(23);
VolName:=Chr(A+64)+DName+'  ';
Phrase:=VolName+Copy(ESP,1,37-Length(Phrase+VolName))+Phrase;
VESA_SetColor(CLText);
D.TRoot[B]:=Phrase;                                    {*Stocke Phrase*}
Inc(B);                                                {*1 Device de Plus*}
End;
		      {====== MAIN CODE ======}
Begin                                                  {*Dtecte Device*}
Mse_SetPointer(MPBusy);                                {*Pointer to be Busy*}
If (D.Style>=2) And (D.Style<=6) Then Off:=HaF+6 Else Off:=0;{*Set Offset Dcalage*}
For A:=1 to Max_Files Do Begin
D.TBN[A]:=''; D.TBS[A]:=''; D.TBL[A]:=0;               {*Clear Tableau*}
End;
D.NB_Files:=0; D.NB_Direct:=0;                         {*Clear Counters*}
D.FList:=1; D.PList:=1;              {*Init Valeurs Positions & Sliders*}

O_Y2:=W.Y2-HaF1-HaF*3-24-Off;                   {*Optimisations*}
O_X1:=W.X1+LaF+1;
Bevel (O_X1,   O_Y2,        W.X1+LaF*4,   O_Y2+HaF-2,  CLGreen,    BLLoweredLine,BLNoLine,Yes); {*Carr Activate On*}
Bevel (O_X1-1, W.Y1+HaF1+8, W.X2-LaF*2-20,O_Y2-HaF-13, CLLightGrey,BLRaisedLine, BLNoLine,Yes); {*Clear Box Principale*}

B:=1;
For A:=1 to 26 do
   If A>2 Then
      If Dsk_TestDeviceExist(Chr(A+64))=True {*Detect All Devices*}
         Then GET_INFO_ON_DEVICE     {*Affiche Device*}
         Else
   Else GET_INFO_ON_DEVICE;

D.LList:=B-1;                                           {*Total Devices Lists*}
Bevel (O_X1, O_Y2, W.X1+LaF*4, O_Y2+HaF-2, CLLightGrey,BLLoweredLine,BLNoLine,Yes); {*Carr Activate Off*}
IAff:=(O_Y2-HaF-22-W.Y1-HaF1) Div HaF -1;
DRAW_SLIDER_ONDIR(D.LList,IAff,0,W,D);     {*Redraw Slider on Window*}
D.Flg_Root:=True;                          {*Pour Affichage des Devices/Assigns*}

DISPLAY_STATS(W,D);                        {*Affichage Statistiques*}
Mse_SetPointer(P_Current);                 {*Pointer to be Current*}
D.OldItem:=-1;                             {*Pas d'item Slectionn*}
End;

{******************************* CORRECT PATH *******************************}

Procedure CORRECT_PATH(Var D:SDir);

Begin
If Copy(D.Cin2,2,1)=':' Then
   If Copy(D.Cin2,Length(D.Cin2),1)<>'\' Then D.Cin2:=Upper(D.Cin2+'\');
End;

{****************************** UPDATE LE PATH ******************************}

Procedure GET_NEW_REP(Var W:TWindow; Var D:SDir);   {*Update le Path*}
Var A:Integer;
    Off:Byte;                              {*Dcalage pour Style=2/3/4*}
Begin
If (D.Style>=2) And (D.Style<=6) Then Off:=HaF+6 Else Off:=0; {*Set Offset Dcalage*}
If ((D.Flg_Root=True) And (D.TBN[D.PList]='..'))
   Or (D.TBN[D.PList]='.') Then Exit;      {*On n'a rien  foutre ici !!!*}
If D.TBN[D.PList]='..' Then                {*Rep Prcdent*}

   Begin
   A:=Length(D.Cin2)-1;
   While Copy(D.Cin2,A,1)<>'\' do
       Dec(A);
   D.Cin2:=Copy(D.Cin2,1,A);               {*Tronque le Path vers la Fin*}
   End Else
   If D.Flg_Root=True
      Then D.Cin2:=D.TBN[D.PList]+'\'      {*Draw Partition Name*}
      Else D.Cin2:=D.Cin2+D.TBN[D.PList]+'\';{*Draw Directory Name*}
InputText(W.X1+LaF*5, W.Y2-HaF1-HaF*3-26-Off, LaF*37, 30, CLLightGrey,CLSky,0,$26+$40,D.Cor2,D.Cin2);{*Drawer*}
End;

{***************************** LECTURE DIRECTORY ****************************}

Procedure GET_FILE_DIR(Var W:TWindow; Var D:SDir);
Var DirInfo:SearchRec;                     {*Struct Search Files & Dirs*}
    A:Integer;                             {*For Loop And Others*}
    IAff:Integer;                          {*Nb d'Items Affichables*}
    Off:Byte;                              {*Dcalage pour Style=2/3/4*}
    O_Y2:Integer;                          {*Optimisations*}
    FD:DirStr;                             {*Pour FSplit*}
    FN:NameStr;
    FE:ExtStr;
    Num:Integer;

Begin
If (D.Flg_Root=True) And (D.TBN[D.PList]='..') Then Exit;{*On n'a rien  foutre ici !!!*}

If (D.Style>=2) And (D.Style<=6) Then Off:=HaF+6 Else Off:=0;{*Set Offset Dcalage*}
O_Y2:=W.Y2-HaF1-HaF*3-24-Off;              {*Optimisations*}
Bevel (W.X1+LaF+1, O_Y2, W.X1+LaF*4, O_Y2+HaF-2, CLGreen,BLLoweredLine,BLNoLine,Yes); {*Carr Activate On*}
For A:=1 to Max_Files Do Begin
D.TBN[A]:=''; D.TBS[A]:=''; D.TBL[A]:=0;            {*Clear Tableau*}
End;
D.Tagged:=0;                                        {*Plus d'Items Slected*}
D.OldItem:=-1;                                      {*Rinit Again*}
D.Flg_Root:=False;                                  {*On est Plus dans le Root*}
A:=1; D.NB_Files:=0; D.NB_Direct:=0;                {*Init Nb Files/Drawers*}
dos.FindFirst(D.Cin2+'*.*',AnyFile,DirInfo);            {*Found First Element*}

While (DosError=0) And (A<Max_Files) Do Begin
FSplit(DirInfo.Name,FD,FN,FE);                      {*Splite le Nom du Fichier*}
FE:=Copy(FE,2,3);                                   {*Vire le '.' dans le Suffixe*}

If (DirInfo.Name<>'..') And (DirInfo.Name<>'.') And
   (DirInfo.Attr And $8<>$8) And                    {*Nom de Volume ?*}
   (DirInfo.Attr And $10<>$10) Then Begin           {*Ce n'est pas un Directory*}
   D.TBN[A]:=FN;                                    {*Write Name*}
   D.TBS[A]:=FE;                                    {*Write Suffix*}
   D.TBL[A]:=DirInfo.Size;                          {*Write Size*}
   D.TBF[A]:=DirInfo.Attr;                          {*Write Attributs*}

   If D.Style<>1 Then                               {*Requester 0/2 = Total*}
    If D.Cin1='*.*' Then
      Begin Inc(D.NB_Files); Inc(A); End            {*1 Fichier de Plus*}
      Else If Copy(D.Cin1,3,Length(D.Cin1)-2)=D.TBS[a]{*Il y a un Masque*}

	   Then Begin Inc(D.NB_Files); Inc(A); End; {*1 Fichier de Plus*}
   End

   Else If (DirInfo.Attr And $8<>$8) And            {*Pas le Nom du Volume !*}
      (DirInfo.Attr And $10=$10)Then                {*C'est vraiment 1 Rep !*}
      Begin
      D.TBN[A]:=DirInfo.Name;                       {*Nom du Repertoire.*}
      D.TBS[A]:='';                                 {*Suffixe Nul  <REP>*}
      D.TBL[A]:=0;                                  {*Taille Nulle <REP>*}
      D.TBF[A]:=DirInfo.Attr;                       {*Write Attributs*}
      Inc(D.NB_Direct); Inc(A);                     {*1 Directory de Plus*}
      End;
dos.FindNext(DirInfo);                         {*Search Next Elment*}
End;

If A=Max_Files Then Begin
   Num:=4;                                   {*Icne Information*}
   Req_Dialog(Language.Loc(1),Language.Loc(221),Language.Loc(24),Num);
   End;
If DosError=3 Then Play_Beep;           {*Chemin non trouv !*}

D.FList:=1; D.PList:=1;
D.LList:=D.NB_Files+D.NB_Direct;           {*Nb Total de Files+Dirs*}

O_Y2:=W.Y2-HaF1-HaF*3-24-Off;              {*Optimisations*}
IAff:=(O_Y2-HaF-22-W.Y1-HaF1) Div HaF -1;
DRAW_SLIDER_ONDIR(D.LList,IAff,0,W,D);     {*Redraw Slider on Window*}
Bevel (W.X1+LaF+1, O_Y2, W.X1+LaF*4, O_Y2+HaF-2, CLLightGrey,BLLoweredLine,BLNoLine,Yes); {*Carr Activate Off*}
End;

{ͻ
                AFFICHE LA LISTE DES FICHIERS DANS LA FENETRE               
 ͼ}

Procedure DRAW_LIST_REQ(Var W:TWindow; Var D:SDir);
Var A,B:Integer;
    Phrase,VolName,ESP,St:String;
    Sep:String[1];                              {*Caractre de Sparation*}
    Off:Byte;                                   {*Dcalage pour Style=2/3/4*}
    FAttr:String[4];                            {*Pour Flags Attributs*}
    O_L,O_X1,O_Y1,O_X2,O_Y2:Integer;            {*Optimisations*}
    Text1:TText;

Begin
If (D.Style>=2) And (D.Style<=6) Then Off:=HaF+6 Else Off:=0;{*Set Offset Dcalage*}

B:=1;                                           {*Pos in Screen for Affichage*}
ESP:='                               ';         {*Pour Tabulation*}
VESA_SetColor(CLText);

O_X1:=W.X1+LaF;
O_Y1:=W.Y1+HaF1+8;                              {*Optimisations*}
O_X2:=W.X2-LaF*2-21;
O_Y2:=W.Y2-HaF1-HaF*4-38-Off;
O_L :=LaF*20;
Mse_Hide;

If D.Flg_Root=True Then
   Begin
   VESA_SetViewPort(O_X1, O_Y1, O_X2, O_Y2, ClipOn);
   For A:=D.FList to D.LList do Begin
      Bevel (1, B*HaF-2, W.X2, (B+1)*HaF-2, -1); {*Clear Box*}
      If O_Y1-3+B*HaF<O_Y2-HaF-2 Then Display(5,B*HaF-3, 0, D.TRoot[A]);
      VolName:=''; VESA_SetColor(CLTextTitle);
      If (A>2) And (Not Test_CDROM(Chr(96+A))) Then VolName:=Dsk_GetDeviceName(Chr(A+64));    {*Nom de Volume*}
      If O_Y1-3+B*HaF<O_Y2-HaF-2 Then Display(LaF*15+10,B*HaF-3, ClWhite, VolName);
      VESA_SetColor(CLText); Inc(B);
      End;
   VESA_SetViewPort(0,0,VESA_GetMaxX,VESA_GetMaxY,ClipOff);    {*Restore Normal ViewPort*}
   End

   Else Begin                                   {*Affiche Files + Drawers*}
   For A:=D.FList to D.LList do Begin
   FAttr:='----';                               {*Clear Flags*}
   If D.TBL[A]<>0 Then Str(D.TBL[A],St) Else St:='';{*Size Fichier*}
   If D.TBL[A]=0 Then Sep:=' ' Else Sep:=' ';   {*Directory*}
   If D.TBF[A] And $01=$01 Then FAttr[1]:='R';  {*Attr Read Only*}
   If D.TBF[A] And $02=$02 Then FAttr[2]:='H';  {*Attr Hidden*}
   If D.TBF[A] And $04=$04 Then FAttr[3]:='S';  {*Attr System*}
   If D.TBF[A] And $20=$20 Then FAttr[4]:='A';  {*Attr Archive*}
   If D.TBF[A] And $10=$10 Then FAttr:='';      {*It's a Drawer => No Flags*}
   Phrase:=D.TBN[A]+Copy(ESP,1,8-Length(D.TBN[A]))+Sep+
	   D.TBS[A]+Copy(ESP,1,15-Length(St))+St+
	   '   '+FAttr;                         {*Construit Ligne*}
      If O_Y1-3+B*HaF<O_Y2-HaF-2 Then
	 Begin
	 VESA_SetViewPort(O_X1, O_Y1, O_X2, O_Y2, ClipOn);
	 If (D.Style>=2) And (D.Style<=6) And (D.TBF[A] And $80=$80) {*Tag Elment for Style 2/3/4*}
	    Then
            Begin
	    Bevel (1, B*HaF-1, W.X2, (B+1)*HaF-3, CLShadow); {*Black Box*}
	    If FAttr='' Then VESA_SetColor(CLText) Else VESA_SetColor(CLTextTitle);{*Drawer ?*}
            Display_Define(Text1,5,B*HaF-3,-1,VESA_GetColor,'',1,TJOnLeft,$0000,Phrase);
            Display_Draw(Text1);
	    If FAttr='' Then DrawGad_Lens(O_L,B*HaF){*Draw Images*}
			Else DrawGad_File(O_L,B*HaF);
	    End
	    Else
            Begin
	    Bevel (1, B*HaF-2, W.X2, (B+1)*HaF-2, CLWinBg); {*White Box*}
	    If FAttr='' Then VESA_SetColor(CLTextTitle) Else VESA_SetColor(CLText);{*Drawer ?*}
            Display_Define(Text1,5,B*HaF-3,-1,VESA_GetColor,'',1,TJOnLeft,$0000,Phrase);
            Display_Draw(Text1);
	    If FAttr='' Then DrawGad_Lens(O_L,B*HaF){*Draw Images*}
			Else DrawGad_File(O_L,B*HaF);
	    End;
	 VESA_SetViewPort(0,0,VESA_GetMaxX,VESA_GetMaxY,ClipOff);{*Restore Normal ViewPort*}
	 End;
      Inc(B);
      End;
                                                {*No Files in Directory*}
   If (D.FList>=D.LList-1) And (Length(D.Cin2)>3) Then Begin
      VESA_SetViewPort(O_X1, O_Y1, O_X2, O_Y2, ClipOn);
      Display(5,(D.LList+2-D.FList)*HaF-3, CLText,Language.Loc(26));
      VESA_SetViewPort(0,0,VESA_GetMaxX,VESA_GetMaxY,ClipOff); {*Restore Normal ViewPort*}
      End;
   End;

Mse_Show;
If D.Style<=1 Then TOGGLE_ITEM(W,D);            {*Affiche Element Slectionn*}
End;

{********************** DELETE OR RENAME LIST ELEMENTS **********************}

Procedure FILE_ACTION(Var W:TWindow; Var D:SDir; Var NUM:Integer);
Var Fil1  :Text;                                {*Pour Traitement des Fichiers*}
    A,Num1,Num2:Integer;
    NewN  :String;                              {*Nouveau Nom Fichier*}
    DoAll :Boolean;                             {*Actions Automatiques*}
    UnPro :Boolean;                             {*Dprotection Automatique*}

Begin
DoAll:=No;                                      {*Pas d'action Automatique de Base*}
UnPro:=No;                                      {*Pas de Dprotection Automatique*}
If D.Tagged=0 Then Begin                        {*Pas de Fichiers Slectionns*}
   Num1:=4;                                     {*Icne Informations*}
   Req_Dialog(Language.Loc(1),'#1'+Language.Loc(25),Language.Loc(24),Num1);
   NUM:=-1; Exit;                               {*On Revient au File-Requester*}
   End;

If D.Style=5 Then
  Begin
  Done_Mouse;
  Save_Screen($FF07);           {*Save Screen for Viewer*}
  End;

For A:=1 to D.LList do Begin                    {*Parcours la Liste*}
   Main_Task;
   If (D.TBF[A] And $80=$80) And (D.TBN[A]<>'.') And{*Tagged ?*}
   (D.TBN[A]<>'..') And (D.TBF[A] And $10<>$10) Then{*Not Drawer, Not Parent*}
      Begin
      Assign(Fil1,D.Cin2+D.TBN[A]+'.'+D.TBS[A]);{*Assign Path + File*}

      D.TBF[A]:=D.TBF[A] And ($FF-$80);         {*Untag File...*}
      Dec(D.Tagged);
      If D.Style<>5 Then DRAW_LIST_REQ(W,D);    {*Display New File List...*}
      D.Cin3:=D.TBN[A]+'.'+D.TBS[A];

      SEARCH_POS_INLIST(W,D);                   {*Se Positionne sur le Fichier*}

      If D.Style=2 Then Begin                   {*Spcial Requester for Delete*}
	 If DoAll=False Then Begin
            Num1:=3;                            {*Icne Question*}
	    Req_Dialog(Language.Loc(1),Language.Loc(29)+D.Cin2+D.TBN[A]+'.'+D.TBS[A]+
			Language.Loc(30),Language.Loc(31)+Language.Loc(32),Num1);
            End
	    Else Num1:=1;                       {*Delete All*}
	 If Num1=2 Then Begin Num1:=1; DoAll:=True; End;
	 If Num1=1 Then Begin
	    If (D.TBF[A] And $01=$01) And (UnPro=Yes) Then{*Change Flags*}
	       Begin SetFAttr(Fil1,$20); D.TBF[A]:=$20; End;
	    If D.TBF[A] And $01=$01 Then Begin
               Num2:=3;                         {*Icne Question*}
	       Req_Dialog(Language.Loc(1),Language.Loc(33)+D.Cin2+D.TBN[A]+'.'+D.TBS[A]+
			   Language.Loc(34),Language.Loc(35),Num2);
	       If Num2=2 Then UnPro:=Yes;        {*DProtect_Software All Files*}
	       If (Num2=1) or (Num2=2) Then     {*Delete File*}
		  Begin SetFAttr(Fil1,$20);
			Erase(Fil1); End;

	       End

	       Else Erase(Fil1);                {*Delete File*}
	    End;
	 If Num1=4 Then Begin NUM:=-1; Exit;End;{*Abort = Pas de Sortie*}
	 If Num1=5 Then Begin NUM:=1; Exit; End;{*Exit*}
	 End;

      If D.Style=3 Then Begin                   {*Spcial Requester for Rename*}
	 NewN:=D.TBN[A]+'.'+D.TBS[A];           {*Copy Name*}
	 If DoAll=False Then
            Begin
            Num1:=3;                            {*Icne Question*}
	    Req_String(Language.Loc(1),Language.Loc(36)+D.Cin2+D.TBN[A]+
            '.'+D.TBS[A]+Language.Loc(37),Language.Loc(38)+Language.Loc(32),12,130,NewN,Num1);
            End;
	 If (Num1=1) And (NewN=D.TBN[A]+'.'+D.TBS[A]) Then Num1:=2;{*Name not Modified*}
	 If Num1=1 Then Begin Rename(Fil1,D.Cin2+NewN); End;
	 If Num1=3 Then Begin NUM:=-1; Exit; End;{*Abort = Pas de Sortie*}
	 If Num1=4 Then Begin NUM:=1; Exit; End;{*Exit*}
	 End;

      If D.Style=4 Then Begin                   {*Spcial Requester for Attrib*}
	 NewN:=D.TBN[A]+'.'+D.TBS[A];           {*Copy Name*}
	 Req_FileInformation(W.X1+50,W.Y1+50,D.Cin2+NewN,D.Cin2+NewN);{*Edit Attrib Flags*}
	 End;

      If D.Style=5 Then Begin                   {*Spcial Requester for Viewer*}
	 NewN:=D.Cin2+D.TBN[A]+'.'+D.TBS[A];    {*Create Name*}
         If BMP_TestFile(NewN) Then BMP_Show(0,0,VESA_GetMaxX,VESA_GetMaxY,0,0,NewN,$53)
                               Else If File_TestExist(NewN) Then Show_GFX(NewN,$2);
(*         If Wait Then Begin                     {*Stop Viewer !*}
            Restore_Screen;
            Num:=-1;
            DISPLAY_QTT_SELECTED(W,D);          {*Affiche Le Nb de Selected*}
            Exit;
            End;*)
	 End;

      If D.Style=6 Then Begin                   {*Spcial Requester for Player*}
	 NewN:=D.Cin2+D.TBN[A]+'.'+D.TBS[A];    {*Create Name*}
	 Play_WAV(NewN);
	 End;
      End;
   End;                                         {*Fin du Parcours de Liste*}

If D.Style=5 Then
  Begin
  Restore_Screen;                               {*Restore Screen*}
  Init_MouseVar;
  End;
NUM:=-1;                                        {*On ne Sort pas du File Requester*}
GET_FILE_DIR(W,D);                              {*Refait un Directory*}
DISPLAY_QTT_SELECTED(W,D);                      {*Affiche "Selected"*}
End;

{**************************** PROCEDURE PRINCIPALE **************************}

Procedure Req_FileManager(X1,Y1,Sv:Integer; Name,OkBut,Mask:String; Style:Byte;
		   Var DirSel,FilSel:String; Var Size:LongInt);
Var  W          :TWindow;           {*Structure Fentre*}
     D          :SDir;          {*Structure Directory*}
     A,B,C      :Integer;       {*For Boucles Only*}
     NUM        :Integer;
     Even       :Integer;       {*Evenement Window Window*}
     IAff       :Integer;       {*Nb D'Items Affichs dans la Liste*}
     DirOk      :Boolean;       {*Directory Slected -> To be Pushed*}
     Off        :Byte;          {*Dcalage pour Style=2/3/4*}
     Match_Name :String;        {*Chaine pour le File Name to Match*}
     Match_Found:Boolean;       {*Boolean pour Fichier Match Trouv*}
     Cl2_One    :Boolean;       {*Click Mouse Middle One Time for Parent*}
//     Asc,Sc     :Byte;          {*ASCII et Scan Code et la Touche Presse*}
     O_X1,O_Y1,O_Y1B,O_Y2,O_Win1,O_Win2:Integer; {*Optimisations*}

{********************* TESTE LA VALIDITE DU DRAWER DONNE ********************}

Procedure TEST_GIVED_DRAWER;
Var DirInfo: SearchRec;                         {*Struct Search Files & Dirs*}
Begin
If DirSel='' Then DirSel:=Dsk_GetCurrentDirectory {*Set Default Drawer*}
   Else Begin
   dos.FindFirst(DirSel+'*.*',AnyFile,DirInfo);     {*Found First Element*}
   If DosError<>0 Then Begin
      DirSel:=Dsk_GetCurrentDirectory;            {*Error => Set Default Drawer*}
      Play_Beep;                             {*Prvient de l'erreur !*}
      End;
   End;
End;

{*********************** RECALCUL DES OPTIMISATIONS *************************}

Procedure OPTIMIZE_CALCUL;
Begin
O_X1:=W.X1+LaF+1;
O_Y2:=W.Y2-HaF1-HaF*4-38-Off;             {*Optimisations*}

O_Win1:=HaF1*2+HaF*7+60+Off;
O_Win2:=LaF*54-2;
End;

{******************************* CALCUL IAFF ********************************}

Procedure CALCUL_IAFF;
Begin
IAff:=(O_Y2 -(W.Y1+HaF1+8)) Div HaF -1;   {*Nb d'Items Affichable pour Slider*}
End;

{***************** EFFACE LA BOITE PRINCIPALE DANS LA FENETRE ***************}

Procedure CLEAR_MAIN_BOX;
Begin
OPTIMIZE_CALCUL;                          {*Calcul des Optimisations*}
Bevel (W.X1+LaF, W.Y1+HaF1+8, W.X2-LaF*2-20, O_Y2+1, CLLightGrey,BLRaisedLine,BLNoLine,Yes); {*Clear Box Principal*}
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
DirOk:=False;                             {*Pas de dir Selected*}
Log.Add('Call FileManager Request',1);
D.Style:=Style;                           {*Type de Requester*}
D.Flg_Root:=False;                        {*Always for Display Root*}
D.CShow.Cyclval:=1;                       {*1er Cycler pour Mask*}
If Mask='' Then Mask:='*.*';              {*Par Dfaut...*}
D.Mask:=Mask;                             {*Stocke le Masque*}
D.Tagged:=0;                              {*Pas d'items Taggs*}
If (Style<0) Or (Style>6) Then            {*Erreur dans Paramtres*}
   Begin Error(641); Exit; End;
Main_Task;                                {*Pour Gestion Erreur*}
D.FList:=0; D.PList:=0; D.LList:=1;       {*Init Valeurs Positions & Sliders*}
If Length(FilSel)>12 Then FilSel:='';     {*Nom non Initialis*}
TEST_GIVED_DRAWER;                        {*Teste Validit du Drawer Donn*}
{SR}{Str_Split(D.Mask,'|',D.TMask);}         {*Split Maskes...*}
If D.Mask[Length(D.Mask)]='|' Then Dec(D.Mask[0]);
D.TMask:=D.Mask;

{SR}D.Cin1:=Upper(Str_Get(D.TMask,1,'|'));                {*Init Names*}
D.Cin2:=Upper(DirSel); D.Cin3:=Upper(FilSel);
CORRECT_PATH(D);                          {*Corrige ventuelement le Path*}
If (Style>=2) And (D.Style<=6) Then Off:=HaF+6 Else Off:=0; {*Set Offset pour Dcalage*}
If Sys.GfxMode=0 Then Begin Y1:=0;           {*Define Vertical Size of Requester*}
   If Off=0 Then Sv:=VESA_GetMaxY
	    Else Sv:=VESA_GetMaxY-Off;
   End;

{Gotoxy(1,5); writeln('FValue=',FontValue,' FSize=',FontSize,'  ');
Gotoxy(1,6); writeln('LaF=',LaF,' HaF=',HaF,'  ');
Gotoxy(1,8); writeln('FTitleT=',Font_TitleT,' FTitleS=',Font_TitleS,'  ');

Gotoxy(1,9); writeln('LaF1=',LaF1,' HaF1=',HaF1,'  ');}

OPTIMIZE_CALCUL;                          {*Calcul des Optimisations*}

If Sv+Off<O_Win1 Then Sv:=O_Win1-Off;
If Not Win_Init(X1, Y1, X1+O_Win2, Y1+Sv+Off,$51DF,Name,W) Then Exit;
X1:=W.X1; Y1:=W.Y1;                       {*Si Coordonnes Modifies...*}
CALCUL_IAFF;                              {*Nb d'Items Affichable pour Slider*}
Win_Sup(X1,Y1, X1+O_Win2, Y1+O_Win1, O_Win2, O_Win1, O_Win2, VESA_GetMaxY,2, CLWinBorder,$0050,W);
Win_Draw(W);                           {*Affiche Window*}
DRAW_DIR(W,D,OkBut);                      {*Draw All Gadgets in Window Palette*}
DRAW_SLIDER_ONDIR(D.LList,IAff,D.Plist,W,D);  {*Draw Slider on Window*}
If Copy(DirSel,2,1)=':' Then Begin
   GET_FILE_DIR(W,D);                     {*Affiche Directory de Base*}
   SEARCH_POS_INLIST(W,D);                {*Recherche Pos  fixer dans liste*}
   DRAW_LIST_REQ(W,D);                    {*Raffiche Items dans Window*}
   DISPLAY_STATS(W,D);                    {*Affichage Statistiques*}
   End;

{**** BOUCLE PRINCIPALE ****}

NUM:=-1;                                  {*Initialisations*}

Repeat
Even:=Win_Test(W);                        {*Recupre Valeur Activation Wind*}
If Even=CMClosed Then NUM:=0;             {*Close Gadget*}
Cl2_One := FALSE;

OPTIMIZE_CALCUL;                          {*Calcul des Optimisations*}

If (Even=4) Or (Even=3) Then              {*Extend Window et ReSize Window*}
   Begin
   CALCUL_IAFF;                           {*Nb d'Items Affichable pour Slider*}
   DRAW_DIR(W,D,OkBut);                   {*Draw All Gadgets in Window*}
   DRAW_SLIDER_ONDIR(D.LList,IAff,D.FList,W,D);{*Draw Slider on Window*}
   D.OldItem:=-1;
   SEARCH_POS_INLIST(W,D);                {*Recherche Pos  fixer dans liste*}
   DRAW_LIST_REQ(W,D);                    {*Raffiche Liste Items*}
   DISPLAY_STATS(W,D);                    {*Affichage Statistiques*}
   End;

If Even=CMMoved Then                            {*Autorise deplacement Window*}
   Begin
   CALCUL_IAFF;                           {*Nb d'Items Affichable pour Slider*}
   DRAW_DIR(W,D,OkBut);                   {*Draw All Gadgets in Window*}

   DRAW_SLIDER_ONDIR(D.LList,IAff,D.FList,W,D);{*Draw Slider on Window*}
   D.OldItem:=-1;

   DRAW_LIST_REQ(W,D);                    {*Raffiche Liste Items*}
   DISPLAY_STATS(W,D);                    {*Affichage Statistiques*}
   End;

If (W.IDCMP And $1=$1) And (Mse_Clicked(3)=True) And (D.Flg_Root=False) And Win_Ready(W)=True Then
   Begin GET_ROOT_DEVICES(W,D); D.Tagged:=0;
   DRAW_LIST_REQ(W,D);                       {*Affiche Liste*}
   DISPLAY_STATS(W,D);                       {*Affichage Statistiques*}
   DISPLAY_QTT_SELECTED(W,D); End;           {*Affiche "Selected"*}

If Win_Ready(W) Then                      {*Fentre Prte ?*}
   Begin
   If InputText_GetMsg(D.Cor1,D.Cin1)=CMModified Then{*Le "MASK"  t chang*}
      Begin
      D.Cin1:=Upper(D.Cin1);                 {*Passe en Majuscules*}
      Mse_SetPointer(MPBusy);                {*Pointer to be Busy*}
      CLEAR_MAIN_BOX;                        {*Clear Box Principal*}
      GET_FILE_DIR(W,D);                     {*Refait un Directory*}
      DRAW_LIST_REQ(W,D);                    {*Raffiche Items dans Window*}
      DISPLAY_STATS(W,D);                    {*Affichage Statistiques*}
      Mse_SetPointer(P_Current);             {*Pointer to be Busy*}
      End;

   If InputText_GetMsg(D.Cor2,D.Cin2)=CMModified Then {*Modifie Path*}
      Begin
      CORRECT_PATH(D);
      InputText(W.X1+LaF*5, O_Y2+HaF+12, LaF*37,30, CLLightGrey,CLSky,0,$26+$40,D.Cor2,D.Cin2);{*Drawer*}
      CLEAR_MAIN_BOX;                        {*Clear Box Principal*}
      GET_FILE_DIR(W,D);
      DRAW_LIST_REQ(W,D);                    {*Raffiche Items dans Window*}
      DISPLAY_STATS(W,D);                    {*Affichage Statistiques*}
      End;

   InputText_GetMsg(D.Cor3,D.Cin3);

//   Kbd_GetChar(Asc,Sc);                          {*ASCII et Scan Code*}

   Win_Clip(Yes,W);
   If Cycler_GetMsg(D.CShow,1)=CMSelected Then     {*Bouton "Show .XXX"*}
      Begin
      Win_Clip(FALSE,W);
      Mse_SetPointer(MPBusy);                {*Pointer to be Busy*}
      CLEAR_MAIN_BOX;                        {*Clear Box Principal*}

{SR}  D.Cin1:=Str_Get(D.TMask,D.CShow.Cyclval,'|');      {*Next Mask....*}
(*      Case D.CShow.Cyclval of
	 1: D.Cin1:='*.*';
	 2: D.Cin1:='*.EXE';
	 3: D.Cin1:='*.COM';
	 4: D.Cin1:='*.PAS';
	 5: D.Cin1:='*.TXT';
	 6: D.Cin1:='*.DOC';
	 7: D.Cin1:=D.Mask;                  {*Mask Spcial Def by User*}
	 End;*)
      InputText(W.X1+LaF*10+2, O_Y2+5, LaF*8-2,5, CLLightGrey,CLSky,0,$26+$40,D.Cor1,D.Cin1);{*Pattern*}
      GET_FILE_DIR(W,D);                     {*Refait un Directory*}
      DRAW_LIST_REQ(W,D);                    {*Raffiche Items dans Window*}
      DISPLAY_QTT_SELECTED(W,D);             {*Affiche "Selected"*}
      DISPLAY_STATS(W,D);                    {*Affichage Statistiques*}
      Mse_SetPointer(P_Current);             {*Pointer to be Busy*}
      End;
   Win_Clip(FALSE,W);

   If (Button_GetMsg(D.BVo,1)=CMSelected)          {*Bouton "VOLUME"*}
      And (W.IDCMP And $1=$1) Then
      Begin
      GET_ROOT_DEVICES(W,D);                 {*Lecture Root*}
      DRAW_LIST_REQ(W,D);                    {*Affiche Liste*}
      DISPLAY_STATS(W,D);                    {*Affichage Statistiques*}
      End;
   If ((Button_GetMsg(D.BPa,1)=CMSelected) Or      {*Bouton "PARENT"*}
      (Mse_Clicked(2)=True)) And               {*Mouse Button Center*}
      (Cl2_One=False) And                    {*Click One Time Only*}
      (Length(D.Cin2)>3) Then                {*Reach the Root*}
      Begin
      Cl2_One:=True;                         {*On vient de Cliquer*}
      D.TBN[D.PList]:='..';                  {*Set Parent Directory*}
      Mse_SetPointer(MPBusy);                {*Pointer to be Busy*}
      CLEAR_MAIN_BOX;                        {*Clear Box Principal*}
      GET_NEW_REP(W,D);                      {*Change le Path*}
      GET_FILE_DIR(W,D);

      DRAW_LIST_REQ(W,D);                    {*Raffiche Items dans Window*}
      DISPLAY_STATS(W,D);                    {*Affichage Statistiques*}
      Mse_SetPointer(P_Current);             {*Pointer to be Busy*}
      End;
   If (Button_GetMsg(D.BCa,1)=CMSelected) Or(NUM=0){*Bouton "CANCEL"*}
      Then Begin
      NUM:=2; Size:=0;
      DirSel:=''; FilSel:='';                {*Pas de Rsultat*}
      End;
   If Button_GetMsg(D.BGe,1)=CMSelected Then       {*Bouton "GET"*}
      Begin

      D.OldItem:=-1; Mse_SetPointer(MPBusy); {*Rinit*}
      If D.Flg_Root=True Then Begin
	 GET_ROOT_DEVICES(W,D);              {*Lecture Root*}
	 DRAW_LIST_REQ(W,D); End             {*Affiche Liste Root*}
	 Else Begin GET_FILE_DIR(W,D);       {*Refait le Directory*}
	 DRAW_LIST_REQ(W,D); End;            {*Raffiche Texte Files+Dirs*}
      DISPLAY_QTT_SELECTED(W,D);             {*Affiche "Selected"*}
      DISPLAY_STATS(W,D);                    {*Affichage Statistiques*}
      Mse_SetPointer(P_Current);
      End;
   If (Button_GetMsg(D.BOk,1)=CMSelected) Or       {*Bouton "OK"*}
      (Kbd_GetKeyDown(VK_RETURN)) Then            {*Touche "Enter"*}
      Begin
      NUM:=1; Size:=D.TBL[D.PList];
      DirSel:=D.Cin2; FilSel:=D.Cin3;        {*Transmet Rsultat*}
      If (D.Style>=2) And (D.Style<=6) Then Begin
	 FILE_ACTION(W,D,NUM);               {*Action for Del or Ren*}
         CLEAR_MAIN_BOX;                     {*Clear Box Principal*}
	 DRAW_LIST_REQ(W,D);
	 DISPLAY_STATS(W,D); End;            {*Affichage Statistiques*}
      End;
   If Slider_GetMsg(D.S1)=CMModified Then    {*Move Slider*}
      If D.S1.Value<>D.FList Then            {*La position change t-elle ?*}
	 Begin
	 D.FList:=D.S1.Value;                {*New Dbut de la Liste*}
	 D.OldItem:=-1;
	 DRAW_LIST_REQ(W,D);                 {*Raffiche Items dans Window*}
	 End;
   If (D.Style>=2) And (D.Style<=6) Then     {*Spcial Button for Delete Req*}
      Begin
      If Button_GetMsg(D.BAl,1)=CMSelected Then    {*Bouton "ALL"*}
	 Begin D.Tagged:=D.LList;            {*Qtt Tagged = Max List*}
	 For A:=1 to D.LList do
	    D.TBF[A]:=D.TBF[A] Or $80;       {*Set Bit 7="Tagged"*}
	 DRAW_LIST_REQ(W,D);                 {*Raffiche Items dans Window*}
	 DISPLAY_QTT_SELECTED(W,D);          {*Affiche "Selected"*}
	 End;
      If Button_GetMsg(D.BTo,1)=CMSelected Then    {*Bouton "TOGGLE"*}
	 Begin D.Tagged:=D.LList-D.Tagged;   {*Qtt Tagged = Max List-Tagged*}
	 For A:=1 to D.Llist do
	    If D.TBF[A] And $80=$80 Then D.TBF[A]:=D.TBF[A] And ($FF-$80)
            Else D.TBF[A]:=D.TBF[A] Or $80;  {*Toggle Bit 7="Tag/UnTag"*}
	 DRAW_LIST_REQ(W,D);                 {*Raffiche Items dans Window*}
	 DISPLAY_QTT_SELECTED(W,D);          {*Affiche "Selected"*}
	 End;
      If Button_GetMsg(D.BMa,1)=CMSelected Then    {*Bouton "MATCH"*}
	 Begin
         Num:=3;
	 Match_Name:=D.TBN[D.PList]+'.'+D.TBS[D.PList];
	 Req_String(Language.Loc(1),Language.Loc(27),Language.Loc(28),12,190,Match_Name, NUM);
	 If NUM=1 Then Begin                    {*Search File-Name Selected*}
	    Match_Found:=False;                 {*Init Boolean*}
	    For C:=1 to D.Nb_Files do
	    If (D.TBN[C]+'.'+D.TBS[C])=Match_Name   {*File-Name Found*}
	       Then Begin
	       D.FList:=C;                      {*Debut de la Liste en C*}
	       D.PList:=C;                      {*Item Slectionn = 1er*}
	       Match_Found:=True;               {*On  Trouv le Fichier*}
	       D.OldItem:=-1;                   {*Rinit Toggle*}
	       DRAW_LIST_REQ(W,D);              {*Raffiche Items dans Window*}
	       TOGGLE_ITEM(W,D);                {*Affiche Item Slectionn*}
               CALCUL_IAFF;                     {*Nb d'Items Affichable pour Slider*}
	       DRAW_SLIDER_ONDIR(D.LList,IAff,D.PList,W,D);{*Draw Slider on Window*}

	       DISPLAY_QTT_SELECTED(W,D);       {*Affiche "Selected"*}
	       End;
	    If Match_Found=False Then Play_Beep;{*Fichier non Trouv*}
	    End;
	 NUM:=-1;                               {*Reset NUM dans tat initial*}
	 End;

      End;                   {*Fin du Test des Boutons sup pour Style 2 et 3*}

   O_Y1 :=W.Y1+HaF1+7;                          {*Optimisations*}
   O_Y1B:=D.PList-D.FList+1;
   If (Mse_TestDoubleClick=True) And (D.TBN[D.PList]<>'.')
      And (D.TBN[D.PList]<>'..') And            {*Item Double Click*}
      (Mse_TestBox(O_X1, O_Y1+(O_Y1B)*HaF, W.X2-36, O_Y1-1+(O_Y1B+1)*HaF,1)=True)
      Then Begin
      NUM:=1; Size:=D.TBL[D.PList];
      DirSel:=D.Cin2; FilSel:=D.Cin3;           {*Exit With Rsultat*}
      If (D.Style>=2) And (D.Style<=6) Then Begin
	 FILE_ACTION(W,D,NUM);                  {*Action sur les Fichiers*}
         CLEAR_MAIN_BOX;                        {*Clear Box Principal*}
	 DRAW_LIST_REQ(W,D); End;               {*Raffiche Liste Items*}
      End;


{gotoxy(1,1); writeln('DirOk=',DirOk,' ');
gotoxy(1,2); writeln('Slider=',D.S1.Flg_But,' ');
gotoxy(1,3); writeln('PList=',TBL[D.PList],' ');}

   B:=1;
   If Sys.SlidersActivated=0 Then               {*le Slider est-t'il Dplac ?*}
   For A:=D.FList to D.LList do Begin           {*Parcours Liste Files+Drawers*}
      O_Y1 :=W.Y1+HaF1+7+B*HaF;                 {*Optimisations*}
      O_Y1B:=W.Y1+HaF1+6+(B+1)*HaF;
      If (Mse_TestBox(O_X1, O_Y1, W.X2-36, O_Y1B,0)=True) And (DirOk=True) Then
         If O_Y1-2<O_Y2-HaF-2 Then
            If D.TBL[D.PList]=0 Then            {*It's a Drawer !!!*}
               Begin
               Mse_SetPointer(MPBusy);          {*Pointer to be Busy*}
               CLEAR_MAIN_BOX;                  {*Clear Box Principal*}
	       GET_NEW_REP(W,D);                {*Change le Path*}
	       GET_FILE_DIR(W,D);
	       DRAW_LIST_REQ(W,D);              {*Raffiche Items dans Window*}
	       DISPLAY_QTT_SELECTED(W,D);       {*Affiche "Selected"*}
	       DISPLAY_STATS(W,D);              {*Affichage Statistiques*}
	       Mse_SetPointer(P_Current);       {*Pointer to be Busy*}
               End;
      If Mse_TestBox(O_X1, O_Y1, W.X2-LaF*2-21, O_Y1B,1)=True Then{*Box Principale*}
	 Begin                                  {*Dans le Box de la Window*}
	 If O_Y1-2<O_Y2-HaF-2 Then Begin
	    D.PList:=A; TOGGLE_ITEM(W,D);       {*Affiche Item Slectionn*}
	    DirOk:=True;
	    End;
	 End;
      Inc(B);
      End;
   End;                                         {*End du Flag Modifie Window*}

   If Mse_Clicked(1)=False Then DirOk:=False;   {*Souris Relache = Rinit Boolean*}
   If Mse_Clicked(2)=False Then Cl2_One:=False; {*Mouse Button Center Relach*}

{   Gotoxy(1,1); Writeln('Display ROOT=',D.Flg_Root,' ');

   Gotoxy(1,2); Writeln('Pos in Slider=',D.S1.Psl,' ');
   Gotoxy(1,3); Writeln('Path=',D.Cin2,'       ');
   Gotoxy(1,4); Writeln('FList=',D.FList,' PList=',D.PList,' LList=',D.LList,' ');
   Gotoxy(1,5); Writeln('Slider: Qtt Items=',D.S1.Qtt,' NbAff=',D.S1.Aff,' ');
   Gotoxy(1,6); Writeln('TBName=',TBN[D.PList],'     ');
   Gotoxy(1,7); Writeln('DirOk=',DirOk,' ');
   Gotoxy(1,8); Writeln('Size File=',TBL[D.PList],' ');}

Until NUM<>-1;

If NUM=0 Then Begin DirSel:=''; FilSel:=''; Size:=0; End;{*Bouton Close Window*}

Win_Done(W);                              {*Kill Window*}
End;

{ͻ
                           FUNCTION Browse_Define                           
 ͹
  IN.....: Df (TBrowse) = Pointer to the TBrowse structure.                 
           X1,Y1,X2,Y2 (INTEGER) = Box coordinates.                         
           Color1, Color2 (LONGINT) = The list colors.                      
              0 = Select directory only.                                    
              1 = Select one file only.                                     
              2 = Select various file only.                                 
           IdFunction (WORD) = Bits to parameter.                           
              Bit 0  $0001 : 1 = Rename file enabled.                       
              Bit 0  $0001 : 1 = Delete file enabled.                       
              Bit 0  $0001 : 1 = File information enabled if need.          
              Bit 0  $0001 : 1 = Associate file to application enabled.     
           IdFunction (WORD) = Bits to parameter.                           
              Bit 0  $0001 : 1 = Save as default configuration.             
              Bit 1  $0002 : 1 = Freezed component.                         
              Bit 2  $0004 : 1 = Unvisible component.                       
         5  0020 :  1 = Multiselection Items Enable / Monoselection         
         9  0200 :  1 = Select Items Enable                                 
        12  1000 :  1 = Enable Items sorting by user                        
         3  0008 :  1 = Disable ENTER Key                                   
           IdLook (WORD) = Bits to parameter.                               
              Bit 0  $0001 : 1 = Display list title                         
        10  0400 :  1 = Show columns separator                              
        11  0800 :  1 = Alternates colors for lines                         
        13  2000 :  1 = Show grid (Using Lightgray Color)                   
           IdColumns (WORD) = Specify columns to display.                   
              Bit 0  $0001 : 1 = Display filenames column.                  
              Bit 1  $0002 : 1 = Display filesize column.                   
              Bit 2  $0004 : 1 = Display description column (type).         
              Bit 3  $0008 : 1 = Display attributes column.                 
              Bit 4  $0010 : 1 = Display date/time column.                  
           Location (STRING) = Path + filename to begin.                    
           Mask (STRING) = File mask.                                       
  OUT....: /                                                                
  EXPLAIN: Display in a list the specified path and files, and allow you    
           to browse the disks.                                             
 ͼ}

Procedure Browse_Define(Var Df:TBrowse; X1,Y1,X2,Y2:Integer; Color1,Color2:Longint; IdFunctions,IdLook,IdColumns:Word; Location,Mask:String);
Var Columns:String;
    IdBits,IdMoreBits:Word;
Begin
// To avoid warnings !
IdFunctions := IdFunctions;

Log.Add('Create Browse component',2);

Columns:='';                            {*Displayable columns*}
If BTST(IdColumns,0) Then Columns:=Columns+'Name ';
If BTST(IdColumns,1) Then Columns:=Columns+';Size ';
If BTST(IdColumns,2) Then Columns:=Columns+';Type ';
If BTST(IdColumns,3) Then Columns:=Columns+';Attr ';
If BTST(IdColumns,4) Then Columns:=Columns+';Date ';

IdBits := $4+$8+$200;
IdMoreBits := $0;

If BTST(IdLook,0) Then BSET(IdBits,0);
List_Define(Df.List,Columns,';',X1,Y1,X2,Y2, 5000, Color1,Color2,IdBits);
List_SetIdMore(Df.List,IdMoreBits);
List_SetColumnAttr(Df.List,1,105,Text_OnLeft);{*Paramtrage des Colonnes*}
List_SetColumnAttr(Df.List,2,60, Text_OnRight);
List_SetColumnAttr(Df.List,3,80, Text_OnLeft);
List_SetColumnAttr(Df.List,4,-1, Text_Center);
List_SetColumnAttr(Df.List,5,160,Text_OnLeft);

Df.CurrentPath:=Dsk_ValideDirectory(File_StrSplit(Location,$0003));
Df.CurrentFile:=File_StrSplit(Location,$000C);
Df.Mask:=Mask;
Df.ConfigFile:=Sys.GetPath(SP_DATAS)+'Fselect.ini';

Browse_Update(Df);                     {*Build list file*}
End;

{ͻ
                            PROCEDURE Browse_Done                           
 ͹
  IN.....: Df (TBrowse) = Pointer to the TBrowse structure.                 
  OUT....: /                                                                
  EXPLAIN: Terminate the Browse component (free memory).                    
 ͼ}

Procedure Browse_Done(Df:TBrowse);
Begin
Log.Add('Kill Browse component',2);
List_Done(Df.List);
End;

{ͻ
                            PROCEDURE Browse_Draw                           
 ͹
  IN.....: Df (TBrowse) = Pointer to the TBrowse structure.                 
  OUT....: /                                                                
  EXPLAIN: Display the Browse component.                                    
 ͼ}

Procedure Browse_Draw(Df:TBrowse);
Begin
If BTST(Df.IdFunctions,2) Then Exit;    {*Unvisible list*}
List_Show(Df.List);
End;

{ͻ
                          PROCEDURE Browse_Refresh                          
 ͹
  IN.....: Df (TBrowse) = Pointer to the TBrowse structure.                 
  OUT....: /                                                                
  EXPLAIN: Refresh the Browse component and display only the list content.  
 ͼ}

Procedure Browse_Refresh(Df:TBrowse);
Begin
List_Refresh(Df.List);
End;

{ͻ
                          PROCEDURE Browse_Update                           
 ͹
  IN.....: Df (TBrowse) = Pointer to the TBrowse structure.                 
  OUT....: /                                                                
  EXPLAIN: Update the Browse list directory using current defined path.     
 ͼ}

Procedure Browse_Update(Var Df:TBrowse);
Var DI            :SearchRec;
    Qtt           :Longint;
    St,SSize      :String;
    Ti,FA,FT      :String;
    Dt            :DateTime;            {*For Pack/UnpackTime*}

Begin
Qtt:=0;                                 {*Quantit de Fichiers Trouvs*}
dos.FindFirst(Df.CurrentPath+Df.Mask, AnyFile, DI);
While DosError=0 do
   Begin
   Inc(Qtt);
   SSize:=Str_L2S(File_GetSize(Df.CurrentPath+DI.Name));
   FT:=Get_FileDescription(DI.Name,M_Extention);
   UnpackTime(DI.Time,Dt);
   Ti:=Str_FillZero(Dt.Day,2)+'.'+Str_FillZero(Dt.Month,2)+'.'+Str_FillZero(Dt.Year,2);
   FA:='      ';
   If BTST(DI.Attr,0) Then FA[6]:='R';
   If BTST(DI.Attr,1) Then FA[5]:='H';
   If BTST(DI.Attr,2) Then FA[4]:='S';
   If BTST(DI.Attr,3) Then FA[3]:='I';
   If BTST(DI.Attr,4) Then FA[2]:='D';
   If BTST(DI.Attr,5) Then FA[1]:='A';

   St:=DI.Name+';'+Str_Format(SSize,' ',3)+';'+FT+';'+FA+';'+Ti;
   List_AddItem(Df.List, St, Insert_Append);
   dos.FindNext(DI);
   End;

List_Sort(Df.List,1,Sort_AZ,2);               {*Tri de la Liste...*}
End;

{ͻ
                         FUNCTION Browse_LoadConfig                         
 ͹
  IN.....: Df (TBrowse) = Pointer to the TBrowse structure.                 
  OUT....: (BOOLEAN) = TRUE if the config has been successfully loaded.     
  EXPLAIN: Load the default configuration for the Browse component.         
 ͼ}

Function Browse_LoadConfig(Var Df:TBrowse):Boolean;
Var Ini:TIniFile;
    Section:String;
Begin
Browse_LoadConfig:=No;
If Not File_TestExist(Df.ConfigFile) Then Exit; {*Config file not found*}
Ini_Init(Ini,Df.ConfigFile);

Section:='Design';
Df.IdLook:=Ini_LoadKey(Ini,Section,'IdLook',Df.IdLook);

Ini_Done(Ini);
Browse_LoadConfig:=Yes;
End;

{ͻ
                         FUNCTION Browse_SaveConfig                         
 ͹
  IN.....: Df (TBrowse) = Pointer to the TBrowse structure.                 
  OUT....: (BOOLEAN) = TRUE if the config has been successfully saved.      
  EXPLAIN: Save the default configuration for the Browse component.         
 ͼ}

Function Browse_SaveConfig(Df:TBrowse):Boolean;
Var Ini:TIniFile;
    Section:String;
Begin
Ini_Init(Ini,Df.ConfigFile);

Section:='Design';
Ini_SaveKey(Ini,Section,'IdLook',Df.IdLook);

Ini_Done(Ini);
Browse_SaveConfig:=Yes;
End;

{ͻ
                           FUNCTION Browse_GetMsg                           
 ͹
  IN.....: Df (TBrowse) = Pointer to the TBrowse structure.                 
  OUT....: (BYTE) = Message from the Browse component.                      
  EXPLAIN: Manage and get messages from the Browse component.               
 ͼ}

Function Browse_GetMsg(Var Df:TBrowse):Byte;
Begin
Browse_GetMsg:=CMNone;
If BTST(Df.IdFunctions,1) Then Exit;    {*Freezed list*}

List_Test(Df.List);
End;

{*------------------------ PAS DE PROG PRINCIPAL ---------------------------*}

Begin
End.
