{ͻ
                               UNIT MosFiles                                
 ͹
  CREATOR....: PLANAS Jean-Pierre                                           
  UPDATED BY.: PLANAS Jean-Pierre                                           
  CREATED THE: 12.11.1998                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: Files procedures & functions.                                
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 1.998 Lines and (42.976 Bytes compiled)                      
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

{$R+}
{$MODE ObjFpc}

UNIT MosFiles;

INTERFACE

Uses
     Dos,
     MosMemory;

Const BufferSize=2048; {*Size of buffer for copy and comparaison...*} {MIC}

Type
      TRecurseProc = Procedure (x:PathStr); {*Type for File_Find*}

      TRSearchRec=Record
       Stack    : TStack;      {MIC}  {*An usual stack*}
       PathInit : String[128]; {MIC}  {*The Path Where begin the search*}
       Mask     : String[12];  {MIC}  {*File Mask*}
       Attr     : Word;        {MIC}  {*Attr of RFindFirst*}
       Ended    : Boolean;     {MIC}  {*Over*}
       FirstDir : Boolean;     {MIC}  {*True while in PathInit*}
       FileName : String[128];   {*Name of the file Found*}
       Dirinfo  : SearchRec;     {*SearchRec of the file *}
      End;

TDateTimeFormat = (                     {*Date time string format*}
   DTFrench,
   DTEnglish);

TFileExpandFormat = (                   {*Used by "BuildNextName"*}
   FEValue,
   FELetter);

TFileConflict = (                       // In case of files conflits
   FCReplaceFile,
   FCIgnore
   );

{|Text Files|}
Function  File_TextCopy(FName,FTarget:String; FLine,LLine:LOngint):Boolean;{*Copy Text files with indices*}
Function  File_DeleteLine(FName:String;Line:Word):Boolean;   {*Delete a line in a text file*}
Function  File_ReplaceLine(FName,NewLine:String;Line:Word):Boolean;{*Replace a line in a Text file*}
Function  File_InsertString(FName,St:String;Pos:Longint):Boolean;  {*Insert a string in a file at pos*}
Function  File_GetLine(FName:String; Line:Longint):String;   {*Get the string of a line in file*}
Function  File_AppendString(FName:String;S:String):Boolean;  {*Add a string in a text file*}
Function  File_TestString(FName,St:String; Mode,Line:Word):Longint;{*Test if string is in file*}
Function  File_CountString(FName,St:String;Id:Word):Integer; {*Count how many times sub-string founded*}
Function  File_CountLines(FName:String):Longint;             {*Count the number of lines of a file*}
Procedure File_ClearBlankLines(Source,Target:String);        {*Delete blank lines in a file*}
Function  File_GetLongString(FName:String):String;           {*Get longest string of the file*}

{|Files|}
Function  File_TestExist2(FName:String):Boolean;
Function  File_GetAttrib(FName:String):Word;      {*Get attributes of a file*}
Function  File_TestWritable(FName:String):Boolean;{*Test if a file can be rewritten*}
Function  File_SetMask(SourceIni,Source,Target:String):String; {*Calculate a target filename*}
Function  File_StrSplit(S:String;Attr:Word):String; {*Get a part of full pathname*}
Function  File_TargetFileName(Source,Target,SourceFN:String):String; {*Get Target file name*}
Function  File_TestExist(FName:String):Boolean; {*Test if the file exist*}
Function  File_TestHeader(FN:String;Header:String;Offset:Longint):Boolean; {*Test if file have a good header*}
Function  File_GetSize(Name:String):Longint;   {* Get the size of a file *}
Function  File_GetModifiedTime(FName:String; Format:TDateTimeFormat):String; {*Get the modified time of file*}
Function  File_BuildNextName(FName:String; Format:TFileExpandFormat):String; {*Get new name for output file*}
Function  File_Erase(Fn:String):Boolean;       {*Delete a File*}
Function  File_Replace(FN1,FN2:String):Boolean;{*Replace a file*}
Function  File_Rename(FN1,FN2:String):Boolean; {*Rename a file*}
Procedure File_Split(S:String;Var Path,Mask:String);     {*Get path and mask from a string*}
Function  File_Copy (SourceFile,TargetFile:String):Byte; {*Copy of file*}
Function  File_Create(FName:String):Boolean;      {*Create an empty file*}
Procedure File_GetDirectory(Source,Target:String);{*Read directory and save in file*}
Function  File_CheckSum(FN:String):Longint;       {*Calculate a CRC*}
Function  File_Comp(FN1,FN2:String):Byte;         {*Compare 2 files*}

{|Temporaire|}                                {MIC}
Function  Get_AppName:String;                 {*Return the file name of the application*}
Function  Get_AppPath:String;
Function  Get_AppIniName:String;              // Return the INI file for the current application

{|To be deleted|}                             {MIC}
Procedure File_FindBreak;
Procedure File_Find(Source:String; Recurse:Boolean; FileDo:TRecurseProc); {*Get files with recurse*}

IMPLEMENTATION

Uses
     MosCPUInstructions,
     MosDisks,
     MosFilesTree,
     MosStrings;

{-------------------------------- Text Files --------------------------------}

{ͻ
                           FUNCTION File_TextCopy                           
 ͹
  IN.....: FName (STRING) = Source filename.                                
           FTarget (STRING) = Target file.                                  
           FLine, LLine (LONGINT) = First and last line number.             
  OUT....: (BOOLEAN) = TRUE if operation completed, else FALSE.             
  EXPLAIN: Copy a text file using the first and last line to copy.          
  EXAMPLE: File_TextCopy('TOTO.TXT','TITI.TXT',10,100);                     
  NB.....: FName and FTarget must be differents.                            
 ͼ}

Function File_TextCopy(FName,FTarget:String; FLine,LLine:Longint):Boolean;
Var F1,F2    :Text;
    St:String;
    Indice:Integer;

Begin
File_TextCopy:=False;

Assign(F1,FName);
{$i-}
Reset(F1);
{$i+}
If Ioresult<>0 Then Exit;              {*Error*}

Assign(F2, FTarget);
{$i-}
Rewrite(F2);
{$i+}
If Ioresult<>0 Then                    {*Error*}
  Begin
  Close(F1); Exit;
  End;

Indice:=0;                             {*Zero lignes...*}
While Not Eof(F1) Do
  Begin
  {$i-}
  Readln(F1,St); Inc(Indice);
  {$i+}
  If Ioresult<>0 Then Begin Close(F1); Close(F2); Exit; End; {*Error*}
  If Indice>=FLine Then                {*Line Not Found*}
    Begin
    {$i-}
    Writeln(F2,St);
    {$i+}
    If Ioresult<>0 Then Begin Close(F1); Close(F2); Exit; End; {*Error*}
    End;
  If Indice>=LLine Then                {*End of file Reached... Exit OK*}
     Begin
     Close(F1); Close(F2);
     File_TextCopy:=TRUE;
     Exit;
     End;
  End;

Close(F2);
Close(F1);
File_TextCopy:=TRUE;
End;

{ͻ
                          FUNCTION File_DeleteLine                          
 ͹
  IN.....: FName (STRING) = Name of a file.                                 
           Line (WORD) = Line number to delete.                             
  OUT....: (BOOLEAN) = TRUE if operation completed, else FALSE              
  EXPLAIN: Delete a line in a text file.                                    
  EXAMPLE: File_DeleteLine('toto.pas',1);                                   
  NB.....: If the line number of the file is less than Line, return TRUE    
 ͼ}
Function File_DeleteLine(FName:String;Line:Word):Boolean;
Var F1,F2    : Text;
    j        : Word;
    FName2,S : String;
Begin
File_DeleteLine:=False;
FName2:=File_BuildNextName(FName, FEValue);

Assign(F1,FName);
FileMode:=0;
{$i-}
Reset(F1);
{$i+}
If Ioresult<>0 Then Exit;                    {*Error*}

Assign(F2,FName2);
FileMode:=1;
{$i-}
Rewrite(F2);
{$i+}
If Ioresult<>0 Then                          {*Error*}
  Begin
  Close(F1);Exit;
  End;

S:=''; j:=0;
While Not eof(F1) Do
  Begin
  {$i-}
  Readln(F1,S);  Inc(j);
  {$i+}
  If Ioresult<>0 Then Begin Close(F1);Close(F2);Exit; End; {*Error*}
  If j<>Line Then                                          {*Line Not Found*}
    Begin

    {$i-}
    Writeln(F2,S);
    {$i+}
    If Ioresult<>0 Then Begin Close(F1);Close(F2);Exit; End; {*Error*}
    End;
  End;

Close(F2);
Close(F1);

If Not File_Replace(FName,FName2) Then Exit;               {*Error*}

File_DeleteLine:=True;

End;

{ͻ
                         FUNCTION File_ReplaceLine                          
 ͹
  IN.....: FName (STRING) = Name of a file.                                 
           NewLine (STRING) = String witch contain the new string.          
           Line (WORD) = Line number to replace.                            
  OUT....: (BOOLEAN) = TRUE if operation completed, else FALSE              
  EXPLAIN: Replace a line of the text file by an other.                     
           NewLine contain the new string and Line is the N of the line    
           in the file to be replaced.                                      
  EXAMPLE: File_ReplaceLine('toto.pas','Uses crt,',1);                      
  NB.....: If the line number of the file is less than Line, return TRUE    
 ͼ}
Function File_ReplaceLine(FName,NewLine:String;Line:Word):Boolean;
Var F1,F2    : Text;
    j        : Word;
    FName2,S : String;
Begin
File_ReplaceLine:=False;
FName2:=File_BuildNextName(FName, FEValue);

Assign(F1,FName);
FileMode:=0;
{$i-}
Reset(F1);
{$i+}
If Ioresult<>0 Then Exit;                    {*Error*}

Assign(F2,FName2);
FileMode:=1;
{$i-}
Rewrite(F2);
{$i+}
If Ioresult<>0 Then                          {*Error*}
  Begin
  Close(F1);Exit;
  End;

S:=''; j:=0;
While Not eof(F1) Do
  Begin
  {$i-}
  Readln(F1,S);  Inc(j);
  {$i+}
  If Ioresult<>0 Then Begin Close(F1);Close(F2);Exit; End; {*Error*}
  If j=Line Then S:=NewLine;                               {*Line Found*}
  {$i-}
  Writeln(F2,S);

  {$i+}
  If Ioresult<>0 Then Begin Close(F1);Close(F2);Exit; End; {*Error*}
  End;

Close(F2);
Close(F1);

If Not File_Replace(FName,FName2) Then Exit;               {*Error*}

File_ReplaceLine:=True;
End;

{ͻ
                         FUNCTION File_InsertString                         
 ͹
  IN.....: FName (STRING) = Path+Name of the file                           
           St (STRING) = String to insert.                                  
           Pos (LONGINT) = Position where the string must be insert.        
  OUT....: (BOOLEAN) = TRUE if all is OK, FALSE if any I/O errors or        
           incorrect Position.                                              
  EXPLAIN: Insert a string at the Pos'th position...                        
 ͼ}
Function File_InsertString(FName,St:String;Pos:Longint):Boolean;
Var F1,F2:Text;
    FName2,S:String;
    I,Qte:Longint;
Begin
File_InsertString:=False;


Qte:=File_CountLines(FName);
If Qte+1<Pos Then Exit;                                     {*Error*}
If Qte+1=Pos Then
  Begin
  File_InsertString:=File_AppendString(FName,St);
  Exit;
  End;

Assign(F1,FName);

FName2:=File_BuildNextName(FName, FEValue);

Assign(F2,FName2);

{$I-}
Reset(F1);
{$I+}
If Ioresult<>0 Then Exit;                                   {*Error*}

{$I-}
ReWrite(F2);
{$I+}
If Ioresult<>0 Then Begin Close(F1);Exit;End;               {*Error*}

I:=0;
While not eof(F1) do
  Begin
  {$I-}
  Readln(F1,S);                                     {*Read a string*}
  {$I+}
  If Ioresult<>0 Then Begin Close(F1);Close(F2);Exit;End;   {*Error*}
  Inc(I);
  If Pos=i Then                                     {*Insert the line*}
    Begin
    {$I-}
    Writeln(F2,St);                                 {*Write the line*}
    If Ioresult<>0 Then Begin Close(F1);Close(F2);Exit;End; {*Error*}
    {$I+}
    End;
  {$I-}
  Writeln(F2,S);                                    {*Write a string*}
  {$I+}
  If Ioresult<>0 Then Begin Close(F1);Close(F2);Exit;End;   {*Error*}
  End;

Close(F2);
Close(F1);

If Not File_Replace(FName,FName2) Then Exit;                {*Error*}

File_InsertString:=True;                                    {*Ok*}
End;

{ͻ
                           FUNCTION File_GetLine                            
 ͹
  IN.....: FName (STRING) = Path+Name of the file                           
           Line (LONGINT) = Line to get the string.                         
  OUT....: (STRING) = The string of the line.                               
  EXPLAIN: Get the string of a line from a file.                            
  SEEALSO: Dsk_CoutLines                                                    
 ͼ}

Function File_GetLine(FName:String; Line:Longint):String;
Var F:Text;
    St:String;
    I:Longint;

Begin
File_GetLine:='';
If Not File_TestExist(FName) Then Exit;

Assign(F,FName);
{$I-}
Reset(F);
{$I+}
I:=0;
While Not Eof(F) do
  Begin
  Readln(F,St);
  Inc(I);
  If Line=I Then
     Begin
     File_GetLine:=St;
     Close(F);
     Exit;
     End;
  End;
Close(F);

End;

{ͻ
                         FUNCTION File_AppendString                         
 ͹
  IN.....: FName (STRING) = Path + Name of the file to process              
           S  (STRING) = String to put on the end of the file               
  OUT....: (BOOLEAN) = TRUE if all is OK, else FALSE                        
  EXPLAIN: Put a string at the end of a text file. If the file don't exist  
           it will be created.                                              
  NB.....: The file must be a text file.                                    
  EXAMPLE: Writeln('Setup completed : ',File_AppendString('AUTOEXEC.BAT',   
           'Set DPMIMEM = MAXMEM 2048'));                                   
 ͼ}
Function File_AppendString(FName:String;S:String):Boolean;
Var F:Text;
Begin
File_AppendString:=False;
Assign(F,FName);
If File_TestExist(FName) Then
  Begin
  {$i-}
  Append(F);
  {$i+}
  If Ioresult<>0 Then Exit;
  End
Else
  Begin
  {$i-}
  Rewrite(F);
  {$i+}
  If Ioresult<>0 Then Exit;
  End;
Writeln(F,S);
Close(F);

File_AppendString:=True;
End;

{ͻ
                          FUNCTION File_TestString                          
 ͹
  IN.....: FName (STRING) = Path + File name                                
           St (STRING) = String to test if is in file !!!                   
           Mode (WORD) = 0 = Test the whole file line is equal.             
                         1 = Test if the string is contained in line.       
            Bit  Num                                                        
             0   0001  Test if the string is contained in line,             
                       (else test if the whole file line is equal).             
             1   0002  Case Sensitive (else not case sensitive)             
             2   0004                                                       
           Line (WORD) = Line number where to begin the test.               
  OUT....: (LONGINT) = Line number where the string found.                  
           Return 0 is no string found.                                     
  EXPLAIN: Test if a string is or not in a text file !!                     
 ͼ}

Function File_TestString(FName,St:String; Mode,Line:Word):Longint;
Var F:Text;
    S:String;
    Qtt:Longint;                        {*Nombre de lignes*}

Begin
File_TestString:=0;
Assign(F,FName);
FileMode:=0;
If Not BTST(Mode,1) Then St:=Upper(St);
{$i-}
Reset(F);
{$i+}
If Ioresult<>0 Then Exit;
S:=''; Qtt:=0;
While not eof(F) do
  Begin
  {$i-}
  Readln(F,S); Inc(Qtt);
  {$i+}
  If Ioresult<>0 Then
    Begin
    Close(F);
    Exit;
    End;
  If Not BTST(Mode,1) Then S:=Upper(S);

  If ((Not BTST(Mode,0)) And (S=St)) Or (BTST(Mode,0) And (Pos(St,S)>0)) And (Qtt>=Line) Then
     Begin
     File_TestString:=Qtt;
     Close(F);
     Exit;
     End;
  End;
{$i-}
Close(F);
{$i+}
If Ioresult<>0 Then Exit;
End;

{ͻ
                         FUNCTION File_CountString                          
 ͹
  IN.....: FName (STRING) = Name of the file.                               
           St (STRING) = String to search in the file                       
           Id (WORD) = Flags :                                              
             Bit 0  $0001 = If bit set Case sensitive                       
             Bit 1  $0002 =                                                 
  OUT....: (INTEGER) = Return the number of lines which contain this sub-   
                       string or return -1 if an I/O error occurs.          
  EXPLAIN: Return how many lines contains the substring.                    
  NB.....: This function is Cas sensitive.                                  
  EXAMPLE: Writeln(File_CountString('example.txt','Echo',1))=3              
           Writeln(File_CountString('example.txt','Echo',0))=5              
           And here is the file example.txt :                               
           @Echo Off                                                        
           Echo Echo                                                        
           Echo On                                                          
           ECHO toto                                                        
           eCHo toto                                                        
 ͼ}
Function File_CountString(FName,St:String;Id:Word):Integer;
Var F:Text;
    S:String;
    Res:Integer;
Begin
File_CountString:=-1;
Res:=0;
Assign(F,FName);
If Not BTST(Id,0) Then St:=UPPER(St);   {*Not Case Sensitive*}
{$i-}
Reset(F);
{$i+}
If IoResult<>0 Then Exit;
While Not Eof(F) do
  Begin
  {$i-}
  Readln(F,S);
  {$i+}
  If Not BTST(Id,0) Then S:=UPPER(S);   {*Not Case Sensitive*}
  If Pos(St,S)>0 Then Inc(Res);
  If IoResult<>0 Then Begin Close(F);Exit; End;
  End;
{$i-}
Close(F);
{$i+}
If IoResult<>0 Then Exit;
File_CountString:=Res;
End;

{ͻ
                          FUNCTION File_CountLines                          
 ͹
  IN.....: FName (STRING) = Path+Name of the file                           
  OUT....: (LONGINT) = Number of lines of the file.                         
                       -1 if I/O error occurs.                              
  EXPLAIN: Count the number of lines of a file.                             
  SEEALSO: File_GetLine                                                     
 ͼ}

Function File_CountLines(FName:String):Longint;
Var F:Text;
    S:String;
    I:Longint;
Begin
File_CountLines:=-1;
Assign(F,FName);
FileMode:=0;
{$I-}
Reset(F);
{$I+}
If Ioresult<>0 Then Exit;                     {*Error*}
i:=0;
While not eof(F) do
  Begin
  {$i-}
  Readln(F,S);
  {$i+}
  If Ioresult<>0 Then Begin Close(F);Exit;End;{*Error*}
  Inc(I);
  End;
{$i-}
Close(F);
{$i+}
If Ioresult<>0 Then Exit;                     {*Error*}

File_CountLines:=i;
End;

{ͻ
                       PROCEDURE File_ClearBlankLines                       
 ͹
  IN.....: Source (STRING) = Path+Name of the file                          
           Target (STRING) = Path+Name of the file result.                  
  OUT....: /                                                                
  EXPLAIN: If there is more than 1 blank line don't copy the blank line     
           but copy all other lines...                                      
 ͼ}

Procedure File_ClearBlankLines(Source,Target:String);
Var FS,FT:Text;
    S,OldS:String;
Begin
{$I-}
Assign(FS,Source);Reset(FS);
Assign(FT,Target);Rewrite(FT);
{$I+}

S:='';
While Not Eof(FS) do
  Begin
  OldS:=S;
  Readln(FS,S);
  If (S<>'') Or (OldS<>'') Then Writeln(FT,S);
  End;
Close(FT);
Close(FS);
End;

{ͻ
                        FUNCTION File_GetLongString                         
 ͹
  IN.....: FName (STRING) = Name of the file where the search will begin    
  OUT....: (STRING) = The longest string of the text file.                  
  EXPLAIN: Return the last longest string of a file.                        
 ͼ}

Function File_GetLongString(FName:String):String;
Var F:Text;
    S1,S2:String;

Begin
File_GetLongString:='';S1:='';S2:='';
Assign(F,FName);
{$i-}
Reset(F);
{$i+}
If IoResult<>0 Then Exit;
While Not Eof(F) do
  Begin
  Readln(F,S1);
  If Length(S1)>=Length(S2) Then S2:=S1;
  End;
Close(F);
File_GetLongString:=S2;
End;

{----------------------------------Files-------------------------------------}

{ͻ
                          FUNCTION File_TestExist2                          
 ͹
  IN.....: FName (STRING) = Path + Name of the file                         
  OUT....: (BOOLEAN) = TRUE if the file exist, else FALSE.                  
  EXPLAIN: Test if the file exist.                                          
  NB.....: If FName='' return FALSE.                                        
 ͼ}

Function File_TestExist2(FName:String):Boolean;
Var DirInfo: SearchRec;
Begin
File_TestExist2:=False;
If (Pos('*',FName)>0) or (Pos('?',FName)>0) Then Exit; {*Pas de Jokers*}
FindFirst(FName,AnyFile-Directory-VolumeId,Dirinfo);
File_TestExist2:= DosError=0;                           {*Resultat*}
End;

{ͻ
                             Function File_GetAttrib                        
 ͹
  IN.....: FName (String) = FileName to get attributes values               
  OUT....: (Word) = Attributes of the files.                                
  EXPLAIN: Return file attributes.                                          
  CF.....: GetFAttr                                                         
  EXAMPLE: If File_GetAttrib('foo.txt') And ReadOnly <>0 Then ...           
 ͼ}
Function File_GetAttrib(FName:String):Word;
Var F:File;
    Attr:Word;
Begin
Assign(F, FName);
GetFAttr(F, Attr);                 {*Dos call*}
File_GetAttrib:=Attr;
End;

{ͻ
                             Function File_TestWritable                     
 ͹
  IN.....: FName (String) = FileName to test.                               
  OUT....: (Boolean) = TRUE if you can write on this file, else FALSE       
  EXPLAIN: Test if an existing file can be rewriten.                        
           If file doesn't exist, this function returns FALSE.              
  EXAMPLE: If File_TestWritable('Autoexec.bat') Then ...                    
 ͼ}
Function File_TestWritable(FName:String):Boolean;
Var Drive:String;
    F:File;
Begin
FName:=FExpand(FName);
Drive:=File_StrSplit(FName,1);
If (Not Dsk_TestWritableDrive(Drive)) Or         {*Read only disk*}
   ((File_GetAttrib(FName) and ReadOnly)<>0)     {*Read Only file*}
                                            Then
  Begin                                          {*Result=False*}
  File_TestWritable:=False;
  Exit;
  End;

Assign(F,FName);
FileMode:=2;
{$I-}
Reset(F);
{$i+}
If ioresult<>0 Then
  Begin                                   {*Result=False*}
  File_TestWritable:=False;               {*Perhars because file is shared*}
  Exit;
  End;
Close(F);

File_TestWritable:=True;                  {*Result=True*}
End;

{ͻ
                            Function File_SetMask                           
 ͹
  IN.....: SourceIni (STRING) = start directory                             
           Source    (STRING) = current file                                
           Target    (STRING) = target path (and mask)                      
  OUT....: (STRING) = target path and file name                             
  EXPLAIN: Calculate the target path and file name.                         
           Usefull for xcopy : Xcopy SourceIni Target /s                    
            loop of all files                                               
            copy(CurrentFile,File_Setmask(SourceIni,CurrentFile,Target));   
            end loop                                                        
  EXAMPLE: File_SetMask('c:\','c:\t.txt','d:\*.*') = d:\t.txt               
           File_SetMask('c:\','c:\2\t.txt','d:\2\*.*') = d:\2\t.txt         
 ͼ}
Function File_SetMask(SourceIni,Source,Target:String):String;
Var FD1,FD2,FD3,FM1,FM2,FM3,S:String;

Begin
File_Split(SourceIni,FD1,FM1);
File_Split(Source   ,FD2,FM2);
File_Split(Target   ,FD3,FM3);

{Writeln(FD1);
Writeln(FD2);
Writeln(FD3);

Writeln(FM1);
Writeln(FM2);
Writeln(FM3);
}

S:= Copy(FD2,Length(FD1)+1,Length(FD2));{* FD2-FD1 *}

File_SetMask:=FD3+S+Str_FileMask(FM2,FM3);
End;

{ͻ
                           FUNCTION File_StrSplit                           
 ͹
  IN.....: S (STRING) = Full path and name of file to split.                
           Attr (WORD) =                                                    
            Bit  Num                                                        
             0   0001  Drive                                                
             1   0002  Path                                                 
             2   0004  File name or file mask                               
             3   0008  Extension of the file or extension mask              
  OUT....: (STRING) = Result string                                         
  EXPLAIN: This function return what you want from a complete pathname.     
           If you want only the drive, or only the path...                  
  NB.....: S must contain the complete path (drive+path+filename+extension) 
  EXAMPLE: S:='d:\toto\titi.pas';                                           
           File_StrSplit(S,0);   =  ''                                      
           File_StrSplit(S,1);   =  'd:'                                    
           File_StrSplit(S,3);   =  'd:\toto\'                              
           File_StrSplit(S,4);   =  'titi'                                  
           File_StrSplit(S,12);  =  'titi.pas'                              
           File_StrSplit(S,15);  =  'd:\toto\titi.pas'                      
 ͼ}

Function File_StrSplit(S:String;Attr:Word):String;
Var R:String;                                     {*Result*}
    P:Integer;                                    {*Position in string*}

Begin
R:='';
If S[2]=':' Then                                  {*Drive*}
  Begin
  If BTST(Attr,0) Then R:=S[1]+':';
  S:=Copy(S,3,Length(S));
  End;

P:=Str_LastPos('\',S);                            {*Path*}
If P>0 Then
  Begin
  If BTST(Attr,1) Then R:=R+Copy(S,1,P);
  S:=Copy(S,P+1,Length(S));
  End;

P:=Str_LastPos('.',S);                            {*FileName*}
If P>0 Then
  Begin
  If BTST(Attr,2) Then R:=R+Copy(S,1,P-1);
  S:=Copy(S,P+1,Length(S));
  End
Else If BTST(Attr,2) Then
  Begin
  R:=R+S;
  S:='';
  End;

If BTST(Attr,2) And BTST(Attr,3) Then R:=R+'.';   {*Extension*}

If BTST(Attr,3) Then R:=R+S;

File_StrSplit:=R;
End;

{ͻ
                        FUNCTION File_TargetFileName                        
 ͹
  IN.....: Source (STRING) = Source Path and Mask                           
           Target (STRING) = Target Path and Mask                           
           SourceFN (STRING) = Complete Source FileName                     
  OUT....: (STRING) = Complete Target FileName                              
  EXPLAIN: This function return a target filename.                          
           If you create an application witch works like this :             
           app source target (Example : Xcopy ...)                          
           And you have to process all the sources files, when you have     
           1 file name, this function return the target filename            
  EXAMPLE: File_TargetFileName('c:\2','d:\','c:\2\t.txt') ='d:\2\t.txt'     
           File_TargetFileName('c:\','d:\3','c:\2\t.txt') ='d:\3\2\t.txt'   
 ͼ}
Function File_TargetFileName(Source,Target,SourceFN:String):String;
Var SPath ,SMask,
    TPath ,TMask,
    FNPath,FNMask:String;
    T1,T2        :String;

 Function Test_Wildcard(S:String):Boolean;   {*Besoin d'un \ a la fin ??*}
 Begin
 Test_Wildcard:=Not ((Pos('*',S)>0) Or (Pos('?',S)>0) Or (Pos('.',S)>0)) And (S[Length(S)]<>'\');
 End;

Begin
Source:=FExpand(Source);                     {*FExpand tout*}
If Test_Wildcard(Source) Then Source:=Source+'\';
Target:=FExpand(Target);
If Test_Wildcard(Target) Then Target:=Target+'\';
SourceFN:=FExpand(SourceFN);
File_Split(Source,SPath,SMask);              {*File_Split tout*}
File_Split(Target,TPath,TMask);
File_Split(SourceFN,FNPath,FNMask);
T1:=Str_Extr(SPath,SourceFN);                {*Determine chaque blocs*}
T2:=Str_FileMask(FNMask,TMask);
File_TargetFileName:=Str_CorrectPath(TPath+'\'+T1+'\'+T2); {*resultat*}
End;

{ͻ
                            FUNCTION File_Create                            
 ͹
  IN.....: FName (STRING) = Name of the file to create                      
  OUT....: (BOOLEAN) = TRUE if the file is created, else FALSE              
  EXPLAIN: Create an empty text file.                                       
 ͼ}

Function File_Create(FName:String):Boolean;
Var F:Text;
Begin
File_Create:=FALSE;
Assign(F,FName);
{$I-}
Rewrite(F);
{$I+}
If IOResult<>0 Then Exit;
{$I-}
Close(F);
{$I+}
If IOResult<>0 Then Exit;
File_Create:=TRUE;
End;

{ͻ
                          FUNCTION File_TestExist                           
 ͹
  IN.....: FName (STRING) = Path + Name of the file                         
  OUT....: (BOOLEAN) = TRUE if the file exist, else FALSE.                  
  EXPLAIN: Test if the file exist.                                          
  NB.....: If FName='' return FALSE.                                        
  BUG....: If the file is locked by a windows program, will return FALSE.   
 ͼ}

Function File_TestExist(FName:String):Boolean;
Var Fichier:File;
Begin
File_TestExist:=False;
If FName='' Then Exit;                {*Pas de noms de Fichier*}
Assign(Fichier,FName);
Filemode:=0;
{$I-}
Reset(Fichier);
{$I+}
If IOResult<>0 Then Exit;             {*Erreur*}
{$I-}
Close(Fichier);
{$I+}
If IOResult<>0 Then Exit;             {*Erreur*}
File_TestExist:=True;                 {*Renvois Rsultat*}
End;

{ͻ
                          FUNCTION File_TestHeader                          
 ͹
  IN.....: FN (STRING) = Path + Name of the File                            
           Header (STRING) = Caracteristic string of the header             
           Offset (LONGINT) = Position in Bytes of the header in the file   
  OUT....: (BOOLEAN) = TRUE if the header is OK.                            
  EXPLAIN: This function tests if a file is typed with the specified        
           format : If the string Header is found in the header of the      
           file return true, else FALSE.                                    
  EXAMPLE: Function TEST_WAV(FN:String);                                    
           Begin                                                            
           TEST_WAV:=File_TestHeader(FN,'RIFF',0);                          
           End;                                                             
  NB.....: TEST_GIF, BMP_TestFile, TEST_WAV can be optimized with.          
           TEST_FLI perharps                                                
 ͼ}

Function File_TestHeader(FN:String;Header:String;Offset:Longint):Boolean;
Var F:File;
    str:String;
    e:integer;
Begin
File_TestHeader:=False;

If Not File_TestExist(FN) Then Exit;
Filemode:=0;
Assign(f,FN);
{$i-}
Reset(f,1);
{$i+}
If Ioresult<>0 Then Exit;
{$i-}
seek(f,Offset);
{$i+}
If Ioresult<>0 Then
  Begin

  Close(F);
  Exit;
  End;
{$i-}
Blockread(f,str[1],Length(Header),e);
{$i+}
If (ioresult<>0) or (e<>Length(Header)) then
  Begin
  Close(f);
  Exit;
  End;
SetLength(Str,Length(Header));
If UPPER(str)<>UPPER(Header) Then Exit;
File_TestHeader:=True;
Close(f);
End;

{ͻ
                           FUNCTION File_GetSize                            
 ͹
  IN.....: Name (STRING) = Name of the file.                                
  OUT....: (LONGINT) = Size of the file.                                    
  EXPLAIN: Return the size of the file if it exist.                         
 ͼ}

Function File_GetSize(Name:String):Longint;
Var DirInfo:SearchRec;               {*Struct Search Files & Dirs*}
    FName:NameStr;
    Path:DirStr;
    Ext:ExtStr;

Begin
File_GetSize:=0;
If Not(File_TestExist(Name)) Then Exit;

FSplit(Name,Path,FName,Ext);         {*Rcupre les composants du Fichier*}

FindFirst(Name,AnyFile,DirInfo);     {*Found Desired File*}
If (DosError=0) And (Upper(Path+DirInfo.Name)=Upper(Name))
   Then File_GetSize:=DirInfo.Size;
End;

{ͻ
                       FUNCTION File_GetModifiedTime                        
 ͹
  IN.....: FName (STRING) = Path and filename of the file.                  
           Format (TDateTimeFormat) = String format:                        
              DTFrench  = French format  = dd.mm.yyyy hh:mm:ss              
              DTEnglish = English format = yyyy.mm.dd hh:mm:ss              
  OUT....: (STRING) = Date en file time.                                    
  EXPLAIN: Return the file date and time when file has been modified.       
 ͼ}

Function File_GetModifiedTime(FName:String; Format:TDateTimeFormat):String;
Var F:Text;
    FTime:Longint;
    Dt:DateTime;

Begin
Assign(F,FName);
  Try
    Reset(F);
    GetFTime(F,FTime);
    UnpackTime(FTime,Dt);
    Case Format of
       DTFrench :
          Result := Str_FillZero(Dt.Day,2)+'.'+ Str_FillZero(Dt.Month,2)+'.'+Str_FillZero(Dt.Year,4)+' '+
                    Str_FillZero(Dt.Hour,2)+':'+Str_FillZero(Dt.Min,2)+':'+  Str_FillZero(Dt.Sec,2);
       DTEnglish:
          Result := Str_FillZero(Dt.Year,4)+'.'+ Str_FillZero(Dt.Month,2)+'.'+Str_FillZero(Dt.Day,2)+' '+
                    Str_FillZero(Dt.Hour,2)+':'+Str_FillZero(Dt.Min,2)+':'+  Str_FillZero(Dt.Sec,2);
       End;
    Close(F);
  Except
    Result := '?';                       {*Error ?*}
    raise;
  End;
End;

{ͻ
                            FUNCTION File_Erase                             
 ͹
  IN.....: Fn (STRING) = Path + Name of a file to delete                    
  OUT....: (BOOLEAN) = TRUE if no I/O error, else FALSE                     
  EXPLAIN: Erase, Delete a file.                                            
  EXAMPLE: File_Erase('Temp.dat');                                          
  NB.....: If the file doesn't exit return FALSE                            
 ͼ}
Function File_Erase(Fn:String):Boolean;
Var F:File;
Begin
File_Erase:=False;
If Not File_TestExist(Fn) Then Exit;{*Le Fichier n'existe Pas...*}
Assign(F,Fn);                       {*Dtruit Fichier Temporaire...*}
SetfAttr(F,0);
If IoResult<>0 Then Exit;
{$i-}
Erase(F);
{$i+}
File_Erase:=Ioresult=0;
End;

{ͻ
                            FUNCTION File_Rename                            
 ͹
  IN.....: FN1 (STRING) = Path + FileName of the file to rename.            
           FN2 (STRING) = New Path and fileName of the file.                
  OUT....: (BOOLEAN) = TRUE if operation completed, else FALSE              
  EXPLAIN: Rename a file.                                                   
  EXAMPLE: File_Rename('toto.pas',toto.bak');                               
 ͼ}

Function File_Rename(FN1,FN2:String):Boolean;
Var F:File;
Begin
Result := FALSE;
If (FN1='') Or (FN2='') Then Exit;
FN1:=FExpand(FN1);
FN2:=FExpand(FN2);
{gotoxy(1,22); Writeln(FN1);
gotoxy(1,23); Writeln(FN2);}

If (FN1[1] = FN2[1]) Then
  Begin
  Assign(F,FN1);
  {$I-}
  Rename(F,FN2);
  {$I+}
  File_Rename := IOResult = 0;
  End
Else
  Begin
  If File_Copy(FN1,FN2) > 1 Then Exit;
  If Not File_Erase(FN1)    Then Exit;
  Result := TRUE;
  End;
End;

{ͻ
                           FUNCTION File_Replace                            
 ͹
  IN.....: FN1 (STRING) = Path and FileName of the file to replace.         
           FN2 (STRING) = FileName of the file that have to replace FN1     
  OUT....: (BOOLEAN) = TRUE if operation completed, else FALSE              
  EXPLAIN: Replace a file by an other. (FN1 by FN2)                         
  EXAMPLE: File_Replace('toto.pas','toto.tmp');                             
  NB.....: Be careful : (FN1 will be replaced by FN2)                       
 ͼ}

Function File_Replace(FN1,FN2:String):Boolean;
Var D: DirStr;
    N: NameStr;
    E: ExtStr;
    R: Byte;
Begin
File_Replace:=False;
FN1:=FExpand(FN1);
FN2:=FExpand(FN2);
If Not File_TestExist(FN1) Then Exit;
If Not File_TestExist(FN2) Then Exit;

Fsplit(FN1,D,N,E);
R:=File_Copy(FN1,D+'TEMPSYB.$$$');
If R>1 Then  Exit;


If Not File_Erase(FN1) Then Exit;
If Not File_Rename(FN2,FN1) Then Exit;
If Not File_Erase(D+'TEMPSYB.$$$') Then Exit;
File_Replace:=True;
End;

{ͻ
                             FUNCTION File_Copy                             
 ͹
  IN.....: SourceFile (STRING) = Path + Name of the source file.            
           TargetFile (STRING) = Path + Name of the target file.            
  OUT....: (BYTE) = Return codes :                                          
             0 successful                                                   
             1 source and target are the same                               
             2 cannot open source                                           
             3 unable to create target                                      
             4 error during copy                                            
  EXPLAIN: Copy a file.                                                     
  EXAMPLE: File_Copy('c:\Command.com','d:\toto.com');                       
 ͼ}

Function File_Copy(SourceFile,TargetFile:String):Byte;
Var Source,Target  : File;
    BRead,BWrite   : Word;
    FileBuf        : Array[1..BufferSize] of Char;
    Attr           : Word;
    Time           : Longint;
begin
If SourceFile = TargetFile then
  begin
  File_Copy:=1;Exit;
  end;

Assign(Source,SourceFile);
FileMode:=0;
{$I-}
Reset(Source,1);
{$I+}

If IOResult <> 0 then
  begin
  File_Copy:=2;Exit;
  end;

Assign(Target,TargetFile);
{$I-}
ReWrite(Target,1);
{$I+}

If IoResult<>0 Then
  begin
  Close(Source);
  File_Copy:=3;Exit;
  end;

  Repeat
  BlockRead(Source,FileBuf,SizeOf(FileBuf),BRead);
  BlockWrite(Target,FileBuf,Bread,BWrite);
  Until (Bread = 0) or (Bread <> BWrite);

Close(Source);
Close(Target);

GetFTime(Source,Time);
SetFTime(Target,Time);

GetFAttr(Source,Attr);
SetFAttr(Target,Attr);

If Bread <> BWrite then File_Copy := 4 else File_Copy := 0;
end;

{ͻ
                        FUNCTION File_BuildNextName                         
 ͹
  IN.....: FName (STRING) = Input File Name                                 
           Format (TFileExpandFormat) = Format for modified filename.       
  OUT....: (STRING)   = OutPut File Name                                    
  EXPLAIN: We put in S a generic file name, and we get a file name witch    
           don't exist.                                                     
           Complete path name must be in S !!                               
  EXAMPLE: If we have this files on the HD :                                
           Image0.bmp, Image1.bmp                                           
           And we use File_BuildNextName('Image.bmp');                      
           The result will be Image2.bmp                                    
  CF.....: Screen Snapshot & Disk Swapping.                                 
  BUGS...: If the Name of the file have 8 letters...                        
 ͼ}

Function File_BuildNextName(FName:String; Format:TFileExpandFormat):String;
Var TempFile         :String;
    Counter          :Integer;
    D                :String;
    N                :String;
    E                :String;

Begin
Counter := 0;
D := File_StrSplit(FName,$0003);
N := File_StrSplit(FName,$0004);
E := File_StrSplit(FName,$0008);

Repeat
   Case Format of
      FEValue : TempFile := D+N + ' ' + Str_FillZero(Counter,3) + '.' + E;
      FELetter: TempFile := D+N + ' ' + Char(Counter+65) + '.' + E;
      End;
   Inc(Counter);
Until Not File_TestExist2(TempFile);
Result := TempFile;
End;

{ͻ
                            PROCEDURE File_Split                            
 ͹
  IN.....: S : (STRING) = Name (& Path) of the file to split or a mask file 
  OUT....: Path : (STRING) = Real path of the file                          
           Mask : (STRING) = Mask obtained                                  
  EXPLAIN: Splits a file name into its 2 components.                        
           File_Split is more powerful than FSplit look examples :          
  CF.....: FSplit from Dos Tp7 unit.                                        
  EXAMPLE: File_Split('',r1,r2)             = r1=Default Path & r2='*.*'    
           File_Split('t.pas',r1,r2)        = r1=Default Path & r2='t.pas'  
           File_Split('c:\',r1,r2)          = r1='C:\'        & r2='*.*'    
           File_Split('c:\dos',r1,r2)       = r1='C:\DOS\'    & r2='*.*'    
           File_Split('c:\dos\*.pas',r1,r2) = r1='C:\DOS\'    & r2='*.pas'  
 ͼ}

Procedure File_Split(S:String;Var Path,Mask:String);
Var i     : Integer;
    BMask : Boolean;
    SPath : DirStr;              {*Path*}
    SName : NameStr;             {*Name*}
    SExtF : ExtStr;              {*Extension*}

Begin
S:=Dsk_FExpand(S);

BMask:=False;
If (Pos('*',S)>0) Or (Pos('?',S)>0) Then BMask:=True;

i:=Str_LastPos('\',S);
If BMask Then
  Begin
  Mask:=Copy(S,i+1,Length(S)-i);
  Delete(S,i+1,length(S)-i);
  End;

FSplit(S,SPath,SName,SExtF);
{Writeln(SPath);
Writeln(SName);
Writeln(SExtF);}

Path:=SPath;
If Not BMask Then Mask:=SName+SExtF;
If Mask='' Then Mask:='*.*';
End;

{ͻ
                        PROCEDURE File_GetDirectory                         
 ͹
  IN.....: Source (String) = Path+Mask for file list.                       
           Target (String) = Filename used to save the list.                
  OUT....: /                                                                
  EXPLAIN: Read directory from a path, build list and save the list.        
 ͼ}

Procedure File_GetDirectory(Source,Target:String);
Var DI            :SearchRec;

Begin
FindFirst(Source, AnyFile, DI);         {*Parcours le Rpertoire*}
While DosError=0 do
   Begin
   File_AppendString(Target,Di.Name);
   FindNext(DI);
   End;
End;

{ͻ
                           FUNCTION File_CheckSum                           
 ͹
  IN.....: FN (STRING) = FileName (+ Path)                                  
  OUT....: (LONGINT) = CheckSum of the File                                 
                       0 if a problem reading file occurs                   
  EXPLAIN: Calculate a checksum of a file. For example if you want to know  
           if a file will be modified, calculate the checksum and if this   
           checksum changes, then you can tell that the file is changed.    
  EXAMPLE: If File_CheckSum('c:\command.com')<>$12345 Then                  
             Writeln('File infected by a virus');                           
  NB.....: This CheckSum calculated is different of the true CRC calculation
  CF.....: Mem_CheckSum                                                     
 ͼ}
Function File_CheckSum(FN:String):Longint;
Var Buffer : Pointer;             {*Memory buffer*}
    FSize  : Longint;             {*File Size*}
    F      : File;                {*File*}
    Idiv,Imod,i,e : Word;         {*i:loop, e:error I/O*}
    Res    : Longint;             {*Result*}

Const BufferSize=32000;
Begin
Res:=0;                           {*Result*}
File_CheckSum:=0;
FSize:=File_GetSize(FN);          {*Size of the file*}
Assign(F,FN);
{$i-}
Reset(F,1);
{$i+}
If Ioresult<>0 Then Exit;

GetMem(Buffer,BufferSize);        {*Memory Allocation*}

Idiv:=FSize div BufferSize;       {*Qtt loop*}
Imod:=FSize mod BufferSize;

For i:=1 to Idiv do               {*Loop to read file*}
  Begin
  BlockRead(F,Buffer^,BufferSize,e);
  If (e<>BufferSize) Then Exit;   {*Error reading*}
  Res:=Res Xor Mem_CheckSum(Buffer^,BufferSize);
  End;

If (Imod<>0) Then                 {*Last bytes of the file*}
  Begin
  BlockRead(F,Buffer^,Imod,e);
  If (e<>Imod) Then Exit;         {*Error reading*}
  Res:=Res Xor Mem_CheckSum(Buffer^,Imod);
  End;

FreeMem(Buffer,BufferSize);       {*UnAllocate Memory*}
Close(F);
If Res=0 Then Res:=1;
File_CheckSum:=Res;
End;

{ͻ
                             FUNCTION File_Comp                             
 ͹
  IN.....: FN1 (STRING) = FileName (+ Path) of the first file to compare    
           FN2 (STRING) = FileName (+ Path) of the second file to compare   
  OUT....: (BYTE) = 0 : The files are the sames                             
                    1 : The files are different                             
                    2 : I/O Error.                                          
  EXPLAIN: Test if 2 files are identicals.                                  
  EXAMPLE: Writeln(File_Comp('c:\autoexec.bat','c:\config.sys'))   = 1      
           Writeln(File_Comp('c:\autoexec.bat','c:\autoexec.bat')) = 0      
 ͼ}

Function File_Comp(FN1,FN2:String):Byte;
Var Source,Target  : File;
    BRead1,BRead2  : Word;


    FileBuf1       : Array[1..BufferSize] of Char;
    FileBuf2       : Array[1..BufferSize] of Char;
    FSize1,FSize2  : Longint;             {*File Size*}

Begin
If FExpand(FN1)=FExpand(FN2) Then
  Begin
  File_Comp:=0;Exit;
  End;

FSize1:=File_GetSize(FN1);
FSize2:=File_GetSize(FN2);        {*Size of the files*}
If FSize1<>FSize2 Then Begin File_Comp:=0;Exit; End;

File_Comp:=2;
Assign(Source,FN1);
Assign(Target,FN2);
{$I-}
Reset(Source,1);
{$I+}
If IOResult <> 0 Then Exit;

{$I-}
Reset(Target,1);
{$I+}
If IOResult <> 0 Then
  Begin
  File_Comp:=2;
  Close(Source);Exit;
  End;

Repeat
BlockRead(Source,FileBuf1,SizeOf(FileBuf1),BRead1);
BlockRead(Target,FileBuf2,SizeOf(FileBuf2),BRead2);
If Not Mem_CompBlock(FileBuf1,FileBuf2,BRead1) And (Bread1<>0) Then
  Begin
  File_Comp:=1;
  Close(Source);
  Close(Target);Exit;
  End;
Until (Bread1 = 0) Or (Bread1 <> BRead2);
Close(Source);
Close(Target);
If Bread1 <> BRead2 Then File_Comp:=1 Else File_Comp:= 0;
End;

{ͻ
                            FUNCTION Get_AppName                            
 ͹
  IN.....: /                                                                
  OUT....: (STRING) = Application name.                                     
  EXPLAIN: Return the file name + extension of the application.             
  EXAMPLE: Get_AppName = 'DID.EXE';                                         
 ͼ}

Function Get_AppName:String;
Var St:String;
Begin
St:=ParamStr(0);
Get_AppName:=File_StrSplit(St,12);
End;

{ͻ
                            FUNCTION Get_AppPath                            
 ͹
  IN.....: /                                                                
  OUT....: (STRING) = Application Path                                      
  EXPLAIN: Return the Path of the application.                              
  EXAMPLE: Get_AppPath = 'D:\MOS\';                                         
 ͼ}

Function Get_AppPath:String;
Var St:String;
Begin
St:=ParamStr(0);
Get_AppPath:=File_StrSplit(St,3);
End;

Function Get_AppIniName:String;
Begin
   Result := File_StrSplit(FExpand(ParamStr(0)),$0007) + '.INI';
End;

{-------------------------------- To be deleted -----------------------------}

{ͻ
                          PROCEDURE File_FindBreak                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Break and stop the File_Find procedure when running.             
  SEEALSO: File_Find                                                        
 ͼ}
//Var  FindFileBo:Boolean;

procedure File_FindBreak;
begin
//FindFileBo:=True;
end;

{ͻ
                            PROCEDURE File_Find                             
 ͹
  IN.....: Source (STRING) = First directory where will begin the search of 
                             the file + the mask                            
           Recurse (BOOLEAN) = Search in sub-directory also.                
           Filedo (TRecurseProc) = Every time this procedure find a file    
                                    a procedure will be called : This proc  
                                    is pass in parameter, and you have to   
                                    write it.                               
                                    The type of this proc is :              
                   Type TRecurseProc = Procedure (x:PathStr);               
            At every file found, the proc filedo will be called with        
            the name of the file for parameter.                             
  OUT....: /                                                                
  EXPLAIN: Search recursively in a directory.                               
  EXAMPLE: Procedure Show(X:PathStr);FAR;                                   
           Begin                                                            
           Writeln(X);                                                      
           End;                                                             
           File_Find('c:\*.*',True,Show);                                   
           File_Find('c:\tp7\*.pas',True,Show);                             
           File_Find('..\..\m?s*.*',False,Show);                            
 ͼ}

type  TFile_Find=class(TFileRecurse)
        Filedo_True:TRecurseProc;
        procedure OnFileFound(FN:string);override;
      end;

procedure TFile_Find.OnFileFound(FN:string);
begin
Filedo_True(FN);
end;

procedure File_Find(Source:string; Recurse:Boolean; FileDo:TRecurseProc);
var O:TFile_Find;                                {*Get files with recurse*}
begin
  O:=TFile_Find.Create;                                          {*Create instance*}
  try
    O.FileDo_True:=FileDo;                     {*Set FileDo proc*}
    O.File_Find(Source,Recurse);                     {*Launch Main proc*}
  finally
    O.Free;
  end;
end;

begin
end.
