{ͻ
                             UNIT MosFilesTree                              
 ͹
  CREATOR....: PLANAS Jean-Pierre                                           
  UPDATED BY.: PLANAS Jean-Pierre                                           
  CREATED THE: 04.01.2002                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: Files procedures & functions to recurse in sub directories.  
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 1.998 Lines and (42.976 Bytes compiled)                      
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

{$R+}
{$MODE ObjFpc}

UNIT MosFilesTree;

INTERFACE

Uses Dos,
     MosFiles;

type
      TFileRecurse=class   {*Class to find the files you want in a directory tree*}
      private
        From:string;         {*Source*}
        Recurse:Boolean;     {*Make recurse*}
        Actif:Boolean;       {*For break*}
      public
        constructor Create;  {*Create the object*}
        procedure OnFileFound(FN:String);Virtual;Abstract;  {*Called for each files found*}
        procedure File_Find(Get_Source:String;Get_Recurse:Boolean); {*Begin search*}
        procedure Stop;      {*Stop search*}
      end;

      TDeltree=class(TFileRecurse)
        procedure OnFileFound(FN:string);override;
      end;

      TCount=class(TFileRecurse)
      private
        fFilesCount    :Longint;          // Count processed files
      public
        constructor create;
        procedure OnFileFound(FN:string);override;
        Property  FilesCount:Longint Read fFilesCount;
      end;

      TXAttrib=class(TFileRecurse)
        Attr : Word;
        constructor create;
        procedure OnFileFound(FN:string);override;
      end;

      TXRename=class(TFileRecurse)
        DestMask:String;
        constructor create;
        procedure OnFileFound(FN:string);override;
      end;

      TXcopy=class(TFileRecurse)
      private
        SPath,
        SMask,
        TPath,
        TMask:String;
        R: Byte;
      public
        procedure OnFileFound(FN:String);override;
        procedure File_Xcopy(Source,Target:String;Get_Recurse:Boolean);
      end;

Procedure File_Deltree(Source:string;Recurse:Boolean);             {*Make a Deltree*}
Function  File_Count  (Source:string;Recurse:Boolean):Longint;     {*How many files ??*}
Procedure File_XAttrib(Source:string;Attr:Word;Recurse:Boolean);   {*Change the attributes of the files*}
Procedure File_XRename(Src,DestMask:string; Recurse:Boolean);       {*Rename files*}
Function  File_Xcopy  (Source,Target:string;Recurse:Boolean):Byte; {*Make an xcopy*}

IMPLEMENTATION

Uses MosDisks,
     MosStrings;

{ͻ
                           CLASS  TFILERECURSE                              
 ͼ}

{ͻ
                       CONSTRUCTOR TFileRecurse.Create                      
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Must be called to initialize object.                             
  SEEALSO: File_Find                                                        
 ͼ}
constructor TFileRecurse.Create;
begin
inherited;
From   :='';
Recurse:=false;
Actif  :=true ;
end;

{ͻ
                      PROCEDURE TFileRecurse.File_Find                      
 ͹
  IN.....: Source (STRING) = Path + file mask of the file to serach         
           Recurse (BOOLEAN) = Make a recurse serach or not                 
  OUT....: /                                                                
  EXPLAIN: This mthod begin the search of the files.                       
  SEEALSO: File_Find                                                        
 ͼ}
Procedure TFileRecurse.File_Find(Get_Source:String;Get_Recurse:Boolean);
VAR FD       : DirStr;    {*FSplit...*}
    FN       : NameStr;   {*FSplit...*}
    FE       : ExtStr;    {*FSplit...*}
    Mask     : String;
    Alias    : Boolean;

 Procedure SubVisit(DirPath:PathStr);
 Var Looking4 : SearchRec;
 Begin
 If Not Actif Then Exit;
 FindFirst (Concat(DirPath,Mask),AnyFile,looking4);
 While (DosError=0) Do
   Begin
   if (looking4.attr and (VolumeID+Directory))=0 Then
     Begin
     If Not Actif Then Exit;
     OnFileFound (Concat(DirPath,looking4.name));
     End;
   FindNext ( Looking4 );
   End;                                    {* While *}
 If Recurse then                           {* Si il y a rcursion *}
   Begin
   FindFirst (Concat(DirPath,'*.*'),AnyFile,looking4);
   While (DosError=0) and (looking4.name[1]='.') Do
     FindNext (looking4);                 {* skip . and .. directories *}
   While (DosError=0) Do
     Begin
     if ((looking4.attr and Directory)=Directory)
      then SubVisit(Concat(DirPath,looking4.name,'\'));

     FindNext(Looking4);
     End;    {* While        *}
   End;      {* if recursing *}
 End;        {* SubVisit     *}


Begin
Actif:=True;
From:=Get_Source;
Recurse:=Get_Recurse;
Alias:=True;
From:=FExpand(From);
FSplit(From,FD,FN,FE);                {*Construit All*}
If (Pos('*',From)>0) Or (Pos('?',From)>0) Then Alias:=True;  {*Il y a des jokers dans le Nom*}
If (FE='') and Not Alias And (Fn<>'') Then Begin FD:=FD+FN+'\'; FN:=''; End;

Mask:=FN+FE;
If (Mask='') Or (Mask='.') Then Mask:='*.*';
If File_TestExist(From) Then
  Begin
  If Not Actif Then Exit;
  OnFileFound(From)
  End
Else SubVisit(FD);

Actif:=False;
End;

Procedure TFileRecurse.Stop;
Begin
Actif:=False;
End;

{ͻ
                        END OF CLASS  TFILERECURSE                          
 ͼ}

{ͻ
                        BEGIN OF CLASS TDELTREE                             
 ͼ}

procedure TDeltree.OnFileFound(FN:String);
begin
File_Erase(FN);
end;

{ͻ
                        END OF CLASS TDELTREE                               
 ͼ}

{ͻ
                        BEGIN OF CLASS TCOUNT                               
 ͼ}

constructor TCount.Create;
begin
inherited;
   fFilesCount := 0;
end;

procedure TCount.OnFileFound(FN:String);
begin
   Inc(fFilesCount);                // Count processed files
   Fn := Fn;                        // To avoid warnings !
end;

{ͻ
                        END OF CLASS TCOUNT                                 
 ͼ}

{ͻ
                        BEGIN OF CLASS TXATTRIB                             
 ͼ}

constructor TXAttrib.Create;
begin
inherited;
Attr:=0;
end;

procedure TXAttrib.OnFileFound(FN:String);
var F:File;
begin
Assign(F,FN);
SetFAttr(F,Attr);
end;

{ͻ
                        END OF CLASS TXATTRIB                               
 ͼ}

{ͻ
                        BEGIN OF CLASS TXRENAME                             
 ͼ}

constructor TXRename.Create;
begin
inherited;
DestMask:='*.*';
end;

procedure TXRename.OnFileFound(FN:String);
var P,N,E:String;
begin
FSplit(FN,P,N,E);
File_Rename(FN,P+Str_FileMask(N+E,DestMask));
end;

{ͻ
                        END OF CLASS TXRENAME                               
 ͼ}

{ͻ
                        BEGIN OF CLASS TXCOPY                               
 ͼ}

Procedure TXcopy.OnFileFound(FN:String);
Var T:String;
    T2,T3:String;
    D: DirStr;
    N: NameStr;
    E: ExtStr;
Begin
If R<>0 Then Exit;
Fsplit(FN,d,n,e);

T2:=Str_Extr(SPath,FN);
T3:=Str_FileMask(n+e,TMask);

T:=Tpath+T2+T3;
Dsk_Mkdir(Tpath+T2);
R:=File_Copy(FN,T);
End;

Procedure TXCopy.File_Xcopy(Source,Target:String;Get_Recurse:Boolean);
Begin
R:=0;
If Source='' Then Source:='*.*';
If Target='' Then Target:='*.*';
Source:=Dsk_FExpand(Source);
Target:=Dsk_FExpand(Target);

File_Split(Source,SPath,SMask);
File_Split(Target,TPath,TMask);

File_Find(SPath+SMask,Get_Recurse);
End;


{ͻ
                        END OF CLASS TXCOPY                                 
 ͼ}

{ͻ
                           PROCEDURE File_Deltree                           
 ͹
  IN.....: Source (STRING) = Directory to delete.                           
           Recurse (BOOLEAN) = Search in sub-directory also.                
  OUT....: /                                                                
  EXPLAIN: Delete all the files and directory of the specified path.        
 ͼ}
Procedure File_Deltree(Source:String;Recurse:Boolean);
Var O:TDeltree;
    S1,S2:String;
Begin
  O:=TDeltree.Create;
  try
    O.File_Find(Source,Recurse);
    File_Split(Source,S1,S2);
    Dsk_Rmdir(S1);
  finally
    O.free;
  end;
End;


{ͻ
                            FUNCTION File_Count                             
 ͹
  IN.....: Source (STRING) = First directory where will begin the count     
                             + Mask of the searched files.                  
           Recurse (BOOLEAN) = Search in sub-directory also.                
  OUT....: (LONGINT) = Number of files founded.                             
  EXPLAIN: Search recursively in a directory.                               
 ͼ}

function File_Count(Source:String;Recurse:Boolean):Longint;
var O:TCount;
begin
  Result:=0;
  O:=TCount.Create;
  try
    O.File_Find(Source,Recurse);
    Result:=O.FilesCount;
  finally
    O.Free;
  end;
end;

{ͻ
                           PROCEDURE File_XAttrib                           
 ͹
  IN.....: Source (STRING) = Directory where to begin the attrib            
           Attr (WORD) = File Attributes                                    
  OUT....: /                                                                
  EXPLAIN: Set to all files in the source directory the attributes.         
 ͼ}

procedure File_XAttrib(Source:String;Attr:Word;Recurse:Boolean);
var O:TXAttrib;
begin
  O:=TXAttrib.Create;
  try
    O.Attr:=Attr;
    O.File_Find(Source,Recurse);
  finally
    O.free;
  end;
end;

{ͻ
                           PROCEDURE File_XRename                           
 ͹
  IN.....: Src (STRING) = Directory where to begin the renaming             
           DestMask (STRING) = Mask of the new filename                     
  OUT....: /                                                                
  EXPLAIN: Set to all files in the source directory a new filename.         
 ͼ}

procedure File_XRename(Src,DestMask:string;Recurse:Boolean);
var O:TXRename;
begin
  O:=TXRename.Create;
  try
    O.DestMask:=DestMask;
    O.File_Find(Src,Recurse);
  finally
    O.free;
  end;
end;

{ͻ
                            FUNCTION File_Xcopy                             
 ͹
  IN.....: Source (STRING) = Source path or Source file(s)                  
           Target (STRING) = Target path or Target file(s)                  
           Recurse (BOOLEAN) = TRUE : Include directories                   
  OUT....: (BYTE) = 0 if no error, else 1.                                  
  EXPLAIN: Make a xcopy of files...                                         
  EXAMPLE: File_Xcopy('c:\','d:\',True);                                    
 ͼ}
function File_Xcopy(Source,Target:String;Recurse:Boolean):Byte;
var O:TXcopy;
begin
  O:=TXcopy.Create;
  try
    O.File_XCopy(Source,Target,Recurse);
    File_Xcopy:=O.R;
  finally
    O.free;
  end;
end;

begin
end.
