{ͻ
                               UNIT MosForms                                
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 08.05.2000                                                   
  COUNTRY....: Montpellier - Timeless (FRANCE)                              
  DESCRIPTION: Visual components "Window".                                  
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 3.718 Lines and (93.136 Bytes compiled)                      
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosForms;

{$Mode Objfpc}

INTERFACE

Uses
     Classes,
     MosBevels,
     MosButtons,
     MosConfig,
     MosControls,
     MosGadgets,
     MosImages,
     MosWindows;

Type

{****************************************************************************}

TFormPosition = (                       // Window position
   WPDesigned,
   WPDefault,
   WPScreenCenter
   );

TFormStyle = (                          // Window style
   FSNormal,
   FSStayOnTop
   );

TWindowState = (                        // Window state
   WSMinimized,
   WSMaximized,
   WSNormal
   );

TCloseAction = (                        // Window close action
   CANone,
   CAHide,
   CAFree,
   CAMinimize
   );

{****************************************************************************}
{*** TCustomForm Class                                                    ***}
{****************************************************************************}

TTrueColor = Longint;

// EVENTS

TPositionEvent   = Procedure(Sender:TObject; Var aLeft,aTop:Integer) of Object;
TSizeEvent       = Procedure(Sender:TObject; Var aWidth,aHeight:Integer) of Object;
TCloseEvent      = Procedure(Sender:TObject; Var Action:TCloseAction) of Object;
TCloseQueryEvent = Procedure(Sender:TObject; Var CanClose:Boolean) of Object;
TMouseOverEvent  = Procedure(Sender:TObject; Over:Boolean) of Object;

// CLASS DEFINITION

TCustomForm = Class(TVisual)            // TCustomForm class definition
   Private
{Ok }      fWindow           :TWindow;
{Ok }      fCaption          :String;        // Window title
{Ok }      fColor            :TTrueColor;
      fCursor           :String;        // Mouse pointer definition
//     fEnabled          :Boolean;       // Enable or disable component
{Ok }      fWinVisible       :Boolean;       // Window is visible or no
      fFormStyle        :TFormStyle;
      fPosition         :TFormPosition; // Define window position
      fWindowState      :TWindowState;  // Window state
{Bug}      fLocked           :Boolean;       // Window status locked or no
{Ok }      fModal            :Boolean;       // Window is modal of no

      fOnActivate       :TNotifyEvent;  // Delphi classic events
      fOnClose          :TCloseEvent;
      fOnCloseQuery     :TCloseQueryEvent;
      fOnCreate         :TNotifyEvent;
      fOnDeactivate     :TNotifyEvent;
      fOnDestroy        :TNotifyEvent;
      fOnHide           :TNotifyEvent;
      fOnMouseMove      :TMouseMoveEvent;
      fOnPaint          :TNotifyEvent;
      fOnShow           :TNotifyEvent;

      fOnExtended       :TNotifyEvent;  // MOS special events
      fOnMouseOver      :TMouseOverEvent;
      fOnMoved          :TNotifyEvent;
      fOnMoving         :TPositionEvent;
      fOnSized          :TNotifyEvent;
      fOnSizing         :TSizeEvent;
      fOnSwapped        :TNotifyEvent;
      fOnTest           :TNotifyEvent;

   Private
      fClient           :TBevelBox;     // Defined client zone
{Ok }      fLimitToScreen    :Boolean;       // Window is limited to screen
{Ok }      fTransparent      :Boolean;       // Transparent window background
{Ok }      fCanMove          :Boolean;       // Window can move or no
{Ok }      fFullHandle       :Boolean;       // Move window by clicking on it
{Ok }      fActivated        :Boolean;       // Window is activated or no
      fExtendedCoord    :TCoordinates;  // Extended coordinates
      fIcon             :AImage;        // Icon image to display
{Ok }      fShowTitle        :Boolean;       // Display window title
{Ok }      fShowBorders      :Boolean;       // Display window borders
{Ok }      fCloseButton      :Boolean;       // Display the close button
{Ok }      fSwapButton       :Boolean;       // Display the swap button
{Ok }      fSizeButton       :Boolean;       // Display the size button
{Ok }      fExtendedButton   :Boolean;       // Display the extended button
{Ok }      fForceClose       :Boolean;       // Message to force the window to close
{Ok }      fMouseOver        :Boolean;       // If mouse is over the window
{Ok }      fZoom             :Boolean;       // Zoom when window is opened or closed

   Protected
{Ok }      Procedure SetCaption(aCaption:String); Virtual;
{Ok }      Procedure SetColor(aColor:TTrueColor);
      Procedure SetCursor(aCursor:String);
      Procedure SetEnabled(aEnabled:Boolean); Override;
      Procedure SetFormStyle(aFormStyle:TFormStyle);
      Procedure SetPosition(aPosition:TFormPosition);
      Procedure SetWindowState(aWindowState:TWindowState);

   Protected
{Ok }      Procedure SetShowTitle(aState:Boolean);
{Ok }      Procedure SetShowBorders(aState:Boolean);
{Ok }      Procedure SetCloseButton(aState:Boolean);
{Ok }      Procedure SetSwapButton(aState:Boolean);
{Ok }      Procedure SetSizeButton(aState:Boolean);
{Ok }      Procedure SetExtendedButton(aState:Boolean);
{Ok }      Procedure SetLimitToScreen(aLimitToScreen:Boolean); Virtual;
{Ok }      Procedure SetTransparent(aTransparent:Boolean); Virtual;
{Bug}      Procedure SetLocked(aLocked:Boolean); Virtual;
{Ok }      Procedure SetCanMove(aCanMove:Boolean); Virtual;
{Ok }      Procedure SetActivated(aActivated:Boolean); Virtual;
{Ok }      Procedure SetZoom(aZoom:Boolean); Virtual;
{Ok }      Procedure SetFullHandle(aFullHandle:Boolean); Virtual;
{Ok }      Function  IsReady:Boolean;        // Check if window is ready
{Ok }      Function  CheckIsMoved:Boolean;
{Ok }      Function  CheckIsSized:Boolean;
{Ok }      Procedure FormManageEvents; Virtual; // To be overriten for new events management

      Function  CheckAndManage:Integer; Virtual;
      Procedure Paint; Virtual;
      Procedure AfterCreate; Virtual;

   Public
{Ok }      Property Activated     :Boolean        Read fActivated      Write SetActivated;
      Property Client        :TBevelBox      Read fClient;
{Ok }      Property LimitToScreen :Boolean        Read fLimitToScreen  Write SetLimitToScreen;
{Ok }      Property Transparent   :Boolean        Read fTransparent    Write SetTransparent;
{Ok }      Property CanMove       :Boolean        Read fCanMove        Write SetCanMove;
{Ok }      Property FullHandle    :Boolean        Read fFullHandle     Write SetFullHandle;
{Bug}      Property Locked        :Boolean        Read fLocked         Write fLocked;
      Property ExtendedCoord :TCoordinates   Read fExtendedCoord;
      Property Icon          :AImage         Read fIcon;
{Ok }      Property Modal         :Boolean        Read fModal;
{Ok }      Property IsMoved       :Boolean        Read CheckIsMoved;
{Ok }      Property IsSized       :Boolean        Read CheckIsSized;
{Ok }      Property CloseButton   :Boolean        Read fCloseButton    Write SetCloseButton;
{Ok }      Property SwapButton    :Boolean        Read fSwapButton     Write SetSwapButton;
{Ok }      Property SizeButton    :Boolean        Read fSizeButton     Write SetSizeButton;
{Ok }      Property ExtendedButton:Boolean        Read fExtendedButton Write SetExtendedButton;
{Ok }      Property ShowTitle          :Boolean        Read fShowTitle      Write SetShowTitle;
{Ok }      Property ShowBorders        :Boolean        Read fShowBorders    Write SetShowBorders;
{Ok }      Property Zoom               :Boolean        Read fZoom           Write SetZoom;

      Constructor Create(AOwner:TComponent); Override;
      Destructor  Destroy; Override;

      Procedure   Close;
      Procedure   Hide; Override; // Only because inherited of TVisual that manage the hide function...
      Procedure   Show;
      Function    ShowModal:Integer; Virtual;

(*
    procedure AfterConstruction; override;
    procedure BeforeDestruction; override;
    function CloseQuery: Boolean; virtual;
    procedure DefaultHandler(var Message); override;
    procedure DefocusControl(Control: TWinControl; Removing: Boolean);
    procedure Dock(NewDockSite: TWinControl; ARect: TRect); override;
    procedure FocusControl(Control: TWinControl);
    function GetFormImage: TBitmap;
    function IsShortCut(var Message: TWMKey): Boolean; dynamic;
    procedure MouseWheelHandler(var Message: TMessage); override;
    procedure Print;
    procedure Release;
    procedure SendCancelMode(Sender: TControl);
    procedure SetFocus; override;
    function SetFocusedControl(Control: TWinControl): Boolean; virtual;
    function WantChildKey(Child: TControl; var Message: TMessage): Boolean; virtual;
*)
   Published
{Ok }      Property Caption       :String           Read fCaption        Write SetCaption;
{Ok }      Property Color         :TTrueColor       Read fColor          Write SetColor;
      Property Cursor        :String           Read fCursor         Write SetCursor;
      Property FormStyle     :TFormStyle       Read fFormStyle      Write SetFormStyle;
      Property Position      :TFormPosition    Read fPosition       Write SetPosition;
      Property WindowState   :TWindowState     Read fWindowState    Write SetWindowState;

   Published
      Property OnActivate    :TNotifyEvent     Read fOnActivate     Write fOnActivate;
      Property OnClose       :TCloseEvent      Read fOnClose        Write fOnClose;
      Property OnCloseQuery  :TCloseQueryEvent Read fOnCloseQuery   Write fOnCloseQuery;
      Property OnCreate      :TNotifyEvent     Read fOnCreate       Write fOnCreate;
      Property OnDeactivate  :TNotifyEvent     Read fOnDeactivate   Write fOnDeactivate;
      Property OnDestroy     :TNotifyEvent     Read fOnDestroy      Write fOnDestroy;
      Property OnHide        :TNotifyEvent     Read fOnHide         Write fOnHide;
      Property OnMouseMove   :TMouseMoveEvent  Read fOnMouseMove    Write fOnMouseMove;
      Property OnPaint       :TNotifyEvent     Read fOnPaint        Write fOnPaint;
      Property OnShow        :TNotifyEvent     Read fOnShow         Write fOnShow;

      Property OnExtended    :TNotifyEvent     Read fOnExtended     Write fOnExtended;
      Property OnMoved       :TNotifyEvent     Read fOnMoved        Write fOnMoved;
      Property OnMouseOver   :TMouseOverEvent  Read fOnMouseOver    Write fOnMouseOver;
      Property OnMoving      :TPositionEvent   Read fOnMoving       Write fOnMoving;
      Property OnSized       :TNotifyEvent     Read fOnSized        Write fOnSized;
      Property OnSizing      :TSizeEvent       Read fOnSizing       Write fOnSizing;
      Property OnSwapped     :TNotifyEvent     Read fOnSwapped      Write fOnSwapped;
      Property OnTest        :TNotifyEvent     Read fOnTest         Write fOnTest;
   End;

{****************************************************************************}
{*** TForm Class                                                          ***}
{****************************************************************************}

TForm = Class(TCustomForm)              // TForm class definition
   Private
      fAutoActivate     :Boolean;       // Auto activate window when mouse is over
      fOldMouseState    :Integer;       // If the window state has been modified

   Protected
      Procedure FormManageEvents; Override;

   Public
      Property AutoActivate  :Boolean          Read fAutoActivate   Write fAutoActivate;

      Constructor Create(AOwner:TComponent); Override;
   End;

{}
{}
{}

IMPLEMENTATION

Uses
     MosBase,
     MosColors,
     MosCpuInstructions,
MosDialogs,
MosStrings,
     MosKeyboard,
     MosGraph,
     MosMouse;

{****************************************************************************}
{*** TCustomForm Class                                                    ***}
{****************************************************************************}

Constructor TCustomForm.Create(AOwner:TComponent);
Var NewIdCmp :Word;

Begin
   Inherited Create(AOwner);

// Events

   fOnActivate       := NIL;
   fOnClose          := NIL;
   fOnCloseQuery     := NIL;
   fOnCreate         := NIL;
   fOnDeactivate     := NIL;
   fOnDestroy        := NIL;
   fOnHide           := NIL;
   fOnPaint          := NIL;
   fOnShow           := NIL;

   fOnMoved          := NIL;
   fOnMoving         := NIL;
   fOnSized          := NIL;
   fOnSizing         := NIL;
   fOnExtended       := NIL;
   fOnSwapped        := NIL;

   fCaption          := '';
   fColor            := CLWinBg;
   fCursor           := MPArrow;
   fFormStyle        := FSNormal;
   fPosition         := WPDesigned;
   fWindowState      := WSNormal;
   fLocked           := FALSE;
   fModal            := TRUE;
   fWinVisible       := FALSE;
   fMouseOver        := FALSE;
   fForceClose       := FALSE;
   fZoom             := FALSE;

   fLimitToScreen    := TRUE;
   fTransparent      := FALSE;
   fCanMove          := TRUE;
   fActivated        := TRUE;

   fShowTitle        := TRUE;
   fShowBorders      := TRUE;

   fCloseButton      := TRUE;
   fSwapButton       := TRUE;
   fSizeButton       := TRUE;
   fExtendedButton   := TRUE;

// Warning ! This following value is the result of the bits combination
// between the previous defined booleans.
// If you change the booleans definition you must adjust the IdCmp value.

   NewIdCmp := $51DF;

   Win_Init(0,0,200,200,NewIdCmp,fCaption,fWindow);
   Win_Sup(100,50,250,200,79,60,639,479,0,fColor,$0A50,fWindow);

{
   fClient           :
   fExtendedCoord    :
   fIcon             :}
End;

Procedure TCustomForm.AfterCreate;
Begin
   If Assigned(fOnCreate) Then fOnCreate(Self); // Event
End;

Destructor TCustomForm.Destroy;
Begin
   Win_Done(fWindow);
   Inherited;
End;

Procedure TCustomForm.Paint;
Begin
   If Not fWinVisible Then Exit; // Display only if window is visible

   Win_Draw(fWindow);

   Win_Clip(TRUE,fWindow);
   If Assigned(fOnPaint) Then fOnPaint(Self); // Event
   Win_Clip(FALSE,fWindow);
End;

Procedure TCustomForm.Hide;
Begin
   If Not fWinVisible Then Exit;

   If Assigned(fOnHide) Then fOnHide(Self); // Event

   Win_Hide(fWindow);
   fWinVisible := FALSE;
End;

Function TCustomForm.ShowModal:Integer;
Begin
   Result := 0;
   Try
      fModal := TRUE;

      Win_Draw(fWindow);
      fWinVisible := TRUE;
      If Assigned(fOnShow) Then fOnShow(Self); // Event

      If Assigned(fOnActivate) Then fOnActivate(Self); // Event

      Win_Clip(TRUE,fWindow);
      If Assigned(fOnPaint) Then fOnPaint(Self); // Event
      Win_Clip(FALSE,fWindow);

      Result := CheckAndManage; // Manage the MOS Form

   Finally
      fWinVisible := FALSE;
      Win_Hide(fWindow);        // Hide the windows now...
   End;
End;

Procedure TCustomForm.Show;
Begin
// Redirected temporarily to ShowModal to manage all kind of windows...

   ShowModal;
End;

Procedure TCustomForm.Close;
Var CanClose   :Boolean;
Begin
   If Assigned(fOnCloseQuery) Then  // Event
   Begin
      CanClose := TRUE;
      fOnCloseQuery(Self,CanClose);
      If Not CanClose Then Exit;    // Closing has been canceled !
   End;

   fForceClose := TRUE;             // Force the window to close...
End;

Function TCustomForm.CheckAndManage:Integer;
Var XOk            :Boolean;
    XCancel        :Boolean;
    Even           :Byte;
    Action         :TCloseAction;
    PaintWinContent:Boolean;
    aLeft          :Integer;
    aTop           :Integer;
    aWidth         :Integer;
    aHeight        :Integer;
    Shift          :TShiftState;
    X,Y            :Word;
    OldX,OldY      :Word;

Begin
   Try
      fForceClose := FALSE;
      X := 0; Y := 0;
      OldX := 0; OldY := 0;

      Repeat
         XOk := FALSE;                 // Reset at each loop...
         XCancel := FALSE;
         PaintWinContent := FALSE;

         If IsReady Then
         Begin
            If Assigned(fOnTest) Then fOnTest(Self); // Event
         End;

         Even := Win_Test(fWindow);

// Events management

         If Even = CMClosed Then XCancel := TRUE;

         If Even = CMActivated Then
         Begin
            If Assigned(fOnActivate) Then fOnActivate(Self);
         End;

         If Even = CMInactivated Then
         Begin
            If Assigned(fOnDeactivate) Then fOnDeactivate(Self);
         End;

         If Even = CMResized Then
         Begin
            If Assigned(fOnSized) Then fOnSized(Self);
            PaintWinContent := TRUE;
         End;

         If Even = CMSwapped Then
         Begin
            If Assigned(fOnSwapped) Then fOnSwapped(Self);
//            PaintWinContent := TRUE;
         End;

         If Even = CMExtended Then
         Begin
            If Assigned(fOnExtended) Then fOnExtended(Self);
            PaintWinContent := TRUE;
         End;

         If Even = CMMoved  Then
         Begin
            If Assigned(fOnMoved) Then fOnMoved(Self);
            PaintWinContent := TRUE;
         End;

         If (Assigned(fOnPaint)) And (PaintWinContent) Then
         Begin  // Force window to repaint gadgets...
            PaintWinContent := FALSE;
            Win_Clip(TRUE,fWindow);
            fOnPaint(Self); // Event
            Win_Clip(FALSE,fWindow);
         End;

         If fWindow.FlgM Then           // Window is currently moving
         Begin
            If Assigned(fOnMoving) Then
            Begin
               aLeft := fWindow.X1;
               aTop  := fWindow.Y1;
               fOnMoving(Self,aLeft,aTop);
            End;
         End;

         If fWindow.FlgS Then           // Window is currently sizing
         Begin
            If Assigned(fOnSizing) Then
            Begin
               aWidth  := fWindow.X2 - fWindow.X1;
               aHeight := fWindow.Y2 - fWindow.Y1;
               fOnSizing(Self,aWidth,aHeight);
            End;
         End;

      Mse_GetPos(X,Y);                  // Get mouse position...

      If (X>=fWindow.X1) And (X<=fWindow.X2) And
         (Y>=fWindow.Y1) And (Y<=fWindow.Y2) // Event OnMouseOver
         Then fMouseOver := TRUE
         Else fMouseOver := FALSE;
      If Assigned(fOnMouseOver) Then fOnMouseOver(Self,fMouseOver);

      If (X<>OldX) Or (Y<>OldY) Then    // Event OnMouseMove
      Begin
         OldX := X;
         OldY := Y;
         If (X>=fWindow.X1 + 2) And (X<=fWindow.X2) And
            (Y>=fWindow.Y1 + HaF1 + 7) And (Y<=fWindow.Y2) Then
         Begin                          // Mouse is on windows...
            X := X - fWindow.X1 - 2;    // Calcule relative coordinates
            Y := Y - fWindow.Y1 - HaF1 - 7;
            Shift := [];                // Need to be developped...
            If Assigned(fOnMouseMove) Then fOnMouseMove(Self,Shift,X,Y);
         End;
      End;

      FormManageEvents;                 // To be overriten for new events management

      If (XOk) Or (XCancel) Then Close; // Try to close window...

      If fForceClose Then               // A request to close the window has been emitted...
      Begin
         Action := CAFree;
         If Assigned(fOnClose) Then fOnClose(Self,Action); // Event
         Case Action of
            CANone     : fForceClose := FALSE; // Cancel close
            CAHide     : fForceClose := FALSE; // Not managed now !
            CAFree     : fForceClose := TRUE;  // Authorisation to close
            CAMinimize : fForceClose := FALSE; // Not managed now !
         End;
      End;

      Until fForceClose;       // Here the window is ready to be closed...

      Result := Even;

   Except
      Result := -1;
      Raise;
   End;
End;

Procedure TCustomForm.FormManageEvents;
Begin
End;

Procedure TCustomForm.SetCaption(aCaption:String);
Begin
   If fCaption = aCaption Then Exit;

   fCaption := aCaption;

// Interface with the TWindow class

   fWindow.Name := fCaption;
   Paint;               // Redraw all...
End;

Procedure TCustomForm.SetColor(aColor:TTrueColor);
Begin
   fColor := aColor;

// Interface with the TWindow class

   fWindow.Coul := fColor;
   Paint;               // Redraw all...
End;

Procedure TCustomForm.SetCursor(aCursor:String);
Begin
   fCursor := aCursor;
//   Invalidate;
End;

Procedure TCustomForm.SetEnabled(aEnabled:Boolean);
Begin
   Inherited;
//   fEnabled := aEnabled;
End;

Procedure TCustomForm.SetFormStyle(aFormStyle:TFormStyle);
Begin
   fFormStyle := aFormStyle;
End;

Procedure TCustomForm.SetPosition(aPosition:TFormPosition);
Begin
   fPosition := aPosition;
End;

Procedure TCustomForm.SetWindowState(aWindowState:TWindowState);
Begin
   fWindowState := aWindowState;
End;

Procedure TCustomForm.SetLimitToScreen(aLimitToScreen:Boolean);
Begin
   fLimitToScreen := aLimitToScreen;

// Interface with the TWindow class

   If fLimitToScreen Then BSET(fWindow.IDCMP,6)
                     Else BCLR(fWindow.IDCMP,6);
End;

Procedure TCustomForm.SetTransparent(aTransparent:Boolean);
Begin
   If fTransparent = aTransparent Then Exit;

   fTransparent := aTransparent;

// Interface with the TWindow class

   If fTransparent Then BSET(fWindow.IDCMP,13)
                   Else BCLR(fWindow.IDCMP,13);

// This trick force the window to repaint but we cannot use
// the "Paint" function that check if the window is visible...

   Win_Hide(fWindow);
   Win_Draw(fWindow);

   Win_Clip(TRUE,fWindow);
   If Assigned(fOnPaint) Then fOnPaint(Self); // Event
   Win_Clip(FALSE,fWindow);
End;

Procedure TCustomForm.SetCanMove(aCanMove:Boolean);
Begin
   fCanMove := aCanMove;

// Interface with the TWindow class

   If fCanMove Then BSET(fWindow.IDCMP,14)
               Else BCLR(fWindow.IDCMP,14);
End;

Procedure TCustomForm.SetLocked(aLocked:Boolean);
Begin
   fLocked := aLocked;

// Interface with the TWindow class

   If fLocked Then BSET(fWindow.IDCMP,10)
              Else BCLR(fWindow.IDCMP,10);
End;

Procedure TCustomForm.SetActivated(aActivated:Boolean);
Begin
   If fActivated = aActivated Then Exit;

   fActivated := aActivated;

// Interface with the TWindow class

   If fActivated Then
   Begin
      BSET(fWindow.IDCMP,0);
      If Assigned(fOnActivate) Then fOnActivate(Self); // Event
   End
   Else
   Begin
      BCLR(fWindow.IDCMP,0);
      If Assigned(fOnDeactivate) Then fOnDeactivate(Self); // Event
   End;
   Paint;                 // Redraw all...
End;

Procedure TCustomForm.SetZoom(aZoom:Boolean);
Begin
   fZoom := aZoom;

// Interface with the TWindow class

   If fZoom Then BSET(fWindow.IDRES,0)
            Else BCLR(fWindow.IDRES,0);
End;

Procedure TCustomForm.SetFullHandle(aFullHandle:Boolean);
Begin
   fFullHandle := aFullHandle;

// Interface with the TWindow class

   If fFullHandle Then BSET(fWindow.IDRES,1)
                  Else BCLR(fWindow.IDRES,1);
End;

Function TCustomForm.CheckIsMoved:Boolean;
Begin
   Result := fWindow.FlgM;
End;

Function TCustomForm.CheckIsSized:Boolean;
Begin
   Result := fWindow.FlgS;
End;

Function TCustomForm.IsReady:Boolean;
Begin
   Result := Win_Ready(fWindow);
End;

Procedure TCustomForm.SetCloseButton(aState:Boolean);
Begin
   If fCloseButton = aState Then Exit;
   fCloseButton := aState;

// Interface with the TWindow class

   If fCloseButton Then BSET(fWindow.IDCMP,4)
                   Else BCLR(fWindow.IDCMP,4);
   Paint;               // Redraw all...
End;

Procedure TCustomForm.SetSwapButton(aState:Boolean);
Begin
   If fSwapButton = aState Then Exit;
   fSwapButton := aState;

// Interface with the TWindow class

   If fSwapButton Then
   Begin
      BSET(fWindow.IDCMP,3);
      Inc(fWindow.NbGsp);
   End
   Else
   Begin
      BCLR(fWindow.IDCMP,3);
      Dec(fWindow.NbGsp);
   End;
   Paint;               // Redraw all...
End;

Procedure TCustomForm.SetSizeButton(aState:Boolean);
Begin
   If fSizeButton = aState Then Exit;
   fSizeButton := aState;

// Interface with the TWindow class

   If fSizeButton Then BSET(fWindow.IDCMP,2)
                  Else BCLR(fWindow.IDCMP,2);
   Paint;               // Redraw all...
End;

Procedure TCustomForm.SetExtendedButton(aState:Boolean);
Begin
   If fExtendedButton = aState Then Exit;
   fExtendedButton := aState;

// Interface with the TWindow class

   If fExtendedButton Then
   Begin
      BSET(fWindow.IDCMP,1);
      Inc(fWindow.NbGsp);
   End
   Else
   Begin
      BCLR(fWindow.IDCMP,1);
      Dec(fWindow.NbGsp);
   End;
   Paint;               // Redraw all...
End;

Procedure TCustomForm.SetShowTitle(aState:Boolean);
Begin
   If fShowTitle = aState Then Exit;
   fShowTitle := aState;

// Interface with the TWindow class

   If fShowTitle Then BSET(fWindow.IDCMP,7)
                 Else BCLR(fWindow.IDCMP,7);
   Paint;               // Redraw all...
End;

Procedure TCustomForm.SetShowBorders(aState:Boolean);
Begin
   If fShowBorders = aState Then Exit;
   fShowBorders := aState;

// Interface with the TWindow class

   If fShowBorders Then BSET(fWindow.IDCMP,8)
                   Else BCLR(fWindow.IDCMP,8);
   Paint;               // Redraw all...
End;

{****************************************************************************}
{*** TForm Class                                                          ***}
{****************************************************************************}

Constructor TForm.Create(AOwner:TComponent);
Begin
   Inherited;

   fAutoActivate := FALSE;     // No auto activate window when mouse is over
   fOldMouseState:= -1;
End;

Procedure TForm.FormManageEvents;
Begin
   Inherited;

   If fAutoActivate Then                // If AutoActivate is ON
   Begin
      If fMouseOver Then                // Mouse is over the window
      Begin
         If (fOldMouseState = -1) Or (fOldMouseState = 0) Then
         Begin                          // Not initialised or previously deactivated
            SetActivated(TRUE);
            fOldMouseState := 1;
         End;
      End;

      If IsReady Then
      Begin
         If Not fMouseOver Then         // Mouse is not over the window
         Begin
            If (fOldMouseState = -1) Or (fOldMouseState = 1) Then
            Begin                       // Not initialised or previously activated
               SetActivated(FALSE);
               fOldMouseState := 0;
            End;
         End;                           // End of "If Not fMouseOver..."
      End;                              // End of "If IsReady Then..."
   End;                                 // End of "If fAutoActivate Then..."
End;

{******************************* NO MAIN CODE *******************************}

Begin
End.
