{ͻ
                               UNIT MosGraph                                
 ͹
  CREATOR....: PLANAS Jean-Pierre                                           
  UPDATED BY.: PLANAS Jean-Pierre                                           
  CREATED THE: 25.06.1998                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: Replace the graph.tpu unit of tp 7.0.                        
  AUTONOMOUS.: Yes                                                          
  UNIT SIZE..: 3.597 Lines and (60.352 Bytes compiled)                      
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

{$ASMMODE intel}
{$Mode ObjFpc}

UNIT MosGraph;

INTERFACE

Const ClipOn   = True;          {*Clipping Constants*}
      ClipOff  = False;
      NormalPut= 0;             {*PutImage Constants*}
      CopyPut  = 0;
      XorPut   = 1;
      AndPut   = 3;
      NotPut   = 4;
      SolidLn  = 0;             {*Line Styles*}
      DottedLn = 1;
      CenterLn = 2;
      DashedLn = 3;
      UserBitLn= 4;             {*User-defined line style*}
      NormWidth = 1;            {*Line Widths*}
      ThickWidth= 3;

Type TCHRHeader = Packed Record        {* Header of a CHR file*}
       Prefix      :Array[1..$80] of Char; {*Header*}
       Sig         :char;	{* SIGNATURE byte                        *}
       Nchrs       :SmallInt;	{* number of characters in file          *}
       Mystery     :char;       {* Currently Undefined                   *}
       First	   :byte;    	{* first character in file               *}
       Cdefs	   :SmallInt;   {* offset to char definitions            *}
       Scan_Flag   :char;	{* True if set is scanable               *}
       Org_To_Cap  :Shortint;	{* Height from origin to top of capitol  *}
       Org_To_Base :Shortint;	{* Height from origin to baseline        *}
       Org_To_Dec  :Shortint;	{* Height from origin to bot of decender *}
       FntName     :Array[1..4] of char;{* Four character name of font   *}
       Unused      :char;       {* Currently undefined                   *}
     End;

     TCHRFont = Packed Record        {*CHR font informations*}
       Font_Name    :String[80]; {* Name and path of the font              *}
       Org_to_cap   :SmallInt; {* Height from origin to top of capitol      *}
       Org_to_base  :SmallInt; {* Height from origin to baseline            *}
       Org_to_dec   :SmallInt; {* Height from origin to bot of decender     *}
       Num_chrs     :SmallInt; {* Four character name of font               *}
       First        :Byte;     {* First character in file                   *}
       Direction    :Byte;     {* Direction : horizontal (0) or vertical (1)*}
       Char_Width   :Array[0..255] of Byte;  {* Character Width Table	   *}
       Offset       :Array[0..255] of SmallInt;
       RFontSize     :Real;   {*1..9 : Font Size on Screen                 *}
       P_Font       :Pointer;
       Size_P_Font  :Word;
     End;

     TLineSettingsType = Record  {*Type for definition of Lines*}
       LineStyle : Word;
       Pattern   : Word;
       Thickness : Word;
     End;

     TPatternSettingsType = Record {*Type pour definition of Pattern*}
       Pattern:Word;
       Color:LongInt;
     End;

     TViewPortType = Record   {*Set View Port parameters*}
       x1, y1, x2, y2 : SmallInt;
       Clip           : Boolean;
     End;

     TPointType = Record    {*Coordinates*}
         X, Y : SmallInt;
     End;

     TFillPatternType = array[1..8] of byte;

     TInternalVESA=Record   {*Internal structure for MosGraph*}        {MIC}
       WriteMode         : SmallInt; {NormalPut, Xorput ...}           {MIC}
       LineInfo          : TLineSettingsType;                         {MIC}
       PatternInfo       : TPatternSettingsType;                      {MIC}
       UserPattern       : TFillPatternType;                          {MIC}
       VesaOn            : Boolean;                                   {MIC}
       CurrentColor      : LongInt;                                   {MIC}
       Coord_To_x        : SmallInt;                                   {MIC}
       Coord_To_y        : SmallInt;                                   {MIC}
       Setvport          : TViewportType;                             {MIC}
     End;                                                             {MIC}

     TPolygon = array of TPointType;

{|Pixels|}
Procedure VESA_Putpixel(x,y:SmallInt;c:Longint);      {*Put a pixel on screen*}
Function  VESA_Getpixel(x,y:SmallInt):LongInt;        {*Get the color of a pixel*}

{|Screen size|}
Function  VESA_GetMaxX : SmallInt;                    {*Get maximum width of the current screen mode*}
Function  VESA_GetMaxY : SmallInt;                    {*Get maximum heigth of the current screen mode*}

{|Colors|}
Procedure VESA_SetColor(Color : LongInt);            {*Set the current color*}
Function  VESA_GetColor : LongInt;                   {*Get the current color*}
Procedure VESA_SetColorNumber(Color : LongInt);
Function  VESA_SetRgbColor(R,G,B:Byte):Longint;
Procedure VESA_GetRgbColor(C:Longint;Var R,G,B:Byte);

{|CHR fonts|}
Function  TEST_CHR(NameFile:String):Boolean;         {*Test if file is a CHR font*}
Procedure VESA_OutTextXY(x,y:SmallInt;S:String);      {*Write text on screen*}
Function  VESA_TextWidth(S : string) : word;         {*Get text width*}
Function  VESA_TextHeight : word;                    {*Get text heigth*}
Procedure VESA_SetTextStyle(FileName:String;Dir,Size:Byte);  {*Set current font and parameters*}

{|Lines|}
Procedure VESA_GetLineStyle(Var LineInfo : TLineSettingsType);     {*Get the line style*}
Procedure VESA_SetLineStyle(LineStyle, Pattern, Thickness : Word); {*Set the line style*}
Procedure VESA_Line(x1, y1, x2, y2 : SmallInt);       {*Draw a line*}
Procedure VESA_Rectangle(x1, y1, x2, y2 : SmallInt);  {*Draw a rectangle*}
Procedure VESA_Bar(X1,Y1,X2,Y2 : SmallInt);           {*Draw a fill rectangle*}

{|Current pointer|}
Function  VESA_GetX : SmallInt;                       {*Get current X position*}
Function  VESA_GetY : SmallInt;                       {*Get current Y position*}
Procedure VESA_LineTo(X, Y : SmallInt);               {*Draw a line with current position*}
Procedure VESA_MoveTo(X, Y : SmallInt);               {*Move current position*}

{--}

{|Images|}
Procedure VESA_GetImage(x1, y1, x2, y2 : SmallInt; var BitMap); {*Save the image*}
Procedure VESA_PutImage(X, Y : SmallInt; var BitMap; BitBlt : word); {*Put image on the screen*}
Procedure VESA_PutImageT(X, Y : SmallInt; var BitMap; BitBlt : word;T:Longint); {*Put image with transparency on the screen*}

{|ViewPort|}
Procedure VESA_SetViewPort(x1, y1, x2, y2 : SmallInt; Clip : boolean);  {*Set viewport parameters*}
Procedure VESA_GetViewSettings(var ViewPort : TViewPortType);          {*Get viewport parameters*}

{|Polygons|}
Procedure Vesa_FillPoly( Num : Word;var PolyPoints);  {*Draw a fill polygon*}
Procedure VESA_DrawPoly(NumPoints: Word; var PolyPoints); {*Draw a polygon*}

{|Miscellaneous|}
Procedure VESA_Circle(X,Y,Rad,Color:Longint);  {*Draw a Circle*}
Procedure VESA_ClearViewPort;                  {*Clear screen*}
Procedure VESA_FillShape(X,Y:SmallInt;Color:LongInt);   {*Fill a part of the screen*}

{|Init/Close graphic modes|}
Procedure VESA_Initgraph(Mode:Byte;Path:String);     {*Initialise GFX mode*}
Procedure VESA_ReInitgraph(Mode:Byte;Path:String);   {*Partial initialisation of GFX mode*}
Procedure VESA_CloseGraph;                           {*End the use of graph Procedures*}

{|Not ready yet|}
Procedure VESA_SetFillStyleNumber(Pattern : Word; Color:LongInt);
Procedure VESA_SetFillStyle(Pattern: Word;Color:LongInt);   {*Set the fill style*}
Function  VESA_GetWriteMode:SmallInt;                  {*Get current write mode*}
Procedure VESA_SetWriteMode(WriteMode : SmallInt);     {*Set current write mode*}
Procedure VESA_SetFillPattern(Pattern: TFillPatternType; Color: Word); {*Set User define Pattern*}

{|Xor Proc|}
Procedure VESA_XorBar(x1,y1,x2,y2:SmallInt;c:longint); {*Xor Bar*}
Procedure VESA_XorLine(x1,y1,x2,y2:SmallInt);          {*Xor Line*}
Procedure VESA_XorRectangle(x1,y1,x2,y2:SmallInt);     {*Xor Rectangle*}

Function  VESA_TestMOSMode(Mode:Byte):Boolean;
Function  GraphiX_Version:String;
Procedure VESA_GetModeInfo(Mode:Byte;Var X,Y:Word;Var Col:LongInt);

{|Graphic Card information|}
Function  GraphicCard_GetVendor:String;             {*Get graphic card Vendor Id*}
Function  GraphicCard_GetSlot:String;               {*Get graphic card slot type AGP/PCI*}
Function  GraphicCard_GetVBEName:String;            {*Get graphic card VBE name*}
Function  GraphicCard_Detected:Boolean;             {*Test if graphic card has been detected*}
Function  GraphicCard_GetMemory:String;             {*Get graphic card memory size in MB*}

Function LOAD_CHR(FileName:String):Byte;
Procedure UNLOAD_CHR;

{*TO IMPLEMENT*}
Function Test_TextMode:Boolean;

IMPLEMENTATION

Uses
     GraphiX,
     GxImg,
     Gx2d,
     GxBase,
     MosCrt,
     MosDisks,
     MosFiles,
     MosStrings,
     MosMemory;

{*Global Vars*}

Var C_Font       : TCHRFont; { Current Font }                         {MIC}
    Chrloaded    : Boolean;                                           {MIC}
    VesaInternal : TInternalVESA;                                     {MIC}
    PolygonPoints: TPolygon;

{*------------------------ Graphic Card Information ------------------------*}

Function GraphicCard_GetVendor:String;
Begin
GraphicCard_GetVendor:=CurGraphiX.VendorName;
End;

Function GraphicCard_GetVBEName:String;
Begin
GraphicCard_GetVBEName:=CurGraphiX.Name;
End;

Function GraphicCard_GetSlot:String;
Begin
If CurGraphiX.PCIDev Then GraphicCard_GetSlot:='PCI'
                     Else GraphicCard_GetSlot:='AGP';
End;

Function GraphicCard_Detected:Boolean;
Begin
GraphicCard_Detected:=CurGraphiX.Detected;
End;

Function GraphicCard_GetMemory:String;
Begin
GraphicCard_GetMemory:=Str_L2S(CurGraphiX.Memory Div 1024);
End;

{*-------------------------------- Pixels ----------------------------------*}

{ͻ
                          Procedure VESA_PUTPIXEL                           
 ͹
  IN.....: (X,Y) (SmallInt) = Coordinates of the pixel.                      
           C (LONGINT) = Color of the pixel to put on screen.               
  OUT....: /                                                                
  EXPLAIN: Show a pixel on screen.                                          
  CLIP...: Yes.                                                             
 ͼ}
Procedure VESA_Putpixel(x,y:SmallInt;c:Longint);
Begin
PutPixel(Vesainternal.Setvport.x1+x,Vesainternal.Setvport.y1+y,c);
End;

{ͻ
                           FUNCTION VESA_GETPIXEL                           
 ͹
  IN.....: (X,Y) : (SmallInt) = Coordinates of the pixel.                    
  OUT....: (LONGINT) = Color of the pixel on screen.                        
  EXPLAIN: Get the color of a pixel.                                        
  NB.....: If the pixel is out of screen, or setviewport, default color will
           be returned.                                                     
  CLIP...: Yes.                                                             
  SEEALSO: VESA_GetColor                                                    
 ͼ}
Function VESA_Getpixel(x,y:SmallInt):LongInt;
Begin
VESA_Getpixel:=GetPixel(Vesainternal.Setvport.x1+x,Vesainternal.Setvport.y1+y);
End;

{*------------------------------ Screen Size -------------------------------*}

{ͻ
                           FUNCTION VESA_GETMAXX                            
 ͹
  IN.....: /                                                                
  OUT....: (SmallInt) : Maximum coordinate X in actual graphic mode.         
  EXPLAIN: This return return 639 if we are in 640*480 mode for example.    
  CLIP...: No . Real coordinates.                                           
 ͼ}
Function VESA_GetMaxX : SmallInt;
Begin
VESA_GetMaxX:=GetMaxX;
End;

{ͻ
                           FUNCTION VESA_GETMAXY                            
 ͹
  IN.....: /                                                                
  OUT....: (SmallInt) : Maximum coordinate Y in actual graphic mode.         
  EXPLAIN: Return maximun Y coordinate in current mode.                     
  EXAMPLE: This function return 479 if we are in 640*480 mode.              
  CLIP...: No . Real coordinates.                                           
 ͼ}
Function VESA_GetMaxY : SmallInt;
Begin
VESA_GetMaxY:=GetMaxY;
End;

{*-------------------------------- Colors ----------------------------------*}

{ͻ
                           FUNCTION VESA_GETCOLOR                           
 ͹
  IN.....: /                                                                
  OUT....: (LONGINT) = Get default color.                                   
  EXPLAIN: /                                                                
 ͼ}
Function VESA_GetColor : LongInt;
begin
 VESA_GetColor:=VesaInternal.CurrentColor;
end;

{ͻ
                       Procedure VESA_SETCOLORNUMBER                        
 ͹
  IN.....: Color : (LONGINT) = Color to set                                 
  OUT....: /                                                                
  EXPLAIN: Set  the default color to use to draw.                           
 ͼ}
Procedure VESA_SetColorNumber(Color : LongInt);
begin
VesaInternal.CurrentColor:=color;
end;

{ͻ
                          Procedure VESA_SETCOLOR                           
 ͹
  IN.....: Color : (LONGINT) = Color to set                                 
  OUT....: /                                                                
  EXPLAIN: Set  the default color to use to draw.                           
 ͼ}
Procedure VESA_SetColor(Color : LongInt);
begin
VesaInternal.CurrentColor:=color;
end;

{ͻ
                         FUNCTION VESA_SetRGBColor                          
 ͹
  IN.....: R,G,B (BYTE) = RGB components of a color                         
  OUT....: (LONGINT) = color RGB.                                           
  EXPLAIN: Return a color from RGB values.                                  
  SEEALSO: VESA_GetRGBColor                                                 
 ͼ}
Function VESA_SetRgbColor(R,G,B:Byte):Longint;
var l:longint;
Begin
//VESA_SetRgbColor:=rgbcolor(R,G,B);  TODOJPP
l:=0;
l:=l+b;
l:=l+g*256;
l:=l+r*256*256;

VESA_SetRgbColor:=rgbcolor(l);
End;

{ͻ
                         Procedure VESA_GetRGBColor                         
 ͹
  IN.....: C (LONGINT) = a color                                            
  OUT....: R,G,B (BYTE) = RGB components of the color C.                    
  EXPLAIN: Return RGB values from a color.                                  
  SEEALSO: VESA_SetRGBColor                                                 
 ͼ}
Procedure VESA_GetRgbColor(C:Longint;Var R,G,B:Byte);
Var L:Longint;
Begin
L:=getrgbcolor32(C);
R:=(L And $00FF0000) Shr 16;
G:=(L And $0000FF00) Shr 8;
B:=(L And $000000FF);
End;

{*-------------------------------- Chr -------------------------------------*}

{ͻ
                             FUNCTION TEST_CHR                              
 ͹
  IN.....: NameFile : (STRING) = Name of the file to test.                  
  OUT....: (BOOLEAN) : TRUE = The file is a CHR File, FALSE = not a CHR file
  EXPLAIN: This function return TRUE if the file is a CHR file, else FALSE  
  OPT....: Can be optimisez with File_TestHeader                            
 ͼ}
Function TEST_CHR(NameFile:String):Boolean;
Var F:File;
    Header : TCHRHeader;
    e:SmallInt;
    s:String;
Begin
If Not File_TestExist(NameFile) then
  Begin
  TEST_CHR:=False;
  Exit;
  End;
Assign(F,Namefile);
{$i-}
Reset(F, 1);
{$i+}
If ioresult=0 then
  Begin
  {$i-}
  Blockread(F, Header, SizeOf(Header),e);
  {$i+}
  If (ioresult<>0) or (e<>Sizeof(Header)) then
    Begin
    test_CHR:=false;
    Close(F);
    exit
    End;
  Close(F);
  S:=UPPER(Header.prefix);
  s[0]:=#20;
  If (Header.sig='+') and (s='PK'+#8+#8+'BGI STROKED FONT') then
    TEST_CHR:=true else TEST_CHR:=false;
  End else test_CHR:=false;
End;

{ͻ
                            Procedure UNLOAD_CHR                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Unload of the memory the font witch have been loaded before with 
           LOAD_CHR function.                                               
  SEEALSO: LOAD_CHR                                                         
 ͼ}
Procedure UNLOAD_CHR;
Begin
If chrloaded then
  Begin
  Freemem(C_Font.P_Font,C_Font.Size_P_Font);
  chrloaded:=False;
  End;
End;

{ͻ
                             FUNCTION LOAD_CHR                              
 ͹
  IN.....: FileName : (STRING) = File Name of a CHR font to load.           
  OUT....: (BYTE) : Error Number                                            
                    0 = No errors.                                          
                    1 = Not enougth conventionnal memory.                   
                    2 = The file is not a CHR font.                         
  EXPLAIN: Load in memory a font in the variable C_Font. You have to make   
           this step if you want to write with a font.                      
  SEEALSO: UNLOAD_CHR                                                       
 ͼ}

Function LOAD_CHR(FileName:String):Byte;
Var F:File;
    Header       : TCHRHeader;
    i:SmallInt;
Begin
{ Il faut garder la fonte si l'autre n'est pas correct !!!}
{ Il faut aussi garder toujours une fonte de rserve !!!}
If Not TEST_CHR(FileName) Then
  Begin
  LOAD_CHR:=2;
  Exit;
  End;

{Ceci devra tre enlev}
If FileName[length(FileName)]='\' Then FileName[0]:=chr(ord(FileName[0])-1);
{fin de Ceci devra tre enlev}
If chrloaded then UNLOAD_CHR;

chrloaded:=False;
{If Not TEST_CHR(FileName) Then FileName:='d:\mos\cd\system\fonts\litt.chr';}

{INIT_STRUCT_CHR;}
C_Font.Size_P_Font:=0;
For i:=0 to 255 do
  Begin
  C_Font.Offset[i]:=0;
  C_Font.Char_Width[i]:=0;
  End;
C_Font.NUM_chrs:=0;
Assign(F,FileName);
Reset(F,1);
BlockRead(F,HEADER,Sizeof(HEADER));       {*Lecture du header*}
C_Font.NUM_chrs:=HEADER.nchrs;
C_Font.org_to_cap :=Header.org_to_cap ;
C_Font.org_to_base:=Header.org_to_base;
C_Font.org_to_dec :=Header.org_to_dec ;
C_Font.first      :=header.first;
                                        {*Charge table offset et taille char*}
BlockRead(F,C_Font.OFFSET[header.first],Sizeof(SmallInt)*C_Font.NUM_chrs);
BlockRead(F,C_Font.CHAR_WIDTH[header.first],Sizeof(Byte)*C_Font.NUM_chrs);

C_Font.Size_P_Font:=Filesize(f)-Filepos(f);      {*Calcule mmoire ncssaire*}
If maxavail<C_Font.Size_P_Font Then              {*Teste si assez de mmoire *}
  Begin
  LOAD_CHR:=1;
  Exit;
  End;

Getmem(C_Font.P_Font,C_Font.Size_P_Font);

BlockRead(F,C_Font.P_Font^,C_Font.Size_P_Font);
Close(F);
LOAD_CHR:=0;
c_Font.Font_name:=FileName;
c_Font.RFontSize:=1;
chrloaded:=true;
End;

{ͻ
                            Procedure DRAW_CHAR                             
 ͹
  IN.....: (X,Y) = (SmallInt) : Coordinates where the char must be written.  
           i = (BYTE) : Number of the char witch will be draw.              
           r = (REAL) : Real size of the font.                              
  OUT....: /                                                                
  EXPLAIN: Draw 1 character at (x,y). Parameter i is the ASCII value of the 
           character.                                                       
 ͼ}

Procedure Draw_char(x,y:SmallInt;i:Byte;R:real);

  Procedure Decode(W:Word;Var Action:Byte;Var X2,Y2:SmallInt);
  Var X,Y:SmallInt;
  Begin
    Action:=0;
    If W And $80=$80 Then Action:=Action+2;
    If W And $8000=$8000 Then Action:=Action+1;
    X:=W And ($FF-$80);
    Y:=((W And ($FF00-$8000)) shr 8);
    asm
    mov ax,x
    shl ax,9
    sar ax,9
    mov x,ax

    mov ax,y
    shl ax,9
    sar ax,9
    mov y,ax
    End;
    X2:=X;
    Y2:=Y;
  End;

Var p_w     :^Word;
    Action  :byte;
    Xd,Yd   :SmallInt;
    Centrage:SmallInt;
Begin

If C_Font.First+C_Font.Num_chrs<i Then Exit;
If (C_Font.OFFSET[i]<>0) or (i=C_Font.First) Then
  Begin
  Centrage:=Trunc((C_Font.org_to_cap-C_Font.org_to_dec)*r);
  VESA_MoveTo(x,y);
  p_w:=C_Font.p_Font;
  inc(p_w,C_Font.OFFSET[i] div 2);
  Decode(p_w^,Action,Xd,Yd);
  While (Action<>0) do
    Begin

    If C_Font.Direction=0 Then
      Case Action of
           1:Write(^g);
           2:VESA_Moveto(x+Trunc(Xd*r),y-Trunc(Yd*r)+Centrage);
           3:VESA_LineTo(x+Trunc(Xd*r),y-Trunc(Yd*r)+Centrage);
      End{Case}
    Else
      Case Action of
           1:Write(^g);
           2:VESA_Moveto(x-Trunc(Yd*r),y-Trunc(Xd*r));
           3:VESA_LineTo(x-Trunc(Yd*r),y-Trunc(Xd*r));
      End;{Case}
    inc(p_w);
    Decode(p_w^,Action,Xd,Yd);
    End;
  End;
End;

{ͻ
                          Procedure VESA_OUTTEXTXY                          
 ͹
  IN.....: (X,Y) = (SmallInt) : Coordinates where s must be written.         
           S = (STRING) : String to write.                                  
  OUT....: /                                                                
  EXPLAIN: Write a text at (x,y).                                           
  CF.....: Tp7 Graph Unit.                                                  
 ͼ}

Procedure VESA_OUTTEXTXY(x,y:SmallInt;S:String);
Var i:SmallInt;
    t:SmallInt;
    OldX,OldY:SmallInt;
    LineInfo:TLineSettingstype;
Begin
Oldx:=VESA_GetX;                           {*Save relative coordinates*}
Oldy:=VESA_GetY;
LineInfo:=VesaInternal.LineInfo;           {*Save line settings*}
VESA_SetLineStyle(SolidLn,0,NormWidth);

If C_Font.direction=0 Then
  Begin             {*Horizontal*}
  t:=x;
  For i:=1 to Length(s) do

    Begin
    Draw_Char(t,y,ord(s[i]),C_Font.RFontSize);
    inc(t,Trunc(C_Font.Char_Width[ord(s[i])]*C_Font.RFontSize));
    End;
  End
Else
  Begin             {*Vertical  *}
  t:=y;
  For i:=1 to Length(s) do inc(t,Trunc((C_Font.Char_Width[ord(s[i])])*C_Font.RFontSize));
  For i:=1 to Length(s) do
    Begin
    Draw_Char(x+Trunc((C_Font.org_to_cap-C_Font.org_to_dec)*C_Font.RFontSize),
    t,ord(s[i]),C_Font.RFontSize);
    dec(t,Trunc(C_Font.Char_Width[ord(s[i])]*C_Font.RFontSize));
    End;
  End;

                                              {*Restore Line settings*}
VESA_SetLineStyle(LineInfo.LineStyle,LineInfo.Pattern,LineInfo.ThickNess);
VESA_MoveTo(OldX,OldY);                       {*Restore relative coordinates*}
End;

{ͻ
                          FUNCTION VESA_TEXTWIDTH                           
 ͹
  IN.....: s = (STRING) : String witch we want to know the size in pixels.  
  OUT....: (WORD) : Size in pixel of the string on the screen.              
  EXPLAIN: Calculate the length in pixel of a string.                       
  CF.....: Tp7 Graph Unit.                                                  
 ͼ}
Function  VESA_TextWidth(S : string) : word;
Var i:Byte;
    total:Word;
Begin
Total:=0;
For I:=1 to Length(S) do inc(Total,C_Font.Char_Width[ord(s[i])]);
VESA_TextWidth:=Trunc(Total*C_Font.RFontSize);
End;

{ͻ
                          FUNCTION VESA_TEXTHEIGHT                          
 ͹
  IN.....: /                                                                
  OUT....: (WORD) = Size in pixel of the current font.                      
  EXPLAIN: Calculate the height in pixel of the current font.               
  CF.....: Tp7 Graph Unit.                                                  
 ͼ}
Function  VESA_TextHeight : word;
Begin
VESA_TextHeight:=Trunc((C_Font.org_to_cap-C_Font.org_to_dec)*C_Font.RFontSize);
End;

{ͻ
                        Procedure VESA_SETTEXTSTYLE                         
 ͹
  IN.....: FileName : (STRING) = File Name of a CHR font.                   
           Dir : (BYTE) = Direction of display  (0=Horizontal               
                                                 and 1=Vertical).           
           Size : (BYTE) = Size of the font.                                
  OUT....: /                                                                
  EXPLAIN: You can change the current font or size or direction.            
           Only one difference between tp7 graph unit : The first parameter 
           is a NameFile instead of an SmallInt.                             
  CF.....: Tp7 Graph Unit.                                                  
 ͼ}
Procedure VESA_SetTextStyle(FileName:String;Dir,Size:Byte);
Begin

LOAD_CHR(FileName);

  Case Size of
       0:C_Font.RFontSize:=1;
       1:C_Font.RFontSize:=33/55;
       2:C_Font.RFontSize:=37/55;
       3:C_Font.RFontSize:=3/4;
       4:C_Font.RFontSize:=1;
       5:C_Font.RFontSize:=1+1/3;
       6:C_Font.RFontSize:=1+2/3;
       7:C_Font.RFontSize:=2;
       8:C_Font.RFontSize:=2.5;
       9:C_Font.RFontSize:=3;
      10:C_Font.RFontSize:=4;
  Else C_Font.RFontSize:=4;
  End;{Case}
C_font.direction:=dir;
End;

{*------------------------------- Lines ------------------------------------*}

{ͻ
                        Procedure VESA_GETLINESTYLE                         
 ͹
  IN.....: /                                                                
  OUT....: LineInfo (TLINESETTINGSTYPE) = Get the LineStyle parameters.     
  EXPLAIN: Get the LineStyle parameters.                                    
 ͼ}
Procedure VESA_GetLineStyle(Var LineInfo : TLineSettingsType);
Begin
LineInfo.LineStyle := VesaInternal.LineInfo.LineStyle;
LineInfo.Pattern   := VesaInternal.LineInfo.Pattern;
LineInfo.Thickness := VesaInternal.LineInfo.Thickness;
End;


{ͻ
                        Procedure VESA_SETLINESTYLE                         
 ͹
  IN.....: LineStyle (WORD) = a value from SolidLn to UserBitLn(0..4)       
           Pattern   (WORD) = is ignored unless LineStyle equals UserBitLn  
           Thickness (WORD) = NormWidth or ThickWidth                       
  OUT....: /                                                                
  EXPLAIN: Set the LineStyle parameters.                                    
  CF.....: Unit GRAPH from Tp7.                                             
  BUGS...: NOT CODED                                                        
 ͼ}
Procedure VESA_SetLineStyle(LineStyle, Pattern, Thickness : Word);
Begin
VesaInternal.LineInfo.LineStyle := LineStyle;
VesaInternal.LineInfo.Pattern   := Pattern;
VesaInternal.LineInfo.Thickness := Thickness;
End;



{ͻ
                           Procedure VESA_XorLine                           
 ͹
  IN.....: X1,Y1,X2,Y2 (SmallInt) = Coordinates of the line                  
  OUT....: /                                                                
  EXPLAIN: Draw a xor line on screen.                                       
  CLIP...: Yes.                                                             
 ͼ}
Procedure VESA_XorLine(x1, y1, x2, y2 : SmallInt);
Begin
LineXor(Vesainternal.Setvport.x1+x1,Vesainternal.Setvport.y1+y1
    ,Vesainternal.Setvport.x1+x2,Vesainternal.Setvport.y1+y2,
    VesaInternal.CurrentColor);
End;

{ͻ
                            Procedure VESA_LINE                             
 ͹
  IN.....: X1,Y1,X2,Y2 (SmallInt) = Coordinates of the line                  
  OUT....: /                                                                
  EXPLAIN: Draw a line on screen.                                           
  CLIP...: Yes.                                                             
  CF.....: Tp7 (GRAPH). No differences...                                   
 ͼ}
Procedure VESA_Line(x1, y1, x2, y2 : SmallInt);
Begin
Case Vesainternal.WriteMode of
 1:VESA_XorLine(x1,y1,x2,y2);{*Xor*}
 Else
  Line(Vesainternal.Setvport.x1+x1,Vesainternal.Setvport.y1+y1
    ,Vesainternal.Setvport.x1+x2,Vesainternal.Setvport.y1+y2,
    VesaInternal.CurrentColor);
 End;
End;

{ͻ
                        Procedure VESA_XorRectangle                         
 ͹
  IN.....: X1,X2,Y1,Y2 (SmallInt) = Coordinates of a rectangle.              
  OUT....: /                                                                
  EXPLAIN: Draw a Xor rectangle.                                            
  CLIP...: Yes.                                                             
 ͼ}
Procedure VESA_XorRectangle(x1, y1, x2, y2 : SmallInt);
Begin
  LineXor(x1,y1,x2,y1,$FF);
  LineXor(x1,y1,x1,y2,$FF);
  LineXor(x2,y1,x2,y2,$FF);
  LineXor(x1,y2,x2,y2,$FF);
End;

{ͻ
                          Procedure VESA_Rectangle                          
 ͹
  IN.....: X1,X2,Y1,Y2 (SmallInt) = Coordinates of a rectangle.              
  OUT....: /                                                                
  EXPLAIN: Draw a rectangle with the current color.                         
           No differences with GRAPH of Tp7.                                
  CLIP...: Yes.                                                             
  CF.....: Unit GRAPH.TPU From TP7.                                         
 ͼ}
Procedure VESA_Rectangle(x1, y1, x2, y2 : SmallInt);
Begin
If VesaInternal.Writemode<>1 Then
Rectangle(Vesainternal.Setvport.x1+x1,Vesainternal.Setvport.y1+y1
         ,Vesainternal.Setvport.x1+x2,Vesainternal.Setvport.y1+y2
         ,VesaInternal.CurrentColor)
Else VESA_XorRectangle(x1, y1, x2, y2);
End;

{ͻ
                           Procedure VESA_XorBar                            
 ͹
  IN.....: X1,Y1,X2,Y2 : (SmallInt) = Coordinates of the box to draw.        
           C : (BYTE) = Color of the box.                                   
  OUT....: /                                                                
  EXPLAIN: Draw a box to draw in Xor mode.                                  
  OPT....: Can be optimized...                                              
 ͼ}
Procedure VESA_XorBar(x1,y1,x2,y2:SmallInt;c:longint);
Begin
BarXor(x1,y1,x2,y2,c);
End;

{ͻ
                             Procedure VESA_BAR                             
 ͹
  IN.....: X1,Y1,X2,Y2 : (SmallInt) = Coordinates of the box.                
  OUT....: /                                                                
  EXPLAIN: Draw a fill box on the screen.                                   
  CLIP...: Yes.                                                             
  CF.....: Tp7 (GRAPH). No differences...                                   
 ͼ}
Procedure VESA_Bar(X1,Y1,X2,Y2 : SmallInt);
Begin
If VesaInternal.WriteMode=Xorput Then
  Begin
  VESA_XORBAR(Vesainternal.Setvport.x1+X1,Vesainternal.Setvport.y1+Y1
   ,Vesainternal.Setvport.x1+X2,Vesainternal.Setvport.y1+Y2
   ,VesaInternal.PatternInfo.Color);
  Exit;
  End;

Bar(Vesainternal.Setvport.x1+X1,Vesainternal.Setvport.y1+Y1
   ,Vesainternal.Setvport.x1+X2,Vesainternal.Setvport.y1+Y2
   ,VesaInternal.PatternInfo.Color);
End;

{*-------------------------- Current Pointer -------------------------------*}

{ͻ
                             FUNCTION VESA_GETX                             
 ͹
  IN.....: /                                                                
  OUT....: (SmallInt) = Abscissa of the current position.                    
  EXPLAIN: Get the coordinate in X of the current position.                 
           No differences with GRAPH unit of Tp7.                           
  CF.....: Unit GRAPH.TPU From TP7.                                         
 ͼ}
Function VESA_GetX : SmallInt;
Begin
VESA_GetX:=VesaInternal.Coord_To_x;
End;

{ͻ
                             FUNCTION VESA_GETY                             
 ͹
  IN.....: /                                                                
  OUT....: (SmallInt) = Ordinate of the current position.                    
  EXPLAIN: Get the coordinate in Y of the current position.                 
           No difference with GRAPH unit of Tp7.                            
  CF.....: Unit GRAPH.TPU From TP7.                                         
 ͼ}
Function VESA_GetY : SmallInt;
Begin
VESA_GetY:=VesaInternal.Coord_To_y;
End;

{ͻ
                           Procedure VESA_MOVETO                            
 ͹
  IN.....: X,Y : (SmallInt) = Coordinates of the current position to move    
  OUT....: /                                                                
  EXPLAIN: Move the current position.                                       
           No difference with GRAPH unit of Tp7.                            
  CF.....: Unit GRAPH.TPU From TP7.                                         
 ͼ}
Procedure VESA_MoveTo(X, Y : SmallInt);
Begin
VesaInternal.Coord_To_x:=x;
VesaInternal.Coord_To_y:=y;
End;

{ͻ
                           Procedure VESA_LINETO                            
 ͹
  IN.....: X,Y : (SmallInt) = Coordinates where the current position must    
                             move and draw the line moving.                 
  OUT....: /                                                                
  EXPLAIN: Draw a line from the current position to (X,Y).                  
           No difference with GRAPH from Tp7.                               
  CF.....: Unit GRAPH.TPU From TP7.                                         
 ͼ}
Procedure VESA_LineTo(X, Y : SmallInt);
Begin
Vesa_Line(VesaInternal.Coord_To_x,VesaInternal.Coord_To_y,x,y);
VESA_MoveTo(X,Y);
End;

{*-------------------------------- Pixels ----------------------------------*}

{ͻ
 ͻ
                        BEGINNING OF GET/PUTIMAGES                        
 ͼ
 ͼ}

{ͻ
                          Procedure VESA_GETIMAGE                           
 ͹
  IN.....: X1,Y1,X2,Y2 (WORD) : Coordinates for the 256 color getimage      
           BitMap (UNTYPED) : Will contain the height and width of image    
                              and the bit image from the screen             
  OUT....: /                                                                
  EXPLAIN: Save a part of screen to the memory.                             
  CLIP...: No. Real coordinates.                                            
  CF.....: Unit GRAPH from Tp7.                                             
 ͼ}
Procedure VESA_GetImage(x1, y1, x2, y2 : SmallInt; var BitMap);
begin
CaptureImage(x1,y1,x2,y2,@Bitmap);
End;

{ͻ
                          Procedure VESA_PUTIMAGE                           
 ͹
  IN.....: X,Y (WORD) : Coordinates where to put the image.                 
           BitMap (UNTYPED) : Contain the height and width of image and the 
                              bit image that will be put onto the screen    
           BitBlt (WORD) : specifies which binary operator will be used     
                           to put the bit image onto the screen.            
  OUT....: /                                                                
  EXPLAIN: Put on screen a stored image from memory.                        
  CLIP...: No. Real coordinates.                                            
  CF.....: Unit GRAPH from Tp7.                                             
 ͼ}

Procedure VESA_PutImage(X, Y : SmallInt; var BitMap; BitBlt : word);
Begin
// To avoid warnings !
   BitBlt := BitBlt;

   PutImage(x,y,@Bitmap);
End;

{ͻ
                          Procedure VESA_PUTIMAGET                          
 ͹
  IN.....: X,Y (WORD) = Coordinates where to put the image.                 
           BitMap (UNTYPED) = Contain the height and width of image and the 
                              bit image that will be put onto the screen    
           BitBlt (WORD) = specifies which binary operator will be used     
                           to put the bit image onto the screen.            
           T (LONGINT) = Transparency color                                 
  OUT....: /                                                                
  EXPLAIN: Put on screen a stored transparent image from memory.            
  CLIP...: No. Real coordinates.                                            
 ͼ}

Procedure VESA_PutImageT(X, Y : SmallInt; var BitMap; BitBlt : word;T:Longint);
Begin
// To avoid warnings !
   BitBlt := BitBlt;

   Setimageflags(@Bitmap,img_transparency);
   SetImageTransparencyColor(@BitMap,T);
   PutImageC(x,y,@Bitmap);
End;

{ͻ
 ͻ
                             FIN DES GET/PUTIMAGES                        
 ͼ
 ͼ}

{ͻ
 ͻ
                           DEBUT DES AUTRES ROUTINES                      
 ͼ
 ͼ}

{ͻ
                           Procedure VESA_CIRCLE                            
 ͹
  IN.....: X,Y (LONGINT) = Coordinates of the center of the circle to draw  
           Rad (LONGINT) = Radius of the circle.                            
           Color (LONGINT) = Color of the circle                            
  OUT....: /                                                                
  EXPLAIN: Draw a circle.                                                   
  CF.....: Unit GRAPH from Tp7.                                             
 ͼ}
Procedure VESA_Circle(X,Y,Rad,Color:Longint);
Begin
Circle(Vesainternal.Setvport.x1+X,Vesainternal.Setvport.y1+Y,Rad,Color);
End;

{ͻ
                        Procedure VESA_CLEARVIEWPORT                        
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Clear the screen with the color 0.                               
  OPT....: Can be optimized.                                                
  CF.....: Unit GRAPH from Tp7.                                             
 ͼ}
Procedure VESA_ClearViewPort;
Var i:longint;
begin
VesaInternal.Coord_To_x:=0;
VesaInternal.Coord_To_y:=0;
i:=VESA_Getcolor;
VESA_Setcolor(0);
Vesa_Bar(0,0,VESA_GetMaxX-1,VESA_GetMaxY-1);
VESA_Setcolor(i);
End;

{ͻ
                         Procedure VESA_SETVIEWPORT                         
 ͹
  IN.....: X1,Y1,X2,Y2 (WORD) = Coordinates for the SetViewPort.            
           Clip (BOOLEAN) = TRUE if clipping is set, else FALSE.            
  OUT....: /                                                                
  EXPLAIN: Sets the current output viewport or window for graphics output   
  BUGS...: I don't test if coordinates are in the screen.                   
  CF.....: Unit GRAPH from Tp7.                                             
 ͼ}
Procedure VESA_SetViewPort(x1, y1, x2, y2 : SmallInt; Clip : boolean);
Begin
Vesainternal.Setvport.x1:=x1;
Vesainternal.Setvport.y1:=y1;
Vesainternal.Setvport.x2:=x2;
Vesainternal.Setvport.y2:=y2;
Vesainternal.Setvport.clip:=Clip;
If Clip=False Then MaxGraphWin Else GraphWin(x1,y1,x2,y2);
Vesa_moveto(0,0);
End;

{ͻ
                       Procedure VESA_GETVIEWSETTINGS                       
 ͹
  IN.....: /                                                                
  OUT....: ViewPort (TVIEWPORTTYPE) = Get the SetViewPort parameters.       
  EXPLAIN: Get the SetViewPort parameters.                                  
 ͼ}
Procedure VESA_GetViewSettings(var ViewPort : TViewPortType);
Begin
Viewport.x1:=Vesainternal.Setvport.x1;
Viewport.y1:=Vesainternal.Setvport.y1;
Viewport.x2:=Vesainternal.Setvport.x2;
Viewport.y2:=Vesainternal.Setvport.y2;
Viewport.clip:=Vesainternal.Setvport.clip;
End;

{ͻ
                        Procedure VESA_SETFILLSTYLE                         
 ͹
  IN.....: Pattern (WORD) = Fill pattern.                                   
           Color   (WORD) = Fill color.                                     
  OUT....: /                                                                
  EXPLAIN: Sets the pattern and color for all filling done by FillPoly,     
           Bar, Bar3D, and PieSlice                                         
  CF.....: Unit GRAPH from Tp7.                                             
  BUGS...: NOT CODED                                                        
 ͼ}
Procedure VESA_SetFillStyle(Pattern : Word; Color:LongInt);
Begin
If Pattern<=12 Then VesaInternal.PatternInfo.Pattern:=Pattern
Else VesaInternal.PatternInfo.Pattern:=12;
VesaInternal.PatternInfo.Color:=Color;
End;

{ͻ
                     Procedure VESA_SETFILLSTYLENUMBER                      
 ͹
  IN.....: Pattern (WORD) = Fill pattern.                                   
           Color   (WORD) = Fill color.                                     
  OUT....: /                                                                
  EXPLAIN: Sets the pattern and color for all filling done by FillPoly,     
           Bar, Bar3D, and PieSlice                                         
  CF.....: Unit GRAPH from Tp7.                                             
  BUGS...: NOT CODED                                                        
 ͼ}
Procedure VESA_SetFillStyleNumber(Pattern : Word; Color:LongInt);
Begin
If Pattern<=12 Then VesaInternal.PatternInfo.Pattern:=Pattern
Else VesaInternal.PatternInfo.Pattern:=12;
VesaInternal.PatternInfo.Color:=Color;
End;

{ͻ
                        Procedure VESA_SETWRITEMODE                         
 ͹
  IN.....: WriteMode (SmallInt) = NormalPut    0    MOV                    
                                 CopyPut      0    MOV                    
                                 XORPut       1    XOR                    
                                 OrPut        2    OR                     
                                 AndPut       3    AND                    
                                 NotPut       4    NOT                    
  OUT....: /                                                                
  EXPLAIN: Set the WriteMode.                                               
  CF.....: Unit GRAPH from Tp7.                                             
 ͼ}
Procedure VESA_SetWriteMode(WriteMode : SmallInt);
Begin
VesaInternal.WriteMode:=WriteMode;
End;

{ͻ
                         FUNCTION VESA_GETWRITEMODE                         
 ͹
  IN.....: /                                                                
  OUT....: (SmallInt) = Current WriteMode                                    
  EXPLAIN: Get the WriteMode.                                               
  CF.....: Unit GRAPH from Tp7.                                             
 ͼ}
Function VESA_GetWriteMode:SmallInt;
Begin
VESA_GetWriteMode:=VesaInternal.WriteMode;
End;

{ͻ
                          Procedure VESA_FILLPOLY                           
 ͹
  IN.....: Num (WORD) = Number of intersection in the polygon.              
           Polypoints (UNTYPED) = Array witch contain the coordinates of    
           each intersection in the polygon.                                
  OUT....: /                                                                
  EXPLAIN: Draw a fill polygon.                                             
  BUGS...: 1) Only convex polygons.                                        
           2) No patterns for the filling ...                              
           3) Not exactly the same result that FillPoly from graph.tpu     
               but it's very near.                                          
  CF.....: Unit GRAPH from Tp7.                                             
  FROM...: Swags                                                            
 ͼ}

Procedure Vesa_FillPoly(Num:Word; Var PolyPoints);
Begin
// To avoid warnings !
   Num := Num;
   SetLength(PolygonPoints,Num);
   PolygonPoints := TPolygon(PolyPoints);
   for Num := Num-1 downto 0 do
   VESA_PutPixel(PolygonPoints[num].X,PolygonPoints[num].Y,VESA_GetColor);
End;

{ͻ
                          Procedure VESA_DRAWPOLY                           
 ͹
  IN.....: NumPoints (WORD) = Number of intersection in the polygon.        
           Polypoints (UNTYPED) = Array of intersections.                   
  OUT....: /                                                                
  EXPLAIN: Draw a polyon.                                                   
           No difference with GRAPH of Tp7.                                 
  CF.....: Unit GRAPH from Tp7.                                             
 ͼ}

Procedure VESA_DrawPoly(NumPoints: Word; var PolyPoints);
Type TarrayPoint=Array[1..1] of TPointType;
Var i:SmallInt;
    tab:^TarrayPoint;
Begin
tab:=@PolyPoints;
VESA_Line(tab^[1].x,tab^[1].y,tab^[NumPoints].x,tab^[NumPoints].y);
For i:=1 to NumPoints-1 do
 VESA_Line(tab^[i].x,tab^[i].y,tab^[i+1].x,tab^[i+1].y);
End;

{*------------------------------- Miscellaneous ----------------------------*}

{ͻ
                          Procedure VESA_FILLSHAPE                          
 ͹
  IN.....: (X,Y) (SmallInt) = Coordinates of the pixel where to begin.       
           Color (SmallInt) = New color to put.                              
  OUT....: /                                                                
  EXPLAIN: Fill a part of the screen with a new color.                      
  BUG....: This Procedure use a lot of stack.                               
           (Very much than 64Ko..). So use it very carefully.               
 ͼ}

Procedure VESA_FillShape(X,Y:SmallInt;Color:LongInt);
Var ColorOld:SmallInt;
Procedure FillShape(X,Y:SmallInt);
Begin
If (X<0) Or (X>Vesa_GetMaxX) Or (X<0) Or (X>Vesa_GetMaxX) Then Exit;
If Vesa_GetPixel(X,Y)<>ColorOld Then Exit;
Vesa_PutPixel(X,Y,Color);
FillShape(X,Y-1);
FillShape(X-1,Y);
FillShape(X+1,Y);
FillShape(X,Y+1);
End;

Begin
ColorOld:=Vesa_GetPixel(X,Y);
If ColorOld=Color Then Exit;
FillShape(X,Y);
End;

{ͻ
                         Procedure VESA_GetModeInfo                         
 ͹
  IN.....: Mode (BYTE) = MOS Mode (c.f. -mode command line parameter)       
  OUT....: X (WORD) = Screen Width                                          
           Y (WORD) = Screen Heigth                                         
           Col (LONGINT) = Number of bits for color Mode.                   
               0      = Mode is not a correct MOS Mode.                     
             ig_Col8  =  8 Bits / Pixels                                    
             ig_Col15 = 15 Bits / Pixels                                    
             ig_Col16 = 16 Bits / Pixels                                    
             ig_Col24 = 24 Bits / Pixels                                    
             ig_Col32 = 32 Bits / Pixels                                    
  EXPLAIN: Convert a MOS mode number to 3 parameter : Screen Width, Screen  
           Height & Col                                                     
  CF.....: VESA_InitGraph                                                   
 ͼ}
Procedure VESA_GetModeInfo(Mode:Byte;Var X,Y:Word;Var Col:LongInt);
Var Screen,Bits:Byte;
Begin
Screen:=Mode Mod 10;

Bits  :=Mode Div 10;

Case Bits Of
     0:Col:=0;                                 {NoCol}
     1:Col:=ig_Col8;
     2:Col:=ig_Col15;
     3:Col:=ig_Col16;
     4:Col:=ig_Col24;
     5:Col:=ig_Col32;
Else Col:=0;
End;

Case Screen Of
     0:Begin X:=320; Y:=200; End;
     1:Begin X:=640; Y:=400; End;
     2:Begin X:=640; Y:=480; End;
     3:Begin X:=800; Y:=600; End;
     4:Begin X:=1024;Y:=768; End;
     5:Begin X:=1280;Y:=1024;End;
     6:Begin X:=1600;Y:=1200;End;
Else Begin X:=0;Y:=0;End;
End;
End;

{ͻ
                          Procedure VESA_INITGRAPH                          
 ͹
  IN.....: Mode (BYTE) = Video mode (C.f. Array)                            
            Size\Bits   |      4        8      15      16      24      32   
            ------------+-------------------------------------------------  
            320*200     |      0       10      20      30      40      50   
            640*400     |      1       11      21      31      41      51   
            640*480     |      2       12      22      32      42      52   
            800*600     |      3       13      23      33      43      53   
            1024*768    |      4       14      24      34      44      54   
            1280*1024   |      5       15      25      35      45      55   
            1600*1200   |      6       16      26      36      46      56   
           Path (STRING) = Path where to found CHR font file.               
  OUT....: /                                                                
  EXPLAIN: Initilise the VESA video mode, all the variables ...             
 ͼ}

Procedure Vesa_Initgraph(Mode:Byte;Path:String);
Var X,Y:Word;Col:LongInt;
Begin
VESA_GetModeInfo(Mode,X,Y,Col);

// On initialise seulement si on est en mode texte et donc
// si GraphiX n'a pas encore t initialis !

If Not CurGraphiX.Detected Then InitGraphiX(ig_vesa,ig_lfb);

IsModeAvailable(X,Y,Col);    {BUG a tester}
SetModeGraphix(X,Y,Col);

VesaInternal.Currentcolor:=0;
VesaInternal.Coord_To_x:=0;
VesaInternal.Coord_To_y:=0;

VesaInternal.WriteMode:=0;
LOAD_CHR(Dsk_ValideDirectory(Path)+'litt.chr');

VesaInternal.Setvport.x1:=0;
VesaInternal.Setvport.y1:=0;
VesaInternal.Setvport.x2:=VESA_GetmaxX;
VesaInternal.Setvport.y2:=VESA_GetmaxY;
VesaInternal.Setvport.clip:=False;

Vesa_SetLineStyle(0,$FFFF,NormWidth);
End;

{ͻ
                         Procedure VESA_REINITGRAPH                         
 ͹
  IN.....: Mode (BYTE) = Video mode (C.f. VESA_InitGraph)                   
           Path (STRING) = Path where to found CHR font file.               
  OUT....: /                                                                
  EXPLAIN: Reinitilisation of the internal variable like VESA_Initgraph but 
           don't init video mode (So it don't clear the screen)             
  SEEALSO: VESA_Initgraph                                                   
 ͼ}
Procedure Vesa_ReInitgraph(Mode:Byte;Path:String);
Begin
Vesa_InitGraph(Mode,Path);
End;

{ͻ
                         Procedure VESA_CLOSEGRAPH                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: End the use of the Graphic mode. This Procedure make a           
           TextMode(3);                                                     
 ͼ}
Procedure VESA_CloseGraph;
Begin
 UNLOAD_CHR;
 DoneGraphiX;
 VesaInternal.Vesaon:=False;
 Textmode(3);
End;

{ͻ
                         FUNCTION VESA_TestMOSMode                          
 ͹
  IN.....: Mode (BYTE) = Mos video mode to test.                            
  OUT....: /                                                                
  EXPLAIN: Test if a video exist and can be set.                            
  SEEALSO: VESA_Initgraph                                                   
 ͼ}
Function VESA_TestMOSMode(Mode:Byte):Boolean;
Var X,Y:Word;Col:LongInt;
Begin
VESA_GetModeInfo(Mode,X,Y,Col);
VESA_TestMOSMode:= IsModeAvailable(X,Y,Col);    {BUG a tester}
End;

{ͻ
                          FUNCTION GraphiX_Version                          
 ͹
  IN.....: /                                                                
  OUT....: (STRING) = Version of GraphiX Used                               
  EXPLAIN: Return the version of GraphiX we use...                          
 ͼ}
Function GraphiX_Version:String;
Begin
GraphiX_Version:=vergraphix;
End;

{ͻ
                       Procedure VESA_SETFILLPATTERN                        
 ͹
  IN.....: Pattern (TFILLPATTERNTYPE) = Array witch contain the pattern.    
           Color (WORD) = Color of the filling                              
  OUT....: /                                                                
  EXPLAIN: Selects a user-defined fill pattern.                             
  CF.....: SetFillPattern from tp7                                          
 ͼ}
Procedure VESA_SetFillPattern(Pattern: TFillPatternType; Color: Word); {*Set User define Pattern*}
Begin
VesaInternal.PatternInfo.Pattern:=12;
VesaInternal.PatternInfo.Color:=Color;
VesaInternal.UserPattern:=Pattern;
End;

{ͻ
                           FUNCTION Test_TextMode                           
 ͹
  IN.....: /                                                                
  OUT....: (BOOLEAN) : TRUE = Actual mode is a text mode.                   
                       FALSE = Actual mode is a graphic mode.               
  EXPLAIN: Return if actual mode is a text mode or not.                     
 ͼ}

Function Test_TextMode:Boolean;
Begin
{*TO IMPLEMENT*}
Result:=false;
End;


{*------------------------------ Main Program ------------------------------*}

Begin
Chrloaded:=False;
FillChar(VesaInternal,Sizeof(VesaInternal),#0);
FillChar(C_Font      ,Sizeof(C_Font      ),#0);
End.

(*
Procedure Bar_Pattern(x1,y1,x2,y2:SmallInt;Pattern:TFillPatternType;Color:Word);

  Function Puis(X,n:SmallInt):SmallInt;
  Begin
  If n=0 Then Puis:=1 Else Puis:=Puis(X,n-1)*X;
  End;

Var i,j:SmallInt;
Begin
For j:=y1 to y2 do
  For i:=x1 to x2 do
    Begin
    If Pattern[(j And $7)+1] And Puis(2,7-(i And $7))<>0 Then VESA_Putpixel(i,j,Color)
      Else VESA_Putpixel(i,j,0);
    End;
End;

*)
