{ͻ
                              UNIT MosKeyboard                              
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: PLANAS Jean-Pierre                                           
  CREATED THE: 31.01.1998                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: Keyboard management.                                         
  AUTONOMOUS.: Partial                                                      
  UNIT SIZE..: 641 Lines and (9.616 Bytes compiled)                         
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosKeyboard;

{$MODE objfpc}

INTERFACE

Type
  TKbdLocate=Class                                {*Text cursor management*}
  private
    Procedure UPDATE_CURSORG;
  public
    X,Y                 :Integer;                 {*2D Position*}
    Flg_Time            :Boolean;                 {*Internal - Timming Toggle*} {MIC}
    Flg_Press           :Boolean;                 {*Status Curseur Aff ou pas*} {MIC}
    C_Exist             :Boolean;                 {*Cursor Exist or No*} {MIC}
    Style               :Integer;                 {*Cursor style*}
    Blink               :Integer;                 {*Speed blink*}

    T1,T2,T3,T4         :Word;                    {*Time variables*}
    N1,N2,N3,N4         :Word;

    Constructor Create;{*Define prefs for the graphic cursor*}
    Procedure InitCursor(AStyle,ABlink:Integer);
    Procedure Locate(AX,AY:Integer);{*Set a location for the graphic cursor*}
    Procedure CursorOn;   {*Display graphic cursor*}
    Procedure CursorOff;  {*Hide graphic cursor*}
  End;

{|Keys test|}
Function  Kbd_GetKeyDown(VirtualKey:integer) : boolean;

{|Miscellaneous|}
Function  Wait:Boolean;                 {*Wait something pressed (Key or Mouse)*}

{|??|}
Function  Kbd_GetHotkeyLabel(Ascii,Scan:Byte):String;{*Return the Hotkey ASCII label*}
Function  Kbd_GetHotkeyValues(Hotkey:String; Var Ascii,Scan:Byte):Boolean;{*Return the Hotkey values*}

{|Keyboard conversions and management|}
Procedure Kbd_PurgeBuffer;              {*Purge the keyboard buffer*}
Function  Kbd_GetASCIICode(V:Byte):Byte;{*Get the ASCII code of a key*}
Function  Kbd_GetScanCode(V:Byte):Byte; {*Get the Scan code of a key*}
Function  Kbd_GetVkValue(Key:Char):Integer; {*Get the VK value of a key (See Define.inc unit)*}

{*TO IMPLEMENT*}
Procedure Kbd_SetSpeedKey(Rate,Delay:Byte);{*Set SpeedKey Definition*}

IMPLEMENTATION

Uses
     Dos,
     Sysutils,
     Windows,
     MosBase,
     MosColors,
     MosConfig,
     MosCrt,
     MosFiles,
     MosGraph,
     MosMouse,
     MosDialogs,//A supprimer une fois dbuggage termin
     MosStrings;

{-------------------------------- Keys test ---------------------------------}

{ͻ
                         FUNCTION Kbd_GetKeyDown                            
 ͹
  IN.....: VirtualKey (INTEGER) = a const of the key of the WIN32 virtual   
                                  keyboard                                  
  OUT....: (BOOLEAN) = key is down ?                                        
  EXPLAIN: Return true if the key is down, and false if the key is up.      
           For more help, see GetKeyState in API windows help.              
           See also D:\MOS\PROGRAMS\FPC\SOURCE\RTL\WIN32\WININC\DEFINES.INC.
           In this file you will find all the VK_ const...                  
  EXAMPLE: Kbd_GetKeyDown(VK_A)                                             
           Kbd_GetKeyDown(VK_CONTROL)                                       
           Kbd_GetKeyDown(VK_LCONTROL)                                      
           Kbd_GetKeyDown(VK_LSHIFT)                                        
           Kbd_GetKeyDown(VK_LEFT)                                          
 ͼ}

var OldKbdTime : dword;
    OldKbdKey  : integer;

function DateTimeToTick(d:TDateTime):comp;
begin
Result:=(TimeStampToMSecs(DateTimeToTimeStamp(d)));
end;

function Kbd_GetKeyDown(VirtualKey:integer) : boolean;
begin
Result:=GetKeyState(VirtualKey) and $80=$80; // WIN32 API

// for mode con rate... (keyboard typematic)
if result and
  ((VirtualKey in [VK_ESCAPE .. VK_F24]) or
   (VirtualKey = VK_BACK   ) or
   (VirtualKey = VK_TAB    ) or
   (VirtualKey = VK_CLEAR  ) or
   (VirtualKey = VK_RETURN )
  )
  then
  begin // Il y a de l'attente  faire
//  showmessage(FloatToStr(DateTimeToTick(now)-DateTimeToTick(OldKbdTime)));

  if (VirtualKey=OldKbdKey) then while
    ((GetTickCount-OldKbdTime)<2*Sys.SpeedKeyRate)
    do; {sleep(Sys.SpeedKeyRate) else}
    (*
    begin
//    sleep(Sys.SpeedKeyDelay*125);
//    beep;
//    showmessage(FloatToStr((DateTimeToTick(now)-DateTimeToTick(OldKbdTime))));
    end;
    *)
  OldKbdKey:=VirtualKey;
  OldKbdTime:=GetTickCount;
  end;


end;

{-------------------------------- Miscellaneous -----------------------------}

{ͻ
                               FUNCTION Wait                                
 ͹
  IN.....: /                                                                
  OUT....: (BOOLEAN) = TRUE if anything is pressed (Keyboard or Mouse).     
  EXPLAIN: Return TRUE if something is pressed.                             
  EXAMPLE: Wait;                                                            
 ͼ}

Function Wait:Boolean;
Var G,D,M:Boolean;
    X,Y:Word;
    VK:Char;
    Exit_Flg:Boolean;

Begin
Kbd_PurgeBuffer;
Exit_Flg:=No; VK:=' ';
   Repeat
   Mse_Get(X,Y,G,M,D);
   If (G) Or (D) Or (M) Then Exit_Flg:=Yes;     {*Wait Mouse Pressed...*}
   If Keypressed Then Begin                     {*Wait Key Pressed...*}
      VK:=Readkey;
      Exit_Flg:=Yes;
      End;
   Until Exit_Flg;

If Ord(VK)=27 Then WAIT:=Yes Else WAIT:=No;     {*ESC Pressed ?*}
End;

{-------------------------- Text cursor management --------------------------}

constructor TKbdLocate.Create;
begin
X:=0;
Y:=0;
Flg_Time  :=false;
Flg_Press :=false;
C_Exist   :=false;
Style:=0;
Blink:=0;

T1:=0;
T2:=0;
T3:=0;
T4:=0;
N1:=0;
N2:=0;
N3:=0;
N4:=0;
end;

{ͻ
                    PROCEDURE UPDATE_CURSORG (INTERNE)                      
 ͼ}

Procedure TKbdLocate.UPDATE_CURSORG;
Var A:Integer;
Begin
VESA_SetColor(CLWinBorder);
VESA_SetWriteMode(XORPut);
Mse_Hide;
If Style=1 Then For A:=0 to HaF-1 do VESA_Line(X,Y+A,X+LaF,Y+A);
If Style=2 Then For A:=0 to 1 do VESA_Line(X,Y+A+HaF-2,X+LaF,Y+A+HaF-2);
If Style=3 Then For A:=0 to 1 do VESA_Line(X+A,Y,X+A,Y+HaF-1);
Mse_Show;
VESA_SetWriteMode(NormalPut);
End;

{ͻ
                           PROCEDURE Kbd_CursorOn                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Display graphic cursor.                                          
 ͼ}

Procedure TKbdLocate.CursorOn;        {*Affiche Curseur GFX*}
Begin
C_Exist:=True;
If Flg_Time=False Then
   Begin
   GetTime(T1,T2,T3,T4);
   Flg_Time:=True;
   UPDATE_CURSORG;                        {*Affiche ou pas le Curseur GFX*}
   If Flg_Press=False Then Flg_Press:=True
                      Else Flg_Press:=False;
   End
   Else Begin
   GetTime(N1,N2,N3,N4);
   If ((N1-T1)*360000+(N2-T2)*6000+(N3-T3)*100+N4-T4)>Blink
      Then Flg_Time:=False;           {*Affiche ou pas le Curseur GFX*}
   End;
End;

{ͻ
                          PROCEDURE Kbd_CursorOff                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Hide graphic cursor.                                             
 ͼ}

Procedure TKbdLocate.CursorOff;               {*Cache le Curseur GFX*}
Begin
If (Flg_Press=True) And (C_Exist=True) Then
   Begin UPDATE_CURSORG; C_Exist:=False;
   Flg_Press:=False; End;
End;

{ͻ
                          PROCEDURE Kbd_InitCursor                          
 ͹
  IN.....: Style (INTEGER) = Cursor style :                                 
                1 = Plain                                                   
                2 = Underline                                               
                3 = Vertical                                                
           Blink (INTEGER) = Blink speed (1/100 sec).                       
  OUT....: /                                                                
  EXPLAIN: Define prefs for the graphic cursor                              
  EXAMPLE: Kbd_InitCursor(1,20);                                            
 ͼ}

Procedure TKbdLocate.InitCursor(AStyle,ABlink:Integer);
Begin
{If (Style<1) Or (Style>3) Then Begin NError:=601; Exit; End;}
Style:=AStyle;
Blink:=ABlink;
Flg_Press:=False;
C_Exist:=True;
End;

{ͻ
                            PROCEDURE Kbd_Locate                            
 ͹
  IN.....: X,Y (INTEGER) = X,Y position of the graphic cursor.              
  OUT....: /                                                                
  EXPLAIN: Set the graphic cursor to the X,Y screen position (Pixels).      
  EXAMPLE: Kbd_Locate(50,20);                                               
 ͼ}

Procedure TKbdLocate.Locate(AX,AY:Integer);
Begin
X:=AX;
Y:=AY;
Flg_Time:=False;                      {*Pour Raffichage du Curseur*}
End;

{----------------------------------------------------------------------------}

{ͻ
                          FUNCTION Kbd_GetScanCode                          
 ͹
  IN.....: Val (BYTE) = ASCII code value.                                   
  OUT....: (BYTE) = SCAN code value.                                        
  EXPLAIN: Return the SCAN code of a key (0 if error).                      
  EXAMPLE: R:=Kbd_GetScanCode(65);                                          
 ͼ}

Function Kbd_GetScanCode(V:Byte):Byte;
Const TSA:Array[1..36,1..2] of Byte = (
   (65,16),(66,48),(67,46),(68,32),(69,18),(70,33),     { A => Z }
   (71,34),(72,35),(73,23),(74,36),(75,37),(76,38),
   (77,39),(78,49),(79,24),(80,25),(81,30),(82,19),
   (83,31),(84,20),(85,22),(86,47),(87,44),(88,45),
   (89,21),(90,17),
   (48,82),(49,79),(50,80),(51,81),(52,75),(53,76),     { 0 => 9 }
   (54,77),(55,71),(56,72),(57,73));
var a:integer;
Begin
   Kbd_GetScanCode:=0;                     {*De base...*}
   For A:=1 to 36 do If V=TSA[A,1] Then Kbd_GetScanCode:=TSA[A,2];
End;

{ͻ
                         FUNCTION Kbd_GetASCIICode                          
 ͹
  IN.....: Val (BYTE) = SCAN code value.                                    
  OUT....: (BYTE) = ASCII code value.                                       
  EXPLAIN: Return the ASCII code of a key (255 if error).                   
  EXAMPLE: R:=Kbd_GetASCIICode(37);                                         
 ͼ}

Function Kbd_GetASCIICode(V:Byte):Byte;
Var R:Byte;
Begin
R:=255;
Case V Of
   30 : R:=65;
   48 : R:=66;
   46 : R:=67;
   32 : R:=68;
   18 : R:=69;
   33 : R:=70;
   34 : R:=71;
   35 : R:=72;
   23 : R:=73;
   36 : R:=74;
   37 : R:=75;
   38 : R:=76;
   50 : R:=77;
   49 : R:=78;
   24 : R:=79;
   25 : R:=80;
   16 : R:=81;
   19 : R:=82;
   31 : R:=83;
   20 : R:=84;
   22 : R:=85;
   47 : R:=86;
   17 : R:=87;
   45 : R:=88;
   21 : R:=89;
   44 : R:=90;
   120..128 :R:=V-119;

   129 : R:=0;
   End;
Kbd_GetASCIICode:=R;                               {*Renvois Rsultat*}
End;

{----------------------------------------------------------------------------}

{ͻ
                         PROCEDURE Kbd_PurgeBuffer                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Clear the keyboard buffer.                                       
  EXAMPLE: Kbd_PurgeBuffer.                                                 
 ͼ}

Procedure Kbd_PurgeBuffer;
Begin
  While keypressed do Readkey;
End;

{ͻ
                         PROCEDURE Kbd_SetSpeedKey                          
 ͹
  IN.....: Rate, Delay (BYTE) = Speed and delay for keyboard.               
  OUT....: /                                                                
  EXPLAIN: Set the keyboard speed and delay as the DOS function             
           "MODE CON RATE=X DELAY=Y".                                       
 ͼ}

Procedure Kbd_SetSpeedKey(Rate,Delay:Byte);
Begin
If ((Delay<5) And (Rate<33)) Then             {*No Errors on Parameters*}
   Begin
   {*TO IMPLEMENT*}
   End;
End;

{ͻ
                        FUNCTION Kbd_GetHotkeyLabel                         
 ͹
  IN.....: Ascii, Scan (BYTE) = Ascii and Scan code Hotkey combination.     
  OUT....: (STRING) = Hotkey definition.                                    
  EXPLAIN: Return the Hotkey ASCII label.                                   
  EXAMPLE: Kbd_GetHotkeyLabel(3,46)      Return 'Ctrl+C'                    
  NB.....: If Hotkey label not found, the function return an empty string.  
 ͼ}

Function Kbd_GetHotkeyLabel(Ascii,Scan:Byte):String;
Var FName,NStr:String;
    Line:Integer;
Begin
Kbd_GetHotkeyLabel:='';                 {*De base*}
FName:=Sys.GetPath(SP_DATAS)+'HOTKEYS.LIS';
NStr:=Str_FillZero(Ascii,3)+';'+Str_FillZero(Scan,3);
Line:=File_TestString(FName,NStr,$0001,1);
If Line>0 Then NStr:=File_GetLine(FName,Line)
          Else Exit;                    {*Error !*}
Kbd_GetHotkeyLabel:=Str_Get(NStr,1,';');{*retrun Result*}
End;

{ͻ
                        FUNCTION Kbd_GetHotkeyValues                        
 ͹
  IN.....: Ascii, Scan (BYTE) = Ascii and Scan code Hotkey combination.     
  OUT....: (BOOLEAN) = TRUE=Ok, Hotkey found.                               
  EXPLAIN: Return the Hotkey ASCII label.                                   
  EXAMPLE: Kbd_GetHotkeyValue('Ctrl+C',As,Sc)    Return As=3 and Sc=46      
  NB.....: If Hotkey label not found, the function return an As=0, Sc=0.    
 ͼ}

Function Kbd_GetHotkeyValues(Hotkey:String; Var Ascii,Scan:Byte):Boolean;
Var FName,NStr:String;
    Line,Code:Integer;
Begin
Kbd_GetHotkeyValues:=FALSE;             {*De base*}
Ascii:=0; Scan:=0;

FName:=Sys.GetPath(SP_DATAS)+'HOTKEYS.LIS';
Line:=File_TestString(FName,Hotkey,$0001,1);
If Line>0 Then
   Begin
   NStr:=File_GetLine(FName,Line);
   Val(Str_Get(NStr,2,';'),Ascii,Code);
   Val(Str_Get(NStr,3,';'),Scan,Code);
   Kbd_GetHotkeyValues:=TRUE;           {*Ok Return TRUE*}
   End
   Else Exit;                           {*Error !*}
End;

{ͻ
                          FUNCTION Kbd_GetVkValue                           
 ͹
  IN.....: Key (CHAR) = Key to get the VK value.                            
  OUT....: Result (INTEGER) = VK value of the key.                          
  EXPLAIN: Return the VK value of the key. See the define.inc unit.         
  EXAMPLE: If Kbd_GetVkValue('L') = VK_L Then ...                           
 ͼ}

Function Kbd_GetVkValue(Key:Char):Integer;
Begin
   Key := Upcase(Key);        // Switch to upcase to test
   Case Key of
     ' ' : Result := VK_SPACE;
     '&' : Result := VK_0;
     '' : Result := VK_1;
     '"' : Result := VK_2;
     '''': Result := VK_3;
     '(' : Result := VK_4;
//     '-' : Result := VK_5; Equal to numpad '-'
     '' : Result := VK_6;
     '_' : Result := VK_7;
     '' : Result := VK_8;
     '' : Result := VK_9;
     'A' : Result := VK_A;
     'B' : Result := VK_B;
     'C' : Result := VK_C;
     'D' : Result := VK_D;
     'E' : Result := VK_E;
     'F' : Result := VK_F;
     'G' : Result := VK_G;
     'H' : Result := VK_H;
     'I' : Result := VK_I;
     'J' : Result := VK_J;
     'K' : Result := VK_K;
     'L' : Result := VK_L;
     'M' : Result := VK_M;
     'N' : Result := VK_N;
     'O' : Result := VK_O;
     'P' : Result := VK_P;
     'Q' : Result := VK_Q;
     'R' : Result := VK_R;
     'S' : Result := VK_S;
     'T' : Result := VK_T;
     'U' : Result := VK_U;
     'V' : Result := VK_V;
     'W' : Result := VK_W;
     'X' : Result := VK_X;
     'Y' : Result := VK_Y;
     'Z' : Result := VK_Z;
     '0' : Result := VK_NUMPAD0;
     '1' : Result := VK_NUMPAD1;
     '2' : Result := VK_NUMPAD2;
     '3' : Result := VK_NUMPAD3;
     '4' : Result := VK_NUMPAD4;
     '5' : Result := VK_NUMPAD5;
     '6' : Result := VK_NUMPAD6;
     '7' : Result := VK_NUMPAD7;
     '8' : Result := VK_NUMPAD8;
     '9' : Result := VK_NUMPAD9;
     '*' : Result := VK_MULTIPLY;
     '+' : Result := VK_ADD;
//     VK_SEPARATOR = 108;
     '-' : Result := VK_SUBTRACT;
     '.' : Result := VK_DECIMAL;
     '/' : Result := VK_DIVIDE;
   End;
End;

{----------------------------------------------------------------------------}

Begin
End.

(*
{ͻ
                           FUNCTION Kbd_TestChar                            
 ͹
  IN.....: Ac (BYTE) = ASCII character                                      
           Sc (BYTE) = Scan Code                                            
  OUT....: (BOOLEAN) = Wanted key pressed.                                  
  EXPLAIN: Test a key without waiting on the function.                      
           This function do not clear the key from the keyboard buffer.     
  EXAMPLE: If Kbd_TestChar(0,59) Then Begin Readkey; Readkey; End;          
  NB.....: This function usualy don't be called. For a clean code, you      
           must use the Kbd_TestKey function.                               
           To determine the key values, use this program :                  
              Writeln(ord(readkey)); // Return ASCII code                   
              Writeln(ord(readkey)); // Return Scan code                    
           F1         : 0,59                                                
           F10        : 0,68                                                
           ALT   + F1 : 0,104                                               
           CTRL  + F1 : 0,94                                                
           SHIFT + F1 : 0,84                                                
           DOWN ARROW : 0,80                                                
  SEEALSO: Kbd_GetChar, Kbd_TestKey                                         
 ͼ}
Function Kbd_TestChar(Ac,Sc:Byte):Boolean;
{ͻ
                         FUNCTION Kbd_TestExtended                          
 ͹
  IN.....: /                                                                
  OUT....: (BOOLEAN) = TRUE = Extended keyboard.                            
  EXPLAIN: Return TRUE if the keyboard is extended.                         
 ͼ}
Function Kbd_TestExtended:Boolean;
{ͻ
                            FUNCTION Kbd_GetChar                            
 ͹
  IN.....: Ac,Sc (BYTE) = ASCII Code and SCAN Code for the key.             
  OUT....: (BOOLEAN) = A key has been pressed.                              
           Return Ac,Sc (BYTE) = ASCII and Scan Code for the pressed key.   
  EXPLAIN: Test if a key is pressed, and return his code.                   
  EXAMPLE: If Kbd_GetChar(Ac,Sc) Then Write(Chr(As));                       
  SEEALSO: Kbd_TestKey, Kbd_TestChar                                        
 ͼ}
Function Kbd_GetChar(Var Ac,Sc:Byte):Boolean; {*Teste sans Bloquer le Clavier*}
{ͻ
                            FUNCTION Kbd_TestKey                            
 ͹
  IN.....: Ac,Sc (BYTE) = ASCII Code and SCAN Code for the key.             
  OUT....: (BOOLEAN) = TRUE = Key pressed.                                  
  EXPLAIN: Test a known keyboard key.                                       
           This function must be used everytime you want to test a key.     
  EXAMPLE: If Kbd_TestKey(0,72) Then Write('Key Up pressed...');            
  SEEALSO: Kbd_GetChar, Kbd_TestChar                                        
 ͼ}
Function Kbd_TestKey(Ac,Sc:Byte):Boolean; {*Teste sans Bloquer le Clavier*}
{ͻ
                        FUNCTION Kbd_TestSpecialKey                         
 ͹
  IN.....: Num (BYTE) = Id number(s) of the special key(s) to test.         
           Bit Num     Utilisation                                          
            0  $01   Right shift key pressed                                
            1  $02   Left  shift key pressed                                
            2  $04   Ctrl        key pressed                                
            3  $08   Alt         key pressed                                
            4  $10   Scroll Lock active                                     
            5  $20   Num Lock    active                                     
            6  $40   Caps Lock   active                                     
            7  $80   Insert state activated                                 
           Mode (BYTE) = Test Mode for multiple combinaison of keys         
            B_AND = 0 : If more than 1 key is specified in Num, this        
                      function return TRUE only if all the keys are pressed 
                      in the same time.                                     
            B_OR = 1 : If more than 1 key is specified in Num, this function
                     return TRUE only if one of the keys are pressed.       
  OUT....: (BOOLEAN) = TRUE = A key is pressed.                             
  EXPLAIN: Test if some special(s) key(s) are activated.                    
           If you want to test if CTRL key is pressed, use parameter $4 for 
           Num, and you have the answer.                                    
           Num is a bit mask, you can have test several                     
           combinaisons of keys at the same time (Mode=0), or if you want   
           to test one of those keys.                                       
  EXAMPLE: If Kbd_TestSpecialKey($1,B_AND) Then Write('R Shift Pressed');   
           If Kbd_TestSpecialKey($3,B_AND) Then Write('R and L Shift Pressed');
           If Kbd_TestSpecialKey($1,B_OR) Then Write('R Shift Pressed');    
           If Kbd_TestSpecialKey($3,B_OR) Then Write('R Or L Shift Pressed');
  BUG....: Alt Gr is known as the ALT Key.                                  
  OPT....: Could be coded 100% in Asm.                                      
 ͼ}
Function Kbd_TestSpecialKey(Num,Mode:Byte):Boolean;
{ͻ
                         FUNCTION Kbd_KeyPressedNow                         
 ͹
  IN.....: /                                                                
  OUT....: (BOOLEAN) = TRUE  = A key is pressed now.                        
                       FALSE = No keys are pressed now.                     
  EXPLAIN: This function allow you to know if a key is pressed at the moment
           This function don't look in the keyboard buffer to see if a      
           key has been pressed. Keyboard buffer don't be flushed.          
  NB.....: All the keys are checked include (CTRL, NUM LOCK, SHIFT...)      
 ͼ}
Function Kbd_KeyPressedNow:Boolean; { TRUE si une touche prsse   }
    *)
