{ͻ
                                UNIT MosList                                
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 21.04.1998                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: List Management with Requesters displaying.                  
  AUTONOMOUS.: Partial                                                      
  UNIT SIZE..: 3.446 Lines and (74.976 Bytes compiled)                      
  LANGUAGE...: French and English for the Headers functions.                
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosList;                           {*Lists Management Unit*}

{$Mode ObjFpc}

{
- Refaire l'affichage et le test de la liste

E Selon la taille de la Liste en Y, il y a un /0 !
E Il y a un Div/0 quand on dplace le taquet gauche de History EId pour avoir les trois points de suspenssion...
- Info box qui merdent
- Key Up et Down quand des items sont freezed et que on ne cycle pas...
- Acclration de l'affichage... Faire des Getimage, Putimage...
- Afficher le texte au milieu Y de la ligne.
- Acclration: Ne pas rafficher les grilles: => vider uniquement le contenu
  des cellules sans effacer les bords.
- Faire un List_And qui fait un And sur une colonne de 2 listes
  et qui stocke dans une 3eme liste les champs communs. Utile pour MRE
  quand on slectionne plusieurs Items n'ayant pas des champs identiques.
- Faire un Clear_Item qui vide tous les champs d'un item.
- Donner la possibilit de dplacer des items dans la liste genre Drag&Drop
}

INTERFACE

Uses
     MosConfig,
     MosGadgets,
     MosMemory,
     MosText;

Const List_MinItem=1;                   {*Lower indice in the list array*}
      Max_Col=30;                       {*Maximum Quantity Columns*}

      Insert_First=0;                   {*Insert Items type*}
      Insert_Append=1;
      Insert_SortAZ=2;
      Insert_SortZA=3;

      Text_OnLeft=0;                    {*Text Justify*}
      Text_Center=1;
      Text_OnRight=2;

      Sort_AZ=0;                        {*Sort Direction*}
      Sort_ZA=1;

Type                                    {*Type declarations*}

TListItem=Record                        {*Item Structure*}
   Item                 :String;        {*Item string*}
   Tag                  :Shortint;      {*Tag value*}
   User                 :Byte;          {*Free variable for user*}
   Color                :LongInt;       {*Pen color line*}
   BkColor              :LongInt;       {*Background color line*}
   CellColor            :Array[1..Max_Col] of Longint; {*Individual cell color*}
   Id                   :Word;          {*Bits configuration*}
       {  0  0001 :  1 = Item Freezed / 0 = Enabled}
       {  1  0002 :  1 = Draw separator line (Used by Menus)}
   IdIn                 :Word;          {*Inner Bits configuration*} {MIC}
       {  0  0001 :  1 = String too long to fit in cell} {MIC}
   End;

TListColumn=Record                      {*Column Structure*}
   Number               :Byte;          {*Column number*}
   Size                 :Integer;       {*Column width (Pixels)*}
   OldSize              :Integer;       {*Column width for Hidden column*}
   Justif               :Byte;          {*Text position Id*}
   User                 :Byte;          {*Free variable for user*}
   NbChar               :Byte;          {*Nombre d'octets du Champs pour "Command"*} {MIC}
   Color                :LongInt;       {*Column number*} {MIC}
   Id                   :Word;          {*Bits configuration*}
       {  0  0001 :  1 = Enable column modifications}
       {  1  0002 :  1 = Display Associated icons for files items}
       {  2  0004 :  1 = Use special column color}
       {  3  0008 :  1 = Column not displayed}
   End;

TList=Record                            {*List Structure*}
   Title                :String;        {*List title (define columns)*}
   Path                 :String;        {*File path for "File column"*}
   Bitmap               :String;        {*Display bitmap in background*}
   Separator            :Char;          {*Caractre de sparation*}
   X1,Y1,X2,Y2          :Integer;       {*List box coordinates*}
   BaseY                :Integer;       {*Dbut Y de la Position des Items*} {MIC}
   MaxX,MaxY            :Integer;       {*Max X et Y des Items*} {MIC}
   Color                :LongInt;       {*Background color for list*}
   Color_Line           :LongInt;       {*Alternate color for lines*}
   Sort_Sens            :Byte;          {*Sort direction for the list*}
   Sort_Column          :Byte;          {*Column number to sort the list*}
   Qtt_Items            :Longint;       {*Number of items in list*}
   Qtt_Max_Items        :Longint;       {*Maximum number of items in list*}
   Qtt_Tagged_Items     :Longint;       {*Number of tagged items*}
   Qtt_Show_Items       :Integer;       {*Number of displayable items*}
   Qtt_Columns          :Byte;          {*Number of columns*}
   Pos_Item             :Longint;       {*Last clicked item indice*}
   Pos_Column           :Byte;          {*Number of the selected column*}
   Pos_Show             :Longint;       {*First displayable item indice*}
   Pos_Taquet           :Byte;          {*Number of the selected taquet*}
   PxGadget             :Integer;       {*Position X du Taquet/Column*} {MIC}
   SurUnTaquet          :Boolean;       {*La souris est sur un Taquet*} {MIC}
   Taquet_Clicked       :Boolean;       {*Un Taquet  t Cliqu*} {MIC}
   Title_Clicked        :Boolean;       {*Un Titre  t Cliqu (Move Columns)*} {MIC}
   Title_Clicked2       :Boolean;       {*Un Titre  t Cliqu (Sort Items)*} {MIC}
   Title_Number         :Byte;          {*Numro de la Colonne Clique*} {MIC}
   Title_NewNumber      :Byte;          {*Numro de Colonne sur laquelle on Glisse (Mouse)*} {MIC}
   Item_SizeY           :Byte;          {*Height of an item (Pixels)*}
   Font                 :TFont;         {*Pointer to font structure*}
   Pointer              :TMouseZone;    {*Mouse pointer management*}
   Tag                  :Word;          {*User field*}
   ColumnLineStyle      :Byte;          {*Column vertical line style*}
   LineStyle            :Byte;          {*Line style*}
   Mouse_Clicked        :Boolean;       {*Bouton Souris Cliqu*} {MIC}
   Mouse_InList         :Boolean;       {*Mouse is clicked over the box list*}
   Mouse_OverList       :Boolean;       {*Mouse is over the box list*}
   MouseX               :Integer;       {*Coordonne X de la Souris (Taquet)*} {MIC}
   MOx,MOy              :Integer;       {*Old Mouse coordinates*}
   OldI,OldC            :Longint;       {*Old Indice,Column for the Cell on Mouse*}
   Sh_Exist             :Boolean;       {*Slider Horizontal Exist*} {MIC}
   Sh_Pos               :Integer;       {*Slider Horizontal Position X*} {MIC}
   Sh_OldPos            :Integer;       {*Slider Horizontal Old Position X*} {MIC}
   Sh_Moved             :Boolean;       {*Slider Horizontal is Moved*} {MIC}
   Sh,Sv                :TSlider;       {*Sliders pointers*}
   IB                   :THint;         {*Hint pointers*}
   ASC                  :Array[1..Max_Col] of TListColumn;{*Columns array*}

   List                 :TArray;        {*Pointer to Dynamic array*}

   Id                   :Word;          {*Bits configuration*}
       {  0  0001 :  1 = Display List title}
       {  1  0002 :  1 = Sensitive items selection. No Multiselection!}
       {  2  0004 :  1 = Columns are movable}
       {  3  0008 :  1 = Columns size modifiable}
       {  4  0010 :  1 = List Freezed / 0 = Activated}
       {  5  0020 :  1 = Multiselection Items Enable / Monoselection}
       {  6  0040 :  1 = Select item when mouse is unclicked}
       {  7  0080 :  1 = Rename Items Enable}
       {  8  0100 :  1 = Move The Whole List When Horizontal Slider is Moved}
       {  9  0200 :  1 = Select Items Enable}
       { 10  0400 :  1 = Show columns separator}
       { 11  0800 :  1 = Alternates colors for lines}
       { 12  1000 :  1 = Enable Items sorting by user}
       { 13  2000 :  1 = Show grid (Using Lightgray Color)}
       { 14  4000 :  1 = Help with an Info-Box}
       { 15  8000 :  1 = Rotation in list when select item}
   IdMore               :Word;          {*Bits configuration 2nd*}
       {  0  0001 :  1 = Don't draw list border}
       {  1  0002 :  1 = Disable F5 key}
       {  2  0004 :  1 = Display Hand pointer on selectable items}
       {  3  0008 :  1 = Disable ENTER Key}
       {  4  0010 :  1 = Don't add '...' in text if column is too short}
       {  5  0020 : * 1 = Use check symbol to tag item} {MIC}
       {  6  0040 : * 1 = Use shortkeys to select item} {MIC}
       {  7  0080 : * 1 = List Hide} {MIC}
       {  8  0100 : * 1 = Disable the list test keys}{MIC}
       {  9  0200 : * 1 = Don't use SHIFT & CTRL to polytag items => MENUS} {MIC}
   IdIn                 :Word;          {*Inner Bits configuration*} {MIC}
       {  0  0001 :  1 = Item Pre-selected. Ready to unclick mouse} {MIC}
       {  1  0002 :  1 = Use keyboard to select Item} {MIC}
       {  2  0004 :  1 = Hint currently displayed} {MIC}
   End;

{*------------------------ Fonctions et Procdures -------------------------*}

{|List file functions|}
Function  File_Sort(FName:String; Col,Sens,DataType:Byte; Sep:Char):Boolean; {*Sort a texte file using lists*}

{|List management procedures|}
Function  List_Define         (Var   L:TList; Title:String; Separator:Char;X1,Y1,X2,Y2:Integer; Qtt:Longint; Color,Color2:Longint; Id:Word):Boolean; {*Define list parameters*}
Procedure List_ReDefine       (Var   L:TList; X1,Y1,X2,Y2:Integer; Color,Color2:LongInt; Id:Word);{*Define again some parameters*}
Procedure List_Done           (Var   L:TList);{*Kill the list*}
Function  List_Test           (Var   L:TList):Longint;{*Manage the list*}
Function  List_Save           (Const L:TList; FName:String):Boolean;{*Save the list in a file*}
Function  List_Load           (Var   L:TList; FName:String):Boolean;{*Load a list from a file*}
Procedure List_Clear          (Var   L:TList);{*Clear the string list items*}
Procedure List_Sort           (Var   L:TList; Column,Sens:Byte;Id:Word); {*Sort the list*}
Function  List_Merge          (Const List1,List2:TList; Var LTarget:TList):Boolean;{*Merge two list in one*}
Function  List_Copy           (Const LSource:TList; Var LTarget:TList; Indice:Longint):Boolean;{*Copy source in a target list*}
Procedure List_Reset          (Var   L:TList);{*Delete all the list items*}

{|Columns management procedures|}
Function  List_InsertColumn   (Var   L:TList; ColNum:Byte):Boolean;{*Insert a new column*}
Function  List_SwapColumns    (Var   L:TList; Col1,Col2:Byte):Boolean;{*Swap the values of two columns*}
Procedure List_AdjustColumn   (Var   L:TList; Column:Word);{*Adjust automatically the column size*}
Procedure List_AdjustColumns  (Var   L:TList);{*Adjust automatically the columns size*}
Procedure List_HideColumn     (Var   L:TList; Column:Word; State:Boolean);{*Hide or show the column*}
Procedure List_HideColumns    (Var   L:TList; State:Boolean);{*Hide or show all the columns*}

{|Items management procedures|}
Function  List_AddItem        (Var   L:TList; Phrase:String; Position:Byte):Boolean;{*Add an item to the list*}
Function  List_DeleteItem     (Var   L:TList; Indice:Longint):Boolean;{*Delete an item from the list*}
Function  List_MoveItems      (Var   L:TList; Debut,Quantite,NewPos:Longint):Boolean;{*Move a block of the list items*}
Procedure List_TagItem        (Var   L:TList; Indice:Longint);{*Tag an item*}
Procedure List_UnTagItem      (Var   L:TList; Indice:Longint);{*Untag an item*}
Procedure List_ToggleItem     (Var   L:TList; Indice:Longint);{*Toggle value of the tag*}
Procedure List_TagAllItems    (Var   L:TList);{*Tag all the list items*}
Procedure List_UnTagAllItems  (Var   L:TList);{*Untag all the list items*}
Procedure List_ToggleAllItems (Var   L:TList);{*Toggle all the list items*}

{|Procedures to define parameters|}
Procedure List_SetId          (Var   L:TList; Id:Word);{*Set new Id for the list*}
Procedure List_SetIdMore      (Var   L:TList; IdMore:Word);{*Set new IdMore for the list*}
Procedure List_SetIdItem      (Var   L:TList; Indice:Longint; Id:Word);{*Set new Id for an item*}
Procedure List_SetIdInItem    (Var   L:TList; Indice:Longint; IdIn:Word);{*Set new IdIn for an item*} {MIC}
Procedure List_SetTagItem     (Var   L:TList; Indice:Longint; Tag:Shortint);{*Set a specific tag for an item*}
Procedure List_SetUserItem    (Var   L:TList; Indice:Longint; User:Shortint);{*Set a specific value for an Item*}
Procedure List_SetColorItem   (Var   L:TList; Indice,Color:Longint);{*Define the pen color item*}
Procedure List_SetBkColorItem (Var   L:TList; Indice,Color:Longint);{*Define the background color item*}
Procedure List_SetStringItem  (Var   L:TList; Indice:Longint; St:String);{*Define the string for an item*}
Procedure List_SetStringCell  (Var   L:TList; Indice,Col:Longint; ColSt:String);{*Define the string for a cell*}
Procedure List_SetColumnAttr  (Var   L:TList; Column,Size,Justif:Integer);{*Define column attributes*}
Procedure List_SetColumnId    (Var   L:TList; Column:Word; Id:Word);{*Set new Id for a column*}
Procedure List_SetColumnColor (Var   L:TList; Column,Color:Longint);{*Set new color for a column*}
Procedure List_SetPosition    (Var   L:TList; Indice:Longint);{*Set first item for displaying list*}
Procedure List_SetSeparator   (Var   L:TList; Separator:Char);{*Define the list items separator*}
Procedure List_SetTitle       (Var   L:TList; Title:String);{*Define the list title*}
Procedure List_SetSortInfo    (Var   L:TList; Column,Sens:Byte);{*Define the sort attributes*}
Procedure List_SetPathList    (Var   L:TList; Path:String);{*Define full path for file items*}

{|Procedures to get parameters|}
Function  List_GetStringItem  (Const L:TList; Indice:Longint):String;{*Get the string of an item*}
Function  List_GetStringCell  (Const L:TList; Indice,Col:Longint):String;{*Get the string of a cell*}
Function  List_GetColumnNum   (Const L:TList; Column:Byte):Byte;{*Get the true number of a column*}
Function  List_GetColumnId    (Const L:TList; Column:Byte):Word;{*Get the Id of a column*}
Function  List_GetSizeColumns (Const L:TList):Word;{*Get total size of columns*}
Function  List_GetColorLine   (Const L:TList; Indice:Longint):Longint;{*Return the background line color*}
Function  List_GetBkColorItem (Const L:TList; Indice:Longint):Longint;{*Get the background color of an item*}
Function  List_GetUserItem    (Const L:TList; Indice:Longint):Byte;{*Get the user item value*}
Function  List_GetIdItem      (Const L:TList; Indice:Longint):Word;{*Get the Id item value*}
Function  List_GetIdInItem    (Const L:TList; Indice:Longint):Word;{*Get the IdIn for an item*} {MIC}
Function  List_GetTaggedItem  (Const L:TList):Longint;{*Get position of the first tagged item*}
Function  List_GetQttItems    (Const L:TList):Longint;{*Get quantity of items*}
Function  List_GetQttColumns  (Const L:TList):Byte;{*Get number of columns*}
Function  List_GetQttShowItems(Const L:TList):Word;{*Get quantity of displayed items*}
Function  List_GetAZIndice    (Const L:TList; Item:TListItem; Ordre:Byte):Longint;{*Calcule position for an item*}
Function  List_GetItemIndice  (Const L:TList; Phrase:String; Column:Byte):Longint;{*Get the position of an item*}
Function  List_GetItemCoord   (Const L:TList; Indice:Longint; Var C:TCoordinates):Boolean;{*Get coordinates of an item*}
Function  List_GetCellCoord   (Const L:TList; Indice,Column:Longint; Var C:TCoordinates):Boolean;{*Get coordinates of a cell*}
Function  List_GetCellOnMouse (Const L:TList; Var Indice,Column:Longint):Boolean;{*Get the cell on mouse pointer*}
Function  List_GetTaquetCoord (Const L:TList; Taquet:Word; Var C:TCoordinates):Boolean;{*Get coordinates for a taquet*}
Function  List_GetNextFreeItem(Const L:TList; Indice:Longint; Sens:Byte):Longint;{*Search the next item not freezed*}
Function  List_GetEditColumn  (Const L:TList):Byte;{*Get the first column "Renamable"*}

{|Display functions|}
Procedure List_Show           (Var   L:TList);{*Display the list box*}
Procedure List_ShowItem       (Const L:TList; Indice:Longint);{*Display an item*}
Procedure List_ShowText       (Const L:TList; Indice:Longint);{*Display a text of an item*}
Procedure List_ShowTitle      (Const L:TList);{*Display title list*}
Procedure List_ShowGrid       (Const L:TList);{*Display grid foSys.SetGridlist*}
Procedure List_ShowColumns    (Const L:TList);{*Display vertical columns*}
Procedure List_ShowSliders    (Var   L:TList);{*Display sliders if needs*}
Procedure List_ClearLine      (Const L:TList; Indice:Longint);{*Clear a line in the list box*}
Procedure List_Refresh        (Const L:TList);{*Refresh list elements*}

{|Test functions|}
Function  List_TestTaggedItem (Const L:TList; Indice:Longint):Shortint;{*Test if an item is tagged*}
Function  List_TestIdItem     (Const L:TList; Indice:Longint; Bit:Word):Boolean;{*Test bits of an Id item*}
Function  List_TestColumnId   (Const L:TList; Column:Byte; Bit:Word):Boolean;{*Test bits of an Id column*}
Function  List_TestMouseOnCell(Const L:TList; Indice,Column:Longint):Boolean;{*Test if mouse is on cell*}
Function  List_TestMouseOnItem(Const L:TList; Indice:Longint):Boolean;{*Test if mouse is on item*}
Function  List_TestMouseOnList(Const L:TList):Byte;{*Return if mouse pointer is over the list*}
Function  List_TestKeys       (Var   L:TList):Longint;{*Manage keys to move in list*}
Procedure List_TestSizeCol    (Var   L:TList);{*Manage the size columns*}
Procedure List_TestMoveCol    (Var   L:TList);{*Manage the move columns*}
Procedure List_TestSortList   (Var   L:TList);{*Manage the list sorting*}
Procedure List_TestHint    (Var   L:TList);{*Manage the Info Box*}

Procedure List_TextShow       (Const L:TList);{*Display the list (Text mode only)*}

{*----------------------------- Dbut Library ------------------------------*}

IMPLEMENTATION

Uses
     Dos,
     Windows,
     MosBase,
     MosColors,
     MosCPUInstructions,
     MosDisks,
     MosErrors,
     MosFiles,
     MosGraph,
     MosImages,
     MosKeyboard,
     MosMouse,
     MosStrings,
     MosTools;

{ͻ
  NB.....: Toutes les fonctions de gestion de liste qui ncessitent         
           l'utilisation d'un numro de colonne, utilisent un numro        
           de colonne physique et non logique. C'est--dire, que la colonne 
           numro 1 est celle qui se trouve affiche la plus  gauche de la 
           liste, et non pas celle qui  t dclare comme premire        
           colonne lors de la cration de la liste.                         
           Cette prcision n'est utile que dans le cas o l'on gre des     
           colonnes dplaable (Dont l'indice physique est donc variable).  
           Voir la fonction "List_GetColumnNum".                            
 ͼ
 ͻ
  NB.....: All the list functions that needs a column number, use a physical
           and not a logical column number. Example :                       
           The column number 1 is the first column displayed on the left of 
           the list, and not the column declared as the first during the    
           list building.                                                   
           This information is only usefull in case of the columns are      
           declared "movable" (Which the physical number is variable).      
           See also the function "List_GetColumnNum".                       
 ͼ}

{ͻ
                            FUNCTION List_Define                            
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Title (String) = List title(s).                                  
           Separator (Char) = List column char separator.                   
           X1,Y1,X2,Y2 (Integer) = Box-List position and size definition.   
           Qtt (Longint) = Maximum quantity of Items managed by the list.   
           Color (LONGINT) = Background color for the list.                 
           Color2 (LONGINT) = Second background color for the list.         
           Id (Word) = Bits definition for the list.                        
               See also the TList structure.                                
  OUT....: (Boolean) = TRUE if Ok, else FALSE if an error occured.          
  EXPLAIN: Define parameters for the list.                                  
  SEEALSO: List_Redefine, List_SetId, TList                                 
 ͼ}

Function List_Define(Var L:TList; Title:String; Separator:Char; X1,Y1,X2,Y2:Integer;
                     Qtt:Longint; Color,Color2:LongInt;Id:Word):Boolean;
Var One_Item:TListItem;

Begin
Log.Add('Create new List',2);

Coord_BoxInScreen(X1,Y1,X2,Y2);         {*Check valid coordinates*}
If Y2-Y1<SyB*2 Then Y2:=Y1+SyB*2;
If X2-X1<LaF*10 Then X2:=X1+LaF*10;     {*Box Minimum de la Liste...*}
L.Mouse_Clicked:=FALSE;
L.Mouse_InList:=FALSE;
L.Mouse_OverList:=FALSE;
L.Taquet_Clicked:=FALSE;
L.Title_Clicked:=FALSE;
L.Title_Clicked2:=FALSE;
L.Sh_Exist:=FALSE;                      {*Pas de Slider Horizontal de Base*}
L.Sh_Moved:=FALSE;
L.Sh_Pos:=0;
L.Item_SizeY:=HaF+2;                    {*Dfinition de la Taille Y d'un Item*}
L.Path:='';                             {*Stocke Paramtres de la Liste*}
L.Bitmap:='';                           {*No images in background*}
L.Separator:=Separator;
L.X1:=X1;
L.Y1:=Y1;
L.X2:=X2;
L.Y2:=Y2;
L.Qtt_Max_Items:=Qtt;
If BTST(Id,5) Then BCLR(Id,1);          {*No Sensitive if Multiselection*}
L.Id:=Id;
L.IdMore:=$0000;
L.IdIn:=$0000;
L.Qtt_Items:=0;
L.Pos_Item:=0;
L.Pos_Column:=0;
L.Pos_Show:=1;
L.Pos_Taquet:=0;
L.Color:=Color;
L.Color_Line:=Color2;                   {*Couleur Ligne Diffrente*}
L.Sort_Sens:=Sort_AZ;
L.Sort_Column:=0;
L.Qtt_Tagged_Items:=0;
L.Font.Name:=Sys.FontCurrent;                 {*Save Used Font*}
L.Font.Size:=Sys.FontCurrentSize;
L.ColumnLineStyle:=2;                   {*Double ligne inverse*}
L.LineStyle:=1;                         {*Ligne simple*}

List_SetTitle(L,Title);                 {*Define new Title*}

If BTST(Id,0) Then L.BaseY:=Y1+SyB+2 Else L.BaseY:=Y1+1;
L.MaxX:=L.X2;                           {*De Base car pas de Sliders*}
L.MaxY:=L.Y2;
L.Qtt_Show_Items:=List_GetQttShowItems(L);{*Nombre d'Items Affichable*}

One_Item.Tag:=0;                        {*Clear Record before to fill Array*}
One_Item.Color:=0;
One_Item.Item:='';

List_Define:=Array_Init(L.List, List_MinItem, Qtt, One_Item, Sizeof(One_Item));
End;

{ͻ
                          PROCEDURE List_Redefine                           
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           X1,Y1,X2,Y2 (Integer) = Box-List position and size definition.   
           Color (LONGINT) = Background color for the list.                 
           Color2 (LONGINT) = Second background color for the list.         
           Id (Word) = Bits definition for the list.                        
  OUT....: /                                                                
  EXPLAIN: Modify the List parameters.                                      
  NB.....: You dont need to use a "List_Done" before using this function.   
  SEEALSO: List_Define                                                      
 ͼ}

Procedure List_ReDefine(Var L:TList; X1,Y1,X2,Y2:Integer; Color,Color2:LongInt;Id:Word);
Begin
L.Item_SizeY:=HaF+2;                    {*Dfinition de la Taille Y d'un Item*}
Coord_BoxInScreen(X1,Y1,X2,Y2);         {*Vrifie Validit Coordonnes...*}
L.X1:=X1;
L.Y1:=Y1;
L.X2:=X2;
L.Y2:=Y2;
L.Id:=Id;

L.Qtt_Show_Items:=List_GetQttColumns(L);{*Nombre d'Items Affichable*}
L.Color:=Color;
L.Color_Line:=Color2;                   {*Couleur Ligne Diffrente*}

If BTST(Id,0) Then L.BaseY:=Y1+SyB+2 Else L.BaseY:=Y1;
L.MaxX:=L.X2;                           {*De Base car pas de Sliders*}
L.MaxY:=L.Y2;
End;

{ͻ
                            PROCEDURE List_Done                             
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Kill the Dynamic array allocated for the List.                   
           By extention, kill the List.                                     
 ͼ}

Procedure List_Done(Var L:TList);
Begin
Log.Add('Kill List',2);
Array_Done(L.List);
BCLR(Id_Gad1,8);                        {*La souris n'est plus sur 1 taquet*}
BCLR(Id_Gad1,12);                       {*La souris n'est plus sur 1 list title*}
End;

{ͻ
                             FUNCTION List_Save                             
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           FName (String) = Path + Filename to save datas.                  
  OUT....: (Boolean) = TRUE if Ok, else FALSE if an error occured.          
  EXPLAIN: Save the datas List in a file.                                   
  SEEALSO: List_Load                                                        
 ͼ}

Function List_Save(Const L:TList; FName:String):Boolean;
Var A:Longint;                          {*Loop*}
    St:String;
    Fil1:Text;

Begin
List_Save:=FALSE;                       {*Erreur de Base*}
If Not Dsk_TestWritableDrive(Copy(FExpand(FName),1,1)) Then Exit; {*On peut crire ?*}

Assign(Fil1,FName);                     {*Assigne le Nom*}
{$I-}
Rewrite(Fil1);                          {*Crer le Fichier*}
{$I+}
If IOResult=0 Then Begin
   For A:=List_MinItem to L.Qtt_Items do{*Parcours tous les Items*}
      Begin
      St:=List_GetStringItem(L,A);
      Writeln(Fil1,St);                 {*Ecris l'Item dans le Fichier...*}
      End;
   Close(Fil1);
   List_Save:=TRUE;                     {*Cration du Ficher Ok !*}
   End;
End;

{ͻ
                             FUNCTION List_Load                             
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           FName (String) = Path + Filename to load datas.                  
  OUT....: (Boolean) = TRUE if Ok, else FALSE if an error occured.          
  EXPLAIN: Load the List in memory from a file.                             
  SEEALSO: List_Save                                                        
 ͼ}

Function List_Load(Var L:TList; FName:String):Boolean;
Var A:Longint;                          {*Counter*}
    St:String;
    Fil1:Text;

Begin
Assign(Fil1,FName);                     {*Assigne le Nom*}
{$I-}
Reset(Fil1);                            {*Ouvre le Fichier*}
{$I+}
If IOResult=0 Then Begin
   A:=List_MinItem-1;                   {*Qtt d'Items = Min de Base*}
   While Not Eof(Fil1) do
      Begin
      Inc(A);                           {*1 Items de plus*}
      Readln(Fil1,St);                  {*Lit l'Item dans le Fichier...*}
      List_AddItem(L,St,Insert_Append); {*Stocke l'Item dans le Tableau*}
      If A>L.Qtt_Max_Items Then
         Begin
         List_Load:=False;              {*Erreur: Trop d'Items*}
         Exit;
         End;
      End;
   L.Qtt_Items:=A;                      {*Stocke le Nombre d'Items*}
   Close(Fil1);
   List_Load:=True;                     {*Chargement de la Liste Ok !*}
   End
   Else List_Load:=False;               {*Erreur: Ouverture du Ficher*}
End;

{ͻ
                            FUNCTION List_Merge                             
 ͹
  IN.....: List1 (TList) = Pointer to the list structure source 1.          
           List2 (TList) = Pointer to the list structure source 2.          
           LTarget (TList) = Pointer to the destination list.               
  OUT....: (Boolean) = TRUE if Ok, else FALSE if an error occured.          
  NB.....: The destination list must be created before using this function  
           by the "List_Define".                                            
  EXPLAIN: Merge two sources Lists in one target List.                      
 ͼ}

Function List_Merge(Const List1,List2:TList; Var LTarget:TList):Boolean;
Begin
If List1.Qtt_Items + List2.Qtt_Items > LTarget.Qtt_Max_Items Then
   Begin                                {*Liste Destination Trop Petite !*}
   List_Merge:=False;
   Exit;
   End;

List_Copy(List1,LTarget,List_MinItem);      {*Copie Liste 1*}
List_Copy(List2,LTarget,List1.Qtt_Items+1); {*Copie Liste 2*}

List_Merge:=True;
End;

{ͻ
                             FUNCTION List_Copy                             
 ͹
  IN.....: LSource (TList) = Pointer to the source list structure.          
           LTarget (TList) = Pointer to the destination list structure.     
           Indice (Longint) = The Item number in the List.                  
  OUT....: (Boolean) = TRUE if Ok, else FALSE if an error occured.          
  NB.....: The destination list must be created before using this function  
           by the "List_Define".                                            
  EXPLAIN: Copy a source List on a destination List.                        
 ͼ}

Function List_Copy(Const LSource:TList; Var LTarget:TList; Indice:Longint):Boolean;
Var A:Integer;                          {*Counter*}
    One_Item:TListItem;

Begin
If (LSource.Qtt_Items>LTarget.Qtt_Max_Items-Indice+1) Or (Indice<List_MinItem) Then
   Begin                                {*Liste Destination Trop Petite !*}
   List_Copy:=False;
   Exit;
   End;

For A:=List_MinItem to LSource.Qtt_Items do
   Begin
   Array_Get(LSource.List,A,One_Item);{*Lit l'Item de la Source*}
   Array_Put(LTarget.List,Indice+A-1,One_Item);{*Copy l'Item dans la Destination*}
   End;
                                        {*Stocke Quantit d'Items*}
LTarget.Qtt_Items:=Indice+LSource.Qtt_Items-1;
List_Copy:=True;
End;

{ͻ
                            PROCEDURE List_Clear                            
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Clear all the items fields for the list in memory.               
 ͼ}

Procedure List_Clear(Var L:TList);
Var A:Integer;                          {*Loop*}
    One_Item:TListItem;

Begin
For A:=List_MinItem to L.Qtt_Max_Items do{*Parcours tout le Tableau*}
   Begin
   One_Item.Item:='';
   One_Item.Tag:=0;
   One_Item.Color:=0;
   One_Item.Id:=$0000;
   Array_Put(L.List,A,One_Item);      {*Replace un Item*}
   End;
End;

{ͻ
                          PROCEDURE List_TextShow                           
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Display the list only in Text mode.                              
 ͼ}

Procedure List_TextShow(Const L:TList);
Var A:Integer;                          {*Loop*}
    One_Item:TListItem;

Begin
Writeln(L.Title);
For A:=List_MinItem to L.Qtt_Items do   {*Parcours tout le Tableau*}
   Begin
   Array_Get(L.List,A,One_Item);      {*Replace un Item*}
   Writeln(A:4,' ',One_Item.Item);
   End;
End;

{ͻ
                            PROCEDURE List_Sort                             
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Column (Byte) = A column number.                                 
           Sens (Byte) = (Sort_AZ) 0 = Alphabetical order.                  
                         (Sort_ZA) 1 = Reverse order.                       
           Id (Word) = Data type of the column for the comparison :         
                0 = Automatic                                               
                1 = String comparison                                       
                2 = Real/Integer comparison                                 
  OUT....: /                                                                
  EXPLAIN: Sort the list in alphabetical or reverse order                   
           using a column to sort.                                          
  SEEALSO: List_SetSortInfo                                                 
 ͼ}

Procedure List_Sort(Var L:TList; Column,Sens:Byte; Id:Word);

Procedure swap(a,b:longint);            {*Swap the Pointers*}
Var Item1,Item2:TListItem;
begin
Array_Get(L.List,A,Item1);            {*Rcupre un Item*}
Array_Get(L.List,B,Item2);

Array_Put(L.List,A,Item2);
Array_Put(L.List,B,Item1);
End;

{Test if a<b}
Function Compare(a,b:TListItem):Boolean;
Var E1,E2:Extended;
    e:integer;
Begin
Case Id Of
  0,1:Compare:=Str_Get(a.Item,Column,L.separator) < Str_Get(b.Item,Column,L.separator);
  2:Begin
    Val(Str_Get(a.Item,Column,L.separator),E1,e);
    Val(Str_Get(b.Item,Column,L.separator),E2,e);
    Compare:=E1<E2;
    End;
End;
End;

Procedure QuickSort(left,right:Longint);
Var pivot,temp          : TListItem;
    lower,upper,middle  : Longint;

  Begin
    lower := left;
    upper := right;
    middle:= (left + right) div 2;
    Array_Get(L.List,middle,pivot);   {*Rcupre un Item*}
    Repeat
      Case Sens of
      Sort_AZ : Begin
                Array_Get(L.List,lower,temp);   {*Rcupre un Item*}
                While Compare(temp,pivot) do
                  Begin
                  inc(lower);
                  Array_Get(L.List,lower,temp); {*Rcupre un Item*}
                  End;
                Array_Get(L.List,upper,temp);   {*Rcupre un Item*}
                While Compare(pivot,temp) do
                  Begin
                  dec(upper);
                  Array_Get(L.List,upper,temp); {*Rcupre un Item*}
                  End;
                End;
      Sort_ZA : Begin
                Array_Get(L.List,lower,temp);   {*Rcupre un Item*}
                While Compare(pivot,temp) do
                  Begin
                  inc(lower);
                  Array_Get(L.List,lower,temp); {*Rcupre un Item*}
                  End;
                Array_Get(L.List,upper,temp);   {*Rcupre un Item*}
                While compare(temp,pivot) do
                  Begin
                  dec(upper);
                  Array_Get(L.List,upper,temp); {*Rcupre un Item*}

                  End;
                End;
      end; { Case }
      if lower <= upper then begin
        { swap the Pointers not the data }
        swap(lower,upper);
        inc(lower);
        dec(upper);
      end;
    Until lower > upper;
    if left < upper then QuickSort(left,upper);
    if lower < right then QuickSort(lower,right);
  end;  { QuickSort }


Begin
If (Column<1) { Or (Column>L.Qtt_Columns)} Then Exit; {*L.Qtt_Columns pas bien calcul*}
If L.Qtt_Items=0 Then Exit;             {*Rien  Trier...*}
L.Sort_Column:=Column;                  {*Save New Parameter*}
QuickSort(List_MinItem, L.Qtt_Items);
End;

{ͻ
                        PROCEDURE List_UnTagAllItems                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Untag all items in the list.                                     
  NB.....: Run only if the "Multiselection" bit is set.                     
  SEEALSO: List_TagAllItem, List_ToggleAllItem                              
 ͼ}

Procedure List_UnTagAllItems(Var L:TList);
Var A:Integer;
Begin
If Not BTST(L.Id,5) Then                {*Monoslection*}
   Begin
   List_UnTagItem(L,L.Pos_Item);
   Exit;
   End;
For A:=List_MinItem to L.Qtt_Items do List_UnTagItem(L,A);
End;

{ͻ
                       PROCEDURE List_ToggleAllItems                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Toggle all items in the list.                                    
  NB.....: Run only if the "Multiselection" bit is set.                     
  SEEALSO: List_UnTagAllItem, List_TagAllItem                               
 ͼ}

Procedure List_ToggleAllItems (Var L:TList);
Var A:Integer;
Begin
If Not BTST(L.Id,5) Then                {*Monoslection*}
   Begin
   List_ToggleItem(L,L.Pos_Item);
   Exit;
   End;
For A:=List_MinItem to L.Qtt_Items do
   If List_TestTaggedItem(L,A)<>0 Then List_UnTagItem(L,A)
                                  Else List_TagItem(L,A);
End;

{ͻ
                         PROCEDURE List_TagAllItems                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Tag all items in the list.                                       
  NB.....: Run only if the "Multiselection" bit is set.                     
  SEEALSO: List_UnTagAllItem, List_ToggleAllItem                            
 ͼ}

Procedure List_TagAllItems(Var L:TList);
Var A:Integer;
Begin
If Not BTST(L.Id,5) Then                {*Monoslection*}
   Begin
   List_TagItem(L,L.Pos_Item);
   Exit;
   End;
For A:=List_MinItem to L.Qtt_Items do List_TagItem(L,A);
End;

{ͻ
                           PROCEDURE List_TagItem                           
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
  OUT....: /                                                                
  EXPLAIN: Tag one item in the list.                                        
  SEEALSO: List_UnTagItem, List_ToggleItem                                  
 ͼ}

Procedure List_TagItem(Var L:TList; Indice:Longint);
Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
If List_GetQttItems(L)<=0 Then Exit;    {*Liste Vide*}
If (Indice<List_MinItem) Or (Indice>L.Qtt_Items) Then Exit;
If List_TestIdItem(L,Indice,0) Then Exit;{*Item Freezed !*}

If L.Pos_Item=0 Then L.Pos_Item:=Indice;{*Pas encore d'Items Taggus => Set_TagPos*}

Array_Get(L.List,Indice,One_Item);   {*Rcupre l'Item*}
If One_Item.Tag=0 Then Inc(L.Qtt_Tagged_Items);
One_Item.Tag:=1;
Array_Put(L.List,Indice,One_Item);   {*Replace l'Item*}
End;

{ͻ
                          PROCEDURE List_UnTagItem                          
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
  OUT....: /                                                                
  EXPLAIN: Untag an Item in the list.                                       
  SEEALSO: List_TagItem, List_ToggleItem                                    
 ͼ}

Procedure List_UnTagItem(Var L:TList; Indice:Longint);
Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
If List_GetQttItems(L)<=0 Then Exit;    {*Liste Vide*}
If (Indice<List_MinItem) Or (Indice>L.Qtt_Max_Items) Then Exit;
If List_TestIdItem(L,Indice,0) Then Exit;{*Item Freezed !*}

Array_Get(L.List,Indice,One_Item);   {*Rcupre l'Item*}
If One_Item.Tag<>0 Then Dec(L.Qtt_Tagged_Items);
One_Item.Tag:=0;
Array_Put(L.List,Indice,One_Item);   {*Replace l'Item*}
//L.Pos_Item:=0;
End;

{ͻ
                         PROCEDURE List_ToggleItem                          
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
  OUT....: /                                                                
  EXPLAIN: Toggle the tag of and Item in the list (Tag / Untag).            
  SEEALSO: List_TagItem, List_UnTagItem                                     
 ͼ}

Procedure List_ToggleItem(Var L:TList; Indice:Longint);
Begin
If (Indice<List_MinItem) Or (Indice>L.Qtt_Max_Items) Then Exit;
If List_TestTaggedItem(L,Indice)>0 Then List_UnTagItem(L,Indice)
                                   Else List_TagItem(L,Indice);
End;

{ͻ
                        PROCEDURE List_SetColorItem                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
           Color (Longint) = New color for the Item.                        
  OUT....: /                                                                
  EXPLAIN: Change the text color Item.                                      
 ͼ}

Procedure List_SetColorItem(Var L:TList; Indice,Color:Longint);
Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
If (Indice<List_MinItem) Or (Indice>L.Qtt_Max_Items) Then Exit;
Array_Get(L.List,Indice,One_Item);   {*Rcupre l'Item*}
One_Item.Color:=Color;
Array_Put(L.List,Indice,One_Item);   {*Replace l'Item*}
End;

{ͻ
                       PROCEDURE List_SetBkColorItem                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
           Color (Longint) = New background color for the Item.             
  OUT....: /                                                                
  EXPLAIN: Change the background color for an item (a line).                
 ͼ}

Procedure List_SetBkColorItem(Var L:TList; Indice,Color:Longint);
Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
If (Indice<List_MinItem) Or (Indice>L.Qtt_Items) Then Exit;
Array_Get(L.List,Indice,One_Item);   {*Rcupre l'Item*}
One_Item.BkColor:=Color;
Array_Put(L.List,Indice,One_Item);   {*Replace l'Item*}
End;

{ͻ
                            PROCEDURE List_SetId                            
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Id (Word) = New Id to set for the List structure.                
  OUT....: /                                                                
  EXPLAIN: Change the field "Id" of the List.                               
  NB.....: I never done a function so trivial.                              
  SEEALSO: List_Define                                                      
 ͼ}

Procedure List_SetId(Var L:TList; Id:Word);
Begin
L.Id:=Id;                               {*Super le Code !*}
End;

{ͻ
                          PROCEDURE List_SetIdMore                          
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           IdMore (Word) = New Id to set for the List structure.            
  OUT....: /                                                                
  EXPLAIN: Change the field "IdMore" of the List.                           
  NB.....: I never done a function so trivial.                              
  SEEALSO: List_Define, List_SetId                                          
 ͼ}

Procedure List_SetIdMore(Var L:TList; IdMore:Word);
Begin
L.IdMore:=IdMore;                       {*Super le Code !*}
End;

{ͻ
                          PROCEDURE List_SetIdItem                          
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
           Id (Word) = New Id to set for the Item.                          
  OUT....: /                                                                
  EXPLAIN: Change the field "Id" of an Item.                                
 ͼ}

Procedure List_SetIdItem(Var L:TList; Indice:Longint; Id:Word);
Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
If (Indice<List_MinItem) Or (Indice>L.Qtt_Max_Items) Then Exit;
Array_Get(L.List,Indice,One_Item);   {*Rcupre l'Item*}
One_Item.Id:=Id;

Array_Put(L.List,Indice,One_Item);   {*Replace l'Item*}
End;

{ͻ
                         PROCEDURE List_SetIdInItem                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
           IdIn (Word) = New IdIn to set for the Item.                      
  OUT....: /                                                                
  EXPLAIN: Change the field "IdIn" of an Item.                              
  NB.....: This procedure is an inner procedure.                            
 ͼ}

Procedure List_SetIdInItem(Var L:TList; Indice:Longint; IdIn:Word);
Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
If (Indice<List_MinItem) Or (Indice>L.Qtt_Max_Items) Then Exit;
Array_Get(L.List,Indice,One_Item);   {*Rcupre l'Item*}
One_Item.IdIn:=IdIn;
Array_Put(L.List,Indice,One_Item);   {*Replace l'Item*}
End;

{ͻ
                        PROCEDURE List_SetStringItem                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
           St (String) = New string for the item.                           
  OUT....: /                                                                
  EXPLAIN: Change the string of an Item (The field "Item").                 
 ͼ}

Procedure List_SetStringItem(Var L:TList; Indice:Longint; St:String);
Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
If (Indice<List_MinItem) Or (Indice>L.Qtt_Max_Items) Then Exit;
Array_Get(L.List,Indice,One_Item);   {*Rcupre l'Item*}
One_Item.Item:=St;
Array_Put(L.List,Indice,One_Item);   {*Replace l'Item*}
End;

{ͻ
                         PROCEDURE List_SetTagItem                          
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
           Tag (Shortint) = Value to tag in the Item.                       
  OUT....: /                                                                
  EXPLAIN: Tag an Item using a special value.                               
 ͼ}

Procedure List_SetTagItem(Var L:TList; Indice:Longint; Tag:Shortint);
Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
If (Indice<List_MinItem) Or (Indice>L.Qtt_Max_Items) Then Exit;
If Tag<>0 Then Inc(L.Qtt_Tagged_Items);
Array_Get(L.List,Indice,One_Item);   {*Rcupre l'Item*}
One_Item.Tag:=Tag;
Array_Put(L.List,Indice,One_Item);   {*Replace l'Item*}
End;

{ͻ
                         PROCEDURE List_SetUserItem                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
           User (Byte) = Value to set in the "User" field in an Item.       
  OUT....: /                                                                
  EXPLAIN: Set a new value in the field "User" of an Item.                  
 ͼ}

Procedure List_SetUserItem(Var L:TList; Indice:Longint; User:Shortint);
Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
If (Indice<List_MinItem) Or (Indice>L.Qtt_Max_Items) Then Exit;
Array_Get(L.List,Indice,One_Item);   {*Rcupre l'Item*}
One_Item.User:=User;
Array_Put(L.List,Indice,One_Item);   {*Replace l'Item*}
End;

{ͻ
                       FUNCTION List_GetNextFreeItem                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (LONGINT) = Current item position.                        
           Sens (BYTE) = Direction to Search.                               
               Sort_AZ = 0 (Alphabetical regular).                          
               Sort_ZA = 1 (Alphabetical inverse).                          
  OUT....: (LONGINT) = Indice of free item.                                 
               Return 0 if no free item is found.                           
  EXPLAIN: Search and return the next free item (Not freezed) begining at   
           the position Indice (Indice is tested).                          
 ͼ}

Function List_GetNextFreeItem(Const L:TList; Indice:Longint; Sens:Byte):Longint;
Var A:Longint;
Begin
List_GetNextFreeItem:=0;                {*De base...*}
If (Indice<List_MinItem) Or (Indice>L.Qtt_Max_Items) Then Exit;
If Sens=Sort_AZ Then Begin              {*De A  Z*}
   For A:=Indice to L.Qtt_Max_Items do If Not BTST(List_GetIdItem(L,A),0) Then
      Begin List_GetNextFreeItem:=A; Exit; End;
   If BTST(L.Id,15) Then
      For A:=List_MinItem to Indice do    If Not BTST(List_GetIdItem(L,A),0) Then
         Begin List_GetNextFreeItem:=A; Exit; End;
   End;
If Sens=Sort_ZA Then Begin              {*De Z  A*}
   For A:=Indice Downto List_MinItem do    If Not BTST(List_GetIdItem(L,A),0) Then
      Begin List_GetNextFreeItem:=A; Exit; End;
   If BTST(L.Id,15) Then
      For A:=L.Qtt_Max_Items Downto Indice do If Not BTST(List_GetIdItem(L,A),0) Then
         Begin List_GetNextFreeItem:=A; Exit; End;
   End;
End;

{ͻ
                        FUNCTION List_GetEditColumn                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: (BYTE) = Column number.                                          
           If there isn't editable columns, the function return 0.          
  EXPLAIN: Get the first column "Renamable".                                
 ͼ}

Function List_GetEditColumn(Const L:TList):Byte;
Var A:Integer;
Begin
For A:=1 to L.Qtt_Columns do
   If BTST(L.ASC[A].Id,0) Then Begin
      List_GetEditColumn:=A;            {*Return Column Number*}
      Exit;
      End;

List_GetEditColumn:=0;                  {*No Editable Columns*}
End;

{ͻ
                        FUNCTION List_GetStringItem                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
  OUT....: (String) = Get the string of an Item.                            
  EXPLAIN: Get the full string of an Item.                                  
 ͼ}

Function List_GetStringItem(Const L:TList; Indice:Longint):String;

Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
List_GetStringItem:='';                 {*De Base en cas d'Erreur !*}
If (Indice<List_MinItem) Or (Indice>L.Qtt_Max_Items) Then Exit;
Array_Get(L.List,Indice,One_Item);   {*Rcupre l'Item*}
List_GetStringItem:=One_Item.Item;
End;

{ͻ
                         FUNCTION List_GetColumnNum                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Column (Word) = Column number.                                   
  OUT....: (Byte) = Get the real number of a column (>1).                   
           If an error occured, then return 0.                              
  EXPLAIN: Get the logical number of a column (The number is set at         
           the initialisation) using the physical number                    
           (The position number of the column).                             
  NB.....: This function is usefull only if the columns are "Movable".      
 ͼ}

Function List_GetColumnNum(Const L:TList; Column:Byte):Byte;
Var A:Integer;
Begin
List_GetColumnNum:=0;                   {*De Base...*}

For A:=1 to L.Qtt_Columns do            {*Parcours toutes les Colonnes*}
   If L.ASC[A].Number=Column Then
      Begin
      List_GetColumnNum:=A;             {*Renvois le Numro Logique*}
      Exit;
      End;
End;

{ͻ
                        FUNCTION List_GetSizeColumns                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: (Word) = Total size of columns.                                  
  EXPLAIN: Get the total size of the list columns.                          
 ͼ}

Function List_GetSizeColumns(Const L:TList):Word;

Var A,Size:Integer;
Begin
Size:=0;                                {*Parcours toutes les Colonnes*}
For A:=1 to L.Qtt_Columns do Inc(Size,L.ASC[A].Size);
List_GetSizeColumns:=Size;              {*Send Result...*}
End;

{ͻ
                        FUNCTION List_GetStringCell                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    

           Indice (Longint) = Item number (Position in list).               
           Column (Longint) = Column number.                                
  OUT....: (String) = Get a string.                                         
  EXPLAIN: Get the string of an Item for a special column.                  
  SEEALSO: List_SetStringCell                                               
 ͼ}

Function List_GetStringCell(Const L:TList; Indice,Col:Longint):String;
Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
List_GetStringCell:='';                 {*De Base en cas d'Erreur !*}
If (Indice<List_MinItem) Or (Indice>L.Qtt_Max_Items) Then Exit;
If (Col<1) Or (Col>L.Qtt_Columns) Then Exit;

Array_Get(L.List,Indice,One_Item);   {*Rcupre l'Item*}

List_GetStringCell:=Str_Get(One_Item.Item,Col,L.Separator); {*Renvois le Rsultat...*}
End;

{ͻ
                        PROCEDURE List_SetStringCell                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
           Column (Longint) = Column number.                                
           ColSt (String) = New string to set.                              
  OUT....: /                                                                
  EXPLAIN: Set a new string for and Item in a special column (Cell).        
  SEEALSO: List_GetStringCell                                               
 ͼ}

Procedure List_SetStringCell(Var L:TList; Indice,Col:Longint; ColSt:String);
Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}
    AColumns:String;

Begin
If (Indice<List_MinItem) Or (Indice>L.Qtt_Max_Items) Then Exit;
If (Col<1) Or (Col>L.Qtt_Columns) Then Exit;

Array_Get(L.List,Indice,One_Item);   {*Rcupre l'Item*}

{SR}{Str_Split(One_Item.Item, L.Separator, AColumns);}
AColumns:=One_Item.Item;
{SR}{AColumns[Col]:=ColSt;}                   {*Remplace la Chaine...*}
AColumns:=Str_Put(AColumns,ColSt,Col,L.separator);
{SR}{Str_Build(AColumns, L.Separator, One_Item.Item);}
One_Item.Item:=Acolumns;
Array_Put(L.List,Indice,One_Item);    {*Stocke l'Item*}
End;

{ͻ
                        FUNCTION List_TestTaggedItem                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
  OUT....: (Shortint) = Get the Tag value (-128  +127).                    
  NB.....: If an error occured, the returned value is -128.                 
  EXPLAIN: Get the Tag value of an Item in the list.                        
 ͼ}


Function List_TestTaggedItem(Const L:TList; Indice:Longint):Shortint;
Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
List_TestTaggedItem:=-128;              {*En cas d'erreur !*}
If (Indice<List_MinItem) Or (Indice>L.Qtt_Max_Items) Then Exit;
Array_Get(L.List,Indice,One_Item);   {*Rcupre l'Item*}
List_TestTaggedItem:=One_Item.Tag;      {*Renvois Rsultat*}
End;

{ͻ
                         FUNCTION List_GetUserItem                          
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
  OUT....: (Byte) = Get the value of the "User" field (0  255).            
  NB.....: If an error occured, the returned value is 0.                    
  EXPLAIN: Get the value of the "User" field of and Item in the list.       
 ͼ}

Function List_GetUserItem(Const L:TList; Indice:Longint):Byte;
Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin

List_GetUserItem:=0;                    {*En cas d'erreur !*}
If (Indice<List_MinItem) Or (Indice>L.Qtt_Max_Items) Then Exit;
Array_Get(L.List,Indice,One_Item);    {*Rcupre l'Item*}
List_GetUserItem:=One_Item.User;        {*Renvois Rsultat*}
End;

{ͻ
                        FUNCTION List_GetBkColorItem                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
  OUT....: (LONGINT) = Get the value of the "BkColor" field.                
  NB.....: If an error occured, the returned value is -1.                   
  EXPLAIN: Return the background color of an item.                          
 ͼ}

Function List_GetBkColorItem(Const L:TList; Indice:Longint):LongInt;
Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
List_GetBkColorItem:=-1;                {*En cas d'erreur !*}
If (Indice<List_MinItem) Or (Indice>L.Qtt_Items) Then Exit;


Array_Get(L.List,Indice,One_Item);   {*Rcupre l'Item*}
List_GetBkColorItem:=One_Item.BkColor;  {*Renvois Rsultat*}
End;

{ͻ
                         FUNCTION List_GetIdInItem                          
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
  OUT....: (Word) = Get the value of the "IdIn" field.                      
  NB.....: If an error occured, the returned value is 0.                    
  EXPLAIN: Get the value of the "IdIn" field of and Item in the list.       
  SEEALSO: List_TestIdInItem                                                
 ͼ}

Function List_GetIdInItem(Const L:TList; Indice:Longint):Word;
Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
List_GetIdInItem:=0;                    {*En cas d'erreur !*}
If (Indice<List_MinItem) Or (Indice>L.Qtt_Max_Items) Then Exit;

Array_Get(L.List,Indice,One_Item);   {*Rcupre l'Item*}

List_GetIdInItem:=One_Item.IdIn;        {*Renvois Rsultat*}
End;

{ͻ
                          FUNCTION List_GetIdItem                           
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
  OUT....: (Word) = Get the value of the "Id" field.                        
  NB.....: If an error occured, the returned value is 0.                    
  EXPLAIN: Get the value of the "Id" field of and Item in the list.         
  SEEALSO: List_TestIdItem                                                  
 ͼ}

Function List_GetIdItem(Const L:TList; Indice:Longint):Word;
Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
List_GetIdItem:=0;                      {*En cas d'erreur !*}
If (Indice<List_MinItem) Or (Indice>L.Qtt_Max_Items) Then Exit;

Array_Get(L.List,Indice,One_Item);    {*Rcupre l'Item*}
List_GetIdItem:=One_Item.Id;            {*Renvois Rsultat*}
End;

{ͻ
                          FUNCTION List_TestIdItem                          
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
           Bit (Word) = Bit to test with the "Id" field.                    
  OUT....: (Word) = Get the value of the "Id" field.                        
  NB.....: If an error occured, the returned value is FALSE.                
  EXPLAIN: Test a Bit from the "Id" field of and Item in the list.          
  SEEALSO: List_GetIdItem                                                   
 ͼ}

Function List_TestIdItem(Const L:TList; Indice:Longint; Bit:Word):Boolean;
Begin
List_TestIdItem:=BTST(List_GetIdItem(L,Indice),Bit);
End;

{ͻ
                         FUNCTION List_TestColumnId                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Column (Byte) = Column number.                                   
           Bit (Word) = Bit to test with the "Id" field.                    
  OUT....: (Word) = Get the value of the "Id" field.                        
  NB.....: If an error occured, the returned value is FALSE.                
  EXPLAIN: Test a Bit from the "Id" field of and Item in the list.          
 ͼ}

Function List_TestColumnId(Const L:TList; Column:Byte; Bit:Word):Boolean;
Begin
List_TestColumnId:=BTST(List_GetColumnId(L,Column),Bit);
End;

{ͻ
                        FUNCTION List_GetTaggedItem                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    

  OUT....: (Longint) = Get the tagged Item position.                        
  EXPLAIN: Get the first tagged Item position.                              
  NB.....: Available only if one and only one Item has been tagged.         
           Return 0 if found none tagged item.                              
 ͼ}

Function List_GetTaggedItem(Const L:TList):Longint;
Var A:Integer;
Begin
List_GetTaggedItem:=0;
If L.Qtt_Tagged_Items>1 Then Exit;      {*Trops d'Items Taggus !*}

For A:=List_MinItem to L.Qtt_Items do   {*Parcours tous les Items...*}
   If List_TestTaggedItem(L,A)>0 Then
      Begin
      List_GetTaggedItem:=A;            {*A trouv l'Item Taggu*}
      Exit;
      End;
End;


{ͻ
                         PROCEDURE List_SetPosition                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
  OUT....: /                                                                
  NB.....: Correct position if out of list.                                 
  EXPLAIN: Set a new position for the Item list display position pointer.   
 ͼ}

Procedure List_SetPosition(Var L:TList; Indice:Longint);
Begin
If Indice<List_MinItem Then Indice:=List_MinItem;
If L.Qtt_Items<L.Qtt_Show_Items         {*Listbox non remplie*}
   Then Indice:=1
   Else If Indice>L.Qtt_Items-L.Qtt_Show_Items Then Indice:=L.Qtt_Items-L.Qtt_Show_Items+1;
If L.Qtt_Items=0 Then Indice:=1;

L.Pos_Show:=Indice;                     {*Dfinit Nouvelle Position*}
End;

{ͻ
                        PROCEDURE List_SetSeparator                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Separator (Char) = New separator for the list.                   
  OUT....: /                                                                
  EXPLAIN: Define a new separator for the strings's list.                   
  SEEALSO: List_Define                                                      

 ͼ}

Procedure List_SetSeparator(Var L:TList; Separator:Char);
Begin
L.Separator:=Separator;                 {*Dfinit un Nouveau Sparateur*}
End;

{ͻ
                          PROCEDURE List_SetTitle                           
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Title (String) = New title for the list.                         
  OUT....: /                                                                
  EXPLAIN: Define a new title for the list.                                 
  SEEALSO: List_Define, List_SetSeparator                                   
 ͼ}

Procedure List_SetTitle(Var L:TList; Title:String);
Var AColumns:String;
    A:Integer;

Begin


L.Title:=Title;                         {*Dfinit un Nouveau Titre*}

L.Qtt_Columns:=List_GetQttColumns(L);   {*Obtient le nombre de Colonnes*}

If L.Qtt_Columns>MAX_COL Then           {*Trop de colonnes*}

   Begin

   Error(573);
   Exit;
   End;


AColumns:=Title;
For A:=1 to L.Qtt_Columns do            {*Informations sur les Colonnes*}
   Begin
   L.ASC[A].Number:=A;                  {*Numro de la Colonne*}
   L.ASC[A].Size:=VESA_TextWidth(Str_Get(AColumns,A,L.Separator))+25;
   L.ASC[A].OldSize:=L.ASC[A].Size;     {*Size de Rcupration pour Hide colonne*}
   L.ASC[A].Justif:=Text_OnLeft;        {*Justifi  Gauche*}
   L.ASC[A].Id:=$0000;                  {*De base, pas d'dition de la Colonne*}
   L.ASC[A].User:=0;                    {*De Base, Nettoy  0*}
   End;
End;

{ͻ
                         PROCEDURE List_SetSortInfo                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Column (Byte) = Column number.                                   
         : Sens (Byte) = Direction to sort datas:                           
                          (Sort_AZ) 0 = Alphabetical order.                 
                          (Sort_ZA) 1 = Reverse order.                      
  OUT....: /                                                                
  EXPLAIN: Define a new separator for the strings's list.                   
  NB.....: This procedure only define the sort parameters,                  
           and don't sort the list.                                         

           To do this, use the function "List_Sort".                        
  SEEALSO: List_Sort                                                        
 ͼ}

Procedure List_SetSortInfo(Var L:TList; Column,Sens:Byte);
Begin
If (Column<1) Or (Column>L.Qtt_Columns) Then Exit;
If (Sens<>Sort_AZ) And (Sens<>Sort_ZA) Then Exit;

L.Sort_Column:=Column;                  {*Save New Parameters*}
L.Sort_Sens:=Sens;
End;

{ͻ
                         PROCEDURE List_SetPathList                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Path (String) = Files path.                                      
  OUT....: /                                                                
  EXPLAIN: Define a new file path to use with the columns Bit 1.            
           A column must be declared as a "Files column" to use this feature
  NB.....: If this field is not correctly filled,                           
           the files functions will not run properly.                       
 ͼ}

Procedure List_SetPathList(Var L:TList; Path:String);
Begin
L.Path:=Path;
End;

{ͻ
                            PROCEDURE List_Reset                            
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Delete all the list items.                                       
  SEEALSO: List_DeleteItem                                                  
 ͼ}

Procedure List_Reset(Var L:TList);
Begin
L.Qtt_Items:=0;                         {*Plus d'items*}
End;

{ͻ
                           FUNCTION List_AddItem                            
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Phrase (String) = Item string.                                   
           Position (Byte) = Addition type for the Item.                    
             (Insert_First)  0 = Insert item at the first place.            
             (Insert_Append) 1 = Insert item at the end of the list.        
             (Insert_SortAZ) 2 = Insert by alphabetical order.              
             (Insert_SortZA) 3 = Insert by reverse order.                   
  OUT....: (Boolean) = TRUE if Ok, else FALSE if an error occured.          
  EXPLAIN: Add an Item to the list.                                         
  NB.....: Default: Others fields of the item are set to 0.                 
  SEEALSO: List_DeleteItem                                                  
 ͼ}

Function List_AddItem(Var L:TList; Phrase:String; Position:Byte):Boolean;
Var A:Integer;                          {*Loop*}
    One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
If (Position<0) Or (Position>3) Then    {*Paramtre Position Incorrect !*}
   Begin
   List_AddItem:=False;
   Exit;
   End;

If L.Qtt_Items>=L.Qtt_Max_Items Then    {*Trop d'Items dans le Tableau !*}
   Begin
   List_AddItem:=False;
   Exit;
   End;
                                        {*Build Item Structure...*}
One_Item.Item:=Phrase; One_Item.Tag:=0;
One_Item.Color:=0; One_Item.BkColor:=-1; One_Item.Id:=$0000;
For A:=List_MinItem to Max_Col do One_Item.CellColor[A]:=-1; {*No cell color*}

Case Position of                        {*En fonction du type d'Insertion*}
   0: Begin                             {*Ajoute l'Item en Dbut de Liste*}
      List_MoveItems(L, List_MinItem, L.Qtt_Items,List_MinItem+1);
      Inc(L.Qtt_Items);
      Array_Put(L.List,List_MinItem,One_Item);
      End;

   1: Begin                             {*Ajoute l'Item en Fin de Liste*}
      Inc(L.Qtt_Items);
      Array_Put(L.List,L.Qtt_Items,One_Item);
      End;

   2..3: Begin                          {*Classement Alphabtique*}
      If Position=2 Then A:=List_GetAZIndice(L,One_Item,Sort_AZ) {*Croissant*}
                    Else A:=List_GetAZIndice(L,One_Item,Sort_ZA);{*Dcroissant*}
      If A>=List_MinItem Then List_MoveItems(L, A, L.Qtt_Items-A+1, A+1);
      Inc(L.Qtt_Items);
      Array_Put(L.List,A,One_Item);
      End;
   End;

List_AddItem:=True;                     {*Pas d'Erreur...*}
End;

{ͻ
                          FUNCTION List_DeleteItem                          
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
  OUT....: (Boolean) = TRUE if Ok, else FALSE if an error occured.          
  EXPLAIN: Delete an Item from the list.                                    
  SEEALSO: List_AddItem                                                     
 ͼ}

Function List_DeleteItem(Var L:TList; Indice:Longint):Boolean;
Var One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
If (Indice<List_MinItem) Or (Indice>L.Qtt_Items) Then
   Begin                                {*Indice Incorrect !*}
   List_DeleteItem:=False;
   Exit;
   End;
                                        {*Decrmente le nombre d'Items taggus if Needs*}
If List_TestTaggedItem(L,Indice)<>0 Then Dec(L.Qtt_Tagged_Items);
List_MoveItems(L, Indice+1, L.Qtt_Items-Indice, Indice);

One_Item.Item:='';                      {*Clear Buffer Item*}
One_Item.Tag:=0;
Array_Put(L.List,L.Qtt_Items,One_Item); {*Set Last Item to cleared Item*}

Dec(L.Qtt_Items);                       {*1 Item de Moins*}

List_DeleteItem:=True;                  {*Pas d'Erreur...*}
End;

{ͻ
                         FUNCTION List_GetQttItems                          
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: (LONGINT) = Number of items.                                     
  EXPLAIN: Get quantity of defined items in list.                           
 ͼ}

Function List_GetQttItems(Const L:TList):Longint;
Begin
List_GetQttItems:=L.Qtt_Items;
End;

{ͻ
                        FUNCTION List_GetQttColumns                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: (Byte) = Number of columns.                                      
  EXPLAIN: Get the number of columns defined in the list.                   
 ͼ}

Function List_GetQttColumns(Const L:TList):Byte;
{SR}{Var AColumns:String;}
Begin                                   {*Lit le Premier Item...*}
{SR}{List_GetQttColumns:=Str_Split(L.Title, L.Separator, AColumns);}
List_GetQttColumns:=Str_Count(L.Title, L.Separator);
End;

{ͻ

                       FUNCTION List_GetQttShowItems                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: (Word) = Number of Items displayable.                            
  EXPLAIN: Get the number of displayable Items in the List-Box.             
 ͼ}

Function List_GetQttShowItems(Const L:TList):Word;
Begin
List_GetQttShowItems:=((L.MaxY-L.BaseY) Div (L.Item_SizeY));
End;

{ͻ
                       PROCEDURE List_SetColumnColor                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Column (LONGINT) = Column number.                                
           Color (LONGINT) = New color for the column.                      
  OUT....: /                                                                
  EXPLAIN: Set a new color for a column.                                    

 ͼ}

Procedure List_SetColumnColor(Var L:TList; Column,Color:LongInt);
Begin
If (Column<1) Or (Column>L.Qtt_Columns) Then Exit;
L.ASC[Column].Color:=Color;             {*New color for Colonne*}
BSET(L.ASC[Column].Id,2);               {*Define special color*}
End;

{ͻ
                         PROCEDURE List_SetColumnId                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Column (Word) = Column number.                                   
           Id (Word) = New "Id" for the column.                             
  OUT....: /                                                                
  EXPLAIN: Set a new "Id" for a column.                                     
  SEEALSO: List_AdjustColumn, List_GetColumnId, SetColumnAttr               
 ͼ}

Procedure List_SetColumnId(Var L:TList; Column,Id:Word);
Begin
If (Column<1) Or (Column>L.Qtt_Columns) Then Exit;

L.ASC[Column].Id:=Id;                   {*Nouveaux Id de la Colonne...*}
End;

{ͻ
                         FUNCTION List_GetColumnId                          
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Column (Byte) = Column number.                                   
  OUT....: (Word) = "Id" of the column.                                     
  EXPLAIN: Get the "Id" of a column.                                        
  SEEALSO: List_AdjustColumn, List_SetColumnId, SetColumnAttr               
 ͼ}

Function List_GetColumnId(Const L:TList; Column:Byte):Word;
Begin
List_GetColumnId:=0;
If (Column<1) Or (Column>L.Qtt_Columns) Then Exit;

List_GetColumnId:= L.ASC[Column].Id;    {*Return Id de la Colonne...*}
End;

{ͻ
                        PROCEDURE List_SetColumnAttr                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Column (Integer) = Column number.                                
           Size (Integer) = Size of the column (in pixels).                 
              If Size=-1 the size of the column is not modified.            
           Justif (Integer) = Justification type for the column.            
                     (Text_OnLeft) 0 = Left justify                         
                     (Text_Center) 1 = Center text                          
                    (Text_OnRight) 2 = Right justify                        
  OUT....: /                                                                
  EXPLAIN: Define the fields "Size" and "Justif" for a column.              
  SEEALSO: List_AdjustColumn, List_SetColumnId, List_GetColumnId            
 ͼ}

Procedure List_SetColumnAttr(Var L:TList; Column,Size,Justif:Integer);

Begin
If (Column<1) Or (Column>L.Qtt_Columns) Then Exit;
If Size>=0 Then Begin                   {*Dfinit la Taille...*}
   L.ASC[Column].Size:=Size;
   L.ASC[Column].OldSize:=Size;
   End;
L.ASC[Column].Justif:=Justif;           {*Dfinit la Justification...*}
End;

{ͻ
                        PROCEDURE List_AdjustColumn                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Column (WORD) = Column number.                                   
  OUT....: /                                                                
  EXPLAIN: Adjust automatically the column size.                            
  SEEALSO: List_AdjustColumns, List_SetColumnId, List_GetColumnId           
 ͼ}


Procedure List_AdjustColumn(Var L:TList; Column:Word);
Var A:Longint;                          {*Loop*}
    Size,VTemp:Integer;
Begin
If List_GetQttItems(L)<=0 Then Exit;    {*Liste Vide !*}
If BTST(L.ASC[Column].Id,3) Then Exit;  {*Column hidden !*}

Size:=VESA_TextWidth(List_GetStringCell(L,1,Column));
For A:=List_MinItem+1 to List_GetQttItems(L) do
   Begin                                {*Parcours toute la liste*}
   VTemp:=VESA_TextWidth(List_GetStringCell(L,A,Column));
   If VTemp>Size Then Size:=VTemp;      {*Taille plus grande*}
   End;

Inc(Size,15);                           {*Marge*}
If BTST(List_GetColumnId(L,Column),1) Then Inc(Size,18);{*File Icon*}
L.ASC[Column].Size:=Size;               {*Define new column size*}

End;


{ͻ
                        PROCEDURE List_AdjustColumns                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Adjust automatically the columns size.                           
  SEEALSO: List_AdjustColumn, List_SetColumnId, List_GetColumnId            
 ͼ}

Procedure List_AdjustColumns(Var L:TList);
Var Column:Word;
Begin
For Column:=1 to List_GetQttColumns(L) do List_AdjustColumn(L,Column);
End;

{ͻ
                         PROCEDURE List_HideColumns                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           State (BOOLEAN) = TRUE=Hide, FALSE=Show.                         
  OUT....: /                                                                
  EXPLAIN: Hide or show all the list columns.                               
  SEEALSO: List_HideColumn                                                  
 ͼ}

Procedure List_HideColumns(Var L:TList; State:Boolean);
Var Column:Word;
Begin

For Column:=1 to List_GetQttColumns(L) do List_HideColumn(L,Column,State);
End;

{ͻ
                         PROCEDURE List_HideColumn                          
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Column (WORD) = Number of the column to modify.                  
           State (BOOLEAN) = TRUE=Hide column, FALSE=Show column.           
  OUT....: /                                                                
  EXPLAIN: Hide or show a column of the list.                               
 ͼ}

Procedure List_HideColumn(Var L:TList; Column:Word; State:Boolean);
Begin
If (Column<1) Or (Column>List_GetQttColumns(L)) Then Exit;
If State Then Begin                     {*Hide column*}
   BSET(L.ASC[Column].Id,3);
   L.ASC[Column].OldSize:=L.ASC[Column].Size;
   L.ASC[Column].Size:=0;
   End Else Begin                       {*Display Column*}
   BCLR(L.ASC[Column].Id,3);
   L.ASC[Column].Size:=L.ASC[Column].OldSize;
   End;
End;

{ͻ
                         FUNCTION List_InsertColumn                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           ColNul (BYTE) = Insert the column at position "ColNum".          
  OUT....: (BOOLEAN) = TRUE if Ok, else FALSE if an error occured.          
  EXPLAIN: Insert a new column in list.                                     
  BUG....: This function is not finished yet.                               
 ͼ}

Function List_InsertColumn(Var L:TList; ColNum:Byte):Boolean;
Var A:Integer;                          {*Loop*}
    One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
List_InsertColumn:=FALSE;
If (ColNum<1) Or (ColNum>L.Qtt_Columns+1) Then Exit; {*Colonne Incorrecte !*}

Inc(L.Qtt_Columns);

For A:=List_MinItem to L.Qtt_Items do   {*Parcours la Liste*}
   Begin
   Array_Get(L.List,A,One_Item);     {*Lit l'Item courrant...*}
{   Swap_Strings(One_Item.Item);}         {*Echange les Chaines...*}
   Array_Put(L.List,A,One_Item);     {*Remet l'Item modifi...*}
   End;

List_InsertColumn:=TRUE;                {*Pas d'Erreur...*}
End;

{ͻ
                         FUNCTION List_SwapColumns                          
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Col1,Col2 (Byte) = Number of the columns to swap.                
  OUT....: (Boolean) = TRUE if Ok, else FALSE if an error occured.          
  EXPLAIN: Swap two columns in the list.                                    
  NB.....: Columns attributes are swapped too.                              
 ͼ}

Function List_SwapColumns(Var L:TList; Col1,Col2:Byte):Boolean;
Var A:Integer;                          {*Loop*}
    St:String;
    ColTmp:TListColumn;                 {*Pour Swap des Attributs des Colonnes*}
    AColumns:String;
    One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

{=====================================}
Procedure Swap_Strings(Var I:String);
Begin

AColumns:=I;

St:=Str_Get(AColumns,Col1,L.Separator);
AColumns:=Str_Put(AColumns,Str_Get(AColumns,Col2,L.separator),Col1,L.Separator);
AColumns:=Str_Put(AColumns,St,Col2,L.Separator);
I:=Acolumns;
End;
{=====================================}

Begin
If (Col1<1) Or (Col1>L.Qtt_Columns) Or (Col2<1) Or (Col2>L.Qtt_Columns)
   Or (Col1=Col2) Then Begin            {*Colonnes Incorrectes !*}
   List_SwapColumns:=False;
   Exit;
   End;
                                        {*Swap Attributs des Colonnes*}
ColTmp:=L.ASC[Col1]; L.ASC[Col1]:=L.ASC[Col2]; L.ASC[Col2]:=ColTmp;
If L.Sort_Column=Col1 Then L.Sort_Column:=Col2
   Else If L.Sort_Column=Col2 Then L.Sort_Column:=Col1;

Swap_Strings(L.Title);                  {*Swap in the Title...*}

For A:=List_MinItem to L.Qtt_Items do   {*Parcours la Liste*}
   Begin
   Array_Get(L.List,A,One_Item);      {*Lit l'Item courrant...*}
   Swap_Strings(One_Item.Item);         {*Echange les Chaines...*}
   Array_Put(L.List,A,One_Item);      {*Remet l'Item modifi...*}
   End;

List_SwapColumns:=True;                 {*Pas d'Erreur...*}
End;

{ͻ
                          FUNCTION List_MoveItems                           
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Debut (Longint) = Begining of the block.                         
           Quantite (Longint) = Quantity of items in the block.             
           NewPos (Longint) = New position for the block.                   
  OUT....: (Boolean) = TRUE if Ok, else FALSE if an error occured.          
  EXPLAIN: Move a block of Items in the list.                               
 ͼ}

Function List_MoveItems(Var L:TList; Debut,Quantite,NewPos:Longint):Boolean;
Var A,B:Integer;                        {*Loops*}
    One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
If (Debut<List_MinItem) Or (Debut>L.Qtt_Items) Or
   (Quantite<1) Or (Quantite>L.Qtt_Max_Items) Or
   (NewPos<List_MinItem) Or (NewPos>L.Qtt_Max_Items) Or
   (NewPos=Debut)
   Then Begin                           {*Erreurs de Paramtres*}
   List_MoveItems:=False;
   Exit;
   End;

If (NewPos<Debut) Then                  {*Dplacement vers le Dbut*}
   Begin
   B:=NewPos;
   For A:=Debut to Debut+Quantite do    {*Parcours le Bloc ->...*}
      Begin
      Array_Get(L.List,A,One_Item);  {*Copie l'Item*}
      Array_Put(L.List,B,One_Item);  {*Colle L'item*}
      One_Item.Item:='';
      One_Item.Tag:=0;
      Array_Put(L.List,A,One_Item);  {*Efface Ancienne Position de l'Item*}
      Inc(B);
      End;
   End
   Else Begin                           {*Dplacement vers la Fin*}
   B:=NewPos+Quantite-1;
   For A:=Debut+Quantite-1 DownTo Debut do{*Parcours le Bloc <-...*}
      Begin
      Array_Get(L.List,A,One_Item);  {*Copie l'Item*}
      Array_Put(L.List,B,One_Item);  {*Colle L'item*}
      One_Item.Item:='';
      One_Item.Tag:=0;
      Array_Put(L.List,A,One_Item);  {*Efface Ancienne Position de l'Item*}
      Dec(B);
      End;
   End;

List_MoveItems:=True;                   {*Pas d'Erreur...*}
End;

{ͻ
                         FUNCTION List_GetAZIndice                          
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Item (TListItem) = Item which the position must be found.        
           Ordre (Byte) = (Sort_AZ) 0 = Alphabetical order.                 

                          (Sort_ZA) 1 = Reverse order.                      
  OUT....: (Longint) = Position to insert the Item.                         
  EXPLAIN: Get the Item position using a type of order.                     
  NB.....: If an error occured, the function return 0.                      
 ͼ}

Function List_GetAZIndice(Const L:TList; Item:TListItem; Ordre:Byte):Longint;

Var A:Integer;                          {*Loop*}
    St:String;                          {*Chaine de Caractres*}
    One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}

Begin
A:=List_MinItem;                        {*1er Item de la Liste*}
St:=Item.Item;                          {*Stocke Chaine Pour Comparaison...*}

If L.Qtt_Items=0 Then Begin
   List_GetAZIndice:=List_MinItem;      {*1ere Position !*}
   Exit;
   End;

While A<=L.Qtt_Items do                 {*Parcours la Liste...*}
   Begin
   Array_Get(L.List,A,One_Item);     {*Get un Item du Tableau*}
   If (Ordre=Sort_AZ) And (St<One_Item.Item) Then
      Begin
      List_GetAZIndice:=A; Exit;        {*CROISSANT*}
      End;
   If (Ordre=Sort_ZA) And (St>One_Item.Item) Then

      Begin
      List_GetAZIndice:=A; Exit;        {*DECROISSANT*}
      End;
   Inc(A);                              {*Next Item dans la Liste...*}
   End;

List_GetAZIndice:=L.Qtt_Items+1;        {*Dernire Position !*}
End;


{ͻ
                        FUNCTION List_GetItemIndice                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Phrase (String) = Phrase to be searched in List.                 
           Column (Byte) = Column number.                                   
  OUT....: (Longint) = Item position in List.                               
  EXPLAIN: Get the Item position (Indice) in List.                          
  NB.....: If an error occured, the function return 0.                      
 ͼ}

Function List_GetItemIndice(Const L:TList; Phrase:String; Column:Byte):Longint;
Var A:Integer;                          {*Loop*}

Begin
For A:=List_MinItem to L.Qtt_Items do   {*Parcours tous les Items...*}
   Begin
   If Upper(List_GetStringCell(L,A,Column))=Upper(Phrase) Then
      Begin
      List_GetItemIndice:=A;            {*Found Item...*}
      Exit;
      End;
   End;

List_GetItemIndice:=0;                  {*Not Found !*}
End;

{ͻ
                           PROCEDURE List_Refresh                           
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Refresh the list Items.                                          
  SEEALSO: List_Show                                                        
 ͼ}

Procedure List_Refresh(Const L:TList);
Var A:Integer;                          {*Loop*}

Begin
BCLR(Id_Sys1,4);                         {*Manage image palette*}
For A:=L.Pos_Show to L.Pos_Show+L.Qtt_Show_Items do {*Anciennement -1*}
   Begin
   List_ShowItem(L,A);                  {*Affiche les Items*}
   End;
End;

{ͻ
                            PROCEDURE List_Show                             
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Display the list Box with all functionnal gadgets.               
  SEEALSO: List_Refresh, List_ShowItem, List_ShowText, List_ShowGrid        
           List_ShowColumns, List_ShowSliders, List_ShowTitle               
 ͼ}

Procedure List_Show(Var L:TList);
Begin
If Not BTST(L.IdMore,0) Then Bevel (L.X1,L.Y1,L.X2,L.Y2, L.Color,BLLoweredLine,BLNoLine,Yes);
List_ShowTitle(L);                      {*Affiche le Titre*}
List_ShowColumns(L);                    {*Affiche Sparation des Colonnes*}
List_ShowGrid(L);                       {*Affiche la Grille*}
List_ShowSliders(L);                    {*Affiche le Slider*}
List_ShowSliders(L);                    {*Recalcul Slider Horizontal*}
List_Refresh(L);                        {*Rafraichit les Items de la Liste*}
End;

{ͻ
                         PROCEDURE List_ShowSliders                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Define and display Sliders of the list.                          
  NB.....: Must be called before the "List_Refresh" function.               
  SEEALSO: List_Show                                                        
 ͼ}

Procedure List_ShowSliders(Var L:TList);
Var TotalSize:Integer;                  {*Taille totale des Colonnes*}
    MaxD:Integer;
Begin
TotalSize:=List_GetSizeColumns(L);      {*Calcule Taille Totale Columns*}
MaxD:=L.MaxX-L.X1-1;                    {*Et Taille Max Displayable*}

If (TotalSize>MaxD) And (Not L.Sh_Exist) Then
   Begin                                {*Existance du Slider Horizontal ?*}
   L.Sh_Exist:=TRUE;
   L.Sh_Pos:=0;
   L.Sh_OldPos:=0;
   L.Sh.Value:=0;
   L.Sh_Moved:=FALSE;
   L.MaxY:=L.Y2-15;
   End;
If (TotalSize<=MaxD) And (L.Sh_Exist) Then
   Begin                                {*N'existe plus...*}
   L.Sh_Exist:=FALSE;
   L.MaxY:=L.Y2;
   End;
If L.Sh_Exist Then                      {*Affiche le Slider Horizontal*}
   Begin
   Slider(L.Sh, L.X1+1,L.Y2-15,L.MaxX-L.X1-2, TotalSize,MaxD, L.Sh.Value, COHorizontal,SSNone,SSColor,$0000,CTBox,BPOposed,Yes, $0000,CLBrightGrey,0,0,CLLightGrey, '','',MPArrow,'');
   End;
                                        {*Recalcul du nombre d'Items Affichable*}
L.Qtt_Show_Items:=List_GetQttShowItems(L);{*Nombre d'Items Affichable*}

If L.Qtt_Items>L.Qtt_Show_Items Then    {*Affiche Slider Vertical*}
   Begin
   Slider(L.Sv, L.X2-15,L.BaseY,L.Y2-L.BaseY-1, L.Qtt_Items, L.Qtt_Show_Items, L.Pos_Show, COVertical,SSNone,SSColor,$0000,CTBox,BPOposed,Yes, $0008,CLBrightGrey,0,0,CLLightGrey, '','',MPArrow,'');
   L.MaxX:=L.X2-15;                     {*Laisser la place libre pour le Slider Now*}
   End Else L.MaxX:=L.X2;
End;

{ͻ
                          PROCEDURE List_ShowTitle                          
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Display list titles and columns headers.                         
  SEEALSO: List_Show                                                        
 ͼ}

Procedure List_ShowTitle(Const L:TList);
Var A:Integer;                          {*Loop*}
    X1,Y1,X2,Y2:Integer;

Begin
If Not BTST(L.Id,0) Then Exit;          {*Pas d'affichage du Titre*}

Y1:=L.Y1+1; Y2:=L.BaseY-1;              {*Build Box Coordonnes...*}
X1:=L.X1+1; X2:=X1;
Dec(X1,L.Sh_Pos); Dec(X2,L.Sh_Pos);     {* - Position Slider Hz*}

For A:=1 to L.Qtt_Columns do            {*Pour chaque Colonne...*}
   Begin
   X2:=X2+L.ASC[A].Size;
   If X2>=L.MaxX Then X2:=L.X2-1;
   If X1<L.X1+1 Then X1:=L.X1+1;        {*Minimum  Gauche...*}
   If X1<X2 Then Bevel (X1,Y1,X2,Y2, CLWinBg,BLRaisedLine,BLNoLine,Yes); {*Affiche Boite*}
   X1:=X2+1;
   End;
                                        {*Trace une Boite jusqu'a la fin...*}
If X2<L.X2-1 Then Bevel (X1,Y1,L.X2-1,Y2, CLWinBg,BLRaisedLine,BLNoLine,Yes);

List_ShowText(L,0);                     {*Affiche le Texte du Titre*}
End;

{ͻ
                          PROCEDURE List_ShowGrid                           
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Display a grid (Grey lines) using the cells list.                
  SEEALSO: List_Show                                                        
 ͼ}

Procedure List_ShowGrid(Const L:TList);
Var Lig,Col,V:Integer;

Begin
If Not BTST(L.Id,13) Then Exit;         {*Pas d'affichage de la Grille*}

VESA_SetColor(CLShadow);                {*Init Color...*}

Mse_Hide;
V:=L.BaseY;
For Lig:=1 to L.Qtt_Show_Items do
   Begin
   V:=V+L.Item_SizeY;                   {*Trace une Ligne Horizontale...*}
   If V<L.MaxY-6 Then VESA_Line(L.X1 + 1, V, L.MaxX - 1, V);
   End;

V:=L.X1+1-L.Sh_Pos;
For Col:=1 to L.Qtt_Columns do          {*Fait toutes les Colonnes...*}
   Begin
   V:=V+L.ASC[Col].Size;                {*Trace une Ligne Verticale...*}
   If (V<L.MaxX-1) And (V>L.X1) Then VESA_Line(V, L.BaseY, V, L.MaxY-1);
   End;

Mse_Show;
End;

{ͻ
                         PROCEDURE List_ShowColumns                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Display the columns lines separations.                           
  SEEALSO: List_Show                                                        
 ͼ}

Procedure List_ShowColumns(Const L:TList);
Var A,X:Integer;

Begin
If Not BTST(L.Id,10) Then Exit;         {*Pas d'affichage des Sparations*}

X:=L.X1+2-L.Sh_Pos; VESA_SetColor(CLLineDown); {*Init Position and Color...*}

For A:=1 to L.Qtt_Columns do            {*Pour chaque Colonne...*}
   Begin
   X:=X+L.ASC[A].Size;                  {*Trace une Ligne Verticale...*}
   If (X<L.MaxX-1) And (X>L.X1) Then Tool_Line(X-1, L.BaseY-1, X-1, L.MaxY-1,0,1);
   End;
End;

{ͻ
                         FUNCTION List_GetColorLine                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (LONGINT) = Item number (Position in list).               

  OUT....: (LONGINT) = Color of the Line.                                   
  EXPLAIN: Return the background line color for the specified indice.       
 ͼ}

Function List_GetColorLine(Const L:TList; Indice:Longint):Longint;
Var NC,CC:Longint;
Begin
CC:=L.Color;
If (BTST(L.Id,11)) And (Odd(Indice)) Then CC:=L.Color_Line;
NC:=List_GetBkColorItem(L,Indice);      {*Special Color defined ?*}
If NC>-1 Then CC:=NC;
List_GetColorLine:=CC;
If Indice=0 Then List_GetColorLine:=7;  {*Title line*}
End;

{ͻ
                          PROCEDURE List_ClearLine                          
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
  OUT....: /                                                                
  EXPLAIN: Clear the Item line in the List box selection.                   
           To clear line, the function use the defined color.               
           There is 4 colors levels with priority :                         
              * 1st - Cell color (if defined)                               
              * 2nd - Column color (if defined)                             
              * 3rd - Line color (if defined)                               
              * 4th - List standard color                                   
  SEEALSO: List_ShowItem                                                    
 ͼ}

Procedure List_ClearLine(Const L:TList; Indice:Longint);
Var Column:Integer;
    Current_Color:LongInt;              {*Couleur Courante de la Ligne*}
    IndRel:Integer;
    Y1,Y2:Integer;                      {*Positions Y de la Barre*}
    C:TCoordinates;
    IdBmp:Word;

Begin
IndRel:=Indice-L.Pos_Show;              {*Calcul de l'Indice Relatif d'Affichage*}
If (IndRel<0) Or (IndRel>L.Qtt_Show_Items) Then Exit;

Y1:=L.BaseY+IndRel*L.Item_SizeY-6;      {*Calcule Pos Ligne*}

Y2:=Y1+L.Item_SizeY-1;
If Y1>L.MaxY-7 Then Exit;               {*En dehors de la Liste*}
If Y2>L.MaxY-7 Then Y2:=L.MaxY-7;       {*Ne pas dpasser le Bas*}

Mse_Hide;                               {*Efface la Ligne...*}
Current_Color:=List_GetColorLine(L,Indice);
If L.Bitmap<>'' Then
   Begin                                {*Display Bitmap...*}
   If BTST(Id_Sys1,4) Then IdBmp:=$0080 Else IdBmp:=$00A0;
   BMP_Show(L.X1+1, Y1+6, L.MaxX-2+1, Y2+6, 0,Y1+6, L.Bitmap,IdBmp);
   BSET(Id_Sys1,4);                     {*Manage image palette*}
   End
Else
   Begin                                {*Display Bar*}
   Bevel (L.X1+1, Y1+6, L.MaxX-2+1, Y2+6, Current_Color);
   End;

For Column:=1 to List_GetQttColumns(L) do
   If (BTST(L.ASC[Column].Id,2)) And (Not BTST(L.ASC[Column].Id,3))  Then
      Begin                             {*Fill columns with special color*}
      If List_GetCellCoord(L,Indice,Column,C) Then
         Begin
         Current_Color:=L.ASC[Column].Color;
         Bevel (C.X1+1, Y1+6, C.X2+1, Y2+6, Current_Color);
         End;
      End;

If List_TestTaggedItem(L,Indice)>0 Then {*Item Tagged => Toggle Bar*}
   Begin
   Bevel (L.X1+1, Y1+6, L.MaxX-2+1, Y2+6, CLToggle);
   End;

If List_TestIdItem(L,Indice,1) Then     {*Fait une Ligne de Sparation (Menu)*}
   If (Y1+12<L.MaxY) And (Indice<=L.Qtt_Items) Then Begin
      Tool_Line(L.X1,Y1+5+6,L.MaxX-2+1,Y1+5+6,0,1);
      End;
Mse_Show;

List_ShowColumns(L);                    {*Raffiche les Colonnes...*}
List_ShowGrid(L);                       {*Raffiche la Grille*}
End;

{ͻ
                          PROCEDURE Show_FileIcon                           
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Px,Py (Integer) = X,Y Icon position.                             
           FName (String) = Filename for search attached icon.              
  OUT....: /                                                                
  EXPLAIN: Display and Icon attached to the file (File list only).          
 ͼ}

Procedure Show_FileIcon(L:TList; Px,Py:Integer; FName:String);
Begin
// To avoid warnings !
   L := L;
   FName := FName;

   DrawGad_File(Px,Py);
End;

{ͻ
                          PROCEDURE List_ShowText                           
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
  OUT....: /                                                                
  NB.....: If number 0 is specified, the title is displayed.                
  EXPLAIN: Display the Text of a specified Item.                            
  SEEALSO: List_Show                                                        
 ͼ}

Procedure List_ShowText(Const L:TList; Indice:Longint);

Var X1,Y,Offset,IndRel,Col:Integer;
    Cells:String;
    One_Item:TListItem;                 {*Un Item pour stockage Temporaire*}
    St:String;
    Text_Overflow:Integer;              {*Nombre de char de dpassement*}
    Correction:Integer;                 {*Correction Pos X Bordure Gauche*}
    Cx,Fx:TCoordinates;                 {*Coordinates Clipping Interne*}
    VP:TViewPortType;                   {*Pour Clipping Interne*}
    Vx1,PenColor:LongInt;
    A:Integer;                          {*Loop*}
    CellShort:Boolean;                  {*A cell is too short to display text*}
    Text1:TText;                        {*Affichage du texte*}
    IdText:Word;
    aX1,aY1,aX2,aY2:Integer;            {*Problme de transtypage*}

Begin
If Indice>0 Then                        {*Ce n'est pas le Titre...*}
   Begin
   IndRel:=Indice-L.Pos_Show;           {*Calcul de l'Indice Relatif d'Affichage*}
   If (IndRel<0) Or (IndRel>L.Qtt_Show_Items) Then Exit;
   Array_Get(L.List,Indice,One_Item);   {*Rcupre l'Item dans la Liste*}
   Cells:=One_Item.Item;
   Y:=L.BaseY+IndRel*L.Item_SizeY-6;

   End
   Else Begin
   Y:=L.Y1-4;                           {*Calcule Pos pour le Titre...*}
   One_Item.Color:=CLBlack;
   One_Item.Tag:=0;
   One_Item.Id:=$0000;
   Cells:=L.Title;
   End;

If (Indice>L.Qtt_Items) Then Exit;      {*Item n'existe pas !*}

If Y+6+L.Item_SizeY>L.MaxY Then Exit;   {*En Dehors de la Box-Liste*}

VESA_GetViewSettings(VP);               {*Get Current ViewPort*}

X1:=L.X1+4-L.Sh_Pos;                    {*Pos X Initiale*}
CellShort:=FALSE;

For Col:=1 to L.Qtt_Columns do          {*Fait toutes les Colonnes...*}
   Begin
   St:=Str_Get(Cells,Col,L.Separator);  {*Transfre la chaine pour Traitement*}

   If (List_TestColumnId(L,Col,1)) And (Indice>0) Then St:='   '+St;{*Place for Icon File*}
   If (L.Sort_Column=Col) And (Indice=0) Then {*Add Flches de Tri...*}
      If L.Sort_Sens=Sort_AZ Then St:=St+'' Else St:=St+'';

   Case L.ASC[Col].Justif of            {*Justification*}
      Text_OnLeft:  Offset:=0;                                            {*A Gauche*}
      Text_OnRight: Offset:= L.ASC[Col].Size-VESA_TextWidth(St)-7;        {*A Droite*}
      Text_Center:  Offset:=(L.ASC[Col].Size-VESA_TextWidth(St)-4) Div 2; {*Au Centre*}
      End;
   If Offset<0 Then Offset:=0;          {*On ne peux pas crire plus  Gauche*}

   Text_Overflow:=((VESA_TextWidth(St)-L.ASC[Col].Size+20) Div (LaF+1));

{!}   {List_SetIdInItem(L,Indice,$0000);}    {*Clear Field Mot trop Long*}
   If Text_Overflow>0 Then              {*Ca dpasse la Colonne !*}
      Begin
      If Not BTST(L.IdMore,4) Then      {*Afficher les '...' quand texte trop long*}
         Begin
         If Text_Overflow>=Length(St) Then St:=''
            Else Delete(St,Length(St)-Text_Overflow+1,Text_Overflow);
         St:=St+'';                  {*Le Mot est Tronqu...*}
         End;
      CellShort:=TRUE;
      End;

   If Indice=0 Then
      Begin                             {*Get Title Coordinates*}
      List_GetCellCoord(L,L.Pos_Show,Col,Cx);
      Cx.Y2:=L.BaseY-8; Cx.Y1:=L.Y1-3;

      End
      Else List_GetCellCoord(L,Indice,Col,Cx); {*Get Cell Coordinates*}
   If Cx.X2>L.MaxX Then Cx.X2:=L.MaxX-1;{*Maximum X dpass...*}
   Correction:=0;
   Vx1:=L.X1+2-L.Sh_Pos;                {*Calcule Correction*}
   For A:=1 to Col-1 do Vx1:=Vx1+L.ASC[A].Size;

   Correction:=Cx.X1-Vx1;
   If Correction<0 Then Correction:=0;

{If Col=1 Then Begin
Gotoxy(1,1); writeln('Calc = ',L.X1+2-L.Sh_Pos,' ');

Gotoxy(1,2); writeln('C.X1 = ',Cx.X1,' ');
Gotoxy(1,3); writeln('C.X2 = ',Cx.X2,' ');
Gotoxy(1,4); writeln('L.Max= ',L.MaxX,' ');
Gotoxy(1,5); writeln('L.X1 = ',L.X1,' ');
Gotoxy(1,6); writeln('Corr = ',Correction,' ');
Gotoxy(1,7); writeln('ClipX = ',T_Clip.X1+Cx.X1+3,' ',T_Clip.X1+Cx.X2-1,' ');
Gotoxy(1,8); writeln('ClipY = ',T_Clip.Y1+Cx.Y1-1,' ',T_Clip.Y1+Cx.Y2,' ');
End;
}
   Fx.X1:=T_Clip.X1+Cx.X1+3; Fx.Y1:=T_Clip.Y1+Cx.Y1-1;
   Fx.X2:=T_Clip.X1+Cx.X2-1; Fx.Y2:=T_Clip.Y1+Cx.Y2+5;
{   Fx.X1:=T_Clip.X1+Cx.X1+3; Fx.Y1:=T_Clip.Y1+Cx.Y1-1;
   Fx.X2:=T_Clip.X1+Cx.X2-1; Fx.Y2:=T_Clip.Y1+Cx.Y2;}

   aX1:=Fx.X1; aY1:=Fx.Y1; aX2:=Fx.X2; aY2:=Fx.Y2; {*Problme de transtypage*}
   Coord_RealClipBox(aX1,aY1,aX2,aY2);  {*For Clipping Window*}
   Fx.X1:=aX1; Fx.Y1:=aY1; Fx.X2:=aX2; Fx.Y2:=aY2; {*Problme de transtypage*}

   If (Fx.X1<Fx.X2) And (Fx.Y1<Fx.Y2) And (Fx.X1>T_Clip.X1+L.X1) And (Fx.X2>T_Clip.X1+L.X1)
      Then Begin                        {*On est en dehors de la Zone d'affichage ?*}
      VESA_SetViewPort(Fx.X1, Fx.Y1, Fx.X2, Fx.Y2, ClipOn);
      If Not List_TestIdItem(L,Indice,1) Then
         Begin
         PenColor:=One_Item.Color;      {*Couleur de l'affichage de l'Item*}
         If One_Item.Tag>0 Then PenColor:=CLWhite;
         If List_GetColorLine(L,Indice)=0 Then PenColor:=PenColor XOR CLWhite;

         If Not BTST(L.ASC[Col].Id,3) Then     {*Hidden Column ?*}
            Begin
            Font_Set(L.Font.Name,L.Font.Size); {*Passe en Fonte pour la Liste*}
            VESA_SetColor(PenColor);    {*Set Pen Color*}

            If BTST(One_Item.Id,0) Then IdText:=$0008 Else IdText:=$0000;
            Display_Define(Text1, Offset-Correction+1, 6, -1,PenColor,'',0,TJOnLeft,IdText,St);
            If BTST(One_Item.Id,0) Then Text1.Font.Pencolor:=Text1.Font.PenColor XOR CLWhite;
            Display_Draw(Text1);

            Mse_Hide;
            If (List_TestColumnId(L,Col,1)) And (Indice>0) Then {*Place for Icon File*}
               Show_FileIcon (L,Offset-Correction+1,+8, List_GetStringCell(L,Indice,List_GetColumnNum(L,1)));
            Mse_Show;
            Font_Set(Sys.FontPrevious,Sys.FontPreviousSize); {*Repasse dans la fonte Prcdente*}
            End;
         End;
      End;

   VESA_SetWriteMode(NormalPut);

   VESA_SetViewPort(VP.X1,VP.Y1,VP.X2,VP.Y2,ClipOff);{*Restore Previous ViewPort*}
   X1:=X1+L.ASC[Col].Size;              {*Next Column...*}
   If X1>L.X2 Then Exit;
   End;

If CellShort Then ;//List_SetIdInItem(L,Indice,$0001);} {*Mot trop long !*}
End;

{ͻ
                          PROCEDURE List_ShowItem                           
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
  OUT....: /                                                                
  EXPLAIN: Display the specified item.                                      
  SEEALSO: List_Show, List_ClearLine                                        
 ͼ}

Procedure List_ShowItem(Const L:TList; Indice:Longint);
Begin
If (Indice<List_MinItem) Or (Indice>L.Qtt_Max_Items) Then Exit;

List_ClearLine(L,Indice);               {*Efface la Ligne...*}
List_ShowText(L,Indice);                {*Affiche le Texte*}
End;

{ͻ
                        FUNCTION List_GetTaquetCoord                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Taquet (Word) = Taquet number (Inter-Column).                    
           C (TCoordinates) = Structure of coordinates.                     
  OUT....: TRUE / FALSE (Boolean) = TRUE: If the cell is displayable.       
  EXPLAIN: Get in the "C" structure the Taquet coordinates.                 
 ͼ}

Function List_GetTaquetCoord(Const L:TList; Taquet:Word; Var C:TCoordinates):Boolean;
Var A:Integer;

Begin
If (Taquet<1) Or (Taquet>L.Qtt_Columns) Then
   Begin List_GetTaquetCoord:=FALSE; Exit; End;

C.X1:=L.X1-L.Sh_Pos;                    {*Coordonnes X*}

For A:=1 to Taquet do C.X1:=C.X1+L.ASC[A].Size;
C.X1:=C.X1-3; C.X2:=C.X1+6;
If (C.X1<=L.X1) And (C.X2<=L.X1) Then   {*Taquet Trop  Gauche !*}
   Begin List_GetTaquetCoord:=FALSE; Exit; End;


C.Y1:=L.Y1-6; C.Y2:=L.BaseY-7;          {*Coordonnes Y*}


List_GetTaquetCoord:=TRUE;
End;

{ͻ
                         FUNCTION List_GetItemCoord                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           C (TCoordinates) = Structure of coordinates.                     
           Indice (Longint) = Item number (Position in list).               
  OUT....: TRUE / FALSE (Boolean) = TRUE: If Item is displayable.           
  EXPLAIN: Get in the "C" structure the Item coordinates.                   
  SEEALSO: List_TestMouseOnItem                                             
 ͼ}

Function List_GetItemCoord(Const L:TList; Indice:Longint; Var C:TCoordinates):Boolean;
Var IndRel:Integer;

Begin
IndRel:=Indice-L.Pos_Show;              {*Calcul de l'Indice Relatif d'Affichage*}
If (IndRel<0) Or (IndRel>L.Qtt_Show_Items) Then
   Begin List_GetItemCoord:=FALSE; Exit; End;

C.X1:=L.X1;                             {*Coordonnes X*}
C.X2:=L.MaxX-1;


C.Y1:=L.BaseY+IndRel*L.Item_SizeY-4;    {*Coordonnes Y*}
C.Y2:=C.Y1+L.Item_SizeY-1;
If C.Y2>L.Y2-7 Then C.Y2:=L.Y2-7;       {*Ne pas dpasser le Bas*}
List_GetItemCoord:=TRUE;
End;

{ͻ
                       FUNCTION List_TestMouseOnItem                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
  OUT....: TRUE / FALSE (Boolean) = TRUE: If the mouse is over an Item.     
  EXPLAIN: Check if the mouse is over an item surface.                      
  SEEALSO: List_GetItemCoord                                                
 ͼ}

Function List_TestMouseOnItem(Const L:TList; Indice:Longint):Boolean;
Var C:TCoordinates;
Begin
List_GetItemCoord(L,Indice,C);          {*Get Coordinates*}
If Mse_TestBox(T_Clip.X1+C.X1+1, T_Clip.Y1+C.Y1-1+6, T_Clip.X1+C.X2+1, T_Clip.Y1+C.Y2-1+6, 10)
   Then List_TestMouseOnItem:=TRUE      {*Send Result*}
   Else List_TestMouseOnItem:=FALSE;
End;

{ͻ
                        FUNCTION List_GetCellOnMouse                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: Indice (Longint) = Item number (Position in list).               
           Column (Longint) = Column number.                                
           TRUE / FALSE (Boolean) = TRUE: The mouse is on a cell.           
  EXPLAIN: Get the coordinates of the cell pointed by the mouse pointer.    

 ͼ}

Function List_GetCellOnMouse(Const L:TList; Var Indice,Column:Longint):Boolean;
Var I,C:Longint;                        {*To search the cell coordinates*}

    Coo:TCoordinates;
    Mx,My:Word;                         {*For mouse info*}
    Ga,Mi,Dr:Boolean;
    Res:Boolean;

Begin
Mse_Get(Mx,My,Ga,Mi,Dr);                {*Get mouse info*}

For C:=1 to L.Qtt_Columns do            {*Parcours les cellules visibles*}
   For I:=L.Pos_Show to L.Pos_Show+L.Qtt_Show_Items-1 do
      Begin
      Res:=List_GetCellCoord(L,I,C,Coo);{*Get coordinates of the Cell*}

      If Res Then
         If Mse_TestBox(T_Clip.X1+Coo.X1, T_Clip.Y1+Coo.Y1, T_Clip.X1+Coo.X2+1, T_Clip.Y1+Coo.Y2+1,10) Then
            Begin
            Indice:=I; Column:=C;       {*Return the cell X and Y*}
            List_GetCellOnMouse:=TRUE;

            Exit;
            End;
      End;
List_GetCellOnMouse:=FALSE;             {*No Cell found !*}
End;

{ͻ
                       FUNCTION List_TestMouseOnList                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: (BYTE) = Return the list zone under the mouse pointer :          
              0 = Mouse is not over the list.                               
              1 = Mouse is over the list items.                             
              2 = Mouse is over the list title.                             
  EXPLAIN: Return if mouse pointer is over the list.                        
 ͼ}

Function List_TestMouseOnList(Const L:TList):Byte;
Var Mx,My:Word;                         {*For mouse info*}
    Ga,Mi,Dr:Boolean;
Begin
Mse_Get(Mx,My,Ga,Mi,Dr);                {*Get mouse info*}
List_TestMouseOnList:=0;

If Mse_TestBox(T_Clip.X1+L.X1, T_Clip.Y1+L.BaseY-6, T_Clip.X1+L.MaxX, T_Clip.Y1+L.MaxY-6,10) Then
   List_TestMouseOnList:=1;             {*Over the list title*}
If Mse_TestBox(T_Clip.X1+L.X1, T_Clip.Y1+L.Y1-6, T_Clip.X1+L.X2, T_Clip.Y1+L.BaseY-6,10) Then
   List_TestMouseOnList:=2;             {*Over the list items*}
End;

{ͻ
                         FUNCTION List_GetCellCoord                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           C (TCoordinates) = Structure of coordinates.                     
           Indice (Longint) = Item number (Position in list).               
           Column (Longint) = Column number.                                
  OUT....: TRUE / FALSE (Boolean) = TRUE: The cell is displayable.          
  EXPLAIN: Get in the "C" structure the cell coordinates.                   
  SEEALSO: List_TestMouseOnCell                                             
 ͼ}

Function List_GetCellCoord(Const L:TList; Indice,Column:Longint; Var C:TCoordinates):Boolean;
Var IndRel,A:Integer;

Begin
IndRel:=Indice-L.Pos_Show;              {*Calcul de l'Indice Relatif d'Affichage*}
If (Indrel<0) Or (IndRel>L.Qtt_Show_Items) Or (Column>L.Qtt_Columns) Then
   Begin List_GetCellCoord:=FALSE; Exit; End;

C.X1:=L.X1+2-L.Sh_Pos;                  {*Coordonnes X*}
For A:=1 to Column-1 do C.X1:=C.X1+L.ASC[A].Size;
C.X2:=C.X1+L.ASC[Column].Size-2;
If Column=1 Then Dec(C.X1,2);
If (C.X1<=L.X1) And (C.X2<=L.X1) Then   {*Cellule Trop  Gauche !*}
   Begin List_GetCellCoord:=FALSE; Exit; End;
If (C.X2>=L.MaxX) And (C.X1>=L.MaxX) Then {*Cellule Trop  Droite !*}
   Begin List_GetCellCoord:=FALSE; Exit; End;
If C.X1<L.X1 Then C.X1:=L.X1;           {*Bord Gauche Minimum*}
If C.X2>L.MaxX-2 Then C.X2:=L.MaxX-2;   {*Bord Droite Minimum*}

C.Y1:=L.BaseY+IndRel*L.Item_SizeY-5;    {*Coordonnes Y*}
C.Y2:=C.Y1+L.Item_SizeY-2;
If C.Y1>L.MaxY-7 Then C.Y1:=L.MaxY-7;   {*En dehors de la Liste*}
If C.Y2>L.Y2-7 Then C.Y2:=L.Y2-7;       {*Ne pas dpasser le Bas*}
List_GetCellCoord:=TRUE;
End;

{ͻ
                       FUNCTION List_TestMouseOnCell                        
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Indice (Longint) = Item number (Position in list).               
           Column (Longint) = Column number.                                
  OUT....: TRUE / FALSE (Boolean) = TRUE: The mouse is over the Cell.       
  EXPLAIN: Check if the mouse is over a cell surface.                       
  SEEALSO: List_GetCellCoord                                                
 ͼ}

Function List_TestMouseOnCell(Const L:TList; Indice,Column:Longint):Boolean;
Var C:TCoordinates;
Begin
List_GetCellCoord(L,Indice,Column,C);   {*Get Coordinates*}
If Mse_TestBox(T_Clip.X1+C.X1, T_Clip.Y1+C.Y1, T_Clip.X1+C.X2, T_Clip.Y1+C.Y2,10)
   Then List_TestMouseOnCell:=TRUE      {*Send Result*}

   Else List_TestMouseOnCell:=FALSE;
End;

{ͻ
                          PROCEDURE List_TestHint                           
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Manage the Hint gadget.                                          
 ͼ}

Procedure List_TestHint(Var L:TList);
Var C:TCoordinates;
    Indice,Column:Longint;
//    Res:Boolean;

Begin
If Not BTST(L.Id,14) Then Exit;         {*Pas d'Info Box*}

{Res:=} List_GetCellOnMouse(L,Indice,Column);

{gotoxy(1,1); writeln(Indice,' ',Column,' ');
gotoxy(1,2); writeln(L.OldI,' ',L.OldC,' ');
gotoxy(1,3); writeln(BTST(L.IdIn,2),' ');}

If (L.OldI<>Indice) Or (L.OldC<>Column) Then
   Begin
{write(#7);}
   If BTST(L.IdIn,2) Then Hint_Done(L.IB);
   L.OldI:=Indice; L.OldC:=Column;
   If Not BTST(List_GetIdInItem(L,Indice),0) Then
      Begin                             {*Mot trop long ?*}
{      If BTST(L.IdIn,2) Then Hint_Done(L.IB);}
      BCLR(L.IdIn,2); Exit;
      End;

   List_GetCellCoord(L,Indice,Column,C);{*Get coordinates of the Cell*}
   Hint(C.X1,C.Y1+6,C.X2,C.Y2+6,$01,L.IB,List_GetStringCell(L,Indice,Column)); {*Info Box Defined*}
   BSET(L.IdIn,2);
   End;

If BTST(L.IdIn,2) Then Hint_GetMsg(L.IB); {*Manage Hint*}
End;

{ͻ
                           FUNCTION List_TestKeys                           
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: (Longint) = If an Item selected return Item Indice else 0.       
  EXPLAIN: Check Keyboard keys and manage list selection.                   
  SEEALSO: List_Test                                                        
 ͼ}

Function List_TestKeys(Var L:TList):Longint;
Var ToDo,Sens:Byte;                     {*Choses  Faire et sens recherche*}
    Depl:Longint;                       {*Dplacement = Nb d'Items*}
    Old_Indice:Longint;                 {*Indice Initial*}
    Next:Longint;

Begin
List_TestKeys:=0;                       {*De Base, ne Renvois rien !*}

Depl:=0;
If Kbd_GetKeyDown(VK_UP   ) Then Depl:=-1;                     {*Flche Haut*}
If Kbd_GetKeyDown(VK_PRIOR) Then Depl:=-L.Qtt_Show_Items;      {*Page Up*}
If Kbd_GetKeyDown(VK_HOME ) Then Depl:=-L.Pos_Item+1;          {*Home*}
If Kbd_GetKeyDown(VK_DOWN ) Then Depl:=1;                      {*Flche Bas*}
If Kbd_GetKeyDown(VK_NEXT ) Then Depl:=L.Qtt_Show_Items;       {*Page Down*}
If Kbd_GetKeyDown(VK_END  ) Then Depl:=L.Qtt_Items-L.Pos_Item; {*End*}

Old_Indice:=L.Pos_Item;                 {*Set Indice Initial*}
ToDo:=0;                                {*Rafficher Item ou Liste Entire*}

If Depl<>0 Then
   Begin
   If BTST(List_GetIdItem(L,L.Pos_Item+Depl),0) Then
      Begin                             {*Next item is not Free !*}
      If Depl>0 Then Sens:=Sort_AZ Else Sens:=Sort_ZA;
      Next:=List_GetNextFreeItem(L,L.Pos_Item+Depl,Sens);
      If Next=0 Then Begin
         If Depl>0 Then Sens:=Sort_ZA Else Sens:=Sort_AZ;
         Next:=List_GetNextFreeItem(L,L.Pos_Item+Depl,Sens);
         If Next>0 Then Depl:=Next-L.Pos_Item;
         End
         Else Depl:=Next-L.Pos_Item;
      If L.Pos_Item+Depl<>Next Then Depl:=Next-L.Pos_Item;
      End;

   L.Pos_Item:=L.Pos_Item+Depl;         {*Se Dplace*}
   If BTST(L.Id,15) Then
      Begin                             {*Rotation dans la Liste*}
      If L.Pos_Item<List_MinItem Then L.Pos_Item:=L.Qtt_Items;
      If L.Pos_Item>L.Qtt_Items  Then L.Pos_Item:=List_MinItem;
      End
      Else Begin                        {*Bornes non Franchissable*}
      If L.Pos_Item<=List_MinItem Then L.Pos_Item:=List_MinItem;
      If L.Pos_Item>=L.Qtt_Items  Then L.Pos_Item:=L.Qtt_Items;
      End;

   If L.Pos_Item<L.Pos_Show Then Begin L.Pos_Show:=L.Pos_Item; ToDo:=1; End;
   If L.Pos_Item>=L.Pos_Show+L.Qtt_Show_Items Then
      Begin L.Pos_Show:=L.Pos_Item-L.Qtt_Show_Items+1; ToDo:=1; End;

   If Old_Indice=L.Pos_Item Then Exit;  {*Pas de Modif de l'Indice*}

   List_UnTagItem(L,Old_Indice);        {*Dslectionne Item Courrant*}

   List_ShowItem(L,Old_Indice);
   If L.Qtt_Tagged_Items>1 Then Begin   {*Desslectionne toute la Liste*}
      List_UnTagAllItems(L);
      ToDo:=1;
      End;

   List_TagItem(L,L.Pos_Item);          {*Slectionne Nouvel Item*}
   List_ShowSliders(L);
   If ToDo=1 Then List_Refresh(L) Else List_ShowItem(L,L.Pos_Item);
   List_TestKeys:=L.Pos_Item;           {*Renvois Item Slectionn*}
   BSET(L.IdIn,0);
   BSET(L.IdIn,1);                      {*Use Keyboard to Select Item*}
   End;                                 {*En Key Pressed*}
{gotoxy(1,1); writeln('Pos_Item=',L.Pos_Item,' ');
gotoxy(1,2); writeln('Pos_Show=',L.Pos_Show,' ');}
End;

{ͻ
           FUNCTIONS Get_NewPosX, Get_NewPosY, Move_ShHorizontal            
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: Resultat (Integer) = Renvois le nouvel indice d'affichage.       
  NB.....: Fonctions  usage interne. Ne peuvent tre appels de l'extrieur
  EXPLAIN: Calcule l'indice d'affichage de liste X ou Y.                    
 ͼ}

Function Get_NewPosY(L:TList; Indice:Integer):Integer;
Var New_Pos:Integer;                    {*Calcul de l'Indice d'Affichage*}
    LeRab:Integer;                      {*Qtt d'items ne pouvant pas tre Affichs*}
    Fac_Div:Real;                       {*Facteur de Division*}
Begin
If L.Qtt_Items=0 Then Begin Get_NewPosY:=1; Exit; End; {*Liste Vide !*}
LeRab:=L.Qtt_Items-L.Qtt_Show_Items+1;
If LeRab=0 Then Begin Get_NewPosY:=1; Exit; End; {*Div /0 !!!*}
Fac_Div:=L.Qtt_Items / Real(LeRab);
New_Pos:=Trunc(Indice / Fac_Div);       {*Calcul de l'indice de position*}

If L.Sv.Quantity=L.Sv.Value Then New_Pos:=LeRab;{*Last Position Correct Erreur Calcul*}
If New_Pos<1 Then Inc(New_Pos);         {*Min=1 Max=Qtt-Show*}
If New_Pos>LeRab Then New_Pos:=LeRab;
Get_NewPosY:=New_Pos;                   {*Renvois le Rsultat...*}
End;

Function Get_NewPosX(L:TList):Integer;
Var New_Pos:Integer;                    {*Calcul de l'Indice d'Affichage*}
    LeRab:Integer;                      {*Qtt d'items ne pouvant pas tre Affichs*}
    Fac_Div:Real;                       {*Facteur de Division*}
    TotalSize:Integer;                  {*Sh: Taille totale des Colonnes*}
    MaxD:Integer;                       {*Sh: Max Displayable*}
Begin
TotalSize:=List_GetSizeColumns(L);      {*Calcule Taille Totale Columns*}

MaxD:=L.MaxX-L.X1-2;                    {*Et Taille Max Displayable*}

LeRab:=TotalSize-MaxD+1;
If LeRab=0 Then Begin Get_NewPosX:=1; Exit; End; {*Mettre si Div /0 !!!*}
Fac_Div:=TotalSize / Real(LeRab);
New_Pos:=Trunc(L.Sh.Value / Fac_Div);     {*Calcul de l'indice de position*}
If New_Pos<0 Then Inc(New_Pos);         {*Min=0 Max=Qtt-Show*}
If New_Pos>LeRab-1 Then New_Pos:=LeRab-1;
Get_NewPosX:=New_Pos;                   {*Renvois le Rsultat...*}
End;

Procedure Move_ListHorizontal(Var L:TList);
Var New_Pos:Integer;                    {*Calcul de l'Indice d'Affichage*}
Begin
New_Pos:=Get_NewPosX(L);                {*Calcule Nouvelle Position*}
L.Sh_Moved:=TRUE;
If L.Sh_Pos<>New_Pos Then Begin
   L.Sh_Pos:=New_Pos;
   List_ShowTitle(L);                   {*Affiche le Titre en Train de se Dplacer*}
{   List_ShowSliders(L);}
   If BTST(L.Id,8) Then List_Refresh(L);
   End;
End;

{ͻ

                     Renomme l'Item avec un InputText                       
 ͼ}

Function Rename_Item(L:TList; C:TCoordinates):Longint;
Var Com1:TInputText;                    {*Pour Rename...*}
    Cin1:String;
    ResCom:Byte;                        {*Rsultat du Gadget InputText*}
Begin                                   {*L'Item est Entirement Visible*}
Cin1:=List_GetStringCell(L,L.Pos_Item,L.Pos_Column);
If C.X2>=L.MaxX-2 Then C.X2:=L.MaxX-2;
InputText(C.X1+1,C.Y1+3, C.X2-C.X1, 255,L.Color,L.Color,2,$27,Com1,Cin1);
ResCom:=InputText_GetMsg(Com1,Cin1);
If ResCom=CMModified Then List_SetStringCell(L,L.Pos_Item,L.Pos_Column,Cin1);
List_ShowTitle(L);
List_Refresh(L);
Rename_Item:=L.Pos_Item;                {*Liste Modifie...*}
End;

{ͻ
                             FUNCTION List_Test                             
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: Resultat (Longint) = Get the selected Item number.               
               Return CMNone if nothing happen.                             
               Return -1 if a F5 is pressed.                                
               Return -2 if a CTRL A is pressed.                            
               Return -3 if a CTRL Q is pressed.                            
  EXPLAIN: Test and manage the List, selection, columns and all the list.   
  SEEALSO: List_TestKeys, List_TestSizeCol, List_TestMoveCol                
           List_TestSortList                                                
 ͼ}

Function List_Test(Var L:TList):Longint;
Var New_Pos:Integer;                    {*Calcul de l'Indice d'Affichage*}
    C:TCoordinates;
    A,B,D,E:Integer;                    {*Loops + Various*}
    Normal:Byte;                        {*Mode Tag Normal, Shift, Crtl...*}
    MinT,MaxT:Integer;                  {*Used pour Tagged avec SHIFT*}
    Mx,My:Word;                         {*Coordonnes Souris*}
    Ga,Mi,Dr:Boolean;                   {*Boutons Souris*}
    Max_Pos:Integer;                    {*Indice Maximum pour l'affichage*}
    Res:Boolean;                        {*Divers Rsultats Boolens*}
    Res_Keys:Longint;                   {*Rsultat Test Keys*}
    Mouse_Activation:Byte;              {*Activation Souris LMB ou Sans Boutons*}
    Max_ToTest:Integer;                 {*Indice Maximum pour Tester Items*}
    MouseOnEnableItem:Boolean;          {*La souris est sur un item...*}

Begin
List_Test:=CMNone;
If BTST(L.Id,4) Then Exit;              {*Liste Freezed / Disabled*}
{gotoxy(1,1);writeln('Qtt_Items=',L.Qtt_Items);
gotoxy(1,2);writeln('Qtt_Show=',L.Qtt_Show_Items);
gotoxy(1,3);writeln('Pos_Show=',L.Pos_Show);}

If Not L.Mouse_InList Then List_TestSizeCol(L);{*Resizige des Colonnes*}
If L.Taquet_Clicked Then Exit;          {*On Resize une Colonne*}

If Not L.Mouse_InList Then List_TestMoveCol(L);  {*Move Columns*}
If L.Title_Clicked Then Exit;           {*On Dplace une Colonne*}

If Not L.Mouse_InList Then List_TestSortList(L);
If L.Title_Clicked2 Then Exit;          {*On Tri la Liste*}

If BTST(L.Id,0) Then List_TestHint(L);{*Gre l'Info-Box*}

If BTST(L.Id,9) Then                    {*Select Items Enable*}
   Begin

   If (BTST(L.Id,7)) And (BTST(L.ASC[L.Pos_Column].Id,0)) And (Mse_TestDoubleClick) Then
      Begin                             {*Double Click = RENAME*}
      List_GetCellCoord(L,L.Pos_Item,L.Pos_Column,C);
      Res:=List_TestMouseOnCell(L,L.Pos_Item,L.Pos_Column);
      If (C.Y1+L.Item_SizeY+5<L.MaxY) And (Res) Then List_Test:=RENAME_ITEM(L,C);
      End;
   If (BTST(L.Id,7)) And (Kbd_GetKeyDown(VK_F2)) Then {*F2 = RENAME*}
      Begin
      L.Pos_Column:=List_GetEditColumn(L);
      Res:=List_GetCellCoord(L,L.Pos_Item,L.Pos_Column,C);
      If (C.Y1+L.Item_SizeY+5<L.MaxY) And (Res) Then List_Test:=RENAME_ITEM(L,C);
      End;

   If (Kbd_GetKeyDown(VK_CONTROL)) and (Kbd_GetKeyDown(VK_A)) And (BTST(L.Id,5))
      Then Begin                        {*CTRL A = Tag All*}
      List_TagAllItems(L);
      List_Refresh(L);
      List_Test:=-2;
      End;

   If (Kbd_GetKeyDown(VK_CONTROL)) and (Kbd_GetKeyDown(VK_Q))  Then {*CTRL Q = Toggle Items*}
      Begin
      List_ToggleAllItems(L);
      List_Refresh(L);
      List_Test:=-3;
      End;
   End;                                 {*End Select Items Enable*}

If (Not BTST(L.IdMore,1)) And (Kbd_GetKeyDown(VK_F5))  Then
   Begin                                {*F5 = UPDATE*}
   List_UnTagAllItems(L);

   L.Pos_Item:=0;
   L.Pos_Show:=List_MinItem;
   List_Sort(L,L.Sort_Column,L.Sort_Sens,0);
   List_ShowSliders(L);
   List_Refresh(L);
   List_Test:=-1;
   End;

If L.Qtt_Items>L.Qtt_Show_Items Then    {*On peut tester le Slider*}
   If Slider_GetMsg(L.Sv)=CMModified Then {*Slider Vertical...*}
      Begin
      New_Pos:=Get_NewPosY(L,L.Sv.Value); {*Calcule Nouvelle Position*}
      If L.Pos_Show<>New_Pos Then Begin
         L.Pos_Show:=New_Pos;           {*Dfinit nouveau dbut d'Affichage*}
         List_Refresh(L);
         End;
      End;

If L.Sh_Exist Then                      {*Slider Horizontal...*}
   Begin
   If Kbd_GetKeyDown(VK_LEFT) Then            {*Flche Gauche*}
      Begin
      Dec(L.Sh.Value,40);
      If L.Sh.Value<0 Then L.Sh.Value:=0;
      Move_ListHorizontal(L);
      End;
   If Kbd_GetKeyDown(VK_RIGHT) Then            {*Flche Droite*}
      Begin
      Inc(L.Sh.Value,40);
      If L.Sh.Value>L.Sh.Quantity Then L.Sh.Value:=L.Sh.Quantity;
      Move_ListHorizontal(L);
      End;

   If Slider_GetMsg(L.Sh)=CMModified Then Move_ListHorizontal(L);
   If (Not BTST(Id_Msg1,2)) And (L.Sh_Moved) Then
      Begin
      L.Sh_Moved:=FALSE;                {*List XMoved => Rafficher*}
      If (Not BTST(L.Id,8)) And (L.Sh_Pos<>L.Sh_OldPos) Then List_Refresh(L);
      L.Sh_OldPos:=L.Sh_Pos;
      End;
   End;
                                        {*LMB ou juste Passer dessus...*}
If (BTST(L.Id,1)) And (Not BTST(L.Id,5)) Then Mouse_Activation:=10
                                         Else Mouse_Activation:=1;
Mse_Get(Mx,My,Ga,Mi,Dr);                {*Lecture Souris...*}

If BTST(L.Id,9) Then Begin              {*Select Items Enable*}
   Normal:=0;                           {*Mode de Tag Standard de Base...*}
   If Kbd_GetKeyDown(VK_SHIFT) Then Normal:=1;{ SHIFT }
   If Kbd_GetKeyDown(VK_CONTROL) Then Normal:=2;{ CTRL  }

   If Normal=0 Then             {!}
   Begin
      Res_Keys := List_TestKeys(L);     {*Manage Arrow Keys...*}
      If (Res_Keys>0) And (Not BTST(L.Id,6)) Then; List_Test:=Res_Keys
   End;

   If (Mse_Clicked(1)) And (Not L.Mouse_Clicked) Then
      Begin                             {*Click LMB to Drag in List*}
      L.Mouse_Clicked:=TRUE;
      If (Mx>T_Clip.X1+L.X1) And (Mx<T_Clip.X1+L.X2) And
         (My>T_Clip.Y1+L.BaseY-6) And (My<T_Clip.Y1+L.MaxY-6) Then L.Mouse_InList:=TRUE;
      End;
   If Not Mse_Clicked(1) Then Begin L.Mouse_InList:=FALSE; L.Mouse_Clicked:=FALSE; End;

   If (Mse_TestBox(T_Clip.X1+L.X1, T_Clip.Y1+L.Y1-20, T_Clip.X1+L.X2, T_Clip.Y1+L.BaseY-10,1)) And
      (L.Mouse_InList) And (L.Pos_Show>List_MinItem) Then
      Begin                             {*Remonte la Liste avec la Souris*}
      Dec(L.Pos_Show);
      If (Not BTST(L.Id,5)) Or (Normal=0) Then List_UnTagItem(L,L.Pos_Item);
      L.Pos_Item:=L.Pos_Show;
      List_TagItem(L,L.Pos_Item);
      List_ShowSliders(L);
      List_Refresh(L);
      If Not BTST(L.Id,6) Then List_Test:=L.Pos_Item;
      BSET(L.IdIn,0);
      End;

   Max_Pos:=L.Qtt_Items-L.Qtt_Show_Items+1; {Get_NewPosY(L,L.Qtt_Items);}
   If (Mse_TestBox(T_Clip.X1+L.X1, T_Clip.Y1+L.MaxY+6, T_Clip.X1+L.X2, T_Clip.Y1+L.MaxY+26,1)) And
      (L.Mouse_InList) And (L.Pos_Show<Max_Pos) Then
      Begin                             {*Descend la Liste avec la Souris*}
      Inc(L.Pos_Show);
      If (Not BTST(L.Id,5)) Or (Normal=0) Then List_UnTagItem(L,L.Pos_Item);
      L.Pos_Item:=L.Pos_Show+L.Qtt_Show_Items-1;
      List_TagItem(L,L.Pos_Item);
      List_ShowSliders(L);
      List_Refresh(L);
      If Not BTST(L.Id,6) Then List_Test:=L.Pos_Item;
      BSET(L.IdIn,0);
      End;

   If (Not BTST(L.IdMore,3)) And (Kbd_GetKeyDown(VK_RETURN)) Then List_Test:=L.Pos_Item; {*ENTER Press*}

   If ((BTST(L.Id,6)) And (BTST(L.IdIn,0))) Then {! SCINDER ce gros bloc qui buggue !}
      If (BTST(L.IdIn,1)) Or
         ((Not BTST(L.IdIn,1)) And (Not Mse_Clicked(1)) And (Not BTST(L.Id,1))) Or
         ((Not BTST(L.IdIn,1)) And (Mse_Clicked(1)) And (BTST(L.Id,1))) Then
         If Mse_TestBox(T_Clip.X1+L.X1, T_Clip.Y1+L.Y1, T_Clip.X1+L.MaxX, T_Clip.Y1+L.MaxY,10) Then
            Begin                       {*Souris Relache*}
            List_Test:=L.Pos_Item; BCLR(L.IdIn,0); BCLR(L.IdIn,1);
            End;
                                        {*Slection Items de Base*}
   If (BTST(L.IdIn,1)) And (Not BTST(L.Id,6)) Then
      Begin                             {*Item Selected sans relacher souris*}
      List_Test:=L.Pos_Item; BCLR(L.IdIn,0); BCLR(L.IdIn,1);
      End;
                                        {*Bug dtect dans MAE Double affichage des Images*}
(*   If ((Not BTST(L.Id,6)) And (BTST(L.IdIn,0))) Then
         Begin                          {*Item Selected sans relacher souris*}
         List_Test:=L.Pos_Item; BCLR(L.IdIn,0); BCLR(L.IdIn,1);
         End;*)

                                        {=== TESTE ITEMS ===}
   Max_ToTest:=L.Pos_Show+L.Qtt_Show_Items-1;{*Indice Maximum  Tester*}
   If Max_ToTest>L.Qtt_Items Then Max_ToTest:=L.Qtt_Items;


   If (L.MOx<>Mx) Or (L.MOy<>My) Then   {*On utilise plus le clavier*}
      Begin L.MOx:=Mx; L.MOy:=My; BCLR(L.IdIn,1); End;

   MouseOnEnableItem:=FALSE;            {*De Base*}
   If Not BTST(L.IdIn,1) Then           {*Use Keyboard to Select Item ?*}
   For A:=L.Pos_Show to Max_ToTest do   {*Indice Maximum  Tester*}
      Begin
      If (List_TestMouseOnItem(L,A)) And (Not List_TestIdItem(L,A,0)) Then
         Begin                          {*Teste si Souris est sur un Item*}
         MouseOnEnableItem:=TRUE;
         For E:=1 to L.Qtt_Columns do   {*Get Colonne Clique...*}
            If List_TestMouseOnCell(L,A,E) Then L.Pos_Column:=E;

         If (Mse_Clicked(Mouse_Activation)) And (A<>L.Pos_Item) And (Not BTST(Id_Msg1,2)) Then
            Begin                       {*Tag / UnTag Item...*}
            If BTST(L.Id,5) Then        {*Multislection Tag*}
               Begin
               If Normal=0 Then Begin   {*Click Souris Simple*}
                  D:=L.Qtt_Tagged_Items;
                  List_UnTagAllItems(L);
                  List_TagItem(L,A);

                  If D>1 Then List_Refresh(L)
                     Else Begin
                     List_ShowItem(L,A);
                     List_ShowItem(L,L.Pos_Item);
                     End;
                  End;
               If Normal=1 Then Begin   {*Touche SHIFT*}
                  MinT:=L.Pos_Item; MaxT:=A;
                  If MinT>MaxT Then Exg(MinT,MaxT);
                  For B:=MinT to MaxT do List_TagItem(L,B);
                  List_Refresh(L);
                  End;
               If Normal=2 Then         {*Touche CTRL*}
                  Begin
                  List_ToggleItem(L,A);
                  List_ShowItem(L,A);
                  End;
               End
               Else Begin               {*Monoslection Tag*}
               If L.Pos_Item>0 Then Begin
                  List_UnTagItem(L,L.Pos_Item);
                  List_ShowItem(L,L.Pos_Item);
                  End;
               List_TagItem(L,A);
               List_ShowItem(L,A);
               End;
            If Not BTST(L.Id,6) Then List_Test:=A; {*Renvois Item Tagg*}
            BSET(L.IdIn,0);
            L.Pos_Item:=A;
            End;                        {*End Tag/UnTag Item*}
         End;                           {*End "BoxMouse" On est sur un Item*}
      End;                              {*End "For" Parcours des Items*}
   End;                                 {*End EnableSelect Items*}

If BTST(L.IdMore,2) Then                {*Hand Pointer over Items ?*}
   If List_TestMouseOnList(L)=1
      Then Begin
         L.Mouse_OverList:=TRUE;
         If MouseOnEnableItem Then BSET(Id_Gad1,5) Else BCLR(Id_Gad1,5)
         End
      Else If L.Mouse_OverList Then     {*Remet pointeur normal*}
         Begin
         L.Mouse_OverList:=FALSE;
         If BTST(Id_Gad1,5) Then BCLR(Id_Gad1,5);
         End;
End;                                    {*End Function*}

{ͻ

                         PROCEDURE Draw_ColumnLine                          
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    

           Px (Integer) = Position X de la ligne  Dessiner.                
  OUT....: /                                                                
  NB.....: Fonction  usage interne. Ne peux tre appele de l'extrieur.   
  EXPLAIN: Affiche en XOR une ligne verticale sous le Taquet.               
 ͼ}

Procedure Draw_ColumnLine(L:TList; Px:Integer);
Var C:TCoordinates;
Begin
List_GetTaquetCoord(L,L.Pos_Taquet,C);
VESA_SetColor(CLLineUp);

VESA_SetWriteMode(XORPut);
Mse_Hide;
VESA_Line(Px+5, L.Y1+1, Px+5, L.MaxY-1);
Mse_Show;
VESA_SetWriteMode(NormalPut);
End;


{ͻ
                         PROCEDURE List_TestSizeCol                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Test and manage the columns Taquets (Size of columns).           
  SEEALSO: List_Test                                                        
 ͼ}

Procedure List_TestSizeCol(Var L:TList);
Var C:TCoordinates;
    Taq:Integer;                        {*Loops*}
    Mx,My:Word;
    Ga,Mi,Dr:Boolean;
    Delta:Integer;                      {*Calcul de Size Column*}

Function Get_DeltaSizeColumn:Integer;   {*Calcule New Size for Column*}
Begin
List_GetTaquetCoord(L,L.Pos_Taquet,C);
Get_DeltaSizeColumn:=C.X1-L.PxGadget;
End;

Begin
If Not BTST(L.Id,0) Then Exit;          {*Pas de Barre de Titres !*}
If Not BTST(L.Id,3) Then Exit;          {*Cannot Resize Columns !*}
If L.Sh_Moved Then Exit;                {*Slider Horizontal Moved !*}

L.SurUnTaquet:=FALSE;
If L.Title_Clicked Then Exit;           {*On Dplace une Colonne*}
If L.Title_Clicked2 Then Exit;          {*On Tri une Colonne*}

Mse_Get(Mx,My,Ga,Mi,Dr);                {*Teste Souris...*}
If Not L.Taquet_Clicked Then
   For Taq:=1 to L.Qtt_Columns do
      Begin
      List_GetTaquetCoord(L,Taq,C);     {*Get Taquet Coordinates*}
      If (Mse_TestBox(T_Clip.X1+C.X1+2, T_Clip.Y1+C.Y1+7, T_Clip.X1+C.X2+2, T_Clip.Y1+C.Y2+7, 10)) And
         (Not BTST(L.ASC[Taq].Id,3)) And{*Colonne non cache ?*}
         (Mx<L.MaxX+T_Clip.X1-5) Then Begin
         L.SurUnTaquet:=TRUE;
         L.Pos_Taquet:=Taq;             {*Numro du Taquet sur lequel on est*}
         End;
      End;

If (L.SurUnTaquet) Or (L.Taquet_Clicked){*Pointeurs Souris*}
   Then BSET(Id_Gad1,8) Else BCLR(Id_Gad1,8);

If Not Mse_Clicked(1) Then Begin        {*On ne Clique plus sur le Taquet*}
   If L.Taquet_Clicked Then Begin
      Draw_ColumnLine(L,L.PxGadget);
      Delta:=Get_DeltaSizeColumn;
      If Delta<>0 Then Begin
         Dec(L.ASC[L.Pos_Taquet].Size,Delta);
         List_Show(L);                  {*Raffiche la Liste...*}
         End;
      End;
   L.Taquet_Clicked:=FALSE;
   End;

If (L.SurUnTaquet) And (Mse_TestDoubleClick) Then
   Begin                                {*Double Click Taquet => Adjust Column*}
   List_AdjustColumn(L,L.Pos_Taquet);
   L.Sh_Pos:=0;                         {*Repositionne obligatoirement  gauche*}
   List_ShowTitle(L);
   List_Show(L);
   End;

If (L.SurUnTaquet) And (Mse_Clicked(1)) Then
   If Not L.Taquet_Clicked Then         {*1er Click sur le Taquet*}
      Begin
      List_GetTaquetCoord(L,L.Pos_Taquet,C);

      Draw_ColumnLine(L,C.X1);
      L.Taquet_Clicked:=TRUE;
      L.MouseX:=Mx;
      L.PxGadget:=C.X1;
      End;

If (L.Taquet_Clicked) And (Mse_Clicked(1)) Then
   Begin                                {*On Dplace le Taquet*}
   List_GetTaquetCoord(L,L.Pos_Taquet-1,C);
   If L.Pos_Taquet=1 Then C.X1:=L.X1;   {*Correction 1er Taquet*}
   If C.X1<L.X1-5 Then C.X1:=L.X1-5;    {*Infrieur au Bord Gauche !*}

   If Mx<=C.X1+T_Clip.X1+10 Then Mx:=C.X1+T_Clip.X1+10;     {*Borne Min Atteinte*}
   If Mx>=L.MaxX+T_Clip.X1-10 Then Mx:=L.MaxX+T_Clip.X1-10; {*Borne Max Atteinte*}

   If Mx<>L.MouseX Then                 {*Taquet dplac...*}
      Begin
      Delta:=Get_DeltaSizeColumn;
{gotoxy(1,1); Writeln('Delta=   ',Delta,' ');
gotoxy(1,2); Writeln('LMouseX= ',L.MouseX,' ');
gotoxy(1,3); Writeln('PxTaquet=',L.PxGadget,' ');
List_GetTaquetCoord(L,L.Pos_Taquet,C);
gotoxy(1,4); Writeln('C.X1=    ',C.X1,' ');
gotoxy(1,5); Writeln('Taquet=  ',L.Pos_Taquet,' ');
gotoxy(12,6); Writeln('Mx=',Mx,' ');}
      Draw_ColumnLine(L,L.PxGadget);
      L.PxGadget:=L.PxGadget+(Mx-L.MouseX);
      List_GetTaquetCoord(L,L.Pos_Taquet-1,C);
      If L.Pos_Taquet=1 Then C.X1:=L.X1;{*Correction 1er Taquet*}
      If L.PxGadget<C.X1 Then L.PxGadget:=C.X1;
      Draw_ColumnLine(L,L.PxGadget);
      L.MouseX:=Mx;
      End;
   End;
End;

{ͻ
                          PROCEDURE Draw_TitleBar                           
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           C (TCoordinates) = TPointer sur structure Coordonnes.           
  OUT....: /                                                                
  NB.....: Procdure  usage interne. Ne peux tre appele de l'extrieur.  
  EXPLAIN: Affiche en XOR une ligne verticale sous le Taquet.               
 ͼ}

Procedure Draw_TitleBar(L:TList; C:TCoordinates);
Begin                                   {*A optimiser pour que ce ne flippe pas*}
Mse_Hide;
If C.X1-1<=L.X1 Then Inc(C.X1);
VESA_SetWriteMode(XORPut);
Bevel (C.X1, L.Y1+1, C.X2+1, L.BaseY-1, CLLineUp);
VESA_SetWriteMode(NormalPut);
Mse_Show;
End;

{ͻ

                         PROCEDURE List_TestMoveCol                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Test and manage the moving of list columns.                      
  SEEALSO: List_Test                                                        
 ͼ}

Procedure List_TestMoveCol(Var L:TList);
Const MBTA=1;                           {*Mouse Button to Activate Function*}
Var C:TCoordinates;
    Colonne:Byte;                       {*Pour parcourir toutes les Colonnes*}
    Mx,My:Word;
    Ga,Mi,Dr:Boolean;
    Delta:Integer;

Procedure Calcule_AndDrawBox;           {*Calcule Position du Box et le Trace*}
Begin
List_GetCellCoord(L,L.Pos_Show,L.Title_Number,C);
Delta:=L.MouseX-L.PxGadget;
C.X1:=C.X1+DelTa; C.X2:=C.X2+Delta;
Draw_TitleBar(L,C);
End;

Begin
If Not BTST(L.Id,0) Then Exit;          {*Pas de Barre de Titres !*}
If Not BTST(L.Id,2) Then Exit;          {*Cannot Move Columns !*}
If L.SurUnTaquet Then Exit;             {*On Resize dja une Colonne !*}
If L.Sh_Moved Then Exit;                {*Slider Horizontal Moved !*}

Mse_Get(Mx,My,Ga,Mi,Dr);                {*Get Coordonnes Souris*}
For Colonne:=1 to L.Qtt_Columns do      {*Parcours toutes les Colonnes*}
   Begin
   List_GetCellCoord(L,L.Pos_Show,Colonne,C);
   If Mse_TestBox(T_Clip.X1+C.X1+1, T_Clip.Y1+L.Y1+1, T_Clip.X1+C.X2+1, T_Clip.Y1+L.BaseY+1, 10) Then
      If (Mse_Clicked(MBTA)) And (Not L.Title_Clicked) Then
         Begin
         L.Title_Clicked:=TRUE;         {*1 Titre est Cliqu...*}
         L.Title_Number:=Colonne;
         L.Title_NewNumber:=Colonne;
         L.MouseX:=Mx;
         L.PxGadget:=Mx;
         List_GetCellCoord(L,L.Pos_Show,L.Title_Number,C);
         Draw_TitleBar(L,C);
         Mse_SetLimit(L.X1+(Mx-C.X1), 0, L.MaxX-(C.X2-Mx)-3, VESA_GetMaxY);
         C.X1:=L.X1-1; C.Y1:=0; C.X2:=L.X2-1; C.Y2:=VESA_GetMaxY;
         MseZone(L.Pointer,C,10,MPHand,''); {*Define mouse pointer*}
         End;

      If Not Mse_Clicked(MBTA) Then     {*Relache la Souris...*}
         Begin
         If L.Title_Clicked Then
            Begin
            Mse_SetLimit(0,0,VESA_GetMaxX,VESA_GetMaxY);
            Calcule_AndDrawBox;
            If L.Title_NewNumber<>L.Title_Number Then
               Begin                    {*Colonnes Echanges !*}
               List_SwapColumns(L,L.Title_Number,L.Title_NewNumber);
               List_Show(L);
               End;
            End;
         L.Title_Clicked:=FALSE;
         End;
   End;                                 {*Fin du Parcours des Colonnes*}

If (L.Title_Clicked) And (Mse_Clicked(MBTA)) Then
   Begin                                {*On dplace la Boite...*}
{Directvideo:=false; gotoxy(1,1); writeln(Random(24)+65);}
   MseZone_GetMsg(L.Pointer);        {*Mouse pointer management*}

   If Mx<>L.MouseX Then
      Begin
      Calcule_AndDrawBox;               {*Efface l'ancienne*}
      L.MouseX:=Mx;
      Calcule_AndDrawBox;               {*Affiche la Nouvelle*}
      For Colonne:=1 to L.Qtt_Columns do{*Parcours toutes les Colonnes*}
         Begin
         List_GetCellCoord(L,L.Pos_Show,Colonne,C);
         If Mse_TestBox(T_Clip.X1+C.X1, 0, T_Clip.X1+C.X2, VESA_GetMaxY,10) Then L.Title_NewNumber:=Colonne;
         End;                           {*Fin du Parcours des Colonnes*}
      End;                              {*Fin la Souris s'est Dplace*}
   End;                                 {*Fin on Dplace un Titre*}


{Gotoxy(1,2); Writeln('Colonne       =',L.Title_Number,' ');
Gotoxy(1,5); Writeln('New Col       =',L.Title_NewNumber,' ');
Gotoxy(1,4); Writeln('Delta         =',Delta,' ');
Gotoxy(1,6); Writeln('X1=',C.X1,' X2=',C.X2,' ');
Gotoxy(1,2); Writeln('Colonne       =',L.Title_Number,' ');
Gotoxy(1,3); Writeln('Title Clicked =',L.Title_Clicked,' ');}
End;

{ͻ
                          PROCEDURE Draw_TitleBox                           
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
           Title (Integer) = Numro du Titre.                               
  OUT....: /                                                                
  NB.....: Fonction  usage interne. Ne peux tre appele de l'extrieur.   
  EXPLAIN: Affiche en XOR une boite autour du Titre.                        
 ͼ}

Procedure Draw_TitleBox(L:TList; Title:Integer);
Var C:TCoordinates;
Begin
List_GetCellCoord(L,L.Pos_Show,Title,C);
If C.X1-1<=L.X1 Then Inc(C.X1);
If C.X2>=L.X2-2 Then C.X2:=L.X2-2;
VESA_SetColor(CLLineUp);
VESA_SetWriteMode(XORPut);
Mse_Hide;
VESA_Rectangle(C.X1-1, L.Y1-5, C.X2, L.BaseY-7);
Mse_Show;
VESA_SetWriteMode(NormalPut);
End;

{ͻ
                        PROCEDURE List_TestSortList                         
 ͹
  IN.....: List (TList) = Pointer to the list structure.                    
  OUT....: /                                                                
  EXPLAIN: Test and manage the Items sorting.                               
  SEEALSO: List_Test                                                        
 ͼ}

Procedure List_TestSortList(Var L:TList);
Const MBTA=3;                           {*Mouse Button to Activate Function*}
Var C:TCoordinates;
    Colonne:Byte;                       {*Pour parcourir toutes les Colonnes*}
    Mx,My:Word;
    Ga,Mi,Dr:Boolean;
    OnTitle:Boolean;                    {*Mouse over Title*}

Begin
{Gotoxy(1,1); Writeln(L.Sh_Moved,' ');}
If Not BTST(L.Id,0) Then Exit;          {*Pas de Barre de Titres !*}
If Not BTST(L.Id,12) Then Exit;         {*User Cannot Sort Items !*}
If L.SurUnTaquet Then Exit;             {*On Resize dja une Colonne !*}
If L.Sh_Moved Then Exit;                {*Slider Horizontal Moved !*}

Mse_Get(Mx,My,Ga,Mi,Dr);                {*Get Coordonnes Souris*}

OnTitle:=FALSE;

For Colonne:=1 to L.Qtt_Columns do      {*Parcours toutes les Colonnes*}
   Begin
   List_GetCellCoord(L,L.Pos_Show,Colonne,C);
   If C.X2>=L.MaxX-2 Then C.X2:=L.MaxX-2;
   If Mse_TestBox(T_Clip.X1+C.X1+1, T_Clip.Y1+L.Y1, T_Clip.X1+C.X2+1, T_Clip.Y1+L.BaseY, 10) Then
      Begin
      OnTitle:=TRUE;                    {*Souris Over Title Cell*}
      If (Mse_Clicked(MBTA)) And (Not L.Title_Clicked2) And (C.X1<L.X2) Then
         Begin
         L.Title_Clicked2:=TRUE;        {*1 Titre est Cliqu...*}
         L.Title_Number:=Colonne;
         Draw_TitleBox(L,L.Title_Number);
         End;
      If Not Mse_Clicked(MBTA) Then     {*Relache la Souris...*}
         Begin
         If L.Title_Clicked2 Then
            Begin
            Draw_TitleBox(L,L.Title_Number);
            If L.Sort_Sens=Sort_AZ Then L.Sort_Sens:=Sort_ZA
                                   Else L.Sort_Sens:=Sort_AZ;
            L.Sort_Column:=L.Title_Number;
            List_Sort(L,L.Sort_Column,L.Sort_Sens,0);
            L.Pos_Item:=List_GetTaggedItem(L);
            List_ShowTitle(L);
            List_Refresh(L);
            End;
         L.Title_Clicked2:=FALSE;

         End;                           {*Fin: Relachement Souris*}
      End;                              {*Fin: La souris est sur la barre de Titre*}
   End;                                 {*Fin: Parcours des Colonnes*}

If OnTitle Then BSET(Id_Gad1,12)        {*Mouse over Title*}
           Else BCLR(Id_Gad1,12);
End;

{ͻ
                             FUNCTION File_Sort                             
 ͹
  IN.....: FName (STRING) = Text file name to sort.                         
           Column (BYTE) = A column number.                                 
           Sens (BYTE) = (Sort_AZ) 0 = Alphabetical order.                  
                         (Sort_ZA) 1 = Reverse order.                       
           DataType (BYTE) = Data type of the column for the comparison :   
                0 = Automatic                                               
                1 = String comparison                                       
                2 = Real/Integer comparison                                 
           Sep (CHAR) = Columns char separator.                             
  OUT....: (BOOLEAN) = TRUE=Ok else FALSE if an error occured.              
  EXPLAIN: Sort a text file using the lists functions.                      
 ͼ}

Function File_Sort(FName:String; Col,Sens,DataType:Byte; Sep:Char):Boolean;
Var L:TList;
Begin
File_Sort:=FALSE;
If Not File_TestExist(FName) Then Exit; {*Fichier introuvable !*}
List_Define(L,Str_Multiply(Sep,MAX_COL-1),Sep,0,0,0,0, File_CountLines(FName)+10, 15,12,$1BED);
List_Load(L,FName);
List_Sort(L,Col,Sens,DataType);         {*Tri la liste*}
List_Save(L,FName);
List_Done(L);

File_Sort:=TRUE;
End;

{*-------------------------- PROGRAMME PRINCIPAL ---------------------------*}

Begin

End.
