{ͻ
                                UNIT MosMath                                
 ͹
  CREATOR....: CHEVEAU Frdric & AUZEILL Alban                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 22.11.1995                                                   
  COUNTRY....: Perpignan - IMERIR (FRANCE)                                  
  DESCRIPTION: Mathematics Functions Management.                            
  AUTONOMOUS.: Yes                                                          
  UNIT SIZE..: 1.185 Lines and (29.040 Bytes compiled)                      
  NB.........: All arguments are in radians.                                
  BUGS.......: Crash with the "ROUND" function when displaying (Overflow).  
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosMath;

{$Mode Objfpc}

INTERFACE

Var
   Mat_Coefangle:Extended;                      {*Coef to apply to a number to get it in Radian*}
   Mat_ModeAngle:String[3];                     {*String DEG,RAD,GRD*}
   Mat_Base:integer;                            {*Current numeric base*}
   Mat_Ans:extended;                            {*Result of the previous calcul*}

Function TAN(x:extended):extended;              {*Tangente*}
Function COT(x:extended): extended;             {*Cotangente*}
Function SEC(x:extended): extended;             {*Secante*}
Function COSEC(x:extended): extended;           {*Cosecante*}

Function ARCSIN(x:extended):extended;           {*ARC Sinus*}
Function ARCCOS(x:extended):extended;           {*ARC Cosinus*}
{La fonction "ARCTAN" est dfinie par le TP7}   {*ARC Tangante*}
Function ARCCOT(x:extended): extended;          {*ARC Cotangente*}
Function ARCSEC(x:extended): extended;          {*ARC Secante*}
Function ARCCOSEC(x:extended): extended;        {*ARC Cosecante*}

Function SINH(x:extended): extended;            {*Sinus Hyperbolic*}
Function COSH(x:extended): extended;            {*Cosinus Hyperbolic*}
Function TANH(x:extended): extended;            {*Tangente Hyperbolic*}
Function COTH(x:extended): extended;            {*Cotangente Hyperbolic*}
Function SECH(x:extended): extended;            {*Secante Hyperbolic*}
Function COSECH(x:extended): extended;          {*Cosecante Hyperbolic*}

Function ARCSINH(x:extended): extended;         {*ARC Sinus Hyperbolic*}
Function ARCCOSH(x:extended): extended;         {*ARC Cosinus Hyperbolic*}
Function ARCTANH(x:extended): extended;         {*ARC Tangente Hyperbolic*}
Function ARCCOTH(x:extended): extended;         {*ARC Cotangente eHyperbolic*}
Function ARCSECH(x:extended):extended;          {*ARC Secante Hyperbolic*}
Function ARCCSCH(x:extended):extended;          {*ARC Cosecante Hyperbolic*}

Function LOG10(x:extended):extended;            {*LOG Base 10*}
Function LOGN(x,Base:extended):extended;        {*LOG Base n*}
Function POWER(x,Exponent:extended):extended;   {*Power function*}
Function ROOT(x,TheRoot:extended):extended;     {*Square root*}
Function FAC(x:extended):extended;              {*Factoriel*}
Function INV(x:extended):extended;              {*Inverse*}

Function Solve(formule:string;var resultat:string):integer{*Mathematical Analysor*};

{ͻ
                              IMPLEMENTATION                                
 ͼ}

IMPLEMENTATION

Function Lower(SUP:String):String;      {*Passe en Minuscules*}
Var      I:Integer;
         ST1:String;
Begin
ST1:=SUP;
For I:=1 to Length(ST1) do
If (Ord(St1[i])>64) and (Ord(St1[i])<91) then St1[i]:=Chr(Ord(St1[i])+32);
Lower:=ST1;
End;

{ͻ
                              --- ROUTINES ---                              
 ͹
  CREATEURS: F.Cheveau as Zuul                                              
  COMMENCE.: Le 22.11.95.                                                   
  RELEASE..: Le 24.11.95  l'IMERIR.                                        
  CONTENU..: Routines de maths, Trigo, Log, Fac...                          
  AIDE.....: Base sur l'unit de Juhani KAUKORANTA Sysop Pooki BBS Finland.
 ͼ}
 {-----------------}
 {  Trigonomtrie  }
 {-----------------}

{ͻ
                                FUNCTION TAN                                
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function TAN(x: extended): extended;
Begin TAN:=SIN(x)/COS(x); End;

{ͻ
                                FUNCTION COT                                
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function COT(x:extended): extended;
Begin COT:=1./TAN(x); End;

{ͻ
                                FUNCTION SEC                                
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function SEC(x:extended): extended;
Begin SEC:=1./COS(x); End;

{ͻ
                               FUNCTION COSEC                               
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function COSEC(x:extended): extended;
Begin COSEC:=1./SIN(x); End;

{ͻ
                               FUNCTION SINH                                
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function SINH(x:extended):extended;
Begin SINH:=(EXP(x)-EXP(-x))/2.; End;

{ͻ
                               FUNCTION COSH                                
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function COSH(x:extended): extended;
Begin COSH:=(EXP(x)+EXP(-x))/2.; End;

{ͻ
                               FUNCTION TANH                                
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function TANH(x:extended): extended;
Begin TANH:=SINH(x)/COSH(x); End;

{ͻ
                               FUNCTION COTH                                
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function COTH(x: extended): extended;
Begin COTH:=SINH(x)/COSH(x); End;

{ͻ
                               FUNCTION SECH                                
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function SECH(x:extended): extended;
Begin SECH:=1./COSH(x); End;

{ͻ
                              FUNCTION COSECH                               
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function COSECH(x:extended): extended;
Begin COSECH:=1./SINH(x); End;

{ͻ
                              FUNCTION ARCSIN                               
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function ARCSIN(x:extended):extended;
Begin
If ABS(x)=1. THEN ARCSIN := x*Pi/2.
             ELSE ARCSIN:=ARCTAN(x/SQRT(-SQR(x)+1));
End;

{ͻ
                              FUNCTION ARCCOS                               
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function ARCCOS(x:extended):extended;
Begin
If x = 1. THEN ARCCOS:=0.
          ELSE IF x = -1. THEN ARCCOS :=Pi
                          ELSE ARCCOS:=-ARCTAN(x/SQRT(-SQR(x)+1))+Pi/2.;
End;

{ͻ
                              FUNCTION ARCCOT                               
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function ARCCOT(x:extended): extended;
Begin ARCCOT:=ARCTAN(1./x); End;

{ͻ
                              FUNCTION ARCSEC                               
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function ARCSEC(x:extended): extended;
Begin ARCSEC:=ARCCOS(1./x); End;

{ͻ
                             FUNCTION ARCCOSEC                              
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function ARCCOSEC(x:extended): extended;
Begin ARCCOSEC:=ARCSIN(1./x); End;

{ͻ
                              FUNCTION ARCSINH                              
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function ARCSINH(x:extended): extended;
Begin ARCSINH:=LN(x+SQRT(x*x+1.0)); End;

{ͻ
                              FUNCTION ARCCOSH                              
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function ARCCOSH(x:extended): extended;
Begin ARCCOSH:=LN(x+SQRT(x*x-1.0)); End;

{ͻ
                              FUNCTION ARCTANH                              
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function ARCTANH(x:extended): extended;
Begin ARCTANH:=LN((1.+x)/(1.-x))/2.; End;

{ͻ
                              FUNCTION ARCCOTH                              
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function ARCCOTH(x:extended): extended;
Begin ARCCOTH:=LN((x+1.0)/(x-1.0))/2.; End;

{ͻ
                              FUNCTION ARCSECH                              
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function ARCSECH (x:extended):extended;
Begin ArcSech:=ArcCosh(1./x); End;

{ͻ
                              FUNCTION ARCCSCH                              
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function ARCCSCH (x:extended):extended;
Begin ArcCsch:=ArcSinh(1./x); End;

{---------------------------------}
{  Logarithms, Powers, and Roots  }
{---------------------------------}

{ͻ
                               FUNCTION Log10                               
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function Log10 (x:extended):extended;
Begin Log10:=ln(x)/ln(10); End;

{ͻ
                               FUNCTION LogN                                
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
           Base (EXTENDED) = Logarithm base.                                
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function LogN (x,base:extended):extended;
Begin LogN:=ln(x)/ln(base); End;

{ͻ
                               FUNCTION Power                               
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
           Exponent (EXTENDED) = Exponent for the power.                    
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function Power(x,Exponent:extended):extended;
Begin if x<>0. then Power:=Exp(Exponent*ln(x)) else Power:=0.; End;

{ͻ
                               FUNCTION Root                                
 ͹
  IN.....: X (EXTENDED) = Input value for Square Root.                      
           TheRoot (EXTENDED) = Square Root Power.                          
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function Root(x,TheRoot:extended):extended;
Begin
Root := Power(x,(1./x));
TheRoot:=TheRoot;                       {*Pour implmenter plus tard et sucrer Hint FPC*}
End;

{ͻ
                                FUNCTION Fac                                
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function Fac(x:extended) : extended;
Var N,Cpt:Longint; Res:extended;
Begin
N:=trunc(x); Res:=1.;
For Cpt:=2 to N do Res:=Res*Cpt;
Fac:=Res
End;

{ͻ
                                FUNCTION Inv                                
 ͹
  IN.....: X (EXTENDED) = Input value.                                      
  OUT....: (EXTENDED) = Calculated value.                                   
  EXPLAIN: Calculate value using the above mathematical function.           
 ͼ}

Function Inv(X:extended):extended;
Begin Inv:=1./X;
End;

{ͻ
                               FUNCTION Solve                               
 ͹
  IN.......: Formule (STRING) = Mathematical expression to evaluate.        
             Resultat (STRING) = Calculated value.                          
  OUT......: Return 0 if no error else return error position in string.     
  AUTHOR...: Alban Auzeill as Falcon.                                       
  EXPLAIN..: Numerical Analysor Expressions.                                
 ͼ}

Function Solve(formule:string;var resultat:string):integer;

{!!! a mettre dans les fonctions de pile }
{ͻ
      --- CONST --- fonction SOLVE      
 ͼ}
Const
    maxpile  = 10; { corespond au nombre de priorit +1 }
{    maxarg   = 1;}  { corespond au nombre maximum d'argument des fonctions }
{ͻ
      --- TYPES --- fonction SOLVE      
 ͼ}
 TYPE
    t_ph = record ch:string; deb,err:integer; end; { formule,position,erreur }
{ͻ
  --- VARIABLES --- fonction SOLVE      
 ͼ}
 VAR
 ph          : t_ph;    { formule,position actuelle dans formule,erreur}

 numcommande : integer; { numro de la commande choisie }

{ͻ
  --- PROTOTYPE --- fonction SOLVE      
 ͼ}
 function Calc:extended; forward; { permet un appel rcurant }

{ͻ
                    --- OUTILS de la fonction SOLVE ---                     
 ͹
 :                                                                           :}
 {---------------------------------------------------------------------}
 { Envoie un message comme rsultat de la formule, et dfinie l'erreur }
 procedure Message(pos:integer;mess:string);
 begin if ph.err=0 then begin
    ph.err:=pos;
    ph.ch:=mess;
 end else ph.ch:=ph.ch+' , '+mess; end;

 {--------------------------------}
 { Converti un chiffre en un char }
 function ValToStr(val:longint):char;
 begin
   if val<10
    then ValToStr:=chr(val+ord('0'))
    else ValToStr:=chr(val+ord('A')-10);
 end;

 {-----------------------------------------}
 { Converti une valeur double en un string }
 procedure ConvStr(val:double);
 var d:integer; signe:boolean;
     temp:double; lon:longint;
 begin if ph.err=0 then begin
  if Mat_base=10 then
   begin
     if ((abs(val)<1E10) and (abs(val)>1E-10)) or (val=0.0) then
      begin
       d:=0;
       temp:=val;
       while frac(temp)<>0 do begin temp:=temp*10; inc(d); end;
       str(val:1:d,ph.ch);
      end
     else str(val,ph.ch);
  end
   else
  begin
   lon:=round(val);
   signe:=false;
   if lon<0 then begin signe:=true; lon:=-lon; end;
   ph.ch:='';
   if lon=0 then ph.ch:='0'
    else while lon<>0 do

     begin
      ph.ch:=ValToStr(lon mod Mat_base)+ph.ch;
      lon:=lon div Mat_base;
     end;
   if signe then ph.ch:='-'+ph.ch;
  end;
 end;end;
{----------------------------------------------}
 { Teste si de caractre courant est un chiffre }
 function ChiffreIs:boolean;
 var valeur:byte;
 begin if ph.err=0 then begin
   valeur:=255;
   if (ph.ch[ph.deb]>='0') and (ph.ch[ph.deb]<='9')
    then valeur:=ord(ph.ch[ph.deb])-ord('0');
   if (ph.ch[ph.deb]>='a') and (ph.ch[ph.deb]<='z')
    then valeur:=ord(ph.ch[ph.deb])-ord('a')+10;
   if (ph.ch[ph.deb]>='A') and (ph.ch[ph.deb]<='Z')
    then valeur:=ord(ph.ch[ph.deb])-ord('A')+10;
   if valeur<Mat_base then ChiffreIs:=true else ChiffreIs:=false;
 end else ChiffreIs:=false; end;


 {--------------------------}
 { Lit un chiffre sur ph.ch }
 function Chiffre:byte;
 var valeur:byte;
 begin if ph.err=0 then begin
   valeur:=255;
   if (ph.ch[ph.deb]>='0') and (ph.ch[ph.deb]<='9')
    then valeur:=ord(ph.ch[ph.deb])-ord('0');
   if (ph.ch[ph.deb]>='a') and (ph.ch[ph.deb]<='z')
    then valeur:=ord(ph.ch[ph.deb])-ord('a')+10;
   if (ph.ch[ph.deb]>='A') and (ph.ch[ph.deb]<='Z')
    then valeur:=ord(ph.ch[ph.deb])-ord('A')+10;
   if valeur<Mat_base
     then begin inc(ph.deb); Chiffre:=valeur; end
     else begin Chiffre:=0; Message(ph.deb,'digit expected'); end;
 end else Chiffre:=0; end;

 {---------------------------------------}
 { Lit le signe + ou - devant une valeur }
 function PhSigne:integer;
 begin if ph.err=0 then begin
   while ph.ch[ph.deb]=' ' do inc(ph.deb);
   PhSigne:=1;
   if ph.ch[ph.deb]='-' then begin PhSigne:=-1; inc(ph.deb); end
   else if ph.ch[ph.deb]='+' then inc(ph.deb);
   while ph.ch[ph.deb]=' ' do inc(ph.deb);
 end else PhSigne:=1; end;

 {----------------------}
 { lit un nombre entier }
 function LireNombre:extended;
 var valeur:extended; signe:integer;
 begin if ph.err=0 then begin
  signe:=PhSigne; valeur:=0;
  if ChiffreIs then

    while ChiffreIs
    do valeur:=valeur*Mat_base+Chiffre
  else Message(ph.deb,'value expected');
  LireNombre:=signe*valeur;
 end else LireNombre:=0; end;

 {---------------------------------}
 { lit un nombre entier en base 10 }
 function LireEntier:LongInt;
 var val,signe:LongInt;
 begin if ph.err=0 then begin
  signe:=PhSigne;
  val:=0;
  while (ph.ch[ph.deb]>='0') and (ph.ch[ph.deb]<='9') do
   begin
    val:=val*10+ord(ph.ch[ph.deb])-$30;
    inc(ph.deb);
   end;
  LireEntier:=signe*val;
 end else LireEntier:=0; end;

{:                                                                           :
 ͹
                 --- FIN des OUTILS de la fonction SOLVE ---                
 ͼ}

{ͻ
                           --- LES OPERATIONS ---                           
 ͹
 :                                                                           :}
{ͻ
  TYPE OPERATION 
 ͼ}
 TYPE
  t_opp  = record name:string[8]; priority:byte; end; { dcrit une oppration }

{ͻ
  Dclaration 
 ͼ}

 CONST { oppration sur les rels }
  nbopp = 11;
  oppliste : array[1..nbopp]of t_opp =
    ((name:'+';priority:1),
     (name:'-';priority:1),
     (name:'*';priority:2),
     (name:'/';priority:2),
     (name:'^';priority:3),
     (name:'div';priority:2),
     (name:'mod';priority:2),
     (name:'and';priority:0),
     (name:'or';priority:0),
     (name:'xor';priority:0),
     (name:'eor';priority:0));

{ͻ
  Implmentation 
 ͼ}
 function CalcOpp(numopp,posch:integer;val1,val2:extended):extended;
 var resultat:extended;
 begin if ph.err=0 then begin

 {!!! penser a rajouter erreur si valeur rel pour div mod ... }

  resultat:=0;
  case numopp of
  {+  }  1:resultat:=val1+val2;
  {-  }  2:resultat:=val1-val2;
  {*  }  3:resultat:=val1*val2;
  {/  }  4:if val2<> 0 then  resultat:=val1/val2 else Message(posch,'Division by 0 !');
  {^  }  5:resultat:=power(val1,val2);{result:=exp(val2*ln(val1));}
  {div}  6:resultat:=trunc(val1) div trunc(val2);
  {mod}  7:resultat:=trunc(val1) mod trunc(val2);
  {and}  8:resultat:=trunc(val1) and trunc(val2);
  {or }  9:resultat:=trunc(val1) or  trunc(val2);
  {xor} 10:resultat:=trunc(val1) xor trunc(val2);
  {eor} 11:resultat:=trunc(val1) xor trunc(val2);
  else Message(posch,'Operation not implemented !');
  end;
  CalcOpp:=resultat;
 end else CalcOpp:=0; end;

{:                                                                           :
 ͹
                        --- FIN OPERATIONS ---                              
 ͼ}

{ͻ
                           --- LES FONCTIONS ---                            
 ͹
 :                                                                           :}
{ͻ
  TYPE FONCTION 
 ͼ}
 TYPE
   t_fonc = record name:string[8]; nbarg:byte; end; { dcrit une fonction }

{ͻ
  Dclaration 
 ͼ}
 CONST { fonction sur les rels }
  nbfonc = 36;
  foncliste:array[1..nbfonc] of t_fonc =
    ((name:'ans';nbarg:0),
     (name:'pi';nbarg:0),
     (name:'abs';nbarg:1),
     (name:'exp';nbarg:1),
     (name:'ln';nbarg:1),
     (name:'sqrt';nbarg:1),
     (name:'sqr';nbarg:1),
     (name:'cos';nbarg:1),
     (name:'sin';nbarg:1),
     (name:'tan';nbarg:1),
     (name:'cot';nbarg:1),
     (name:'sec';nbarg:1),
     (name:'cosec';nbarg:1),
     (name:'sinh';nbarg:1),
     (name:'cosh';nbarg:1),
     (name:'tanh';nbarg:1),
     (name:'coth';nbarg:1),
     (name:'sech';nbarg:1),
     (name:'cosech';nbarg:1),
     (name:'arcsin';nbarg:1),
     (name:'arccos';nbarg:1),
     (name:'arctan';nbarg:1),
     (name:'arccot';nbarg:1),
     (name:'arcsec';nbarg:1),
     (name:'arccosec';nbarg:1),
     (name:'arcsinh';nbarg:1),
     (name:'arccosh';nbarg:1),
     (name:'arctanh';nbarg:1),
     (name:'arccoth';nbarg:1),
     (name:'arcsech';nbarg:1),
     (name:'arccsch';nbarg:1),
     (name:'log10';nbarg:1),
     (name:'log';nbarg:1),
     (name:'fac';nbarg:1),
     (name:'inv';nbarg:1),
     (name:'not';nbarg:1));

{ͻ
  Implmentation 
 ͼ}

 { Utilis pour arrondir les calculs trigonomtriques peut prcis }
 function Arrondi(val:extended):extended;
 begin if abs(val) > 1E-16 then Arrondi:=val else Arrondi:=0; end;

 { Effectue le calcule de la fonction dsir }
 function CalcFonc(numfonc:integer;var arg:extended;var error:string):extended;
 var res:extended;
 begin res:=0;
  case numfonc of
   {ans     } 1:res:=Mat_ans;
   {pi      } 2:res:=pi;
   {abs     } 3:res:=abs(arg);
   {exp     } 4:res:=exp(arg);
   {ln      } 5:res:=ln(arg);
   {sqrt    } 6:res:=sqrt(arg);
   {sqr     } 7:res:=arg*arg;
   {cos     } 8:res:=arrondi(cos(Mat_coefangle*arg));
   {sin     } 9:res:=arrondi(sin(Mat_coefangle*arg));
   {tan     }10:res:=arrondi(tan(Mat_coefangle*arg));
   {cot     }11:res:=cot(Mat_coefangle*arg);
   {sec     }12:res:=sec(Mat_coefangle*arg);
   {cosec   }13:res:=cosec(Mat_coefangle*arg);
   {sinh    }14:res:=sinh(Mat_coefangle*arg);
   {cosh    }15:res:=cosh(Mat_coefangle*arg);
   {tanh    }16:res:=tanh(Mat_coefangle*arg);
   {coth    }17:res:=coth(Mat_coefangle*arg);
   {sech    }18:res:=sech(Mat_coefangle*arg);
   {cosech  }19:res:=cosech(Mat_coefangle*arg);
   {arcsin  }20:res:=arcsin(arg)/Mat_coefangle;
   {arccos  }21:res:=arccos(arg)/Mat_coefangle;
   {arctan  }22:res:=arctan(arg)/Mat_coefangle;
   {arccot  }23:res:=arccot(arg)/Mat_coefangle;
   {arcsec  }24:res:=arcsec(arg)/Mat_coefangle;
   {arccosec}25:res:=arccosec(arg)/Mat_coefangle;
   {arcsinh }26:res:=arcsinh(arg)/Mat_coefangle;
   {arccosh }27:res:=arccosh(arg)/Mat_coefangle;
   {arctanh }28:res:=arctanh(arg)/Mat_coefangle;
   {arccoth }29:res:=arccoth(arg)/Mat_coefangle;
   {arcsech }30:res:=arcsech(arg)/Mat_coefangle;
   {arccsch }31:res:=arccsch(arg)/Mat_coefangle;
   {log10   }32:res:=log10(arg);
   {log     }33:res:=log10(arg);
   {fac     }34:res:=fac(arg);
   {inv     }35:res:=inv(arg);
   {not     }36:res:=not(trunc(arg));
  else error:='Function not implemented !';
  end;
  CalcFonc:=res;
 end;
{:                                                                           :
 ͹
                         --- FIN FONCTIONS ---                              
 ͼ}

{ͻ
                           --- LES COMMANDES ---                            
 ͹
 :                                                                           :}
{ͻ
  TYPE COMMANDE 
 ͼ}
 TYPE
   t_comm = record name:string[8]; nbarg:byte; end; { dcrit une commande }

{ͻ
  Dclaration 
 ͼ}
 CONST { liste des commandes }
  nbcommande = 5;
  commliste:array[1..nbcommande]of t_comm =
    ((name:'deg'    ;nbarg:0),
     (name:'rad'    ;nbarg:0),
     (name:'grd'    ;nbarg:0),
     (name:'base'   ;nbarg:1),
     (name:'help'   ;nbarg:0));

{ͻ
  Implmentation 
 ͼ}
 { Execute la commande base }
 procedure CommandeBase;
 var basetmp:integer;
 begin if ph.err=0 then begin
   while ph.ch[ph.deb]=' ' do inc(ph.deb);
   if ph.ch[ph.deb]=#0 then { s'il n'y a pas de paramtre }
    begin str(Mat_base,ph.ch); Message(-1,'base '+ph.ch); end
   else
   begin { s'il y a un paramtre }
    basetmp:=LireEntier;
    while ph.ch[ph.deb]=' ' do inc(ph.deb);
    if(basetmp>1)and(basetmp<=36)and(ph.ch[ph.deb]=#0)
     then Mat_base:=basetmp else Message(-1,'Base error !');
   end
 end;end;

 { Execute la commande dsir }
 procedure ExecCommand(numcommande:integer);
 begin if ph.err=0 then begin
  Mat_ans:=Mat_ans*Mat_coefangle;
  Case numcommande of
   { deg   } 1 : Begin Mat_coefangle:= Pi / 180; Mat_ModeAngle := 'DEG'; End;
   { rad   } 2 : Begin Mat_coefangle:= 1;        Mat_ModeAngle := 'RAD'; End;
   { grd   } 3 : Begin Mat_coefangle:= Pi / 200; Mat_ModeAngle := 'GRD'; End;
   { base  } 4 : CommandeBase;
   { help  } 5 : Message(-1,'deg rad grd base');
  else Message(-1,'Debug error in ExecCommande !');
  end;
  Mat_ans:=Mat_ans/Mat_coefangle;
  if ph.err=0 then ConvStr(Mat_ans);
 end; end;

{:                                                                           :
 ͹
                         --- FIN COMMANDES ---                              
 ͼ}

TYPE

{ type utilis pour mmoriser une oppration dans la pile avec sa position }
t_oppetpos = record num:integer; pos:byte; end;

{ liste des arguments pass dans une fonction }
{t_listearg = array[1..maxarg]of extended;}

{************************************************************************}
{================= }
      TYPE
{ ================= }
{ pile de nombres rels }
t_pival = record val:array[1..maxpile]of extended;  i:integer; end;
{ pile d'opprations (position de lopration dans la formule) }
t_piopp   = record opp:array[1..maxpile]of t_oppetpos; i:integer; end;

{************************************************************************}
function OpIs(pos:integer;var numopp:integer):boolean;
begin if ph.err=0 then begin
  OpIs:=false;  numopp:=1;
  while (numopp<=nbopp) and
        (copy(ph.ch,pos,length(oppliste[numopp].name)) <>
         oppliste[numopp].name) do inc(numopp);
  if numopp<=nbopp then OpIs:=true;
end else OpIs:=false; end;



















{************************************************************************}
function Calcfrac:extended;
var res,pos:extended;
begin if ph.err=0 then begin
 inc(ph.deb); { avance sur '.' }
 pos:=Mat_base; res:=0;
 while ChiffreIs do begin res:=res+Chiffre/pos; pos:=pos*Mat_base; end;
 Calcfrac:=res;

end else Calcfrac:=0; end;










{************************************************************************}
function LitValeur:extended;
var resultat:extended; num:integer;
begin if ph.err=0 then begin
 resultat:=0;
 if ChiffreIs then
  begin
   resultat:=LireNombre;
   if ph.ch[ph.deb]='.' then resultat:=resultat+Calcfrac;
   while ph.ch[ph.deb]=' ' do inc(ph.deb);
{   if (ph.ch[ph.deb]='e')or(ph.ch[ph.deb]='E') then result:=result*expo;
   while ph.ch[ph.deb]=' ' do inc(ph.deb); }
   if not((OpIs(ph.deb,num))or(ph.ch[ph.deb]=')')or(ph.ch[ph.deb]=#0))
    then Message(ph.deb,'Operator expected');
  end
 else Message(ph.deb,'Value expected');
 LitValeur:=resultat;
end else LitValeur:=0; end;


{************************************************************************}
function PhCmpStr(chaine:string):boolean;
var rep:boolean;
    pos:integer;
begin if ph.err=0 then begin
  rep:=true;  pos:=1;
  while (pos<=length(chaine)) and rep do
    begin
     if (chaine[pos]<>ph.ch[ph.deb+pos-1]) then rep:=false;
     inc(pos);
    end;
  PhCmpStr:=rep;
end else PhCmpStr:=false; end;







{************************************************************************}
procedure EmpileVal(var pival:t_pival;val:extended);
begin if ph.err=0 then begin
 inc(pival.i);
 if (pival.i>maxpile) then Message(-1,'Stack too small')
  else pival.val[pival.i]:=val;
end;end;


{************************************************************************}
function FoncIs(var numfonc:integer):boolean;
var num,numopp:integer; { compteur pour parcourir la liste des fonctions }
begin if ph.err=0 then begin
  while ph.ch[ph.deb]=' ' do inc(ph.deb); { supression des espaces inutils }
  num:=1; numfonc:=0;
  while (numfonc=0) and (num<=nbfonc) do  { pour chaque fonction }
   begin
     if (PhCmpStr(foncliste[num].name)) and        { teste le nom         }
        ((ph.ch[ph.deb+length(foncliste[num].name)]=' ') or  { teste la fin }
         (ph.ch[ph.deb+length(foncliste[num].name)]=')') or

         (ph.ch[ph.deb+length(foncliste[num].name)]= #0) or
         (OpIs(ph.deb+length(foncliste[num].name),numopp)) or
         (ph.ch[ph.deb+length(foncliste[num].name)]='(')) then numfonc:=num;
     inc(num);
   end;
  if numfonc=0 then FoncIs:=false   { si ce n'est pas une commande }
  else begin FoncIs:=true; ph.deb:=ph.deb+length(foncliste[numfonc].name);
       end;
end else FoncIs:=false; end; { valeur par dfaut en cas d'erreur }

{************************************************************************}
function ExecFonc(numfonc:integer;pos:integer):extended;
var arg:extended; error:string;
begin if ph.err=0 then begin
  error:='';
  while ph.ch[ph.deb]=' ' do inc(ph.deb);
  if foncliste[numfonc].nbarg=0
   then   ExecFonc:=CalcFonc(numfonc,arg,error)
  else if foncliste[numfonc].nbarg=1 then
   begin
     if ph.ch[ph.deb]='(' then
      begin
       inc(ph.deb);
       arg:=Calc;
       if ph.ch[ph.deb]=')' then
         begin
          inc(ph.deb);
          ExecFonc:=CalcFonc(numfonc,arg,error);

          if error<>'' then Message(pos,error);
         end
        else Message(ph.deb,') expected');
      end
     else Message(ph.deb,'( expected');
   end
  else Message(pos,'More than one arg not suported');
end else ExecFonc:=0; end;

{************************************************************************}
procedure LitEtEmpileArg(var pival:t_pival);
var signe,numfonc:integer;
begin if ph.err=0 then begin
  signe:=PhSigne;
  if ph.ch[ph.deb]='(' then

    begin
     inc(ph.deb);
     EmpileVal(pival,signe*Calc);
     if ph.ch[ph.deb]=')' then inc(ph.deb)
      else Message(ph.deb,'not enough )');
    end
  else
  begin
   if FoncIs(numfonc) then EmpileVal(pival,signe*ExecFonc(numfonc,(ph.deb-length(foncliste[numfonc].name))))
    else EmpileVal(pival,signe*LitValeur);
  end;
  while ph.ch[ph.deb]=' ' do inc(ph.deb);
end; end;

{************************************************************************}
procedure EmpileOpp(var piopp:t_piopp;numopp:integer);
begin if ph.err=0 then begin
 inc(piopp.i);
 if (piopp.i>maxpile) then Message(-1,'Stack too small')
  else begin
        piopp.opp[piopp.i].num:=numopp;
        piopp.opp[piopp.i].pos:=ph.deb;
        inc(ph.deb,length(oppliste[numopp].name));
       end;
end; end;









{************************************************************************}
procedure ExecOpp(var pival:t_pival;var piopp:t_piopp;pospile:integer);
begin if ph.err=0 then begin
 pival.val[pospile]:=CalcOpp(piopp.opp[pospile].num,piopp.opp[pospile].pos,
                               pival.val[pospile],pival.val[pospile+1]);
 piopp.opp[pospile].num:=piopp.opp[pospile+1].num;
 piopp.opp[pospile].pos:=piopp.opp[pospile+1].pos;
 dec(piopp.i); dec(pival.i);
end;end;

{************************************************************************}
procedure Depile(var pival:t_pival;var piopp:t_piopp);
begin if ph.err=0 then begin
 while (piopp.i>1)and(ph.err=0)and
       ((oppliste[piopp.opp[piopp.i  ].num].priority)<=
        (oppliste[piopp.opp[piopp.i-1].num].priority))
    do ExecOpp(pival,piopp,piopp.i-1);
end; end;


{************************************************************************}
function Videpile(var pival:t_pival;var piopp:t_piopp):extended;
begin if ph.err=0 then begin
 while (piopp.i>0)and(ph.err=0) do ExecOpp(pival,piopp,piopp.i);
 VidePile:=pival.val[pival.i];
end else Videpile:=0; end;














{************************************************************************}
function Calc:extended;
var pival:t_pival; piopp:t_piopp;
    numopp:integer;
begin if ph.err=0 then begin
  pival.i:=0;  piopp.i:=0;
  LitEtEmpileArg(pival);
  while OpIs(ph.deb,numopp) do
   begin
    EmpileOpp(piopp,numopp);

    Depile(pival,piopp);
    LitEtEmpileArg(pival);
   end;
   Calc:=VidePile(pival,piopp);
end else Calc:=0; end;




{************************************************************************}
procedure CalcSolve;
var res:extended;
begin if ph.err=0 then begin
  res:=Calc;
  if ph.ch[ph.deb]=#0 then
   begin
    ConvStr(res);
    Mat_ans:=res;
   end
  else if ph.err=0 then Message(ph.deb,'too much )');
end;end;








{************************************************************************}
function Commandfin(num:integer):boolean;
begin

 if ((ph.ch[ph.deb+length(commliste[num].name)]=' ') or
     (ph.ch[ph.deb+length(commliste[num].name)]='(') or
     (ph.ch[ph.deb+length(commliste[num].name)]=#0))
     then Commandfin:=true
     else Commandfin:=false;
end;










{************************************************************************}
function CommandeIs(var numcommand:integer):boolean;
var num:integer; { compteur pour parcourir la liste de commande }
begin if ph.err=0 then begin
  while ph.ch[ph.deb]=' ' do inc(ph.deb); { supression des espaces inutils }
  num:=1; numcommand:=0;
  while (numcommand=0) and (num<=nbcommande) do  { pour chaque commande }
   begin
     if (PhCmpStr(commliste[num].name) and Commandfin(num))
          then numcommand:=num;
     inc(num);
   end;
  if numcommand=0 then CommandeIs:=false   { si ce n'est pas une commande }
  else begin
         CommandeIs:=true; ph.deb:=ph.deb+length(commliste[numcommand].name);
       end;
end else CommandeIs:=false; end; { valeur par dfaut en cas d'erreur }

{************************************************************************}
{:                                                                           :
 ͹
                      --- SUITE FONCTION SOLVE ---                          
 ͹
 :                                                                           :}
 { suite de function Solve(formule:string;var resultat:string):integer; }
Begin
{init de ph}
Formule:=Lower(Formule);                        {*Passe Tout en Minuscules*}
ph.ch:=formule+#0;  ph.deb:=1; ph.err:=0;
{ teste si c'est une commande }
if CommandeIs(numcommande)
then ExecCommand(numcommande) { c'est une commande }
else CalcSolve;              { c'est un calcul }

Resultat:=ph.ch;   { retourne le resultat du calcul ou le message d'erreur }
Solve:=ph.err; { retourne la position de l'erreur }
End;
{ͻ
                        --- FIN FONCTION SOLVE ---                          
 ͼ}

{ͻ
                          INITIALISATION DE MosMath                         
 ͼ}

Begin
Mat_coefangle:=1;      {*Angle en mode radian*}
Mat_ModeAngle:= 'RAD'; {*Corresponding string*}
Mat_base:=10;          {*Base numrique 10   *}
Mat_ans:=0;            {*Resultat antrieur 0*}
End.
