{ͻ
                                UNIT MosMenu                                
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 27.11.1994                                                   
  COUNTRY....: Toulouse - COG Gendarmerie (FRANCE)                          
  DESCRIPTION: Menu Management.                                             
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 662 Lines and (18.912 Bytes compiled)                        
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosMenu;

{$Mode Objfpc}

INTERFACE

Const Max_Length_Points=33;              {*String maximum length*}
      Max_Menu_Points=17;                {*Menu points maximum-2*}
      Max_Menu=10;                       {*Maximum menus quantity*}

Type TMenu = Record                      {*Menus structure*}
     TbMen :Array[1..Max_Menu,1..Max_Menu_Points] of String[Max_Length_Points];
     TbLen :Array[1..Max_Menu] of Word;  {*Menus length array*}
     TbSiz :Array[1..Max_Menu] of Word;  {*Menus width array*}
     TbId  :Array[1..Max_Menu,1..Max_Menu_Points] of Byte;{*Definition bits*}
     TbKey :Array[1..Max_Menu,1..Max_Menu_Points] of Byte;{*Hotkey for each menu point*}
     End;

     {*Structure for the array "Men_Id" =  Initialisation bits*}
     {* Bit 0       * $0001 = Disabled       Menu disabled*}
     {* Bit 1 Point * $0002 = Separator      Separation bar*}
     {*       Menu  * $0002 = Check Exclusif Exclusif check points in menu*}
     {* Bit 2       * $0004 = Check Point    Check point*}
     {* Bit 3       * $0008 = Status CP      Check point status. Tagged=1*}
     {* Bit 4       * $0010 = Last Point     Last menu point*}
     {* Bit 5       * $0020 = Check Border   Check point in a box*}

                 {*Pour les Labels de Menus Uniquement - Interne*} {MIC}
     {* Bit 6       * $0040 = Internal      Fentre du Menu Affiche ou Pas*} {MIC}
     {* Bit 7       * $0080 = Internal      [1,1] = 1ere Fois Afficher Bandeau Menu*} {MIC}

Procedure Menu_Clear    (Var M:TMenu);                               {*Clear menu arrays*}
Procedure Menu_Add      (Var M:TMenu; MX,MY:Integer; Lab:String);    {*Add a menu point to list*}
Procedure Menu_Test     (Var M:TMenu; CB,CP:Longint; Var MS,PS,SS:Byte);{*Manage menu*}
Function  Menu_TestCheck(    M:TMenu; MS,PS:Byte):Boolean;           {*Test a check point value*}
Procedure Menu_SetId    (Var M:TMenu;MS,PS:Byte; Id:Byte);           {*Modify menu point Id*}

{*----------------------------- Debut Library ------------------------------*}

IMPLEMENTATION

Uses
     Windows,
     MosBase,
     MosColors,
     MosConfig,
     MosCPUInstructions,
     MosErrors,
     MosGadgets,
     MosGraph,
     MosKeyboard,
     MosMouse,
     MosStrings,
     MosText,
     MosTime,
     MosTools,
     MosWindows;

{ͻ
                            PROCEDURE Menu_SetId                            
 ͹
  IN.....: MS,PS (BYTE) = Menu and menu point number to modify.             
           Id (BYTE) = New value for Id.                                    
  OUT....: /                                                                
  EXPLAIN: Modify the Id value of a menu point.                             
  SEEALSO: Menu_TestCheck, Menu_Test, Menu_Add, Menu_Clear                  
 ͼ}

Procedure Menu_SetId(Var M:TMenu; MS,PS:Byte; Id:Byte);
Begin
M.TbId[MS,PS+1]:=Id;                      {*Set New Valeur*}
End;

{ͻ
                          FUNCTION Menu_TestCheck                           
 ͹
  IN.....: MS,PS (BYTE) = Menu and menu point number.                       
  OUT....: (BOOLEAN) = TRUE : The menu point is tagged.                     
  EXPLAIN: Test a menu point declared as "check" and return TRUE if tagged. 
  SEEALSO: Menu_SetId, Menu_Test, Menu_Add, Menu_Clear                      
 ͼ}

Function Menu_TestCheck(M:TMenu; MS,PS:Byte):Boolean;
Begin
Menu_TestCheck:=False;                    {*De Base*}

If (M.TbId[MS,PS+1] And $4=$4) Then       {*Point Check ?*}
   If M.TbId[MS,PS+1] And $8=$8
      Then Menu_TestCheck:=True           {*Point Crochet*}
      Else Menu_TestCheck:=False;         {*Point Non Crochet*}
End;

{ͻ
                            PROCEDURE Menu_Clear                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  MODIFY.: TbMen, TbLen, TbSiz, TbId are initialised.                       
  EXPLAIN: Clear all the arrays menu before their initialisation.           
  SEEALSO: Menu_SetId, Menu_Test, Menu_Add, Menu_TestCheck                  
 ͼ}

Procedure Menu_Clear(Var M:TMenu);  {*Nttoie Les Tableaux*}
Var       A,B:Integer;
Begin
For A:=1 to Max_Menu do Begin
   M.TbLen[A]:=0; M.TbSiZ[A]:=0;
   End;
For A:=1 to Max_Menu do
   For B:=1 to Max_Menu_Points do Begin
      M.TbMen[A,B]:=''; M.TbId[A,B]:=0; M.TbKey[A,B]:=0;
      End;
Id_Scr1:=Id_Scr1 And ($FFFF-$40);     {*Clear Papillon dans Menu*}
End;

{ͻ
                             PROCEDURE Menu_Add                             
 ͹
  IN.....: Menu (TMENU) = Pointer to the structure menu.                    
           MX,MY (INTEGER) = Menu and menu point number.                    
           Lab (STRING) = Menu label (with his definition bits).            
  OUT....: /                                                                
  MODIFY.: TbMen, TbLen, TbSiz, TbId are initialised.                       
  EXPLAIN: Add a new menu point in menu.                                    
  BITS...: A byte used as a string must be present at the begining          
           of a menu point definition.                                      
                                                                            
                       Menu point Id bits structure                         
   Bit 0       * $0001 = Disabled       Menu disabled                       
   Bit 1 Point * $0002 = Separator      Separation bar                      
         Menu  * $0002 = Check Exclusif Exclusifs check points in menu      
   Bit 2       * $0004 = Check Point    Check point                         
   Bit 3       * $0008 = Status CP      Check point status. Tagged=1        
   Bit 4       * $0010 = Last Point     Last menu point in menu             
   Bit 5       * $0020 = Check Border   Check point in a box                
                                                                            
  NB.....: Maximum 10 menus, 15 menus points and 33 chars for each point.   
  KEYS...: Menus points can be selectionned by keyboard using the ALT key   
           plus the hotkey of each menu point.                              
  EXAMPLE: Menu_Clear(M);                                                   
           M.TbMen[1,1]:='00 _PREFERENCES';       Menu 1 title              
           M.TbMen[1,2]:='00 _LOAD PREFS';        Normal point              
           M.TbMen[1,3]:='02';                    Separation bar            
           M.TbMen[1,4]:='04 POINT _CHECK 1';     Check point untagged      
           M.TbMen[1,5]:='1C POINT C_HECK 2';     Check point tagged        
           M.TbMen[2,1]:='02 POINTS _EXCLUSIFS'   Menu 2 title + Exclusif   
           M.TbMen[2,2]:='0C E_XCLUSIF 1';        Check point tagged        
           M.TbMen[2,3]:='04 EX_CLUSIF 2';        Check point untagged      
           Init_Menu(M);                                                    
  SEEALSO: Menu_SetId, Menu_Test, Menu_Add, Menu_TestCheck                  
 ͼ}

Procedure Menu_Add(Var M:TMenu; MX,MY:Integer; Lab:String);
Var       O_Tw    :Integer;         {*Optimisations*}
          O_Pl    :Integer;

{**************************** CODE PRINCIPAL ********************************}

Begin                               {*Menu Dfinit en Dehors des Limites*}
If (MX<=0) Or (MX>Max_Menu) Or (MY<=0) Or (MY>Max_Menu_Points) Then
   Begin Error(590); Exit; End;

Font_Set(Sys.FontMenu,Sys.FontMenuSize);  {*Fonte Pour Menus*}

M.TbId[MX,MY]:=Str_Base2L(Copy(Lab,1,2),16);{*Stocke Id pour Menu Label*}

If ((M.TbId[MX,MY] And $2<>$2) And (MY>1)) Or (MY=1) Then
   Begin
   Lab:=Copy(Lab,4,length(Lab)-3);
   O_Pl:=Pos('_',Lab);              {*Optimisations*}
   If O_Pl>0 Then Begin
      M.TbKey[MX,MY]:=O_Pl;         {*Vanillia Key ? = OUI*}
      Delete(Lab,O_Pl,1);
      End;
   M.TbMen[MX,MY]:=Lab;             {*Stocke Label dans Tableau*}
   End;

O_Tw:=VESA_TextWidth(M.TbMen[MX,MY])+(6*LaF);     {*Calule la Size Hz des Menus*}
If (O_Tw>M.TbSiz[MX]) And (MY>1) Then M.TbSiz[MX]:=O_Tw;

If M.TbLen[MX]<MY Then M.TbLen[MX]:=MY;{*Stocke Nombre de Points dans Menu*}

Font_Set(Sys.FontMain,Sys.FontMainSize);  {*Repasse en Fonte Normale*}
End;

{ͻ
                            PROCEDURE Menu_Test                             
 ͹
  IN.....: CB,CP (LONGINT) = Color pen and background for menu.             
  OUT....: MS,PS,SS (BYTE) Var = Menu number and selected menu point.       
  EXPLAIN: Manage a menu.                                                   
  EXAMPLE: Menu_Test(7,0,MS,PS,SS);                                         
           Case MS of                                                       
             1: Case PS of                      ; Menu 1                    
                  1:                            ; Menu point 1,1            
                  2:                            ; Menu point 1,2            
                  End;                                                      
             2:                                                             
             3:                                                             
             End;                                                           
  SEEALSO: Menu_SetId, Menu_Clear, Menu_Add, Menu_TestCheck                 
 ͼ}

Procedure Menu_Test(Var M:TMenu; CB,CP:Longint; Var MS,PS,SS:Byte);
Var       Qtt_Men    :Byte;                     {*Nombre de Menus-Bar*}
          W,WB       :TWindow;                      {*Fentres Menus/Bandeau*}
          A,B,PosX   :Integer;                  {*Pour Itrations et Calculs*}
          PLM        :Array[1..Max_Menu]of Word;{*Pos des Labels des Menus*}
          Point_Ok   :Boolean;                  {*On est sur un Point du Menu*}
          Check_Bit  :Boolean;                  {*Modifier 1 Seule fois Check*}
          Last_Point :Boolean;                  {*Dernier Point Cliqu*}
          MS1,PS1    :Byte;                     {*Pour Point Cliqu*}
          DeltaX     :Integer;                  {*Dcalage X Affichage Window*}
          Exit_Flag  :Boolean;                  {*Sortie du Menu (key or Other)*}
          Win_Exist  :Byte;                     {*Num de la Fentre Affiche...*}
          Cancel     :Boolean;                  {*Annulation Menu...*}
          MActiv     :Boolean;                  {*Menu Activ (Mouse ou Keyb)*}
//          Asc,Sc     :Byte;                     {*Pour Kbd_GetChar*}
//          Vsc        :Char;                     {*Transtypage pour SCAN Code*}
          Vle        :Char;                     {*Calcul Lettre Apelante*}
          Nmak       :Byte;                     {*Num du menu Activate by Key*}
          Point      :Byte;                     {*Number of point to Activate*}
          T          :TClock;                   {*Structure "TIME"*}

{ͻ
                    AFFICHE LE UNDERSCORE DANS LES MENUS                    
 ͼ}

Procedure DISPLAY_UNDERSCORE(IM,IP,PosX:Integer);
Var RHaF,PCx:Integer;
Begin
If M.TbKey[IM,IP]<>0 Then Begin                {*Display Underscore...*}
   RHaF:=3+VESA_TextHeight;                    {*Cacule Pos du Underscore*}
   If IP>1 Then RHaF:=RHaF+IP*(HaF+4)-HaF-2;
   PCx:=PosX+VESA_TextWidth(Copy(M.TbMen[IM,IP],1,M.TbKey[IM,IP]-1));
   Mse_Hide;
   VESA_Line(PCx-1, RHaF, PCx+LaF, RHaF);           {*Trace Underscore*}
   Mse_Show;
   End;
End;

{ͻ
                          AFFICHE LA BARRE DES MENUS                        
 ͼ}

Procedure DISPLAY_MENU_Bar(M:TMenu);            {*Affiche la Barre des Menus*}
Var A,Cl:Integer;
Begin
Mse_SetPointer(P_Current);
Kbd_PurgeBuffer;
Bevel (0,0,VESA_GetMaxX,HaF+4, CB,BLRaisedLine,BLNoLine,Yes); {*Affiche Bandeau Menu*}

PosX:=LaF*2+2;                                  {*Bord Gauche + X Pixels*}
For A:=1 to Qtt_Men do Begin
   If M.TbId[A,1] And $1=$1 Then Cl:=CLLightGrey{*Couleur Grise*}
                            Else Cl:=CP;        {*Couleur Pen Definit par User*}
   Display(PosX,1,Cl,M.TbMen[A,1]);             {*Display Menu Labels*}
   DISPLAY_UNDERSCORE(A,1,PosX);                {*Affiche le Underscore*}
   PLM[A]:=PosX;                                {*Stocke Position Label Menu*}
   PosX:=PosX+VESA_TextWidth(M.TbMen[A,1])+LaF*4;    {*Calcul Next Pos Horizontale*}
   End;
PLM[A+1]:=PosX;
End;

{ͻ
                 AFFICHE LA FENETRE D'UN MENU ET SES POINTS                 
 ͼ}

Procedure DISPLAY_MENU_WIN(Var M:TMenu);
Var B,C,Of1:Integer;                 {*For Itration*}
    O_X1,O_Y1,O_X2:Integer;          {*Optimisations*}
Begin
If M.TbLen[MS]>1 Then                {*Au moins 1 point dans Menu*}
   Win_Draw(W);                   {*Affiche la Fentre*}
Font_Set(Sys.FontMenu,Sys.FontMenuSize);   {*Fonte Pour Menus*}

M.TbId[MS,1]:=M.TbId[MS,1] Or $40;   {*Set Internal Bit Window is Displaying*}
For B:=2 to M.TbLen[MS] do Begin
   C:=PLM[MS]-LaF*2;                 {*Pos X du Dbut de la Fentre*}
   O_Y1:=B*(HaF+4)-HaF+5;            {*Optimisations*}
   Mse_Hide;
   If M.TbId[MS,B] And $2=$2 Then    {*Ligne Sparatrice*}
      While C<PLM[MS]+M.TbSiz[MS]-1 do Begin
         VESA_Putpixel(C-DeltaX,O_Y1,CP); {*Draw Double Line*}
         VESA_Putpixel(C-DeltaX+1,O_Y1-1,CP);
         Inc(C,2);                   {*2 Pixels en Deux*}
         End
   Else Begin                        {*Point Menu Classique*}
      O_X1:=PLM[MS]-LaF*2+4-DeltaX;
      O_X2:=PLM[MS]+LaF*2+2-DeltaX;
      If M.TbId[MS,B] And $24=$24    {*Select Design for Check Mark - Bevel*}
         Then Bevel (O_X1, O_Y1-6, O_X2, O_Y1+HaF-4, CLShadow,BLRaisedLine,BLNoLine,Yes);
      If M.TbId[MS,B] And $C=$C Then {*Draw Amiga Check if Check-Bit is Set*}
         Begin
         If M.TbId[MS,B] And $20=$20 {*Select Design for Check Mark - Mask*}
            Then ;
         DrawGad_AmigaOkBut(O_X1, O_Y1-6);{*Mask*}
         If M.TbId[MS,B] And $24=$24 Then
            Bevel (O_X1, O_Y1-6, O_X2, O_Y1+HaF-4, CLBlack,BLRaisedLine,BLNoLine,No);
         End;
      If M.TbId[MS,B] And $1=$1 Then VESA_SetColor(CLWinBg)
         Else VESA_SetColor(CP);     {*Point Gris ou Non ? => Coul Diffrente*}
      Of1:=0;                        {*De Base pas de Dcalage (Point Check)*}
      If M.TbID[MS,B] And $4=$4      {*Point Check Dcal  Droite*}
         Then Of1:=LaF*3;            {*Si Bug Couleur, Remettre CB Actif...*}
      Display(PLM[MS]-DeltaX+Of1, O_Y1-6, VESA_GetColor, M.TbMen[MS,B]);
      DISPLAY_UNDERSCORE(MS,B,PLM[MS]-DeltaX+Of1);{*Affiche le Underscore*}
      End;
   Mse_Show;
   End;
End;


{ͻ
                       MET UN POINT CROCHETE EXCLUSIF                       
 ͼ}

Procedure SET_EXCLUSIF(Var M:TMenu);
Var E:Integer;
Begin
For E:=2 to M.TbLen[MS] do
   M.TbId[MS,E]:=M.TbId[MS,E] And ($FF-$8);     {*Clear Other Check Points*}
M.TbId[MS,PS]:=M.TbId[MS,PS] Or $8;             {*Set Check to "On"*}
End;

{ͻ
                            TOGGLE UN POINT DU MENU                         
 ͼ}

Procedure TOGGLE_POINT(M:TMenu; P:Byte);        {*Numro du Point  Inverser*}
Var U:Integer;
Begin
VESA_SetWriteMode(XorPut);
Mse_Hide;
VESA_SetColor(CB);
For U:=2+(P-1)*(HaF+4) to 2+P*(HaF+4) do        {*Draw New Line for a Block*}
VESA_Line(PLM[MS]-DeltaX-LaF*2+1, U, PLM[MS]-DeltaX+M.TbSiz[MS]-1, U);
Mse_Show;
VESA_SetWriteMode(NormalPut);
End;

{ͻ
                 RECALCUL DES VARIABLES TAILLES ETC DU MENU                 
 ͼ}

Procedure REFRESH_MENU(Var M:TMenu);
Var       A,B     :Integer;
          O_Tw    :Integer;           {*Optimisations*}
Begin
For A:=1 to Max_Menu do M.TbSiZ[A]:=0;{*Clear Tableau for Calcul Length & Size*}

Font_Set(Sys.FontMenu,Sys.FontMenuSize);    {*Fonte Pour Menus*}
For A:=1 to Qtt_Men do
    For B:=2 to M.TbLen[A] do         {*Calule la Size Hz des Menus*}
       Begin
       O_Tw:=VESA_TextWidth(M.TbMen[A,B])+(6*LaF);
       If O_Tw>M.TbSiz[A] Then M.TbSiz[A]:=O_Tw;
       End;

Font_Set(Sys.FontMain,Sys.FontMainSize);    {*Repasse en Fonte Normale*}
Id_Msg1:=Id_Msg1 And $FFFE;           {*Annule Bit 0 = Do 1 Time*}
End;

{ͻ
           SEARCH NEXT POINT DE MENU LIBRE (NO INHIBE, NO SPERATOR)         
 ͼ}

Procedure SEARCH_NEXT_POINT(Sens:Boolean);      {*True=Haut, False=Bas*}
Var Pas:Byte;
Begin
Pas:=0;
While ((M.TbId[MS,Point+1] And $1=$1) Or (M.TbId[MS,Point+1] And $2=$2)) And (Pas<255) do
   Begin
   If Sens=True  Then Begin Dec(Point);         {*Remonte la Liste*}
      If Point<1 Then Point:=M.TbLen[MS]-1;
      End
   Else Begin Inc(Point);                       {*Descend la Liste*}
      If Point>M.TbLen[MS]-1 Then Point:=1;
      End;
   Inc(Pas);                                    {*Compteur si Overflow ! Patch*}
   End;
End;

{ͻ
                   RENVOIS DANS "QTT_MENU" LA QTT DE MENUS                  
 ͼ}

Procedure GET_QTT_MENU;

Var A:Integer;
Begin
Qtt_Men:=0;                                     {*Pr-initialise...*}
For A:=1 to Max_Menu do
  If M.TbLen[A]<>0 Then Qtt_Men:=A;             {*Calcule Qtt de Menus*}
End;

{ͻ
                CODE PRINCIPAL DE LA PROCEDURE "Menu_Test"                  
 ͼ}

Var WinWMake:Boolean; {Sybaris dbuggage}
    NewTime,OldTime:String;              {*Time management*}

Begin
If BTST(Id_Gad1,12) Then Exit;                  {*Souris sur un List Title !*}
If BTST(Id_Msg1,2)  Then Exit;                  {*Slider Move Somewhere !*}
WinWMake:=False;      {Sybaris dbuggage}
GET_QTT_MENU;                                   {*Calcule la Quantit de Menus*}

GET_QTT_MENU;                                   {*Recalcule la Quantit de Menus*}

If Id_Msg1 And $0001=$0001 Then REFRESH_MENU(M);{*Recalcule Variables Menu*}

MS:=0; PS:=0; SS:=0;                            {*Init de Base au Cas o*}
Point_Ok:=False;                                {*On n'est pas sur un Pt du Menu*}
Last_Point:=False;                              {*Pas Encore de Dernier Point*}
Win_Exist:=0;                                   {*Pas de Fentre Affiche de Base*}
Cancel:=False;                                  {*Pas d'annulations de Base*}
OldTime:='';                                    {*Init pour sucrer Hint FPC*}

If (Mse_Clicked(3)) And (Id_Gad1 And $8<>$8)
   Then Begin MActiv:=True; Id_Gad1:=Id_Gad1 And ($FFFF-$4) End
   Else If kbd_GetKeyDown(VK_MENU) Then
       Begin
       MActiv:=True;
       Id_Gad1:=Id_Gad1 Or $4;
       End
     Else MActiv:=False;

If (MActiv) And (Sys.WinMoved=False) And (Sys.WinSized=False) Then
   Begin
   Repeat
   Exit_Flag:=False;                            {*De Base pas de Sortie*}
   Font_Set(Sys.FontMenu,Sys.FontMenuSize);     {*Fonte Pour Menus*}

   If M.TbId[1,1] And $80<>$80 Then             {*Init et Affiche Bandeau Menu*}
      Begin
      If Not Win_Init(0,0,VESA_GetMaxX,HaF+4,$1561,'',WB) Then Exit;
      Win_Sup(0,0,0,0,0,0,0,0,0,CB,$1040,WB);   {*Open Bandeau Menu*}
      M.TbId[1,1]:=M.TbId[1,1] Or $80;          {*Set Bit 7 for Mark Boolean*}
      DISPLAY_MENU_Bar(M);                      {*Affiche Barre des Menus*}
      End;

{********** Gestion de l'heure dans le Menu *}

   NewTime:=Time_GetTime(0,T);
   If NewTime<>OldTime Then

      Begin
      Display_Attr(WB.X2-LaF*11,WB.Y1+1,-1,Cp,$0041, NewTime);
      OldTime:=NewTime;
      End;

{********** Fin de Gestion de l'heure dans le Menu *}

   Nmak:=0;                                     {*De base pas de Key d'Appel*}
//   If Kbd_GetChar(Asc,Sc) Then                  {*A Key is Pressed...*}
//   Begin
      If kbd_GetKeyDown(VK_MENU) then {*Test Touche d'appel Menu*}
//      If Kbd_TestSpecialKey($08,B_OR) Then             {*Test Touche d'appel Menu*}
         For A:=1 to Qtt_Men do Begin
//            Vsc:=Chr(Kbd_GetASCIICode(Sc));
            Vle:=M.TbMen[A,1][M.TbKey[A,1]];
            If kbd_GetKeyDown(Ord(Upcase(Vle))) Then Nmak:=A;{*Good Menu...*}
            End
         Else
         For A:=2 to M.TbLen[Win_Exist] do Begin{*Test Touche d'appel Menu Point*}
            Vle:=M.TbMen[Win_Exist,A][M.TbKey[Win_Exist,A]];
            If kbd_GetKeyDown(Ord(Upcase(Vle)))
               And (M.TbId[Win_Exist,A] And $1<>$1) Then      {*Pas Gris ?*}
               Begin Point_Ok:=True; PS:=A; Win_Exist:=0; End;{*Select Point*}
            End;
//      End else Begin Asc:=0;Sc:=0;End; {syb}

   If kbd_GetKeyDown(VK_ESCAPE) Then Begin Win_Exist:=0; Cancel:=True; End; {*ESC Pressed --> Exit*}
   If kbd_GetKeyDown(VK_RETURN) Then Win_Exist:=0;                  {*ENTER = Ok...*}
   If kbd_GetKeyDown(VK_LEFT) Then Begin Nmak:=Win_Exist-1;       {*Flche Gauche*}
      If NMak<=0 Then Nmak:=Qtt_Men;
      End;
   If kbd_GetKeyDown(VK_RIGHT) Then Begin Nmak:=Win_Exist+1;       {*Flche Droite*}
      If NMak>Qtt_Men Then Nmak:=1;
      End;
{gotoxy(1,3); writeln('Nmak = ',Nmak);
gotoxy(1,4); writeln('WinE = ',Win_Exist);}

   Point:=0;                                    {*De Base pas de Points Activs*}
   If (kbd_GetKeyDown(VK_UP)) And (M.TbId[MS,2] And $80<>$80)
      Then Begin Point:=PS-2;                   {*Flche Haut*}
      If PS<=2 Then Begin TOGGLE_POINT(M,PS);
         Point:=M.TbLen[MS]-1;                  {*Rotate par le Haut...*}
         TOGGLE_POINT(M,PS);
         End;
      SEARCH_NEXT_POINT(True);                  {*Renvois N prochain Point*}
      End;
   If (kbd_GetKeyDown(VK_DOWN)) And (M.TbId[MS,2] And $80<>$80)
      Then Begin Point:=PS;                     {*Flche Bas*}
      If PS>=M.TbLen[MS] Then Begin
         TOGGLE_POINT(M,PS); Point:=1;
         TOGGLE_POINT(M,PS);                    {*Rotate par le Bas...*}
         End;
      SEARCH_NEXT_POINT(False);                 {*Renvois N prochain Point*}
      End;

   For A:=1 to Qtt_Men do Begin                 {*Teste si Menu Must Activate*}
       If ((Mse_TestBox(PLM[A]-LaF*2,0,PLM[A+1]-1-LaF*2,HaF+4,10)=True) And (Id_Gad1 And $4<>$4))
         Or ((Nmak=A) And (Id_Gad1 And $4=$4))  {*Activate by Key...*}
         Then
         If (MS<>A) And (M.TbId[A,1] And $1<>$1){*New Menu Slect & pas Gris*}
            Then Begin
            PS:=0;                              {*Rinit Point car New Menu*}
            Mse_SetPointer(P_Current);          {*TPointer Courrant*}
            Mse_Hide;
            If MS>0 Then Begin                  {*1er Menu Cliqu ?*}
               If M.TbLen[MS]>1 Then Win_Done(W);{*Sucre la Fentre Menu Prec*}
               M.TbId[MS,1]:=M.TbId[MS,1] And ($FF-$40);{*Clear Bit 6 Window is Displaying*}
               Bevel(PLM[MS]-LaF*2,1,PLM[MS+1]-1-LaF*2,HaF+3,CB);
               Display(PLM[MS],1,CP,M.TbMen[MS,1]);{*Display Old Menu Label*}
               DISPLAY_UNDERSCORE(MS,1,PLM[MS]);{*Affiche le Underscore*}
               End;
            Bevel(PLM[A]-LaF*2,1,PLM[A+1]-1-LaF*2,HaF+3,CP);
            Display(PLM[A],1,CB,M.TbMen[A,1]); {*Display New Menu Label*}
            DISPLAY_UNDERSCORE(A,1,PLM[A]);{*Affiche le Underscore*}
            Mse_Show; MS:=A;                   {*MS est le Menu Slectionn*}
            Check_Bit:=False;                   {*Autre Menu => Check <>*}

            Win_Exist:=A;                       {*On Affiche la Fentre Num:A*}

            If M.TbLen[A]>1 Then Begin          {*Au moins 1 point dans Menu*}
               Win_Init(PLM[A]-LaF*2, HaF+5, PLM[A]+M.TbSiz[A], M.TBLen[A]*(HaF+4)+3,$5101,'',W);
               Win_Sup(0,0,0,0,0,0,0,0,0,CB,$1042,W);

               WinWMake:=True;    {Sybaris dbuggage}
               If PLM[A]-LaF*2<>W.X1 Then DeltaX:=PLM[A]-LaF*2-W.X1{*Calcul Dcalage Fentre*}
                  Else DeltaX:=0;               {*Window Affiche  l'endroit Demand*}
               End;

{Gotoxy(1,14); Writeln('TbId_A1=',TbId[A,1] And $40,' ');
Gotoxy(1,15); Writeln('X1=',PLM[A]-LaF*2,'  Y1=',HaF+5,'  X2=',PLM[A]+TbSiz[A],'  Y2=',TBLen[A]*(HaF+4)+3,'     ');
Gotoxy(1,16); Writeln('Menu No=',A,'      Size=',TbSiz[A],'  ');
Gotoxy(1,17); Writeln('Qtt TWindow=',Sys.WinOpenCount,' ');
Gotoxy(1,18); Writeln('NError=',NError,' ');}

(*            If MOS_Errors.NError<>0 Then Begin        {*Erreurs Initialisations*}
               M.TbId[A,1]:=M.TbId[A,1] And ($FF-$40);{*Clear Bit 6 Window is Displaying*}
               Win_Done(WB);                 {*Suprime Bandeau*}
               Exit; End;*)
            DISPLAY_MENU_WIN(M);                {*Aff Menu & Points in Window*}
            If (Id_Gad1 And $4=$4) And          {*Accs par Clavier =>...*}
               (M.TbLen[A]>1) Then Begin        {*Et au moins 1 point Menu !*}
               PS:=2; Point:=1;                 {*Point N1 Activ*}
               SEARCH_NEXT_POINT(False);        {*Renvois Next Point Libre*}
               If M.TbId[MS,2] And $80<>$80 Then
                  TOGGLE_POINT(M,PS);           {*...Active Point Menu No 1*}
               End;
            End;

      If M.TbId[A,1] And $40=$40 Then           {*Slectionne les Points*}
         For B:=2 to M.TbLen[A] do Begin

            If (Mse_TestBox(PLM[A]-DeltaX-LaF*2, 2+(B-1)*(HaF+4), PLM[A]+M.TbSiz[A]-DeltaX, 1+B*(HaF+4),10)=True)
               Or (Point=B-1) Then              {*Active by Key*}
               If (M.TbId[A,B] And $1<>$1) And  {*Point Gris = Non*}
                  (M.TbId[A,B] And $2<>$2) Then {*Barre Sparation = Non*}
                  Begin
                  Point_Ok:=True;               {*On est sur le Point !!!*}
                  If (PS<>B) Then Begin
                     If PS>0 Then TOGGLE_POINT(M,PS);{*Raffiche Old Point*}
                     TOGGLE_POINT(M,B);         {*Inverse New Point Slectionn*}
                     PS:=B;                     {*Point Slectionn dans PS*}
                     Check_Bit:=False;          {*Autre Point => Check <>*}
                     End;
                  End
                  Else Begin
                  Point_Ok:=False;              {*On est ds un Pt non Slectionnable*}
                  If (PS<>B) Then Begin         {*Inverse Old Point Slectionn*}
                     If PS>0 Then TOGGLE_POINT(M,PS);
                     PS:=0; End;
                  End;
            End;

      If (M.TbId[A,1] And $40=$40) And          {*Menu Window Ouverte ?*}
      (Mse_TestBox(PLM[A]-DeltaX-LaF*2, HaF+6, PLM[A]+M.TbSiz[A], 2+M.TbLen[A]*(HaF+4),10)=False)
      And (Id_Gad1 And $4<>$4) Then Begin       {*Inverse Old Point Slectionn*}
         If PS>0 Then TOGGLE_POINT(M,PS);
         PS:=0; End;
      End;

{Gotoxy(1,5); Writeln('MS=',MS,' PS=',PS,' ');
Gotoxy(1,6); Writeln('Point Sel=',Point_Sel,' ');
Gotoxy(1,7); Writeln('Last_Point=',Last_Point,' ');}

   If (MS>0) And (Id_Gad1 And $4<>$4) And       {*Menu Slectionn by Mouse ?*}
      (Mse_TestBox(PLM[MS]-DeltaX-LaF*2, HaF+5, PLM[MS]+M.TbSiz[MS], M.TBLen[MS]*(HaF+4)+3,10)=False)
         Then Point_Ok:=False;                  {*On est pas sur un Pt du Menu*}

   If (Point_Ok=True) And (M.TbId[MS,PS] And $4=$4){*Point Ok et Check ?*}
      And (Mse_Clicked(1)=True)                 {*LMB Cliqu*}
      And (Id_Gad1 And $4<>$4) And              {*Not in key Select Mode ?*}
      (Check_Bit=False) Then Begin              {*Pas Encore Modifi ?*}
      If M.TbId[MS,1] And $2=$2                 {*Bit Exclusif du Menu Label*}
         Then SET_EXCLUSIF(M)
         Else
         If M.TbId[MS,PS] And $8=$8 Then        {*Point Crochet*}
            M.TbId[MS,PS]:=M.TbId[MS,PS] And ($FF-$8)
            Else
            M.TbId[MS,PS]:=M.TbId[MS,PS] Or $8; {*Point Non Crochet*}
      TOGGLE_POINT(M,PS);                       {*Efface Toggle Point*}
      DISPLAY_MENU_WIN(M);                      {*Raffiche le Menu*}

      TOGGLE_POINT(M,PS);                       {*Raffiche Toggle Point*}
      Check_Bit:=True;                          {*On  Modifi le Check*}
      Last_Point:=True;                         {*On  Cliqu sur un Point !*}
      MS1:=MS; PS1:=PS;                         {*Save Position Point*}
      End;

   If Mse_Clicked(1)=False Then Check_Bit:=False;{*Check_Bit Rinitialis*}

   If (Id_Gad1 And $4<>$4) And (Mse_Clicked(3)=False) Then Exit_Flag:=True; {*Tant que RMB=True*}
   If (Id_Gad1 And $4=$4) And (kbd_GetKeyDown(VK_MENU)=False) And (Win_Exist=0) Then Exit_Flag:=TRUE;{*Tant que ALT=True*}

   Font_Set(Sys.FontMain,Sys.FontMainSize);           {*Repasse en Fonte Normale*}
   Until Exit_Flag=True;                        {*Sortie du Menu !!!*}

   W.IDRES:=$0000;                              {*Clear IDRES for Cool Kill*}
   If WinWMake Then Win_Done(W); {Sybaris dbuggage}  {*Sucre Fentre Restante*}
   If MS>0 Then M.TbId[MS,1]:=M.TbId[MS,1] And ($FF-$40);{*Clear Bit 6 Window is Displaying*}
   M.TbId[1,1]:=M.TbId[1,1] And ($FF-$80);      {*Clear Bit 7 for Mark Boolean*}
   Win_Done(WB);                             {*Suprime Bandeau*}
   If Cancel=True Then Begin MS:=0; PS:=0; Exit; End; {*Annulation*}
   If Point_Ok=True Then Begin
      If (M.TbId[MS,PS] And $4=$4) Then         {*Point Check ?*}
         If M.TbId[MS,1] And $2=$2              {*Bit Exclusif du Menu Label*}
            Then SET_EXCLUSIF(M)
            Else
            If M.TbId[MS,PS] And $8=$8 Then
               M.TbId[MS,PS]:=M.TbId[MS,PS] And ($FF-$8){*Point Crochet*}
               Else
               M.TbId[MS,PS]:=M.TbId[MS,PS] Or $8;{*Point Non Crochet*}
      Dec(PS)                                   {*Dcale  Cause du Titre Menu*}
      End
      Else If Last_Point=False
         Then Begin MS:=0; PS:=0; End           {*Aucun Points Slectionns*}
         Else Begin MS:=MS1; PS:=PS1-1; End;    {*Rcupre Coordones Point*}
   End;

{Mse_SetPointerMode(P_AutoMode);}                 {*Inhibe Autogestion du TPointer*}
End;

{*-------------------------- PROGRAMME PRINCIPAL ---------------------------*}

Begin
End.
