{ͻ
                               UNIT MosMouse                                
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: PLANAS Jean-Pierre                                           
  CREATED THE: 15.02.1994                                                   
  COUNTRY....: IUT Montpellier.                                             
  DESCRIPTION: Management of the mouse.                                     
  AUTONOMOUS.: Partial                                                      
  UNIT SIZE..: 1.602 Lines and (29.728 Bytes compiled)                      
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosMouse;

{$Mode ObjFpc}

INTERFACE

Uses
     MosConfig;

Type TPosMse=Record                      {*Mouse position Multiple uses *}
       X,Y          :Integer;
     End;

     TMouseState=Record
       X,Y    :Word;                     {*Mouse coordinantes*}
       L,M,R  :Boolean;                  {*Mouse Buttons Actions*}
     End;

     TAction=Record
       State        :TMouseState;
       XOld,YOld    :Word;               {*Old mouse coordinantes*}
     End;

     TClickM=Record
       T1,T2,T3,T4         :Word;        {*Time for Timming             *}
       N1,N2,N3,N4         :Word;
       Flg_Press           :Boolean;     {*Button Pressed ot not        *}
       Flg_Relache         :Boolean;     {*Internal Flg Relach         *}
     End;

Var PosMouse      :TPosMse;              {*Mouse position*}
    MseLimitBox   :Array[1..4] of Word;  {*For Mse_SetLimit*}
    CM1,CM        :TClickM;              {*              *}

{--------------------------}

{|Hide/Show mouse|}
Procedure Mse_Show;                      {*Show mouse*}
Procedure Mse_Hide;                      {*Hide mouse*}

{|Position|}
Procedure Mse_Put(X,Y:Word);             {*Put mouse on X,Y*}

{|Boxes|}
Procedure Mse_SetLimit(X1,Y1,X2,Y2:Word);{*Limit mouse on box*}

{|Mouse pointers|}
Procedure Mse_SetPointer(Style:String);  {*Set mouse pointer*}

{|Miscellaneous|}
Procedure Mse_Speed(X,Y:Integer);        {*Speed Mouse. Mickeys/Pixels*}

{|Hardware information|}
Function  Mse_Test:Boolean;              {*Test if the mouse exist*}
Function  Mse_GetVersion:String;         {*Get Mouse driver version*}
Function  Mse_GetType:String;            {*Get Mouse type*}

{|Init/Done Mouse|}
Procedure Init_Mouse;                    {*Reinstalle Normal Mouse*}
Procedure Done_Mouse;                    {*Reinstalle Normal Mouse*}

Procedure Init_MouseDriver;              {*No mouse driver*}
Procedure Init_MouseVar;                 {*Initialise mouse variables*}
Procedure Done_MouseVar;                 {*Restore mouse parameters*}

{--------------------------}

{|Boxes|}
Function  Mse_TestBox(X1,Y1,X2,Y2,B:Word):Boolean; {*Test if mouse is in Box*}
Procedure Mse_GetLimit(Var X1,Y1,X2,Y2:Integer); {*Get the limits ot the mouse box*}

{|Double click|}
Procedure Mse_SetDoubleClick(T:Integer); {*Set double click*}
Function  Mse_TestDoubleClick:Boolean;   {*Test mouse double click*}

{|Mouse Delay|}
Procedure Mse_SetDelay(T:Integer);       {*Set mouse delay*}
Function  Mse_TestDelay:Boolean;         {*True=Mouse Delay Passed*}

{|Miscellaneous|}
Function  Mse_Clicked(Num:Integer):Boolean;{*Test if mouse is clicked*}
Procedure Mse_Blanker;                   {*Manage the mouse blanker*}
Procedure Mse_GetPosInGrid(Var X,Y:Word);{*Calculate Coord With Grid*}

{|Position|}
Procedure Mse_Get(Var X,Y:Word;Var L,M,R:Boolean);{*Get mouse position and buttons states*}
Procedure Mse_GetPos(Var X,Y:Word);               {*Get mouse position only*}

Function  Mse_TestClippedBox(C:TCoordinates):Boolean; {*Test if mouse is in box*}

IMPLEMENTATION

Uses
     Dos,
     IniFiles,
     GraphiX,
     GxImg,
     GxMouse,
     MosBase,
     MosCPUInstructions,
     MosCrt,
     MosFiles,
     MosGraph,
     MosStrings,
     MosTasks;

{ͻ
                        FUNCTION Mse_TestClippedBox                         
 ͹
  IN.....: C (TCOORDINATES) = Box coordinates                               
  OUT....: (BOOLEAN) = TRUE if in box else return FALSE                     
  EXPLAIN: This function test if mouse is in a box.                         
 ͼ}
Function Mse_TestClippedBox(C:TCoordinates):Boolean;
Const Sp=16;                            {*Mouse pointer size in pixel*}
Begin
If Id_Scr1 And $8=$8 Then Begin         {*Window Clipped*}
   Inc(C.X1,T_Clip.X1);
   Inc(C.Y1,T_Clip.Y1);
   Inc(C.X2,T_Clip.X1);
   Inc(C.Y2,T_Clip.Y1);
   End;
If Mse_TestBox(C.X1-Sp,C.Y1-Sp,C.X2+Sp,C.Y2+Sp,10) Then Mse_TestClippedBox:=Yes Else Mse_TestClippedBox:=No;
End;

{***************************************************************************}
{***************************************************************************}
{***************************************************************************}
{***************************************************************************}
{***************************************************************************}

Const MseStack:Integer=0;
{ͻ
                             PROCEDURE Mse_Show                             
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Show the mouse.                                                  
 ͼ}
Procedure Mse_Show;
Var VP:TViewPortType;
Begin
Inc(MseStack);
If MseStack>=1 Then
  Begin
  MseStack:=1;

  VESA_GetViewSettings(VP);               {*Save ViewPort*}
  VESA_SetViewPort(VP.X1,VP.Y1,VP.X2,VP.Y2,False); {*Restore ViewPort*}

  MouseOn;
  VESA_SetViewPort(VP.X1,VP.Y1,VP.X2,VP.Y2,VP.Clip); {*Restore ViewPort*}
  End;
End;

{ͻ
                             PROCEDURE Mse_Hide                             
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Hide the mouse.                                                  
 ͼ}
Procedure Mse_Hide;
Var VP:TViewPortType;
Begin
Dec(MseStack);
VESA_GetViewSettings(VP);               {*Save ViewPort*}
VESA_SetViewPort(VP.X1,VP.Y1,VP.X2,VP.Y2,False); {*Restore ViewPort*}
MouseOff;
VESA_SetViewPort(VP.X1,VP.Y1,VP.X2,VP.Y2,VP.Clip); {*Restore ViewPort*}
End;

{*----------------------------- POSITION -----------------------------------*}

{ͻ
                           PROCEDURE Mse_GetBase                            
 ͹
  IN.....: /                                                                
  OUT....: X,Y (WORD) = Mouse coordinates.                                  
           G,M,D (BOOLEAN) = State of mouse buttons.                        
  EXPLAIN: Return mouse position and buttons states.                        
           G=Gauche (Left), M=Milieu (Center), D=Droit (Right)              
  EXAMPLE: Mse_GetBase(X,Y,G,M,D); Writeln(X,Y,G,M,D);                      
  SEEALSO: Mse_Get                                                          
 ͼ}

Procedure Mse_GetBase(Var X,Y:Word;Var G,M,D:Boolean);
Var But:Byte;
    VP:TViewPortType;
    XA,YA:Longint;
Begin
VESA_GetViewSettings(VP);               {*Save ViewPort*}
VESA_SetViewPort(VP.X1,VP.Y1,VP.X2,VP.Y2,False); {*Restore ViewPort*}

But:=MouseButton;
G:=BTST(But,0);    {*Left  *}
D:=BTST(But,1);    {*Right *}
M:=BTST(But,2);    {*Middle*}
MouseCoords(XA,YA);
X:=XA;Y:=YA;

VESA_SetViewPort(VP.X1,VP.Y1,VP.X2,VP.Y2,VP.Clip); {*Restore ViewPort*}

End;

{ͻ
                             PROCEDURE Mse_Put                              
 ͹
  IN.....: X,Y (WORD) = Mouse coordinates.                                  
  OUT....: /                                                                
  EXPLAIN: Put the mouse on X,Y coordinates.                                
  EXAMPLE: Mse_Put(2,2);                                                    
 ͼ}

Procedure Mse_Put(X,Y:Word);
Begin
SetMousePosition(X,Y);
End;

{ͻ
                           PROCEDURE Mse_SetLimit                           
 ͹
  IN.....: X1,Y1,X2,Y2 (WORD) = Coordinates of the limit box.               
  OUT....: /                                                                
  EXPLAIN: Limit the move of the mouse in box.                              
  EXAMPLE: Mse_SetLimit(16,50,5,10);                                        
  SEEALSO: Mse_GetLimit                                                     
 ͼ}
Procedure Mse_SetLimit(X1,Y1,X2,Y2:Word);
Begin
MseLimitBox[1]:=X1;
MseLimitBox[2]:=X2;
MseLimitBox[3]:=Y1;
MseLimitBox[4]:=Y2;
SetMouseArea(X1,Y1,X2,Y2);
End;

{*----------------------------- MOUSE POINTERS -----------------------------*}

{ͻ
                            PROCEDURE Mse_Speed                             
 ͹
  IN.....: X (INTEGER) = Mickeys                                            
           Y (INTEGER) = Pixels                                             
  OUT....: /                                                                
  EXPLAIN: Define the yield between Mickeys and Pixels.                     
  EXAMPLE: Mse_Speed(5,10);                                                 
 ͼ}

Procedure Mse_Speed(X,Y:Integer);
Begin
// To avoid warnings !
   X := X;
   Y := Y;
End;

{ͻ
                             FUNCTION Mse_Test                              
 ͹
  IN.....: /                                                                
  OUT....: (BOOLEAN) = TRUE if mouse is installed, else FALSE               
  EXPLAIN: Test if the mouse is present (Mouse driver loaded).              
           This function reinit mouse driver and if an handler is loaded,   
           it's reset.                                                      
 ͼ}

Function Mse_Test:Boolean;
Begin
   InitMouse;
   Result := TRUE; // Now mouse will always run !
End;

{ͻ
                          FUNCTION Mse_GetVersion                           
 ͹
  IN.....: /                                                                
  OUT....: (STRING) = Version of mouse driver.                              
  EXPLAIN: Return the version of mouse driver installed.                    
 ͼ}

Function Mse_GetVersion:String;
Begin
Mse_GetVersion:='';
End;

{ͻ
                            FUNCTION Mse_GetType                            
 ͹
  IN.....: /                                                                
  OUT....: (STRING) = Type of mouse installed.                              
  EXPLAIN: Return the type of mouse installed.                              
 ͼ}

Function Mse_GetType:String;         {*Type de Souris*}
Begin
Mse_GetType:='';
End;

{*----------------------------- INIT / DONE MOUSE --------------------------*}

{ͻ
                            PROCEDURE Init_Mouse                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Init the graphic mouse.                                          
 ͼ}

Procedure Init_Mouse;                   {*Initialise Mouse for Gfx*}
Begin
Mse_Test;
Init_MouseVar;                          {*Initialise mouse variables*}
End;

{ͻ
                            PROCEDURE Done_Mouse                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: "Close" and end the use of graphic mouse.                        
 ͼ}

Procedure Done_Mouse;                         {*Reinstalle Normal Mouse*}
Begin
Main_Task;
Mse_SetLimit(0,0,VESA_GetMaxX,VESA_GetMaxY);     {*Souris Plein Ecran*}
Mse_Speed(10,10);                             {*Vitesse Souris Classique*}
Mse_Hide;                                     {*Planque la Souris*}
End;

{---}
Type TMsePointer=Record
     Name      : String;
     BMPFile   : String;
     Sprite    : Pointer;
     MseSprite : PMousePointer;
     HSx,HSy   : Byte;                     {*HotSpot X & Y*}
     TColor    : Longint;
     End;

Const MSE_PointerLoaded : Boolean = False ;
Var MSE_ActualPointer:TMSEPointer;
{---}
Procedure Mse_LoadPointer(Var P:TMSEPointer;FileName:String);
Var TColor,Hsp:String;
    R,G,B     :Byte;
    Ini       :TIniFile;

Begin
If Not File_TestExist(FileName) Then Exit;  {*File not found*}

Ini_Init(Ini,FileName);
P.BMPFile:=Ini_LoadKey(Ini,'Mouse Pointer','Bitmap','');
TColor:=Ini_LoadKey(Ini,'Mouse Pointer','Transparency color','');
R:=Str_S2L(Str_Get(TColor,1,','));
G:=Str_S2L(Str_Get(TColor,2,','));
B:=Str_S2L(Str_Get(TColor,3,','));
P.TColor:=VESA_SetRGBColor(R,G,B);

HSp:=Ini_LoadKey(Ini,'Mouse Pointer','Hotspot','1,1');
P.HSx:=Str_S2L(Str_Get(Hsp,1,','));
P.HSy:=Str_S2L(Str_Get(Hsp,2,','));
Ini_Done(Ini);
End;
{---}

Procedure Mse_SetNewPointer(Style:String);
Var St:String;
Begin
St:=Sys.GetPath(SP_POINTERS)+Style;  {*Build name*}
If Pos('.CUR',Style)<=0 Then St:=St+'.CUR';

Mse_LoadPointer(MSE_ActualPointer,St);         {*Load .cur file*}
MSE_ActualPointer.Name:=Style;

With MSE_ActualPointer Do
  Begin
  BMPFile:=Sys.GetPath(SP_POINTERS)+BMPFile;  {*Build name*}

  If Not File_TestExist(BMPFile) Then Exit;    {*File not found*}

  LoadImageFile(itBMP,BMPFile,Sprite,1);
  SetImageTransparencyColor(Sprite,TColor);

  CreateMousePointer(MseSprite,HSx,HSy,Sprite);
  Initmousepointer(MseSprite);
  End;
MSE_PointerLoaded:=True;
End;

{---}

Procedure Mse_UnSetPointer;
Begin
If Not MSE_PointerLoaded Then Exit;
Initmousepointer(Defaultmousepointer);
With MSE_ActualPointer Do
  Begin
  Destroymousepointer(MseSprite);
  DestroyImage(Sprite);
  End;
MSE_PointerLoaded:=False;
End;

{ͻ
                          PROCEDURE Mse_SetPointer                          
 ͹
  IN.....: Style (BYTE): Number of the style pointer.                       
  OUT....: /                                                                
  EXPLAIN: Change the mouse pointer.                                        
           Constants you can use for Style :                                
           - MPArrow     = Normal pointer (arrow).                          
           - MPBusy    = Wait pointer (Busy,Watch).                         
           - MPHand    = Hand pointer.                                      
           - MPText    = Text pointer.                                      
           - MPTarget  = Target pointer (draw application...).              
           - MPMove    = Move pointer.                                      
           - MPHead    = Dead head pointer.                                 
           - MPMoveX   = Horizontal move pointer.                           
           - MPPiano   = Piano style pointer                                
           - MPSizeLR  = Resize Left/Right pointer                          
           - MPSizeLUDR= Resize Left & Up / Down Right pointer              
           - MPSizeRUDL= Resize Rigth & Up / Down Left pointer              
           - MPSizeUD  = Resize Up/Down pointer                             
           - MPTarget  = TARGET';                                           
           - MPText    = TEXT';                                             
           - MPWarning = WARNING';                                          
 ͼ}

Procedure Mse_SetPointer(Style:String);
Begin
Style:=Upper(Style);
If Style=Actual_Pointer Then Exit;      {*Pointer current*}
If Style='' Then Exit;                  {*No pointer defined*}

{BUG tester si le fichier existe avant de dcharger le pointeur de la mmoire}

Mse_Hide;
Mse_UnSetPointer;
{//$IFNDEF WIN32}
Mse_SetNewPointer(Style);
{//$ENDIF}
Mse_Show;

Actual_Pointer:=Style;
End;

{****************************************************************************}
{****************************************************************************}
{****************************************************************************}
{****************************************************************************}
{****************************************************************************}
{****************************************************************************}
{****************************************************************************}
{****************************************************************************}
{****************************************************************************}
{****************************************************************************}

{*------------------------------- BOXES ------------------------------------*}

{ͻ
                            FUNCTION Mse_TestBox                            
 ͹
  IN.....: X1,Y1,X2,Y2 (WORD) = Box where to test the mouse position.       
           B (WORD) = Code of buttons to test + of the zone.                
           0 = Test Zone + Buttons not activated                            
           1 = Test Zone + Left Buttons                                     
           2 = Test Zone + Middle Buttons                                   
           3 = Test Zone + Right Buttons                                    
          10 = Test Zone however the state of the buttons                   
  OUT....: (BOOLEAN)                                                        
  EXPLAIN: Test if the mouse is in the specified box.                       
  EXAMPLE: If Mse_TestBox(10,15,5,6,3)=True Then Writeln('OK');             
 ͼ}

Function Mse_TestBox(X1,Y1,X2,Y2,B:Word):Boolean;
Var X,Y:Word;
    G,M,D:Boolean;
Begin
Mse_TestBox:=False;                               {*No Mouse Driver*}

Mse_Get(X,Y,G,M,D);
If (B<0) Or (B>10) Then Exit;                     {*Error in Mouse Buttons*}

If (X>=X1) And (X<=X2) And (Y>=Y1) And (Y<=Y2) Then
   Begin
   If (B=0) And (G=False) And (M=False) And (D=False) Then Mse_TestBox:=True;
   If B=1 Then If G=True Then Mse_TestBox:=True;
   If B=2 Then If M=True Then Mse_TestBox:=True;
   If B=3 Then If D=True Then Mse_TestBox:=True;
   If B=10 Then Mse_TestBox:=True;                {*Zone + (Buttons)*}
   End
End;

{ͻ
                           PROCEDURE Mse_GetLimit                           
 ͹
  IN.....: /                                                                
  OUT....: X1,Y1,X2,Y2 (WORD) = Coordinates of the limit box.               
  EXPLAIN: Get the limit box of the mouse set with Mse_SetLimit             
  SEEALSO: Mse_SetLimit                                                     
 ͼ}
Procedure Mse_GetLimit(Var X1,Y1,X2,Y2:Integer);
Begin
X1:=MseLimitBox[1];
X2:=MseLimitBox[2];
Y1:=MseLimitBox[3];
Y2:=MseLimitBox[4];
End;

{*----------------------------- DOUBLE CLICK -------------------------------*}

{ͻ
                        PROCEDURE MSE_SetDoubleClick                        
 ͹
  IN.....: T (INTEGER): Value in Ms for a Double Click                      
  OUT....: /                                                                
  EXPLAIN: Define again the delay of a double click.                        
  EXAMPLE: MSE_SetDoubleClick(100);                                         
 ͼ}

Procedure MSE_SetDoubleClick(T:Integer);
Begin
Sys.MouseDblClickDelay:=T;
End;

{ͻ
                        FUNCTION Mse_TestDoubleClick                        
 ͹
  IN.....: /                                                                
  OUT....: (BOOLEAN) = TRUE if double click success                         
  EXPLAIN: To know if a double clicked on an item.                          
  EXAMPLE: If Mse_TestDoubleClick Then ...                                  
 ͼ}

Function Mse_TestDoubleClick:Boolean;
Begin
Mse_TestDoubleClick:=False;
If Mse_Clicked(1) Then
   Begin
   If CM.Flg_Press=False Then
      Begin
      CM.Flg_Press:=True;
      CM.Flg_Relache:=True;
      GetTime(CM.T1,CM.T2,CM.T3,CM.T4);
      GetTime(CM.N1,CM.N2,CM.N3,CM.N4);
      End

   Else Begin
      GetTime(CM.N1,CM.N2,CM.N3,CM.N4);
      If CM.Flg_Relache=False Then
      If ((CM.N1-CM.T1)*360000+(CM.N2-CM.T2)*6000+(CM.N3-CM.T3)*100+CM.N4-CM.T4)<Sys.MouseDblClickDelay
         Then Begin Mse_TestDoubleClick:=True; CM.Flg_Press:=False; End
         Else Begin CM.Flg_Press:=False; End;
      End;
   End
   Else Begin CM.Flg_Relache:=False; End;
End;

{*----------------------------- MOUSE DELAY --------------------------------*}

{ͻ
                           PROCEDURE Mse_SetDelay                           
 ͹
  IN.....: T (INTEGER): Value in Ms for a delay click.                      
  OUT....: /                                                                
  EXPLAIN: Define again the delay of a click.                               
  EXAMPLE: Mse_SetDelay(100);                                               
 ͼ}
Procedure Mse_SetDelay(T:Integer);
Begin
Sys.MouseClickDelay:=T;
End;

{ͻ
                           FUNCTION Mse_TestDelay                           
 ͹
  IN.....: /                                                                
  OUT....: (BOOLEAN) = TRUE if mouse delay passed, else FALSE.              
  EXPLAIN: To know if the Delay Mouse Clicked is past.                      
  EXAMPLE: If Mse_TestDelay=True Then ...                                   
 ͼ}

Function Mse_TestDelay:Boolean;                   {True=Mouse Delay Pass}
Begin
If Mse_Clicked(1) Then
   Begin
   If CM1.T1>=25 Then
      Begin
      CM1.Flg_Press:=True;
      GetTime(CM1.T1,CM1.T2,CM1.T3,CM1.T4);
      Mse_TestDelay:=True;
      End

      Else Begin
      GetTime(CM1.N1,CM1.N2,CM1.N3,CM1.N4);
      If ((CM1.N1-CM1.T1)*360000+(CM1.N2-CM1.T2)*6000+(CM1.N3-CM1.T3)*100+CM1.N4-CM1.T4)>Sys.MouseClickDelay
         Then Mse_TestDelay:=True
         Else Mse_TestDelay:=False;
      End;
   End
   Else Begin CM1.Flg_Press:=False; CM1.T1:=25; Mse_TestDelay:=False; End;
End;


{*----------------------------- MISCELLANEOUS ------------------------------*}

{ͻ
                            FUNCTION Mse_Clicked                            
 ͹
  IN.....: Num (INTEGER) = Code of buttons to test + of the zone.           
             0 = Test Zone + Buttons not activated                          
             1 = Test Zone + Left Buttons                                   
             2 = Test Zone + Middle Buttons                                 
             3 = Test Zone + Right Buttons                                  
            10 = Test Zone however the state of the buttons                 
  OUT....: (BOOLEAN) = TRUE if clicked, else FALSE.                         
  EXPLAIN: Test if one Button of the mouse is clicked.                      
  EXAMPLE: If Mse_Clicked=True Then ...                                     
 ͼ}

Function Mse_Clicked(Num:Integer):Boolean;
Var X,Y     :Word;
    Ga,Mi,Dr:Boolean;
Begin
Mse_Clicked:=False;
If (Num<0) Or (Num>10) Then Exit;              {*Error in Mouse Buttons*}
Mse_Get(X,Y,Ga,Mi,Dr);
If (Num=1) And (Ga=True) Then Mse_Clicked:=True;
If (Num=2) And (Mi=True) Then Mse_Clicked:=True;
If (Num=3) And (Dr=True) Then Mse_Clicked:=True;
If (Num=0) And ((Ga=True) Or (Mi=True) Or (Dr=True)) Then Mse_Clicked:=True;
If (Num=10) Then Mse_Clicked:=True;
End;

{ͻ
                           PROCEDURE Mse_Blanker                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Manage the mouse blanker.                                        
 ͼ}

Procedure Mse_Blanker;
Var X,Y     :Word;
    Ga,Mi,Dr:Boolean;
Begin
If Sys.SetMouseBlanker=True Then
  Begin
  If KeyPressed Then Mse_Hide;                {*Cache la Souris*}
  If Mse_Clicked(0)=True Then Mse_Show;       {*Boutons Souris Presss*}
  Mse_Get(X,Y,Ga,Mi,Dr);
  If (X<>PosMouse.X) Or (Y<>PosMouse.Y) Then   {*Souris Dplace*}
     Begin
     PosMouse.X:=X; PosMouse.Y:=Y;
     Mse_Show;
     End;
  End;
End;

{ͻ
                         PROCEDURE Mse_GetPosInGrid                         
 ͹
  IN.....: X,Y (WORD) = X,Y coordinates to test.                            
  OUT....: X,Y (WORD) = New coordinates perharps modified.                  
  EXPLAIN: Put the coordinates X,Y in function of the grid if the Grid is   
           set.                                                             
 ͼ}

Procedure Mse_GetPosInGrid(Var X,Y:Word);       {*Calcule Coord With Grid*}
Var Det:Word;
Begin
If Sys.SetGrid=True Then
  Begin
  Det:=(Abs(X Mod Sys.GridStepX)+(X Mod Sys.GridStepX));      {*Calcule Nouveau X*}
  If Det<Sys.GridStepX Then X:=X-(X Mod Sys.GridStepX)
                Else X:=X-(X Mod Sys.GridStepX)+Sys.GridStepX;
  Det:=(Abs(Y Mod Sys.GridStepY)+(Y Mod Sys.GridStepY));      {*Calcule Nouveau Y*}
  If Det<Sys.GridStepY Then Y:=Y-(Y Mod Sys.GridStepY)
                Else Y:=Y-(Y Mod Sys.GridStepY)+Sys.GridStepY;
  End;
If X>VESA_GetMaxX Then X:=VESA_GetMaxX;         {*Correction Maximum Position*}
If Y>VESA_GetMaxY Then Y:=VESA_GetMaxY;
If X<0 Then X:=0;                               {*Correction Minimum Position*}
If Y<0 Then Y:=0;
End;

{*----------------------------- HARDWARE INFORMATION -----------------------*}


{ͻ
                             PROCEDURE Mse_Get                              
 ͹
  IN.....: /                                                                
  OUT....: X,Y (WORD) = Mouse coordinates.                                  
           G,M,D (BOOLEAN) = State of mouse buttons.                        
  EXPLAIN: Return mouse position and buttons states.                        
           L=Left, M=Middle (Center), R=Right                               
  EXAMPLE: Mse_Get(X,Y,L,M,R); Writeln(X,Y,L,M,R);                          
 ͼ}

Procedure Mse_Get(Var X,Y:Word; Var L,M,R:Boolean);
Var BSwap:Boolean;                               {*Echange LMB et RMB Gaucher*}

Begin
Mse_GetBase(X,Y,L,M,R);
Mse_GetPosInGrid(X,Y);                           {*Modifie X,Y if Grid=Grid}

If BTST(Id_Gad1,4) Then                          {*Swap LMB & RMB - GAUCHERS*}
  Begin
  BSwap:=L;
  L:=R;
  R:=BSwap;
  End;
End;

{ͻ
                            PROCEDURE Mse_GetPos                            
 ͹
  IN.....: /                                                                
  OUT....: X,Y (WORD) = Mouse coordinates.                                  
  EXPLAIN: Return mouse position                                            
  EXAMPLE: Mse_GetPos(X,Y); Writeln(X,Y);                                   
 ͼ}

Procedure Mse_GetPos(Var X,Y:Word);
Var G,M,D:Boolean;                               {*Echange LMB et RMB Gaucher*}
Begin
Mse_Get(X,Y,G,M,D);
End;

{ͻ
                         PROCEDURE Init_MouseDriver                         
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test if mouse driver is present.                                 
 ͼ}

Procedure Init_MouseDriver;
Begin
If Application.Mode = AMText Then Exit; {*Not in graphic mode*}

Log.Add('Initialise mouse driver');
Mse_Test;
End;

{ͻ
                          PROCEDURE Init_MouseVar                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Initialise mouse variables and parameters.                       
 ͼ}

Procedure Init_MouseVar;
Begin
If Application.Mode = AMText Then Exit; {*Not in graphic mode*}

Log.Add('Initialise mouse parameters');
Mse_SetLimit(0,0,VESA_GetMaxX,VESA_GetMaxY);  {*Souris Plein Ecran*}
Mse_Speed(Sys.MouseSpeed,Sys.MouseSpeed);     {*Vitesse Souris*}
Mse_Put(VESA_GetMaxX Div 2, VESA_GetMaxY Div 2); {*Set Mouse in Screen Center*}
Mse_SetPointer(P_Current);                    {*Pointer to be Current*}
Mse_Show;                                     {*Affiche la Souris*}
End;

{ͻ
                          PROCEDURE Done_MouseVar                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Restore mouse parameters.                                        
 ͼ}

Procedure Done_MouseVar;
Begin
If Application.Mode = AMText Then Exit; {*Not in graphic mode*}

Log.Add('Restore initial mouse parameters');
Mse_SetLimit(0,0,VESA_GetMaxX,VESA_GetMaxY);  {*Souris Plein Ecran*}
Mse_Speed(10,10);                             {*Vitesse Souris Classique*}
Mse_Hide;                                     {*Planque la Souris*}
Mse_UnSetPointer;
End;


{*----------------------------- INITIALISATIONS ----------------------------*}

Begin
CM.Flg_Press:=False;
MseLimitBox[1]:=0;
MseLimitBox[2]:=0;
MseLimitBox[3]:=0;
MseLimitBox[4]:=0;
End.
