{ͻ
                               UNIT MosPopup                                
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 06.05.1999                                                   
  COUNTRY....: Perpignan - ASI Informatique                                 
  DESCRIPTION: Popup Menu and Main Menu management                          
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 833 Lines and (20.368 Bytes compiled)                        
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosPopup;

{$Mode Objfpc}

INTERFACE

Uses
     MosConfig,
     MosText,
     MosWindows;

Type TPopupMenu = Record                {*Menus structure*}
     MenuType           :Byte;          {*0=Window, 1=Popup*}
     Wti                :TCoordinates;  {*Menu title box*}
     Wpa                :TCoordinates;  {*Menu parent window*}
     Box                :TCoordinates;  {*Menu parent selected point box*}
     Mou                :TCoordinates;  {*Mouse zone to activate*}
     Font               :TFont;         {*Font structure pointer*}
     Enabled            :Boolean;       {*Menu enabled*}
     Visible            :Boolean;       {*Menu visible*}
     Tag                :Integer;       {*User tag*}
     MPointer           :String[12];    {*Mouse pointer to use*}
     Action             :Byte;          {*Actions transmited*}
     Result             :String[64];    {*Selected menu point*}
     SubMenuCount       :Byte;          {*Count SubMenus. Max: 32 Sub-Menus*}
     LineHeight         :Byte;          {*Height of the menu point*}
     MenuMovable        :Boolean;       {*Allow menu windows to move*}
     TitleBarClicked    :Boolean;       {*Menu title point has been clicked*}
     TitleClicked       :Byte;          {*Menu title number that has been clicked*}
     TitleMouseOver     :Byte;          {*Menu title number under mouse*}
     MouseOnTitle       :Boolean;       {*Mouse is over the menu title bar*}
     ListId             :Word;          {*List Id bits definition*}
     ListIdMore         :Word;          {*List IdMore bits definition*}
     Id                 :Word;          {*Bits selection for menu*}
        {*Bit 0  $0001 : 1 = Drop down menu window to upper*} {MIC}
     Image              :String[12];    {*Display image in menu background*}
     DataSource         :String;        {*Menu data path*}
     DataEntry          :String[12];    {*Menu initial entry main file*}
     DataFile           :String[12];    {*Menu current file*}
        {*Structure for the datasource menu file*}
        {*  Column      Description*}
        {*    1            Menu point type (C,R,S)*}
        {*                   ' '= Standard point*}
        {*                    C = Check point*}
        {*                    R = Radio point*}
        {*                    S = Separator*}
        {*    2            Enabled (Default=1)*}
        {*    3            Tagged or no (Check or radio point)*}
        {*                    T = Point tagged*}
        {*                   ' '= Point untagged*}
        {*    4            Menu point caption*}
        {*    5            Hotkey (Default=No hotkey)*}
        {*    6            SubMenu (Default='') SubMenu filename*}
     End;

   TMainMenu=TPopupMenu;                {*Use the same Menu structure*}

{|Main menu management|}
Procedure Menu_SetCoordinates(Var M:TPopupMenu; X1,Y1,X2,Y2:Integer);     {*Set special coordinates for main menu*}
Function  Menu_Main          (Var M:TMainMenu;  W:TWindow; MoveUp:Boolean; DataSource:String):Boolean; {*Define a main Menu*}
Function  Menu_TestMain      (Var M:TMainMenu):String;                    {*Manage and get messages from a main menu*}
Procedure Menu_ToggleTitle   (Var M:TMainMenu; Num:Byte);                 {*Toggle the selected menu title*}
Procedure Menu_ShowTitle     (Const M:TMainMenu);                         {*Display menu window title*}

{|Popup menu management|}
Function  Menu_Popup         (Var M:TPopupMenu; X1,Y1,X2,Y2:Integer; MoveUp:Boolean; DataSource:String):Boolean; {*Popup Menu*}
Function  Menu_ShowPopup     (Var M:TPopupMenu; W,I:TCoordinates; X1,Y1:Integer; DataFile:String):String;{*Display Popup menu*}
Function  Menu_TestPopup     (Var M:TPopupMenu):String;                   {*Display and manage a Popup menu*}

{|Miscellaneous menu management|}
Procedure Menu_Default       (Var M:TPopupMenu);                          {*Define default parameters*}
Function  Menu_AddPoint      (Var M:TPopupMenu; PPoint:Byte; DataFile,Point:String):Boolean;{*Add a menu point*}
Function  Menu_DeletePoint   (Var M:TPopupMenu; PPoint:Byte; DataFile:String):Boolean;      {*Delete a menu point*}
Function  Menu_TestCheckPoint(    Const MFile:String; PPoint:Byte):Boolean;   {*Test if a menu point is tagged*}
Function  Menu_SetCheckPoint (    Const MFile:String; PPoint:Byte; Value:Boolean):Boolean;  {*Tag/Untag check*}
Function  Menu_GetRadioPoint (    Const MFile:String):Byte;                   {*Get the tagged radio point menu*}
Function  Menu_EnablePoint   (    Const MFile:String; PPoint:Byte; Status:Boolean):Boolean; {*Enable/Disab point*}

{*----------------------------- Debut Library ------------------------------*}

IMPLEMENTATION

Uses
     Dos,
     Windows,
     MosBase,
     MosColors,
     MosErrors,
     MosFiles,
     MosGadgets,
     MosGraph,
     MosKeyboard,
     MosList,
     MosMouse,
     MosStrings,
     MosTools;

{ͻ
                           PROCEDURE Menu_Default                           
 ͹
  IN.....: M (TPopupMenu) = Pointer to the TPopupMenu structure.            
  OUT....: /                                                                
  EXPLAIN: Define default menu parameters.                                  
  SEEALSO: Menu_Main, Menu_Popup                                            
 ͼ}

Procedure Menu_Default(Var M:TPopupMenu);
Begin
With M do
   Begin
   Font.BgColor:=CLLightGrey;
   Font.PenColor:=CLText;
   Wpa.X1:=-1; Wpa.Y1:=-1; Wpa.X2:=-1; Wpa.Y2:=-1;
   Box.X1:=-1; Box.Y1:=-1; Box.X2:=-1; Box.Y2:=-1;
   Mou.X1:=-1; Mou.Y1:=-1; Mou.X2:=-1; Mou.Y2:=-1;
   DataSource:=FExpand('.')+'\';
   DataFile:='MENU.LIS';
   Image:='';
   TitleBarClicked:=FALSE;
   TitleClicked:=0;
   TitleMouseOver:=0;
   MouseOnTitle:=No;
   ListId:=$8342;                       {*Ou 8742*}
   ListIdMore:=$0013;
   Id:=$0000;
   MenuMovable:=FALSE;
   Enabled:=TRUE;
   Visible:=TRUE;
   Result:='';
   SubMenuCount:=0;
   Tag:=0;
   LineHeight:=HaF+2;
   Mse_SetPointer(P_Current);             {*Pointeur souris courrant*}
   End;
End;

{ͻ
                       PROCEDURE Menu_SetCoordinates                        
 ͹
  IN.....: M (TPopupMenu) = Pointer to the TPopupMenu structure.            
           X1,Y1,X2,Y2 (INTEGER) = New coordinates.                         
  OUT....: /                                                                
  EXPLAIN: Define new menu title coordinates for a Window menu.             
  SEEALSO: Menu_Main, Menu_Default                                          
 ͼ}

Procedure Menu_SetCoordinates(Var M:TPopupMenu; X1,Y1,X2,Y2:Integer);
Begin
M.Wti.X1:=X1;
M.Wti.Y1:=Y1;
M.Wti.X2:=X2;
M.Wti.Y2:=Y2;
End;

{ͻ
                            FUNCTION Menu_Popup                             
 ͹
  IN.....: M (TPopupMenu) = Pointer to the TPopupMenu structure.            
           X1,Y1,X2,Y2 (INTEGER) = Mouse box to activate to Popup menu.     
           MoveUp (BOOLEAN) = Allow menu windows to move.                   
           DataSource (STRING) = Menu data file.                            
  OUT....: (BOOLEAN) = TRUE = Definition Ok.                                
  EXPLAIN: Define a Popup menu.                                             
  SEEALSO: Menu_Main, Menu_Manage                                           
 ͼ}

Function Menu_Popup(Var M:TPopupMenu; X1,Y1,X2,Y2:Integer; MoveUp:Boolean; DataSource:String):Boolean;
Var  FD:DirStr;
     FN:NameStr;
     FE:ExtStr;
Begin
Menu_Popup:=FALSE;                      {*De base*}

Log.Add('Create new Popup Menu',2);

Menu_Default(M);                        {*Initialise with Menu default*}

M.Mou.X1:=X1;                           {*Set menu parameters*}
M.Mou.Y1:=Y1;
M.Mou.X2:=X2;
M.Mou.Y2:=Y2;
M.MenuMovable:=MoveUp;
M.Action:=0;
M.Font.Name:=Sys.FontCurrent;                 {*Save Used Font*}
M.Font.Size:=Sys.FontCurrentSize;

DataSource:=FExpand(DataSource);        {*Source data path*}
If Not File_TestExist(DataSource) Then Exit;

FSplit(DataSource, FD,FN,FE);
M.DataSource:=FD;

M.DataFile:=FN+FE;                      {*Source data file*}

Menu_Popup:=TRUE;                       {*No error*}
End;

{ͻ
                           FUNCTION Menu_AddPoint                           
 ͹
  IN.....: M (TPopupMenu) = Pointer to the TPopupMenu structure.            
           PPoint (BYTE) = Menu point index (0 to n).                       
           DataFile (STRING) = Menu filename to add menu point.             
           Point (STRING) = The point line.                                 
              Structure for the point line (Each column separated by ';').  
                Column      Description                                     
                  1            Menu point number                            
                  2            Enabled (Default=1)                          
                  3            Menu point type (Default=P) (P,C,R,S)        
                  4            Menu point caption                           
                  5            Hotkey (Default=No hotkey)                   
                  6            SubMenu (Default='') SubMenu filename        
  OUT....: (BOOLEAN) = TRUE = Point added safely.                           
  EXPLAIN: Add a menu point in a menu.                                      
  SEEALSO: Menu_DeletePoint                                                 
 ͼ}

Function Menu_AddPoint(Var M:TPopupMenu; PPoint:Byte; DataFile,Point:String):Boolean;
Var NbCol:Integer;
    FName:String;
Begin

Menu_AddPoint:=FALSE;

NbCol:=Str_Count(Point,';');            {*Count number of columns*}
If (NbCol<4) Or (NbCol>6) Then Exit;    {*Invalid number of columns !*}

FName:=M.DataSource+DataFile;
If Not File_TestExist(FName) Then Exit; {*Fichier absent !*}


Menu_AddPoint:=File_InsertString(FName,Point,PPoint); {*Insert new menu point*}
End;

{ͻ
                         FUNCTION Menu_DeletePoint                          
 ͹
  IN.....: M (TPopupMenu) = Pointer to the TPopupMenu structure.            
           PPoint (BYTE) = Menu point index (0 to n).                       
           DataFile (STRING) = Menu filename to add menu point.             
  OUT....: (BOOLEAN) = TRUE = Point added safely.                           
  EXPLAIN: Delete a menu point.                                             
  SEEALSO: Menu_AddPoint                                                    
 ͼ}

Function Menu_DeletePoint(Var M:TPopupMenu; PPoint:Byte; DataFile:String):Boolean;
Var FName:String;
Begin
Menu_DeletePoint:=FALSE;
FName:=M.DataSource+DataFile;
If Not File_TestExist(FName) Then Exit; {*Fichier absent !*}

Menu_DeletePoint:=File_DeleteLine(FName,PPoint); {*Delete menu point*}
End;

{ͻ
                             FUNCTION Menu_Main                             
 ͹
  IN.....: M (TMainMenu) = Pointer to the TPopupMenu structure.             
           W (TWindow) = Pointer to the Window structure.                   
           MoveUp (BOOLEAN) = Allow menu windows to move.                   
           DataSource (STRING) = Menu data file.                            
  OUT....: (BOOLEAN) = TRUE = Definition Ok.                                
  EXPLAIN: Define a classic window menu.                                    
  SEEALSO: Menu_Popup, Menu_Manage                                          
 ͼ}

Function Menu_Main(Var M:TMainMenu; W:TWindow; MoveUp:Boolean; DataSource:String):Boolean;
Var  FD:DirStr;
     FN:NameStr;
     FE:ExtStr;
Begin
Menu_Main:=FALSE;                       {*De base*}

Log.Add('Create new Main Menu',2);

Menu_Default(M);                        {*Initialise with Menu default*}

M.Wti.X1:=0;                            {*Set menu parameters*}
M.Wti.Y1:=0;
M.Wti.X2:=W.X2-W.X1-1;
M.Wti.Y2:=HaF1+10;                      {*Hauteur fonte menu*}

M.MenuMovable:=MoveUp;
M.Action:=0;
M.Font.Name:=Sys.FontCurrent;           {*Save Used Font*}
M.Font.Size:=Sys.FontCurrentSize;

DataSource:=FExpand(DataSource);        {*Source data path*}
If Not File_TestExist(DataSource) Then Exit;

FSplit(DataSource, FD,FN,FE);
M.DataSource:=FD;
M.DataEntry:=FN+FE;                     {*Source data file*}

If W.Destroyed Then Exit;               {*Window not defined or killed*}

Menu_Main:=TRUE;                        {*No error*}
End;

{ͻ
                          PROCEDURE Menu_ShowTitle                          
 ͹
  IN.....: M (TMainMenu) = Pointer to the MainMenu structure.               
  OUT....: /                                                                
  EXPLAIN: Display the menu window title.                                   
  SEEALSO: Menu_Main                                                        
 ͼ}

Procedure Menu_ShowTitle(Const M:TMainMenu);
Var FName,OneTitle:String;
    A,XPos:Integer;
Begin
If Not M.Visible Then Exit;             {*Unvisible menu*}

FName:=M.DataSource+M.DataEntry;        {*Datasource OK*}
If Not File_TestExist(FName) Then Exit;

Font_Set(M.Font.Name,M.Font.Size);      {*Set special font*}

Tool_Line(M.Wti.X1-1,M.Wti.Y2-6,M.Wti.X2-1,M.Wti.Y2-6,0,1); {*Display line at the menu bottom*}


XPos:=M.Wti.X1+5;
Mse_Hide;
For A:=1 to File_CountLines(FName) do   {*Affiche les titres de menus*}
   Begin
   OneTitle:=Str_Get(File_GetLine(FName,A),3,';');
   OneTitle:=Str_PurgeHotkey(OneTitle); {*Vire la Hotkey*}
   Display(XPos+4,M.Wti.Y1,M.Font.PenColor,OneTitle);
   XPos:=XPos+VESA_TextWidth(OneTitle)+LaF*3;
   End;

Mse_Show;
Font_Set(Sys.FontMain,Sys.FontMainSize);      {*Revient en fonte normale*}
End;

{ͻ
                       FUNCTION Menu_BuildCoordinates                       
 ͹
  IN.....: M (TPopupMenu) = Pointer to the PopupMenu structure.             
           DataFile (STRING) = Menu DataFile file (Entry point).            
           Width,Height (INTEGER) = Width and Height of the window.         
  OUT....: (BOOLEAN) = TRUE=Coordinates correctly defined.                  
  EXPLAIN: Calculate the needed size of the popup window.                   
 ͼ}

Function Menu_BuildCoordinates(Var M:TPopupMenu; DataFile:String; Var Width,Height:Integer):Boolean;

Var A,Qtt,Size:Integer;
    Sc3,Sc4,Sc5,Sc6:Integer;            {*Taille des colonnes 4 et 5*}
    St:String;

Begin
Menu_BuildCoordinates:=FALSE;
If Not File_TestExist(DataFile) Then
   Begin                                {*DataSource not found !*}
   Error(592); Exit;
   End;
                                        {*Hauteur de la fentre*}
Qtt:=File_CountLines(DataFile);
Height:=Qtt*M.LineHeight+3;

Sc3:=0; Sc4:=0; Sc5:=0; Sc6:=0;         {*Initialise les tailles de colonnes*}

For A:=1 to Qtt do                      {*Largeur de la fentre (Calcul)*}
   Begin
   St:=File_GetLine(DataFile,A);

   Sc3:=5+15;                           {*Espace obligatoire*}

   Size:=VESA_TextWidth(Str_Get(St,4,';'));
   If Size>Sc4 Then Sc4:=Size;


   Size:=VESA_TextWidth(Str_Get(St,5,';'));
   If Size>Sc5 Then Sc5:=Size;

   If Str_Get(St,6,';')<>'' Then Sc6:=13;{*Flche de SousMenu*}
   End;

If Sc4>0 Then Inc(Sc4,20);              {*Add marges des colonnes*}
If Sc5=0 Then Dec(Sc5,15);              {*Pas de CheckPoints*}

Width:=Sc3+Sc4+12+Sc5+Sc6;              {*Largeur de la fentre (Affectation)*}

Menu_BuildCoordinates:=TRUE;            {*Return Ok*}
End;

{ͻ
                          FUNCTION Menu_ShowPopup                           
 ͹
  IN.....: M (TMainMenu) = Pointer to the TPopupMenu structure.             
           W (TCoordinates) = Pointer to the parent window coordinates.     
           I (TCoordinates) = Pointer to the selection point coordinates.   
           X1,Y1 (INTEGER) = Popup menu initial coordinates.                
           DataFile (STRING) = Menu DataFile file (Entry point).            
  OUT....: (STRING) = Selected point number as string.                      
  EXPLAIN: Display and manage a Popup menu or a main submenu.               
  EXAMPLE: Menu_ShowPopup(M, M.Wpa, M.Box, X1-1,Y1-1,M.DataFile);           
  NB.....: This function musn't be called by user.                          
  SEEALSO: Menu_Popup, Menu_TestPopup                                       
 ͼ}

Function Menu_ShowPopup(Var M:TPopupMenu; W,I:TCoordinates; X1,Y1:Integer; DataFile:String):String;
Var WPop:TWindow;
    XOut:Boolean;
    Even,Res:Integer;
    LPop:TList;                         {*List structure*}
    Rspm:String;                        {*Rsultat de la slection des points prcdents*}
    Next_MenuFile:String;               {*Prochain fichier Menu*}
    NewWinParent:TCoordinates;          {*Nouvelle fentre parent*}
    Width,Height:Integer;               {*Taille de la fentre courante*}
    A:Integer;                          {*Parcourir la liste*}
    IdWin:Word;                         {*Id de la fentre*}
    FName,St:String;                    {*Fichier  utiliser + Temp String*}

    Pt:String[2];                       {*Point type*}

Begin
Menu_ShowPopup:='';                     {*De base...*}
FName:=M.DataSource+DataFile;
If Not File_TestExist(FName) Then
   Begin                                {*DataSource not found !*}
   Error(592); Exit;
   End;

If File_CountLines(FName)<=0 Then
   Begin                                {*DataSource file Empty !*}
   Error(593); Exit;
   End;

Font_Set(M.Font.Name,M.Font.Size);      {*Set special font*}

If Not Menu_BuildCoordinates(M,FName,Width,Height) Then Exit;

WPop.X1:=X1; WPop.Y1:=Y1;               {*Build coordinates*}
WPop.X2:=X1+Width; WPop.Y2:=Y1+Height;

List_Define(LPop,'1;2;3;4;5;6;7',';',0,0,WPop.X2-WPop.X1-2,WPop.Y2-WPop.Y1-2, 200,M.Font.BgColor,M.Font.BgColor,M.ListId);
If M.Image<>'' Then LPop.Bitmap:=M.Image;
LPop.Item_SizeY:=M.LineHeight;          {*Taille d'une ligne*}
List_Load(LPop,FName);
List_SetIdMore  (LPop,M.ListIdMore);
List_HideColumns(LPop,Yes);
List_HideColumn (LPop,3,No);
List_HideColumn (LPop,4,No);
List_HideColumn (LPop,5,No);
List_AdjustColumns(LPop);               {*Ajustement de la liste*}
List_HideColumn (LPop,5,Yes);
List_SetColumnAttr(LPop,3,17,Text_OnLeft);

For A:=1 to List_GetQttItems(LPop) do
   Begin
   If List_GetStringCell(LPop,A,2)='0' Then List_SetIdItem(LPop,A,$0001);
   If List_GetStringCell(LPop,A,1)='S' Then List_SetIdItem(LPop,A,$0003);
   If List_GetStringCell(LPop,A,1)='C' Then
      Begin                             {*Point Check*}
      If List_GetStringCell(LPop,A,3)='T' Then List_SetStringCell(LPop,A,3,'');
      List_HideColumn(LPop,3,No);
      End;
   If List_GetStringCell(LPop,A,1)='R' Then
      Begin                             {*Point radio*}
      If List_GetStringCell(LPop,A,3)='T' Then List_SetStringCell(LPop,A,3,'');
      List_HideColumn(LPop,3,No);
      End;
   If List_GetStringCell(LPop,A,5)<>'' Then
      Begin                             {*Hotkey defined*}
      List_HideColumn(LPop,5,No);
      End;
   If List_GetStringCell(LPop,A,6)<>'' Then
      Begin                             {*Add symbole SubMenu...*}
      List_SetStringCell(LPop,A,7,'');
      List_HideColumn(LPop,7,No);
      List_SetColumnAttr(LPop,7,13,Text_OnLeft);
      End;
   End;

If M.MenuMovable Then IdWin:=$5141 Else IdWin:=$1141;
Win_Init(WPop.X1,WPop.Y1,WPop.X2,WPop.Y2, IdWin,'',WPop);
Win_Sup(0,0,0,0,0,0,0,0,0,M.Font.BgColor,$0072,WPop);
Win_Draw(WPop);                         {*Affiche la Fentre*}

Inc(M.SubMenuCount);                    {*1 Sous-menu de plus*}

Win_Clip(Yes,WPop);
List_Show(LPop);
Win_Clip(No, WPop);
Repeat Until Not Mse_Clicked(1);        {*Relache bouton gauche souris*}
Repeat Until Not Mse_Clicked(3);        {*Relache bouton droit souris*}

XOut:=FALSE;
Repeat
If Win_Ready(WPop) Then                 {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Personnels*}
   If Kbd_GetKeyDown(VK_LEFT) Then            {*Flche Gauche*}
      Begin
      M.Action:=3;
      XOut:=TRUE;
      End;
   If Kbd_GetKeyDown(VK_RIGHT) Then            {*Flche Droite*}
      Begin
      M.Action:=4;
      XOut:=TRUE;
      End;

   Win_Clip(Yes,WPop);
   Res:=List_Test(LPop);                {*Test de la Liste*}
   Win_Clip(No, WPop);
   If Res>0 Then
      Begin
      Next_MenuFile:=List_GetStringCell(LPop,Res,6);
      Rspm:='';
      If Next_MenuFile<>'' Then         {*Il y a un Sous-Menu !*}
         Begin
         List_GetItemCoord(LPop,Res,I); {*Get coordinates of the Menu Point*}
         Inc(I.X1,T_Clip.X1); Inc(I.Y1,T_Clip.Y1);
         Inc(I.X2,T_Clip.X1); Inc(I.Y2,T_Clip.Y1);
         Coord_SetInStruct(WPop.X1,WPop.Y1,WPop.X2,WPop.Y2,NewWinParent);
         Rspm:=Menu_ShowPopup(M, NewWinParent,I, WPop.X2-3,WPop.Y1+I.Y1-3-T_Clip.Y1, Next_MenuFile);
         End
      Else
         Begin                          {*Point slectionn !*}
         Pt:=List_GetStringCell(LPop,Res,1);
         If (Pt='C') Or (Pt='R') Then   {*Check or Radio point*}
            Begin

            St:=File_GetLine(FName,Res);{*Tag/Untag Check or radio point*}
            If Str_Get(St,3,';')='T' Then St:=Str_Put(St,' ',3,';')
                                     Else St:=Str_Put(St,'T',3,';');
            File_ReplaceLine(FName,St,Res);
            End;

         M.Action:=5;
         End;
      Case M.Action of                  {*Teste le rsultat quand on sort*}
         0: Begin
{            Menu_ShowPopup:=Rspm;}
            If M.SubMenuCount=1 Then Menu_ShowPopup:=M.Result;
            XOut:=TRUE;                 {*Slectionn !*}
            End;
         1: Begin                       {*Escape pressed !*}
            List_TagItem(LPop,Res);
            M.Action:=0;
            End;
         2: Begin                       {*Pointer sur Window Parent*}
            M.Action:=0;
            End;
         3: Begin                       {*Flche Gauche*}
            If M.SubMenuCount=1 Then XOut:=TRUE;
            End;
         4: Begin                       {*Flche Droite*}
            If M.SubMenuCount=1 Then XOut:=TRUE;
            End;
         5: Begin                       {*Point slectionn !*}
            Menu_ShowPopup:=';'+Str_L2S(Res)+Rspm;
            XOut:=Yes;
            End;
         End;
      End;

   If Mse_TestBox(W.X1,W.Y1,W.X2,W.Y2, 10) Then {*Souris sur la fentre parent*}
      If Not Mse_TestBox(WPop.X1,WPop.Y1,WPop.X2,WPop.Y2, 10) Then {*Et pas sur la nouvelle fentre*}
         If Not Mse_TestBox(I.X1,I.Y1,I.X2,I.Y2, 10) Then {*Et pas sur le point parent*}
            Begin
            XOut:=TRUE;
            M.Action:=2;                {*On est pass sur la fentre mre => Ferme le menu actuel...*}
            End;
   End;

Even:=Win_Test(WPop);
If Even=CMClosed Then Begin M.Action:=1; XOut:=TRUE; End; {*Window Closed => Exit*}
If Even=CMInactivated Then XOut:=TRUE;              {*Window Inactivated => Exit*}
If Even=CMMoved Then Begin
   Win_Clip(Yes,WPop);
   List_Show(LPop);                     {*Window Moved => Display List*}
   Win_Clip(No, WPop);
   End;

Until XOut;                             {*Flag de Sortie*}

Win_Done(WPop);                         {*Close Window Popup*}
List_Done(LPop);                        {*Kill the List*}
Font_Set(Sys.FontMain,Sys.FontMainSize);{*Revient en fonte normale*}

Dec(M.SubMenuCount);                    {*1 Sous-menu de moins*}
End;

{ͻ
                          FUNCTION Menu_TestPopup                           
 ͹
  IN.....: M (TPopupMenu) = Pointer to the TPopupMenu structure.            
  OUT....: (STRING) = Selected point number as string else ''.              
  EXPLAIN: Display and manage a Popup menu or a main submenu.               
  SEEALSO: Menu_Popup                                                       
 ͼ}

Function Menu_TestPopup(Var M:TPopupMenu):String;
Var X1,Y1:Word;
    Ga,Mi,Dr:Boolean;
Begin
Menu_TestPopup:='';
If Not M.Enabled Then Exit;             {*Menu disabled*}

If Mse_TestBox(M.Mou.X1,M.Mou.Y1,M.Mou.X2,M.Mou.Y2,10) Then
   If (Mse_Clicked(3)) Or
      ((Kbd_GetKeyDown(VK_CONTROL)) And (Kbd_GetKeyDown(VK_LSHIFT))) Or
      ((Kbd_GetKeyDown(VK_CONTROL)) And (Kbd_GetKeyDown(VK_RSHIFT))) Then
//   If (Mse_Clicked(3)) Or (Kbd_TestSpecialKey($0005,B_AND)) Or (Kbd_TestSpecialKey($0006,B_AND)) Then
      Begin
      Mse_Get(X1,Y1,Ga,Mi,Dr);
      Menu_TestPopup := Copy(Menu_ShowPopup(M, M.Wpa, M.Box, X1-1,Y1-1,M.DataFile),2,255);
      End;
End;

{ͻ
                     FUNCTION Menu_GetTitleCoordinates                      
 ͹
  IN.....: M (TMainMenu) = Pointer to the TMainMenu structure.              
           NumC (BYTE) = Title number.                                      
           C (TCoordinates) = Pointer to a coordinates structure.           
  OUT....: (BOOLEAN) = TRUE:Coordinates found.                              
  EXPLAIN: Get the coordinates from a main menu.                            
  SEEALSO: Menu_ShowTitle                                                   
 ͼ}

Function Menu_GetTitleCoordinates(Const M:TMainMenu; Num:Byte; Var C:TCoordinates):Boolean;
Var FName,OneTitle:String;
    XPos,XBase,A:Integer;

Begin
Menu_GetTitleCoordinates:=FALSE;        {*De base*}

FName:=M.DataSource+M.DataEntry;        {*Build datasource Path+Filename*}
If (Num<=0) Or (Num>File_CountLines(FName)) Then Exit;

XPos:=M.Wti.X1+1; XBase:=XPos;
For A:=1 to Num do                      {*Affiche les titres de menus*}
   Begin
   OneTitle:=Str_Get(File_GetLine(FName,A),3,';');
   OneTitle:=Str_PurgeHotkey(OneTitle); {*Vire la Hotkey*}
   XPos:=XPos+VESA_TextWidth(OneTitle)+LaF*3;
   If A=Num-1 Then XBase:=XPos;         {*Bord gauche de la boite*}
   End;
C.X1:=XBase;                            {*Store coordinates*}
C.Y1:=M.Wti.Y1+1;
C.X2:=XPos;
C.Y2:=M.Wti.Y2-6;
Menu_GetTitleCoordinates:=TRUE;         {*It's Ok !*}
End;

{ͻ
                         PROCEDURE Menu_ToggleTitle                         
 ͹
  IN.....: M (TMainMenu) = Pointer to the TMainMenu structure.              
           Num (BYTE) = Title number to toggle.                             
  OUT....: /                                                                
  EXPLAIN: Toggle the selected menu title.                                  
 ͼ}

Procedure Menu_ToggleTitle(Var M:TMainMenu; Num:Byte);
Var C:TCoordinates;
Begin
If Menu_GetTitleCoordinates(M,Num,C) Then
   Begin
   VESA_SetWriteMode(XORPut);
   Bevel(C.X1-1,C.Y1-1,C.X2-1,C.Y2-1,CLWhite);
   VESA_SetWriteMode(NormalPut);
   End;
End;

{ͻ
                           FUNCTION Menu_TestMain                           
 ͹
  IN.....: M (TMainMenu) = Pointer to the TMainMenu structure.              
  OUT....: (STRING) = Selected point number as string.                      
  EXPLAIN: Manage and get messages from a main menu.                        
  SEEALSO: Menu_Main                                                        
 ͼ}

Function Menu_TestMain(Var M:TMainMenu):String;
Var FName:String;                       {*Nom du fichier menu principal*}
    QttTitles:Byte;                     {*Nombre de titres de menus*}
    Num:Integer;
    C:TCoordinates;                     {*Coordonnes temporaires*}
    Rspm:String;                        {*Rsultat de la slection des points prcdents*}
    VP:TViewPortType;

Begin
Menu_TestMain:='';                      {*De base...*}

If Not M.Enabled Then Exit;             {*Menu disabled*}

FName:=M.DataSource+M.DataEntry;        {*Datasource OK*}
If Not File_TestExist(FName) Then Exit;

QttTitles:=File_CountLines(FName);      {*Nombre de titres de menus*}
M.MouseOnTitle:=No;

For Num:=1 to QttTitles do              {*Parcours les titres de menu*}
   Begin
   If Menu_GetTitleCoordinates(M,Num,C) Then
      Begin
      If Mse_TestBox(T_Clip.X1+C.X1, T_Clip.Y1+C.Y1, T_Clip.X1+C.X2, T_Clip.Y1+C.Y2,10) Then
         Begin                          {*La souris est sur un titre de menu*}
         M.MouseOnTitle:=Yes;

         If Num<>M.TitleMouseOver Then
            Begin                       {*On passe dessus...*}
            If M.TitleMouseOver>0 Then Menu_ToggleTitle(M,M.TitleMouseOver);
            Menu_ToggleTitle(M,Num);
            M.TitleMouseOver:=Num;
            End;

         If (Mse_Clicked(1)) Or (M.TitleBarClicked) Then
            Begin                       {*On clique le titre...*}
            VESA_GetViewSettings(VP);

            M.TitleBarClicked:=Yes;
            M.DataFile:=Str_Get(File_GetLine(FName,Num),1,';');
            M.Wpa:=M.Wti; M.Box:=C; M.Mou:=C;
            Inc(M.Wpa.X1,T_Clip.X1); Inc(M.Wpa.Y1,T_Clip.Y1); {*Clipper  la base*}
            Inc(M.Wpa.X2,T_Clip.X1); Inc(M.Wpa.Y2,T_Clip.Y1);
            Inc(M.Box.X1,T_Clip.X1); Inc(M.Box.Y1,T_Clip.Y1-2);
            Inc(M.Box.X2,T_Clip.X1); Inc(M.Box.Y2,T_Clip.Y1);
            Rspm:=Menu_ShowPopup(M, M.Wpa, M.Box, T_Clip.X1+C.X1,T_Clip.Y1+C.Y2, M.DataFile);

            If M.Action=5 Then          {*Point slectionn*}
               Begin
{               VESA_SetViewPort(VP.X1,VP.y1,VP.x2,VP.y2,ClipOn);
               Menu_ToggleTitle(M,M.TitleMouseOver);}
               M.TitleBarClicked:=No;
               Menu_TestMain:=Str_L2S(Num)+Rspm;
               End;
            End;
         End
      End;
   End;

If Mse_Clicked(1) Then M.TitleBarClicked:=No; {*On clique ailleurs*}

If (Not M.MouseOnTitle) And (M.TitleMouseOver>0) Then
   Begin                                {*On n'est plus sur la barre du menu*}
   Menu_ToggleTitle(M,M.TitleMouseOver);
   M.TitleMouseOver:=0;

   End;
End;

{ͻ
                        FUNCTION Menu_TestCheckPoint                        
 ͹
  IN.....: MFile (STRING) = Path and filename of the submenu to test.       
           PPoint (BYTE) = Index of the check menu point to test.           
  OUT....: (BOOLEAN) = TRUE if check menu point is tagged.                  
  EXPLAIN: Test if a check menu point is tagged.                            
  SEEALSO: Menu_SetCheckPoint, Menu_GetRadioPoint                           
 ͼ}

Function Menu_TestCheckPoint(Const MFile:String; PPoint:Byte):Boolean;
Var St:String;
Begin
Menu_TestCheckPoint:=No;
If Not File_TestExist(MFile) Then Exit; {*File not found*}
St:=File_GetLine(MFile,PPoint);
If Upper(Str_Get(St,3,';'))='T' Then Menu_TestCheckPoint:=Yes; {*Tagged*}
End;

{ͻ
                        FUNCTION Menu_SetCheckPoint                         
 ͹
  IN.....: MFile (STRING) = Path and filename of the submenu.               
           PPoint (BYTE) = Index of the check point to modify.              
           Value (BOOLEAN) = TRUE: Tag check point, FALSE: Untag check point
  OUT....: (BOOLEAN) = TRUE if check menu point has been correctly modified 
  EXPLAIN: Tag or untag a check point from a menu.                          
  SEEALSO: Menu_TestCheckPoint                                              
 ͼ}

Function Menu_SetCheckPoint(Const MFile:String; PPoint:Byte; Value:Boolean):Boolean;
Var St:String;
Begin
Menu_SetCheckPoint:=No;
If Not File_TestExist(MFile) Then Exit; {*File not found*}

St:=File_GetLine(MFile,PPoint);
If Value Then St:=Str_Put(St,'T',3,';')
         Else St:=Str_Put(St,' ',3,';');
File_ReplaceLine(MFile,St,PPoint);      {*Replace line in a menu file*}
Menu_SetCheckPoint:=Yes;
End;

{ͻ
                        FUNCTION Menu_GetRadioPoint                         
 ͹
  IN.....: MFile (STRING) = Path and filename of the submenu to test.       
  OUT....: (BYTE) = Index of the radio point tagged.                        
  EXPLAIN: Get index of the tagged radio menu point in a submenu.           
  NB.....: This function could be optimised.                                
  SEEALSO: Menu_TestCheckPoint                                              
 ͼ}

Function Menu_GetRadioPoint(Const MFile:String):Byte;
Var St:String;
    A:Integer;
Begin
Menu_GetRadioPoint:=0;

If Not File_TestExist(MFile) Then Exit; {*File not found*}
For A:=1 to File_CountLines(MFile) do
   Begin
   St:=File_GetLine(MFile,A);
   If (Upper(Str_Get(St,1,';'))='R') And (Upper(Str_Get(St,3,';'))='T') Then
      Begin
      Menu_GetRadioPoint:=A;            {*Radio Point Tagged*}
      Exit;
      End;
   End;
End;

{ͻ
                         FUNCTION Menu_EnablePoint                          
 ͹
  IN.....: MFile (STRING) = Path and filename of the submenu.               
           PPoint (BYTE) = Index of the menu point to modify.               
           Status (BOOLEAN) = TRUE: Enable, FALSE: Disable menu point.      
  OUT....: (BOOLEAN) = TRUE if menu point has been correctly modified.      
  EXPLAIN: Enable or disable a menu point.                                  
 ͼ}

Function Menu_EnablePoint(Const MFile:String; PPoint:Byte; Status:Boolean):Boolean;
Var St:String;
Begin
Menu_EnablePoint:=No;
If Not File_TestExist(MFile) Then Exit; {*File not found*}
St:=File_GetLine(MFile,PPoint);
If Status Then St:=Str_Put(St,'1',2,';')
          Else St:=Str_Put(St,'0',2,';');
File_ReplaceLine(MFile,St,PPoint);      {*Replace line in a menu file*}
Menu_EnablePoint:=Yes;
End;

{*-------------------------- PROGRAMME PRINCIPAL ---------------------------*}

Begin
End.
