{ͻ
                              UNIT MosProtect                               
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 21.02.1998                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: MOS Protection. Anti-dbuging.                               
  AUTONOMOUS.: Pro                                                          
  UNIT SIZE..: 132 Lines and (3.216 Bytes compiled)                         
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosProtect;

{$Mode Objfpc}

INTERFACE

{Procedure ALLOC_ALL_MEMORY;}
{Procedure HOOK_DEBUGER_INTERRUPT;}
{Procedure TESTE_NONMODIF_DU NOM DU REGISTERED USER;}
{Procedure PASSER EN MODE PROTEGER....}

Function  Protect_Software(Days:Integer):Boolean; {*Protge ".EXE" pour "Days" Jours*}

{*----------------------------- Dbut Library ------------------------------*}

IMPLEMENTATION

Uses
      Dos,
      MosConfig,
      MosFiles,
      MosTime;

{ͻ
                         FUNCTION Protect_Software                          
 ͹
  IN.....: Days (INTEGER) = Number of days before to lock software.         
  OUT....: (BOOLEAN) = TRUE=Software must be locked.                        
  EXPLAIN: Test if a software must be locked if the days delay is out.      
 ͼ}

Function Protect_Software(Days:Integer):Boolean;
Var F             :File;
    Name,FName    :String;
    IDate,PDate,TDate:Longint;
    DN            :DirStr;
    FN            :NameStr;
    FE            :ExtStr;
    Size,ChkSum   :Longint;
    SL            :Integer;             {*Size of Longint*}
    CY,CM,CD,CDow :Word;                {*Date D'aujourd'hui*}

{**************************** WRITE Protect_Software FILE  ***************************}

Function WRITE_PROT:Boolean;
Begin
Assign(F,FName);
{$I-}
Rewrite(F,1);                           {*ReBuild File...*}
{$I+}
If IOResult=0 Then Begin                {*No Errors ? => Ok !*}
   PDate:=TDate;
   ChkSum:=IDate+PDate;
   BlockWrite(F,IDate,SL);
   BlockWrite(F,PDate,SL);
   BlockWrite(F,ChkSum,SL);
   Close(F);
   Write_Prot:=Yes;                     {*OK !*}
   End
   Else Write_Prot:=No;                 {*Cannot Create File !*}
End;

{******************************** MAIN CODE *********************************}

Begin
Name:=FExpand(FSearch(ParamStr(0),GetEnv('PATH')));
FSplit(Name,DN,FN,FE);                  {*Search Name Prog Apellant...*}
FName:=DN+FN+'.PRO';

If Not File_TestExist(FName) Then      {*Fichier "Protect_Software" Introuvable !*}
   Begin
   Protect_Software:=No; Exit;
   End;

GetDate(CY,CM,CD,CDow);                 {*Date D'aujourd'hui*}
TDate:=Time_PackDate(CD,CM,CY);             {*Packe la Date*}
SL:=Sizeof(Longint);                    {*Calcule Longint Size*}

Size:=File_GetSize(FName);             {*Si Taille = 0 => INIT*}
If Size=0 Then Begin
   IDate:=TDate; PDate:=TDate;
   Protect_Software:=WRITE_PROT;                 {*Quit With WRITE_PROT Result !*}
   Exit;
   End;

Assign(F,FName);
{$I-}
Reset(F,1);                             {*Open File...*}
{$I+}
If IOResult=0 Then Begin                {*No Errors ? => Ok !*}
   BlockRead(F,IDate,SL);
   BlockRead(F,PDate,SL);
   BlockRead(F,ChkSum,SL);
{gotoxy(1,5); writeln(TDate-IDate);}
   If ChkSum<>IDate+PDate Then          {*Checksum Eronne...*}
      Begin Protect_Software:=No; Close(F);
{gotoxy(1,1); writeln('Checksum Eronne...');}
      Exit;
      End;
   If TDate-IDate>Days Then             {*Priode Ecoule...*}
      Begin Protect_Software:=No; Close(F);
{gotoxy(1,1); writeln('Priode coule...');}
      Exit;
      End;
   If TDate<PDate Then                  {*Date Trafique...*}
      Begin Protect_Software:=No; Close(F);
{gotoxy(1,1); writeln('Date trafique...');}
      Exit;
      End;
   Close(F);
   End
   Else Begin Protect_Software:=No; Exit; End;   {*Cannot Open File !*}

If Not WRITE_PROT Then Begin Protect_Software:=No; Exit; End;{*Error Writing File...*}

Protect_Software:=Yes;                           {*Ok : No Errors !*}
End;

{*-------------------------- PROGRAMME PRINCIPAL ---------------------------*}

Begin
End.
