{ͻ
                              UNIT MosRequests                              
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 15.12.1993                                                   
  COUNTRY....: Montpellier - IUT (FRANCE)                                   
  DESCRIPTION: Mathematics Functions Management.                            
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 1.974 Lines and (72.208 Bytes compiled)                      
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosRequests;

{$Mode Objfpc}

INTERFACE

Uses
     MosGadgets,
     MosTime,
     MosWindows;

Type TProgress=Record                   {*Structure Progression Bar*}
     W    :TWindow;                     {*Pointer to Window structure*}
     B    :TButton;                     {*Pointer to Button "Abort" structure*}
     Abort:Boolean;                     {*Abort Operation*}
     Init :Byte;                        {*Initialise le Requester*}
     End;

{|Miscellaneous requesters|}
Function  Req_Calculator(X1,Y1:Integer; Title:String):String; {*Calculator requester*}
Procedure Req_Font(Px,Py:Integer; Title:String; Var FntType:String; Var FntSize:Integer); {*Font viewer requester*}
Procedure Req_Pattern(X1,Y1:Integer; Name:String; Var NUM:Integer); {*Patten management*}
Procedure Req_Progress(Name,Explain:String; Px,Py,Val:Integer; CoB:Longint; Var P:TProgress); {*Percentage progression*}
Procedure Req_ProgressInit(Var P:TProgress);
Procedure Req_DisplayWinBMP(Px,Py:Integer; FName:String); {*Display a BMP in a window*}
Procedure Req_Register;                  {*Display The Register MOS Requester*}
Procedure Req_DefineAudioCD(Px,Py:Integer; Title,FName:String);{*Display an Audio CD manager*}

Procedure Req_DisplayClock(X1,Y1,X2,Y2:Integer; Co:Longint; State:Byte; Var T:TClock; W:TWindow); {*Display a clock*}

{*----------------------------- Debut Library ------------------------------*}

IMPLEMENTATION

Uses
     Dos,
     SysUtils,
     Windows,
     MosBase,
     MosCPUInstructions,
     MosColors,
     MosConfig,
     MosDirectory,
     MosDisks,
     MosErrors,
     MosFiles,
     MosGraph,
     MosImages,
     MosKeyboard,
     MosList,
     MosMath,
     MosMouse,
     MosStrings,
     MosText,
     MosTools;

{ͻ
                        PROCEDURE Req_DisplayWinBMP                         
 ͹
  IN.....: X1,Y1 (INTEGER) = Image position on screen.                      
         : FName (STRING) = BMP filename to display.                        
  OUT....: /                                                                
  EXPLAIN: Display a BMP in a child window.                                 
  SEEALSO: BMP_Show, BMP_TestFile                                           
 ͼ}

Procedure Req_DisplayWinBMP(Px,Py:Integer; FName:String);
Const Step=7;                           {*Pixels steps to move by Keyboard*}

Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    Exit_Flg      :Boolean;             {*Exit Flag*}
    Sx,Sy         :Word;                {*Infos Image...*}
    Dx,Dy         :Integer;             {*Delta X,Y pour Offset*}
    SWx,SWy       :Word;                {*Size Window...*}
    Co            :Longint;
    FD            :DirStr;              {*FSplit*}
    FN            :NameStr;
    FE            :ExtStr;
    Ox,Oy         :Integer;             {*Offsets X & Y*}
    X1,Y1,X2,Y2   :Integer;             {*Coordonnes du Cadre...*}
    Click         :Boolean;             {*LMB Cliqu*}
    Mix,Miy       :Word;                {*Initial Mouse X,Y*}
    Mx,My         :Word;                {*Actual Mouse X,Y*}
    OMx,OMy       :Word;                {*Old Coordinates for Mouse X,Y*}
    Ga,Mi,Dr      :Boolean;             {*Mouse Button - Useless*}
    SyOf          :Integer;
    Pointer       :TMouseZone;          {*Mouse pointer management*}
    Kbd           :Boolean;             {*Use Keyboard*}

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Var C:TCoordinates;
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}

BMP_GetInfo(FName,Sx,Sy,Co);
X1:=LaF*2+1;                            {*Calcule Coordonnes*}
Y1:=HaF+1;
X2:=W1.X2-W1.X1-LaF*2-1;
Y2:=W1.Y2-W1.Y1-SyOf;
Dx:=Sx-(X2-X1)-1;                       {*Calcule Delta Offset*}
Dy:=Sy-(Y2-Y1)-1;
If Dx<0 Then Dx:=0;
If Dy<0 Then Dy:=0;

{Gotoxy(1,1); Writeln('X1=',X1,' Y1=',Y1,'     ');
Gotoxy(1,2); Writeln('X2=',X2,' Y2=',Y2,'     ');
Gotoxy(1,3); Writeln('Ox=',Ox,' Oy=',Oy,'     ');
Gotoxy(1,4); Writeln('Sx=',Sx,' Sy=',Sy,'     ');
Gotoxy(1,5); Writeln('Dx=',Dx,' Dy=',Dy,'     ');}

C.X1:=X1-1; C.Y1:=Y1-6; C.X2:=X2-1; C.Y2:=Y2-6;
MseZone(Pointer,C,10,MPHand,'');       {*Define mouse pointer*}

BMP_Show(X1-1,Y1-6,X2-1,Y2-6,Ox,Oy,FName,$A0);
Win_Clip(No,W1);                       {*Restore Normal Clipping*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
Log.Add('Call DisplayWinBMP request',1);
If Not File_TestExist(FName) Then Exit; {*No file present!*}

BMP_GetInfo(FName,Sx,Sy,Co);
SyOf:=1+HaF1+HaF*2+HaF Div 2;
SWx:=Sx+LaF*4+1;
SWy:=Sy+HaF+SyOf;                       {*Taille Y du Pro-look*}
If SWx>VESA_GetMaxX Then SWx:=VESA_GetMaxX; {*Si Image Trop grande => Tronque !*}
If SWy>VESA_GetMaxY Then SWy:=VESA_GetMaxY;
Ox:=0; Oy:=0;                           {*De Base, pas d'Offsets*}

FSplit(FName,FD,FN,FE);

If Not Win_Init(Px,Py,Px+SWx,Py+SWy,$51FD,FN+FE,W1) Then Exit;
Win_Sup(070,030,300,055,110,120,VESA_GetMaxX,VESA_GetMaxY,0,CLWinBorder,$0A90,W1);
Win_Draw(W1);                           {*Display Window*}

REDRAW_FRAME;                           {*Display Window Content*}
Exit_Flg:=No;                           {*Init Exit Flag*}
Click:=No;                              {*On ne Clique pas au Dbut*}
Ox:=0; Oy:=0;
Mx:=0; My:=0;                           {*Hint FPC*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   Kbd:=No;
   If Kbd_GetKeyDown(VK_DOWN ) Then Begin Inc(Oy,Step); Kbd:=Yes; End; {*Flche Bas*}
   If Kbd_GetKeyDown(VK_UP   ) Then Begin Dec(Oy,Step); Kbd:=Yes; End; {*Flche Haut*}
   If Kbd_GetKeyDown(VK_LEFT ) Then Begin Dec(Ox,Step); Kbd:=Yes; End; {*Flche Gauche*}
   If Kbd_GetKeyDown(VK_RIGHT) Then Begin Inc(Ox,Step); Kbd:=Yes; End; {*Flche Droite*}
   If Kbd Then                          {*Move image using Keyboard*}
      Begin
      If Ox<0 Then Ox:=0;               {*Max & Min...*}
      If Oy<0 Then Oy:=0;
      If Ox>Dx Then Ox:=Dx;
      If Oy>Dy Then Oy:=Dy;
      REDRAW_FRAME;                     {*Raffiche l'Image...*}
      OMx:=Mx; OMy:=My;
      End;

   If ((Mse_TestBox(W1.X1+X1, W1.Y1+HaF1+Y1, W1.X1+X2, W1.Y1+HaF1+Y2,10)) And ((Dx>0) Or (Dy>0)))
      Or (Click) Then                   {*On  dja Cliqu Dedans...*}
      Begin
      MseZone_GetMsg(Pointer);          {*Mouse pointer management*}

      Mse_Get(Mx,My,Ga,Mi,Dr);          {*Get Mouse Coords...*}
      If (Mse_Clicked(1)) And (Not Click) Then Begin
         Click:=Yes;
         Mix:=Mx+Ox; Miy:=My+Oy;        {*Previous Position*}
         End;
      If (Mse_Clicked(1)) And (Click) Then {*Move Image*}
         Begin
         Ox:=Mix-Mx; Oy:=Miy-My;        {*Delta de Dplacement de l'Image*}
         If Ox<0 Then Ox:=0;            {*Max & Min...*}
         If Oy<0 Then Oy:=0;
         If Ox>Dx Then Ox:=Dx;
         If Oy>Dy Then Oy:=Dy;
         If (OMx<>Mx) Or (OMy<>My) Then REDRAW_FRAME;{*Raffiche l'Image...*}
         OMx:=Mx; OMy:=My;
         End;
      If Not Mse_Clicked(1) Then Click:=No;
      End;

   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

If Not Click Then Even:=Win_Test(W1);   {*Get Windows Evens*}
If Even=CMClosed  Then Exit_Flg:=Yes;   {*Window Closed   => Exit*}
If Even=CMResized Then REDRAW_FRAME;    {*Window Resized  => Display Content*}
If Even=CMMoved   Then REDRAW_FRAME;    {*Window Moved    => Display Content*}

except
  on e:Exception do HandleException(e);
end;
Until Exit_Flg=Yes;                     {*Exit Flag*}

Win_Done(W1);                           {*Close Window if Needs*}
End;

{ͻ
                           PROCEDURE Req_Register                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Display the MOS Register request (Must be in 256 color mode).    
 ͼ}

Procedure Req_Register;
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1,But2     :TButton;             {*Structure Boutons*}
    FName         :String;              {*Nom du Ficher Image*}
    Sx,Sy         :Word;
    Colors        :Longint;             {*Position et Taille de la Fentre*}
    Px1,Py1,Px2,Py2:Integer;
    Text1         :TText;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);                       {*Clipping de la Fentre*}

Bevel   (005,005,W1.X2-T_Clip.X1-6, W1.Y2-T_Clip.Y1-6, CLLightGrey,BLLoweredLine,BLRaisedLine,Yes);
BMP_Show(006,006,640,480, 0,1,FName,$0080);
Display_Define(Text1,290,078,-1,CLWhite,'MODN.CHR',4,TJOnLeft,$0024, Application.TypeCaption + ' (' + User.Name + ')');
Display_Draw  (Text1);

Button (272,154,100,-1, CLTextButton,CLBgButton,$0002,But2,Language.Loc(270));
Font_Set('MODN.CHR',4);
Button (272,174,100,-1, CLTextButton,CLBgButton,$0110,But1,'_Ok');

Win_Clip(No,W1);                       {*Clipping de la Fentre*}
End;

{************************** PROCEDURE PRINCIPALE ****************************}

Begin
Log.Add('Call Register request',1);
Sys.DisplayRegister := RRDisplaying;                 {*Register Requester currently displaying*}

If Language.Code = LFFrancais Then FName := Sys.GetPath(SP_IMAGES)+'LOG_FRA.BMP';
If Language.Code = LFEnglish  Then FName := Sys.GetPath(SP_IMAGES)+'LOG_ENG.BMP';
If Language.Code = LFEspanol  Then FName := Sys.GetPath(SP_IMAGES)+'LOG_ESP.BMP';

BMP_GetInfo(FName,Sx,Sy,Colors);
Sx:=Sx+14; Sy:=Sy+12;
Px1:=(VESA_GetMaxX Div 2)-(Sx Div 2); Py1:=(VESA_GetMaxY Div 2)-(Sy Div 2);
Px2:=(VESA_GetMaxX Div 2)+(Sx Div 2); Py2:=(VESA_GetMaxY Div 2)+(Sy Div 2);

If Not Win_Init(Px1, Py1, Px2, Py2, $5541, Language.Loc(63),W1) Then Exit;
Win_Sup(100,050,249,200,059,050,639,479,000,CLWinBorder,$0872,W1); {*Supplment*}
Win_Draw(W1);                           {*Affiche la Fentre*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False;                        {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Teste si Fentre Prte*}
   Begin
   Win_Clip(Yes,W1);                    {*Clipping de la Fentre*}
   Button_GetMsg(But2,1);
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True;
   Win_Clip(No,W1);                     {*Clipping de la Fentre*}
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Exit_Flg:=True;   {*Fentre Ferme => Exit*}
If Even=CMMoved  Then REDRAW_FRAME;     {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until Exit_Flg=True;                    {*Flag de Sortie*}

Win_Done(W1);                           {*Supprime Fentre*}
Sys.DisplayRegister := RRNoDisplay;     {*Register Requester not displayed now*}
End;

{ͻ
                             PROCEDURE Req_Font                             
 ͹
  IN.....: Px,Py (INTEGER) = Requester position.                            
           Title (STRING) = The window title.                               
           FntType (STRING) = Set Font filename.                            
           FntSize (INTEGER) = Set Font filesize.                           
  OUT....: FntType (STRING) = Get Font filename.                            
           FntSize (INTEGER) = Get Font filesize.                           
  NB.....: If no font selected then FntType='' and FntSize=0.               
  EXPLAIN: Display a Font requester. Allow you to select a font from the    
           Font directory.                                                  
  EXAMPLE: Req_Font(200,100,'CHOOSE YOUR FONT',FType,FSize);                
 ͼ}

Procedure Req_Font(Px,Py:Integer; Title:String; Var FntType:String; Var FntSize:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flags*}
    But1,But2,But3:TButton;             {*Buttons Structure*}
    Com1          :TInputText;          {*Commands Structure*}
    Cin1          :String;              {*Strings for Commands*}
    DirSel,FilSel :String;
    FSize         :Longint;
    L             :TList;               {*Gestion de la liste*}
    Res           :Word;                {*Rsultat de la Slection de la Liste*}
    Num_Font      :Integer;             {*Numro de la Fonte Slectionne*}
    Code          :Word;                {*Pour Erreur Transformation "Val"*}
    OldFont       :String;              {*Initial font type and size*}
    OldSize       :Integer;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure DISPLAY_FONT_EXEMPLE;
Var St:String;
    VSize,Code:Word;
    Tx:TCoordinates;

Begin
If Res>0 Then Num_Font:=Res;            {*Numro de la Fonte Slectionne*}

Tx.X1:=W1.X1+LaF*4+1; Tx.Y1:=W1.Y2-HaF*9+5;
Tx.X2:=W1.X1+LaF*69+3;Tx.Y2:=W1.Y2-HaF*4-2;
St:=List_GetStringCell(L,Num_Font,List_GetColumnNum(L,2));
Val(St,VSize,Code);

VESA_SetViewPort(Tx.X1, Tx.Y1, Tx.X2, Tx.Y2, ClipOn);
Bevel(002,000,Tx.X2,Tx.Y2,CLWinBg);
Font_Set(List_GetStringCell(L,Num_Font,List_GetColumnNum(L,1)),VSize);{*Change de Fonte*}
Display(004,001,CLText,'ABCDE abcdefgh 01234');
Font_Set(Sys.FontMain,Sys.FontMainSize);
VESA_SetViewPort(0,0,VESA_GetMaxX,VESA_GetMaxY,ClipOff);{*Restore Normal ViewPort*}
End;

Procedure REDRAW_COMMAND;               {*Define Commands*}
Begin
Win_Clip(Yes,W1);                        {*Clipping Window*}
InputText (139,021,200,255, CLSky,CLLIghtBlue,0,$0020,Com1,Cin1);
Win_Clip(No,W1);                       {*Restore Normal Clipping*}
End;

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                        {*Clipping Window*}
Bevel    (019,011,349,046, CLLightGrey,BLLoweredLine,BLNoLine,Yes);
Bevel_Mos(019,238,349,290, CLLightGrey,CLWhite,BLLoweredLine,BLRaisedLine,Yes,Language.Loc(58));
List_Show(L);

Button (029,021,100,-1, CLTextButton,CLBgButton, $0000,But1,Language.Loc(52));
Button (069,310,100,-1, CLTextButton,CLBgButton, $0110,But2,'_OK');
Button (204,310,090,-1, CLTextButton,CLBgButton, $0000,But3,Language.Loc(13));
DISPLAY_FONT_EXEMPLE;                   {*Display Font Exemple*}
REDRAW_COMMAND;
Win_Clip(No,W1);                       {*Restore Normal Clipping*}
End;

{************************* CONSTRUCTION DE LA LISTE *************************}

Procedure BUILD_LIST;
Var DI            :SearchRec;
    FSizeL,Qtt,A  :Longint;
    St,Si,FT      :String;
    NoFont        :Boolean;
    FontRequested :String;

Begin
Mse_SetPointer(MPBusy);
List_Define(L,Language.Loc(59),';',019,056,349,221, 1000, CLDataZone,CLDataZone,$1B8D);
List_SetIdMore(L,$000A);
List_SetColumnAttr(L,3,-1,Text_OnRight);
List_SetColumnAttr(L,2,-1,Text_OnRight);
List_SetColumnId(L,2,$0001);

Qtt:=0;                                 {*Quantit de Fichiers Trouvs*}
FontRequested:='';
dos.FindFirst(Cin1+'*.*', Archive, DI);
While DosError=0 do
   Begin
   Inc(Qtt);
   FSizeL:=File_GetSize(Cin1+DI.Name); Str(FSizeL,St);
   FT:=Get_FileDescription(DI.Name,M_Extention);
   If Pos('BGI',FT)=0 Then NoFont:=TRUE Else NoFont:=FALSE;
   Font_Set(DI.Name,4);                 {*Calcule Taille Approximative...*}
   If VESA_TextHeight>40 Then Si:='2' Else Si:='4';
   If NoFont Then Si:='';
   St:=DI.Name+';'+Si+';'+Str_Format(St,' ',3)+';'+FT;

   List_AddItem(L, St, Insert_Append);
   If FntType=DI.Name Then FontRequested:=DI.Name;
   If NoFont Then List_SetColorItem(L,Qtt,8);
   dos.FindNext(DI);
   End;

List_Sort(L,1,Sort_AZ,0);               {*Trie la Liste...*}
A:=0;
If FontRequested<>'' Then Begin         {*Get Indice of Font Found...*}
   A:=List_GetItemIndice(L,FontRequested,1);
   List_TagItem(L,A);                   {*Taggue la Fonte Trouve*}
   List_SetPosition(L,A-1);
   End;
Font_Set(Sys.FontMain,Sys.FontMainSize);
Num_Font:=A;                            {*Numro de la Fonte Slectionne*}
Mse_SetPointer(P_Current);
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
Log.Add('Call Font request',1);
If Not Win_Init(Px,Py,Px+370,Py+HaF1+336,$51D9,Title,W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

OldFont:=FntType;
OldSize:=FntSize;
Cin1:=Sys.GetPath(SP_FONTS);         {*Chemin de Base = FONTS*}
DirSel:=Cin1; FilSel:='';

BUILD_LIST;                             {*Construit la Liste*}
REDRAW_FRAME;                           {*Display Window Content*}
XOk:=No; XCancel:=No;                   {*Init Exit Flags*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then
      Begin
      DirSel:=Cin1;
      Req_FileManager(W1.X1+20,W1.Y1+30,300,Language.Loc(60),'_OK','*.*',1,DirSel,FilSel,FSize);
      If DirSel<>'' Then Begin
         Cin1:=DirSel;
         List_Done(L);                  {*Dtruit la liste Existante*}
         BUILD_LIST;                    {*Construit la Liste*}
         REDRAW_FRAME;                  {*Display Window Content*}
         End;
      End;
   If Button_GetMsg(But2,1)=CMSelected Then XOk:=Yes;
   If Button_GetMsg(But3,1)=CMSelected Then XCancel:=Yes;
   If InputText_GetMsg(Com1,Cin1)=CMModified Then
      Begin
      Cin1:=Dsk_ValideDirectory(Cin1);
      List_Done(L);                     {*Dtruit la liste Existante*}
      BUILD_LIST;                       {*Construit la Liste*}
      REDRAW_FRAME;                     {*Display Window Content*}
      End;
   Res:=List_Test(L);                   {*Teste la Liste*}
   If Res>0 Then DISPLAY_FONT_EXEMPLE;  {*Display Font Exemple*}
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;     {*Window Closed   => Exit*}
If Even=CMMoved  Then REDRAW_FRAME;     {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flags*}

If XOk Then Begin                       {*Renvois la Fonte et sa Taille*}
   FntType:=List_GetStringCell(L,Num_Font,1);
   Cin1:=List_GetStringCell(L,Num_Font,2);
   Val(Cin1,FntSize,Code);
   End
   Else Begin
   FntType:=OldFont; FntSize:=OldSize;  {*De base si "Cancel"...*}
   End;

Win_Done(W1);                           {*Close Window if Needs*}
List_Done(L);                           {*Dtruit la liste Existante*}
End;

{ͻ
                         PROCEDURE Req_ProgressInit                         
 ͹
  IN.....: P (TPROGRESS) = Pointer to the TProgress structure.              
  OUT....: /                                                                
  EXPLAIN: Initialise a Progress requester.                                 
 ͼ}

Procedure Req_ProgressInit(Var P:TProgress);
Begin
Log.Add('Call Progress request (Initialisation)',1);
P.Init:=1;
End;

{ͻ
                           PROCEDURE Req_Progress                           
 ͹
  IN.....: Name (STRING) = The window title.                                
           Explain (STRING) = An explanation phrase to describe the process.
           Px,Py (INTEGER) = Window position.                               
                   If Px or Py =-1 window is opened in the screen center.   
           Val (INTEGER) = Percentage value (0-100%).                       
           CoB (LONGINT) = The fill bar color.                              
           P (TPROGRESS) = Pointer to the TProgress structure.              
  OUT....: /                                                                
  EXPLAIN: Display and manage a Progress requester.                         
  NB.....: If the "Val" variable is set to 0, the requester is opened,      
           and, with the value 100, the requester is closed.                
           If the "Abort" Button is pressed, the "Abort" field is TRUE.     
  EXAMPLE: CountP:=0;                                                       
           Repeat                                                           
              Str(CountP,CountS);                                           
              Req_Progress('Process...','Crunched '+CountS,CountP,12,Pro1); 
              Delay(15); Inc(CountP);                                       
           Until (Pro1.Abort=True) Or (CountP>100);                         
 ͼ}

Procedure Req_Progress(Name,Explain:String; Px,Py,Val:Integer; CoB:Longint; Var P:TProgress);
Var Even:Byte;                             {*Evenement Window*}
    Id:Word;                               {*Id Open Window*}

Procedure DRAW_PROGRESS_WIN;
Var O_Y1:Integer;
Begin
O_Y1:=P.W.Y1+HaF1+25;
Bevel (P.W.X1+55, O_Y1-5, P.W.X2-55, O_Y1+9+HaF, CLLightGrey, BLLoweredLine,BLNoLine,No);
Button(P.W.X1+160,P.W.Y2-10-HaF,80,-1, CLTextButton,CLBgButton,$0,P.B,Language.Loc(67)); {*Bouton Abort*}
VESA_SetViewPort(P.W.X1+20, O_Y1, P.W.X1+53, O_Y1+5+HaF,ClipOn);
Display(0,0,CLText,'000 %');
VESA_SetViewPort(P.W.X2-48, O_Y1, P.W.X2-12, O_Y1+5+HaF,ClipOn);
Display(0,0,CLText,'100 %');
VESA_SetViewPort(0,0,VESA_GetMaxX,VESA_GetMaxY,ClipOff);   {*Restore Normal ViewPort*}
End;

Procedure DRAW_GRADIENT_PROGRESS;
Var Qtt:Integer;
Begin
If P.W.Destroyed=True Then Exit;           {*Ya Plus de Fentre !!!*}
Qtt:=(Val*(P.W.X2-P.W.X1-110)) Div 100;
Bevel(P.W.X1+56, P.W.Y1+21+HaF1, P.W.X1+57+Qtt, P.W.Y1+HaF1+HaF+33, CoB);
Display(((P.W.X2+P.W.X1) Div 2)-(VESA_TextWidth(Explain) Div 2),P.W.Y2-24-HaF*2, CLText,Explain);
End;

{*************************** PROCEDURE PRINCIPALE ***************************}

Begin
If P.Init=1 Then                           {*Init Window*}
   Begin
   P.Init:=0;
   If Not Win_Init(Px,Py,Px+400,Py+65+HaF*3+HaF1,$51D9,Name,P.W) Then Exit;
   If (Px=-1) Or (Py=-1) Then Id:=$0015 Else Id:=$0011;
   Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,Id,P.W);
   Win_Draw(P.W);
   DRAW_PROGRESS_WIN;
   P.Abort:=False;
   End;

If (Val>0) And (Val<100) Then              {*Affiche & Augmente la Barre*}
   Begin
   If (P.W.IDCMP And $0001=$0001) And (Button_GetMsg(P.B,1)=CMSelected)
      Then P.Abort:=True;                  {*Abort Operation*}
   Even:=Win_Test(P.W);
   If Even=CMMoved Then DRAW_PROGRESS_WIN;       {*Redraw Objects Window*}
   If Even=CMClosed Then Begin P.Abort:=True;     {*Close Window*}
		  P.W.Name:=''; End;
   If Sys.WinMoved=False Then DRAW_GRADIENT_PROGRESS; {*Draw Barre de Progression*}
   End;

If (Val>=100) Or (P.Abort=True) Then       {*Ending Process - Kill Window*}
  If P.W.Destroyed=False Then
     Begin
	Repeat
	Even:=Win_Test(P.W);               {*On Wait que Window ne Move Plus*}
	If Even=CMMoved Then DRAW_PROGRESS_WIN;
	Until Sys.WinMoved=False;
     Dec(Val,1);
     DRAW_GRADIENT_PROGRESS;               {*Draw Barre Last Time*}
     Win_Done(P.W);
     P.W.Name:='';                         {*Clear Name to Identifie*}
     End;
End;

{****************************************************************************}
{****************************************************************************}
{****************************************************************************}

{ͻ
                           PROCEDURE Req_Pattern                            
 ͹
  IN.....: X1,Y1 (INTEGER) = Requester coordinates.                         
           Name (STRING) = Window name.                                     
  OUT....: Num (SHORTINT) = Selected pattern number.                        
  EXPLAIN: Display and manage a "Pattern" requester.                        
  EXAMPLE: Req_Pattern(100,50,'Please select a pattern...',Num);            
 ͼ}

Procedure Req_Pattern(X1,Y1:Integer; Name:String; Var NUM:Integer);
Var W1:TWindow;
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1,But2     :TButton;             {*Structure Boutons*}
    Haut          :Integer;
    I             :Integer;
    Pattern       :Byte;                {*Pattern Courrante*}
    Pointer       :TMouseZone;          {*Mouse pointer management*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure DRAW_PAT_EXEMPLE;             {*Draw Exemple de Pattern*}
Begin

Win_Clip(Yes,W1);
Bevel (LaF*24, HaF*6-3, LaF*30, HaF*6+11,{Pattern,}CLGrey,BLLoweredLine,BLNoLine,Yes);
Win_Clip(No,W1);
End;

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Var A:Integer;                          {*Boucle*}
    C:TCoordinates;
Begin
Win_Clip(Yes,W1);
VESA_SetColor(CLCursor);
For A:=0 to 7 do
   Bevel (19+A*29, 16, 48+A*29, 31,{A,}CLGrey,BLLoweredLine,BLNoLine,Yes);
For A:=8 to 15 do
   Bevel (19+(A-8)*29, 32, 48+(A-8)*29, 46,{A,}CLGrey,BLLoweredLine,BLNoLine,Yes);

Button(LaF*4-1,HaF*5+7,LaF*16,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
Button(LaF*34, HaF*5+7,LaF*16,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));

C.X1:=19-1; C.Y1:=16-6; C.X2:=19+7*29-1; C.Y2:=46-6;

MseZone(Pointer,C,10,MPHand,'');       {*Define mouse pointer*}

DRAW_PAT_EXEMPLE;                      {*Affiche Exemple de Pattern*}
Win_Clip(No,W1);
End;

{************************** PROCEDURE PRINCIPALE ****************************}

Begin
Log.Add('Call Pattern request',1);
Haut:=HaF1+4;
If Not Win_Init(X1,Y1,X1+LaF*54,Y1+HaF1+HaF*8-3,$51D9,Name,W1) Then Exit;
Win_Sup(100,50,250,200,59,50,639,349,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                          {*Affiche la Fentre*}

Pattern:=Num;                          {*Pattern de Base*}
REDRAW_FRAME;                          {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False;                       {*Init Flag de Sortie*}

{**** BOUCLE PRINCIPALE ****}

Repeat
try

If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                             {*Test des Gadgets Personnels*}
   Win_Clip(Yes,W1);                 {*Clipping Window*}
   MseZone_GetMsg(Pointer);          {*Mouse pointer management*}

   For I:=0 to 7 do If Mse_TestBox(W1.X1+19+I*29,W1.Y1+Haut+12,W1.X1+47+I*29,W1.Y1+Haut+27,1)=True Then
      If Pattern<>I Then
	 Begin Pattern:=I; DRAW_PAT_EXEMPLE;
	 End;
   For I:=8 to 15 do If Mse_TestBox(W1.X1+19+(I-8)*29,W1.Y1+Haut+28,W1.X1+47+(I-8)*29,W1.Y1+Haut+42,1)=True Then
      If Pattern<>I Then
	 Begin Pattern:=I; DRAW_PAT_EXEMPLE;
	 End;

   If Button_GetMsg(But1,1)=CMSelected Then Begin Num:=Pattern; Exit_Flg:=Yes; End;{*Ok*}
   If Button_GetMsg(But2,1)=CMSelected Then Exit_Flg:=Yes; {*Cancel*}
   Win_Clip(No,W1);                    {*Clipping Window*}
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Exit_Flg:=True;          {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until Exit_Flg=True;                    {*Flag de Sortie*}

Win_Done(W1);                           {*Supprime Fentre*}
End;

{****************************************************************************}
{****************************************************************************}
{****************************************************************************}
{****************************************************************************}
{****************************************************************************}

{ͻ
                          FUNCTION Req_Calculator                           
 ͹
  IN.....: X1,Y1 (INTEGER) = Calculator position on screen.                 
         : Title (STRING) = Calculator title.                               
  OUT....: (STRING) = Result string.                                        
  EXPLAIN: Display a Calculator on screen (Model Casio 8000G).              
  SEEALSO: Solve                                                            
 ͼ}

Function Req_Calculator(X1,Y1:Integer; Title:String):String;
Const TN:Array[1..45] of String[6]=(    {*Labels des Boutons*}
   'SHFT','BASE','DEG','1/x','FAC','7','4','1','0','ALFA','SQR',
   'RAD','HYP','(','8','5','2','.','INV','x','GRD','SIN',')',
   '9','6','3','EXP','CLS','10x','LOG','COS','xY','DEL','X','+',
   'ANS','MODE','eX','Ln','TAN','xSQR','_AC','/','-','_EXE');
      TE:Array[1..45] of String[6]=(    {*Fonctions des Calculs*}
   '','BASE ','DEG','1/(','FAC (','7','4','1','0','','SQR (',
   'RAD','HYP (','(','8','5','2','.','','^2','GRD','SIN (',')',
   '9','6','3','EXP (','','10^','LOG (','COS (','^','','*','+',
   'ANS','','EXP (','Ln (','TAN (','','','/','-','');

Var W1            :TWindow;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    TBut          :Array[1..45] Of TButton;{*Tableau des Boutons*}
    Com1,Com2,Com3,
    Com4          :TInputText;              {*Structure Commands*}
    Cin1,Cin2,Cin3,
    Cin4          :String;              {*Strings pour Commands*}
    SMode         :String[12];
    SBase         :String[12];
    X,Y,Dy        :Integer;             {*Coordonnes Boutons*}
    Nb            :Integer;             {*Loop*}
    C1,C2         :Longint;             {*Colors Buttons*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure SHOW_SCREEN;
Var O_X1,O_X2:Integer;                  {*Optimisations*}
    ColSpe:Longint;
Begin
O_X1:=LaF*2; O_X2:=LaF*41+3;
Win_Clip(Yes,W1);
ColSpe:=VESA_SetRGBColor(181,181,139);
InputText (O_X1, HaF*1-4, O_X2, 255, ColSpe,ColSpe,2,$0020,Com1,Cin1);
InputText (O_X1, HaF*2+1, O_X2, 255, ColSpe,ColSpe,2,$0020,Com2,Cin2);
InputText (O_X1, HaF*4-4, O_X2, 255, ColSpe,ColSpe,2,$0020,Com3,Cin3);
InputText (O_X1, HaF*5+1, O_X2, 255, ColSpe,ColSpe,2,$0020,Com4,Cin4);
Win_Clip(No,W1);
End;

Procedure DRAW_GADGETS;                 {*Dfinition des Gadgets Fentre*}
Var IdBut:Integer;
    St:String;

Begin
Win_Clip(Yes,W1);
Bevel (LaF*2-1, HaF*7, LaF*44-1, HaF*10-5, CLGrey,BLLoweredLine,BLNoLine,Yes);
St:=Upper(Cin1);
If St='RAD' Then SMode:='RADIANS';{*Modes de la Calculatrice*}
If St='DEG' Then SMode:='DEGRES';
If St='GRD' Then SMode:='GRADES';
Str(Mat_Base,SBase);

Display (LaF*2+4, HaF*7+1, CLTextTitle,'MODE : '+SMode);
Display (LaF*2+4, HaF*8+2, CLTextTitle,'BASE : '+SBase);

X:=4; Nb:=1;                            {*Pos X et Qtt=1*}
While (X<37) do Begin

   Y:=11;
   While (Y<28) do Begin
      If (Y>=11) And (Y<=19) Then Begin Dy:=1; C1:=CLBlack; C2:=CLGrey; End
			     Else Begin Dy:=6; C1:=CLWhite; C2:=CLDarkGrey; End;
      If (X=4)  And (Y=11) Then C2:=CLSalmon;
      If (X=12) And (Y=11) Then C2:=CLOrange;
      If (X=28) And (Y=21) Then C2:=CLOrange;
      If (X=36) And (Y=21) Then C2:=CLOrange;
      If (X=36) And (Y=27) Then C2:=CLGrey;

      If Nb=45 Then IdBut:=$0100 Else IdBut:=$0000;
      Button (LaF*X-1, HaF*Y+Dy-6, LaF*6,-1,C1,C2,IdBut,TBut[Nb],TN[Nb]);
      Inc(Nb);                          {*Next Item*}
      Inc(Y,2);                         {*Next Ligne*}
      End;
   Inc(X,8);                            {*Next Colonne*}
   End;

Win_Clip(No,W1);
SHOW_SCREEN;                            {*Affiche l'cran LCD*}
End;

Procedure REDRAW_FRAME;                 {*Dfinition des Cadres de Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (009,005,219,066, CLLightGrey,BLLoweredLine,BLNoLine,Yes);
Bevel (009,100,219,205, CLLightGrey,BLRaisedLine,BLNoLine,Yes);
Bevel (009,205,219,290, CLPaper,    BLRaisedLine,BLNoLine,Yes);
Win_Clip(No,W1);
DRAW_GADGETS;
End;

{******************* CALCUL DE L'EXPRESSION MATHEMATIQUE ********************}

Procedure CALCUL;
Begin
Solve(Cin1,Cin2);
{Error:=Solve(Cin1,Cin2);}              {*For errors management*}
SHOW_SCREEN;                            {*Affiche l'cran LCD*}
DRAW_GADGETS;
End;

{************************** PROCEDURE PRINCIPALE ****************************}

Begin
Log.Add('Call Calculator request',1);

If Not Application.TestRegistered Then Begin Error(670); Exit; End; {*Shareware Version ?*}

If Not Win_Init(X1,Y1,X1+LaF*46,Y1+HaF1+HaF*30+1,$51D9,Title,W1) Then Exit;
Win_Sup(100,50,250,200,59,50,639,349,0,CLDarkGrey,$0A51,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Cin1:=''; Cin2:=''; Cin3:=''; Cin4:='';
SMode:='RADIANS';

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False;                        {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Personnels*}
   For X:=1 to 45 do Begin
   If Button_GetMsg(TBut[X],1)=CMSelected Then
      Begin
      If TE[X]='' Then                  {*Spcific Actions or NO Actions...*}
	 Begin
	 If X=28 Then Cin1:='0';
	 If X=33 Then Cin1:=Copy(Cin1,1,Length(Cin1)-1);
	 If X=42 Then Cin1:='';
	 If X=45 Then CALCUL Else SHOW_SCREEN;
	 End                            {*Action du Bouton 'X'*}

	 Else Begin Cin1:=Cin1+TE[X]; SHOW_SCREEN; End;
      End;
   End;

   If InputText_GetMsg(Com1,Cin1)=CMModified Then Calcul;
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Exit_Flg:=True;          {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until Exit_Flg=True;                    {*Flag de Sortie*}

Win_Done(W1);                           {*Supprime Fentre*}
Req_Calculator:=Cin2;                   {*Renvois Rsultat*}
End;

{ͻ
                         PROCEDURE Req_DisplayClock                         
 ͹
  IN.......: X1,Y1,X2,Y2 (INTEGER) = Coordinates of the clock box.          
             Co (LONGINT) = Clock color.                                    
             State (BYTE) = Clock state (0 = Initialisation, 1 = Test).     
             T (TClock) = Pointer to a "TClock" structure.                  
             W (TWindow) = Pointer to a window structure.                   
  OUT......: /                                                              
  EXPLAIN..: Display and manage a classical clock in a box.                 
 ͼ}

Procedure Req_DisplayClock(X1,Y1,X2,Y2:Integer; Co:Longint; State:Byte; Var T:TClock; W:TWindow);
Var Done          :Boolean;             {*Affichage Dja Fait...*}

{********************* CALCUL DE VARIABLES ETENTIELLES **********************}

Procedure BUILD_DATAS;
Begin
T.Cx:=((X1+X2) Div 2);                  {*Calcul du Centre du Cadran*}
T.Cy:=((Y1+Y2) Div 2);

T.Sx:=((X2-X1) Div 2);                  {*Prcalcul du Coef Taille du Cadran*}

T.Sy:=((Y2-Y1) Div 2);
T.Fs:=(T.Sx+T.Sy) Div 60;               {*Taille des Points Heures*}
If T.Fs<1 Then T.Fs:=1;                 {*Taille Min des Carrs*}

T.Sx:=((X2-X1) Div 2)-T.Fs-8;           {*Coef Taille du Cadran*}
T.Sy:=((Y2-Y1) Div 2)-T.Fs-8;
End;

{*************************** AFFICHAGE DU CADRAN ****************************}

Procedure DRAW_CADRAN;
Var A:Integer;
    Ar:Real;                            {*Angle en Radian*}
    X,Y:Integer;

Begin
Win_Clip(Yes,W);                      {*Clipping Window*}
For A:=0 to 359 do                      {*Parcours le Cercle*}
   Begin
   If A<>0 Then Ar:=(2*Pi*A)/360        {*Switching to Radian Mode...*}
      Else Ar:=0;
   X:=Trunc(Cos(Ar)*T.Sx)+T.Cx;         {*Calcul Pos X,Y des Points*}
   Y:=Trunc(Sin(Ar)*T.Sy)+T.Cy;

   If A Mod 6=0 Then                    {*360 / 60 Graduations = 6 Degrs*}
      If T.Fs-1>=1 Then Bevel (X-2,Y-7,X,Y-5,CLLightGrey,BLLoweredLine,BLNoLine,Yes);
   If A Mod 30=0 Then                   {*360 / 12 Heures = 30 Degrs*}
      Bevel (X-T.Fs-1,Y-T.Fs-6,X+T.Fs-1,Y+T.Fs-6, Co,BLRaisedLine,BLNoLine,Yes);
   End;
Win_Clip(No,W);                     {*Restore Normal Clipping*}
End;

{***************************** CALCUL UN POINT ******************************}

Procedure BUILD_POINT(Num:Byte; Ar:Real; Size:Real);
Var X,Y:Integer;
    Nx,Ny:Integer;                      {*Taille de l'Aiguille*}

Begin
Nx:=Trunc(T.Sx/Size);
Ny:=Trunc(T.Sy/Size);
X:=(Trunc(Cos(Ar)*Nx)+T.Cx)-1;          {*Calcul Pos X,Y des Points*}
Y:=(Trunc(Sin(Ar)*Ny)+T.Cy)-6;
T.Aiguille[Num].X:=X;                   {*Stocke dans Record Aiguille*}
T.Aiguille[Num].Y:=Y;
End;

{**************** AFFICHAGE / EFFACEMENT DES GRANDES AIGUILLES **************}

Procedure DRAW_HAND(S,Max:Shortint; Mode:Boolean);
Var Ar:Real;                            {*Angle en Radian*}
    S1,S2:Real;
    C1,C2:Integer;                      {*Couleur 1 et 2*}

Begin

S:=S-(Max Div 4);
If S<>0 Then Ar:=(2*Pi*S)/Max           {*Converting Units to Radians...*}
   Else Ar:=0;
If Max=60
   Then Begin S1:=9; S2:=1.15; End     {*Petite ou Grande Aiguille*}
   Else Begin S1:=12; S2:=1.6;  End;

If Mode=Yes                             {*Mode Effacement ou Affichage...*}
   Then Begin C1:=CLShadow; C2:=Co; End
   Else Begin C1:=CLWinBg;  C2:=C1; End;

Win_Clip(Yes,W);                       {*Clipping Window*}
If Mode Then VESA_SetColor(CLLineDown) {*Affiche / Efface Contours...*}
	Else VESA_SetColor(CLWinBg);

BUILD_POINT(1,Ar+Pi   ,6);
BUILD_POINT(2,Ar-Pi/2,S1);              {*Shadow Aiguille Coordonnes...*}
BUILD_POINT(3,Ar     ,S2);
BUILD_POINT(4,Ar+Pi/2,S1);
BUILD_POINT(5,Ar+Pi   ,6);

Dec(T.Aiguille[3].X,T.Sx Div 20);       {*Build Shadow...*}
Inc(T.Aiguille[3].Y,T.Sy Div 20);
Dec(T.Aiguille[1].X,T.Sx Div 50);
Inc(T.Aiguille[1].Y,T.Sy Div 50);
Dec(T.Aiguille[5].X,T.Sx Div 50);
Inc(T.Aiguille[5].Y,T.Sy Div 50);

Mse_Hide;
VESA_SetFillStyle(1,C1);                     {*Draw Shadow of Aiguille*}
VESA_FillPoly(SizeOf(T.Aiguille) Div SizeOf(TPointType), T.Aiguille);

BUILD_POINT(1,Ar+Pi   ,6);
BUILD_POINT(3,Ar     ,S2);              {*Real Aiguille Coordonnes...*}
BUILD_POINT(5,Ar+Pi   ,6);

VESA_SetFillStyle(1,C2);                     {*Draw Aiguille*}
VESA_FillPoly(SizeOf(T.Aiguille) Div SizeOf(TPointType), T.Aiguille);
					{*Draw Contours Aiguille*}
VESA_DrawPoly(SizeOf(T.Aiguille) Div SizeOf(TPointType), T.Aiguille);
Mse_Show;

Win_Clip(No,W);                     {*Restore Normal Clipping*}
End;

{********************* AFFICHAGE DE LA PETITE AIGUILLE **********************}

Procedure DRAW_SMALL_HAND(S:Shortint);
Var Ar:Real;                            {*Angle en Radian*}

Begin
S:=S-15;
If S<>0 Then Ar:=(2*Pi*S)/60            {*Converting Seconds to Radians...*}
   Else Ar:=0;

BUILD_POINT(1,Ar,1.15);                 {*Calcul Pos X,Y des Points*}

VESA_SetColor(CLWinBg);
VESA_SetWriteMode(XORPut);
Win_Clip(Yes,W);                      {*Clipping Window*}
Mse_Hide;
VESA_Line(T.Cx-1,T.Cy-6,T.Aiguille[1].X,T.Aiguille[1].Y);
Mse_Show;
Win_Clip(No,W);                     {*Restore Normal Clipping*}
VESA_SetWriteMode(NormalPut);
End;

{*********************** EFFACE TOUTES LES AIGUILLES ************************}

Procedure CLEAR_ALL;
Begin
If Done Then Exit;                      {*Dja Fait...*}
DRAW_SMALL_HAND(T.Os);                  {*Planque la Petite Aiguille*}
DRAW_HAND(T.Oh,12,FALSE);
DRAW_HAND(T.Om,60,FALSE);
End;

{********************** REAFFICHE TOUTES LES AIGUILLES **********************}

Procedure SHOW_ALL;
Begin
If Done Then Exit;                      {*Dja Fait...*}
DRAW_HAND(T.Cur[2],60,TRUE);
DRAW_HAND(T.Cur[1],12,TRUE);
DRAW_SMALL_HAND(T.Cur[3]);              {*Planque la Petite Aiguille*}
Done:=Yes;
End;

{************************** PROCEDURE PRINCIPALE ****************************}

Begin
Log.Add('Create new Clock',2);

GetTime(T.Cur[1],T.Cur[2],T.Cur[3],T.Cur[4]); {*Prends le Temps*}
Done:=No;

If State=0 Then
   Begin
   BUILD_DATAS;
   DRAW_CADRAN;                         {*Affiche le Cadran...*}
   T.Oh:=T.Cur[1]; T.Om:=T.Cur[2];      {*Stocke New Time...*}
   T.Os:=T.Cur[3]; T.Od:=T.Cur[4];
   SHOW_ALL;
   End;

If T.Cur[1]<>T.Oh Then Begin            {*Affiche Aiguille Heures*}
   CLEAR_ALL;
   SHOW_ALL;
   T.Oh:=T.Cur[1];                      {*Stocke New Heures...*}
   End;

If T.Cur[2]<>T.Om Then Begin            {*Affiche Aiguille Minutes*}
   CLEAR_ALL;
   SHOW_ALL;
   T.Om:=T.Cur[2];                      {*Stocke New Minutes...*}
   End;

If T.Cur[3]<>T.Os Then                  {*Affiche Petite Aiguille*}
   Begin
   If Not Done Then Begin
      DRAW_SMALL_HAND(T.Os);            {*Cache Petite Aiguille*}
      DRAW_SMALL_HAND(T.Cur[3]);        {*Affiche Petite Aiguille*}
      End;
   T.Os:=T.Cur[3];                      {*Stocke New Seconds...*}
   End;
End;

{ͻ
                        PROCEDURE Req_DefineAudioCD                         
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
           Title (STRING) = Requester title.                                
           FName (STRING) = Audio CD data filename else '' for blank.       
  OUT....: /                                                                
  EXPLAIN: Display and manage an Audio CD requester.                        
 ͼ}

Procedure Req_DefineAudioCD(Px,Py:Integer; Title,FName:String);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flags*}
    But1,But2,But3:TButton;             {*Buttons Structure*}
    Com1,Com2,Com3,
    Com4          :TInputText;          {*Commands Structure*}
    Cin1,Cin2,Cin3,
    Cin4          :String;              {*Strings for Commands*}
    DirSel        :String;              {*Manage Directories*}
    Size          :Longint;
    List          :TList;
    A             :Integer;             {*Loop*}
    St            :String;              {*Temp*}

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_COMMANDS;
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
InputText (189,014,060, 255, CLSky,CLLightBlue,1,$0066,Com1,Cin1);
InputText (189,034,180, 255, CLSky,CLLightBlue,0,$0026,Com2,Cin2);
InputText (189,049,180, 255, CLSky,CLLightBlue,0,$0026,Com3,Cin3);
InputText (189,064,180, 255, CLSky,CLLightBlue,0,$0026,Com4,Cin4);
End;

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}

BMP_Show(019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_scda.bmp',$0080);

St:=Language.Loc(227);
Display (119,014, CLText,Str_Get(St,1,';'));
Display (119,034, CLText,Str_Get(St,2,';'));
Display (119,049, CLText,Str_Get(St,3,';'));
Display (119,064, CLText,Str_Get(St,4,';'));

St:=Language.Loc(226);
Button (279,014,090,-1, CLTextButton,CLBgButton,$0000,But1,Str_Get(St,1,';'));
Button (090,204,080,-1, CLTextButton,CLBgButton,$0110,But2,Str_Get(St,2,';'));
Button (220,204,080,-1, CLTextButton,CLBgButton,$0000,But3,Language.Loc(13));

List_Show(List);                        {*Display the list*}

Win_Clip(No,W1);                        {*Restore Normal Clipping*}

REDRAW_COMMANDS;                        {*Display commands*}
End;

{************************* MISE A JOUR DES DONNEES **************************}

Procedure UPDATE_LIST;
Var A:Integer;
Begin
List_Load(List,DirSel+FName);
List_AdjustColumns(List);
List_SetColumnAttr(List,1,40,Text_Center);
For A:=2 to 5 do List_SetColumnId(List,A,$0001);

Cin1:=Copy(FName,1,8);
Cin2:=List_GetStringCell(List,1,3);
Cin3:=List_GetStringCell(List,1,4);
Cin4:=List_GetStringCell(List,1,5);
End;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure INIT_FRAME;
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}

DirSel:=Sys.GetPath(SP_MEDIAS);

If Not File_TestExist(DirSel+FName) Then FName:='';

List_Define(List,Language.Loc(228),';',119,089,369,189, 1000, CLDataZone,CLDataZone,$1BE9);
List_SetIdMore(List,$0008);

Update_List;

Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
Log.Add('Call DefineAudioCD request',1);
If Not Win_Init(Px,Py,Px+390,Py+HaF1+230,$51D9,Title,W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

INIT_FRAME;                             {*Initialise Frame*}
REDRAW_FRAME;                           {*Display Window Content*}

XOk:=No; XCancel:=No;                   {*Init Exit Flags*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then
      Begin
      Req_FileManager(120,30,300,Str_Get(Language.Loc(226),3,';'),'_OK','*.CDA',0,DirSel,FName,Size);
      If FName<>'' Then
         Begin
         List_Reset(List);
         Update_List;
         Win_Clip(Yes,W1);              {*Clipping Window*}
         REDRAW_COMMANDS;
         List_Show(List);               {*Display the list*}
         End;
      End;
   If Button_GetMsg(But2,1)=CMSelected Then
      Begin
      List_Sort(List,1,Sort_AZ,1);
      List_Save(List,DirSel+FName); XOk:=Yes;
      End;
   If Button_GetMsg(But3,1)=CMSelected Then XCancel:=Yes;

   If InputText_GetMsg(Com2,Cin2)=CMModified Then
      Begin
      For A:=1 to List_GetQttItems(List) do List_SetStringCell(List,A,3,Cin2);
      List_Refresh(List);
      End;
   If InputText_GetMsg(Com3,Cin3)=CMModified Then
      Begin
      For A:=1 to List_GetQttItems(List) do List_SetStringCell(List,A,4,Cin3);
      List_Refresh(List);
      End;
   If InputText_GetMsg(Com4,Cin4)=CMModified Then
      Begin
      For A:=1 to List_GetQttItems(List) do List_SetStringCell(List,A,5,Cin4);
      List_Refresh(List);
      End;

   List_test(List);                     {*Teste de la liste*}

   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;            {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flags*}

Win_Done(W1);                           {*Close Window if Needs*}
List_Done(List);
End;

{*------------------------ PAS DE PROG PRINCIPAL ---------------------------*}


Begin
End.
