{ͻ
                              UNIT MosStrings                               
 ͹
  CREATOR....: PLANAS Jean-Pierre                                           
  UPDATED BY.: PLANAS Jean-Pierre                                           
  CREATED THE: 10.06.1998                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: Management of strings.                                       
  AUTONOMOUS.: Yes                                                          
  UNIT SIZE..: 2.371 Lines and (40.128 Bytes compiled)                      
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosStrings;
{$MODE objfpc}

INTERFACE

Type TPointer = Record                     {*Redefinition of a Pointer*}
                  Case Boolean of
                    TRUE:(Offset,Segment:Word);
                    FALSE:(P:Pointer);
                 End;

{|Capital/Small letters|}
Function  Upper(SUP:String):String;         {*Put a string on capital letters*}
Function  Lower(SUP:String):String;         {*Put a string on small letters*}
Function  Midder(SUP:String):String;        {*Put a string on 1st letter only capital*}

{|Separators|}
Function  Str_Count(S:String;Sep:Char):Byte; {*Count number of columns in the string*}
Function  Str_Get(s:string;num:integer;Sep:char):string; {*Get substring in a specified column*}
Function  Str_Delete(s:string;num:integer;Sep:char):string; {*Delete a column in this string*}
Function  Str_Insert(s,substring:string;num:integer;Sep:char):string; {*Insert a column in this string*}
Function  Str_Put(s,substring:string;num:integer;Sep:char):string; {*Put substring in a specified column*}
Function  Str_GetIndex(SubS,Main:String; Sep:Char):Byte; {*Get substring index*}

{|Convert|}
Function  Str_S2C(St:String):Char;                  {*Convert a string to a char*}
Function  Str_C2S(C:Char):String;                   {*Convert a char to a string*}
Function  Str_A2S(A:Array of Char;Max:Byte):String; {*Convert array to string*}
Function  Str_Po2S(p:pointer):String;               {*Convert an adress to a writable string*}
Function  Str_P2S(P:Pointer;Size:Byte):String;      {*Convert pointer to string*}
Procedure Str_S2P(S:String;P:Pointer;Size:Byte);    {*Convert string to pointer*}
Function  Str_D2S(Year:Word;Month,Day:Byte):String; {*Convert date to string*}
Function  Str_S2D(S:String;Var Year:Word;Var Month,Day:Byte):Boolean; {*Convert string to date*}
Procedure Str_S2PC(Dest: PChar; Source: String);    {*Convert string to pchar*}
Function  Str_S2H(S:String):String;                 {*Convert string to hexadecimal ascii codes*}
Function  Str_Data2S(P:Pointer;Deb,Qte:Integer):String; {*Convert data in memory to a string*}
Function  Str_CorrectChars(Str : String):String;    {*Convert all accentuated chars*}
Function  Str_Palindrome(St:String):String;         {*Get the string palindrome...*}
Function  Str_S2B(S:String):Boolean;                {*Convert String to Boolean*}
Function  Str_B2S(B:Boolean):String;                {*Convert Boolean to String*}
Function  Str_TestBoolean(S:String):Boolean;        {*Test if the string is a boolean*}
Function  Str_I2S(Value:Longint):String;            {*Convert an integer to a string*}
Function  Str_S2I(Value:String):Longint;            {*Convert a string to an integer*}

{|Base convertion|}
Function  Str_CheckBase(St:String;Base:Byte):Boolean;  {*Check if the number is in a correct base*}
Function  Str_Base2L(St:String;Base:Byte):Longint;  {*Convert a number from a specified base to a longint*}
Function  Str_L2Base(N:Longint;Base:Byte):String;   {*Convert a longint to a specified base*}
Function  Str_L2H(L:Longint;Format:Byte):String;    {*Convert a longint to hexadecimal*}
Function  Str_H2L(S:String):Longint;                {*Convert Hexa String to longint*}
Function  Str_S2L(S:String):Longint;                {*Convert Decimal String to longint*}
Function  Str_L2S(L:Longint):String;                {*Convert Decimal Longint to string*}

{|Str_Crypt|}
Function  Str_Crypt(Phr:String; Clef:Byte):String; {*Crypt & Uncrypt String*}
Function  Str_GetCryptKey(Phr:String):Byte;            {*Get a key to Str_Crypt*}

{|Spaces|}
Function  Str_CleanSpaces(S:String):String;         {*Keep only one space between each word*}
Function  Str_Fill(s:string;taille:integer;Sens:Byte):string; {*Fill a string with spaces*}
Function  Str_Spaces(N:Byte):String;                {*Return N spaces string*}
Function  Str_Clear(s:String):String;               {*Clear a string of the spaces*}
Function  Str_Trim(Const S:String):String;          {*Delete spaces before and after the string*}

{|Extraction|}
Function  Str_ExtractEmail(aEmail:String):String;   {*Extract an email in string*}
Function  Str_Extract(S,S1,S2:String):String;       {*Extract a substring witch is between 2 items*}
Function  Str_Int(S:String;Pos:Byte):LongInt;       {*Get a Number from a string*}

{|Modification / Destructive|}
Function  Str_Cut(S,Sub:String;Flg:Byte):String;    {*Get a part of the string*}
Function  Str_Suppr(S,S1,S2:String):String;         {*Suppress a part of the string*}
Function  Str_Replace(S,Sub,Rep:String;Mode:Word):String;{*Replace a substring by another string*}
Function  Str_Center(S:String; Sub:String):String;  {*Copy a subString in a string but in the middle*}
Function  Str_FilenameCaracters(StIn,Rep:String):String;{*Replace invalid caracters to accord with filenames*}
Function  Str_Multiply(St:String; Count:Byte):String;{*Multiply and return the string*}
Function  Str_DelSub(Main,Sub:String):String;       {*Delete a substring*}

{|Words|}
Function  Str_GetWordNum(S:String;Num:Byte):String; {*Get the 'th word in the string*}
Function  Str_CountWords(S:String):Byte;            {*Count the number of words in the string*}
Function  Str_GetWord(S:String;Pos:Byte):String;    {*Get a word in a sentence*}
Function  Str_IsReservedWord(S:String):Boolean;     {*Check if is a reserved Pascal word*}
Function  Str_GetToken(aToken,aInput:String):Integer;{*Extract a token from a phrase*}

{|Get Information|}
Function  Str_LastPos(Substr: String; S: String): Byte;  {*Like pos but for last occurence*}
Function  Str_TestPos(S,Sub:String;i:Byte):Boolean; {*Test substring position in the string*}
Function  Str_CountItem(S,SubSt:String):Byte;       {*Count how many times the substring is found *}

{|Format|}
Function  Str_FillZero(W:Longint;Num:Byte):String;  {*Complete string with zeros*}
Function  Str_Format(StIn:String; Sep:Char; Block:Byte):String;{*Format a String*}

{|Miscellaneous|}
Function  Str_Mask(StIn:String; Sep,Base:Char):String;   {*Build a Mask for a String*}

{|Command line|}
Function  Str_ParamCount(S:String):Byte;            {*Make a ParamCount on a string*}
Function  Str_ParamStr(S:String;Num:Byte):String;   {*Make a ParamStr on a string*}
Function  Str_Parameter(S:String;Var St:String;Mode:Word):Byte; {*Make a parameter on the string*}
Function  Str_GetCommandLine:String;                {*Get the Command Line*}
Function  Parameter(Var St:String;Mode:Word):Byte;  {*Get parameter of command line*}

{|Files Masks|}
Function  Str_WildCards(S:String;Mask:String):String; {*Wilcards apply to a string*}
Function  Str_FileMask(FileName:String;Mask:String):String; {*Apply a mask on a filename*}
Function  Str_Extr(PS,PS2:String):String; {*Extract a subdirectory from 2 directory*}
Function  Str_PathRelative(P1,P2:String):String; {*Return a relative path*}
Function  Str_CorrectPath(S:String):String;         {*return string without '\\' substring*}

{|Hotkeys management|}
Function  Str_PurgeHotkey    (      Line:String):String; {*Purge Hotkey definer from String*}
Function  Str_GetHotkeyPos   (Const Line:String):Byte;   {*Get Hotkey index from a String*}
Function  Str_GetHotkey      (Const Line:String):String; {*Get Hotkey from a String*}

{|Versions|}
Function  Str_SetVersion(Major,Minor:Word):String; {*Return a complete version*}
Function  Str_GetVersionMajor(V:String):Word;      {*Get Major version*}
Function  Str_GetVersionMinor(V:String):Word;      {*Get Minor version*}
Function  Str_TestVersion(V1,V2:String):Byte;      {*Test version number*}

IMPLEMENTATION

Uses
     Dos,
     MosCPUInstructions;

{*--------------------------- CAPITAL/SMALL LETTERS ------------------------*}

{ͻ
                               FUNCTION UPPER                               
 ͹
  IN.....: SUP (STRING) = Input String                                      
  OUT....: (STRING) = String result                                         
  EXPLAIN: Transform a string to capital letters                            
  EXAMPLE: Writeln(Upper(FREderic)) ='FREDERIC'                             
  SEEALSO: Lower, Midder                                                    
 ͼ}
Function UPPER(SUP:String):String;      {*Capital letters*}
Var I:Integer;
    ST1:String;
Begin
St1:=SUP;
For I:=1 to Length(ST1) do
ST1[I]:=Upcase(ST1[I]);
UPPER:=ST1;
End;

{ͻ
                               FUNCTION LOWER                               
 ͹
  IN.....: SUP (STRING) = Input String                                      
  OUT....: (STRING) = String result                                         
  EXPLAIN: Transform a string to small letters.                             
  EXAMPLE: Writeln(Lower('FREderic')) ='frederic'                           
  SEEALSO: Upper, Midder                                                    
 ͼ}
Function LOWER(SUP:String):String;      {*Small letters*}
Var      I:Integer;
         ST1:String;
Begin
ST1:=SUP;
For I:=1 to Length(ST1) do
If (Ord(St1[i])>64) and (Ord(St1[i])<91) then St1[i]:=Chr(Ord(St1[i])+32);
LOWER:=ST1;
End;

{ͻ
                              FUNCTION MIDDER                               
 ͹
  IN.....: SUP (STRING) = Input String                                      
  OUT....: (STRING) = String result                                         
  EXPLAIN: Transform a string to small letters except first letter will     
           be in capital letter.                                            
  EXAMPLE: Writeln(Midder(FREderic)) ='Frederic'                            
  SEEALSO: Lower, Upper                                                     
 ͼ}
Function MIDDER(SUP:String):String;     {*Small letters & 1st Capital*}
Var      I:Integer;
         ST1:String;
Begin
ST1:=SUP;
ST1[1]:=Upcase(ST1[1]);
For I:=2 to Length(ST1) do
If (Ord(St1[i])>64) and (Ord(St1[i])<91) then St1[i]:=Chr(Ord(St1[i])+32);
MIDDER:=ST1;
End;

{*----------------------------- SEPARATORS ---------------------------------*}

{ͻ
                             FUNCTION STR_COUNT                             
 ͹
  IN.....: s : (STRING) = String source.                                    
           sep : (CHAR) = Char witch separate substrings in the string s    
  OUT....: (BYTE) = Number of columns counted.                              
  EXPLAIN: Count the number of columns in a string . This result is the     
           same as the number of separator +1.                              
  EXAMPLE: Str_Count('18/01/1998','/') = 3                                  
           Str_Count('toto',';')       = 1                                  
           Str_Count('1;3;5;7;9;',';') = 6                                  
           Str_Count('toto;',';')      = 2                                  
  SEEALSO: Str_Get, Str_Delete, Str_Insert, Str_Put                         
 ͼ}

Function Str_Count(S:String;Sep:Char):Byte;
Var cp,i:Byte;

Begin
cp:=1;
For i:=1 to Length(S) do If S[i]=Sep Then Inc(cp);
Str_Count:=cp;
End;

{ͻ
                              FUNCTION STR_GET                              
 ͹
  IN.....: s : (STRING) = String source.                                    
           num : (INTEGER) = N of the substring to extract                 
           sep : (CHAR) = Char witch separate substrings in the string s    
  OUT....: (STRING) = Substring extracted.                                  
  EXPLAIN: Extract a substring from a string with contain substring         
           separated by separators (sep).                                   
  EXAMPLE: Str_get('18/01/1998',2,'/')   = '01'                             
           Str_get('t;oio;ertt',3,';')   = 'ertt'                           
           Str_get('t;oio;ertt',4,';')   = ''                               
           Str_get('t;oio;ertt',0,';')   = ''                               
           Str_get('t;oio;ertt',2,';')   = 'oio'                            
  SEEALSO: Str_Delete, Str_Insert, Str_Put, Str_Count                       
 ͼ}

Function Str_Get(s:string;num:integer;sep:char):string;
Var i,j,cp:integer;
    s2:string;
Begin
cp:=1; {*Count number of columns*}
i:=1;
s2:=s+sep;
j:=0;
While ((i<=length(s2)) and (cp<=num)) do
  Begin
  if (num=cp) And (j=0) then j:=i;
  if s2[i]=sep then
    begin
    inc(cp);
    end;
  inc(i);
  End;
If (j=0) Then s2:='' Else s2:=Copy(s2,j,i-j);
If s2[length(s2)]=sep Then SetLength(s2,Length(s2)-1);
Str_Get:=s2;
End;

{ͻ
                            FUNCTION STR_DELETE                             
 ͹
  IN.....: s : (STRING) = String source.                                    
           num : (INTEGER) = N of the substring to delete.                 
           sep : (CHAR) = Char witch separate substrings in the string s    
  OUT....: (STRING) = String result.                                        
  EXPLAIN: Delete a substring from a string with contain substrings         
           separated by a separator (sep).                                  
  EXAMPLE: Str_Delete('18/01/1998',2,'/')   = '18/1998'                     
           Str_Delete('t;oio;ertt',4,';')   = 't;oio;ertt'                  
           Str_Delete('t;oio;ertt',0,';')   = 't;oio;ertt'                  
           Str_Delete('t;oio;ertt',2,';')   = 't;ertt'                      
  SEEALSO: Str_Get, Str_Insert, Str_Put, Str_Count                          
 ͼ}

Function Str_Delete(s:string;num:integer;sep:char):string;
Var i,j,cp:integer;
    s2:string;
Begin
If S='' Then
   Begin
   Result:='';
   Exit;
   End;

If (Str_Count(S,Sep)=1) And (Num=1) Then
   Begin
   Result:='';
   Exit;
   End;

cp:=1; {*Count number of columns*}
i:=1;
s2:=s+sep;
j:=0;
While ((i<=length(s2)) and (cp<=num)) do
  Begin
  if (num=cp) And (j=0) then j:=i;
  if s2[i]=sep then inc(cp);
  inc(i);
  End;
If (j<>0) Then Delete(s2,j,i-j);
If s2[length(s2)]=sep Then SetLength(s2,Length(s2)-1);
Str_Delete:=s2;
End;

{ͻ
                            FUNCTION STR_INSERT                             
 ͹
  IN.....: s : (STRING) = String source.                                    
           substring : (STRING) = Substring to insert.                      
           num : (INTEGER) = N of the position to insert the substring     
           sep : (CHAR) = Char witch separate substrings in the string s    
  OUT....: (STRING) = String result.                                        
  EXPLAIN: Insert at position num a substring with will be delimited by     
           separators.                                                      
  EXAMPLE: Str_Insert('18/1998','01',2,'/')      = '18/01/1998'             
           Str_Insert('t;oio;ertt','jp',4,';')   = 't;oio;ertt;jp'          
           Str_Insert('t;oio;ertt','jp',0,';')   = 'jp;t;oio;ertt'          
           Str_Insert('t;oio;ertt','jp',2,';')   = 't;jp;oio;ertt'          
           Str_Insert('t','jp',3,';')            = 't;;jp'                  
  SEEALSO: Str_Get, Str_Delete, Str_Put, Str_Count                          
 ͼ}

Function Str_Insert(s,substring:string;num:integer;sep:char):string;
Var i,j,cp:integer;
    s2:string;
Begin
If S='' Then
   Begin
   Result:=SubString;
   Exit;
   End;

cp:=1; {*Count number of columns*}
i:=1;
s2:=s+sep;
While ((i<=length(s2)) and (cp<num)) do
  Begin
  if s2[i]=sep then inc(cp);
  inc(i);
  End;
If cp<num then
  For j:=cp to num-1 do
    Begin
    s2:=s2+sep;
    inc(i);
    End;
Insert(substring+sep,s2,i);
If length(s2)>0 Then SetLength(s2,Length(s2)-1);;
Str_Insert:=s2;
End;

{ͻ
                              FUNCTION STR_PUT                              
 ͹
  IN.....: s : (STRING) = String source.                                    
           substring : (STRING) = Substring to put.                         
           num : (INTEGER) = N of the substring to replace.                
           sep : (CHAR) = Char witch separate substrings in the string s    
  OUT....: (STRING) = String result.                                        
  EXPLAIN: Put at position num (column num) the substring.                  
           Every column is delimited by separators (sep).                   
  EXAMPLE: Str_Put('18/1998','01',2,'/')      = '18/01'                     
           Str_Put('t;oio;ertt','jp',4,';')   = 't;oio;ertt;jp'             
           Str_Put('t;oio;ertt','jp',0,';')   = 'jp;t;oio;ertt'             
           Str_Put('t;oio;ertt','jp',2,';')   = 't;jp;ertt'                 
           Str_Put('t','jp',3,';')            = 't;;jp'                     
  OPT....: Can be optimised if needed.                                      
  SEEALSO: Str_Get, Str_Delete, Str_Insert, Str_Count                       
 ͼ}
Function Str_Put(s,substring:string;num:integer;sep:char):string;
var s2:string;
Begin
s2:=s;
s2:=Str_Delete(s2,num,sep);
s2:=Str_Insert(s2,substring,num,sep);
Str_Put:=s2;
End;

{ͻ
                            FUNCTION STR_GETINDEX                           
 ͹
  IN.....: SubS : (STRING) = Substring to check.                            
           Main : (STRING) = The main string to search substring.           
           Sep : (CHAR) = Char witch separate substrings in the string s    
  OUT....: (BYTE) = Index of the substring in string else 0 if error.       
  EXPLAIN: Get the substring index in string separated by "Sep".            
  SEEALSO: Str_Get, Str_Delete, Str_Insert, Str_Put, Str_Count              
 ͼ}

Function Str_GetIndex(SubS,Main:String; Sep:Char):Byte;
Var A:Integer;
Begin
For A:=1 to Str_Count(Main,Sep) do
   Begin
   If SubS=Str_Get(Main,A,Sep) Then
      Begin
      Result:=A;
      Exit;
      End;
   End;
Result:=0;
End;

{*--------------------------------CONVERT-----------------------------------*}
{ͻ
                              FUNCTION Str_S2C                              
 ͹
  IN.....: St (STRING) = Input String                                       
  OUT....: (CHAR) = Return the first char of the String                     
  EXPLAIN: Return the first char of the string.                             
  NB.....: If the string is empty, return also a char ...                   
  SEEALSO: Str_C2S                                                          
 ͼ}
Function Str_S2C(St:String):Char;
Begin
Str_S2C:=St[1];                           {*Return result*}
End;

{ͻ
                              FUNCTION Str_C2S                              
 ͹
  IN.....: C (CHAR) = Char to convert in a string[1]                        
  OUT....: (STRING) = String result witch contain the only char C           
  EXPLAIN: Return a string witch contain 1 char : C                         
  SEEALSO: Str_S2C                                                          
 ͼ}
Function Str_C2S(C:Char):String;
Var St:String;
Begin
St:=' '; St[1]:=C;                        {*Fill St*}
Str_C2S:=St;
End;

{ͻ
                              FUNCTION Str_A2S                              
 ͹
  IN......: A : (ARRAY OF CHAR) = Array source.                             
            Max : (BYTE) = Number maximun of char of the array.             
  OUT.....: (STRING) = String result.                                       
  EXPLAIN.: Transform an array of char finished by a #0 in a pascal string  
  EXAMPLE.: Write(Str_A2S('toto'+#0+#0+'oi'));                              
            Show 'toto'                                                     
 ͼ}
Function Str_A2S(A:Array of Char;Max:Byte):String;
Var i:Integer;
    s:String;
Begin
i:=0;
s:='';
While (A[i]<>#0) And (i<=255) do
  Begin
  s:=s+A[i];
  Inc(i);
  End;
SetLength(s,Min(Max,Length(s)));
Str_A2S:=S;
End;

{ͻ
                             FUNCTION Str_Po2S                              
 ͹
  IN.....: P (POINTER) = Adress to put in format XXXX:XXXX in the string    
  OUT....: (STRING) = String result.                                        
  EXPLAIN: This function convert an address in a string format              
           (Hexadecimal).                                                   
  EXAMPLE: Str_Po2S(P) = '1C45:0060' for example                            
 ͼ}
Function Str_Po2S(p:pointer):String;
Begin
Str_Po2S:=Str_L2H(TPointer(P).Segment,4)+':'+Str_L2H(TPointer(P).Offset,4);
End;

{ͻ
                              FUNCTION Str_P2S                              
 ͹
  IN.....: P (POINTER) : pointer on a buffer.                               
           Size (BYTE) : Size of buffer.                                    
  OUT....: (STRING) : String result.                                        
  EXPLAIN: Convert a buffer to a string.                                    
 ͼ}
Function Str_P2S(P:Pointer;Size:Byte):String;
Var p_b:TPByte;
    i:integer;
    S:string;
Begin
SetLength(s,Size);
p_b:=p;
For i:=1 to Size do
  Begin
  S[i]:=chr(p_b^);
  inc(p_b);
  End;
Str_P2S:=S;
End;

{ͻ
                             PROCEDURE Str_S2P                              
 ͹
  IN.....: S (STRING) : String source.                                      
           P (POINTER) : pointer on a buffer.                               
           Size (BYTE) : size of this buffer.                               
  OUT....: /                                                                
  EXPLAIN: Copy a string to a buffer witch the adress is in P.              
  NB....1: If the string is < buffer, space complete the buffer.            
  NB....2: If the string is > buffer, string is cut to the size of buffer.  
 ͼ}
Procedure Str_S2P(S:String;P:Pointer;Size:Byte);
Var p_b:TPByte;
    i:integer;l:byte;
Begin
p_b:=p;
l:=length(S);
For i:=1 to Size do
  Begin
  If (i<=l) Then p_b^:=Ord(S[i]) Else p_b^:=$20; {*Spaces*}
  inc(p_b);
  End;
End;

{ͻ
                              FUNCTION Str_D2S                              
 ͹
  IN.....: Year  : (WORD) = Year                                            
           Month : (BYTE) = Month                                           
           Day   : (BYTE) = Day                                             
  OUT....: S : (STRING) = String result (AAAAMMJJ)                          
  EXPLAIN: Convert a date to a string like this : AAAAMMJJ                  
  EXAMPLE: Writeln(Str_D2S(1998,01,31));                                    
           Result : 19980131                                                
 ͼ}
Function Str_D2S(Year:Word;Month,Day:Byte):String;
Var S1:String[4];S:String[8];
    i:Byte;
Begin
Str(Year :4,S);
Str(Month:2,S1);
S:=concat(S,S1);
Str(Day  :2,S1);
S:=concat(S,S1);
For i:=1 to 8 do If S[i]=' ' Then S[i]:='0';
Str_D2S:=S;
End;

{ͻ
                              FUNCTION Str_S2D                              
 ͹
  IN.....: S : (STRING) = String to convert.                                
  OUT....: Year  : (WORD) = Year                                            
           Month : (BYTE) = Month                                           
           Day   : (BYTE) = Day                                             
           (BOOLEAN) = TRUE if all is OK, else FALSE.                       
  EXPLAIN: Transform a string (AAAAMMJJ) to 3 numbers.                      
  EXAMPLE: Var j,m:Byte;a:word;Res:Boolean                                  
           Res=Str_S2D('19980131',a,m,j)                                    
           Writeln('Transformation OK ? : ',Res);                           
           Writeln('Day : ',j',' Month : ',m,' Year : ',a);                 
 ͼ}
Function Str_S2D(S:String;Var Year:Word;Var Month,Day:Byte):Boolean;
Var S1,S2,S3:String[4];
    e:integer;
    Res:Boolean;
Begin
Res:=True;
If Length(S)<>8 Then Res:=False;
SetLength(S1,4); S1[1]:=S[1]; S1[2]:=S[2]; S1[3]:=S[3]; S1[4]:=S[4];
SetLength(S2,2); S2[1]:=S[5]; S2[2]:=S[6];
SetLength(S3,2); S3[1]:=S[7]; S3[2]:=S[8];
Val(S1,Year,e);
If e<>0 Then Res:=False;
Val(S2,Month,e);
If e<>0 Then Res:=False;
Val(S3,Day,e);
If e<>0 Then Res:=False;
Str_S2D:=Res;
End;

{ͻ
                             PROCEDURE STR_S2PC                             
 ͹
  IN.....: Dest : (PCHAR) = The variable witch will receive the result.     
           Source : (STRING) = String to convert.                           
  OUT....: Dest : (PCHAR) String converted.                                 
  EXPLAIN: This function convert string to Pchar (array of char with a #0   
           to end the string).                                              
  EXAMPLE: Var fn:Array[0..63]Of Char;                                      
               s:string;                                                    
           Begin                                                            
            Str_S2Pc(fn,s); (*String -->PChar*)                             
           End;                                                             
 ͼ}
Procedure Str_S2PC(Dest: PChar; Source: String);
Var i:integer;
    P:Pchar;
Begin
P:=Dest;
For i:=1 to Length(Source) do
  Begin
  P^:=Source[i];
  Inc(P);
  End;
P^:=#0;
End;

{ͻ
                              FUNCTION STR_S2H                              
 ͹
  IN.....: S (STRING) = Input string                                        
  OUT....: (STRING) = String result                                         
  EXPLAIN: Take each caracter of the string S, and return the hexadecimal   
           ascii code.                                                      
  EXAMPLE: Str_S2H('A0z') = '41 30 71'                                      
 ͼ}
Function Str_S2H(S:String):String;
Var St:String;
    i:Byte;
Begin
St:='';
For i:=1 to Length(S) do
  Begin
  St:=St+Str_L2H(Ord(S[i]),2)+' ';
  End;
If Length(St)>0 Then SetLength(St,Length(St)-1);  {*Delete last space*}
Str_S2H:=St;
End;

{ͻ
                            FUNCTION Str_Data2S                             
 ͹
  IN.....: P (POINTER) : Pointer on a buffer.                               
           Deb (INTEGER) : Where begin the extraction.                      
           The first byte is indexed 0.                                     
           Qt (INTEGER) : Quantity of bytes to copy.                       
  OUT....: (STRING) : String result.                                        
  EXPLAIN: Extract from an pointer a string. The value indexed at deb and   
           the last (deb+qtt) will be copied.                               
  EXAMPLE: If P^=  ABCDEFG                                                  
                   0123456 <- This is only an help to count.                
           Writeln(Str_Data2S(p,1,3));                                      
           Will write : BCD                                                 
 ͼ}
Function Str_Data2S(P:Pointer;Deb,Qte:Integer):String;
Var S:String;
    p2:^Char;
Begin
SetLength(s,qte);
p2:=p;
inc(p2,deb);
move(p2^,s[1],Qte); {*Copy i bytes ofthe pointer to the string*}
Str_Data2S:=S;
End;

{ͻ
                         FUNCTION STR_CORRECTCHARS                          
 ͹
  IN.....: Str (STRING) = Input String                                      
  OUT....: (STRING) = Outpur String                                         
  EXPLAIN: The String passed in parameter is analysed and unaccentuated.    
  NB.....: This char conversion concern french,spanish and english.         
  FROM...: Bilbo                                                            
 ͼ}
Function Str_CorrectChars(Str : String):String;
Var i:integer;
    Convert : string;
Begin
Convert:=Str;
For i:=1 TO Length(Convert) Do
Begin
 Case Convert[i] of
  #131..#134 : Convert[i]:='a';
  #160       : Convert[i]:='a';
  #135       : Convert[i]:='c';
  #130       : Convert[i]:='e';
  #136..#138 : Convert[i]:='e';
  #139..#141 : Convert[i]:='i';
  #161       : Convert[i]:='i';
  #164       : Convert[i]:='n';
  #147..#149 : Convert[i]:='o';
  #162       : Convert[i]:='o';
  #129       : Convert[i]:='u';
  #150..#151 : Convert[i]:='u';
  #163       : Convert[i]:='u';
  #152       : Convert[i]:='y';
  End;
End;
Str_CorrectChars:=Convert;
END;

{ͻ
                          FUNCTION Str_Palindrome                           
 ͹
  IN.....: St (STRING) = Input String                                       
  OUT....: (STRING) = String result                                         
  EXPLAIN: Transform a string his reverse string :                          
  EXAMPLE: Writeln('toto') = 'otot'                                         
           Writeln('1234') = '4321'                                         
           Writeln('integer') = 'regeteni'                                  
 ͼ}
Function Str_Palindrome(St:String):String;
Var St2:String;
    i:Byte;
Begin
SetLength(St2,Length(St));
For i:=1 to Length(St) do St2[Length(St)-i+1]:=St[i];
Str_Palindrome:=St2;
End;

{ͻ
                              FUNCTION STR_S2B                              
 ͹
  IN.....: S (STRING) = Input String                                        
  OUT....: (BOOLEAN) = If S='TRUE' this return TRUE else return FALSE       
  EXPLAIN: Transform a string to a boolean                                  
  EXAMPLE: Writeln(Str_S2B('True'));  = TRUE                                
           Writeln(Str_S2B('False')); = FALSE                               
           Writeln(Str_S2B('Toto'));  = FALSE                               
  SEEALSO: Str_B2S                                                          
 ͼ}
Function Str_S2B(S:String):Boolean;
Begin
If  Upper(S)='TRUE' Then Str_S2B:=True
                    Else Str_S2B:=False;
End;

{ͻ
                              FUNCTION STR_B2S                              
 ͹
  IN.....: B (BOOLEAN) = Input flag                                         
  OUT....: (STRING) = 'TRUE' if B=TRUE else return 'FALSE'                  
  EXPLAIN: Transform a boolean in string                                    
  EXAMPLE: Writeln(Str_B2S(True));  = 'TRUE'                                
           Writeln(Str_B2S(False)); = 'FALSE'                               
  SEEALSO: Str_S2B                                                          
 ͼ}
Function Str_B2S(B:Boolean):String;
Begin
If B Then Str_B2S:='TRUE'
     Else Str_B2S:='FALSE';
End;

{ͻ
                          FUNCTION STR_TestBoolean                          
 ͹
  IN.....: S (STRING) = Input string                                        
  OUT....: (BOOLEAN) = TRUE if the string is a boolean.                     
  EXPLAIN: Test if the string is or not a boolean.                          
  EXAMPLE: Writeln(Str_TestBoolean('True'));     = TRUE                     
           Writeln(Str_TestBoolean('FALSE'));    = TRUE                     
           Writeln(Str_TestBoolean('Toto'));     = FALSE                    
  SEEALSO: Str_S2B                                                          
 ͼ}

Function Str_TestBoolean(S:String):Boolean;
Begin
Str_TestBoolean:=(Upper(S)='TRUE') Or (Upper(S)='FALSE');
End;

{ͻ
                              FUNCTION STR_I2S                              
 ͹
  IN.....: Value (LONGINT) = Input value as longint.                        
  OUT....: Result (STRING) = The value as string.                           
  EXPLAIN: Convert an integer to a string.                                  
           If an error occurs the returned value is ''.                     
  EXAMPLE: Writeln(Str_I2S(6));                                             
  SEEALSO: Str_S2I                                                          
 ͼ}

Function Str_I2S(Value:Longint):String;
Var St:String;
Begin
   Try
      Str(Value,St);
      Result := St;
   Except
      Result := '';
   End;
End;

{ͻ
                              FUNCTION STR_S2I                              
 ͹
  IN.....: Value (STRING) = Input value as string.                          
  OUT....: Result (LONGINT) = The value.                                    
  EXPLAIN: Convert a string to an integer.                                  
           If an error occurs the returned value is -1.                     
  EXAMPLE: Writeln(Str_S2I('6'));                                           
  SEEALSO: Str_I2S                                                          
 ͼ}

Function Str_S2I(Value:String):Longint;
Var Code   :Word;
    ValTmp :Longint;
Begin
   Try
      Val(Value,ValTmp,Code);
      If Code = 0 Then Result := ValTmp
                  Else Result := -1;
   Except
      Result := -1;
   End;
End;

{*--------------------------- Base convertion ------------------------------*}

{ͻ
                           FUNCTION Str_CheckBase                           
 ͹
  IN.....: St : (STRING) = Number in a base between 2..36                   
           Base : (BYTE) = Base                                             
  OUT....: (BOOLEAN) : True  = The number St is correct in this base        
                       False = The number St contain incorrect char to be   
                               in this base.                                
  EXPLAIN: Test if a number is in the correct base, and so if it can be     
           converted.                                                       
  EXAMPLE: Str_CheckBase('-123',10) = TRUE                                  
           Str_CheckBase('A123',10) = FALSE                                 
           Str_CheckBase('F1A3',16) = TRUE                                  
 ͼ}
Function Str_CheckBase(St:String;Base:Byte):Boolean;
Var i, Cpt : Byte;
    Chiffres : String;
Begin
St:=Upper(St);
If St[1]='-' Then St:=Copy(St,2,Length(St));
Chiffres:='0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
Cpt:=0;
For i:=1 To Length(St) Do
  If (POS(St[i],Chiffres)>Base) Or (POS(St[i],Chiffres)=0) Then INC(Cpt);
If Cpt>0 Then Str_CheckBase:=FALSE
Else Str_CheckBase:=TRUE
End;

{ͻ
                            FUNCTION STR_BASE2L                             
 ͹
  IN.....: St : (STRING) = Number in a base between 2..36                   
           Base : (Byte) = Base                                             
  OUT....: (LONGINT) : Number St (in base Base) converted in longint.       
  EXPLAIN: Convert a number exprimed in a base <> of base 10 to a longint   
           which is independant of any base choosen.                        
  EXAMPLE: Str_Base2L('-123',10) = -123                                     
           Str_Base2L('-123',16) = -291                                     
           Str_Base2L('FF',16)   = 255                                      
  NB.....: The number must be correct, you can check it with Str_CheckBase. 
 ͼ}
Function Str_Base2L(St:String;Base:Byte):Longint;
Var i   : Byte;
    B10 : Longint;
    Chiffres : String;
Begin
If St[1]='-' Then
  Begin
  Str_Base2L:=-1*Str_Base2L(Copy(St,2,Length(St)),Base);
  Exit;
  End;

Chiffres:='0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
B10:=0;
For i:=1 To Length(St) Do
  B10:=B10*Base+POS(St[i],Chiffres)-1;
Str_Base2L:=B10
End;

{ͻ
                            FUNCTION STR_L2BASE                             
 ͹
  IN.....: N : (LONGINT) = Number                                           
           Base : (Byte) = Base                                             
  OUT....: (STRING) = Number converted in the correct base.                 
  EXPLAIN: Convert a number N, a longint to a choosen base. Typicaly <> of  
           base 10 because str make this work for base 10.                  
  EXAMPLE: Str_L2Base(123,16)   =  '7B'                                     
           Str_L2Base(-123,16)  =  '-7B'                                    
           Str_L2Base(123,10)   =  '123'                                    
 ͼ}
Function Str_L2Base(N:Longint;Base:Byte):String;
Var i : Byte;
    B,Chiffres : String;
Begin
If N<0 Then
  Begin
  Str_L2Base:='-'+Str_L2Base(-1*N,Base);
  Exit;
  End;

Chiffres:='0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
B:='';
While not (N=0) Do
  Begin
  i:=N mod Base;
  B:=Chiffres[i+1]+B;
  N:=N div Base
  End;
Str_L2Base:=B;
End;

{ͻ
                              FUNCTION STR_L2H                              
 ͹
  IN.....: L : (LONGINT) = Number to convert in Hexadecimal.                
           Format : (BYTE) = Number of character the number must take       
                             (Completed with 0)                             
  OUT....: (STRING) : String Result.                                        
  EXPLAIN: Convert a number L, a longint to a string witch represent the    
           same number but in Hexadecimal Base.                             
  EXAMPLE: Writeln(str_l2h(100,0)); = 64                                    
           Writeln(str_l2h(100,1)); = 64                                    
           Writeln(str_l2h(100,4)); = 0064                                  
  NB 1...: If the number take more char than specified in Format, all the   
           number is writen, so the size of the string result > Format...   
  NB 2...: If you don't want any 0 before the number, use Format=0.         
 ͼ}
Function Str_L2H(L:Longint;Format:Byte):String;
Var S,S2:String;
    i:byte;
Begin
SetLength(S,Format);
For i:=1 to Format do S[i]:='0';
S2:=Str_L2Base(L,16);
If Length(S2)>=Format Then S:=S2
Else For i:=1 to Length(S2) do S[Format-Length(S2)+i]:=S2[i];
Str_L2H:=S;
End;

{ͻ
                              FUNCTION Str_H2L                              
 ͹
  IN.....: S (STRING) = Number in hexadecimal to convert to longint.        
  OUT....: (LONGINT) = Result.                                              
  EXPLAIN: Convert an hexadecimal number (S) to a normal longint.           
  EXAMPLE: Writeln(Str_H2L('F6A'));                                         
  NB.....: Return -1 if illegal characters found.                           
 ͼ}

Function Str_H2L(S:String):Longint;
Begin
If Str_CheckBase(S,16) Then Str_H2L:=STR_Base2L(S,16)
   Else Str_H2L:=-1; {*Returns -1 if illegal characters found*}
End;

{ͻ
                              FUNCTION Str_S2L                              
 ͹
  IN.....: S (STRING) = Number in decimal to convert to longint.            
  OUT....: (LONGINT) = Result.                                              
  EXPLAIN: Convert an decimal number (S) to a normal longint.               
  EXAMPLE: Writeln(Str_S2L('165')); = 165                                   
  NB.....: Return -1 if illegal characters found.                           
 ͼ}
Function  Str_S2L(S:String):Longint;                {*Convert Decimal String to longint*}
Begin
If Str_CheckBase(S,10) Then Str_S2L:=STR_Base2L(S,10)
   Else Str_S2L:=-1; {*Returns -1 if illegal characters found*}
End;

{ͻ
                              FUNCTION Str_L2S                              
 ͹
  IN.....: L (LONGINT) = Number in decimal to convert to string             
  OUT....: (STRING) = Result.                                               
  EXPLAIN: Convert an decimal number in the same number but in a string     
  EXAMPLE: Writeln(Str_S2L(168)); = '168'                                   
 ͼ}
Function Str_L2S(L:Longint):String;
Var S:String;
Begin
Str(L,S);
Str_L2S:=S;
End;

{*------------------------------ Cryptage ----------------------------------*}

{ͻ
                             FUNCTION Str_Crypt                             
 ͹
  IN.....: Phr (STRING) = Sentence to Str_Crypt                             
           Clef (BYTE) = Key for the Str_Crypt.                             
  OUT....: Res (STRING) = Cypted sentence.                                  
  EXPLAIN: Str_Crypt / Uncrypt a sentence with a crypt key                  
 ͼ}
Function Str_Crypt(Phr:String; Clef:Byte):String;    {*Cryp & Uncrypt String*}
Var Ph2:String;
    A:Integer;
    R:Byte;

Begin
Ph2:='';
For A:=1 To Length(Phr) Do Begin
    R:=Clef Xor Ord(Phr[A]);
    Ph2:=Ph2+Char(R);
    End;
Str_Crypt:=Ph2;
End;

{ͻ
                          FUNCTION Str_GetCryptKey                          
 ͹
  IN.....: Phr (STRING) = Sentence witch we want the key.                   
  OUT....: Res (BYTE) = Key  (0 <-> 255).                                   
  EXPLAIN: Generate a Key (BYTE) associated to the string.                  
 ͼ}

Function Str_GetCryptKey(Phr:String):Byte;
Var L,Clef:Integer;
Begin
L:=Length(Phr)+10;                          {*Dcalage + 10 Sinon, pas Homogne*}
Clef:=Round((255 Mod L)*(255 div L));
If Clef=0 Then Clef:=1;
Str_GetCryptKey:=Clef;                             {*Renvois la Clef Calcule...*}
End;

{*--------------------------- Miscellaneous --------------------------------*}

{ͻ
                          FUNCTION STR_CLEANSPACES                          
 ͹
  IN.....: S (STRING) = String input                                        
  OUT....: (STRING) = String result                                         
  EXPLAIN: Keep only one spaces between each word, and delete the spaces at 
           the begining or the end of the string.                           
  EXAMPLE: Str_CleanSpaces('  toto  is    here   ') = 'toto is here'        
 ͼ}
Function Str_CleanSpaces(S:String):String;
Var i:Byte;
    B:Boolean;
Begin
i:=1;
B:=True;
While i<=Length(S) do
  Begin
  If (S[i]=' ') And B Then Delete(S,i,1)
  Else If S[i]=' ' Then
    Begin
    B:=True;
    Inc(i);
    End
  Else
    Begin
    B:=False;
    Inc(i);
    End;
  End;
If S[Length(S)]=' ' Then SetLength(S,Length(S)-1);
Str_CleanSpaces:=S;
End;

{ͻ
                              FUNCTION Str_Trim                             
 ͹
  IN.....: S (STRING) = String source.                                      
  OUT....: Result (STRING) = String without spaces.                         
  EXPLAIN: Delete all spaces before and after the string.                   
 ͼ}

Function Str_Trim(Const S:String):String;
Var
  I, L: Integer;

Begin
  L := Length(S);
  I := 1;
  while (I <= L) and (S[I] <= ' ') do Inc(I);
  if I > L then Result := '' else
  begin
    while S[L] <= ' ' do Dec(L);
    Result := Copy(S, I, L - I + 1);
  end;
End;

{ͻ
                             FUNCTION Str_Fill                              
 ͹
  IN.....: S : (STRING) = String source.                                    
           Taille : (INTEGER) = Size of the string with the spaces they     
                    will be insert.                                         
           Sens : (BYTE) = 0 : Insert before the string                     
                           1 : Insert after the string                      
  OUT....: (STRING) = String result.                                        
  EXPLAIN: Complete a string with spaces.                                   
  EXAMPLE: Str_Fill('toto',8,0) = '    toto'                                
           Str_Fill('toto',8,1) = 'toto    '                                
           Str_Fill('toto',3,0) = 'oto'                                     
           Str_Fill('toto',3,1) = 'tot'                                     
 ͼ}
Function Str_Fill(s:string;taille:integer;Sens:Byte):string;
Var i:integer;
    s2:string;
Begin
SetLength(S2,Taille);
For i:=1 to 255 do s2[i]:=' ';
If Sens=0 Then {Before}
  Begin
  For i:=Taille downto Max(1,Taille-Ord(Length(s))+1) do S2[i]:=S[i-Taille+Ord(length(s))];
  End
Else           {After sens=1}
  Begin
  SetLength(s2,Taille);
  For i:=1 to Length(s) do S2[i]:=S[i];
  End;

Str_Fill:=s2;
End;

{ͻ
                            FUNCTION Str_Spaces                             
 ͹
  IN.....: N (BYTE) = Number of spaces to put                               
  OUT....: (STRING) = return N spaces ' '                                   
  EXPLAIN: This function return a string with N spaces.                     
  EXAMPLE: Writeln(Str_Spaces(3)); = '   ';                                 
 ͼ}
Function Str_Spaces(N:Byte):String;              {*Return N spaces string*}
Var i:Integer;
    St:String;
Begin
St:='';
For i:=1 to N do St:=St+' ';
Str_Spaces:=St;
End;

{ͻ
                             FUNCTION Str_clear                             
 ͹
  IN.....: s : (STRING) = String source.                                    
  OUT....: (STRING) = Substring extracted.                                  
  EXPLAIN: Delete all the spaces before and after the string.               
  EXAMPLE: Str_clear('  toto   est ici  ') = 'toto   est ici'               
           Str_clear('     99         ')   = '99'                           
 ͼ}
Function Str_clear(s:String):String;
Var s2:String;
    i:integer;
Begin
i:=1;
While s[i]=' ' do inc(i);
s2:=copy(s,i,length(s));
i:=length(s2);
While s2[i]=' ' do dec(i);
s2:=copy(s2,1,i);
Str_clear:=s2;
End;

{*----------------------------- Extraction ---------------------------------*}

{ͻ
                            FUNCTION STR_EXTRACT                            
 ͹
  IN.....: S (STRING) = String input                                        
           S1 (STRING) = First item witch indicate the beginning of the copy
           S2 (STRING) = Last item witch indicate the end of the copy       
  OUT....: (STRING) = The substring witch is between S1 and S2              
  EXPLAIN: Extract the substring witch is between the 2 items S1 and S2     
  EXAMPLE: Str_Extract('toto (* and me*) was here','(*','*)') = ' and me'   
 ͼ}

Function Str_Extract(S,S1,S2:String):String;
Var i:Integer;
    b:boolean;
    St:String;
Begin
St:='';
i:=1;
b:=false;
While i<=Length(S) do
  Begin
  If not b And Str_TestPos(S,S1,i) Then

    Begin
    B:=True;
    i:=i+length(S1);
    End;
  If b And Str_TestPos(S,S2,i) Then
    Begin
    B:=False;
    i:=i+length(S2);
    End;
  If b then St:=St+S[i];
  Inc(i);
  End;
Str_Extract:=St;
End;

{ͻ
                          FUNCTION STR_EXTRACTEMAIL                         
 ͹
  IN.....: S (STRING) = String input                                        
  OUT....: (STRING) = The email.                                            
  EXPLAIN: Extract an Email in a phrase.                                    
 ͼ}

Function Str_ExtractEmail(aEmail:String):String;
Var StLeft  :String;
    StRight :String;
    PArobas :Integer;
    A       :Integer;

Begin
   Result  := '';

   PArobas := Pos('@',aEmail);
   If pArobas = 0 Then Exit;   // No Email address in this string !

   StLeft  := Copy(aEmail, 1, PArobas - 1);
   StRight := Copy(aEmail, PArobas + 1, 65535);

   For A := Length(StLeft) Downto 1 do
   Begin
      If StLeft[A] In [' ','/','\','=',',',';',':','<','>'] Then
      Begin
         StLeft := Copy(StLeft,A + 1,65535);
         Break;
      End;
   End;

   For A := 1 to Length(StRight) do
   Begin
      If StRight[A] In [' ','/','\','=',',',';',':','<','>'] Then
      Begin
         StRight := Copy(StRight,1,A - 1);
         Break;
      End;
   End;

   Result := Str_Trim(StLeft) + '@' + Str_Trim(StRight); // Return the result
End;

{ͻ
                              FUNCTION STR_INT                              
 ͹
  IN.....: S (STRING) = String where the extract must begin                 
           Pos (BYTE) = Position where begin the extraction                 
  OUT....: (LONGINT) = Return number extracted.                             
                       If at the position there is no number, return 0      
  EXPLAIN: Get a number at a position from a string.                        
 ͼ}
Function Str_Int(S:String;Pos:Byte):LongInt;
Var S2:String;
    i:byte;l:longint;
    e:integer;
Begin
Str_Int:=0;l:=0;
S2:='';
i:=Pos;
If (S[Pos]='-') And (Length(S)>Pos) Then
  Begin
  S2:=S2+S[i];
  Inc(i);
  End;

While (S[i] in ['0'..'9']) And (i<=Length(S)) do
  Begin
  S2:=S2+S[i];
  Inc(i);
  End;
Val(S2,l,e);

Str_Int:=l;
End;

{*--------------------- MODIFICATION / DESTRUCTIVE --------------------------------*}

{ͻ
                            FUNCTION Str_DelSub                             
 ͹
  IN.....: Main (STRING) = Source string                                    
           Sub (STRING) = Substring to delete in Main                       
  OUT....: (STRING) = Result sring                                          
  EXPLAIN: This function return a string without the any occurence of sub...
 ͼ}
Function Str_DelSub(Main,Sub:String):String;
Var P:Integer;
Begin
While Pos(Sub,Main)>0 do
   Begin
   P:=Pos(Sub,Main);
   Delete(Main,P,Length(Sub));
   End;
Str_DelSub:=Main;
End;

{ͻ
                              FUNCTION STR_CUT                              
 ͹
  IN.....: S (STRING) = Substring to cut                                    
           Sub (STRING) = SubString witch decide the begin or end of the cut
           Flg (BYTE) =                                                     
           Bit  Num  Action if the bit is set :                             
            0   01   Begin the cut at Sub else End the cut at Sub           
            1   02   If there is more than 1 SubString in the string        
                     Use first, else the last                               
  OUT....: (STRING) = Get a part of the string                              
  EXPLAIN: Cut a part of the string                                         
  EXAMPLE: Str_Cut('toto(*is(*here','(*',0) = 'here'                        
           Str_Cut('toto(*is(*here','(*',1) = 'toto(*is'                    
           Str_Cut('toto(*is(*here','(*',2) = 'is(*here'                    
           Str_Cut('toto(*is(*here','(*',3) = 'toto'                        
 ͼ}
Function Str_Cut(S,Sub:String;Flg:Byte):String;
Begin
  Case Flg of
    0:Str_Cut:=Copy(S,Str_LastPos(Sub,S)+Length(Sub),Length(S));
    1:Str_Cut:=Copy(S,1,Str_LastPos(Sub,S)-1);
    2:Str_Cut:=Copy(S,Pos(Sub,S)+Length(Sub),Length(S));
    3:Str_Cut:=Copy(S,1,Pos(Sub,S)-1);
  End;
End;

{ͻ
                             FUNCTION STR_SUPPR                             
 ͹
  IN.....: S (STRING) = String to process                                   
           S1 (STRING) = First item witch indicate the beginning of the cut 
           S2 (STRING) = Last item witch indicate the end of the cut        
  OUT....: (STRING) = String result                                         
  EXPLAIN: Cut S between S1 and S2.                                         
  EXAMPLE: Str_Suppr('readkey; (* read a key *)','(*','*)') = 'readkey; '.  
           Str_Suppr('abc(*def*)ghi(*jkl*)','(*','*)') = 'abcghi'.          
           Str_Suppr('abc*)def(*ghi*)j(*kl','(*','*)') = 'abc*)defj(*kl'.   
 ͼ}
Function Str_Suppr(S,S1,S2:String):String;
Var B:Boolean;
    I:Byte;
    R:String;
Begin
If (Pos(S1,S)=0) And (Pos(S2,S)=0) Then
  Begin
  Str_Suppr:=S;
  Exit;
  End;

B:=False;
R:='';
i:=1;
While i<=Length(S) do
  Begin
  If Str_TestPos(S,S1,i) Then B:=True;
  If Str_TestPos(S,S2,i) And B Then
    Begin
    i:=i+Length(S2);
    If i>Length(S) Then Break;
    B:=False;
    End;
  If Not B Or (Str_LastPos(S2,S)<i) Then R:=R+S[i];
  Inc(I);
  End;
Str_Suppr:=R;
End;

{ͻ
                            FUNCTION STR_REPLACE                            
 ͹
  IN.....: S (STRING) = Source string.                                      
           Sub (STRING) = Substring of S witch the function must replace    
           Rep (STRING) = String witch contain the replacement of Sub       
           Mode (WORD) =                                                    
            Bit  Num                                                        
             0   0001  Replace is case sensitive.                           
             1   0002                                                       
  OUT....: (STRING) = String result.                                        
  EXPLAIN: This function replace a substring in the source string by the    
           rep string.                                                      
  EXAMPLE: Str_Replace('%1 toto %1','%1','t')  =  't toto t'                
 ͼ}
Function Str_Replace(S,Sub,Rep:String;Mode:Word):String;
Var P:Word;
Begin
If BTST(Mode,0) Then P:=Pos(Sub,S) Else P:=Pos(Upper(Sub),Upper(S));

If P=0 Then
  Begin
  Str_Replace:=S;
  Exit;
  End;
Str_Replace:=Copy(S,1,P-1)+Rep
             +Str_Replace(Copy(S,P+Length(Sub),Length(S)),Sub,Rep,Mode);
End;

{ͻ
                            FUNCTION STR_CENTER                             
 ͹
  IN.....: S (STRING) = Main string.                                        
           Sub (STRING = SubString to copy on S but centered.               
  OUT....: /                                                                
  EXPLAIN: Copy Sub in the center of the string S.                          
  EXAMPLE: Writeln(Str_Center('1 3 5 7 9','ABC') = '1 3ABC7 9'              
  BUG....: Length(S) must be > Length(Sub)                                  
 ͼ}
Function Str_Center(S:String; Sub:String):String;
Var i:Byte;
Begin
For i:=1 to Length(Sub) do
  Begin
  S[((Length(S)-Length(Sub)) div 2)+i]:=Sub[i];
  End;
Str_Center:=S;
End;

{ͻ
                       FUNCTION Str_FilenameCaracters                       
 ͹
  IN.....: StIn (STRING) = String to modify.                                
           Rep (STRING) = String to be used to replace.                     
  OUT....: (STRING) = Returned string.                                      
  EXPLAIN: Test the string for valid caracters used in filenames.           
           If the string contain invalid caracters, they will be            
           replaced by the "Rep" string.                                    
 ͼ}

Function Str_FilenameCaracters(StIn,Rep:String):String;
Const MaxChar=9;
      AC:Array[1..MaxChar] of Char=('/','\',':','*','?','"','<','>','|');
Var A:Integer;
Begin
For A:=1 to MaxChar do StIn:=Str_Replace(StIn,AC[A],Rep,0);
Str_FilenameCaracters:=StIn;
End;

{ͻ
                           FUNCTION Str_Multiply                            
 ͹
  IN.....: St (STRING) = String to multiply.                                
           Count (BYTE) = How much time to multiply.                        
  OUT....: (STRING) = Returned string.                                      
  EXPLAIN: Multiply 'Count' time the St string.                             
 ͼ}

Function Str_Multiply(St:String; Count:Byte):String;{*Multiply and return the string*}
Var A:Integer;
    Res:String;
Begin
Res:='';
For A:=1 to Count do Res:=Res+St;
Str_Multiply:=Res;
End;

{*------------------------------- Words ------------------------------------*}

{ͻ
                        FUNCTION STR_TESTFRENCHCHAR                         
 ͹
  IN.....: C (CHAR) = Character to test.                                    
  OUT....: (BOOLEAN) = Return if C is an ASCII char.                        
  EXPLAIN: If C = 'A'..'Z' or 'a'..'z' or '0'..'9' or '' or '' or '' or  
              '' then return true, else return false.                      
           All this caracters could make a word.                            
  EXAMPLE: Writeln(Str_TestFrenchChar('A')) = TRUE                          
           Writeln(Str_TestFrenchChar('[')) = FALSE                         
 ͼ}
Function Str_TestFrenchChar(C:Char):Boolean;
Begin
Str_TestFrenchChar:= ((Upcase(C) in ['A'..'Z']) Or (C='_')
                     Or (C in ['0'..'9']) Or (C='') Or (C='') Or (C='')
                     Or (C=''))
End;

{ͻ
                            FUNCTION STR_GETTOCKEN                          
 ͹
  IN.....: aToken (String) = Token to search in phrase.                     
         : aInput (String) = Source phrase.                                 
  OUT....: Result (Integer) = Index of the token in phrase.                 
  EXPLAIN: Search for the specified token in the phrase.                    
           If the tocken is not found the function return -1;               
  NB.....: The function is not case sensitive.                              
  EXAMPLE: If Str_GetToken('to','Else to: the top') Then...                 
           Return 6 as token index in phrase.                               
 ͼ}
Function Str_GetToken(aToken,aInput:String):Integer;{*Extract a token from a phrase*}
Var StCheck  :String;
    IndexT   :Integer;
    NewIndexT:Integer;
    LeftOk   :Boolean;
    RightOk  :Boolean;

Begin
   Result  := -1;
   StCheck := Upper(aInput);   // To avoid case sensitive problems...
   aToken  := Upper(aToken);
   IndexT  := 0;
//Writeln('"',aInput,'"');

   Repeat
      // Get the index of the presumed token in string
      // and add the current index to previous index
      // to get the TRUE index...
      NewIndexT := Pos(aToken, StCheck);
      IndexT := IndexT + NewIndexT;
{Writeln('IndexT    = ',IndexT);
Writeln('NewIndexT = ',NewIndexT);
Writeln('Length(aToken) = ',Length(aToken));}

      If NewIndexT = 0 Then Exit; // No token found...

      LeftOk  := FALSE;        // Initialisations
      RightOK := FALSE;

      If IndexT = 1 Then LeftOk := TRUE; // It's the first char of the phrase
//Writeln('LeftOk (Limit) = ',LeftOk);
      If IndexT > 1 Then
      Begin
//Writeln('PrevChar = "',aInput[IndexT - 1], '"');
         If Not (aInput[IndexT - 1] in ['a'..'z','A'..'Z','0'..'9']) Then LeftOk := TRUE;
      End;
//Writeln('LeftOk = ',LeftOk);

      If NewIndexT + Length(aToken) - 1 = Length(StCheck) Then RightOk := TRUE; // It's the last char of the phrase
//Writeln('Length Check = ',NewIndexT + Length(aToken) -1, '/',Length(StCheck));
//Writeln('RightOk (Limit) = ',RightOk);
      If Not RightOk Then
      Begin
//Writeln('NextChar = "',aInput[IndexT + Length(aToken)], '"');
         If Not (aInput[IndexT + Length(aToken)] in ['a'..'z','A'..'Z','0'..'9']) Then RightOk := TRUE;
      End;
//Writeln('RightOk = ',RightOk);

      If (LeftOk) And (RightOk) Then
      Begin               // All is Ok. The token has been found...
//Writeln('Found !');
         Result := IndexT;
         Exit;
      End;

      StCheck := Copy(StCheck,NewIndexT + 1, 65535); // Remove the first part...
{Writeln('NewStCheck = ',StCheck);
Writeln;
Readln;}
   Until FALSE;
End;

{ͻ
                          FUNCTION STR_COUNTWORDS                           
 ͹
  IN.....: S (STRING) = String witch contain a sentence.                    
  OUT....: (BYTE) = Number of words in this string.                         
  EXPLAIN: Count the number of word in the string.                          
 ͼ}
Function Str_CountWords(S:String):Byte;
Var i,Count  : Byte;
    BW,OldBW : Boolean;
Begin
Count:=0;
BW:=False;
For i:=1 to Length(S) do
  Begin
  OldBW:=BW;
  If Str_TestFrenchChar(S[i]) Then
  BW:=True Else BW:=False;
  If (BW<>OldBW) And BW Then Count:=Count+1;
  End;
Str_CountWords:=Count;
End;

{ͻ
                          FUNCTION STR_GETWORDNUM                           
 ͹
  IN.....: S (STRING) = String witch contain a sentence.                    
           Num (BYTE) = N of the word to get.                              
  OUT....: (STRING) = Word number Num.                                      
  EXPLAIN: Get the "Num"'th word.                                           
 ͼ}
Function Str_GetWordNum(S:String;Num:Byte):String;
Var i,Count:byte;
    BW,OldBW:Boolean;
    S2:String;
Begin
Count:=0;
BW:=False;S2:='';
For i:=1 to Length(S) do
  Begin
  OldBW:=BW;
  If Str_TestFrenchChar(S[i]) Then
  BW:=True Else BW:=False;
  If (BW<>OldBW) And BW Then Count:=Count+1;
  If (Num=Count) And BW Then S2:=S2+S[i];
  End;
Str_GetWordNum:=S2;
End;

{ͻ
                            FUNCTION STR_GETWORD                            
 ͹
  IN.....: S (STRING) = A string witch contain a sentence.                  
           Pos (BYTE) = Position where to begin the extraction of the word  
  OUT....: (STRING) = String result.                                        
  EXPLAIN: Extract a word witch we know the position from a string.         
  EXAMPLE: Writeln(Str_GetWord('toto is here',9))  = 'here'                 
           Writeln(Str_GetWord('toto is here',10)) = 'ere'                  
           Writeln(Str_GetWord('MosStrings',1))       = 'MosStrings'              
 ͼ}
Function Str_GetWord(S:String;Pos:Byte):String;
Var i:Byte;
    S2:String;
    L:Word;
Begin
S2:='';
i:=Pos;
L:=Length(S);
While Str_TestFrenchChar(S[i]) And (i<=L) do
  Begin
  S2:=S2+S[i];
  Inc(i);
  End;
Str_GetWord:=S2;
End;

{*------------------------- Get Information --------------------------------*}

{ͻ
                            FUNCTION Str_LastPos                            
 ͹
  IN.....: Substr : (STRING) = Substring to search in the String S          
           S : (STRING) = String where the search is made                   
  OUT....: (BYTE) = Position of the last substring found in S.              
  EXPLAIN: Str_Pos_Last Searches for Substr within S and returns an integer 
           value that is the index of last character of Substr within S.    
           If Substr is not found, Str_Pos_Last returns zero.               
           This function is like pascal Pos but it takes the last substring 
           found.                                                           
  EXAMPLE: Str_LastPos('to','toto') = 3                                     
           Str_LastPos('to','titi') = 0                                     
           Str_LastPos('to','toto is toto') = 11                            
 ͼ}
Function Str_LastPos(Substr: String; S: String): Byte;
Var i,j:byte;
Begin
i:=0;
while Pos(Substr,S)> 0 do
  Begin
  j:=Pos(Substr,S);
  i:=i+j;
  S:=Copy(S,j+1,Length(S));
  End;
Str_LastPos:=i;
End;

{ͻ
                            FUNCTION STR_TESTPOS                            
 ͹
  IN.....: S (STRING) = String to test if the sub string is on position I   
           Sub (STRING) = SubString                                         
           I (BYTE) = Exact position where to search if Sub is in S         
  OUT....: (BOOLEAN) = TRUE if Sub is at the position i in the string S     
  EXPLAIN: Test if the substring is at the position i in S.                 
  EXAMPLE: Str_TestPos('toto','to',3)= TRUE                                 
           Str_TestPos('toto','to',2)= FALSE                                
 ͼ}
Function Str_TestPos(S,Sub:String;i:Byte):Boolean;
Begin
Str_TestPos:=(Pos(Sub,Copy(S,i,Length(S)))=1);
End;

{ͻ
                           FUNCTION STR_COUNTITEM                           
 ͹
  IN.....: S (STRING) = String                                              
           SubSt (STRING)= SubString witch contain the the item to search   
  OUT....: (BYTE) = Number of SubStr found in S.                            
  EXPLAIN: Count how many times the string S contains the SubString SubSt   
  EXAMPLE: Str_CountItem('toto is here, isn't he ?','is') = 2               
           Str_CountItem('12341512','12')   = 2                             
           Str_CountItem('totototo','toto') = 2                             
 ͼ}
Function Str_CountItem(S,SubSt:String):Byte;
Begin
If Pos(SubSt,S)=0 Then Begin Str_CountItem:=0;Exit; End;
Str_CountItem:=1+Str_CountItem(Copy(S,Pos(SubSt,S)+Length(SubSt),Length(S)),SubSt);
End;

{*----------------------------- Format -------------------------------------*}

{ͻ
                           FUNCTION Str_FillZero                            
 ͹
  IN.....: W (LONGINT) = The value.                                         
           Num (WORD) = Number of characters the string will be long        
                        (Completed by 0).                                   
  OUT....: (STRING) = Return the string completed.                          
  EXPLAIN: Return a string completed with Zeros before if needs.            
  EXAMPLE: Str_FillZero(5,2) = '05'                                         
           Str_FillZero(55,2) = '55'                                        
           Str_FillZero(5,5) = '00005'                                      
 ͼ}
Function Str_FillZero(W:Longint; Num:Byte):String;
Var S:String;
    i:byte;
Begin
Str(W:0,S);

If Length(S)<Num Then
  For i:=1 to Num-Length(S) do S:='0'+S;

Str_FillZero:=S;
End;

{ͻ
                            FUNCTION Str_Format                             
 ͹
  IN.....: StIn (STRING) = String source.                                   
           Sep (Char) = Separator of blocks                                 
           Block (Byte) = size of the blocks (in number of char).           
  OUT....: StOut (STRING) = String Formated.                                
  EXPLAIN: Format a string this the parameters.                             
  EXAMPLE: '0123456789' with Sparator  '.' and blocks of 3 :               
           '0.123.456.789'                                                  
 ͼ}
Function Str_Format(StIn:String; Sep:Char; Block:Byte):String;
Var St,St1:String;

Begin
St1:=StIn; St:='';
Repeat                                  {*Formate la Chane de Caractres*}
   St:=Sep+Copy(St1,Length(St1)-(Block-1),Block)+St;
   St1:=Copy(St1,1,Length(St1)-Block);
Until Length(St1)<=0;
Str_Format:=Copy(St,2,Length(St)-1);    {*Renvois Rsultat*}
End;

{*--------------------------- Miscellaneous --------------------------------*}

{ͻ
                             FUNCTION Str_Mask                              
 ͹
  IN.....: StIn (STRING) = String source.                                   
           Sep (Char)  = Sparator of blocks.                               
           Base (Char) = Basic Char.                                        
  OUT....: StOut (STRING) = Mask of the string.                             
  EXPLAIN: Create a mask for a string.                                      
  EXAMPLE: '12:27' with Separator ':' and Basic Char '8' = '88:88'.         
 ͼ}
Function Str_Mask(StIn:String; Sep,Base:Char):String;
Var A:Integer;
Begin
For A:=1 to Length(StIn) do
   If Copy(StIn,A,1)<>Sep Then StIn[A]:=Base;
Str_Mask:=StIn;                      {*Send Result*}
End;

{*----------------------------COMMAND LINE PARAMETER------------------------*}

{ͻ
                          FUNCTION Str_ParamCount                           
 ͹
  IN.....: S (STRING) = String parameter                                    
  OUT....: (BYTE) = Number of "parameters" found in S                       
  EXPLAIN: This function return the number of "parameters" it founds in this
           string. It's the same like ParamCount from DOS unit but the      
           difference is this function is not on command line parameter but 
           on the string S.                                                 
  EXAMPLE: Writeln(Str_ParamCount('TOTO.EXE 1 2 3'))       =  3             
           Writeln(Str_ParamCount('-INI=F:\T.INI /? /S'))  =  2             
           Writeln(Str_ParamCount('Toto is here))          =  2             
           Writeln(Str_ParamCount(''))                     =  0             
  SEEALSO: Str_ParamStr                                                     
  NB.....: The first word is never counted.                                 
  CF.....: ParamCount from Tp7                                              
 ͼ}
Function Str_ParamCount(S:String):Byte;
{*        Graphe d'tat                                                *}
{*                                        Transitions                  *}
{*                 " (2)                                               *}
{* +------+<-----------------+            " = Caractre '"'            *}
{* |      |        "         |            E = Caractre ' ' = space    *}
{* |Etat 1|---------------+  |            A = Autres caractre = [A-Z] *}
{* +------+               |  |                                         *}
{*  |   ^                 v  |                                         *}
{*  |   |                +------+                                      *}
{*  +---+                |Etat 3|<-+                                   *}
{*   A+E                 +------+  |                                   *}
{*              A (1)     | ^  ^   |E                                  *}
{* +------+<--------------+ |  |   |                                   *}
{* |      |     E           |  +---+                                   *}
{* |Etat 2|-----------------+                                          *}
{* +------+                                                            *}
{*  |   ^                                                              *}
{*  |   |                                                              *}
{*  +---+                                                              *}
{*   A+"                                                               *}
Var Etat,OldEtat : Byte;
    {* Automate Fini d'tats : Valeur de ces variables : *}
    {*                                                   *}
    {* 1 Bloc ""                                         *}
    {* 2 Bloc [A-Z]                                      *}
    {* 3 Extrieur d'un bloc                             *}
    i            : Integer;
    Res          : Integer;
Begin
Res:=0;

Etat:=3;
OldEtat:=Etat;

For i:=1 to Length(S) do
  Begin
    Case Etat Of
      1:Begin {1 Bloc ""}
        If S[i]='"' Then Etat:=3 Else
        If S[i]=' ' Then Etat:=1 Else Etat:=1;
        End;
      2:Begin {2 Bloc [A-Z]}
        If S[i]='"' Then Etat:=2 Else
        If S[i]=' ' Then Etat:=3 Else Etat:=2;
        End;
      3:Begin {3 Extrieur d'un bloc}
        If S[i]='"' Then Etat:=1 Else
        If S[i]=' ' Then Etat:=3 Else Etat:=2;
        End;
    End; {Case}
  If (OldEtat=3) And (Etat=2) Then Inc(Res); {Transition (1)}
  If (OldEtat=3) And (Etat=1) Then Inc(Res); {Transition (2)}
  OldEtat:=Etat;
  End;
If Res=0 Then Str_ParamCount:=0 Else Str_ParamCount:=Res-1;
End;

{ͻ
                           FUNCTION Str_ParamStr                            
 ͹
  IN.....: S (STRING) = String parameter                                    
           Num (BYTE) = N of the parameter to get.                         
  OUT....: (STRING) = String result (Parameter N Num)                      
  EXPLAIN: Get a Num'th parameter from S.This function is like ParamStr     
           from DOS unit, but the difference is this function is not on     
           Command line but on the string S.                                
  EXAMPLE: Writeln(Str_ParamStr('-INI=F:\T.INI /? /S',1))  =  '/?'          
           Writeln(Str_ParamStr('Toto is here',0))         =  'Toto'        
           Writeln(Str_ParamStr('',1))                     =  ''            
           Writeln(Str_ParamStr('Toto.exe "is here"',1))   =  'is here'     
  NB.....: Not that Str_ParamStr return an empty string ('').               
  SEEALSO: Str_ParamCount                                                   
  CF.....: ParamStr from Tp7                                                
 ͼ}
Function Str_ParamStr(S:String;Num:Byte):String;
Var Etat,OldEtat : Byte;
    i            : Integer;      {*AFE -> Cf Str_ParamCount*}
    Res          : Integer;
    St           : String;
Begin
St:='';
Res:=0;

Etat:=3;

OldEtat:=Etat;

For i:=1 to Length(S) do
  Begin
    Case Etat Of
      1:Begin {1 Bloc ""}
        If S[i]='"' Then Etat:=3 Else
        If S[i]=' ' Then Etat:=1 Else Etat:=1;
        End;
      2:Begin {2 Bloc [A-Z]}
        If S[i]='"' Then Etat:=2 Else
        If S[i]=' ' Then Etat:=3 Else Etat:=2;
        End;
      3:Begin {3 Extrieur d'un bloc}
        If S[i]='"' Then Etat:=1 Else
        If S[i]=' ' Then Etat:=3 Else Etat:=2;
        End;
    End; {Case}

  If (OldEtat=3) And (Etat=2) Then Inc(Res); {Transition (1)}
  If (OldEtat=3) And (Etat=1) Then Inc(Res); {Transition (2)}

  If Res-1=Num Then St:=St+S[i];

  OldEtat:=Etat;
  End;

If St[Length(St)]=' ' Then SetLength(St,Length(St)-1);   {*If last char =' ', delete it*}

If St[1]='"' Then
  Begin
  St:=Copy(St,2,Length(St)-2);
  If St[Length(St)]='"' Then St:=Copy(St,1,Length(St)-1);
  End;
Str_ParamStr:=St;
End;

{ͻ
                           FUNCTION Str_Parameter                           
 ͹
  IN.....: S (STRING) = String source                                       
           St (STRING) = Parameter to look for in S                         
           Mode (WORD) =                                                    
            Bit  Num                                                        
             0   0001  Parameter case sensitive (if bit set)                
             1   0002  Result parameter case sensitive                      
             2   0004                                                       
  OUT....: St (STRING) = If parameter followed by '=xxx' then return 'xxx'  
           (BYTE) = Position where is found the parameter, else if not      
                    found return 0.                                         
  EXPLAIN: Test if the string S contain the parameter St.If the anwser      
           is yes, send the position of this parameter is.                  
           And if the parameter is followed by '=xxx',St is replaced by     
           'xxx'.                                                           
  EXAMPLE: S:='toto.exe /record=test.lmp /machin'                           
           Code           Result                                            
           St:='/Record';  Str_Parameter(S,St,0) = 1 & St='TEST.LMP'        
           St:='/Truc';    Str_Parameter(S,St,0) = 0 & St='/TRUC'           
           St:='/Machin';  Str_Parameter(S,St,0) = 2 & St='/MACHIN'         
           St:='/ReCord'   Str_Parameter(S,St,1) = 0 & St='/RECORD'         
           St:='/Record';  Str_Parameter(S,St,2) = 3 & St='test.lmp'        
           Example 2 : s='toto.exe /record="test here" /machin'             
           St:='/Record';  Str_Parameter(S,St,0) = 2 & St='test here'       
  SEEALSO: Parameter, ParameterMOS                                          
 ͼ}
Function Str_Parameter(S:String;Var St:String;Mode:Word):Byte;
Var A,PP:Integer;
    P:String;
    S1,S2,S3:String;
Begin
Str_Parameter:=0;

For A:=1 to Str_ParamCount(S) do
  Begin
  P:=Str_ParamStr(S,A);

  PP:=Pos('=',P);                        {*Search Sous-Paramtre position...*}
  If PP>0 Then S1:=Copy(P,1,PP-1) Else S1:=P;
  S2:=St;
  If PP>0 Then S3:=Copy(P,PP+1,Length(P)-PP+1)
          Else S3:='';

  If Mode And $1<>$1 Then                {*Parameter not case sensitive*}
    Begin
    S1:=Upper(S1);
    S2:=Upper(S2);
    End;

  If S1=S2 Then                          {*Parameter found*}
    Begin

    If PP>0 Then                         {*Sub-Parameter found*}
      Begin
      St:=S3;                            {*Return Sub-Paramtre*}
      Str_Parameter:=A;                  {*Found... !*}
      End
    Else Str_Parameter:=A;               {*Found... !*}

    End;

  End; {For}
If Mode And $2<>$2 Then St:=Upper(St);
End;

{ͻ
                        FUNCTION Str_GetCommandLine                         
 ͹
  IN.....: /                                                                
  OUT....: (STRING) = Return the complete line command parameter.           
  EXPLAIN: Return the complete command line parameter included the program  
           name.                                                            
  EXAMPLE: If you execute this under dos :                                  
           toto.exe /record=test.lmp /machin                                
           and here the code of toto.pas :                                  
           Uses MosStrings;                                                 
           Begin                                                            
           Writeln(Str_GetParamLine)                                        
           End.                                                             
           The result will be :                                             
           toto.exe /record=test.lmp /machin                                
  SEEALSO: Str_Parameter                                                    
 ͼ}
Function Str_GetCommandLine:String;
Var S:String;
    i:byte;
Begin
S:='';
For i:=0 to ParamCount do S:=S+'"'+ParamStr(i)+'" ';
SetLength(S,Length(S)-1);                    {*Delete last space*}
Str_GetCommandLine:=S;
End;

{ͻ
                             FUNCTION Parameter                             
 ͹
  IN.....: St (STRING) = Parameter to test                                  
           Mode (WORD) =                                                    
            Bit  Num                                                        
             0   0001  Parameter case sensitive (if bit set)                
             1   0002  Result parameter case sensitive                      
             2   0004                                                       
  OUT....: St (STRING) = If parameter followed by '=xxx' then return 'xxx'  
           (BYTE) = Position where is found the parameter, else if not      
                    found return 0.                                         
  EXPLAIN: Test if the program is launch with the parameter St.If the anwser
           is yes, send the position of this parameter.                     
           And if the parameter is followed by '=xxx',St is replaced by     
           'xxx'.                                                           
  EXAMPLE: toto.exe /record=test.lmp /machin                                
           S:='/Record';                                                    
           Parameter(S) = 2 & S='/TEST.LMP'                                 
           S:='/Truc'                                                       
           Parameter(S) = 0 & S='/TRUC'                                     
           S:='/Machin'                                                     
           Parameter(S) = 3 & S='/MACHIN'                                   
  SEEALSO: ParameterMOS, Str_Parameter                                      
  CF.....: ParamStr, ParamCount from Tp7                                    
 ͼ}
Function Parameter(Var St:String;Mode:Word):Byte;
Begin
Parameter:=Str_Parameter(Str_GetCommandLine,St,Mode);
End;

{ͻ
                             FUNCTION Parameter                             
 ͹
  IN.....: St (STRING) = Parameter to test                                  
  OUT....: St (STRING) = If parameter followed by '=xxx' then return 'xxx'  
           (BYTE) = Position where is found the parameter, else if not      
                    found return 0.                                         
  EXPLAIN: Test if the program is launch with the parameter St.If the anwser
           is yes, send the position of this parameter.                     
           And if the parameter is followed by '=xxx',St is replaced by     
           'xxx'.                                                           
  EXAMPLE: toto.exe /record=test.lmp /machin                                
           S:='/Record';                                                    
           Parameter(S) = 2 & S='/TEST.LMP'                                 
           S:='/Truc'                                                       
           Parameter(S) = 0 & S='/TRUC'                                     
           S:='/Machin'                                                     
           Parameter(S) = 3 & S='/MACHIN'                                   
  SEEALSO: ParameterMOS, Str_Parameter                                      
  CF.....: ParamStr, ParamCount from Tp7                                    
 ͼ}
{Function Parameter(Var St:String):Byte;
Begin
Parameter:=Str_Parameter(Str_GetCommandLine,St,0);
End;}

{*------------------------------ FILE MASK ---------------------------------*}

{ͻ
                           FUNCTION STR_WILDCARDS                           
 ͹
  IN.....: S : (STRING) = String source                                     
                          (A FileName without Extension for example)        
           Mask : (STRING) = String witch can contain WildCards             
  OUT....: (STRING) = String result                                         
  EXPLAIN: Transform a String in another allowing * and ? as Wildcards.     
           The Char '*' = All the rest of the string will not be changed    
           The Char '?' = The letter of the string source will not be       
                          change.                                           
           All other char = Replaced by this char.                          
  EXAMPLE: Str_WildCards('toto','?i?i')   = 'titi'                          
           Str_WildCards('123456','0123') = '0123'                          
           Str_WildCards('toto.i','t*.pas') = 'toto.i'                      
           Str_WildCards('123456','0*99') = '023456'                        
           Str_WildCards('123456','0*1?') = '023456'                        
  NB.....: This function don't make like dos example (C.F. Last example)    
           It works only on string.                                         
  SEEALSO: Str_FileMask                                                     
 ͼ}
Function Str_WildCards(S:String;Mask:String):String;
Var i,j:Integer;
    b:boolean;
    S2:String;
Begin
b:=False;
i:=1;
S2:='';
While i<=Length(S) do
  Begin
  If b Then S2:=S2+S[i]
  Else If i<=Length(Mask) Then
    Begin
      Case Mask[i] Of
        '*':Begin
            b:=True;
            S2:=S2+S[i];
            End;
        '?':S2:=S2+S[i];
      Else S2:=S2+Mask[i];
      End; {Case}
    End;
  Inc(i);
  End;
For j:=i to Length(Mask) do If (Mask[j]<>'?') And (Mask[j]<>'*') Then S2:=S2+Mask[j];
Str_WildCards:=S2;
End;

{ͻ
                           FUNCTION Str_FileMask                            
 ͹
  IN.....: S : (STRING) = String source                                     
                          (A FileName+Extension without Path for example)   
           Mask : (STRING) = String witch can contain WildCards             
  OUT....: (STRING) = String result                                         
  EXPLAIN: Transform a fileName to another using the Mask witch contains    
           Wilcard.                                                         
  EXAMPLE: Str_FileMask('toto.pas','autoexec.bat') = 'autoexec.bat'         
           Str_FileMask('toto.pas','*.bat')        = 'toto.bat'             
           Str_FileMask('toto.pas','a?toexec.bat') = 'aotoexec.bat'         
           Str_FileMask('toto.pas','au*.bat')      = 'auto.bat'             
           Str_FileMask('toto.pas','au*.b*')       = 'auto.bas'             
           Str_FileMask('toto.pas','a??oexec.ba?') = 'aotoexec.bat'         
  NB.....: This function use Str_WildCards                                  
  BUGS...: S must be only FileName, it must contain no path !!!             
  SEEALSO: Str_Wildcards                                                    
 ͼ}
Function Str_FileMask(FileName:String;Mask:String):String;
Var FName,FExt,MName,MExt:String;
Begin
{FileName:=UPPER(FileName);
Mask:=UPPER(Mask);}

If (Mask='') Or (Mask='*.*') Then
  Begin
  Str_FileMask:=FileName;
  Exit;
  End;

If (Pos('*',Mask)=0) And (Pos('?',Mask)=0) Then
  Begin
  Str_FileMask:=Mask;
  Exit;
  End;

If (Pos('.',FileName)=0) Then
  Begin
  FExt:='';
  FName:=FileName;
  End
Else
  Begin
  FExt:=Copy(FileName,Pos('.',FileName)+1,Length(FileName));
  FName:=Copy(FileName,1,Pos('.',FileName)-1);
  End;

If (Pos('.',Mask)=0) Then
  Begin
  MExt:='';
  MName:=Mask;
  End
Else
  Begin
  MExt:=Copy(Mask,Pos('.',Mask)+1,Length(Mask));
  MName:=Copy(Mask,1,Pos('.',Mask)-1);
  End;
Str_FileMask:=Str_WildCards(FName,MName)+'.'+Str_WildCards(FExt,MExt);
End;

{ͻ
                             FUNCTION STR_EXTR                              
 ͹
  IN.....: PS (STRING) = Path to extract                                    
           PS2 (STRING) = Path from the extraction                          
  OUT....: (STRING) =  Path exctracted                                      
  EXPLAIN: /                                                                
  EXAMPLE: Str_Extr('c:\dos\','c:\dos\toto\') = 'toto\'                     
 ͼ}
Function Str_Extr(PS,PS2:String):String;
Begin
If Pos(PS,PS2)<>1 Then
  Begin
  Str_Extr:='';Exit;
  End;
Str_Extr:=Copy(PS2,Length(PS)+1,Str_LastPos('\',PS2)-Length(PS));
End;

{ͻ
                         FUNCTION Str_PathRelative                          
 ͹
  IN.....: P1 (STRING) = Path where you are in.                             
           P2 (STRING) = Path or filename you want in relative.             
  OUT....: (STRING) = String result                                         
  EXPLAIN: Return the relative path of a filename or a path.                
           This function make the oposite job of FExpand.                   
  EXAMPLE: Str_PathRelative('f:\cd\examples','f:\cd\system')='..\system'    
           Str_PathRelative('f:\2\2','f:\2\config.sys')     ='..\config.sys'
  CF.....: FExpand from Tp7                                                 
 ͼ}
Function Str_PathRelative(P1,P2:String):String;
Var i,j,c:integer;
    St:String;
Begin
P1:=FExpand(P1);                 {*Met les Paths sous forme quivalente*}
P2:=FExpand(P2);
P1:=Upper(P1);
P2:=Upper(P2);

If (P1[Length(P1)]='\') And (Length(P1)>3) Then SetLength(P1,Length(P1)-1);
If (P2[Length(P2)]='\') And (Length(P2)>3) Then SetLength(P2,Length(P2)-1);

If P1[1]<>P2[1] Then             {*Si lecteur diffrents*}
  Begin
  Str_PathRelative:=P2;
  Exit;
  End;
i:=1;
While (i<=Min(Length(P1),Length(P2))) And (P1[i]=P2[i]) do Inc(i);
Dec(i);                          {*i=dbut de la diffrence entre P1 et P2*}
St:='';
P1:=Str_CorrectPath(P1+'\');
C:=Str_CountItem(Copy(P1,i+1,length(P1)),'\');
If c=0 Then                      {*Pas besoin de ..\*}
  begin
  st:='.';
  end;
For j:=1 to c do st:=st+'..\';   {*Met en relatif*}
st:=Str_CorrectPath(st+Copy(P2,i,length(P2)));

Str_PathRelative:=st;
End;

{ͻ
                          FUNCTION Str_CorrectPath                          
 ͹
  IN.....: S (STRING) = Input String                                        
  OUT....: (STRING) = String result                                         
  EXPLAIN: If a string contain one or several times the substring '\\'      
           then replace it by '\'.                                          
  EXAMPLE: Writeln(Str_CorrectPath('c:\\dos')) = 'c:\dos'                   
 ͼ}
Function Str_CorrectPath(S:String):String;
Begin
If Pos('\\',S)>0 Then Delete(S,Pos('\\',S),1);
If Pos('\\',S)>0 Then S:=Str_CorrectPath(S);
Str_CorrectPath:=S;
End;

{*-------------------------------- HOTKEYS ---------------------------------*}

{ͻ
                         FUNCTION Str_GetHotkeyPos                          
 ͹
  IN.....: Line (STRING) = Input line to process.                           
  OUT....: (BYTE) = Index of the Hotkey (0 if not found).                   
  EXPLAIN: Return the index of the hotkey found in string.                  
  NB.....: Hotkey is preceded by the '_' caracter.                          
 ͼ}

Function Str_GetHotkeyPos(Const Line:String):Byte;
Begin
Str_GetHotkeyPos:=Pos('_',Line);
End;

{ͻ
                           FUNCTION Str_GetHotkey                           
 ͹
  IN.....: Line (STRING) = Input line to process.                           
  OUT....: (STRING) = Hotkey caracter if found ('' if not found).           
  EXPLAIN: Return the hotkey caracter found in a string.                    
  NB.....: Hotkey is preceded by the '_' caracter.                          
 ͼ}

Function Str_GetHotkey(Const Line:String):String;
Var P:Byte;
Begin
P:=Pos('_',Line);
If P>0 Then Str_GetHotkey:=Line[P]
       Else Str_GetHotkey:='';
End;

{ͻ
                          FUNCTION Str_PurgeHotKey                          
 ͹
  IN.....: Line (STRING) = Input line to process.                           
  OUT....: (STRING) = String furged from a hotkey.                          
  EXPLAIN: Return the string purged from a hotkey if found.                 
  NB.....: Hotkey is preceded by the '_' caracter.                          
 ͼ}

Function Str_PurgeHotkey(Line:String):String;

Var P:Byte;
Begin
P:=Pos('_',Line);
If P>0 Then Delete(Line,P,1);
Str_PurgeHotkey:=Line;
End;

{*------------------------------ Versions ----------------------------------*}

{ͻ
                          FUNCTION Str_SetVersion                           
 ͹
  IN.....: Major (WORD) = Major N version                                  
           Minor (WORD) = Minor N version                                  
  OUT....: (STRING) = Returned string.                                      
  EXPLAIN: Return the complete number version.                              
           The result is a string with 'Major.Minor'                        
  EXAMPLE: Str_SetVersion(3,1) = '3.1'                                      
 ͼ}

Function Str_SetVersion(Major,Minor:Word):String;
Var S1,S2:String;
Begin
Str(Major,S1);Str(Minor,S2);       {*Conversion word->string*}
Str_SetVersion:=S1+'.'+S2;         {*Result*}
End;

{ͻ
                        FUNCTION Str_GetVersionMajor                        
 ͹
  IN.....: V (STRING) = version number.                                     
  OUT....: (WORD) = Major version number.                                   
  EXPLAIN: Return the major part of a number version.                       
  EXAMPLE: Str_GetVersionMajor('3.1') = 3                                   
  NB.....: If an error occurs, return $FFFF                                 
 ͼ}

Function Str_GetVersionMajor(V:String):Word;
Var S:String;
    i,e:Word;
Begin
S:=Copy(V,1,Pos('.',V)-1);
Val(s,i,e);

If (e<>0) or (S='') Then i:=$FFFF;
Str_GetVersionMajor:=i;
End;

{ͻ
                        FUNCTION Str_GetVersionMinor                        
 ͹
  IN.....: V (STRING) = version number.                                     
  OUT....: (WORD) = Minor version number.                                   
  EXPLAIN: Return the minor part of a number version.                       
           Return only the integer part of the minor version.               
  EXAMPLE: Str_GetVersionMinor('3.1') = 1                                   
           Str_GetVersionMinor('1.9a') = 9                                  
           Str_GetVersionMinor('1.9.5') = 9                                 
  NB.....: If an error occurs, return $FFFF                                 
 ͼ}


Function Str_GetVersionMinor(V:String):Word;
Var S:String;
    i,e:Word;
Begin
S:=Copy(V,Pos('.',V)+1,Length(V));
Val(s,i,e);
If e<>0 Then
  Begin
  S:=Copy(S,1,e-1);
  Val(s,i,e);
  If (e<>0) or (S='') Then i:=$FFFF;
  End;
Str_GetVersionMinor:=i;
End;

{ͻ
                          FUNCTION Str_TestVersion                          
 ͹
  IN.....: V1 (STRING) = First version                                      
           V2 (STRING) = Second version                                     
  OUT....: (BYTE) = 0 = V1>V2.                                              
                    1 = V1<V2.                                              
                    2 = V1=V2.                                              
                    3 = Error in input parameters.                          
  EXPLAIN: Return if V1 is a higher version than V2.                        
  EXAMPLE: Str_TestVersion('3.1','2.9') = 0                                 
           Str_TestVersion('1.1','2.9') = 1                                 
           Str_TestVersion('1.9','2.8') = 1                                 
           Str_TestVersion('3.1','3.1') = 2                                 
           Str_TestVersion('3.1','3.1a') = 3                                
 ͼ}

Function Str_TestVersion(V1,V2:String):Byte;
Var Minor1,Major1:Word;
    Minor2,Major2:Word;
Begin
Major1:=Str_GetVersionMajor(V1);
Minor1:=Str_GetVersionMinor(V1);
Major2:=Str_GetVersionMajor(V2);
Minor2:=Str_GetVersionMinor(V2);

If (Major1=$FFFF) Or (Major1=$FFFF) Or (Major1=$FFFF) Or (Major1=$FFFF) Then
  Begin
  Str_TestVersion:=3;
  Exit;
  End;
If Major1>Major2 Then
  Begin                            {*Major1>Major2*}
  Str_TestVersion:=0;
  Exit;
  End;

If Major1<Major2 Then              {*Major1<Major2*}
  Begin
  Str_TestVersion:=1;
  Exit;
  End;
                                   {*Major1=Major2*}
If Minor1>Minor2 Then              {*Minor1>Minor2*}
  Begin
  Str_TestVersion:=0;
  Exit;
  End;
If Minor1<Minor2 Then              {*Minor1>Minor2*}
  Begin
  Str_TestVersion:=1;
  Exit;
  End;

Str_TestVersion:=2;          {*Same versions*}
End;

{ͻ
                        FUNCTION Str_IsReservedWord                         
 ͹
  IN.....: S (STRING) = String to test.                                     
  OUT....: Result (BOOLEAN) = TRUE : It's a reserved word.                  
  EXPLAIN: Check if the specified word is a Pascal reserved word.           
 ͼ}

Function Str_IsReservedWord(S:String):Boolean;     {*Check if is a reserved Pascal word*}
{ checks if S is a Reserved word or a directive}

Type STR20 = string[20];

Const HashingNumber = 23;
      MaxOnHashLine = 10;

Const RWords : array[0..HashingNumber-1,0..MaxOnHashLine-1] of str20 =
(
{00}  ('CONST','OR','TYPE','','','','','','',''),
{01}  ('SHL','FOR','DESTRUCTOR','INHERITED','PROPERTY','','','','',''),
{02}  ('TO','OBJECT','TRY','CDECL','','','','','',''),
{03}  ('VAR','ASSEMBLER','','','','','','','',''),
{04}  ('AND','FORWARD','THEN','IMPLEMENTATION','LIBRARY','RAISE','','','',''),
{05}  ('IF','UNTIL','PUBLISHED','STORED','','','','','',''),
{06}  ('SET','CLASS','INITIALIZATION','THREADVAR','','','','','',''),
{07}  ('LABEL','PROGRAM','SHR','FINALIZATION','NODEFAULT','','','','',''),
{08}  ('CASE','END','DISPID','INDEX','RESIDENT','','','','',''),
{09}  ('ABSOLUTE','WHILE','DO','AUTOMATED','','','','','',''),
{10}  ('RECORD','PACKED','INLINE','PUBLIC','PRIVATE','AS','FAR','OVERRIDE','',''),
{11}  ('OF','STRING','NOT','DEFAULT','DYNAMIC','MESSAGE','','','',''),
{12}  ('FILE','REPEAT','BEGIN','','','','','','',''),
{13}  ('IN','EXTERNAL','INTERFACE','EXPORTS','NAME','STDCALL','','','',''),
{14}  ('GOTO','PROCEDURE','','','','','','','',''),
{15}  ('DOWNTO','ARRAY','PROTECTED','','','','','','',''),
{16}  ('FUNCTION','','','','','','','','',''),
{17}  ('MOD','WITH','','','','','','','',''),
{18}  ('IS','NEAR','','','','','','','',''),
{19}  ('XOR','CONSTRUCTOR','','','','','','','',''),
{20}  ('DIV','NIL','EXCEPT','','','','','','',''),
{21}  ('ELSE','UNIT','USES','FINALLY','ABSTRACT','','','','',''),
{22}  ('EXPORT','PASCAL','VIRTUAL','','','','','','',''));

Var HN,L:word;
    C:word;
    Found:boolean;

   function Key(S:string;Divisor:byte):word;
   { calcula chave de acesso }
   var I:integer;
       SOMA:longint;
   begin
   SOMA:=0;
   for I:=1 to length(S) do
       inc(SOMA,ord(S[I]));
   Key:=SOMA mod Divisor;
   end;

   function GetHash(S:String):word;
   begin
   GetHash:=Key(S,HashingNumber);
   end;

Begin
L:=Length(S);
for C:=1 to L
    do S[C]:=UpCase(S[C]);

HN:=GetHash(S);
C:=0;
Found:=false;
while (C<MaxOnHashLine) and (RWORDS[HN,C]<>'') and not(Found) do
      begin
      Found:=Found or (S=RWORDS[HN,C]);
      inc(C);
      end;
Result := Found;
End;

{*----------------------------- INITIALISATIONS ----------------------------*}

Begin
End.
(*
{ͻ
                           FUNCTION ParameterMOS                            
 ͹
  IN.....: St (STRING) = Parameter to test                                  
           Mode (WORD) =                                                    
            Bit  Num                                                        
             0   0001  Parameter case sensitive (if bit set)                
             1   0002  Result parameter case sensitive                      
             2   0004                                                       
  OUT....: St (STRING) = If parameter followed by '=xxx' then return 'xxx'  
           (BYTE) = Position where is found the parameter, else if not      
                    found return 0.                                         
  EXPLAIN: Test if the program is launch with the parameter St.If the anwser
           is yes, send the position of this parameter.                     
           And if the parameter is followed by '=xxx',St is replaced by     
           'xxx'.                                                           
  EXAMPLE: toto.exe /record=test.lmp /machin                                
           S:='Record';                                                     
           Parameter(S) = 2 & S='Test.lmp'                                  
           S:='Truc'                                                        
           Parameter(S) = 0 & S='Truc'                                      
           S:='Machin'                                                      
           Parameter(S) = 3 & S='Machin'                                    
  CF.....: Str_Parameter, ParamStr, ParamCount.                             
  NB.....: You must use this function if you are in MOS, else use Parameter 
  SEEALSO: Parameter, Str_Parameter                                         
 ͼ}
Function ParameterMOS(Var St:String;Mode:Word):Byte;
Begin
If BCmd Then ParameterMOS:=Str_Parameter(ParamStr(0)+' '+SCmd,St,Mode)
        Else ParameterMOS:=Parameter(St,Mode);
End;
*)


(*
{ͻ
                          FUNCTION Str_ParamCount                           
 ͹
  IN.....: S (STRING) = String parameter                                    
  OUT....: (BYTE) = Number of "parameters" found in S                       
  EXPLAIN: This function return the number of "parameters" it founds in this
           string. It's the same like ParamCount from DOS unit but the      
           difference is this function is not on command line parameter but 
           on the string S.                                                 
  EXAMPLE: Writeln(Str_ParamCount('-INI=F:\T.INI /? /S'))  =  3             
           Writeln(Str_ParamCount('Toto is here))          =  3             
           Writeln(Str_ParamCount(''))                     =  0             
  SEEALSO: Str_ParamStr                                                     
  CF.....: ParamCount from Tp7                                              
 ͼ}
Function Str_ParamCount(S:String):Byte;
Var i,c:Byte;
    b:boolean;                    {*True if between quotes*}
Begin
S:=Str_CleanSpaces(S);
If Length(S)=0 Then
  Begin
  Str_ParamCount:=0;
  Exit;
  End;
c:=1;
b:=False;
For i:=1 to Length(S) do
  If (S[i]=' ') And Not b Then Inc(c) Else
  If S[i]='"' Then b:=not b;      {* '"' found !! *}
Str_ParamCount:=c-1;              {*First string = FileName, don't used*}
End;*)

(*
{ͻ
                           FUNCTION Str_ParamStr                            
 ͹
  IN.....: S (STRING) = String parameter                                    
           Num (BYTE) = N of the parameter to get.                         
  OUT....: (STRING) = String result (Parameter N Num)                      
  EXPLAIN: Get a Num'th parameter from S.This function is like ParamStr     
           from DOS unit, but the difference is this function is not on     
           Command line but on the string S.                                
  EXAMPLE: Writeln(Str_ParamStr('-INI=F:\T.INI /? /S',1))  =  '/?'          
           Writeln(Str_ParamStr('Toto is here',0))         =  'Toto'        
           Writeln(Str_ParamStr('',1))                     =  ''            
  NB.....: Not that Str_ParamStr return an empty string ('').               
  SEEALSO: Str_ParamCount                                                   
  CF.....: ParamStr from Tp7                                                
 ͼ}
Function Str_ParamStr(S:String;Num:Byte):String;
Var i,c:Byte;
    S2:String;
    b:boolean;                    {*True if between quotes*}
Begin
S:=Str_CleanSpaces(S);
i:=1;c:=0;
S2:='';
b:=False;
While (i<=Length(S)) do
  Begin
  If (S[i]=' ') And Not b Then Inc(c)
    Else If S[i]='"' Then b:=not b
      Else If c=Num Then S2:=S2+S[i];
  Inc(i);
  End;
Str_ParamStr:=S2;
End;*)
(*
{ͻ
                           FUNCTION Str_Parameter                           
 ͹
  IN.....: S (STRING) = String source                                       
           St (STRING) = Parameter to look for in S                         
           Mode (WORD) =                                                    
            Bit  Num                                                        
             0   0001  Parameter case sensitive (if bit set)                
             1   0002  Result parameter case sensitive                      
             2   0004                                                       
  OUT....: St (STRING) = If parameter followed by '=xxx' then return 'xxx'  
           (BYTE) = Position where is found the parameter, else if not      
                    found return 0.                                         
  EXPLAIN: Test if the string S contain the parameter St.If the anwser      
           is yes, send the position of this parameter is.                  
           And if the parameter is followed by '=xxx',St is replaced by     
           'xxx'.                                                           
  EXAMPLE: S:='toto.exe /record=test.lmp /machin'                           
           Code           Result                                            
           St:='/Record';  Str_Parameter(S,St) = 2 & St='TEST.LMP'          
           St:='/Truc';    Str_Parameter(S,St) = 0 & St='/TRUC'             
           St:='/Machin';  Str_Parameter(S,St) = 3 & St='/MACHIN'           
           Example 2 : s='toto.exe /record="test here" /machin'             
           St:='/Record';  Str_Parameter(S,St) = 2 & St='/TEST HERE'        
  SEEALSO: Parameter, ParameterMOS                                          
 ͼ}
Function Str_Parameter(S:String;Var St:String):Byte;
Var A,PP:Integer;
    P:String;
Begin
Str_Parameter:=0;                           {*De Base*}

St:=Upper(St);
S :=Upper(S);

For A:=1 to Str_ParamCount(S) do
   Begin
   P:=Upper(Str_ParamStr(S,A));             {*Passe tout en Majuscule*}

   If (P[1]='-') Or (P[1]='/') Then
      Begin
      St:=Upper(St);
      PP:=Pos('=',P);                       {*Search for Sous-Paramtre...*}
      If PP>0 Then                          {*Il y a un Sous-Paramtre*}
         If Copy(P,1,PP-1)=St Then
           Begin
           St:=Copy(P,PP+1,Length(P)-PP+1); {*Renvois Sous-Paramtre*}
           Str_Parameter:=A;                {*Trouv... !*}
           End
         Else
      Else                                  {*Pas de '=' Sous-Paramtre*}
         If St=P Then Str_Parameter:=A;     {*Trouv... !*}
      End;
   End;
End;
*)
