{ͻ
                                UNIT MosTab                                 
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 31.01.1998                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: Tabs and ComboBox components management.                     
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 668 Lines and (16.880 Bytes compiled)                        
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosTab;

{$Mode Objfpc}

INTERFACE

Uses
     MosGadgets,
     MosList,
     MosWindows;

Type TTabs=Record                       {*Tabs structure*}
   X1,Y1,X2,Y2         :Integer;        {*Box coordinates*}
   STxt                :Integer;        {*Labels Size Y*}
   QttO                :Byte;           {*Quantity of Tabs*}
   No                  :Shortint;       {*Current Tabs Number*}
   COa,COi             :Longint;        {*Tabs colors (Activated or no)*}
   Pointer             :TMouseZone;     {*Mouse pointer management*}
   TCT                 :String;         {*Tabs titles*}
   AvailableTabs       :Word;           {*AvailableTabs tabs*}
   Tag                 :Word;           {*User field*}
   Id                  :Word;           {*Id Tabss*}
   {*Bit 0  $0001 = Freezed            Freezed Tabs*}
   {*Bit 1  $0002 = Invisible Tabs   Invisible Tabs*}
   {*Bit 2  $0004 = Hand Pointer       Hand Mouse Pointer on title*}
   {*Bit 3  $0008 = Unicolor           All the Tab sheets have the same color*}
   {*Bit 4  $0010 = Small vertical size for the Tabss*}
   {*Bit 14 $4000 = Reserved           Status Gadget 0=Active,1=Freezed*} {MIC}
   {*Bit 15 $8000 = Reserved           Mouse Pointer on Gadget...*} {MIC}
   End;

TCombo=Record                            {*Combo Box definition*}
     X1,Y1       :Integer;               {*Gadget position*}
     Sx          :Integer;               {*Gadget width*}
     Col1,Col2   :Longint;               {*Gadget colors*}
     Col3        :Longint;               {*List color*}
     Selected    :Integer;               {*Item selected*}
     But         :TButton;               {*Pointer to the Button Structure*}
     Inp         :TInputText;            {*Pointer to the Command Structure*}
     List        :TList;                 {*Pointer to the List Structure*}
     ListName    :String[12];            {*Filename for the List file*}
     QttMaxItems :Integer;               {*Maximum numbers of Items in List*}
     Win         :TWindow;               {*Pointer to the Window Structure*}
     Tag         :Word;                  {*User field*}
     Id          :Word;                  {*Id Combo Box*}
     {*Bit 0  $0001 : 1 = No InputText. Select only in List*}
     {*Bit 1  $0002 : 1 = Freezed Gadget*}
     {*Bit 2  $0004 : 1 = Invisible Gadget*}
     {*Bit 3  $0008 : 1 = Combo list movable*}
     {*Bit 4  $0010 : 1 = Hand Pointer on button*}
     {*Bit 5  $0020 : 1 = Adjust List-box to horizontal optimal size*}
     {*Bit 6  $0040 : 1 = Adjust List-box to vertical optimal size*}
     {*Bit 7  $0080 : 1 = Enable preselection item*}
     {*Bit 8  $0100 : 1 = Sort list items*}
     {*Bit 9  $0200 : 1 = Enable rotation in list selection*}
     {*Bit 10 $0400 : 1 = Do not display the Combo box value*}
     IdIn        :Word;                  {*Id pour Gestion Interne*} {MIC}
     {*Bit 0  $0001 : 1 = La Liste des items est affiche*} {MIC}
     End;

{****************************************************************************}

ATab = Class
   Private
      MyTab            :TTabs;
   Protected
   Public
      Constructor Define(X1,Y1,X2,Y2,No:Integer; COa,COi:LongInt; Id,AvailableTabs:Word; Cin,MPointer,SHint:String); {*Define Tab*}
      Constructor Create(X1,Y1,X2,Y2,No:Integer; COa,COi:Longint; Id:Word; Cin:String);                  {*Define and display Tab*}
      Destructor  Free;                                   {*Free Tab resources*}
      Procedure   Draw;                                   {*Draw Tab*}
      Procedure   SetSheet(Sheet:Byte);                   {*Set current TabSheet*}
      Procedure   EnableTabs(AvailableTabs:Word);         {*Enable or disable Tab sheets*}
      Procedure   Freeze(Status:Boolean);                 {*Freeze or unfreeze Tab*}
      Function    GetMsg:Byte;                            {*Get Messages from Tab*}
   End;

AComboBox = Class
   Private
      MyComboBox       :TCombo;
   Protected
   Public
      Constructor Init;
      Constructor Create(X1,Y1,Sx:Integer; Col1,Col2,Col3:Longint;Id,Selected:Word); {*Define and display ComboBox*}
      Destructor  Free;                                   {*Free ComboBox resources*}
      Procedure   Draw;                                   {*Draw ComboBox*}
      Procedure   Clear;                                  {*Clear ComboBox*}
      Procedure   Update;                                 {*Update ComboBox*}
      Procedure   Freeze(Status:Boolean);                 {*Freeze or unfreeze ComboBox*}
      Function    AddItem(Item:String):Boolean;           {*Add an item in Combo*}
      Function    DelItem(Item:String):Boolean;           {*Del an item from Combo*}
      Function    GetItem(Item:Integer):String;           {*Get a String item from Combo*}
      Function    GetItemIndex(Item:String):Integer;      {*Get the item index from Combo*}
      Function    GetSelectedItem:String;                 {*Get the selected string item from Combo*}
      Function    GetSelected:Integer;                    {*Get the selected index item from Combo*}
      Function    SetItem(Item:Integer):Boolean;          {*Define and set the main item in Combo*}
      Function    GetMsg:Byte;                            {*Get Messages from ComboBox*}
   End;

{****************************************************************************}

{|Tabs management|}
Procedure Tabs           (X1,Y1,X2,Y2,No:Integer; COa,COi:Longint; Id:Word; Var O:TTabs; Cin:String); {*Define Tabs*}
Procedure Tabs_Define    (Var O:TTabs; X1,Y1,X2,Y2,No:Integer; COa,COi:LongInt; Id,AvailableTabs:Word; Cin,MPointer,SHint:String);
Procedure Tabs_Draw      (Var O:TTabs);                     {*Draw Tabs*}
Procedure Tabs_Freeze    (Status:Boolean; Var O:TTabs);     {*Freeze Tabs*}
Function  Tabs_GetMsg    (Var O:TTabs; M:Byte):Byte;        {*Manage Tabs*}
Procedure Tabs_SetSheet  (Var O:TTabs; Sheet:Byte);         {*Set current TabSheet*}
Procedure Tabs_EnableTabs(Var O:TTabs; AvailableTabs:Word); {*Enable or disable Tabs sheets*}

{|Combos management|}
Procedure Combo(X1,Y1,Sx:Integer; Col1,Col2,Col3:Longint;Id,Selected:Word; Var C:TCombo); {*Define Combo*}
Procedure Combo_Init(Var C:TCombo);
Procedure Combo_Done(C:TCombo);
Procedure Combo_Clear(C:TCombo);
Function  Combo_AddItem(Item:String; C:TCombo):Boolean;{*Add an item in Combo*}
Function  Combo_DelItem(Item:String; C:TCombo):Boolean;{*Del an item from Combo*}
Function  Combo_GetItem(Item:Integer; C:TCombo):String;{*Get a String item from Combo*}
Function  Combo_GetItemIndex(Item:String; C:TCombo):Integer;{*Get the item index from Combo*}
Function  Combo_GetSelectedItem(C:TCombo):String;      {*Get the selected string item from Combo*}
Function  Combo_GetSelected(C:TCombo):Integer;         {*Get the selected index item from Combo*}
Function  Combo_SetItem(Var C:TCombo; Item:Integer):Boolean;{*Define and set the main item in Combo*}
Procedure Combo_Update(    C:TCombo);                  {*Update list items*} {MIC}
Procedure Combo_Draw  (Var C:TCombo);                  {*Draw Combo*}
Procedure Combo_Freeze(Status:Boolean; Var C:TCombo);  {*Freeze Combo*}
Function  Combo_GetMsg(Var C:TCombo):Byte;             {*Get Messages from Combo*}

IMPLEMENTATION

Uses
     Dos,
     MosBase,
     MosColors,
     MosConfig,
     MosCPUInstructions,
     MosDisks,
     MosFiles,
     MosGraph,
     MosMouse,
     MosStrings,
     MosTools;

{*--------------------------- Temporary Library ----------------------------*}

{||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||}

Constructor ATab.Define(X1,Y1,X2,Y2,No:Integer; COa,COi:LongInt; Id,AvailableTabs:Word; Cin,MPointer,SHint:String);
Begin
Tabs_Define(MyTab, X1,Y1,X2,Y2,No, COa,COi, Id,AvailableTabs, Cin,MPointer,SHint);
End;

Constructor ATab.Create(X1,Y1,X2,Y2,No:Integer; COa,COi:Longint; Id:Word; Cin:String);
Begin
Tabs(X1,Y1,X2,Y2,No, COa,COi, Id, MyTab, Cin);
End;

Destructor ATab.Free;
Begin
End;

Procedure ATab.Draw;
Begin
Tabs_Draw(MyTab);
End;

Procedure ATab.SetSheet(Sheet:Byte);
Begin
Tabs_SetSheet(MyTab,Sheet);
End;

Procedure ATab.EnableTabs(AvailableTabs:Word);
Begin
Tabs_EnableTabs(MyTab,AvailableTabs);
End;

Procedure ATab.Freeze(Status:Boolean);
Begin
Tabs_Freeze(Status,MyTab);
End;

Function ATab.GetMsg:Byte;
Begin
Result:=Tabs_GetMsg(MyTab,1);
End;

{||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||}

Constructor AComboBox.Init;
Begin
Combo_Init(MyComboBox);
End;

Constructor AComboBox.Create(X1,Y1,Sx:Integer; Col1,Col2,Col3:Longint;Id,Selected:Word);
Begin
Combo(X1,Y1,Sx, Col1,Col2,Col3, Id,Selected, MyComboBox);
End;

Destructor AComboBox.Free;
Begin
End;

Procedure AComboBox.Draw;
Begin
Combo_Draw(MyComboBox);
End;

Procedure AComboBox.Clear;
Begin
Combo_Clear(MyComboBox);
End;

Procedure AComboBox.Update;
Begin
Combo_Update(MyComboBox);
End;

Procedure AComboBox.Freeze(Status:Boolean);
Begin
Combo_Freeze(Status,MyComboBox);
End;

Function AComboBox.GetMsg:Byte;
Begin
Result:=Combo_GetMsg(MyComboBox);
End;

Function AComboBox.AddItem(Item:String):Boolean;
Begin
Result:=Combo_AddItem(Item,MyComboBox);
End;

Function AComboBox.DelItem(Item:String):Boolean;
Begin
Result:=Combo_DelItem(Item,MyComboBox);
End;

Function AComboBox.GetItem(Item:Integer):String;
Begin
Result:=Combo_GetItem(Item,MyComboBox);
End;

Function AComboBox.GetItemIndex(Item:String):Integer;
Begin
Result:=Combo_GetItemIndex(Item,MyComboBox);
End;

Function AComboBox.GetSelectedItem:String;
Begin
Result:=Combo_GetSelectedItem(MyComboBox);
End;

Function AComboBox.GetSelected:Integer;
Begin
Result:=Combo_GetSelected(MyComboBox);
End;

Function AComboBox.SetItem(Item:Integer):Boolean;
Begin
Result:=Combo_SetItem(MyComboBox,Item);
End;

{*----------------------------- Debut Library ------------------------------*}

{}
{}
{}

{ͻ
                              PROCEDURE Combo                               
 ͹
  IN.....: X1,Y1 (INTEGER) = Gadget coordinates.                            
           Sx (INTEGER) = Gadget width.                                     
           Col1,Col2,Col3 (LONGINT) = Gadgets colors.                       
           Id (WORD) = Bits to parameter gadget :                           
              Bit 0  $0001 : 1 = No InputText. Select only in List          
              Bit 1  $0002 : 1 = Freezed Gadget                             
              Bit 2  $0004 : 1 = Invisible Gadget                           
              Bit 3  $0008 : 1 = Combo list movable                         
              Bit 4  $0010 : 1 = Hand Pointer on button                     
              Bit 5  $0020 : 1 = Adjust List-box to horizontal optimal size 
              Bit 6  $0040 : 1 = Adjust List-box to vertical optimal size   
              Bit 7  $0080 : 1 = Enable preselection item                   
              Bit 8  $0100 : 1 = Sort list item                             
              Bit 9  $0200 : 1 = Enable rotation in list selection          
              Bit 10 $0400 : 1 = Do not display the Combo box value         
           Selected (WORD) = Define selected item.                          
              If 0 then no item selected.                                   
           C (TCombo) = Pointer to a Combo structure.                       
  OUT....: /                                                                
  NB.....: Maximum Combo list is limited to 500 items.                      
  EXPLAIN: Build and display a Combo Gadget.                                
 ͼ}

Procedure Combo(X1,Y1,Sx:Integer; Col1,Col2,Col3:LongInt;Id,Selected:Word; Var C:TCombo);
Var Cin:String;
    IdInp,IdBut:Word;









Begin
C.X1:=X1;                               {*Store Values*}
C.Y1:=Y1;
C.Sx:=Sx-LaF*3-1;                       {*Moins la largeur du Bouton*}
C.Id:=Id;
C.IdIn:=$0000;
C.Col1:=Col1;
C.Col2:=Col2;

C.Col3:=Col3;
C.QttMaxItems:=500;                     {*500 Items Maximum*}
C.Selected:=Selected;
                                        {*Generate a specific filename*}
If Selected>0 Then Cin:=File_GetLine(Sys.GetPath(SP_TEMP)+C.ListName,Selected)
              Else Cin:='';             {*Get the string of a line in file*}
IdInp:=$0026;
If BTST(C.Id,0) Then BSET(IdInp,6);     {*No Test*}
If BTST(C.Id,1) Then BSET(IdInp,9);     {*Freezed*}
If BTST(C.Id,2) Then BSET(IdInp,11);    {*Invisible*}

InputText_Define(C.X1,C.Y1,C.Sx, 255,Col1,Col2,0,IdInp,C.Inp,Cin);
If Not BTST(C.Id,10) Then InputText_Draw(C.Inp);

IdBut:=$0060;
If BTST(C.Id,1) Then BSET(IdBut,1);     {*Freezed*}
If BTST(C.Id,2) Then BSET(IdBut,2);     {*Invisible*}
If BTST(C.Id,4) Then BSET(IdBut,4);     {*Hand Pointer*}

Button(C.X1+C.Sx+1,C.Y1,LaF*3, -1, CLTextButton,CLBgButton, IdBut,C.But,'','',Language.Loc(182));

{Combo_Update(C);}                        {*Update la liste des Items (SORT)*}
End;

{ͻ
                           FUNCTION Combo_DelItem                           
 ͹
  IN.....: Item (STRING) = String to delete from the Combo list.            
           C (TCombo) = Pointer to the Combo structure.                     
  OUT....: /                                                                
  EXPLAIN: Delete a string item from a Combo component.                     
 ͼ}

Function Combo_DelItem(Item:String; C:TCombo):Boolean;
Var FName:String;
Begin
FName:=Sys.GetPath(SP_TEMP)+C.ListName;
Combo_DelItem:=File_DeleteLine(FName,File_TestString(FName,Item,$0001,1));
End;

{ͻ
                           FUNCTION Combo_AddItem                           
 ͹
  IN.....: Item (STRING) = String to add to the Combo list.                 
           C (TCombo) = Pointer to a Combo structure.                       
  OUT....: /                                                                
  EXPLAIN: Add a string item to a Combo Gadget.                             
 ͼ}

Function Combo_AddItem(Item:String; C:TCombo):Boolean;
Begin
Combo_AddItem:=File_AppendString(Sys.GetPath(SP_TEMP)+C.ListName, Item);
End;

{ͻ
                           FUNCTION Combo_GetItem                           
 ͹
  IN.....: Item (INTEGER) = Item number in Combo list.                      
           C (TCombo) = Pointer to a Combo structure.                       
  OUT....: (STRING) = Return the string item.                               
  EXPLAIN: Get the string of a Combo item.                                  
 ͼ}

Function Combo_GetItem(Item:Integer; C:TCombo):String;{*Get an item in Combo*}
Begin
Combo_GetItem:=File_GetLine(Sys.GetPath(SP_TEMP)+C.ListName, Item);
End;

{ͻ
                         FUNCTION Combo_GetSelected                         
 ͹
  IN.....: C (TCombo) = Pointer to a Combo structure.                       
  OUT....: (INTEGER) = Return the selected item index.                      
  EXPLAIN: Get the selected item index from a Combo list.                   
 ͼ}

Function Combo_GetSelected(C:TCombo):Integer;
Begin
Combo_GetSelected:=C.Selected;
End;

{ͻ
                       FUNCTION Combo_GetSelectedItem                       
 ͹
  IN.....: C (TCombo) = Pointer to a Combo structure.                       
  OUT....: (STRING) = Return the selected item (String format).             
  EXPLAIN: Get the selected item string from a Combo list.                  
 ͼ}

Function Combo_GetSelectedItem(C:TCombo):String;
Begin
Combo_GetSelectedItem:=Combo_GetItem(C.Selected,C);
End;

{ͻ
                        FUNCTION Combo_GetItemIndex                         
 ͹
  IN.....: Item (STRING) = Item string in Combo list.                       
           C (TCombo) = Pointer to a Combo structure.                       
  OUT....: (INTEGER) = Return the item index in Combo list.                 
  EXPLAIN: Get the item index from a Combo list.                            
 ͼ}

Function Combo_GetItemIndex(Item:String; C:TCombo):Integer;
Var FName:String;
Begin
FName:=Sys.GetPath(SP_TEMP)+C.ListName;
Combo_GetItemIndex:=File_TestString(FName,Item,$0001,1);
End;

{ͻ
                           FUNCTION Combo_SetItem                           
 ͹
  IN.....: C (TCombo) = Pointer to a Combo structure.                       
           Item (INTEGER) = Item index to define as displayed item.         
  OUT....: (BOOLEAN) = TRUE if the item has been correctly defined.         
  EXPLAIN: Define and set the main item in Combo from the Combo list.       
 ͼ}

Function Combo_SetItem(Var C:TCombo; Item:Integer):Boolean;
Var St:String;
Begin
St:=File_GetLine(Sys.GetPath(SP_TEMP)+C.ListName, Item);
If St<>'' Then
   Begin
   C.Inp.Cin:=St;
   C.Selected:=Item;
   Combo_Draw(C);                    {*Raffiche Combo Value*}
   Combo_SetItem:=Yes;
   End
   Else Combo_SetItem:=No;           {*Error !*}
End;

{ͻ
                           PROCEDURE Combo_Update                           
 ͹
  IN.....: C (TCombo) = Pointer to a Combo structure.                       
  OUT....: /                                                                
  EXPLAIN: Update the lists items (Only if list is sorted).                 
 ͼ}

Procedure Combo_Update(C:TCombo);
Begin
If Not BTST(C.Id,8) Then Exit;          {*List not sorted => EXIT*}
List_Define(C.List,'',';',1,6,C.Win.X2-C.Win.X1-1,C.Win.Y2-C.Win.Y1+4, C.QttMaxItems,C.Col3,C.Col3,$8342);
List_Load  (C.List,Sys.GetPath(SP_TEMP)+C.ListName);
List_Sort  (C.List,1,Sort_AZ,0);
List_Save  (C.List,Sys.GetPath(SP_TEMP)+C.ListName);
List_Done  (C.List);
End;

{ͻ
                            PROCEDURE Combo_Draw                            
 ͹
  IN.....: C (TCombo) = Pointer to a Combo structure.                       
  OUT....: /                                                                
  EXPLAIN: Redraw the Combo Gadget.                                         
 ͼ}

Procedure Combo_Draw(Var C:TCombo);
Begin
If Not BTST(C.Id,10) Then InputText_Draw(C.Inp);

Button_Draw(C.But);
End;

{ͻ
                            PROCEDURE Combo_Init                            
 ͹
  IN.....: C (TCombo) = Pointer to a Combo structure.                       
  OUT....: /                                                                
  EXPLAIN: Initialise the Combo Gadget.                                     
           This procedure must be called before every others Combo procs.   
 ͼ}

Procedure Combo_Init(Var C:TCombo);
Var D:DirStr;
    N:NameStr;
    E:ExtStr;
    St:String;

Begin
St:=File_BuildNextName(Sys.GetPath(SP_TEMP)+'COMBO.LIS', FEValue);
FSplit(St,D,N,E);
C.ListName:=N+E;                        {*Store Filename*}
File_Create(Sys.GetPath(SP_TEMP)+C.ListName);
Log.Add('Create new ComboBox ('+C.ListName+')',2);
End;

{ͻ
                            PROCEDURE Combo_Done                            
 ͹
  IN.....: C (TCombo) = Pointer to a Combo structure.                       
  OUT....: /                                                                
  EXPLAIN: Kill the Combo Gadget structure.                                 
           This procedure must be called at the end of the Combo management.
 ͼ}

Procedure Combo_Done(C:TCombo);
Begin                                   {*Erase The Combo File*}
File_Erase(Sys.GetPath(SP_TEMP)+C.ListName);
Log.Add('Kill ComboBox ('+C.ListName+')',2);
End;

{ͻ
                           PROCEDURE Combo_Clear                            
 ͹
  IN.....: C (TCombo) = Pointer to a Combo structure.                       
  OUT....: /                                                                
  EXPLAIN: Delete all the list items in the Combo Gadget.                   
 ͼ}

Procedure Combo_Clear(C:TCombo);
Begin
Combo_Done(C);                          {*Erase The Combo File*}
File_Create(Sys.GetPath(SP_TEMP)+C.ListName);
End;

{ͻ
                           PROCEDURE Combo_Freeze                           
 ͹
  IN.....: Status (BOOLEAN) = On = Freeze the Gadget.                       
           C (TCombo) = Pointer to a Combo structure.                       
  OUT....: /                                                                
  EXPLAIN: Freeze or Unfreeze the Combo Gadget.                             
 ͼ}

Procedure Combo_Freeze(Status:Boolean; Var C:TCombo);
Begin
If Status Then BSET(C.Id,1) Else BCLR(C.Id,1);
If Status Then BSET(C.Inp.Id,9);        {*Freeze InputText*}
If Status Then BSET(C.But.Id,1);        {*Freeze Button*}
Combo_Draw(C);
End;

{ͻ
                           FUNCTION Combo_GetMsg                            
 ͹
  IN.....: C (TCombo) = Pointer to a Combo structure.                       
  OUT....: (BYTE) = Message Id as:                                          
               CMNone               No messages                             
               CMSelected           Combo item selected                     
               CMModified           Combo item modified                     
  EXPLAIN: Manage and get messages from a ComboBox component.               
  NB.....: Use "Combo_GetSelectedItem" to get the selected item string.     
  SEEALSO: Combo_Draw, Combo_GetSelectedItem                                
 ͼ}

Function Combo_GetMsg(Var C:TCombo):Byte;
Var Even:Integer;
    XOk,XCancel:Boolean;
    IdWin,IdList:Word;                  {*Flags Id Fentre et Liste*}
    SizeX,SizeY:Integer;
    Res:Longint;                        {*Slection Item Rsultat*}

Begin
Combo_GetMsg:=CMNone;
If BTST(C.Id,1) Then Exit;              {*Gadget Freezed !*}

If Button_GetMsg(C.But,1)=CMSelected Then BSET(C.IdIn,0); {*Display List*}
If (BTST(C.Id,0)) And
   (Mse_TestBox(T_Clip.X1+C.X1, T_Clip.Y1+C.Y1+1, T_Clip.X1+C.X1+C.Sx, T_Clip.Y1+C.Y1+HaF+5, 1)) Then
   Begin
   Repeat Until Not Mse_Clicked(1);     {*Jusqu'a ce qu'on ne clique plus*}
   BSET(C.IdIn,0);

   End;

If Not BTST(C.Id,0) Then                {*Clique dans l'InputText*}
   If InputText_GetMsg(C.Inp,C.Inp.Cin)=CMModified Then
      If (C.Inp.Cin<>'') And (File_TestString(Sys.GetPath(SP_TEMP)+C.ListName,C.Inp.Cin,0,1)=0)

         Then Begin
         Combo_AddItem(C.Inp.Cin, C);
         Combo_GetMsg:=CMModified;      {*Item modified*}
         End;

If BTST(C.IdIn,0) Then                  {*Gestion de la Liste Affiche*}
   Begin
   SizeX:=C.Sx-1;                       {*Adjust Horizontal list size*}
   If BTST(C.Id,5) Then SizeX:=VESA_TextWidth(File_GetLongString(Sys.GetPath(SP_TEMP)+C.ListName))+20;
   SizeY:=HaF*10;
   If BTST(C.Id,6) Then                 {*Adjust vertical list size*}
      SizeY:=(File_CountLines(Sys.GetPath(SP_TEMP)+C.ListName))*(HaF+2)+13;
   If SizeY>=VESA_GetMaxY Then SizeY:=VESA_GetMaxY;
   IdWin:=$1111; If BTST(C.Id,3) Then BSET(IdWin,14);{*Window Movable*}
   Win_Init(C.X1+T_Clip.X1, C.Y1+T_Clip.Y1+HaF+5, C.X1+T_Clip.X1+SizeX+1, C.Y1+T_Clip.Y1+SizeY+5, IdWin,'',C.Win);
   Win_Sup(0,0,0,0,0,0,0,0,0,C.Col3,$3A72,C.Win);{*Supplment*}
   Win_Draw(C.Win);                     {*Affiche la Fentre*}
   Win_Clip(Yes,C.Win);
                                        {*Define list parameters*}

   If BTST(C.Id,7) Then IdList:=$8342 Else IdList:=$8340; {*Prslection / Sensitive*}
   If BTST(C.Id,9) Then BSET(IdList,15) Else BCLR(IdList,15); {*Rotation in list*}
   List_Define(C.List,'',';',0,0,C.Win.X2-C.Win.X1-2,C.Win.Y2-C.Win.Y1-2, C.QttMaxItems,C.Col3,C.Col3,IdList);
   List_Load(C.List,Sys.GetPath(SP_TEMP)+C.ListName);
   If BTST(C.Id,8) Then List_Sort(C.List,1,Sort_AZ,0);{*Sort the List*}
   List_AdjustColumns(C.List);
   List_Show(C.List);
   Win_Clip(No,C.Win);
   XOk:=FALSE; XCancel:=FALSE;

   Repeat
   If Win_Ready(C.Win) Then             {*Teste si Fentre Prte*}
      Begin                             {*Test des Gadgets Personnels*}
      Win_Clip(Yes,C.Win);
      Res:=List_Test(C.List);           {*Test de la Liste*}
      Win_Clip(No,C.Win);
      If Res>0 Then XOk:=TRUE;          {*Slectionn !*}
      End;

   Even:=Win_Test(C.Win);
   If Even=CMClosed Then XCancel:=TRUE;        {*Window Inactivated => Exit*}
   If Even=CMInactivated Then XCancel:=TRUE;        {*Window Inactivated => Exit*}
   If Even=CMMoved Then Begin
      Win_Clip(Yes,C.Win);
      List_Show(C.List);                {*Window Moved => Display List*}
      Win_Clip(No,C.Win);
      End;
   Until (XOk) Or (XCancel);            {*Flag de Sortie*}

   Win_Done(C.Win);                     {*Supprime Fentre*}
   If XOk Then Begin                    {*Affiche Rsultat*}
{      Combo_SetItem(C,Res);}           {*Ne peux pas tre utilis, car ne tri pas la liste*}
      C.Inp.Cin:=List_GetStringCell(C.List,Res,1);
      C.Selected:=Res;
      Combo_GetMsg:=CMSelected;         {*Item selected*}
      Win_Clip(Yes,C.Win);
      Combo_Draw(C);                    {*Raffiche Combo Value*}
      Win_Clip(No,C.Win);
      End;
   List_Done(C.List);
   BCLR(C.IdIn,0);                      {*No displaying List now*}
   End;
End;

{}
{}
{}

{ͻ
                               PROCEDURE Tabs                               
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Box coordinates.                         
           No (INTEGER) = First selected Tabs.                              
           Coa, Coi (LONGINT) = Tabss colors.                               
           Id (WORD) = Bits to parameter Tabss :                            
              Bit 0  $0001 = Freezed            Freezed Tabs                
              Bit 1  $0002 = Invisible Tabs     Invisible Tabs              
              Bit 2  $0004 = Hand Pointer       Hand Mouse Pointer on title 
           O (TTabss) = Pointer to an Tabs structure.                       
           Cin (STRING) = Tabs Title (words are separated by '|').          
  OUT....: /                                                                
  EXPLAIN: Build and display an Tabs Gadget.                                
 ͼ}

Procedure Tabs(X1,Y1,X2,Y2,No:Integer; COa,COi:LongInt; Id:Word; Var O:TTabs; Cin:String);
Begin
Tabs_Define(O, X1,Y1,X2,Y2,No, COa,COi,Id,$FFFF,Cin,'','');

Tabs_Draw(O);                              {*Va Afficher le Bouton Radio*}
If BTST(Id,0) Then Tabs_Freeze(Yes,O);     {*Freeze l'Tabs*}
End;

{ͻ
                           PROCEDURE Tabs_Define                            
 ͹
  IN.....: O (TTabss) = Pointer to an Tabs structure.                       
           X1,Y1,X2,Y2 (INTEGER) = Box coordinates.                         
           No (INTEGER) = First selected Tabs.                              
           Coa, Coi (LONGINT) = Tabss colors.                               
           Id (WORD) = Bits to parameter Tabss :                            
              Bit 0  $0001 = Freezed            Freezed Tabs                
              Bit 1  $0002 = Invisible Tabs     Invisible Tabs              
              Bit 2  $0004 = Hand Pointer       Hand Mouse Pointer on title 
           AvailableTabs (WORD) = Available tabs sheets.                    
           Cin (STRING) = Tabs Title (words are separated by '|').          
           MPointer (STRING) = Defined mouse pointer.                       
           SHint (STRING) = Defined hint.                                   
  OUT....: /                                                                
  EXPLAIN: Build and display an Tabs Gadget.                                
 ͼ}

Procedure Tabs_Define(Var O:TTabs; X1,Y1,X2,Y2,No:Integer; COa,COi:LongInt; Id,AvailableTabs:Word; Cin,MPointer,SHint:String);
Var C:TCoordinates;

Begin
Log.Add('Create new Tabs',2);

C.X1:=X1; C.Y1:=Y1+2; C.X2:=X2-1; C.Y2:=Y1+2+HaF+8;

MseZone(O.Pointer,C,10,MPointer,SHint); {*Define mouse pointer and Hint*}

If Id_Scr1 And $8=$8 Then Begin         {*Window Clipped*}
   X1:=X1+T_Clip.X1; Y1:=Y1+T_Clip.Y1;  {*Restore True Coordones*}
   X2:=X2+T_Clip.X1; Y2:=Y2+T_Clip.Y1;
   End;

O.X1:=X1;                               {*Save Values & Correct It !*}
O.Y1:=Y1;
O.X2:=X2;
O.Y2:=Y2;

O.Id:=Id;
O.COa:=COa;
O.COi:=COi;

If Cin[Length(Cin)]='|' Then SetLength(Cin,Length(Cin)-1);
O.QttO:=Str_Count(Cin,'|');
O.TCT:=Cin;

If O.QttO<=0 Then Inc(O.QttO);          {*1 Tabs Minimum*}
If No>O.QttO Then No:=O.QttO;           {*Cannot Suprieur au Maximum*}
If No<1 Then No:=1;                     {*Cannot Infrieur  1*}
O.STxt:=HaF+10;                         {*Delta Y des Labels Tabss*}
O.No:=No;
O.AvailableTabs:=AvailableTabs;         {*All tabs sheets available*}
End;

{ͻ
                            PROCEDURE Tabs_Draw                             
 ͹
  IN.....: O (TTabss) = Pointer to an Tabs structure.                       
  OUT....: /                                                                
  EXPLAIN: Display Tab sheets.                                              
  EXAMPLE: Tabs_Draw(Ong1);                                                 
 ͼ}

Procedure Tabs_Draw(Var O:TTabs);
Const Del=2;                                  {*Delta pour Agrandissement Bouton*}
Var X1,Y1,X2,Y2:Integer;
    SxO,Sy:Integer;
    Xc,Yc:Integer;
    A:Integer;                                {*Loop*}
    CfS:Longint;
    FirstAvailableTab:Integer;          {*First available tab*}

{********************** AFFICHE UN Tabs DE POSITION "n" *******************}

Procedure DRAW_ONE_Tabs(N,T:Byte);
Var D:Shortint;
    Px,Sx,Ax,Bx,I:Integer;
    C:Longint;
    B:TButton;                                   {*Faux Bouton...*}
    BId:Word;                                    {*Button Id*}

Procedure ARRONDIS_ANGLE(X,U,V,Co:Longint);
Begin
VESA_Putpixel(X+U+1,Y1+D,CfS);   VESA_Putpixel(X+V+1,Y1+D,CfS);
VESA_Putpixel(X+U+1,Y1+D+1,CfS); VESA_Putpixel(X+V+1,Y1+D+1,Co);
End;

{***************************** MAIN SECON CODE ******************************}

Begin
If T=0 Then Begin D:=1;  C:=O.COi; End  {*Couleurs Diffrentes*}
       Else Begin D:=-1; C:=O.COa; End;

Px:=X1+SxO*(N-1); Sx:=SxO-1;
Bx:=X1+SxO*N-2;
If T=1 Then
   Begin
   If N>1 Then Begin Px:=Px-Del; Bx:=Bx+Del; Sx:=Sx+Del; End Else Bx:=Bx+Del;
   If N<O.QttO Then Sx:=Sx+Del Else Bx:=Bx-Del;
   End;

Ax:=Px; Sy:=O.STxt-D;                   {*Affiche le Bouton...*}
If BTST(O.Id,3) Then C:=O.COa;
If BTST(O.Id,4) Then Sy:=Sy-6;
If BTST(O.AvailableTabs,N-1) Then BId:=$0000 Else BId:=$0002;

Button (Px, Y1+D, Sx, Sy, CLBlack,C, BId ,B,Str_Get(O.TCT,N,'|'));

Mse_Hide;
ARRONDIS_ANGLE(Ax,-1,0,CLWhite);        {*Arrondis les Angles...*}
ARRONDIS_ANGLE(Bx,0,-1,CLBlack);

VESA_SetColor(O.COa);                   {*Del 2 Lines du Bas du Bouton*}
If T=1 Then
   For I:=0 to 1 do
      VESA_Line(Px+1, Y1+Sy-1+I, Px+Sx-1, Y1+Sy-1+I);
Mse_Show;
End;

{******************************** MAIN CODE *********************************}

Begin
If Id_Scr1 And $8=$8 Then Begin               {*Window Clipped*}
   Xc:=T_Clip.X1; Yc:=T_Clip.Y1;
   X1:=O.X1-Xc; Y1:=O.Y1-Yc;                  {*Set Relative Coordones*}
   X2:=O.X2-Xc; Y2:=O.Y2-Yc;
   End Else Begin                             {*No Modifs...*}
   X1:=O.X1; Y1:=O.Y1; X2:=O.X2; Y2:=O.Y2;
   End;

Mse_Hide;
CfS:=VESA_GetPixel(X1, Y1-2);                 {*Couleur de Fond de l'Ecran*}
Mse_Show;
If BTST(O.Id,1) Then Begin                    {*Invisible Gadget....*}
   Bevel(X1-1,Y1+O.STxt,X2-1,Y2, CfS);        {*Efface la Zone de Travail Quand Mme !*}
   Exit;
   End;

FirstAvailableTab:=-1;
For A:=1 to O.QttO do                   {*Set active Tab to first free Tab*}
   If (BTST(O.AvailableTabs,A-1)) And (FirstAvailableTab=-1) Then FirstAvailableTab:=A;
If O.No<FirstAvailableTab Then O.No:=FirstAvailableTab;

	  {=== AFFICHAGE DE LA MATRICE ===}

Sy:=Y1;
If BTST(O.Id,4) Then Sy:=Sy-6;
Bevel (X1,Sy+O.STxt+1,X2,Y2, O.COa,BLRaisedLine,BLNoLine,Yes); {*Affichage de la Matrice*}
Bevel (X1, Y1-2 ,X2, Y1+2, Cfs);              {*Efface dessus du Grand Tabs*}

	  {=== AFFICHAGE DES DIFFERENTS TabsS ===}

SxO:=(X2-X1) Div O.QttO;                      {*Size X d'un Tabs*}
For A:=1 to O.QttO do
   If A<>O.No Then DRAW_ONE_Tabs(A,0);      {*Affiche les Tabs Standard*}

DRAW_ONE_Tabs(O.No,1);                      {*Affiche l'Tabs Activ*}
End;

{ͻ
                          PROCEDURE Tabs_SetSheet                           
 ͹
  IN.....: O (TTabs) = Pointer to an TTabs structure.                       
           Sheet (BYTE) = The TabSheet number.                              
  OUT....: /                                                                
  EXPLAIN: Activate and display the specified TabSheet.                     
  EXAMPLE: Tabs_SetSheet(Ong1,3);                                           
 ͼ}

Procedure Tabs_SetSheet(Var O:TTabs; Sheet:Byte);
Begin
If (O.No<=0) Or (O.No>O.QttO) Then Exit;
O.No:=Sheet;
Tabs_Draw(O);
End;

{ͻ
                         PROCEDURE Tabs_EnableTabs                          
 ͹
  IN.....: O (TTabs) = Pointer to an TTabs structure.                       
           AvailableTabs (WORD) = Enabled tabs sheets.                      
              Each bit enable a Tab sheet (left to right).                  
  OUT....: /                                                                
  EXPLAIN: Enable or disable Tabs sheets.                                   
 ͼ}

Procedure Tabs_EnableTabs(Var O:TTabs; AvailableTabs:Word);
Begin
O.AvailableTabs:=AvailableTabs;
End;

{ͻ
                           PROCEDURE Tabs_Freeze                            
 ͹
  IN.....: Status (BOOLEAN) = TRUE = Freeze Tabs.                           
           O (TTabss) = Pointer to an Tabs structure.                       
  OUT....: /                                                                
  EXPLAIN: Freeze or UnFreeze the specified Tabs.                           
  EXAMPLE: Tabs_Freeze(On,Ong1);                                            
 ͼ}

Procedure Tabs_Freeze(Status:Boolean; Var O:TTabs);
Var Xd,Yd:Integer;

Begin
If Id_Scr1 And $8=$8 Then Begin            {*Window Clipped*}
   Xd:=-T_Clip.X1-1; Yd:=-T_Clip.Y1-12;    {*Set Relative Coordones*}
   End Else Begin
   Xd:=0; Yd:=0;                           {*No Modifs...*}
   End;

If (Status=Yes) And (Not BTST(O.Id,14)) Then{*Tabs  Dsactiver*}
   Begin
   BSET(O.Id,14);
   Bar_FillGray(O.X1+Xd, O.Y1+Yd, O.X2+Xd, O.Y1+Yd+O.STxt);
   End;
If (Status=No) And (BTST(O.Id,14)) Then   {*Tabs  Activer*}
   Begin
   BCLR(O.Id,14);
   Tabs_Draw(O);
   End;
End;

{ͻ
                            FUNCTION Tabs_GetMsg                            
 ͹
  IN.....: O (TTabss) = Pointer to an Tabs structure.                       
           M (BYTE) = Mouse Button to activate Tabss.                       
  OUT....: (BYTE) = Message Id as:                                          
               CMNone               No messages                             
               CMSelected           Tab sheet has been selected             
  EXPLAIN: Manage tabs.                                                     
  EXAMPLE: If Tabs_GetMsg(Ong1,1)=CMSelected Then ...                       
 ͼ}

Function Tabs_GetMsg(Var O:TTabs; M:Byte):Byte;
Var      X,Y,A:Word;
	 Ga,Mi,Dr:Boolean;
	 SxO,Sy:Integer;                       {*Taille X d'un Tabs*}
Begin
Tabs_GetMsg:=CMNone;

If BTST(O.Id,0) Then Exit;                  {*Tabs Freezed non Test*}

Mse_Get(X,Y,Ga,Mi,Dr);                    {*Get Mouse Infos*}

SxO:=(O.X2-O.X1) Div O.QttO;                {*Size X d'un Tabs*}
If BTST(O.Id,4) Then Sy:=6 Else Sy:=0;

	  {=== GESTION DU TPointer HAND ===}

If BTST(O.Id,2) Then MseZone_GetMsg(O.Pointer);

	  {=== GESTION DE LA SELECTION DES TabsS ===}

For A:=1 to O.QttO do                       {*Parcours tous les Tabss*}
   If Mse_TestBox(O.X1+SxO*(A-1)-1, O.Y1+2, O.X1+SxO*A-2, O.Y1+O.STxt-Sy, 10) Then
      Begin
      If (Mse_Clicked(M)) And (O.No<>A) And (BTST(O.AvailableTabs,A-1)) Then
	 Begin
	 O.No:=A;
	 Tabs_Draw(O);
	 Tabs_GetMsg:=CMSelected;            {*Tabs Activ*}
	 BCLR(Id_Gad1,5);                    {*Plus de Pointer Hand sur Boutons*}
	 BCLR(Id_Msg1,3);                    {*Plus de Pointer Hand sur Commands*}
	 End;
      End;
End;

{*------------------------ PAS DE PROG PRINCIPAL ---------------------------*}

Begin
End.
