{ͻ
                               UNIT MosTasks                                
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 31.01.1998                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: Manage the MOS system (Threads, main call, tasks...).        
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 844 Lines and (17.008 Bytes compiled)                        
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosTasks;

{$Mode Objfpc}

INTERFACE

{|Program execution|}
Procedure Execute_MOS(Path, CmdLine:String);{*Execute a MOS program*}

{|MOS initialisations|}
Procedure Init_Screen;                  {*Initialise the graphic screen*}
Procedure Done_Screen;                  {*Restore initial text mode*}

{|Miscelaneous|}
Procedure Main_Task;                    {*Manage All Main MOS Tasks*}

{*----------------------------- Debut Library ------------------------------*}

IMPLEMENTATION

Uses
     Dos,
     SysUtils,
     Windows,
     MosBase,
     MosBlankers,
     MosColors,
     MosConfig,
     MosCPUInstructions,
     MosErrors,
     MosExecute,
     MosFiles,
     MosGadgets,
     MosGraph,
     MosGraphics,
     MosImages,
     MosKeyboard,
     MosMouse,
     MosRequests,
     MosStrings,
     MosWindows;

{****************************************************************************}
{****************************************************************************}
{****************************************************************************}

{ͻ
                         PROCEDURE MANAGE_SNAPSHOT                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Gre et crer des Snapshots d'crans...                          
 ͼ}

Procedure MANAGE_SNAPSHOT;             {*Generate Snapshot...*}
Var X1,Y1,X2,Y2:Integer;
Begin
If Kbd_GetKeyDown(VK_SNAPSHOT) Then       {*Print Screen Key*}
//If Kbd_TestKey(0,82) Then       {*INSERT Key*}
   Begin
   If Kbd_GetKeyDown(VK_LSHIFT) then
//   If Kbd_TestSpecialKey($02,B_OR) Then
      Begin
      X1:=Sys.WinCurrentCoord.X1; Y1:=Sys.WinCurrentCoord.Y1;
      X2:=Sys.WinCurrentCoord.X2; Y2:=Sys.WinCurrentCoord.Y2;
      End;
   If Kbd_GetKeyDown(VK_RSHIFT) then
//   If Kbd_TestSpecialKey($01,B_OR) Then
      Begin
      X1:=0; Y1:=0; X2:=VESA_GetMaxX; Y2:=VESA_GetMaxY;
      End;
   BMP_Create(File_BuildNextName(Sys.GetPath(SP_SNAPSHOTS)+'SNAP.BMP', FEValue),X1,Y1,X2,Y2);
   End;
End;

{ͻ
                          PROCEDURE Process_Select                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Manage applications process                                      
 ͼ}

Procedure Process_Select;
Const Border=3;
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flags*}
    WSx           :Integer;
    FName,FProc   :String;
    Qtt_Process   :Integer;
    Com1          :TInputText;
    Pp            :Byte;                {*Position du process Affich*}
    X1,Y1,X2,Y2   :Integer;
    St            :String;
    PId,Code      :Word;

Procedure TOGGLE_ICON(Num,C:Byte);
Begin
X1:=(Num-1)*45+30-Border-1; X2:=X1+35+Border*2-1;
Win_Clip(TRUE,W1);                      {*Clipping Window*}
VESA_SetColor(C);
VESA_SetLineStyle(0,0,3);               {*Trait pais*}
VESA_Rectangle(X1,Y1-Border-6,X2,Y2+Border-6);
VESA_SetLineStyle(0,0,1);               {*Trait pais*}
Win_Clip(FALSE,W1);                     {*Restore Normal Clipping*}
End;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Var A:Integer;
Begin
Win_Clip(TRUE,W1);                      {*Clipping Window*}
Font_Set('MODN.CHR',4);
InputText(10,60,WSx-20,70,CLText,CLText,1,$27,Com1,Com1.Cin);
For A:=1 to Qtt_Process do
   Begin                                {*Affiche tous les process*}
   Show_Icon((A-1)*45+30,Y1, Sys.GetPath(SP_ICONS)+'I_INST.ICO');
   End;
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
TOGGLE_ICON(Pp,CLShadow);
End;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure INIT_FRAME;                   {*Define Window Content*}
Begin
FName:=Sys.GetPath(SP_TEMP)+'PID.LIS';
File_Erase(FName);                      {*Kill old PId list*}
File_GetDirectory(Sys.GetPath(SP_PROCESS)+'*.PID', FName);
Qtt_Process:=File_CountLines(FName);    {*How many process ?*}
WSx:=100+((35+10)*Qtt_Process);
Y1:=16; Y2:=Y1+35;
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
BSET(Id_Sys1,3);                        {*On peux plus rouvrir la fentre*}
INIT_FRAME;                             {*Calcule la taille de la fentre*}

If Not Win_Init(0,0,WSx,80,$1501,'',W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLLightGrey,$0054,W1); {*Supplement*}
Win_Draw(W1);                           {*Display Window*}

Com1.Cin:='';
Pp:=1;                                  {*Process 1 to Display*}
REDRAW_FRAME;                           {*Display Window Content*}
XOk:=No; XCancel:=No;                   {*Init Exit Flags*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(TRUE,W1);                   {*Clipping Window*}
   if Kbd_GetKeyDown(VK_MENU) and Kbd_GetKeyDown(VK_A) then
      Begin                             {*ALT + A => NEXT Process*}
      TOGGLE_ICON(Pp,CLWinBg);
      Inc(Pp);
      If Pp>Qtt_Process Then Pp:=1;
      TOGGLE_ICON(Pp,CLShadow);
      End;
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;     {*Window Closed   => Exit*}
//If Not Kbd_TestSpecialKey($08,B_OR) Then XOk:=TRUE;
If Kbd_GetKeyDown(VK_MENU) Then XOk:=TRUE;
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flags*}

Win_Done(W1);                           {*Close Window if Needs*}

If XOk Then Begin                       {*Switch to new application*}
   FProc:=Sys.GetPath(SP_PROCESS)+File_GetLine(FName,Pp);
   St:=File_GetLine(FProc, File_TestString(FProc,'Process Id',1,1));
   Val(Str_Extract(St,'(',')'), PId,Code);{*Extract PId*}
   End;

File_Erase(FName);                      {*Kill PId list*}
Kbd_PurgeBuffer;                        {*L, on peut le faire*}
BCLR(Id_Sys1,3);                        {*On peux de nouveau rouvrir la fentre*}
End;

{ͻ
                          PROCEDURE Process_Manage                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Manage applications process                                      
 ͼ}

Procedure Process_Manage;
Begin
If BTST(Id_Sys1,3) Then Exit;           {*Process window yet oppened*}

If Not Sys.EnableTasksManager Then Exit;{*Pas de tasks manager*}

if kbd_getkeydown(VK_MENU) and kbd_getkeydown(VK_A) then
   Begin
   Process_Select;                      {*Call the Process Window*}
   End;
End;

{ͻ
                          PROCEDURE Main_Task                               
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Manages all the tasks like errors, mouse blankers..              
  NB.....: This procedure must be called regulary, and often.               
           For example, if you make a loop, include this procedure into.    
  SEEALSO: Main_TaskBase                                                    
 ͼ}

Procedure Main_Task;                    {*Gre System (Blankers, Errors...)*}
Begin
If Sys.DisplayRegister = RRToDisplay Then Req_Register; {*Display Register Requester*}
Mse_Blanker;                            {*Gre le Mouse Blanker*}
SCREEN_BLANKER;                         {*Gre le Screen Blanker*}
MANAGE_SNAPSHOT;                        {*Generate Snapshot...*}
Process_Manage;                         {*Manage applications process*}
End;

{ͻ
                           PROCEDURE Execute_MOS                            
 ͹
  IN......: Path (STRING) = Path + Filename of the program to run.          
            CmdLine (STRING) = Parameters for the program.                  
  OUT.....: /                                                               
  EXPLAIN.: Execute a MOS program without going to DOS.                     
  NB......: Please be sure that the program to run is really a MOS program. 
 ͼ}

Procedure Execute_MOS(Path, CmdLine:String);
Var P1:String;
Begin
P1:=FExpand(FSearch(Path,GetEnv('PATH')));{*Search Name Prog*}
If Not File_TestExist(P1) Then
  Begin
  Error(682);
  Exit;
  End; {*.EXE Not Found !*}

Save_Config(Sys.GetPath(SP_TEMP)+'MOS.TMP');
CmdLine:=CmdLine+' -LMP -HOME -INI='+Sys.GetPath(SP_TEMP)+'MOS.TMP';
Mse_SetPointer(MPBusy);
Execute(Path,CmdLine,$117E);              {*Execute a MOS Program...*}
File_Erase(Sys.GetPath(SP_TEMP)+'MOS.TMP'); {*Dtruit Fichier Temporaire...*}
End;

{ͻ
                           PROCEDURE Init_Screen                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Initialise the graphic screen.                                   
 ͼ}

Procedure Init_Screen;                  {*Init Screen Gfx*}
Begin
Init_BootGfx;                           {*Display boot image*}
Init_Graph;                             {*Initialisation du mode graphique*}
Init_Register;                          {*Requeter Register*}

Init_Keyboard;                          {*Initialise keyboard*}
Init_Display;                           {*Display Bg and init some Gfx*}
Init_Password;                          {*Password pour Connection*}
End;

{ͻ
                           PROCEDURE Done_Screen                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Restore the initial text screen.                                 
 ͼ}

Procedure Done_Screen;                  {*Restore Normal Screen*}
Begin
Done_Graph;                             {*Ferme Mode Graphique*}
Done_Demo;                              {*Close current demo*}
Done_Message;                           {*Message de Fin si Dmo Version*}
Done_Keyboard;                          {*Restore keyboard options*}
End;

{*------------------------ PAS DE PROG PRINCIPAL ---------------------------*}

Begin
End.
