{ͻ
                                UNIT MosText                                
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 20.12.1998                                                   
  COUNTRY....: Perpignan - (FRANCE)                                         
  DESCRIPTION: Text, hypertext and coordinates management.                  
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 587 Lines and (13.648 Bytes compiled)                        
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosText;

{$Mode ObjFpc}

INTERFACE

Uses
     MosConfig;

Const

   TJOnLeft     = 1;                    {*Text justify*}
   TJOnRight    = 2;
   TJOnCenter   = 3;
   TJOnTop      = 4;
   TJOnBottom   = 5;
   TJJustify    = 6;

   TDHorizontal = 0;                    {*Text direction*}
   TDVertical   = 1;

   FABold       = $0001;                {*Font attributes*}
   FAItalic     = $0002;
   FAUnderlined = $0004;
   FAStrikeout  = $0008;
   FAExposant   = $0010;
   FAIndice     = $0020;

Type                                    {*Structure dfinition*}

TFont=Record                            {*Font structure*}
   Name                :String[12];     {*Font filename*}
   Size                :Byte;           {*Font size*}
   PenColor            :LongInt;           {*Font pen color*}
   BgColor             :LongInt;           {*Font background color*}
   Direction           :Byte;           {*Writing direction. 0=Default*}
   Style               :Word;           {*Font attributes*}
       {  Bit 0  $0001 :  1 = FABold}
       {  Bit 1  $0002 :  1 = FAItalic}
       {  Bit 2  $0004 :  1 = FAUnderlined}
       {  Bit 3  $0008 :  1 = FAStrikeout}
       {  Bit 4  $0010 :  1 = FAExposant}
       {  Bit 5  $0020 :  1 = FAIndice}
   End;

TText=Record                            {*Text structure*}
   X,Y                 :Integer;        {*Position*}
   Width               :Integer;        {*Text width (usefull for clipping)*}
   Height              :Integer;        {*Text height (usefull for clipping)*}
   Caption             :String;         {*Caption*}
   Font                :TFont;          {*Used font*}
   Popup               :String[12];     {*Popup menu file definition*}
   Hint                :String[12];     {*Hint file to display*}
   MaskSep             :Char;           {*Mask separator for LCD displaying*}
   HJustify            :Byte;           {*Horizontal justify method*}
       {  1 = TJOnLeft      Left justify}
       {  2 = TJOnRight     Right justify}
       {  3 = TJOnCenter    Center}
       {  6 = TJJustify     Justify text}
   VJustify            :Byte;           {*Vertical justify method*}
       {  4 = TJOnTop       Top justify}
       {  5 = TJOnBottom    Bottom justify}
       {  3 = TJOnCenter    Center}
   Id                  :Word;           {*Bits for miscellaneous attributes*}
       {  Bit 0  $0001 :  1 = Clear background}
       {  Bit 1  $0002 :  1 = Text clipped in box}
       {  Bit 2  $0004 :  1 = Text in relieve}
       {  Bit 3  $0008 :  1 = Text in shadow}
       {  Bit 4  $0010 :  1 = LCD display mode}
       {  Bit 5  $0020 :  1 = Set defined font}
       {  Bit 6  $0040 :  1 = Only clear background under text}
   End;

TScreenContext=Record                   {*Screen context structure*}
   Clip                :TCoordinates;   {*Main clipping*}
   WinClip             :TCoordinates;   {*Window clipping*}
   WinClipped          :Boolean;        {*Window is clipped*}
   Limit               :TCoordinates;   {*Mouse limits box*}
   ClipState           :Boolean;        {*Clipping state*}
   FontsFile           :Array[1..2] of ShortString;
   FontsSize           :Array[1..2] of Byte; {*Font*}
   End;

{|Text management|}
Procedure Display       (    X,Y:Integer; PenColor:Longint; Caption:String);{*Define and display a text*}
Procedure Display       (    X,Y,Width:Integer; PenColor:Longint; Caption:String; HJustify:Byte);{*Display a justified text*}
Procedure Display       (    X,Y:Integer; PenColor:Longint; Value:Longint); {*Define and display a value*}
Procedure Display       (    X,Y:Integer; PenColor:Longint; Font:String; FontSize:Word; Caption:String);{*Display a text with special font*}
Procedure Display_Attr  (    X,Y:Integer; BgColor,PenColor:LongInt; Id:Word; Caption:String);{*Old Display_Attr emulation*}
Procedure Display_Draw  (Var Text:TText);              {*Display a text*}
Procedure Display_Define(Var Text:TText; X,Y:Integer; BgColor,PenColor:Longint; Font:String; FontSize,HJustify:Byte;
                             Id:Word; Caption:String); {*Define text*}
{|Hypertext management|}

Procedure HText         (    X,Y:Integer; PenColor:Longint; Caption:String);{*Define and display hypertext*}

{|Coordinates management|}
Function  Coord_SetInStruct    (    X1,Y1,X2,Y2:Integer; Var C:TCoordinates):Boolean; {*Set coordinates in a structure*}
Function  Coord_RealClipBox    (Var VX1,VY1,VX2,VY2:Integer):Boolean; {*Cut Real coordinates to set in current window*}
Function  Coord_TestEqual      (    C1,C2:TCoordinates):Boolean;      {*Test if coordinates are identical*}
Procedure Coord_RelativeClipBox(Var VX1,VY1,VX2,VY2:Integer);{*Cut Relative coordinates to set in current window*}
Procedure Coord_BoxInScreen    (Var X1,Y1,X2,Y2:Integer);    {*Put the box in screen*}
Procedure Coord_BoxCorrect     (Var X1,Y1,X2,Y2:Integer);    {*Verify coherence*}
Procedure Coord_WinInScreen    (Var x1,y1,x2,y2:Integer);    {*Put the window in the screen*}
Procedure Coord_PointInScreen  (Var X,Y:Integer);            {*Put coordinates in screen*}
Function  Coord                (X1,Y1,X2,Y2:Integer):TCoordinates; {*Set coordinates in struct*}

{|Context management|}
Procedure Save_Context    (Var C:TScreenContext; Mode:Byte); {*Save the screen context*}
Procedure Restore_Context (    C:TScreenContext);            {*Restore the screen context*}

{*---------------------------- Debut Library -------------------------------*}

IMPLEMENTATION

Uses
     MosBase,
     MosColors,
     MosCPUInstructions,
     MosGraph,
     MosMouse,
     MosStrings;

{*---------------------------- Debut Library -------------------------------*}

Function Mse_TestClippedBox(C:TCoordinates):Boolean;
Const Sp=16;                            {*Mouse pointer size in pixel*}
Begin
If Id_Scr1 And $8=$8 Then Begin         {*Window Clipped*}
   Inc(C.X1,T_Clip.X1);
   Inc(C.Y1,T_Clip.Y1);
   Inc(C.X2,T_Clip.X1);
   Inc(C.Y2,T_Clip.Y1);
   End;
If Mse_TestBox(C.X1-Sp,C.Y1-Sp,C.X2+Sp,C.Y2+Sp,10) Then Mse_TestClippedBox:=Yes Else Mse_TestClippedBox:=No;
End;

{*-------------------------------- Context ---------------------------------*}

{ͻ
                           PROCEDURE Save_Context                           
 ͹
  IN.....: C (TScreenContext) = Pointer to the TScreenContext structure.    
           Mode (BYTE) = 1 : Reinit context.                                
  OUT....: /                                                                
  EXPLAIN: Save the screen context (Viewport, etc...) in the Context record.
 ͼ}

Procedure Save_Context(Var C:TScreenContext; Mode:Byte);
Var VP:TViewPortType;
Begin
VESA_GetViewSettings(VP);
C.Clip.X1:=VP.X1;                       {*Save main clipping definition*}
C.Clip.Y1:=VP.Y1;
C.Clip.X2:=VP.X2;
C.Clip.Y2:=VP.Y2;
C.ClipState:=VP.Clip;

C.WinClip.X1:=T_Clip.X1;                {*Save window clipping definiton*}
C.WinClip.Y1:=T_Clip.Y1;
C.WinClip.X2:=T_Clip.X2;
C.WinClip.Y2:=T_Clip.Y2;
C.WinClipped:=BTST(Id_Scr1,3);          {*Window is clipped ?*}

Mse_GetLimit(C.Limit.X1,C.Limit.Y1,C.Limit.X2,C.Limit.Y2);

C.FontsFile[1]:=Sys.FontCurrent;        {*Save fonts*}
C.FontsSize[1]:=Sys.FontCurrentSize;

C.FontsFile[2]:=Sys.FontPrevious;
C.FontsSize[2]:=Sys.FontPreviousSize;

If Mode=1 Then
   Begin                                {*Reset all*}
   VESA_SetViewPort(0,0,VESA_GetMaxX,VESA_GetMaxY,ClipOn);
   Mse_SetLimit(0,0,VESA_GetMaxX,VESA_GetMaxY);
   End;
End;

{ͻ
                         PROCEDURE Restore_Context                          
 ͹
  IN.....: C (TScreenContext) = Pointer to the TScreenContext structure.    
  OUT....: /                                                                
  EXPLAIN: Restore the screen context (Viewport...) from the Context record.
 ͼ}

Procedure Restore_Context(C:TScreenContext);
Begin
VESA_SetViewPort(C.Clip.X1,C.Clip.Y1,C.Clip.X2,C.Clip.Y2,ClipOn);
Mse_SetLimit(C.Limit.X1,C.Limit.Y1,C.Limit.X2,C.Limit.Y2);

T_Clip.X1:=C.WinClip.X1;                {*Restore window clipping definiton*}
T_Clip.Y1:=C.WinClip.Y1;
T_Clip.X2:=C.WinClip.X2;
T_Clip.Y2:=C.WinClip.Y2;
If C.WinClipped Then BSET(Id_Scr1,3) Else BCLR(Id_Scr1,3);

Sys.FontCurrent:=C.FontsFile[1];
Sys.FontCurrentSize:=C.FontsSize[1];

Sys.FontPrevious:=C.FontsFile[2];
Sys.FontPreviousSize:=C.FontsSize[2];

Font_Set(Sys.FontCurrent,Sys.FontCurrentSize);

Sys.SlidersActivated:=0;                {*No slider has been activated*}
Sys.ButtonsActivated:=0;                {*No buttons has been activated*}
End;

{*------------------------- HyperText Management ---------------------------*}

{ͻ
                              PROCEDURE HText                               
 ͹
  IN.....: X,Y (INTEGER) = Coordinates of the text to display.              
           PenColor (LONGINT) = Pen color of the text.                      
           Caption (STRING) = Text to display.                              
  OUT....: /                                                                
  EXPLAIN: Define and display an hypertext in current window.               
           This procedure allow you to display quickly a simple text        
           without define a TText structure. If you want to display special 
           text, use the functions listed below and set parameters yourself.
  NB.....: Hypertext is common text with special tags.                      
           Color tag: '#' followed by the color number. Ex: 'Hello #15world'
 ͼ}

Procedure HText(X,Y:Integer; PenColor:Longint; Caption:String);
Var St:String;
    Width,A,Color:LongInt;
    ColSize,Words,Segment:Byte;
    Res:Longint;
Begin
Width:=0; Color:=PenColor;
Words:=Str_CountItem(Caption,'#');
Inc(Words);                             {*1 mot de plus*}
For A:=1 to Words do
   Begin
   St:=Str_Get(Caption,1,'#');
   Display(X+Width,Y,Color,St);         {*Display segment*}
   Segment:=Length(St);
   Color:=Str_S2L(Copy(Caption,Segment+2,2)); ColSize:=2;
   If Color=-1 Then Begin Color:=Str_S2L(Copy(Caption,Segment+2,1)); ColSize:=1; End;
   If Color=-1 Then Begin Color:=PenColor; ColSize:=0; End;
   Case Color of                        {*Correspondance des code #xx dans Textes*}
      00: Res:=VESA_SetRGBColor(0 *4,0 *4,0 *4);
      01: Res:=VESA_SetRGBColor(33*4,33*4,33*4);
      02: Res:=VESA_SetRGBColor(27*4,42*4,10*4);
      03: Res:=VESA_SetRGBColor(20*4,36*4,44*4);
      04: Res:=VESA_SetRGBColor(0 *4,42*4,42*4);
      05: Res:=VESA_SetRGBColor(50*4,53*4,51*4);
      06: Res:=VESA_SetRGBColor(42*4,44*4,49*4);
      07: Res:=VESA_SetRGBColor(42*4,42*4,42*4);
      08: Res:=VESA_SetRGBColor(23*4,25*4,25*4);
      09: Res:=VESA_SetRGBColor(25*4,32*4,54*4);
      10: Res:=VESA_SetRGBColor(45*4,55*4,27*4);
      11: Res:=VESA_SetRGBColor(21*4,63*4,63*4);
      12: Res:=VESA_SetRGBColor(40*4,53*4,63*4);
      13: Res:=VESA_SetRGBColor(63*4,54*4,41*4);
      14: Res:=VESA_SetRGBColor(63*4,39*4,17*4);
      15: Res:=VESA_SetRGBColor(63*4,63*4,63*4);
      End;
   Color:=Res;
   Inc(Width,VESA_TextWidth(St));
   Caption:=Copy(Caption,Segment+2+ColSize,255);
   End;
End;

{*---------------------------- Text Management -----------------------------*}

{ͻ
                             PROCEDURE Display                              
 ͹
  IN.....: X,Y (INTEGER) = Coordinates of the text to display.              
           Width (INTEGER) = Text horizontal box size.                      
           PenColor (LONGINT) = Pen color of the text.                      
           Font (STRING) = Font to use.                                     
           FontSize (WORD = Font size to use.                               
           Caption (STRING) = Text to display.                              
           HJustify (BYTE) = Horizontal justification text method.          
  OUT....: /                                                                
  EXPLAIN: Define and display a text in current window.                     
           The text is clipped in a box and justified.                      
           This procedure allow you to display quickly a simple text        
           without define a TText structure. If you want to display special 
           text, use the functions listed below and set parameters yourself.
           This function allow you tu use a special font to display text.   
  SEEALSO: Display_Define, Display_Draw                                     
 ͼ}

Procedure Display (X,Y,Width:Integer; PenColor:Longint; Caption:String; HJustify:Byte);
Var Text:TText;
Begin
Display_Define(Text,X,Y,-1,PenColor,Sys.FontCurrent,Sys.FontCurrentSize,HJustify,$0003,Caption);
Text.Width:=Width;
Display_Draw(Text);
End;

{ͻ
                             PROCEDURE Display                              
 ͹
  IN.....: X,Y (INTEGER) = Coordinates of the text to display.              
           PenColor (LONGINT) = Pen color of the text.                      
           Font (STRING) = Font to use.                                     
           FontSize (WORD = Font size to use.                               
           Caption (STRING) = Text to display.                              
  OUT....: /                                                                
  EXPLAIN: Define and display a text in current window.                     
           This procedure allow you to display quickly a simple text        
           without define a TText structure. If you want to display special 
           text, use the functions listed below and set parameters yourself.
           This function allow you tu use a special font to display text.   
  SEEALSO: Display_Define, Display_Draw                                     
 ͼ}

Procedure Display(X,Y:Integer; PenColor:Longint; Font:String; FontSize:Word; Caption:String);{*Display a text with special font*}
Var Text:TText;
Begin
Display_Define(Text,X,Y,-1,PenColor,Font,FontSize,TJOnLeft,$0021,Caption);
Display_Draw(Text);
End;

{ͻ
                             PROCEDURE Display                              
 ͹
  IN.....: X,Y (INTEGER) = Coordinates of the text to display.              
           PenColor (LONGINT) = Pen color of the text.                      
           Value (LONGINT) = Value to display.                              
  OUT....: /                                                                
  EXPLAIN: Define and display a value in current window.                    
           This procedure allow you to display quickly a simple value       
           without define a TText structure. If you want to display special 
           text, use the functions listed below and set parameters yourself.
  SEEALSO: Display_Define, Display_Draw                                     
 ͼ}

Procedure Display(X,Y:Integer;PenColor:Longint; Value:Longint);
Begin
Display(X,Y,PenColor,Str_L2S(Value));
End;

{ͻ
                             PROCEDURE Display                              
 ͹
  IN.....: X,Y (INTEGER) = Coordinates of the text to display.              
           PenColor (LONGINT) = Pen color of the text.                      
           Caption (STRING) = Text to display.                              
  OUT....: /                                                                
  EXPLAIN: Define and display a text in current window.                     
           This procedure allow you to display quickly a simple text        
           without define a TText structure. If you want to display special 
           text, use the functions listed below and set parameters yourself.
  SEEALSO: Display_Define, Display_Draw                                     
 ͼ}

Procedure Display(X,Y:Integer; PenColor:Longint; Caption:String);
Var Text:TText;
Begin
Display_Define(Text,X,Y,-1,PenColor,Sys.FontCurrent,Sys.FontCurrentSize,TJOnLeft,$0001,Caption);
Display_Draw(Text);
End;

{ͻ
                           PROCEDURE Display_Attr                           
 ͹
  IN.....: X,Y (INTEGER) = Coordinates of the text do display.              
           BgColor (LONGINT) = Background color of the text.                
           PenColor (LONGINT) = Pen color of the text.                      
           Id (WORD) = Special attributes :                                 
              Bit 0  $0001 :  1 = Clear background                          
              Bit 1  $0002 :  1 = Text clipped in box                       
              Bit 2  $0004 :  1 = Text in relieve                           
              Bit 3  $0008 :  1 = Text in shadow                            
              Bit 4  $0010 :  1 = LCD display mode                          
              Bit 5  $0020 :  1 = Set defined font (More slow)              
           Caption (STRING) = String to display.                            
  EXPLAIN: Use special attributes to display text.                          
           Old "Display_Attr" procedure emulation.                          
  SEEALSO: Display                                                          
 ͼ}

Procedure Display_Attr(X,Y:Integer; BgColor,PenColor:Longint; Id:Word; Caption:String);
Var Text1:TText;
Begin
Display_Define(Text1,X,Y,BgColor,PenColor,'',0,TJOnLeft,Id,Caption);
Display_Draw  (Text1);
End;

{ͻ
                          PROCEDURE Display_Define                          
 ͹
  IN.....: Text (TText) = Pointer to the TText structure.                   
           X,Y (INTEGER) = Coordinates of the text to display.              
           BgColor (LONGINT) = Background color of the text.                
           PenColor (LONGINT) = Pen color of the text.                      
           Font (STRING) = The text font.                                   
           FontSize (BYTE) = The text font size.                            
           HJustify (BYTE) = Horizontal text justification :                
              1 = TJOnLeft      Left justify                                
              2 = TJOnRight     Right justify                               
              3 = TJOnCenter    Center                                      
              6 = TJJustify     Justify text                                
              For vertical justification, please see the TText structure.   
           Id (WORD) = Set more parameters for the text definition.         
              Bit 0  $0001 :  1 = Clear background                          
              Bit 1  $0002 :  1 = Text clipped in box                       
              Bit 2  $0004 :  1 = Text in relieve                           
              Bit 3  $0008 :  1 = Text in shadow                            
              Bit 4  $0010 :  1 = LCD display mode                          
              Bit 5  $0020 :  1 = Set defined font (More slow)              
           Caption (STRING) = Text to display.                              
  OUT....: /                                                                
  EXPLAIN: Define text with more parameters than classic text.              
           After use this procedure, you can set more parameters if you want
           Please see the TText structure to see what parameter to set.     
  SEEALSO: Display_Draw, Display                                            
 ͼ}

Procedure Display_Define(Var Text:TText; X,Y:Integer; BgColor,PenColor:Longint;
                         Font:String; FontSize,HJustify:Byte; Id:Word; Caption:String);
Var NeedToHideMouse:Boolean;            {*Mouse is on box or else*}
    C:TCoordinates;                     {*Coordinates for mouse on box*}

Begin
If Id_Scr1 And $8=$8 Then Begin         {*Window Clipped*}
{   Dec(X,1); Dec(Y,6);}                  {*Restore True Coordinates*}
   End;

Text.Font.Direction:=TDHorizontal;
Text.Font.Name:=Font;                   {*Font attribute*}
Text.Font.Size:=FontSize;
Text.Font.PenColor:=PenColor;
Text.Font.Style:=$0000;                 {*Font attribute*}
If (BTST(Id,5)) And (Font<>'') Then
   Begin
   Font_Set(Font,FontSize);             {*Set to special font*}
   Font_SetDirection(Text.Font.Direction); {*Horizontal or vertical*}
   End;
Text.X:=X;
Text.Y:=Y;
Text.Width:=VESA_TextWidth(Caption);    {*Text width (usefull for clipping)*}
Text.Height:=HaF+1;
Text.Caption:=Caption;                  {*Caption*}
Text.Popup:='';                         {*Popup menu file definition*}
Text.Hint:='';                          {*Hint file to display*}
Text.HJustify:=HJustify;                {*Horizontal justify method*}
Text.VJustify:=TJOnTop;                 {*Vertical justify method (Center)*}
Text.Id:=Id;                            {*Bits for miscellaneous attributes*}
Text.MaskSep:=':';                      {*Mask separator for LCD displaying*}

Case Sys.RefreshMode of
   RMHideAlways : NeedToHideMouse:=Yes; {*Hide mouse*}
   RMHideOver   :                       {*Hide mouse localis*}
      Begin
      C.X1:=X; C.Y1:=Y; C.X2:=X+Text.Width; C.Y2:=Y+Text.Height;
      If Mse_TestClippedBox(C) Then NeedToHideMouse:=Yes Else NeedToHideMouse:=No;
      End;
   Else NeedToHideMouse:=No;
   End;
If NeedToHideMouse Then Mse_Hide;       {*Hide Mouse*}
If BgColor>=0 Then Text.Font.BgColor:=BgColor
              Else Text.Font.BgColor:=VESA_Getpixel(X+1,Y+1);
If NeedToHideMouse Then Mse_Show;       {*Restore Mouse*}
End;

{ͻ
                           PROCEDURE Display_Draw                           
 ͹
  IN.....: Text (TText) = Pointer to the TText structure.                   
  OUT....: /                                                                
  EXPLAIN: Display (draw) the text using the TText structure.               
  SEEALSO: Display_Define, Display                                          
 ͼ}

Procedure Display_Draw(Var Text:TText);
Const Fd=2.5;                           {*Facteur d'attnuation pour LCD*}

Var Tx,Ty:Integer;                      {*Text coordinates*}
    Cx,Cy:Integer;                      {*Clipped coordinates*}
    Ox,Oy:Integer;                      {*Offsets coordinates*}

    C1,C2:LongInt;                      {*Color 1 and 2 for pen*}
    VP   :TViewPortType;
    R,G,B:Byte;                         {*RGB composants for LCD displaying*}
    V    :TCoordinates;                 {*Viewport coordinates for clipping*}
    Xa,Ya,Xb,Yb:Integer;                {*Pour transtypage*}
    NeedToHideMouse:Boolean;            {*Mouse is on box or else*}
    C    :TCoordinates;                 {*Coordinates for mouse on box*}
    SizeX:Integer;                      {*X Size for fill background*}

{****************************************************************************}

Procedure Display_Justify(Jx,Jy:Integer; Caption:String);
Var Esp:Real;
    A,QttWord,QttEsp:Integer;
    MotPx:Real;                         {*Position X du mot courrant*}
    St:String;

Begin
QttWord:=Str_CountWords(Caption);       {*Nombre de mots dans la phrase*}
QttEsp:=Str_CountItem(Caption,' ');     {*Nombre d'espaces dans la phrase*}
Esp:=(Text.Width-VESA_TextWidth(Caption) +2 + QttEsp*LaF) / (Real(QttWord)-1);{*Taille des espaces entre mots (pixels)*}

If Esp<LaF Then Esp:=LaF;               {*1 Char minimum*}

MotPx:=Jx;
For A:=1 to QttWord do                  {*Parcours tous les mots*}
   Begin
   St:=Str_GetWordNum(Caption,A);
   VESA_OutTextXY(Round(MotPx),Jy,St);  {*Display word*}
   MotPx:=MotPx+VESA_TextWidth(St)+Esp; {*Calcule position X du mot courrant*}
   End;
End;

{****************************************************************************}

Begin
With Text do
   Begin
   If Font.Direction=TDVertical Then Exg(Width,Height);

   If BTST(Id,5) Then                   {*Return to previous font*}
      Begin
      Font_Set(Font.Name,Font.Size);    {*Set to special font*}
      Font_SetDirection(Font.Direction);{*Horizontal or vertical*}
      End;

   Cx:=X; Cy:=Y;                        {*Base position*}

   If BTST(Id,1) Then                   {*Text clipped => Viewport*}
      Begin
      V.X1:=X+T_Clip.X1; V.Y1:=Y+T_Clip.Y1; V.X2:=X+T_Clip.X1+Width; V.Y2:=Y+T_Clip.Y1+Height;
      Xa:=V.X1; Ya:=V.Y1; Xb:=V.X2; Yb:=V.Y2;
      Coord_RealClipBox(Xa,Ya,Xb,Yb);   {*Clip text in window border*}
      Coord_SetInStruct(Xa,Ya,Xb,Yb, V);{*Set coordinates in a structure*}
      VESA_GetViewSettings(VP);
      VESA_SetViewPort(V.X1,V.Y1,V.X2,V.Y2,ClipOn);
      Cx:=0; Cy:=0;
      End;

   Ox:=0; Oy:=0; C1:=Font.PenColor;
   If BTST(Id,2) Then                   {*Text in relieve*}
      Begin Ox:=1; Oy:=-1; C2:=CLText; End;

   If BTST(Id,3) Then                   {*Text in shadow*}
      Begin Ox:=1; Oy:=-1; C1:=CLShadow; C2:=Font.PenColor; End;

   Case HJustify of                     {*Calcule X position*}
      TJOnRight : Tx:=Cx+Width-VESA_TextWidth(Caption);
      TJOnCenter: Tx:=Cx+(Width Div 2)-(VESA_TextWidth(Caption) Div 2);
      Else Tx:=Cx;
      End;
   Case VJustify of                     {*Calcule Y position*}
      TJOnBottom: Ty:=Cy+Height-VESA_TextHeight;
      TJOnCenter: Ty:=Cy+(Height Div 2)-(VESA_TextHeight Div 2)-1;
      Else Ty:=Cy;
      End;

   Case Sys.RefreshMode of
      RMHideAlways : NeedToHideMouse:=Yes; {*Hide mouse*}
      RMHideOver   :                    {*Hide mouse localis*}
         Begin
         C.X1:=X; C.Y1:=Y; C.X2:=X+Text.Width; C.Y2:=Y+Text.Height;
         If Mse_TestClippedBox(C) Then NeedToHideMouse:=Yes Else NeedToHideMouse:=No;
         End;
      Else NeedToHideMouse:=No;
      End;
   If NeedToHideMouse Then Mse_Hide;    {*Hide Mouse*}

   VESA_SetFillStyle(1,Font.BgColor);   {*Fill Background*}
   If BTST(Id,0) Then
      Begin                             {*Fill all the zone or only under text*}
      If HJustify=TJJustify Then SizeX:=Cx+Width Else SizeX:=Tx+VESA_TextWidth(Caption);

      If BTST(Id,6) Then VESA_Bar(Tx,Ty,SizeX,Ty+VESA_TextHeight)
                    Else VESA_Bar(Cx,Cy,Cx+Width,Cy+Height);
      End;

   If (BTST(Id,2)) Or (BTST(Id,3)) Then {*Text in relieve or Shadow*}
      Begin
      VESA_SetColor(C2);
      If HJustify=TJJustify Then Display_Justify(Tx+Ox,Ty,Caption) {*Display justified text*}
                            Else VESA_OutTextXY (Tx+Ox,Ty,Caption);{*Display normal text*}
      End;
   If BTST(Id,4) Then                   {*Display LCD shadow text*}
      Begin
      VESA_GetRGBColor(C1,R,G,B);
      R:=Round(R/Fd); G:=Round(G/Fd); B:=Round(B/Fd);
      VESA_SetColor(VESA_SetRGBColor(R,G,B));
      VESA_OutTextXY(Tx,Ty+Oy,Str_Mask(Caption,MaskSep,'8'));
      End;

   VESA_SetColor(C1);
   If HJustify=TJJustify Then Display_Justify(Tx,Ty+Oy,Caption) {*Display justified text*}
                         Else VESA_OutTextXY (Tx,Ty+Oy,Caption);{*Display normal text*}
   If NeedToHideMouse Then Mse_Show;    {*Restore Mouse*}

   If BTST(Id,1) Then VESA_SetViewPort(VP.X1, VP.Y1, VP.X2, VP.Y2, ClipOn); {*End text clipped*}
   End;
End;

{*------------------------------ COORDINNATES ------------------------------*}

{ͻ
                          FUNCTION Coord_TestEqual                          
 ͹
  IN.....: C1,C2 (TCoordinates) = Coordinates to check.                     
  OUT....: (BOOLEAN) = TRUE if coordinates are indentical.                  
  EXPLAIN: Compare if coordinates are equal.                                
 ͼ}

Function Coord_TestEqual(C1,C2:TCoordinates):Boolean;
Begin
If (C1.X1=C2.X1) And (C1.Y1=C2.Y1) And (C1.X2=C2.X2) And (C1.Y2=C2.Y2)
   Then Coord_TestEqual:=Yes
   Else Coord_TestEqual:=No;
End;

{ͻ
                       PROCEDURE Coord_PointInScreen                        
 ͹
  IN.....: (X,Y) (INTEGER) = Coordinates of a point                         
  OUT....: (X,Y) (INTEGER) = Coordinates of the same point or another.      
  EXPLAIN: Put the point in the screen                                      
  EXAMPLE: Coord_PointInScreen(X,Y) with X=-1 and Y=1280                    
           With a mode : 800*600                                            
           The resultat is : (0,599)                                        
 ͼ}

PROCEDURE Coord_PointInScreen(Var X,Y:Integer);
Begin
If X<0 Then X:=0 Else
 If X>VESA_GetMaxX Then X:=VESA_GetMaxX;
If Y<0 Then Y:=0 Else
 If Y>VESA_GetMaxY Then Y:=VESA_GetMaxY;
End;

{ͻ
                               FUNCTION Coord                               
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Box coordinates.                         
  OUT....: (TCoordinates) = Structure result.                               
  EXPLAIN: Set the X1,Y1,X2,Y2 values in a TCoordinate structure.           
 ͼ}

Function Coord(X1,Y1,X2,Y2:Integer):TCoordinates;
Begin
Result.X1 := X1;
Result.Y1 := Y1;
Result.X2 := X2;
Result.Y2 := Y2;
End;

{ͻ
                         FUNCTION Coord_SetInStruct                         
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Box coordinates.                         
  OUT....: (BOOLEAN) = TRUE if coordinates ar set.                          
  EXPLAIN: Set the X1,Y1,X2,Y2 values in a TCoordinate structure.           
 ͼ}

Function Coord_SetInStruct(X1,Y1,X2,Y2:Integer; Var C:TCoordinates):Boolean;
Begin
Coord_SetInStruct:=TRUE;
C.X1:=X1;
C.Y1:=Y1;
C.X2:=X2;
C.Y2:=Y2;
End;

{ͻ
                         FUNCTION Coord_RealClipBox                         
 ͹
  IN.....: VX1,VY1,VX2,VY2 (INTEGER) = Real box coordinates.                
  OUT....: VX1,VY1,VX2,VY2 (INTEGER) = New box coordinates.                 
  EXPLAIN: Check the coordinates, and verify if they are in the window      
           clipping. Else, cut coordinates to set in window clipping.       
  NB.....: Return FALSE if the box is totaly hidden, else return TRUE.      
  SEEALSO: Coord_RelativeClipBox                                            
 ͼ}

Function Coord_RealClipBox(Var VX1,VY1,VX2,VY2:Integer):Boolean;
Begin
If VX1<T_Clip.X1 Then VX1:=T_Clip.X1;   {*Coord ViewPort Bouton*}
If VY1<T_Clip.Y1 Then VY1:=T_Clip.Y1;
If VX2>T_Clip.X2 Then VX2:=T_Clip.X2;
If VY2>T_Clip.Y2 Then VY2:=T_Clip.Y2;
                                        {*Bouton Totalement Cach...*}
If (VX2<=VX1) Or(VY2<=VY1) Then Coord_RealClipBox:=FALSE
                           Else Coord_RealClipBox:=TRUE;
End;

{ͻ
                      PROCEDURE Coord_RelativeClipBox                       
 ͹
  IN.....: VX1,VY1,VX2,VY2 (INTEGER) = Relative box coordinates.            
  OUT....: VX1,VY1,VX2,VY2 (INTEGER) = New box coordinates.                 
           Return FALSE if the box is totaly hidden, else return TRUE.      
  EXPLAIN: Check the coordinates, and verify if they are in the window      
           clipping. Else, cut coordinates to set in window clipping.       
  SEEALSO: Coord_RealClipBox                                                
 ͼ}

Procedure Coord_RelativeClipBox(Var VX1,VY1,VX2,VY2:Integer);
Var Sx,Sy:Integer;
Begin
Sx:=T_Clip.X2-T_Clip.X1;
Sy:=T_Clip.Y2-T_Clip.Y1;

If VX1<0 Then VX1:=0;                   {*Coord Window ViewPort*}
If VY1<0 Then VY1:=0;
If VX2>Sx Then VX2:=Sx;
If VY2>Sy Then VY2:=Sy;
End;

{ͻ
                        PROCEDURE Coord_BoxInScreen                         
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Coordinate of the box.                   
  OUT....: X1,Y1,X2,Y2 (INTEGER) = New coordinates of the box.              
  EXPLAIN: Check if coordinates are in screen and if they are coherent.     
           If it is not the case, return them coherent !!!                  
 ͼ}

Procedure Coord_BoxInScreen(Var X1,Y1,X2,Y2:Integer);
Begin
Coord_BoxCorrect(X1,Y1,X2,Y2);          {*Vrifie la Cohrence*}
If X1<0 Then X1:=0;
If Y1<0 Then Y1:=0;

If X1>VESA_GetMaxX Then X1:=VESA_GetMaxX;

If Y1>VESA_GetMaxY Then Y1:=VESA_GetMaxY;
End;

{ͻ
                         PROCEDURE Coord_BoxCorrect                         
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Coordinate of the box.                   
  OUT....: X1,Y1,X2,Y2 (INTEGER) = New coordinates of the box.              
  EXPLAIN: Check if coordinates are not swapped else swap them.             
 ͼ}

Procedure Coord_BoxCorrect(Var X1,Y1,X2,Y2:Integer);{*Vrifie la Cohrence*}
Begin
If X1>X2 Then Exg(X1,X2);
If Y1>Y2 Then Exg(Y1,Y2);
End;

{ͻ
                        PROCEDURE Coord_WinInScreen                         
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Coordinates of the box                   
  OUT....: X1,Y1,X2,Y2 (INTEGER) = New coordinates of the box               
  EXPLAIN: Check if coordinates are coherent, and put the box in the screen.
 ͼ}

Procedure Coord_WinInScreen(Var x1,y1,x2,y2:Integer);
Begin
If X1<0 Then
   If Abs(X1)+X2<=VESA_GetMaxX Then Begin      {*Recentrage Window out of Screen*}
      Inc(X2,Abs(X1)); X1:=0; End;
//      Else Error(525);
If Y1<0 Then
   If Abs(Y1)+Y2<=VESA_GetMaxY Then Begin      {*Recentrage Window out of Screen*}
      Inc(Y2,Abs(Y1)); Y1:=0; End;
//      Else Error(525);
If X2>VESA_GetMaxX Then
   If X1-(X2-VESA_GetMaxX)>=0 Then Begin       {*Recentrage Window out of Screen*}
      Dec(X1,(X2-VESA_GetMaxX)); X2:=VESA_GetMaxX; End;
//      Else Error(525);
If Y2>VESA_GetMaxY Then
   If Y1-(Y2-VESA_GetMaxY)>=0 Then Begin       {*Recentrage Window out of Screen*}
      Dec(Y1,(Y2-VESA_GetMaxY)); Y2:=VESA_GetMaxY; End;
//      Else Error(525);
End;

{*--------------------------- Programme Principal ------------------------------*}

BEGIN
END.
