{ͻ
                               UNIT MosTexts                                
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 08.05.2000                                                   
  COUNTRY....: Montpellier - Timeless (FRANCE)                              
  DESCRIPTION: MOS visual components library (AFont, AText).                
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 3.718 Lines and (93.136 Bytes compiled)                      
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosTexts;

{$Mode Objfpc}

INTERFACE

Uses
     Classes,
     MosControls;

Type                                    {*Types definition*}

{****************************************************************************}

TFontPosition = (                       {*Font position*}
   FPNormal,
   FPExposant,
   FPIndice);

TDockOrientation = (                    {*Item direction*}
   DOHorizontal,
   DOVertical);

THPosition =(                           {*Horizontal justify method*}
   TPOnLeft,
   TPOnRight,
   TPOnCenter,
   TPJustify);

TVPosition = (                          {*Vertical justify method*}
   TPOnTop,
   TPOnBottom,
   TPOnMiddle);

{****************************************************************************}
{*** AFont Class                                                          ***}
{****************************************************************************}

AFont = Class (TComponent)              {*TFont component*}
   Private
      fName             :String;        {*Font filename*}
      fSize             :Byte;          {*Font size*}
      fStyle            :Word;          {*Font attributes*}
      fDirection        :TDockOrientation;{*Writing direction. Default = Horizontal*}
      fPosition         :TFontPosition; {*Text font position*}

   Protected
      Procedure SetName(N:String);      {*Set a new font name*}
      Procedure SetSize(S:Byte);        {*Set a new font size*}

   Public
      Property Name     :String           Read fName      Write SetName;
      Property Size     :Byte             Read fSize      Write SetSize;
      Property Style    :Word             Read fStyle     Write fStyle;
      Property Direction:TDockOrientation Read fDirection Write fDirection;
      Property Position :TFontPosition    Read fPosition  Write fPosition;

      Constructor Create(AOwner:TComponent); Override; {*Create new component*}
   End;

{****************************************************************************}
{*** AText Class                                                          ***}
{****************************************************************************}

AText = Class (TVisual)                 {*TText component*}
   Private
      fAutoSize         :Boolean;       {*Auto size text*}
      fCaption          :String;        {*Caption*}
      fFont             :AFont;         {*Used font*}
      fPenColor         :Longint;       {*Font pen color*}
      fBgColor          :Longint;       {*Font background color*}
      fTransparent      :Boolean;       {*Transparent background*}
      fHJustify         :THPosition;    {*Horizontal justify method*}
      fVJustify         :TVPosition;    {*Vertical justify method*}
      fClipped          :Boolean;       {*Text clipped in box*}
      fUseFont          :Boolean;       {*Set defined font*}
//fWordWrap         :Boolean;
//fClearUnderOnly   :Boolean;       {*Only clear background under text*}

      fTextWidth        :Integer;       {*Text width in pixels*}
      fInnerCalcul      :Boolean;       {*Interaction with "AutoSize"*}
      fOffsetX          :Integer;       {*Offset X to display text*}
      fOffsetY          :Integer;       {*Offset Y to display text*}

      Procedure SetOffsetX(O:Integer);  {*Set text offset X*}
      Procedure SetOffsetY(O:Integer);  {*Set text offset Y*}
      Procedure Define;                 {*Define base variables*}

   Protected
      Property  TextWidth   :Integer       Read fTextWidth;
      Property  InnerCalcul :Boolean       Read fInnerCalcul;
      Property  OffSetX     :Integer       Read fOffsetX     Write SetOffsetX;
      Property  OffSetY     :Integer       Read fOffsetY     Write SetOffsetY;

      Procedure SetCaption(C:String);           {*Set a new text*}
      Procedure SetAutoSize(B:Boolean);         {*Set automatic size*}
      Procedure SetTransparent(T:Boolean);      {*Set transparent value*}
      Procedure SetHPosition(J:THPosition);     {*Set horizontal justification*}
      Procedure SetVPosition(J:TVPosition);     {*Set vertical justification*}
      Procedure SetPenColor(C:Longint);         {*Set new pen color*}
      Procedure SetBgColor(C:Longint);          {*Set new background color*}
      Procedure CalculeSize;                    {*Calcule width and height*}

      Procedure SetWidth(W:Integer); Override;  {*Set the component width*}
      Procedure SetHeight(H:Integer); Override; {*Set the component height*}
      Procedure SetX2(X:Integer); Override;     {*Set the component right*}
      Procedure SetY2(Y:Integer); Override;     {*Set the component bottom*}

   Public
      Property  Transparent :Boolean       Read fTransparent Write SetTransparent;
      Property  AutoSize    :Boolean       Read fAutoSize    Write SetAutoSize;
      Property  Caption     :String        Read fCaption     Write SetCaption;
      Property  HJustify    :THPosition    Read fHJustify    Write SetHPosition;
      Property  VJustify    :TVPosition    Read fVJustify    Write SetVPosition;
      Property  PenColor    :Longint       Read fPenColor    Write SetPenColor;
      Property  BgColor     :Longint       Read fBgColor     Write SetBgColor;
      Property  Font        :AFont         Read fFont;

      Constructor Create(AOwner:TComponent); Override; {*Create new component*}
      Constructor Create(AOwner:TComponent; pX1,pY1:Integer; pCaption:String); {*Create new component with more parameters*}
      Constructor Create(AOwner:TComponent; pX1,pY1:Integer; pPenColor:Longint; pCaption:String); {*Create new component with more parameters*}
      Constructor Create(AOwner:TComponent; pX1,pY1,pWidth:Integer; pPenColor:Longint; pCaption:String; pHJustify:THPosition); {*Create new component with more parameters*}
      Destructor  Destroy; Override;              {*Destroy component*}
      Procedure   Draw; Override;                 {*Draw component*}
      Function    GetMsg:TCompMessage; Override;  {*Get messages from component*}

(*      Procedure Display       (    pX,pY,pWidth:Integer; pPenColor:Longint; pCaption:String; pHJustify:Byte);{*Display a justified text*}
      Procedure Display       (    pX,pY:Integer; pPenColor:Longint; pValue:Longint); {*Define and display a value*}
      Procedure Display       (    pX,pY:Integer; pPenColor:Longint; pFont:String; pFontSize:Word; pCaption:String);{*Display a text with special font*}
      Procedure Display_Attr  (    pX,pY:Integer; pBgColor,pPenColor:LongInt; pId:Word; pCaption:String);{*Old Display_Attr emulation*}
      Procedure Display_Define(Var pText:TText; pX,pY:Integer; pBgColor,pPenColor:Longint; pFont:String; pFontSize,pHJustify:Byte;
                                   pId:Word; pCaption:String); {*Define text*}*)
   End;

{****************************************************************************}
{*** TDigitalText                                                         ***}
{****************************************************************************}

TDigitalText = Class (AText)            {*TDigitalText component*}
   Private
      fMask             :Char;          {*Mask char for LCD displaying*}
      fMaskSep          :Char;          {*Mask separator for LCD displaying*}
      fAttenuation      :Real;          {*Light attenuation fo LCD shadow*}

      Procedure Define;                 {*Define base variables*}

   Protected
      Procedure SetMask(M:Char);        {*Set new mask*}
      Procedure SetMaskSep(M:Char);     {*Set new mask separator*}
      Procedure SetAttenuation(A:Real); {*Set attenuation light*}

   Public
      Property  Mask        :Char   Read fMask        Write SetMask;
      Property  MaskSep     :Char   Read fMaskSep     Write SetMaskSep;
      Property  Attenuation :Real   Read fAttenuation Write SetAttenuation;

      Constructor Create(AOwner:TComponent); Override; {*Create new component*}
      Constructor Create(AOwner:TComponent; pX1,pY1:Integer; pPenColor:Longint; pCaption:String);
      Procedure   Draw; Override;                 {*Draw component*}
   End;

{****************************************************************************}
{*** THyperText                                                           ***}
{****************************************************************************}

THyperText = Class (AText)              {*THyperText component*}
   Private
      fRelieve          :Boolean;       {*Text in relieve else shadow*}
      fColorBelow       :Longint;       {*Text color below*}
      fColorOver        :Longint;       {*Text color over*}

      Procedure Define;                 {*Define base variables*}

   Protected
      Procedure SetRelieve(R:Boolean);    {*Set relieve or no*}
      Procedure SetColorBelow(C:Longint); {*Set text color below*}
      Procedure SetColorOver(C:Longint);  {*Set text color over*}

   Public
      Property  Relieve    :Boolean  Read fRelieve     Write SetRelieve;
      Property  ColorBelow :Longint  Read fColorBelow  Write SetColorBelow;
      Property  ColorOver  :Longint  Read fColorOver   Write SetColorOver;

      Constructor Create(AOwner:TComponent); Override; {*Create new component*}
      Constructor Create(AOwner:TComponent; pX1,pY1:Integer; pPenColor:Longint; pRelieve:Boolean; pCaption:String);
      Procedure   Draw; Override;                 {*Draw component*}
   End;

{}
{}
{}

IMPLEMENTATION

Uses
     MosBase,
     MosColors,
     MosConfig,
     MosGraph,
     MosMouse,
     MosStrings,
     MosText;

{****************************************************************************}
{*** AFont Class                                                          ***}
{****************************************************************************}

Constructor AFont.Create(AOwner:TComponent);
Begin
Inherited Create(AOwner);

fName  := 'LITT.CHR';
fSize  := 4;
fStyle := $0000;
fDirection := DOHorizontal;
fPosition  := FPNormal;
End;

Procedure AFont.SetName(N:String);
Begin
If N = fName Then Exit;
fName := N;
End;

Procedure AFont.SetSize(S:Byte);
Begin
If S = fSize Then Exit;
fSize := S;
{Owner.Draw;}
End;

{****************************************************************************}
{*** AText Class                                                          ***}
{****************************************************************************}

Procedure AText.Define;
Begin
fCaption        := '';
fHJustify       := TPOnLeft;
fVJustify       := TPOnTop;
fPenColor       := CLText;
fBgColor        := CLWinBg;

fAutoSize       := Yes;
fTransparent    := No;                  {*Clear background*}
fClipped        := Yes;                 {*Text clipped in box*}
fUseFont        := Yes;                 {*Set defined font*}
fInnerCalcul    := No;

If Owner = Self Then Log.Add('Create new TText ('+')',2);
End;

Constructor AText.Create(AOwner:TComponent);
Begin
Inherited Create(AOwner);
fFont := AFont.Create(AOwner);

Define;
End;

Constructor AText.Create(AOwner:TComponent; pX1,pY1:Integer; pCaption:String);
Begin
Inherited Create(AOwner, pX1,pY1,pX1,pY1);
fFont := AFont.Create(AOwner);

Define;                                 {*Assign common variables*}

X1        := pX1;
Y1        := pY1;

SetCaption(pCaption);                   {*Set new text*}
End;

Constructor AText.Create(AOwner:TComponent; pX1,pY1:Integer; pPenColor:Longint; pCaption:String);
Begin
Inherited Create(AOwner, pX1,pY1,pX1,pY1);
fFont := AFont.Create(AOwner);

Define;                                 {*Assign common variables*}

X1        := pX1;
Y1        := pY1;
fPenColor := pPenColor;

SetCaption(pCaption);                   {*Set new text*}
End;

Constructor AText.Create(AOwner:TComponent; pX1,pY1,pWidth:Integer; pPenColor:Longint; pCaption:String; pHJustify:THPosition);
Begin
Inherited Create(AOwner, pX1,pY1,pX1+pWidth,pY1);
fFont := AFont.Create(AOwner);

Define;                                 {*Assign common variables*}

X1        := pX1;
Y1        := pY1;
fPenColor := pPenColor;

SetCaption(pCaption);                   {*Set new text*}
fInnerCalcul := Yes;                    {*Interaction with "AutoSize"*}
Width        := pWidth;
fInnerCalcul := No;                     {*Interaction with "AutoSize"*}
fHJustify    := pHJustify;
End;

Destructor AText.Destroy;
Begin
fFont.Destroy;
Inherited Destroy;
End;

Procedure AText.CalculeSize;
Begin
fTextWidth := VESA_TextWidth(fCaption);
If fAutoSize Then
   Begin
   fInnerCalcul := Yes;                 {*Interaction with "AutoSize"*}
   Width  := fTextWidth;
   Height := VESA_TextHeight;
   fInnerCalcul := No;                  {*Interaction with "AutoSize"*}
   End;
End;

Procedure AText.SetCaption(C:String);
Begin
If C = fCaption Then Exit;
fCaption := C;

CalculeSize;                            {*Calcule width and height*}

Invalidate;                             {*Redraw if needs*}
End;

Procedure AText.SetAutoSize(B:Boolean);
Begin
If B = fAutoSize Then Exit;
fAutoSize := B;
CalculeSize;                            {*Calcule width and height again*}
Invalidate;                             {*Redraw if needs*}
End;

Procedure AText.SetTransparent(T:Boolean);
Begin
If T = fTransparent Then Exit;
fTransparent := T;
End;

Procedure AText.SetHPosition(J:THPosition);
Begin
If fHJustify = J Then Exit;
fHJustify := J;
Invalidate;                             {*Redraw if needs*}
End;

Procedure AText.SetVPosition(J:TVPosition);
Begin
If fVJustify = J Then Exit;
fVJustify := J;
Invalidate;                             {*Redraw if needs*}
End;

Procedure AText.SetPenColor(C:Longint);
Begin
If fPenColor = C Then Exit;
fPenColor := C;
Invalidate;                             {*Redraw if needs*}
End;

Procedure AText.SetBgColor(C:Longint);
Begin
If fBgColor = C Then Exit;
fBgColor := C;
Invalidate;                             {*Redraw if needs*}
End;

Procedure AText.SetWidth(W:Integer);
Begin
If (fInnerCalcul) Or (Not fAutoSize) Then Inherited SetWidth(W);
End;

Procedure AText.SetHeight(H:Integer);
Begin
If (fInnerCalcul) Or (Not fAutoSize) Then Inherited SetHeight(H);
End;

Procedure AText.SetX2(X:Integer);
Begin
If (fInnerCalcul) Or (Not fAutoSize) Then Inherited SetX2(X);
End;

Procedure AText.SetY2(Y:Integer);
Begin
If (fInnerCalcul) Or (Not fAutoSize) Then Inherited SetY2(Y);
End;

Procedure AText.SetOffsetX(O:Integer);
Begin
If O = fOffsetX Then Exit;
fOffsetX := O;
Invalidate;                             {*Redraw if needs*}
End;

Procedure AText.SetOffsetY(O:Integer);
Begin
If O = fOffsetY Then Exit;
fOffsetY := O;
Invalidate;                             {*Redraw if needs*}
End;

{ͻ
                             METHOD AText.Draw                              
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Draw text component using defined parameters.                    
  SEEALSO: Create, Hide                                                     
 ͼ}

Procedure AText.Draw;
Var VP             :TViewPortType;      {*For text clipping*}
    Xa,Ya,Xb,Yb    :Integer;            {*ViewPort Coordinates*}
    TextPx         :Integer;            {*Left for text*}
    TextPy         :Integer;            {*Right for text*}

{Ajouter le TJJustify pour justifier le texte sur une ligne entire}

Begin
If Not Visible Then Exit;               {*Not displayed*}

Inherited Draw;                         {*Call parent draw*}

If Not fTransparent Then                {*Clear background before*}
   Begin
   Mse_Hide;
   VESA_SetFillStyle(1, fBgColor);
   VESA_Bar(X1,Y1,X2,Y2);
   Mse_Show;
   End;

If fClipped Then                        {*Set clipping*}
   Begin
   VESA_GetViewSettings(VP);
   Xa := X1+T_Clip.X1;                  {*Calcule coordinates*}
   Ya := Y1+T_Clip.Y1;
   Xb := X2+T_Clip.X1;
   Yb := Y2+T_Clip.Y1;
   Coord_RealClipBox(Xa,Ya,Xb,Yb);      {*Clip text in window border*}
   VESA_SetViewPort (Xa,Ya,Xb,Yb, ClipOn);
   End;

If fUseFont Then                        {*Use defined font*}
   Begin
   Font_Set(fFont.Name, fFont.Size);    {*Set to user font*}
//   Font_SetDirection(Font.Direction);   {*Horizontal or vertical*}
   End;

fOffsetX := 0;
Case fHJustify of                       {*Calcule text horizontal position*}
   TPOnRight  : TextPx := fOffsetX + Width - fTextWidth;
   TPOnCenter : TextPx := fOffsetX +(Width Div 2)-(fTextWidth Div 2);
   Else         TextPx := fOffsetX;
   End;

fOffsetY := 0;
Case VJustify of                        {*Calcule text vertical position*}
   TPOnBottom : TextPy := fOffsetY + Height - VESA_TextHeight;
   TPOnMiddle : TextPy := fOffsetY + (Height Div 2)-(VESA_TextHeight Div 2)-1;
   Else         TextPy := fOffsetY;
   End;

//wait;
Mse_Hide;
VESA_SetColor (fPenColor);
If fHJustify = TPJustify Then
   Begin                                {*Justified on width*}
   End
Else
   Begin                                {*Normal text*}
   VESA_OutTextXY(TextPx,TextPy, fCaption);
   End;
Mse_Show;

If fClipped Then                        {*Restore preview clipping*}
   Begin
   VESA_SetViewPort(VP.X1, VP.Y1, VP.X2, VP.Y2, ClipOn);
   End;
End;

{ͻ
                            METHOD AText.GetMsg                             
 ͹
  IN.....: /                                                                
  OUT....: Result (TCompMessage) = Component messages.                      
  EXPLAIN: Manage and get messages from component.                          
  SEEALSO: Create, Draw                                                     
 ͼ}

Function AText.GetMsg:TCompMessage;
Begin
Result := CMNone;
If Not Enabled Then Exit;               {*Component disabled*}

Inherited GetMsg;
Result := Message.GetFromList;
End;

(*Procedure AText.Display       (    pX,pY:Integer; pPenColor:Longint; pValue:Longint); {*Define and display a value*}
Begin
Display(pX,pY, pPenColor, pValue);
End;

Procedure AText.Display       (    pX,pY:Integer; pPenColor:Longint; pFont:String; pFontSize:Word; pCaption:String);{*Display a text with special font*}
Begin
Display(pX,pY, pPenColor, pFont, pFontSize, pCaption);
End;

Procedure AText.Display_Attr  (    pX,pY:Integer; pBgColor,pPenColor:LongInt; pId:Word; pCaption:String);{*Old Display_Attr emulation*}
Begin
Display_Attr(pX,pY, pBgColor,pPenColor, pId, pCaption);
End;

Procedure AText.Display_Define(Var pText:TText; pX,pY:Integer; pBgColor,pPenColor:Longint; pFont:String; pFontSize,pHJustify:Byte;
                             pId:Word; pCaption:String); {*Define text*}
Begin
Display_Define(pText, pX,pY, pBgColor,pPenColor, pFont, pFontSize,pHJustify, pId, pCaption);
End;*)

{****************************************************************************}
{*** TDigitalText                                                         ***}
{****************************************************************************}

Procedure TDigitalText.Define;
Begin
fMask        := '8';
fMaskSep     := ':';
fAttenuation := 2.5;
Font.Name    := 'LCDN.CHR';
BgColor      := CLBlack;
Transparent  := No;
//Caption      := fMask+fMask + fMaskSep + fMask+fMask;

If Owner = Self Then Log.Add('Create new TDigitalText ('+')',2);
End;

Constructor TDigitalText.Create(AOwner:TComponent);
Begin
Inherited Create(AOwner);

Define;
End;

Constructor TDigitalText.Create(AOwner:TComponent; pX1,pY1:Integer; pPenColor:Longint; pCaption:String);
Begin
Inherited Create(AOwner, pX1,pY1, pPenColor, pCaption);

Define;
{If Transparent Then VESA_OutTextXY(10,10,'Transparent = Yes')
               Else VESA_OutTextXY(10,10,'Transparent = No');
//Mse_SetPointer(MPBusy); Wait;}
End;

Procedure TDigitalText.SetMask(M:Char);
Begin
If M = fMask Then Exit;
fMask := M;
Invalidate;                             {*Redraw if needs*}
End;

Procedure TDigitalText.SetMaskSep(M:Char);
Begin
If M = fMaskSep Then Exit;
fMaskSep := M;
Invalidate;                             {*Redraw if needs*}
End;

Procedure TDigitalText.SetAttenuation(A:Real);
Begin
If A = fAttenuation Then Exit;
fAttenuation := A;
Invalidate;                             {*Redraw if needs*}
End;

Procedure TDigitalText.Draw;
Var R,G,B            :Byte;             {*RGB composants for LCD displaying*}
    SavePenColor     :Longint;
    SaveTransparent  :Boolean;
    SaveCaption      :String;

Begin
If Not Visible Then Exit;

{If Transparent Then VESA_OutTextXY(10,10,'Transparent = Yes')
               Else VESA_OutTextXY(10,10,'Transparent = No');
//Mse_SetPointer(MPBusy); Wait;}

SaveCaption     := Caption;             {*Save some values*}
SavePenColor    := PenColor;
SaveTransparent := Transparent;

VESA_GetRGBColor(PenColor,R,G,B);       {*Calcule new color*}
R := Round (R / fAttenuation);
G := Round (G / fAttenuation);
B := Round (B / fAttenuation);

DrawOnModify := No;
PenColor     := VESA_SetRGBColor(R,G,B);{*Define some values*}
Caption      := Str_Mask(Caption,MaskSep,'8');
DrawOnModify := Yes;
//Transparent  := No;
Inherited Draw;                         {*Draw LCD mask*}

DrawOnModify := No;
Transparent  := Yes;
PenColor     := SavePenColor;           {*Restore some values*}
Caption      := SaveCaption;
DrawOnModify := Yes;
Inherited Draw;                         {*Draw text*}

DrawOnModify := No;
Transparent  := SaveTransparent;        {*Restore some values*}
DrawOnModify := Yes;
End;

{****************************************************************************}
{*** THyperText                                                           ***}
{****************************************************************************}

Procedure THyperText.Define;
Begin
SetRelieve(Yes);                        {*Text in relieve*}

If Owner = Self Then Log.Add('Create new THyperText ('+')',2);
End;

{ͻ
                          METHOD THyperText.Create                          
 ͹
  IN.....: AOwner (TComponent) = Owner of component.                        
  OUT....: /                                                                
  EXPLAIN: Create a new component. Parameters must be defined manually.     
 ͼ}

Constructor THyperText.Create(AOwner:TComponent);
Begin
Inherited Create(AOwner);

Define;
End;

{ͻ
                          METHOD THyperText.Create                          
 ͹
  IN.....: pX1,Py1 (Integer) = Component position.                          
           pPencolor (Longint) = Component text color.                      
           pRelieve (Boolean) = Draw text in relieve or shadow.             
           pCaption (String) = Text to display.                             
  OUT....: /                                                                
  EXPLAIN: Create a new component using defined parameters.                 
 ͼ}

Constructor THyperText.Create(AOwner:TComponent; pX1,pY1:Integer; pPenColor:Longint; pRelieve:Boolean; pCaption:String);
Begin
Inherited Create(AOwner, pX1,pY1, pPenColor, pCaption);

Define;

SetRelieve(pRelieve);                   {*Text in relieve or shadow*}
End;

{ͻ
                          METHOD THyperText.Draw                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Draw text component using defined parameters.                    
  SEEALSO: Create, Hide                                                     
 ͼ}

Procedure THyperText.Draw;
Var SavePenColor      :Longint;
    SaveTransparent   :Boolean;
    SaveOffsetX       :Integer;
    SaveOffsetY       :Integer;

Begin
If Not Visible Then Exit;

SavePenColor    := PenColor;
SaveTransparent := Transparent;
SaveOffsetX     := OffsetX;
SaveOffsetY     := OffsetY;

DrawOnModify := No;
PenColor     := fColorBelow;
DrawOnModify := Yes;
Inherited Draw;                         {*Draw text below*}

DrawOnModify := No;
PenColor     := fColorOver;
Transparent  := Yes;                    {*Don't clear background*}
OffsetX      := 1;                      {*Shift text over*}
OffsetY      := 1;
DrawOnModify := Yes;
Inherited Draw;                         {*Draw text over*}

DrawOnModify := No;
OffsetY      := SaveOffsetY;
OffsetX      := SaveOffsetX;
Transparent  := SaveTransparent;
PenColor     := SavePenColor;
DrawOnModify := Yes;
End;

{ͻ
                        METHOD THyperText.SetRelieve                        
 ͹
  IN.....: R (Boolean) = Relieve or shadow.                                 
  OUT....: /                                                                
  EXPLAIN: Define text as relieve or shadow.                                
  SEEALSO: Create, Draw                                                     
 ͼ}

Procedure THyperText.SetRelieve(R:Boolean);
Begin
If R = fRelieve Then Exit;
fRelieve := R;

If fRelieve Then                        {*Modify colors for relieve*}
   Begin
   fColorOver  := PenColor;
   fColorBelow := CLText;
   End
Else
   Begin                                {*Modify colors for shadow*}
   fColorOver  := CLShadow;
   fColorBelow := PenColor;
   End;

Invalidate;                             {*Redraw if needs*}
End;

{ͻ
                       METHOD THyperText.SetColorBelow                      
 ͹
  IN.....: C (Longint) = Set text color below the main text.                
  OUT....: /                                                                
  EXPLAIN: Define the text color below main text for relieve or shadow.     
  SEEALSO: Create, Draw                                                     
 ͼ}

Procedure THyperText.SetColorBelow(C:Longint);
Begin
If C = fColorBelow Then Exit;
fColorBelow := C;
Invalidate;                             {*Redraw if needs*}
End;

{ͻ
                        METHOD THyperText.SetColorOver                      
 ͹
  IN.....: C (Longint) = Set text color over the text below.                
  OUT....: /                                                                
  EXPLAIN: Define the main text color for relieve or shadow.                
  SEEALSO: Create, Draw                                                     
 ͼ}

Procedure THyperText.SetColorOver(C:Longint);
Begin
If C = fColorOver Then Exit;
fColorOver := C;
Invalidate;                             {*Redraw if needs*}
End;

{******************************* NO MAIN CODE *******************************}

Begin
End.
