{ͻ
                                UNIT MosTime                                
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: PLANAS Jean-Pierre                                           
  CREATED THE: 14.02.1999                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: Time and date management.                                    
  AUTONOMOUS.: Yes                                                          
  UNIT SIZE..: 293 Lines and (6.672 Bytes compiled)                         
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosTime;

{$Mode Objfpc}

INTERFACE

Uses
     MosGraph; {A}

Type

   TClock=Record                        {*Clock structure*}
   Cx,Cy          :Integer;             {*Center of the clock*}
   Sx,Sy          :Integer;             {*Radius X,Y of the clock*}
   Fs             :Integer;             {*Size factor...*}
   Show           :Boolean;             {*DIGITAL : Display or not*}
   OldS           :Word;                {*DIGITAL : Old Seconds*}
   Inter          :String[1];           {*DIGITAL : Between 2 numbers*}
   Cur            :Array[1..4] of Word;
   Old            :Array[1..3] of String[2];
   Oh,Om,Os,Od    :Word;                {*Latest hour*}
   Px,Py          :Integer;
   Aiguille       :Array[1..5] of TPointType;
   IT,CT          :Longint;             {*Timer : Initial and current time*}
   End;

   TDate=Record                         {*Date structure*}
   Day,Month      :Byte;
   Year           :Word;
   End;

   TTime=Record                         {*Time structure*}
   Hour,Minute,Second,Hund:Byte;
   End;

{|Time management|}
Procedure Time_InitTimer(Var T:TClock);           {*Initialise Timer*}
Function  Time_TestTimer(V:Integer; Var T:TClock):Boolean; {*Use a Timer*}
Function  Time_GetTime(Mode:Byte; Var T:TClock):String;{*String hour*}

Function  Time_GetDayName(Pd:Word):Byte;          {*Get the day of the week from packed date*}
Function  Time_PackDate(D,Mth,Yr:Word):Word;      {*Pack a date in a Word*}
Procedure Time_UnPackDate(Var D,Mth,Yr:Word; PD:Longint); {*Unpack the date*}

Function  Time_GetDaysInMonth(M,Y:Word):Byte;     {*Get Numbers of days in a month*}
Function  Time_GetSTime(Mode:Byte):String;        {*Return the Time in String*}
Function  Time_GetSDate:String;                   {*Return the Date in String*}

{|Miscellaneous|}
Function  Cmp_Date(D1,D2:TDate):Boolean; {*Compare 2 dates*}

IMPLEMENTATION

Uses
     Dos,
     MosBase,
     MosConfig,
     MosStrings;

{*----------------------------- TIME FUNCTIONS -----------------------------*}

{ͻ
                          PROCEDURE Time_InitTimer                          
 ͹
  IN......: T (TClock) = TClock structure.                                  
  OUT.....: /                                                               
  EXPLAIN.: Initialise a timer (must be called before test timer).          
 ͼ}

Procedure Time_InitTimer(Var T:TClock);
Begin
T.Show:=No;
End;

{ͻ
                          FUNCTION Time_TestTimer                           
 ͹
  IN......: V (INTEGER) = Delay in 1/60th Seconds.                          
            T (TClock) = TClock structure.                                  
  OUT.....: (BOOLEAN) = TRUE if the delay is ended, else FALSE.             
  EXPLAIN.: Create a Timer witch will return TRUE when the delay is ended.  
 ͼ}

Function Time_TestTimer(V:Integer; Var T:TClock):Boolean;
Begin
With T do
   Begin
   GetTime(Cur[1],Cur[2],Cur[3],Cur[4]);{*Get Current Time*}
   CT:=Cur[1]*21600+Cur[2]*3600+Cur[3]*60+Cur[4];
{   CT:=Cur[1]*3600+Cur[2]*60+Cur[3];}
   If (IT<>CT) And (Not Show) Then      {*Initialise Timer (First Time)*}
      Begin
      IT:=CT;
      Show:=True;                       {*Initialisations Faites*}
      End;

   If (Show=True) And (CT-IT>=V)        {*Delay Ecoul...*}
      Then
         Begin
         IT:=CT-1; Show:=No;
         Time_TestTimer:=TRUE           {*Reset timer and Send Ok*}
         End
      Else Time_TestTimer:=FALSE;
   End;
{gotoxy(1,1); writeln(T.CT-T.IT,' ');
gotoxy(1,2); writeln(V,' ');}
End;

{ͻ
                           FUNCTION Time_GetSTime                           
 ͹
  IN.....: Mode (BYTE) = If Mode = 1 the function returns hunds else no.    
  OUT....: (STRING) = Return the time in a string.                          
  EXPLAIN: Return a string witch contain the current time (with seconds).   
  SEEALSO: Time_GetSDate                                                    
 ͼ}

Function Time_GetSTime(Mode:Byte):String;
Var  H,M,S,Hund:Word;
     St:String;
Begin
GetTime(H,M,S,Hund);
St:=Str_FillZero(H,2)+':'+Str_FillZero(M,2)+':'+Str_FillZero(S,2);
If Mode=1 Then St:=St+':'+Str_FillZero(Hund,2);
Time_GetSTime:=St;
End;

{ͻ
                           FUNCTION Time_GetSDate                           
 ͹
  IN.....: /                                                                
  OUT....: (STRING) = Return the date in a string.                          
  EXPLAIN: Return a string witch contain the current date.                  
  SEEALSO: Time_GetSTime                                                    
 ͼ}

Function Time_GetSDate:String;
Var Y,M,D,Dow:Word;
    YSt:String;
Begin
GetDate(Y,M,D,Dow);

Str(Y,YSt);
Time_GetSDate:=Str_FillZero(D,2)+'.'+Str_FillZero(M,2)+'.'+YSt;
End;

{ͻ
                           FUNCTION Time_GetTime                            
 ͹
  IN.....: Mode (BYTE) = Not used now, will be later.                       
           T (TClock) = TClock variable structure TClock.                   
  OUT....: (STRING) = Return the hour in the string.                        
  EXPLAIN: Return a string witch contain the current time.                  
           If the time d'ont change since last call, the function return    
           an empty string.                                                 
  NB.....: To use with "Display" procedure.                                 
  SEEALSO: Display                                                          
 ͼ}

Function Time_GetTime(Mode:Byte; Var T:TClock):String;
Var Lti:Integer;

Begin
// To avoid warnings !
Mode := Mode;

GetTime(T.Cur[1],T.Cur[2],T.Cur[3],T.Cur[4]);{*Gestion de l'Heure Menu*}
T.Show:=False;
If T.OldS<>T.Cur[3] Then                {*Nouvelle Seconde*}
   Begin
   For Lti:=1 to 3 do Begin             {*H / M / S*}
      Str(T.Cur[Lti],T.Old[Lti]);
      If Length(T.Old[Lti])=1 Then T.Old[Lti]:='0'+T.Old[Lti];
      End;
   T.Inter:=TSep[Sys.TimeSeparator];    {*Swap Entre ":" et " "*}
   T.Show:=True;
   End;

If (T.Cur[4]>45) And (T.Inter=TSep[Sys.TimeSeparator]) Then
   Begin T.Inter:=' '; T.Show:=True; End;

If T.Show Then                          {*Fait un Affichage*}
   With T do Time_GetTime:=Old[1]+Inter+Old[2]+Inter+Old[3]
   Else Time_GetTime:='';

T.OldS:=T.Cur[3];                       {*Save Old Seconds*}
End;

{ͻ
                          FUNCTION Time_GetDayName                          
 ͹
  IN......: Pd (WORD) = Day Packed                                          
  OUT.....: Res (BYTE) = N of the day of the week (0 <-> 6).               
  EXPLAIN.: Returns the N of the day of the week (Calender julien)         
  NB......: The day 0 = Monday to 6=Sunday.                                 
 ͼ}

Function Time_GetDayName(Pd:Word):Byte;
Begin
Time_GetDayName:=(Pd-1) Mod 7;
End;

{ͻ
                        FUNCTION Time_GetDaysInMonth                        
 ͹
  IN......: Month,Year (WORD) = Month and Year.                             
  OUT.....: (BYTE) = Number of days in the month.                           
  EXPLAIN.: Returns the numbers of days in the specified month.             
  NB......: This function works between years 1901 to 2078.                 
 ͼ}

Function Time_GetDaysInMonth(M,Y:Word):Byte;
Begin
   Case M of
   1,3,5,7,8,10,12 :Time_GetDaysInMonth:=31;
   4,6,9,11        :Time_GetDaysInMonth:=30;
   2               :Time_GetDaysInMonth:=28+Ord((Y Mod 4)=0);
   End;
End;

{ͻ
                           FUNCTION Time_PackDate                           
 ͹
  IN......: D,Mth,Yr (WORD) = Day, Month and Year of the date.              
  OUT.....: (WORD) = Packed day.                                            
  EXPLAIN.: Transform a date to a julian date.                              
  NB......: This function work between years 1901  2078.                   
 ͼ}

Const TDays: Array[Boolean,0..12] of Word =
                ((0,31,59,90,120,151,181,212,243,273,304,334,365),
                (0,31,60,91,121,152,182,213,244,274,305,335,366));

Function Time_PackDate(D,Mth,Yr:Word):Word;
Var Temp  :Word;
    Lyr   :Boolean;

Begin
Lyr:=(Yr Mod 4=0);
If Yr>=1900 Then Dec(Yr,1900);
Temp:=Yr*Word(365)+(Yr Div 4)-Ord(Lyr);
Inc(Temp,TDays[Lyr][Mth-1]);
Inc(Temp,D);
Time_PackDate:=Temp;
End;

{ͻ
                         PROCEDURE Time_UnPackDate                          
 ͹
  IN......: PD (WORD) = Packed day.                                         
  OUT.....: D,Mth,Yr (WORD) = Day, Month and Year of the packed day.        
  EXPLAIN.: Returns the date in function of the packed date.                
  NB......: This function work between years 1901  2078.                   
 ͼ}

Procedure Time_UnPackDate(Var D,Mth,Yr:Word; PD:Longint);
Var julian : Word;
    lyr    : Boolean;

Begin
d:= pd;
yr:= (LongInt(d)*4) div 1461;
julian:=d-(yr*365+(yr div 4));
inc(yr,1900);
lyr:=(yr mod 4 = 0);
inc(julian,ord(lyr));
mth:=0;
While julian>TDays[lyr][mth] do Inc(mth);
d:=julian-TDays[lyr][mth-1];
End;

{ͻ
                             FUNCTION CMP_DATE                              
 ͹
  IN.....: D1,D2 : (TDate) = 2 dates to be compared                         
  OUT....: (BOOLEAN) : True  = D1<D2                                        
                       False = D1>=D2                                       
  EXPLAIN: Test if a date in before than another.                           
 ͼ}

Function Cmp_Date(D1,D2:TDate):Boolean;
Begin
If (D1.Year<D2.Year) Or
   ((D1.Year=D2.Year) And (D1.Month<D2.Month)) Or
   ((D1.Year=D2.Year) And (D1.Month=D2.Month) And (D1.Day<D2.Day)) Then
  Cmp_Date:=True Else Cmp_date:=False;
End;

{*--------------------------- Programme Principal ------------------------------*}

BEGIN
END.
