{ͻ
                               UNIT MosTools                                
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 06.11.1993                                                   
  COUNTRY....: Montpellier - IUT (FRANCE)                                   
  DESCRIPTION: Graphical tools like boxes for MOS.                          
  AUTONOMOUS.: Partial                                                      
  UNIT SIZE..: 1.049 Lines and (23.120 Bytes compiled)                      
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosTools;

{$Mode ObjFpc}

INTERFACE

Uses
     MosConfig,
     MosMouse,
     MosText;

Const
   BLNoLine       = 0;                  {*Border line definition*}
   BLUniformLine  = 1;
   BLLoweredLine  = 2;
   BLRaisedLine   = 3;

   TPTopLeft      = 0;                  {*Title Position for Bevel*}
   TPTopCenter    = 1;
   TPTopRight     = 2;
   TPMediumLeft   = 3;
   TPMediumRight  = 4;
   TPBottomLeft   = 5;
   TPBottomCenter = 6;
   TPBottomRight  = 7;
   TPCenter       = 8;

   COHorizontal   = 0;                  {*Component orientation*}
   COVertical     = 1;

Type

TSingleBorder=Record                    {*Single border structure*}
   Style               :Byte;           {*Border style*}
       {  0 = BLNoline}
       {  1 = BLUniformLine}
       {  2 = BLLoweredLine}
       {  3 = BLRaisedLine}
   LineStyle           :Byte;           {*Border line style (Solid, dot...)*}
       {  0 = SolidLn}
       {  1 = DottedLn}
       {  2 = CenterLn}
       {  3 = DashedLn}
       {  4 = UserBitLn 4 (User-defined line style)}
   LineSize            :Byte;           {*Border line size in pixels*}
   Color               :LongInt;        {*Border line color*}
   End;

TBorder=Record                          {*Border structure*}
   Width               :Byte;           {*Size between borders*}
   Inner               :TSingleBorder;  {*Inner border line*}
   Outer               :TSingleBorder;  {*Outer border line*}
   Color               :Longint;        {*Border background color*}
   Filled              :Boolean;        {*Fill the border*}
   End;

TShape=Record                           {*Shape structure*}
   Color               :Longint;        {*Shape background color*}
   Filled              :Boolean;        {*Fill the shape*}
   BorderWidth         :Byte;           {*Space beetween shape and border*}
   Pattern             :ShortString;    {*Use pattern to fill. Default=''*}
   End;

TBevel=Record                           {*Bevel structure*}
   Title               :TText;          {*Bevel title*}
   Shape               :TShape;         {*Bevel shape*}
   Border              :TBorder;        {*Bevel borders*}
   Box                 :TCoordinates;   {*Bevel coordinates*}
   Popup               :ShortString;    {*Popup menu file definition*}
   Hint                :ShortString;    {*Hint file to display*}
   End;

{|Draw tools|}
Procedure Grid_Draw(C:TCoordinates; StepX,StepY:Integer; Color:Longint);{*Plot a grid*}
Procedure Tool_Line(X1,Y1,X2,Y2,Style,Relief:Integer); {*Draw a line in relief*}
Procedure Bar_FillGray(X1,Y1,X2,Y2:Integer);{*Fill in Gray for "FREEZE"*}
Procedure Bar_Progress(X1,Y1,X2,Y2:Integer; Col:Longint; Percent:Integer; Id:Word);{*Draw a Progress Bar*}

{|Shade management|}
Procedure Display_Shade    (X1,Y1,X2,Y2:Integer; C1,C2:LongInt;Sens:Integer);{*Display a shade box*}
Procedure Display_ShadeBox (X1,Y1,X2,Y2:Integer; Color:Longint); {*Shade with primary color*}

{|Miscellaneous|}
Function  Test_AnythingActioned(Var P:TAction; Mode:Byte):Boolean; {*Test if there is an action*}

{|Bevel Boxes|}
Procedure Bevel         (    X1,Y1,X2,Y2:Integer; ShapeColor:Longint; OuterStyle,InnerStyle:Byte; ShapeFilled:Boolean);{*Display Bevel*}
Procedure Bevel         (    X1,Y1,X2,Y2:Integer; ShapeColor:Longint);{*Display simple Bar*}
Procedure Bevel_Draw    (    Bevel:TBevel);            {*Draw a Bevel*}
Procedure Bevel_Mos     (    X1,Y1,X2,Y2:Integer; ShapeColor,TitlePenColor:Longint; OuterStyle,InnerStyle:Byte; ShapeFilled:Boolean; Caption:String);{*Display Old MOS Bevel style*}
Procedure Bevel_Border  (    X1,Y1,X2,Y2:Integer; ShapeColor,BorderColor:Longint; OuterStyle,InnerStyle, BorderSize:Byte; ShapeFilled,BorderFilled:Boolean); {*Bevel Border*}
Procedure Bevel_Title   (    X1,Y1,X2,Y2:Integer; ShapeColor,PenColor:Longint; OuterStyle,InnerStyle,   {*Bevel with title*}
                             HJustify,VJustify:Byte; ShapeFilled:Boolean; FontName:String; FontSize:Byte; IdText:Word; Caption:String);
Procedure Bevel_Define  (Var Bevel:TBevel; X1,Y1,X2,Y2:Integer; ShapeColor,PenColor:Longint;            {*Define a Bevel*}
                             OuterStyle,InnerStyle, HJustify,VJustify,BorderWidth:Byte; ShapeFilled:Boolean; FontName:String; FontSize:Byte; IdText:Word; Caption:String);

IMPLEMENTATION

Uses
     Windows,
     MosBase,
     MosBlankers,
     MosColors,
     MosCPUInstructions,
     MosCrt,
     MosErrors,
     MosGraph,
     MosImages,
     MosKeyboard,
     MosStrings;

{*--------------------------- Shades Management ----------------------------*}

{ͻ
                         PROCEDURE Display_ShadeBox                         
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Position of box.                         
           Color (LONGINT) = Color to use for shade box displaying.         
  OUT....: /                                                                
  EXPLAIN: Fill the box with a shade using the main color.                  
  EXAMPLE: Display_ShadeBox(50,100,130,110, Color);                         
 ͼ}

Procedure Display_ShadeBox(X1,Y1,X2,Y2:Integer; Color:Longint);
Var C1,C2:Longint;
    Y,A,QttPixel,HalfPixel:Integer;
    R1b,G1b,B1b:Byte;
    Vg,R2,G2,B2,Ra,Ga,Ba:Byte;
    Step,SRu,SGu,SBu,SRl,SGl,SBl:Real;

Begin
Y:=Y1;
QttPixel:=Y2-Y1;
Step:=255/Real(QttPixel); HalfPixel:=QttPixel Div 2;

VESA_GetRGBColor(Color,R2,G2,B2);       {*Calcul steps for upper part*}
SRu:=R2/Real(HalfPixel);
SGu:=G2/Real(HalfPixel);
SBu:=B2/Real(HalfPixel);

R1b:=R2; G1b:=G2; B1b:=B2;
SRl:=(255-R1b)/Real(HalfPixel);
SGl:=(255-G1b)/Real(HalfPixel);
SBl:=(255-B1b)/Real(HalfPixel);

For A:=0 to QttPixel do
   Begin
   Vg:=Round(Step*A);                   {*Left color calculation*}
   If Vg>255 Then Vg:=255;

   C1:=VESA_SetRGBColor(Vg,Vg,Vg);

   If A<=HalfPixel Then
      Begin
      Ra:=Round(SRu*A);
      Ga:=Round(SGu*A);
      Ba:=Round(SBu*A);
      End
   Else
      Begin
      Ra:=R1b+Round(SRl*(A-HalfPixel));
      Ga:=G1b+Round(SGl*(A-HalfPixel));
      Ba:=B1b+Round(SBl*(A-HalfPixel));
      End;
   C2:=VESA_SetRGBColor(Ra,Ga,Ba);
   Display_Shade(X1,Y,X2,Y,C1,C2,0);
   Inc(Y);
   End;
End;

{ͻ
                          PROCEDURE Display_Shade                           
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Position of box.                         
           C1,C2 (LONGINT) = First and last color to use.                   
           Sens (INTEGER) = 0=Horizontal, 1=Vertical shade.                 
  OUT....: /                                                                
  EXPLAIN: Fill the box with an horizontal shade.                           
  EXAMPLE: Display_Shade(50,100,130,110, 240,16);                           
 ͼ}

Procedure Display_Shade(X1,Y1,X2,Y2:Integer; C1,C2:Longint; Sens:Integer);
Var A:Integer;                          {*Loop*}
    SizeX,SizeY:Longint;                   {*Taille Block Title*}
    Px:Integer;
    QttPixel:Integer;                   {*Quantity of pixels*}
    Save_Color:LongInt;
    R,G,B,R1,G1,B1,R2,G2,B2:Byte;

Begin
Save_Color:=VESA_GetColor;
SizeX:=X2-X1+1;
SizeY:=Y2-Y1+1;
If Sens=COHorizontal Then QttPixel:=SizeX;
If Sens=COVertical   Then QttPixel:=SizeY;

Mse_Hide;
VESA_GetRGBColor(C1,R1,G1,B1);
VESA_GetRGBColor(C2,R2,G2,B2);
R:=R1;G:=G1;B:=B1;

For A:=0 to QttPixel-1 do
   Begin                                {*Draw shade*}
   R:=R1+(R2-R1)*A div (QttPixel-1);
   G:=G1+(G2-G1)*A div (QttPixel-1);
   B:=B1+(B2-B1)*A div (QttPixel-1);
   VESA_SetColor(VESA_SetRgbColor(R,G,B));
   If Sens=COHorizontal Then            {*Horizontal shade*}
      Begin
      Px:=A+X1;
      VESA_Line(Px,Y1,Px,Y2);
      End;
   If Sens=COVertical Then              {*Vertical shade*}
      Begin
      Px:=A+Y1;
      VESA_Line(X1,Px,X2,Px);
      End;
   End;

Mse_Show;
VESA_SetColor(Save_Color)
End;

{*--------------------------- Bevels Management ----------------------------*}

{ͻ
                              PROCEDURE Bevel                               
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Bevel's coordinates.                     
           ShapeColor (LONGINT) = Shape and border color.                   
                  If ShapeColor=-1 ShapeColor take the background color.    
  OUT....: /                                                                
  EXPLAIN: Define a simple colored bar as the "Bar" function.               
  SEEALSO: Bevel_Define, Bevel_Draw, Bevel_Border, Bevel_Title              
 ͼ}

Procedure Bevel(X1,Y1,X2,Y2:Integer; ShapeColor:Longint);
Begin
Bevel(X1,Y1,X2,Y2,ShapeColor,BLNoLine,BLNoLine,Yes);
End;

{ͻ
                              PROCEDURE Bevel                               
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Bevel's coordinates.                     
           ShapeColor (LONGINT) = Shape and border color.                   
                  If ShapeColor=-1 ShapeColor take the background color.    
           OuterStyle (BYTE) = Outer border line style.                     
           InnerStyle (BYTE) = Inner border line style.                     
           ShapeFilled (BOOLEAN) = Fill the shape or no.                    
  OUT....: /                                                                
  EXPLAIN: Define and display a classic Bevel Box.                          
  SEEALSO: Bevel_Define, Bevel_Draw, Bevel_Border, Bevel_Title              
 ͼ}

Procedure Bevel(X1,Y1,X2,Y2:Integer;ShapeColor:LongInt; OuterStyle,InnerStyle:Byte; ShapeFilled:Boolean);
Var Bevel:TBevel;
Begin
Bevel_Define(Bevel,X1,Y1,X2,Y2,ShapeColor,0,OuterStyle,InnerStyle,TJOnLeft,TJOnTop,
             1,ShapeFilled,'',0,$0063,'');
Bevel_Draw(Bevel);
End;

{ͻ
                            PROCEDURE Bevel_Mos                             
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Bevel's coordinates.                     
           ShapeColor (LONGINT) = Define the shape color.                   
                  If ShapeColor=-1 ShapeColor take the background color.    
           TitlePenColor (LONGINT) = Define the title pen color.            
           OuterStyle (BYTE) = Outer border line style.                     
           InnerStyle (BYTE) = Inner border line style.                     
           ShapeFilled (BOOLEAN) = Fill the shape or no.                    
           Caption (STRING) = Displayed title.                              
  OUT....: /                                                                
  EXPLAIN: Display old MOS Bevel box style.                                 
  SEEALSO: Bevel_Define, Bevel_Draw                                         
 ͼ}

Procedure Bevel_Mos (X1,Y1,X2,Y2:Integer; ShapeColor,TitlePenColor:Longint; OuterStyle,InnerStyle:Byte; ShapeFilled:Boolean; Caption:String);
Var Bevel1:TBevel;
    HalfSize,XCenter,Tx1,Tx2:Integer;
    Text:TText;

Begin
Bevel_Define (Bevel1,X1,Y1,X2,Y2,ShapeColor,TitlePenColor,OuterStyle,InnerStyle,TJOnCenter,TJOnTop,
              1,ShapeFilled,'',0,$0063,'');
Bevel_Draw   (Bevel1);

HalfSize:=(VESA_TextWidth(Caption)+40) Div 2;
XCenter:=((X1+X2) Div 2);              {*Build title coordinates*}
Tx1:=XCenter-HalfSize+1;
If Tx1<X1+20 Then Tx1:=X1+20;
Tx2:=XCenter+HalfSize+1;
If Tx2>X2-20 Then Tx2:=X2-20;

Display_Shade (X1+8, Y1-6,X2-8,Y1+6, Sys.PanelShadeCol1,Sys.PanelShadeCol2,0);{*Display a ShadeBox*}
Display_Define(Text,X1+25,Y1-6,-1,TitlePenColor,'',4,TJOnLeft,$0002,Caption);
Display_Draw  (Text);
Bmp_ShowTransparency(X1+11,Y1-5,X1+30,Y1+10,0,0,Sys.GetPath(SP_BUTTONS)+Sys.ImgBevel,$0080,CLTransparency);
End;

{ͻ
                           PROCEDURE Bevel_Border                           
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Bevel's coordinates.                     
           ShapeColor (LONGINT) = Define the shape color.                   
                  If ShapeColor=-1 ShapeColor take the background color.    
           BorderColor (LONGINT) = Define the border color.                 
           OuterStyle (BYTE) = Outer border line style.                     
           InnerStyle (BYTE) = Inner border line style.                     
           BorderSize (BYTE) = The border size in pixels.                   
           ShapeFilled (BOOLEAN) = Fill the shape or no.                    
           BorderFilled (BOOLEAN) = Fill the Border or no.                  
  OUT....: /                                                                
  EXPLAIN: Define and display a Bevel Box. Special for Bevels with borders. 
  SEEALSO: Bevel_Define, Bevel_Draw                                         
 ͼ}

Procedure Bevel_Border (X1,Y1,X2,Y2:Integer;ShapeColor,BorderColor:LongInt; OuterStyle,InnerStyle,
                        BorderSize:Byte; ShapeFilled,BorderFilled:Boolean);
Var Bevel1:TBevel;
Begin
Bevel_Define (Bevel1,X1,Y1,X2,Y2,ShapeColor,0,OuterStyle,InnerStyle,TJOnLeft,TJOnTop,
              BorderSize,ShapeFilled,'',0,$0063,'');
Bevel1.Border.Color :=BorderColor;
Bevel1.Border.Filled:=BorderFilled;
Bevel_Draw   (Bevel1);
End;

{ͻ
                           PROCEDURE Bevel_Title                            
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Bevel's coordinates.                     
           ShapeColor (LONGINT) = Shape and border color.                   
                  If ShapeColor=-1 ShapeColor take the background color.    
           PenColor (LONGINT) = Pen color for title displaying.             
           OuterStyle (BYTE) = Outer border line style.                     
           InnerStyle (BYTE) = Inner border line style.                     
           HJustify (BYTE) = Horizontal text justification :                
              1 = TJOnLeft      Left justify                                
              2 = TJOnRight     Right justify                               
              3 = TJOnCenter    Center                                      
              6 = TJJustify     Justify text                                
           VJustify (BYTE) = Vertical text justification :                  
              4 = TJOnTop       Top justify                                 
              5 = TJOnBottom    Bottom justify                              
              3 = TJOnCenter    Center                                      
           ShapeFilled (BOOLEAN) = Fill the shape or no.                    
           FontName (STRING) = Font filename to use.                        
           FontSize (BYTE) = Font size to use.                              
           IdText (WORD) = Id for text parameters (Usually $0063).          
           Caption (STRING) = Bevel title.                                  
  OUT....: /                                                                
  EXPLAIN: Define and display a Bevel Box. Special for Bevels Titled.       
  SEEALSO: Bevel_Define, Bevel_Draw                                         
 ͼ}

Procedure Bevel_Title(X1,Y1,X2,Y2:Integer;ShapeColor,PenColor:LongInt; OuterStyle,InnerStyle,HJustify,VJustify:Byte;
                      ShapeFilled:Boolean; FontName:String; FontSize:Byte; IdText:Word; Caption:String);
Var Bevel1:TBevel;

Begin
Bevel_Define (Bevel1,X1,Y1,X2,Y2,ShapeColor,PenColor,OuterStyle,InnerStyle,HJustify,VJustify,
              1,ShapeFilled,FontName,FontSize,IdText,Caption);
Bevel_Draw   (Bevel1);
End;

{ͻ
                           PROCEDURE Bevel_Define                           
 ͹
  IN.....: Bevel (TBevel) = Pointer to the TBevel structure.                
           X1,Y1,X2,Y2 (INTEGER) = Bevel's coordinates.                     
           ShapeColor (LONGINT) = Shape and border color.                   
                  If ShapeColor=-1 ShapeColor take the background color.    
           PenColor (LONGINT) = Pen color for the bevel's title.            
           OuterStyle (BYTE) = Outer border line style.                     
           InnerStyle (BYTE) = Inner border line style.                     
           HJustify (BYTE) = Horizontal text justification :                
              1 = TJOnLeft      Left justify                                
              2 = TJOnRight     Right justify                               
              3 = TJOnCenter    Center                                      
              6 = TJJustify     Justify text                                
           VJustify (BYTE) = Vertical text justification :                  
              4 = TJOnTop       Top justify                                 
              5 = TJOnBottom    Bottom justify                              
              3 = TJOnCenter    Center                                      
           BorderWidth (BYTE) = Border size in pixels between inner         
                                and outer border lines (1 -> n).            
           ShapeFilled (BOOLEAN) = Fill the shape or no.                    
           FontName (STRING) = Font filename to use.                        
           FontSize (BYTE) = Font size to use.                              
           IdText (WORD) = Id for text parameters (Usually $0063).          
           Caption (STRING) = Bevel's title to display (optional).          
  OUT....: /                                                                
  EXPLAIN: Define a Bevel Box with more parameters than classic Bevel.      
           After use this procedure, you can set more parameters if you want
           Please see the TBevel structure to see what parameter to set.    
  SEEALSO: Bevel_Draw, Bevel                                                
 ͼ}

Procedure Bevel_Define (Var Bevel:TBevel; X1,Y1,X2,Y2:Integer;ShapeColor,PenColor:LongInt; OuterStyle,InnerStyle,
                       HJustify,VJustify,BorderWidth:Byte; ShapeFilled:Boolean;
                       FontName:String; FontSize:Byte; IdText:Word; Caption:String);
Begin
Bevel.Box.X1:=X1;

Bevel.Box.Y1:=Y1;
Bevel.Box.X2:=X2;
Bevel.Box.Y2:=Y2;
If ShapeColor=-1 Then ShapeColor:=VESA_GetPixel(X1+1,Y1+1);
Bevel.Shape.Color:=ShapeColor;
Bevel.Shape.Filled:=ShapeFilled;
Bevel.Shape.BorderWidth:=0;
Bevel.Shape.Pattern:='';
Bevel.Border.Outer.Style:=OuterStyle;
Bevel.Border.Outer.Color:=CLBlack;
Bevel.Border.Outer.LineSize:=1;
Bevel.Border.Outer.LineStyle:=SolidLn;
Bevel.Border.Inner.Style:=InnerStyle;
Bevel.Border.Inner.Color:=CLBlack;
Bevel.Border.Inner.LineSize:=1;
Bevel.Border.Inner.LineStyle:=SolidLn;
Bevel.Border.Color:=ShapeColor;
Bevel.Border.Filled:=Yes;
Bevel.Border.Width:=BorderWidth;

Display_Define(Bevel.Title,X1+10,Y1-5,ShapeColor,PenColor,FontName,FontSize,TJOnLeft,IdText,Caption);
Bevel.Title.Width :=X2-X1-20;
Bevel.Title.Height:=Y2-Y1+8;
Bevel.Title.HJustify:=HJustify;
Bevel.Title.VJustify:=VJustify;
End;

{ͻ
                            PROCEDURE Bevel_Draw                            
 ͹
  IN.....: Bevel (TBevel) = Pointer to the TBevel structure.                
  OUT....: /                                                                
  EXPLAIN: Display (draw) a Bevel using a TBevel structure.                 
  SEEALSO: Bevel_Define, Bevel                                              
 ͼ}

Procedure Bevel_Draw(Bevel:TBevel);
Var BWidth:Shortint;
    S:TCoordinates;
    Offset:Integer;

Procedure In_DrawOneBorder(X1,Y1,X2,Y2:Integer; CBorder:TSingleBorder);
Begin                                   {*Draw one border*}
VESA_SetColor(CBorder.Color);
VESA_SetLineStyle(CBorder.LineStyle,0,CBorder.LineSize);

Case CBorder.Style of                   {*Single Line*}
   BLUniformLine : VESA_Rectangle(X1,Y1,X2,Y2);
   BLLoweredLine :                      {*Lowered*}
      Begin
      VESA_Line(X1,Y1,X2,Y1); VESA_Line(X1,Y1,X1,Y2);
      VESA_SetColor(CLLineUp);
      VESA_Line(X1+1,Y2,X2,Y2); VESA_Line(X2,Y1,X2,Y2);
      End;
   BLRaisedLine  :                      {*Raised*}
      Begin
      VESA_Line(X1,Y2,X2,Y2); VESA_Line(X2,Y1,X2,Y2);
      VESA_SetColor(CLLineUp);
      VESA_Line(X1,Y1,X2-1,Y1); VESA_Line(X1,Y1,X1,Y2);
      End;
   End;
End;

{****************************************************************************}

Begin
With Bevel do
   Begin
   BWidth:=Border.Width;
   Mse_Hide;                            {*Hide mouse again*}
   {*** DRAW SHAPE ***}
   If Shape.Filled Then
      Begin
      If Border.Outer.Style=BLNoLine Then Dec(BWidth,1);
      If Border.Inner.Style=BLNoLine Then Dec(BWidth,1);
      VESA_SetFillStyle(1,Shape.Color);
      S.X1:=Box.X1+BWidth+1+Shape.BorderWidth;
      S.Y1:=Box.Y1+BWidth+1+Shape.BorderWidth;
      S.X2:=Box.X2-BWidth-1-Shape.BorderWidth;
      S.Y2:=Box.Y2-BWidth-1-Shape.BorderWidth;
      VESA_Bar(S.X1,S.Y1,S.X2,S.Y2);
      End;

   {*** DRAW BORDERS ***}
   BWidth:=Border.Width;
   Offset:=BWidth;
   If Border.Outer.Style<>BLNoLine Then
      Begin
      In_DrawOneBorder(Box.X1,Box.Y1,Box.X2,Box.Y2,Border.Outer);
      Offset:=0;
      End;
   If Border.Inner.Style<>BLNoLine Then In_DrawOneBorder(Box.X1+BWidth-Offset, Box.Y1+BWidth-Offset, Box.X2-BWidth+Offset, Box.Y2-BWidth+Offset, Border.Inner);
   If (Border.Width>1) And (Border.Filled) Then
      Begin                             {*Fill border with color*}
      VESA_SetFillStyle(1,Border.Color);
      VESA_Bar(Box.X1+1,Box.Y1+1,Box.X2-1,Box.Y1+BWidth-1);
      VESA_Bar(Box.X1+1,Box.Y2-BWidth+1,Box.X2-1,Box.Y2-1);
      VESA_Bar(Box.X1+1,Box.Y1+1,Box.X1+BWidth-1,Box.Y2-1);
      VESA_Bar(Box.X2-BWidth+1,Box.Y1+1,Box.X2-1,Box.Y2-1);
      End;
   Mse_Show;                            {*Display mouse again*}
   {*** DRAW TITLE ***}
   If Title.Caption<>'' Then Display_Draw(Title);
   Font_Set(Sys.FontMain, Sys.FontMainSize);
   End;
End;

{*----------------------------- MISCELLANEOUS ------------------------------*}

{ͻ
                       FUNCTION Test_AnythingActioned                       
 ͹
  IN.....: P (TACTION) = Record witch will contains all infos               
           Mode (BYTE) = C_Init    = 1 = Initialise the P record            
                         C_Execute = 2 = Test if there is an action         
  OUT....: P (TACTION) = Record witch will contains all infos               
           (BOOLEAN) = If an action is detected and you are in mode=2 then  
                       return TRUE, else FALSE                              
  EXPLAIN: Test if an action (Key pressed, mouse button pressed or mouse    
           moved) is made.                                                  
 ͼ}

Function Test_AnythingActioned(Var P:TAction; Mode:Byte):Boolean;
Begin
Test_AnythingActioned:=FALSE;           {*De Base...*}

If Mode=C_Init Then Begin               {*Initialise Record*}
   Mse_Get(P.State.X,P.State.Y,P.State.L,P.State.M,P.State.R);
   P.XOld:=P.State.X; P.YOld:=P.State.Y;
   Exit;
   End;

If Mode=C_Execute Then Begin            {*Test Values*}
   If Keypressed Then Test_AnythingActioned:=TRUE;
//   If Kbd_TestSpecialKey($0F,B_OR) Then Test_AnythingActioned:=TRUE;
   If Kbd_GetKeyDown(VK_SHIFT) or Kbd_GetKeyDown(VK_CONTROL) or
      Kbd_GetKeyDown(VK_MENU) Then Test_AnythingActioned:=TRUE;
   Mse_Get(P.State.X,P.State.Y,P.State.L,P.State.M,P.State.R);
   If (P.State.L) Or (P.State.M) Or (P.State.R) Then Test_AnythingActioned:=TRUE;
   If (P.State.X<>P.XOld) Or (P.State.Y<>P.YOld) Then Test_AnythingActioned:=TRUE;
   P.XOld:=P.State.X; P.YOld:=P.State.Y;
   End;
End;

{*--------------------------------- DRAW -----------------------------------*}

{ͻ
                           PROCEDURE Bar_FillGray                           
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Position of box on screen.               
  OUT....: /                                                                
  EXPLAIN: Fill the box to gray (Used by "FREEZE_xxx").                     
  EXAMPLE: Bar_FillGray(50,100,130,110);                                    
 ͼ}

Procedure Bar_FillGray(X1,Y1,X2,Y2:Integer);

Var A1,B1,A2,B2:Integer;                {*Coordones line*}
Begin
If X1>X2 Then Exg(X1,X2);               {*Controle des paramtres*}
If Y1>Y2 Then Exg(Y1,Y2);
If (X1<0) Or (Y1<0) Or (X2>VESA_GetMaxX) Or (Y2>VESA_GetMaxY) Then
   Begin Error(650); Exit; End;        {*Illegal Parameters*}

A1:=X1; B1:=Y1; A2:=X1; B2:=Y1;         {*Initialisation*}
VESA_SetWriteMode(XorPut); VESA_SetColor(VESA_SetRGBColor(0,0,127));
If Odd(X2-X1)=True Then Dec(X2,1);      {*Correct Coordones*}
If Odd(Y2-Y1)=True Then Dec(Y2,1);

Mse_Hide;
Repeat
VESA_Line(A1,B1,A2,B2);                 {*Draw Line*}
Inc(A2,2); Inc(B1,2);                   {*Dcalage pour la Prochaine Ligne*}
If A2>X2 Then Begin A2:=X2; Inc(B2,2); End;
If B1>Y2 Then Begin B1:=Y2; Inc(A1,2); End;
Until (A1>X2) And (B2>Y2);              {*Fin du Remplissage*}
Mse_Show;

VESA_SetWriteMode(NormalPut);
End;

{ͻ
                           PROCEDURE Bar_Progress                           
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Coordinates to display.                  
           Col (LONGINT) = Color to fill the bar.                           
           Percent (INTEGER) = Percentage done.                             
           Id (WORD) = Bits to define the Bar_Progress.                     
               Bit 0  $0001 = Force to draw the box.                        
               Bit 1  $0002 = Never draw the box.                           
  OUT....: /                                                                
  EXPLAIN: Draw a Progress bar using the percent done.                      
  EXAMPLE: Bar_Progress(50,100,190,120,50,$0000);                           
 ͼ}

Procedure Bar_Progress(X1,Y1,X2,Y2:Integer;Col:LongInt;Percent:Integer; Id:Word);
Const QttBlocks=26;                     {*Nombre minimum de Blocks*}

Var   NbBlocks,A:Integer;
      SizeB,Xa,Xb:Real;

Begin
Screen_BlankerInit;                     {*Reinitialise the Screen Blanker*}

If Not BTST(Id,1) Then                  {*Never Draw the box*}
   If (Percent=0) Or BTST(Id,0) Then
      Begin                             {*Trace le cadre externe*}
      VESA_SetColor(CLLineDown);
      Bevel (X1,Y1,X2,Y2, CLLightGrey,BLLoweredLine,BLNoLine,Yes);
      End;
Inc(X1,2); Dec(X2,2); Inc(Y1,2); Dec(Y2,2);
SizeB:=(X2-X1)/Real(QttBlocks);         {*Rajuste les coordonnes*}
NbBlocks:=Trunc(Percent/(100/QttBlocks));
Xa:=X1;
{gotoxy(1,1);writeln(NbBlocks,' ');}

For A:=1 to NbBlocks do                 {*Trace la barre...*}
   Begin
   Xb:=Xa+SizeB-3;
   If Xa>X2 Then Xa:=X2;
   If Xb>X2 Then Xb:=X2;
   Bevel (Trunc(Xa),Y1,Trunc(Xb),Y2, Col);
   Xa:=Xa+SizeB;
   End;
End;

{ͻ
                            PROCEDURE Tool_Line                             
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Line coordinates.                        
           Style (INTEGER) = Style of the line.                             
           Relief (INTEGER) = Relief: 0=Relief, 1=Shadow.                   
  OUT....: /                                                                
  EXPLAIN: Draw a line in relief.                                           
  EXAMPLE: Tool_VESA_Line(0,0,130,110,1,1);                                 
 ͼ}

Procedure Tool_Line(X1,Y1,X2,Y2,Style,Relief:Integer);
Var C1,C2:Integer;
Begin
VESA_SetLineStyle(Style,0,NormWidth);

If Relief=0 Then Begin C1:=CLLineUp; C2:=CLLineDown; End Else Begin C1:=CLLineDown; C2:=CLLineUp; End;
Mse_Hide;
VESA_SetColor(C1); VESA_Line(X1,Y1,X2,Y2);
VESA_SetColor(C2); VESA_Line(X1+1,Y1+1,X2+1,Y2+1);
Mse_Show;
VESA_SetLineStyle(0,0,NormWidth);
End;

{ͻ
                            PROCEDURE Grid_Draw                             
 ͹
  IN.....: X (TCoordinates) = Pointer to the structure coordinates.         
           StepX, StepY (INTEGER) = Step X and Y for the grid.              
           Color (LONGINT) = Plot color to draw grid.                       
  OUT....: /                                                                
  EXPLAIN: Draw a grid in box using plots.                                  
 ͼ}

Procedure Grid_Draw(C:TCoordinates; StepX,StepY:Integer;Color:LongInt);
Var X,Y:Integer;
Begin
Mse_Hide;
X:=C.X1;
While X<=C.X2 do
   Begin
   Y:=C.Y1;
   While Y<=C.Y2 do
      Begin
      VESA_PutPixel(X,Y,Color);         {*Plot point*}
      Inc(Y,StepY);
      End;
   Inc(X,StepX);
   End;
Mse_Show;
End;

{*--------------------------- Programme Principal ------------------------------*}

BEGIN
END.
