{ͻ
                               UNIT MosWinAPI                               
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 28.12.2001                                                   
  COUNTRY....: Montpellier - (FRANCE)                                       
  DESCRIPTION: Provide interface with the Windows API functions.            
  AUTONOMOUS.: Yes                                                          
  UNIT SIZE..: 60 Lines and (640 Bytes compiled)                            
  LAST UPDATE: 28.12.2001 at 20:51                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosWinAPI;

Interface

Const
   DLL_Kernel32  = 'kernel32.dll';
   DLL_Advapi32  = 'advapi32.dll';
   DLL_Mpr       = 'mpr.dll';
   DLL_Version   = 'version.dll';
   DLL_Comctl32  = 'comctl32.dll';
   DLL_Gdi32     = 'gdi32.dll';
   DLL_Opengl32  = 'opengl32.dll';
   DLL_User32    = 'user32.dll';
   DLL_Wintrust  = 'wintrust.dll';
   DLL_Msimg32   = 'msimg32.dll';

Type

  LPCSTR = PAnsiChar;
  UINT   = LongWord;
  BOOL   = LongBool;

  _SYSTEM_INFO = Record
    Case Integer of
      0: (
        dwOemId: DWORD);
      1: (
        wProcessorArchitecture:Word;
        wReserved:Word;
        dwPageSize:DWORD;
        lpMinimumApplicationAddress:Pointer;
        lpMaximumApplicationAddress:Pointer;
        dwActiveProcessorMask:DWORD;
        dwNumberOfProcessors:DWORD;
        dwProcessorType:DWORD;
        dwAllocationGranularity:DWORD;
        wProcessorLevel:Word;
        wProcessorRevision:Word);
  end;

  TSystemInfo = _SYSTEM_INFO;

{****************************************************************************}

Function  GetComputerName(lpBuffer:PChar; Var nSize:DWORD):BOOL; Stdcall; External DLL_Kernel32 Name 'GetComputerNameA';
Function  GetLogicalDrives:Dword; StdCall; External DLL_Kernel32 Name 'GetLogicalDrives';
Function  GetTickCount:Dword; StdCall; External DLL_Kernel32 Name 'GetTickCount';
Procedure GetSystemInfo(Var lpSystemInfo:TSystemInfo); Stdcall; External DLL_Kernel32 Name 'GetSystemInfo';
Function  GetVersion:Dword; StdCall; External DLL_Kernel32 Name 'GetVersion';
Procedure Sleep(dwMilliseconds:Dword); Stdcall; External DLL_Kernel32 Name 'Sleep';
Function  WinExec(lpCmdLine:LPCSTR; uCmdShow:Uint):Uint; Stdcall; External DLL_Kernel32 Name 'WinExec';

Function  SwapMouseButton(fSwap:BOOL):BOOL; Stdcall; External DLL_User32 Name 'SwapMouseButton';

Implementation

Begin
End.

{ Externals from advapi32.dll }

Function AbortSystemShutdownA; External DLL_Advapi32 Name 'AbortSystemShutdownA';
Function AbortSystemShutdownW; External DLL_Advapi32 Name 'AbortSystemShutdownW';
Function AbortSystemShutdown; External DLL_Advapi32 Name 'AbortSystemShutdownA';
Function AccessCheck; External DLL_Advapi32 Name 'AccessCheck';
Function AccessCheckAndAuditAlarmA; External DLL_Advapi32 Name 'AccessCheckAndAuditAlarmA';
Function AccessCheckAndAuditAlarmW; External DLL_Advapi32 Name 'AccessCheckAndAuditAlarmW';
Function AccessCheckAndAuditAlarm; External DLL_Advapi32 Name 'AccessCheckAndAuditAlarmA';
Function AccessCheckByType; External DLL_Advapi32 Name 'AccessCheckByType';
Function AccessCheckByTypeAndAuditAlarmA; External DLL_Advapi32 Name 'AccessCheckByTypeAndAuditAlarmA';
Function AccessCheckByTypeAndAuditAlarmW; External DLL_Advapi32 Name 'AccessCheckByTypeAndAuditAlarmW';
Function AccessCheckByTypeAndAuditAlarm; External DLL_Advapi32 Name 'AccessCheckByTypeAndAuditAlarmA';
Function AccessCheckByTypeResultList; External DLL_Advapi32 Name 'AccessCheckByTypeResultList';
Function AccessCheckByTypeResultListAndAuditAlarmA; External DLL_Advapi32 Name 'AccessCheckByTypeResultListAndAuditAlarmA';
Function AccessCheckByTypeResultListAndAuditAlarmW; External DLL_Advapi32 Name 'AccessCheckByTypeResultListAndAuditAlarmW';
Function AccessCheckByTypeResultListAndAuditAlarm; External DLL_Advapi32 Name 'AccessCheckByTypeResultListAndAuditAlarmA';
Function AddAccessAllowedAce; External DLL_Advapi32 Name 'AddAccessAllowedAce';
Function AddAccessAllowedAceEx; External DLL_Advapi32 Name 'AddAccessAllowedAceEx';
Function AddAccessAllowedObjectAce; External DLL_Advapi32 Name 'AddAccessAllowedObjectAce';
Function AddAccessDeniedAce; External DLL_Advapi32 Name 'AddAccessDeniedAce';
Function AddAccessDeniedObjectAce; External DLL_Advapi32 Name 'AddAccessDeniedObjectAce';
Function AddAccessDeniedAceEx; External DLL_Advapi32 Name 'AddAccessDeniedAceEx';
Function AddAce; External DLL_Advapi32 Name 'AddAce';
Function AddAuditAccessAce; External DLL_Advapi32 Name 'AddAuditAccessAce';
Function AddAuditAccessAceEx; External DLL_Advapi32 Name 'AddAuditAccessAceEx';
Function AddAuditAccessObjectAce; External DLL_Advapi32 Name 'AddAuditAccessObjectAce';
Function AdjustTokenGroups; External DLL_Advapi32 Name 'AdjustTokenGroups';
Function AdjustTokenPrivileges(TokenHandle: THandle; DisableAllPrivileges:BOOL;
  const NewState: TTokenPrivileges; BufferLength: DWORD;
  var PreviousState: TTokenPrivileges; var ReturnLength: DWORD): BOOL; External DLL_Advapi32 Name 'AdjustTokenPrivileges';
Function AdjustTokenPrivileges(TokenHandle: THandle; DisableAllPrivileges:BOOL;
  const NewState: TTokenPrivileges; BufferLength: DWORD;
  PreviousState: PTokenPrivileges; var ReturnLength: DWORD): BOOL; External DLL_Advapi32 Name 'AdjustTokenPrivileges';
Function AllocateAndInitializeSid; External DLL_Advapi32 Name 'AllocateAndInitializeSid';
Function AllocateLocallyUniqueId; External DLL_Advapi32 Name 'AllocateLocallyUniqueId';
Function AreAllAccessesGranted; External DLL_Advapi32 Name 'AreAllAccessesGranted';
Function AreAnyAccessesGranted; External DLL_Advapi32 Name 'AreAnyAccessesGranted';
Function BackupEventLogA; External DLL_Advapi32 Name 'BackupEventLogA';
Function BackupEventLogW; External DLL_Advapi32 Name 'BackupEventLogW';
Function BackupEventLog; External DLL_Advapi32 Name 'BackupEventLogA';
Function ClearEventLogA; External DLL_Advapi32 Name 'ClearEventLogA';
Function ClearEventLogW; External DLL_Advapi32 Name 'ClearEventLogW';
Function ClearEventLog; External DLL_Advapi32 Name 'ClearEventLogA';
Function CloseEventLog; External DLL_Advapi32 Name 'CloseEventLog';
Function ConvertToAutoInheritPrivateObjectSecurity; External DLL_Advapi32 Name 'ConvertToAutoInheritPrivateObjectSecurity';
Function CopySid; External DLL_Advapi32 Name 'CopySid';
Function CreatePrivateObjectSecurity; External DLL_Advapi32 Name 'CreatePrivateObjectSecurity';
Function CreatePrivateObjectSecurityEx; External DLL_Advapi32 Name 'CreatePrivateObjectSecurityEx';
Function CreateProcessAsUserA; External DLL_Advapi32 Name 'CreateProcessAsUserA';
Function CreateProcessAsUserW; External DLL_Advapi32 Name 'CreateProcessAsUserW';
Function CreateProcessAsUser; External DLL_Advapi32 Name 'CreateProcessAsUserA';
Function DeleteAce; External DLL_Advapi32 Name 'DeleteAce';
Function DeregisterEventSource; External DLL_Advapi32 Name 'DeregisterEventSource';
Function DestroyPrivateObjectSecurity; External DLL_Advapi32 Name 'DestroyPrivateObjectSecurity';
Function DuplicateToken; External DLL_Advapi32 Name 'DuplicateToken';
Function DuplicateTokenEx; External DLL_Advapi32 Name 'DuplicateTokenEx';
Function EqualPrefixSid; External DLL_Advapi32 Name 'EqualPrefixSid';
Function EqualSid; External DLL_Advapi32 Name 'EqualSid';
Function FindFirstFreeAce; External DLL_Advapi32 Name 'FindFirstFreeAce';
Function FreeSid; External DLL_Advapi32 Name 'FreeSid';
Function GetAce; External DLL_Advapi32 Name 'GetAce';
Function GetAclInformation; External DLL_Advapi32 Name 'GetAclInformation';
Function GetCurrentHwProfileA; External DLL_Advapi32 Name 'GetCurrentHwProfileA';
Function GetCurrentHwProfileW; External DLL_Advapi32 Name 'GetCurrentHwProfileW';
Function GetCurrentHwProfile; External DLL_Advapi32 Name 'GetCurrentHwProfileA';
Function GetFileSecurityA; External DLL_Advapi32 Name 'GetFileSecurityA';
Function GetFileSecurityW; External DLL_Advapi32 Name 'GetFileSecurityW';
Function GetFileSecurity; External DLL_Advapi32 Name 'GetFileSecurityA';
Function GetKernelObjectSecurity; External DLL_Advapi32 Name 'GetKernelObjectSecurity';
Function GetLengthSid; External DLL_Advapi32 Name 'GetLengthSid';
Function GetNumberOfEventLogRecords; External DLL_Advapi32 Name 'GetNumberOfEventLogRecords';
Function GetOldestEventLogRecord; External DLL_Advapi32 Name 'GetOldestEventLogRecord';
Function GetPrivateObjectSecurity; External DLL_Advapi32 Name 'GetPrivateObjectSecurity';
Function GetSecurityDescriptorControl; External DLL_Advapi32 Name 'GetSecurityDescriptorControl';
Function GetSecurityDescriptorDacl; External DLL_Advapi32 Name 'GetSecurityDescriptorDacl';
Function GetSecurityDescriptorGroup; External DLL_Advapi32 Name 'GetSecurityDescriptorGroup';
Function GetSecurityDescriptorLength; External DLL_Advapi32 Name 'GetSecurityDescriptorLength';
Function GetSecurityDescriptorOwner; External DLL_Advapi32 Name 'GetSecurityDescriptorOwner';
Function GetSecurityDescriptorSacl; External DLL_Advapi32 Name 'GetSecurityDescriptorSacl';
Function GetSidIdentifierAuthority; External DLL_Advapi32 Name 'GetSidIdentifierAuthority';
Function GetSidLengthRequired; External DLL_Advapi32 Name 'GetSidLengthRequired';
Function GetSidSubAuthority; External DLL_Advapi32 Name 'GetSidSubAuthority';
Function GetSidSubAuthorityCount; External DLL_Advapi32 Name 'GetSidSubAuthorityCount';
Function GetTokenInformation; External DLL_Advapi32 Name 'GetTokenInformation';
Function GetUserNameA; External DLL_Advapi32 Name 'GetUserNameA';
Function GetUserNameW; External DLL_Advapi32 Name 'GetUserNameW';
Function GetUserName; External DLL_Advapi32 Name 'GetUserNameA';
Function ImpersonateLoggedOnUser; External DLL_Advapi32 Name 'ImpersonateLoggedOnUser';
Function ImpersonateNamedPipeClient; External DLL_Advapi32 Name 'ImpersonateNamedPipeClient';
Function ImpersonateSelf; External DLL_Advapi32 Name 'ImpersonateSelf';
Function InitializeAcl; External DLL_Advapi32 Name 'InitializeAcl';
Function InitializeSecurityDescriptor; External DLL_Advapi32 Name 'InitializeSecurityDescriptor';
Function InitializeSid; External DLL_Advapi32 Name 'InitializeSid';
Function InitiateSystemShutdownA; External DLL_Advapi32 Name 'InitiateSystemShutdownA';
Function InitiateSystemShutdownW; External DLL_Advapi32 Name 'InitiateSystemShutdownW';
Function InitiateSystemShutdown; External DLL_Advapi32 Name 'InitiateSystemShutdownA';
Function IsTextUnicode; External DLL_Advapi32 Name 'IsTextUnicode';
Function IsValidAcl; External DLL_Advapi32 Name 'IsValidAcl';
Function IsValidSecurityDescriptor; External DLL_Advapi32 Name 'IsValidSecurityDescriptor';
Function IsValidSid; External DLL_Advapi32 Name 'IsValidSid';
Function LogonUserA; External DLL_Advapi32 Name 'LogonUserA';
Function LogonUserW; External DLL_Advapi32 Name 'LogonUserW';
Function LogonUser; External DLL_Advapi32 Name 'LogonUserA';
Function LookupAccountNameA; External DLL_Advapi32 Name 'LookupAccountNameA';
Function LookupAccountNameW; External DLL_Advapi32 Name 'LookupAccountNameW';
Function LookupAccountName; External DLL_Advapi32 Name 'LookupAccountNameA';
Function LookupAccountSidA; External DLL_Advapi32 Name 'LookupAccountSidA';
Function LookupAccountSidW; External DLL_Advapi32 Name 'LookupAccountSidW';
Function LookupAccountSid; External DLL_Advapi32 Name 'LookupAccountSidA';
Function LookupPrivilegeDisplayNameA; External DLL_Advapi32 Name 'LookupPrivilegeDisplayNameA';
Function LookupPrivilegeDisplayNameW; External DLL_Advapi32 Name 'LookupPrivilegeDisplayNameW';
Function LookupPrivilegeDisplayName; External DLL_Advapi32 Name 'LookupPrivilegeDisplayNameA';
Function LookupPrivilegeNameA; External DLL_Advapi32 Name 'LookupPrivilegeNameA';
Function LookupPrivilegeNameW; External DLL_Advapi32 Name 'LookupPrivilegeNameW';
Function LookupPrivilegeName; External DLL_Advapi32 Name 'LookupPrivilegeNameA';
Function LookupPrivilegeValueA; External DLL_Advapi32 Name 'LookupPrivilegeValueA';
Function LookupPrivilegeValueW; External DLL_Advapi32 Name 'LookupPrivilegeValueW';
Function LookupPrivilegeValue; External DLL_Advapi32 Name 'LookupPrivilegeValueA';
Function MakeAbsoluteSD; External DLL_Advapi32 Name 'MakeAbsoluteSD';
Function MakeSelfRelativeSD; External DLL_Advapi32 Name 'MakeSelfRelativeSD';
Procedure MapGenericMask; External DLL_Advapi32 Name 'MapGenericMask';
Function NotifyChangeEventLog; External DLL_Advapi32 Name 'NotifyChangeEventLog';
Function ObjectCloseAuditAlarmA; External DLL_Advapi32 Name 'ObjectCloseAuditAlarmA';
Function ObjectCloseAuditAlarmW; External DLL_Advapi32 Name 'ObjectCloseAuditAlarmW';
Function ObjectCloseAuditAlarm; External DLL_Advapi32 Name 'ObjectCloseAuditAlarmA';
Function ObjectDeleteAuditAlarmA; External DLL_Advapi32 Name 'ObjectDeleteAuditAlarmA';
Function ObjectDeleteAuditAlarmW; External DLL_Advapi32 Name 'ObjectDeleteAuditAlarmW';
Function ObjectDeleteAuditAlarm; External DLL_Advapi32 Name 'ObjectDeleteAuditAlarmA';
Function ObjectOpenAuditAlarmA; External DLL_Advapi32 Name 'ObjectOpenAuditAlarmA';
Function ObjectOpenAuditAlarmW; External DLL_Advapi32 Name 'ObjectOpenAuditAlarmW';
Function ObjectOpenAuditAlarm; External DLL_Advapi32 Name 'ObjectOpenAuditAlarmA';
Function ObjectPrivilegeAuditAlarmA; External DLL_Advapi32 Name 'ObjectPrivilegeAuditAlarmA';
Function ObjectPrivilegeAuditAlarmW; External DLL_Advapi32 Name 'ObjectPrivilegeAuditAlarmW';
Function ObjectPrivilegeAuditAlarm; External DLL_Advapi32 Name 'ObjectPrivilegeAuditAlarmA';
Function OpenBackupEventLogA; External DLL_Advapi32 Name 'OpenBackupEventLogA';
Function OpenBackupEventLogW; External DLL_Advapi32 Name 'OpenBackupEventLogW';
Function OpenBackupEventLog; External DLL_Advapi32 Name 'OpenBackupEventLogA';
Function OpenEventLogA; External DLL_Advapi32 Name 'OpenEventLogA';
Function OpenEventLogW; External DLL_Advapi32 Name 'OpenEventLogW';
Function OpenEventLog; External DLL_Advapi32 Name 'OpenEventLogA';
Function OpenProcessToken; External DLL_Advapi32 Name 'OpenProcessToken';
Function OpenThreadToken; External DLL_Advapi32 Name 'OpenThreadToken';
Function PrivilegeCheck; External DLL_Advapi32 Name 'PrivilegeCheck';
Function PrivilegedServiceAuditAlarmA; External DLL_Advapi32 Name 'PrivilegedServiceAuditAlarmA';
Function PrivilegedServiceAuditAlarmW; External DLL_Advapi32 Name 'PrivilegedServiceAuditAlarmW';
Function PrivilegedServiceAuditAlarm; External DLL_Advapi32 Name 'PrivilegedServiceAuditAlarmA';
Function ReadEventLogA; External DLL_Advapi32 Name 'ReadEventLogA';
Function ReadEventLogW; External DLL_Advapi32 Name 'ReadEventLogW';
Function ReadEventLog; External DLL_Advapi32 Name 'ReadEventLogA';
Function RegCloseKey; External DLL_Advapi32 Name 'RegCloseKey';
Function RegConnectRegistryA; External DLL_Advapi32 Name 'RegConnectRegistryA';
Function RegConnectRegistryW; External DLL_Advapi32 Name 'RegConnectRegistryW';
Function RegConnectRegistry; External DLL_Advapi32 Name 'RegConnectRegistryA';
Function RegCreateKeyA; External DLL_Advapi32 Name 'RegCreateKeyA';
Function RegCreateKeyW; External DLL_Advapi32 Name 'RegCreateKeyW';
Function RegCreateKey; External DLL_Advapi32 Name 'RegCreateKeyA';
Function RegCreateKeyExA; External DLL_Advapi32 Name 'RegCreateKeyExA';
Function RegCreateKeyExW; External DLL_Advapi32 Name 'RegCreateKeyExW';
Function RegCreateKeyEx; External DLL_Advapi32 Name 'RegCreateKeyExA';
Function RegDeleteKeyA; External DLL_Advapi32 Name 'RegDeleteKeyA';
Function RegDeleteKeyW; External DLL_Advapi32 Name 'RegDeleteKeyW';
Function RegDeleteKey; External DLL_Advapi32 Name 'RegDeleteKeyA';
Function RegDeleteValueA; External DLL_Advapi32 Name 'RegDeleteValueA';
Function RegDeleteValueW; External DLL_Advapi32 Name 'RegDeleteValueW';
Function RegDeleteValue; External DLL_Advapi32 Name 'RegDeleteValueA';
Function RegEnumKeyExA; External DLL_Advapi32 Name 'RegEnumKeyExA';
Function RegEnumKeyExW; External DLL_Advapi32 Name 'RegEnumKeyExW';
Function RegEnumKeyEx; External DLL_Advapi32 Name 'RegEnumKeyExA';
Function RegEnumKeyA; External DLL_Advapi32 Name 'RegEnumKeyA';
Function RegEnumKeyW; External DLL_Advapi32 Name 'RegEnumKeyW';
Function RegEnumKey; External DLL_Advapi32 Name 'RegEnumKeyA';
Function RegEnumValueA; External DLL_Advapi32 Name 'RegEnumValueA';
Function RegEnumValueW; External DLL_Advapi32 Name 'RegEnumValueW';
Function RegEnumValue; External DLL_Advapi32 Name 'RegEnumValueA';
Function RegFlushKey; External DLL_Advapi32 Name 'RegFlushKey';
Function RegGetKeySecurity; External DLL_Advapi32 Name 'RegGetKeySecurity';
Function RegLoadKeyA; External DLL_Advapi32 Name 'RegLoadKeyA';
Function RegLoadKeyW; External DLL_Advapi32 Name 'RegLoadKeyW';
Function RegLoadKey; External DLL_Advapi32 Name 'RegLoadKeyA';
Function RegNotifyChangeKeyValue; External DLL_Advapi32 Name 'RegNotifyChangeKeyValue';
Function RegOpenKeyA; External DLL_Advapi32 Name 'RegOpenKeyA';
Function RegOpenKeyW; External DLL_Advapi32 Name 'RegOpenKeyW';
Function RegOpenKey; External DLL_Advapi32 Name 'RegOpenKeyA';
Function RegOpenKeyExA; External DLL_Advapi32 Name 'RegOpenKeyExA';
Function RegOpenKeyExW; External DLL_Advapi32 Name 'RegOpenKeyExW';
Function RegOpenKeyEx; External DLL_Advapi32 Name 'RegOpenKeyExA';
Function RegQueryInfoKeyA; External DLL_Advapi32 Name 'RegQueryInfoKeyA';
Function RegQueryInfoKeyW; External DLL_Advapi32 Name 'RegQueryInfoKeyW';
Function RegQueryInfoKey; External DLL_Advapi32 Name 'RegQueryInfoKeyA';
Function RegQueryMultipleValuesA; External DLL_Advapi32 Name 'RegQueryMultipleValuesA';
Function RegQueryMultipleValuesW; External DLL_Advapi32 Name 'RegQueryMultipleValuesW';
Function RegQueryMultipleValues; External DLL_Advapi32 Name 'RegQueryMultipleValuesA';
Function RegQueryValueA; External DLL_Advapi32 Name 'RegQueryValueA';
Function RegQueryValueW; External DLL_Advapi32 Name 'RegQueryValueW';
Function RegQueryValue; External DLL_Advapi32 Name 'RegQueryValueA';
Function RegQueryValueExA; External DLL_Advapi32 Name 'RegQueryValueExA';
Function RegQueryValueExW; External DLL_Advapi32 Name 'RegQueryValueExW';
Function RegQueryValueEx; External DLL_Advapi32 Name 'RegQueryValueExA';
Function RegReplaceKeyA; External DLL_Advapi32 Name 'RegReplaceKeyA';
Function RegReplaceKeyW; External DLL_Advapi32 Name 'RegReplaceKeyW';
Function RegReplaceKey; External DLL_Advapi32 Name 'RegReplaceKeyA';
Function RegRestoreKeyA; External DLL_Advapi32 Name 'RegRestoreKeyA';
Function RegRestoreKeyW; External DLL_Advapi32 Name 'RegRestoreKeyW';
Function RegRestoreKey; External DLL_Advapi32 Name 'RegRestoreKeyA';
Function RegSaveKeyA; External DLL_Advapi32 Name 'RegSaveKeyA';
Function RegSaveKeyW; External DLL_Advapi32 Name 'RegSaveKeyW';
Function RegSaveKey; External DLL_Advapi32 Name 'RegSaveKeyA';
Function RegSetKeySecurity; External DLL_Advapi32 Name 'RegSetKeySecurity';
Function RegSetValueA; External DLL_Advapi32 Name 'RegSetValueA';
Function RegSetValueW; External DLL_Advapi32 Name 'RegSetValueW';
Function RegSetValue; External DLL_Advapi32 Name 'RegSetValueA';
Function RegSetValueExA; External DLL_Advapi32 Name 'RegSetValueExA';
Function RegSetValueExW; External DLL_Advapi32 Name 'RegSetValueExW';
Function RegSetValueEx; External DLL_Advapi32 Name 'RegSetValueExA';
Function RegUnLoadKeyA; External DLL_Advapi32 Name 'RegUnLoadKeyA';
Function RegUnLoadKeyW; External DLL_Advapi32 Name 'RegUnLoadKeyW';
Function RegUnLoadKey; External DLL_Advapi32 Name 'RegUnLoadKeyA';
Function RegisterEventSourceA; External DLL_Advapi32 Name 'RegisterEventSourceA';
Function RegisterEventSourceW; External DLL_Advapi32 Name 'RegisterEventSourceW';
Function RegisterEventSource; External DLL_Advapi32 Name 'RegisterEventSourceA';
Function ReportEventA; External DLL_Advapi32 Name 'ReportEventA';
Function ReportEventW; External DLL_Advapi32 Name 'ReportEventW';
Function ReportEvent; External DLL_Advapi32 Name 'ReportEventA';
Function RevertToSelf; External DLL_Advapi32 Name 'RevertToSelf';
Function SetAclInformation; External DLL_Advapi32 Name 'SetAclInformation';
Function SetFileSecurityA; External DLL_Advapi32 Name 'SetFileSecurityA';
Function SetFileSecurityW; External DLL_Advapi32 Name 'SetFileSecurityW';
Function SetFileSecurity; External DLL_Advapi32 Name 'SetFileSecurityA';
Function SetKernelObjectSecurity; External DLL_Advapi32 Name 'SetKernelObjectSecurity';
Function SetPrivateObjectSecurity; External DLL_Advapi32 Name 'SetPrivateObjectSecurity';
Function SetPrivateObjectSecurityEx; External DLL_Advapi32 Name 'SetPrivateObjectSecurityEx';
Function SetSecurityDescriptorControl; External DLL_Advapi32 Name 'SetSecurityDescriptorControl';
Function SetSecurityDescriptorDacl; External DLL_Advapi32 Name 'SetSecurityDescriptorDacl';
Function SetSecurityDescriptorGroup; External DLL_Advapi32 Name 'SetSecurityDescriptorGroup';
Function SetSecurityDescriptorOwner; External DLL_Advapi32 Name 'SetSecurityDescriptorOwner';
Function SetSecurityDescriptorSacl; External DLL_Advapi32 Name 'SetSecurityDescriptorSacl';
Function SetThreadToken; External DLL_Advapi32 Name 'SetThreadToken';
Function SetTokenInformation; External DLL_Advapi32 Name 'SetTokenInformation';

{ Externals from imaghlp.dll }

{ !!! these fuctions are not yet available in this dll
Function WinSubmitCertificate; External imaghlp Name 'WinSubmitCertificate';
Function WinVerifyTrust; External imaghlp Name 'WinVerifyTrust'; }

{ Externals from kernel32.dll }

Function AddAtomA; External DLL_Kernel32 Name 'AddAtomA';
Function AddAtomW; External DLL_Kernel32 Name 'AddAtomW';
Function AddAtom; External DLL_Kernel32 Name 'AddAtomA';
Function AllocConsole; External DLL_Kernel32 Name 'AllocConsole';
Function AreFileApisANSI; External DLL_Kernel32 Name 'AreFileApisANSI';
Function BackupRead; External DLL_Kernel32 Name 'BackupRead';
Function BackupSeek; External DLL_Kernel32 Name 'BackupSeek';
Function BackupWrite; External DLL_Kernel32 Name 'BackupWrite';
Function Beep; External DLL_Kernel32 Name 'Beep';
Function BeginUpdateResourceA; External DLL_Kernel32 Name 'BeginUpdateResourceA';
Function BeginUpdateResourceW; External DLL_Kernel32 Name 'BeginUpdateResourceW';
Function BeginUpdateResource; External DLL_Kernel32 Name 'BeginUpdateResourceA';
Function BuildCommDCBA; External DLL_Kernel32 Name 'BuildCommDCBA';
Function BuildCommDCBW; External DLL_Kernel32 Name 'BuildCommDCBW';
Function BuildCommDCB; External DLL_Kernel32 Name 'BuildCommDCBA';
Function BuildCommDCBAndTimeoutsA; External DLL_Kernel32 Name 'BuildCommDCBAndTimeoutsA';
Function BuildCommDCBAndTimeoutsW; External DLL_Kernel32 Name 'BuildCommDCBAndTimeoutsW';
Function BuildCommDCBAndTimeouts; External DLL_Kernel32 Name 'BuildCommDCBAndTimeoutsA';
Function CallNamedPipeA; External DLL_Kernel32 Name 'CallNamedPipeA';
Function CallNamedPipeW; External DLL_Kernel32 Name 'CallNamedPipeW';
Function CallNamedPipe; External DLL_Kernel32 Name 'CallNamedPipeA';
Function CancelIo; External DLL_Kernel32 Name 'CancelIo';
Function CancelWaitableTimer; External DLL_Kernel32 Name 'CancelWaitableTimer';
Function ClearCommBreak; External DLL_Kernel32 Name 'ClearCommBreak';
Function ClearCommError; External DLL_Kernel32 Name 'ClearCommError';
Function CloseHandle; External DLL_Kernel32 Name 'CloseHandle';
Procedure CloseRaw; External DLL_Kernel32 Name 'CloseRaw';
Function CommConfigDialogA; External DLL_Kernel32 Name 'CommConfigDialogA';
Function CommConfigDialogW; External DLL_Kernel32 Name 'CommConfigDialogW';
Function CommConfigDialog; External DLL_Kernel32 Name 'CommConfigDialogA';
Function CompareFileTime; External DLL_Kernel32 Name 'CompareFileTime';
Function CompareStringA; External DLL_Kernel32 Name 'CompareStringA';
Function CompareStringW; External DLL_Kernel32 Name 'CompareStringW';
Function CompareString; External DLL_Kernel32 Name 'CompareStringA';
Function ConnectNamedPipe; External DLL_Kernel32 Name 'ConnectNamedPipe';
Function ContinueDebugEvent; External DLL_Kernel32 Name 'ContinueDebugEvent';
Function ConvertThreadToFiber; External DLL_Kernel32 Name 'ConvertThreadToFiber';
Function ConvertDefaultLocale; External DLL_Kernel32 Name 'ConvertDefaultLocale';
Function CopyFileA; External DLL_Kernel32 Name 'CopyFileA';
Function CopyFileExA; External DLL_Kernel32 Name 'CopyFileExA';
Function CopyFileW; External DLL_Kernel32 Name 'CopyFileW';
Function CopyFileExW; External DLL_Kernel32 Name 'CopyFileExW';
Function CopyFile; External DLL_Kernel32 Name 'CopyFileA';
Function CopyFileEx; External DLL_Kernel32 Name 'CopyFileExA';
Function CreateConsoleScreenBuffer; External DLL_Kernel32 Name 'CreateConsoleScreenBuffer';
Function CreateDirectoryA; External DLL_Kernel32 Name 'CreateDirectoryA';
Function CreateDirectoryW; External DLL_Kernel32 Name 'CreateDirectoryW';
Function CreateDirectory; External DLL_Kernel32 Name 'CreateDirectoryA';
Function CreateDirectoryExA; External DLL_Kernel32 Name 'CreateDirectoryExA';
Function CreateDirectoryExW; External DLL_Kernel32 Name 'CreateDirectoryExW';
Function CreateDirectoryEx; External DLL_Kernel32 Name 'CreateDirectoryExA';
Function CreateEventA; External DLL_Kernel32 Name 'CreateEventA';
Function CreateEventW; External DLL_Kernel32 Name 'CreateEventW';
Function CreateEvent; External DLL_Kernel32 Name 'CreateEventA';
Function CreateFiber; External DLL_Kernel32 Name 'CreateFiber';
Function CreateFileA; External DLL_Kernel32 Name 'CreateFileA';
Function CreateFileW; External DLL_Kernel32 Name 'CreateFileW';
Function CreateFile; External DLL_Kernel32 Name 'CreateFileA';
Function CreateFileMappingA; External DLL_Kernel32 Name 'CreateFileMappingA';
Function CreateFileMappingW; External DLL_Kernel32 Name 'CreateFileMappingW';
Function CreateFileMapping; External DLL_Kernel32 Name 'CreateFileMappingA';
Function CreateHardLinkA; External DLL_Kernel32 Name 'CreateHardLinkA';
Function CreateHardLinkW; External DLL_Kernel32 Name 'CreateHardLinkW';
Function CreateHardLink; External DLL_Kernel32 Name 'CreateHardLinkA';
Function CreateIoCompletionPort; External DLL_Kernel32 Name 'CreateIoCompletionPort';
Function CreateMailslotA; External DLL_Kernel32 Name 'CreateMailslotA';
Function CreateMailslotW; External DLL_Kernel32 Name 'CreateMailslotW';
Function CreateMailslot; External DLL_Kernel32 Name 'CreateMailslotA';
Function CreateMutexA; External DLL_Kernel32 Name 'CreateMutexA';
Function CreateMutexW; External DLL_Kernel32 Name 'CreateMutexW';
Function CreateMutex; External DLL_Kernel32 Name 'CreateMutexA';
Function CreateNamedPipeA; External DLL_Kernel32 Name 'CreateNamedPipeA';
Function CreateNamedPipeW; External DLL_Kernel32 Name 'CreateNamedPipeW';
Function CreateNamedPipe; External DLL_Kernel32 Name 'CreateNamedPipeA';
Function CreatePipe; External DLL_Kernel32 Name 'CreatePipe';
Function CreateProcessA; External DLL_Kernel32 Name 'CreateProcessA';
Function CreateProcessW; External DLL_Kernel32 Name 'CreateProcessW';
Function CreateProcess; External DLL_Kernel32 Name 'CreateProcessA';
Function CreateRemoteThread; External DLL_Kernel32 Name 'CreateRemoteThread';
Function CreateSemaphoreA; External DLL_Kernel32 Name 'CreateSemaphoreA';
Function CreateSemaphoreW; External DLL_Kernel32 Name 'CreateSemaphoreW';
Function CreateSemaphore; External DLL_Kernel32 Name 'CreateSemaphoreA';
Function CreateTapePartition; External DLL_Kernel32 Name 'CreateTapePartition';
Function CreateThread; External DLL_Kernel32 Name 'CreateThread';
Function CreateWaitableTimerA; External DLL_Kernel32 Name 'CreateWaitableTimerA';
Function CreateWaitableTimerW; External DLL_Kernel32 Name 'CreateWaitableTimerW';
Function CreateWaitableTimer; External DLL_Kernel32 Name 'CreateWaitableTimerA';
Function DecryptFileA; External DLL_Kernel32 Name 'DecryptFileA';
Function DecryptFileW; External DLL_Kernel32 Name 'DecryptFileW';
Function DecryptFile; External DLL_Kernel32 Name 'DecryptFile';
Function DebugActiveProcess; External DLL_Kernel32 Name 'DebugActiveProcess';
Procedure DebugBreak; External DLL_Kernel32 Name 'DebugBreak';
Function DefineDosDeviceA; External DLL_Kernel32 Name 'DefineDosDeviceA';
Function DefineDosDeviceW; External DLL_Kernel32 Name 'DefineDosDeviceW';
Function DefineDosDevice; External DLL_Kernel32 Name 'DefineDosDeviceA';
Function DeleteAtom; External DLL_Kernel32 Name 'DeleteAtom';
Procedure DeleteCriticalSection; External DLL_Kernel32 Name 'DeleteCriticalSection';
Function DeleteFiber; External DLL_Kernel32 Name 'DeleteFiber';
Function DeleteFileA; External DLL_Kernel32 Name 'DeleteFileA';
Function DeleteFileW; External DLL_Kernel32 Name 'DeleteFileW';
Function DeleteFile; External DLL_Kernel32 Name 'DeleteFileA';
Function DeviceIoControl; External DLL_Kernel32 Name 'DeviceIoControl';
Function DisableThreadLibraryCalls; External DLL_Kernel32 Name 'DisableThreadLibraryCalls';
Function DisconnectNamedPipe; External DLL_Kernel32 Name 'DisconnectNamedPipe';
Function DosDateTimeToFileTime; External DLL_Kernel32 Name 'DosDateTimeToFileTime';
Function DuplicateHandle; External DLL_Kernel32 Name 'DuplicateHandle';
//Function EncryptFileA; External DLL_Kernel32 Name 'EncryptFileA';
//Function EncryptFileW; External DLL_Kernel32 Name 'EncryptFileW';
//Function  EncryptFile(lpFilename:PChar):BOOL; Stdcall; External DLL_Kernel32 Name 'EncryptFile';
Function EndUpdateResourceA; External DLL_Kernel32 Name 'EndUpdateResourceA';
Function EndUpdateResourceW; External DLL_Kernel32 Name 'EndUpdateResourceW';
Function EndUpdateResource; External DLL_Kernel32 Name 'EndUpdateResourceA';
Procedure EnterCriticalSection; External DLL_Kernel32 Name 'EnterCriticalSection';
Function EnumCalendarInfoA; External DLL_Kernel32 Name 'EnumCalendarInfoA';
Function EnumCalendarInfoW; External DLL_Kernel32 Name 'EnumCalendarInfoW';
Function EnumCalendarInfo; External DLL_Kernel32 Name 'EnumCalendarInfoA';
Function EnumDateFormatsA; External DLL_Kernel32 Name 'EnumDateFormatsA';
Function EnumDateFormatsW; External DLL_Kernel32 Name 'EnumDateFormatsW';
Function EnumDateFormats; External DLL_Kernel32 Name 'EnumDateFormatsA';
Function EnumResourceLanguagesA; External DLL_Kernel32 Name 'EnumResourceLanguagesA';
Function EnumResourceLanguagesW; External DLL_Kernel32 Name 'EnumResourceLanguagesW';
Function EnumResourceLanguages; External DLL_Kernel32 Name 'EnumResourceLanguagesA';
Function EnumResourceNamesA; External DLL_Kernel32 Name 'EnumResourceNamesA';
Function EnumResourceNamesW; External DLL_Kernel32 Name 'EnumResourceNamesW';
Function EnumResourceNames; External DLL_Kernel32 Name 'EnumResourceNamesA';
Function EnumResourceTypesA; External DLL_Kernel32 Name 'EnumResourceTypesA';
Function EnumResourceTypesW; External DLL_Kernel32 Name 'EnumResourceTypesW';
Function EnumResourceTypes; External DLL_Kernel32 Name 'EnumResourceTypesA';
Function EnumSystemCodePagesA; External DLL_Kernel32 Name 'EnumSystemCodePagesA';
Function EnumSystemCodePagesW; External DLL_Kernel32 Name 'EnumSystemCodePagesW';
Function EnumSystemCodePages; External DLL_Kernel32 Name 'EnumSystemCodePagesA';
Function EnumSystemLocalesA; External DLL_Kernel32 Name 'EnumSystemLocalesA';
Function EnumSystemLocalesW; External DLL_Kernel32 Name 'EnumSystemLocalesW';
Function EnumSystemLocales; External DLL_Kernel32 Name 'EnumSystemLocalesA';
Function EnumTimeFormatsA; External DLL_Kernel32 Name 'EnumTimeFormatsA';
Function EnumTimeFormatsW; External DLL_Kernel32 Name 'EnumTimeFormatsW';
Function EnumTimeFormats; External DLL_Kernel32 Name 'EnumTimeFormatsA';
Function EraseTape; External DLL_Kernel32 Name 'EraseTape';
Function EscapeCommFunction; External DLL_Kernel32 Name 'EscapeCommFunction';
Procedure ExitProcess; External DLL_Kernel32 Name 'ExitProcess';
Procedure ExitThread; External DLL_Kernel32 Name 'ExitThread';
Function ExpandEnvironmentStringsA; External DLL_Kernel32 Name 'ExpandEnvironmentStringsA';
Function ExpandEnvironmentStringsW; External DLL_Kernel32 Name 'ExpandEnvironmentStringsW';
Function ExpandEnvironmentStrings; External DLL_Kernel32 Name 'ExpandEnvironmentStringsA';
Procedure FatalAppExitA; External DLL_Kernel32 Name 'FatalAppExitA';
Procedure FatalAppExitW; External DLL_Kernel32 Name 'FatalAppExitW';
Procedure FatalAppExit; External DLL_Kernel32 Name 'FatalAppExitA';
Procedure FatalExit; External DLL_Kernel32 Name 'FatalExit';
Function FileTimeToDosDateTime; External DLL_Kernel32 Name 'FileTimeToDosDateTime';
Function FileTimeToLocalFileTime; External DLL_Kernel32 Name 'FileTimeToLocalFileTime';
Function FileTimeToSystemTime; External DLL_Kernel32 Name 'FileTimeToSystemTime';
Function FillConsoleOutputAttribute; External DLL_Kernel32 Name 'FillConsoleOutputAttribute';
Function FillConsoleOutputCharacterA; External DLL_Kernel32 Name 'FillConsoleOutputCharacterA';
Function FillConsoleOutputCharacterW; External DLL_Kernel32 Name 'FillConsoleOutputCharacterW';
Function FillConsoleOutputCharacter; External DLL_Kernel32 Name 'FillConsoleOutputCharacterA';
Function FindAtomA; External DLL_Kernel32 Name 'FindAtomA';
Function FindAtomW; External DLL_Kernel32 Name 'FindAtomW';
Function FindAtom; External DLL_Kernel32 Name 'FindAtomA';
Function FindClose; External DLL_Kernel32 Name 'FindClose';
Function FindCloseChangeNotification; External DLL_Kernel32 Name 'FindCloseChangeNotification';
Function FindFirstChangeNotificationA; External DLL_Kernel32 Name 'FindFirstChangeNotificationA';
Function FindFirstChangeNotificationW; External DLL_Kernel32 Name 'FindFirstChangeNotificationW';
Function FindFirstChangeNotification; External DLL_Kernel32 Name 'FindFirstChangeNotificationA';
Function FindFirstFileA; External DLL_Kernel32 Name 'FindFirstFileA';
Function FindFirstFileExA; External DLL_Kernel32 Name 'FindFirstFileExA';
Function FindFirstFileW; External DLL_Kernel32 Name 'FindFirstFileW';
Function FindFirstFileExW; External DLL_Kernel32 Name 'FindFirstFileExW';
Function FindFirstFile; External DLL_Kernel32 Name 'FindFirstFileA';
Function FindFirstFileEx; External DLL_Kernel32 Name 'FindFirstFileExA';
Function FindNextChangeNotification; External DLL_Kernel32 Name 'FindNextChangeNotification';
Function FindNextFileA; External DLL_Kernel32 Name 'FindNextFileA';
Function FindNextFileW; External DLL_Kernel32 Name 'FindNextFileW';
Function FindNextFile; External DLL_Kernel32 Name 'FindNextFileA';
Function FindResourceA; External DLL_Kernel32 Name 'FindResourceA';
Function FindResourceW; External DLL_Kernel32 Name 'FindResourceW';
Function FindResource; External DLL_Kernel32 Name 'FindResourceA';
Function FindResourceExA; External DLL_Kernel32 Name 'FindResourceExA';
Function FindResourceExW; External DLL_Kernel32 Name 'FindResourceExW';
Function FindResourceEx; External DLL_Kernel32 Name 'FindResourceExA';
Function FlushConsoleInputBuffer; External DLL_Kernel32 Name 'FlushConsoleInputBuffer';
Function FlushFileBuffers; External DLL_Kernel32 Name 'FlushFileBuffers';
Function FlushInstructionCache; External DLL_Kernel32 Name 'FlushInstructionCache';
Function FlushViewOfFile; External DLL_Kernel32 Name 'FlushViewOfFile';
Function FoldStringA; External DLL_Kernel32 Name 'FoldStringA';
Function FoldStringW; External DLL_Kernel32 Name 'FoldStringW';
Function FoldString; External DLL_Kernel32 Name 'FoldStringA';
Function FormatMessageA; External DLL_Kernel32 Name 'FormatMessageA';
Function FormatMessageW; External DLL_Kernel32 Name 'FormatMessageW';
Function FormatMessage; External DLL_Kernel32 Name 'FormatMessageA';
Function FreeConsole; External DLL_Kernel32 Name 'FreeConsole';
Function FreeEnvironmentStringsA; External DLL_Kernel32 Name 'FreeEnvironmentStringsA';
Function FreeEnvironmentStringsW; External DLL_Kernel32 Name 'FreeEnvironmentStringsW';
Function FreeEnvironmentStrings; External DLL_Kernel32 Name 'FreeEnvironmentStringsA';
Function FreeLibrary; External DLL_Kernel32 Name 'FreeLibrary';
Procedure FreeLibraryAndExitThread; External DLL_Kernel32 Name 'FreeLibraryAndExitThread';
Function InterlockedCompareExchange; External DLL_Kernel32 Name 'InterlockedCompareExchange';
Function InterlockedDecrement; External DLL_Kernel32 Name 'InterlockedDecrement';
Function InterlockedExchange; External DLL_Kernel32 Name 'InterlockedExchange';
Function InterlockedExchangeAdd; External DLL_Kernel32 Name 'InterlockedExchangeAdd';
Function InterlockedIncrement; External DLL_Kernel32 Name 'InterlockedIncrement';
Function FreeResource; External DLL_Kernel32 Name 'FreeResource';
Function GenerateConsoleCtrlEvent; External DLL_Kernel32 Name 'GenerateConsoleCtrlEvent';
Function GetACP; External DLL_Kernel32 Name 'GetACP';
Function GetAtomNameA; External DLL_Kernel32 Name 'GetAtomNameA';
Function GetAtomNameW; External DLL_Kernel32 Name 'GetAtomNameW';
Function GetAtomName; External DLL_Kernel32 Name 'GetAtomNameA';
Function GetBinaryTypeA; External DLL_Kernel32 Name 'GetBinaryTypeA';
Function GetBinaryTypeW; External DLL_Kernel32 Name 'GetBinaryTypeW';
Function GetBinaryType; External DLL_Kernel32 Name 'GetBinaryTypeA';
Function GetCPInfo; External DLL_Kernel32 Name 'GetCPInfo';
Function GetCommandLineA; External DLL_Kernel32 Name 'GetCommandLineA';
Function GetCommandLineW; External DLL_Kernel32 Name 'GetCommandLineW';
Function GetCommandLine; External DLL_Kernel32 Name 'GetCommandLineA';
Function GetCommConfig; External DLL_Kernel32 Name 'GetCommConfig';
Function GetCommMask; External DLL_Kernel32 Name 'GetCommMask';
Function GetCommModemStatus; External DLL_Kernel32 Name 'GetCommModemStatus';
Function GetCommProperties; External DLL_Kernel32 Name 'GetCommProperties';
Function GetCommState; External DLL_Kernel32 Name 'GetCommState';
Function GetCommTimeouts; External DLL_Kernel32 Name 'GetCommTimeouts';
Function GetCompressedFileSizeA; External DLL_Kernel32 Name 'GetCompressedFileSizeA';
Function GetCompressedFileSizeW; External DLL_Kernel32 Name 'GetCompressedFileSizeW';
Function GetCompressedFileSize; External DLL_Kernel32 Name 'GetCompressedFileSizeA';
Function GetComputerNameA; External DLL_Kernel32 Name 'GetComputerNameA';
Function GetComputerNameW; External DLL_Kernel32 Name 'GetComputerNameW';
Function GetConsoleCP; External DLL_Kernel32 Name 'GetConsoleCP';
Function GetConsoleCursorInfo; External DLL_Kernel32 Name 'GetConsoleCursorInfo';
Function GetConsoleMode; External DLL_Kernel32 Name 'GetConsoleMode';
Function GetConsoleOutputCP; External DLL_Kernel32 Name 'GetConsoleOutputCP';
Function GetConsoleScreenBufferInfo; External DLL_Kernel32 Name 'GetConsoleScreenBufferInfo';
Function GetConsoleTitleA; External DLL_Kernel32 Name 'GetConsoleTitleA';
Function GetConsoleTitleW; External DLL_Kernel32 Name 'GetConsoleTitleW';
Function GetConsoleTitle; External DLL_Kernel32 Name 'GetConsoleTitleA';
Function GetCurrencyFormatA; External DLL_Kernel32 Name 'GetCurrencyFormatA';
Function GetCurrencyFormatW; External DLL_Kernel32 Name 'GetCurrencyFormatW';
Function GetCurrencyFormat; External DLL_Kernel32 Name 'GetCurrencyFormatA';
Function GetCurrentDirectoryA; External DLL_Kernel32 Name 'GetCurrentDirectoryA';
Function GetCurrentDirectoryW; External DLL_Kernel32 Name 'GetCurrentDirectoryW';
Function GetCurrentDirectory; External DLL_Kernel32 Name 'GetCurrentDirectoryA';
Function GetCurrentProcess; External DLL_Kernel32 Name 'GetCurrentProcess';
Function GetCurrentProcessId; External DLL_Kernel32 Name 'GetCurrentProcessId';
Function GetCurrentThread; External DLL_Kernel32 Name 'GetCurrentThread';
Function GetCurrentThreadId; External DLL_Kernel32 Name 'GetCurrentThreadId';
Function GetDateFormatA; External DLL_Kernel32 Name 'GetDateFormatA';
Function GetDateFormatW; External DLL_Kernel32 Name 'GetDateFormatW';
Function GetDateFormat; External DLL_Kernel32 Name 'GetDateFormatA';
Function GetDefaultCommConfigA; External DLL_Kernel32 Name 'GetDefaultCommConfigA';
Function GetDefaultCommConfigW; External DLL_Kernel32 Name 'GetDefaultCommConfigW';
Function GetDefaultCommConfig; External DLL_Kernel32 Name 'GetDefaultCommConfigA';
Function GetDiskFreeSpaceA; External DLL_Kernel32 Name 'GetDiskFreeSpaceA';
Function GetDiskFreeSpaceW; External DLL_Kernel32 Name 'GetDiskFreeSpaceW';
Function GetDiskFreeSpace; External DLL_Kernel32 Name 'GetDiskFreeSpaceA';
Function GetDiskFreeSpaceExA; External DLL_Kernel32 Name 'GetDiskFreeSpaceExA';
Function GetDiskFreeSpaceExW; External DLL_Kernel32 Name 'GetDiskFreeSpaceExW';
Function GetDiskFreeSpaceEx; External DLL_Kernel32 Name 'GetDiskFreeSpaceExA';
Function GetDriveTypeA; External DLL_Kernel32 Name 'GetDriveTypeA';
Function GetDriveTypeW; External DLL_Kernel32 Name 'GetDriveTypeW';
Function GetDriveType; External DLL_Kernel32 Name 'GetDriveTypeA';
Function GetEnvironmentStringsA; External DLL_Kernel32 Name 'GetEnvironmentStringsA';
Function GetEnvironmentStringsW; External DLL_Kernel32 Name 'GetEnvironmentStringsW';
Function GetEnvironmentStrings; External DLL_Kernel32 Name 'GetEnvironmentStringsA';
Function GetEnvironmentVariableA; External DLL_Kernel32 Name 'GetEnvironmentVariableA';
Function GetEnvironmentVariableW; External DLL_Kernel32 Name 'GetEnvironmentVariableW';
Function GetEnvironmentVariable; External DLL_Kernel32 Name 'GetEnvironmentVariableA';
Function GetExitCodeProcess; External DLL_Kernel32 Name 'GetExitCodeProcess';
Function GetExitCodeThread; External DLL_Kernel32 Name 'GetExitCodeThread';
Function GetFileAttributesA; External DLL_Kernel32 Name 'GetFileAttributesA';
Function GetFileAttributesW; External DLL_Kernel32 Name 'GetFileAttributesW';
Function GetFileAttributes; External DLL_Kernel32 Name 'GetFileAttributesA';
Function GetFileAttributesExA; External DLL_Kernel32 Name 'GetFileAttributesExA';
Function GetFileAttributesExW; External DLL_Kernel32 Name 'GetFileAttributesExW';
Function GetFileAttributesEx; External DLL_Kernel32 Name 'GetFileAttributesExA';
Function GetFileInformationByHandle; External DLL_Kernel32 Name 'GetFileInformationByHandle';
Function GetFileSize; External DLL_Kernel32 Name 'GetFileSize';
Function GetFileTime; External DLL_Kernel32 Name 'GetFileTime';
Function GetFileType; External DLL_Kernel32 Name 'GetFileType';
Function GetFullPathNameA; External DLL_Kernel32 Name 'GetFullPathNameA';
Function GetFullPathNameW; External DLL_Kernel32 Name 'GetFullPathNameW';
Function GetFullPathName; External DLL_Kernel32 Name 'GetFullPathNameA';
Function GetHandleInformation; External DLL_Kernel32 Name 'GetHandleInformation';
Function GetLargestConsoleWindowSize; External DLL_Kernel32 Name 'GetLargestConsoleWindowSize';
Function GetLastError; External DLL_Kernel32 Name 'GetLastError';
Procedure GetLocalTime; External DLL_Kernel32 Name 'GetLocalTime';
Function GetLocaleInfoA; External DLL_Kernel32 Name 'GetLocaleInfoA';
Function GetLocaleInfoW; External DLL_Kernel32 Name 'GetLocaleInfoW';
Function GetLocaleInfo; External DLL_Kernel32 Name 'GetLocaleInfoA';
Function GetLogicalDriveStringsA; External DLL_Kernel32 Name 'GetLogicalDriveStringsA';
Function GetLogicalDriveStringsW; External DLL_Kernel32 Name 'GetLogicalDriveStringsW';
Function GetLogicalDriveStrings; External DLL_Kernel32 Name 'GetLogicalDriveStringsA';
Function GetMailslotInfo; External DLL_Kernel32 Name 'GetMailslotInfo';
Function GetModuleFileNameA; External DLL_Kernel32 Name 'GetModuleFileNameA';
Function GetModuleFileNameW; External DLL_Kernel32 Name 'GetModuleFileNameW';
Function GetModuleFileName; External DLL_Kernel32 Name 'GetModuleFileNameA';
Function GetModuleHandleA; External DLL_Kernel32 Name 'GetModuleHandleA';
Function GetModuleHandleW; External DLL_Kernel32 Name 'GetModuleHandleW';
Function GetModuleHandle; External DLL_Kernel32 Name 'GetModuleHandleA';
Function GetNamedPipeHandleStateA; External DLL_Kernel32 Name 'GetNamedPipeHandleStateA';
Function GetNamedPipeHandleStateW; External DLL_Kernel32 Name 'GetNamedPipeHandleStateW';
Function GetNamedPipeHandleState; External DLL_Kernel32 Name 'GetNamedPipeHandleStateA';
Function GetNamedPipeInfo; External DLL_Kernel32 Name 'GetNamedPipeInfo';
Function GetNumberFormatA; External DLL_Kernel32 Name 'GetNumberFormatA';
Function GetNumberFormatW; External DLL_Kernel32 Name 'GetNumberFormatW';
Function GetNumberFormat; External DLL_Kernel32 Name 'GetNumberFormatA';
Function GetNumberOfConsoleInputEvents; External DLL_Kernel32 Name 'GetNumberOfConsoleInputEvents';
Function GetNumberOfConsoleMouseButtons; External DLL_Kernel32 Name 'GetNumberOfConsoleMouseButtons';
Function GetOEMCP; External DLL_Kernel32 Name 'GetOEMCP';
Function GetOverlappedResult; External DLL_Kernel32 Name 'GetOverlappedResult';
Function GetPriorityClass; External DLL_Kernel32 Name 'GetPriorityClass';
Function GetPrivateProfileIntA; External DLL_Kernel32 Name 'GetPrivateProfileIntA';
Function GetPrivateProfileIntW; External DLL_Kernel32 Name 'GetPrivateProfileIntW';
Function GetPrivateProfileInt; External DLL_Kernel32 Name 'GetPrivateProfileIntA';
Function GetPrivateProfileSectionA; External DLL_Kernel32 Name 'GetPrivateProfileSectionA';
Function GetPrivateProfileSectionW; External DLL_Kernel32 Name 'GetPrivateProfileSectionW';
Function GetPrivateProfileSection; External DLL_Kernel32 Name 'GetPrivateProfileSectionA';
Function GetPrivateProfileSectionNamesA; External DLL_Kernel32 Name 'GetPrivateProfileSectionNamesA';
Function GetPrivateProfileSectionNamesW; External DLL_Kernel32 Name 'GetPrivateProfileSectionNamesW';
Function GetPrivateProfileSectionNames; External DLL_Kernel32 Name 'GetPrivateProfileSectionNamesA';
Function GetPrivateProfileStringA; External DLL_Kernel32 Name 'GetPrivateProfileStringA';
Function GetPrivateProfileStringW; External DLL_Kernel32 Name 'GetPrivateProfileStringW';
Function GetPrivateProfileString; External DLL_Kernel32 Name 'GetPrivateProfileStringA';
Function GetPrivateProfileStructA; External DLL_Kernel32 Name 'GetPrivateProfileStructA';
Function GetPrivateProfileStructW; External DLL_Kernel32 Name 'GetPrivateProfileStructW';
Function GetPrivateProfileStruct; External DLL_Kernel32 Name 'GetPrivateProfileStructA';
Function GetProcAddress; External DLL_Kernel32 Name 'GetProcAddress';
Function GetProcessAffinityMask; External DLL_Kernel32 Name 'GetProcessAffinityMask';
Function GetProcessHeap; External DLL_Kernel32 Name 'GetProcessHeap';
Function GetProcessHeaps; External DLL_Kernel32 Name 'GetProcessHeaps';
Function GetProcessPriorityBoost; External DLL_Kernel32 Name 'GetProcessPriorityBoost';
Function GetProcessShutdownParameters; External DLL_Kernel32 Name 'GetProcessShutdownParameters';
Function GetProcessTimes; External DLL_Kernel32 Name 'GetProcessTimes';
Function GetProcessVersion; External DLL_Kernel32 Name 'GetProcessVersion';
Function GetProcessWorkingSetSize; External DLL_Kernel32 Name 'GetProcessWorkingSetSize';
Function GetProfileIntA; External DLL_Kernel32 Name 'GetProfileIntA';
Function GetProfileIntW; External DLL_Kernel32 Name 'GetProfileIntW';
Function GetProfileInt; External DLL_Kernel32 Name 'GetProfileIntA';
Function GetProfileSectionA; External DLL_Kernel32 Name 'GetProfileSectionA';
Function GetProfileSectionW; External DLL_Kernel32 Name 'GetProfileSectionW';
Function GetProfileSection; External DLL_Kernel32 Name 'GetProfileSectionA';
Function GetProfileStringA; External DLL_Kernel32 Name 'GetProfileStringA';
Function GetProfileStringW; External DLL_Kernel32 Name 'GetProfileStringW';
Function GetProfileString; External DLL_Kernel32 Name 'GetProfileStringA';
Function GetQueuedCompletionStatus; External DLL_Kernel32 Name 'GetQueuedCompletionStatus';
Function GetShortPathNameA; External DLL_Kernel32 Name 'GetShortPathNameA';
Function GetShortPathNameW; External DLL_Kernel32 Name 'GetShortPathNameW';
Function GetShortPathName; External DLL_Kernel32 Name 'GetShortPathNameA';
Procedure GetStartupInfoA; External DLL_Kernel32 Name 'GetStartupInfoA';
Procedure GetStartupInfoW; External DLL_Kernel32 Name 'GetStartupInfoW';
Procedure GetStartupInfo; External DLL_Kernel32 Name 'GetStartupInfoA';
Function GetStdHandle; External DLL_Kernel32 Name 'GetStdHandle';
Function GetStringTypeExA; External DLL_Kernel32 Name 'GetStringTypeExA';
Function GetStringTypeExW; External DLL_Kernel32 Name 'GetStringTypeExW';
Function GetStringTypeEx; External DLL_Kernel32 Name 'GetStringTypeExA';
Function GetStringTypeA; External DLL_Kernel32 Name 'GetStringTypeA';
Function GetStringTypeW; External DLL_Kernel32 Name 'GetStringTypeW';
Function GetSystemDefaultLCID; External DLL_Kernel32 Name 'GetSystemDefaultLCID';
Function GetSystemDefaultLangID; External DLL_Kernel32 Name 'GetSystemDefaultLangID';
Function GetSystemDirectoryA; External DLL_Kernel32 Name 'GetSystemDirectoryA';
Function GetSystemDirectoryW; External DLL_Kernel32 Name 'GetSystemDirectoryW';
Function GetSystemDirectory; External DLL_Kernel32 Name 'GetSystemDirectoryA';
Function GetSystemPowerStatus; External DLL_Kernel32 Name 'GetSystemPowerStatus';
Procedure GetSystemTime; External DLL_Kernel32 Name 'GetSystemTime';
Procedure GetSystemTimeAsFileTime; External DLL_Kernel32 Name 'GetSystemTimeAsFileTime';
Function GetSystemTimeAdjustment; External DLL_Kernel32 Name 'GetSystemTimeAdjustment';
Function GetTapeParameters; External DLL_Kernel32 Name 'GetTapeParameters';
Function GetTapePosition; External DLL_Kernel32 Name 'GetTapePosition';
Function GetTapeStatus; External DLL_Kernel32 Name 'GetTapeStatus';
Function GetTempFileNameA; External DLL_Kernel32 Name 'GetTempFileNameA';
Function GetTempFileNameW; External DLL_Kernel32 Name 'GetTempFileNameW';
Function GetTempFileName; External DLL_Kernel32 Name 'GetTempFileNameA';
Function GetTempPathA; External DLL_Kernel32 Name 'GetTempPathA';
Function GetTempPathW; External DLL_Kernel32 Name 'GetTempPathW';
Function GetTempPath; External DLL_Kernel32 Name 'GetTempPathA';
Function GetThreadContext; External DLL_Kernel32 Name 'GetThreadContext';
Function GetThreadLocale; External DLL_Kernel32 Name 'GetThreadLocale';
Function GetThreadPriority; External DLL_Kernel32 Name 'GetThreadPriority';
Function GetThreadPriorityBoost; External DLL_Kernel32 Name 'GetThreadPriorityBoost';
Function GetThreadSelectorEntry; External DLL_Kernel32 Name 'GetThreadSelectorEntry';
Function GetThreadTimes; External DLL_Kernel32 Name 'GetThreadTimes';
Function GetTimeFormatA; External DLL_Kernel32 Name 'GetTimeFormatA';
Function GetTimeFormatW; External DLL_Kernel32 Name 'GetTimeFormatW';
Function GetTimeFormat; External DLL_Kernel32 Name 'GetTimeFormatA';
Function GetTimeZoneInformation; External DLL_Kernel32 Name 'GetTimeZoneInformation';
Function GetUserDefaultLCID; External DLL_Kernel32 Name 'GetUserDefaultLCID';
Function GetUserDefaultLangID; External DLL_Kernel32 Name 'GetUserDefaultLangID';
Function GetVersionExA; External DLL_Kernel32 Name 'GetVersionExA';
Function GetVersionExW; External DLL_Kernel32 Name 'GetVersionExW';
Function GetVersionEx; External DLL_Kernel32 Name 'GetVersionExA';
Function GetVolumeInformationA; External DLL_Kernel32 Name 'GetVolumeInformationA';
Function GetVolumeInformationW; External DLL_Kernel32 Name 'GetVolumeInformationW';
Function GetVolumeInformation; External DLL_Kernel32 Name 'GetVolumeInformationA';
Function GetWindowsDirectoryA; External DLL_Kernel32 Name 'GetWindowsDirectoryA';
Function GetWindowsDirectoryW; External DLL_Kernel32 Name 'GetWindowsDirectoryW';
Function GetWindowsDirectory; External DLL_Kernel32 Name 'GetWindowsDirectoryA';
Function GlobalAddAtomA; External DLL_Kernel32 Name 'GlobalAddAtomA';
Function GlobalAddAtomW; External DLL_Kernel32 Name 'GlobalAddAtomW';
Function GlobalAddAtom; External DLL_Kernel32 Name 'GlobalAddAtomA';
Function GlobalAlloc; External DLL_Kernel32 Name 'GlobalAlloc';
Function GlobalCompact; External DLL_Kernel32 Name 'GlobalCompact';
Function GlobalDeleteAtom; External DLL_Kernel32 Name 'GlobalDeleteAtom';
Function GlobalFindAtomA; External DLL_Kernel32 Name 'GlobalFindAtomA';
Function GlobalFindAtomW; External DLL_Kernel32 Name 'GlobalFindAtomW';
Function GlobalFindAtom; External DLL_Kernel32 Name 'GlobalFindAtomA';
Procedure GlobalFix; External DLL_Kernel32 Name 'GlobalFix';
Function GlobalFlags; External DLL_Kernel32 Name 'GlobalFlags';
Function GlobalFree; External DLL_Kernel32 Name 'GlobalFree';
Function GlobalGetAtomNameA; External DLL_Kernel32 Name 'GlobalGetAtomNameA';
Function GlobalGetAtomNameW; External DLL_Kernel32 Name 'GlobalGetAtomNameW';
Function GlobalGetAtomName; External DLL_Kernel32 Name 'GlobalGetAtomNameA';
Function GlobalLock; External DLL_Kernel32 Name 'GlobalLock';
Function GlobalHandle; External DLL_Kernel32 Name 'GlobalHandle';
Procedure GlobalMemoryStatus; External DLL_Kernel32 Name 'GlobalMemoryStatus';
Function GlobalReAlloc; External DLL_Kernel32 Name 'GlobalReAlloc';
Function GlobalSize; External DLL_Kernel32 Name 'GlobalSize';
Function GlobalUnWire; External DLL_Kernel32 Name 'GlobalUnWire';
Procedure GlobalUnfix; External DLL_Kernel32 Name 'GlobalUnfix';
Function GlobalUnlock; External DLL_Kernel32 Name 'GlobalUnlock';
Function GlobalWire; External DLL_Kernel32 Name 'GlobalWire';
Function HeapAlloc; External DLL_Kernel32 Name 'HeapAlloc';
Function HeapCompact; External DLL_Kernel32 Name 'HeapCompact';
Function HeapCreate; External DLL_Kernel32 Name 'HeapCreate';
Function HeapDestroy; External DLL_Kernel32 Name 'HeapDestroy';
Function HeapFree; External DLL_Kernel32 Name 'HeapFree';
Function HeapLock; External DLL_Kernel32 Name 'HeapLock';
Function HeapReAlloc; External DLL_Kernel32 Name 'HeapReAlloc';
Function HeapSize; External DLL_Kernel32 Name 'HeapSize';
Function HeapUnlock; External DLL_Kernel32 Name 'HeapUnlock';
Function HeapValidate; External DLL_Kernel32 Name 'HeapValidate';
Function HeapWalk; External DLL_Kernel32 Name 'HeapWalk';
Function InitAtomTable; External DLL_Kernel32 Name 'InitAtomTable';
Procedure InitializeCriticalSection; External DLL_Kernel32 Name 'InitializeCriticalSection';
Function InitializeCriticalSectionAndSpinCount; External DLL_Kernel32 Name 'InitializeCriticalSectionAndSpinCount';
Function IsBadCodePtr; External DLL_Kernel32 Name 'IsBadCodePtr';
Function IsBadHugeReadPtr; External DLL_Kernel32 Name 'IsBadHugeReadPtr';
Function IsBadHugeWritePtr; External DLL_Kernel32 Name 'IsBadHugeWritePtr';
Function IsBadReadPtr; External DLL_Kernel32 Name 'IsBadReadPtr';
Function IsBadStringPtrA; External DLL_Kernel32 Name 'IsBadStringPtrA';
Function IsBadStringPtrW; External DLL_Kernel32 Name 'IsBadStringPtrW';
Function IsBadStringPtr; External DLL_Kernel32 Name 'IsBadStringPtrA';
Function IsBadWritePtr; External DLL_Kernel32 Name 'IsBadWritePtr';
Function IsDBCSLeadByte; External DLL_Kernel32 Name 'IsDBCSLeadByte';
Function IsDBCSLeadByteEx; External DLL_Kernel32 Name 'IsDBCSLeadByteEx';
Function IsProcessorFeaturePresent; External DLL_Kernel32 Name 'IsProcessorFeaturePresent';
Function IsValidCodePage; External DLL_Kernel32 Name 'IsValidCodePage';
Function IsValidLocale; External DLL_Kernel32 Name 'IsValidLocale';
Function LCMapStringA; External DLL_Kernel32 Name 'LCMapStringA';
Function LCMapStringW; External DLL_Kernel32 Name 'LCMapStringW';
Function LCMapString; External DLL_Kernel32 Name 'LCMapStringA';
Procedure LeaveCriticalSection; External DLL_Kernel32 Name 'LeaveCriticalSection';
Function LoadLibraryA; External DLL_Kernel32 Name 'LoadLibraryA';
Function LoadLibraryW; External DLL_Kernel32 Name 'LoadLibraryW';
Function LoadLibrary; External DLL_Kernel32 Name 'LoadLibraryA';
Function LoadLibraryExA; External DLL_Kernel32 Name 'LoadLibraryExA';
Function LoadLibraryExW; External DLL_Kernel32 Name 'LoadLibraryExW';
Function LoadLibraryEx; External DLL_Kernel32 Name 'LoadLibraryExA';
Function LoadModule; External DLL_Kernel32 Name 'LoadModule';
Function LoadResource; External DLL_Kernel32 Name 'LoadResource';
Function LocalAlloc; External DLL_Kernel32 Name 'LocalAlloc';
Function LocalCompact; External DLL_Kernel32 Name 'LocalCompact';
Function LocalFileTimeToFileTime; External DLL_Kernel32 Name 'LocalFileTimeToFileTime';
Function LocalFlags; External DLL_Kernel32 Name 'LocalFlags';
Function LocalFree; External DLL_Kernel32 Name 'LocalFree';
Function LocalLock; External DLL_Kernel32 Name 'LocalLock';
Function LocalReAlloc; External DLL_Kernel32 Name 'LocalReAlloc';
Function LocalShrink; External DLL_Kernel32 Name 'LocalShrink';
Function LocalSize; External DLL_Kernel32 Name 'LocalSize';
Function LocalUnlock; External DLL_Kernel32 Name 'LocalUnlock';
Function LockFile; External DLL_Kernel32 Name 'LockFile';
Function LockFileEx; External DLL_Kernel32 Name 'LockFileEx';
Function LockResource; External DLL_Kernel32 Name 'LockResource';
Function MapViewOfFile; External DLL_Kernel32 Name 'MapViewOfFile';
Function MapViewOfFileEx; External DLL_Kernel32 Name 'MapViewOfFileEx';
Function MoveFileA; External DLL_Kernel32 Name 'MoveFileA';
Function MoveFileW; External DLL_Kernel32 Name 'MoveFileW';
Function MoveFile; External DLL_Kernel32 Name 'MoveFileA';
Function MoveFileExA; External DLL_Kernel32 Name 'MoveFileExA';
Function MoveFileExW; External DLL_Kernel32 Name 'MoveFileExW';
Function MoveFileEx; External DLL_Kernel32 Name 'MoveFileExA';
Function MoveFileWithProgressA; External DLL_Kernel32 Name 'MoveFileWithProgressA';
Function MoveFileWithProgressW; External DLL_Kernel32 Name 'MoveFileWithProgressW';
Function MoveFileWithProgress; External DLL_Kernel32 Name 'MoveFileWithProgressA';
Function MulDiv; External DLL_Kernel32 Name 'MulDiv';
Function MultiByteToWideChar; External DLL_Kernel32 Name 'MultiByteToWideChar';
Function OpenEventA; External DLL_Kernel32 Name 'OpenEventA';
Function OpenEventW; External DLL_Kernel32 Name 'OpenEventW';
Function OpenEvent; External DLL_Kernel32 Name 'OpenEventA';
Function OpenFile; External DLL_Kernel32 Name 'OpenFile';
Function OpenFileMappingA; External DLL_Kernel32 Name 'OpenFileMappingA';
Function OpenFileMappingW; External DLL_Kernel32 Name 'OpenFileMappingW';
Function OpenFileMapping; External DLL_Kernel32 Name 'OpenFileMappingA';
Function OpenMutexA; External DLL_Kernel32 Name 'OpenMutexA';
Function OpenMutexW; External DLL_Kernel32 Name 'OpenMutexW';
Function OpenMutex; External DLL_Kernel32 Name 'OpenMutexA';
Function OpenProcess; External DLL_Kernel32 Name 'OpenProcess';
Function OpenRawA; External DLL_Kernel32 Name 'OpenRawA';
Function OpenRawW; External DLL_Kernel32 Name 'OpenRawW';
Function OpenRaw; External DLL_Kernel32 Name 'OpenRaw';
Function OpenSemaphoreA; External DLL_Kernel32 Name 'OpenSemaphoreA';
Function OpenWaitableTimerA; External DLL_Kernel32 Name 'OpenWaitableTimerA';
Function OpenSemaphoreW; External DLL_Kernel32 Name 'OpenSemaphoreW';
Function OpenWaitableTimerW; External DLL_Kernel32 Name 'OpenWaitableTimerW';
Function OpenSemaphore; External DLL_Kernel32 Name 'OpenSemaphoreA';
Function OpenWaitableTimer; External DLL_Kernel32 Name 'OpenWaitableTimerA';
Procedure OutputDebugStringA; External DLL_Kernel32 Name 'OutputDebugStringA';
Procedure OutputDebugStringW; External DLL_Kernel32 Name 'OutputDebugStringW';
Procedure OutputDebugString; External DLL_Kernel32 Name 'OutputDebugStringA';
Function PeekConsoleInputA; External DLL_Kernel32 Name 'PeekConsoleInputA';
Function PeekConsoleInputW; External DLL_Kernel32 Name 'PeekConsoleInputW';
Function PeekConsoleInput; External DLL_Kernel32 Name 'PeekConsoleInputA';
Function PeekNamedPipe; External DLL_Kernel32 Name 'PeekNamedPipe';
Function PostQueuedCompletionStatus; External DLL_Kernel32 Name 'PostQueuedCompletionStatus';
Function PrepareTape; External DLL_Kernel32 Name 'PrepareTape';
Function PulseEvent; External DLL_Kernel32 Name 'PulseEvent';
Function PurgeComm; External DLL_Kernel32 Name 'PurgeComm';
Function QueryDosDeviceA; External DLL_Kernel32 Name 'QueryDosDeviceA';
Function QueryDosDeviceW; External DLL_Kernel32 Name 'QueryDosDeviceW';
Function QueryDosDevice; External DLL_Kernel32 Name 'QueryDosDeviceA';
Function QueryPerformanceCounter; External DLL_Kernel32 Name 'QueryPerformanceCounter';
Function QueryPerformanceFrequency; External DLL_Kernel32 Name 'QueryPerformanceFrequency';
Function QueryRecoveryAgentsA; External DLL_Kernel32 Name 'QueryRecoveryAgentsA';
Function QueryRecoveryAgentsW; External DLL_Kernel32 Name 'QueryRecoveryAgentsW';
Function QueryRecoveryAgents; External DLL_Kernel32 Name 'QueryRecoveryAgentsA';
Function QueueUserAPC; External DLL_Kernel32 Name 'QueueUserAPC';
Procedure RaiseException; External DLL_Kernel32 Name 'RaiseException';
Function ReadConsoleA; External DLL_Kernel32 Name 'ReadConsoleA';
Function ReadConsoleW; External DLL_Kernel32 Name 'ReadConsoleW';
Function ReadConsole; External DLL_Kernel32 Name 'ReadConsoleA';
Function ReadConsoleInputA; External DLL_Kernel32 Name 'ReadConsoleInputA';
Function ReadConsoleInputW; External DLL_Kernel32 Name 'ReadConsoleInputW';
Function ReadConsoleInput; External DLL_Kernel32 Name 'ReadConsoleInputA';
Function ReadConsoleOutputA; External DLL_Kernel32 Name 'ReadConsoleOutputA';
Function ReadConsoleOutputW; External DLL_Kernel32 Name 'ReadConsoleOutputW';
Function ReadConsoleOutput; External DLL_Kernel32 Name 'ReadConsoleOutputA';
Function ReadConsoleOutputAttribute; External DLL_Kernel32 Name 'ReadConsoleOutputAttribute';
Function ReadConsoleOutputCharacterA; External DLL_Kernel32 Name 'ReadConsoleOutputCharacterA';
Function ReadConsoleOutputCharacterW; External DLL_Kernel32 Name 'ReadConsoleOutputCharacterW';
Function ReadConsoleOutputCharacter; External DLL_Kernel32 Name 'ReadConsoleOutputCharacterA';
Function ReadDirectoryChanges; External DLL_Kernel32 Name 'ReadDirectoryChangesW';
Function ReadDirectoryChangesW; External DLL_Kernel32 Name 'ReadDirectoryChangesW';
Function ReadFile; External DLL_Kernel32 Name 'ReadFile';
Function ReadFileEx; External DLL_Kernel32 Name 'ReadFileEx';
Function ReadProcessMemory; External DLL_Kernel32 Name 'ReadProcessMemory';
Function ReadRaw; External DLL_Kernel32 Name 'ReadRaw';
Function ReleaseMutex; External DLL_Kernel32 Name 'ReleaseMutex';
Function ReleaseSemaphore; External DLL_Kernel32 Name 'ReleaseSemaphore';
Function RemoveDirectoryA; External DLL_Kernel32 Name 'RemoveDirectoryA';
Function RemoveDirectoryW; External DLL_Kernel32 Name 'RemoveDirectoryW';
Function RemoveDirectory; External DLL_Kernel32 Name 'RemoveDirectoryA';
Function ResetEvent; External DLL_Kernel32 Name 'ResetEvent';
Function ResumeThread; External DLL_Kernel32 Name 'ResumeThread';
Function ScrollConsoleScreenBufferA; External DLL_Kernel32 Name 'ScrollConsoleScreenBufferA';
Function ScrollConsoleScreenBufferW; External DLL_Kernel32 Name 'ScrollConsoleScreenBufferW';
Function ScrollConsoleScreenBuffer; External DLL_Kernel32 Name 'ScrollConsoleScreenBufferA';
Function SearchPathA; External DLL_Kernel32 Name 'SearchPathA';
Function SearchPathW; External DLL_Kernel32 Name 'SearchPathW';
Function SearchPath; External DLL_Kernel32 Name 'SearchPathA';
Function SetCommBreak; External DLL_Kernel32 Name 'SetCommBreak';
Function SetCommConfig; External DLL_Kernel32 Name 'SetCommConfig';
Function SetCommMask; External DLL_Kernel32 Name 'SetCommMask';
Function SetCommState; External DLL_Kernel32 Name 'SetCommState';
Function SetCommTimeouts; External DLL_Kernel32 Name 'SetCommTimeouts';
Function SetComputerNameA; External DLL_Kernel32 Name 'SetComputerNameA';
Function SetComputerNameW; External DLL_Kernel32 Name 'SetComputerNameW';
Function SetComputerName; External DLL_Kernel32 Name 'SetComputerNameA';
Function SetConsoleActiveScreenBuffer; External DLL_Kernel32 Name 'SetConsoleActiveScreenBuffer';
Function SetConsoleCP; External DLL_Kernel32 Name 'SetConsoleCP';
Function SetConsoleCtrlHandler; External DLL_Kernel32 Name 'SetConsoleCtrlHandler';
Function SetConsoleCursorInfo; External DLL_Kernel32 Name 'SetConsoleCursorInfo';
Function SetConsoleCursorPosition; External DLL_Kernel32 Name 'SetConsoleCursorPosition';
Function SetConsoleMode; External DLL_Kernel32 Name 'SetConsoleMode';
Function SetConsoleOutputCP; External DLL_Kernel32 Name 'SetConsoleOutputCP';
Function SetConsoleScreenBufferSize; External DLL_Kernel32 Name 'SetConsoleScreenBufferSize';
Function SetConsoleTextAttribute; External DLL_Kernel32 Name 'SetConsoleTextAttribute';
Function SetConsoleTitleA; External DLL_Kernel32 Name 'SetConsoleTitleA';
Function SetConsoleTitleW; External DLL_Kernel32 Name 'SetConsoleTitleW';
Function SetConsoleTitle; External DLL_Kernel32 Name 'SetConsoleTitleA';
Function SetConsoleWindowInfo; External DLL_Kernel32 Name 'SetConsoleWindowInfo';
Function SetCriticalSectionSpinCount; External DLL_Kernel32 Name 'SetCriticalSectionSpinCount';
Function SetCurrentDirectoryA; External DLL_Kernel32 Name 'SetCurrentDirectoryA';
Function SetCurrentDirectoryW; External DLL_Kernel32 Name 'SetCurrentDirectoryW';
Function SetCurrentDirectory; External DLL_Kernel32 Name 'SetCurrentDirectoryA';
Function SetDefaultCommConfigA; External DLL_Kernel32 Name 'SetDefaultCommConfigA';
Function SetDefaultCommConfigW; External DLL_Kernel32 Name 'SetDefaultCommConfigW';
Function SetDefaultCommConfig; External DLL_Kernel32 Name 'SetDefaultCommConfigA';
Function SetEndOfFile; External DLL_Kernel32 Name 'SetEndOfFile';
Function SetEnvironmentVariableA; External DLL_Kernel32 Name 'SetEnvironmentVariableA';
Function SetEnvironmentVariableW; External DLL_Kernel32 Name 'SetEnvironmentVariableW';
Function SetEnvironmentVariable; External DLL_Kernel32 Name 'SetEnvironmentVariableA';
Function SetErrorMode; External DLL_Kernel32 Name 'SetErrorMode';
Function SetEvent; External DLL_Kernel32 Name 'SetEvent';
Procedure SetFileApisToANSI; External DLL_Kernel32 Name 'SetFileApisToANSI';
Procedure SetFileApisToOEM; External DLL_Kernel32 Name 'SetFileApisToOEM';
Function SetFileAttributesA; External DLL_Kernel32 Name 'SetFileAttributesA';
Function SetFileAttributesW; External DLL_Kernel32 Name 'SetFileAttributesW';
Function SetFileAttributes; External DLL_Kernel32 Name 'SetFileAttributesA';
Function SetFilePointer; External DLL_Kernel32 Name 'SetFilePointer';
Function SetFileTime; External DLL_Kernel32 Name 'SetFileTime';
Function SetHandleCount; External DLL_Kernel32 Name 'SetHandleCount';
Function SetHandleInformation; External DLL_Kernel32 Name 'SetHandleInformation';
Procedure SetLastError; External DLL_Kernel32 Name 'SetLastError';
Function SetLocalTime; External DLL_Kernel32 Name 'SetLocalTime';
Function SetLocaleInfoA; External DLL_Kernel32 Name 'SetLocaleInfoA';
Function SetLocaleInfoW; External DLL_Kernel32 Name 'SetLocaleInfoW';
Function SetLocaleInfo; External DLL_Kernel32 Name 'SetLocaleInfoA';
Function SetMailslotInfo; External DLL_Kernel32 Name 'SetMailslotInfo';
Function SetNamedPipeHandleState; External DLL_Kernel32 Name 'SetNamedPipeHandleState';
Function SetPriorityClass; External DLL_Kernel32 Name 'SetPriorityClass';
Function SetProcessAffinityMask; External DLL_Kernel32 Name 'SetProcessAffinityMask';
Function SetProcessPriorityBoost; External DLL_Kernel32 Name 'SetProcessPriorityBoost';
Function SetProcessShutdownParameters; External DLL_Kernel32 Name 'SetProcessShutdownParameters';
Function SetProcessWorkingSetSize; External DLL_Kernel32 Name 'SetProcessWorkingSetSize';
Function SetStdHandle; External DLL_Kernel32 Name 'SetStdHandle';
Function SetSystemPowerState; External DLL_Kernel32 Name 'SetSystemPowerState';
Function SetSystemTime; External DLL_Kernel32 Name 'SetSystemTime';
Function SetSystemTimeAdjustment; External DLL_Kernel32 Name 'SetSystemTimeAdjustment';
Function SetTapeParameters; External DLL_Kernel32 Name 'SetTapeParameters';
Function SetTapePosition; External DLL_Kernel32 Name 'SetTapePosition';
Function SetThreadAffinityMask; External DLL_Kernel32 Name 'SetThreadAffinityMask';
Function SetThreadContext; External DLL_Kernel32 Name 'SetThreadContext';
Function SetThreadIdealProcessor; External DLL_Kernel32 Name 'SetThreadIdealProcessor';
Function SetThreadLocale; External DLL_Kernel32 Name 'SetThreadLocale';
Function SetThreadPriority; External DLL_Kernel32 Name 'SetThreadPriority';
Function SetThreadPriorityBoost; External DLL_Kernel32 Name 'SetThreadPriorityBoost';
Function SetTimeZoneInformation; External DLL_Kernel32 Name 'SetTimeZoneInformation';
Function SetUnhandledExceptionFilter; External DLL_Kernel32 Name 'SetUnhandledExceptionFilter';
Function SetVolumeLabelA; External DLL_Kernel32 Name 'SetVolumeLabelA';
Function SetVolumeLabelW; External DLL_Kernel32 Name 'SetVolumeLabelW';
Function SetVolumeLabel; External DLL_Kernel32 Name 'SetVolumeLabelA';
Function SetWaitableTimer; External DLL_Kernel32 Name 'SetWaitableTimer';
Function SetupComm; External DLL_Kernel32 Name 'SetupComm';
Function SignalObjectAndWait; External DLL_Kernel32 Name 'SignalObjectAndWait';
Function SizeofResource; External DLL_Kernel32 Name 'SizeofResource';
Function SleepEx; External DLL_Kernel32 Name 'SleepEx';
Function SuspendThread; External DLL_Kernel32 Name 'SuspendThread';
Function SwitchToFiber; External DLL_Kernel32 Name 'SwitchToFiber';
Function SwitchToThread; External DLL_Kernel32 Name 'SwitchToThread';
Function SystemTimeToFileTime; External DLL_Kernel32 Name 'SystemTimeToFileTime';
Function SystemTimeToTzSpecificLocalTime; External DLL_Kernel32 Name 'SystemTimeToTzSpecificLocalTime';
Function TerminateProcess; External DLL_Kernel32 Name 'TerminateProcess';
Function TerminateThread; External DLL_Kernel32 Name 'TerminateThread';
Function TlsAlloc; External DLL_Kernel32 Name 'TlsAlloc';
Function TlsFree; External DLL_Kernel32 Name 'TlsFree';
Function TlsGetValue; External DLL_Kernel32 Name 'TlsGetValue';
Function TlsSetValue; External DLL_Kernel32 Name 'TlsSetValue';
Function TransactNamedPipe; External DLL_Kernel32 Name 'TransactNamedPipe';
Function TransmitCommChar; External DLL_Kernel32 Name 'TransmitCommChar';
Function TryEnterCriticalSection; External DLL_Kernel32 Name 'TryEnterCriticalSection';
Function UnhandledExceptionFilter; External DLL_Kernel32 Name 'UnhandledExceptionFilter';
Function UnlockFile; External DLL_Kernel32 Name 'UnlockFile';
Function UnlockFileEx; External DLL_Kernel32 Name 'UnlockFileEx';
Function UnmapViewOfFile; External DLL_Kernel32 Name 'UnmapViewOfFile';
Function UpdateResourceA; External DLL_Kernel32 Name 'UpdateResourceA';
Function UpdateResourceW; External DLL_Kernel32 Name 'UpdateResourceW';
Function UpdateResource; External DLL_Kernel32 Name 'UpdateResourceA';
Function VerLanguageNameA; External DLL_Kernel32 Name 'VerLanguageNameA';
Function VerLanguageNameW; External DLL_Kernel32 Name 'VerLanguageNameW';
Function VerLanguageName; External DLL_Kernel32 Name 'VerLanguageNameA';
Function VirtualAlloc; External DLL_Kernel32 Name 'VirtualAlloc';
Function VirtualAllocEx; External DLL_Kernel32 Name 'VirtualAllocEx';
Function VirtualFree; External DLL_Kernel32 Name 'VirtualFree';
Function VirtualFreeEx; External DLL_Kernel32 Name 'VirtualFreeEx';
Function VirtualLock; External DLL_Kernel32 Name 'VirtualLock';
Function VirtualProtect(lpAddress: Pointer; dwSize, flNewProtect: DWORD;
  lpflOldProtect: Pointer): BOOL; External DLL_Kernel32 Name 'VirtualProtect';
Function VirtualProtect(lpAddress: Pointer; dwSize, flNewProtect: DWORD;
  var OldProtect: DWORD): BOOL; External DLL_Kernel32 Name 'VirtualProtect';
Function VirtualProtectEx(hProcess: THandle; lpAddress: Pointer;
  dwSize, flNewProtect: DWORD; lpflOldProtect: Pointer): BOOL; External DLL_Kernel32 Name 'VirtualProtectEx';
Function VirtualProtectEx(hProcess: THandle; lpAddress: Pointer;
  dwSize, flNewProtect: DWORD; var OldProtect: DWORD): BOOL; External DLL_Kernel32 Name 'VirtualProtectEx';
Function VirtualQuery; External DLL_Kernel32 Name 'VirtualQuery';
Function VirtualQueryEx; External DLL_Kernel32 Name 'VirtualQueryEx';
Function VirtualUnlock; External DLL_Kernel32 Name 'VirtualUnlock';
Function WaitCommEvent; External DLL_Kernel32 Name 'WaitCommEvent';
Function WaitForDebugEvent; External DLL_Kernel32 Name 'WaitForDebugEvent';
Function WaitForMultipleObjects; External DLL_Kernel32 Name 'WaitForMultipleObjects';
Function WaitForMultipleObjectsEx; External DLL_Kernel32 Name 'WaitForMultipleObjectsEx';
Function WaitForSingleObject; External DLL_Kernel32 Name 'WaitForSingleObject';
Function WaitForSingleObjectEx; External DLL_Kernel32 Name 'WaitForSingleObjectEx';
Function WaitNamedPipeA; External DLL_Kernel32 Name 'WaitNamedPipeA';
Function WaitNamedPipeW; External DLL_Kernel32 Name 'WaitNamedPipeW';
Function WaitNamedPipe; External DLL_Kernel32 Name 'WaitNamedPipeA';
Function WideCharToMultiByte; External DLL_Kernel32 Name 'WideCharToMultiByte';
Function WriteConsoleA; External DLL_Kernel32 Name 'WriteConsoleA';
Function WriteConsoleW; External DLL_Kernel32 Name 'WriteConsoleW';
Function WriteConsole; External DLL_Kernel32 Name 'WriteConsoleA';
Function WriteConsoleInputA; External DLL_Kernel32 Name 'WriteConsoleInputA';
Function WriteConsoleInputW; External DLL_Kernel32 Name 'WriteConsoleInputW';
Function WriteConsoleInput; External DLL_Kernel32 Name 'WriteConsoleInputA';
Function WriteConsoleOutputA; External DLL_Kernel32 Name 'WriteConsoleOutputA';
Function WriteConsoleOutputW; External DLL_Kernel32 Name 'WriteConsoleOutputW';
Function WriteConsoleOutput; External DLL_Kernel32 Name 'WriteConsoleOutputA';
Function WriteConsoleOutputAttribute; External DLL_Kernel32 Name 'WriteConsoleOutputAttribute';
Function WriteConsoleOutputCharacterA; External DLL_Kernel32 Name 'WriteConsoleOutputCharacterA';
Function WriteConsoleOutputCharacterW; External DLL_Kernel32 Name 'WriteConsoleOutputCharacterW';
Function WriteConsoleOutputCharacter; External DLL_Kernel32 Name 'WriteConsoleOutputCharacterA';
Function WriteFile; External DLL_Kernel32 Name 'WriteFile';
Function WriteFileEx; External DLL_Kernel32 Name 'WriteFileEx';
Function WritePrivateProfileSectionA; External DLL_Kernel32 Name 'WritePrivateProfileSectionA';
Function WritePrivateProfileSectionW; External DLL_Kernel32 Name 'WritePrivateProfileSectionW';
Function WritePrivateProfileSection; External DLL_Kernel32 Name 'WritePrivateProfileSectionA';
Function WritePrivateProfileStringA; External DLL_Kernel32 Name 'WritePrivateProfileStringA';
Function WritePrivateProfileStringW; External DLL_Kernel32 Name 'WritePrivateProfileStringW';
Function WritePrivateProfileString; External DLL_Kernel32 Name 'WritePrivateProfileStringA';
Function WritePrivateProfileStructA; External DLL_Kernel32 Name 'WritePrivateProfileStructA';
Function WritePrivateProfileStructW; External DLL_Kernel32 Name 'WritePrivateProfileStructW';
Function WritePrivateProfileStruct; External DLL_Kernel32 Name 'WritePrivateProfileStructA';
Function WriteProcessMemory; External DLL_Kernel32 Name 'WriteProcessMemory';
Function WriteProfileSectionA; External DLL_Kernel32 Name 'WriteProfileSectionA';
Function WriteProfileSectionW; External DLL_Kernel32 Name 'WriteProfileSectionW';
Function WriteProfileSection; External DLL_Kernel32 Name 'WriteProfileSectionA';
Function WriteProfileStringA; External DLL_Kernel32 Name 'WriteProfileStringA';
Function WriteProfileStringW; External DLL_Kernel32 Name 'WriteProfileStringW';
Function WriteProfileString; External DLL_Kernel32 Name 'WriteProfileStringA';
Function WriteRaw; External DLL_Kernel32 Name 'WriteRaw';
Function WriteTapemark; External DLL_Kernel32 Name 'WriteTapemark';
Function _hread; External DLL_Kernel32 Name '_hread';
Function _hwrite; External DLL_Kernel32 Name '_hwrite';
Function _lclose; External DLL_Kernel32 Name '_lclose';
Function _lcreat; External DLL_Kernel32 Name '_lcreat';
Function _llseek; External DLL_Kernel32 Name '_llseek';
Function _lopen; External DLL_Kernel32 Name '_lopen';
Function _lread; External DLL_Kernel32 Name '_lread';
Function _lwrite; External DLL_Kernel32 Name '_lwrite';
Function lstrcatA; External DLL_Kernel32 Name 'lstrcatA';
Function lstrcatW; External DLL_Kernel32 Name 'lstrcatW';
Function lstrcat; External DLL_Kernel32 Name 'lstrcatA';
Function lstrcmpA; External DLL_Kernel32 Name 'lstrcmpA';
Function lstrcmpW; External DLL_Kernel32 Name 'lstrcmpW';
Function lstrcmp; External DLL_Kernel32 Name 'lstrcmpA';
Function lstrcmpiA; External DLL_Kernel32 Name 'lstrcmpiA';
Function lstrcmpiW; External DLL_Kernel32 Name 'lstrcmpiW';
Function lstrcmpi; External DLL_Kernel32 Name 'lstrcmpiA';
Function lstrcpyA; External DLL_Kernel32 Name 'lstrcpyA';
Function lstrcpyW; External DLL_Kernel32 Name 'lstrcpyW';
Function lstrcpy; External DLL_Kernel32 Name 'lstrcpyA';
Function lstrcpynA; External DLL_Kernel32 Name 'lstrcpynA';
Function lstrcpynW; External DLL_Kernel32 Name 'lstrcpynW';
Function lstrcpyn; External DLL_Kernel32 Name 'lstrcpynA';
Function lstrlenA; External DLL_Kernel32 Name 'lstrlenA';
Function lstrlenW; External DLL_Kernel32 Name 'lstrlenW';
Function lstrlen; External DLL_Kernel32 Name 'lstrlenA';


{ Externals from mpr.dll }

Function MultinetGetConnectionPerformanceA; External DLL_Mpr Name 'MultinetGetConnectionPerformanceA';
Function MultinetGetConnectionPerformanceW; External DLL_Mpr Name 'MultinetGetConnectionPerformanceW';
Function MultinetGetConnectionPerformance; External DLL_Mpr Name 'MultinetGetConnectionPerformanceA';
Function WNetAddConnection2A; External DLL_Mpr Name 'WNetAddConnection2A';
Function WNetAddConnection2W; External DLL_Mpr Name 'WNetAddConnection2W';
Function WNetAddConnection2; External DLL_Mpr Name 'WNetAddConnection2A';
Function WNetAddConnection3A; External DLL_Mpr Name 'WNetAddConnection3A';
Function WNetAddConnection3W; External DLL_Mpr Name 'WNetAddConnection3W';
Function WNetAddConnection3; External DLL_Mpr Name 'WNetAddConnection3A';
Function WNetAddConnectionA; External DLL_Mpr Name 'WNetAddConnectionA';
Function WNetAddConnectionW; External DLL_Mpr Name 'WNetAddConnectionW';
Function WNetAddConnection; External DLL_Mpr Name 'WNetAddConnectionA';
Function WNetCancelConnection2A; External DLL_Mpr Name 'WNetCancelConnection2A';
Function WNetCancelConnection2W; External DLL_Mpr Name 'WNetCancelConnection2W';
Function WNetCancelConnection2; External DLL_Mpr Name 'WNetCancelConnection2A';
Function WNetCancelConnectionA; External DLL_Mpr Name 'WNetCancelConnectionA';
Function WNetCancelConnectionW; External DLL_Mpr Name 'WNetCancelConnectionW';
Function WNetCancelConnection; External DLL_Mpr Name 'WNetCancelConnectionA';
Function WNetCloseEnum; External DLL_Mpr Name 'WNetCloseEnum';
Function WNetConnectionDialog1A; External DLL_Mpr Name 'WNetConnectionDialog1A';
Function WNetConnectionDialog1W; External DLL_Mpr Name 'WNetConnectionDialog1W';
Function WNetConnectionDialog1; External DLL_Mpr Name 'WNetConnectionDialog1A';
Function WNetConnectionDialog; External DLL_Mpr Name 'WNetConnectionDialog';
Function WNetDisconnectDialog1A; External DLL_Mpr Name 'WNetDisconnectDialog1A';
Function WNetDisconnectDialog1W; External DLL_Mpr Name 'WNetDisconnectDialog1W';
Function WNetDisconnectDialog1; External DLL_Mpr Name 'WNetDisconnectDialog1A';
Function WNetDisconnectDialog; External DLL_Mpr Name 'WNetDisconnectDialog';
Function WNetEnumResourceA; External DLL_Mpr Name 'WNetEnumResourceA';
Function WNetEnumResourceW; External DLL_Mpr Name 'WNetEnumResourceW';
Function WNetEnumResource; External DLL_Mpr Name 'WNetEnumResourceA';
Function WNetGetConnectionA; External DLL_Mpr Name 'WNetGetConnectionA';
Function WNetGetConnectionW; External DLL_Mpr Name 'WNetGetConnectionW';
Function WNetGetConnection; External DLL_Mpr Name 'WNetGetConnectionA';
Function WNetGetLastErrorA; External DLL_Mpr Name 'WNetGetLastErrorA';
Function WNetGetLastErrorW; External DLL_Mpr Name 'WNetGetLastErrorW';
Function WNetGetLastError; External DLL_Mpr Name 'WNetGetLastErrorA';
Function WNetGetNetworkInformationA; External DLL_Mpr Name 'WNetGetNetworkInformationA';
Function WNetGetNetworkInformationW; External DLL_Mpr Name 'WNetGetNetworkInformationW';
Function WNetGetNetworkInformation; External DLL_Mpr Name 'WNetGetNetworkInformationA';
Function WNetGetProviderNameA; External DLL_Mpr Name 'WNetGetProviderNameA';
Function WNetGetProviderNameW; External DLL_Mpr Name 'WNetGetProviderNameW';
Function WNetGetProviderName; External DLL_Mpr Name 'WNetGetProviderNameA';
Function WNetGetResourceParentA; External DLL_Mpr Name 'WNetGetResourceParentA';
Function WNetGetResourceParentW; External DLL_Mpr Name 'WNetGetResourceParentW';
Function WNetGetResourceParent; External DLL_Mpr Name 'WNetGetResourceParentA';
Function WNetGetUniversalNameA; External DLL_Mpr Name 'WNetGetUniversalNameA';
Function WNetGetUniversalNameW; External DLL_Mpr Name 'WNetGetUniversalNameW';
Function WNetGetUniversalName; External DLL_Mpr Name 'WNetGetUniversalNameA';
Function WNetGetUserA; External DLL_Mpr Name 'WNetGetUserA';
Function WNetGetUserW; External DLL_Mpr Name 'WNetGetUserW';
Function WNetGetUser; External DLL_Mpr Name 'WNetGetUserA';
Function WNetOpenEnumA; External DLL_Mpr Name 'WNetOpenEnumA';
Function WNetOpenEnumW; External DLL_Mpr Name 'WNetOpenEnumW';
Function WNetOpenEnum; External DLL_Mpr Name 'WNetOpenEnumA';
Function WNetSetConnectionA; External DLL_Mpr Name 'WNetSetConnectionA';
Function WNetSetConnectionW; External DLL_Mpr Name 'WNetSetConnectionW';
Function WNetSetConnection; External DLL_Mpr Name 'WNetSetConnectionA';
Function WNetUseConnectionA; External DLL_Mpr Name 'WNetUseConnectionA';
Function WNetUseConnectionW; External DLL_Mpr Name 'WNetUseConnectionW';
Function WNetUseConnection; External DLL_Mpr Name 'WNetUseConnectionA';


{ Externals from version.dll }

Function GetFileVersionInfoA; External DLL_Version Name 'GetFileVersionInfoA';
Function GetFileVersionInfoW; External DLL_Version Name 'GetFileVersionInfoW';
Function GetFileVersionInfo; External DLL_Version Name 'GetFileVersionInfoA';
Function GetFileVersionInfoSizeA; External DLL_Version Name 'GetFileVersionInfoSizeA';
Function GetFileVersionInfoSizeW; External DLL_Version Name 'GetFileVersionInfoSizeW';
Function GetFileVersionInfoSize; External DLL_Version Name 'GetFileVersionInfoSizeA';
Function VerFindFileA; External DLL_Version Name 'VerFindFileA';
Function VerFindFileW; External DLL_Version Name 'VerFindFileW';
Function VerFindFile; External DLL_Version Name 'VerFindFileA';
Function VerInstallFileA; External DLL_Version Name 'VerInstallFileA';
Function VerInstallFileW; External DLL_Version Name 'VerInstallFileW';
Function VerInstallFile; External DLL_Version Name 'VerInstallFileA';
Function VerQueryValueA; External DLL_Version Name 'VerQueryValueA';
Function VerQueryValueW; External DLL_Version Name 'VerQueryValueW';
Function VerQueryValue; External DLL_Version Name 'VerQueryValueA';

{ Externals from gdi32.dll }

Function AbortDoc; External DLL_Gdi32 Name 'AbortDoc';
Function AbortPath; External DLL_Gdi32 Name 'AbortPath';
Function AddFontMemResourceEx; External DLL_Gdi32 Name 'AddFontMemResourceEx';
Function AddFontResourceA; External DLL_Gdi32 Name 'AddFontResourceA';
Function AddFontResourceW; External DLL_Gdi32 Name 'AddFontResourceW';
Function AddFontResource; External DLL_Gdi32 Name 'AddFontResourceA';
Function AddFontResourceExA; External DLL_Gdi32 Name 'AddFontResourceExA';
Function AddFontResourceExW; External DLL_Gdi32 Name 'AddFontResourceExW';
Function AddFontResourceEx; External DLL_Gdi32 Name 'AddFontResourceExA';
Function AlphaBlend; External DLL_Msimg32 Name 'AlphaBlend';
Function AlphaDIBBlend; External DLL_Msimg32 Name 'AlphaDIBBlend';
Function AngleArc; External DLL_Gdi32 Name 'AngleArc';
Function AnimatePalette; External DLL_Gdi32 Name 'AnimatePalette';
Function Arc; External DLL_Gdi32 Name 'Arc';
Function ArcTo; External DLL_Gdi32 Name 'ArcTo';
Function BeginPath; External DLL_Gdi32 Name 'BeginPath';
Function BitBlt; External DLL_Gdi32 Name 'BitBlt';
Function CancelDC; External DLL_Gdi32 Name 'CancelDC';
Function CheckColorsInGamut; External DLL_Gdi32 Name 'CheckColorsInGamut';
Function ChoosePixelFormat; External DLL_Gdi32 Name 'ChoosePixelFormat';
Function Chord; External DLL_Gdi32 Name 'Chord';
Function CloseEnhMetaFile; External DLL_Gdi32 Name 'CloseEnhMetaFile';
Function CloseFigure; External DLL_Gdi32 Name 'CloseFigure';
Function CloseMetaFile; External DLL_Gdi32 Name 'CloseMetaFile';
Function ColorCorrectPalette; External DLL_Gdi32 Name 'ColorCorrectPalette';
Function ColorMatchToTarget; External DLL_Gdi32 Name 'ColorMatchToTarget';
Function CombineRgn; External DLL_Gdi32 Name 'CombineRgn';
Function CombineTransform; External DLL_Gdi32 Name 'CombineTransform';
Function CopyEnhMetaFileA; External DLL_Gdi32 Name 'CopyEnhMetaFileA';
Function CopyEnhMetaFileW; External DLL_Gdi32 Name 'CopyEnhMetaFileW';
Function CopyEnhMetaFile; External DLL_Gdi32 Name 'CopyEnhMetaFileA';
Function CopyMetaFileA; External DLL_Gdi32 Name 'CopyMetaFileA';
Function CopyMetaFileW; External DLL_Gdi32 Name 'CopyMetaFileW';
Function CopyMetaFile; External DLL_Gdi32 Name 'CopyMetaFileA';
Function CreateBitmap; External DLL_Gdi32 Name 'CreateBitmap';
Function CreateBitmapIndirect; External DLL_Gdi32 Name 'CreateBitmapIndirect';
Function CreateBrushIndirect; External DLL_Gdi32 Name 'CreateBrushIndirect';
Function CreateColorSpaceA; External DLL_Gdi32 Name 'CreateColorSpaceA';
Function CreateColorSpaceW; External DLL_Gdi32 Name 'CreateColorSpaceW';
Function CreateColorSpace; External DLL_Gdi32 Name 'CreateColorSpaceA';
Function CreateCompatibleBitmap; External DLL_Gdi32 Name 'CreateCompatibleBitmap';
Function CreateCompatibleDC; External DLL_Gdi32 Name 'CreateCompatibleDC';
Function CreateDCA; External DLL_Gdi32 Name 'CreateDCA';
Function CreateDCW; External DLL_Gdi32 Name 'CreateDCW';
Function CreateDC; External DLL_Gdi32 Name 'CreateDCA';
Function CreateDIBPatternBrush; External DLL_Gdi32 Name 'CreateDIBPatternBrush';
Function CreateDIBPatternBrushPt; External DLL_Gdi32 Name 'CreateDIBPatternBrushPt';
Function CreateDIBSection; External DLL_Gdi32 Name 'CreateDIBSection';
Function CreateDIBitmap; External DLL_Gdi32 Name 'CreateDIBitmap';
Function CreateDiscardableBitmap; External DLL_Gdi32 Name 'CreateDiscardableBitmap';
Function CreateEllipticRgn; External DLL_Gdi32 Name 'CreateEllipticRgn';
Function CreateEllipticRgnIndirect; External DLL_Gdi32 Name 'CreateEllipticRgnIndirect';
Function CreateEnhMetaFileA; External DLL_Gdi32 Name 'CreateEnhMetaFileA';
Function CreateEnhMetaFileW; External DLL_Gdi32 Name 'CreateEnhMetaFileW';
Function CreateEnhMetaFile; External DLL_Gdi32 Name 'CreateEnhMetaFileA';
Function CreateFontA; External DLL_Gdi32 Name 'CreateFontA';
Function CreateFontW; External DLL_Gdi32 Name 'CreateFontW';
Function CreateFont; External DLL_Gdi32 Name 'CreateFontA';
Function CreateFontIndirectA; External DLL_Gdi32 Name 'CreateFontIndirectA';
Function CreateFontIndirectW; External DLL_Gdi32 Name 'CreateFontIndirectW';
Function CreateFontIndirect; External DLL_Gdi32 Name 'CreateFontIndirectA';
Function CreateFontIndirectExA; External DLL_Gdi32 Name 'CreateFontIndirectExA';
Function CreateFontIndirectExW; External DLL_Gdi32 Name 'CreateFontIndirectExW';
Function CreateFontIndirectEx; External DLL_Gdi32 Name 'CreateFontIndirectExA';
Function CreateHalftonePalette; External DLL_Gdi32 Name 'CreateHalftonePalette';
Function CreateHatchBrush; External DLL_Gdi32 Name 'CreateHatchBrush';
Function CreateICA; External DLL_Gdi32 Name 'CreateICA';
Function CreateICW; External DLL_Gdi32 Name 'CreateICW';
Function CreateIC; External DLL_Gdi32 Name 'CreateICA';
Function CreateMetaFileA; External DLL_Gdi32 Name 'CreateMetaFileA';
Function CreateMetaFileW; External DLL_Gdi32 Name 'CreateMetaFileW';
Function CreateMetaFile; External DLL_Gdi32 Name 'CreateMetaFileA';
Function CreatePalette; External DLL_Gdi32 Name 'CreatePalette';
Function CreatePatternBrush; External DLL_Gdi32 Name 'CreatePatternBrush';
Function CreatePen; External DLL_Gdi32 Name 'CreatePen';
Function CreatePenIndirect; External DLL_Gdi32 Name 'CreatePenIndirect';
Function CreatePolyPolygonRgn; External DLL_Gdi32 Name 'CreatePolyPolygonRgn';
Function CreatePolygonRgn; External DLL_Gdi32 Name 'CreatePolygonRgn';
Function CreateRectRgn; External DLL_Gdi32 Name 'CreateRectRgn';
Function CreateRectRgnIndirect; External DLL_Gdi32 Name 'CreateRectRgnIndirect';
Function CreateRoundRectRgn; External DLL_Gdi32 Name 'CreateRoundRectRgn';
Function CreateScalableFontResourceA; External DLL_Gdi32 Name 'CreateScalableFontResourceA';
Function CreateScalableFontResourceW; External DLL_Gdi32 Name 'CreateScalableFontResourceW';
Function CreateScalableFontResource; External DLL_Gdi32 Name 'CreateScalableFontResourceA';
Function CreateSolidBrush; External DLL_Gdi32 Name 'CreateSolidBrush';
Function DPtoLP; External DLL_Gdi32 Name 'DPtoLP';
Function DeleteColorSpace; External DLL_Gdi32 Name 'DeleteColorSpace';
Function DeleteDC; External DLL_Gdi32 Name 'DeleteDC';
Function DeleteEnhMetaFile; External DLL_Gdi32 Name 'DeleteEnhMetaFile';
Function DeleteMetaFile; External DLL_Gdi32 Name 'DeleteMetaFile';
Function DeleteObject; External DLL_Gdi32 Name 'DeleteObject';
Function DescribePixelFormat; External DLL_Gdi32 Name 'DescribePixelFormat';
Function DeviceCapabilitiesA; External DLL_Gdi32 Name 'DeviceCapabilitiesA';
Function DeviceCapabilitiesW; External DLL_Gdi32 Name 'DeviceCapabilitiesW';
Function DeviceCapabilities; External DLL_Gdi32 Name 'DeviceCapabilitiesA';
{Function DeviceCapabilitiesEx; External DLL_Gdi32 Name 'DeviceCapabilities';}
Function DrawEscape; External DLL_Gdi32 Name 'DrawEscape';
Function Ellipse; External DLL_Gdi32 Name 'Ellipse';
Function EndDoc; External DLL_Gdi32 Name 'EndDoc';
Function EndPage; External DLL_Gdi32 Name 'EndPage';
Function EndPath; External DLL_Gdi32 Name 'EndPath';
Function EnumEnhMetaFile; External DLL_Gdi32 Name 'EnumEnhMetaFile';
Function EnumFontFamiliesA; External DLL_Gdi32 Name 'EnumFontFamiliesA';
Function EnumFontFamiliesW; External DLL_Gdi32 Name 'EnumFontFamiliesW';
Function EnumFontFamilies; External DLL_Gdi32 Name 'EnumFontFamiliesA';
Function EnumFontFamiliesExA; External DLL_Gdi32 Name 'EnumFontFamiliesExA';
Function EnumFontFamiliesExW; External DLL_Gdi32 Name 'EnumFontFamiliesExW';
Function EnumFontFamiliesEx; External DLL_Gdi32 Name 'EnumFontFamiliesExA';
Function EnumFontsA; External DLL_Gdi32 Name 'EnumFontsA';
Function EnumFontsW; External DLL_Gdi32 Name 'EnumFontsW';
Function EnumFonts; External DLL_Gdi32 Name 'EnumFontsA';
Function EnumICMProfilesA; External DLL_Gdi32 Name 'EnumICMProfilesA';
Function EnumICMProfilesW; External DLL_Gdi32 Name 'EnumICMProfilesW';
Function EnumICMProfiles; External DLL_Gdi32 Name 'EnumICMProfilesA';
Function EnumMetaFile; External DLL_Gdi32 Name 'EnumMetaFile';
Function EnumObjects; External DLL_Gdi32 Name 'EnumObjects';
Function EqualRgn; External DLL_Gdi32 Name 'EqualRgn';
Function Escape; External DLL_Gdi32 Name 'Escape';
Function ExcludeClipRect; External DLL_Gdi32 Name 'ExcludeClipRect';
Function ExtCreatePen; External DLL_Gdi32 Name 'ExtCreatePen';
Function ExtCreateRegion; External DLL_Gdi32 Name 'ExtCreateRegion';
Function ExtEscape; External DLL_Gdi32 Name 'ExtEscape';
Function ExtFloodFill; External DLL_Gdi32 Name 'ExtFloodFill';
Function ExtSelectClipRgn; External DLL_Gdi32 Name 'ExtSelectClipRgn';
Function ExtTextOutA; External DLL_Gdi32 Name 'ExtTextOutA';
Function ExtTextOutW; External DLL_Gdi32 Name 'ExtTextOutW';
Function ExtTextOut; External DLL_Gdi32 Name 'ExtTextOutA';
Function FillPath; External DLL_Gdi32 Name 'FillPath';
Function FillRgn; External DLL_Gdi32 Name 'FillRgn';
Function FlattenPath; External DLL_Gdi32 Name 'FlattenPath';
Function FloodFill; External DLL_Gdi32 Name 'FloodFill';
Function FrameRgn; External DLL_Gdi32 Name 'FrameRgn';
Function GdiComment; External DLL_Gdi32 Name 'GdiComment';
Function GdiFlush; External DLL_Gdi32 Name 'GdiFlush';
Function GdiGetBatchLimit; External DLL_Gdi32 Name 'GdiGetBatchLimit';
Function GdiSetBatchLimit; External DLL_Gdi32 Name 'GdiSetBatchLimit';
Function GetArcDirection; External DLL_Gdi32 Name 'GetArcDirection';
Function GetAspectRatioFilterEx; External DLL_Gdi32 Name 'GetAspectRatioFilterEx';
Function GetBitmapBits; External DLL_Gdi32 Name 'GetBitmapBits';
Function GetBitmapDimensionEx; External DLL_Gdi32 Name 'GetBitmapDimensionEx';
Function GetBkColor; External DLL_Gdi32 Name 'GetBkColor';
Function GetBkMode; External DLL_Gdi32 Name 'GetBkMode';
Function GetBoundsRect; External DLL_Gdi32 Name 'GetBoundsRect';
Function GetBrushOrgEx; External DLL_Gdi32 Name 'GetBrushOrgEx';
Function GetCharABCWidthsA; External DLL_Gdi32 Name 'GetCharABCWidthsA';
Function GetCharABCWidthsW; External DLL_Gdi32 Name 'GetCharABCWidthsW';
Function GetCharABCWidths; External DLL_Gdi32 Name 'GetCharABCWidthsA';
Function GetCharABCWidthsI; External DLL_Gdi32 Name 'GetCharABCWidthsI';
Function GetCharABCWidthsFloatA; External DLL_Gdi32 Name 'GetCharABCWidthsFloatA';
Function GetCharABCWidthsFloatW; External DLL_Gdi32 Name 'GetCharABCWidthsFloatW';
Function GetCharABCWidthsFloat; External DLL_Gdi32 Name 'GetCharABCWidthsFloatA';
Function GetCharWidth32A; External DLL_Gdi32 Name 'GetCharWidth32A';
Function GetCharWidth32W; External DLL_Gdi32 Name 'GetCharWidth32W';
Function GetCharWidth32; External DLL_Gdi32 Name 'GetCharWidth32A';
Function GetCharWidthA; External DLL_Gdi32 Name 'GetCharWidthA';
Function GetCharWidthW; External DLL_Gdi32 Name 'GetCharWidthW';
Function GetCharWidth; External DLL_Gdi32 Name 'GetCharWidthA';
Function GetCharWidthFloatA; External DLL_Gdi32 Name 'GetCharWidthFloatA';
Function GetCharWidthFloatW; External DLL_Gdi32 Name 'GetCharWidthFloatW';
Function GetCharWidthFloat; External DLL_Gdi32 Name 'GetCharWidthFloatA';
Function GetCharWidthI; External DLL_Gdi32 Name 'GetCharWidthI';
Function GetCharacterPlacementA; External DLL_Gdi32 Name 'GetCharacterPlacementA';
Function GetCharacterPlacementW; External DLL_Gdi32 Name 'GetCharacterPlacementW';
Function GetCharacterPlacement; External DLL_Gdi32 Name 'GetCharacterPlacementA';
Function GetClipBox; External DLL_Gdi32 Name 'GetClipBox';
Function GetClipRgn; External DLL_Gdi32 Name 'GetClipRgn';
Function GetColorAdjustment; External DLL_Gdi32 Name 'GetColorAdjustment';
Function GetColorSpace; External DLL_Gdi32 Name 'GetColorSpace';
Function GetCurrentObject; External DLL_Gdi32 Name 'GetCurrentObject';
Function GetCurrentPositionEx; External DLL_Gdi32 Name 'GetCurrentPositionEx';
Function GetDCBrushColor; External DLL_Gdi32 Name 'GetDCBrushColor';
Function GetDCPenColor; External DLL_Gdi32 Name 'GetDCPenColor';
Function GetDCOrgEx; External DLL_Gdi32 Name 'GetDCOrgEx';
Function GetDIBColorTable; External DLL_Gdi32 Name 'GetDIBColorTable';
Function GetDIBits; External DLL_Gdi32 Name 'GetDIBits';
Function GetDeviceCaps; External DLL_Gdi32 Name 'GetDeviceCaps';
Function GetDeviceGammaRamp; External DLL_Gdi32 Name 'GetDeviceGammaRamp';
Function GetEnhMetaFileA; External DLL_Gdi32 Name 'GetEnhMetaFileA';
Function GetEnhMetaFileW; External DLL_Gdi32 Name 'GetEnhMetaFileW';
Function GetEnhMetaFile; External DLL_Gdi32 Name 'GetEnhMetaFileA';
Function GetEnhMetaFileBits; External DLL_Gdi32 Name 'GetEnhMetaFileBits';
Function GetEnhMetaFileDescriptionA; External DLL_Gdi32 Name 'GetEnhMetaFileDescriptionA';
Function GetEnhMetaFileDescriptionW; External DLL_Gdi32 Name 'GetEnhMetaFileDescriptionW';
Function GetEnhMetaFileDescription; External DLL_Gdi32 Name 'GetEnhMetaFileDescriptionA';
Function GetEnhMetaFileHeader; External DLL_Gdi32 Name 'GetEnhMetaFileHeader';
Function GetEnhMetaFilePaletteEntries; External DLL_Gdi32 Name 'GetEnhMetaFilePaletteEntries';
Function GetEnhMetaFilePixelFormat; External DLL_Gdi32 Name 'GetEnhMetaFilePixelFormat';
Function GetFontData; External DLL_Gdi32 Name 'GetFontData';
Function GetFontLanguageInfo; External DLL_Gdi32 Name 'GetFontLanguageInfo';
Function GetFontUnicodeRanges; External DLL_Gdi32 Name 'GetFontUnicodeRanges';
Function GetGlyphIndicesA; External DLL_Gdi32 Name 'GetGlyphIndicesA';
Function GetGlyphIndicesW; External DLL_Gdi32 Name 'GetGlyphIndicesW';
Function GetGlyphIndices; External DLL_Gdi32 Name 'GetGlyphIndicesA';
Function GetGlyphOutlineA; External DLL_Gdi32 Name 'GetGlyphOutlineA';
Function GetGlyphOutlineW; External DLL_Gdi32 Name 'GetGlyphOutlineW';
Function GetGlyphOutline; External DLL_Gdi32 Name 'GetGlyphOutlineA';
Function GetGraphicsMode; External DLL_Gdi32 Name 'GetGraphicsMode';
Function GetICMProfileA; External DLL_Gdi32 Name 'GetICMProfileA';
Function GetICMProfileW; External DLL_Gdi32 Name 'GetICMProfileW';
Function GetICMProfile; External DLL_Gdi32 Name 'GetICMProfileA';
Function GetKerningPairs; External DLL_Gdi32 Name 'GetKerningPairs';
Function GetLogColorSpaceA; External DLL_Gdi32 Name 'GetLogColorSpaceA';
Function GetLogColorSpaceW; External DLL_Gdi32 Name 'GetLogColorSpaceW';
Function GetLogColorSpace; External DLL_Gdi32 Name 'GetLogColorSpaceA';
Function GetMapMode; External DLL_Gdi32 Name 'GetMapMode';
Function GetMetaFileA; External DLL_Gdi32 Name 'GetMetaFileA';
Function GetMetaFileW; External DLL_Gdi32 Name 'GetMetaFileW';
Function GetMetaFile; External DLL_Gdi32 Name 'GetMetaFileA';
Function GetMetaFileBitsEx; External DLL_Gdi32 Name 'GetMetaFileBitsEx';
Function GetMetaRgn; External DLL_Gdi32 Name 'GetMetaRgn';
Function GetMiterLimit; External DLL_Gdi32 Name 'GetMiterLimit';
Function GetNearestColor; External DLL_Gdi32 Name 'GetNearestColor';
Function GetNearestPaletteIndex; External DLL_Gdi32 Name 'GetNearestPaletteIndex';
Function GetObjectA; External DLL_Gdi32 Name 'GetObjectA';
Function GetObjectW; External DLL_Gdi32 Name 'GetObjectW';
Function GetObject; External DLL_Gdi32 Name 'GetObjectA';
Function GetObjectType; External DLL_Gdi32 Name 'GetObjectType';
Function GetOutlineTextMetricsA; External DLL_Gdi32 Name 'GetOutlineTextMetricsA';
Function GetOutlineTextMetricsW; External DLL_Gdi32 Name 'GetOutlineTextMetricsW';
Function GetOutlineTextMetrics; External DLL_Gdi32 Name 'GetOutlineTextMetricsA';
Function GetPaletteEntries; External DLL_Gdi32 Name 'GetPaletteEntries';
Function GetPath; External DLL_Gdi32 Name 'GetPath';
Function GetPixel; External DLL_Gdi32 Name 'GetPixel';
Function GetPixelFormat; External DLL_Gdi32 Name 'GetPixelFormat';
Function GetPolyFillMode; External DLL_Gdi32 Name 'GetPolyFillMode';
Function GetROP2; External DLL_Gdi32 Name 'GetROP2';
Function GetRasterizerCaps; External DLL_Gdi32 Name 'GetRasterizerCaps';
Function GetRegionData; External DLL_Gdi32 Name 'GetRegionData';
Function GetRgnBox; External DLL_Gdi32 Name 'GetRgnBox';
Function GetStockObject; External DLL_Gdi32 Name 'GetStockObject';
Function GetStretchBltMode; External DLL_Gdi32 Name 'GetStretchBltMode';
Function GetSystemPaletteEntries; External DLL_Gdi32 Name 'GetSystemPaletteEntries';
Function GetSystemPaletteUse; External DLL_Gdi32 Name 'GetSystemPaletteUse';
Function GetTextAlign; External DLL_Gdi32 Name 'GetTextAlign';
Function GetTextCharacterExtra; External DLL_Gdi32 Name 'GetTextCharacterExtra';
Function GetTextCharset; External DLL_Gdi32 Name 'GetTextCharset';
Function GetTextCharsetInfo; External DLL_Gdi32 Name 'GetTextCharsetInfo';
Function GetTextColor; External DLL_Gdi32 Name 'GetTextColor';
Function GetTextExtentExPointA; External DLL_Gdi32 Name 'GetTextExtentExPointA';
Function GetTextExtentExPointW; External DLL_Gdi32 Name 'GetTextExtentExPointW';
Function GetTextExtentExPoint; External DLL_Gdi32 Name 'GetTextExtentExPointA';
Function GetTextExtentExPointI; External DLL_Gdi32 Name 'GetTextExtentExPointI';
Function GetTextExtentPoint32A; External DLL_Gdi32 Name 'GetTextExtentPoint32A';
Function GetTextExtentPoint32W; External DLL_Gdi32 Name 'GetTextExtentPoint32W';
Function GetTextExtentPoint32; External DLL_Gdi32 Name 'GetTextExtentPoint32A';
Function GetTextExtentPointA; External DLL_Gdi32 Name 'GetTextExtentPointA';
Function GetTextExtentPointW; External DLL_Gdi32 Name 'GetTextExtentPointW';
Function GetTextExtentPoint; External DLL_Gdi32 Name 'GetTextExtentPointA';
Function GetTextExtentPointI; External DLL_Gdi32 Name 'GetTextExtentPointI';
Function GetTextFaceA; External DLL_Gdi32 Name 'GetTextFaceA';
Function GetTextFaceW; External DLL_Gdi32 Name 'GetTextFaceW';
Function GetTextFace; External DLL_Gdi32 Name 'GetTextFaceA';
Function GetTextMetricsA; External DLL_Gdi32 Name 'GetTextMetricsA';
Function GetTextMetricsW; External DLL_Gdi32 Name 'GetTextMetricsW';
Function GetTextMetrics; External DLL_Gdi32 Name 'GetTextMetricsA';
Function GetViewportExtEx; External DLL_Gdi32 Name 'GetViewportExtEx';
Function GetViewportOrgEx; External DLL_Gdi32 Name 'GetViewportOrgEx';
Function GetWinMetaFileBits; External DLL_Gdi32 Name 'GetWinMetaFileBits';
Function GetWindowExtEx; External DLL_Gdi32 Name 'GetWindowExtEx';
Function GetWindowOrgEx; External DLL_Gdi32 Name 'GetWindowOrgEx';
Function GetWorldTransform; External DLL_Gdi32 Name 'GetWorldTransform';
Function GradientFill; External DLL_Msimg32 Name 'GradientFill';
Function IntersectClipRect; External DLL_Gdi32 Name 'IntersectClipRect';
Function InvertRgn; External DLL_Gdi32 Name 'InvertRgn';
Function LPtoDP; External DLL_Gdi32 Name 'LPtoDP';
Function LineDDA; External DLL_Gdi32 Name 'LineDDA';
Function LineTo; External DLL_Gdi32 Name 'LineTo';
Function MaskBlt; External DLL_Gdi32 Name 'MaskBlt';
Function ModifyWorldTransform; External DLL_Gdi32 Name 'ModifyWorldTransform';
Function MoveToEx; External DLL_Gdi32 Name 'MoveToEx';
Function OffsetClipRgn; External DLL_Gdi32 Name 'OffsetClipRgn';
Function OffsetRgn; External DLL_Gdi32 Name 'OffsetRgn';
Function OffsetViewportOrgEx(DC: HDC; X, Y: Integer; var Points): BOOL; External DLL_Gdi32 Name 'OffsetViewportOrgEx';
Function OffsetWindowOrgEx(DC: HDC; X, Y: Integer; var Points): BOOL; stdcall; External DLL_Gdi32 Name 'OffsetWindowOrgEx'
Function OffsetViewportOrgEx(DC: HDC; X, Y: Integer; Points: PPoint): BOOL; External DLL_Gdi32 Name 'OffsetViewportOrgEx';
Function OffsetWindowOrgEx(DC: HDC; X, Y: Integer; Points: PPoint): BOOL; External DLL_Gdi32 Name 'OffsetWindowOrgEx'
Function PaintRgn; External DLL_Gdi32 Name 'PaintRgn';
Function PatBlt; External DLL_Gdi32 Name 'PatBlt';
Function PathToRegion; External DLL_Gdi32 Name 'PathToRegion';
Function Pie; External DLL_Gdi32 Name 'Pie';
Function PlayEnhMetaFile; External DLL_Gdi32 Name 'PlayEnhMetaFile';
Function PlayEnhMetaFileRecord; External DLL_Gdi32 Name 'PlayEnhMetaFileRecord';
Function PlayMetaFile; External DLL_Gdi32 Name 'PlayMetaFile';
Function PlayMetaFileRecord; External DLL_Gdi32 Name 'PlayMetaFileRecord';
Function PlgBlt; External DLL_Gdi32 Name 'PlgBlt';
Function PolyBezier; External DLL_Gdi32 Name 'PolyBezier';
Function PolyBezierTo; External DLL_Gdi32 Name 'PolyBezierTo';
Function PolyDraw; External DLL_Gdi32 Name 'PolyDraw';
Function PolyPolygon; External DLL_Gdi32 Name 'PolyPolygon';
Function PolyPolyline; External DLL_Gdi32 Name 'PolyPolyline';
Function PolyTextOutA; External DLL_Gdi32 Name 'PolyTextOutA';
Function PolyTextOutW; External DLL_Gdi32 Name 'PolyTextOutW';
Function PolyTextOut; External DLL_Gdi32 Name 'PolyTextOutA';
Function Polygon; External DLL_Gdi32 Name 'Polygon';
Function Polyline; External DLL_Gdi32 Name 'Polyline';
Function PolylineTo; External DLL_Gdi32 Name 'PolylineTo';
Function PtInRegion; External DLL_Gdi32 Name 'PtInRegion';
Function PtVisible; External DLL_Gdi32 Name 'PtVisible';
Function RealizePalette; External DLL_Gdi32 Name 'RealizePalette';
Function RectInRegion; External DLL_Gdi32 Name 'RectInRegion';
Function RectVisible; External DLL_Gdi32 Name 'RectVisible';
Function Rectangle; External DLL_Gdi32 Name 'Rectangle';
Function RemoveFontMemResourceEx; External DLL_Gdi32 Name 'RemoveFontMemResourceEx';
Function RemoveFontResourceA; External DLL_Gdi32 Name 'RemoveFontResourceA';
Function RemoveFontResourceW; External DLL_Gdi32 Name 'RemoveFontResourceW';
Function RemoveFontResource; External DLL_Gdi32 Name 'RemoveFontResourceA';
Function RemoveFontResourceExA; External DLL_Gdi32 Name 'RemoveFontResourceExA';
Function RemoveFontResourceExW; External DLL_Gdi32 Name 'RemoveFontResourceExW';
Function RemoveFontResourceEx; External DLL_Gdi32 Name 'RemoveFontResourceExA';
Function ResetDCA; External DLL_Gdi32 Name 'ResetDCA';
Function ResetDCW; External DLL_Gdi32 Name 'ResetDCW';
Function ResetDC; External DLL_Gdi32 Name 'ResetDCA';
Function ResizePalette; External DLL_Gdi32 Name 'ResizePalette';
Function RestoreDC; External DLL_Gdi32 Name 'RestoreDC';
Function RoundRect; External DLL_Gdi32 Name 'RoundRect';
Function SaveDC; External DLL_Gdi32 Name 'SaveDC';
Function ScaleViewportExtEx; External DLL_Gdi32 Name 'ScaleViewportExtEx';
Function ScaleWindowExtEx; External DLL_Gdi32 Name 'ScaleWindowExtEx';
Function SelectClipPath; External DLL_Gdi32 Name 'SelectClipPath';
Function SelectClipRgn; External DLL_Gdi32 Name 'SelectClipRgn';
Function SelectObject; External DLL_Gdi32 Name 'SelectObject';
Function SelectPalette; External DLL_Gdi32 Name 'SelectPalette';
Function SetAbortProc; External DLL_Gdi32 Name 'SetAbortProc';
Function SetArcDirection; External DLL_Gdi32 Name 'SetArcDirection';
Function SetBitmapBits; External DLL_Gdi32 Name 'SetBitmapBits';
Function SetBitmapDimensionEx; External DLL_Gdi32 Name 'SetBitmapDimensionEx';
Function SetBkColor; External DLL_Gdi32 Name 'SetBkColor';
Function SetBkMode; External DLL_Gdi32 Name 'SetBkMode';
Function SetBoundsRect; External DLL_Gdi32 Name 'SetBoundsRect';
Function SetBrushOrgEx; External DLL_Gdi32 Name 'SetBrushOrgEx';
Function SetColorAdjustment; External DLL_Gdi32 Name 'SetColorAdjustment';
Function SetColorSpace; External DLL_Gdi32 Name 'SetColorSpace';
Function SetDCBrushColor; External DLL_Gdi32 Name 'SetDCBrushColor';
Function SetDCPenColor; External DLL_Gdi32 Name 'SetDCPenColor';
Function SetDIBColorTable; External DLL_Gdi32 Name 'SetDIBColorTable';
Function SetDIBits; External DLL_Gdi32 Name 'SetDIBits';
Function SetDIBitsToDevice; External DLL_Gdi32 Name 'SetDIBitsToDevice';
Function SetDeviceGammaRamp; External DLL_Gdi32 Name 'SetDeviceGammaRamp';
Function SetEnhMetaFileBits; External DLL_Gdi32 Name 'SetEnhMetaFileBits';
Function SetGraphicsMode; External DLL_Gdi32 Name 'SetGraphicsMode';
Function SetICMMode; External DLL_Gdi32 Name 'SetICMMode';
Function SetICMProfileA; External DLL_Gdi32 Name 'SetICMProfileA';
Function SetICMProfileW; External DLL_Gdi32 Name 'SetICMProfileW';
Function SetICMProfile; External DLL_Gdi32 Name 'SetICMProfileA';
Function SetMapMode; External DLL_Gdi32 Name 'SetMapMode';
Function SetMapperFlags; External DLL_Gdi32 Name 'SetMapperFlags';
Function SetMetaFileBitsEx; External DLL_Gdi32 Name 'SetMetaFileBitsEx';
Function SetMetaRgn; External DLL_Gdi32 Name 'SetMetaRgn';
Function SetMiterLimit; External DLL_Gdi32 Name 'SetMiterLimit';
Function SetPaletteEntries; External DLL_Gdi32 Name 'SetPaletteEntries';
Function SetPixel; External DLL_Gdi32 Name 'SetPixel';
Function SetPixelFormat; External DLL_Gdi32 Name 'SetPixelFormat';
Function SetPixelV; External DLL_Gdi32 Name 'SetPixelV';
Function SetPolyFillMode; External DLL_Gdi32 Name 'SetPolyFillMode';
Function SetROP2; External DLL_Gdi32 Name 'SetROP2';
Function SetRectRgn; External DLL_Gdi32 Name 'SetRectRgn';
Function SetStretchBltMode; External DLL_Gdi32 Name 'SetStretchBltMode';
Function SetSystemPaletteUse; External DLL_Gdi32 Name 'SetSystemPaletteUse';
Function SetTextAlign; External DLL_Gdi32 Name 'SetTextAlign';
Function SetTextColor; External DLL_Gdi32 Name 'SetTextColor';
Function SetTextCharacterExtra; External DLL_Gdi32 Name 'SetTextCharacterExtra';
Function SetTextJustification; External DLL_Gdi32 Name 'SetTextJustification';
Function SetViewportExtEx; External DLL_Gdi32 Name 'SetViewportExtEx';
Function SetViewportOrgEx; External DLL_Gdi32 Name 'SetViewportOrgEx';
Function SetWinMetaFileBits; External DLL_Gdi32 Name 'SetWinMetaFileBits';
Function SetWindowExtEx; External DLL_Gdi32 Name 'SetWindowExtEx';
Function SetWindowOrgEx; External DLL_Gdi32 Name 'SetWindowOrgEx';
Function SetWorldTransform; External DLL_Gdi32 Name 'SetWorldTransform';
Function StartDocA; External DLL_Gdi32 Name 'StartDocA';
Function StartDocW; External DLL_Gdi32 Name 'StartDocW';
Function StartDoc; External DLL_Gdi32 Name 'StartDocA';
Function StartPage; External DLL_Gdi32 Name 'StartPage';
Function StretchBlt; External DLL_Gdi32 Name 'StretchBlt';
Function StretchDIBits; External DLL_Gdi32 Name 'StretchDIBits';
Function StrokeAndFillPath; External DLL_Gdi32 Name 'StrokeAndFillPath';
Function StrokePath; External DLL_Gdi32 Name 'StrokePath';
Function SwapBuffers; External DLL_Gdi32 Name 'SwapBuffers';
Function TextOutA; External DLL_Gdi32 Name 'TextOutA';
Function TextOutW; External DLL_Gdi32 Name 'TextOutW';
Function TextOut; External DLL_Gdi32 Name 'TextOutA';
Function TranslateCharsetInfo; External DLL_Gdi32 Name 'TranslateCharsetInfo';
Function TransparentBlt; External DLL_Msimg32 Name 'TransparentBlt';
Function TransparentDIBits; External DLL_Gdi32 Name 'TransparentDIBits';
Function UnrealizeObject; External DLL_Gdi32 Name 'UnrealizeObject';
Function UpdateColors; External DLL_Gdi32 Name 'UpdateColors';
Function UpdateICMRegKeyA; External DLL_Gdi32 Name 'UpdateICMRegKeyA';
Function UpdateICMRegKeyW; External DLL_Gdi32 Name 'UpdateICMRegKeyW';
Function UpdateICMRegKey; External DLL_Gdi32 Name 'UpdateICMRegKeyA';
Function WidenPath; External DLL_Gdi32 Name 'WidenPath';

{ Externals from opengl32.dll }

Function wglCopyContext; External DLL_Opengl32 Name 'wglCopyContext';
Function wglCreateContext; External DLL_Opengl32 Name 'wglCreateContext';
Function wglCreateLayerContext; External DLL_Opengl32 Name 'wglCreateLayerContext';
Function wglDeleteContext; External DLL_Opengl32 Name 'wglDeleteContext';
Function wglDescribeLayerPlane; External DLL_Opengl32 Name 'wglDescribeLayerPlane';
Function wglGetCurrentContext; External DLL_Opengl32 Name 'wglGetCurrentContext';
Function wglGetCurrentDC; External DLL_Opengl32 Name 'wglGetCurrentDC';
Function wglGetLayerPaletteEntries; External DLL_Opengl32 Name 'wglGetLayerPaletteEntries';
Function wglMakeCurrent; External DLL_Opengl32 Name 'wglMakeCurrent';
Function wglRealizeLayerPalette; External DLL_Opengl32 Name 'wglRealizeLayerPalette';
Function wglSetLayerPaletteEntries; External DLL_Opengl32 Name 'wglSetLayerPaletteEntries';
Function wglShareLists; External DLL_Opengl32 Name 'wglShareLists';
Function wglSwapLayerBuffers; External DLL_Opengl32 Name 'wglSwapLayerBuffers';
Function wglSwapMultipleBuffers; External DLL_Opengl32 Name 'wglSwapMultipleBuffers';
Function wglUseFontBitmapsA; External DLL_Opengl32 Name 'wglUseFontBitmapsA';
Function wglUseFontOutlinesA; External DLL_Opengl32 Name 'wglUseFontOutlinesA';
Function wglUseFontBitmapsW; External DLL_Opengl32 Name 'wglUseFontBitmapsW';
Function wglUseFontOutlinesW; External DLL_Opengl32 Name 'wglUseFontOutlinesW';
Function wglUseFontBitmaps; External DLL_Opengl32 Name 'wglUseFontBitmapsA';
Function wglUseFontOutlines; External DLL_Opengl32 Name 'wglUseFontOutlinesA';


{ Externals from user32.dll }

Function ActivateKeyboardLayout; External DLL_User32 Name 'ActivateKeyboardLayout';
Function AdjustWindowRect; External DLL_User32 Name 'AdjustWindowRect';
Function AdjustWindowRectEx; External DLL_User32 Name 'AdjustWindowRectEx';
Function AnsiToOem; External DLL_User32 Name 'CharToOemA';
Function AnsiToOemBuff; External DLL_User32 Name 'CharToOemBuffA';
Function AnsiUpper; External DLL_User32 Name 'CharUpperA';
Function AnsiUpperBuff; External DLL_User32 Name 'CharUpperBuffA';
Function AnsiLower; External DLL_User32 Name 'CharLowerA';
Function AnsiLowerBuff; External DLL_User32 Name 'CharLowerBuffA';
Function AnsiNext; External DLL_User32 Name 'CharNextA';
Function AnsiPrev; External DLL_User32 Name 'CharPrevA';
Function AnyPopup; External DLL_User32 Name 'AnyPopup';
Function AppendMenuA; External DLL_User32 Name 'AppendMenuA';
Function AppendMenuW; External DLL_User32 Name 'AppendMenuW';
Function AppendMenu; External DLL_User32 Name 'AppendMenuA';
Function ArrangeIconicWindows; External DLL_User32 Name 'ArrangeIconicWindows';
Function AttachThreadInput; External DLL_User32 Name 'AttachThreadInput';
Function BeginDeferWindowPos; External DLL_User32 Name 'BeginDeferWindowPos';
Function BeginPaint; External DLL_User32 Name 'BeginPaint';
Function BringWindowToTop; External DLL_User32 Name 'BringWindowToTop';
Function BroadcastSystemMessageA; External DLL_User32 Name 'BroadcastSystemMessageA';
Function BroadcastSystemMessageW; External DLL_User32 Name 'BroadcastSystemMessageA';
Function BroadcastSystemMessage; External DLL_User32 Name 'BroadcastSystemMessageA';
Function CallMsgFilterA; External DLL_User32 Name 'CallMsgFilterA';
Function CallMsgFilterW; External DLL_User32 Name 'CallMsgFilterW';
Function CallMsgFilter; External DLL_User32 Name 'CallMsgFilterA';
Function CallNextHookEx; External DLL_User32 Name 'CallNextHookEx';
Function CallWindowProcA; External DLL_User32 Name 'CallWindowProcA';
Function CallWindowProcW; External DLL_User32 Name 'CallWindowProcW';
Function CallWindowProc; External DLL_User32 Name 'CallWindowProcA';
Function CascadeWindows; External DLL_User32 Name 'CascadeWindows';
Function ChangeClipboardChain; External DLL_User32 Name 'ChangeClipboardChain';
Function ChangeDisplaySettingsA; External DLL_User32 Name 'ChangeDisplaySettingsA';
Function ChangeDisplaySettingsW; External DLL_User32 Name 'ChangeDisplaySettingsW';
Function ChangeDisplaySettings; External DLL_User32 Name 'ChangeDisplaySettingsA';
Function ChangeDisplaySettingsExA; External DLL_User32 Name 'ChangeDisplaySettingsExA';
Function ChangeDisplaySettingsExW; External DLL_User32 Name 'ChangeDisplaySettingsExW';
Function ChangeDisplaySettingsEx; External DLL_User32 Name 'ChangeDisplaySettingsExA';
Function ChangeMenuA; External DLL_User32 Name 'ChangeMenuA';
Function ChangeMenuW; External DLL_User32 Name 'ChangeMenuW';
Function ChangeMenu; External DLL_User32 Name 'ChangeMenuA';
Function CharLowerA; External DLL_User32 Name 'CharLowerA';
Function CharLowerW; External DLL_User32 Name 'CharLowerW';
Function CharLower; External DLL_User32 Name 'CharLowerA';
Function CharLowerBuffA; External DLL_User32 Name 'CharLowerBuffA';
Function CharLowerBuffW; External DLL_User32 Name 'CharLowerBuffW';
Function CharLowerBuff; External DLL_User32 Name 'CharLowerBuffA';
Function CharNextA; External DLL_User32 Name 'CharNextA';
Function CharNextW; External DLL_User32 Name 'CharNextW';
Function CharNext; External DLL_User32 Name 'CharNextA';
Function CharNextEx; External DLL_User32 Name 'CharNextExA';
Function CharNextExA; External DLL_User32 Name 'CharNextExA';
Function CharPrevA; External DLL_User32 Name 'CharPrevA';
Function CharPrevW; External DLL_User32 Name 'CharPrevW';
Function CharPrev; External DLL_User32 Name 'CharPrevA';
Function CharPrevEx; External DLL_User32 Name 'CharPrevExA';
Function CharPrevExA; External DLL_User32 Name 'CharPrevExA';
Function CharToOemA; External DLL_User32 Name 'CharToOemA';
Function CharToOemW; External DLL_User32 Name 'CharToOemW';
Function CharToOem; External DLL_User32 Name 'CharToOemA';
Function CharToOemBuffA; External DLL_User32 Name 'CharToOemBuffA';
Function CharToOemBuffW; External DLL_User32 Name 'CharToOemBuffW';
Function CharToOemBuff; External DLL_User32 Name 'CharToOemBuffA';
Function CharUpperA; External DLL_User32 Name 'CharUpperA';
Function CharUpperW; External DLL_User32 Name 'CharUpperW';
Function CharUpper; External DLL_User32 Name 'CharUpperA';
Function CharUpperBuffA; External DLL_User32 Name 'CharUpperBuffA';
Function CharUpperBuffW; External DLL_User32 Name 'CharUpperBuffW';
Function CharUpperBuff; External DLL_User32 Name 'CharUpperBuffA';
Function CheckDlgButton; External DLL_User32 Name 'CheckDlgButton';
Function CheckMenuItem; External DLL_User32 Name 'CheckMenuItem';
Function CheckMenuRadioItem; External DLL_User32 Name 'CheckMenuRadioItem';
Function CheckRadioButton; External DLL_User32 Name 'CheckRadioButton';
Function ChildWindowFromPoint; External DLL_User32 Name 'ChildWindowFromPoint';
Function ChildWindowFromPointEx; External DLL_User32 Name 'ChildWindowFromPointEx';
Function ClientToScreen; External DLL_User32 Name 'ClientToScreen';
Function ClipCursor; External DLL_User32 Name 'ClipCursor';
Function CloseClipboard; External DLL_User32 Name 'CloseClipboard';
Function CloseDesktop; External DLL_User32 Name 'CloseDesktop';
Function CloseWindow; External DLL_User32 Name 'CloseWindow';
Function CloseWindowStation; External DLL_User32 Name 'CloseWindowStation';
Function CopyAcceleratorTableA; External DLL_User32 Name 'CopyAcceleratorTableA';
Function CopyAcceleratorTableW; External DLL_User32 Name 'CopyAcceleratorTableW';
Function CopyAcceleratorTable; External DLL_User32 Name 'CopyAcceleratorTableA';
Function CopyIcon; External DLL_User32 Name 'CopyIcon';
Function CopyImage; External DLL_User32 Name 'CopyImage';
Function CopyRect; External DLL_User32 Name 'CopyRect';
Function CountClipboardFormats; External DLL_User32 Name 'CountClipboardFormats';
Function CreateAcceleratorTableA; External DLL_User32 Name 'CreateAcceleratorTableA';
Function CreateAcceleratorTableW; External DLL_User32 Name 'CreateAcceleratorTableW';
Function CreateAcceleratorTable; External DLL_User32 Name 'CreateAcceleratorTableA';
Function CreateCaret; External DLL_User32 Name 'CreateCaret';
Function CreateCursor; External DLL_User32 Name 'CreateCursor';
Function CreateDesktopA; External DLL_User32 Name 'CreateDesktopA';
Function CreateDesktopW; External DLL_User32 Name 'CreateDesktopW';
Function CreateDesktop; External DLL_User32 Name 'CreateDesktopA';
Function CreateDialogIndirectParamA; External DLL_User32 Name 'CreateDialogIndirectParamA';
Function CreateDialogIndirectParamW; External DLL_User32 Name 'CreateDialogIndirectParamW';
Function CreateDialogIndirectParam; External DLL_User32 Name 'CreateDialogIndirectParamA';
Function CreateDialogParamA; External DLL_User32 Name 'CreateDialogParamA';
Function CreateDialogParamW; External DLL_User32 Name 'CreateDialogParamW';
Function CreateDialogParam; External DLL_User32 Name 'CreateDialogParamA';
Function CreateIcon; External DLL_User32 Name 'CreateIcon';
Function CreateIconFromResource; External DLL_User32 Name 'CreateIconFromResource';
Function CreateIconFromResourceEx; External DLL_User32 Name 'CreateIconFromResourceEx';
Function CreateIconIndirect; External DLL_User32 Name 'CreateIconIndirect';
Function CreateMDIWindowA; External DLL_User32 Name 'CreateMDIWindowA';
Function CreateMDIWindowW; External DLL_User32 Name 'CreateMDIWindowW';
Function CreateMDIWindow; External DLL_User32 Name 'CreateMDIWindowA';
Function CreateMenu; External DLL_User32 Name 'CreateMenu';
Function CreatePopupMenu; External DLL_User32 Name 'CreatePopupMenu';
Function CreateWindowExA; External DLL_User32 Name 'CreateWindowExA';
Function CreateWindowExW; External DLL_User32 Name 'CreateWindowExW';
Function CreateWindowEx; External DLL_User32 Name 'CreateWindowExA';
Function CreateWindowStationA; External DLL_User32 Name 'CreateWindowStationA';
Function CreateWindowStationW; External DLL_User32 Name 'CreateWindowStationW';
Function CreateWindowStation; External DLL_User32 Name 'CreateWindowStationA';
Function DdeSetQualityOfService; External DLL_User32 Name 'DdeSetQualityOfService';
Function DefDlgProcA; External DLL_User32 Name 'DefDlgProcA';
Function DefDlgProcW; External DLL_User32 Name 'DefDlgProcW';
Function DefDlgProc; External DLL_User32 Name 'DefDlgProcA';
Function DefFrameProcA; External DLL_User32 Name 'DefFrameProcA';
Function DefFrameProcW; External DLL_User32 Name 'DefFrameProcW';
Function DefFrameProc; External DLL_User32 Name 'DefFrameProcA';
Function DefMDIChildProcA; External DLL_User32 Name 'DefMDIChildProcA';
Function DefMDIChildProcW; External DLL_User32 Name 'DefMDIChildProcW';
Function DefMDIChildProc; External DLL_User32 Name 'DefMDIChildProcA';
Function DefWindowProcA; External DLL_User32 Name 'DefWindowProcA';
Function DefWindowProcW; External DLL_User32 Name 'DefWindowProcW';
Function DefWindowProc; External DLL_User32 Name 'DefWindowProcA';
Function DeferWindowPos; External DLL_User32 Name 'DeferWindowPos';
Function DeleteMenu; External DLL_User32 Name 'DeleteMenu';
Function DestroyAcceleratorTable; External DLL_User32 Name 'DestroyAcceleratorTable';
Function DestroyCaret; External DLL_User32 Name 'DestroyCaret';
Function DestroyCursor; External DLL_User32 Name 'DestroyCursor';
Function DestroyIcon; External DLL_User32 Name 'DestroyIcon';
Function DestroyMenu; External DLL_User32 Name 'DestroyMenu';
Function DestroyWindow; External DLL_User32 Name 'DestroyWindow';
Function DialogBoxIndirectParamA; External DLL_User32 Name 'DialogBoxIndirectParamA';
Function DialogBoxIndirectParamW; External DLL_User32 Name 'DialogBoxIndirectParamW';
Function DialogBoxIndirectParam; External DLL_User32 Name 'DialogBoxIndirectParamA';
Function DialogBoxParamA; External DLL_User32 Name 'DialogBoxParamA';
Function DialogBoxParamW; External DLL_User32 Name 'DialogBoxParamW';
Function DialogBoxParam; External DLL_User32 Name 'DialogBoxParamA';
Function DispatchMessageA; External DLL_User32 Name 'DispatchMessageA';
Function DispatchMessageW; External DLL_User32 Name 'DispatchMessageW';
Function DispatchMessage; External DLL_User32 Name 'DispatchMessageA';
Function DlgDirListA; External DLL_User32 Name 'DlgDirListA';
Function DlgDirListW; External DLL_User32 Name 'DlgDirListW';
Function DlgDirList; External DLL_User32 Name 'DlgDirListA';
Function DlgDirListComboBoxA; External DLL_User32 Name 'DlgDirListComboBoxA';
Function DlgDirListComboBoxW; External DLL_User32 Name 'DlgDirListComboBoxW';
Function DlgDirListComboBox; External DLL_User32 Name 'DlgDirListComboBoxA';
Function DlgDirSelectComboBoxExA; External DLL_User32 Name 'DlgDirSelectComboBoxExA';
Function DlgDirSelectComboBoxExW; External DLL_User32 Name 'DlgDirSelectComboBoxExW';
Function DlgDirSelectComboBoxEx; External DLL_User32 Name 'DlgDirSelectComboBoxExA';
Function DlgDirSelectExA; External DLL_User32 Name 'DlgDirSelectExA';
Function DlgDirSelectExW; External DLL_User32 Name 'DlgDirSelectExW';
Function DlgDirSelectEx; External DLL_User32 Name 'DlgDirSelectExA';
Function DragDetect; External DLL_User32 Name 'DragDetect';
Function DragObject; External DLL_User32 Name 'DragObject';
Function DrawAnimatedRects; External DLL_User32 Name 'DrawAnimatedRects';
Function DrawCaption; External DLL_User32 Name 'DrawCaption';
Function DrawEdge; External DLL_User32 Name 'DrawEdge';
Function DrawFocusRect; External DLL_User32 Name 'DrawFocusRect';
Function DrawFrameControl; External DLL_User32 Name 'DrawFrameControl';
Function DrawIcon; External DLL_User32 Name 'DrawIcon';
Function DrawIconEx; External DLL_User32 Name 'DrawIconEx';
Function DrawMenuBar; External DLL_User32 Name 'DrawMenuBar';
Function DrawStateA; External DLL_User32 Name 'DrawStateA';
Function DrawStateW; External DLL_User32 Name 'DrawStateW';
Function DrawState; External DLL_User32 Name 'DrawStateA';
Function DrawTextA; External DLL_User32 Name 'DrawTextA';
Function DrawTextW; External DLL_User32 Name 'DrawTextW';
Function DrawText; External DLL_User32 Name 'DrawTextA';
Function DrawTextExA; External DLL_User32 Name 'DrawTextExA';
Function DrawTextExW; External DLL_User32 Name 'DrawTextExW';
Function DrawTextEx; External DLL_User32 Name 'DrawTextExA';
Function EmptyClipboard; External DLL_User32 Name 'EmptyClipboard';
Function EnableMenuItem; External DLL_User32 Name 'EnableMenuItem';
Function EnableScrollBar; External DLL_User32 Name 'EnableScrollBar';
Function EnableWindow; External DLL_User32 Name 'EnableWindow';
Function EndDeferWindowPos; External DLL_User32 Name 'EndDeferWindowPos';
Function EndDialog; External DLL_User32 Name 'EndDialog';
Function EndMenu; External DLL_User32 Name 'EndMenu';
Function EndPaint; External DLL_User32 Name 'EndPaint';
Function EnumChildWindows; External DLL_User32 Name 'EnumChildWindows';
Function EnumClipboardFormats; External DLL_User32 Name 'EnumClipboardFormats';
Function EnumDesktopsA; External DLL_User32 Name 'EnumDesktopsA';
Function EnumDesktopsW; External DLL_User32 Name 'EnumDesktopsW';
Function EnumDesktops; External DLL_User32 Name 'EnumDesktopsA';
Function EnumDesktopWindows; External DLL_User32 Name 'EnumDesktopWindows';
Function EnumDisplaySettingsA; External DLL_User32 Name 'EnumDisplaySettingsA';
Function EnumDisplaySettingsW; External DLL_User32 Name 'EnumDisplaySettingsW';
Function EnumDisplaySettings; External DLL_User32 Name 'EnumDisplaySettingsA';
Function EnumDisplayDevicesA; External DLL_User32 Name 'EnumDisplayDevicesA';
Function EnumDisplayDevicesW; External DLL_User32 Name 'EnumDisplayDevicesW';
Function EnumDisplayDevices; External DLL_User32 Name 'EnumDisplayDevicesA';
Function EnumPropsA; External DLL_User32 Name 'EnumPropsA';
Function EnumPropsW; External DLL_User32 Name 'EnumPropsW';
Function EnumProps; External DLL_User32 Name 'EnumPropsA';
Function EnumPropsExA; External DLL_User32 Name 'EnumPropsExA';
Function EnumPropsExW; External DLL_User32 Name 'EnumPropsExW';
Function EnumPropsEx; External DLL_User32 Name 'EnumPropsExA';
Function EnumThreadWindows; External DLL_User32 Name 'EnumThreadWindows';
Function EnumWindowStationsA; External DLL_User32 Name 'EnumWindowStationsA';
Function EnumWindowStationsW; External DLL_User32 Name 'EnumWindowStationsW';
Function EnumWindowStations; External DLL_User32 Name 'EnumWindowStationsA';
Function EnumWindows; External DLL_User32 Name 'EnumWindows';
Function EqualRect; External DLL_User32 Name 'EqualRect';
Function ExcludeUpdateRgn; External DLL_User32 Name 'ExcludeUpdateRgn';
Function ExitWindowsEx; External DLL_User32 Name 'ExitWindowsEx';
Function FillRect; External DLL_User32 Name 'FillRect';
Function FindWindowA; External DLL_User32 Name 'FindWindowA';
Function FindWindowW; External DLL_User32 Name 'FindWindowW';
Function FindWindow; External DLL_User32 Name 'FindWindowA';
Function FindWindowExA; External DLL_User32 Name 'FindWindowExA';
Function FindWindowExW; External DLL_User32 Name 'FindWindowExW';
Function FindWindowEx; External DLL_User32 Name 'FindWindowExA';
Function FlashWindow; External DLL_User32 Name 'FlashWindow';
Function FlashWindowEx; External DLL_User32 Name 'FlashWindowEx';
Function FrameRect; External DLL_User32 Name 'FrameRect';
Function FreeDDElParam; External DLL_User32 Name 'FreeDDElParam';
Function GetActiveWindow; External DLL_User32 Name 'GetActiveWindow';
Function GetAltTabInfoA; External DLL_User32 Name 'GetAltTabInfoA';
Function GetAltTabInfoW; External DLL_User32 Name 'GetAltTabInfoW';
Function GetAltTabInfo; External DLL_User32 Name 'GetAltTabInfoA';
Function GetAncestor; External DLL_User32 Name 'GetAncestor';
Function GetAsyncKeyState; External DLL_User32 Name 'GetAsyncKeyState';
Function GetCapture; External DLL_User32 Name 'GetCapture';
Function GetCaretBlinkTime; External DLL_User32 Name 'GetCaretBlinkTime';
Function GetCaretPos; External DLL_User32 Name 'GetCaretPos';
Function GetClassInfoA; External DLL_User32 Name 'GetClassInfoA';
Function GetClassInfoW; External DLL_User32 Name 'GetClassInfoW';
Function GetClassInfo; External DLL_User32 Name 'GetClassInfoA';
Function GetClassInfoExA; External DLL_User32 Name 'GetClassInfoExA';
Function GetClassInfoExW; External DLL_User32 Name 'GetClassInfoExW';
Function GetClassInfoEx; External DLL_User32 Name 'GetClassInfoExA';
Function GetClassLongA; External DLL_User32 Name 'GetClassLongA';
Function GetClassLongW; External DLL_User32 Name 'GetClassLongW';
Function GetClassLong; External DLL_User32 Name 'GetClassLongA';
Function GetClassNameA; External DLL_User32 Name 'GetClassNameA';
Function GetClassNameW; External DLL_User32 Name 'GetClassNameW';
Function GetClassName; External DLL_User32 Name 'GetClassNameA';
Function GetClassWord; External DLL_User32 Name 'GetClassWord';
Function GetClientRect; External DLL_User32 Name 'GetClientRect';
Function GetClipCursor; External DLL_User32 Name 'GetClipCursor';
Function GetClipboardData; External DLL_User32 Name 'GetClipboardData';
Function GetClipboardFormatNameA; External DLL_User32 Name 'GetClipboardFormatNameA';
Function GetClipboardFormatNameW; External DLL_User32 Name 'GetClipboardFormatNameW';
Function GetClipboardFormatName; External DLL_User32 Name 'GetClipboardFormatNameA';
Function GetClipboardSequenceNumber; External DLL_User32 Name 'GetClipboardSequenceNumber';
Function GetClipboardOwner; External DLL_User32 Name 'GetClipboardOwner';
Function GetClipboardViewer; External DLL_User32 Name 'GetClipboardViewer';
Function GetComboBoxInfo; External DLL_User32 Name 'GetComboBoxInfo';
Function GetCursor; External DLL_User32 Name 'GetCursor';
Function GetCursorInfo; External DLL_User32 Name 'GetCursorInfo';
Function GetCursorPos; External DLL_User32 Name 'GetCursorPos';
Function GetDC; External DLL_User32 Name 'GetDC';
Function GetDCEx; External DLL_User32 Name 'GetDCEx';
Function GetDesktopWindow; External DLL_User32 Name 'GetDesktopWindow';
Function GetDialogBaseUnits; External DLL_User32 Name 'GetDialogBaseUnits';
Function GetDlgCtrlID; External DLL_User32 Name 'GetDlgCtrlID';
Function GetDlgItem; External DLL_User32 Name 'GetDlgItem';
Function GetDlgItemInt; External DLL_User32 Name 'GetDlgItemInt';
Function GetDlgItemTextA; External DLL_User32 Name 'GetDlgItemTextA';
Function GetDlgItemTextW; External DLL_User32 Name 'GetDlgItemTextW';
Function GetDlgItemText; External DLL_User32 Name 'GetDlgItemTextA';
Function GetDoubleClickTime; External DLL_User32 Name 'GetDoubleClickTime';
Function GetFocus; External DLL_User32 Name 'GetFocus';
Function GetForegroundWindow; External DLL_User32 Name 'GetForegroundWindow';
Function GetGuiResources; External DLL_User32 Name 'GetGuiResources';
Function GetGUIThreadInfo; External DLL_User32 Name 'GetGUIThreadInfo';
Function GetIconInfo; External DLL_User32 Name 'GetIconInfo';
Function GetInputState; External DLL_User32 Name 'GetInputState';
Function GetKBCodePage; External DLL_User32 Name 'GetKBCodePage';
Function GetKeyNameTextA; External DLL_User32 Name 'GetKeyNameTextA';
Function GetKeyNameTextW; External DLL_User32 Name 'GetKeyNameTextW';
Function GetKeyNameText; External DLL_User32 Name 'GetKeyNameTextA';
Function GetKeyState; External DLL_User32 Name 'GetKeyState';
Function GetKeyboardLayout; External DLL_User32 Name 'GetKeyboardLayout';
Function GetKeyboardLayoutList; External DLL_User32 Name 'GetKeyboardLayoutList';
Function GetKeyboardLayoutNameA; External DLL_User32 Name 'GetKeyboardLayoutNameA';
Function GetKeyboardLayoutNameW; External DLL_User32 Name 'GetKeyboardLayoutNameW';
Function GetKeyboardLayoutName; External DLL_User32 Name 'GetKeyboardLayoutNameA';
Function GetMouseMovePoints; External DLL_User32 Name 'GetMouseMovePoints';
Function GetKeyboardState; External DLL_User32 Name 'GetKeyboardState';
Function GetKeyboardType; External DLL_User32 Name 'GetKeyboardType';
Function GetLastActivePopup; External DLL_User32 Name 'GetLastActivePopup';
Function GetLastInputInfo; External DLL_User32 Name 'GetLastInputInfo';
Function GetListBoxInfo; External DLL_User32 Name 'GetListBoxInfo';
Function GetMenu; External DLL_User32 Name 'GetMenu';
Function GetMenuBarInfo; External DLL_User32 Name 'GetMenuBarInfo';
Function GetMenuCheckMarkDimensions; External DLL_User32 Name 'GetMenuCheckMarkDimensions';
Function GetMenuContextHelpId; External DLL_User32 Name 'GetMenuContextHelpId';
Function GetMenuDefaultItem; External DLL_User32 Name 'GetMenuDefaultItem';
Function GetMenuInfo; External DLL_User32 Name 'GetMenuInfo';
Function GetMenuItemCount; External DLL_User32 Name 'GetMenuItemCount';
Function GetMenuItemID; External DLL_User32 Name 'GetMenuItemID';
Function GetMenuItemInfoA; External DLL_User32 Name 'GetMenuItemInfoA';
Function GetMenuItemInfoW; External DLL_User32 Name 'GetMenuItemInfoW';
Function GetMenuItemInfo; External DLL_User32 Name 'GetMenuItemInfoA';
Function GetMenuItemRect; External DLL_User32 Name 'GetMenuItemRect';
Function GetMenuState; External DLL_User32 Name 'GetMenuState';
Function GetMenuStringA; External DLL_User32 Name 'GetMenuStringA';
Function GetMenuStringW; External DLL_User32 Name 'GetMenuStringW';
Function GetMenuString; External DLL_User32 Name 'GetMenuStringA';
Function GetMessageA; External DLL_User32 Name 'GetMessageA';
Function GetMessageW; External DLL_User32 Name 'GetMessageW';
Function GetMessage; External DLL_User32 Name 'GetMessageA';
Function GetMessageExtraInfo; External DLL_User32 Name 'GetMessageExtraInfo';
Function GetMessagePos; External DLL_User32 Name 'GetMessagePos';
Function GetMessageTime; External DLL_User32 Name 'GetMessageTime';
Function GetNextDlgGroupItem; External DLL_User32 Name 'GetNextDlgGroupItem';
Function GetNextDlgTabItem; External DLL_User32 Name 'GetNextDlgTabItem';
Function GetNextWindow; External DLL_User32 Name 'GetWindow';
Function GetOpenClipboardWindow; External DLL_User32 Name 'GetOpenClipboardWindow';
Function GetParent; External DLL_User32 Name 'GetParent';
Function GetPriorityClipboardFormat; External DLL_User32 Name 'GetPriorityClipboardFormat';
Function GetProcessWindowStation; External DLL_User32 Name 'GetProcessWindowStation';
Function GetPropA; External DLL_User32 Name 'GetPropA';
Function GetPropW; External DLL_User32 Name 'GetPropW';
Function GetProp; External DLL_User32 Name 'GetPropA';
Function GetQueueStatus; External DLL_User32 Name 'GetQueueStatus';
Function GetScrollBarInfo; External DLL_User32 Name 'GetScrollBarInfo';
Function GetScrollInfo; External DLL_User32 Name 'GetScrollInfo';
Function GetScrollPos; External DLL_User32 Name 'GetScrollPos';
Function GetScrollRange; External DLL_User32 Name 'GetScrollRange';
Function GetSubMenu; External DLL_User32 Name 'GetSubMenu';
Function GetSysColor; External DLL_User32 Name 'GetSysColor';
Function GetSysColorBrush; External DLL_User32 Name 'GetSysColorBrush';
Function GetSystemMenu; External DLL_User32 Name 'GetSystemMenu';
Function GetSystemMetrics; External DLL_User32 Name 'GetSystemMetrics';
Function GetTabbedTextExtentA; External DLL_User32 Name 'GetTabbedTextExtentA';
Function GetTabbedTextExtentW; External DLL_User32 Name 'GetTabbedTextExtentW';
Function GetTabbedTextExtent; External DLL_User32 Name 'GetTabbedTextExtentA';
Function GetThreadDesktop; External DLL_User32 Name 'GetThreadDesktop';
Function GetTitleBarInfo; External DLL_User32 Name 'GetTitleInfo';
Function GetTopWindow; External DLL_User32 Name 'GetTopWindow';
Function GetUpdateRect; External DLL_User32 Name 'GetUpdateRect';
Function GetUpdateRgn; External DLL_User32 Name 'GetUpdateRgn';
Function GetUserObjectInformationA; External DLL_User32 Name 'GetUserObjectInformationA';
Function GetUserObjectInformationW; External DLL_User32 Name 'GetUserObjectInformationW';
Function GetUserObjectInformation; External DLL_User32 Name 'GetUserObjectInformationA';
Function GetUserObjectSecurity; External DLL_User32 Name 'GetUserObjectSecurity';
Function GetWindow; External DLL_User32 Name 'GetWindow';
Function GetWindowContextHelpId; External DLL_User32 Name 'GetWindowContextHelpId';
Function GetWindowDC; External DLL_User32 Name 'GetWindowDC';
Function GetWindowInfo; External DLL_User32 Name 'GetWindowInfo';
Function GetWindowLongA; External DLL_User32 Name 'GetWindowLongA';
Function GetWindowLongW; External DLL_User32 Name 'GetWindowLongW';
Function GetWindowLong; External DLL_User32 Name 'GetWindowLongA';
Function GetWindowModuleFileNameA; External DLL_User32 Name 'GetWindowModuleFileNameA';
Function GetWindowModuleFileNameW; External DLL_User32 Name 'GetWindowModuleFileNameW';
Function GetWindowModuleFileName; External DLL_User32 Name 'GetWindowModuleFileNameA';
Function GetWindowPlacement; External DLL_User32 Name 'GetWindowPlacement';
Function GetWindowRect; External DLL_User32 Name 'GetWindowRect';
Function GetWindowRgn; External DLL_User32 Name 'GetWindowRgn';
Function GetWindowTextA; External DLL_User32 Name 'GetWindowTextA';
Function GetWindowTextW; External DLL_User32 Name 'GetWindowTextW';
Function GetWindowText; External DLL_User32 Name 'GetWindowTextA';
Function GetWindowTextLengthA; External DLL_User32 Name 'GetWindowTextLengthA';
Function GetWindowTextLengthW; External DLL_User32 Name 'GetWindowTextLengthW';
Function GetWindowTextLength; External DLL_User32 Name 'GetWindowTextLengthA';
Function GetWindowThreadProcessId; External DLL_User32 Name 'GetWindowThreadProcessId';
Function GetWindowWord; External DLL_User32 Name 'GetWindowWord';
Function GrayStringA; External DLL_User32 Name 'GrayStringA';
Function GrayStringW; External DLL_User32 Name 'GrayStringW';
Function GrayString; External DLL_User32 Name 'GrayStringA';
Function HideCaret; External DLL_User32 Name 'HideCaret';
Function HiliteMenuItem; External DLL_User32 Name 'HiliteMenuItem';
Function ImpersonateDdeClientWindow; External DLL_User32 Name 'ImpersonateDdeClientWindow';
Function InSendMessage; External DLL_User32 Name 'InSendMessage';
Function InSendMessageeX; External DLL_User32 Name 'InSendMessageeX';
Function InflateRect; External DLL_User32 Name 'InflateRect';
Function InsertMenuA; External DLL_User32 Name 'InsertMenuA';
Function InsertMenuW; External DLL_User32 Name 'InsertMenuW';
Function InsertMenu; External DLL_User32 Name 'InsertMenuA';
Function InsertMenuItemA; External DLL_User32 Name 'InsertMenuItemA';
Function InsertMenuItemW; External DLL_User32 Name 'InsertMenuItemW';
Function InsertMenuItem; External DLL_User32 Name 'InsertMenuItemA';
Function IntersectRect; External DLL_User32 Name 'IntersectRect';
Function InvalidateRect; External DLL_User32 Name 'InvalidateRect';
Function InvalidateRgn; External DLL_User32 Name 'InvalidateRgn';
Function InvertRect; External DLL_User32 Name 'InvertRect';
Function IsCharAlphaA; External DLL_User32 Name 'IsCharAlphaA';
Function IsCharAlphaW; External DLL_User32 Name 'IsCharAlphaW';
Function IsCharAlpha; External DLL_User32 Name 'IsCharAlphaA';
Function IsCharAlphaNumericA; External DLL_User32 Name 'IsCharAlphaNumericA';
Function IsCharAlphaNumericW; External DLL_User32 Name 'IsCharAlphaNumericW';
Function IsCharAlphaNumeric; External DLL_User32 Name 'IsCharAlphaNumericA';
Function IsCharLowerA; External DLL_User32 Name 'IsCharLowerA';
Function IsCharLowerW; External DLL_User32 Name 'IsCharLowerW';
Function IsCharLower; External DLL_User32 Name 'IsCharLowerA';
Function IsCharUpperA; External DLL_User32 Name 'IsCharUpperA';
Function IsCharUpperW; External DLL_User32 Name 'IsCharUpperW';
Function IsCharUpper; External DLL_User32 Name 'IsCharUpperA';
Function IsChild; External DLL_User32 Name 'IsChild';
Function IsClipboardFormatAvailable; External DLL_User32 Name 'IsClipboardFormatAvailable';
Function IsDialogMessageA; External DLL_User32 Name 'IsDialogMessageA';
Function IsDialogMessageW; External DLL_User32 Name 'IsDialogMessageW';
Function IsDialogMessage; External DLL_User32 Name 'IsDialogMessageA';
Function IsDlgButtonChecked; External DLL_User32 Name 'IsDlgButtonChecked';
Function IsIconic; External DLL_User32 Name 'IsIconic';
Function IsMenu; External DLL_User32 Name 'IsMenu';
Function IsRectEmpty; External DLL_User32 Name 'IsRectEmpty';
Function IsWindow; External DLL_User32 Name 'IsWindow';
Function IsWindowEnabled; External DLL_User32 Name 'IsWindowEnabled';
Function IsWindowUnicode; External DLL_User32 Name 'IsWindowUnicode';
Function IsWindowVisible; External DLL_User32 Name 'IsWindowVisible';
Function IsZoomed; External DLL_User32 Name 'IsZoomed';
Function KillTimer; External DLL_User32 Name 'KillTimer';
Function LoadAcceleratorsA; External DLL_User32 Name 'LoadAcceleratorsA';
Function LoadAcceleratorsW; External DLL_User32 Name 'LoadAcceleratorsW';
Function LoadAccelerators; External DLL_User32 Name 'LoadAcceleratorsA';
Function LoadBitmapA; External DLL_User32 Name 'LoadBitmapA';
Function LoadBitmapW; External DLL_User32 Name 'LoadBitmapW';
Function LoadBitmap; External DLL_User32 Name 'LoadBitmapA';
Function LoadCursorA; External DLL_User32 Name 'LoadCursorA';
Function LoadCursorW; External DLL_User32 Name 'LoadCursorW';
Function LoadCursor; External DLL_User32 Name 'LoadCursorA';
Function LoadCursorFromFileA; External DLL_User32 Name 'LoadCursorFromFileA';
Function LoadCursorFromFileW; External DLL_User32 Name 'LoadCursorFromFileW';
Function LoadCursorFromFile; External DLL_User32 Name 'LoadCursorFromFileA';
Function LoadIconA; External DLL_User32 Name 'LoadIconA';
Function LoadIconW; External DLL_User32 Name 'LoadIconW';
Function LoadIcon; External DLL_User32 Name 'LoadIconA';
Function LoadImageA; External DLL_User32 Name 'LoadImageA';
Function LoadImageW; External DLL_User32 Name 'LoadImageW';
Function LoadImage; External DLL_User32 Name 'LoadImageA';
Function LoadKeyboardLayoutA; External DLL_User32 Name 'LoadKeyboardLayoutA';
Function LoadKeyboardLayoutW; External DLL_User32 Name 'LoadKeyboardLayoutW';
Function LoadKeyboardLayout; External DLL_User32 Name 'LoadKeyboardLayoutA';
Function LoadMenuA; External DLL_User32 Name 'LoadMenuA';
Function LoadMenuW; External DLL_User32 Name 'LoadMenuW';
Function LoadMenu; External DLL_User32 Name 'LoadMenuA';
Function LoadMenuIndirectA; External DLL_User32 Name 'LoadMenuIndirectA';
Function LoadMenuIndirectW; External DLL_User32 Name 'LoadMenuIndirectW';
Function LoadMenuIndirect; External DLL_User32 Name 'LoadMenuIndirectA';
Function LoadStringA; External DLL_User32 Name 'LoadStringA';
Function LoadStringW; External DLL_User32 Name 'LoadStringW';
Function LoadString; External DLL_User32 Name 'LoadStringA';
Function LockWindowUpdate; External DLL_User32 Name 'LockWindowUpdate';
Function LockWorkStation; External DLL_User32 Name 'LockWorkStation';
Function LookupIconIdFromDirectory; External DLL_User32 Name 'LookupIconIdFromDirectory';
Function LookupIconIdFromDirectoryEx; External DLL_User32 Name 'LookupIconIdFromDirectoryEx';
Function MapDialogRect; External DLL_User32 Name 'MapDialogRect';
Function MapVirtualKeyA; External DLL_User32 Name 'MapVirtualKeyA';
Function MapVirtualKeyW; External DLL_User32 Name 'MapVirtualKeyW';
Function MapVirtualKey; External DLL_User32 Name 'MapVirtualKeyA';
Function MapVirtualKeyExA; External DLL_User32 Name 'MapVirtualKeyExA';
Function MapVirtualKeyExW; External DLL_User32 Name 'MapVirtualKeyExW';
Function MapVirtualKeyEx; External DLL_User32 Name 'MapVirtualKeyExA';
Function MapWindowPoints; External DLL_User32 Name 'MapWindowPoints';
Function MenuItemFromPoint; External DLL_User32 Name 'MenuItemFromPoint';
Function MessageBeep; External DLL_User32 Name 'MessageBeep';
Function MessageBoxA; External DLL_User32 Name 'MessageBoxA';
Function MessageBoxW; External DLL_User32 Name 'MessageBoxW';
Function MessageBox; External DLL_User32 Name 'MessageBoxA';
Function MessageBoxExA; External DLL_User32 Name 'MessageBoxExA';
Function MessageBoxExW; External DLL_User32 Name 'MessageBoxExW';
Function MessageBoxEx; External DLL_User32 Name 'MessageBoxExA';
Function MessageBoxIndirectA; External DLL_User32 Name 'MessageBoxIndirectA';
Function MessageBoxIndirectW; External DLL_User32 Name 'MessageBoxIndirectW';
Function MessageBoxIndirect; External DLL_User32 Name 'MessageBoxIndirectA';
Function ModifyMenuA; External DLL_User32 Name 'ModifyMenuA';
Function ModifyMenuW; External DLL_User32 Name 'ModifyMenuW';
Function ModifyMenu; External DLL_User32 Name 'ModifyMenuA';
Function MoveWindow; External DLL_User32 Name 'MoveWindow';
Function MsgWaitForMultipleObjects; External DLL_User32 Name 'MsgWaitForMultipleObjects';
Function MsgWaitForMultipleObjectsEx; External DLL_User32 Name 'MsgWaitForMultipleObjectsEx';
Procedure NotifyWinEvent; External DLL_User32 Name 'NotifyWinEvent';
Function OemKeyScan; External DLL_User32 Name 'OemKeyScan';
Function OemToAnsi; External DLL_User32 Name 'OemToCharA';
Function OemToAnsiBuff; External DLL_User32 Name 'OemToCharBuffA';
Function OemToCharA; External DLL_User32 Name 'OemToCharA';
Function OemToCharW; External DLL_User32 Name 'OemToCharW';
Function OemToChar; External DLL_User32 Name 'OemToCharA';
Function OemToCharBuffA; External DLL_User32 Name 'OemToCharBuffA';
Function OemToCharBuffW; External DLL_User32 Name 'OemToCharBuffW';
Function OemToCharBuff; External DLL_User32 Name 'OemToCharBuffA';
Function OffsetRect; External DLL_User32 Name 'OffsetRect';
Function OpenClipboard; External DLL_User32 Name 'OpenClipboard';
Function OpenDesktopA; External DLL_User32 Name 'OpenDesktopA';
Function OpenDesktopW; External DLL_User32 Name 'OpenDesktopW';
Function OpenDesktop; External DLL_User32 Name 'OpenDesktopA';
Function OpenIcon; External DLL_User32 Name 'OpenIcon';
Function OpenInputDesktop; External DLL_User32 Name 'OpenInputDesktop';
Function OpenWindowStationA; External DLL_User32 Name 'OpenWindowStationA';
Function OpenWindowStationW; External DLL_User32 Name 'OpenWindowStationW';
Function OpenWindowStation; External DLL_User32 Name 'OpenWindowStationA';
Function PackDDElParam; External DLL_User32 Name 'PackDDElParam';
Function PaintDesktop; External DLL_User32 Name 'PaintDesktop';
Function PeekMessageA; External DLL_User32 Name 'PeekMessageA';
Function PeekMessageW; External DLL_User32 Name 'PeekMessageW';
Function PeekMessage; External DLL_User32 Name 'PeekMessageA';
Function PostMessageA; External DLL_User32 Name 'PostMessageA';
Function PostMessageW; External DLL_User32 Name 'PostMessageW';
Function PostMessage; External DLL_User32 Name 'PostMessageA';
Procedure PostQuitMessage; External DLL_User32 Name 'PostQuitMessage';
Function PostThreadMessageA; External DLL_User32 Name 'PostThreadMessageA';
Function PostThreadMessageW; External DLL_User32 Name 'PostThreadMessageW';
Function PostThreadMessage; External DLL_User32 Name 'PostThreadMessageA';
Function PtInRect; External DLL_User32 Name 'PtInRect';
Function RealChildWindowFromPoint; External DLL_User32 Name 'RealChildWindowFromPoint';
Function RealGetWindowClassA; External DLL_User32 Name 'RealGetWindowClassA';
Function RealGetWindowClassW; External DLL_User32 Name 'RealGetWindowClassW';
Function RealGetWindowClass; External DLL_User32 Name 'RealGetWindowClassA';
Function RedrawWindow; External DLL_User32 Name 'RedrawWindow';
Function RegisterClassA; External DLL_User32 Name 'RegisterClassA';
Function RegisterClassW; External DLL_User32 Name 'RegisterClassW';
Function RegisterClass; External DLL_User32 Name 'RegisterClassA';
Function RegisterClassExA; External DLL_User32 Name 'RegisterClassExA';
Function RegisterClassExW; External DLL_User32 Name 'RegisterClassExW';
Function RegisterClassEx; External DLL_User32 Name 'RegisterClassExA';
Function RegisterClipboardFormatA; External DLL_User32 Name 'RegisterClipboardFormatA';
Function RegisterClipboardFormatW; External DLL_User32 Name 'RegisterClipboardFormatW';
Function RegisterClipboardFormat; External DLL_User32 Name 'RegisterClipboardFormatA';
Function RegisterDeviceNotificationA; External DLL_User32 Name 'RegisterDeviceNotificationA';
Function RegisterDeviceNotificationW; External DLL_User32 Name 'RegisterDeviceNotificationW';
Function RegisterDeviceNotification; External DLL_User32 Name 'RegisterDeviceNotificationA';
Function RegisterHotKey; External DLL_User32 Name 'RegisterHotKey';
Function RegisterWindowMessageA; External DLL_User32 Name 'RegisterWindowMessageA';
Function RegisterWindowMessageW; External DLL_User32 Name 'RegisterWindowMessageW';
Function RegisterWindowMessage; External DLL_User32 Name 'RegisterWindowMessageA';
Function ReleaseCapture; External DLL_User32 Name 'ReleaseCapture';
Function ReleaseDC; External DLL_User32 Name 'ReleaseDC';
Function RemoveMenu; External DLL_User32 Name 'RemoveMenu';
Function RemovePropA; External DLL_User32 Name 'RemovePropA';
Function RemovePropW; External DLL_User32 Name 'RemovePropW';
Function RemoveProp; External DLL_User32 Name 'RemovePropA';
Function ReplyMessage; External DLL_User32 Name 'ReplyMessage';
Function ReuseDDElParam; External DLL_User32 Name 'ReuseDDElParam';
Function ScreenToClient; External DLL_User32 Name 'ScreenToClient';
Function ScrollDC; External DLL_User32 Name 'ScrollDC';
Function ScrollWindow; External DLL_User32 Name 'ScrollWindow';
Function ScrollWindowEx; External DLL_User32 Name 'ScrollWindowEx';
Function SendDlgItemMessageA; External DLL_User32 Name 'SendDlgItemMessageA';
Function SendDlgItemMessageW; External DLL_User32 Name 'SendDlgItemMessageW';
Function SendDlgItemMessage; External DLL_User32 Name 'SendDlgItemMessageA';
Function SendInput; External DLL_User32 Name 'SendInput';
Function SendMessageA; External DLL_User32 Name 'SendMessageA';
Function SendMessageW; External DLL_User32 Name 'SendMessageW';
Function SendMessage; External DLL_User32 Name 'SendMessageA';
Function SendMessageCallbackA; External DLL_User32 Name 'SendMessageCallbackA';
Function SendMessageCallbackW; External DLL_User32 Name 'SendMessageCallbackW';
Function SendMessageCallback; External DLL_User32 Name 'SendMessageCallbackA';
Function SendMessageTimeoutA; External DLL_User32 Name 'SendMessageTimeoutA';
Function SendMessageTimeoutW; External DLL_User32 Name 'SendMessageTimeoutW';
Function SendMessageTimeout; External DLL_User32 Name 'SendMessageTimeoutA';
Function SendNotifyMessageA; External DLL_User32 Name 'SendNotifyMessageA';
Function SendNotifyMessageW; External DLL_User32 Name 'SendNotifyMessageW';
Function SendNotifyMessage; External DLL_User32 Name 'SendNotifyMessageA';
Function SetActiveWindow; External DLL_User32 Name 'SetActiveWindow';
Function SetCapture; External DLL_User32 Name 'SetCapture';
Function SetCaretBlinkTime; External DLL_User32 Name 'SetCaretBlinkTime';
Function SetCaretPos; External DLL_User32 Name 'SetCaretPos';
Function SetClassLongA; External DLL_User32 Name 'SetClassLongA';
Function SetClassLongW; External DLL_User32 Name 'SetClassLongW';
Function SetClassLong; External DLL_User32 Name 'SetClassLongA';
Function SetClassWord; External DLL_User32 Name 'SetClassWord';
Function SetClipboardData; External DLL_User32 Name 'SetClipboardData';
Function SetClipboardViewer; External DLL_User32 Name 'SetClipboardViewer';
Function SetCursor; External DLL_User32 Name 'SetCursor';
Function SetCursorPos; External DLL_User32 Name 'SetCursorPos';
Procedure SetDebugErrorLevel; External DLL_User32 Name 'SetDebugErrorLevel';
Function SetDlgItemInt; External DLL_User32 Name 'SetDlgItemInt';
Function SetDlgItemTextA; External DLL_User32 Name 'SetDlgItemTextA';
Function SetDlgItemTextW; External DLL_User32 Name 'SetDlgItemTextW';
Function SetDlgItemText; External DLL_User32 Name 'SetDlgItemTextA';
Function SetDoubleClickTime; External DLL_User32 Name 'SetDoubleClickTime';
Function SetFocus; External DLL_User32 Name 'SetFocus';
Function SetForegroundWindow; External DLL_User32 Name 'SetForegroundWindow';
Function SetKeyboardState; External DLL_User32 Name 'SetKeyboardState';
Procedure SetLastErrorEx; External DLL_User32 Name 'SetLastErrorEx';
Function SetMenu; External DLL_User32 Name 'SetMenu';
Function SetMenuContextHelpId; External DLL_User32 Name 'SetMenuContextHelpId';
Function SetMenuDefaultItem; External DLL_User32 Name 'SetMenuDefaultItem';
Function SetMenuInfo; External DLL_User32 Name 'SetMenuInfo';
Function SetMenuItemBitmaps; External DLL_User32 Name 'SetMenuItemBitmaps';
Function SetMenuItemInfoA; External DLL_User32 Name 'SetMenuItemInfoA';
Function SetMenuItemInfoW; External DLL_User32 Name 'SetMenuItemInfoW';
Function SetMenuItemInfo; External DLL_User32 Name 'SetMenuItemInfoA';
Function SetMessageExtraInfo; External DLL_User32 Name 'SetMessageExtraInfo';
Function SetMessageQueue; External DLL_User32 Name 'SetMessageQueue';
Function SetParent; External DLL_User32 Name 'SetParent';
Function SetProcessWindowStation; External DLL_User32 Name 'SetProcessWindowStation';
Function SetPropA; External DLL_User32 Name 'SetPropA';
Function SetPropW; External DLL_User32 Name 'SetPropW';
Function SetProp; External DLL_User32 Name 'SetPropA';
Function SetRect; External DLL_User32 Name 'SetRect';
Function SetRectEmpty; External DLL_User32 Name 'SetRectEmpty';
Function SetScrollInfo; External DLL_User32 Name 'SetScrollInfo';
Function SetScrollPos; External DLL_User32 Name 'SetScrollPos';
Function SetScrollRange; External DLL_User32 Name 'SetScrollRange';
Function SetSysColors; External DLL_User32 Name 'SetSysColors';
Function SetSystemCursor; External DLL_User32 Name 'SetSystemCursor';
Function SetThreadDesktop; External DLL_User32 Name 'SetThreadDesktop';
Function SetTimer; External DLL_User32 Name 'SetTimer';
Function SetUserObjectInformationA; External DLL_User32 Name 'SetUserObjectInformationA';
Function SetUserObjectInformationW; External DLL_User32 Name 'SetUserObjectInformationW';
Function SetUserObjectInformation; External DLL_User32 Name 'SetUserObjectInformationA';
Function SetUserObjectSecurity; External DLL_User32 Name 'SetUserObjectSecurity';
Function SetWindowContextHelpId; External DLL_User32 Name 'SetWindowContextHelpId';
Function SetWindowLongA; External DLL_User32 Name 'SetWindowLongA';
Function SetWindowLongW; External DLL_User32 Name 'SetWindowLongW';
Function SetWindowLong; External DLL_User32 Name 'SetWindowLongA';
Function SetWindowPlacement; External DLL_User32 Name 'SetWindowPlacement';
Function SetWindowPos; External DLL_User32 Name 'SetWindowPos';
Function SetWindowTextA; External DLL_User32 Name 'SetWindowTextA';
Function SetWindowTextW; External DLL_User32 Name 'SetWindowTextW';
Function SetWindowText; External DLL_User32 Name 'SetWindowTextA';
Function SetWindowWord; External DLL_User32 Name 'SetWindowWord';
Function SetWindowsHookA; External DLL_User32 Name 'SetWindowsHookA';
Function SetWindowsHookW; External DLL_User32 Name 'SetWindowsHookW';
Function SetWindowsHook; External DLL_User32 Name 'SetWindowsHookA';
Function SetWindowsHookExA; External DLL_User32 Name 'SetWindowsHookExA';
Function SetWindowsHookExW; External DLL_User32 Name 'SetWindowsHookExW';
Function SetWindowsHookEx; External DLL_User32 Name 'SetWindowsHookExA';
Function SetWindowRgn; External DLL_User32 Name 'SetWindowRgn';
Function SetWinEventHook; External DLL_User32 Name 'SetWinEventHook';
Function ShowCaret; External DLL_User32 Name 'ShowCaret';
Function ShowCursor; External DLL_User32 Name 'ShowCursor';
Function ShowOwnedPopups; External DLL_User32 Name 'ShowOwnedPopups';
Function ShowScrollBar; External DLL_User32 Name 'ShowScrollBar';
Function ShowWindow; External DLL_User32 Name 'ShowWindow';
Function AnimateWindow; External DLL_User32 Name 'AnimateWindow';
Function ShowWindowAsync; External DLL_User32 Name 'ShowWindowAsync';
Function SubtractRect; External DLL_User32 Name 'SubtractRect';
Function SwitchDesktop; External DLL_User32 Name 'SwitchDesktop';
Function SystemParametersInfoA; External DLL_User32 Name 'SystemParametersInfoA';
Function SystemParametersInfoW; External DLL_User32 Name 'SystemParametersInfoW';
Function SystemParametersInfo; External DLL_User32 Name 'SystemParametersInfoA';
Function TabbedTextOutA; External DLL_User32 Name 'TabbedTextOutA';
Function TabbedTextOutW; External DLL_User32 Name 'TabbedTextOutW';
Function TabbedTextOut; External DLL_User32 Name 'TabbedTextOutA';
Function TileWindows; External DLL_User32 Name 'TileWindows';
Function ToAscii; External DLL_User32 Name 'ToAscii';
Function ToAsciiEx; External DLL_User32 Name 'ToAsciiEx';
Function ToUnicode; External DLL_User32 Name 'ToUnicode';
Function ToUnicodeEx; External DLL_User32 Name 'ToUnicodeEx';
Function TrackMouseEvent; External DLL_User32 Name 'TrackMouseEvent';
Function TrackPopupMenu; External DLL_User32 Name 'TrackPopupMenu';
Function TrackPopupMenuEx; External DLL_User32 Name 'TrackPopupMenuEx';
Function TranslateAcceleratorA; External DLL_User32 Name 'TranslateAcceleratorA';
Function TranslateAcceleratorW; External DLL_User32 Name 'TranslateAcceleratorW';
Function TranslateAccelerator; External DLL_User32 Name 'TranslateAcceleratorA';
Function TranslateMDISysAccel; External DLL_User32 Name 'TranslateMDISysAccel';
Function TranslateMessage; External DLL_User32 Name 'TranslateMessage';
Function UnhookWindowsHook; External DLL_User32 Name 'UnhookWindowsHook';
Function UnhookWindowsHookEx; External DLL_User32 Name 'UnhookWindowsHookEx';
Function UnhookWinEvent; External DLL_User32 Name 'UnhookWinEvent';
Function UnionRect; External DLL_User32 Name 'UnionRect';
Function UnloadKeyboardLayout; External DLL_User32 Name 'UnloadKeyboardLayout';
Function UnpackDDElParam; External DLL_User32 Name 'UnpackDDElParam';
Function UnregisterClassA; External DLL_User32 Name 'UnregisterClassA';
Function UnregisterClassW; External DLL_User32 Name 'UnregisterClassW';
Function UnregisterClass; External DLL_User32 Name 'UnregisterClassA';
Function UnregisterDeviceNotification; External DLL_User32 Name 'UnregisterDeviceNotification';
Function UnregisterHotKey; External DLL_User32 Name 'UnregisterHotKey';
Function UpdateWindow; External DLL_User32 Name 'UpdateWindow';
Function UserHandleGrantAccess; External DLL_User32 Name 'UserHandleGrantAccess';
Function ValidateRect; External DLL_User32 Name 'ValidateRect';
Function ValidateRgn; External DLL_User32 Name 'ValidateRgn';
Function VkKeyScanA; External DLL_User32 Name 'VkKeyScanA';
Function VkKeyScanW; External DLL_User32 Name 'VkKeyScanW';
Function VkKeyScan; External DLL_User32 Name 'VkKeyScanA';
Function VkKeyScanExA; External DLL_User32 Name 'VkKeyScanExA';
Function VkKeyScanExW; External DLL_User32 Name 'VkKeyScanExW';
Function VkKeyScanEx; External DLL_User32 Name 'VkKeyScanExA';
Function WaitForInputIdle; External DLL_User32 Name 'WaitForInputIdle';
Function WaitMessage; External DLL_User32 Name 'WaitMessage';
Function WinHelpA; External DLL_User32 Name 'WinHelpA';
Function WinHelpW; External DLL_User32 Name 'WinHelpW';
Function WinHelp; External DLL_User32 Name 'WinHelpA';
Function WindowFromDC; External DLL_User32 Name 'WindowFromDC';
Function WindowFromPoint; External DLL_User32 Name 'WindowFromPoint';
Procedure keybd_event; External DLL_User32 Name 'keybd_event';
Procedure mouse_event; External DLL_User32 Name 'mouse_event';
Function wsprintfA; External DLL_User32 Name 'wsprintfA';
Function wsprintfW; External DLL_User32 Name 'wsprintfW';
Function wsprintf; External DLL_User32 Name 'wsprintfA';
Function wvsprintfA; External DLL_User32 Name 'wvsprintfA';
Function wvsprintfW; External DLL_User32 Name 'wvsprintfW';
Function wvsprintf; External DLL_User32 Name 'wvsprintfA';

{ Externals from wintrust.dll }

Function WinLoadTrustProvider; External DLL_Wintrust Name 'WinLoadTrustProvider';
Function WinSubmitCertificate; External DLL_Wintrust Name 'WinSubmitCertificate';
Function WinVerifyTrust; External DLL_Wintrust Name 'WinVerifyTrust';
