{ͻ
                             Test_Components.pas                            
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 08.05.2000                                                   
  COUNTRY....: Montpellier - Timeless (FRANCE)                              
  DESCRIPTION: Test all visual components.                                  
  AUTONOMOUS.: No                                                           
 ͼ}

{$Mode Objfpc}

Uses Crt,
     Windows,
     Classes,
     MosControls,
     MosButtons,
     MosCombos,
     MosSliders,
     MosLists,
     MosTexts,
     MosBevels,
     MosGauges,
     MosForms,
     MosStrings,
     MosConfig,
     MosBase,
     MosKeyboard;

Var Page             :Integer;
    MaxPages         :Integer;
    Loop             :Integer;
    Modified         :Boolean;
    MustExit         :Boolean;

{}
{}
{}

Procedure Test_TMessage;
Var Message  :TMessage;

Begin
MustExit := Yes;
Clrscr;
Writeln('Test TMessage');
Writeln;

Message := NIL;
Message := TMessage.Create;
Message.PutToList(CMClosed);
Message.PutToList(CMSelected);
Message.PutToList(CMSelected);
Writeln(Message.Count);

Message.GetFromList;
Writeln(Message.Count);
Message.GetFromList;
Writeln(Message.Count);
Message.GetFromList;
Message.GetFromList;
Message.GetFromList;
Message.GetFromList;
Writeln(Message.Count);

If Assigned(Message) Then Message.Free;
End;

{}
{}
{}

Procedure Test_TControl;
Var Comp:TControl;

Begin
MustExit := Yes;
Clrscr;
Writeln('Test TControl');
Writeln;

Comp := NIL;
Comp := TControl.Create(NIL);

With Comp do
   Begin
   Writeln('-> Initial values');
   Writeln('Position = ',X1:3,' ',Y1:3,' ',X2:3,' ',Y2:3,' - ','(Width:',Width:3,' Height:',Height:3,')');

   X1:=100;
   Y1:=110;
   X2:=200;
   Y2:=210;
   Writeln('-> Set Coordinates := 100,110,200,210');
   Writeln('Position = ',X1:3,' ',Y1:3,' ',X2:3,' ',Y2:3,' - ','(Width:',Width:3,' Height:',Height:3,')');
   Writeln;

   Top:=320;
   Writeln('-> Top := ',Top);
   Writeln('Position = ',X1:3,' ',Y1:3,' ',X2:3,' ',Y2:3,' - ','(Width:',Width:3,' Height:',Height:3,')');

   Height:=132;
   Writeln('-> Height := ',Height);
   Writeln('Position = ',X1:3,' ',Y1:3,' ',X2:3,' ',Y2:3,' - ','(Width:',Width:3,' Height:',Height:3,')');

   Width:=20;
   Writeln('-> Width := ',Width);
   Writeln('Position = ',X1:3,' ',Y1:3,' ',X2:3,' ',Y2:3,' - ','(Width:',Width:3,' Height:',Height:3,')');
   Writeln;

   X1:=50;
   Writeln('-> X1 := ',X1);
   Writeln('Position = ',X1:3,' ',Y1:3,' ',X2:3,' ',Y2:3,' - ','(Width:',Width:3,' Height:',Height:3,')');

   Left:=-111;
   Writeln('-> Left := ',Left);
   Writeln('Position = ',X1:3,' ',Y1:3,' ',X2:3,' ',Y2:3,' - ','(Width:',Width:3,' Height:',Height:3,')');
   Writeln;

   MoveTo(500,600);
   Writeln('-> MoveTo := 500,600');
   Writeln('Position = ',X1:3,' ',Y1:3,' ',X2:3,' ',Y2:3,' - ','(Width:',Width:3,' Height:',Height:3,')');
   End;

If Assigned(Comp) Then Comp.Free;
End;

{}
{}
{}

Procedure Test_TMouseZone;
Var MZ:AMouseZone;

Begin
MustExit := Yes;
Clrscr;
Writeln('Test TMouseZone');
Writeln;

Mz := NIL;
Mz := AMouseZone.Create(NIL, 010,010,100,100, MBIgnore, MPBusy);
Writeln('Mz.Enabled = ',Mz.Enabled);
Writeln('Mz.Visible = ',Mz.Visible);
Writeln;

If Assigned(Mz) Then Mz.Free;
End;

{}
{}
{}

Procedure Test_TList;
Var List1            :TList;
{    Compare          :TListSortCompare;}
    Loop             :Longint;

Begin
MustExit := Yes;
Clrscr;
Writeln('Test TList');
Writeln;

List1 := NIL;
List1 := TList.Create;

Writeln('Capacity = ',List1.Capacity);
Writeln('Count = ',List1.Count);
//Writeln('Item size (Pointer) = ',List1.List.Size,' bytes');
Writeln;

Writeln('-> Add pointer(s) ',Str_Po2S(List1));
List1.Add(List1);
List1.Add(NIL);
List1.Add(List1);
List1.Add(NIL);
List1.Add(NIL);
List1.Add(@Loop);
List1.Add(@List1.Capacity);
Writeln('Count = ',List1.Count);
Writeln;

Writeln('Display items with "Items[n]"');
For Loop := 0 to List1.Count - 1 do
   Begin
   Writeln('Pointer [',Loop:3,'] = $',Str_Po2S(List1.Items[Loop]));
   End;
Writeln;
Writeln('Pointer [First] = $',Str_Po2S(List1.First));
Writeln('Pointer [Last]  = $',Str_Po2S(List1.Last));
Writeln;
Readkey; {=======================}

Writeln('-> Pack list');
List1.Pack;
Writeln('Count = ',List1.Count);
Writeln('Pointer [Last]  = $',Str_Po2S(List1.Last));
Writeln;
Writeln('Display items with "Items[n]"');
For Loop := 0 to List1.Count - 1 do
   Begin
   Writeln('Pointer [',Loop:3,'] = $',Str_Po2S(List1.Items[Loop]));
   End;
Writeln;
Writeln('Pointer [First] = $',Str_Po2S(List1.First));
Writeln('Pointer [Last]  = $',Str_Po2S(List1.Last));
Writeln;
Readkey; {=======================}

Writeln('-> Pack list again !');
List1.Pack;
Writeln('Count = ',List1.Count);
Writeln('Pointer [Last]  = $',Str_Po2S(List1.Last));
Writeln;
Writeln('Display items with "Items[n]"');
For Loop := 0 to List1.Count - 1 do
   Begin
   Writeln('Pointer [',Loop:3,'] = $',Str_Po2S(List1.Items[Loop]));
   End;
Writeln;
Writeln('Pointer [First] = $',Str_Po2S(List1.First));
Writeln('Pointer [Last]  = $',Str_Po2S(List1.Last));
Writeln;

Writeln('Index of Items[0] pointer [',Str_Po2S(List1.Items[0]),'] = ',List1.IndexOf(List1.Items[0]));
Writeln('Index of Items[1] pointer [',Str_Po2S(List1.Items[1]),'] = ',List1.IndexOf(List1.Items[1]));
Writeln('Index of Items[2] pointer [',Str_Po2S(List1.Items[2]),'] = ',List1.IndexOf(List1.Items[2]));
Writeln('Index of Items[3] pointer [',Str_Po2S(List1.Items[3]),'] = ',List1.IndexOf(List1.Items[3]));
Writeln;
Readkey; {=======================}

Writeln('-> Exchange Items[0] with Items[2]');
List1.Exchange(0,2);
For Loop := 0 to List1.Count - 1 do
   Begin
   Writeln('Pointer [',Loop:3,'] = $',Str_Po2S(List1.Items[Loop]));
   End;
Writeln;
Writeln('-> Exchange Items[1] with Items[0]');
List1.Exchange(1,0);
For Loop := 0 to List1.Count - 1 do
   Begin
   Writeln('Pointer [',Loop:3,'] = $',Str_Po2S(List1.Items[Loop]));
   End;
Writeln;
Readkey; {=======================}

Writeln('-> Delete Items[2]');
List1.Delete(2);
Writeln('-> Delete Items[0]');
List1.Delete(0);
For Loop := 0 to List1.Count - 1 do
   Begin
   Writeln('Pointer [',Loop:3,'] = $',Str_Po2S(List1.Items[Loop]));
   End;
Writeln;
Readkey; {=======================}

Writeln('-> Insert Items[0]');
List1.Insert(0, Pointer(@List1.Free));
For Loop := 0 to List1.Count - 1 do
   Begin
   Writeln('Pointer [',Loop:3,'] = $',Str_Po2S(List1.Items[Loop]));
   End;
Writeln;
Writeln('-> Insert Items[3]');
List1.Insert(3, Pointer(@List1.Create));
For Loop := 0 to List1.Count - 1 do
   Begin
   Writeln('Pointer [',Loop:3,'] = $',Str_Po2S(List1.Items[Loop]));
   End;
Writeln;
Readkey; {=======================}

Writeln('-> Move Items[2] to Items[3]');
List1.Move(2,3);
For Loop := 0 to List1.Count - 1 do
   Begin
   Writeln('Pointer [',Loop:3,'] = $',Str_Po2S(List1.Items[Loop]));
   End;
Writeln;
Readkey; {=======================}

{Writeln('-> Sort list');
Compare := Compare(List1.Items[0], List1.Items[1]);
List1.Sort(Compare);
For Loop := 0 to List1.Count - 1 do
   Begin
   Writeln('Pointer [',Loop:3,'] = $',Str_Po2S(List1.Items[Loop]));
   End;}

If Assigned(List1) Then List1.Free;
End;

{}
{}
{}

Procedure Test_TStrings;
Var Strings1         :TStrings;

Begin
MustExit := Yes;
Clrscr;
Writeln('Test TStrings');
Writeln;

Strings1 := NIL;
Strings1 := TStrings.Create;
Writeln('No test performed on TStrings');
Writeln('This class should not be instanciated !');

If Assigned(Strings1) Then Strings1.Free;
End;

{}
{}
{}

Procedure Test_TStringList;
Var StringList1      :TStringList;
    Loop             :Longint;

Begin
MustExit := Yes;
Clrscr;
Writeln('Test TStringList');
Writeln;

StringList1 := NIL;
StringList1 := TStringList.Create;
StringList1.Sorted := No;
Writeln('GetNamePath = ',StringList1.GetNamePath);

Writeln('Initial count = ',StringList1.Count);
Writeln('Initial capacity = ',StringList1.Capacity);
Writeln;

StringList1.Add('Frdric');
StringList1.Add('Cathy');
StringList1.Add('Xavier');
StringList1.Add('Olivier');
StringList1.Add('Marie');
StringList1.Add('Christophe');
StringList1.Add('Florianne');
Writeln('-> Added ',StringList1.Count,' strings to list');

For Loop := 0 to StringList1.Count - 1 do
   Begin
   Writeln('String [',Loop:3,'] = "',StringList1.Strings[Loop],'"');
   End;
Writeln;

Writeln('-> Sort list');
StringList1.Sort;
For Loop := 0 to StringList1.Count - 1 do
   Begin
   Writeln('String [',Loop:3,'] = "',StringList1.Strings[Loop],'"');
   End;
Writeln;
Readkey; {=======================}

Writeln('-> Exchange Items(0,3)');
StringList1.Exchange(0,3);
Writeln('-> Delete Items[4]');
StringList1.Delete(4);
For Loop := 0 to StringList1.Count - 1 do
   Begin
   Writeln('String [',Loop:3,'] = "',StringList1.Strings[Loop],'"');
   End;
Writeln;

Writeln('-> Get IndexOf("Cathy") = ',StringList1.IndexOf('Cathy'));
Writeln('-> Get IndexOf("Gloubiboulga") = ',StringList1.IndexOf('Gloubiboulga'));

Writeln('-> Insert("Guillemette" at Index[3])');
StringList1.Insert(3,'Guillemette');
For Loop := 0 to StringList1.Count - 1 do
   Begin
   Writeln('String [',Loop:3,'] = "',StringList1.Strings[Loop],'"');
   End;
Writeln;
Readkey; {=======================}

Writeln('-> Save list to file "Tcom.lis"');
StringList1.SaveToFile('Tcom.lis');
Writeln;
Readkey; {=======================}
Writeln('-> Load list from file "Tcom.pas"');
StringList1.LoadFromFile('Tcom.pas');
Writeln('Count = ',StringList1.Count);
Writeln('Capacity = ',StringList1.Capacity);

Writeln('New loaded list from file "Tcom.pas" will be now displayed...');
Writeln;
Readkey; {=======================}
For Loop := 0 to StringList1.Count - 1 do
   Begin
   Writeln('String [',Loop:3,'] = "',StringList1.Strings[Loop],'"');
   End;

If Assigned(StringList1) Then StringList1.Free;
End;

{}
{}
{}

Procedure Test_TListItems;
Var ListItems1       :TListItems;
//    Loop             :Longint;

Begin
MustExit := Yes;
Clrscr;
Writeln('Test TListItems');
Writeln;

ListItems1 := NIL;
//ListItems1 := TListItems.Create;

If Assigned(ListItems1) Then ListItems1.Free;
End;

{}
{}
{}

Procedure Test_TLogFile;
Var MyLog            :TLogFile;

Begin
MustExit := Yes;
Clrscr;
Writeln('Test TLogFile');
Writeln;

MyLog := NIL;
MyLog := TLogFile.Create('TCom.log');

With MyLog do
   Begin
   Level := 2;

   Writeln('System Log level = ',Level);
   Writeln;
   Writeln('Add common Log line in file "TCom.log"...');
   Add('Line with current level');
   Writeln('Try to add Log line in file "TCom.log" with level 2...');
   Add('Line with level 2',2);
   Writeln('Try to add Log line in file "TCom.log" with level 3...');
   Add('Line with level 3',3);
   Writeln;
   Writeln('Lines currently added in Log file = ',Count);
   End;

If Assigned(MyLog) Then MyLog.Free;
End;

{}
{}
{}

Procedure Test_TApplication;
Begin
MustExit := Yes;
Clrscr;
Writeln('Test TApplication (Main)');
Writeln;
With Application do
   Begin
   Writeln('Active       = ',Active);
   Case State of
      ASBoot  : Writeln('State        = ASBoot');
      ASRun   : Writeln('State        = ASRun');
      ASClose : Writeln('State        = ASClose');
      End;
   Case Mode of
      AMText    : Writeln('Mode         = AMText');
      AMGraphic : Writeln('Mode         = AMGraphic');
      End;
   Writeln('ExeName      = ',ExeName);
   Writeln('Title        = ',Title);
   Writeln;
   Writeln('Name         = ',Name);
   Writeln('Version      = ',Version);
   Writeln('Copyright    = ',Copyright);
   Writeln('Author       = ',Author);
   Writeln('Date         = ',Date);
   Writeln;
   Writeln('MOS Name     = ',MOSName);
   Writeln('MOS version  = ',MOSVersion);
   Case VersionType of
      VTDemo        : Writeln('Version type = VTDemo');
      VTDevelopment : Writeln('Version type = VTDevelopment');
      VTRegistered  : Writeln('Version type = VTRegistered');
      End;
   Writeln;
   Writeln('Press a key...');
   Readkey;

   Clrscr;
   Writeln('Test TApplication (Coordinates and Parent)');
   Writeln('X1 = ',X1);
   Writeln('Y1 = ',Y1);
   Writeln('X2 = ',X2,' (Not defined in text modes)');
   Writeln('Y2 = ',Y2,' (Not defined in text modes)');
   Writeln;
   Writeln('Parent = ',Str_Po2S(Parent),' (NIL)');
   End;
End;

{}
{}
{}

Procedure Test_TSystem;
Begin
MustExit := Yes;
Clrscr;
Writeln('Test TSystem');
Writeln;

With Sys do
   Begin
   Writeln('Directory     = ',Directory);
   Writeln('System found  = ',SystemFound);
   Writeln('Test system   = ',TestDefined);
   Writeln('System path   = ',FontMainSize);
   Writeln;
   Writeln('System path (Main)   = ',GetPath(SP_Main));
   Writeln('System path (Data)   = ',GetPath(SP_Datas));
   Writeln('System path (Cards)  = ',GetPath(SP_Cards));
   Writeln;
   Writeln('Cursor blink speed   = ',CursorBlinkSpeed);
   Writeln('Display hints        = ',DisplayHints);
   Writeln('Initial memory       = ',InitialMemory,' bytes');
   Writeln('Opened windows       = ',WinOpenCount);
   Writeln('Enable tasks manager = ',EnableTasksManager);
   Case FileTypeDetection of
      FDNone   : Writeln('File detection       = FDNone');
      FDHeader : Writeln('File detection       = FDHeader');
      FDSuffix : Writeln('File detection       = FDSuffix');
      End;
   Case RefreshMode of
      RMHideAlways : Writeln('Refresh mode         = RMHideAlways');
      RMHideOver   : Writeln('Refresh mode         = RMHideOver');
      RMShowAlways : Writeln('Refresh mode         = RMShowAlways');
      End;
   Writeln;

   Writeln('Main font file = ',FontMain);
   Writeln('Main font size = ',FontMainSize);
   End;
End;

{}
{}
{}

Procedure Test_TLocale;
Begin
MustExit := Yes;
Clrscr;
Writeln('Test TLocale');
Writeln;

With Locale do
   Begin
   Writeln('Defined languages = ',Count);
   Writeln;
   Writeln('Locale file "English"    (IdLan code : "ENG") = ',GetLocaleFile(LFEnglish));
   Writeln('Locale file "Franais"   (IdLan code : "FRA") = ',GetLocaleFile(LFFrancais));
   Writeln('Locale file "Espanol"    (IdLan code : "ESP") = ',GetLocaleFile(LFEspanol));
   Writeln('Locale file "Portuguese" (IdLan code : "POR") = ',GetLocaleFile(LFPortuguese));
   Writeln;
   Writeln('Error file "English"    (IdLan code : "ENG") = ',GetErrorFile(LFEnglish));
   Writeln('Error file "Franais"   (IdLan code : "FRA") = ',GetErrorFile(LFFrancais));
   Writeln('Error file "Espanol"    (IdLan code : "ESP") = ',GetErrorFile(LFEspanol));
   Writeln('Error file "Portuguese" (IdLan code : "POR") = ',GetErrorFile(LFPortuguese));
   Writeln;
   Writeln('Application locale file "English"    (IdLan code : "ENG") = ',GetAppLocaleFile(LFEnglish));
   Writeln('Application locale file "Franais"   (IdLan code : "FRA") = ',GetAppLocaleFile(LFFrancais));
   Writeln('Application locale file "Espanol"    (IdLan code : "ESP") = ',GetAppLocaleFile(LFEspanol));
   Writeln('Application locale file "Portuguese" (IdLan code : "POR") = ',GetAppLocaleFile(LFPortuguese));
   End;
End;

{}
{}
{}

Procedure Test_TLanguage;
Begin
MustExit := Yes;
Clrscr;
Writeln('Test TLanguage');
Writeln;

With Language do
   Begin
   Writeln('Current language after booting :');
   Writeln('Language code    = ',Code);
   Writeln('Language file    = ',Filename);
   Writeln('Language loaded  = ',Loaded);
   Writeln('Defined captions = ',Count);
   Writeln('Lines from file  = ',FileLines);
   Writeln('Free Id labels   = ',CountFree);
   Writeln;

   Writeln('Loading language from file...');
   LoadLanguage;
   Writeln('Language code    = ',Code);
   Writeln('Language file    = ',Filename);
   Writeln('Language loaded  = ',Loaded);
   Writeln('Defined captions = ',Count);
   Writeln('Lines from file  = ',FileLines);
   Writeln('Free Id labels   = ',CountFree);
   Writeln;

   Writeln('Removing language from memory...');
   RemoveLanguage;
   Writeln('Language code    = ',Code);
   Writeln('Language file    = ',Filename);
   Writeln('Language loaded  = ',Loaded);
   Writeln('Defined captions = ',Count);
   Writeln('Lines from file  = ',FileLines);
   Writeln('Free Id labels   = ',CountFree);
   Writeln;
   Wait;
   Clrscr;

   Writeln('Set language to "ESP"');
   SetLanguage('ESP');
   Writeln('Language code    = ',Code);
   Writeln('Language file    = ',Filename);
   Writeln('Language loaded  = ',Loaded);
   Writeln('Defined captions = ',Count);
   Writeln('Lines from file  = ',FileLines);
   Writeln('Free Id labels   = ',CountFree);
   Writeln;

   Writeln('Caption [0001] = "',Loc(0001),'"');
   Writeln('Caption [0135] = "',Loc(0135),'"');
   Writeln('Caption [1000] = "',Loc(1000),'"');
   Writeln('Caption [1032] = "',Loc(1032),'"');

   Writeln;
   Writeln('-> SetLoc(1032,"Borrador")');
   SetLoc(1032,'Borrador');
   Writeln('Caption [1032] = "',Loc(1032),'"');
   Writeln;

   Writeln('Free first line  = ',GetFreeLoc);
   Writeln('-> AddLoc("First line test")');
   AddLoc('First line test');
   Writeln('Caption [0000] = "',Loc(0000),'"');
   Writeln('Free first line  = ',GetFreeLoc);
   Writeln('-> AddLoc("Must be in line 271")');
   AddLoc('Must be in line 271');
   Writeln('Caption [0271] = "',Loc(0271),'"');
   Writeln;
   Writeln('Free Id labels   = ',CountFree);
   Writeln;

   Writeln('-> SaveToFile "Tcom.esp")');
   SaveToFile('Tcom.esp');
   End;
End;

{}
{}
{}

Procedure Test_Parents;
Var Control1, Control2:TControl;
    Point             :TPoint;
    Coord             :TCoordinates;

Begin
MustExit := Yes;
Clrscr;
Writeln('Test Parents components (Main)');
Writeln;

Writeln('Application:');
Writeln('    Parents count   = ',Application.ParentsCount);
Writeln('    Parents defined = ',Application.TestParents);

Writeln;
Writeln('-> Creating Control1 with "Application" as parent...');
Control1 := NIL;
Control1 := TControl.Create(NIL, 100,100,600,300);
Control1.Parent := Application;

Writeln('-> Creating Control2 with "Control1" as parent...');
Control2 := NIL;
Control2 := TControl.Create(NIL, 050,020,100,070);
Control2.Parent := Control1;
Writeln;

Writeln('Control1:');
Writeln('    Parents count   = ',Control1.ParentsCount);
Writeln('    Parents defined = ',Control1.TestParents);
Writeln;
Writeln('Control2:');
Writeln('    Parents count   = ',Control2.ParentsCount);
Writeln('    Parents defined = ',Control2.TestParents);
Writeln;
Write('Press a key...');
Readkey;

Clrscr;
Writeln('Test Parents components (Modifications)');
Writeln;
Writeln('-> Set "Control2" parent to NIL');
Control2.Parent := NIL;
Writeln('Control2:');
Writeln('    Parents count   = ',Control2.ParentsCount);
Writeln('    Parents defined = ',Control2.TestParents);
Writeln;

Writeln('-> Set "Control2" parent to "Application"');
Control2.Parent := Application;
Writeln('Control2:');
Writeln('    Parents count   = ',Control2.ParentsCount);
Writeln('    Parents defined = ',Control2.TestParents);
Writeln;

Writeln('-> Set "Control2" parent to "Control1"');
Writeln('-> Set "Control1" parent to NIL');
Control1.Parent := NIL;
Control2.Parent := Control1;
{Writeln('Control1 test Parent = ',Control1.TestParent);
Writeln('Control2 test Parent = ',Control2.TestParent);
Writeln;}
Writeln('Control1:');
Writeln('    Parents count   = ',Control1.ParentsCount);
Writeln('    Parents defined = ',Control1.TestParents);
Writeln('Control2:');
Writeln('    Parents count   = ',Control2.ParentsCount,'     (Just 1 parent found till "Control1")');
Writeln('    Parents defined = ',Control2.TestParents,' (Link broken at "Control1")');
Writeln('-> Restore "Control1" parent to "Application" now');
Control1.Parent := Application;
Writeln;
Write('Press a key...');
Readkey;

Clrscr;
Writeln('Test Parents components (Coordinates)');
Writeln;

Application.X2 := 800;                  {*Set manualy because not in graphic mode*}
Application.Y2 := 600;
With Application do
   Writeln('Application position  = ',X1:3,',',Y1:3,',',X2:3,',',Y2:3,' - ','(Width:',Width:3,' Height:',Height:3,')');
With Control1 do
   Writeln('Control1 position     = ',X1:3,',',Y1:3,',',X2:3,',',Y2:3,' - ','(Width:',Width:3,' Height:',Height:3,')');
With Control2 do
   Writeln('Control2 position     = ',X1:3,',',Y1:3,',',X2:3,',',Y2:3,' - ','(Width:',Width:3,' Height:',Height:3,')');
Writeln;

With Control1 do
   Begin
   Point := GetScreenPoint;
   Coord := GetScreenRect;
   Writeln('Control1 Screen point = ',Point.X:3,',',Point.Y:3);
   Writeln('Control1 Screen pos   = ',Coord.X1:3,',',Coord.Y1:3,',',Coord.X2:3,',',Coord.Y2:3,' - ','(Width:',Width:3,' Height:',Height:3,')');
   End;
With Control2 do
   Begin
   Point := GetScreenPoint;
   Coord := GetScreenRect;
   Writeln('Control2 Screen point = ',Point.X:3,',',Point.Y:3);
   Writeln('Control2 Screen pos   = ',Coord.X1:3,',',Coord.Y1:3,',',Coord.X2:3,',',Coord.Y2:3,' - ','(Width:',Width:3,' Height:',Height:3,')');
   End;
Writeln;

Writeln('-> Move Control2 to (060,030)');
Control2.MoveTo(60,30);
With Control1 do
   Begin
   Point := GetScreenPoint;
   Coord := GetScreenRect;
   Writeln('Control1 Screen point = ',Point.X:3,',',Point.Y:3);
   Writeln('Control1 Screen pos   = ',Coord.X1:3,',',Coord.Y1:3,',',Coord.X2:3,',',Coord.Y2:3,' - ','(Width:',Width:3,' Height:',Height:3,')');
   End;
With Control2 do
   Begin
   Point := GetScreenPoint;
   Coord := GetScreenRect;
   Writeln('Control2 Screen point = ',Point.X:3,',',Point.Y:3);
   Writeln('Control2 Screen pos   = ',Coord.X1:3,',',Coord.Y1:3,',',Coord.X2:3,',',Coord.Y2:3,' - ','(Width:',Width:3,' Height:',Height:3,')');
   End;
Writeln;

Writeln('-> Move Control1 to (200,150)');
Control1.MoveTo(200,150);
With Control1 do
   Begin
   Point := GetScreenPoint;
   Coord := GetScreenRect;
   Writeln('Control1 Screen point = ',Point.X:3,',',Point.Y:3);
   Writeln('Control1 Screen pos   = ',Coord.X1:3,',',Coord.Y1:3,',',Coord.X2:3,',',Coord.Y2:3,' - ','(Width:',Width:3,' Height:',Height:3,')');
   End;
With Control2 do
   Begin
   Point := GetScreenPoint;
   Coord := GetScreenRect;
   Writeln('Control2 Screen point = ',Point.X:3,',',Point.Y:3);
   Writeln('Control2 Screen pos   = ',Coord.X1:3,',',Coord.Y1:3,',',Coord.X2:3,',',Coord.Y2:3,' - ','(Width:',Width:3,' Height:',Height:3,')');
   End;
Writeln;

Coord := Control2.GetParentRect;
Writeln('Control2 Parent coord = ',Coord.X1:3,',',Coord.Y1:3,',',Coord.X2:3,',',Coord.Y2:3);

If Assigned(Control2) Then Control2.Free;
If Assigned(Control1) Then Control1.Free;
End;

{}
{}
{}

Procedure Test_Controls;
Var Control1          :TControl;
    Control2          :TControl;
    Control3          :TControl;
    Panel1            :TPanel;
    Panel2            :TPanel;

Begin
MustExit := Yes;
Clrscr;
Writeln('Test child Controls components (Main)');
Writeln;

Writeln('Application:');
Writeln('    Controls count      = ',Application.ControlCount);
Writeln('    Child control count = ',Application.ChildControlCount);

Writeln('-> Creating Panel1   with "Application" as parent...');
Panel1 := NIL;
Panel1 := TPanel.Create(NIL);
Panel1.Parent := Application;
Writeln('-> Creating Control1 with "Application" as parent...');
Control1 := NIL;
Control1 := TControl.Create(NIL);
Control1.Parent := Application;
Writeln('-> Creating Panel2   with "Panel1" as parent...');
Panel2 := NIL;
Panel2 := TPanel.Create(NIL);
Panel2.Parent := Panel1;
Writeln('-> Creating Control2 with "Panel1" as parent...');
Control2 := NIL;
Control2 := TControl.Create(NIL);
Control2.Parent := Panel1;
Writeln('-> Creating Control3 with "Panel2" as parent...');
Control3 := NIL;
Control3 := TControl.Create(NIL);
Control3.Parent := Panel2;

Writeln;
Writeln('Application:');
Writeln('    Controls count      = ',Application.ControlCount);
Writeln('    Child control count = ',Application.ChildControlCount);

{If Assigned(Control3) Then Control3.Free;
If Assigned(Panel2)   Then Panel2.Free;
If Assigned(Control2) Then Control2.Free;
If Assigned(Panel1)   Then Panel1.Free;
If Assigned(Control1) Then Control1.Free;}
End;

{}
{}
{}

Procedure Test_Focus;
Begin
MustExit := Yes;
Clrscr;
Writeln('Test Focus management');
Writeln;
End;

{}

Procedure DrawPage(pPage:Integer);
Begin
TextBackGround(LightGray);
Gotoxy(28,2); Write(Str_Spaces(52));

TextBackGround(Black);
Window(1,6,80,23);
ClrScr;                                 {*Clear zone*}
Window(1,1,80,25);

Gotoxy(9,2);
For Loop:=1 to MaxPages do
   Begin
   If pPage = Loop Then
      Begin
      TextBackGround(Green);
      TextColor(White);
      End
   Else
      Begin
      TextBackGround(Black);
      TextColor(LightGray);
      End;
   Write(Loop);
   End;

TextBackGround(Black);                  {*Restore colors*}
TextColor(LightGray);
Write(' Arrow <- ->');
TextColor(White);

Writeln;
Writeln;
Writeln('      Test Name          Kernel      State');

Case pPage of
   1: Begin
      Gotoxy(28,2);
      TextBackGround(LightGray);
      TextColor(Black);
      Writeln('Base components management');
      TextBackGround(Black);
      TextColor(White);
      Gotoxy(1,6);
      Writeln(' 01 - Test TMessage      MOS');
      Writeln(' 02 - Test TControl      MOS         Miss some methods');
      Writeln(' 03 - Test TMouseZone    MOS');
      End;

   2: Begin
      Gotoxy(28,2);
      TextBackGround(LightGray);
      TextColor(Black);
      Writeln('Lists management');
      TextBackGround(Black);
      TextColor(White);
      Gotoxy(1,6);
      Writeln(' 01 - Test TList         FPC         No bugs');
      Writeln(' 02 - Test TStrings      FPC         No bugs');
      Writeln(' 03 - Test TStringList   FPC         No bugs');
      Writeln(' 04 - Test TListItems    MOS/D5');
      End;

   3: Begin
      Gotoxy(28,2);
      TextBackGround(LightGray);
      TextColor(Black);
      Writeln('MOS System management');
      TextBackGround(Black);
      TextColor(White);
      Gotoxy(1,6);
      Writeln(' 01 - Test TApplication  MOS/D5');
      Writeln(' 02 - Test TLogFile      MOS');
      Writeln(' 03 - Test TSystem       MOS');
      Writeln(' 04 - Test TLocaleList   MOS/FPC');
      Writeln(' 05 - Test TLanguage     MOS');
      Writeln;
      Writeln(' 06 - Test Parents       MOS');
      Writeln(' 07 - Test Controls      MOS');
      Writeln(' 08 - Test Focus         MOS');
      End;
   End;

Gotoxy(22,24);
End;

{}
{}
{}

Begin
TApplication.Initialize;                {*Initialise all for application*}
Application.Mode := AMText;             {*Text application*}
Application.Run;                        {*Run application*}

Page     := 1;
MaxPages := 5;
MustExit := No;

ClrScr;
TextBackGround(Green);
TextColor(White);
Gotoxy(01,1); Write(Str_Spaces(80));
Gotoxy(19,1); Writeln('MOS Non visual classes test program v1.20');

TextBackGround(LightGray);
Gotoxy(1,2); Write(Str_Spaces(80));

Gotoxy(1,2);
TextColor(Black);
Write('Pages : ');

TextBackGround(Black);                  {*Restore colors*}
TextColor(White);
Gotoxy(1,24);
Write('Select your choice : ');

DrawPage(Page);                         {*Draw first selection page*}

Repeat
   If (Kbd_GetKeyDown(VK_LEFT)) And (Page > 1) Then
      Begin
      Dec(Page);
      Modified := Yes;
      End;
   If (Kbd_GetKeyDown(VK_RIGHT)) And (Page < MaxPages) Then
      Begin
      Inc(Page);
      Modified := Yes;
      End;
   If Kbd_GetKeyDown(VK_ESCAPE) Then MustExit := Yes;

   If Modified Then
      Begin
      DrawPage(Page);
      Modified := No;
      End;

   Case Page of
      01 : Begin
           If Kbd_GetKeyDown(VK_NUMPAD0) Then Test_TMessage;
           If Kbd_GetKeyDown(VK_NUMPAD1) Then Test_TControl;
           If Kbd_GetKeyDown(VK_NUMPAD2) Then Test_TMouseZone;
           End;
      02 : Begin
           If Kbd_GetKeyDown(VK_NUMPAD0) Then Test_TList;
           If Kbd_GetKeyDown(VK_NUMPAD1) Then Test_TStrings;
           If Kbd_GetKeyDown(VK_NUMPAD2) Then Test_TStringList;
           If Kbd_GetKeyDown(VK_NUMPAD3) Then Test_TListItems;
           End;
      03 : Begin
           If Kbd_GetKeyDown(VK_NUMPAD0) Then Test_TApplication;
           If Kbd_GetKeyDown(VK_NUMPAD1) Then Test_TLogFile;
           If Kbd_GetKeyDown(VK_NUMPAD2) Then Test_TSystem;
           If Kbd_GetKeyDown(VK_NUMPAD3) Then Test_TLocale;
           If Kbd_GetKeyDown(VK_NUMPAD4) Then Test_TLanguage;
           If Kbd_GetKeyDown(VK_NUMPAD5) Then Test_Parents;
           If Kbd_GetKeyDown(VK_NUMPAD6) Then Test_Controls;
           If Kbd_GetKeyDown(VK_NUMPAD7) Then Test_Focus;
           End;
{           If Kbd_TestKey(57,73) Then Test_TLogFile;}
      End;
Until MustExit;

Application.Close;                      {*Restore all for application*}
End.
