{ͻ
                                UNIT MosBase                                
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 06.11.1993                                                   
  COUNTRY....: Montpellier - IUT (FRANCE)                                   
  DESCRIPTION: Base and MOS initialisations. Loader.                        
  AUTONOMOUS.: Partial                                                      
  UNIT SIZE..: 1.587 Lines and (33.440 Bytes compiled)                      
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosBase;

{$mode objfpc}{$H+}

INTERFACE

Uses
      MosConfig,
      MosControls;

{****************************************************************************}

Type

TApplicationStates = (                  {*Application running states*}
   ASBoot,
   ASRun,
   ASClose);

TApplicationModes = (                   {*Application modes*}
   AMText,
   AMGraphic);

TVersionType = (                        {*Version types definition*}
   VTDemo,
   VTFreeware,
   VTDevelopment,
   VTRegistered);

{****************************************************************************}
{*** TApplication Class                                                   ***}
{****************************************************************************}

TApplication = Class(TControl)          {*TApplication class*}
   Private
      fActive           :Boolean;       {*Application is active or no*}
      fState            :TApplicationStates; {*Application states*}
      fMode             :TApplicationModes;  {*Application modes*}
      fExeName          :String;        {*Application path and name*}
      fTitle            :String;        {*Displayed title when reduced*}

      fMOSName          :String;        {*Define the MOS name*}
      fMOSVersion       :String;        {*Define the MOS version*}
      fVersionType      :TVersionType;  {*Version type*}

      fName             :String;        {*Application name*}
      fVersion          :ShortString;   {*Application version*}
      fCopyright        :String;        {*Application copyright*}
      fAuthor           :String;        {*Application author*}
      fDate             :String;        {*Application creation date and time*}
//      fMainForm         :TForm;         {*Main application form*}

   Protected
      Procedure SetState(S:TApplicationStates); Virtual; {*Set application state*}
      Procedure SetMode(M:TApplicationModes); Virtual;   {*Set application mode*}
      Procedure SetTitle(T:String); Virtual;   {*Set application title*}
      Function  GetActive:Boolean;             {*Application is active or no*}
      Function  GetTypeCaption:String;         {*Version type caption*}

   Public
      Property Active     :Boolean            Read GetActive;
      Property ExeName    :String             Read fExeName;
      Property State      :TApplicationStates Read fState     Write SetState;
      Property Mode       :TApplicationModes  Read fMode      Write SetMode;
      Property Title      :String             Read fTitle     Write SetTitle;

      Property MOSName    :String             Read fMOSName;
      Property MOSVersion :String             Read fMOSVersion;
      Property TypeCaption:String             Read GetTypeCaption;
      Property VersionType:TVersionType       Read fVersionType;

      Property Name       :String             Read fName      Write fName;
      Property Version    :ShortString        Read fVersion   Write fVersion;
      Property Copyright  :String             Read fCopyright Write fCopyright;
      Property Author     :String             Read fAuthor    Write fAuthor;
      Property Date       :String             Read fDate      Write fDate;

      Constructor Create;               {*Create a TApplication object*}
      Class Procedure Initialize;       {*Initialize base application*}
      Procedure   Run;                  {*Initialize all and run aplication*}
      Procedure   Close;                {*Close application*}
      Procedure   SetInformation(pName,pVersion,pCopyright,pAuthor,pDate:String); {*Define application information*}
      Function    TestRegistered:Boolean;
      Function    ManageRegistered:Boolean;
   End;

{****************************************************************************}

TFileInfo=Record                        {*File information structure*}
   Path                 :String;        {*Pathname*}
   Name                 :String;        {*Filename*}
   DosName              :ShortString;   {*DOS filename (8+3)*}
   CompiledBy           :String;        {*Program compiled by*}
   CompilerVersion      :String;        {*Compiled version*}
   CompilerTargetCpu    :String;        {*Compiler target CPU*}
   CompilationDate      :String;        {*Compilation date*}
   CompilationTime      :String;        {*Compilation time*}
   CreatedBy            :String;        {*Program created by*}
   IconFile             :String;        {*File icon*}
   FileDescription      :String;        {*File type description (string)*}
   FileType             :Integer;       {*File type value (categories)*}
   FileTypeString       :String;        {*File type string (categories)*}
   Size                 :String;        {*Visible size*}
   RealSize             :String;        {*True size using clusters*}
   Created              :String;        {*Date and time for the creation*}
   Modified             :String;        {*Date and time for the last modification*}
   Used                 :String;        {*Date and time for the last access*}
   AttrArchive          :Boolean;       {*File attributes*}
   AttrReadOnly         :Boolean;
   AttrHidden           :Boolean;
   AttrSystem           :Boolean;
   AttrDirectory        :Boolean;
   End;

Var BCmd:Boolean;       {False = Parameter, True = Str_Parameter  }
    SCmd:String;        {If BCmd then contain comand line parameter}

    Locale           :TLocale;                {*Manage locale list*}
    Language         :TLanguage;              {*Manage current language*}
    Application      :TApplication;           {*Application object*}
    User             :TUser;                  {*Owner of MOS*}
    Log              :TLogFile;               {*Manage log file*}
    Sys              :TSystem;                {*MOS System*}

{|Fonts management|}
Procedure Font_Set(Name:String;Size:Byte);    {*Define a new font*}
Procedure Font_SetMain;                       {*Set the main font*}
Procedure Font_SetPrevious;                   {*Set the previous font*}
Procedure Font_SetUser(Name:String;Size:Byte);{*Define a user font*}
Procedure Font_SetSpecial(NFont:Word); {MIC}{*Define a special font*}
Procedure Font_SetDirection(Dir:Byte); {*Define a write direction using fonts*}

{|File informations|}
Function  Get_FileInfoLine(FName:String; Methode:Byte):String;    {*Get file informations*}
Function  Get_FileDescription(FName:String; Methode:Byte):String; {*Get file description*}
Function  Get_FileType(FName:String; Methode:Byte):Integer;       {*Get file type*}
Function  Get_FileTypeString(FName:String; Methode:Byte):String;  {*Get file type string*}
Function  Get_FileIcon(FName:String; Methode:Byte):String;        {*Get file icon*}
Function  Get_FileInformation(FName:String; Var Inf:TFileInfo):Boolean; {*Get informations about a file*}

{|Process|}
Function  Process_Init:Boolean;               {*Initialise process information*}
Procedure Process_Done;                       {*Clear disk process information*}
Function  Process_GetFileName(PId:Word):String;{*Return the process filename*}
Function  Process_GetInfo(Var P:TProcess):Boolean; {*Fill the process structure*}
Function  Process_UpdateInfo(P:TProcess):Boolean;{*Update process file information*}

{|Miscellaneous|}
Function  ParameterMOS(Var St:String):Byte;   {*Get MOS command line parameter*}
Procedure Play_SoundAction(Num:Byte);         {*Play the sound of the action*}
Function  Check_RangesValue(Var Value:Longint; Min,Max:Longint):Boolean; {*Check the range value (Longint)*}
Procedure Show_Screen;                  {*Display the screen background*}

{|Initialisations|}
Procedure Init_Graph;                   {*Graphic init*}
Procedure Init_Display;                 {*Display Bg and init some Gfx*}
Procedure Init_TestConfig;              {*Test Hardware and Software configuration*}
Procedure Init_Password;                {*Password pour Connection*}
Procedure Init_VarGraph;                {*Initialise all for the graphic*}
Procedure Init_CheckSystem;             {*Create Sub-System directories*}
Procedure Init_InstallApp;              {*Check first installation*}
Procedure Init_Process;                 {*Initialise le processus courrant*}
Procedure Init_Statistics;              {*Add statistics into system*}
Procedure Init_Locale;                  {*Load locale language in memory*}
Procedure Init_Sound;                   {*Init sound and play if needs*}
Procedure Init_BootGfx;                 {*Display boot image*}
Procedure Init_BootApp;                 {*Lauch boot applications*}
Procedure Init_Register;                {*Requeter Register*}
Procedure Init_Keyboard;                {*Initialise keyboard*}
Procedure Init_CmdCommand;              {*Read a command line in text file*}
Procedure Init_CmdDebug;                {*Get debug informations *}
Procedure Init_CmdHome;                 {*Set program directory as default*}
Procedure Init_CmdLoadTheme;            {*Load main theme file*}
Procedure Init_CmdLoadIni;              {*Manage initialisation file*}
Procedure Init_CmdSetWd;                {*Set Working Directory*}
Procedure Init_SearchWd;                {*Search WD in environment variables*}
Procedure Init_CmdLoc;                  {*Set new locale language*}
Procedure Init_CmdBmp;                  {*Specify background image*}
Procedure Init_CmdMsgUser;              {*Display user message*}
Procedure Init_CmdHiddenPart;           {*Set MOS hidden part mode*}
Procedure Init_CmdNoSound;              {*Don't initialise sounds*}
Procedure Init_CmdGfxMode;              {*Set graphic mode to 'X'*}
Procedure Init_CmdErrorDemo;            {*Test for errors in demo commands*}
Procedure Init_CmdRecordDemo;           {*Start to record MOS demo*}
Procedure Init_CmdPlayDemo;             {*Start to play MOS demo*}
Procedure Init_CmdSave;                 {*Test Save command*}
Procedure Init_CmdQuit;                 {*Test Quit command*}
Procedure Init_CmdHelp;                 {*Help displaying*}

{|Restorations|}
Procedure Done_Sound;                   {*Play end sound and Stop Buzzer*}
Procedure Done_Process;                 {*Clear disk process information*}
Procedure Done_Locale;                  {*Remove locale file from memory*}
Procedure Done_SystemDrawer;            {*Vire le Drawer temporaire*}
Procedure Done_Message;                 {*Ending message*}
Procedure Done_Graph;                   {*Ferme Mode Graphique*}
Procedure Done_Demo;                    {*Close current demo*}
Procedure Done_Keyboard;                {*Restore keyboard options*}
Procedure Done_Objects;                 {*Free memory allocated by objects*}

IMPLEMENTATION

Uses
      Dos,
      Classes,
      IniFiles,
      GraphiX,
      MosColors,
      MosCPUInstructions,
      MosCrt,
      MosDebug,
      MosDialogs,
      MosDisks,
      MosErrors,
      MosFiles,
      MosFilesTree,
      MosGraph,
      MosImages,
      MosKeyboard,
      MosMouse,
      MosRequests,
      MosSound,
      MosStrings,
      MosText,
      MosTime,
      MosTools;

{*---------------------------- Initialisations -----------------------------*}

{ͻ
                           PROCEDURE Done_Message                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Display a register message on exit of MOS if the MOS version     
           is a demo version or a non registered version.                   
 ͼ}

Procedure Done_Message;
Var St:String;
Begin
If Application.TestRegistered Then Exit;{*Version Registered*}
Log.Add('Display register message');
Clrscr;
TextBackground(Red); TextColor(White);
St := 'Master Operating System ' + Application.MOSVersion;
Gotoxy(1,1); Write(Str_Spaces(80));
Gotoxy(40-Length(St) Div 2,1); Write(St);
TextBackground(Black); TextColor(LightGray);
Writeln;
Delay(3000);                            {*Waiting for Christmas... He He !!*}
End;

{ͻ
                         PROCEDURE Play_SoundAction                         
 ͹
  IN.....: Num (BYTE) = Number of the sound to play.                        
  OUT....: /                                                                
  EXPLAIN: Play a sound corresponding to an action.                         
 ͼ}

Procedure Play_SoundAction(Num:Byte);
Var FName:String;                         {*File Name for Sound Play*}
Begin
FName:=Sys.GetPath(SP_SOUNDS)+Sys.SoundFile[Num];
Play_WAV(FName);                          {*Play Sound...*}
End;

{ͻ
                         FUNCTION Check_RangesValue                         
 ͹
  IN.....: Value (LONGINT) = The value to check.                            
           Min,Max (LONGINT) = The range.                                   
  OUT....: (BOOLEAN) = TRUE : Value is in range.                            
  EXPLAIN: Check if a value is in the defined range (Longint).              
 ͼ}

Function Check_RangesValue(Var Value:Longint; Min,Max:Longint):Boolean;
Var Ok:Boolean;
Begin
Ok:=Yes;
If Value<Min Then Begin Value:=Min; Ok:=No; End;
If Value>Max Then Begin Value:=Max; OK:=No; End;
Check_RangesValue:=Ok;
End;

{*------------------------------- FONTS ------------------------------------*}

{ͻ
                         PROCEDURE Font_SetSpecial                          
 ͹
  IN.....: NFont (WORD) = N of the font to set                             
                          0 = litt.chr                                      
                          1 = tscr.chr                                      
  OUT....: /                                                                
  EXPLAIN: Set one of this 2 fonts.                                         
 ͼ}

Procedure Font_SetSpecial(NFont:Word);           {*Rajuste Taille Fonte*}
Var St:Char;
Begin
St:='X';
If NFont=0 Then Begin                       {*Fonte de Gnrale*}
   VESA_SetTextStyle(Sys.GetPath(SP_FONTS)+Sys.FontMain,0,Sys.FontMainSize);  {*Dfinit Fonte Gnrale*}
   HaF:=VESA_TextHeight+1;                  {*Def Hauteur de la Fonte*}
   LaF:=VESA_TextWidth(St)-1;               {*Def Largeur de la Fonte*}
   Syb:=HaF+4;                              {*Size Y Standard des Buttons*}
   End;
If NFont=1 Then Begin                       {*Fonte Titre Windows*}
   VESA_SetTextStyle(Sys.GetPath(SP_FONTS)+Sys.FontWinTitle,0,Sys.FontWinTitleSize); {*Dfinit Fonte Title Window*}
   HaF1:=VESA_TextHeight+1;
   LaF1:=VESA_TextWidth(St)-1;
   End;
End;

{ͻ
                        PROCEDURE Font_SetDirection                         
 ͹
  IN.....: Dir (BYTE) = Font direction.                                     
              0 = Horizontal, 1 = Vertical.                                 
  OUT....: /                                                                
  EXPLAIN: Set a font direction for write functions.                        
  SEEALSO: Font_Set, Set_CurrentFont                                        
 ͼ}

Procedure Font_SetDirection(Dir:Byte); {*Dfinit une nouvelle direction d'criture*}
Begin
If Dir>1 Then Dir:=1;                  {*Paramtre Naze => Vertical de Base*}
Sys.FontDirection:=Dir;
Font_Set(Sys.FontCurrent,Sys.FontCurrentSize);

{Remplacer le code au dessus par : VESA_SetTextStyle(Name,Sys.FontDirection,Size);}  {*Style et Taille Fonte*}
End;

{ͻ
                           PROCEDURE Font_SetUser                           
 ͹
  IN.....: Name (STRING) = Font name (Path + filename).                     
           Size (BYTE) = Font size (usualy beetween 1 and 4).               
  OUT....: /                                                                
  EXPLAIN: Set a user font (available fonts are in the SYSTEM\FONT drawer). 
  NB.....: This procedure is a sub routine of the Font_Set procedure.       
  SEEALSO: Font_Set, Set_CurrentFont                                        
 ͼ}

Procedure Font_SetUser(Name:String;Size:Byte);{*Dfinit une Fonte User*}
Var St:Char;
Begin
VESA_SetTextStyle(Name,Sys.FontDirection,Size);  {*Style et Taille Fonte*}

St:='X';                               {*Rajuste LaF et HaF pour Fonte Gnrale*}
HaF:=VESA_TextHeight+1;                {*Def Hauteur de la Fonte*}
LaF:=VESA_TextWidth(St)-1;             {*Def Largeur de la Fonte*}
End;

{ͻ
                             PROCEDURE Font_Set                             
 ͹
  IN.....: Name (STRING) = Font name (do not specify the path.filename only)
           Size (BYTE) = Font size (usualy beetween 1 and 4).               
  OUT....: /                                                                
  EXPLAIN: Set a user font (available fonts are in the SYSTEM\FONT drawer). 
  SEEALSO: Set_CurrentFont, Font_SetPrevious                                
 ͼ}

Procedure Font_Set(Name:String;Size:Byte); {*Dfinit une nouvelle Fonte*}
Begin
Sys.FontPrevious:=Sys.FontCurrent;                  {*Set Previous Font*}
Sys.FontPreviousSize:=Sys.FontCurrentSize;

If (Sys.FontCurrent=Name) And (Sys.FontCurrentSize=Size) And (Sys.FontPreviousDirection=Sys.FontDirection) Then Exit;
Sys.FontPreviousDirection:=Sys.FontDirection;

Sys.FontCurrent:=Name;                       {*Set Current Font*}
Sys.FontCurrentSize:=Size;

Font_SetUser(Sys.GetPath(SP_FONTS)+Name, Size);{*Dfinit une Fonte User*}
End;

{ͻ
                           PROCEDURE Font_SetMain                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Restore the main font type, size and direction.                  
  SEEALSO: Font_Set, Font_SetPrevious                                       
 ͼ}

Procedure Font_SetMain;                {*Passe en fonte courrante*}
Begin
Font_SetUser(Sys.FontMain, Sys.FontMainSize);
End;

{ͻ
                         PROCEDURE Font_SetPrevious                         
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Restore the font type and size defined previously.               
  SEEALSO: Font_Set, Font_SetMain                                           
 ͼ}

Procedure Font_SetPrevious;            {*Passe en fonte Prcdente*}
Begin
Font_SetUser(Sys.FontPrevious, Sys.FontPreviousSize);

Font_SetDirection(Sys.FontPreviousDirection);
End;

{*--------------------------- FILES INFORMATIONS ---------------------------*}

{ͻ
                         FUNCTION Get_FileInfoLine                          
 ͹
  IN.....: FName (STRING) = Filename of the data file.                      
           Methode (BYTE) = Used method to do detection.                    
               M_Extention = 1 : Detection by file suffix (Win95 Method).   
               M_Header    = 2 : Detection by file header (MOS Pro Method). 
  OUT....: (STRING) = Line for file identification.                         
  EXPLAIN: Return the Line for file indentification in the SYSTEM.FTM file. 
  SEEALSO: Get_FileDescription, Get_FileIcon                                
 ͼ}

Function Get_FileInfoLine(FName:String; Methode:Byte):String;
Var F:Text;
    SM,St:String;
    Path:DirStr;
    Name:NameStr;
    Extention:ExtStr;

Begin
Get_FileInfoLine:='';

If Methode=M_Extention Then SM:='[EXTENTION]';
If Methode=M_Header    Then SM:='[HEADER]';

Assign(F,Sys.GetPath(SP_DATAS)+'SYSTEM.FTM');
{gotoxy(1,1); writeln(Sys.GetPath(SP_DATAS)+'SYSTEM.FTM');}
{$I-}
Reset(F);                               {*Open Datas*}
{$I+}
If IOResult=0 Then                      {*Pas d'Erreurs*}
   Begin
   Readln(F,St);
   If Upper(St)<>'MOS FILE TYPE MANAGER' Then Exit;
      Repeat
      Readln(F,St);
      Until (Upper(St)=SM) Or (Eof(F)); {*Se Positionne au bon Endroit*}
   If Eof(F) Then Exit;

   FSplit(FName, Path,Name,Extention);  {*Get Extention from File*}
   Extention:=Upper(Copy(Extention,2,255)); {*Enlve le '.' de l'Extention*}
      Repeat
      Readln(F,St);
      If Str_Get(St,1,';')=Extention Then
         Begin
         Get_FileInfoLine:=St; Close(F); Exit;
         End;
      Until (Upper(St)=Extention) Or (Eof(F));{*Se Positionne au bon Endroit*}
   Close(F);
   End;                                 {*Fin de la Lecture du Fichier*}
End;

{ͻ
                        FUNCTION Get_FileDescription                        
 ͹
  IN.....: FName (STRING) = Filename.                                       
           Methode (BYTE) = Used method to do detection.                    
               M_Extention = 1 : Detection by file suffix (Win95 Method).   
               M_Header    = 2 : Detection by file header (MOS Pro Method). 
  OUT....: (STRING) = File identification.                                  
  EXPLAIN: Identify the file and return the identification string.          
  SEEALSO: Get_FileInfoLine, Get_FileIcon                                   
 ͼ}

Function Get_FileDescription(FName:String; Methode:Byte):String;
Var St:String;
    Path:DirStr;
    Name:NameStr;
    Extention:ExtStr;

Begin
St:=Get_FileInfoLine(FName,Methode);    {*Rcupre la Ligne dans SYSTEM.FTM*}

If St='' Then Begin
   FSplit(FName, Path,Name,Extention);  {*Extention non trouve !*}
   Get_FileDescription:=Copy(Extention,2,255)+' '+Language.Loc(62)
   End Else Get_FileDescription:=Str_Get(St,2,';');
End;

{ͻ
                           FUNCTION Get_FileType                            
 ͹
  IN.....: FName (STRING) = Filename.                                       
           Methode (BYTE) = Used method to do detection.                    
               M_Extention = 1 : Detection by file suffix (Win95 Method).   
               M_Header    = 2 : Detection by file header (MOS Pro Method). 
  OUT....: (INTEGER) = File type.                                           
  EXPLAIN: Identify the file and return the integer type.                   
  SEEALSO: Get_FileInfoLine, Get_FileIcon                                   
 ͼ}

Function Get_FileType(FName:String; Methode:Byte):Integer;
Var St:String;

Begin
St:=Get_FileInfoLine(FName,Methode);    {*Rcupre la Ligne dans SYSTEM.FTM*}

If St='' Then Get_FileType:=0           {*File not found*}
         Else Get_FileType:=Str_S2L(Str_Get(St,3,';'));
End;

{ͻ
                        FUNCTION Get_FileTypeString                         
 ͹
  IN.....: FName (STRING) = Filename.                                       
           Methode (BYTE) = Used method to do detection.                    
               M_Extention = 1 : Detection by file suffix (Win95 Method).   
               M_Header    = 2 : Detection by file header (MOS Pro Method). 
  OUT....: (STRING) = File type string.                                     
  EXPLAIN: Identify the file and return the string type.                    
  SEEALSO: Get_FileInfoLine, Get_FileIcon                                   
 ͼ}

Function Get_FileTypeString(FName:String; Methode:Byte):String;
Var Value:Integer;
Begin
Value:=Get_FileType(FName,Methode);
Get_FileTypeString:='Unknown';
If Value=01 Then Get_FileTypeString:='Program';
If Value=02 Then Get_FileTypeString:='Image';
If Value=03 Then Get_FileTypeString:='Animation';
If Value=04 Then Get_FileTypeString:='Sound';
If Value=05 Then Get_FileTypeString:='Music';
If Value=06 Then Get_FileTypeString:='Database';
If Value=07 Then Get_FileTypeString:='Source';
If Value=08 Then Get_FileTypeString:='Archive';
If Value=09 Then Get_FileTypeString:='Text';
If Value=10 Then Get_FileTypeString:='Font';
End;

{ͻ
                           FUNCTION Get_FileIcon                            
 ͹
  IN.....: FName (STRING) = Filename.                                       
           Methode (BYTE) = Used method to do detection.                    
               M_Extention = 1 : Detection by file suffix (Win95 Method).   
               M_Header    = 2 : Detection by file header (MOS Pro Method). 
  OUT....: (STRING) = Icon Filename.                                        
  EXPLAIN: Get the Icon filename associated to the requested File.          
  SEEALSO: Get_FileType, Get_FileInfoLine                                   
 ͼ}

Function Get_FileIcon(FName:String; Methode:Byte):String;
Var St:String;

Begin
St:=Get_FileInfoLine(FName,Methode);    {*Rcupre la Ligne dans SYSTEM.FTM*}

If St='' Then St:='I_butfly.ico'           {*Define result*}
         Else Begin
         St:=Str_Get(St,4,';');
         If St='' Then St:='I_butfly.ico'  {*Set default*}
         End;
Get_FileIcon:=Sys.GetPath(SP_ICONS)+St;
End;

{ͻ
                        FUNCTION Get_FileInformation                        
 ͹
  IN.....: FName (STRING) = Path and filename of the file.                  
           Inf (TFileInfo) = Structure containing file information.         
  OUT....: (BOOLEAN) = TRUE if information found.                           
  EXPLAIN: Get information about a file and return in structure TFileInfo.  
 ͼ}

Function Get_FileInformation(FName:String; Var Inf:TFileInfo):Boolean;  {*Get informations about a file*}
Var FSize:Longint;
    Fil1:Text;
    Attr:Word;

{*************************** Return Size in String **************************}

Function GetSSize(S:Longint):String;
Var AdaptedSize:Longint;
Begin
AdaptedSize:=S Div 1024;
If AdaptedSize>1024 Then             {*KB*}
   Begin
   AdaptedSize:=AdaptedSize Div 1024;
   GetSSize:=' ('+Str_Format(Str_L2S(AdaptedSize),' ',3)+' Mb)';
   End
   Else Begin                        {*MB*}
   GetSSize:=' ('+Str_Format(Str_L2S(AdaptedSize),' ',3)+' Kb)';
   End;
End;

{****************************************************************************}

Begin
Get_FileInformation:=No;
If Not File_TestExist(FName) Then Exit; {*File not found*}

FName:=FExpand(FName);                  {*Get Truename*}

With Inf do                             {*Fill record*}
   Begin
   Path:=File_StrSplit(FName,$0003);
   Name:=File_StrSplit(FName,$000C);
   DOSName:=FName;
   GetShortName(DOSName);
   DOSName:=File_StrSplit(DOSName,$000C);
   FSize:=File_GetSize(FName);
   Size:=Str_Format(Str_L2S(FSize),' ',3)+' bytes'+GetSSize(FSize);

   RealSize:=Str_Format(Str_L2S(FSize),' ',3)+' bytes'+GetSSize(FSize);

   IconFile:=Get_FileIcon(FName,M_Extention);
   FileDescription:=Get_FileDescription(FName,M_Extention);
   FileType:=Get_FileType(FName,M_Extention);
   FileTypeString:=Get_FileTypeString(FName,M_Extention);

   Assign(Fil1,FName);                  {*Get attrib bits*}
   GetFAttr(Fil1,Attr);
   If Attr And ReadOnly <>0 Then AttrReadOnly:=Yes  Else AttrReadOnly:=No;
   If Attr And Hidden   <>0 Then AttrHidden:=Yes    Else AttrHidden:=No;
   If Attr And SysFile  <>0 Then AttrSystem:=Yes    Else AttrSystem:=No;
   If Attr And Archive  <>0 Then AttrArchive:=Yes   Else AttrArchive:=No;
   If Attr And Directory<>0 Then AttrDirectory:=Yes Else AttrDirectory:=No;

   Modified := File_GetModifiedTime(FName, DTFrench);
   Created  := File_GetModifiedTime(FName, DTFrench);
   Used     := File_GetModifiedTime(FName, DTFrench);

   CreatedBy:='Unknown';
   {$IFDEF FPC}
   CompiledBy:='Free Pascal Compiler';
   CompilerVersion:='v'+{$I %FPCVERSION%};
   CompilerTargetCpu:={$I %FPCTARGET%};
   CompilationDate:={$I %DATE%};
   CompilationTime:={$I %TIME%};
   {$ELSE}
   CompiledBy:='Unknown';
   CompilerVersion:='Unknown';
   CompilerTargetCpu:='Unknown';
   CompilationDate:=Created;
   CompilationTime:='';
   {$ENDIF}
   End;

Get_FileInformation:=Yes;
End;

{*------------------------------- MISCELLANEOUS ----------------------------*}

{ͻ
                           FUNCTION ParameterMOS                            
 ͹
  IN.....: St (STRING) = Parameter to test                                  
  OUT....: St (STRING) = If parameter followed by '=xxx' then return 'xxx'  
           (BYTE) = Position where is found the parameter, else if not      
                    found return 0.                                         
  EXPLAIN: Test if the program is launch with the parameter St.If the anwser
           is yes, send the position of this parameter.                     
           And if the parameter is followed by '=xxx',St is replaced by     
           'xxx'.                                                           
  EXAMPLE: toto.exe /record=test.lmp /machin                                
           S:='Record';                                                     
           Parameter(S) = 2 & S='Test.lmp'                                  
           S:='Truc'                                                        
           Parameter(S) = 0 & S='Truc'                                      
           S:='Machin'                                                      
           Parameter(S) = 3 & S='Machin'                                    
  CF.....: Str_Parameter, ParamStr, ParamCount.                             
  NB.....: You must use this function if you are in MOS, else use Parameter 
  SEEALSO: Parameter, Str_Parameter                                         
 ͼ}

Function ParameterMOS(Var St:String):Byte;
var tmp: ShortString;
Begin
move(St[1],tmp[1], Min( Length(st), sizeof(ShortString))-1);
SetLength(tmp, Min(Length(st),sizeof(ShortString))-1);
If BCmd Then ParameterMOS:=Str_Parameter(ParamStr(0)+' '+SCmd,tmp,0) Else
ParameterMOS:=Parameter(tmp,0);
End;

{*--------------------------------------------------------------------------*}

{ͻ
                            PROCEDURE Init_Graph                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Initialise graphic mode using 'Sys.GfxMode' variable.            
 ͼ}

Procedure Init_Graph;                   {*Initialisation Graphique*}
Var CP       :Boolean;                  {*Dtourner Gfx ou Pas...*}
    Bits     :Longint;
    MX,MY    :Word;
    SBits    :String;
    List     :TStringList;
    A        :Integer;
    StrError :String;

Procedure GetAvailableGfxMode(L:TStringList);
Var ListBase     :TStringList;
    FName        :String;
    NumMode,Code :Word;
    A,B          :Integer;
    Line         :String;
    NewLine      :String;
    ModeCaption  :String;

Begin
   FName := Sys.GetPath(SP_DATAS)+'Gfxmodes.lis';

   ListBase := NIL;
   Try
      ListBase := TStringList.Create;      // On crer la liste temporaire
      ListBase.LoadFromFile(FName);        // On charge la liste  partir du fichier

      For A := 0 to ListBase.Count - 1 do  // On parcours la liste temporaire
      Begin
         Val(Str_Get(ListBase[A],1,';'),NumMode,Code);
         If VESA_TestMOSMode(NumMode) Then // Le mode est support !
         Begin
            Line := ListBase[A];           // Ligne d'info du mode graphique
            NewLine := '';
            For B := 1 to Str_Count(Line,';') do
            Begin                          // On reformate la ligne (look)
               If B = 1 Then NewLine := 'Mode ' + Str_Get(Line,B,';');
               If B = 2 Then
               Begin
                  ModeCaption := Str_CleanSpaces(Str_Get(Line,B,';'));
                  If Length(ModeCaption) = 9 Then ModeCaption := ' ' + ModeCaption + ' ';
                  NewLine := NewLine + ' (' + ModeCaption + ')';
               End;
               If B = 3 Then NewLine := NewLine + Str_Spaces(24 - Length(NewLine)) + ' Colors : ' + Str_CleanSpaces(Str_Get(Line,B,';'));
               If B = 4 Then NewLine := NewLine + Str_Spaces(40 - Length(NewLine)) + ' Bits : ' +   Str_CleanSpaces(Str_Get(Line,B,';'));
            End;
            L.Add(NewLine);                // On ajoute le mode  la liste des modes autoriss
         End;
         //Inc(A);
      End;
   Finally
      ListBase.Free;                       // On libre tout
   End;
End;

//****************************************************************************

Begin
   If Application.Mode = AMText Then Exit; {*Not in graphic mode*}

   MosGraph.VESA_GetModeInfo(Sys.GfxMode,MX,MY,Bits);
   Case Bits of                            {*Get graphic mode information*}
      ig_Col8  : SBits:='8 bits';
      ig_Col15 : SBits:='15 bits';
      ig_Col16 : SBits:='16 bits';
      ig_Col24 : SBits:='24 bits';
      ig_Col32 : SBits:='32 bits';
      Else SBits:='4 bits';                {*Obsolete 16 colors modes*}
   End;

   Log.Add('Initialise graphic mode');     {*Append in Log file*}
   Log.Add('    Mode '+Str_L2S(Sys.GfxMode)+' ('+Str_L2S(MX)+'*'+Str_L2S(MY)+' in '+SBits+')"');

   If BTST(Id_Msg1,12) Then CP:=Yes        {*On est dans un Programme Appel...*}
                       Else CP:=No;

// Attention, on pr-initialise ici GraphiX pour que l'appel  IsModeAvailable
//  travers la fonction "VESA_TestMOSMode" fonctionne correctement
// de manire  dtecter quels sont les modes graphiques autoriss.

   InitGraphiX(ig_vesa,ig_lfb);

// Ici on va tester si le mode demand est possible
// Si ce n'est pas le cas alors on affiche la liste des modes disponibles...

   If Not VESA_TestMOSMode(Sys.GfxMode) Then // Le mode n'est pas support !
   Begin
      StrError := 'Graphic mode not supported !';
      Log.Add('    ' + StrError);

      Writeln(StrError);
      Writeln;
      Writeln('Available modes are :');

      List := NIL;                         // On affiche la liste des modes autoriss
      Try
         List := TStringList.Create;
         GetAvailableGfxMode(List);
         For A := 0 to List.Count - 1 do
         Begin
            Writeln('    ' + List[A]);
         End;
      Finally
         List.Free;
      End;

      DoneGraphiX;                         // On ferme Graphix que l'on avait initialis
      Halt(9);                             // Exit with error code...
   End;

   If CP Then VESA_ReinitGraph(Sys.GfxMode, Sys.GetPath(SP_FONTS))
         Else VESA_InitGraph  (Sys.GfxMode, Sys.GetPath(SP_FONTS));

   Id_Msg1:=Id_Msg1 Or $40;        // Set Bit Needs SVGA Driver

   Sys.OldGfxMode := Sys.GfxMode;  // Store Old Gfx Mode...

   Init_SetColorsValues;           // Dfinition des couleurs RGB
End;

{ͻ
                           PROCEDURE Init_Display                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Display screen and initialise some graphic functions.            
 ͼ}

Procedure Init_Display;
var Coords: TCoordinates;
Begin

If Application.Mode = AMText Then Exit; {*Not in graphic mode*}

If BTST(Id_Msg1,12) Then Exit;          {*On est dans un Programme Appel...*}
Log.Add('Display background desktop');

Show_Screen;                            {*Affiche le fond de l'cran*}
VESA_SetTextStyle(Sys.GetPath(SP_FONTS)+'LITT.CHR',0,Sys.FontMainSize); {*Set Font*}

Coords.X1 := 0;
Coords.Y1 := 0;
Coords.X2 := VESA_GetMaxX;
Coords.Y2 := VESA_GetMaxY;

Sys.SetWinCurrentCoord(Coords);              {*Coord Fentre Courrante*}
End;

{ͻ
                           PROCEDURE Show_Screen                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Display again the screen background.                             
 ͼ}

Procedure Show_Screen;
Var ShowB:Word;                         {*Bit d'affichage de l'Image en Fond*}
    Text2:TText;

Begin
If BTST(Id_Msg1,12) Then Exit;          {*On est dans un Programme Appel...*}

If Sys.OldGfxMode<>Sys.GfxMode Then
   Begin
   Mse_Hide;
   Done_Mouse;
   Init_Graph;                          {*Switche dans le bon Mode Graphique*}
   Init_Mouse;
   Mse_Hide;
   If P_Current=MPArrow Then Mse_SetPointer(MPBusy)
                        Else Mse_SetPointer(MPArrow);
   Mse_SetPointer(P_Current);           {*Set the current mouse pointer*}
   Sys.OldGfxMode:=Sys.GfxMode;
   Mse_Show;
   End;

Bevel(0,0,VESA_GetMaxX,VESA_GetMaxY,CLBackground); {*Clear background*}


Case Sys.DesktopStyle of                {*Desktop style*}
   DSGraphic:                           {*Display image*}
      Begin
      Log.Add('    Image "'+Sys.DesktopImage+'"');
      Case Sys.DesktopDisplayStyle of   {*Desktop image style displayed*}
         DICenter:  ShowB:=$28;         {*Center*}
         DIStretch: ShowB:=$28;         {*Stretch*}
         DIMosaic:  ShowB:=$24;         {*Mosaic*}
         End;

      BMP_Show(0,0,VESA_GetMaxX,VESA_GetMaxY,0,0,Sys.DesktopImage,ShowB);
      End;
   DSPattern:                           {*Display pattern*}
      Begin
      End;
   End;

If BTST(Id_Msg1,14) Then                {*Display 'DEBUG MODE'*}
   Begin
   Display_Define(Text2,20,VESA_GetMaxY-30,-1,CLWhite,'LITT.CHR',4,TJOnLeft,$0004,'DEBUG MODE');
   Display_Draw(Text2);
   End;
End;

{ͻ
                          PROCEDURE Init_Password                           
 ͹
  IN......: /                                                               
  OUT.....: /                                                               
  EXPLAIN.: Demande  l'utilisateur un mot de Passe pour se connecter.      
  NB......: Si le mot de passe n'est pas correct, alors Sortie Virile.      
 ͼ}

Procedure Init_Password;
Var A,Num:Integer;                      {*Loop*}
    Ok:Boolean;
    Cin:ShortString;
Begin
If BTST(Id_Msg1,12) Then Exit;          {*On est dans un Programme Appel...*}

If Application.Mode = AMText Then Exit; {*Not in graphic mode*}

If Sys.AskForBootPwd Then Begin                   {*Password at Boot...*}
   Log.Add('Check password to run application');
   A:=Sys.BootPwdTestCount; Ok:=No;
   While (Not Ok) And (A>0) do
      Begin
      Num:=5; Cin:='$';
      Req_String(Language.Loc(1602),Language.Loc(1603),Language.Loc(708),30,220,Cin,Num);
      Dec(A);
      If (Cin=Str_Crypt(Sys.BootPwd,Str_GetCryptKey(Sys.BootPwd))) And (Cin<>'') Then Ok:=Yes;
      If Num<>1 Then A:=0;
      End;
   If Not Ok Then Application.Close;    {*Connection Avorte*}
   End;
End;

{ͻ
                          PROCEDURE Init_CmdDebug                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Store informations for debugging.                                
           Must be set at the begining of the program.                      
  SEEALSO: Done_Debug                                                       
 ͼ}

Procedure Init_CmdDebug;
Var Par:String;
Begin
Par:='-DEBUG';                          {*Debug Mode Requested ?*}
If (ParameterMOS(Par)>0) Then BSET(Id_Msg1,14);
If Not BTST(Id_Msg1,14) Then Exit;      {*Not in Debug Mode ?*}
Log.Add('Initialise Debug mode');
End;

{ͻ
                           PROCEDURE Init_CmdHome                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test command line to set default directory as program directory. 
 ͼ}

Procedure Init_CmdHome;
Var Par:String;
Begin
Par:='-HOME';
If (ParameterMOS(Par)>0) Then           {*Se positionne dans le rpertoire appellant*}
   Begin
   Log.Add('Set program directory as default');
   Chdir(Dsk_GetHome);
   End;
End;

{ͻ
                           PROCEDURE Init_CmdLoc                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test command line for locale language definition.                
 ͼ}

Procedure Init_CmdLoc;
Var Par:String;
    LocFile:String;

Begin
Par:='-LOC';
If ParameterMOS(Par)>0 Then             {*Demande  Changer le Langage*}
   Begin
   If (Par<>LFEnglish) And (Par<>LFFrancais) And (Par<>LFEspanol) And (Par<>LFPortuguese)
      Then LocFile := '?'
      Else LocFile := Locale.GetLocaleFile(Par);

   Log.Add('Set new language ('+Par+')="'+LocFile+'"');
   If LocFile = '?' Then
      Begin
      Log.Add('    Unknown requested language "'+Par+'" (default set to English)');
      Language.Code := LFEnglish;
      End
   Else Language.Code := Par;           {*Define requested language*}
   End;
End;

{ͻ
                           PROCEDURE Init_Locale                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Load new locale language file into memory.                       
 ͼ}

Procedure Init_Locale;
Begin
Log.Add('Load locale file in memory "'+Locale.GetLocaleFile(Language.Code)+'"');
Language.SetLanguage(Language.Code);    {*Set new language*}
End;

{ͻ
                           PROCEDURE Init_CmdBmp                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test command line for BMP background image.                      
 ͼ}

Procedure Init_CmdBmp;
Var Par:String;
Begin

Par:='-BMP';
If ParameterMOS(Par)>0 Then             {*Demande  Changer l'image de Fond*}
   If Par<>'' Then
      Begin
      Log.Add('Set background image to "'+Par+'"');
      Sys.DesktopImage:=Par;
      End;
End;

{ͻ
                         PROCEDURE Init_CmdMsgUser                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test command line for user message displaying.                   
 ͼ}

Procedure Init_CmdMsgUser;
Var UserMsg:String;
Begin
UserMsg:=Str_Clear(Language.Loc(271));
If UserMsg='' Then UserMsg:='?';        {*User message exist or no ?*}

If (UserMsg<>'?') And (Not BTST(Id_Msg1,12)) Then {*Affiche ventuellement Msg Perso*}
   Begin
   Log.Add('Display user message "'+Language.Loc(271)+'"');
   Writeln(Language.Loc(271)); Delay(3000);
   End;
End;

{ͻ
                        PROCEDURE Init_CmdHiddenPart                        
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test command line for MOS hidden part cheat command.             
 ͼ}

Procedure Init_CmdHiddenPart;
Var Par:String;
Begin
Par:='-MOS';
If ParameterMOS(Par)>0 Then             {*Cheat mode for MOS*}
   Begin
   Log.Add('Set MOS hidden part mode');
   End;
End;


{ͻ
                         PROCEDURE Init_CmdNoSound                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test command line for no sound command.                          
 ͼ}

Procedure Init_CmdNoSound;
Var Par:String;
Begin
Par:='-NOSOUND';
If ParameterMOS(Par)>0 Then             {*Supprime les sons dans MOS*}
   Begin
   Log.Add('Don''t initialise sounds');
   Id_Msg1:=Id_Msg1 Or $100;

   End;
End;

{ͻ
                         PROCEDURE Init_CmdGfxMode                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test command line for graphic mode definition.                   
 ͼ}

Procedure Init_CmdGfxMode;
Var Par:String;
    I:Integer;
Begin
Par:='-MODE';
If ParameterMOS(Par)>0 Then             {*Demande  Changer le Mode GFX*}
   Begin
   Log.Add('Set graphic mode to "'+Par+'"');
   I:=Str_S2L(Par);
   If I>0 Then Sys.GfxMode:=I Else Error(570);{*Erreur dans la ligne de Commande*}
   End;

If Sys.GfxMode<0 Then Sys.GfxMode:=12;        {*Pas de Modes Ngatifs...*}
End;

{ͻ
                           PROCEDURE Init_CmdHelp                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test command line for help displaying.                           
 ͼ}

Procedure Init_CmdHelp;
Var Par1,Par2:String;
    A:Integer;
Begin
Par1:='-?'; Par2:='/?';
If (ParameterMOS(Par1)>0) Or (ParameterMOS(Par2)>0) Then
   Begin
   Log.Add('Display help');
   Writeln(Application.MOSName+' '+Application.MOSVersion,' ',Language.Loc(236));{*Info sur MOS*}
   Writeln(Language.Loc(1725)+Sys.GetVersion);
   Writeln(Language.Loc(244),' ',User.Name);
   Writeln(Language.Loc(234),' ',Application.GetTypeCaption);
   Writeln;
   For A:=237 to 242 do Writeln(Language.Loc(A));
   Writeln(Language.Loc(269)); Writeln(Language.Loc(272));
   Writeln(Language.Loc(250)); Writeln(Language.Loc(252));
   Writeln(Language.Loc(253)); Writeln(Language.Loc(374));

   Writeln(Language.Loc(851)); Writeln(Language.Loc(1605));
   Writeln(Language.Loc(232)); Writeln(Language.Loc(243));
   Halt(0);
   End;
End;

{ͻ
                           PROCEDURE Init_CmdSave                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test command line to save MOS initialisation file.               
 ͼ}

Procedure Init_CmdSave;
Var Par:String;
Begin
Par:='-SAVE';
If ParameterMOS(Par)>0 Then             {*Demande d'Update du ".INI"*}
   Begin
   Log.Add('Save initialisation file');
   Save_Config(Copy(ParamStr(0),1,Length(ParamStr(0))-3)+'INI');
   Error(574);                          {*Informe de la Sauvegarde*}
   End;

End;

{ͻ
                        PROCEDURE Init_CmdErrorDemo                         
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test command line for error in demo action.                      
 ͼ}

Procedure Init_CmdErrorDemo;
Var Par1,Par2:String;

Begin
Par1:='-RECORD'; Par2:='-PLAYDEMO';
If (ParameterMOS(Par1)>0) And (ParameterMOS(Par2)>0) Then
   Begin
   Log.Add('Error in demo commands');
   Writeln(Midder(Language.Loc(251)));               {*Record & PlayDemo en mme Temps*}
   Halt(11);
   End;
End;

{ͻ
                        PROCEDURE Init_CmdRecordDemo                        
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test command line for recording demo.                            
 ͼ}

Procedure Init_CmdRecordDemo;
Var Par:String;
Begin
Par:='-RECORD';
If ParameterMOS(Par)>0 Then             {*Demande de Record de Dmo*}
   Begin
   If Par='-RECORD' Then Error(661) Else
      Begin                             {* Set demo + Record mode *}
      Log.Add('Start to record MOS demo');
      Sys.DemoFile:=Par;
      Id_Msg1:=Id_Msg1 Or $600;
      End;
   End;
End;

{ͻ
                         PROCEDURE Init_CmdPlayDemo                         
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test command line for playing demo.                              
 ͼ}

Procedure Init_CmdPlayDemo;
Var Par:String;
Begin
Par:='-PLAYDEMO';
If ParameterMOS(Par)>0 Then
   Begin
   Log.Add('Start to play MOS demo');
   Id_Msg1:=Id_Msg1 Or $200;             {* Set demo mode *}
   Id_Msg1:=Id_Msg1 And ($FFFF-$400);    {* Set lecture MODE*}
   Sys.DemoFile:=Par;
   End;
End;

{ͻ
                           PROCEDURE Init_CmdQuit                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test command line to quit MOS and return to DOS.                 
 ͼ}

Procedure Init_CmdQuit;
Var Par:String;
Begin
Par:='-QUIT';
If ParameterMOS(Par)>0 Then             {*Sort sans excuter le Programme*}
   Begin
   Log.Add('Exit to DOS');
   Halt(2);
   End;
End;

{ͻ
                         PROCEDURE Init_CmdCommand                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test command line to read a DOS command line in text file.       
 ͼ}

Procedure Init_CmdCommand;
Var Par:ShortString;
Begin
BCmd:=False;
Par:='-CMD';
If (Parameter(Par,0)>0) Then
   Begin
   Log.Add('Reading a command line in text file');
   SCmd:=File_GetLine(Par,1);
   If SCmd<>'' Then BCmd:=True;
   End;
End;

{ͻ
                        PROCEDURE Init_CmdLoadTheme                         
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Load the main theme file.                                        
 ͼ}

Procedure Init_CmdLoadTheme;
Var Par:String;
Begin
Log.Add('Checking for main theme');
Par:='-THEME';
If ParameterMOS(Par)>0 Then
   Begin
   If Par<>'-THEME' Then                {*Define main theme*}
      Begin
      Log.Add('    Set main theme to "'+Par+'"');
      End;
   End;
End;

{ͻ
                         PROCEDURE Init_CmdLoadIni                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test command line to specify a new initialisation file.          
 ͼ}

Procedure Init_CmdLoadIni;
Var Par,IniFile:String;
    IniByCmd:Boolean;                   {*INI defined by Command*}
Begin
Par:='-INI'; IniFile:=''; IniByCmd:=No;
If ParameterMOS(Par)>0 Then
   Begin
   If Par<>'-INI' Then                  {*Set specified INI file*}
      Begin
      IniFile:=Par;
      IniByCmd:=Yes;
      Log.Add('Set initialisation file to "'+IniFile+'"');
      End;
   End;

If IniFile='' Then                      {*INI file not specified*}
   Begin
   IniFile := Get_AppIniName; {*Search Name Prog*}
   End;

If Not File_TestExist(IniFile) Then     {*INI file not found !*}
   Begin
   Sys.Directory:=IniFile;
   BSET(Id_Sys1,5);
   Sys.SystemFound:=No;
   If IniByCmd Then                     {*Incorrect specified INI*}
      Begin
      Log.Add('    File "'+Sys.Directory+'" not found');
      Writeln('File "'+Sys.Directory+'" not found...');
      End;
   End
   Else
   Begin
   Log.Add('Load initialisation file "'+IniFile+'"');
   Load_Config(IniFile);                {*Try to load specified .INI*}
   End;
End;

{ͻ
                          PROCEDURE Init_CmdSetWd                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test command line to set Working Directory.                      
 ͼ}

Procedure Init_CmdSetWd;
Var Par:String;
Begin
Par:='-WD';
If ParameterMOS(Par)>0 Then             {*Demande de redfinir le system directory*}
   If Par<>'-WD' Then
   Begin
   BSET(Id_Sys1,6);
   Sys.Directory:=Par;
   Sys.Directory:=Dsk_ValideDirectory(Sys.Directory);
   Log.Add('Set system directory to "'+Sys.Directory+'"');
   End;
End;

{ͻ
                          PROCEDURE Init_SearchWd                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Search system path in Set environment variables.                 
 ͼ}

Procedure Init_SearchWd;
Var Path:String;

Begin
Log.Add('Searching system directory');

If (Not Sys.SystemFound) And (Not BTST(Id_Sys1,6)) Then
   Begin                                {*Search in environment variable*}
   Path:=GetEnv('MOSDIR');
   If Path='' Then
      Begin                             {*No ".INI" Founds*}
      Log.Add('    System directory not defined');
      Writeln('System directory not defined...');
      Halt(3);
      End
   Else                                 {*Found system directory*}
      Begin
      Sys.Directory:=Dsk_ValideDirectory(Path);
      Log.Add('MOS environment variable defined as "'+Sys.Directory+'"');
      End;
   End;

If Not Sys.TestDefined Then
   Begin                                {*Check the system directory*}
   Log.Add('    Incorrect system directory '+Sys.GetPath(SP_MAIN));
   Writeln('Incorrect system directory "'+Sys.GetPath(SP_MAIN)+'"');
   Halt(3);
   End;
End;

{ͻ
                         PROCEDURE Init_Statistics                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Add statistics into the MOS system data directory.               
 ͼ}

Procedure Init_Statistics;
Var FName:String;                       {*Nom du fichier STATS.DAT*}
Begin
FName := Sys.GetPath(SP_DATAS) + 'Stats.dat';
If Log.Level > 0 Then
   Begin                                {*Fill Stats file for Bootlog*}
   Ini_UpdateKey(FName, 'System','Bootlog files',+1);
   End;
                                        {*Add statistics in data file*}
Log.Add('Updating statistics in file "'+FName+'"');
Ini_UpdateKey(FName,'System','Programs runned',+1); {*1 Prog de plus*}
Ini_UpdateKey(FName,'System','Windows launched',+1); {*+1 pour Windows*}
Ini_UpdateKey(FName,'Graphic','Graphic mode '+Str_FillZero(Sys.GfxMode,2),+1); {*1 pour le gfx mode*}
End;

{ͻ
                          PROCEDURE Init_VarGraph                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Initialise all for the graphic.                                  
 ͼ}

Procedure Init_VarGraph;
Begin
Log.Add('Init font values');            {*Append in Log file*}
Font_SetSpecial(0);                     {*Dfinit Fonte Gnrale*}
Font_SetSpecial(1);                     {*Dfinit Fonte Title Window*}
End;

{ͻ
                         PROCEDURE Init_CheckSystem                         
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Create SYSTEM sub-directories if they don't exists.              
 ͼ}

Procedure Init_CheckSystem;
Var A:Integer;
    DName:String;
Begin
Log.Add('Check sub-system drawers (Quantity '+Str_L2S(SP_LASTDIR)+')');
For A:=1 to SP_LASTDIR do               {*Create System Directories...*}
  Begin
  If Not Dsk_TestDirectory(Sys.GetPath(A)) Then
     Begin
     DName:=Sys.GetPath(A);
     Dsk_Mkdir(DName);
     Log.Add('    Creating "'+DName+'"');
     End;
  End;
End;

{ͻ
                         PROCEDURE Init_TempDrawer                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Initialise temporary MOS drawers.                                
 ͼ}

Procedure Init_TempDrawer;
Begin
Log.Add('Test writable support');       {*Append in Log file*}
Sys.TempDirectory:='C:\MOS99_13\';      {*Nom  la Con ! mais Top*}

If Not Dsk_TestWritableDrive(Copy(Dsk_GetHome,1,1)) Then
   Begin
   BSET(Id_Sys1,0);                     {*Taggue Support CD-Rom*}
   If Not Dsk_TestDirectory(Sys.TempDirectory) Then
      Begin                             {*On crer le "C:\TEMP"*}
      Log.Add('    Temporary drawer "'+Sys.TempDirectory+'" created');
      Dsk_Mkdir(Sys.TempDirectory);
      BSET(Id_Sys1,1);                  {*Taggue Rpertoire cr*}
      End;
   End;
End;

{ͻ
                         PROCEDURE Init_TestConfig                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test Hardware and Software configuration.                        
 ͼ}

Procedure Init_TestConfig;
Begin
Log.Add('Test hardware configuration');

Log.Add('Test software configuration');
If Lo(DosVersion)<4 Then                {*Bad DOS version*}
   Begin
   Writeln('DOS version too old');
   Log.Add('    DOS version too old');
   Halt(6);
   End;

{*TO IMPLEMENT*}
If False Then                  {*Bad video card*}
   Begin
   Writeln('Video card too old');
   Log.Add('    Video card too old');
   Halt(7);
   End;

{*TO IMPLEMENT*}
If False Then                  {*Windows NT*}
   Begin
   Writeln('Cannot run MOS under Windows NT');
   Log.Add('    Cannot run MOS under Windows NT');
   Halt(8);
   End;
End;

{ͻ
                            PROCEDURE Init_App                              
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Initialise the application object.                               
 ͼ}

Procedure Init_App;
Begin
Application := NIL;
Application := TApplication.Create;     {*Create application object*}
Application.Mode := AMGraphic;          {*Graphic application*}
Application.SetInformation('Unknown','v1.00','MOS Developments','Unknown','Unknown'); {*Application information*}

Sys := NIL;                             {*Create system manager*}
Sys := TSystem.Create;

User := NIL;                            {*Create MOS owner object*}
User := TUser.Create;

Locale := NIL;
Locale := TLocale.Create;               {*Create locale file list*}
Locale.Add('ENG;ENGLISH.LOC');
Locale.Add('FRA;FRANCAIS.LOC');
Locale.Add('ESP;ESPANOL.LOC');
Locale.Add('POR;PORTUG.LOC');

Language := NIL;
Language := TLanguage.Create;           {*Create object language*}
End;

{ͻ
                             PROCEDURE Init_Log                             
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Initialise the MOS Log file.                                     
 ͼ}

Procedure Init_Log;
Var Par:String;
    Res:Integer;

Begin
//Sys.LogFileBackup:='';
Application := NIL;                     {*Necessary to check if Application is assigned*}

Log := NIL;                             {*Assign pointer to NIL*}
Log := TLogFile.Create('Bootlog.txt');  {*Create Log file*}
Log.Level := 0;                         {*Cannot append Log lines*}

Par := '-LOG';                          {*Set Log level*}
If (ParameterMOS(Par)>0) Then
   Begin
   Res:=Str_S2L(Par);
   Check_RangesValue(Res,1,3);          {*1 to 3*}
   Log.Erase;                           {*Erase previous Log file if exist*}
   Log.Level := Res;
   Log.Add('Log level set to '+Str_L2S(Log.Level));
   End;
End;

{ͻ
                           PROCEDURE Init_SetVar                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Initialise all the variables using default values.               
 ͼ}

Procedure Init_SetVar;
Var TimeTemp:Word;

Begin
Log.Add('Initialise main variables');   {*Append in Log file*}

GetTime(SbH,SbM,SbS,TimeTemp); {*H/M/S pour Start Screen Blanker*}
{!}Sys.CursorBlinkSpeed := TimeTemp;

Randomize;                              {*For Registered Random 139*}

WPMx:=0; WPMy:=0;                       {*Init Window Pos Mouse X,Y*}

P_Current:=MPArrow;                     {*Pointer Arrow*}
Actual_Pointer:='';                     {*Pointer Diffrent pour Initialisation*}

MOS_Errors.Level:=3;                    {*Intercept classic error*}

Id_Sys1:=$0000;                         {*Systme de Base*}
Id_Err1:=$0007;                         {*Dfinition Erreurs Systme*}
Id_Msg1:=$0000;                         {*Pas de Messages du Systme*}
Id_Gad1:=$0000;                         {*Pas de Messages des Gadgets*}
Id_Scr1:=$0000;                         {*Pas de Status pour les Gfx*}

MPArrow     :='Arrow.cur';           {*Id for Arrow pointer*}
MPBusy      :='Busy.cur';            {*Id for Busy pointer*}
MPDrag      :='Drag.cur';            {*Id for Drag and Drop pointer*}
MPEyeDrop   :='Eyedrop.cur';         {*Id for Eyedrop pointer*}
MPForbiden  :='Forbiden.cur';        {*Id for Forbiden pointer*}
MPHand      :='Hand.cur';            {*Id for Hand pointer*}
MPHead      :='Head.cur';            {*Id for Dead Head pointer*}
MPHelp      :='Help.cur';            {*Id for Dead Help pointer*}
MPHourGlass :='Hourglas.cur';        {*Id for Hourglass pointer*}
MPLetter    :='Letter.cur';          {*Id for Letter pointer*}
MPMove      :='Move.cur';            {*Id for Move pointer*}
MPMoveDown  :='Movedown.cur';        {*Id for Move Down pointer*}
MPMoveLD    :='Moveld.cur';          {*Id for Move Left and Down pointer*}
MPMoveLeft  :='Moveleft.cur';        {*Id for Move Left pointer*}
MPMoveLU    :='Movelu.cur';          {*Id for Move Left and Up pointer*}
MPMoveRD    :='Moverd.cur';          {*Id for Move Right and Down pointer*}
MPMoveRight :='Moverigh.cur';        {*Id for Move Right pointer*}
MPMoveRU    :='Moveru.cur';          {*Id for Move Right pointer*}
MPMoveUp    :='Moveup.cur';          {*Id for Move Up pointer*}
MPMoveX     :='Movex.cur';           {*Id for Horizontal move pointer*}
MPMoveY     :='Movey.cur';           {*Id for Vertical move pointer*}
MPAudio     :='Arrowcd.cur';         {*Id for Audio pointer*}
MPSizeLR    :='Sizelr.cur';          {*Id for Size Left and Right pointer*}
MPSizeLUDR  :='Sizeludr.cur';        {*Id for Size Left Up and Down Right pointer*}
MPSizeRUDL  :='Sizerudl.cur';        {*Id for Size Right Up and Down Left pointer*}
MPSizeUD    :='Sizeud.cur';          {*Id for Size Upd Down pointer*}
MPTarget    :='Target.cur';          {*Id for Target pointer*}
MPText      :='Text.cur';            {*Id for Text pointer*}
MPWarning   :='Warning.cur';         {*Id for Warning pointer*}
End;

{ͻ
                            PROCEDURE Init_Sound                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Initialise sound card an play sound if needs.                    
 ͼ}

Procedure Init_Sound;

Begin
Log.Add('Initialise sound card');
NoSound;                                {*Stop Buzzer*}
If BTST(Id_Msg1,12) Then Exit;          {*On est dans un Programme Appel...*}
Play_SoundAction(1);                    {*Sound at Boot...*}
End;

{ͻ
                           PROCEDURE Init_Process                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Open and initialise process information.                         
 ͼ}

Procedure Init_Process;
Begin
Log.Add('Initialise application process');
If Application.Mode = AMGraphic Then Process_Init; {*Initialise le processus courrant*}
End;

{ͻ
                           PROCEDURE Init_BootGfx                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Display boot image if exist.                                     
 ͼ}

Procedure Init_BootGfx;                 {*Display boot image*}
Begin
If Application.Mode = AMText Then Exit; {*Not in graphic mode*}

Log.Add('Initialise boot graphic');
If (BMP_TestFile(Sys.BootImage)) And (Not BTST(Id_Msg1,12))
   Then
   BMP_Show(0,0,0,0,0,0,Sys.BootImage,$5B);  {*Affichage Image Boot*}
End;

{ͻ
                           PROCEDURE Init_BootApp                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Launch boot applications if exists.                              
 ͼ}

Procedure Init_BootApp;                 {*Lauch boot applications*}
Var Qtt:Integer;
Begin
Log.Add('Launch boot applications');
If BTST(Id_Msg1,12) Then Exit;          {*On est dans un Programme Appel...*}

Qtt:=File_Count(Sys.GetPath(SP_BOOT),No);
If Qtt<=0 Then Log.Add('    No applications found')
   Else Begin                           {*For each applications*}
   End;
End;

{ͻ
                          PROCEDURE Init_Register                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Display Register requester if it's a MOS demo version.           
 ͼ}

Procedure Init_Register;
Begin
If Application.Mode = AMText Then Exit; {*Not in graphic mode*}

If BTST(Id_Msg1,12) Then Exit;          {*On est dans un Programme Appel...*}
Log.Add('Check to display register request');
If Not Application.TestRegistered Then Req_Register; {*Requeter Register*}
Sys.DisplayRegister := RRNoDisplay;
End;

{ͻ
                          PROCEDURE Init_Keyboard                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Initialise keyboard.                                             
 ͼ}

Procedure Init_Keyboard;
Begin
If BTST(Id_Msg1,12) Then Exit;          {*On est dans un Programme Appel...*}
Log.Add('Reset keyboard');
Kbd_PurgeBuffer;                        {*Vide le Buffer Clavier*}
Kbd_SetSpeedKey(Sys.SpeedKeyRate,Sys.SpeedKeyDelay);{*Mode Con Rate=X Delay=Y*}
End;

{ͻ
                            PROCEDURE Done_Sound                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Play end sound and close sound device.                           
 ͼ}

Procedure Done_Sound;
Begin
Log.Add('Release sound channels');
If Not BTST(Id_Msg1,12) Then            {*On est dans un Programme Appel...*}
   Play_SoundAction(2);                 {*Sound at Exit...*}
NoSound;                                {*Stop Buzzer*}
End;

{ͻ
                           PROCEDURE Done_Locale                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Remove locale file from memory.                                  
 ͼ}

Procedure Done_Locale;
Begin
If Language.Loaded Then
   Begin
   Log.Add('Remove locale file from memory');
   Language.RemoveLanguage;             {*Remove .LOC from memory*}
   End;
End;

{ͻ
                        PROCEDURE Done_SystemDrawer                         
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Close and delete temporary MOS System drawers.                   
 ͼ}

Procedure Done_SystemDrawer;
Begin
If BTST(Id_Sys1,1) Then
   Begin
   Log.Add('Remove temporary system drawer');
   File_Deltree(Sys.TempDirectory,true);{*Vire le Drawer temporaire*}
   End;
End;

{ͻ
                           PROCEDURE Done_Process                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Close process information.                                       
 ͼ}

Procedure Done_Process;
Begin
Log.Add('Remove application process');
Process_Done;                           {*Clear disk process information*}
End;

{ͻ
                        FUNCTION Process_UpdateInfo                         
 ͹
  IN.....: P (TProcess) = Pointer to process structure.                     
  OUT....: (BOOLEAN) = TRUE if process information succesfully created.     
  EXPLAIN: Create a MOS Process Information file.                           
 ͼ}

Function Process_UpdateInfo(P:TProcess):Boolean;
Var Ini:TIniFile;

Begin
Process_UpdateInfo:=FALSE;
If Not File_Create(P.FName) Then Exit;

If Not Ini_Init(Ini,P.FName) Then Exit; {* Cannot write !*}

Ini_SaveKey(Ini,'Process','Id',Str_FillZero(P.PId,4));
Ini_SaveKey(Ini,'Process','Status','Running');
If P.PId<>1 Then
   Begin
   Ini_SaveKey(Ini,'Process','Application',P.AppName);
   Ini_SaveKey(Ini,'Process','Parameters',P.AppParameters);
   Ini_SaveKey(Ini,'Process','Launched at',Time_GetSTime(1)+' the '+Time_GetSDate);
   End;
Ini_Done(Ini);
Process_UpdateInfo:=TRUE;
End;

{ͻ
                        FUNCTION Process_GetFileName                        
 ͹
  IN.....: PId (WORD) = Process Id.                                         
  OUT....: (STRING) = Return the process filename according to his PId.     
  EXPLAIN: Calculate the process filename to store information.             
 ͼ}

Function Process_GetFileName(PId:Word):String;
Begin
Process_GetFileName:=Sys.GetPath(SP_PROCESS)+'P'+Str_FillZero(PId,7)+'.PID';
End;

{ͻ
                          FUNCTION Process_GetInfo                          
 ͹
  IN.....: P (TProcess) = Pointer to process structure.                     
  OUT....: (BOOLEAN) = TRUE if process information structure is filled.     
  NB.....: Need the PId value to fill the structure correctly.              
  EXPLAIN: Fill the process structure with information.                     
 ͼ}

Function Process_GetInfo(Var P:TProcess):Boolean;
Var A:Integer;
    Param:String;
Begin
P.AppName:=FExpand(ParamStr(0));
P.FName:=Process_GetFileName(P.PId);
P.AppPArameters:='';
Param:='';
For A:=1 to ParamCount do Param:=Param+ParamStr(A)+' ';
P.AppParameters:=Param;
Process_GetInfo:=TRUE;
End;

{ͻ
                         PROCEDURE Init_InstallApp                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Test if program is lauched for the first time and create         
           an installation file in System\install directory.                
 ͼ}

Procedure Init_InstallApp;
Var FName,FName2:String;                {*Nom du fichier STATS.DAT*}
    Ini:TIniFile;
Begin
FName:=Sys.GetPath(SP_DATAS)+'STATS.DAT';
FName2:=Sys.GetPath(SP_INSTALL)+File_StrSplit(Get_AppName,$0004)+'.MIF';

If Not File_TestExist(FName2) Then      {*Premire installation*}
   Begin
   Log.Add('Installing application');
   Log.Add('    Save information in "'+FName2+'"');
   Ini_UpdateKey(FName, 'System','Installed applications',+1);

   If Not Ini_Init(Ini,FName2) Then Exit;{*Cannot write !*}

   Ini_SaveKey(Ini,'Installation','Title',    Application.Name);
   Ini_SaveKey(Ini,'Installation','Name',     Midder(File_StrSplit(Get_AppName,$0004)));
   Ini_SaveKey(Ini,'Installation','Version',  Application.Version);
   Ini_SaveKey(Ini,'Installation','Copyright',Application.Copyright);
   Ini_SaveKey(Ini,'Installation','Author',   Application.Author);
   Ini_SaveKey(Ini,'Installation','Drawer',   Dsk_ValideDirectory(Dsk_GetHome));
   Ini_SaveKey(Ini,'Installation','Creation date',      Application.Date);
   Ini_SaveKey(Ini,'Installation','Installation date',  Time_GetSDate+' at '+Time_GetSTime(0)); {*Installation du Prog*}
   Ini_SaveKey(Ini,'Installation','System target',Application.MOSName+' '+Application.MOSVersion);
   Ini_SaveKey(Ini,'Installation','Compiled with','FPC v'+{$I %FPCVERSION%});
   Ini_Done(Ini);
   End;
End;

{ͻ
                           FUNCTION Process_Init                            
 ͹
  IN.....: /                                                                
  OUT....: (BOOLEAN) = TRUE if process information succesfully created.     
  EXPLAIN: Initialise the current MOS process multitasking.                 
 ͼ}

Function Process_Init:Boolean;
Var PRes:Boolean;
    PWin:TProcess;                      {*Windows process information*}
//    PApp:TProcess;                      {*Application process information*}

Begin
PWin.PId:=1;                            {*Build Windows process structure*}
Process_GetInfo(PWin);
Log.Add('    Process file "'+PWin.FName+'"');

If Not File_TestExist(PWin.FName) Then
  Begin
  PRes:=Process_UpdateInfo(PWin);   {*Create Window Process file if Needs*}
  End;

Process_Init:=PRes;
If Not PRes Then BSET(Id_Sys1,2);       {*Cannot create process information file*}
End;

{ͻ
                           PROCEDURE Process_Done                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Terminate the current MOS process.                               
 ͼ}

Procedure Process_Done;
Var PApp:TProcess;                      {*Windos process information*}
Begin
PApp.FName:=Process_GetFileName(PApp.PId);
If File_TestExist(PApp.FName) Then File_Erase(PApp.FName);
End;

{ͻ
                            PROCEDURE Done_Graph                            
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Close graphic mode and restore texte mode.                       
 ͼ}

Procedure Done_Graph;
Begin
If BTST(Id_Msg1,12) Then Exit;          {*On est dans un Programme Appel...*}

If Application.Mode = AMText Then Exit; {*Not in graphic mode*}

Log.Add('Close graphic');
VESA_CloseGraph;                        {*Ferme Mode Graphique*}
Log.Add('Restore text mode');
End;

{ͻ
                            PROCEDURE Done_Demo                             
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Finish the current demo and close attached file.                 
 ͼ}

Procedure Done_Demo;
Begin
If BTST(Id_Msg1,12) Then Exit;          {*On est dans un Programme Appel...*}
If Id_Msg1 And $400=$400 Then
   Begin
   Log.Add('Demo file closed');
   Writeln(Language.Loc(254)+Sys.DemoFile);
   End;
End;

{ͻ
                          PROCEDURE Done_Keyboard                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Restore keyboards options.                                       
 ͼ}

Procedure Done_Keyboard;
Begin
If BTST(Id_Msg1,12) Then Exit;          {*On est dans un Programme Appel...*}
Log.Add('Restore keyboard');
Kbd_SetSpeedKey(32,1);                  {*Mode Con Rate=32 Delay=1*}
End;

{ͻ
                           PROCEDURE Done_Objects                           
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Restore memory allocated by objects.                             
 ͼ}

Procedure Done_Objects;
Begin
If Assigned(Locale)      Then Begin Locale.Free;      Locale := NIL;     End;
If Assigned(Language)    Then Begin Language.Free;    Language := NIL;   End;
If Assigned(User)        Then Begin User.Free;        User := NIL;       End;
If Assigned(Sys)         Then Begin Sys.Free;         Sys := NIL;        End;
If Assigned(Log)         Then Begin Log.Free;         Log := NIL;        End;
If Assigned(Application) Then Begin Application.Free; Application:= NIL; End;
End;

{****************************************************************************}
{*** TApplication Class                                                   ***}
{****************************************************************************}

Constructor TApplication.Create;
Begin
Inherited Create(NIL, 0,0, VESA_GetMaxX, VESA_GetMaxY);

fActive      := Yes;                    {*Always when no threads*}
fState       := ASBoot;
fMode        := AMGraphic;
fExeName     := FExpand(ParamStr(0));
fTitle       := 'Unknown title';

fMOSName     := 'MOS';
fMOSVersion  := 'v4.00 Professional';
fVersionType := VTFreeware;

fName        := 'Unknown application';
fVersion     := 'v1.00';
fCopyright   := 'MOS Developments';
fAuthor      := 'Unknown';
fDate        := 'Unknown';
End;

Function TApplication.GetTypeCaption:String;
Var St               :String;
Begin
St := Language.Loc(266);
If St = Language.DefaultText Then St := 'Demo|Development|Registered|Freeware|Unknown';
Case fVersionType of
   VTDemo        : Result := Str_Get(St,1,'|');
   VTDevelopment : Result := Str_Get(St,2,'|');
   VTRegistered  : Result := Str_Get(St,3,'|');
   VTFreeware    : Result := Str_Get(St,4,'|');
   Else            Result := Str_Get(St,5,'|');
   End;
End;

Procedure TApplication.SetState(S:TApplicationStates);
Begin
If S = fState Then Exit;
fState := S;
End;

Procedure TApplication.SetMode(M:TApplicationModes);
Begin
If M = fMode Then Exit;
fMode := M;
End;

Procedure TApplication.SetTitle(T:String);
Begin
If T = fTitle Then Exit;
fTitle := T;
End;

Function TApplication.GetActive:Boolean;
Begin
Result := fActive;
End;

Function TApplication.TestRegistered:Boolean;
Begin
If fVersionType = VTDemo Then Result := No Else Result := Yes;
End;

Function TApplication.ManageRegistered:Boolean;
Begin
If (fVersionType = VTDemo) And (Sys.DisplayRegister = RRNoDisplay) And (Random(10) = 0) Then
   Begin
   Sys.DisplayRegister := RRToDisplay;  {*Call Register Request*}
   Result := Yes;
   End
Else
   Begin
   Result := No;
   End;
End;

{ͻ
                     PROCEDURE TApplication.SetInformation                  
 ͹
  IN.....: pName (STRING) = Application name.                               
           pVersion (STRING) = Application version and revision.            
           pCopyright (STRING) = Application copyright.                     
           pAuthor (STRING) = Application author name.                      
           pDate (STRING) = Application date and time.                      
  OUT....: /                                                                
  EXPLAIN: Define the current application parameters.                       
 ͼ}

Procedure TApplication.SetInformation(pName,pVersion,pCopyright,pAuthor,pDate:String);
Begin
fName      := pName;
fVersion   := pVersion;
fCopyright := pCopyright;
fAuthor    := pAuthor;
fDate      := pDate;
End;

{ͻ
                   Class PROCEDURE TApplication.Initialize                  
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Initialise all data for the application.                         
 ͼ}

Class Procedure TApplication.Initialize;
Begin
Init_Log;                               {*Initialise the Log file*}
Init_App;                               {*Init application object*}
Init_SetVar;                            {*Initialise les Variables de Base*}
End;

{ͻ
                          PROCEDURE TApplication.Run                        
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Initialise all the rest of data and run MOS system application.  
 ͼ}

Procedure TApplication.Run;
Begin
If fState = ASRun Then Exit;            {*Application yet initialized*}
fState := ASBoot;

Init_TestConfig;                        {*Test Hardware and Software configuration*}
Init_CmdCommand;                        {*Read a command line in text file*}
Init_CmdDebug;                          {*Initialise the Debug mode*}
Init_TempDrawer;                        {*Make Temporary drawers on C if needs*}
Init_CmdHome;                           {*Set program directory as default*}
Init_CmdLoadIni;                        {*Manage initialisation file*}
Init_CmdSetWd;                          {*Set Working Directory*}
Init_SearchWd;                          {*Search WD in environment variables*}
Init_Statistics;                        {*Add statistics into system*}
Init_CmdLoc;                            {*Check requested language*}
Init_Locale;                            {*Load locale language in memory*}

If Application.Mode = AMGraphic Then    {*Graphic application*}
   Begin
   Init_CmdLoadTheme;                   {*Load main theme if needs*}
   Init_CmdBmp;                         {*Specify background image*}
   Init_CmdMsgUser;                     {*Display user message*}
   Init_CmdHiddenPart;                  {*Set MOS hidden part mode*}
   Init_CmdNoSound;                     {*Don't initialise sounds*}
   Init_CmdGfxMode;                     {*Set graphic mode to 'X'*}
   Init_CmdHelp;                        {*Help displaying*}
   Init_CmdSave;                        {*Test Save command*}
   Init_CmdQuit;                        {*Test Quit command*}
   Init_CmdErrorDemo;                   {*Test for errors in demo commands*}
   Init_CmdRecordDemo;                  {*Start to record MOS demo*}
   Init_CmdPlayDemo;                    {*Start to play MOS demo*}
   Init_VarGraph;                       {*Initialise all for the graphic*}
   End
Else
   Begin                                {*Text application*}
   Init_CmdMsgUser;                     {*Display user message*}
   Init_CmdHiddenPart;                  {*Set MOS hidden part mode*}
   Init_CmdNoSound;                     {*Don't initialise sounds*}
   Init_CmdHelp;                        {*Help displaying*}
   Init_CmdSave;                        {*Test Save command*}
   Init_CmdQuit;                        {*Test Quit command*}
   End;
Init_CheckSystem;                       {*Create Sub-System directories*}
Init_Process;                           {*Initialise le processus courrant*}
Init_InstallApp;                        {*Check first installation*}
Init_Sound;                             {*Init sound and play if needs*}

Init_BootGfx;                           {*Display boot image*}
Init_Graph;                             {*Initialisation du mode graphique*}
Init_Keyboard;                          {*Initialise keyboard*}
Init_MouseDriver;                       {*No mouse driver*}
Init_MouseVar;                          {*Initialise mouse variables*}
Init_Display;                           {*Display Desktop and init some Gfx*}

Init_Register;                          {*Requeter Register*}
Init_Password;                          {*Password pour Connection*}
Init_BootApp;                           {*Lauch boot applications*}

Application.State := ASRun;             {*Application running*}
Log.Add('---------------------');
End;

{ͻ
                        PROCEDURE TApplication.Close                        
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Restore all data for the application.                            
 ͼ}

Procedure TApplication.Close;
Begin
If fState <> ASRun Then Exit;           {*Application not running*}
fState := ASClose;                      {*Application running now*}

Log.Add('---------------------');

Done_MouseVar;                          {*Restore mouse parameters*}

Done_Graph;                             {*Ferme Mode Graphique*}
Done_Demo;                              {*Close current demo*}
Done_Message;                           {*Message de fin si demo version*}
Done_Keyboard;                          {*Restore keyboard options*}

Done_Sound;                             {*Play end sound and Stop Buzzer*}
Done_Process;                           {*Clear disk process information*}
Done_Locale;                            {*Remove locale file from memory*}
Done_SystemDrawer;                      {*Vire le Drawer temporaire*}

Done_Debug;                             {*Close the Debug mode*}
Done_Objects;                           {*Free memory allocated by objects*}
End;

{*-------------------------- PROGRAMME PRINCIPAL ---------------------------*}

Begin
End.
