{ͻ
                              UNIT MosHardware                              
 ͹
  CREATOR....: PLANAS Jean-Pierre                                           
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 22.01.1999                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: PC hardware requesters.                                      
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 259 Lines and (10.128 Bytes compiled)                        
  LAST UPDATE: 29.12.1999 at 14:59                                          
 ͼ}

UNIT MosHardware;

INTERFACE

{$IFDEF FPC}
 {$ASMMODE intel}{$MODE objfpc}
{$ENDIF}

{|Miscellaneous hardware requesters|}
Procedure Req_Memory  (X1,Y1:Integer; Name:String); {*Display memory information*}
Procedure Req_GetGraphicCardInfo(Px,Py:Integer);    {*Display graphic card information*}
Procedure Req_AvailableGraphicCards(Px,Py:Integer); {*Display managed graphic cards*}

{*----------------------------- Debut Library ------------------------------*}

IMPLEMENTATION

Uses
     SysUtils,
     MosBase,
     MosColors,
     MosConfig,
     MosErrors,
     MosMemory,
     MosGadgets,
     MosGraph,
     MosImages,
     MosList,
     MosStrings,
     MosTab,
     MosText,
     MosTools,
     MosWindows;

{ͻ
                      PROCEDURE Req_GetGraphicCardInfo                      
 ͹
  IN.....: Px,Py (INTEGER) = X,Y coordinates for the requester.             
  OUT....: /                                                                
  EXPLAIN: Display graphic card information.                                
 ͼ}

Procedure Req_GetGraphicCardInfo(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flag*}
    But1,But2     :TButton;             {*Buttons Structure*}
    B1            :TButton;
    Tab1          :TTabs;               {*Tab structure*}
    List          :TList;               {*Device information*}
    Text          :TText;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
Tabs (008,008,290,268,Tab1.No, CLLightGrey,CLLightGrey,$0014,Tab1,Language.Loc(1743));

Case Tab1.No of                         {*Display Tabs components*}
   1: Begin
      BMP_ShowTransparency (021,032,021+120,032+100, 0,0,Sys.GetPath(SP_BUTTONS)+'Ico_comp.bmp',$0080,CLTransparency);
      Display(066,034,CLText, Str_Get(Language.Loc(1744),1,'|')+'XXX');
      Display(066,045,CLText, Str_Get(Language.Loc(1744),2,'|')+GraphicCard_GetVendor);
      Display(066,056,CLText, Str_Get(Language.Loc(1744),3,'|')+'XXX');
      Tool_line(012,076,285,076,1,1);
      Display(020,084,CLText, Str_Get(Language.Loc(1744),4,'|')+GraphicCard_GetMemory+Str_Get(Language.Loc(268),2,'|'));
      Display(020,095,CLText, Str_Get(Language.Loc(1744),5,'|')+GraphicCard_GetSlot);
      Display(020,106,CLText, Str_Get(Language.Loc(1744),6,'|')+'GraphiX v3.00g');
      Display(020,117,CLText, Str_Get(Language.Loc(1744),7,'|')+GraphicCard_GetVBEName);
      Tool_line(012,137,285,137,1,1);
      Tool_line(012,137,285,137,1,1);
      Button (020,147,180,-1, CLTextButton,CLBgButton,$0000,B1,Language.Loc(1745));
      Display_Shade (009,169,289,181, Sys.PanelShadeCol1,Sys.PanelShadeCol2, 0);
      Display_Define(Text,020,169,-1,CLText,'APLA.CHR',4,TJOnLeft,$0022,Language.Loc(1746));
      Display_Draw  (Text);

      List_Show(List);
      End;
   End;

Button (060,274,080,-1, CLTextButton,CLBgButton,$0110,But1,'_OK',MPHand,'');
Button (160,274,080,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+300,Py+HaF1+300,$51D9,Language.Loc(341),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBg,$0A50,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

Tab1.No:=1;
XOk:=No; XCancel:=No;                   {*Init Exit Flag*}
List_Define (List,'Information',';',020,187,277,260, 100, CLLightGrey,CLLightGrey,$1308);
List_AddItem(List,Language.Loc(1737),Insert_Append);
List_AdjustColumns(List);
REDRAW_FRAME;                           {*Display Window Content*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes;
   If Button_GetMsg(But2,1)=CMSelected Then XCancel:=Yes;
   If Button_GetMsg(B1,  1)=CMSelected Then Req_AvailableGraphicCards(W1.X1+20,W1.Y1+30);
   If Tabs_GetMsg  (Tab1,1)=CMSelected Then REDRAW_FRAME;
   Win_Clip(No,W1);                     {*Clipping Window*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;     {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flag*}

Win_Done(W1);                           {*Close Window if Needs*}
List_Done(List);
End;

{ͻ
                    PROCEDURE Req_AvailableGraphicCards                     
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: Display managed graphic cards.                                   
 ͼ}

Procedure Req_AvailableGraphicCards(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk           :Boolean;             {*Exit Flags*}
    But1          :TButton;             {*Buttons Structure*}
    L1,L2         :TList;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_syst.bmp',$0080);
BMP_ShowTransparency (120,017,300+120,017+100, 0,0,Sys.GetPath(SP_BUTTONS)+'Ico_netw.bmp',$0080,CLTransparency);
Button   (235,204,080,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
Display  (170,15,CLText,Language.Loc(212)+'XXX');
(* ZUUL
Display  (170,25,CLText,Language.Loc(333)+GraphicCard_GetVendor);
*)
List_Show(L1);
List_Show(L2);
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{******************************** INIT ALL **********************************}

Procedure INIT_MODEL;
Var ModelFile:String;
Begin
List_Reset(L2);
ModelFile:=List_GetStringCell(L1,List_GetTaggedItem(L1),2);
List_Load(L2,Sys.GetPath(SP_DATAS)+ModelFile);
List_AdjustColumns(L2);
List_Sort(L2,1,Sort_AZ,1);
List_SetPosition(L2,1);
List_SetIdMore(L2,$000A);
End;

Procedure INIT_VENDORANDMODEL;
Begin
List_Define(L1,Language.Loc(335),';',119,047,310,186, 500, CLDataZone,CLDataZone,$1309);
List_Load(L1,Sys.GetPath(SP_DATAS)+'Gfx_main.lis');
List_AdjustColumns(L1);
List_HideColumn(L1,2,Yes);
List_TagItem(L1,1);                     {*Tag the first item*}
List_Sort(L1,1,Sort_AZ,1);
List_SetIdMore(L1,$000A);

INIT_MODEL;                             {*Init card model*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+550,Py+HaF1+230,$51D9,Language.Loc(336),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

XOk:=No;                                {*Init Exit Flags*}
List_Define(L2,Language.Loc(336),';',320,047,520,186, 500, CLDataZone,CLDataZone,$1309);

INIT_VENDORANDMODEL;                    {*Init all data*}
REDRAW_FRAME;                           {*Display Window Content*}

Repeat
try

If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes;
   If List_Test(L1)>0 Then              {*Manage lists*}
      Begin
      INIT_MODEL;                       {*Init card model*}
      List_Show(L2);
      End;
   List_Test(L2);
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XOk:=Yes;         {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk);                            {*Exit Flags*}

List_Done(L2);
List_Done(L1);
Win_Done(W1);                           {*Close Window if Needs*}
End;

{ͻ
                            PROCEDURE Req_Memory                            
 ͹
  IN.....: X1,Y1 (INTEGER) = Requester position.                            
           Name (STRING) = Window title.                                    
  OUT....: /                                                                
  EXPLAIN: Display some information about memory.                           
 ͼ}

Procedure Req_Memory(X1,Y1:Integer; Name:String); {*Aff Paramtres Mmoire*}
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1          :TButton;             {*Structure Boutons*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);                       {*Clipping de la Fentre*}
BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_memo.bmp',$0080);
Bevel_Mos(119,020,347,187, CLMauve,CLWhite ,BLLoweredLine,BLRaisedLine,Yes,Language.Loc(96));

Display    (215,041, CLText,Language.Loc(85));
Bevel_Title(130,040,203,055, CLSky,CLText,BLLoweredLine,BLNoLine,TJOnCenter,TJOnCenter,Yes,'LITT.CHR',4,$0063, Str_L2S(Sys.InitialMemory Div 1024)+Str_Get(Language.Loc(268),1,'|'));
Display    (215,061, CLText,Language.Loc(86));
Bevel_Title(130,060,203,075, CLSky,CLText,BLLoweredLine,BLNoLine,TJOnCenter,TJOnCenter,Yes,'LITT.CHR',4,$0063, Str_L2S(MemAvail Div 1024)+Str_Get(Language.Loc(268),1,'|'));
Display    (215,081, CLText,Language.Loc(87));
Bevel_Title(130,080,203,095, CLSky,CLText,BLLoweredLine,BLNoLine,TJOnCenter,TJOnCenter,Yes,'LITT.CHR',4,$0063, Str_L2S(MaxAvail Div 1024)+Str_Get(Language.Loc(268),1,'|'));
Display    (130,110, CLText,Language.Loc(267));
BMP_ShowTransparency (140,127,140+100,127+054, 0,0,Sys.GetPath(SP_IMAGES)+'Ram.bmp',$0080,CLTransparency);

Button (145,204,080,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
Win_Clip(No,W1);                        {*Restore le Clipping Normal*}
End;

{************************** PROCEDURE PRINCIPALE ****************************}

Begin
If Not Win_Init(X1,Y1,X1+370,Y1+HaF1+230,$51D9,Name,W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWInBorder,$0A10,W1);  {*Supplment*}
Win_Draw(W1);                           {*Affiche la Fentre*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False;                        {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Teste si Fentre Prte*}
   Begin
   Win_Clip(Yes,W1);                    {*Clipping*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True;
   Win_Clip(No,W1);                     {*Clipping*}
   End;

Even:=Win_Test(W1);

If Even=CMClosed Then Exit_Flg:=True;   {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until Exit_Flg=True;                    {*Flag de Sortie*}

Win_Done(W1);                           {*Supprime Fentre*}
End;

{*-------------------------- PROGRAMME PRINCIPAL ---------------------------*}


Begin
End.
