unit moswinclasses;

interface

uses
  classes,moswindows,moscontrols;

type
  TMOSWindow = class(TComponent)
  private
    FMosWindow: moswindows.TWindow;
    FFlags: word;
  public
    constructor Create(ALeft,ATop,ARight,ABottom: Integer; Flags: Word; AName: String);
    constructor Define(ALeft,ATop,ARight,ABottom: Integer; Flags: Word; AName: String);
    destructor Destroy; override;
    procedure Clear;
    procedure Clip(yes: Boolean);
    procedure Done;
    procedure Draw;
    function GetMsg: Integer;
    procedure Hide;
    procedure IdCmp(value: word);
    procedure IdRes(value: word);
    function Ready: Boolean;
    procedure Rename(NewName: String);
    function Sup(Xu,Yu,Xv,Yv,XMin,YMin,XMax,YMax,BarSld:Integer;Coul:LongInt; _IDRES:Word):Boolean;
    procedure Zoom(mode: boolean);
  end;
  AWindow = TMosWindow;

  TFormWindow = class(moscontrols.TControl)
  private
    FName: String;
    FXPos,FYPos: Integer;
  public
    constructor Create(AOwner: TComponent; X,Y: Integer; AName: String);
  end;
  BWindow = TFormWindow;

implementation

constructor TMosWindow.Create(ALeft,ATop,ARight,ABottom: Integer; Flags: Word; AName: String);
begin
  inherited Create(self);
  Win_Init(ALeft,ATop,ARight,ABottom,Flags,AName,FMosWindow);
end;

constructor TMosWindow.Define(ALeft,ATop,ARight,ABottom: Integer; Flags: Word; AName: String);
begin
  inherited Create(self);
  Win_Init(ALeft,ATop,ARight,ABottom,Flags,AName,FMosWindow);
end;

destructor TMosWindow.Destroy;
begin
  Done;
  inherited Destroy;
end;

procedure TMosWindow.Clear;
begin
  Win_Clear(FMosWindow);
end;

procedure TMosWindow.Clip(yes: Boolean);
begin
  Win_Clip(yes,FMosWindow);
end;

procedure TMosWindow.Done;
begin
  Win_Done(FMosWindow);
end;

procedure TMosWindow.Draw;
begin
  Win_Draw(FMosWindow);
end;

function TMosWindow.GetMsg: Integer;
begin
  GetMsg := Win_Test(FMosWindow);
end;

procedure TMosWindow.Hide;
begin
  Win_Hide(FMosWindow);
end;

procedure TMosWindow.IdCmp(value: word);
begin
  Win_IdCmp(value, FMosWindow);
end;

procedure TMosWindow.IdRes(value: word);
begin
  Win_IdRes(value, FMosWindow);
end;

function TMosWindow.Ready: Boolean;
begin
  Ready := Win_Ready(FMosWindow);
end;

procedure TMosWindow.Rename(NewName: String);
begin
  Win_Rename(NewName, FMosWindow);
end;

function TMosWindow.Sup(Xu,Yu,Xv,Yv,XMin,YMin,XMax,YMax,BarSld:Integer;Coul:LongInt; _IDRES:Word):Boolean;
begin
  Sup := Win_Sup(Xu,Yu,Xv,Yv,Xmin,Ymin,Xmax,Ymax,BarSld,Coul,_IDRES,FMosWindow);
end;

procedure TMosWindow.Zoom(mode: boolean);
begin
  Win_Zoom(mode, FMosWindow);
end;


constructor TFormWindow.Create(AOwner: TComponent; X,Y: Integer; AName: String);
begin
  inherited Create(AOwner);
  SetX1(X); SetY1(Y);
end;

end.
