{ͻ
                              UNIT MosWindows                               
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 15.12.1993                                                   
  COUNTRY....: Montpellier - IUT (FRANCE)                                   
  DESCRIPTION: Windows Management.                                          
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 1.413 Lines and (33.136 Bytes compiled)                      
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosWindows;

{$Mode ObjFpc}

INTERFACE

Uses
     MosGraphics,
     MosGadgets,
     MosKeyboard,
     MosText;

const
  VK_CONTROL = $8000;
  VK_F4      = $0073;
  VK_ESCAPE  = $001B;

Type TWinStack=Record                    {*Stack and windows layers*}
     X1,Y1,X2,Y2:Integer;                {*Coordinates*}
     End;

    TWindow=Record                       {*Window structure*}
    X1,Y1,X2,Y2  :Integer;               {*Main coordinates*}
    Xa,Ya,Xb,Yb  :Integer;               {*Previous coordinates before move*}
    Xu,Yu,Xv,Yv  :Integer;               {*Second coordinates for extend*}
    XMin,YMin    :Integer;               {*Minimum size of window*}
    XMax,YMax    :Integer;               {*Maximum size of window*}
    Xo,Yo        :Integer;               {*Old Position of Window when Move*} {MIC}
    Name         :String[60];            {*Window title*}
    Close        :TButton;               {*Structure Gadget Close Window*}
    Swap         :TButton;               {*Structure Gadget Swap Window*}
    Extend       :TButton;               {*Structure Gadget Extend Window*}
    Size         :TButton;               {*Structure Gadget Size Window*}
    Context      :TScreenContext;        {*Window context to restore*}
    Displayed    :Boolean;               {*Window is currently displayed*}

    IDCMP        :Word;                  {*Flags Id Window*}
           {*Bit 0  $0001 = Activated      1 = Window Activated*}
           {*Bit 1  $0002 = Extended       1 = Enable Extend*}
           {*Bit 2  $0004 = Size           1 = Enable Resize*}
           {*Bit 3  $0008 = Swap           1 = Enable window Swapping*}
           {*Bit 4  $0010 = Close          1 = Enable Close window*}
           {*Bit 5  $0020 = Backdrop       1 = Window always on back*}
           {*Bit 6  $0040 = Block          1 = Window limited on screen*}
           {*Bit 7  $0080 = Title          1 = Display window title*}
           {*Bit 8  $0100 = Border         1 = Display window borders*}
           {*Bit 9  $0200 = Cursor         1 = Mannage window cursor*}
           {*Bit 10 $0400 = Locked         1 = Window status locked*}
           {*Bit 11 $0800 = Sensitive      1 = Active window is mouse over*}
           {*Bit 12 $1000 = Multi-Windows  1 = Modale window*}
           {*Bit 13 $2000 = Transparent    1 = Transparent background*}
           {*Bit 14 $4000 = Move           1 = Enable window deplacement*}
           {*Bit 15 $8000 = Relief         1 = Reliefs borders*}

    IDRES        :Word;                  {*Id Flags*}
           {*Bit 0  $0001 = Zoom Window     1 = Zoom window when Open and Close*}
           {*Bit 1  $0002 = Whole Move      1 = Move window cliking on all his surface*}
           {*Bit 2  $0004 = Window Centered 1 = Center window on screen*}
           {*Bit 3  $0008 = Task Window Off 1 = Inhibe le Task Window*} {MIC}
           {*Bit 4  $0010 = Close ESC       1 = Enable ESC key to close window*}
           {*Bit 5  $0020 = Move with RMB   1 = Move window with RMB*}
           {*Bit 6  $0040 = No Pro-Look     1 = Do not display internal box*}
           {*Bit 7  $0080 = Free*}
           {*Bit 8  $0100 = Reserved        Transmission Refresh Contenu Window*} {MIC}
           {*Bit 9  $0200 = Reserved        Test for Zoom Window 1 Time Only*} {MIC}
           {*Bit 10 $0400 = Reserved        Test Active Window - MSE Click*} {MIC}
           {*Bit 11 $0800 = Reserved        Gestion Layers. Priority Window*} {MIC}
           {*Bit 12 $1000 = No shade in title*}
           {*Bit 13 $2000 = Wait when window is killed*}

    FlgM         :Boolean;               {*Flag Window is Moving*} {MIC}
    FlgS         :Boolean;               {*Flag Window is Resizing*} {MIC}
    FClick       :Boolean;               {*Internal Flag for Click & Move TWindow*} {MIC}
    Destroyed    :Boolean;               {*1 =  Window has been destroyed*}
    BarSld       :Integer;               {*Number of sliders*}
    Num          :Byte;                  {*Window number*}
    Coul         :LongInt;               {*Window background color*}
    NbGsp        :Byte;                  {*Nb de Gadgets Sp sur Barre Wind*} {MIC}
    Curs         :TKbdLocate;            {*Structure for cursor*}
    Sw           :TRefresh;              {*Structure for deplacement*}
    MsePointerMode :Byte;
    End;

Function  Win_Init(X1,Y1,X2,Y2:Integer; IDCMP:Word; Name:String; Var W:TWindow):Boolean; {*Define a window*}
Function  Win_Sup(Xu,Yu,Xv,Yv,XMin,YMin,XMax,YMax,BarSld:Integer;Coul:LongInt; IDRES:Word; Var W:TWindow):Boolean;{*Define more*}
Procedure Win_Done(Var W:TWindow);                {*Kill the window*}
Procedure Win_Draw(Var W:TWindow);                {*Draw the Window*}
Procedure Win_Hide(Var W:TWindow);                {*Hide the Window*}
Function  Win_Test(Var W:TWindow):Integer;        {*Manage the window*}
{Function  Win_Move(Var W:TWindow):Boolean;}      {*Move the Window*}
{Procedure Win_Task(Var W:TWindow);}              {*Mannage multi-windows*}
Procedure Win_Clip(Clip:Boolean; Var W:TWindow);  {*Clip the window*}
Procedure Win_Zoom(Mode:Boolean; Var W:TWindow);  {*Made a zoom on the window*}
Procedure Win_IdCmp(IDCMP:Word; Var W:TWindow);   {*Modify window's IDCMP*}
Procedure Win_IdRes(IDRES:Word; Var W:TWindow);   {*Modify window's IDRES*}
Procedure Win_Clear(Var W:TWindow);               {*Clear the window (Clrscr)*}
Procedure Win_Rename(NewName:String; Var W:TWindow);{*Modify window title*}
Function  Win_Ready(Var W:TWindow):Boolean;       {*Test if window is ready*}

{Function  Get_ActivePage:Byte;}          {*Renvois le Numro de la Page Active*}

IMPLEMENTATION

Uses
    {$ifdef MSWINDOWS} Windows, {$endif}
     MosBase,
     MosColors,
     MosConfig,
     MosCPUInstructions,
     MosCrt,
     MosErrors,
     MosGraph,
     MosImages,
     MosMouse,
     MosStrings,
     MosTasks,
     MosTools;

{*----------------------------- Debut Library ------------------------------*}

{ͻ
                             FUNCTION Win_Init                              
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Window coordinates                       
           IDCMP (WORD) = IDCMP Flags :                                     
             Bit 0  $0001 = Activated      1 = Window Activated             
             Bit 1  $0002 = Extended       1 = Enable Extend                
             Bit 2  $0004 = Size           1 = Enable Resize                
             Bit 3  $0008 = Swap           1 = Enable window Swapping       
             Bit 4  $0010 = Close          1 = Enable Close window          
             Bit 5  $0020 = Backdrop       1 = Window always on back        
             Bit 6  $0040 = Block          1 = Window limited on screen     
             Bit 7  $0080 = Title          1 = Display window title         
             Bit 8  $0100 = Border         1 = Display window borders       
             Bit 9  $0200 = Cursor         1 = Mannage window cursor        
             Bit 10 $0400 = Locked         1 = Window status locked         
             Bit 11 $0800 = Sensitive      1 = Active window is mouse over  
             Bit 12 $1000 = Multi-Windows  1 = Modale window                
             Bit 13 $2000 = Transparent    1 = Transparent background       
             Bit 14 $4000 = Move           1 = Enable window deplacement    
             Bit 15 $8000 = Relief         1 = Reliefs borders              
           Name (STRING) = Window title.                                    
           W (TWindow) = Pointer to the window structure.                   
  EXPLAIN: Initialise the window structure.                                 
  OUT....: (BOOLEAN) = TRUE: Initialisation Ok else FALSE.                  
  EXAMPLE: Win_Init(10,50,450,180,$13DE,'My Window',Win1);                  
 ͼ}

Function Win_Init(X1,Y1,X2,Y2:Integer; IDCMP:Word; Name:String; Var W:TWindow):Boolean;
Begin
Win_Init:=TRUE;                         {*Ok base...*}
Save_Context(W.Context,0);

Application.ManageRegistered;

Play_SoundAction(3);                    {*Play Sound Action...*}

VESA_SetViewPort(0,0,VESA_GetMaxX,VESA_GetMaxY,ClipOn);  {*Restore Normal ViewPort*}
Id_Scr1:=Id_Scr1 And ($FFFF-$8);        {*No Clipping Now !...*}
Mse_SetPointer(P_Current);              {*Pointer to be Current*}
Sys.CommandCount:=0;                    {*Prt  compter les "Commands"*}
If Y2-Y1<HaF1+4 Then Y2:=Y1+HaF1+4;     {*Correction Erreur Size Min*}
Sys.WinOpenCount := Sys.WinOpenCount + 1; {*Il y a une Fentre de Plus*}
Log.Add('Create new Window ('+Str_FillZero(Sys.WinOpenCount,2)+':Id='+Str_L2H(IdCmp,4)+' - '+Name+')',2);

Coord_WinInScreen(x1,y1,x2,y2);         {*Box en Dehors de l'cran ?*}

W.X1:=X1;                               {*Build Graphic Window Structure*}
W.Y1:=Y1;
W.X2:=X2;
W.Y2:=Y2;
W.IDCMP:=IDCMP;                           {*Flags IDCMP de la Fentre*}
W.IDRES:=$810;                            {*Enable Window Ready for Test Gadgets*}
W.Name:=Name;                             {*Nom de la Fentre*}
W.FlgM:=False;                            {*Not Moved Now*}
W.FlgS:=False;                            {*Not Sized Now*}
W.Destroyed:=False;                       {*Window Vivante*}
W.Xa:=X1; W.Ya:=Y1;                       {*Save Old Coordones Window for Move*}
W.Xb:=X2; W.Yb:=Y2;
W.Xu:=50; W.Yu:=50;                       {*Def Coordones Window for Extend*}
W.Xv:=350; W.Yv:=150;
W.XMin:=Length(Name)*6+20*2+20;           {*Limit a la taille du titre*}
W.YMin:=HaF1+4+20;
W.XMax:=VESA_GetMaxX;                     {*Taille Maximum de la Fentre*}
W.YMax:=VESA_GetMaxY;
W.Coul:=CLWinBg;                          {*Fond Gris Clair de Base*}

W.Curs:=TKbdLocate.Create;
W.Curs.Flg_Press:=True;                   {*Curseur Affich la 1ere Fois*}
W.Curs.Flg_Time:=False;                   {*Time for Cursor Init=0*}
W.BarSld:=0;                              {*Pas de Barres de Base*}
W.Displayed:=FALSE;                       {*Fentre pas encore affiche*}

W.Num:=Sys.WinOpenCount;                  {*Numro d'ordre*}
Id_Msg1:=Id_Msg1 And ($FFFF-$8);          {*Rinit Bool Pos Mouse for Pointer Style*}
BCLR(Id_Gad1,7);                          {*No hints displayed*}

If W.IDCMP And $200=$200 Then W.Curs.InitCursor(W.Curs.Style,W.Curs.Blink);
If Sys.WinActionType=0 Then Sys.WinFirstToSwap:=255;      {*Set for Search Lower Window*}

If (X1>=0) And (Y1>=0) And (X2<=VESA_GetMaxX) And (Y2<=VESA_GetMaxY) Then
   Begin
   If W.IDCMP And $1000=$1000 Then        {*Fentre Modale = Refresh Screen*}
      Begin
      W.Sw:=TRefresh.Create;              {*Initialise Structure Move Window*}
      W.Sw.GetImageFromScreen(W.X1,W.Y1,W.X2,W.Y2); {*Save Screen in Mem for Refresh It}
      End;
   End
   Else Begin W.Destroyed:=False;         {*Initialisation Coord Error*}
        Error(520);
        Sys.WinOpenCount := Sys.WinOpenCount - 1;
        Win_Init:=FALSE;                  {*Error !*}
        End;

W.NbGsp:=0;
If IDCMP And $8=$8 Then Inc(W.NbGsp,1);   {*Gadget Swap sur Barre Title*}
If IDCMP And $2=$2 Then Inc(W.NbGsp,1);   {*1 Gadgets Sp 2+ sur Barre Wind*}

Main_Task;                                {*Main Task*}
End;

{ͻ
                              FUNCTION Win_Sup                              
 ͹
  IN.....: Xu,Yu,Xv,Yv (INTEGER) = Coordinates for extended window .        
           X1,Y1,X2,Y2 (INTEGER) = Window minimum and maximum size.         
           BarSld (INTEGER) = Numbers and positions for the windows sliders.
              0 = No sliders                                                
              1 = Vertical Slider                                           
              2 = Horizontal Slider                                         
              3 = Horizontal + vertical Slider                              
           Coul (LONGINT) = Window background color.                        
           W (TWindow) = Pointer to the window structure.                   
  EXPLAIN: Initialise more parameters for the window.                       
  OUT....: (BOOLEAN) = TRUE: Initialisation Ok else FALSE.                  
  NB.....: This procedure must be always called after "Win_Init".           
           If you want to have a color fade in your window title,           
           you must call this procedure to define palette.                  
  EXAMPLE: Win_Sup(0,0,200,100,80,50,530,200,3,Col5,Win1);                  
 ͼ}

Function Win_Sup(Xu,Yu,Xv,Yv,XMin,YMin,XMax,YMax,BarSld:Integer;Coul:LongInt; IDRES:Word; Var W:TWindow):Boolean;
Var X1,Y1,X2,Y2:Integer;

Begin
Win_Sup:=TRUE;                          {*Des base...*}

If (Xu<0) Or (Yu<0) Or (Xu>VESA_GetMaxX) Or (Yu>VESA_GetMaxY) Then
   Begin Error(521); Exit; End;          {*2nd Size is out of Ranges*}
If (Xu<0) Or (Yu<0) Or (Xu>VESA_GetMaxX) Or (Yu>VESA_GetMaxY) Then
   Begin Error(522); Exit; End;          {*Min or Max Size are out of Ranges*}
If (BarSld<0) Or (BarSld>3) Then
   Begin Error(523); Exit; End;          {*Window Bars Parameter Error*}
If IDRES And $4=$4 Then                   {*On centre  l'Ecran*}
   Begin
   X1:=W.X1; Y1:=W.Y1 ;X2:=W.X2; Y2:=W.Y2;
   W.X1:=(VESA_GetMaxX Div 2)-((X2-X1) Div 2); {*New Coordones*}
   W.Y1:=(VESA_GetMaxY Div 2)-((Y2-Y1) Div 2);
   W.X2:=(VESA_GetMaxX Div 2)+((X2-X1) Div 2);
   W.Y2:=(VESA_GetMaxY Div 2)+((Y2-Y1) Div 2);
   Win_Done(W);                           {*Dtruit la Fentre Deja Cre*}
   Win_Init(W.X1,W.Y1,W.X2,W.Y2,W.IDCMP,W.Name,W);{*Reinit*}
   End;
W.Xu:=Xu;                                 {*Secondes coordones 2 la fentre*}
W.Yu:=Yu;
W.Xv:=Xv;
W.Yv:=Yv;
W.XMin:=XMin;                             {*Limite de la taille fentre*}
W.YMin:=YMin;
W.XMax:=XMax;
W.YMax:=YMax;
W.BarSld:=BarSld;                         {*Select Pos & Number Bar for Slider*}
W.Coul:=Coul;                             {*Couleur Fond de Fentre*}
W.Destroyed:=False;                       {*Window Vivante*}
IDRES:=IDRES Or $200;                     {*Set Internal Flags*}
IDRES:=IDRES Or $800;                     {*Enable Window Ready for Test Gadgets*}
W.IDRES:=IDRES;                           {*Flags IDRES de la Fentre*}

Main_Task;                                {*Main Task*}
End;

{ͻ
                             PROCEDURE Win_Draw                             
 ͹
  IN.....: W (TWindow) = Pointer to the window structure.                   
  OUT....: /                                                                
  EXPLAIN: Draw the window previously defined.                              
  EXAMPLE: Win_Draw(W);                                                     
 ͼ}

Procedure Win_Draw(Var W:TWindow);
Var PG,Haut:Shortint;                       {*Hauteur Barre pour Txt (Fnt)*}
    AE:Boolean;                             {*Teste si Window Invisible*}
    PDr:Byte;                               {*Position X Set Gadget on Title*}
    C1:Longint;                             {*Optimisations et Couleurs...*}
    O_Nbg:Integer;                          {*Optimisations*}
    O_B:Boolean;

Procedure DRAW_BORDER_TITLE(X1,Y1,X2,Y2:Integer; Fill:Boolean);
Begin
Bevel (X1,Y1,X2,Y2,W.Coul,BLRaisedLine,BLNoLine,No);
VESA_SetColor(CLFlamand); VESA_Rectangle(X1+1,Y1+1,X2-1,Y2-1);
Bevel (X1+2,Y1+2,X2-2,Y2-2,W.Coul,BLLoweredLine,BLNoLine,Fill);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not W.Destroyed Then                     {*Teste si fentre Vivante*}
Begin
If (W.IDRES And $1=$1) And (W.IDRES And $200=$200) Then
   Begin
   Win_Zoom(True,W);                        {*Zoom In sur la Fenetre*}
   W.IDRES:=W.IDRES And ($FFFF-$200);       {*Clear Bit 8*}
   End;

Font_Set(Sys.FontWinTitle,Sys.FontWinTitleSize);        {*Passe en Fonte Title Fentre*}
Haut:=HaF+4; PDr:=0;
PG:=(Haut Div 2)-6;                         {*Pos Centre du Gadget Spcial*}
If PG>50 Then PG:=0;                        {*Correction Erreur*}

O_Nbg:=W.X2-20*W.NbGsp;                     {*Optimisations*}

W.Displayed:=TRUE;                          {*Window is displayed now*}
Win_Rename(W.Name,W);                       {*Affiche le Titre de la Fentre*}
Font_Set(Sys.FontWinTitle,Sys.FontWinTitleSize);        {*Repasse en Fonte Title Fentre*}

Mse_Hide;
If (W.IDCMP And $80)=$80 Then
   Begin
   If (W.IDCMP And $10)=$10 Then            {*Affiche Gadget Close Window*}
      Begin
      Button(W.X1,W.Y1,19,HaF1+4,CLTextButton,CLBgButton,$20,W.Close,'','',Language.Loc(207));
      W.Close.ButSp:=6; Button_Draw(W.Close);
      End;

   If (W.IDCMP And $8)=$8 Then              {*Affiche Gadget Swap Window*}
      Begin
      Button(W.X2-19,W.Y1,19,HaF1+4,CLTextButton,CLBgButton,$20,W.Swap,'','',Language.Loc(133));
      W.Swap.ButSp:=7; Button_Draw(W.Swap); Inc(PDr,20);
      End;

   If ((W.IDCMP And $2)=$2) Then Begin      {*Affiche Gadget Extend Window*}
      Button(W.X2-19-PDr,W.Y1,19,HaF1+4,CLTextButton,CLBgButton,$20,W.Extend,'','',Language.Loc(223));
      W.Extend.ButSp:=8; Button_Draw(W.Extend); Inc(PDr,20);
      End;

   VESA_SetColor(CLLineDown);
   If O_Nbg>W.X1
      Then VESA_Line(O_Nbg, W.Y1, O_Nbg, W.Y1+Haut);
   End;
Mse_Show;

If (W.Y2-W.Y1<HaF1+10) And (BTST(W.IDCMP,7)) Then Exit; {*Taille Y Trop Petite...*}

Mse_Hide;
If (W.IDCMP And $2000)<>$2000 Then          {*Window Visible Not Transparent*}
   AE:=False Else AE:=True;
If (W.IDCMP And $100)=$100 Then             {*Draw Main Box Whith Border*}
   Begin
   If AE=False Then O_B:=True               {*Borders in Relief*}
               Else O_B:=False;
   If (W.IDCMP And $80)<>$80 Then           {*No Title*}
      If (W.IDCMP And $8000)=$8000
         Then DRAW_BORDER_TITLE(W.X1,W.Y1,W.X2,W.Y2,O_B)
         Else Bevel (W.X1,W.Y1,W.X2,W.Y2,{Sys.WindowBgPattern,}W.Coul,BLRaisedLine,BLNoLine,O_B)


      Else
      If (W.IDCMP And $8000)=$8000
         Then DRAW_BORDER_TITLE(W.X1,W.Y1+Haut+1,W.X2,W.Y2,O_B)
         Else Bevel (W.X1,W.Y1+Haut+1,W.X2,W.Y2,{Sys.WindowBgPattern,}W.Coul,BLRaisedLine,BLNoLine,O_B);
   End
   Else
   Begin
   If (W.IDCMP And $80)<>$80 Then
      If AE=False Then Bevel (W.X1,W.Y1,W.X2,W.Y2, W.Coul) Else
      Else If AE=False Then Bevel (W.X1,W.Y1+Haut+1,W.X2-1,W.Y2, W.Coul);
   End;

If (W.IDCMP And $4)=$4 Then                 {*Affiche Gadget Size Window*}
   Begin
   Button(W.X2-19,W.Y2-Haut,19,HaF1+4,CLTextButton,CLBgButton,$0020,W.Size,'','',Language.Loc(264));
{   W.Size.Pointer.MPointer:='MOVERD';}
   W.Size.ButSp:=9; Button_Draw(W.Size);
   If (W.IDCMP And $1)=$1 Then C1:=CLFlamand{*Draw Bar Hz ou Vert ou None*}
                          Else C1:=CLWinBg;
   If (W.BarSld=1) Or (W.BarSld=3) Then Bevel (W.X2-19,W.Y1+Haut+1,W.X2,W.Y2-Haut-1,C1,BLRaisedLine,BLNoLine,Yes);
   If (W.BarSld=2) Or (W.BarSld=3) Then Bevel (W.X1,W.Y2-Haut,W.X2-20,W.Y2,C1,BLRaisedLine,BLNoLine,Yes);

   VESA_Putpixel(W.X2-19,W.Y2, CLLineDown); {*Efface Points Disgracieux*}
   If (W.BarSld=2) Or (W.BarSld=3) Then VESA_Putpixel(W.X2-20,W.Y2-Haut,CLLineUp);
   End;

Mse_Show;
Font_Set(Sys.FontMain,Sys.FontMainSize);          {*Repasse en Fonte Courante*}

If Sys.WindowImage<>'' Then BMP_Show(W.X1+1,W.Y1+Haut+2,W.X2-1,W.Y2-1,0,0,Sys.WindowImage,$0080);
                                            {*Window Pro-Look*}
If W.IdRes And $40<>$40 Then Bevel (W.X1+LaF*2, W.Y1+HaF1+HaF, W.X2-LaF*2, W.Y2-HaF*2-HaF Div 2, CLWinBg,BLLoweredLine,BLNoLine,Yes);
End;                                        {*End Test Fentre Destroyed*}
End;

{ͻ
                             PROCEDURE Win_Task                             
 ͹
  IN.....: W (TWindow) = Pointer to the window structure.                   
  OUT....: /                                                                
  EXPLAIN: Mannage multi-windows layers.                                    
  EXAMPLE: Win_Task(W);                                                     
 ͼ}

Procedure Win_Task(Var W:TWindow);                {*Gere Multi-Windows*}
Begin
{gotoxy(1,1); writeln('WinCount=',Sys.WinOpenCount,' ');
gotoxy(1,2); If Sys.WinActionType<>0 Then writeln('Sys.WinActionType=',Sys.WinActionType,' ');}

{********* RECHERCHE PLUS BASSE FENETRE *}

If (Sys.WinActionType=0) And (W.Destroyed=False) Then     {*Search Lower Window*}
   If (W.NUM<Sys.WinFirstToSwap) And (W.NUM>0) Then Begin Sys.WinFirstToSwap:=W.NUM;
{Gotoxy(1,1); Writeln('Base: ',Sys.WinFirstToSwap);}
      End;

{Gotoxy(1,3+W.Num); Write(W.NUM);
If W.IDRES And $800=$800 Then Write(' - OK   ') Else Write(' -      ');}

{********* GESTION LAYERS ***********}

If (Sys.WinActionType=3) And (Sys.WinFirstToSwap=255) Then Sys.WinActionType:=0;    {*Correct Bugg*}

If (Sys.WinActionType=3) And (W.NUM=Sys.WinFirstToSwap) Then       {*Set Begining Window 1*}
   Begin Sys.WinInnerFlag:=True; Sys.WinToRefresh:=Sys.WinFirstToSwap; End;

If (Sys.WinActionType=3) And (Sys.WinInnerFlag=True) Then
   Begin

   W.IDRES:=W.IDRES And ($FFFF-$800);              {*Disable Bit to Test Gadgets*}
{Gotoxy(8,3+W.Num); Write('*');}

   If (WPMx>=W.X1) And (WPMx<=W.X2) And            {*Test si Mse is in Window*}
      (WPMy>=W.Y1) And (WPMy<=W.Y2) And
      (W.NUM>=Sys.WinFirstToSwap)
      Then Begin Sys.WinFirstToSwap:=W.NUM;        {*LMB dans Cadre Fentre*}
{gotoxy(1,3); Writeln('Sys.WinFirstToSwap: ',Sys.WinFirstToSwap,'  ');
Gotoxy(3,3+W.Num); Write('*');}
       End;

   Sys.WinToRefresh := Sys.WinToRefresh + 1;            {*Next Window*}
{gotoxy(50,2); Writeln('Refresh= ',Sys.WinToRefresh);}
   If Sys.WinToRefresh>Sys.WinOpenCount Then               {*Ending Scanning all Wind*}
      Begin Sys.WinActionType:=4;                          {*Set Terminaison Flag*}
      Sys.WinInnerFlag:=False;                             {*Rinit Flags*}
      End;
   End;

{Gotoxy(50,1); Writeln(Sys.WinInnerFlag,' ');
Gotoxy(1,2); Writeln('Sys.WinActionType: ',Sys.WinActionType,' - Sys.WinOpenCount: ',Sys.WinOpenCount);
gotoxy(50,3); Writeln('W.NUM= ',W.NUM);}

{********* SWAPPING WINDOWS *********}

If (Sys.WinActionType<=2) And (W.IDCMP And $1000=$1000) Then Sys.WinActionType:=0; {*Multi Win & ReTWindowsh*}
If (Sys.WinActionType<=2) And (Sys.WinOpenCount=1) And (W.IDCMP And $1000<>$1000) Then Sys.WinActionType:=0;{*1 Win & No RefTWindowh*}
{If (Sys.WinActionType=2) Or (Sys.WinActionType=1) Then Write(#7);}

If (Sys.WinActionType=2) And (W.NUM=1) Then                {*Wait for 1ere Fentre*}
   Begin Sys.WinInnerFlag:=True; Sys.WinToRefresh:=1; End;

If (Sys.WinActionType=2) And (Sys.WinInnerFlag=True) Then          {*Swapper Windows*}
   Begin
   If W.IDCMP And $20=$20                          {*Window Backdrop !*}
      Then Sys.WinFirstToSwap:=Sys.WinToRefresh+1               {*Mmo le Numro*}
      Else
      If (W.NUM>=Sys.WinFirstToSwap) And (W.NUM<=Sys.WinToSwap)
      Then If W.NUM=Sys.WinToSwap                     {*It's The Window to Swap*}
           Then W.NUM:=Sys.WinFirstToSwap
           Else Inc(W.NUM,1)                       {*Rotation Numros*}
      Else;                                        {*Number Not Changed !*}

   Sys.WinToRefresh := Sys.WinToRefresh + 1;            {*Next Window*}

   If Sys.WinToRefresh>Sys.WinOpenCount Then               {*Ending Swapping*}
      Begin Sys.WinActionType:=1;                          {*And Go to Refresh*}
      Sys.WinToRefresh:=1;
      Sys.WinInnerFlag:=False;                             {*Rinit Flags*}
      End;
   End;

{********* REFRESH WINDOWS *********}

If Sys.WinActionType=1 Then                                {*Rafraichir Windows*}
   Begin
   If Sys.WinToRefresh=W.NUM Then
      Begin
      Sys.WinToRefresh := Sys.WinToRefresh + 1;         {*Next Window*}
      W.IDRES:=W.IDRES Or $100;                    {*Window Will be Refresh*}
      Win_Draw(W);
      End;
   If Sys.WinToRefresh>Sys.WinOpenCount Then
      Begin Sys.WinActionType:=0; Sys.WinFirstToSwap:=255; End;    {*Ending Refresh*}
   End;
End;

{ͻ
                            PROCEDURE Win_Rename                            
 ͹
  IN.....: W (TWindow) = Pointer to the window structure.                   
           NewName (STRING) = New title.                                    
  OUT....: /                                                                
  EXPLAIN: Rename window title.                                             
  EXAMPLE: Win_Rename('I WANT SOME GIRLS',W);                               
  NB.....: The window must have his title displayed.                        
 ͼ}

Procedure Win_Rename(NewName:String; Var W:TWindow);
Var AddDtd,Haut:Byte;                       {*Hauteur Barre pour Txt (Fnt)*}
    X1vp,X2vp:Integer;                      {*XMin et XMax du Viewport Title*}
    C1,C2:Longint;                          {*Optimisations et Couleurs...*}
    FirstColor,LastColor:Longint;           {*Shade colors*}

    Text1:TText;

Begin                                       {*Teste fentre Vivante & Title*}
If (W.Destroyed=False) And ((W.IDCMP And $80)=$80) Then Begin
   If W.IDCMP And $10=$10 Then AddDtd:=20 Else AddDtd:=0;{*Calcule Distance*}
   Haut:=HaF1+4;                            {*Hauteur Barre en Fonction Fonte*}
   X1vp:=W.X1+AddDtd+5;                     {*Calcul Bornes Viewport Title*}
   X2vp:=W.X2-20*W.NbGsp-5;

   W.Name:=NewName;                         {*Set new window name*}

   If (W.IDCMP And $1)=$1 Then Begin        {*Window Activated*}

      C1:=CLFlamand; C2:=CLTextTitle;
      FirstColor:=Sys.WinActiveCol1;
      LastColor :=Sys.WinActiveCol2;
      End
      Else Begin                            {*Window Inactivated*}

      C1:=CLWinBg; C2:=CLShadow;
      FirstColor:=Sys.WinInactiveCol1;
      LastColor :=Sys.WinInactiveCol2;
      End;

   Bevel (W.X1+AddDtd, W.Y1, W.X2-20*W.NbGsp, W.Y1+Haut, C1,BLRaisedLine,BLNoLine,Yes);
                                            {*Dgrad dans title*}
   If Not BTST(W.IDRES,12) Then
      Display_Shade(W.X1+AddDtd+1, W.Y1+1, W.X2-20*W.NbGsp-1, W.Y1+Haut-1, FirstColor,LastColor,0);

   If X2vp>X1vp Then Begin
      VESA_SetViewPort(X1vp,W.Y1+2,X2vp,W.Y1+Haut-1,ClipOn);
      Display_Define(Text1,1,0,C2,C2,Sys.FontWinTitle,Sys.FontWinTitleSize,TJOnLeft,$0024,W.Name);
      Display_Draw(Text1);
      End;

   Font_Set(Sys.FontMain,Sys.FontMainSize);       {*Repasse en Fonte Courante*}
   VESA_SetViewPort(0,0,VESA_GetMaxX,VESA_GetMaxY,ClipOff);{*Restore Normal ViewPort*}
   End;
End;

{ͻ
                            PROCEDURE Win_Clear                             
 ͹
  IN.....: W (TWindow) = Pointer to the window structure.                   
  OUT....: /                                                                
  EXPLAIN: Clear the window (as a Clrscr).                                  
  EXAMPLE: Win_Clear(W);                                                    
 ͼ}

Procedure Win_Clear(Var W:TWindow);
Var Rel,Haut,DelT:Byte;                      {*Hauteur Barre pour Txt (Fnt)*}
Begin
If Not W.Destroyed Then Begin                {*Teste si fentre Vivante*}
   If (W.IDCMP And $2000)<>$2000 Then        {*Window Visible not Transparent*}
      Begin
      If (W.IDCMP And $8000)=$8000           {*Borders in Relief*}
         Then Rel:=2 Else Rel:=0;
      Haut:=HaF1+4; DelT:=Haut+2;            {*Size Bar Title Etc (Fnt)*}
      If (W.IDCMP And $80)=$80 Then Inc(Haut,2) Else Haut:=1;

      If (W.IDCMP And $4)<>$4 Then Bevel(W.X1+1+Rel,W.Y1+Haut+Rel,W.X2-1-Rel,W.Y2-1-Rel, W.Coul)
         Else Begin
              If (W.BarSld=1) Or (W.BarSld=0) Then Bevel (W.X1+1+Rel,W.Y1+Haut+Rel,W.X2-20-Rel,W.Y2-1-Rel, W.Coul);
              If (W.BarSld=2) Or (W.BarSld=0) Then Bevel (W.X1+1+Rel,W.Y1+Haut+Rel,W.X2-1-Rel,W.Y2-DelT+1-Rel, W.Coul);
              If W.BarSld=3 Then Bevel (W.X1+1+Rel,W.Y1+Haut+Rel,W.X2-20-Rel,W.Y2-Haut+1-Rel, W.Coul);
              End;
      End;
   End;
End;

{ͻ
                             PROCEDURE Win_Clip                             
 ͹
  IN.....: Clip (BOOLEAN) = Clipping Status (TRUE = Clip window).           
           W (TWindow) = Pointer to the window structure.                   
  OUT....: /                                                                
  EXPLAIN: Enable or disable the window clipping.                           
  EXAMPLE: Win_Clip(TRUE,W);                                                
  NB.....: When you display or test gadgets, the clipping must be set.      
 ͼ}

Procedure Win_Clip(Clip:Boolean; Var W:TWindow);     {*Clipping Window*}
Var Haut:Byte;                               {*Hauteur Barre pour Txt (Fnt)*}
    Rel :Byte;                               {*Border in Relief or No*}
Begin
If Not W.Destroyed Then Begin                {*Teste si fentre Vivante*}
   Haut:=HaF1+4;                             {*Size Bar Title Etc (Fnt)*}
   Id_Scr1:=Id_Scr1 And ($FFFF-$8);          {*No Clipping is Signaled !*}
   If Clip=True Then
      Begin
      Id_Scr1:=Id_Scr1 Or $8;                {*Clipping Signaled to Everyone !*}
      If (W.IDCMP And $8000)=$8000           {*Borders in Relief*}
         Then Rel:=2 Else Rel:=0;

      If (W.IDCMP And $80)=$80 Then Inc(Haut,2) Else Haut:=1; {*No title ?*}
      T_Clip.X1:=W.X1+1+Rel;
      T_Clip.Y1:=W.Y1+Haut+Rel;              {*Save Coord Clip Window...*}
      T_Clip.X2:=W.X2-1-Rel;
      T_Clip.Y2:=W.Y2-1-Rel;
      VESA_SetViewPort(W.X1+1+Rel, W.Y1+Haut+Rel, W.X2-1-Rel, W.Y2-1-Rel,Clip);
      End
      Else VESA_SetViewPort(0,0,VESA_GetMaxX,VESA_GetMaxY,Clip);
   End;
End;

{ͻ
                             PROCEDURE Win_Zoom                             
 ͹
  IN.....: Mode (BOOLEAN) = FALSE = Zoom In, TRUE = Zoom Out.               
           W (TWindow) = Pointer to the window structure.                   
  EXPLAIN: Made a Zoom on a window. Zoom center is set on the mouse position
  OUT....: /                                                                
  EXAMPLE: Win_Zoom(W);                                                     
 ͼ}

Procedure Win_Zoom(Mode:Boolean; Var W:TWindow);  {*Comme Zoom Window v1.2*}
Var X,Y:Word;
    Ga,Mi,Dr:Boolean;
    X1r,Y1r,X2r,Y2r:Real;                   {*Valeurs des Ratios Respectifs*}
    X1,Y1,X2,Y2    :Real;                   {*Coordones du Box*}

Procedure DRAW_RECTZOOM;                    {*Draw VESA_Rectangle ZooM*}
Begin
VESA_Rectangle(Round(X1),Round(Y1),Round(X2),Round(Y2));
End;

{******************************** MAIN CODE *********************************}

Begin
Mse_Get(X,Y,Ga,Mi,Dr);                    {*Calcul Ratios*}

X1r:=(X-W.X1) / Real(Speed_Zoom);
Y1r:=(Y-W.Y1) / Real(Speed_Zoom);
X2r:=(X-W.X2) / Real(Speed_Zoom);
Y2r:=(Y-W.Y2) / Real(Speed_Zoom);

VESA_SetWriteMode(XorPut); VESA_SetColor(CLWinBg);
Mse_Hide;

If Mode=True Then               {*ZOOM Ouverture*}
   Begin
   X1:=X; Y1:=Y; X2:=X; Y2:=Y;
   DRAW_RECTZOOM;                           {*Draw First Cadre*}
      Repeat
      DRAW_RECTZOOM;                        {*Clear Old Cadre*}
      X1:=X1-X1r; Y1:=Y1-Y1r;               {*Calul New Position of Box*}

      X2:=X2-X2r; Y2:=Y2-Y2r;
      DRAW_RECTZOOM;                        {*Draw Main Cadre*}
      Delay(4);
      Until (X2-X1>W.X2-W.X1) Or (Y2-Y1>W.Y2-W.Y1);
   End

   Else                         {*ZOOM Fermeture*}
   Begin
   X1:=W.X1; Y1:=W.Y1; X2:=W.X2; Y2:=W.Y2;
   DRAW_RECTZOOM;                           {*Draw First Cadre*}
      Repeat
      DRAW_RECTZOOM;                        {*Clear Old Cadre*}
      X1:=X1+X1r; Y1:=Y1+Y1r;               {*Calul New Position of Box*}
      X2:=X2+X2r; Y2:=Y2+Y2r;
      DRAW_RECTZOOM;                        {*Draw Main Cadre*}
      Delay(4);
      Until (X1>X2) Or (Y1>Y2);
   End;

DRAW_RECTZOOM;                              {*Clean Last Cadre*}
Mse_Show;
VESA_SetWriteMode(NormalPut);
End;

{ͻ
                             PROCEDURE Win_Hide                             
 ͹
  IN.....: W (TWindow) = Pointer to the window structure.                   
  EXPLAIN: Hide the window.                                                 
           When the window is hidden, the windows cannot be managed.        
  OUT....: /                                                                
  EXAMPLE: Win_Draw(W);                                                     
 ͼ}

Procedure Win_Hide(Var W:TWindow);
Begin
If (Not W.Destroyed) And (Not W.FlgM) And (Not W.FlgS) Then  {*Fentre pas en action...*}
   Begin
   W.Displayed:=FALSE;                     {*Fentre plus affiche*}
   BCLR(Id_Msg1,3);                        {*Rinit Bool Pos Mouse for Pointer Style*}
   BCLR(Id_Gad1,5);                        {*Plus de Pointer Hand sur Gadgets*}
   BCLR(Id_Gad1,7);                        {*Plus de Info Box Affichs*}
   If W.IDCMP And $1000=$1000 Then         {*Fentre Modale = Refresh Screen*}
      Begin
      W.Sw.PutImageToScreen(W.Xa,W.Ya);    {*Refresh Screen Before Quit*}
      End;

   End;
End;

{ͻ
                             PROCEDURE Win_Done                             
 ͹
  IN.....: W (TWindow) = Pointer to the window structure.                   
  EXPLAIN: Kill the window (Destroy the structure).                         
  OUT....: /                                                                
  EXAMPLE: Win_Done(W);                                                     
 ͼ}

Procedure Win_Done(Var W:TWindow);
Begin
If Not W.Destroyed Then                    {*Teste si Fentre Vivante....*}
   Begin
   Log.Add('Kill Window ('+Str_FillZero(Sys.WinOpenCount,2)+':Id='+Str_L2H(W.IdCmp,4)+' - '+W.Name+')',2);
   Play_SoundAction(4);                    {*Play Sound Action...*}
   W.Destroyed:=TRUE;                      {*Fentre dsormais Dtruite*}
   W.Displayed:=FALSE;                     {*Fentre plus affiche*}
   Sys.WinOpenCount := Sys.WinOpenCount - 1;{*1 Fentre de Moins*}
   BCLR(Id_Msg1,3);                        {*Rinit Bool Pos Mouse for Pointer Style*}
   BCLR(Id_Gad1,5);                        {*Plus de Pointer Hand sur Gadgets*}
   BCLR(Id_Gad1,7);                        {*Plus de Info Box Affichs*}
   If W.IDRES And $1=$1 Then Win_Zoom(False,W);{*Zoom Out sur la Fentre*}
   If W.IDCMP And $1000=$1000 Then         {*Fentre Modale = Refresh Screen*}
      Begin
      W.Sw.PutImageToScreen(W.Xa,W.Ya);    {*Refresh Screen Before Quit*}
      W.Sw.Destroy;                        {*Destroy Structure Move Window*}
      End
      Else Begin
      Sys.WinActionType:=1;                {*On Active le Rafraichissement*}
      Sys.WinToRefresh:=1;                 {*TPointer First Window*}
      W.IDRES:=W.IDRES Or $100;            {*All Windows Will be Refreshed*}
      End;
   Mse_SetPointer(P_Current);
   BCLR(Id_Gad1,10);                       {*Mouse pointer not Busy*}
   Mse_SetLimit(0,0,VESA_GetMaxX,VESA_GetMaxY);
   If BTST(W.IdRes,13) Then Delay(100);    {*Eviter l'activation des gadgets de la fentre Mre*}
   Restore_Context(W.Context);
   End;
W.Curs.Free;
W.Curs:=nil;
End;

{ͻ
                             FUNCTION Win_Ready                             
 ͹
  IN.....: W (TWindow) = Pointer to the window structure.                   
  OUT....: (BOOLEAN) = TRUE = Window is ready (Gadgets can be tested).      
  EXPLAIN: Return TRUE if the window is ready.                              
  EXAMPLE: If Win_Ready(W) Then Begin End;                                  
 ͼ}

Function Win_Ready(Var W:TWindow):Boolean;         {*Teste si Fentre Prte*}
Begin

If ((W.FlgM=False) And (W.FlgS=False) And          {*Test Not Move & Not Size*}
   (W.IDCMP And $1=$1) And                         {*And Activate*}
   (W.IDRES And $800=$800) And                     {*Window Autorised to Test*}
   (W.Destroyed=FALSE) And                         {*Fentre Non Dtruite*}
   (W.Displayed=TRUE))                             {*Fentre affiche*}
(*  Or ((W.FlgM=False) And (W.FlgS=False) And        {*Test Not Move & Not Size*}
   (W.IDCMP And $1=$1) And                         {*And Activate*}
   (W.IDCMP And $400=$400)) *)                       {*Window Locked on Active*}
   Then Win_Ready:=True Else Win_Ready:=False;
End;

{ͻ
                            PROCEDURE Win_IdCmp                             
 ͹
  IN.....: IDCMP (WORD) = New IDCMP flags.                                  
           W (TWindow) = Pointer to the window structure.                   
  OUT....: /                                                                
  EXPLAIN: Set new IDCMP flags for a window.                                
  EXAMPLE: Win_IdCmp($47DE,W1);                                             

 ͼ}

Procedure Win_IdCmp(IDCMP:Word; Var W:TWindow);     {*Change IDCMP Fentre*}
Begin
W.IDCMP:=IDCMP;
W.NbGsp:=0;
If IDCMP And $8=$8 Then Inc(W.NbGsp,1);   {*Gadget Swap sur Barre Title*}
If IDCMP And $2=$2 Then Inc(W.NbGsp,1);   {*1 Gadgets Sp 2+ sur Barre Wind*}
Win_Draw(W);
End;

{ͻ
                            PROCEDURE Win_IdRes                             
 ͹
  IN.....: IDRES (WORD) = New IDRES flags.                                  
           W (TWindow) = Pointer to the window structure.                   
  OUT....: /                                                                
  EXPLAIN: Set new IDRES flags for a window.                                
  EXAMPLE: Win_IdRes($0003,W);                                              
 ͼ}

Procedure Win_IdRes(IDRES:Word; Var W:TWindow);   {*Change IDRES Fentre*}
Begin
W.IDRES:=IDRES;
Win_Draw(W);
End;

{ͻ
                             PROCEDURE Win_Move                             
 ͹
  IN.....: W (TWindow) = Pointer to the window structure.                   
  EXPLAIN: Manage the window deplacement.                                   
  EXAMPLE: Win_Move(W);                                                     
 ͼ}

Function Win_Move(Var W:TWindow):Boolean;
Var X,Y:Word;                             {*Recupere Valeurs Souris*}
    Ga,Mi,Dr:Boolean;
    Mb:Boolean;                           {*Quel Bouton Souris pour Dplacement*}

    NMb:Byte;                             {*Numro du bouton Souris*}
    PM:TPosMse;                            {*Structure Position Souris*}
    AddDtd:Byte;                          {*Delta Dtd en + Si Exist Close*}
    Haut:Byte;                            {*Hauteur Barre pour Txt (Fnt)*}
    Vert:Integer;                         {*Taille de la Barre de Move*}
    O_X2:Integer;                         {*Optimisations*}

{**************************** DEPLACE CADRE XOR *****************************}

Procedure MOVE_WIN;
Begin
VESA_SetWriteMode(XorPut);                     {*Dplace Window with Mouse (XOR)*}
VESA_SetColor(CLWinBg);
Mse_Hide;
VESA_Rectangle(W.X1,W.Y1,W.X2,W.Y2);           {*Efface old Cadre*}
Inc(W.X1,(X-W.Xo)); Inc(W.X2,(X-W.Xo));        {*Calcule New Coordones*}
Inc(W.Y1,(Y-W.Yo)); Inc(W.Y2,(Y-W.Yo));
W.Xo:=X; W.Yo:=Y;
VESA_Rectangle(W.X1,W.Y1,W.X2,W.Y2);           {*Affiche new Cadre*}
Mse_Show;
VESA_SetWriteMode(NormalPut);
End;

{******************** EFFACE DERNIER CADRE TRACE EN XOR *********************}


Procedure CLEAR_LAST_CADRE;
Begin                                {*Efface Dernier Cadre Trac (XOR)*}
Mse_SetPointer(P_Current);           {*Pointer to Pointer_Move Window*}
If (W.IDCMP And $40)=$40 Then
   Mse_SetLimit(0,0,VESA_GetMaxX,VESA_GetMaxY);{*Window Not Bloked on Screen Limits Now*}
VESA_SetWriteMode(XorPut);
VESA_SetColor(CLWinBg);
Mse_Hide;
VESA_Rectangle(W.X1,W.Y1,W.X2,W.Y2); {*Efface Dernier Cadre*}
Mse_Show;
VESA_SetWriteMode(NormalPut);
W.FlgM:=False;
BCLR(Id_Gad1,9);                     {*Dplacement Window Finit*}
Sys.WinMoved:=False;                 {*On ne Bouge plus de Fentre*}
End;

{******************** AFFICHE PREMIER CADRE TRACE EN XOR ********************}

Procedure CLICK_MOVE_WINDOW;         {*Clique 1ere Fois*}
Begin
Mse_SetPointer(MPMove);              {*Pointer to Move Window*}

If W.IDCMP And $200=$200 Then        {*Is There a Cursor on Window ?*}
   Begin
   Win_Clip(True,W);                 {*Hide Cursor In Window*}
   W.Curs.CursorOff;
   Win_Clip(False,W);
   End;
If (W.IDCMP And $40)=$40 Then        {*Window Blocked on Screen Limits*}
   Mse_SetLimit(X-W.X1,Y-W.Y1,VESA_GetMaxX-(W.X2-X),VESA_GetMaxY-(W.Y2-Y));
W.FlgM:=True;                        {*1er Cliquage pour dplacer Window*}
BSET(Id_Gad1,9);                     {*A Window is Moved Somewhere*}
Sys.WinMoved:=True;                  {*On Signale que on Bouge une Fentre*}
W.Xa:=W.X1; W.Ya:=W.Y1;              {*Save Old Coordones Window for Move*}

W.Xb:=W.X2; W.Yb:=W.Y2;
VESA_SetWriteMode(XorPut);
VESA_SetColor(CLWinBg);
Mse_Hide;
VESA_Rectangle(W.X1,W.Y1,W.X2,W.Y2);      {*Affiche 1er Cadre*}
Mse_Show;
VESA_SetWriteMode(NormalPut);
W.Xo:=X; W.Yo:=Y;
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
Win_Move:=False;

If Not W.Displayed Then Exit;                     {*Teste si fentre affiche*}

If W.Destroyed=False Then Begin                   {*Teste si fentre Vivante*}
Haut:=HaF1+4;                                     {*Size Bar Title Etc (Fnt)*}
If W.IDCMP And $10=$10 Then AddDtd:=20 Else AddDtd:=0;{*Calcule Dtd Title*}
If W.IDRES And $02=$02 Then Vert:=W.Y2-W.Y1       {*Calcule Size Move*}
                       Else Vert:=Haut;


Mse_Get(X,Y,Ga,Mi,Dr);                {*Infos sur Souris...*}

If W.IDRES And $20=$20 Then Begin Mb:=Dr; NMb:=3; End
   Else Begin Mb:=Ga; NMb:=1; End;      {*Dplace avec LMB ou RMB ???*}

If Mb=False Then W.FClick:=False;

If (Mb=True) And (W.FClick=False) Then
   Begin PM.X:=X; PM.Y:=Y; W.FClick:=True; End; {*Save Coordones Mse*}

If Mb=False Then
   Begin
   If (W.FlgM=True) And (W.X1=W.Xa) And (W.Y1=W.Ya) Then
      CLEAR_LAST_CADRE;                 {*Efface Dernier Cadre Trac (XOR)*}

   If W.FlgM=True Then
      Begin                             {*Efface Dernier Cadre Trac (XOR)*}
      CLEAR_LAST_CADRE;                 {*Efface Dernier Cadre Trac (XOR)*}
                                        {*Correction Bornes*}

      If W.X1<000 Then Begin Dec(W.X2,W.X1); W.X1:=0; End;
      If W.X2>VESA_GetMaxX Then Begin Inc(W.X1,(VESA_GetMaxX-W.X2)); W.X2:=VESA_GetMaxX; End;
      If W.Y1<000 Then Begin Dec(W.Y2,W.Y1); W.Y1:=0; End;
      If W.Y2>VESA_GetMaxY Then Begin Inc(W.Y1,(VESA_GetMaxY-W.Y2)); W.Y2:=VESA_GetMaxY; End;

      If W.IDCMP And $1000=$1000 Then   {*Fentre modale = Refresh Screen*}
         Begin
         W.Sw.PutImageToScreen(W.Xa,W.Ya);            {*Refresh Screen*}
         W.Sw.GetImageFromScreen(W.X1,W.Y1,W.X2,W.Y2);{*Save New Screen*}
         End
         Else Begin
         Sys.WinActionType:=1;          {*On Fait Signe aux autres Windows*}
         Sys.WinToRefresh:=1;           {*On Rafraichit  Partir 2 la 1ere*}
         End;

      W.Xa:=W.X1; W.Ya:=W.Y1;           {*Save Old Coordones Window for Move*}
      W.Xb:=W.X2; W.Yb:=W.Y2;
      Win_Move:=True;                   {*On a Boug la fentre !!!*}
      Sys.CommandCount:=0;              {*Rinit "InputText" Counter*}
      Win_Draw(W);                      {*ReDraw Window*}
      End
      Else W.FlgM:=False;               {*Souris Simplement dclique*}
   End;

O_X2:=W.X2-20*W.NbGsp;                  {*Optimisations*}
                                        {*Prvient Menus que fentre SP Move*}
If (Mse_TestBox(W.X1+AddDtd, W.Y1, O_X2, W.Y1+Vert,10)=True) And
   (W.IDRES And $20=$20) Then Id_Gad1:=Id_Gad1 Or $8
                         Else Id_Gad1:=Id_Gad1 And ($FFFF-$8);
                                        {*Dplace Window*}
If ((Mb=True) And (W.FlgM=True)) And ((X<>W.Xo) Or (Y<>W.Yo)) Then MOVE_WIN;
If (Mse_TestBox(W.X1+AddDtd, W.Y1, O_X2, W.Y1+Vert,NMb)=True)
   And (W.FlgM=False) And (Sys.WinMoved=False) And (Sys.WinSized=False)
   And (PM.X>=W.X1+AddDtd) And (PM.X<=O_X2)
   And (PM.Y>=W.Y1) And (PM.Y<=W.Y1+Vert) Then CLICK_MOVE_WINDOW;
                                        {*Move Window First...*}

End;                                    {*Fin du test Window Vivante*}
End;

{ͻ
                             FUNCTION Win_Test                              
 ͹
  IN.....: W (TWindow) = Pointer to the window structure.                   
  OUT....: Val (INTEGER) = Return an even else 0 if nothing happens.        
               CMNone               No messages                             
               CMClosed             Window closed                           
               CMSwapped            Window swapped                          
               CMExtended           Window extended                         
               CMResized            Window resized                          
               CMActivated          Window activated                        
               CMInactivated        Window inactivated                      
               CMMoved              Window moved                            
  EXPLAIN: Manage windows events (Activation, Close, Extend...).            
  EXAMPLE: Even:=Win_Test(W);                                               
           If Even=CMClosed Then....[Window closed];                        
 ͼ}

Function Win_Test(Var W:TWindow):Integer;
Var X,Y      :Word;
    Ga,Mi,Dr :Boolean;
    PG,Haut  :Shortint;                     {*Hauteur Barre pour Txt (Fnt)*}
    Resultat :Byte;                         {*Even Pour Close Window*}
    CurCoords: TCoordinates;

{***************** DESSIN DE LA FENETRE ACTIVATE OU DESACTIVE ***************}

Procedure DRAW_COLOR_CADRE(C1,C2:Longint);  {*Dessine la Fentre Active/Inactive*}
Begin
Win_Rename(W.Name,W);                    {*Affiche le Titre de la Fentre*}
If (W.BarSld=1) Or (W.BarSld=3) Then Bevel (W.X2-19,W.Y1+Haut+1,W.X2,W.Y2-Haut-1, C1,BLRaisedLine,BLNoLine,Yes);
If (W.BarSld=2) Or (W.BarSld=3) Then
   Begin Bevel (W.X1,W.Y2-Haut,W.X2-20,W.Y2, C1,BLRaisedLine,BLNoLine,Yes);
   Mse_Hide;

   VESA_Putpixel(W.X2-20,W.Y2-Haut,C2);
   Mse_Show;
   End;
End;

{************************ ACTIVATION DE LA FENETRE **************************}

Procedure ACTIVE_WIN;                {*Active la fentre*}
Begin
W.IDCMP:=W.IDCMP Or $1;              {*Act (Bool):=True*}
DRAW_COLOR_CADRE(CLFlamand,CLLineUp);{*Dessine la Fentre Active...*}
End;

{*********************** INACTIVATION DE LA FENETRE *************************}

Procedure INACTIVE_WIN;              {*Inactive la fentre*}
Begin
W.IDCMP:=W.IDCMP And ($FFFF-$1);     {*Act (Bool):=False*}
DRAW_COLOR_CADRE(CLWinBg,CLLineDown);{*Dessine la Fentre Inactive...*}
End;

{*************************** SIZE FIRST WINDOW ******************************}

Procedure SIZE_FIRST_WINDOW;         {*On Clique sur le Bouton Size*}
Var X1,Y1,X2,Y2:Integer;
Begin
X1:=W.X1+W.XMin-(W.X2-X);            {*Calcule Bornes Size of Window*}
Y1:=W.Y1+W.YMin-(W.Y2-Y);
X2:=W.X1+W.XMax-(W.X2-X);
Y2:=W.Y1+W.YMax-(W.Y2-Y);

If X2>VESA_GetMaxX-(W.X2-X) Then X2:=VESA_GetMaxX-(W.X2-X);
If Y2>VESA_GetMaxY-(W.Y2-Y) Then Y2:=VESA_GetMaxY-(W.Y2-Y);
Mse_SetLimit(X1,Y1,X2,Y2);            {*Window Bloqued on his Limits*}

W.FlgS:=True;                        {*1er Cliquage pour Sizer Window*}

Sys.WinSized:=True;                      {*On Signale que on Size une Fentre*}
W.Xb:=W.X2; W.Yb:=W.Y2;              {*Save Old Coordones Window for Move*}
VESA_SetWriteMode(XorPut);
VESA_SetColor(CLWinBg);
Mse_Hide;
VESA_Rectangle(W.X1,W.Y1,W.X2,W.Y2);      {*Affiche 1er Cadre*}
Mse_Show;
VESA_SetWriteMode(NormalPut);
W.Xo:=X; W.Yo:=Y;
End;

{****************************** RESIZE WINDOW *******************************}

Procedure RESIZE_WINDOW;             {*On Resize la Fentre*}
Begin
VESA_SetWriteMode(XORPut);                {*Resize Window with Mouse (XOR)*}
VESA_SetColor(CLWinBg);
Mse_Hide;
VESA_Rectangle(W.X1,W.Y1,W.X2,W.Y2);      {*Efface old Cadre*}
Inc(W.X2,(X-W.Xo)); Inc(W.Y2,(Y-W.Yo));
W.Xo:=X; W.Yo:=Y;
VESA_Rectangle(W.X1,W.Y1,W.X2,W.Y2);      {*Affiche new Cadre*}
Mse_Show;
VESA_SetWriteMode(NormalPut);
End;

{******************** EFFACE DERNIER CADRE TRACE EN XOR *********************}

Procedure CLEAR_OLD_CADRE;
Begin
Mse_SetLimit(0,0,VESA_GetMaxX,VESA_GetMaxY); {*Mouse Not Bloked on Screen Limits Now*}
VESA_SetWriteMode(XorPut);
VESA_SetColor(CLWinBg);
Mse_Hide;
VESA_Rectangle(W.X1,W.Y1,W.X2,W.Y2);   {*Efface Dernier Cadre*}
Mse_Show;
VESA_SetWriteMode(NormalPut);
W.FlgS:=False;
Sys.WinSized:=False;                  {*On ne Size plus de Fentre*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
Main_Task;                                      {*Gre Taches Gnrales*}
Win_Test:=CMNone;                               {*Pas de Messages de Base*}

CurCoords.X1 := W.X1;
CurCoords.X2 := W.X2;
CurCoords.Y1 := W.Y1;
CurCoords.Y2 := W.Y2;
Sys.SetWinCurrentCoord(CurCoords);              {*Save en Global Coord Fentre*}

If W.IDRES And $8<>$8 Then Win_Task(W);         {*Appelle Gestion Tche Window*}
{gotoxy(50,4); Writeln('Sys.WinFirstToSwap: ',Sys.WinFirstToSwap,'  ');}
If Id_Msg1 And $0002=$0002 Then Begin           {*Font Changed => Redraw TWindow*}
   Id_Msg1:=Id_Msg1 And $FFFD;
  { Win_Test:=10;} Exit; End;
{If Sys.WinActionType=3 Then Exit;}                       {*En Attente car Test Layers*}

If Not W.Displayed Then Exit;                   {*Teste si fentre affiche*}

If Not W.Destroyed Then Begin                   {*Teste si fentre Vivante*}

If (W.IDRES And $800=$800) And                  {*Fentre Autorise*}
   (W.IDCMP And $4000=$4000) And
   (Win_Move(W)=True) Then Begin                {*Fentre peut tre Dplace*}
      Win_Test:=CMMoved;
      Play_SoundAction(5);                      {*Play Sound Action...*}
      Exit; End;

Resultat:=CMNone;                               {*Even Pour Close Window*}
Haut:=HaF1+4;                                   {*Size Bar Title Etc (Fnt)*}
PG:=(Haut Div 2)-6;                             {*Pos Centre du Gadget*}
If PG>50 Then PG:=0;                            {*Correction Erreur*}

Mse_Get(X,Y,Ga,Mi,Dr);                        {*Get Datas Mouse*}

If (Mse_TestBox(W.X1,W.Y1,W.X2,W.Y2,1)=True) And (Sys.WinSized=False)
   And (W.Xo>=W.X1) And (W.Xo<=W.X2) And (W.Yo>=W.Y1) And (W.Yo<=W.Y2)
   And ((W.IDCMP And $1)<>$1) And ((W.IDCMP And $80)=$80) And ((W.IDCMP And $400)<>$400)
   And (Not BTST(W.IDCMP,11))
   Then Begin ACTIVE_WIN; Win_Test:=CMActivated; VESA_SetFillStyle(1,CLFlamand); Mse_Hide;
        BCLR(Id_Gad1,10);                       {*Send Signal to Main*}
        If (W.IDCMP And $200)=$200 Then W.Curs.InitCursor(W.Curs.Style,W.Curs.Blink);
        Mse_Show;                               {*Active Window*}
        End;

If (Sys.WinMoved=False) And (Sys.WinSized=False) Then
   Begin                      {*Pas d'activation quand on Modifie la Fentre*}
   If (Not Sys.OnMouseZone) And (Win_Ready(W)) Then {*La souris est sur une zone spciale*}
      Begin
      Mse_SetPointer(P_Current);
      End;
   Sys.OnMouseZone:=No;                         {*Rinit no mouse on special zones*}

   If (Sys.WinActionType=4) And (Sys.WinFirstToSwap>0) And (W.NUM=Sys.WinFirstToSwap) Then
      Begin W.IDRES:=W.IDRES Or $800;           {*Set Enable Bit to Test Gad*}
      Sys.WinActionType:=0; End;

   If (Ga=True) And (Sys.WinActionType=0) And           {*Send Msg.Get Priority Layers*}
{      (Sys.WinFirstToSwap>Sys.WinOpenCount) And}            {*1 Seule Fentre Ouverte !*}

      ((WPMx<>X) Or (WPMy<>Y)) Then
      Begin Sys.WinActionType:=3;
      WPMx:=X; WPMy:=Y; End;                    {*Stocke TWindow Pos Mouse X,Y*}

   If Ga=False Then W.IDRES:=W.IDRES And ($FFFF-$400);
   If (Ga=True) And (W.IDRES And $400<>$400) Then
      Begin W.Xo:=X; W.Yo:=Y;
      W.IDRES:=W.IDRES Or $400;                 {*Save Coordones Mse*}
      End;

   If BTST(W.IDCMP,11) Then                     {*Window Sensitive... With Mouse*}
      If Mse_TestBox(W.X1,W.Y1,W.X2,W.Y2,10)
         Then If Not BTST(W.IDCMP,0)
            Then Begin ACTIVE_WIN; Win_Test:=CMActivated; End
            Else
         Else If BTST(W.IDCMP,0)
            Then Begin INACTIVE_WIN; Win_Test:=CMInactivated; End;

   If (Mse_TestBox(0,0,VESA_GetMaxX,VESA_GetMaxY,1)=True) And (Mse_TestBox(W.X1,W.Y1,W.X2,W.Y2,1)=False)
      And ((W.Xo<W.X1) Or (W.Xo>W.X2) Or (W.Yo<W.Y1) Or (W.Yo>W.Y2))
      And ((W.IDCMP And $1)=$1) And ((W.IDCMP And $400)<>$400)
      And (Not BTST(W.IDCMP,11))                {*Inactive Window...*}
      Then Begin INACTIVE_WIN; Win_Test:=CMInactivated; VESA_SetFillStyle(1,CLWinBg);
           Mse_SetPointer(MPBusy);
           BSET(Id_Gad1,10);                    {*Send Signal to Main*}
           End;

   If (Kbd_GetKeyDown(VK_CONTROL) and Kbd_GetKeyDown(VK_F4) ) And (BTST(W.IDCMP,4)) Then {*CTRL-F4 Close Window*}
      Begin {Win_Done(W); }Resultat:=CMClosed; End;    {!Even 1 ne doit pas fermer la fentre!}

   If (Kbd_GetKeyDown(VK_ESCAPE)) And (BTST(W.IDRES,4)) Then {*ESC Close Window*}
      Begin {Win_Done(W); }Resultat:=CMClosed; End;    {!Even 1 ne doit pas fermer la fentre!}

   If (W.IDCMP And $80=$80) And (W.IDCMP And $10=$10) And (W.IDCMP And $1=$1) And (W.IDRES And $800=$800)
      Then If Button_GetMsg(W.Close,1)=CMSelected Then        {*Gadget Close Window*}
         Begin {Win_Done(W);} Resultat:=CMClosed; End; {!Even 1 ne doit pas fermer la fentre!}

   If (W.IDCMP And $80=$80) And (W.IDCMP And $8=$8) And (W.IDCMP And $1=$1) And (W.IDRES And $800=$800)
      Then If Button_GetMsg(W.Swap,1)=CMSelected Then         {*Gadget Swap Window*}

         Begin Win_Test:=CMSwapped; Sys.WinActionType:=2;
         Sys.WinToSwap:=W.NUM; Sys.WinToRefresh:=1;             {*Num Wind to Swap*}
         End;

   If (W.IDCMP And $80=$80) And (W.IDCMP And $2=$2) And (W.IDCMP And $1=$1) And (W.IDRES And $800=$800)
      Then If Button_GetMsg(W.Extend,1)=CMSelected Then
      Begin                             {*Gadget Extend Wind*}
      BCLR(Id_Gad1,5);                  {*Plus de Pointer Hand sur Gadgets*}
      Win_Test:=CMExtended;

      Play_SoundAction(5);              {*Play Sound Action...*}
      Sys.CommandCount:=0;                     {*Rinit "InputText" Counter*}
      If W.IDCMP And $1000=$1000 Then   {*Fentre modale = Refresh Screen*}
         Begin

         W.Sw.PutImageToScreen(W.Xa,W.Ya);{*Refresh Screen*}
{   Win_Zoom(False,W);}                   {*Zoom In sur la Fenetre*}
{   Win_Zoom(True,W); }                   {*Zoom In sur la Fenetre*}
         W.Sw.GetImageFromScreen(W.Xu,W.Yu,W.Xv,W.Yv);{*Save Screen*}
         End
         Else Begin
         Sys.WinActionType:=1;                  {*On Fait Signe aux autres Windows*}
         Sys.WinToRefresh:=1;                {*On Rafraichit  Partir 2 la 1ere*}
         End;

      Exg(W.X1,W.Xu); Exg(W.Y1,W.Yu);   {*Swap Coordones des Pos Window*}
      Exg(W.X2,W.Xv); Exg(W.Y2,W.Yv);
      W.Xa:=W.X1; W.Ya:=W.Y1;           {*Ractualise Old Coordones Window*}
      W.Xb:=W.X2; W.Yb:=W.Y2;
      Mse_Hide;
      Win_Draw(W);                      {*ReDraw Window*}
      Mse_Show;
      End;

   If ((W.IDRES And $100)=$100) Then    {*Window Must be Refresh Manualy*}
      Begin W.IDRES:=W.IDRES And ($FFFF-$100); Win_Test:=CMSwapped; End;

   End;

If (W.FlgM=False) And (W.FlgS=False) And ((W.IDCMP And $1)=$1) And ((W.IDCMP And $200)=$200) Then
   Begin
   Win_Clip(True,W);                    {*Display Cursor If Exist*}
   W.Curs.CursorOn;
   Win_Clip(False,W);
   End;

If (W.FlgM=False) And (W.FlgS=False) And ((W.IDCMP And $1)<>$1) And ((W.IDCMP And $200)=$200) Then
   Begin
   Win_Clip(True,W);                    {*Hide Cursor If Exist*}
   W.Curs.CursorOff;
   Win_Clip(False,W);
   End;

If Ga=False Then                        {*Resize Window*}
   Begin
   If (W.FlgS=True) And (W.X2=W.Xb) And (W.Y2=W.Yb) Then
      Begin
      CLEAR_OLD_CADRE;                  {*Efface Dernier Cadre Trac (XOR)*}
      If W.Size.ButSp=9 Then Begin
         Bevel (W.Size.X1,W.Size.Y1,W.Size.X2,W.Size.Y2, CLBgButton,BLRaisedLine,BLNoLine,No);{*Redraw Gadget Size Window*}
         Mse_Hide;
         VESA_Putpixel(W.Size.X2-19,W.Size.Y2, CLLineDown); {*Efface Point Disgracieux*}
         Mse_Show;
         End
      End;

   If W.FlgS=True Then
      Begin
      CLEAR_OLD_CADRE;                  {*Efface Dernier Cadre Trac (XOR)*}
      If W.X2>VESA_GetMaxX Then W.X2:=VESA_GetMaxX;{*Verify Max of box -BUG*}
      If W.Y2>VESA_GetMaxY Then W.Y2:=VESA_GetMaxY;

      If W.IDCMP And $1000=$1000 Then   {*Fentre Modale = Refresh Screen*}

         Begin
         W.Sw.PutImageToScreen(W.Xa,W.Ya);          {*Refresh Screen*}
         W.Sw.GetImageFromScreen(W.X1,W.Y1,W.X2,W.Y2);{*Save Screen*}
         End
         Else Begin
         Sys.WinActionType:=1;                  {*On Fait Signe aux autres Windows*}
         Sys.WinToRefresh:=1;                {*On Rafraichit  Partir 2 la 1ere*}
         End;

      W.Xb:=W.X2; W.Yb:=W.Y2;           {*Save Old Coordones Window for Move*}
      Win_Test:=CMResized;                 {*Even Size Window*}
      Play_SoundAction(5);                   {*Play Sound Action...*}
      Sys.CommandCount:=0;                     {*Rinit "InputText" Counter*}
      Mse_Hide;
      Win_Draw(W);                   {*ReDraw Window*}
      Mse_Show;
      End
      Else W.FlgS:=False;               {*Souris Simplement dclique*}
   End;                                 {*End ReSize Window...*}

If ((Ga=True) And (W.FlgS=True)) And ((X<>W.Xo) Or (Y<>W.Yo)) Then RESIZE_WINDOW;{*Resize Window*}
If ((W.IDCMP And $4)=$4) And (W.FlgS=False) And (Sys.WinSized=False)
   And (Sys.WinMoved=False) And (W.IDCMP And $1=$1) And (W.IDRES And $800=$800)
   Then Begin                           {*Bouton Size Window ?*}
   Button_GetMsg(W.Size,1);
   If W.Size.Flg_But Then SIZE_FIRST_WINDOW;
   End;

End;                                    {*Fin du test Window Vivante*}
If Resultat<>0 Then Win_Test:=Resultat; {*Transmet Info "Even" Close Window*}
End;

{*------------------------ PAS DE PROG PRINCIPAL ---------------------------*}


Begin
End.
