{ͻ
                               UNIT MosSystem                               
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 15.12.1993                                                   
  COUNTRY....: Montpellier - IUT (FRANCE)                                   
  DESCRIPTION: System Parameters Management.                                
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 2.932 Lines and (121.232 Bytes compiled)                     
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosSystem;

{$Mode Objfpc}

INTERFACE

Uses
     MosGadgets,
     MosList,
     MosWindows;

{|System management|}
Function  Sys_Request(X1,Y1:Integer; CName:String):Byte;{*Define MOS system parameters*}

Procedure Sys_Design(Px,Py:Integer);          {*Define MOS visual design*}
Procedure Sys_Colors(Px,Py:Integer);          {*Define Colors parameters*}
Procedure Sys_Fonts(Px,Py:Integer);           {*Define Fonts parameters*}
Procedure Sys_Sounds(Px,Py:Integer);          {*Define Sounds parameters*}
Procedure Sys_Graphics(Px,Py:Integer);        {*Define Graphics parameters*}
Procedure Sys_Apm(Px,Py:Integer);             {*Manage the APM functions*}
Procedure Sys_Skins(Px,Py:Integer);           {*Manage Skins parameters*}
Function  Sys_Screen(Px,Py,Mode:Integer; Title:String):Integer;{*Define Video Modes parameters*}

Procedure Sys_Hardware(Px,Py:Integer);        {*Define hardware parameters*}
Function  Sys_MousePointers(Px,Py:Integer; CurrentPointer:String):String;{*Define used mouse pointer*}
Procedure Sys_Mouse(Px,Py:Integer);           {*Define Mouse parameters*}
Procedure Sys_Keyboard(Px,Py:Integer);        {*Define Keyboard parameters*}
Procedure Sys_Printers(Px,Py:Integer);        {*Define Printer parameters*}
Procedure Sys_Peripherics(Px,Py:Integer);     {*Display available peripherics*}

Procedure Sys_System(Px,Py:Integer);          {*Define System parameters*}
Procedure Sys_SystemPaths(Px,Py:Integer);     {*View system paths*}
Procedure Sys_SystemStats(Px,Py:Integer);     {*Display system statistics*}
Procedure Sys_SystemBootlog(Px,Py:Integer);   {*Display system bootlog*}
Procedure Sys_SystemInfo(Px,Py:Integer);      {*Display information about system*}
Procedure Sys_SystemApplications(Px,Py:Integer);{*Display installed applications*}
Procedure Sys_ApplicationInfo(Px,Py:Integer; FName:String);{*Info about application*}

Procedure Sys_General(Px,Py:Integer);         {*Define General parameters*}
Procedure Sys_Misc(Px,Py:Integer);            {*Define Miscellaneous parameters*}
Procedure Sys_Blankers(Px,Py:Integer);        {*Define Blankers parameters*}
Procedure Sys_Errors(Px,Py:Integer);          {*Define Errors parameters*}
Procedure Sys_ErrorsHistory(Px,Py:Integer);   {*Define ErrorsHistory parameters*}
Procedure Sys_ListErrors(Px,Py:Integer);      {*Display List Errors*}
Function  Sys_Locale(Px,Py:Integer):Byte;     {*Define Langage parameters*}
Procedure Sys_Security(Px,Py:Integer);        {*Define Security parameters*}
Procedure Sys_TimeBelt(Px,Py:Integer);        {*Define TimeBelt parameters*}
Function  Sys_Date(Px,Py,Mode:Integer):String;{*Define Date parameters*}
Procedure Sys_Time(Px,Py:Integer);            {*Define Time parameters*}

Procedure Sys_Network(Px,Py:Integer);         {*Define Network parameters*}

{*----------------------------- Dbut Library ------------------------------*}

IMPLEMENTATION

Uses
     Dos,
     SysUtils,
     IniFiles,
     Graphix,
     MosApm,
     MosBase,
     MosBlankers,
     MosColors,
     MosColorDialogs,
     MosConfig,
     MosCPUInstructions,
     MosDialogs,
     MosDirectory,
     MosDisks,
     MosErrors,
     MosFiles,
     MosFilesTree,
     MosGraph,
     MosHardware,
     MosImages,
     MosKeyboard,
     MosMouse,
MosPopup,
     MosRequests,
     MosSound,
     MosStrings,
     MosTab,
     MosText,
     MosTime,
     MosTools;

{ͻ
                        PROCEDURE Sys_SystemBootlog                         
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: Display the current bootlog file.                                
 ͼ}

Procedure Sys_SystemBootlog(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flags*}
    But1          :TButton;             {*Buttons Structure*}
    List          :TList;
    FName         :String;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_anal.bmp',$0080);
Button   (210,204,080,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
List_Show(List);
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{******************************** INIT ALL **********************************}

Procedure INIT;                         {*Init all data*}
Var A:Integer;
    St:String;
Begin
XOk:=No; XCancel:=No;                   {*Init Exit Flags*}
List_Define(List,Language.Loc(1755),';',119,014,479,186, 500, CLDataZone,CLDataZone,$1309);
List_Load(List,FName);

For A:=List_MinItem to List_GetQttItems(List) do
   Begin
   St:=List_GetStringCell(List,A,1);
   If Pos(']',St)>0 Then
      Begin
      List_SetStringCell(List,A,1,Copy(St,1,Pos(']',St)+1));
      List_SetStringCell(List,A,2,Copy(St,Pos(']',St)+2,255));
      End;
   If Pos('---',St)>0 Then
      Begin
      List_SetStringItem(List,A,'');
      List_SetBkColorItem(List,A,CLSky);
      End;
   End;

List_AdjustColumns(List);
List_SetIdMore(List,$0008);
List_SetColumnAttr(List,1,-1,Text_Center);
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
FName:='bootlog.txt';
If Not File_TestExist(FName) Then Exit; {*Bootlog not found!*}

If Not Win_Init(Px,Py,Px+500,Py+HaF1+230,$51D9,Language.Loc(370),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

INIT;                                   {*Init all data*}
REDRAW_FRAME;                           {*Display Window Content*}

Repeat
try

If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes;
   List_Test(List);                     {*Display new pointer*}
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;     {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flags*}

List_Done(List);
Win_Done(W1);                           {*Close Window if Needs*}
End;

{ͻ
                       PROCEDURE Sys_ApplicationInfo                        
 ͹
  IN.....: Px,Py (INTEGER) = X,Y coordinates for the requester.             
           FName (STRING) = Application filename (MIF file).                
  OUT....: /                                                                
  EXPLAIN: Display application information.                                 
 ͼ}

Procedure Sys_ApplicationInfo(Px,Py:Integer; FName:String);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flag*}
    But1          :TButton;             {*Buttons Structure*}
    Tab1          :TTabs;               {*Tab structure*}
    Ini           :TIniFile;            {*Application file*}

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
Tabs (008,008,290,268,Tab1.No, CLLightGrey,CLLightGrey,$0014,Tab1,Language.Loc(275));

Case Tab1.No of                         {*Display Tabs components*}
   1: Begin
      BMP_ShowTransparency (021,032,021+120,032+100, 0,0,Sys.GetPath(SP_BUTTONS)+'Ico_prog.bmp',$0080,CLTransparency);
      Display(066,034,220,CLText, Str_Get(Language.Loc(273),1,'|')+Ini_LoadKey(Ini,'Installation','Title','?'), TJOnLeft);
      Display(066,045,220,CLText, Str_Get(Language.Loc(273),2,'|')+Ini_LoadKey(Ini,'Installation','Version','?'), TJOnLeft);
      Display(066,056,220,CLText, Str_Get(Language.Loc(273),3,'|')+Ini_LoadKey(Ini,'Installation','Drawer','?'), TJOnLeft);
      Tool_line(012,076,285,076,1,1);
      Display(020,084,260,CLText, Str_Get(Language.Loc(273),4,'|')+File_StrSplit(FName,$000C), TJOnLeft);
      Display(020,095,260,CLText, Str_Get(Language.Loc(273),5,'|')+Ini_LoadKey(Ini,'Installation','Name','?'), TJOnLeft);
      Display(020,106,260,CLText, Str_Get(Language.Loc(273),6,'|')+Ini_LoadKey(Ini,'Installation','Copyright','?'), TJOnLeft);
      Display(020,117,260,CLText, Str_Get(Language.Loc(273),7,'|')+Ini_LoadKey(Ini,'Installation','Author','?'), TJOnLeft);
      Tool_line(012,137,285,137,1,1);
      Display(020,145,260,CLText, Str_Get(Language.Loc(274),1,'|')+Ini_LoadKey(Ini,'Installation','Creation date','?'), TJOnLeft);
      Display(020,156,260,CLText, Str_Get(Language.Loc(274),2,'|')+Ini_LoadKey(Ini,'Installation','Installation date','?'), TJOnLeft);
      Display(020,167,260,CLText, Str_Get(Language.Loc(274),3,'|')+Ini_LoadKey(Ini,'Installation','System target','?'), TJOnLeft);
      Display(020,178,260,CLText, Str_Get(Language.Loc(274),4,'|')+Ini_LoadKey(Ini,'Installation','Compiled with','?'), TJOnLeft);
      End;
   End;

Button (110,274,080,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+300,Py+HaF1+300,$51D9,Language.Loc(276),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBg,$0A50,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

If FName[2]<>':' Then FName:=Sys.GetPath(SP_INSTALL)+FName;
Tab1.No:=1;
XOk:=No; XCancel:=No;                   {*Init Exit Flag*}
Ini_Init(Ini,FName);                    {*Open Ini file*}

REDRAW_FRAME;                           {*Display Window Content*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes;
   If Tabs_GetMsg  (Tab1,1)=CMSelected Then REDRAW_FRAME;
   Win_Clip(No,W1);                     {*Clipping Window*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;     {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flag*}

Ini_Done(Ini);                          {*Validate and close IniFile*}
Win_Done(W1);                           {*Close Window if Needs*}
End;

{ͻ
                      PROCEDURE Sys_SystemApplications                      
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: Display installed applications.                                  
 ͼ}

Procedure Sys_SystemApplications(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flags*}
    But1,But2,But3:TButton;             {*Buttons Structure*}
    List          :TList;
    FName,AppName :String;
    Num           :Integer;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_appl.bmp',$0080);
Button   (160,204,090,-1, CLTextButton,CLBgButton,$0000,But1,'_OK',MPHand,'');
Button   (240,024,140,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(193));
Button   (240,044,140,-1, CLTextButton,CLBgButton,$0100,But3,Language.Loc(194));
BMP_ShowTransparency (120,020,120+100,020+100, 0,0,Sys.GetPath(SP_BUTTONS)+'Ico_prog.bmp',$0080,CLTransparency);
List_Show(List);
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{******************************** INIT ALL **********************************}

Procedure INIT;                         {*Init all data*}
Var A:Integer;
    St,St1,St2:String;
    Ini:TIniFile;
Begin
List_Reset(List);
FName:=Sys.GetPath(SP_TEMP)+File_BuildNextName('App.lis', FEValue);
File_Erase(FName);                      {*Delete application list file*}
File_GetDirectory(Sys.GetPath(SP_INSTALL)+'*.MIF',FName);
List_Load(List,FName);

For A:=List_MinItem to List_GetQttItems(List) do
   Begin
   St:=Sys.GetPath(SP_INSTALL)+List_GetStringCell(List,A,1);
   Ini_Init(Ini,St);
   St1:=Ini_LoadKey(Ini,'Installation','Title','');
   If St1='' Then St1:=Ini_LoadKey(Ini,'Installation','Name','');
   St2:=Ini_LoadKey(Ini,'Installation','Version','');
   Ini_Done(Ini);
   List_SetStringCell(List,A,2,St1+' '+St2);
   End;

List_Sort(List,1,Sort_AZ,1);            {*Sort the list*}
List_AdjustColumns(List);
List_SetIdMore(List,$000A);
List_HideColumn(List,1,Yes);
List_TagItem(List,1);                   {*Tag the first item*}
AppName:=Sys.GetPath(SP_INSTALL)+List_GetStringCell(List,List_GetTaggedItem(List),1);
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+400,Py+HaF1+230,$51D9,Language.Loc(278),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

XOk:=No; XCancel:=No;                   {*Init Exit Flags*}
List_Define(List,'File;Application',';',119,065,380,186, 500, CLDataZone,CLDataZone,$1308);
INIT;                                   {*Init all data*}
REDRAW_FRAME;                           {*Display Window Content*}

Repeat
try

If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes;
   If (Button_GetMsg(But3,1)=CMSelected) Or
      ((List_TestMouseOnList(List)=1) And (Mse_TestDoubleClick)) Then
   Begin
      Sys_ApplicationInfo(W1.X1+20,W1.Y1+30, AppName);
   End;

   If Button_GetMsg(But2,1)=CMSelected Then
      Begin                             {*Remove application*}
      Num:=3;
      Req_Dialog(Language.Loc(1),'Do you want really to remove this application ?|All the attached files will be deleted in the application directory','  _CANCEL  |  _REMOVE  ',Num);
      If Num=2 Then                     {*Delete all files*}
         Begin
         File_Deltree(Dsk_ValideDirectory(Ini_LoadKey(FName,'Installation','Drawer')),true);
         File_Erase(AppName);
         INIT;                          {*Reload applications list*}
         End;
      End;
   If List_Test(List)>0 Then AppName:=Sys.GetPath(SP_INSTALL)+List_GetStringCell(List,List_GetTaggedItem(List),1);
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;     {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flags*}

List_Done(List);
Win_Done(W1);                           {*Close Window if Needs*}
File_Erase(FName);
End;

{ͻ
                         PROCEDURE Sys_SystemStats                          
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: Display MOS system statistics.                                   
 ͼ}

Procedure Sys_SystemStats(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flags*}
    But1          :TButton;             {*Buttons Structure*}
    List          :TList;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_stat.bmp',$0080);
Button   (160,204,090,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
List_Show(List);
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{******************************** INIT ALL **********************************}

Procedure INIT;                         {*Init all data*}
Var A:Integer;
    St:String;
Begin
XOk:=No; XCancel:=No;                   {*Init Exit Flags*}
List_Define(List,Language.Loc(137),';',119,014,379,186, 500, CLDataZone,CLDataZone,$1309);
List_Load(List,Sys.GetPath(SP_DATAS)+'Stats.dat');

For A:=List_MinItem to List_GetQttItems(List) do
   Begin
   St:=List_GetStringCell(List,A,1);

   If Pos('[',St)>0 Then
      Begin
      St:=Str_DelSub(St,'[');
      St:=Str_DelSub(St,']');
      List_SetBkColorItem(List,A,CLSky);
      End;
   If Pos('=',St)>0 Then
      Begin
      List_SetStringCell(List,A,2,Copy(St,Pos('=',St)+1,255));
      St:=Copy(St,1,Pos('=',St)-1);
      List_SetStringCell(List,A,1,St);
      End;
   End;

List_AdjustColumns(List);
List_SetColumnAttr(List,2,60,Text_OnLeft);
List_SetIdMore(List,$0008);
List_TagItem(List,2);                   {*Tag the first item*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+400,Py+HaF1+230,$51D9,Language.Loc(138),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

INIT;                                   {*Init all data*}
REDRAW_FRAME;                           {*Display Window Content*}

Repeat
try

If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes;
   List_Test(List);                     {*Display new pointer*}
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;     {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flags*}

List_Done(List);
Win_Done(W1);                           {*Close Window if Needs*}
End;

{ͻ
                         PROCEDURE Sys_SystemDrawer                         
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: Define the MOS System correct drawer.                            
 ͼ}

Procedure Sys_SystemDrawer(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flags*}
    But1,But2     :TButton;             {*Buttons Structure*}
    Com1          :TInputText;          {*Structure Commands*}
    DirSel1,FilSel:String;              {*Gestion du Directory*}
    Size          :Longint;
    Num           :Integer;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
BMP_Show  (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_heel.bmp',$0080);
Bevel_Mos (120,020,340,080, CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(187));
Button    (142,204,080,-1,  CLTextButton,CLBgButton,$0110,But1,'_OK');
Button    (130,035,140,-1,  CLTextButton,CLBgButton,$0000,But2,Str_Get(Language.Loc(188),1,'|'));
InputText (130,055,200,255, CLSky,CLLightBlue,0,$27,Com1,Com1.Cin);
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{****************************** MAIN PROCEDURE ******************************}

Procedure SEL_DRAWER(Var Drawer,Res:String);
Begin
Req_FileManager(W1.X1+020,W1.Y1+030,269,Language.Loc(190),'_OK','*.*',1,Drawer,FilSel,Size);
If Drawer<>'' Then Res:=Drawer+FilSel;
REDRAW_FRAME;                           {*Affiche les Gadgets Commands*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+364,Py+HaF1+230,$51D9,Language.Loc(231),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

Com1.Cin:=Sys.GetPath(SP_MAIN);
DirSel1:=Com1.Cin;                      {*Init pour File Requester*}
FilSel:='';
XOk:=No; XCancel:=No;
REDRAW_FRAME;                           {*Display Window Content*}

Repeat
try

If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then {*Use*}
      Begin
      Num:=1;                           {*Icne Warning*}
      Com1.Cin:=Dsk_ValideDirectory(Com1.Cin);
      If File_TestExist(Com1.Cin+'DATAS\'+'ENGLISH.LOC') Then {*Est-ce le bon Rpertoire ?*}
         Begin Sys.Directory:=Com1.Cin; XOk:=Yes; End
         Else Req_Dialog(Language.Loc(1),Language.Loc(246),Language.Loc(24),Num);{*Sinon Erreur...*}
      End;
   If Button_GetMsg(But2,1)=CMSelected Then SEL_DRAWER(DirSel1,Com1.Cin);
   InputText_GetMsg(Com1,Com1.Cin);
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;     {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flags*}

Win_Done(W1);                           {*Close Window if Needs*}
End;

{ͻ
                         PROCEDURE Sys_SystemPaths                          
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: Display defined system paths.                                    
 ͼ}

Procedure Sys_SystemPaths(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flags*}
    But1          :TButton;             {*Buttons Structure*}
    List          :TList;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
BMP_Show  (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_syst.bmp',$0080);
Button    (160,204,080,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
List_Show(List);
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{******************************** INIT ALL **********************************}

Procedure INIT;                         {*Init all data*}
Var A:Integer;
    St:String;
Begin
XOk:=No; XCancel:=No;                   {*Init Exit Flags*}
List_Define(List,Language.Loc(1672),';',119,014,379,186, 500, CLDataZone,CLDataZone,$1309);

For A:=1 to SP_LASTDIR do               {*Create System Directories...*}
   Begin
   St:=Str_FillZero(A,2)+';'+Sys.GetPath(A);
   List_AddItem(List,St,Insert_Append); {*Add an item to the list*}
   End;
List_AdjustColumns(List);
List_SetColumnAttr(List,1,40,Text_Center);
List_TagItem(List,1);                   {*Tag the first item*}
List_SetIdMore(List,$0008);
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+400,Py+HaF1+230,$51D9,Language.Loc(224),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

INIT;                                   {*Init all data*}
REDRAW_FRAME;                           {*Display Window Content*}

Repeat
try

If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes;
   List_Test(List);                     {*Display new pointer*}
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;     {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flags*}

List_Done(List);
Win_Done(W1);                           {*Close Window if Needs*}
End;

{ͻ
                         FUNCTION Sys_MousePointers                         
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: (STRING) = Selected mouse pointer filename.                      
  EXPLAIN: Display available pointers and return selected mouse pointer.    
 ͼ}

Function Sys_MousePointers(Px,Py:Integer; CurrentPointer:String):String;
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flags*}
    But1          :TButton;             {*Buttons Structure*}
    List          :TList;
    FName         :String;
    Res           :Integer;             {*Result selection list*}
    MZ            :TMouseZone;
    C             :TCoordinates;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}

Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
Button (165,135,080,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
List_Show(List);
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{******************************** INIT ALL **********************************}

Procedure INIT;                         {*Init all data*}
Var Ini:TIniFile;
    A,Index:Integer;
    St:String;
Begin
XOk:=No; XCancel:=No;                   {*Init Exit Flags*}
List_Define(List,Language.Loc(1670),';',019,014,388,119, 500, CLDataZone,CLDataZone,$1309);
FName:=Sys.GetPath(SP_TEMP)+File_BuildNextName('Point.lis', FEValue);
File_GetDirectory(Sys.GetPath(SP_POINTERS)+'*.CUR',FName);
List_Load(List,FName);
For A:=1 to File_CountLines(FName) do   {*Add pointer name*}
   Begin
   St:=Sys.GetPath(SP_POINTERS)+List_GetStringCell(List,A,1);
   Ini_Init(Ini,St);
   List_SetStringCell(List,A,2, Ini_LoadKey(Ini,'Mouse Pointer','Name','?'));
   List_SetStringCell(List,A,3, Ini_LoadKey(Ini,'Mouse Pointer','Familly','?'));
   List_SetStringCell(List,A,4, Ini_LoadKey(Ini,'Mouse Pointer','Theme','?'));
   Ini_Done(Ini);
   End;
List_Save(List,FName);                  {*Just because it's better !*}
List_SetIdMore(List,$0008);
List_AdjustColumns(List);
List_SetColumnAttr(List,2,110,Text_OnLeft);
List_Sort(List,1,SORT_AZ,1);
Win_Rename(Str_L2S(List_GetQttItems(List))+' '+Language.Loc(112),W1);

Index:=List_GetItemIndice(List,CurrentPointer,1);{*Get the position of an item*}
If Index=0 Then Index:=1;

List_TagItem(List,Index);               {*Tag the first item*}
List_SetPosition(List,Index);           {*Set liste position to display*}

C.X1:=0; C.Y1:=30;
C.X2:=372; C.Y2:=VESA_GetMaxY;
MseZone(MZ,C,10,List_GetStringCell(List,Index,1),''); {*Define a mouse zone*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+410,Py+HaF1+160,$51D9,Language.Loc(112),W1) Then Exit;

Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

INIT;                                   {*Init all data*}
REDRAW_FRAME;                           {*Display Window Content*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes;
   MseZone_GetMsg(MZ);                  {*Set pointer*}
   Res:=List_Test(List);                {*Display new pointer*}
   If Res>0 Then
      Begin
      MZ.Value:=(List_GetStringCell(List,Res,1));
      End;
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;     {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flags*}

If XOk                                  {*Ok and validate*}
   Then Sys_MousePointers:=MZ.Value
   Else Sys_MousePointers:=CurrentPointer;

File_Erase(FName);                      {*Delete Temporary file*}
List_Done(List);
Win_Done(W1);                           {*Close Window if Needs*}
End;

{ͻ
                            PROCEDURE Sys_Mouse                             
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: Mouse System Requester. Set parameters for the mouse.            
 ͼ}

Procedure Sys_Mouse(Px,Py:Integer);
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    XOk,XCancel   :Boolean;             {*Flag de Sortie*}
    Tab1          :TTabs;
    Isl1,Isl2,Isl3:TInputSlider;
    Sld1,Sld2,Sld3:TSlider;             {*Structure Sliders*}
    Val1,Val2,Val3:Longint;
    Rad1          :TRadioBox;           {*Radios Structure*}
    But1,But2,But3:TButton;             {*Structure Boutons*}
    List          :TList;
    Selected,Res  :Longint;             {*Selected mouse pointer*}
    Example       :String;              {*Mouse pointer image*}
    NPointer      :String;              {*Nouveau Courant TPointer*}
    A             :Integer;             {*Loop*}

{************************* AFFICHE EXEMPLE POINTEUR *************************}

Procedure REDRAW_POINTEREXAMPLE;
Begin
Win_Clip(Yes,W1);
Case Tab1.No of
   2: Begin
      NPointer:=List_GetStringCell(List,Selected,3);
      Example:=Sys.GetPath(SP_POINTERS)+Ini_LoadKey(Sys.GetPath(SP_POINTERS)+NPointer,'Mouse Pointer','Bitmap');
      Bevel  (310,036,345,071, CLGrey,BLRaisedLine,BLNoLine,Yes);
      BMP_ShowTransparency(311,037,311+32,037+32, 0,0,Example,$0080,CLTransparency);
      End;
   End;
End;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_VALUES;
Begin
Win_Clip(Yes,W1);
Case Tab1.No of
   1: Begin
      InputSlider (180,065,025, CLSky,CLSalmon,0,0,100,1,Val1,$0000,Isl1);
      InputSlider (180,085,025, CLSky,CLSalmon,0,0,100,1,Val2,$0000,Isl2);
      InputSlider (180,105,025, CLSky,CLSalmon,0,0,100,1,Val3,$0000,Isl3);
      End;
   End;
End;

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_mous.bmp',$0080);

Tabs (119,014,370,189, Tab1.No, CLLightGrey,CLLightGrey,$0014,Tab1,Language.Loc(139));
Button (090,204,080,-1, CLTextButton,CLBgButton,$0000,But1,Language.Loc(114),MPHand,'');
Button (220,204,080,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));

Case Tab1.No of
   1: Begin
      Bevel_Mos (130,045,360,180,  CLMauve,CLWhite ,BLLoweredLine,BLRaisedLine,Yes,Language.Loc(105));
      Bevel   (180,125,300,140, CLPaper,BLRaisedLine,BLNoLine,Yes);
      Display (140,066, CLText,Language.Loc(106));
      Display (140,086, CLText,Language.Loc(107));
      Display (140,106, CLText,Language.Loc(108));
      Display (140,126, CLText,Language.Loc(109));
      Display (190,127, CLText,Language.Loc(110));
      RadioBox(140,154,1,$10,0,0,Rad1.Status,Rad1,Language.Loc(312));
      BMP_ShowTransparency (315,135,315+100,135+100, 0,0,Sys.GetPath(SP_BUTTONS)+'Ico_mous.bmp',$0080,CLTransparency);
      Slider  (Sld1,230,065,115, 100,010,Sld1.Value, COHorizontal,BPOposed,Yes,CLLightGrey, MPArrow,'');
      Slider  (Sld2,230,085,115, 100,010,Sld2.Value, COHorizontal,BPOposed,Yes,CLLightGrey, MPArrow,'');
      Slider  (Sld3,230,105,115, 100,010,Sld3.Value, COHorizontal,BPOposed,Yes,CLLightGrey, MPArrow,'');
      End;
   2: Begin
      Button   (130,045,160,-1, CLTextButton,CLBgButton,$0100,But3,Language.Loc(115));
      List_Show(List);
      End;
   End;

Win_Clip(No,W1);

REDRAW_VALUES;
REDRAW_POINTEREXAMPLE;
End;

{***************************** INITIALISATIONS ******************************}

Procedure INIT_FRAME;
Var A:Longint;
    InName:String;
Begin
Tab1.No:=1;                             {*1st Tab displayed*}
NPointer:=P_Current;                    {*Transmet Valeurs*}
Sld1.Value:=Sys.MouseClickDelay;
Sld2.Value:=100-Sys.MouseSpeed;
Sld3.Value:=Sys.MouseDblClickDelay;
Val1:=Sys.MouseClickDelay;
Val2:=Sld2.Value;
Val3:=Sys.MouseDblClickDelay;
Rad1.Status:=BTST(Id_Gad1,4);           {*Swap Mouse Buttons*}

List_Define(List,Language.Loc(140),';',130,080,359,180, 1000, CLDataZone,CLDataZone,$1BAD);
Selected:=List_MinItem;
List_Load(List,Sys.GetPath(SP_DATAS)+'Pointers.lis');
List_TagItem(List,Selected);
List_SetColumnId(List,3,$0001);
List_SetIdMore(List,$0008);
List_HideColumn(List,1,Yes);
List_SetColumnAttr(List,2,112,Text_OnLeft);
List_SetColumnAttr(List,3,090,Text_OnLeft);
For A:=List_MinItem to List_GetQttItems(List) do
   Begin
   InName:=List_GetStringCell(List,A,1);
   If InName='MPArrow'     Then List_SetStringCell(List,A,3,MPArrow);
   If InName='MPBusy'      Then List_SetStringCell(List,A,3,MPBusy);
   If InName='MPDrag'      Then List_SetStringCell(List,A,3,MPDrag);
   If InName='MPEyeDrop'   Then List_SetStringCell(List,A,3,MPEyeDrop);
   If InName='MPForbiden'  Then List_SetStringCell(List,A,3,MPForbiden);
   If InName='MPHand'      Then List_SetStringCell(List,A,3,MPHand);
   If InName='MPHead'      Then List_SetStringCell(List,A,3,MPHead);
   If InName='MPHelp'      Then List_SetStringCell(List,A,3,MPHelp);
   If InName='MPHourGlass' Then List_SetStringCell(List,A,3,MPHourGlass);
   If InName='MPLetter'    Then List_SetStringCell(List,A,3,MPLetter);
   If InName='MPMove'      Then List_SetStringCell(List,A,3,MPMove);
   If InName='MPMoveDown'  Then List_SetStringCell(List,A,3,MPMoveDown);
   If InName='MPMoveLD'    Then List_SetStringCell(List,A,3,MPMoveLD);
   If InName='MPMoveLeft'  Then List_SetStringCell(List,A,3,MPMoveLeft);
   If InName='MPMoveLU'    Then List_SetStringCell(List,A,3,MPMoveLU);
   If InName='MPMoveRD'    Then List_SetStringCell(List,A,3,MPMoveRD);
   If InName='MPMoveRigh'  Then List_SetStringCell(List,A,3,MPMoveRight);
   If InName='MPMoveRU'    Then List_SetStringCell(List,A,3,MPMoveRU);
   If InName='MPMoveUp'    Then List_SetStringCell(List,A,3,MPMoveUp);
   If InName='MPMoveX'     Then List_SetStringCell(List,A,3,MPMoveX);
   If InName='MPMoveY'     Then List_SetStringCell(List,A,3,MPMoveY);
   If InName='MPAudio'     Then List_SetStringCell(List,A,3,MPAudio);
   If InName='MPSizeLR'    Then List_SetStringCell(List,A,3,MPSizeLR);
   If InName='MPSizeLUDR'  Then List_SetStringCell(List,A,3,MPSizeLUDR);
   If InName='MPSizeRUDL'  Then List_SetStringCell(List,A,3,MPSizeRUDL);
   If InName='MPSizeUD'    Then List_SetStringCell(List,A,3,MPSizeUD);
   If InName='MPTarget'    Then List_SetStringCell(List,A,3,MPTarget);
   If InName='MPText'      Then List_SetStringCell(List,A,3,MPText);
   If InName='MPWarning'   Then List_SetStringCell(List,A,3,MPWarning);
   End;

But3.Pointer.Value:=NPointer;
XOk:=No; XCancel:=No;                   {*Init Flag de Sortie*}
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(Px,Py,Px+390,Py+HaF1+230,$51D9,Language.Loc(116),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                           {*Affiche la Fentre*}

INIT_FRAME;                             {*Initialise data*}
REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}

Repeat
try

If Win_Ready(W1) Then                   {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   Win_Clip(Yes,W1);
   If Tabs_GetMsg(Tab1,1)=CMSelected Then REDRAW_FRAME;

   Case Tab1.No of
      1: Begin
         RadioBox_GetMsg(Rad1,1);
         If Slider_GetMsg(Sld1)=CMModified Then
            Begin
            Mse_SetDelay(Sld1.Value); Val1:=Sld1.Value;
            REDRAW_VALUES;
            End;
         If Slider_GetMsg(Sld2)=CMModified Then
            Begin
            Mse_Speed(100-Sld2.Value,100-Sld2.Value); Val2:=Sld2.Value;
            REDRAW_VALUES;
            End;
         If Slider_GetMsg(Sld3)=CMModified Then
            Begin
            Mse_SetDoubleClick(Sld3.Value); Val3:=Sld3.Value;
            REDRAW_VALUES;
            End;
         If InputSlider_GetMsg(Isl1,Val1)=CMModified Then
            Begin
	    Sld1.Value:=Val1; Mse_SetDelay(Sld1.Value);
            Slider_Refresh(Sld1);
	    End;
         If InputSlider_GetMsg(Isl2,Val2)=CMModified Then
            Begin
	    Sld2.Value:=Val2; Mse_Speed(100-Sld2.Value,100-Sld2.Value);
            Slider_Refresh(Sld2);
	    End;
         If InputSlider_GetMsg(Isl3,Val3)=CMModified Then
            Begin
	    Sld3.Value:=Val3; Mse_SetDoubleClick(Sld3.Value);
            Slider_Refresh(Sld3);
	    End;
         If (Mse_TestDoubleClick) And
            (Mse_TestBox(T_Clip.X1+180, T_Clip.Y1+125, T_Clip.X1+300, T_Clip.Y1+140, 10))
            Then Play_Beep;             {*Item Double-Click*}
         End;

      2: Begin
         If Button_GetMsg(But3,1)=CMSelected Then
            Begin                       {*Define used mouse pointer*}
            NPointer:=Sys_MousePointers(W1.X1+20,W1.Y1+30,NPointer);
            List_SetStringCell(List,Selected,3,NPointer);
            List_Refresh(List);
            REDRAW_POINTEREXAMPLE;
            End;
         Res:=List_Test(List);          {*Test list*}
         If Res>0 Then
            Begin
            Selected:=Res;
            REDRAW_POINTEREXAMPLE;
            End;
         End;
      End;

   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes; {*Use*}
   If Button_GetMsg(But2,1)=CMSelected Then
      Begin                             {*Cancel*}
      Mse_SetDoubleClick(Sys.MouseDblClickDelay);
      Mse_SetDelay(Sys.MouseClickDelay);
      Mse_Speed(Sys.MouseSpeed,Sys.MouseSpeed);
      XCancel:=Yes;
      End;
   Win_Clip(No,W1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then XCancel:=True;    {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Fentre Dplace => Rafficher Contenu*}

except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Flag de Sortie*}

Win_Done(W1);                           {*Suprime Fentre*}

If XOk Then                             {*Save values*}
   Begin
   Sys.RefreshScreen:=2;                {*Refresh level set to 2*}
   Sys.MouseClickDelay:=Sld1.Value;
   Sys.MouseSpeed:=100-Sld2.Value;
   Sys.MouseDblClickDelay:=Sld3.Value;
   Sys.MouseClickDelay:=Val1;
   If Rad1.Status Then BSET(Id_Gad1,4)  {*Swap Mouse Buttons*}
                  Else BCLR(Id_Gad1,4);

   For A:=List_MinItem to List_GetQttItems(List) do
      Begin
      If List_GetStringCell(List,A,1)='MPArrow'     Then MPArrow    :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPBusy'      Then MPBusy     :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPDrag'      Then MPDrag     :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPEyeDrop'   Then MPEyeDrop  :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPForbiden'  Then MPForbiden :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPHand'      Then MPHand     :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPHelp'      Then MPHelp     :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPHourGlass' Then MPHourGlass:=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPLetter'    Then MPLetter   :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPMove'      Then MPMove     :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPMoveDown'  Then MPMoveDown :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPMoveLD'    Then MPMoveLD   :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPMoveLeft'  Then MPMoveLeft :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPMoveLU'    Then MPMoveLU   :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPMoveRD'    Then MPMoveRD   :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPMoveRigh'  Then MPMoveRight:=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPMoveRU'    Then MPMoveRU   :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPMoveUp'    Then MPMoveUp   :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPMoveX'     Then MPMoveX    :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPMoveY'     Then MPMoveY    :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPAudio'     Then MPAudio    :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPSizeLR'    Then MPSizeLR   :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPSizeLUDR'  Then MPSizeLUDR :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPSizeRUDL'  Then MPSizeRUDL :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPSizeUD'    Then MPSizeUD   :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPTarget'    Then MPTarget   :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPText'      Then MPText     :=List_GetStringCell(List,A,3);
      If List_GetStringCell(List,A,1)='MPWarning'   Then MPWarning  :=List_GetStringCell(List,A,3);
      End;
   P_Current:=MPArrow;
   Mse_SetPointer(P_Current);
   End;
End;

{ͻ
                           PROCEDURE Sys_Keyboard                           
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: System requester. Set parameters for the keyboard.               
 ͼ}

Procedure Sys_Keyboard(Px,Py:Integer);
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1,But2     :TButton;             {*Structure Boutons*}
    Cyc1          :TCycler;             {*Structure Cyclers*}
    Sld1,Sld2     :TSlider;             {*Structure Sliders*}
    Com3,Com4     :TInputText;          {*Structure Commands*}
    Cin3,Cin4     :String;              {*Strings pour Commands*}
    Isl1,Isl2     :TInputSlider;
    Val1,Val2     :Longint;
    Code          :Integer;
    ValTemp       :Word;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_COMPONENTS;            {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Kbd_SetSpeedKey(Sld1.Value,Sld2.Value);
InputSlider(169,035,025, CLSky,CLSalmon,0,1,32,1,Val1,$0000,Isl1);
InputSlider(169,055,025, CLSky,CLSalmon,0,1,04,1,Val2,$0000,Isl2);
End;

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
BMP_Show  (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_keyb.bmp',$0080);

Bevel_Mos (119,020,345,100, CLMauve,CLWhite,BLLoweredLine,BLRaisedLine,Yes,Language.Loc(117));
Bevel_Mos (119,115,345,186, CLMauve,CLWhite,BLLoweredLine,BLRaisedLine,Yes,Language.Loc(121));

Button (083,204,080,-1, CLTextButton,CLBgButton,$0110,But1,Language.Loc(114));
Button (206,204,080,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));

Slider (Sld1,220,035,114, 32,3,Sld1.Value, COHorizontal,BPOposed,Yes,CLLightGrey, MPArrow,'');
Slider (Sld2,220,055,114, 04,1,Sld2.Value, COHorizontal,BPOposed,Yes,CLLightGrey, MPArrow,'');

Display (129,037, CLText,Language.Loc(118));
Display (129,057, CLText,Language.Loc(119));
Display (129,077, CLText,Language.Loc(120));

InputText  (189,075,145,100,CLSky,CLSalmon,0,$0026,Com3,Cin3);

Bevel      (240,135,270,155, CLBlue,BLLoweredLine,BLNoLine,Yes);
Display    (150,141, CLText,Language.Loc(122));
Display    (150,161, CLText,Language.Loc(123));
Cycler     (190,160,065,   Cyc1.CyclVal,CLTextButton,CLBgButton,$0,Cyc1,Language.Loc(124));
InputText  (190,140,030,3, CLSky,CLSalmon,0,$0027,Com4,Cin4);

BMP_ShowTransparency (290,135,290+100,135+100, 0,0,Sys.GetPath(SP_BUTTONS)+'Ico_keyb.bmp',$0080,CLTransparency);

REDRAW_COMPONENTS;
Win_Clip (No,W1);
End;

Procedure DEFINE_NEW_CURSOR;
Begin
Win_Clip(True,W1);                    {*Hide Cursor If Exist*}
W1.Curs.CursorOff;

Win_Clip(False,W1);
W1.Curs.InitCursor(Cyc1.CyclVal,Sys.CursorBlinkSpeed);{*Set New Cursor Datas*}
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(Px,Py,Px+369,Py+HaF1+230,$53D9,Language.Loc(125),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Cyc1.CyclVal:=Sys.CursorShape;
Sld1.Value:=Sys.SpeedKeyRate;
Sld2.Value:=Sys.SpeedKeyDelay;
Val1:=Sys.SpeedKeyRate;
Val2:=Sys.SpeedKeyDelay;
Str(Sys.CursorBlinkSpeed,Cin4);
Cin3:=Language.Loc(126);

W1.Curs.InitCursor(Sys.CursorShape,Sys.CursorBlinkSpeed);      {*Initialise le Curseur*}
W1.Curs.Locate(252,141);

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False;                        {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   Win_Clip(Yes,W1);
   If Button_GetMsg(But1,1)=CMSelected Then Begin    {*Use*}
      Sys.SpeedKeyRate:=Val1;
      Sys.SpeedKeyDelay:=Val2;
      Val(Cin4, ValTemp, Code);
      Sys.CursorBlinkSpeed := ValTemp;
      Sys.CursorShape:=Cyc1.CyclVal;
      Exit_Flg:=True;
      End;
   If Button_GetMsg(But2,1)=CMSelected Then Begin    {*Cancel*}
      Kbd_SetSpeedKey(Sys.SpeedKeyRate,Sys.SpeedKeyDelay); {*Mode Con Rate=X Delay=Y*}
      Exit_Flg:=True;
      End;
   If Slider_GetMsg(Sld1)=CMModified Then
      Begin
      Val1:=Sld1.Value;
      REDRAW_COMPONENTS;
      End;
   If Slider_GetMsg(Sld2)=CMModified Then
      Begin
      Val2:=Sld2.Value;
      REDRAW_COMPONENTS;
      End;
   If InputSlider_GetMsg(Isl1,Val1)=CMModified Then
      Begin
      Sld1.Value:=Val1;
      Slider_Refresh(Sld1);
      End;
   If InputSlider_GetMsg(Isl2,Val2)=CMModified Then Begin
      Sld2.Value:=Val2;
      Slider_Refresh(Sld2);
      End;
   InputText_GetMsg(Com3,Cin3);
   If InputText_GetMsg(Com4,Cin4)=CMModified Then
      Begin                             {*New Blink Frequence*}
      Val(Cin4, ValTemp, Code);
      Sys.CursorBlinkSpeed := ValTemp;
      DEFINE_NEW_CURSOR;
      End;
   If Cycler_GetMsg(Cyc1,1)=CMSelected Then DEFINE_NEW_CURSOR;{*Change Cursor*}
   Win_Clip(No,W1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Exit_Flg:=True;          {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until Exit_Flg=True;                    {*Flag de Sortie*}

Win_Done(W1);                           {*Suprime Fentre*}
End;

{ͻ
                            FUNCTION Sys_Screen                             
 ͹
  IN.....: Px,Py (INTEGER) = Requester position.                            
           Mode (INTEGER) = Selected mode.                                  
           Title (STRING) = Requester title.                                
  OUT....: (INTEGER) = Return the selected graphic mode.                    
  EXPLAIN: Allow user to select an enable graphics mode in the modes list.  
 ͼ}

Function Sys_Screen(Px,Py,Mode:Integer; Title:String):Integer;
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    XOk,XCancel   :Boolean;             {*Flag de Sortie*}
    But1          :TButton;             {*Structure Boutons*}
    L             :TList;               {*Structure List*}
    P             :Longint;             {*Rsultat Liste Clicke*}
    NumMode,Code,A:Word;
    FName         :String;              {*Nom du fichier Modes Graphiques*}
    SMode         :String;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);

BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_reso.bmp',$0080);
Button   (175,204,080,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
List_Show(L);                           {*Display the List*}
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(Px,Py,Px+430,Py+HaF1+230,$51F9,Title,W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                           {*Affiche la Fentre*}
FName:=Sys.GetPath(SP_DATAS)+'Gfxmodes.lis';

List_Define(L,Language.Loc(222),';',119,014,405,186, 500, CLDataZone,CLSky,$130D);
List_SetIdMore(L,$000C);
List_Load(L,FName);                     {*Load the Graphic Modes*}
List_SetColumnAttr(L,1,-1,Text_Center);
Str(Mode,SMode); P:=List_GetItemIndice(L,SMode,1);
If P>0 Then
   Begin
   List_TagItem(L,P);                   {*Tague le Mode slectionn*}
   List_SetPosition(L,P);               {*Set list begining*}
   End;
For A:=List_MinItem to List_GetQttItems(L) do
   Begin
   Val(List_GetStringCell(L,A,1),NumMode,Code);
   If Not VESA_TestMOSMode(NumMode) Then
      Begin
      List_SetIdItem(L,A,$0001);
      List_SetBkColorItem(L,A,CLLightGrey);
      End;
   End;
REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
XOk:=FALSE; XCancel:=FALSE;             {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Personnels*}
   Win_Clip(Yes,W1);
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=TRUE;      {*Exit*}
   List_Test(L);                        {*Test de la Liste*}
   If (List_TestMouseOnList(L)=1) And (Mse_TestDoubleClick) Then XOk:=TRUE;
   Win_Clip(No,W1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then XCancel:=TRUE;    {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Flag de Sortie*}

If XOk Then
   Begin
   Sys.RefreshScreen:=2;                {*Refresh level set to 2*}
   Val(List_GetStringCell(L,List_GetTaggedItem(L),1), Mode,Code);
   End;
Sys_Screen:=Mode;                       {*Send result*}

List_Done(L);                           {*Supprime la Liste*}
Win_Done(W1);                           {*Supprime Fentre*}
End;

{ͻ
                            PROCEDURE Sys_Colors                            
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: System requester. Set parameters for the MOS colors.             
 ͼ}

Procedure Sys_Colors(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flags*}
    Ong1          :TTabs;               {*Tabs Tab*}
    But1,But2     :TButton;             {*Button structure*}
    Bu1,Bu2,Bu3,
    Bu4,Bu5,Bu6   :TButton;
    A1,A2,B1,B2,C1,C2:Longint;          {*Shades colors*}
    List          :TList;               {*List colors*}
    Res           :Longint;             {*Result list*}
    ColItem       :Longint;             {*Color item*}

{***************************** DISPLAY COLITEM ******************************}

Procedure DISPLAY_COLITEM;
Begin
End;

{****************************** DISPLAY SHADES ******************************}

Procedure DISPLAY_SHADES;
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
Button (130,055,025,020, CLTextButton,B1,$0020,Bu3,'','',Language.Loc(141));
Button (330,055,025,020, CLTextButton,B2,$0020,Bu4,'','',Language.Loc(142));
Display_Shade(165,055,320,075,B1,B2,0);

Button (130,105,025,020, CLTextButton,A1,$0020,Bu1,'','',Language.Loc(141));
Button (330,105,025,020, CLTextButton,A2,$0020,Bu2,'','',Language.Loc(142));
Display_Shade(165,105,320,125,A1,A2,0);

Button (130,155,025,020, CLTextButton,C1,$0020,Bu5,'','',Language.Loc(141));
Button (330,155,025,020, CLTextButton,C2,$0020,Bu6,'','',Language.Loc(142));
Display_Shade(165,155,320,175,C1,C2,0);
End;

{************************** DISPLAY WINDOW CONTENT **************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
BMP_Show(019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_colo.bmp',$0080);

Tabs (119,014,365,189, Ong1.No, CLLightGrey,CLLightGrey,$0014,Ong1,Language.Loc(311));
Button (080,204, 100,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
Button (208,204, 100,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));

Case Ong1.No of
   1: Begin                             {*Interface colors*}
      List_Show(List);
      DISPLAY_COLITEM;
      End;
   2: Begin                             {*Window title colors*}
      Display (130,040,CLText,Language.Loc(88));
      Display (130,090,CLText,Language.Loc(89));
      Display (130,140,CLText,Language.Loc(90));
      DISPLAY_SHADES;
      End;
   End;

Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+388,Py+HaF1+230,$51F9,Language.Loc(265),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

Ong1.No:=1;                             {*1er tab*}
XOk:=No; XCancel:=No;
A1:=Sys.WinInactiveCol1;
A2:=Sys.WinInactiveCol2;
B1:=Sys.WinActiveCol1;
B2:=Sys.WinActiveCol2;
C1:=Sys.PanelShadeCol1;
C2:=Sys.PanelShadeCol2;

List_Define(List,Language.Loc(84),';',130,040,355,152, 100,CLDataZone,CLDataZone,$1381);
List_Load(List,Sys.GetPath(SP_DATAS)+'Colitems.lis');
List_AdjustColumns(List);
List_TagItem(List,1);
List_SetIdMore(List,$0008);

ColItem:=CLBlack;

REDRAW_FRAME;                           {*Display Window Content*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes;       {*Ok*}
   If Button_GetMsg(But2,1)=CMSelected Then XCancel:=Yes;   {*Cancel*}

   If Tabs_GetMsg(Ong1,1)=CMSelected Then REDRAW_FRAME;

   Case Ong1.No of
      1: Begin
         Res:=List_Test(List);
         If Res>0 Then
            Begin
            ColItem:=Res;
            DISPLAY_COLITEM;
            End;
         If Button_GetMsg(Bu5,1)=CMSelected Then
            Begin
            ColItem:=Req_GetRGBColor(W1.X1+20,W1.Y1+30,ColItem,1,$0007,Language.Loc(91));
            DISPLAY_COLITEM;
            End;
	 End;

      2: Begin
         If Button_GetMsg(Bu1,1)=CMSelected Then
            Begin
            A1:=Req_GetRGBColor(W1.X1+20,W1.Y1+30,A1,1,$0007,Language.Loc(91));
            DISPLAY_SHADES;
            End;
         If Button_GetMsg(Bu2,1)=CMSelected Then
            Begin
            A2:=Req_GetRGBColor(W1.X1+20,W1.Y1+30,A2,1,$0007,Language.Loc(91));
            DISPLAY_SHADES;
            End;
         If Button_GetMsg(Bu3,1)=CMSelected Then
            Begin
            B1:=Req_GetRGBColor(W1.X1+20,W1.Y1+30,B1,1,$0007,Language.Loc(91));
            DISPLAY_SHADES;
            End;
         If Button_GetMsg(Bu4,1)=CMSelected Then
            Begin
            B2:=Req_GetRGBColor(W1.X1+20,W1.Y1+30,B2,1,$0007,Language.Loc(91));
            DISPLAY_SHADES;
            End;
         If Button_GetMsg(Bu5,1)=CMSelected Then
            Begin
            C1:=Req_GetRGBColor(W1.X1+20,W1.Y1+30,C1,1,$0007,Language.Loc(91));
            DISPLAY_SHADES;
            End;
         If Button_GetMsg(Bu6,1)=CMSelected Then
            Begin
            C2:=Req_GetRGBColor(W1.X1+20,W1.Y1+30,C2,1,$0007,Language.Loc(91));
            DISPLAY_SHADES;
            End;
	 End;
      End;

   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;     {*Window Closed   => Exit*}
If Even=CMMoved  Then REDRAW_FRAME;     {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flags*}

List_Done(List);                        {*Kill list*}
Win_Done(W1);                           {*Close Window if Needs*}

If XOk Then                             {*Validate modifications*}
   Begin
   Sys.WinInactiveCol1:=A1;
   Sys.WinInactiveCol2:=A2;
   Sys.WinActiveCol1:=B1;
   Sys.WinActiveCol2:=B2;
   Sys.PanelShadeCol1:=C1;
   Sys.PanelShadeCol2:=C2;
   Sys.RefreshScreen:=2;                {*Refresh level set to 2*}
   End;
End;

{ͻ
                             PROCEDURE Sys_Misc                             
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: System requester. Set parameters for miscellaneous MOS parts.    
 ͼ}

Procedure Sys_Misc(Px,Py:Integer);
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1,But2     :TButton;             {*Structure Boutons*}
    Rad1,Rad2     :TRadioBox;           {*Structure Radios*}
    Sld1          :TSlider;             {*Structure Sliders*}
    Isl1,Isl2,Isl3:TInputSlider;
    Val1,Val2,Val3:Longint;
    Num           :Integer;
    Tab1          :TTabs;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_ISL3;
Begin
Win_Clip(Yes,W1);
InputSlider(139,065,030, CLSky,CLSalmon,0,1,100,1,Val3,$0000,Isl3);
End;

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
BMP_Show  (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_misc.bmp',$0080);

Tabs   (119,014,340,189, Tab1.No, CLLightGrey,CLLightGrey,$0014,Tab1,'_Grid|_Miscellaneous');
Button (082,204,080,-1, CLTextButton,CLBgButton,$0110,But1,Language.Loc(114));
Button (203,204,080,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));

Case Tab1.No of
   1: Begin
      Bevel_Mos (129,045,330,125, CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(127));
      Display (190,081, CLText,Language.Loc(130));
      Display (190,101, CLText,Language.Loc(131));
      RadioBox   (139,060,1,$0010,0,0,Rad1.Status,Rad1,Language.Loc(129));
      InputSlider(139,080,030, CLSky,CLSalmon,0,1,99,1,Val1,$0001,Isl1);
      InputSlider(139,100,030, CLSky,CLSalmon,0,1,99,1,Val2,$0000,Isl2);
      End;
   2: Begin
      Bevel_Mos  (129,045,330,135, CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(128));
      Display (190,065, CLText,Language.Loc(132));
      RadioBox   (139,110,1,$0010,0,0,Rad2.Status,Rad2,'Display hints information');
      Slider(Sld1,139,085,160, 100,10,Sld1.Value, COHorizontal,BPOposed,Yes,CLLightGrey, MPArrow,'');
      REDRAW_ISL3;
      End;
   End;

Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(Px,Py,Px+363,Py+HaF1+230,$51D9,Language.Loc(134),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                           {*Affiche la Fentre*}

Rad1.Status:=Sys.SetGrid;
Rad2.Status:=Sys.DisplayHints;
Sld1.Value:=Sys.LightBoxMinSize;
Val3:=Sys.LightBoxMinSize;
Val1:=Sys.GridStepX;
Val2:=Sys.GridStepY;
Tab1.No:=1;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False;                        {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   Win_Clip(Yes,W1);
   If Tabs_GetMsg(Tab1,1)=CMSelected Then REDRAW_FRAME;

   Case Tab1.No of
      1: Begin
         RadioBox_GetMsg(Rad1,1);
         InputSlider_GetMsg(Isl1,Val1); {*Grid offset X*}
         InputSlider_GetMsg(Isl2,Val2); {*Grid offset Y*}
         End;
      2: Begin
         RadioBox_GetMsg(Rad2,1);
         If Slider_GetMsg(Sld1)=CMModified Then
            Begin
            Val3:=Sld1.Value;
            REDRAW_ISL3;
            End;
         If InputSlider_GetMsg(Isl3,Val3)=CMModified Then
            Begin                       {*Light Box Min Size*}
            Sld1.Value:=Val3;
            Slider_Refresh(Sld1);
            End;
         End;
      End;

   If Button_GetMsg(But1,1)=CMSelected Then Begin    {*Use*}
      Sys.SetGrid:=Rad1.Status;
      Sys.GridStepX:=Val1;
      Sys.GridStepY:=Val2;
      Sys.LightBoxMinSize:=Sld1.Value;
      Sys.DisplayHints:=Rad2.Status;
      Exit_Flg:=True;
      End;
   If Button_GetMsg(But2,1)=CMSelected Then Exit_Flg:=True; {*Cancel*}
   Win_Clip(No,W1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Exit_Flg:=True;   {*Fentre Ferme => Exit*}

If Even=CMMoved Then REDRAW_FRAME;      {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until Exit_Flg=True;                    {*Flag de Sortie*}

Win_Done(W1);                           {*Suprime Fentre*}

If (Sys.GridStepX>20) or (Sys.GridStepY>10) Then Begin Sys.SetGrid:=No;
   Num:=3;                              {*Icne Question*}
   Req_Dialog(Language.Loc(1),Language.Loc(135)+Language.Loc(208)+Language.Loc(209),Language.Loc(136),NUM);
   If Num=2 Then Begin Sys.GridStepX:=10; Sys.GridStepY:=5; End;
   Sys.SetGrid:=Rad1.Status;            {*Remet grid dans l'tat Dfinit*}
   End;
End;

{ͻ
                           PROCEDURE Sys_Blankers                           
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: System requester. Set parameters for the MOS screen blankers.    
 ͼ}

Procedure Sys_Blankers(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flags*}
    But1,But2,But3,But4,But5:TButton;
    Rad1          :TRadioBox;
    L,L2          :TList;               {*List Structure*}
    Res           :Integer;             {*List Test*}
    Num           :Integer;
    A,B           :Integer;
    FTemp1,FTemp2 :String;
    S1,S2         :String;              {*Strings pour Comparaisons*}
    Found         :Integer;             {*Comparaison*}
    Selected      :Integer;
    Str1          :String;
    FName         :String;              {*Blanker Name*}
    Size          :Integer;
    Com1          :TInputText;          {*InputText Requester*}
    Cin1          :String;
    Code          :Integer;
    ValTemp       :Byte;

{************************** DISPLAY IMAGE EXAMPLE ***************************}

Procedure Display_Example_IMAGE;
Begin
FName:=List_GetStringCell(L,Selected,List_GetColumnNum(L,1));
FName:=Str_FileMask(FName,'*.BMP');     {*Build BMP Name*}
If FName[1]='(' Then FName:='NONE.BMP'; {*Pas de Blankers*}
FName:=Sys.GetPath(SP_BLANKERS)+FName;
If Not BMP_TestFile(FName) Then Begin   {*Pas d'images de prsentation*}
   FName:=Sys.GetPath(SP_BLANKERS)+'NONE.BMP';
   End;

Win_Clip(Yes,W1);                       {*Clipping Window*}
If BMP_TestFile(FName) Then BMP_Show(439,046,560,135, 0,0,FName,$0080);
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_cryp.bmp',$0080);

Bevel_Title (119,014,400,194, CLLightGrey,CLWhite,BLLoweredLine,BLRaisedLine,TJOnLeft,TJOnTop,Yes,'MODN.CHR',4,$0067,Language.Loc(143));
List_Show(L);

RadioBox (129,170,1,$0010,0,0,Rad1.Status,Rad1,Language.Loc(144));
Display  (129,128, CLText,Language.Loc(145));
InputText(279,128,040,2, CLSky,CLSalmon,0,$26,Com1,Cin1);
Button   (165,210,080,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
Button   (370,210,080,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));
Button   (279,170,110,-1, CLTextButton,CLBgButton,$0000,But3,Language.Loc(146));
Button   (279,148,110,-1, CLTextButton,CLBgButton,$0000,But4,Language.Loc(147));
Button   (129,148,110,-1, CLTextButton,CLBgButton,$0000,But5,Language.Loc(282));

Button_Freeze(Not Rad1.Status,But5);    {*Password or No ?*}
BMP_ShowTransparency(408,018,610,192, 0,0,Sys.GetPath(SP_IMAGES)+'Monitor.bmp',$0080,CLTransparency);

Display_Example_IMAGE;                  {*Affiche un Exemple*}

Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{***************************** MAIN PROCEDURE *******************************}

Procedure EXEC_BLK(Mode:Byte);
Var BlkName:String;
Begin
BlkName:=List_GetStringCell(L,Selected,List_GetColumnNum(L,1));
If BlkName[1]='(' Then Exit;            {*Aucun Blanker*}
Execute_Blanker(BlkName, Mode);         {*Appel Blanker*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
Size:=615;

If Not Win_Init(Px,Py,Px+Size,Py+HaF1+236,$51F9,Language.Loc(1661),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);  {*Supplement*}
Win_Draw(W1);                           {*Display Window*}

List_Define(L, Language.Loc(771),';',129,027,389,120, 200, CLDataZone,CLSky,$138D);
List_Define(L2,'',';',0,0,0,0,500,CLBlack,CLBlack,$1388);{*Max = 500 Blankers*}

List_SetColumnAttr(L,1,100,Text_OnLeft);{*Paramtrage des Colonnes*}
List_SetColumnAttr(L,2,158,Text_OnLeft);
List_SetColumnId(L,2,$01);              {*Edit Description*}
List_SetIdMore(L,$0008);

FTemp1:=Sys.GetPath(SP_TEMP)+'BLANKERS.UPD';
FTemp2:=Sys.GetPath(SP_DATAS)+'BLANKERS.LIS';
List_Load(L,FTemp2);
File_GetDirectory(Sys.GetPath(SP_BLANKERS)+'*.EXE',FTemp1);
List_Load(L2,FTemp1);                   {*Load New List*}

For A:=1 to L2.Qtt_Items do             {*Parcours Main List*}
   Begin
   S1:=Upper(List_GetStringCell(L2,A,1));{*1 Fichier...*}
   Found:=0;
   For B:=1 to L.Qtt_Items do           {*Compare  New List*}
      Begin
      S2:=List_GetStringCell(L,B,1);
      If Upper(S2)=S1 Then Found:=A;
      End;
   If Found=0 Then List_AddItem(L,S1,Insert_Append);
   End;

File_Erase(FTemp1);                  {*Delete Liste Temporaire*}
List_Sort(L,1,Sort_AZ,0);
If Copy(List_GetStringCell(L,1,1),1,1)<>'(' Then List_AddItem(L,Language.Loc(360),Insert_First);

List_Done(L2);                          {*Dtruit la Liste Temporaire*}

{Rad1.Status:=Sys.SetMouseBlanker;}
{!}Rad1.Status:=FALSE;                  {*A mettre dans les ".INI"*}

Selected:=0;                            {*Recherche du Blanker dfinit*}
Selected:=List_GetItemIndice(L,Sys.ScreenBlanker,1);
List_TagItem(L,Selected);
Str(Sys.ScreenBlankerDelay,Cin1);
REDRAW_FRAME;                           {*Display Window Content*}
XOk:=No; XCancel:=No;                   {*Init Exit Flags*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   InputText_GetMsg(Com1,Cin1);
   If RadioBox_GetMsg(Rad1,1)<>CMNone Then Button_Freeze(Not Rad1.Status,But5);
   If Button_GetMsg (But1,1)=CMSelected Then XOk:=TRUE;
   If Button_GetMsg (But2,1)=CMSelected Then XCancel:=TRUE;
   If Button_GetMsg (But3,1)=CMSelected Then Begin EXEC_BLK(BLK_Execute); End; {*Execute Blanker*}
   If Button_GetMsg (But4,1)=CMSelected Then Begin EXEC_BLK(BLK_Parameter);End;{*Paramtre Blanker*}
   If Button_GetMsg (But5,1)=CMSelected Then
      Begin

      Str1:='$'; Num:=3;
      Req_String(Language.Loc(772),Language.Loc(277),Language.Loc(708),100,180,Str1,Num);
      If Num=1 Then
         Begin                          {*Password Accepted...*}
         End;
      End;
   Res:=List_Test(L);                   {*Text de la Liste...*}
   If Res>0 Then Begin
      Selected:=Res;
      Display_Example_IMAGE;            {*Affiche un Exemple*}
      End;
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;            {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flags*}

Win_Done(W1);                           {*Close Window if Needs*}
If XOk Then Begin
   List_Save(L,FTemp2);                 {*Save New List*}
   Sys.ScreenBlanker:=List_GetStringCell(L,Selected,List_GetColumnNum(L,1));
   Val(Cin1, ValTemp, Code);
   Sys.ScreenBlankerDelay := ValTemp;
   End;
List_Done(L);                           {*Dtruit la Liste*}
End;

{ͻ
                            PROCEDURE Sys_Sounds                            
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: System requester. Set parameters for sounds.                     
 ͼ}

Procedure Sys_Sounds(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;
    Tab1          :TTabs;               {*Tabs Tab*}
    But1,But2,But3,
    But4,But5     :TButton;             {*Ok / Cancel*}
    Rad1,Rad2     :TRadioBox;           {*Radios Structure*}
    Sld1,Sld2     :TSlider;             {*Sliders Structure*}
    DirSel,FilSel :String;              {*Manage Directories*}
    Size          :Longint;
    A             :Integer;
    L             :TList;               {*Structure Liste*}
    StItem        :String;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_soun.bmp',$0080);

Tabs (119,014,420,189, Tab1.No, CLLightGrey,CLLightGrey,$0014,Tab1,Language.Loc(92));
Button (106,204,080,-1, CLTextButton,CLBgButton,$0000,But1,'_OK',MPHand,'');
Button (253,204,080,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));

Case Tab1.No of
   1: Begin
      Button (130,166,120,-1, CLTextButton,CLBgButton,$0160,But3,Language.Loc(181));
      Button (290,166,120,-1, CLTextButton,CLBgButton,$0060,But4,Language.Loc(213));
      List_Show(L);                     {*Display List*}
      End;
   2: Begin
      Bevel_Mos(130,045,410,180, CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(179));
      Display  (310,100, CLText,Language.Loc(180));
      Display  (310,121, CLText,Language.Loc(313));
      RadioBox (310,061,2,$10,0,1,Rad1.Status,Rad1,Language.Loc(184));
      RadioBox (310,076,2,$10,0,1,Rad2.Status,Rad2,Language.Loc(185));
      Slider   (Sld1,140,099,150, 64,6,Sld1.Value, COHorizontal,BPOposed,Yes,CLLightGrey, MPArrow,'');
      Slider   (Sld2,140,120,150, 64,6,Sld2.Value, COHorizontal,BPOposed,Yes,CLLightGrey, MPArrow,'');
      Button   (140,155,161,-1, CLTextButton,CLBgButton,$0000,But5,Language.Loc(225),MPAudio,Language.Loc(93));
      BMP_ShowTransparency (355,065,355+100,065+100, 0,0,Sys.GetPath(SP_BUTTONS)+'Ico_mult.bmp',$0080,CLTransparency);
      BMP_ShowTransparency (325,141,325+100,141+100, 0,0,Sys.GetPath(SP_BUTTONS)+'Ico_cdmu.bmp',$0080,CLTransparency);
      End;
   End;

Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+440,Py+HaF1+230,$51D9,Language.Loc(183),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

Tab1.No:=1;
List_Define(L,Language.Loc(178),';',130,040,410,156, 200, CLDataZone,CLDataZone,$0B89);
List_SetIdMore(L,$000A);
List_SetColumnId(L,2,$0001);

Rad1.Status:=BTST(Id_Msg1,11);          {*Speaker or SB...*}
Rad2.Status:=Not Rad1.Status;

Sld1.Value:=64;
Sld2.Value:=44;
For A:=1 to Max_AS do List_AddItem(L,Language.Loc(A+313)+';'+Sys.SoundFile[A],Insert_Append);
List_TagItem(L,List_MinItem);
List_AdjustColumn(L,1);
List_SetColumnAttr(L,2,090,Text_OnLeft);

REDRAW_FRAME;                           {*Display Window Content*}
XOk:=No; XCancel:=No;                   {*Init Exit Flag*}
StItem:='';                             {*No items de base*}
DirSel:=Sys.GetPath(SP_SOUNDS);      {*Sons dans le rpertoire Systme*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes;
   If Button_GetMsg(But2,1)=CMSelected Then XCancel:=Yes;
   If Tabs_GetMsg(Tab1,1)=CMSelected Then REDRAW_FRAME;

   Case Tab1.No of
      1: Begin
         A:=List_Test(L);               {*Teste la Liste*}
         If A<>0 Then StItem:=List_GetStringCell(L,A,2);
         If Button_GetMsg(But4,1)=CMSelected Then {*Play Sound*}
            If Test_WAV(Sys.GetPath(SP_SOUNDS)+StItem) Then
            If Rad1.Status Then Play_WAVSb(Sys.GetPath(SP_SOUNDS)+StItem)      {*Play WAV SB...*}
                           Else Play_WAVSpeaker(Sys.GetPath(SP_SOUNDS)+StItem);{*Play WAV Speaker...*}
         If Button_GetMsg(But3,1)=CMSelected Then
            Begin
            A:=List_GetTaggedItem(L);
            FilSel:=StItem;
            Req_FileManager(W1.X1+50,W1.Y1+30,250,Language.Loc(177),'_OK','*.WAV',0,DirSel,FilSel,Size);
            List_SetStringCell(L,A,2,FilSel);
            StItem:=FilSel;
            Win_Clip(Yes,W1);           {*Reclip Window*}
            List_ShowItem(L,A);
            End;
         End;

      2: Begin
         RadioBox_GetMsg(Rad1,1);
         RadioBox_GetMsg(Rad2,1);
         Slider_GetMsg(Sld1);           {*Define volume*}
         Slider_GetMsg(Sld2);           {*Define volume*}

         If Button_GetMsg(But5,1)=CMSelected Then Req_DefineAudioCD(W1.X1+20,W1.Y1+30,Str_Replace(Language.Loc(225),'_','',$000),'');
         End;
      End;

   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;     {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flag*}

If XOk Then                             {*Use*}
   Begin
   For A:=1 to Max_AS do Sys.SoundFile[A]:=List_GetStringCell(L,A,2);
   If Rad1.Status Then BSET(Id_Msg1,11)
                  Else BCLR(Id_Msg1,11);
   End;

Win_Done(W1);                           {*Close Window if Needs*}
List_Done(L);
End;

{ͻ
                        PROCEDURE Sys_ErrorsHistory                         
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: System requester. Get history for errors.                        
 ͼ}

Procedure Sys_ErrorsHistory(Px,Py:Integer);  {*Define ErrorsHistory parameters*}
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    XOk           :Boolean;             {*Flag de Sortie*}
    But1,But2     :TButton;             {*Structure Boutons*}
    Inp1          :TInputText;          {*Structure InputText*}
    Cin1          :String;
    L             :TList;               {*Structure List*}
    FName         :String;              {*Nom de la Liste*}
    Num           :Integer;

{************************* AFFICHE CONTENU FENETRE **************************}


Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);

Button (175,190,080,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
Button (270,163,150,-1, CLTextButton,CLBgButton,$0070,But2,Language.Loc(1660));
Display(060,163,CLText,Language.Loc(1663));
Str(MOS_Errors.QttErrors,Cin1);                    {*Nombre d'erreurs*}
InputText(020,163,030,5, CLSky,CLLightBlue,1,$0066,Inp1,Cin1);

List_Show(L);                           {*Display the List*}

Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Procedure INIT;
Var QttLines:Longint;

Begin
FName:=Sys.GetPath(SP_DATAS)+'Errors.his';
If Not File_TestExist(FName) Then File_Create(FName);
QttLines:=File_CountLines(FName)+10;     {*10 entres de plus par scurit*}
List_Define(L,Language.Loc(1664),';',020,014,420,154, QttLines, CLDataZone,CLDataZone,$1B89);
List_SetIdMore(L,$0008);
List_SetColumnAttr(L,1,-1,Text_OnRight);{*Corrige les attributs des colonnes*}
List_Load(L,FName);                     {*Load the History*}

List_AdjustColumns(L);                  {*Ajuste les colonnes*}

List_SetColumnAttr(L,8,300,Text_OnLeft);
List_SetColumnId(L,8,$0001);

List_TagItem(L,List_GetQttItems(L));    {*Tag the Last Error*}
List_SetPosition(L,List_GetQttItems(L));{*Pos sur l'item Tagu*}
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(Px,Py,Px+440,Py+HaF1+216,$51F9,Language.Loc(1665),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);
Win_Draw(W1);                           {*Affiche la Fentre*}

INIT;                                   {*Initialise the List*}
REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
XOk:=FALSE;                             {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Personnels*}
   Win_Clip(Yes,W1);
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=TRUE;      {*Ok*}
   If Button_GetMsg(But2,1)=CMSelected Then Begin  {*Clear History*}
      Num:=3;
      Req_Dialog(Language.Loc(1666),Language.Loc(1667),Language.Loc(94),Num);
      If Num=1 Then Begin
         File_Erase(FName);
         List_Done(L);                  {*Supprime la Liste*}
         INIT;                          {*Reinitialise the List*}
         REDRAW_FRAME;
         End;
      End;
   List_Test(L);                        {*Test de la Liste*}
   Win_Clip(No,W1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then XOk:=True;               {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until XOk;                              {*Flag de Sortie*}

Win_Done(W1);                           {*Supprime Fentre*}
List_Save(L,FName);                     {*Save Datas*}
List_Done(L);                           {*Supprime la Liste*}
End;

{ͻ
                          PROCEDURE Sys_ListErrors                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Display the Runtimes errors list managed by MOS.                 
 ͼ}

Procedure Sys_ListErrors(Px,Py:Integer);
Var FName:String;
Begin
FName:=Sys.GetPath(SP_DATAS)+'Err_run.lis';
If File_TestExist(FName) Then File_Erase(FName);
FName:=Sys.GetPath(SP_DATAS) + Locale.GetErrorFile(Language.Code);
Req_List(Px,Py,$0000,Language.Loc(1673),Language.Loc(1674),';',FName); {*Display List*}
End;

{ͻ
                            PROCEDURE Sys_Errors                            
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: System requester. Set parameters for manage the MOS errors.      
 ͼ}

Procedure Sys_Errors(Px,Py:Integer);
Const Max_Rad=5;
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But2,But3,But4,
    But5,But6     :TButton;             {*Structure Boutons*}
    Rad2,Rad3     :TRadioBox;           {*Structure Radios*}
    TR            :Array[1..Max_Rad] of TRadioBox;
    A             :Integer;
    Tab1          :TTabs;               {*Tabs Tab*}

{************************* FREEZE / DEFREEZE GADGETS ************************}

Procedure FREEZE_GAD;
Begin
Win_Clip(Yes,W1);
If Rad3.Status=No
   Then Button_Freeze(Yes,But2)         {*Freeze Gadgets*}
   Else Button_Freeze(No,But2);
Win_Clip(No,W1);
End;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Var A             :Integer;
Begin
Win_Clip (Yes,W1);
BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_erro.bmp',$0080);

Tabs   (119,014,330,189, Tab1.No, CLLightGrey,CLLightGrey,$0014,Tab1,Language.Loc(95));
Button (076,204,080,-1, CLTextButton,CLBgButton,$0110,But3,Language.Loc(114));
Button (194,204,080,-1, CLTextButton,CLBgButton,$0000,But4,Language.Loc(13));

Case Tab1.No of
   1: Begin
      Bevel_Mos (130,045,320,135, CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(148));
      BMP_ShowTransparency (130,145,130+100,145+100, 0,0,Sys.GetPath(SP_BUTTONS)+'Bsm_warn.bmp',$0080,CLTransparency);
      For A:=1 to Max_Rad do
         RadioBox (140,057+(A-1)*14,2,$0010,1,0,TR[A].Status,TR[A],Upper(Str_Get(Language.Loc(1727),A,';')));
      End;
   2: Begin
      Bevel_Mos(130,045,320,178,CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(150));
      Button   (140,060,170,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(154));
      Button   (140,080,170,-1, CLTextButton,CLBgButton,$0000,But5,Language.Loc(1668));
      Button   (140,100,170,-1, CLTextButton,CLBgButton,$0000,But6,Language.Loc(1669));
      RadioBox (140,138,1,$0010,0,0,Rad2.Status,Rad2, Language.Loc(151));
      RadioBox (140,155,1,$0010,0,0,Rad3.Status,Rad3, Language.Loc(152));
      FREEZE_GAD;                       {*Freeze / Unfreeze Gadgets*}
      End;
   End;

Win_Clip (No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(Px,Py,Px+350,Py+HaF1+230,$51F9,Language.Loc(155),W1) Then Exit;
If Not Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1) Then Exit;
Win_Draw(W1);                           {*Affiche la Fentre*}

Tab1.No:=1;
For A:=1 to Max_Rad do TR[A].Status:=FALSE;
TR[MOS_Errors.Level+1].Status:=TRUE;    {*Tag le bon Radiobox*}
If Id_Err1 And $2=$2 Then Rad2.Status:=True Else Rad2.Status:=False;
If Id_Err1 And $4=$4 Then Rad3.Status:=True Else Rad3.Status:=False;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False;                        {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Personnels*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Tabs_GetMsg(Tab1,1)=CMSelected Then REDRAW_FRAME;

   Case Tab1.No of
      1: Begin
         For A:=1 to Max_Rad do RadioBox_GetMsg(TR[A],1);
         End;
      2: Begin
         If Button_GetMsg(But2,1)=CMSelected Then   {*Select Sound Error*}
            Sys_Sounds(W1.X1+20,W1.Y1+30);
         If Button_GetMsg(But5,1)=CMSelected Then Sys_ErrorsHistory(W1.X1+20,W1.Y1+30); {*History*}
         If Button_GetMsg(But6,1)=CMSelected Then Sys_ListErrors(W1.X1+20,W1.Y1+30);
         RadioBox_GetMsg(Rad2,1);
         If RadioBox_GetMsg(Rad3,1)<>CMNone Then FREEZE_GAD; {*Test Freeze ou pas*}
         End;
      End;

   If Button_GetMsg(But3,1)=CMSelected Then Begin    {*Use*}
      Id_Err1:=Id_Err1 And $F8;                {*Masque les 3 1er Bits*}
      If Rad2.Status=TRUE Then Id_Err1:=Id_Err1 Or $2;
      If Rad3.Status=TRUE Then Id_Err1:=Id_Err1 Or $4;
      For A:=1 to Max_Rad do If TR[A].Status Then MOS_Errors.Level:=A-1;
      Exit_Flg:=TRUE;
      End;
   If Button_GetMsg(But4,1)=CMSelected Then Exit_Flg:=TRUE;      {*Cancel*}
   Win_Clip(No,W1);                     {*Clipping Window*}
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Exit_Flg:=True;   {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until Exit_Flg=True;                    {*Flag de Sortie*}

Win_Done(W1);                           {*Supprime Fentre*}
End;

{ͻ
                            PROCEDURE Sys_Fonts                             
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: System requester. Set parameters for the Fonts.                  
 ͼ}

Procedure Sys_Fonts(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flags*}
    But1,But2,But3:TButton;             {*Buttons Structure*}
    List          :TList;
    FontVa        :String;
    FontSi        :Longint;
    Tagged        :Integer;             {*Tagged item*}

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_EXAMPLE;
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
Tagged:=List_GetTaggedItem(List);
FontVa:=List_GetStringCell(List,Tagged,2);
FontSi:=Str_S2L(List_GetStringCell(List,Tagged,3));
Bevel_Title(120,116,380,160, CLLightGrey,CLWhite,BLLoweredLine,BLRaisedLine,TJOnCenter,TJOnCenter,Yes,FontVa,FontSi,$0067,Language.Loc(161));
End;

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
BMP_Show  (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_font.bmp',$0080);
Button    (093,204,080,-1, CLTextButton,CLBgButton,$0000,But1,'_OK',MPHand,'');
Button    (226,204,080,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));
Button    (120,170,150,-1, CLTextButton,CLBgButton,$0110,But3,Language.Loc(160));
List_Show(List);
Win_Clip(No,W1);                        {*Restore Normal Clipping*}

REDRAW_EXAMPLE;                         {*Draw font example*}
End;

{******************************** INIT ALL **********************************}

Procedure INIT;                         {*Init all data*}
Begin
XOk:=No; XCancel:=No;                   {*Init Exit Flags*}
List_Define(List,Language.Loc(158),';',120,014,380,106, 100, CLDataZone,CLDataZone,$0389);

List_AddItem(List,Str_Get(Language.Loc(159),1,'|')+Sys.FontMain+';'+Str_L2S(Sys.FontMainSize),Insert_Append);
List_AddItem(List,Str_Get(Language.Loc(159),2,'|')+Sys.FontWinTitle+';'+Str_L2S(Sys.FontWinTitleSize),Insert_Append);
List_AddItem(List,Str_Get(Language.Loc(159),3,'|')+Sys.FontMenu+';'+Str_L2S(Sys.FontMenuSize),Insert_Append);
List_AddItem(List,Str_Get(Language.Loc(159),4,'|')+Sys.FontHint+';'+Str_L2S(Sys.FontHintSize),Insert_Append);

List_AdjustColumns(List);
List_SetColumnAttr(List,2,80,Text_OnLeft);
List_SetColumnAttr(List,3,50,Text_OnLeft);
List_SetColumnId(List,2,$0001);
List_SetColumnId(List,3,$0001);
List_TagItem(List,1);                   {*Tag the first item*}
List_SetIdMore(List,$0008);
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+400,Py+HaF1+230,$51D9,Language.Loc(157),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

INIT;                                   {*Init all data*}
REDRAW_FRAME;                           {*Display Window Content*}

Repeat
try

If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes;
   If Button_GetMsg(But2,1)=CMSelected Then XCancel:=Yes;
   If (Button_GetMsg(But3,1)=CMSelected) Or
      ((List_TestMouseOnList(List)=1) And (Mse_TestDoubleClick)) Then
   Begin
      FontVa:=List_GetStringCell(List,Tagged,2);
      FontSi:=Str_S2L(List_GetStringCell(List,Tagged,3));
      Req_Font(W1.X1+20,W1.Y1+30,Language.Loc(168),FontVa,FontSi);
      List_SetStringCell(List,Tagged,2,FontVa);
      List_SetStringCell(List,Tagged,3,Str_L2S(FontSi));
      List_Refresh(List);
      REDRAW_EXAMPLE;
   End;

   If List_Test(List)>0 Then REDRAW_EXAMPLE;
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;     {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flags*}

Font_SetSpecial(1);                     {*Rajuste Taille Fonte Window Title*}
Font_SetSpecial(0);                     {*Rajuste Taille Fonte Norm*}
{Font_SetSpecial(2);}                     {*Rajuste Taille Fonte Icne*}

Win_Done(W1);                           {*Close Window if Needs*}
If XOk Then                             {*Validate*}
   Begin
   Sys.FontMain    :=List_GetStringCell(List,1,2);
   Sys.FontWinTitle:=List_GetStringCell(List,2,2);
   Sys.FontMenu    :=List_GetStringCell(List,3,2);
   Sys.FontHint    :=List_GetStringCell(List,4,2);
   Sys.FontMainSize:=Str_S2L(List_GetStringCell(List,1,3));
   Sys.FontWinTitleSize:=Str_S2L(List_GetStringCell(List,2,3));
   Sys.FontMenuSize:=Str_S2L(List_GetStringCell(List,3,3));
   Sys.FontHintSize:=Str_S2L(List_GetStringCell(List,4,3));
   Sys.RefreshScreen:=2;                {*Refresh level set to 2*}
   End;

List_Done(List);
End;

{ͻ
                           PROCEDURE Sys_Graphics                           
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: System requester. Set parameters for the MOS visual aspect.      
 ͼ}

Procedure Sys_Graphics(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flag*}
    But1,But2     :TButton;             {*Buttons Structure*}
    Tab1          :TTabs;               {*Tabs Tab*}
    B1,BEx,BTrans :TButton;
    Com1,Com2,Com3:TInputText;
    DirSel,FilSel :String;
    FileSize      :Longint;
    NewTransparency:Longint;            {*Transparency color*}
    Rad1,Rad2,Rad3:TRadioBox;           {*Center or Mosaic*}

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_EXAMPLES;
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
Case Tab1.No of
   1: Begin
      Button    (140,105,100,063, CLTextButton,CLBgButton,$0068,BEx,Com1.Cin);
      InputText (140,080,200,255, CLSky,CLLightBlue,1,$0066,Com1,Com1.Cin);
      End;
   2: Begin
      Button    (190,105,100,063, CLTextButton,CLBgButton,$0068,BEx,Com2.Cin);
      InputText (140,080,200,255, CLSky,CLLightBlue,1,$0066,Com2,Com2.Cin);
      End;
   3: Begin
      Button    (140,105,100,063, CLTextButton,CLBgButton,$0068,BEx,Com3.Cin);
      InputText (140,080,200,255, CLSky,CLLightBlue,1,$0066,Com3,Com3.Cin);
      Button    (275,120,035,035, CLTextButton,NewTransparency,$0000,BTrans,'');
      End;
   End;
End;

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_imag.bmp',$0080);

Tabs (119,014,360,189, Tab1.No, CLLightGrey,CLLightGrey,$0014,Tab1,Language.Loc(1659));

Case Tab1.No of
   1: Begin
      Bevel_Mos (130,045,350,180, CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(257));
      Button    (140,060,170,-1,  CLTextButton,CLBgButton,$0000,B1,Language.Loc(259));
      RadioBox  (250,120,2,$0010,0,0,Rad1.Status,Rad1,Str_Get(Language.Loc(261),1,'|'));
      RadioBox  (250,135,2,$0010,0,0,Rad2.Status,Rad2,Str_Get(Language.Loc(261),2,'|'));
      RadioBox  (250,150,2,$0010,0,0,Rad3.Status,Rad3,Str_Get(Language.Loc(261),3,'|'));
      End;
   2: Begin
      Bevel_Mos (130,045,350,180, CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(173));
      Button    (140,060,170,-1,  CLTextButton,CLBgButton,$0000,B1,Language.Loc(262));
      End;
   3: Begin
      Bevel_Mos (130,045,350,180, CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(263));
      Button    (140,060,170,-1,  CLTextButton,CLBgButton,$0000,B1,Language.Loc(258));
      Display   (255,103,CLText,Language.Loc(256));
      End;
   End;

Button (087,204,080,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
Button (216,204,080,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));
Win_Clip(No,W1);                        {*Restore Normal Clipping*}

REDRAW_EXAMPLES;                        {*Display buttons examples*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+380,Py+HaF1+230,$51D9,Language.Loc(175),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

Tab1.No:=1;
Com1.Cin:=Sys.DesktopImage;             {*Load Value*}
Com2.Cin:=Sys.BootImage;
Com3.Cin:=Sys.WindowImage;
NewTransparency:=Sys.WindowImageTransp;
Rad1.Status:=No; Rad2.Status:=No; Rad3.Status:=No;
Case Sys.DeskTopDisplayStyle of
   DICenter:  Rad1.Status:=Yes;
   DIStretch: Rad2.Status:=Yes;
   DIMosaic:  Rad3.Status:=Yes;
   End;
REDRAW_FRAME;                           {*Display Window Content*}
XOk:=No; XCancel:=No;                   {*Init Exit Flag*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes;
   If Button_GetMsg(But2,1)=CMSelected Then XCancel:=Yes;

   If Tabs_GetMsg(Tab1,1)=CMSelected Then REDRAW_FRAME;

   Case Tab1.No of
      1: Begin
         If Button_GetMsg(B1, 1)=CMSelected Then
            Begin
            FilSel:=Com1.Cin;
            DirSel:=Sys.GetPath(SP_IMAGES);
            Req_FileManager(W1.X1+20,W1.Y1+30,269,Language.Loc(260),'_OK','*.BMP',0,DirSel,FilSel,FileSize);
            If FilSel<>'' Then Com1.Cin:=DirSel+FilSel Else Com1.Cin:='';
            REDRAW_EXAMPLES;
            End;
         RadioBox_GetMsg(Rad1,1);
         RadioBox_GetMsg(Rad2,1);
         RadioBox_GetMsg(Rad3,1);
         If Button_GetMsg(BEx,1)=CMSelected Then Req_DisplayWinBMP(W1.X1+20,W1.Y1+30,Com1.Cin);
         End;

      2: Begin
         If Button_GetMsg(B1, 1)=CMSelected Then
            Begin
            FilSel:=Com2.Cin;
            DirSel:=Sys.GetPath(SP_IMAGES);
            Req_FileManager(W1.X1+20,W1.Y1+30,269,Language.Loc(260),'_OK','*.BMP',0,DirSel,FilSel,FileSize);
            If FilSel<>'' Then Com2.Cin:=DirSel+FilSel Else Com2.Cin:='';
            REDRAW_EXAMPLES;
            End;
         If Button_GetMsg(BEx,1)=CMSelected Then Req_DisplayWinBMP(W1.X1+20,W1.Y1+30,Com2.Cin);
         End;

      3: Begin
         If Button_GetMsg(B1, 1)=CMSelected Then
            Begin
            FilSel:=Com3.Cin;
            DirSel:=Sys.GetPath(SP_IMAGES);
            Req_FileManager(W1.X1+20,W1.Y1+30,269,Language.Loc(260),'_OK','*.BMP',0,DirSel,FilSel,FileSize);
            If FilSel<>'' Then Com3.Cin:=DirSel+FilSel Else Com3.Cin:='';
            REDRAW_EXAMPLES;
            End;
         If Button_GetMsg(BEx,1)=CMSelected    Then Req_DisplayWinBMP(W1.X1+20,W1.Y1+30,Com3.Cin);
         If Button_GetMsg(BTrans,1)=CMSelected Then
            Begin
            NewTransparency:=Req_SelectColor(W1.X1+20,W1.Y1+30,26,CLBlack,CLBlack,Sys.GetPath(SP_PALETTES)+'Palette.pal',Language.Loc(255));
            REDRAW_EXAMPLES;
            End;
         End;
      End;
   Win_Clip(No,W1);                     {*Clipping Window*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;     {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flag*}

Win_Done(W1);                           {*Close Window if Needs*}

If XOk Then
   Begin
   Sys.RefreshScreen:=2;                {*Refresh level set to 2*}
   Sys.DesktopImage:=Com1.Cin;          {*Save Values*}
   Sys.BootImage:=Com2.Cin;
   Sys.WindowImage:=Com3.Cin;
   Sys.WindowImageTransp:=NewTransparency;
   If Rad1.Status Then Sys.DeskTopDisplayStyle:=DICenter;
   If Rad2.Status Then Sys.DeskTopDisplayStyle:=DIStretch;
   If Rad3.Status Then Sys.DeskTopDisplayStyle:=DIMosaic;
   If BMP_TestFile(Sys.DesktopImage) Then Sys.DesktopStyle := DSGraphic
                                     Else Sys.DesktopStyle := DSNone;
   End;
End;

{ͻ
                            FUNCTION Sys_Locale                             
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: (BYTE) = 0 if cancel, else 1 if a language is selected.          
  EXPLAIN: System requester. Set parameters for languages.                  
 ͼ}

Function Sys_Locale(Px,Py:Integer):Byte;
Var W1            :TWindow;             {*Structure Fentre*}
    A             :Integer;             {*Loop*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    XOk,XCancel   :Boolean;             {*Flags de Sortie*}
    But1          :TButton;             {*Structure Boutons*}
    ArB:Array[1..5] of TButton;         {*Buttons structure*}
    An1,An2,An3,An4,An5:TAnimate;       {*Animation structure*}
    BColor        :Longint;             {*Button background color*}
    OldLanguage   :ShortString;         {*Initial language*}

{************************* PLAY ANIMATIONS (FLAGS) **************************}

Procedure REDRAW_INFOS;                 {*Draw animations*}
Begin
   Win_Clip(Yes,W1);                    {*Clipping Window*}

   Anim_GetMsg(An1);                    {*Display animation*}
   Anim_GetMsg(An2);
   Anim_GetMsg(An3);
   Anim_GetMsg(An4);
   Anim_GetMsg(An5);

   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
End;

{**************************** DRAW MODIFIED DATA ****************************}

Procedure REDRAW_SELECTION;
Var A             :Integer;             {*Loop*}
    Flg_Name      :String;

Begin
   Win_Clip(Yes,W1);

   Bevel_Mos(115,020,400,095, VESA_SetRGBColor(205,195,180),CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(169));
   Button   (170,204,080,-1, CLTextButton,CLBgButton,$0110,But1,Language.Loc(114));

   If Language.Code = LFEnglish    Then Flg_Name:='FLG_ENG.BMP';
   If Language.Code = LFFrancais   Then Flg_Name:='FLG_FRA.BMP';
   If Language.Code = LFEspanol    Then Flg_Name:='FLG_ESP.BMP';
   If Language.Code = LFPortuguese Then Flg_Name:='FLG_POR.BMP';
   If Language.Code = LFNihon      Then Flg_Name:='FLG_NIH.BMP';

   Bevel(115,100,400,190, CLWinBg);
   BMP_ShowTransparency (180,108,180+500,108+500, 0,0,Sys.GetPath(SP_IMAGES)+Flg_Name,$0080,CLTransparency);

   For A:=1 to 5 do
   Begin
      BColor:=CLBgButton;
      Font_Set('LCSM.CHR',2);
      If (A=1) And (Language.Code = LFEnglish)    Then BColor:=CLSkin;
      If (A=2) And (Language.Code = LFFrancais)   Then BColor:=CLSkin;
      If (A=3) And (Language.Code = LFEspanol)    Then BColor:=CLSkin;
      If (A=4) And (Language.Code = LFPortuguese) Then BColor:=CLSkin;
      If (A=5) And (Language.Code = LFNihon)      Then BColor:=CLSkin;

      Button ((55)*A+67,075, 046,010, CLTextButton,BColor,$0000,ArB[A],Language.Loc(760+A));
   End;

   Button_Freeze(Yes,ArB[5]);
   Win_Clip(No,W1);
End;

{*************************** DRAW THE WHOLE WINDOW **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
   Win_Clip(Yes,W1);

   BMP_Show (019,014,019+90, 014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_loca.bmp',$0080);

   REDRAW_SELECTION;                 {*Redraw modified data*}

   Win_Clip(No,W1);
End;

{************************** UPDATE WITH NEW LANGUAGE ************************}

Procedure ChangeLanguage(NewLanguage:Integer);
Begin
   If NewLanguage = 1 Then Language.Code := LFEnglish;
   If NewLanguage = 2 Then Language.Code := LFFrancais;
   If NewLanguage = 3 Then Language.Code := LFEspanol;
   If NewLanguage = 4 Then Language.Code := LFPortuguese;
   If NewLanguage = 5 Then Language.Code := LFNihon;

   REDRAW_SELECTION;              {*Redraw modified data*}
   Sys.RefreshScreen := 2;        {*Refresh screen level 2*}
   Win_Rename(Language.Loc(170),W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
OldLanguage := Language.Code;      // Save initial language...
Result := 0;

If Not Win_Init(Px,Py,Px+420,Py+HaF1+230,$51D9,Language.Loc(170),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplment*}

Anim (An1,130,035,130+32,035+32, 0,0,Sys.GetPath(SP_ANIMS)+'FLG_EN',$00A0);
An1.Reverse:=Yes; An1.Index:=0;  An1.Frequency:=50;
Anim (An2,185,035,185+32,035+32, 0,0,Sys.GetPath(SP_ANIMS)+'FLG_FR',$00A0);
An2.Reverse:=Yes; An2.Index:=5;  An2.Frequency:=50;
Anim (An3,240,035,240+32,035+32, 0,0,Sys.GetPath(SP_ANIMS)+'FLG_ES',$00A0);
An3.Reverse:=Yes; An3.Index:=10; An3.Frequency:=50;
Anim (An4,295,035,295+32,035+32, 0,0,Sys.GetPath(SP_ANIMS)+'FLG_DE',$00A0);
An4.Reverse:=Yes; An4.Index:=15; An4.Frequency:=50;
Anim (An5,350,035,350+32,035+32,0,0,Sys.GetPath(SP_ANIMS)+'FLG_NI',$00A0);
An5.Reverse:=Yes; An5.Index:=20; An5.Frequency:=50;
Win_Draw(W1);                           {*Affiche la Fentre*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
XOk := FALSE; XCancel := False;         {*Init Flag de Sortie*}

Repeat
try

If Win_Ready(W1) Then                   {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Personnels*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1) = CMSelected Then Begin
      XOk := TRUE;                      {*Use*}
      Result := 1;
      End;
   For A:=1 to 4 do
   Begin
      If Button_GetMsg(ArB[A],1)=CMSelected Then ChangeLanguage(A);
   End;
   REDRAW_INFOS;                        {*Play animations*}
   Win_Clip(No,W1);                     {*Clipping Window*}
   End;

Even:=Win_Test(W1);
If Even = CMClosed Then                 {*Fentre Ferme => Exit*}
Begin
   XCancel := TRUE;
   Result := 0;
End;
If Even = CMMoved Then REDRAW_FRAME;    {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flag*}
If XCancel Then
Begin
   Language.Code := OldLanguage;        // Save initial language...
End;

Win_Done(W1);                           {*Supprime Fentre*}
End;

{ͻ
                           PROCEDURE Sys_Hardware                           
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: Sub window to view and specify Hardware parameters.              
 ͼ}

Procedure Sys_Hardware(Px,Py:Integer);
Const MaxBut=5;
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1          :TButton;             {*Structure Boutons*}
    TBut          :Array[1..MaxBut] of TButton; {*Structure Boutons*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Var A             :Integer;             {*Loop*}
Begin
Win_Clip(Yes,W1);
BMP_Show  (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_proc.bmp',$0080);

Bevel_Mos (120,020,280,180, CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(186));

Button (112,205,080,-1, CLTextButton,CLBgButton,$0100,But1,'_OK',MPHand,'');
For A:=1 to MaxBut do
   Button (130,035+((A-1)*20),140,-1, CLTextButton,CLBgButton,$0000,TBut[A],Str_Get(Language.Loc(328),A,'|'),'',Str_Get(Language.Loc(342),A,'|'));
Button_Freeze(Yes,TBut[4]);
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(Px,Py,Px+304,Py+HaF1+230,$51D9,Language.Loc(171),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                           {*Affiche la Fentre*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False;                        {*Init Flag de Sortie*}

Repeat
try

If Win_Ready(W1) Then                   {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Personnels*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True; {*Cancel*}
   If Button_GetMsg(TBut[1],1)=CMSelected Then Sys_Mouse   (W1.X1+20,W1.Y1+30);
   If Button_GetMsg(TBut[2],1)=CMSelected Then Sys_Keyboard(W1.X1+20,W1.Y1+30);
   If Button_GetMsg(TBut[3],1)=CMSelected Then Sys_Printers(W1.X1+20,W1.Y1+30);
   If Button_GetMsg(TBut[4],1)=CMSelected Then ;
   If Button_GetMsg(TBut[5],1)=CMSelected Then Sys_Peripherics(W1.X1+20,W1.Y1+30);

   If Sys.RefreshScreen=2 Then          {*Refresh screen level 2*}
      Begin
      Sys.RefreshScreen:=1;
      REDRAW_FRAME;
      End;
   Win_Clip(No,W1);                     {*Clipping Window*}
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Exit_Flg:=True;   {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until Exit_Flg=True;                    {*Flag de Sortie*}

Win_Done(W1);                           {*Supprime Fentre*}
End;

{ͻ
                         PROCEDURE Sys_Peripherics                          
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: Display and manage all the peripheric cards an ports.            
 ͼ}

Procedure Sys_Peripherics(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk           :Boolean;             {*Exit Flags*}
    But1,But2     :TButton;             {*Buttons Structure*}
    List          :TList;
    Id            :String;              {*Peripheric Id in list*}
    IcoName       :String;              {*Peripheric icon*}

{*********************** DISPLAY BUTTON INFORMATION *************************}

Procedure REDRAW_EXAMPLE;
Begin
Win_Clip(Yes,W1);
Button  (119,030,140,-1, CLTextButton,CLBgButton,$0100,But2, Str_Get(Language.Loc(1750),1,''),'',Str_Get(Language.Loc(1750),2,''));
If List_GetStringCell(List,List_GetTaggedItem(List),3) = '' Then Button_Freeze(Yes,But2);
IcoName:=Sys.GetPath(SP_BUTTONS)+List_GetStringCell(List,List_GetTaggedItem(List),1);
Bevel (280,014,280+070,014+035, CLWinBg);
BMP_ShowTransparency (280,014,280+120,014+100, 0,0,IcoName,$0080,CLTransparency);
End;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_peri.bmp',$0080);
Button   (160,204,080,-1, CLTextButton,CLBgButton,$0000,But1,'_OK',MPHand,'');
List_Show(List);
Win_Clip(No,W1);                        {*Restore Normal Clipping*}

REDRAW_EXAMPLE;                         {*Display button "More information"*}
End;

{******************************** INIT ALL **********************************}

Procedure INIT_FRAME;
Var St:String;
Begin
XOk:=No;                                {*Init Exit Flags*}
List_Define (List,Language.Loc(1748),';',119,050,370,186, 500, CLDataZone,CLDataZone,$1309);

St:=Language.Loc(1749);                          {*Labels*}
List_AddItem(List,'Ico_comp.bmp;'+Str_Get(St,1,'|'),Insert_Append);
List_AddItem(List,'Ico_cdro.bmp;'+Str_Get(St,2,'|'),Insert_Append);
List_AddItem(List,'Ico_netw.bmp;'+Str_Get(St,3,'|'),Insert_Append);
List_AddItem(List,'Ico_keyb.bmp;'+Str_Get(St,4,'|'),Insert_Append);
List_AddItem(List,'Ico_mous.bmp;'+Str_Get(St,5,'|'),Insert_Append);
List_AddItem(List,'Ico_scsi.bmp;'+Str_Get(St,6,'|'),Insert_Append);
List_AddItem(List,'Ico_netw.bmp;'+Str_Get(St,7,'|'),Insert_Append);
List_AddItem(List,'Ico_chip.bmp;'+Str_Get(St,8,'|'),Insert_Append);
List_AddItem(List,'Ico_coms.bmp;'+Str_Get(St,9,'|'),Insert_Append);

List_HideColumn(List,3,Yes);
List_AdjustColumns(List);
List_SetColumnAttr(List,1,030,Text_OnLeft);
List_SetColumnAttr(List,2,190,Text_OnLeft);
List_TagItem(List,1);                     {*Tag the first item*}
List_SetIdMore(List,$000A);
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+400,Py+HaF1+230,$51D9,Language.Loc(1747),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

INIT_FRAME;                             {*Init all data*}
REDRAW_FRAME;                           {*Display Window Content*}

Repeat
try

If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes;
   If (Button_GetMsg(But2,1)=CMSelected) Or
      ((List_TestMouseOnList(List)=1) And (Mse_TestDoubleClick)) Then
   Begin                                {*Get more information about Peripherics*}
      Id:=List_GetStringCell(List,List_GetTaggedItem(List),3);
      If Id='01' Then Req_GetGraphicCardInfo(W1.X1+20,W1.Y1+30);
   End;
   If List_Test(List)>0 Then REDRAW_EXAMPLE; {*Manage lists*}
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XOk:=Yes;         {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk);                            {*Exit Flags*}

List_Done(List);
Win_Done(W1);                           {*Close Window if Needs*}
End;

{ͻ
                            PROCEDURE Sys_Design                            
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: Sub window to view and specify the MOS design parameters.        
 ͼ}

Procedure Sys_Design(Px,Py:Integer);
Const MaxBut=7;
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1          :TButton;             {*Structure Boutons*}
    TBut          :Array[1..MaxBut] of TButton; {*Structure Boutons*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Var A             :Integer;             {*Loop*}
Begin
Win_Clip(Yes,W1);
BMP_Show  (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_anim.bmp',$0080);

Bevel_Mos (120,020,280,180, CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(186));

Button (112,205,080,-1, CLTextButton,CLBgButton,$0100,But1,'_OK',MPHand,'');
For A:=1 to MaxBut do
   Button (130,035+((A-1)*20),140,-1, CLTextButton,CLBgButton,$0000,TBut[A],Str_Get(Language.Loc(330),A,'|'),'',Str_Get(Language.Loc(334),A,'|'));
Button_Freeze(Yes,TBut[7]);
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(Px,Py,Px+304,Py+HaF1+230,$51D9,Language.Loc(172),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                           {*Affiche la Fentre*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False;                        {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Personnels*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True; {*Cancel*}
   If Button_GetMsg(TBut[1],1)=CMSelected Then Sys_Colors(W1.X1+20,W1.Y1+30);
   If Button_GetMsg(TBut[2],1)=CMSelected Then Sys_Fonts (W1.X1+20,W1.Y1+30);
   If Button_GetMsg(TBut[3],1)=CMSelected Then Sys_Sounds(W1.X1+20,W1.Y1+30);
   If Button_GetMsg(TBut[4],1)=CMSelected Then Sys_Graphics(W1.X1+20,W1.Y1+30);
   If Button_GetMsg(TBut[5],1)=CMSelected Then Sys_Skins (W1.X1+20,W1.Y1+30);
   If Button_GetMsg(TBut[6],1)=CMSelected Then Sys.GfxMode:=Sys_Screen(W1.X1+20,W1.Y1+30,Sys.GfxMode,Language.Loc(1662));
   If Button_GetMsg(TBut[7],1)=CMSelected Then ;

   If Sys.RefreshScreen=2 Then          {*Refresh screen level 2*}
      Begin
      Win_Clip(No,W1);
      Sys.RefreshScreen:=1;
      Win_Rename(Language.Loc(172),W1);
      Win_Draw(W1);
      REDRAW_FRAME;
      Win_Clip(Yes,W1);
      End;
   Win_Clip(No,W1);                     {*Clipping Window*}
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Exit_Flg:=True;   {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until Exit_Flg=True;                    {*Flag de Sortie*}

Win_Done(W1);                           {*Supprime Fentre*}
End;

{ͻ
                           PROCEDURE Sys_General                            
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: Sub window to view and specify MOS general parameters.           
 ͼ}

Procedure Sys_General(Px,Py:Integer);
Const MaxBut=7;
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1          :TButton;             {*Structure Boutons*}
    TBut          :Array[1..MaxBut] of TButton; {*Structure Boutons*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Var A             :Integer;             {*Loop*}
Begin
Win_Clip(Yes,W1);
BMP_Show  (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_text.bmp',$0080);

Bevel_Mos (120,020,280,180, CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(186));

Button (112,205,080,-1, CLTextButton,CLBgButton,$0100,But1,'_OK',MPHand,'');
For A:=1 to MaxBut do
   Button (130,035+((A-1)*20),140,-1, CLTextButton,CLBgButton,$0000,TBut[A],Str_Get(Language.Loc(331),A,'|'),'',Str_Get(Language.Loc(332),A,'|'));
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(Px,Py,Px+304,Py+HaF1+230,$51D9,Language.Loc(329),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                           {*Affiche la Fentre*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False;                        {*Init Flag de Sortie*}

Repeat
try

If Win_Ready(W1) Then                   {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Personnels*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True; {*Cancel*}
   If Button_GetMsg(TBut[1],1)=CMSelected Then Sys_Misc(W1.X1+20,W1.Y1+30);
   If Button_GetMsg(TBut[2],1)=CMSelected Then Sys_Blankers(W1.X1+20,W1.Y1+30);
   If Button_GetMsg(TBut[3],1)=CMSelected Then Sys_Errors(W1.X1+20,W1.Y1+30);
   If Button_GetMsg(TBut[4],1)=CMSelected Then
      Begin
      Sys_Locale(W1.X1+20,W1.Y1+30);
      Language.SetLanguage(Language.Code);
      REDRAW_FRAME;
      End;
   If Button_GetMsg(TBut[5],1)=CMSelected Then Sys_Security(W1.X1+20,W1.Y1+30);
   If Button_GetMsg(TBut[6],1)=CMSelected Then Sys_TimeBelt(W1.X1+20,W1.Y1+30);
   If Button_GetMsg(TBut[7],1)=CMSelected Then Sys_Apm(W1.X1+20,W1.Y1+30);

   If Sys.RefreshScreen=2 Then          {*Refresh screen level 2*}
      Begin
      Sys.RefreshScreen:=1;
      Win_Rename(Language.Loc(329),W1);
      REDRAW_FRAME;
      End;
   Win_Clip(No,W1);                     {*Clipping Window*}
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Exit_Flg:=True;   {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until Exit_Flg=True;                    {*Flag de Sortie*}

Win_Done(W1);                           {*Supprime Fentre*}
End;

{ͻ
                            PROCEDURE Sys_System                            
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: System requester. Set parameters for the MOS system directory.   
 ͼ}

Procedure Sys_System(Px,Py:Integer);
Const MaxBut=8;
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1          :TButton;             {*Structure Boutons*}
    TmpList       :String;              {*Temporary file for Libraries*}
    TBut          :Array[1..MaxBut] of TButton; {*Structure Boutons*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Var A:Integer;
Begin
Win_Clip(Yes,W1);
BMP_Show  (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_hard.bmp',$0080);

Bevel_Mos (120,020,280,200, CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(186));

Button (112,215,080,-1, CLTextButton,CLBgButton,$0100,But1,'_OK',MPHand,'');

For A:=1 to MaxBut do
   Button (130,035+((A-1)*20),140,-1, CLTextButton,CLBgButton,$0000,TBut[A],Str_Get(Language.Loc(188),A,'|'),'',Str_Get(Language.Loc(1671),A,'|'));
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(Px,Py,Px+304,Py+HaF1+240,$51D9,Language.Loc(189),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                           {*Affiche la Fentre*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False;                        {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Personnels*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True; {*Cancel*}
   If Button_GetMsg(TBut[1],1)=CMSelected Then Sys_SystemDrawer(W1.X1+020,W1.Y1+030);{*Select system Drawer*}
   If Button_GetMsg(TBut[2],1)=CMSelected Then Sys_SystemPaths(W1.X1+020,W1.Y1+030);{*View system Paths*}
   If Button_GetMsg(TBut[4],1)=CMSelected Then Req_Memory(W1.X1+020,W1.Y1+030,Language.Loc(174));
   If Button_GetMsg(TBut[5],1)=CMSelected Then Sys_SystemStats(W1.X1+020,W1.Y1+030);{*View system Stats*}
   If Button_GetMsg(TBut[6],1)=CMSelected Then Sys_SystemBootlog(W1.X1+020,W1.Y1+030);{*View system Bootlog*}
   If Button_GetMsg(TBut[7],1)=CMSelected Then Sys_SystemInfo(W1.X1+020,W1.Y1+030);{*View system Information*}
   If Button_GetMsg(TBut[8],1)=CMSelected Then Sys_SystemApplications(W1.X1+020,W1.Y1+030);{*View installed Information*}
   If Button_GetMsg(TBut[3],1)=CMSelected Then   {*Display Libraries*}
      Begin
      TmpList:=Sys.GetPath(SP_TEMP)+'LIBS.LIS';
      File_AppendString(TmpList,'Mos System;v'+Sys.GetVersion+'   ;Frdric Cheveau;zuulcoder@hotmail.com');
      File_AppendString(TmpList,VerGxName+';v'+VerGxMajorNum+'.'+VerGxMinorNum+';'+VerGxAuthor+';mknapp@gmx.at');
      File_AppendString(TmpList,'FPC;v'+{$I %FPCVERSION%}+';Florian Klaempfl;www.freepascal.org');
{     File_AppendString(TmpList,'CPU Information;v'+Str_L2S(GetVersion)+';Vladimir M.Zakharychev;zak@dzbjaro.bertelsmann.de');
      File_AppendString(TmpList,'DOS;v'+Hard_GetDOSVersion+';Microsoft(R);customers@microsoft.com');
      If Hard_TestWin Then File_AppendString(TmpList,'Windows;v'+Hard_GetWinVersion+';Microsoft(R);customers@microsoft.com');}
      Req_List(W1.X1+020,W1.Y1+030,$0002,Language.Loc(229),Language.Loc(230),';',TmpList);
      File_Erase(TmpList);
      End;
   Win_Clip(No,W1);                     {*Clipping Window*}
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Exit_Flg:=True;   {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until Exit_Flg=True;                    {*Flag de Sortie*}

Win_Done(W1);                           {*Supprime Fentre*}
End;

{ͻ
                           PROCEDURE Sys_Network                            
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: System requester. Set parameters for the NOVELL Network (IPX).   
 ͼ}

Procedure Sys_Network(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    Exit_Flg      :Boolean;             {*Exit Flag*}
    Cancel        :Boolean;
    But1,But2,But3,But4:TButton;        {*Buttons Structure*}
    Rad1,Rad2,Rad3:TRadioBox;           {*Radios Structure*}
    Com1,Com2,Com3:TInputText;          {*Commands Structure*}
    Cin1,Cin2,Cin3:String;              {*Strings for Commands*}
    Tab1          :TTabs;               {*Tabs Tab*}

{************************* DISPLAY WINDOW CONTENT ***************************}


Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_netw.bmp',$0080);

Tabs (119,014,390,189, Tab1.No, CLLightGrey,CLLightGrey,$0014,Tab1,Language.Loc(176));
Button (097,204,080, -1, CLTextButton,CLBgButton,$0110,But1,'_OK');
Button (233,204,080, -1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));

Case Tab1.No of
   1: Begin

      Bevel_Mos(130,046,380,106, CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(346));
      Button   (130,116,210,-1,  CLTextButton,CLBgButton,$0000,But4,Language.Loc(1606));
      RadioBox (140,061,1,$10,0,0,Rad1.Status,Rad1,Language.Loc(200));
      RadioBox (140,081,1,$10,0,0,Rad2.Status,Rad2,Language.Loc(201));
      BMP_ShowTransparency (340,070,340+100,070+100, 0,0,Sys.GetPath(SP_BUTTONS)+'Ico_netw.bmp',$0080,CLTransparency);
      End;
   2: Begin
      Bevel_Mos(130,046,380,166, CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(347));
      Display  (300,082, CLText,Language.Loc(203));
      Display  (300,102, CLText,Language.Loc(204));
      Display  (300,120, CLText,Language.Loc(205));
      Button   (140,141,090, -1, CLTextButton,CLBgButton,$0000,But3,Language.Loc(1729));
      InputText(140,082,150,255, CLBlue,CLLightBlue,0,$26,Com3,Cin3);
      InputText(140,102,150,255, CLBlue,CLLightBlue,0,$A6,Com1,Cin1);
      InputText(140,121,150,255, CLSky, CLLightBlue,0,$26,Com2,Cin2);
      RadioBox (140,061,1,$0010,0,0,Rad3.Status,Rad3,Language.Loc(202));
      End;
   End;

Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+410,Py+HaF1+230,$51D9,Language.Loc(348),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

Rad1.Status:=Sys.NetEnableNetMsg;
Rad2.Status:=Sys.NetEnableUserMsg;
Rad3.Status:=Sys.NetDisplayLogin;                   {*Login at Boot*}
Cin3:=Sys.NetLoginName;
Cin2:='';
Cin1:='';

Tab1.No:=1;
REDRAW_FRAME;                           {*Display Window Content*}
Exit_Flg:=No;                           {*Init Exit Flag*}
Cancel:=No;

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                     {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=Yes;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=Yes;

   If Tabs_GetMsg(Tab1,1)=CMSelected Then REDRAW_FRAME;

   Case Tab1.No of
      1: Begin
         If Button_GetMsg(But4,1)=CMSelected Then {Net_Main(W1.X1+20,W1.Y1+30)};
         RadioBox_GetMsg(Rad1,1);
         RadioBox_GetMsg(Rad2,1);
         End;
      2: Begin
         If Button_GetMsg(But3,1)=CMSelected Then {LOGIN};
         InputText_GetMsg(Com1,Cin1);
         InputText_GetMsg(Com2,Cin2);
         InputText_GetMsg(Com3,Cin3);
         RadioBox_GetMsg(Rad3,1);
         End;
      End;
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then Cancel:=Yes;      {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg) Or (Cancel);           {*Exit Flag*}
Win_Done(W1);                           {*Close Window if Needs*}

If Not Cancel Then                      {*OK*}
   Begin
   Sys.NetEnableNetMsg:=Rad1.Status;
   Sys.NetEnableUserMsg:=Rad2.Status;
   Sys.NetDisplayLogin:=Rad3.Status;    {*Login at Boot*}
   Sys.NetLoginName:=Cin3;
   End;
End;

{ͻ
                           PROCEDURE Sys_Security                           
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: System requester. Set parameters for the security.               
 ͼ}

Procedure Sys_Security(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    Exit_Flg      :Boolean;             {*Exit Flag*}
    Cancel        :Boolean;
    But1,But2     :TButton;             {*Buttons Structure*}
    Rad1          :TRadioBox;           {*Radios Structure*}
    Com1,Com2     :TInputText;          {*Commands Structure*}
    Cin1,Cin2     :String;              {*Strings for Commands*}
    Code          :Integer;             {*For "Val"*}
    Num           :Integer;             {*EZ*}
    ValTemp       :Byte;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_secu.bmp',$0080);
Bevel_Mos(119,020,380,100, CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(351));


BMP_ShowTransparency (120,110,120+100,110+100, 0,0,Sys.GetPath(SP_BUTTONS)+'Ico_keys.bmp',$0080,CLTransparency);

Display  (133,077,CLText,Language.Loc(350));

Button   (094,204,080,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
Button   (228,204,080,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));
InputText(129,056,240,30, CLBlue,CLLightBlue,0,$A7,Com1,Cin1);
InputText(329,076,040, 1, CLSky, CLLightBlue,0,$26,Com2,Cin2);
RadioBox (129,035,1,$0010,0,0,Rad1.Status,Rad1,Language.Loc(349));
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;


{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+403,Py+HaF1+230,$51D9,Language.Loc(352),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

Rad1.Status:=Sys.AskForBootPwd;                   {*Password at Boot or No*}

Cin1:=Str_Crypt(Sys.BootPwd,Str_GetCryptKey(Sys.BootPwd)); {*Decrypte Password*}
Str(Sys.BootPwdTestCount,Cin2);

REDRAW_FRAME;                           {*Display Window Content*}
Exit_Flg:=No;                           {*Init Exit Flag*}
Cancel:=No;

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then
      Begin
      If (Rad1.Status) And (Cin1='') Then {*Check if password has been defined*}
         Begin
         Num:=1;
         Req_Dialog(Language.Loc(1),Language.Loc(233),'   _OK   ',Num);
         End
         Else Exit_Flg:=Yes;
      End;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=Yes;
   RadioBox_GetMsg(Rad1,1);
   InputText_GetMsg(Com1,Cin1);
   InputText_GetMsg(Com2,Cin2);
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then Cancel:=Yes;             {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg) Or (Cancel);           {*Exit Flag*}
Win_Done(W1);                           {*Close Window if Needs*}

If Not Cancel Then                      {*OK*}
   Begin
   Sys.AskForBootPwd:=Rad1.Status;                {*Password at Boot or No*}
   Sys.BootPwd:=Str_Crypt(Cin1,Str_GetCryptKey(Cin1)); {*Crypte Password*}
   Val(Cin2, ValTemp, Code);
   Sys.BootPwdTestCount := ValTemp;
   If Sys.BootPwdTestCount<=0 Then Sys.BootPwdTestCount := Sys.BootPwdTestCount + 1; {*Minimum 1 Tentative*}
   End;
End;

{ͻ
                             FUNCTION Sys_Date                              
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: System requester. Set parameters for the date.                   
 ͼ}

Function Sys_Date(Px,Py,Mode:Integer):String;
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    Exit_Flg      :Boolean;             {*Exit Flag*}
    Cancel        :Boolean;
    But1,But2     :TButton;                {*Buttons Structure*}
    TBut          :Array[1..31] of TButton;{*Buttons Structure*}
    Cyc1,Cyc2     :TCycler;                {*Cyclers Structure*}
    Com1,Com2     :TInputText;             {*Commands Structure*}
    Cin1,Cin2     :String;              {*Strings for Commands*}
    I             :Integer;             {*For Loop*}
    Dy,Dm,Dd,Dow  :Word;                {*For Current Date...*}
    Iy,Im,Id,Iow  :Word;                {*For Initial Date...*}
    X,Y           :Integer;             {*Pos X,Y pour Draw Tableau Jours*}
    Day           :Byte;                {*Jour Slectionn*}
    TAS           :String;              {*Tableau des Noms des Jours*}
    Code          :Integer;
    St            :String;
    Year          :String;              {*Annes pour Cycler*}
    Dt            :Integer;             {*TMP Calcul Date...*}
    Text1         :TText;               {*Text displaying*}

{*************************** DISPLAY DAYS ARRAY *****************************}

Procedure REDRAW_STATUS;                {*Draw Current Date...*}
Var St            :String;
    T1            :String;              {*Tableau des Annes*}
Begin
St:=Str_Get(TAS,Time_GetDayName(Time_PackDate(Day,Dm,Dy))+1,'|');
Str(Day,Cin1);

T1:=Year;
Cin1:=St+' '+Cin1+' '+Midder(Str_Get(Cyc2.TCT, Cyc2.CyclVal,'|'))+' '+Str_Get(T1,Cyc1.CyclVal,'|');
{gotoxy(1,5); writeln(Cin1,' ');}

Win_Clip(Yes,W1);                       {*Clipping Window*}
Cycler   (090,060,040, Cyc1.CyclVal, CLTextButton,CLBgButton,$0000,Cyc1,Year);
InputText(090,038,165, 255, CLSky,CLLightBlue,1,$0026,Com1,Cin1);
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{****************************** CLEAR BOX DAYS ******************************}

Procedure CLEAR_BOX_DAYS;               {*Clear Box Days...*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
Bevel (051,143,239,269, CLBlue);
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{*************************** DISPLAY DAYS ARRAY *****************************}

Procedure REDRAW_DAYS;                  {*Draw Days...*}
Var I             :Integer;             {*For Loop*}
    V1            :String[2];           {*Numro du Jour*}
    Co            :Longint;             {*Couleur Bouton...*}

Begin
Dd:=Day;
Dm:=Cyc2.CyclVal;
Val(Cyc1.TCT[Cyc1.CyclVal],Dy,Code);

Win_Clip(Yes,W1);                        {*Clipping Window*}
X:=060+(Time_GetDayName(Time_PackDate(1,Dm,Dy)))*025; {*Initial Coordonnes*}
Y:=149;

For I:=1 to Time_GetDaysInMonth(Dm,Dy) do {*Parcours Les Days du Mois...*}
   Begin
   If Day=I Then Co:=CLLightBlue Else Co:=CLSky; {*Bouton du Jour de Couleur Diffrente*}
   Str(I,V1);
   Button(X,Y,020,-1, CLTextButton,Co,$0,TBut[I],V1);{*Display Button*}
   Inc(X,025);

   If X>210 Then                        {*Marge Droite Atteinte...*}
      Begin
      X:=060;                           {*Retour  la Ligne...*}
      Inc(Y,020);
      End;
   End;
Win_Clip(No,W1);                        {*Restore Normal Clipping*}

REDRAW_STATUS;                          {*Draw Current Date...*}
End;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Var I             :Integer;             {*For Loop*}

Begin
Win_Clip(Yes,W1);                        {*Clipping Window*}
Bevel_Mos(020,020,270,280, CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(359));
Bevel (050,120,240,270, CLLightGrey,BLLoweredLine,BLNoLine,No);
Bevel (050,120,240,142, CLFlamand,  BLLoweredLine,BLNoLine,Yes);

Display (045,062, CLText,Language.Loc(355));
Display (170,062, CLText,Language.Loc(357));
Display (045,082, CLText,Language.Loc(356));
Display (030,040, CLText,Language.Loc(358));

Button (054,295,080, -1,CLTextButton,CLBgButton,$0110,But1,'_OK');
Button (155,295,080, -1,CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));
Cycler (090,080,080, Cyc2.CyclVal,CLTextButton,CLBgButton,$00,Cyc2,Language.Loc(361));

InputText(210,060,040, 4,CLBlue,CLLightBlue,1,$126,Com2,Cin2);

VESA_SetFillStyle(1,CLWinBg);
Font_Set('TSCR.CHR',1);                 {*Display LMMJVSD*}
Mse_Hide;
For I:=1 to 7 do
   Begin
   X:=64+(I-1)*25;                      {*Initial Coordonnes*}
   Y:=120;
   Display_Define(Text1,X,Y,-1,CLWhite,'TSCR.CHR',1,TJOnLeft,$0004,Copy(Language.Loc(354),I,1));
   Display_Draw  (Text1);
   End;
Mse_Show;
Font_Set(Sys.FontMain,Sys.FontMainSize);

Win_Clip(No,W1);                        {*Restore Normal Clipping*}

CLEAR_BOX_DAYS;                         {*Clear Box Days...*}
REDRAW_DAYS;                            {*Raffiche Tableau Jours*}
End;

{************************* PROCEDURE SET_NEW_DATE ***************************}

Procedure SET_NEW_DATE;
Var T1:String;
Begin
T1:=Year;
Val(Str_Get(T1,Cyc1.CyclVal,'|'),Dt,Code);
SetDate(Dt,Cyc2.CyclVal,Day);
End;

{**************************** CONSTRUIT LA DATE *****************************}

Procedure BUILD_DATE;
Begin
SET_NEW_DATE;
CLEAR_BOX_DAYS;                         {*Clear Box Days...*}
REDRAW_DAYS;
End;

{*************************** BUILD Cycler ANNEES ****************************}

Procedure BUILD_YEARS;
Var T1:Real;
    A,Diz:Integer;
    S1:String[4];
Begin
Val(Cin2,Dt,Code);                      {*Get Date Base*}
T1:=Dt/10.0;
Diz:=Round(Frac(T1)*10);                {*Get Dizaines...*}
Cyc1.Cyclval:=Diz+1;
Str(Trunc(T1),S1);                      {*Prpare Build Date in String*}
Dt:=Trunc(T1)*10;                       {*Set Date de 10 en 10...*}
Str(Dt,Cin2);
Year:='';
For A:=0 to 9 do Year:=Year+S1+Chr(48+A)+'|';
{Gotoxy(1,10); writeln(Year);}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+290,Py+HaF1+321,$51D9,Language.Loc(362),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

TAS:=Language.Loc(353);

GetDate(Iy,Im,Id,Iow);                  {*For Restore Old Date*}
GetDate(Dy,Dm,Dd,Dow);

Str(Dy,Cin2);                           {*Get & Set Year*}
BUILD_YEARS;                            {*Build Year String...*}
Cyc2.CyclVal:=Dm;
Day:=Dd;

REDRAW_FRAME;                           {*Display Window Content*}
Exit_Flg:=No;                           {*Init Exit Flag*}
Cancel:=No;

Repeat
try

If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=Yes;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=Yes;
   For I:=1 to 31 do                    {*Parcours les 31 Jours...*}
      If Button_GetMsg(TBut[I],1)=CMSelected Then
         Begin
         Day:=I;
         SET_NEW_DATE;                  {*Dfinit Nouveau Jour...*}
//         REDRAW_DAYS;                   {*Raffiche les Jours*}
         End;
                                        {*Raffiche Tableau du Mois*}
   If Cycler_GetMsg(Cyc1,1)=CMSelected Then
      Begin                             {*Modif Years*}
      SET_NEW_DATE;
      CLEAR_BOX_DAYS;                   {*Clear Box Days...*}
      REDRAW_DAYS;
      End;
   If Cycler_GetMsg(Cyc2,1)=CMSelected Then
      Begin                             {*Modif Months*}
      SET_NEW_DATE;
      CLEAR_BOX_DAYS;                   {*Clear Box Days...*}
      REDRAW_DAYS;
      End;
   If InputText_GetMsg(Com2,Cin2)=CMModified Then  {*Dfinit Base Annes...*}
      Begin
      BUILD_YEARS;
      BUILD_DATE;
      End;
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then Cancel:=Yes;      {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg) Or (Cancel);           {*Exit Flag*}
Win_Done(W1);                           {*Close Window if Needs*}

If Cancel Then SetDate(Iy,Im,Id);       {*Restore old Date...*}

Case Mode of
   1: Sys_Date:=Cin1;                   {*Renvois la date en toutes Lettres*}
   2: Begin
      Str(Day,Cin1);
      If Length(Cin1)=1 Then Cin1:='0'+Cin1;
      Str(Cyc2.CyclVal,St);
      If Length(St)=1 Then St:='0'+St;
      Cin1:=Cin1+'.'+St+'.'+Cyc1.TCT[Cyc1.CyclVal];
      Sys_Date:=Cin1;                {*Renvois la Date Format Abrg*}
      End;
   Else Sys_Date:='';                {*Ne renvois Rien !*}
   End;
End;

{ͻ
                             PROCEDURE Sys_Time                             
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: System requester. Set parameters for the time.                   
 ͼ}

Procedure Sys_Time(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    Exit_Flg      :Boolean;             {*Exit Flag*}
    Cancel        :Boolean;             {*Cancel*}
    But1,But2     :TButton;             {*Buttons Structure*}
    Cyc1          :TCycler;             {*Cyclers Structure*}
    Com1,Com2,Com3:TInputText;          {*Commands Structure*}
    Cin1,Cin2,Cin3:String;              {*Strings for Commands*}
    T             :TClock;              {*Structure Time*}
    Ih,Im,Isec    :Word;                {*Temps Initial*}
    Th,Tm,Ts,Td   :Word;                {*Temps*}
    TsW           :Integer;             {*Secondes en Word*}
    Code          :Word;                {*Pour "Val"*}

{***************************** DISPLAY COMMANDS *****************************}

Procedure REDRAW_COMMANDS;              {*Define Gadgets Commands*}
Begin
Str(Th,Cin1); Str(Tm,Cin2); Str(Ts,Cin3);
Win_Clip(Yes,W1);                        {*Clipping Window*}
InputText (090,041,040,3, CLSky,CLLightBlue,1,$0026,Com1,Cin1);
InputText (090,061,040,3, CLSky,CLLightBlue,1,$0026,Com2,Cin2);
InputText (090,081,040,3, CLSky,CLLightBlue,1,$0026,Com3,Cin3);

Win_Clip(No,W1);                       {*Restore Normal Clipping*}
End;


{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                        {*Clipping Window*}
Bevel_Mos (020,020,230,110, CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(368));

Bevel (240,014,380,150, CLLightGrey,BLRaisedLine, BLNoLine,No);
Bevel (140,125,210,140, CLBlack,    BLLoweredLine,BLNoLine,Yes);

Display (044,042, CLText,Language.Loc(363));
Display (036,062, CLText,Language.Loc(364));
Display (031,082, CLText,Language.Loc(365));
Display (040,127, CLText,Language.Loc(366));
Display (150,047, CLText,Language.Loc(367));

Button (090,165,080, -1,CLTextButton,CLBgButton,$0110,But1,'_OK');
Button (230,165,080, -1,CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));
Cycler (150,065,040, Cyc1.CyclVal,CLTextButton,CLBgButton,$0,Cyc1,'  :|  /|  |');

REDRAW_COMMANDS;                        {*Affiche les Gadgets Commands*}
Req_DisplayClock (240,019,380,150, CLSky,0,T,W1);
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{***************************** MODIFIE LE TEMPS *****************************}

Procedure SET_NEW_TIME;                 {*Modifie le Temps*}
Begin
Val(Cin1,Th,Code);
Val(Cin2,Tm,Code);
Val(Cin3,Ts,Code);
SetTime(Th,Tm,Ts,Td);                   {*Rinjecte le Temps*}
REDRAW_COMMANDS;                        {*Affiche les Gadgets Commands*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+400,Py+HaF1+191,$51D9,Language.Loc(369),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1); {*Supplement*}
Win_Draw(W1);                           {*Display Window*}

GetTime(Ih,Im,Isec,Td);                 {*Rcupre le Temps Initial*}
GetTime(Th,Tm,Ts,Td);                   {*Rcupre le Temps*}
Cyc1.CyclVal:=Sys.TimeSeparator;        {*Time Separator*}

REDRAW_FRAME;                           {*Display Window Content*}
Exit_Flg:=No;                           {*Init Exit Flag*}
Cancel:=No;

Repeat
try
;
GetTime(Th,Tm,Ts,Td);                   {*Rcupre le Temps*}
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=Yes;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=Yes;

   Cycler_GetMsg(Cyc1,1);
                                        {*Affiche l'Heure Digitale*}
   Font_Set('ITAL.CHR',4);              {*Passe en Italique*}
   Display(150,126, CLLightBlue, Time_GetTime(0,T));
   Font_Set(Sys.FontMain,Sys.FontMainSize);

   If InputText_GetMsg(Com1,Cin1)=CMModified Then SET_NEW_TIME;
   If InputText_GetMsg(Com2,Cin2)=CMModified Then SET_NEW_TIME;
   If InputText_GetMsg(Com3,Cin3)=CMModified Then SET_NEW_TIME;

   Val(Cin3,TsW,Code);
   If Ts<>TsW Then REDRAW_COMMANDS;

   Win_Clip(Yes,W1);                     {*Clipping Window*}
   Req_DisplayClock (240,019,380,150, CLSky,1,T,W1);
   Win_Clip(No,W1);                     {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then Cancel:=Yes;      {*Window Closed   => Exit*}

If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg) Or (Cancel);           {*Exit Flag*}

Win_Done(W1);                           {*Close Window if Needs*}

If Not Cancel Then                      {*OK*}
   Begin
   Sys.TimeSeparator:=Cyc1.CyclVal;     {*Time Separator*}
   End
   Else Begin                           {*CANCEL*}
   SetTime(Ih,Im,Isec,Td);              {*Rcupre le Temps Initial*}
   End;
End;

{ͻ
                           PROCEDURE Sys_TimeBelt                           
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: System requester. Set parameters for the Time-Belt.              
 ͼ}

Procedure Sys_TimeBelt(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    Exit_Flg      :Boolean;             {*Exit Flag*}
    Cancel        :Boolean;
    But1,But2,But3,
    But4          :TButton;             {*Buttons Structure*}
    Com1          :TInputText;          {*Commands Structure*}
    Cin1          :String;              {*Strings for Commands*}
    Fus           :Shortint;            {*Numro du Fuseau Courrant...*}
    A             :Byte;                {*Loop*}
    Mz1           :TMouseZone;          {*Mouse pointer*}
    C             :TCoordinates;
    Tab1          :TTabs;               {*Tabs Tab*}

{************************* TOGGLE FUSEAUX HORAIRES **************************}

Procedure TOGGLE_FUSEAU(F:Shortint);
Var A,Px:Integer;
Begin
If Tab1.No<>1 Then Exit;                {*No good sheet!*}

Dec(F,2);
If F<-12 Then F:=24+F;

Win_Clip(Yes,W1);                       {*Clipping Window*}
VESA_SetColor(CLShadow);                {Anciennement 120}
VESA_SetWriteMode(XorPut);
Mse_Hide;
For A:=0 to 14 do
   Begin
   Px:=310+F*15+A;                      {*Pos X de la Ligne...*}

   VESA_Line(Px,039,Px,222);
   End;
Mse_Show;
VESA_SetWriteMode(NormalPut);
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{************************* BUILD FUSEAUX HORAIRES ***************************}

Procedure BUILD_NUMBER(F:Shortint);
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
If F=13 Then Dec(F,24);
Str(F,Cin1);                            {*Build Fuseau Horaire Number*}
If F>0 Then Cin1:='+'+Cin1;
Cin1:='GREENWICH '+Cin1;
InputText (020,210,086, 100, CLSky,CLLightBlue,1,$0026,Com1,Cin1);
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{************************** DISPLAY VILLES NAMES ****************************}

Procedure REDRAW_VILLES;                {*Redraw Villes*}
Var Villes:Integer;
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
Bevel (020,241,500,261, CLLightGrey,BLRaisedLine,BLNoLine,Yes);
If Fus=13 Then Villes:=375              {*Fuseau -11*}
          Else Villes:=386+Fus;
Display (030,245,CLText,(Language.Loc(Villes)));
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_belt.bmp',$0080);

Tabs   (119,014,500,234,Tab1.No, CLLightGrey,CLLightGrey,$0014,Tab1,Language.Loc(1730));
Button (130,274,080,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
Button (310,274,080,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));

Case Tab1.No of
   1: Begin
      Bevel   (129,038,490,223, CLLightGrey,BLLoweredLine,BLNoLine,Yes);
      BMP_Show(130,039,490,500, 0,0, Sys.GetPath(SP_IMAGES)+'Worldmap.bmp',$0080);
      C.X1:=130; C.Y1:=038; C.X2:=490; C.Y2:=222;
      MseZone(MZ1,C,10,MPHand,'');      {*Define a mouse zone*}
      End;
   2: Begin
      Bevel_Mos(130,045,350,135,CLMauve,CLWhite, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(1731));
      Button   (140,060,150,-1, CLTextButton,CLBgButton,$0000,But3,Language.Loc(371));

      Button   (140,080,150,-1, CLTextButton,CLBgButton,$0000,But4,Language.Loc(372));
      BMP_ShowTransparency (130,145,130+100,145+100, 0,0,Sys.GetPath(SP_BUTTONS)+'Ico_date.bmp',$0080,CLTransparency);
      End;
   End;

Win_Clip(No,W1);                        {*Restore Normal Clipping*}

BUILD_NUMBER(Fus);                      {*Affiche Numro Fuseau Courrant*}
TOGGLE_FUSEAU(Fus);                     {*Affiche Fuseau Horaire Courrant...*}
REDRAW_VILLES;
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+521,Py+HaF1+300,$51D9,Language.Loc(373),W1) Then Exit;

Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A90,W1);  {*Supplement*}

Win_Draw(W1);                           {*Display Window*}

Tab1.No:=1;
Fus:=Sys.TimeBelt;
BUILD_NUMBER(Fus);                      {*Build Fuseau Horaire Number*}

REDRAW_FRAME;                           {*Display Window Content*}
Exit_Flg:=No;                           {*Init Exit Flag*}
Cancel:=No;


Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=Yes;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=Yes;
   If Tabs_GetMsg(Tab1,1)=CMSelected Then REDRAW_FRAME;

   Case Tab1.No of
      1: Begin
         MseZone_GetMsg(MZ1);           {*Test mouse zone*}
         End;
      2: Begin
         If Button_GetMsg(But3,1)=CMSelected Then Sys_Date(W1.X1+20,W1.Y1+30,1);
         If Button_GetMsg(But4,1)=CMSelected Then Sys_Time(W1.X1+20,W1.Y1+30);
         End;
      End;

   Win_Clip(No,W1);                     {*Restore Normal Clipping*}


   If Tab1.No=1 Then
      Begin
      For A:=0 to 23 do                 {*Teste si On est sur Un Fuseau...*}
      If Mse_TestBox(W1.X1+130+A*15, W1.Y1+HaF1+045, W1.X1+129+(A+1)*15, W1.Y1+HaF1+228, 10) Then
         Begin
         If (Mse_Clicked(1)) And (A-10<>Fus) Then Begin
            TOGGLE_FUSEAU(Fus);         {*Efface Ancien Fuseau Horaire*}
            Fus:=A-10;                  {*Set New Fuseau Horaire...*}
            TOGGLE_FUSEAU(Fus);         {*Affiche Nouveau Fuseau Horaire*}
            BUILD_NUMBER(Fus);          {*Build Fuseau Horaire Number*}
            REDRAW_VILLES;              {*Affiche Exemples Villes*}
            End;
         End;
      End;
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then Cancel:=Yes;      {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg) Or (Cancel);           {*Exit Flag*}

Win_Done(W1);                           {*Close Window if Needs*}

If Not Cancel Then Sys.TimeBelt:=Fus;   {*OK*}
End;

{ͻ
                           PROCEDURE Sys_Printers                           
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: System requester. Reset the printer.                             
 ͼ}


Procedure Sys_Printers(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Flag de Sortie*}
    But1,But2,But3:TButton;             {*Buttons Structure*}

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                        {*Clipping Window*}
BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_prin.bmp',$0080);

Bevel_Mos(115,020,300,186, CLWinBg,CLTextTitle, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(399));

Button (066,204,080,-1, CLTextButton,CLBgButton,$0110,But1,'_OK',MPHand,'');
Button (173,204,080,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));
Button (133,035,150,-1, CLTextButton,CLBgButton,$0002,But3,Language.Loc(1600));

BMP_ShowTransparency (130,065,130+100,065+100, 0,0,Sys.GetPath(SP_BUTTONS)+'Ico_prin.bmp',$0080,CLTransparency);
Win_Clip(No,W1);                       {*Restore Normal Clipping*}
End;


{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+320,Py+HaF1+230,$51D9,Language.Loc(1601),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

REDRAW_FRAME;                           {*Display Window Content*}
XOk:=FALSE; XCancel:=FALSE;             {*Init Flag de Sortie*}

Repeat
try

If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                     {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk     := TRUE;
   If Button_GetMsg(But2,1)=CMSelected Then XCancel := TRUE;
   If Button_GetMsg(But3,1)=CMSelected Then ; //Hard_PrinterInit(0);
   Win_Clip(No,W1);                    {*Clipping Window*}
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then XCancel:=TRUE;    {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Flag de Sortie*}

Win_Done(W1);                           {*Close Window if Needs*}
End;

{ͻ
                             PROCEDURE Sys_Apm                              
 ͹
  IN.....: Px,Py (INTEGER) = Requester position on screen.                  
  OUT....: /                                                                
  EXPLAIN: System requester. Manage the APM functions.                      
 ͼ}

Procedure Sys_Apm(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    Exit_Flg      :Boolean;             {*Exit Flag*}
    But1,But3     :TButton;             {*Buttons Structure*}
    Num           :Integer;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                        {*Clipping Window*}
BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_moth.bmp',$00A0);
Bevel_Mos(115,020,300,186, CLMauve,CLTextTitle, BLLoweredLine,BLRaisedLine,Yes,Language.Loc(210));
BMP_ShowTransparency (130,065,130+100,065+100, 0,0,Sys.GetPath(SP_BUTTONS)+'Ico_powe.bmp',$0080,CLTransparency);

Button (120,204,080,-1, CLTextButton,CLBgButton,$0110,But1,'_OK',MPHand,'');
Button (133,035,150,-1, CLTextButton,CLBgButton,$0000,But3,Language.Loc(211));
Win_Clip(No,W1);                       {*Restore Normal Clipping*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+320,Py+HaF1+230,$51D9,Language.Loc(149),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

REDRAW_FRAME;                           {*Display Window Content*}
Exit_Flg:=No;                           {*Init Exit Flag*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=Yes;
   If Button_GetMsg(But3,1)=CMSelected Then
      Begin
      Num:=2;
      Req_Dialog(Language.Loc(1),Str_Get(Language.Loc(1754),1,''),Str_Get(Language.Loc(1754),2,''),Num);
      If Num=2 Then Apm_PowerOff;
      End;
   Win_Clip(No,W1);                     {*Clipping Window*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then Exit_Flg:=Yes;    {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until Exit_Flg=Yes;                     {*Exit Flag*}

Win_Done(W1);                           {*Close Window if Needs*}
End;

{ͻ
                            PROCEDURE Sys_Skins                             
 ͹
  IN.....: Px,Py (INTEGER) = Requester position.                            
  OUT....: /                                                                
  EXPLAIN: Allow user to select images to skin the MOS interface.           
 ͼ}

Procedure Sys_Skins(Px,Py:Integer);
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    XOk,XCancel   :Boolean;             {*Flag de Sortie*}
    But1,But2,BCh :TButton;             {*Structure Boutons*}
    L             :TList;               {*Structure List*}
    Res           :Longint;             {*Rsultat Liste Clicke*}
    FName         :String;              {*Skin file*}
    SelImage      :String;              {*Selected skin image*}
    DirSel,FilSel :String;              {*File management*}
    FSize         :Longint;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_IMAGES;
Var ExName:String;
    Sx,Sy:Word;
    Colors:Longint;
Begin
ExName:=Sys.GetPath(SP_BUTTONS)+SelImage;
Win_Clip(Yes,W1);
Bevel (270,139,385,183,CLMauve);
BMP_GetInfo(ExName,Sx,Sy,Colors);
BMP_ShowTransparency (300,162-(Sy Div 2),300+100,162+100, 0,0,ExName,$0080,CLTransparency);
End;

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
BMP_Show (019,014,019+90,014+175, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_cryp.bmp',$0080);
Bevel_Mos(119,132,387,185,CLMauve,CLWhite ,BLLoweredLine,BLRaisedLine,Yes,Language.Loc(1732));
Button   (096,204,080,-1, CLTextButton,CLBgButton,$0000,But1,'_OK',MPHand,'');
Button   (233,204,080,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(13));
Button   (130,155,130,-1, CLTextButton,CLBgButton,$0100,BCh,Language.Loc(1733));
List_Show(L);                           {*Display the List*}
Win_Clip(No,W1);

REDRAW_IMAGES;                          {*Display skin images*}
End;

Procedure INIT_FRAME;
Begin
FName:=Sys.GetPath(SP_DATAS)+'Skins.lis';
List_Define(L,Language.Loc(1734),';',119,014,385,114, 100, CLDataZone,CLDataZone,$0389);
List_SetIdMore(L,$000C);
List_SetColumnId(L,2,$0001);
List_Load(L,FName);                     {*Load the Graphic Modes*}

List_SetStringCell(L,01,2,Sys.ImgCheckYes); {*Store filenames*}
List_SetStringCell(L,02,2,Sys.ImgCheckNo);
List_SetStringCell(L,03,2,Sys.ImgRadioYes);
List_SetStringCell(L,04,2,Sys.ImgRadioNo);
List_SetStringCell(L,05,2,Sys.ImgCycler);
List_SetStringCell(L,06,2,Sys.ImgBevel);
List_SetStringCell(L,07,2,Sys.ImgError);
List_SetStringCell(L,08,2,Sys.ImgBomb);
List_SetStringCell(L,09,2,Sys.ImgInformation);
List_SetStringCell(L,10,2,Sys.ImgQuestion);
List_SetStringCell(L,11,2,Sys.ImgStop);
List_SetStringCell(L,12,2,Sys.ImgWarning);
List_SetStringCell(L,13,2,Sys.ImgSliderUpNo);
List_SetStringCell(L,14,2,Sys.ImgSliderUpYes);
List_SetStringCell(L,15,2,Sys.ImgSliderDownNo);
List_SetStringCell(L,16,2,Sys.ImgSliderDownYes);
List_SetStringCell(L,17,2,Sys.ImgSliderLeftNo);
List_SetStringCell(L,18,2,Sys.ImgSliderLeftYes);
List_SetStringCell(L,19,2,Sys.ImgSliderRightNo);
List_SetStringCell(L,20,2,Sys.ImgSliderRightYes);

List_AdjustColumns(L);
List_TagItem(L,List_MinItem);
SelImage:=List_GetStringCell(L,List_GetTaggedItem(L),2);
XOk:=FALSE; XCancel:=FALSE;             {*Init Flag de Sortie*}
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(Px,Py,Px+410,Py+HaF1+230,$51F9,Language.Loc(1735),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                           {*Affiche la Fentre*}

INIT_FRAME;
REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}

Repeat
try

If Win_Ready(W1) Then                   {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Personnels*}
   Win_Clip(Yes,W1);
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=TRUE;
   If Button_GetMsg(But2,1)=CMSelected Then XCancel:=TRUE;

   If (Button_GetMsg(BCh, 1)=CMSelected) Or
      ((List_TestMouseOnList(L)=1) And (Mse_TestDoubleClick)) Then
   Begin                                {*Change image*}
      DirSel:=Sys.GetPath(SP_BUTTONS);
      FilSel:=SelImage;
      Req_FileManager(W1.X1+30,W1.Y1+20,250,Language.Loc(1736),'_OK','*.BMP',0,DirSel,FilSel,FSize);
      If FilSel<>'' Then
      Begin
         SelImage:=FilSel;
         List_SetStringCell(L,List_GetTaggedItem(L),2,SelImage);
         REDRAW_IMAGES;
         List_Refresh(L);
      End;
   End;

   Res:=List_Test(L);                   {*Test de la Liste*}
   If Res>0 Then
   Begin
      SelImage:=List_GetStringCell(L,List_GetTaggedItem(L),2);
      REDRAW_IMAGES;
   End;
   Win_Clip(No,W1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then XCancel:=TRUE;    {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Flag de Sortie*}

If XOk Then                             {*Save values*}
   Begin
   Sys.ImgCheckYes:=List_GetStringCell(L,01,2);
   Sys.ImgCheckNo :=List_GetStringCell(L,02,2);
   Sys.ImgRadioYes:=List_GetStringCell(L,03,2);
   Sys.ImgRadioNo :=List_GetStringCell(L,04,2);
   Sys.ImgCycler  :=List_GetStringCell(L,05,2);
   Sys.ImgBevel   :=List_GetStringCell(L,06,2);
   Sys.ImgError   :=List_GetStringCell(L,07,2);
   Sys.ImgBomb    :=List_GetStringCell(L,08,2);
   Sys.ImgInformation:=List_GetStringCell(L,09,2);
   Sys.ImgQuestion:=List_GetStringCell(L,10,2);
   Sys.ImgStop    :=List_GetStringCell(L,11,2);
   Sys.ImgWarning :=List_GetStringCell(L,12,2);
   Sys.ImgSliderUpNo    :=List_GetStringCell(L,13,2);
   Sys.ImgSliderUpYes   :=List_GetStringCell(L,14,2);
   Sys.ImgSliderDownNo  :=List_GetStringCell(L,15,2);
   Sys.ImgSliderDownYes :=List_GetStringCell(L,16,2);
   Sys.ImgSliderLeftNo  :=List_GetStringCell(L,17,2);
   Sys.ImgSliderLeftYes :=List_GetStringCell(L,18,2);
   Sys.ImgSliderRightNo :=List_GetStringCell(L,19,2);
   Sys.ImgSliderRightYes:=List_GetStringCell(L,20,2);
   End;

List_Done(L);                           {*Supprime la Liste*}
Win_Done(W1);                           {*Supprime Fentre*}
End;

{ͻ
                          PROCEDURE Sys_SystemInfo                          
 ͹
  IN.....: Px,Py (INTEGER) = Requester position.                            
  OUT....: /                                                                
  EXPLAIN: Allow user to get miscellaneous information about system.        
 ͼ}

Procedure Sys_SystemInfo(Px,Py:Integer);
Var W1            :TWindow;             {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk           :Boolean;             {*Exit Flag*}
    But1          :TButton;             {*Buttons Structure*}
    Tab1          :TTabs;               {*Tab structure*}
    Inf           :TFileInfo;           {*File information*}
    Ani1          :TAnimate;
    RunningMode   :String;              {*Debug mode detection*}

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                       {*Clipping Window*}
Tabs (008,008,290,268,Tab1.No, CLLightGrey,CLLightGrey,$0014,Tab1,Language.Loc(1739));

If BTST(Id_Msg1,14) Then RunningMode:=Str_Get(Language.Loc(164),2,'|') Else RunningMode:=Str_Get(Language.Loc(164),1,'|');

Case Tab1.No of                         {*Display Tabs components*}
   1: Begin
      Display(120,050,CLText,Str_Get(Language.Loc(1740),1,'|'));
      Display(140,063,CLText,Str_Get(Language.Loc(1740),2,'|'));
      Display(140,076,CLText, Application.MOSName+' '+ Application.MOSVersion);
      Display(140,089,CLText,Str_Get(Language.Loc(1740),3,'|')+Sys.GetVersion);
      Display(140,102,CLText,Str_Get(Language.Loc(1740),4,'|')+RunningMode);
      Tool_line(012,126,285,126,1,1);
      Display(020,134,CLText,Str_Get(Language.Loc(1741),2,'|'));
      Display(040,147,CLText,User.Name);
      Display(040,160,CLText,Str_Get(Language.Loc(1741),1,'|')+Application.TypeCaption);
      BMP_ShowTransparency (240,142,240+100,142+100, 0,0,Sys.GetPath(SP_BUTTONS)+'Ico_cert.bmp',$0080,CLTransparency);
      Tool_line(012,182,285,182,1,1);
      Display(020,190,CLText,Str_Get(Language.Loc(1742),2,'|'));
      Display(040,203,CLText,Inf.CompiledBy+' '+Inf.CompilerVersion);
      Display(040,216,CLText,Str_Get(Language.Loc(1742),1,'|')+Inf.CompilerTargetCpu);
      Display(040,229,CLText,Inf.CompilationDate+' '+Inf.CompilationTime);
      BMP_ShowTransparency (240,210,240+100,210+100, 0,0,Sys.GetPath(SP_BUTTONS)+'Ico_comp.bmp',$0080,CLTransparency);
      End;
   End;

Button (110,274,080,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
Win_Clip(No,W1);                        {*Restore Normal Clipping*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
Get_FileInformation(Application.ExeName,Inf); {*Get informations about system*}

Anim(Ani1,020,030,500,500,0,0,Sys.GetPath(SP_ANIMS)+'Logo_',$0080);
Ani1.Frequency:=100;                    {*1 image per 100 call*}

If Not Win_Init(Px,Py,Px+300,Py+HaF1+300,$51D9,Language.Loc(1738),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBg,$0A50,W1);{*Supplement*}
Win_Draw(W1);                           {*Display Window*}

Tab1.No:=1;
REDRAW_FRAME;                           {*Display Window Content*}
XOk:=No;                                {*Init Exit Flag*}

Repeat
try
;
If Win_Ready(W1) Then                   {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                    {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes;
   If Tabs_GetMsg(Tab1,1)=CMSelected Then REDRAW_FRAME;

   Anim_GetMsg(Ani1);                   {*Display animation*}
   Win_Clip(No,W1);                     {*Clipping Window*}
   End;

Even:=Win_Test(W1);                     {*Get Windows Evens*}
If Even=CMClosed Then XOk:=Yes;         {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;      {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk);                            {*Exit Flag*}

Win_Done(W1);                           {*Close Window if Needs*}
End;

{****************************************************************************}
{****************************************************************************}
{****************************************************************************}
{****************************************************************************}
{****************************************************************************}
{****************************************************************************}

{ͻ
                            FUNCTION Sys_Request                            
 ͹
  IN.....: X1,Y1 (INTEGER) = Window position.                               
           CName (STRING) = Initialisation file to save.                    
  OUT....: Res (BYTE) = (0=Cancel, 1=Use, 2=Save).                          
  EXPLAIN: Call the MOS system configuration requester.                     
  EXAMPLE: Sys_Request(200,100,'MRE.INI');                                  
 ͼ}

Function Sys_Request(X1,Y1:Integer; CName:String):Byte;
Var W             :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1,But2,But3:TButton;             {*Buttons*}
    B1,B2,B3,B4,B5:TButton;             {*Buttons*}
    MenuPop       :TPopupMenu;          // Popup menu
    PopupFile     :String;              // Popup filename
    ResPop        :String;              // Popup menu test result

{ͻ
               PROCEDURES DE GESTION INTERNE DE SYSTEM REQUEST              
 ͼ}

{*********************** TRANSMET VALEURS PARAMETRES ************************}

Procedure Action_Initialize;
Begin
   Load_Config(Get_AppIniName);
   Save_Config(Sys.GetPath(SP_TEMP)+'MOS.TMP');
   {Get_Palette(MPal);}                      {*Rcupre toutes les Couleurs*}
   {!}  {Sauvegarder les couleurs courrantes de MosColors... CL...}
End;

{*********************** RECUPERE VALEURS PARAMETRES ************************}

Procedure Action_Cancel;
Begin
   Load_Config(Sys.GetPath(SP_TEMP)+'MOS.TMP');
   Language.SetLanguage(Language.Code);
   {Set_Palette(MPal);}                      {*Rinstalle Anciennes Couleurs*}
   {!}  {Restaurer les couleurs courrantes de MosColors... CL...}
   Sys_Request := 0;
End;

Procedure Action_ReloadInitConf;
Begin
   Load_Config(Sys.GetPath(SP_TEMP)+'MOS.TMP');
End;

Procedure Action_Save(SFileName:String);
Begin
   Mse_SetPointer(MPBusy);
   Save_Config(SFileName);
   Mse_SetPointer(P_Current);
   Sys_Request := 2;
End;

Procedure Action_SaveAs;
Var DirSel,FilSel:String;
    Size:Longint;

Begin
   DirSel := '';
   FilSel := CName;
   Req_FileManager(100,100,250,'Select file...','_SAVE','*.INI',0, DirSel,FilSel,Size);
ShowMessage(DirSel + FilSel);
   If FilSel <> '' Then Action_Save(DirSel + FilSel);
End;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W);
BMP_Show (010,005,010+600,005+600, 0,0,Sys.GetPath(SP_IMAGES)+'Sys_main.bmp',$0080);

Font_Set('MODN.CHR',4);
Button (028,115,070,-1, CLTextButton,CLBgButton,$0100,But1,Language.Loc(343),MPHand,'');
Font_Set('LITT.CHR',4);
Button (108,115,070,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(345),MPHand,'');
Button (188,115,070,-1, CLTextButton,CLBgButton,$0000,But3,Language.Loc(344));

Button (020,015,105,-1, CLTextButton,CLBgButton,$0000,B1,Language.Loc(337));
Button (020,085,105,-1, CLTextButton,CLBgButton,$0000,B2,Language.Loc(327));
Button (090,050,105,-1, CLTextButton,CLBgButton,$0000,B3,Language.Loc(340));
Button (160,015,105,-1, CLTextButton,CLBgButton,$0000,B4,Language.Loc(338));
Button (160,085,105,-1, CLTextButton,CLBgButton,$0000,B5,Language.Loc(339));

PopupFile := Sys.GetPath(SP_DATAS)+'Syspopm.dat';
Menu_Popup (MenuPop,W.X1,W.Y1,W.X2,W.Y2, FALSE, PopupFile); {*Popup Menu*}

Win_Clip(No,W);
End;

{****************************** DEFINE WINDOW *******************************}

Procedure DEFINE_MAIN_WINDOW;
Begin
If Not Win_Init(X1,Y1,X1+290,Y1+HaF1+141,$51D9,Language.Loc(206),W) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W);{*Supplment*}
Win_Draw(W);                            {*Affiche la Fentre*}
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
DEFINE_MAIN_WINDOW;                     {*Dfinition de la Fentre Principale*}
REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Action_Initialize;                      {*Load and init config file*}

Exit_Flg:=False;                        {*Init Flag de Sortie*}

Repeat
Try

If Win_Ready(W) Then                    {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   If Button_GetMsg(B1,1)=CMSelected Then Sys_Design  (W.X1+20,W.Y1+30);
   If Button_GetMsg(B2,1)=CMSelected Then Sys_Hardware(W.X1+20,W.Y1+30);
   If Button_GetMsg(B3,1)=CMSelected Then Sys_General (W.X1+20,W.Y1+30);
   If Button_GetMsg(B4,1)=CMSelected Then Sys_System  (W.X1+20,W.Y1+30);
   If Button_GetMsg(B5,1)=CMSelected Then Sys_Network (W.X1+20,W.Y1+30);

   If Button_GetMsg(But1,1)=CMSelected Then
      Begin                             {*Save*}
      Action_Save(CName);
      Exit_Flg:=TRUE;
      End;
   If Button_GetMsg(But2,1)=CMSelected Then
      Begin                             {*Cancel*}
      Action_Cancel;
      Exit_Flg:=True;                   {*Flag Sortie du Programme*}
      End;
   If Button_GetMsg(But3,1)=CMSelected Then
      Begin                             {*Use*}
      Exit_Flg:=True;
      Sys_Request:=1;
      End;
   If Sys.RefreshScreen=1 Then          {*Refresh screen level 1*}
      Begin
      Sys.RefreshScreen:=0;             {*No refresh needed now*}
      Win_Rename(Language.Loc(206),W);
      Win_Draw(W);
      REDRAW_FRAME;
      End;

   ResPop := Menu_TestPopup(MenuPop);   // Check popup for menu...
   If ResPop <> '' Then
   Begin
      If ResPop = '1' Then Action_Save(CName);
      If ResPop = '2' Then Action_SaveAs;
      If ResPop = '4' Then Sys_Request := 1;
      If ResPop = '6' Then Action_ReloadInitConf;
      If ResPop = '7' Then Action_Initialize;
   End;
   End;

Even:=Win_Test(W);

If Even=CMClosed Then
   Begin
   Action_Cancel;                       {*Fentre Ferme => Exit*}
   Exit_Flg:=True;
   End;

If Even = CMMoved Then REDRAW_FRAME;    {*Fentre Dplace => Rafficher Contenu*}

Except
  On e:Exception do HandleException(e);
End;

Until Exit_Flg=True;                    {*Flag de Sortie*}

Id_Msg1:=Id_Msg1 Or $0001;              {*Menu parameters will be Recalculed*}
Win_Done(W);                            {*Suprime Fentre*}

File_Erase(Sys.GetPath(SP_TEMP)+'MOS.TMP'); {*Dtruit Fichier Temporaire...*}
End;

{*------------------------ PAS DE PROG PRINCIPAL ---------------------------*}

Begin
End.
