{ͻ
                              UNIT MosGadgets                               
 ͹
  CREATOR....: CHEVEAU Frdric                                             
  UPDATED BY.: CHEVEAU Frdric                                             
  CREATED THE: 15.12.1993                                                   
  COUNTRY....: Montpellier - IUT (FRANCE)                                   
  DESCRIPTION: Miscellaneous gadgets management.                            
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 3.718 Lines and (93.136 Bytes compiled)                      
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosGadgets;

{$Mode ObjFpc}

INTERFACE

Uses
     MosConfig,
     MosGraphics,
     MosMouse,
     MosText,
     MosTime;

Const
   MaxTaquets     = 8;                  {*Maximum numbers of Taquets for Canvas*}
   Max_CPIndex    = 256;                {*256 colors in Color Palette*}

                                        {*Component messages definition*}
   CMNone         = 00;                 {*No messages*}
   CMClosed       = 01;                 {*Closable component*}
   CMSwapped      = 02;                 {*Swappable component*}
   CMExtended     = 03;                 {*Extendable component*}
   CMResized      = 04;                 {*Canvas is resized*}
   CMActivated    = 05;                 {*Component activated*}
   CMInactivated  = 06;                 {*Component inactivated*}
  CMHidden       = 07;                 {*Hide component*}
  CMUnHidden     = 08;                 {*Unhide (display) component*}
   CMMoved        = 09;                 {*Movable component*}
  CMFreezed      = 10;                 {*Component has been freezed*}
  CMUnFreezed    = 11;                 {*Component has been unfreezed*}
  CMClicked      = 12;                 {*Component clicked*}
  CMDblClicked   = 13;                 {*Component double clicked*}
   CMSelected     = 14;                 {*Component selected*}
   CMUnSelected   = 15;                 {*Radio Box set to unselected*}
   CMModified     = 16;                 {*Component (data) modified or changed*}
  CMKeyPressed   = 17;                 {*Key pressed (keys sensitive components)*}
   CMMouseOver    = 18;                 {*Mouse is over the component*}
  CMTextSelected = 19;                 {*Text selected in InputText*}
  CMTextCopyied  = 20;                 {*Text copyied in InputText*}
  CMTextCutted   = 21;                 {*Text cutted in InputText*}
  CMTextPasted   = 22;                 {*Text pasted in InputText*}
  CMColumnMoved  = 23;                 {*Column moved in List component*}
  CMColumnResized= 24;                 {*Column resized in List component*}
  CMCellModified = 25;                 {*Cell modified in List component*}
   CMFirstFrame  = 26;                 {*First frame animation displayed*}
   CMLastFrame   = 27;                 {*Last frame animation displayed*}
   CMHintShowed  = 28;                 {*Hint activated and displayed*}

   SSBox         = 1;                  {*Support style*}
   SSLine        = 2;

   SSNone        = 0;                  {*Shape style*}
   SSColor       = 1;
   SSShade       = 2;
   SSImage       = 3;

   CTNone        = 0;                  {*Cursor type*}
   CTBox         = 1;
   CTRectangle   = 2;
   CTLine        = 3;
   CTBoxArrow    = 4;
   CTTriangle    = 5;
   CTImage       = 6;

   BPGrouped     = 1;                  {*Buttons positions*}
   BPOposed      = 2;

Type                                   {*Gadgets types definition*}

TLightBox=Record                       {*Light-Box record*}
     X1,Y1,X2,Y2 :Integer;             {*Light-Box coordinates*}
     Xo,Yo       :Integer;             {*Old mouse coordinates*}
     End;

THotKey=Record                         {*Hotkey structure*}
     IdDisable   :Word;                {*Bits selection for Hotkey*}
     {*Bit 0  $0001 : 1 = Disable Ctrl Key*}
     {*Bit 1  $0002 : 1 = Disable Alt Key*}
     {*Bit 2  $0004 : 1 = Disable AltGr Key*}
     {*Bit 3  $0008 : 1 = Disable Shift Key*}
     End;

THint=Record                            {*Hint component structure*}
     X1,Y1,X2,Y2 :Integer;              {*Test mouse box coordinates*}
     Xd,Yd,Xf,Yf :Integer;              {*Hint display coordinates*}
     SizeX,SizeY :Integer;              {*Hint size X,Y*}
     Status      :Boolean;              {*Display component or no*}
     TempsOk     :Boolean;              {*Elapsed time is 0*}
     Time        :TClock;               {*Pointer to TClock structure*}
     Info        :String;               {*String to display*}
     Swap        :TRefresh;             {*Structure for Refresh Screen*}
     Qtt         :Byte;                 {*Number of info lines*}
     MOx,MOy     :Integer;              {*Old mouse coordinates*}
     Tag         :Word;                 {*User field*}
     Id          :Word;                 {*Id pref component*}
     {*Bit 0  $0001 = Activated          1 = Component activated*}
     {*Bit 1  $0002 = Display box corner 1 = Display hint at the right bottom box*}
     {*Bit 2  $0004 = Delay to display   1 = Delay before display Hint*}
     End;

TMouseZone=Record                       {*Mouse Pointer structure*}
     C           :TCoordinates;         {*Coordinates structure*}
     Value       :String[12];           {*File mouse pointer*}
     MBAction    :Byte;                 {*Mouse button action*}
     Hint        :THint;                {*Hint on zone*}
     End;

TAnimate=Record                         {*BMP animation structure*}
     C           :TCoordinates;         {*Coordinates structure*}
     Ox,Oy       :Integer;              {*Offset X,Y*}
     BaseName    :String;               {*File base name*}
     Index       :Integer;              {*Current index on file*}
     IndexMin    :Integer;              {*Minimum index on file*}
     IndexMax    :Integer;              {*Maximum index on file*}
     Count       :Integer;              {*Number of BMP in animation*}
     FrameStep   :Shortint;             {*Frame step value (+ or -)*}
     Frequency   :Integer;              {*Frequency to display images*}
     FreqIndex   :Integer;              {*Frequency index*}
     Visible     :Boolean;              {*Animation visible or no*}
     Enabled     :Boolean;              {*Animation enabled or no*}
     Cycling     :Boolean;              {*Animation cycling or no*}
     Reverse     :Boolean;              {*Back reverse animation when last frame is reached*}
     Tag         :Word;                 {*User field*}
     Id          :Word;                 {*Bits for displaying Anim. See "BMP_Show" bits*}
     End;

TCanvas=Record                          {*Canvas Box definition*}
     X           :Array[1..MaxTaquets] of Integer;
     Y           :Array[1..MaxTaquets] of Integer;    {*Points coordinates*}
     Pointer     :Array[1..MaxTaquets] of TMouseZone; {*Pointers*}
     SizeTaq     :Integer;              {*Half size of a Taquet*}
     Status_Size :Boolean;              {*Canvas currently resized*}
     Status_Move :Boolean;              {*Canvas currently moved*}
     MouseBut    :Byte;                 {*Mouse Button to Activate*}
     OnTaquet    :Byte;                 {*Mouse on Taquet number*}
     Color       :LongInt;              {*Pen color for the Canvas*}
     Mx,My       :Integer;              {*Mouse Position when click a Taquet*}
     OldX,OldY   :Integer;              {*Previous Mouse Position*}
     Tag         :Word;                 {*User field*}
     Id          :Word;                 {*Bits selection for Canvas*}
     {*Bit 0  $0001 : 1 = Enable Move Canvas*}
     {*Bit 1  $0002 : 1 = Canvas Freezed*}
     {*Bit 2  $0004 : 1 = Unvisible Canvas*}
     {*Bit 3  $0008 : 1 = Draw Canvas box*}
     {*Bit 4  $0010 : 1 = Hand Pointer on Taquets*}
     {*Bit 5  $0020 : 1 = Enable Resize Canvas*}
     {*Bit 6  $0040 : 1 = Inverse Canvas Allowed*}
     {*Bit 7  $0080 : * 1 = Fix black line color*}
     {*Bit 8  $0100 : * 1 = Polygon Mode*}
           {Polygon Mode = Draw lines uniquement entre les points qui existent} {MIC}
     {*Bit 9  $0200 : * 1 = Proportional canvas size*}
     IdTaq       :Word;                 {*Bits to Set Taquets (0..8)*}
     IdIn        :Word;                 {*Id pour Gestion Interne*} {MIC}
     {*Bit 0  $0001 : 1 = Pointeur souris sur ce Gadget*} {MIC}
     End;

TColorPalette=Record                    {*Color Palette structure*}
     Px,Py       :Integer;              {*Component position*}
     Count       :Integer;              {*Quantity of defined colors*}
     CellX,CellY :Integer;              {*Size of a Cell*}
     InterCell   :Integer;              {*Space between two cells (in pixels)*}
     QttColumns  :Integer;              {*Number of columns*}
     Line        :Byte;                 {*Line type for selected box*}
     Border      :Byte;                 {*Borders structure*}
        {0 = BLNoline}
        {1 = BLUniformLine}
        {2 = BLLoweredLine}
        {3 = BLRaisedLine}
     Pointer     :ShortString;          {*Mouse pointer file to use*}
     SelectedColor:Integer;             {*Previous selected index color*}
     Selected    :Integer;              {*Current selected index color*}
     PFile       :String;               {*Filename of the JASC-PAL palette*}
     FirstColor  :Longint;              {*First color for shade*}
     LastColor   :Longint;              {*Last color for shade*}
     Tag         :Word;                 {*User field*}

     Id          :Word;                 {*Bits selection for component*}
     {*Bit 0  $0001 : 1 = Component freezed*}
     {*Bit 1  $0002 : 1 = Unvisible component*}
     {*Bit 2  $0004 : 1 = Do not display selection boxes*}
     {*Bit 3  $0008 : 1 = Select cell by clicking on it (default is unclicking)*}

     IdIn        :Word;                 {*Inner bits for component management*}
     {*Bit 0  $0001 : 1 = Last selected cell box has been hidden*}
     End;

TButton=Record                          {*Button Gadget*}
     X1,Y1,X2,Y2 :Integer;              {*Button coordinates*}
     Ox1,Oy1,Ox2,Oy2:Integer;           {*Images offset coordinates*}
     TCT         :String[128];          {*String to display*}
     Flg_But     :Boolean;   {INTERNAL} {*Button status. TRUE=Selected*} {MIC}
     VanillaKey  :Byte;                 {*Activation key position in string*}
     Font        :TFont;                {*Pointer to font structure*}
     ButSp       :Integer;              {*Special button or no*}
     Tag         :Word;                 {*User field*}
     Pointer     :TMouseZone;           {*Mouse pointer record*}
     Id          :Word;                 {*Id Pref button*}
     {*Bit 0  $0001 : 1 = FREE}
     {*Bit 1  $0002 : 1 = Freezed button*}
     {*Bit 2  $0004 : 1 = Unvisible button*}
     {*Bit 3  $0008 : 1 = Set image in button (ICO, BMP)*}
//     {*Bit 4  $0010 : 1 = Pointer to be Hand over Button*}
     {*Bit 5  $0020 : 1 = Constant Color display*}
     {*Bit 6  $0040 : 1 = Text Shift when selected*}
     {*Bit 7  $0080 : 1 = Repeat Activation (Send TRUE after delay on button)*}
     {*Bit 8  $0100 : 1 = Select button by ENTER key*}
     {*Bit 9  $0200 : 1 = Do not display the box button*}
     {*Bit 10 $0400 : 1 = Text underlined*}
     {*Bit 11 $0800 : 1 = Text button on left side*}
     {*Bit 12 $1000 : * 1 = Button activable only by clicking on it*} {MIC}
{- Ne pas utiliser la touche CTRL} {MIC}
     {*Bit 15 $8000 : 1 = Reserved for Cyclers equivalence*}
     IdIn        :Word;                 {*Id pour Gestion Interne*} {MIC}
     {*Bit 0  $0001 : 1 O Mouse Pointer      1 = Pointer souris sur ce Gadget*} {MIC}
     {*Bit 1  $0002 : 1 = KeyB Activated     1 = Button Pressed by Keyboard*} {MIC}
     End;

TCycler=Record                          {*Cycler Gadget*}
     B           :TButton;              {*Pointer to the Button structure*}
     TCT         :String;               {*Strings to display*}
     CyclVal     :Integer;              {*Label number currently displayed*}
     Tag         :Word;                 {*User field*}
     Id          :Word;                 {*Id Prefs cycler*}
     {*Bit 0  $0001 : 1 = Use Image Palette to Display Image} {MIC}
     {*Bit 1  $0002 : 1 = Freezed Cycler*} {MIC}
     {*Bit 2  $0004 : 1 = Unvisible Cycler*} {MIC}
     {*Bit 3  $0008 : 1 = Use image. Only "ICO" or ".BMP"*} {MIC}
     {*Bit 4  $0010 : 1 = Pointer to be Hand over Cycler*} {MIC}
     {*Bit 5  $0020 : 1 = Constant Color display*}
     {*Bit 6  $0040 : 1 = Text Shift when selected*}
     {*Bit 7  $0080 : 1 = Repeat Activation (Send TRUE after delay on button)*}
     {*Bit 8  $0100 : 1 = Select button by ENTER key*}
     {*Bit 9  $0200 : 1 = Do not display the box gadget*}
     {*Bit 10 $0400 : 1 = Text underlined*}
     {*Bit 11 $0800 : 1 = Text button on left side (Forced)*}
     {*Bit 15 $8000 : 1 = Do not display the "Loop" image*}
     End;

TSlider=Record                          {*Slider component structure*}
   MainC               :TCoordinates;   {*Main coordinates*}
   SupportC            :TCoordinates;   {*Support coordinates*}
   ShapeC              :TCoordinates;   {*Shape coordinates*}
   Value               :Longint;        {*Slider current value*}
   Quantity            :Longint;        {*Quantity of values*}
   Displayed           :Longint;        {*Displayed values*}
   MoveStep            :Longint;        {*Step when move Slider*}
   BgColor             :Longint;        {*Background color*}
   Pointer             :TMouseZone;     {*Mouse pointer and hint management*}
   Orientation         :Longint;        {*Slider orientation*}
       {  0 = COHorizontal  Horizontal slider}
       {  1 = COVertical    Vertical slider}
   Support             :Byte;           {*Support style*}
       {  0 = SSNone        No support}
       {  1 = SSBox         Rectangular support}
       {  2 = SSLine        Line support}
   Shape               :Byte;           {*Shape style*}
       {  0 = SSNone        No shape}
       {  1 = SSColor       Solid color in shape}
       {  2 = SSShade       Shade in shape}
       {  3 = SSImage       Image shape}
   ShapeImage          :String;         {*Shape image*}
   ShapeColor          :Longint;        {*Shape color*}
   ShapeShadeCol1      :Longint;        {*Shape shade first color*}
   ShapeShadeCol2      :Longint;        {*Shape shade last color*}
   Graduations         :Word;           {*Graduations type*}
       {  Bit 0  $0001 :  1 = Left graduations displayed}
       {  Bit 1  $0002 :  1 = Center graduations displayed}
       {  Bit 2  $0004 :  1 = Right graduations displayed}
   Cursor              :Byte;           {*Cursor type*}
       {  0 = CTNone        No cursor}
       {  1 = CTBox         Proportional box cursor}
       {  2 = CTRectangle   Static rectangle}
       {  3 = CTLine        Static line cursor}
       {  4 = CTBoxArrow    Static box with arrow cursor}
       {  5 = CTTriangle    Small triangle}
       {  6 = CTImage       Static transparent image cursor}
   CursorImage         :String;         {*Shape image*}
   CursorC             :TCoordinates;   {*Cursor coordinates*}
   CursorSize          :Integer;        {*Cursor size*}
   CursorColor         :Longint;        {*Cursor color if box designed*}
   ButtonsPos          :Byte;           {*Buttons positions*}
       {  1 = BPGrouped     Grouped buttons}
       {  2 = BPOposed      Oposed buttons}
   ButtonsDef          :Boolean;        {*Defined buttons Yes or No*}
   BAdd                :TButton;        {*Add button*}
   BSub                :TButton;        {*Sub button*}
   Tag                 :Word;           {*User field*}
   Id                  :Word;           {*Parameters bits*}
       {  Bit 0  $0001 :  1 = Don't use images for slider buttons}
       {  Bit 1  $0002 :  1 = Freezed component}
       {  Bit 2  $0004 :  1 = Unvisible component}
       {  Bit 3  $0008 :  1 = Switch to "List mode" for vertical slider}
   IdIn                :Word;           {*Inner parameters bits*}
       {  Bit 0  $0001 :  1 = Mouse pointer over the cursor zone}
       {  Bit 1  $0001 :  1 = Cursor has been selected}
       {  Bit 2  $0004 :  1 = Must increase the "ActivatedSliders" value}
   End;

TRadioBox=Record                        {*Radio Box Gadget*}
     X,Y          :Integer;             {*Radio Box coordinates*}
     Style        :Word;                {*Radio Box style*}
     Font         :TFont;               {*Font structure*}
     Zone         :TMouseZone;          {*Mouse pointer and hint record*}
     Status       :Boolean;             {*Status. TRUE=Selected*}
     FClick       :Boolean;             {*Internal Flag for On/Off Gadgets*}{MIC}
     Fl1          :Boolean;             {*Other Internal Flag - Don't Touch*}{MIC}
     Tag          :Word;                {*User field*}
     IDCMP        :Word;                {*Id Prefs Radio Box*}
     {*Bit 0  $01 = Demandeur            Est le bouton qui demande  tre activ*} {MIC}
     {*Bit 1  $02 = Recherche Demandeur  Demande de recherche de bouton activ*} {MIC}
     {*Bit 2  $04 = Freeze Radio Box     Freeze le Radio Box*} {MIC}
     {*Bit 3  $08 = Invisible Gadget     Gadget Non Visible, Mais Gr...*} {MIC}
     {*Bit 4  $10 = Select with Text     Slectionner en cliquant sur le Texte*} {MIC}
{!}  {*Bit 5  $20 = Hand Pointer         Pointer to be Hand on Radio*} {MIC}
     {*Bit 6  $40 = Reserved             Mouse Pointer on Gadget...*} {MIC}
     {*Bit 7  $80 = Reserved             1=Afficher 1ere Fois le Label...} {MIC}
     Group        :Byte;                {*Group number (only for Radio Box)*}
     Cin          :String[50];          {*Attached text to display*}
     PLab         :Byte;                {*Text position*}
     PTx          :Integer;             {*Delta +- Pos Texte par Rapport au Radio*} {MIC}
     End;

TCheckBox=TRadioBox;                    {*CheckBox structure equal to RadioBox*}

TInputText=Record                       {*InputText Gadget*}
     X,Y         :Word;                 {*InputText coordinates*}
     Siz         :Word;                 {*InputText width*}
     Len         :Byte;                 {*Maximum caracters lenght *}
     CoB,Co2     :Longint;              {*Background colors*}
     Sty         :Byte;                 {*Design styles*}
     Cin         :String;               {*String to display*}
     PM          :TPosMse;              {*Mouse coordinates*}
     Pointer     :TMouseZone;           {*Mouse pointer record*}
     Fl1         :Boolean;              {*Test Bouton Press au bon endroit*} {MIC}
     Freeze      :Boolean;              {*Freezed gadget or no*}
     Font        :TFont;                {*Pointer to font structure*}
     IDCMP       :Byte;                 {*Communication "Inter-InputText"*} {MIC}
     Tag         :Word;                 {*User field*}
     Id          :Word;                 {*Id Prefs InputText*}
     {*Bit 0  $0001 = Gadget Activ*} {MIC}
     {*Bit 1  $0002 = Gadget Prcdent si Flche Haut*} {MIC}
     {*Bit 2  $0004 = Gadget Suivant si Flche Bas*} {MIC}
     {*Bit 3  $0008 = Gadget Prcdent si Flche Gauche*} {MIC}
     {*Bit 4  $0010 = Gadget Suivant si Flche Droite*} {MIC}
     {*Bit 5  $0020 = Touche ESC = Restore String (CANCEL)*} {MIC}
     {*Bit 6  $0040 = Si le Gadget InputText n'est pas test*} {MIC}
     {*Bit 7  $0080 = Password = Pas d'affichage des Caractres*} {MIC}
     {*Bit 8  $0100 = Affichage des Chiffres uniquement*} {MIC}
     {*Bit 9  $0200 = Freezed InputText*} {MIC}
     {*Bit 10 $0400 = Mode Majuscules*} {MIC}
     {*Bit 11 $0800 = Invisible InputText*} {MIC}
     {*Bit 12 $1000 = Overwrite Mode*} {MIC}
     {*Bit 13 $2000 = Positionne le Curseur en Dbut de Ligne*} {MIC}
     End;

TInputSlider=Record                     {*Input Slider definition*}
     X1,Y1,Sx    :Integer;              {*Gadget position and size*}
     Com         :TInputText;           {*Pointer to an InputText gadget*}
     But1,But2   :TButton;              {*Pointer to 2 Buttons*}
     Min,Max,Step:Longint;              {*Available array and Step*}
     Col1,Col2   :LongInt;              {*Colors for Gadget InputText*}
     Style       :Integer;              {*Style for Gadget InputText*}
     Tag         :Word;                 {*User field*}
     Id          :Word;                 {*Bits selection for Canvas*}
     {*Bit 0  $0001 : 1 = Gadget Activated*}
     {*Bit 1  $0002 : 1 = Gadget Freezed*}
     {*Bit 2  $0004 : 1 = Unvisible Gadget*}
     End;

{****************************************************************************}

{|Buttons management|}
Procedure Button(X,Y,Sx,Sy:Integer; CoP,CoB:Longint; Id:Word; Var But:TButton; St:String); {*Define and display Button*}
Procedure Button(X,Y,Sx,Sy:Integer; CoP,CoB:Longint; Id:Word; Var But:TButton; St,MPointer,Hint:String); {*Define and display Button with Hint*}
Procedure Button_Define(X,Y,Sx,Sy:Integer; CoP,CoB:Longint; Id:Word; Var But:TButton; St,MPointer,StHint:String); {*Define Button*}
Procedure Button_Draw(B:TButton);                      {*Draw Button*}
Procedure Button_Freeze(Status:Boolean; Var B:TButton);{*Freeze Button*}
Function  Button_GetMsg(Var B:TButton; M:Word):Byte;   {*Get Messages from Button*}

{|Cyclers management|}
Procedure Cycler(X,Y,Size,Num:Integer; CoP,CoB:LongInt; Id:Word; Var C:TCycler; St:String);{*Display Cycler*}
Procedure Cycler(X,Y,Size,Num:Integer; CoP,CoB:LongInt; Id:Word; Var C:TCycler; St,MPointer,SHint:String);{*Display extended Cycler*}
Procedure Cycler_Define(X,Y,Size,Num:Integer; CoP,CoB:LongInt; Id:Word; Var C:TCycler; St,MPointer,SHint:String);{*Define Cycler*}
Procedure Cycler_Draw(C:TCycler);                      {*Draw Cycler*}
Procedure Cycler_Freeze(Status:Boolean; Var C:TCycler);{*Freeze Cycler*}
Function  Cycler_GetMsg(Var C:TCycler; M:Word):Byte;   {*Get Messages from Cycler*}

{|RadioBox management|}
Procedure RadioBox(X,Y,Style:Integer; Id,Group,PLab:Byte; Status:Boolean; Var R:TRadioBox; Cin:String); {*Display Radio-box*}
Procedure RadioBox(X,Y,Style:Integer; Id,Group,PLab:Byte; Status:Boolean; Var R:TRadioBox; Cin,MPointer,SHint:String);{*Display extended Radio-box*}
Procedure RadioBox_Define(Var R:TRadioBox; X,Y,Style:Integer; Id,Group,PLab:Byte; Status:Boolean; Cin,MPointer,SHint:String); {*Define Radio-box*}
Procedure RadioBox_Draw  (Var R:TRadioBox);                {*Draw Radio Box*}
Procedure RadioBox_Freeze(Status:Boolean; Var R:TRadioBox);{*Freeze Radio Box*}
Function  RadioBox_GetMsg(Var R:TRadioBox; M:Word):Byte;   {*Get Messages from Radio Box*}

{|Sliders management|}
Procedure Slider        (Var S:TSlider; X1,Y1,Size:Integer; Quantity,Value,Orientation:Longint; Graduations:Word; Cursor:Byte; MPointer,SHint:String); {*Define graduation Slider*}
Procedure Slider        (Var S:TSlider; X1,Y1,Size:Integer; Quantity,Value,Orientation:Longint; Cursor:Byte; MPointer,SHint:String); {*Define value Slider*}
Procedure Slider        (Var S:TSlider; X1,Y1,Size:Integer; Quantity,Displayed,Value,Orientation:Longint; ButtonsPos:Byte; ButtonsDef:Boolean; ShapeColor:Longint; MPointer,SHint:String); {*Define classical Slider*}
Procedure Slider        (Var S:TSlider; X1,Y1,Size:Integer; Quantity,Displayed,Value,Orientation:Longint; Support,Shape:Byte; Graduations:Word; Cursor,ButtonsPos:Byte; ButtonsDef:Boolean; Id:Word;
                         ShapeColor,ShapeShadeCol1,ShapeShadeCol2,CursorColor:Longint; ShapeImage,CursorImage,MPointer,SHint:String); {*Define and draw a Slider*}
Procedure Slider_Define (Var S:TSlider; X1,Y1,X2,Y2:Integer;Quantity,Displayed,Value,Orientation:Longint; Support,Shape:Byte; Graduations:Word; Cursor,ButtonsPos:Byte; ButtonsDef:Boolean; Id:Word;
                         ShapeColor,ShapeShadeCol1,ShapeShadeCol2,CursorColor:Longint; ShapeImage,CursorImage,MPointer,SHint:String); {*Define Slider*}
Procedure Slider_Refresh(    S:TSlider);               {*Update position and draw again Slider*}
Procedure Slider_Draw   (    S:TSlider);               {*Draw Slider*}
Procedure Slider_DrawShape(  S:TSlider);               {*Draw Slider shape*}
Procedure Slider_DrawSupport(S:TSlider);               {*Draw Slider support*}
Procedure Slider_DrawGraduations(S:TSlider);           {*Draw Slider graduations*}
Procedure Slider_DrawCursor (S:TSlider);               {*Draw Slider cursor*}
Function  Slider_GetMsg (Var S:TSlider):Byte;          {*Get messages from Slider*}

{|InputText management|}
Procedure InputText(X,Y,Siz,Len:Integer; CoB,Co2:Longint; Sty:Byte; Id:Word; Var C:TInputText; Var Cin:String);{*Define Input*}
Procedure InputText_Define(X,Y,Siz:Integer; Len:Byte; CoB,Co2:Longint;Sty:Byte; ID:Word; Var C:TInputText;Var Cin:String);
Procedure InputText_Draw  (C:TInputText);                    {*Draw InputText*}
Procedure InputText_Freeze(Status:Boolean; Var C:TInputText);{*Freeze Input Text*}
Function  InputText_GetMsg(Var C:TInputText; Var Cin:String):Byte;{*Get Messages from Input Text*}

{|InputSliders management|}
Procedure InputSlider(X1,Y1,Sx:Integer; Col1,Col2,Style:Longint; Min,Max,Step:Longint; Var Value:Longint; Id:Word; Var ISl:TInputSlider);{*Define InputSlider*}
Procedure InputSlider_Draw  (Var ISl:TInputSlider);                 {*Draw InputSlider*}
Procedure InputSlider_Freeze(Status:Boolean; Var ISl:TInputSlider); {*Freeze InputSlider*}
Function  InputSlider_GetMsg(Var ISl:TInputSlider; Var VCin:Longint):Byte;{*Get Messages from InputSlide*}

{|Canvas management|}
Procedure Canvas(X1,Y1,X2,Y2,SizeTaq:Integer; Color:LongInt; IdTaq,Id,MouseBut:Word; Var C:TCanvas); {*Define Canvas*}
Procedure Canvas_Draw  (Var C:TCanvas);                 {*Draw Canvas*}
Procedure Canvas_Freeze(Status:Boolean; Var C:TCanvas); {*Freeze Canvas*}
Function  Canvas_GetMsg(Var C:TCanvas):Boolean;         {*Get Messages from Canvas*}

{|ColorPalette management|}
Procedure ColorPalette(Var Cp:TColorPalette; Px,Py,CellX,CellY,InterCell,Columns:Integer; FirstColor,LastColor:Longint; Count,Selected,BorderType:Integer; Id:Word; MPointer:ShortString);{*Define ColorPalette shade*}
Procedure ColorPalette(Var Cp:TColorPalette; Px,Py,CellX,CellY,InterCell,Columns:Integer; PaletteFile:String; Selected,BorderType:Integer; Id:Word; MPointer:ShortString);{*Define ColorPalette file*}
Procedure ColorPalette_Define(Var Cp:TColorPalette; Px,Py,CellX,CellY,InterCell,Columns:Integer; FirstColor,LastColor:Longint; Count:Integer; PaletteFile:String; Selected,BorderType:Integer; Id:Word; MPointer:ShortString);{*Define a ColorPalette*}
Procedure ColorPalette_ToggleCell(Var Cp:TColorPalette; Index:Integer; Display:Boolean; Border:Byte); {*Toggle a ColorPalette cell*}
Procedure ColorPalette_Draw  (Var Cp:TColorPalette);         {*Draw ColorPalette*}
Procedure ColorPalette_Freeze(Var Cp:TColorPalette; Status:Boolean); {*Freeze ColorPalette*}
Function  ColorPalette_GetMsg(Var Cp:TColorPalette):Byte;    {*Get messages from ColorPalette*}
Function  ColorPalette_GetSelected(CP:TColorPalette):Longint;{*Get RGB values of the selected color*}

{|Hint management|}
Procedure Hint(X1,Y1,X2,Y2:Integer; Id:Word; Var I:THint; Info:String); {*Define Info Box*}
Procedure Hint_Done  (Var I:THint);        {*Kill the Info Box*}
Function  Hint_GetMsg(Var I:THint):Byte;   {*Get Messages from Info Box*}

{|LightBox management|}
Function  LightBox_GetMsg(Var LB:TLightBox; M:Word;T:Byte):Byte;{*Draw box clicking mouse*}
Function  MoveBox_GetMsg (Var LB:TLightBox; M:Word):Byte; {*Move selected box*}

{|BMP animation management|}
Function  Anim(Var A:TAnimate; X1,Y1,X2,Y2,Ox,Oy:Integer; BName:String; Id:Word):Boolean;{*Define BMP animation*}
Procedure Anim_SetParam(Var A:TAnimate; Enabled,Visible,Cycling,Reverse:Boolean);{*Define more parameters*}
Procedure Anim_Draw(A:TAnimate);                      {*Draw current frame from BMP animation*}
Function  Anim_GetMsg(Var A:TAnimate):Byte;           {*Display BMP animation*}
Procedure Anim_Pause (Var A:TAnimate; Status:Boolean);{*Pause or run a BMP animation*}

{|Mouse Zone management|}
Procedure MseZone(Var MZ:TMouseZone; C:TCoordinates; MBAction:Byte; PName,SHint:String);{*Define a Mouse Zone*}
Function  MseZone_GetMsg(Var MZ:TMouseZone):Integer; {*Get messages from Mouse Zone*}

{|Display bitmap images|}
Procedure DrawGad_LeftArrow(X,Y:Integer);  {*Draw left arrow image*}
Procedure DrawGad_RightArrow(X,Y:Integer); {*Draw right arrow image*}
Procedure DrawGad_UpArrow(X,Y:Integer);    {*Draw up arrow image*}
Procedure DrawGad_DownArrow(X,Y:Integer);  {*Draw down arrow image*}
Procedure DrawGad_Cycler(X,Y:Integer);     {*Draw cycler image*}
Procedure DrawGad_Close(X,Y:Integer);      {*Draw close button image*}
Procedure DrawGad_Swap(X,Y:Integer);       {*Draw swap button image*}
Procedure DrawGad_Extend(X,Y:Integer);     {*Draw extend button image*}
Procedure DrawGad_Size(X,Y:Integer);       {*Draw size button image*}
Procedure DrawGad_AmigaOkBut(X,Y:Integer); {*Draw check image*}
Procedure DrawGad_CheckOff(X,Y:Integer);   {*Draw radio set image*}
Procedure DrawGad_CheckOn(X,Y:Integer);    {*Draw radio unset image*}
Procedure DrawGad_Lens(X,Y:Integer);       {*Draw lens image*}
Procedure DrawGad_Question(X,Y:Integer);   {*Draw question image*}
Procedure DrawGad_File(X,Y:Integer);       {*Draw standard file image*}

{|Miscellaneous|}
Procedure Play_Beep;                       {*Display beep and flash screen*}

IMPLEMENTATION

Uses
     Windows,
     MosBase,
     MosColors,
     MosCPUInstructions,
     MosCrt,
     MosFiles,
     MosFilesTree,
     MosGraph,
     MosImages,
     MosKeyboard,
     MosStrings,
     MosTools;

{*----------------------------- Dbut Library ------------------------------*}

Procedure Canvas_CalculePosTaquets(Var C:TCanvas); Forward;

{}
{}
{}

{ͻ
                      PROCEDURE Slider_PositionToValue                      
 ͹
  IN.....: S (TSlider) = Pointer to the TSlider structure.                  
  OUT....: /                                                                
  EXPLAIN: Calcul cursor position using "Value" and fill cursor fields.     
 ͼ}

Procedure Slider_PositionToValue(Var S:TSlider);
Var SizePixels:Integer;
    MyPos:Integer;
Begin
If S.Orientation=COHorizontal Then
   Begin
   SizePixels:=S.SupportC.X2-S.SupportC.X1-S.CursorSize;
   MyPos:=S.CursorC.X1-S.SupportC.X1;
   S.Value:=Round(Real(MyPos*S.Quantity)/SizePixels);
   If S.SupportC.X1+1=S.CursorC.X1 Then S.Value:=0; {*Patch - Set value to 0*}
   End
Else Begin
   SizePixels:=S.SupportC.Y2-S.SupportC.Y1-S.CursorSize;
   MyPos:=S.CursorC.Y1-S.SupportC.Y1;
   S.Value:=S.Quantity-Round(Real(MyPos*S.Quantity)/SizePixels);
   If S.SupportC.Y2-1=S.CursorC.Y2 Then S.Value:=0; {*Patch - Set value to 0*}
   If BTST(S.Id,3) Then S.Value:=S.Quantity-S.Value;{*List mode*}
   End;
Check_RangesValue(S.Value,0,S.Quantity);
End;

{ͻ
                       PROCEDURE Slider_ValueToPosition                     
 ͹
  IN.....: S (TSlider) = Pointer to the TSlider structure.                  
  OUT....: /                                                                
  EXPLAIN: Calcul cursor position using "Value" and fill cursor fields.     
 ͼ}

Procedure Slider_ValueToPosition(Var S:TSlider);
Var SizePixels:Integer;
    PosCur:Integer;
    Offset:Integer;
    D1,D2:Integer;

Begin
Check_RangesValue(S.Quantity,1,100000); {*Check ranges values*}
Check_RangesValue(S.Displayed,1,S.Quantity);
Check_RangesValue(S.Value,0,S.Quantity);

If S.Orientation=COHorizontal Then SizePixels:=S.SupportC.X2-S.SupportC.X1
                              Else SizePixels:=S.SupportC.Y2-S.SupportC.Y1;

PosCur:=Trunc(Real(S.Value*(SizePixels-S.CursorSize))/S.Quantity);
Check_RangesValue(PosCur,0,SizePixels-S.CursorSize);
If S.Support=SSBox Then Offset:=0 Else Offset:=1; {*Dcalage cursor*}

If S.Orientation=COHorizontal Then      {*Set cursor coordinates*}
   Begin                                {*Horizontal*}
   S.CursorC.X1:=S.SupportC.X1+PosCur;
   S.CursorC.Y1:=S.SupportC.Y1+1-Offset;
   S.CursorC.X2:=S.CursorC.X1+S.CursorSize;
   S.CursorC.Y2:=S.SupportC.Y2-1+Offset;
   End
   Else Begin                           {*Vertical*}
   S.CursorC.X1:=S.SupportC.X1+1-Offset;
   S.CursorC.Y1:=S.SupportC.Y1+PosCur;
   S.CursorC.X2:=S.SupportC.X2-1+Offset;
   S.CursorC.Y2:=S.CursorC.Y1+S.CursorSize;

   If Not BTST(S.Id,3) Then             {*List mode*}
      Begin
      D1:=S.CursorC.Y1-S.SupportC.Y1;   {*Swap values if vertical Slider*}
      D2:=S.CursorC.Y2-S.SupportC.Y1;
      S.CursorC.Y2:=S.SupportC.Y2-D1;
      S.CursorC.Y1:=S.SupportC.Y2-D2;
      End;
   End;
End;

{ͻ
                             PROCEDURE Slider                               
 ͹
  IN.....: S (TSlider) = Pointer to the TSlider structure.                  
           X,Y (INTEGER) = Slider position.                                 
           Size (INTEGER) = Slider size.                                    
           Quantity (LONGINT) = Quantity of available values.               
           Value (LONGINT) = Current Slider value.                          
           Orientation (LONGINT) = Slider orientation:                      
              0 = COHorizontal  Horizontal Slider                           
              1 = COVertical    Vertical Slider                             
           Cursor (BYTE) = Cursor style:                                    
              0 = CTNone        No cursor (Unvisible)                       
              1 = CTBox         Proportional cursor                         
              2 = CTRectangle   Fixed size rectangle                        
              3 = CTLine        Fixed size line                             
              4 = CTBoxArrow    Solid box with arrow                        
              5 = CTTriangle    Small black arrow                           
              6 = CTImage       Image                                       
           MPointer (STRING) = Mouse pointer else '' if current pointer used
           SHint (STRING) = Hint to display else '' if no help              
  OUT....: /                                                                
  EXPLAIN: Define and draw a value Slider with left graduations.            
  SEEALSO: Slider_Draw, Slider_GetMsg                                       
 ͼ}

Procedure Slider(Var S:TSlider; X1,Y1,Size:Integer; Quantity,Value,Orientation:Longint; Cursor:Byte; MPointer,SHint:String); {*Define value Slider*}
Var X2,Y2:Integer;
    Grad:Word;                          {*Adapted graduations*}
Begin
If Orientation=COHorizontal
  Then Begin X2:=X1+Size; Y2:=Y1+14; Grad:=$0004; End
  Else Begin X2:=X1+14; Y2:=Y1+Size; Grad:=$0001; End;
Slider_Define(S,X1,Y1,X2,Y2,Quantity,10,Value, Orientation, SSNone,SSColor, Grad,Cursor,BPOposed,No, $0000, VESA_GetPixel(X1,Y1),0,0,CLLightGrey, '','',MPointer,SHint);
Slider_Draw(S);
End;

{ͻ
                             PROCEDURE Slider                               
 ͹
  IN.....: S (TSlider) = Pointer to the TSlider structure.                  
           X,Y (INTEGER) = Slider position.                                 
           Size (INTEGER) = Slider size.                                    
           Quantity (LONGINT) = Quantity of available values.               
           Value (LONGINT) = Current Slider value.                          
           Orientation (LONGINT) = Slider orientation:                      
              0 = COHorizontal  Horizontal Slider                           
              1 = COVertical    Vertical Slider                             
           Graduations (WORD) = Defined graduations (optional)              
              Bit 0  $0001 :  1 = Display left graduations                  
              Bit 1  $0002 :  1 = Display center graduations                
              Bit 2  $0004 :  1 = Display right graduations                 
           Cursor (BYTE) = Cursor style:                                    
              0 = CTNone        No cursor (Unvisible)                       
              1 = CTBox         Proportional cursor                         
              2 = CTRectangle   Fixed size rectangle                        
              3 = CTLine        Fixed size line                             
              4 = CTBoxArrow    Solid box with arrow                        
              5 = CTTriangle    Small black arrow                           
              6 = CTImage       Image                                       
           MPointer (STRING) = Mouse pointer else '' if current pointer used
           SHint (STRING) = Hint to display else '' if no help              
  OUT....: /                                                                
  EXPLAIN: Define and draw a Slider with graduations component.             
  SEEALSO: Slider_Draw, Slider_GetMsg                                       
 ͼ}

Procedure Slider(Var S:TSlider; X1,Y1,Size:Integer; Quantity,Value,Orientation:Longint; Graduations:Word; Cursor:Byte; MPointer,SHint:String); {*Define Slider*}
Var X2,Y2:Integer;
Begin
If Orientation=COHorizontal
  Then Begin X2:=X1+Size; Y2:=Y1+14; End
  Else Begin X2:=X1+14; Y2:=Y1+Size; End;
Slider_Define(S,X1,Y1,X2,Y2,Quantity,10,Value, Orientation, SSLine,SSNone, Graduations,Cursor,BPOposed,No, $0000, 0,0,0,CLLightGrey, '','',MPointer,SHint);
Slider_Draw(S);
End;

{ͻ
                             PROCEDURE Slider                               
 ͹
  IN.....: S (TSlider) = Pointer to the TSlider structure.                  
           X,Y (INTEGER) = Slider position.                                 
           Size (INTEGER) = Slider size.                                    
           Quantity (LONGINT) = Quantity of available values.               
           Displayed (LONGINT) = Displayed values (proportional cursor).    
           Value (LONGINT) = Current Slider value.                          
           Orientation (LONGINT) = Slider orientation:                      
              0 = COHorizontal  Horizontal Slider                           
              1 = COVertical    Vertical Slider                             
           ButtonsPos (BYTE) =                                              
              1 = BPGrouped     Grouped buttons (on the same side)          
              2 = BPOposed      Opposed buttons (on different sides)        
           ButtonsDef (BOOLEAN) = Yes : Display buttons                     
           ShapeColor (LONGINT) = Shape color (if shape defined)            
           MPointer (STRING) = Mouse pointer else '' if current pointer used
           SHint (STRING) = Hint to display else '' if no help              
  OUT....: /                                                                
  EXPLAIN: Define and draw a classical Slider component.                    
  SEEALSO: Slider_Draw, Slider_GetMsg                                       
 ͼ}

Procedure Slider(Var S:TSlider; X1,Y1,Size:Integer; Quantity,Displayed,Value,Orientation:Longint; ButtonsPos:Byte; ButtonsDef:Boolean; ShapeColor:Longint; MPointer,SHint:String);
Var X2,Y2:Integer;
Begin
If Orientation=COHorizontal
  Then Begin X2:=X1+Size; Y2:=Y1+14; End
  Else Begin X2:=X1+14; Y2:=Y1+Size; End;
Slider_Define(S,X1,Y1,X2,Y2,Quantity,Displayed,Value, Orientation, SSBox,SSColor, $0000,CTBox,ButtonsPos,ButtonsDef, $0000,ShapeColor,0,0,CLLightGrey, '','',MPointer,SHint);
Slider_Draw(S);
End;

{ͻ
                             PROCEDURE Slider                               
 ͹
  IN.....: S (TSlider) = Pointer to the TSlider structure.                  
           X,Y (INTEGER) = Slider position.                                 
           Size (INTEGER) = Slider size.                                    
           Quantity (LONGINT) = Quantity of available values.               
           Displayed (LONGINT) = Displayed values (proportional cursor).    
           Value (LONGINT) = Current Slider value.                          
           Orientation (LONGINT) = Slider orientation:                      
              0 = COHorizontal  Horizontal Slider                           
              1 = COVertical    Vertical Slider                             
           Support (BYTE) =                                                 
              0 = SSNone        No support (Unvisible)                      
              1 = SSBox         Box support                                 
              2 = SSLine        Central line support for cursor             
           Shape (BYTE) =                                                   
              0 = SSNone        No shape (Unvisible)                        
              1 = SSColor       Solid color                                 
              2 = SSShade       Shade between two colors                    
              3 = SSImage       Image                                       
           Graduations (WORD) = Defined graduations (optional)              
              Bit 0  $0001 :  1 = Display left graduations                  
              Bit 1  $0002 :  1 = Display center graduations                
              Bit 2  $0004 :  1 = Display right graduations                 
           Cursor (BYTE) = Cursor style:                                    
              0 = CTNone        No cursor (Unvisible)                       
              1 = CTBox         Proportional cursor                         
              2 = CTRectangle   Fixed size rectangle                        
              3 = CTLine        Fixed size line                             
              4 = CTBoxArrow    Solid box with arrow                        
              5 = CTTriangle    Small black arrow                           
              6 = CTImage       Image                                       
           ButtonsPos (BYTE) =                                              
              1 = BPGrouped     Grouped buttons (on the same side)          
              2 = BPOposed      Opposed buttons (on different sides)        
           ButtonsDef (BOOLEAN) = Yes : Display buttons                     
           Id (WORD) = Bits definition :                                    
               Bit 0  $0001 :  1 = Don't use images for slider buttons      
               Bit 1  $0002 :  1 = Freezed component                        
               Bit 2  $0004 :  1 = Unvisible component                      
               Bit 3  $0008 :  1 = Switch to "List mode" for vertical slider
           ShapeColor (LONGINT) = Shape color (if shape defined)            
           ShapeShadeCol1 (LONGINT) = Shape shade color 1                   
           ShapeShadeCol2 (LONGINT) = Shape shade color 2                   
           CursorColor (LONGINT) = Cursor color                             
           ShapeImage (STRING) = Shape image else '' if no image defined    
           CursorImage (STRING) = Cursor image else '' if no image defined  
           MPointer (STRING) = Mouse pointer else '' if current pointer used
           SHint (STRING) = Hint to display else '' if no help              
  OUT....: /                                                                
  EXPLAIN: Define and draw a Slider component with full parameters.         
  SEEALSO: Slider_Draw, Slider_GetMsg                                       
 ͼ}

Procedure Slider(Var S:TSlider; X1,Y1,Size:Integer; Quantity,Displayed,Value,Orientation:Longint; Support,Shape:Byte; Graduations:Word; Cursor,ButtonsPos:Byte; ButtonsDef:Boolean; Id:Word;
                 ShapeColor,ShapeShadeCol1,ShapeShadeCol2,CursorColor:Longint; ShapeImage,CursorImage,MPointer,SHint:String);
Var X2,Y2:Integer;
Begin
If Orientation=COHorizontal
  Then Begin X2:=X1+Size; Y2:=Y1+14; End
  Else Begin X2:=X1+14; Y2:=Y1+Size; End;
Slider_Define(S, X1,Y1,X2,Y2, Quantity,Displayed,Value, Orientation,Support,Shape,Graduations,Cursor,ButtonsPos,ButtonsDef, Id, ShapeColor,ShapeShadeCol1,ShapeShadeCol2,CursorColor, ShapeImage,CursorImage,MPointer,SHint);
Slider_Draw(S);
End;

{ͻ
                          PROCEDURE Slider_Define                           
 ͹
  IN.....: S (TSlider) = Pointer to the TSlider structure.                  
           X1,Y1,X2,Y2 (INTEGER) = Slider coordinates.                      
           Quantity (LONGINT) = Quantity of available values.               
           Displayed (LONGINT) = Displayed values (proportional cursor).    
           Value (LONGINT) = Current Slider value.                          
           Orientation (LONGINT) = Slider orientation:                      
              0 = COHorizontal  Horizontal Slider                           
              1 = COVertical    Vertical Slider                             
           Support (BYTE) =                                                 
              0 = SSNone        No support (Unvisible)                      
              1 = SSBox         Box support                                 
              2 = SSLine        Central line support for cursor             
           Shape (BYTE) =                                                   
              0 = SSNone        No shape (Unvisible)                        
              1 = SSColor       Solid color                                 
              2 = SSShade       Shade between two colors                    
              3 = SSImage       Image                                       
           Graduations (WORD) = Defined graduations (optional)              
              Bit 0  $0001 :  1 = Display left graduations                  
              Bit 1  $0002 :  1 = Display center graduations                
              Bit 2  $0004 :  1 = Display right graduations                 
           Cursor (BYTE) = Cursor style:                                    
              0 = CTNone        No cursor (Unvisible)                       
              1 = CTBox         Proportional cursor                         
              2 = CTRectangle   Fixed size rectangle                        
              3 = CTLine        Fixed size line                             
              4 = CTBoxArrow    Solid box with arrow                        
              5 = CTTriangle    Small black arrow                           
              6 = CTImage       Image                                       
           ButtonsPos (BYTE) =                                              
              1 = BPGrouped     Grouped buttons (on the same side)          
              2 = BPOposed      Opposed buttons (on different sides)        
           ButtonsDef (BOOLEAN) = Yes : Display buttons                     
           Id (WORD) = Bits definition :                                    
               Bit 0  $0001 :  1 = Don't use images for slider buttons      
               Bit 1  $0002 :  1 = Freezed component                        
               Bit 2  $0004 :  1 = Unvisible component                      
               Bit 3  $0008 :  1 = Switch to "List mode" for vertical slider
           ShapeColor (LONGINT) = Shape color (if shape defined)            
           ShapeShadeCol1 (LONGINT) = Shape shade color 1                   
           ShapeShadeCol2 (LONGINT) = Shape shade color 2                   
           CursorColor (LONGINT) = Cursor color                             
           ShapeImage (STRING) = Shape image else '' if no image defined    
           CursorImage (STRING) = Cursor image else '' if no image defined  
           MPointer (STRING) = Mouse pointer else '' if current pointer used
           SHint (STRING) = Hint to display else '' if no help              
  OUT....: /                                                                
  EXPLAIN: Define Slider component without draw it.                         
  SEEALSO: Slider_Draw, Slider_GetMsg                                       
 ͼ}

Procedure Slider_Define(Var S:TSlider; X1,Y1,X2,Y2:Integer; Quantity,Displayed,Value,Orientation:Longint; Support,Shape:Byte; Graduations:Word; Cursor,ButtonsPos:Byte; ButtonsDef:Boolean; Id:Word;
                        ShapeColor,ShapeShadeCol1,ShapeShadeCol2,CursorColor:Longint; ShapeImage,CursorImage,MPointer,SHint:String); {*Define Slider*}
Var Xa,Ya,Sx,Sy:Integer;                {*Button position*}
    IdB:Word;                           {*Id boutons*}
    Sx1,Sy1,Sx2,Sy2:Integer;            {*X1 and X2 support values*}
    SizePixels:Integer;
    Ix,Iy:Longint;                      {*To get information about cursor image*}
    wix,wiy: word;
    Colors:Longint;
    ButtonIcon:Byte;                    {*Inner icon to use with buttons*}
    BHint:String;                       {*Modular button hint*}
    BName:String;                       {*Button filename (images or arrow)*}

Begin
Log.Add('Create new Slider',2);

If Orientation=COHorizontal Then If X2-X1<29 Then X2:=X1+29;
If Orientation=COVertical   Then If Y2-Y1<29 Then Y2:=Y1+29;

S.MainC.X1:=X1;
S.MainC.Y1:=Y1;
S.MainC.X2:=X2;
S.MainC.Y2:=Y2;

S.Shape:=Shape;                         {*Shape style*}
S.ShapeImage:=ShapeImage;               {*Shape image*}
S.ShapeColor:=ShapeColor;               {*Shape color*}
S.ShapeShadeCol1:=ShapeShadeCol1;       {*Shade for shape*}
S.ShapeShadeCol2:=ShapeShadeCol2;

S.BgColor:=VESA_GetPixel(X1,Y1);        {*Get background color*}
S.Orientation:=Orientation;             {*Slider orientation*}
S.Support:=Support;                     {*Support style*}
S.Graduations:=Graduations;             {*Graduations type*}
S.Cursor:=Cursor;                       {*Cursor type*}
S.CursorImage:=CursorImage;             {*Cursor image*}
S.CursorColor:=CursorColor;             {*Cursor color*}

S.ButtonsPos:=ButtonsPos;               {*Buttons positions*}
S.ButtonsDef:=ButtonsDef;               {*Defined buttons*}
Sx1:=S.MainC.X1;
Sy1:=S.MainC.Y1;
Sx2:=S.MainC.X2;
Sy2:=S.MainC.Y2;

S.Tag:=0;                               {*User field*}
S.Id:=Id;                               {*Parameters bits*}
S.IdIn:=$0000;                          {*Inner parameters bits*}

If ButtonsDef Then
   Begin                                {*Left button*}
   If BTST(S.Id,0) Then Idb:=$0080 Else Idb:=$0288;
   If S.Orientation=COHorizontal Then   {*Horizontal*}
      Begin
      Ya:=S.MainC.Y1; Sx:=14; Sy:=S.MainC.Y2-S.MainC.Y1;
      ButtonIcon:=2;
      If ButtonsPos=BPGrouped Then Xa :=S.MainC.X2-14*2-1 Else Xa:=S.MainC.X1;
      If ButtonsPos=BPGrouped Then Sx2:=Sx2-15 Else Sx1:=Sx1+15;
      BHint:=Language.Loc(163);
      If BTST(S.Id,0) Then BName:=''
                      Else BName:=Sys.GetPath(SP_BUTTONS)+Sys.ImgSliderLeftNo+'|'+Sys.GetPath(SP_BUTTONS)+Sys.ImgSliderLeftYes;
      End
      Else Begin                        {*Vertical*}
      Xa:=S.MainC.X1; Sx:=S.MainC.X2-S.MainC.X1; Sy:=14;
      ButtonIcon:=4;
      If ButtonsPos=BPGrouped Then Ya :=S.MainC.Y2-14*2-1 Else Ya:=S.MainC.Y1;
      If ButtonsPos=BPGrouped Then Sy2:=Sy2-15 Else Sy1:=Sy1+15;
      BHint:=Language.Loc(162);
      If BTST(S.Id,0) Then BName:=''
                      Else BName:=Sys.GetPath(SP_BUTTONS)+Sys.ImgSliderUpNo+'|'+Sys.GetPath(SP_BUTTONS)+Sys.ImgSliderUpYes;
      End;
   Button_Define(Xa,Ya,Sx,Sy, CLTextButton,CLBgButton,IdB, S.BSub, BName,MPArrow,BHint);
   If BTST(S.Id,0) Then S.BSub.ButSp:=ButtonIcon;
                                        {*Right button*}
   If S.Orientation=COHorizontal Then   {*Horizontal*}
      Begin
      Sx2:=Sx2-15; ButtonIcon:=3;
      Xa:=S.MainC.X2-14; Ya:=S.MainC.Y1; Sx:=14; Sy:=S.MainC.Y2-S.MainC.Y1;
      BHint:=Language.Loc(162);
      If BTST(S.Id,0) Then BName:=''
                      Else BName:=Sys.GetPath(SP_BUTTONS)+Sys.ImgSliderRightNo+'|'+Sys.GetPath(SP_BUTTONS)+Sys.ImgSliderRightYes;
      End
      Else Begin                        {*Vertical*}
      Sy2:=Sy2-15; ButtonIcon:=5;
      Xa:=S.MainC.X1; Ya:=S.MainC.Y2-14; Sx:=S.MainC.X2-S.MainC.X1; Sy:=14;
      BHint:=Language.Loc(163);
      If BTST(S.Id,0) Then BName:=''
                      Else BName:=Sys.GetPath(SP_BUTTONS)+Sys.ImgSliderDownNo+'|'+Sys.GetPath(SP_BUTTONS)+Sys.ImgSliderDownYes;
      End;
   Button_Define(Xa,Ya,Sx,Sy, CLTextButton,CLBgButton,IdB, S.BAdd, BName,MPArrow,BHint);
   If BTST(S.Id,0) Then S.BAdd.ButSp:=ButtonIcon;
   End;

S.SupportC.X1:=Sx1;                     {*Coordinates support*}
S.SupportC.Y1:=Sy1;
S.SupportC.X2:=Sx2;
S.SupportC.Y2:=Sy2;

S.ShapeC:=S.SupportC;                   {*Save shape coordinates*}
If S.Support=SSBox Then                 {*Adjust shape for special support*}
   Begin
   Inc(S.ShapeC.X1,1); Inc(S.ShapeC.Y1,1);
   Dec(S.ShapeC.X2,1); Dec(S.ShapeC.Y2,1);
   End;

MseZone(S.Pointer,S.SupportC, MBIgnore, MPointer,SHint); {*Define mouse pointer*}

S.Value:=Value;                         {*Slider current value*}
S.Quantity:=Quantity;                   {*Quantity of values*}
S.Displayed:=Displayed;                 {*Displayed values*}
S.MoveStep:=Quantity Div 10;            {*Step to move cursor*}

If S.Orientation=COHorizontal Then SizePixels:=S.SupportC.X2-S.SupportC.X1
                              Else SizePixels:=S.SupportC.Y2-S.SupportC.Y1;
Case S.Cursor of
   CTBox:                               {*Proportional box cursor*}
      Begin
      S.CursorSize:=Trunc(Real(S.Displayed*SizePixels)/S.Quantity);
      If S.CursorSize<6 Then S.CursorSize:=6; {*Minimum size needed*}
      End;
   CTRectangle: S.CursorSize:=10;       {*Static rectangle*}
   CTLine     : S.CursorSize:=05;       {*Static line*}
   CTBoxArrow : S.CursorSize:=08;       {*Static box with arrow*}
   CTTriangle : S.CursorSize:=06;       {*Small bold triangle*}
   CTImage    :                         {*Static transparent image cursor*}
      Begin
      BMP_GetInfo(S.CursorImage,wIx,wIy,Colors); Ix := wix; Iy := wiy;
      If S.Orientation=COHorizontal Then
         Begin
         Check_RangesValue(Ix,0,S.SupportC.X2-S.SupportC.X1);
         S.CursorSize:=Ix;
         End
         Else Begin
         Check_RangesValue(Iy,0,S.SupportC.Y2-S.SupportC.Y1);
         S.CursorSize:=Iy;
         End;
      End;
   End;

Slider_ValueToPosition(S);              {*Calcul the cursor pixels position*}
End;

{ͻ
                         PROCEDURE Slider_DrawShape                         
 ͹
  IN.....: S (TSlider) = Pointer to the TSlider structure.                  
  OUT....: /                                                                
  EXPLAIN: Draw Slider shape if defined.                                    
 ͼ}

Procedure Slider_DrawShape(S:TSlider);
Begin
Case S.Shape of
   SSColor: Begin
      Bevel(S.ShapeC.X1, S.ShapeC.Y1, S.ShapeC.X2, S.ShapeC.Y2, S.ShapeColor);
      End;
   SSShade: Begin
      Display_Shade(S.ShapeC.X1, S.ShapeC.Y1, S.ShapeC.X2, S.ShapeC.Y2, S.ShapeShadeCol1,S.ShapeShadeCol2, S.Orientation);
      End;
   SSImage: Begin
      BMP_Show(S.ShapeC.X1, S.ShapeC.Y1, S.ShapeC.X2, S.ShapeC.Y2, 0,0,S.ShapeImage, $0080);
      End;
   End;
End;

{ͻ
                        PROCEDURE Slider_DrawSupport                        
 ͹
  IN.....: S (TSlider) = Pointer to the TSlider structure.                  
  OUT....: /                                                                
  EXPLAIN: Draw Slider support if defined.                                  
 ͼ}

Procedure Slider_DrawSupport(S:TSlider);
Var MoyX,MoyY:Integer;

Procedure Create_Tringle(X1,Y1,X2,Y2,Orientation:Integer);
Var A:Integer;
Begin
Mse_Hide;
If Orientation=COHorizontal Then        {*Horizontal*}
   Begin
   VESA_SetColor(CLBlack); VESA_Line(X1+2,Y1,X2-1,Y1);
   VESA_SetColor(CLWinBg); VESA_Line(X1+1,Y1+1,X2-1,Y2+1);
   VESA_PutPixel(X1+1,Y1,CLWinBg);
   VESA_SetColor(CLGrey);  VESA_Line(X1,Y1-1,X2,Y1-1);
   VESA_SetColor(CLGrey);  VESA_Line(X2,Y1-1,X2,Y1+1);
   VESA_SetColor(CLBrightGrey); VESA_Line(X1,Y1-1,X1,Y2+2);
   VESA_SetColor(CLBrightGrey); VESA_Line(X1,Y2+2,X2,Y2+2);
   VESA_SetColor(S.BgColor);
   For A:=S.SupportC.Y1 to Y1-2 do VESA_Line(X1,A,X2,A); {*Clear array autour de la tringle*}
   For A:=Y2+3 to S.SupportC.Y2 do VESA_Line(X1,A,X2,A);
   End
   Else Begin                           {*Vertical*}
   VESA_SetColor(CLBlack); VESA_Line(X1,Y1+1,X2,Y2-2);
   VESA_SetColor(CLWinBg); VESA_Line(X1+1,Y1+1,X2+1,Y2-1);
   VESA_PutPixel(X1,Y2-1,CLWinBg);
   VESA_SetColor(CLGrey);  VESA_Line(X1-1,Y1,X2-1,Y2-1);
   VESA_SetColor(CLGrey);  VESA_Line(X1-1,Y1,X2+1,Y1);
   VESA_SetColor(CLBrightGrey); VESA_Line(X1+2,Y1,X2+2,Y2);
   VESA_SetColor(CLBrightGrey); VESA_Line(X1-1,Y2,X2+2,Y2);
   VESA_SetColor(S.BgColor);
   For A:=S.SupportC.X1 to X1-2 do VESA_Line(A,Y1,A,Y2); {*Clear array autour de la tringle*}
   For A:=X1+3 to S.SupportC.X2 do VESA_Line(A,Y1,A,Y2);
   End;
Mse_Show;
End;

Begin
Case S.Support of
   SSBox: Begin
      Bevel(S.SupportC.X1, S.SupportC.Y1, S.SupportC.X2, S.SupportC.Y2, CLBlack, BLRaisedLine,BLNoLine,No);
      End;
   SSLine: Begin
      MoyX:=(S.SupportC.X1+S.SupportC.X2) Div 2;
      MoyY:=(S.SupportC.Y1+S.SupportC.Y2) Div 2;
      If S.Orientation=COHorizontal Then Create_Tringle(S.SupportC.X1, MoyY, S.SupportC.X2, MoyY, S.Orientation)
                                    Else Create_Tringle(MoyX, S.SupportC.Y1, MoyX, S.SupportC.Y2, S.Orientation);
      End;
   End;
End;

{ͻ
                      PROCEDURE Slider_DrawGraduations                      
 ͹
  IN.....: S (TSlider) = Pointer to the TSlider structure.                  
  OUT....: /                                                                
  EXPLAIN: Draw Slider graduations if defined.                              
 ͼ}

Procedure Slider_DrawGraduations(S:TSlider);
Var Px,Pg:Integer;
Begin
VESA_SetColor(CLBlack);
Mse_Hide;
If S.Orientation=COHorizontal Then
   Begin                                {*Horizontal*}
   Pg:=S.SupportC.X1-3;
      Repeat
      Inc(Pg,6);
      If BTST(S.Graduations,0) Then
         Begin
         If (Pg=S.SupportC.X1+3) Or (Pg+5>=S.SupportC.X2) Then Px:=S.CursorC.Y1-5 Else Px:=S.CursorC.Y1-4;
         VESA_Line(Pg,Px,Pg,S.CursorC.Y1-2);
         End;
      If BTST(S.Graduations,1) Then
         Begin
         If (Pg=S.SupportC.X1+3) Or (Pg+5>=S.SupportC.X2) Then Px:=0 Else Px:=1;
         VESA_Line(Pg,S.CursorC.Y1+Px,Pg,S.CursorC.Y2-Px);
         End;
      If BTST(S.Graduations,2) Then
         Begin
         If (Pg=S.SupportC.X1+3) Or (Pg+5>=S.SupportC.X2) Then Px:=S.CursorC.Y2+5 Else Px:=S.CursorC.Y2+4;
         VESA_Line(Pg,S.CursorC.Y2+2,Pg,Px);
         End;
      Until Pg+5>=S.SupportC.X2;
   End
   Else Begin                           {*Vertical*}
   Pg:=S.SupportC.Y2+3;
      Repeat
      Dec(Pg,6);
      If BTST(S.Graduations,0) Then
         Begin
         If (Pg=S.SupportC.Y2-3) Or (Pg-3<=S.SupportC.Y1) Then Px:=S.CursorC.X1-5 Else Px:=S.CursorC.X1-4;
         VESA_Line(Px,Pg,S.CursorC.X1-2,Pg);
         End;
      If BTST(S.Graduations,1) Then
         Begin
         If (Pg=S.SupportC.Y2-3) Or (Pg-3<=S.SupportC.Y1) Then Px:=0 Else Px:=1;
         VESA_Line(S.CursorC.X1+Px,Pg,S.CursorC.X2-Px,Pg);
         End;
      If BTST(S.Graduations,2) Then
         Begin
         If (Pg=S.SupportC.Y2-3) Or (Pg-3<=S.SupportC.Y1) Then Px:=S.CursorC.X2+5 Else Px:=S.CursorC.X2+4;
         VESA_Line(S.CursorC.X2+2,Pg,Px,Pg);
         End;
      Until Pg-3<=S.SupportC.Y1;
   End;
Mse_Show;
End;

{ͻ
                         PROCEDURE Slider_DrawCursor                        
 ͹
  IN.....: S (TSlider) = Pointer to the TSlider structure.                  
  OUT....: /                                                                
  EXPLAIN: Draw Slider cursor.                                              
 ͼ}

Procedure Slider_DrawCursor(S:TSlider);
Begin
Case S.Cursor of
   CTBox,CTRectangle,CTLine : Bevel(S.CursorC.X1, S.CursorC.Y1, S.CursorC.X2, S.CursorC.Y2, S.CursorColor, BLRaisedLine,BLNoLine,Yes);
   CTBoxArrow:
      Begin
      If S.Orientation=COHorizontal Then
         Begin
         Bevel(S.CursorC.X1, S.CursorC.Y1, S.CursorC.X2, S.CursorC.Y2-4, CLLightGrey, BLRaisedLine,BLNoLine,Yes);
         Mse_Hide;
         VESA_SetColor(S.BgColor);
         VESA_Line(S.CursorC.X1, S.CursorC.Y2-4, S.CursorC.X2, S.CursorC.Y2-4);
         VESA_SetColor(CLLineUp);
         VESA_Line(S.CursorC.X1, S.CursorC.Y2-4, S.CursorC.X1+4, S.CursorC.Y2);
         VESA_SetColor(CLLineDown);
         VESA_Line(S.CursorC.X1+4, S.CursorC.Y2, S.CursorC.X2, S.CursorC.Y2-4);
         Mse_Show;
         End
      Else Begin
         Bevel(S.CursorC.X1+4, S.CursorC.Y1, S.CursorC.X2, S.CursorC.Y2, CLLightGrey, BLRaisedLine,BLNoLine,Yes);
         Mse_Hide;
         VESA_SetColor(S.BgColor);
         VESA_Line(S.CursorC.X1+4, S.CursorC.Y1, S.CursorC.X1+4, S.CursorC.Y2);
         VESA_SetColor(CLLineUp);
         VESA_Line(S.CursorC.X1, S.CursorC.Y1+4, S.CursorC.X1+4, S.CursorC.Y1);
         VESA_SetColor(CLLineDown);
         VESA_Line(S.CursorC.X1, S.CursorC.Y1+4, S.CursorC.X1+4, S.CursorC.Y2);
         Mse_Show;
         End
      End;
   CTTriangle:
      Begin
      VESA_SetColor(CLBlack);
      Mse_Hide;
      If S.Orientation=COHorizontal Then
         Begin
         VESA_Line(S.CursorC.X1+0, S.CursorC.Y1+2, S.CursorC.X1+0, S.CursorC.Y2-9);
         VESA_Line(S.CursorC.X1+1, S.CursorC.Y1+2, S.CursorC.X1+1, S.CursorC.Y2-7);
         VESA_Line(S.CursorC.X1+2, S.CursorC.Y1+2, S.CursorC.X1+2, S.CursorC.Y2-5);
         VESA_Line(S.CursorC.X1+3, S.CursorC.Y1+2, S.CursorC.X1+3, S.CursorC.Y2-3);
         VESA_Line(S.CursorC.X1+4, S.CursorC.Y1+2, S.CursorC.X1+4, S.CursorC.Y2-5);
         VESA_Line(S.CursorC.X1+5, S.CursorC.Y1+2, S.CursorC.X1+5, S.CursorC.Y2-7);
         VESA_Line(S.CursorC.X1+6, S.CursorC.Y1+2, S.CursorC.X1+6, S.CursorC.Y2-9);
         VESA_SetColor(S.BgColor);
         VESA_Line(S.CursorC.X1, S.CursorC.Y1+4, S.CursorC.X2, S.CursorC.Y1+4);
         End
      Else Begin
         VESA_Line(S.CursorC.X1+9, S.CursorC.Y1+0, S.CursorC.X2-2, S.CursorC.Y1+0);
         VESA_Line(S.CursorC.X1+7, S.CursorC.Y1+1, S.CursorC.X2-2, S.CursorC.Y1+1);
         VESA_Line(S.CursorC.X1+5, S.CursorC.Y1+2, S.CursorC.X2-2, S.CursorC.Y1+2);
         VESA_Line(S.CursorC.X1+3, S.CursorC.Y1+3, S.CursorC.X2-2, S.CursorC.Y1+3);
         VESA_Line(S.CursorC.X1+5, S.CursorC.Y1+4, S.CursorC.X2-2, S.CursorC.Y1+4);
         VESA_Line(S.CursorC.X1+7, S.CursorC.Y1+5, S.CursorC.X2-2, S.CursorC.Y1+5);
         VESA_Line(S.CursorC.X1+9, S.CursorC.Y1+6, S.CursorC.X2-2, S.CursorC.Y1+6);
         VESA_SetColor(S.BgColor);
         VESA_Line(S.CursorC.X2-4, S.CursorC.Y1, S.CursorC.X2-4, S.CursorC.Y2);
         End;
      Mse_Show;
      End;
   CTImage:
      Begin
      BMP_ShowTransparency(S.CursorC.X1, S.CursorC.Y1, S.CursorC.X2, S.CursorC.Y2, 0,0,S.CursorImage, $0080,CLTransparency);
      End;
   End;
End;

{ͻ
                          PROCEDURE Slider_Refresh                          
 ͹
  IN.....: S (TSlider) = Pointer to the TSlider structure.                  
  OUT....: /                                                                
  EXPLAIN: Refresh the visual part of Slider except buttons.                
 ͼ}

Procedure Slider_Refresh(S:TSlider);
Begin
If BTST(S.Id,2) Then Exit;              {*Unvisible component*}
Slider_ValueToPosition(S);              {*Calcul the cursor pixels position*}

Slider_DrawShape(S);                    {*Draw Slider shape*}
Slider_DrawGraduations(S);              {*Draw Slider graduations*}
Slider_DrawSupport(S);                  {*Draw Slider support*}
Slider_DrawCursor(S);                   {*Draw Slider cursor*}
End;

{ͻ
                           PROCEDURE Slider_Draw                            
 ͹
  IN.....: S (TSlider) = Pointer to the TSlider structure.                  
  OUT....: /                                                                
  EXPLAIN: Draw a defined Slider with buttons.                              
 ͼ}

Procedure Slider_Draw(S:TSlider);
Begin
If BTST(S.Id,2) Then Exit;              {*Unvisible component*}
//Bevel(S.MainC.X1-1, S.MainC.Y1-1, S.MainC.X2+1, S.MainC.Y2+1, CLRed); {Debug}

Slider_Refresh(S);                      {*Draw all Slider components*}

If S.ButtonsDef Then                    {*Draw buttons*}
   Begin
   Button_Draw(S.BSub);
   Button_Draw(S.BAdd);
   End;
End;

{ͻ
                           FUNCTION Slider_GetMsg                           
 ͹
  IN.....: S (TSlider) = Pointer to the TSlider structure.                  
  OUT....: (BYTE) = Message Id as:                                          
               CMNone               No messages                             
               CMModified           Slider value has been modified          
  EXPLAIN: Manage and get messages from a slider.                           
 ͼ}

Function Slider_GetMsg(Var S:TSlider):Byte;
Var OldCursorC:TCoordinates;
    Mx,My:Word;                         {*Mouse position*}
    Delta:Integer;                      {*Pixels between Mouse and cursor center*}
    Val:Integer;                        {*Value to add or dec for buttons*}

Begin
Slider_GetMsg:=CMNone;
If BTST(S.Id,1) Then Exit;              {*Freezed component*}

If Not Mse_Clicked(MBLeft) Then Sys.SlidersActivated:=0; {*No Sliders actived*}

If (Not Mse_Clicked(MBLeft)) And (BTST(S.IdIn,0)) Then
   Begin
   BCLR(S.IdIn,0);
   BCLR(S.IdIn,1);
   End;

If (MseZone_GetMsg(S.Pointer)=CMSelected) And (Not BTST(S.IdIn,0)) And (Sys.ButtonsActivated=0) Then
   Begin
   If Kbd_GetKeyDown(VK_SHIFT) Or (Sys.SlidersActivated=0) Then
      Begin                             {*Mono or multi Sliders activated*}
      BSET(S.IdIn,0);
      BSET(S.IdIn,2);
      End;
   End;

If (BTST(S.IdIn,0)) And (Mse_Clicked(MBLeft))  Then
   Begin                                {*Manage hint and mouse zone*}
   If BTST(S.IdIn,2) Then
      Begin
      BSET(S.IdIn,1);
      BCLR(S.IdIn,2);
      Sys.SlidersActivated := Sys.SlidersActivated + 1;
      End;
   Mse_GetPos(Mx,My);
   Dec(Mx,T_Clip.X1); Dec(My,T_Clip.Y1);
   OldCursorC:=S.CursorC;
   If S.Orientation=COHorizontal Then
      Begin
      Delta:=Mx-((S.CursorC.X1+S.CursorC.X2) Div 2);
      Inc(S.CursorC.X1,Delta); Inc(S.CursorC.X2,Delta);
      End
      Else Begin
      Delta:=My-((S.CursorC.Y1+S.CursorC.Y2) Div 2);
      Inc(S.CursorC.Y1,Delta); Inc(S.CursorC.Y2,Delta);
      End;
   Slider_PositionToValue(S);           {*Calcul the Slider value*}
   Slider_ValueToPosition(S);           {*Calcul the cursor pixels position*}
   If Not Coord_TestEqual(OldCursorC,S.CursorC) Then
      Begin
      Slider_Refresh(S);
      Slider_GetMsg:=CMModified;
      End;
   End;

If S.ButtonsDef Then
   Begin                                {*Test buttons*}
   If Button_GetMsg(S.BSub,1)=CMSelected Then
      Begin                             {* SUB (Hz) or ADD (Vert) Button *}
      OldCursorC:=S.CursorC;
      If (S.Value>0) And (S.Orientation=COHorizontal) Then
         Begin Dec(S.Value); Slider_GetMsg:=CMModified; End;
      If S.Orientation=COVertical Then
         Begin
         If BTST(S.Id,3) Then Val:=-1 Else Val:=+1; {*Mode list*}
         S.Value:=S.Value+Val;
         If Check_RangesValue(S.Value,0,S.Quantity) Then Slider_GetMsg:=CMModified;
         End;
      Slider_ValueToPosition(S);
      If Not Coord_TestEqual(OldCursorC,S.CursorC) Then Slider_Refresh(S);
      End;
   If Button_GetMsg(S.BAdd,1)=CMSelected Then
      Begin                             {* ADD (Hz) or SUB (Vert) Button *}
      OldCursorC:=S.CursorC;
      If (S.Value<S.Quantity) And (S.Orientation=COHorizontal) Then
         Begin Inc(S.Value); Slider_GetMsg:=CMModified; End;
      If S.Orientation=COVertical Then
         Begin
         If BTST(S.Id,3) Then Val:=+1 Else Val:=-1; {*Mode list*}
         S.Value:=S.Value+Val;
         If Check_RangesValue(S.Value,0,S.Quantity) Then Slider_GetMsg:=CMModified;
         End;
      Slider_ValueToPosition(S);
      If Not Coord_TestEqual(OldCursorC,S.CursorC) Then Slider_Refresh(S);
      End;
   End;
End;

{}
{}
{}

{ͻ
                            PROCEDURE Play_Beep                             
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Play a beep and display a flash screen.                          
 ͼ}

Procedure Play_Beep;                     {*Comme Sur Amiga/Intuition*}
Begin
If Id_Err1 And $4<>$4 Then Begin         {*Make Sound... Beep_Modulo*}
   Sound(400); Delay(70); NoSound;
   End Else Delay(70);
If Id_Err1 And $4=$4 Then
   Play_SoundAction(10);                 {*Play Sampled Sound*}
End;

{ͻ
                          PROCEDURE DrawGad_Cycler                          
 ͹
  IN.....: X,Y (INTEGER) = Picture coordinates.                             
  OUT....: /                                                                
  EXPLAIN: Draw specialized picture at coordinates X,Y.                     
 ͼ}

Procedure DrawGad_CYCLER(X,Y:Integer);
Var O_X1,O_X2,O_X3,O_X4:Integer;          {*Optimisations*}
Begin
O_X1:=X+11; O_X2:=X+12; O_X3:=X+4; O_X4:=X+5;

VESA_SetColor(CLLineDown);
VESA_Line(O_X3,Y+2, O_X3,Y+10);VESA_Line(O_X4,Y+1, O_X4,Y+11); {*Ligne Gauche*}

VESA_Line(O_X3,Y+2, O_X2,Y+2); VESA_Line(O_X4,Y+1, O_X1,Y+1);  {*Ligne Haute*}
VESA_Line(O_X3,Y+10,O_X2,Y+10);VESA_Line(O_X4,Y+11,O_X1,Y+11); {*Ligne Basse*}

VESA_Line(O_X1,Y+9,O_X2,Y+9);VESA_Line(O_X1,Y+3,O_X2,Y+3);   {*Dessin Fleche*}
VESA_Line(X+9,Y+4,X+14,Y+4); VESA_Line(X+10,Y+5,X+13,Y+5);
VESA_Line(O_X1,Y+6,O_X2,Y+6);
End;

{ͻ
                        PROCEDURE DrawGad_LeftArrow                         
 ͹
  IN.....: X,Y (INTEGER) = Picture coordinates.                             
  OUT....: /                                                                
  EXPLAIN: Draw specialized picture at coordinates X,Y.                     
 ͼ}

Procedure DrawGad_LeftArrow(X,Y:Integer);
Begin
VESA_SetColor(CLLineDown);
Inc(X,2); Inc(Y,3);
VESA_Line(X+6,Y+0,X+7,Y+0);
VESA_Line(X+4,Y+1,X+7,Y+1);
VESA_Line(X+2,Y+2,X+7,Y+2);
VESA_Line(X+0,Y+3,X+7,Y+3);             {*Center line*}
VESA_Line(X+2,Y+4,X+7,Y+4);
VESA_Line(X+4,Y+5,X+7,Y+5);
VESA_Line(X+6,Y+6,X+7,Y+6);
End;

{ͻ
                        PROCEDURE DrawGad_RightArrow                        
 ͹
  IN.....: X,Y (INTEGER) = Picture coordinates.                             
  OUT....: /                                                                
  EXPLAIN: Draw specialized picture at coordinates X,Y.                     
 ͼ}

Procedure DrawGad_RightArrow(X,Y:Integer);
Begin
VESA_SetColor(CLLineDown);
Inc(X,2); Inc(Y,3);
VESA_Line(X,Y+0,X+1,Y+0);
VESA_Line(X,Y+1,X+3,Y+1);
VESA_Line(X,Y+2,X+5,Y+2);
VESA_Line(X,Y+3,X+7,Y+3);               {*Center line*}
VESA_Line(X,Y+4,X+5,Y+4);
VESA_Line(X,Y+5,X+3,Y+5);
VESA_Line(X,Y+6,X+1,Y+6);
End;

{ͻ
                         PROCEDURE DrawGad_UpArrow                          
 ͹
  IN.....: X,Y (INTEGER) = Picture coordinates.                             
  OUT....: /                                                                
  EXPLAIN: Draw specialized picture at coordinates X,Y.                     
 ͼ}

Procedure DrawGad_UpArrow(X,Y:Integer);
Begin
VESA_SetColor(CLLineDown);
Inc(X,2); Dec(Y,1);
VESA_Line(X+0,Y+9,X+0,Y+9);
VESA_Line(X+1,Y+8,X+1,Y+9);
VESA_Line(X+2,Y+7,X+2,Y+9);
VESA_Line(X+3,Y+6,X+3,Y+9);
VESA_Line(X+4,Y+5,X+4,Y+9);             {*Center line*}
VESA_Line(X+5,Y+6,X+5,Y+9);
VESA_Line(X+6,Y+7,X+6,Y+9);
VESA_Line(X+7,Y+8,X+7,Y+9);
VESA_Line(X+8,Y+9,X+8,Y+9);
End;

{ͻ
                        PROCEDURE DrawGad_DownArrow                         
 ͹
  IN.....: X,Y (INTEGER) = Picture coordinates.                             
  OUT....: /                                                                
  EXPLAIN: Draw specialized picture at coordinates X,Y.                     
 ͼ}

Procedure DrawGad_DownArrow(X,Y:Integer);
Begin
VESA_SetColor(CLLineDown);
Inc(X,2); Dec(Y,1);
VESA_Line(X+0,Y+5,X+0,Y+5);
VESA_Line(X+1,Y+5,X+1,Y+6);
VESA_Line(X+2,Y+5,X+2,Y+7);
VESA_Line(X+3,Y+5,X+3,Y+8);
VESA_Line(X+4,Y+5,X+4,Y+9);             {*Center line*}
VESA_Line(X+5,Y+5,X+5,Y+8);
VESA_Line(X+6,Y+5,X+6,Y+7);
VESA_Line(X+7,Y+5,X+7,Y+6);
VESA_Line(X+8,Y+5,X+8,Y+5);
End;

{ͻ
                          PROCEDURE DrawGad_Close                           
 ͹
  IN.....: X,Y (INTEGER) = Picture coordinates.                             
  OUT....: /                                                                
  EXPLAIN: Draw specialized picture at coordinates X,Y.                     
 ͼ}

Procedure DrawGad_Close(X,Y:Integer);
Begin
VESA_SetColor(CLLineDown);
VESA_Line(X+4,Y+7,X+14,Y+7);
VESA_Line(X+14,Y+6,X+14,Y+6);
VESA_SetColor(CLLineUp);
VESA_Line(X+4,Y+5,X+14,Y+5);

VESA_Line(X+4,Y+6,X+4,Y+6);
VESA_SetColor(CLBgButton);
VESA_Line(X+5,Y+6,X+13,Y+6);
End;

{ͻ
                           PROCEDURE DrawGad_Swap                           
 ͹
  IN.....: X,Y (INTEGER) = Picture coordinates.                             
  OUT....: /                                                                
  EXPLAIN: Draw specialized picture at coordinates X,Y.                     
 ͼ}

Procedure DrawGad_Swap(X,Y:Integer);
Begin

VESA_SetColor(CLLineDown);
VESA_Line(X+2,Y+3,X+12,Y+3);VESA_Line(X+2,Y+7,X+12,Y+7);
VESA_Line(X+2,Y+3,X+2,Y+7); VESA_Line(X+12,Y+3,X+12,Y+7);
Bevel (X+3,Y+4,X+11,Y+6, CLFlamand);
VESA_Line(X+5,Y+5,X+15,Y+5);VESA_Line(X+5,Y+9,X+15,Y+9);
VESA_Line(X+5,Y+5,X+5,Y+9); VESA_Line(X+15,Y+5,X+15,Y+9);
Bevel (X+6,Y+6,X+14,Y+8, CLLineUp);
End;

{ͻ
                          PROCEDURE DrawGad_Extend                          
 ͹
  IN.....: X,Y (INTEGER) = Picture coordinates.                             
  OUT....: /                                                                
  EXPLAIN: Draw specialized picture at coordinates X,Y.                     
 ͼ}

Procedure DrawGad_Extend(X,Y:Integer);
Var O_X1:Integer;                         {*Optimisations*}
Begin
O_X1:=X+2;
VESA_SetColor(CLLineDown);
VESA_Line(O_X1,Y+2,X+14,Y+2); VESA_Line(O_X1,Y+10,X+14,Y+10);
VESA_Line(O_X1,Y+2,O_X1,Y+10);VESA_Line(X+14,Y+2,X+14,Y+10);
Bevel (X+3,Y+3,X+13,Y+9, CLFlamand);
VESA_Line(O_X1,Y+6,X+9,Y+6);  VESA_Line(X+9,Y+3,X+9,Y+6);
Bevel(X+3,Y+3,X+8,Y+5, CLLineUp);
End;

{ͻ
                           PROCEDURE DrawGad_Size                           
 ͹
  IN.....: X,Y (INTEGER) = Picture coordinates.                             
  OUT....: /                                                                
  EXPLAIN: Draw specialized picture at coordinates X,Y.                     
 ͼ}

Procedure DrawGad_Size(X,Y:Integer);
Var O_X1:Integer;                         {*Optimisations*}
Begin
O_X1:=X+13;
VESA_SetColor(CLLineDown);
VESA_Line(X+4,Y+10,X+14,Y+10);VESA_Line(X+14,Y+1,X+14,Y+10);
VESA_Line(X+4,+Y+10,O_X1,Y+1);VESA_SetColor(CLFlamand);
VESA_Putpixel(O_X1,Y+2,3);
VESA_Line(X+12,Y+3,O_X1,Y+3); VESA_Line(X+11,Y+4,O_X1,Y+4);
VESA_Line(X+10,Y+5,O_X1,Y+5); VESA_Line(X+9,Y+6,O_X1,Y+6);
VESA_Line(X+8,Y+7,O_X1,Y+7);  VESA_Line(X+7,Y+8,O_X1,Y+8);

VESA_Line(X+6,Y+9,O_X1,Y+9);
End;

{ͻ
                        PROCEDURE DrawGad_AmigaOkBut                        
 ͹
  IN.....: X,Y (INTEGER) = Picture coordinates.                             
  OUT....: /                                                                
  EXPLAIN: Draw specialized picture at coordinates X,Y.                     
 ͼ}

Procedure DrawGad_AmigaOkBut(X,Y:Integer);
Begin
VESA_SetColor(CLLineDown);
VESA_Line(X+3,Y+8,X+5,Y+10); VESA_Line(X+3,Y+7,X+5,Y+9); VESA_Line(X+13,Y+3,X+15,Y+3);

VESA_Line(X+6,Y+10,X+12,Y+4);VESA_Line(X+6,Y+9,X+12,Y+3);
End;

{ͻ
                         PROCEDURE DrawGad_CheckOff                         
 ͹
  IN.....: X,Y (INTEGER) = Picture coordinates.                             
  OUT....: /                                                                
  EXPLAIN: Draw specialized picture at coordinates X,Y.                     
 ͼ}

Procedure DrawGad_CheckOff(X,Y:Integer);
Begin
Bevel (X+3,Y+2,X+16,Y+11, CLCursor);
VESA_SetColor(CLLineUp);VESA_Line(X+4,Y+1,X+15,Y+1);  VESA_Line(X+2,Y+3,X+2,Y+10);
VESA_SetColor(CLLineDown); VESA_Line(X+4,Y+12,X+15,Y+12);VESA_Line(X+17,Y+3,X+17,Y+10);
VESA_Putpixel(X+3,Y+11,CLLineUp);VESA_Putpixel(X+16,Y+11,0);
VESA_Putpixel(X+3,Y+2,CLLineUp); VESA_Putpixel(X+16,Y+2,0);
End;

{ͻ
                         PROCEDURE DrawGad_CheckOn                          
 ͹
  IN.....: X,Y (INTEGER) = Picture coordinates.                             
  OUT....: /                                                                
  EXPLAIN: Draw specialized picture at coordinates X,Y.                     
 ͼ}

Procedure DrawGad_CheckOn(X,Y:Integer);
Begin
Bevel (X+3,Y+2,X+16,Y+11, CLCursor);
VESA_SetColor(CLLineDown); VESA_Line(X+4,Y+1,X+15,Y+1); VESA_Line(X+2,Y+3,X+2,Y+10);
VESA_SetColor(CLLineUp);VESA_Line(X+4,Y+12,X+15,Y+12); VESA_Line(X+17,Y+3,X+17,Y+10);
VESA_Putpixel(X+3,Y+11,0);VESA_Putpixel(X+16,Y+11,CLLineUp);

VESA_Putpixel(X+3,Y+2,0); VESA_Putpixel(X+16,Y+2,CLLineUp);
Bevel (X+6,Y+3,X+13,Y+10, CLSky);
VESA_SetColor(CLSky); VESA_Line(X+5,Y+4,X+5,Y+9); VESA_Line(X+14,Y+4,X+14,Y+9);
End;

{ͻ
                           PROCEDURE DrawGad_Lens                           
 ͹
  IN.....: X,Y (INTEGER) = Picture coordinates.                             
  OUT....: /                                                                
  EXPLAIN: Draw specialized picture at coordinates X,Y.                     
 ͼ}

Procedure DrawGad_Lens(X,Y:Integer);
Begin
Bevel (X+1,Y+1,X+10,Y+5, CLLineUp);
VESA_SetColor(CLLineDown);
VESA_Line(X+3,Y,X+8,Y);     VESA_Line(X+3,Y+6,X+8,Y+6);
VESA_Line(X+1,Y+1,X+2,Y+1); VESA_Line(X+9,Y+1,X+10,Y+1);
VESA_Line(X+1,Y+5,X+2,Y+5); VESA_Line(X+9,Y+5,X+10,Y+5);
VESA_Line(X,Y+2,X,Y+4);     VESA_Line(X+11,Y+2,X+11,Y+4);
VESA_Line(X+10,Y+6,X+12,Y+6); VESA_Line(X+11,Y+7,X+13,Y+7);
VESA_Putpixel(X+3,Y+3,3);   VESA_Putpixel(X+4,Y+2,3); VESA_Putpixel(X+6,Y+2,3);
End;

{ͻ
                         PROCEDURE DrawGad_Question                         
 ͹
  IN.....: X,Y (INTEGER) = Picture coordinates.                             
  OUT....: /                                                                
  EXPLAIN: Draw specialized picture at coordinates X,Y.                     
 ͼ}

Procedure DrawGad_Question(X,Y:Integer);
Var O_X1:Integer;                         {*Optimisations*}
Begin
O_X1:=X+7;
VESA_SetColor(CLLineUp);
VESA_Line(X+3,Y,X+8,Y);
VESA_Line(X+1,Y+1,X+2,Y+1); VESA_Line(X+9,Y+1,X+10,Y+1);
VESA_Line(X+9,Y+2,X+10,Y+2);VESA_Line(X+8,Y+3,X+9,Y+3);
VESA_Line(O_X1,Y+4,X+8,Y+4);VESA_Line(X+6,Y+5,O_X1,Y+5); VESA_Line(X+6,Y+7,O_X1,Y+7);
VESA_SetColor(CLLineDown);
VESA_Line(X+4,Y+1,O_X1,Y+1);VESA_Line(X+10,Y+3,O_X1,Y+6);
VESA_Line(X+2,Y+2,X+3,Y+2); VESA_Line(O_X1,Y+8,X+8,Y+8);
End;

{ͻ
                           PROCEDURE DrawGad_File                           
 ͹
  IN.....: X,Y (INTEGER) = Picture coordinates.                             
  OUT....: /                                                                
  EXPLAIN: Draw specialized picture at coordinates X,Y.                     
 ͼ}

Procedure DrawGad_File(X,Y:Integer);
Begin
Bevel (X+1,Y+1,X+9,Y+6, CLLineUp);
Bevel (X+8,Y+2,X+12,Y+6,CLLineUp);
VESA_SetColor(CLLineDown); VESA_MoveTo(X,Y);
VESA_LineTo(X+8,Y); VESA_LineTo(X+8,Y+3); VESA_LineTo(X+13,Y+3);
VESA_LineTo(X+13,Y+7); VESA_LineTo(X,Y+7); VESA_LineTo(X,Y);
VESA_Line(X+9,Y,X+13,Y+2); VESA_Line(X+2,Y+3,X+6,Y+3); VESA_Line(X+2,Y+5,X+9,Y+5);
End;

{}
{}
{}

{ͻ
                       PROCEDURE ColorPalette_Define                        
 ͹
  IN.....: CP (TColorPalette) = Pointer to the component structure.         
           Px,Py (INTEGER) = Component X,Y position.                        
           CellX,CellY (INTEGER) = Cell sizeX and sizeY.                    
           InterCell (INTEGER) = Space between two cells in pixels.         
           Columns (INTEGER) = Number of columns to display ColorPalette.   
           FirstColor,LastColor (LONGINT) = First and last RGB colors to use
           Count (INTEGER) = Quantity of colors (1 to 256).                 
           PaletteFile (STRING) = Path and filename for the JASC-PAL palette
           Selected (INTEGER) = Current selected color index (1 to 256).    
           Border (WORD) = Border style for color cell.                     
                   0 = BLNoline                                             
                   1 = BLUniformLine                                        
                   2 = BLLoweredLine                                        
                   3 = BLRaisedLine                                         
           Id (WORD) = Bits definition :                                    
               Bit 0  $0001 : 1 = Sensitive mouse selection                 
               Bit 1  $0002 : 1 = Component Freezed                         
               Bit 2  $0004 : 1 = Unvisible Component                       
               Bit 3  $0008 : 1 = Toggle border                             
           MPointer (ShortString) = Mouse pointer file to use.              
  OUT....: /                                                                
  EXPLAIN: Define and draw a ColorPalette component.                        
  EXAMPLE: ColorPalette(10,50,70,12,13,0,-50,+50,5,1,$0040,Cp1);            
  SEEALSO: ColorPalette_Draw, ColorPalette_Freeze, ColorPalette_GetMsg      
 ͼ}

Procedure ColorPalette_Define(Var Cp:TColorPalette; Px,Py,CellX,CellY,InterCell,Columns:Integer; FirstColor,LastColor:Longint; Count:Integer; PaletteFile:String; Selected,BorderType:Integer; Id:Word; MPointer:ShortString);
Begin
Log.Add('Create new ColorPalette',2);
Cp.Px:=Px;                              {*Component position*}
Cp.Py:=Py;
Cp.FirstColor:=FirstColor;              {*Minimum and Maximum Colors Indices*}
Cp.LastColor:=LastColor;
Cp.CellX:=CellX;
Cp.CellY:=CellY;
Cp.InterCell:=InterCell;
Cp.QttColumns:=Columns;                 {*Number of columns*}
Cp.Border:=BorderType;
Cp.Line:=BLRaisedLine;
Cp.Id:=Id;
Cp.IdIn:=$0000;
Cp.Tag:=0;
Cp.PFile:=PaletteFile;                  {*JASC-PAL palette filename*}
Cp.Pointer:=MPointer;                   {*Mouse pointer to use*}

If Cp.PFile<>'' Then                    {*JASC-PAL Palette*}
   Begin
   Cp.Count:=0;
   End
Else
   Begin                                {*Colors shade*}
   Check_RangesValue(Count,1,Max_CPIndex);
   Cp.Count:=Count;
   Check_RangesValue(Selected,1,Cp.Count);
   End;

Cp.SelectedColor:=Selected;             {*Initial cell previously selected*}
Cp.Selected:=Selected;
End;

{ͻ
                           PROCEDURE ColorPalette                           
 ͹
  IN.....: CP (TColorPalette) = Pointer to the component structure.         
           Px,Py (INTEGER) = Component X,Y position.                        
           CellX,CellY (INTEGER) = Cell sizeX and sizeY.                    
           InterCell (INTEGER) = Space between two cells in pixels.         
           Columns (INTEGER) = Number of columns to display ColorPalette.   
           FirstColor,LastColor (LONGINT) = First and last RGB colors to use
           Count (INTEGER) = Quantity of colors (1 to 256).                 
           Selected (INTEGER) = Current selected color index.               
           Border (WORD) = Border style for color cell.                     
                   0 = BLNoline                                             
                   1 = BLUniformLine                                        
                   2 = BLLoweredLine                                        
                   3 = BLRaisedLine                                         
           Id (WORD) = Bits definition :                                    
               Bit 0  $0001 : 1 = Sensitive mouse selection                 
               Bit 1  $0002 : 1 = Component Freezed                         
               Bit 2  $0004 : 1 = Unvisible Component                       
               Bit 3  $0008 : 1 = Toggle border                             
           MPointer (ShortString) = Mouse pointer file to use.              
  OUT....: /                                                                
  EXPLAIN: Define and draw a ColorPalette component.                        
  EXAMPLE: ColorPalette(10,50,70,12,13,0,-50,+50,5,1,$0040,Cp1);            
  SEEALSO: ColorPalette_Draw, ColorPalette_Freeze, ColorPalette_GetMsg      
 ͼ}

Procedure ColorPalette(Var Cp:TColorPalette; Px,Py,CellX,CellY,InterCell,Columns:Integer; FirstColor,LastColor:Longint; Count,Selected,BorderType:Integer; Id:Word; MPointer:ShortString);
Begin
ColorPalette_Define(Cp,Px,Py,CellX,CellY,InterCell,Columns,FirstColor,LastColor,Count,'',Selected,BorderType,Id,MPointer);
ColorPalette_Draw(Cp);                  {*Draw ColorPalette*}
End;

{ͻ
                           PROCEDURE ColorPalette                           
 ͹
  IN.....: CP (TColorPalette) = Pointer to the component structure.         
           Px,Py (INTEGER) = Component X,Y position.                        
           CellX,CellY (INTEGER) = Cell sizeX and sizeY.                    
           InterCell (INTEGER) = Space between two cells in pixels.         
           Columns (INTEGER) = Number of columns to display ColorPalette.   
           PaletteFile (STRING) = Path and filename for the JASC-PAL palette
           Selected (INTEGER) = Current selected color index.               
           Border (WORD) = Border style for color cell.                     
                   0 = BLNoline                                             
                   1 = BLUniformLine                                        
                   2 = BLLoweredLine                                        
                   3 = BLRaisedLine                                         
           Id (WORD) = Bits definition :                                    
               Bit 0  $0001 : 1 = Component Freezed                         
               Bit 1  $0002 : 1 = Unvisible Component                       
           MPointer (ShortString) = Mouse pointer file to use.              
  OUT....: /                                                                
  EXPLAIN: Define and draw a ColorPalette component.                        
  EXAMPLE: ColorPalette(010,010,11,11,3,CLBlack,CLOrange,256,10,BLRaisedLine,$0000,MPAudio);
  SEEALSO: ColorPalette_Draw, ColorPalette_Freeze, ColorPalette_GetMsg      
 ͼ}

Procedure ColorPalette(Var Cp:TColorPalette; Px,Py,CellX,CellY,InterCell,Columns:Integer; PaletteFile:String; Selected,BorderType:Integer; Id:Word; MPointer:ShortString);{*Define ColorPalette file*}
Begin
ColorPalette_Define(Cp,Px,Py,CellX,CellY,InterCell,Columns,CLBlack,CLBlack,0,PaletteFile,Selected,BorderType,Id,MPointer);
ColorPalette_Draw(Cp);                  {*Draw ColorPalette*}
End;
{ͻ
                     PROCEDURE ColorPalette_GetXYCoord                      
 ͹
  IN.....: Cp (TColorPalette) = Pointer to the component structure.         
           Index (INTEGER) = The cell index.                                
  IN/OUT.: X,Y (INTEGER) = The cell coordinates.                            
  OUT....: (BOOLEAN) = TRUE if the cell XY coordinates are correct.         
  EXPLAIN: Return the cell coordinates in X,Y variables.                    
 ͼ}


Function ColorPalette_GetXYCoord(Cp:TColorPalette; Index:Integer; Var X,Y:Integer):Boolean;
Begin
If Not Check_RangesValue(Index,1,Max_CPIndex) Then
   Begin                                {*Check if index is in ranges*}
   ColorPalette_GetXYCoord:=No;
   Exit;
   End;
Dec(Index,1);
Y:=Index Div Cp.QttColumns;             {*Get X,Y position*}
X:=Index Mod Cp.QttColumns;
ColorPalette_GetXYCoord:=Yes;
End;

{ͻ
                 PROCEDURE ColorPalette_GetCellCoordinates                  
 ͹
  IN.....: CP (TColorPalette) = Pointer to the component structure.         
           Index (INTEGER) = The cell index.                                
           Mode (INTEGER) = 0 : Get the whole cell coordinates.             
                            1 : Get only the colored box cell coordinates.  
           C (TCoordinates) = Pointer to a coordinates structure.           
  OUT....: (BOOLEAN) = TRUE = Coordinates has been correctly calculated.    
  EXPLAIN: Return in the "C" structure the cell specified coordinates.      
  SEEALSO: ColorPalette, ColorPalette_Freeze, ColorPalette_GetMsg           
           ColorPalette_Draw                                                
 ͼ}

Function ColorPalette_GetCellCoordinates(CP:TColorPalette; Index,Mode:Integer; Var C:TCoordinates):Boolean;
Var X,Y:Integer;
    aX1,aY1,aX2,aY2:Integer;            {*Problme de transtypage*}

Begin
If Not Check_RangesValue(Index,1,Cp.Count) Then
   Begin                                {*Check if index is in ranges*}
   ColorPalette_GetCellCoordinates:=No;
   Exit;
   End;

ColorPalette_GetXYCoord(Cp,Index,X,Y);   {*Get XY coordinates*}

C.X1:=Cp.Px+Cp.InterCell+(Cp.InterCell+Cp.CellX)*X;  {*Build coordinates*}
C.Y1:=Cp.Py+Cp.InterCell+(Cp.InterCell+Cp.CellY)*Y;
C.X2:=C.X1+Cp.CellX-1;
C.Y2:=C.Y1+Cp.CellY-1;
If Mode=0 Then                          {*Get the whole cell box*}
   Begin
   Dec(C.X1,2); Dec(C.Y1,2);
   Inc(C.X2,2); Inc(C.Y2,2);
   End;

aX1:=C.X1; aY1:=C.Y1;                   {*Problme de transtypage*}
aX2:=C.X2; aY2:=C.Y2;
Coord_BoxCorrect(aX1,aY1,aX2,aY2);  {*Check box coordinates validity*}
//Coord_BoxCorrect(C.X1,C.Y1,C.X2,C.Y2);  {*Check box coordinates validity*}
C.X1:=aX1; C.Y1:=aY1;
C.X2:=aX2; C.Y2:=aY2;                   {*Problme de transtypage*}

ColorPalette_GetCellCoordinates:=Yes;
End;

{ͻ
                        PROCEDURE ColorPalette_Draw                         
 ͹
  IN.....: CP (TColorPalette) = Pointer to the gadget structure.            
  OUT....: /                                                                
  EXPLAIN: Draw a ColorPalette Gadget.                                      
  EXAMPLE: ColorPalette_Draw(Cp1);                                          
  SEEALSO: ColorPalette, ColorPalette_Freeze, ColorPalette_GetMsg           
 ͼ}

Procedure ColorPalette_Draw(Var CP:TColorPalette);

Var C:TCoordinates;
    Color:Longint;
    A:Integer;
    Line:Byte;                          {*Line type*}
    St:String;                          {*Temporary string for file reading*}
    Cr,Cg,Cb:Byte;                      {*RGB color components*}

    F1:Text;                            {*Text JASC-PAL file*}

Begin
Case Cp.Border of
   0 : Line:=BLNoLine;                  {*BLNoLine*}
   1 : Line:=BLUniformLine;             {*BLUniformLine*}
   2 : Line:=BLLoweredLine;             {*BLLoweredLine*}
   3 : Line:=BLRaisedLine;              {*BLRaisedLine*}
   End;

If Cp.PFile<>'' Then
   Begin                                {*Load palette from file...*}
   Assign(F1,Cp.PFile);
   {$I-}
   Reset(F1);
   {$I+}
   If IOResult<>0 Then Exit;            {*File access error !*}
   For A:=1 to 3 do Readln(F1,St);      {*Skip header*}
   A:=1;
   While (Not Eof(F1)) And (A<=Max_CPIndex) do
      Begin
      Readln(F1,St);                    {*Read line...*}
      If St<>'' Then
         Begin
         Inc(Cp.Count);                 {*One more cell*}
         Cr:=Str_S2L(Str_Get(St,1,' '));
         Cg:=Str_S2L(Str_Get(St,2,' '));
         Cb:=Str_S2L(Str_Get(St,3,' '));
         Color:=VESA_SetRGBColor(Cr,Cg,Cb);
         ColorPalette_GetCellCoordinates(Cp,A,1,C);
         If Not BTST(Cp.Id,1) Then Bevel (C.X1,C.Y1,C.X2,C.Y2, Color,Line,BLNoLine,Yes);
         End;
      Inc(A);                           {*Next line...*}
      End;
   Close(F1);
   Check_RangesValue(Cp.Selected,1,Cp.Count);
   End
Else
   Begin                                {*Build shade using two colors...*}
   For A:=1 to Cp.Count do
      Begin
      ColorPalette_GetCellCoordinates(Cp,A,1,C);
      Color:=Col_GetShadeColor(Cp.Count,A,Cp.FirstColor,Cp.LastColor);

      If Not BTST(Cp.Id,1) Then Bevel (C.X1,C.Y1,C.X2,C.Y2, Color,Line,BLNoLine,Yes);
      End;
   End;


If Cp.SelectedColor>0 Then              {*Display Selected Color*}
   Begin
   ColorPalette_ToggleCell(Cp,Cp.SelectedColor,Yes,BLRaisedLine);
   End;
End;

{ͻ
                       PROCEDURE ColorPalette_Freeze                        
 ͹
  IN.....: Status (BOOLEAN) = (On = Freeze component).                      
           CP (TColorPalette) = Pointer to the component structure.         
  OUT....: /                                                                
  EXPLAIN: Freeze or unfreeze a ColorPalette component.                     
  EXAMPLE: ColorPalette_Freeze(On,Cp1);                                     
  SEEALSO: ColorPalette, ColorPalette_Draw, ColorPalette_GetMsg             
 ͼ}

Procedure ColorPalette_Freeze(Var CP:TColorPalette; Status:Boolean);

Begin
If Status=Yes Then BSET(Cp.Id,0)
              Else BCLR(Cp.Id,0);
End;

{ͻ
                     PROCEDURE ColorPalette_ToggleCell                      
 ͹
  IN.....: CP (TColorPalette) = Pointer to the component structure.         
           Index (INTEGER) = The cell index.                                
           Display (BOOLEAN) = Display or hide the border cell.             
           Border (BYTE) = Border line style.                               
               0 = BLNoline                                                 
               1 = BLUniformLine                                            
               2 = BLLoweredLine                                            
               3 = BLRaisedLine                                             
  OUT....: /                                                                
  EXPLAIN: Toggle a box around the selected cell.                           
 ͼ}

Procedure ColorPalette_ToggleCell(Var Cp:TColorPalette; Index:Integer; Display:Boolean; Border:Byte);
Var C             :TCoordinates;
Begin
If BTST(Cp.Id,2) Then Exit;             {*Do not display selection boxes*}
ColorPalette_GetCellCoordinates(Cp,Index,0,C);

If Display Then                         {*Display toggled box*}
   Bevel (C.X1,C.Y1,C.X2,C.Y2, CLBlack,Border,BLNoLine,No)
Else
   Begin                                {*Hide box*}
   Mse_Hide;
   VESA_SetColor(CLWinBg);
   VESA_Rectangle(C.X1,C.Y1,C.X2,C.Y2);
   Mse_Show;
   End;
End;

{ͻ
                     FUNCTION ColorPalette_GetSelected                      
 ͹
  IN.....: CP (TColorPalette) = Pointer to the component structure.         
  OUT....: (LONGINT) = Selected RGB color value.                            
  EXPLAIN: Return the selected RGB color from a ColorPalette component.     
  SEEALSO: ColorPalette_GetMsg                                              
 ͼ}

Function ColorPalette_GetSelected(CP:TColorPalette):Longint;
Var St:String;
    Cr,Cg,Cb:Byte;
Begin

If Cp.PFile='' Then ColorPalette_GetSelected:=Col_GetShadeColor (Cp.Count,Cp.SelectedColor,Cp.FirstColor,Cp.LastColor)
   Else
   Begin                                {*Read color from file*}
   St:=File_GetLine(Cp.PFile,Cp.SelectedColor+3);
   Cr:=Str_S2L(Str_Get(St,1,' '));
   Cg:=Str_S2L(Str_Get(St,2,' '));
   Cb:=Str_S2L(Str_Get(St,3,' '));
   ColorPalette_GetSelected:=VESA_SetRGBColor(Cr,Cg,Cb);
   End;
End;

{ͻ
                        FUNCTION ColorPalette_GetMsg                        
 ͹
  IN.....: CP (TColorPalette) = Pointer to the component structure.         

  OUT....: (BYTE) = Message Id as:                                          
               CMNone               No messages                             
               CMSelected           Color cell selected                     
               CMMouseOver          Mouse is over the list                  
  EXPLAIN: Manage a ColorPalette component.                                 
           Use the "ColorPalette_GetSelected" to get the RGB value of       
           the selected color.                                              
  EXAMPLE: If ColorPalette_GetMsg(Cp1)=CMSelected Then...                   
  SEEALSO: ColorPalette, ColorPalette_Draw, ColorPalette_GetSelected        
 ͼ}

Function ColorPalette_GetMsg(Var CP:TColorPalette):Byte;
Var Zone:TMouseZone;
    C:TCoordinates;
    Index:Integer;
    CellSelected:Boolean;               {*Mouse is on cell*}
    Redraw:Boolean;                     {*Need to draw the selected box*}
    FunctionResult:Byte;
    Selected:Boolean;                   {*To check how to select cell*}

Begin
FunctionResult:=CMNone;                 {*De base, pas de messages*}

If BTST(Cp.Id,1) Then Exit;             {*Freezed Gadget*}
If Sys.LightBoxMinSized Then Exit;      {*Light Box en-train d'tre trace => Exit*}
If BTST(Id_Msg1,2) Then Exit;           {*Un Slider Dplac quelque part => Exit*}
If BTST(Id_Gad1,14) Then Exit;          {*Un Canvas Dplac quelque part => Exit*}


CellSelected:=No;                       {*Init no cell selected*}
Redraw:=No;

For Index:=1 to Cp.Count do             {*Do all the cells*}
   Begin
   ColorPalette_GetCellCoordinates(Cp,Index,0,C);
   Inc(C.X1); Inc(C.Y1);
   Zone.Value:=Cp.Pointer;              {*Hand pointer*}
   Zone.C:=C;
   Zone.MBAction:=MBIgnore;
   If (MseZone_GetMsg(Zone)=CMSelected) And (Not CellSelected) Then
      Begin                             {*Manage mouse zone and pointer*}
      CellSelected:=Yes;                {*A cell has been selected*}
      If (Mse_Clicked(MBLeft)) And (Cp.Line=BLRaisedLine) Then Begin Redraw:=Yes; End;
      If (Not Mse_Clicked(MBLeft)) And (Cp.Line=BLLoweredLine) Then Begin Redraw:=Yes; End;
      If Index<>Cp.Selected Then Redraw:=Yes;
      If Redraw Then                    {*Need to redraw the box*}
         Begin
         Redraw:=No;
         BCLR(Cp.IdIn,0);               {*Can hide selected cell box*}
         Selected:=No;
         If (Not Mse_Clicked(MBLeft)) And (Cp.Selected<>0) And (Cp.Line=BLLoweredLine) Then Selected:=Yes;
         If (BTST(Cp.Id,3)) And (Mse_Clicked(MBLeft)) And (Cp.Selected<>0) And (Cp.SelectedColor<>Index) Then Selected:=Yes;
         If Selected Then
            Begin                       {*Cell selected !*}
            ColorPalette_ToggleCell(Cp,Cp.SelectedColor,No,Cp.Line);
            Cp.SelectedColor:=Cp.Selected;
            FunctionResult:=CMSelected;
            End;
         If Mse_Clicked(MBLeft) Then Cp.Line:=BLLoweredLine Else Cp.Line:=BLRaisedLine;
         If Cp.Selected<>0 Then ColorPalette_ToggleCell(Cp,Cp.Selected,No,Cp.Line);
         Cp.Selected:=Index;
         ColorPalette_ToggleCell(Cp,Cp.Selected,Yes,Cp.Line);
         If Cp.SelectedColor<>Index Then ColorPalette_ToggleCell(Cp,Cp.SelectedColor,Yes,BLRaisedLine); {*Display selected color*}
         End;
      End;
   End;

If (Not CellSelected) And (Not BTST(Cp.IdIn,0)) Then
   Begin                                {*No cell has been selected*}
   ColorPalette_ToggleCell(Cp,Cp.Selected,No,BLRaisedLine);
   ColorPalette_ToggleCell(Cp,Cp.SelectedColor,Yes,BLRaisedLine);
   Cp.Selected:=0;
   BSET(Cp.IdIn,0);                     {*Last selected cell box has been hidden*}
   End;

If (CellSelected) And (FunctionResult=CMNone) Then FunctionResult:=CMMouseOver;

ColorPalette_GetMsg:=FunctionResult;    {*Return result*}
End;

{}
{}
{}

{ͻ
                           PROCEDURE InputSlider                            
 ͹
  IN.....: X1,Y1 (INTEGER) = Gadget coordinates.                            
           Sx (INTEGER) = Width of the gadget.                              
           Col1,Col2 (LONGINT) = Colors for the Gadget.                     
           Style (LONGINT) = Gadget Style like InputText Gadget.            
           Min,Max (LONGINT) = Available number array.                      
           Step (LONGINT) = Step to add or dec value in array.              
           Value (LONGINT) = Initial value to modify.                       
           Id (WORD) = Bits definition :                                    
               Bit 0  $0001 : 1 = Gadget Activated                          
               Bit 1  $0002 : 1 = Gadget Freezed                            
               Bit 2  $0004 : 1 = Unvisible Gadget                          
           ISl (TInputSlider) = Pointer to the gadget structure.            
  OUT....: /                                                                
  EXPLAIN: Define and draw an InputSlider Gadget.                           
  EXAMPLE: InputSlider(10,50,70,12,13,0,-50,+50,5,Value,$01,Isl1);          
  SEEALSO: InputSlider_Draw, InputSlider_Freeze, InputSlider_GetMsg         
 ͼ}

Procedure InputSlider_SetId(Var ISl:TInputSlider);
Begin                                   {*Define Correct Bits for Gadgets*}
ISl.Com.Id:=$0126; ISl.But1.Id:=$00E0; ISl.But1.Id:=$00E0;
If BTST(ISl.Id,0) Then BSET(ISl.Com.Id,0);
If BTST(ISl.Id,1) Then Begin BSET(ISl.Com.Id,9); BSET(ISl.But1.Id,1); BSET(ISl.But2.Id,1); End;
If BTST(ISl.Id,2) Then Begin BSET(ISl.Com.Id,11);BSET(ISl.But1.Id,2); BSET(ISl.But2.Id,2); End;
End;

Procedure InputSlider(X1,Y1,Sx:Integer; Col1,Col2,Style:Longint; Min,Max,Step:Longint;
                      Var Value:Longint; Id:Word; Var ISl:TInputSlider);
Var SCin        :String;

Begin
Log.Add('Create new InputSlider',2);

Dec(Sx,1);
Str(Value,SCin);                        {*Store Values in Struct*}
ISl.X1:=X1;
ISl.Y1:=Y1;

ISl.Sx:=Sx;
ISl.Col1:=Col1;
ISl.Col2:=Col2;
ISl.Style:=Style;

ISl.Min:=Min;
ISl.Max:=Max;
ISl.Step:=Step;
ISl.Id:=Id;

InputSlider_SetId(ISl);                 {*Set Bits for Freeze / UnFreeze*}

InputText(X1,Y1,Sx,30,Col1,Col2,Style,ISl.Com.Id,ISl.Com,SCin);
Button (X1+Sx+1,Y1,  10,7, CLTextButton,CLBgButton,ISl.But1.Id,ISl.But1,'+',MPArrow,Language.Loc(162));
Button (X1+Sx+1,Y1+8,10,6, CLTextButton,CLBgButton,ISl.But1.Id,ISl.But2,'-',MPArrow,Language.Loc(163));
End;

{ͻ
                         PROCEDURE InputSlider_Draw                         
 ͹
  IN.....: Isl1 (TInputSlider) = Pointer to the InputSlider structure.      
  OUT....: /                                                                
  EXPLAIN: Draw the InputSlider Gadget.                                     
  EXAMPLE: InputSlider_Draw(Isl1);                                          
  SEEALSO: InputSlider, InputSlider_Freeze, InputSlider_GetMsg              
 ͼ}

Procedure InputSlider_Draw(Var ISl:TInputSlider);
Begin
Button_Draw(ISl.But1);
Button_Draw(ISl.But2);
InputText_Draw(ISl.Com);
End;

{ͻ
                        PROCEDURE InputSlider_Freeze                        
 ͹
  IN.....: Isl1 (TInputSlider) = Pointer to the InputSlider structure.      
           Status (BOOLEAN) = TRUE: Freeze component.                       
  OUT....: /                                                                
  EXPLAIN: Freeze or Unfreeze the InputSlider Gadget.                       
  EXAMPLE: InputSlider_Freeze(On,Isl1);                                     
  SEEALSO: InputSlider, InputSlider_Draw, InputSlider_GetMsg                
 ͼ}

Procedure InputSlider_Freeze(Status:Boolean; Var ISl:TInputSlider);
Begin
If Status Then BSET(ISl.Id,1) Else BCLR(ISl.Id,1);
InputSlider_SetId(ISl);                 {*Set Bits for Freeze / UnFreeze*}
InputSlider_Draw(ISl);
End;

{ͻ
                        FUNCTION InputSlider_GetMsg                         
 ͹
  IN.....: ISl (TInputSlider) = Pointer to the gadget structure.            
  OUT....: VCin (LONGINT) = Get modified value.                             
           (BYTE) = Message Id as:                                          
               CMNone               No messages                             
               CMModified           Value has been modified                 
  EXPLAIN: Manage an InputSlider Gadget.                                    
  EXAMPLE: If InputSlider_GetMsg(Isl1,VCin))=CMModified Then ;              
  SEEALSO: InputSlider_Draw, InputSlider_Freeze, InputSlider                
 ͼ}

Function InputSlider_GetMsg(Var ISl:TInputSlider; Var VCin:Longint):Byte;
Var Message1,Message2,Message3:Byte;
    Value,NewValue:Longint;
    Code:Word;

Begin
InputSlider_GetMsg:=CMNone;
If BTST(ISl.Id,1) Then Exit;            {*Freezed Gadget*}

Message1:=Button_GetMsg(ISl.But1,1);    {*Test des Gadgets...*}
Message2:=Button_GetMsg(ISl.But2,1);
Message3:=InputText_GetMsg(ISl.Com,ISl.Com.Cin);

Val(ISl.Com.Cin,Value,Code);            {*Get Current Value*}
NewValue:=Value;
If Message1=CMSelected Then Inc(NewValue,ISl.Step);
If Message2=CMSelected Then Dec(NewValue,ISl.Step); {*Test Maximum and Minimum*}
If NewValue>ISl.Max Then NewValue:=ISl.Max;
If NewValue<ISl.Min Then NewValue:=ISl.Min;
Str(NewValue,ISl.Com.Cin);

If (Message1=CMSelected) Or (Message2=CMSelected) Or (Message3=CMModified) Then
   Begin                                {*Send result...*}
   VCin:=NewValue;                      {*Raffiche le Gadget*}
   If NewValue<>Value Then InputSlider_Draw(ISl);
   InputSlider_GetMsg:=CMModified;
   End;
End;

{}
{}
{}

{ͻ
                              PROCEDURE Canvas                              
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Canvas coordinates.                      
           SizeTaq (INTEGER) = Half size of a Taquet (In pixels).           
           Color (WORD) = Pen color for the Canvas.                         
           Id (WORD) = Bits definition :                                    
               Bit 0  $0001 : 1 = Enable Move Canvas                        
               Bit 1  $0002 : 1 = Canvas Freezed                            
               Bit 2  $0004 : 1 = Unvisible Canvas                          
               Bit 3  $0008 : 1 = Draw Canvas box                           
               Bit 4  $0010 : 1 = Hand pointer on Taquets                   
               Bit 5  $0020 : 1 = Enable Resize Canvas                      
               Bit 6  $0040 : 1 = Inverse Canvas Allowed                    
               Bit 7  $0080 : * 1 = Polygon Mode                            
               Bit 8  $0100 : * 1 = Proportional canvas size                
           IdTaq (WORD) = Enable Taquets :                                  
               Number  Hexa   Localisation                                  
               Bit 0  $0001 : 1 = Top and Left                              
               Bit 1  $0002 : 1 = Top and Center                            
               Bit 2  $0004 : 1 = Top and Right                             
               Bit 3  $0008 : 1 = Right and Center                          
               Bit 4  $0010 : 1 = Bottom and Right                          
               Bit 5  $0020 : 1 = Bottom and Center                         
               Bit 6  $0040 : 1 = Bottom and Left                           
               Bit 7  $0080 : 1 = Left and Center                           
             Use the following Id values to define :                        
               -> Only the corners = $55                                    
               -> Only the centers = $AA                                    
               -> All the Taquets  = $FF                                    
           MouseBut (WORD) = Mouse button to test Canvas.                   
           Can1 (TCanvas) = Pointer to the Canvas structure.                
  OUT....: /                                                                
  EXPLAIN: Define and draw a Canvas Gadget.                                 
  EXAMPLE: Canvas(10,50,80,70,3,$FF,$10,Can1);                              
  SEEALSO: Canvas_Draw, Canvas_Freeze, Canvas_GetMsg                        
 ͼ}

Procedure Canvas(X1,Y1,X2,Y2,SizeTaq:Integer; Color:LongInt;IdTaq,Id,MouseBut:Word; Var C:TCanvas); {*Define Canvas*}
Begin
Log.Add('Create new Canvas',2);

If BTST(Id_Scr1,3) Then Begin           {*Window Clipped*}
   X1:=X1+T_Clip.X1-1;Y1:=Y1+T_Clip.Y1-6;{*Restore True Coordonnes*}
   X2:=X2+T_Clip.X1-1;Y2:=Y2+T_Clip.Y1-6;
   End;

C.X[1]:=X1; C.Y[1]:=Y1;                 {*Set Canvas Coordinates*}
C.X[3]:=X2; C.Y[3]:=Y1;
C.X[5]:=X2; C.Y[5]:=Y2;
C.X[7]:=X1; C.Y[7]:=Y2;
Canvas_CalculePosTaquets(C);            {*Calcule Taquets Intermdaires*}

C.MouseBut:=MouseBut;
C.Color:=Color XOR CLLightGrey;         {*Define XOR Color as Base Color*}
C.SizeTaq:=SizeTaq;
C.Status_Size:=FALSE;                   {*Init Actions on Canvas*}
C.Status_Move:=FALSE;
C.Id:=Id;                               {*Bits selection for Canvas*}
C.IdIn:=0;
C.IdTaq:=IdTaq;                         {*Bits to Set Taquets (0..8)*}

Canvas_Draw(C);                         {*Draw Canvas*}
End;


{ͻ
                           PROCEDURE Canvas_Draw                            
 ͹
  IN.....: Can1 (TCanvas) = Pointer to the Canvas structure.                
  OUT....: /                                                                
  EXPLAIN: Draw the Canvas Gadget.                                          
  EXAMPLE: Canvas_Draw(Can1);                                               
  SEEALSO: Canvas, Canvas_Freeze, Canvas_GetMsg                             
 ͼ}

Procedure Canvas_Draw(Var C:TCanvas);   {*Draw Canvas*}
Var A:Integer;                          {*Loop*}
    Xa,Ya,Xb,Yb:Integer;
    Xu,Yu,Xv,Yv:Integer;
    Coo:TCoordinates;
    FName:String;

Procedure Draw_CanvasTaquet(X1,Y1,Num:Integer);
Begin                                   {*Draw Canvas Taquet*}
If BTST(Id_Scr1,3) Then Begin           {*Window Clipped*}
   Xa:=X1-T_Clip.X1; Ya:=Y1-T_Clip.Y1;
   End Else Begin                       {*No Modifs...*}
   Xa:=X1; Ya:=Y1;
   End;

Xu:=Xa-C.SizeTaq; Yu:=Ya-C.SizeTaq; Xv:=Xa+C.SizeTaq; Yv:=Ya+C.SizeTaq;
Coo.X1:=Xu; Coo.Y1:=Yu; Coo.X2:=Xv; Coo.Y2:=Yv;
Case Num of
   1: FName:='SIZELUDR';                {*Pointers types*}
   2: FName:='SIZEUD';
   3: FName:='SIZERUDL';
   4: FName:='SIZELR';
   5: FName:='SIZELUDR';
   6: FName:='SIZEUD';
   7: FName:='SIZERUDL';
   8: FName:='SIZELR';
   End;
MseZone(C.Pointer[Num],Coo,10,FName,'');{*Define mouse pointer*}
Bevel (Xu+1,Yu+6,Xv+1,Yv+6, C.Color);
End;

{******************************** Main Code *********************************}

Begin
If BTST(C.Id,2) Then Exit;              {*Unvisible Canvas*}

If BTST(Id_Scr1,3) Then Begin           {*Window Clipped*}

   Xa:=C.X[1]-T_Clip.X1; Ya:=C.Y[1]-T_Clip.Y1;
   Xb:=C.X[5]-T_Clip.X1; Yb:=C.Y[5]-T_Clip.Y1;
   End Else Begin                       {*No Modifs...*}
   Xa:=C.X[1]; Ya:=C.Y[1]; Xb:=C.X[5]; Yb:=C.Y[5];

   End;

Mse_Hide;                               {*Hide Mouse*}

VESA_SetWriteMode(XORPut);
VESA_SetColor(C.Color);                 {*Draw Canvas Rectangle*}
If BTST(C.Id,3) Then VESA_Rectangle(Xa,Ya,Xb,Yb);
VESA_SetFillStyle(1,C.Color);
                                        {*Call the Draw Canvas Taquet Procdure*}
If BTST(C.Id,5) Then                    {*Autorize Resizage du Canvas*}
   For A:=1 to MaxTaquets do
      If BTST(C.IdTaq,A-1) Then Draw_CanvasTaquet(C.X[A],C.Y[A],A);

Mse_Show;
VESA_SetWriteMode(NormalPut);           {*Restore Normal Draw*}

If BTST(C.Id,1) Then Canvas_Freeze(Yes,C);{*Freezed Canvas*}
End;

{ͻ
                          PROCEDURE Canvas_Freeze                           
 ͹
  IN.....: Status (Boolean) = On = Freeze the Canvas.                       
           Can1 (TCanvas) = Pointer to the Canvas structure.                
  OUT....: /                                                                
  EXPLAIN: Freeze or Unfreeze the Canvas Gadget.                            
  EXAMPLE: Canvas_Freeze(Can1);                                             
  SEEALSO: Canvas, Canvas_Draw, Canvas_GetMsg                               
 ͼ}

Procedure Canvas_Freeze(Status:Boolean; Var C:TCanvas); {*Freeze Canvas*}
Begin

If Status=Yes Then BSET(C.Id,1)
              Else BCLR(C.Id,1);
End;

{ͻ
                           FUNCTION Canvas_GetMsg                           
 ͹
  IN.....: Can1 (TCanvas) = Pointer to the Canvas structure.                
  OUT....: (BOOLEAN) = TRUE = Canvas Activated.                             
  EXPLAIN: Return if the Canvas Gadget is activated.                        
  EXAMPLE: If Canvas_GetMsg(Can1) Then...                                   
  SEEALSO: Canvas, Canvas_Draw, Canvas_Freeze                               
 ͼ}

Function Canvas_GetMsg(Var C:TCanvas):Boolean;
Var X,Y           :Word;                {*Test mouse...*}
    Ga,Mi,Dr      :Boolean;
    A             :Integer;             {*Loop*}
    DeltaX,DeltaY :Integer;             {*Mouse Delta X,Y*}
    Cx1,Cy1,Cx2,Cy2,Rab:Integer;        {*Canvas limit*}

Begin
Canvas_GetMsg:=FALSE;                   {*De base, pas de message...*}

If (BTST(Id_Gad1,14)) And (Not BTST(C.IdIn,1)) Then Exit;  {*Another Canvas Activated*}
If BTST(C.Id,1) Then Exit;              {*Canvas Freezed*}
If Sys.LightBoxMinSized Then Exit;      {*Light Box en-train d'tre trace => Exit*}
If BTST(Id_Msg1,2) Then Exit;           {*Un Slider Dplac quelque part => Exit*}
If Sys.WinMoved Then Exit;
If Sys.WinSized Then Exit;

Mse_Get(X,Y,Ga,Mi,Dr);                  {*Test pour Bouton Enfonc*}

If BTST(C.Id,5) Then                    {*Autorize Resizage du Canvas*}
   Begin
   For A:=1 to MaxTaquets do MseZone_GetMsg(C.Pointer[A]); {*Mouse pointers management*}

   If (Not C.Status_Size) And (Not C.Status_Move) Then {*Pas d'actions entreprise*}
      Begin
      C.OnTaquet:=0;                    {*Init de Base...*}
      For A:=1 to MaxTaquets do
         If BTST(C.IdTaq,A-1) Then      {*Test pour chaque Taquet...*}
            If Mse_TestBox(C.X[A]-C.SizeTaq, C.Y[A]-C.SizeTaq, C.X[A]+C.SizeTaq, C.Y[A]+C.SizeTaq, 10)
               Then C.OnTaquet:=A;      {*On est sur un Taquet*}

      If C.OnTaquet>0 Then
         If BTST(C.Id,4) Then           {*Mouse Pointer on Canvas ?*}
            Begin BSET(Id_Gad1,5); BSET(C.IdIn,0); End
         Else Begin End
      Else If (BTST(C.Id,4)) And (BTST(C.IdIn,0)) Then
         Begin BCLR(Id_Gad1,5); BCLR(C.IdIn,0); End;
      End;                              {*Fin de "On ne tient pas un Taquet"*}

   If C.OnTaquet>0 Then
      If (Mse_Clicked(C.MouseBut)) And (Not C.Status_Size) Then
         Begin                          {*Premier click sur le Taquet*}
         C.Status_Size:=TRUE;
         BSET(Id_Gad1,14);
         BSET(C.IdIn,1);
         C.Mx:=X; C.My:=Y;
         C.OldX:=X; C.OldY:=Y;
         End;

   If (Not Mse_Clicked(C.MouseBut)) And (C.Status_Size) Then
      Begin                             {*On lche le Taquet*}
      If Not BTST(C.Id,6) Then Mse_SetLimit(0,0,VESA_GetMaxX,VESA_GetMaxY);
      C.Status_Size:=FALSE;
      Canvas_GetMsg:=TRUE;              {*Renvois message Canvas modified...*}

      BCLR(Id_Gad1,14);
      BCLR(C.IdIn,1);
      Canvas_Draw(C);
      Coord_BoxCorrect (C.X[1], C.Y[1], C.X[3], C.Y[3]);{*Cohrence Box...*}
      Coord_BoxCorrect (C.X[7], C.Y[7], C.X[5], C.Y[5]);
      Coord_BoxCorrect (C.X[1], C.Y[1], C.X[7], C.Y[7]);
      Coord_BoxCorrect (C.X[3], C.Y[3], C.X[5], C.Y[5]);
      Canvas_CalculePosTaquets(C);      {*Recalcule Taquets Intermdaires*}
      Canvas_Draw(C);
      End;

   If C.Status_Size Then                {*Move les Taquets...*}
      Begin
      If (X<>C.OldX) Or (Y<>C.OldY) Then
         Begin
         Canvas_Draw(C);                {*Efface le Canvas Actuel*}
         DeltaX:=X-C.OldX; DeltaY:=Y-C.OldY;
         Rab:=C.SizeTaq*5;
                                        {*Taille X,Y Minimum...*}
         Case C.OnTaquet of
            1: Begin Inc(C.X[1],DeltaX);{*Haut  Gauche*}
                     Inc(C.Y[1],DeltaY);
                     Inc(C.Y[2],DeltaY);
                     Inc(C.Y[3],DeltaY);
                     Inc(C.X[7],DeltaX);
                     Inc(C.X[8],DeltaX);
                     Cx1:=0;          Cy1:=0;
                     Cx2:=C.X[5]-Rab; Cy2:=C.Y[5]-Rab;
               End;
            2: Begin C.Y[1]:=C.Y[1]+DeltaY;{*Haut au Centre*}
                     C.Y[2]:=C.Y[2]+DeltaY;
                     C.Y[3]:=C.Y[3]+DeltaY;
                     Cx1:=0;            Cy1:=0;
                     Cx2:=VESA_GetMaxX; Cy2:=C.Y[5]-Rab;
               End;
            3: Begin C.X[3]:=C.X[3]+DeltaX;{*Haut  Droite*}
                     C.Y[3]:=C.Y[3]+DeltaY;
                     C.Y[1]:=C.Y[1]+DeltaY;
                     C.Y[2]:=C.Y[2]+DeltaY;
                     C.X[4]:=C.X[4]+DeltaX;
                     C.X[5]:=C.X[5]+DeltaX;
                     Cx1:=C.X[7]+Rab;   Cy1:=0;
                     Cx2:=VESA_GetMaxX; Cy2:=C.Y[7]-Rab;
               End;
            4: Begin C.X[3]:=C.X[3]+DeltaX;{*Droite au Centre*}
                     C.X[4]:=C.X[4]+DeltaX;
                     C.X[5]:=C.X[5]+DeltaX;
                     Cx1:=C.X[1]+Rab;   Cy1:=0;
                     Cx2:=VESA_GetMaxX; Cy2:=VESA_GetMaxY;
               End;
            5: Begin C.X[5]:=C.X[5]+DeltaX;{*Bas  Droite*}
                     C.Y[5]:=C.Y[5]+DeltaY;
                     C.X[3]:=C.X[3]+DeltaX;
                     C.X[4]:=C.X[4]+DeltaX;
                     C.Y[6]:=C.Y[6]+DeltaY;

                     C.Y[7]:=C.Y[7]+DeltaY;
                     Cx1:=C.X[1]+Rab;   Cy1:=C.Y[1]+Rab;
                     Cx2:=VESA_GetMaxX; Cy2:=VESA_GetMaxY;
               End;
            6: Begin C.Y[5]:=C.Y[5]+DeltaY;{*Bas au Centre*}
                     C.Y[6]:=C.Y[6]+DeltaY;
                     C.Y[7]:=C.Y[7]+DeltaY;
                     Cx1:=0;            Cy1:=C.Y[1]+Rab;
                     Cx2:=VESA_GetMaxX; Cy2:=VESA_GetMaxY;
               End;
            7: Begin C.X[7]:=C.X[7]+DeltaX;{*Bas  Gauche*}
                     C.Y[7]:=C.Y[7]+DeltaY;
                     C.X[8]:=C.X[8]+DeltaX;
                     C.X[1]:=C.X[1]+DeltaX;
                     C.Y[5]:=C.Y[5]+DeltaY;
                     C.Y[6]:=C.Y[6]+DeltaY;
                     Cx1:=0;          Cy1:=C.Y[3]+Rab;
                     Cx2:=C.X[3]-Rab; Cy2:=VESA_GetMaxY;
               End;
            8: Begin C.X[1]:=C.X[1]+DeltaX;{*Gauche au Centre*}
                     C.X[7]:=C.X[7]+DeltaX;
                     C.X[8]:=C.X[8]+DeltaX;
                     Cx1:=0;          Cy1:=0;
                     Cx2:=C.X[3]-Rab; Cy2:=VESA_GetMaxY;
               End;
            End;
                                        {*Limit mouse to Minimum*}
         If Not BTST(C.Id,6) Then Mse_SetLimit(Cx1,Cy1,Cx2,Cy2);
         Canvas_CalculePosTaquets(C);   {*Calcule Taquets Intermdaires*}

         Canvas_Draw(C);                {*Raffiche le Canvas*}
         C.OldX:=X; C.OldY:=Y;          {*Store Previous Mouse Position*}
         End;
      End;                              {*Fin de "Move les Taquets"*}
   End;                                 {*Fin de "Autorize Resizage"*}

If BTST(C.Id,0) Then                    {*Autorize Canvas Move*}
   Begin
   If Mse_TestBox(C.X[1], C.Y[1], C.X[5], C.Y[5], 10) Then
      Begin
      If (Mse_Clicked(C.MouseBut)) And (Not C.Status_Move) And (Not C.Status_Size) Then
         Begin                          {*Premier Click pour dplacer le Canvas*}
         C.Status_Move:=TRUE;
         C.Mx:=X; C.My:=Y;
         C.OldX:=X; C.OldY:=Y;
         BSET(Id_Gad1,14);
         BSET(C.IdIn,1);
         End;
      End;

   If (Not Mse_Clicked(C.MouseBut)) And (C.Status_Move) Then
      Begin                             {*On lche le Canvas*}
      C.Status_Move:=FALSE;
      Canvas_GetMsg:=TRUE;              {*Renvois message Canvas modified...*}
      BCLR(Id_Gad1,14);
      BCLR(C.IdIn,1);
      End;

   If (Mse_Clicked(C.MouseBut)) And (C.Status_Move) Then
      If (X<>C.OldX) Or (Y<>C.OldY) Then
         Begin
         Canvas_Draw(C);                {*Efface le Canvas Actuel*}
         DeltaX:=X-C.OldX; DeltaY:=Y-C.OldY;

         Inc(C.X[1],DeltaX); Inc(C.Y[1],DeltaY);
         Inc(C.X[3],DeltaX); Inc(C.Y[3],DeltaY);
         Inc(C.X[5],DeltaX); Inc(C.Y[5],DeltaY);
         Inc(C.X[7],DeltaX); Inc(C.Y[7],DeltaY);

         Canvas_CalculePosTaquets(C);   {*Calcule Taquets Intermdaires*}
         Canvas_Draw(C);                {*Raffiche le Canvas*}
         C.OldX:=X; C.OldY:=Y;          {*Store Previous Mouse Position*}
         End;
   End;

{gotoxy(1,1); writeln(C.OnTaquet,' ');
gotoxy(1,1); writeln(C.Status,' ');}
End;

{ͻ
                     PROCEDURE Canvas_CalculePosTaquets                     
 ͹
  IN.....: Can1 (TCanvas) = Pointer to the Canvas structure.                
  Internal Procdure.                                                       
 ͼ}

Procedure Canvas_CalculePosTaquets(Var C:TCanvas);
Begin
C.X[2]:=(C.X[1]+C.X[3]) Div 2;  C.Y[2]:=C.Y[1];
C.X[4]:= C.X[3];C.Y[4]:=(C.Y[3]+C.Y[5]) Div 2;
C.X[6]:=(C.X[1]+C.X[3]) Div 2;  C.Y[6]:=C.Y[5];
C.X[8]:= C.X[1];C.Y[8]:=(C.Y[1]+C.Y[7]) Div 2;
End;

{}
{}
{}

{ͻ
                         PROCEDURE RadioBox_Define                          
 ͹
  IN.....: Rad1 (TRadioBox) = Pointer to the Radio Box structure.           
           X,Y (INTEGER) = Radio Box coordinates.                           
           Style (INTEGER) = Using mode :                                   
                0 = Check Box (Invisible)                                   
                1 = Check Box (Visible)                                     
                2 = Radio Box (Exclusif check)                              
           Id (BYTE) = Control bits :                                       
                Bit 0  $01 = Private (do not touch this bit !)              
                Bit 1  $02 = Private (do not touch this bit !)              
                Bit 2  $04 = Freeze Radio Box                               
                Bit 3  $08 = Invisible Radio Box                            
                Bit 4  $10 = Select gadget using text                       
           Group (BYTE) = Group number (Only for the Radio Box).            
           PLab (BYTE) = Label Position                                     
                0 = Display text on the rigth                               
                1 = Display text on the left                                
           Status (BOOLEAN) = Radio Box state : TRUE = Tagged.              
           Cin (STRING) = Radio Box attached text to display.               
           MPointer (STRING) = Mouse pointer file.                          
           SHint (STRING) = Hint to display.                                
  OUT....: /                                                                
  EXPLAIN: Define and display a Radio Box / Check Box.                      
  EXAMPLE: RadioBox(10,50,1,$10,0,1,True,Rad1,'CLICK ME');                  
  SEEALSO: RadioBox_Draw, RadioBox_Freeze, RadioBox_GetMsg                  
 ͼ}

Procedure RadioBox_Define(Var R:TRadioBox; X,Y,Style:Integer; Id,Group,PLab:Byte; Status:Boolean; Cin,MPointer,SHint:String);
Var C:TCoordinates;
    Lt:Integer;

Begin
Log.Add('Create new RadioBox ('+Cin+')',2);

R.Font.BgColor:=CLCursor;               {*Background Color*}
R.Style:=Style;
R.Status:=Status;
R.IDCMP:=Id;                            {*Pas de "Demandeur" + Autres Bits*}
BSET(R.IDCMP,7);                        {*Set Bit "Display Label One Time"*}
R.Group:=Group;                         {*Groupe du Gadget Radio*}
R.Cin:=Cin;                             {*Label  Afficher*}
R.PLab:=PLab;                           {*Position du Label...*}

Lt:=10+VESA_TextWidth(R.Cin);           {*Text Length*}
R.PTx:=Lt;                              {*Delta pour Test Mouse on Text*}

C.X1:=X; C.Y1:=Y; C.X2:=X+20; C.Y2:=Y+16;
If R.PLab=1 Then C.X1:=C.X1-R.PTx
            Else C.X2:=C.X2+R.PTx;
MseZone(R.Zone,C,10,MPointer,SHint);    {*Define mouse pointer*}

If BTST(Id_Scr1,3) Then Begin           {*Window Clipped*}
   X:=X+T_Clip.X1; Y:=Y+T_Clip.Y1;      {*Restore True Coordones*}
   End;

R.X:=X;
R.Y:=Y;
End;

{ͻ
                             PROCEDURE RadioBox                             
 ͹
  IN.....: X,Y (INTEGER) = Radio Box coordinates.                           
           Style (INTEGER) = Using mode :                                   
                0 = Check Box (Invisible)                                   
                1 = Check Box (Visible)                                     
                2 = Radio Box (Exclusif check)                              
           Id (BYTE) = Control bits :                                       
                Bit 0  $01 = Private (do not touch this bit !)              
                Bit 1  $02 = Private (do not touch this bit !)              
                Bit 2  $04 = Freeze Radio Box                               
                Bit 3  $08 = Invisible Radio Box                            
                Bit 4  $10 = Select gadget using text                       
           Group (BYTE) = Group number (Only for the Radio Box).            
           PLab (BYTE) = Label Position                                     
                0 = Display text on the rigth                               
                1 = Display text on the left                                
           Status (BOOLEAN) = Radio Box state : TRUE = Tagged.              
           Rad1 (TRadioBox) = Pointer to the Radio Box structure.           
           Cin (STRING) = Radio Box attached text to display.               
           MPointer (STRING) = Mouse pointer file.                          
           SHint (STRING) = Hint to display.                                
  OUT....: /                                                                
  EXPLAIN: Define and display a Radio Box / Check Box.                      
  EXAMPLE: RadioBox(10,50,1,$10,0,1,True,Rad1,'CLICK ME');                  
  SEEALSO: RadioBox_Draw, RadioBox_Freeze, RadioBox_GetMsg                  
 ͼ}

Procedure RadioBox(X,Y,Style:Integer; Id,Group,PLab:Byte; Status:Boolean; Var R:TRadioBox; Cin,MPointer,SHint:String);
Begin
RadioBox_Define(R,X,Y,Style,Id,Group,PLab,Status,Cin,MPointer,SHint);
RadioBox_Draw(R);                       {*Va Afficher le Bouton Radio*}
If BTST(R.IDCMP,2) Then RadioBox_Freeze(Yes,R); {*Freeze le Bouton*}
End;

{ͻ
                             PROCEDURE RadioBox                             
 ͹
  IN.....: X,Y (INTEGER) = Radio Box coordinates.                           
           Style (INTEGER) = Using mode :                                   
                0 = Check Box (Invisible)                                   
                1 = Check Box (Visible)                                     
                2 = Radio Box (Exclusif check)                              
           Id (BYTE) = Control bits :                                       
                Bit 0  $01 = Private (do not touch this bit !)              
                Bit 1  $02 = Private (do not touch this bit !)              
                Bit 2  $04 = Freeze Radio Box                               
                Bit 3  $08 = Invisible Radio Box                            
                Bit 4  $10 = Select gadget using text                       
           Group (BYTE) = Group number (Only for the Radio Box).            
           PLab (BYTE) = Label Position                                     
                0 = Display text on the rigth                               
                1 = Display text on the left                                
           Status (BOOLEAN) = Radio Box state : TRUE = Tagged.              
           Rad1 (TRadioBox) = Pointer to the Radio Box structure.           
           Cin (STRING) = Radio Box attached text to display.               
  OUT....: /                                                                
  EXPLAIN: Define and display a Radio Box / Check Box.                      
  EXAMPLE: RadioBox(10,50,1,$10,0,1,True,Rad1,'CLICK ME');                  
  SEEALSO: RadioBox_Draw, RadioBox_Freeze, RadioBox_GetMsg                  
 ͼ}

Procedure RadioBox(X,Y,Style:Integer; Id,Group,PLab:Byte; Status:Boolean; Var R:TRadioBox; Cin:String);
Begin
RadioBox_Define(R,X,Y,Style,Id,Group,PLab,Status,Cin,'','');
RadioBox_Draw(R);                       {*Va Afficher le Bouton Radio*}
If BTST(R.IDCMP,2) Then RadioBox_Freeze(Yes,R); {*Freeze le Bouton*}
End;

{ͻ
                          PROCEDURE RadioBox_Draw                           
 ͹
  IN.....: Rad1 (TRadioBox) = Pointer to a RadioBox structure.              
  OUT....: /                                                                
  EXPLAIN: Display the specified gadget.                                    
  EXAMPLE: RadioBox_Draw(Rad1);                                             
  SEEALSO: RadioBox, RadioBox_Freeze, RadioBox_GetMsg                       
 ͼ}

Procedure RadioBox_Draw(Var R:TRadioBox);
Var PG:Shortint;
    X,Y,Tx:Integer;
    BName:String;
Begin
If R.IDCMP And $8=$8 Then Exit;               {*Invisible Gadget....*}

PG:=((HaF+4) Div 2)-6;                        {*Pos Centre du Gadget*}
If PG>50 Then PG:=0;                          {*Correction Erreur*}
VESA_SetFillStyle(1,R.Font.BgColor);
If Id_Scr1 And $8=$8 Then Begin               {*Window Clipped*}
   X:=R.X-T_Clip.X1; Y:=R.Y-T_Clip.Y1;        {*Set Relative Coordones*}
   End Else Begin
   X:=R.X; Y:=R.Y;                            {*No Modifs...*}
   End;

	  {=== AFFICHAGE DU TEXTE ===}
If R.IDCMP And $80=$80 Then Begin             {*Affiche Uniquement 1 Fois...*}
   If R.PLab=0 Then Tx:=X+LaF*2+19            {*Calcule Position X*}
      Else
      If R.PLab=1 Then Tx:=X-R.PTx
	 Else Begin Tx:=X-LaF*4-(R.PLab-2)*3*LaF; R.PTx:=X-Tx; End;
   Display(Tx,Y+1, 0,R.Cin);                  {*Affiche le Label*}
   R.IDCMP:=R.IDCMP And ($FF-$80);            {*Clear Bit One Time...*}
   End;

	  {=== AFFICHAGE DU BOUTON ===}
Mse_Hide;
If R.Style=0 Then                             {*No Motif*}
   If R.Status=True Then DrawGad_AmigaOkBut(X+1,Y+PG)
		    Else Bevel (X,Y,X+19,Y+HaF+4, R.Font.BgColor);
If R.Style=1 Then                             {*Box with Check*}
   Begin
   If R.Status Then BName:=Sys.ImgCheckYes Else BName:=Sys.ImgCheckNo;
   BMP_ShowTransparency(X,Y,X+20,Y+20,0,0,Sys.GetPath(SP_BUTTONS)+BName,$0080,CLTransparency);
   End;
If R.Style=2 Then                             {*Filled Blue Box*}
   Begin
   If R.Status Then BName:=Sys.ImgRadioYes Else BName:=Sys.ImgRadioNo;
   BMP_ShowTransparency(X,Y,X+20,Y+20,0,0,Sys.GetPath(SP_BUTTONS)+BName,$0080,CLTransparency);
   End;
Mse_Show;
End;

{ͻ
                         PROCEDURE RadioBox_Freeze                          
 ͹
  IN.....: On/Off (BOOLEAN) = (On = Enable gadget).                         
           Rad1 (Var TRadioBox) = Pointer to the Radio Box structure.       
  OUT....: /                                                                
  EXPLAIN: Enable or disable the Radio Box gadget.                          
  EXAMPLE: RadioBox_Freeze(On,Rad1);                                        
  SEEALSO: RadioBox, RadioBox_Draw, RadioBox_GetMsg,                        
 ͼ}

Procedure RadioBox_Freeze(Status:Boolean; Var R:TRadioBox);
Var Xd,Yd:Integer;
    O_Rx,O_Ry:Integer;                     {*Optimisations*}
    Inv:Boolean;

Begin
If R.IDCMP And $8=$8 Then Inv:=Yes         {*Invisible Gadget....*}
		     Else Inv:=No;
If Id_Scr1 And $8=$8 Then Begin            {*Window Clipped*}
   Xd:=-T_Clip.X1; Yd:=-T_Clip.Y1;         {*Set Relative Coordones*}
   End Else Begin
   Xd:=0; Yd:=0;                           {*No Modifs...*}
   End;

If Status=Yes Then Begin                   {*Bouton  dsactiver*}
   O_Rx:=R.X+Xd; O_Ry:=R.Y+Yd;
   If Not Inv Then Begin                   {*Bouton Visible ?*}
      If R.Style<=1 Then Bar_FillGray(O_Rx+1, O_Ry+1, O_Rx+18, O_Ry+HaF+4);
      If R.Style=2  Then Bar_FillGray(O_Rx+4, O_Ry+2, O_Rx+16, O_Ry+HaF+2);
      End;
   R.IDCMP:=R.IDCMP Or $4;
   End
   Else Begin                              {*Bouton  Activer*}
   RadioBox_Draw(R);
   R.IDCMP:=R.IDCMP And ($FF-$4);
   End;
End;

{ͻ
                          FUNCTION RadioBox_GetMsg                          
 ͹
  IN.....: Rad1 (TRadioBox) = Pointer to the RadioBox structure.            
           M (Word) = Activation code.                                      
  OUT....: (BYTE) = Message Id as:                                          
               CMNone               No messages                             
               CMSelected           RadioBox selected                       
               CMUnSelected         RadioBox unselected                     
  EXPLAIN: Test if the gadget is selected.                                  
  EXAMPLE: If RadioBox_GetMsg(Rad1,1)=TRUE Then...                          
  NB.....: To test the value of the radio box, check the "Status" field     
           of the RadioBox structure.                                       
  SEEALSO: RadioBox, RadioBox_Draw, RadioBox_Freeze                         
 ͼ}

Function RadioBox_GetMsg(Var R:TRadioBox; M:Word):Byte;
Var      X,Y,Rx1,Rx2:Word;
	 Ga,Mi,Dr:Boolean;
	 PM:TPosMse;                         {*Structure Position Souris*}
Begin
RadioBox_GetMsg:=CMNone;
If R.IDCMP And $4=$4 Then Exit;             {*Bouton Gris non Test*}
If (Sys.RadioId And $1=$1) And              {*Test Bit Extrude*}
   (R.Style=2) Then                         {*On est le Style 2 Exclusif*}
   If R.IDCMP And $1<>$1 Then               {*On n'est pas le "Demandeur"*}
      Begin                                 {* => On Dsactive le Bouton...*}
      If Sys.RadioBoxGroup=R.Group Then     {*Radio Box Demandeur Group ?*}
	 Begin
	 R.Status:=False; R.Fl1:=True; RadioBox_Draw(R);
	 RadioBox_GetMsg:=CMUnSelected;
	 End;
      End
      Else Begin                            {*On est le Bouton "Demandeur"*}
      R.Status:=True; R.Fl1:=True; RadioBox_Draw(R);
      R.IDCMP:=R.IDCMP And $FE;             {*Neg Bit 0 pour "Demandeur"*}
      Sys.RadioId:=Sys.RadioId And $FE;     {*Neg Bit 0 pour "Multiutilisateur"*}
      RadioBox_GetMsg:=CMSelected;
      End;

MseZone_GetMsg(R.Zone);                 {*Mouse pointer and Hint*}

Mse_Get(X,Y,Ga,Mi,Dr);
If Mse_Clicked(M)=False Then Begin R.Fl1:=False; R.FClick:=False; End;

If (Mse_Clicked(M)=True) And (R.FClick=False) Then
   Begin PM.X:=X; PM.Y:=Y; R.FClick:=True; End;{*Save Coordones Mse*}

If R.IDCMP And $10=$10 Then Begin              {*Click Texte = Select Radio*}
   If R.Plab>=1 Then Begin Rx1:=R.X-R.PTx; Rx2:=R.X+19; End;
   If R.Plab=0  Then Begin Rx1:=R.X; Rx2:=R.X+19+R.PTx; End;
   End Else Begin
   Rx1:=R.X; Rx2:=R.X+19;                      {*Dcalage *}

   End;

If (Mse_TestBox(Rx1,R.Y,Rx2,R.Y+HaF+4,M)=True)
   And (PM.X>=Rx1) And (PM.X<=Rx2)
   And (PM.Y>=R.Y) And (PM.Y<=R.Y+HaF+4) Then
   If R.Style=2 Then                           {*Boutons Push Exclusifs*}
   If R.Status=False Then
      Begin
      Sys.RadioId:=Sys.RadioId Or $1;          {*Set Bit Extrude*}
      Sys.RadioBoxGroup:=R.Group;              {*Radio Box Demandeur Group*}
      R.IDCMP:=R.IDCMP Or $1;                  {*Set Bit "Demandeur"*}
      End Else

   Else                                        {*Boutons Check-Mark*}
   If (R.Status=False) And (R.Fl1=False) Then
	Begin
	R.Status:=True; R.Fl1:=True; RadioBox_Draw(R);
	RadioBox_GetMsg:=CMSelected;
	End
   Else If R.Fl1=False Then
	Begin
	R.Status:=False; R.Fl1:=True; RadioBox_Draw(R);
	RadioBox_GetMsg:=CMUnSelected;
	End;
End;

{}
{}
{}

{ͻ
                         PROCEDURE InputText_Define                         
 ͹
  IN.....: X,Y (INTEGER) = Gadget coordinates.                              
           Size (INTEGER) = Gadget width in pixel.                          
           Len (BYTE) = Maximum lenght in chars.                            
           CoB (LONGINT) = Background color (When not selected).            
           Co2 (LONGINT) = Background color (When selected).                
           Sty (BYTE) = Design style for the gadget.                        
                        0 = Use double border box                           
                        1 = Use simple border box                           
                        2 = Without any border box                          
           Id (WORD) = Define gadget comportement.                          
               Bit 0  $0001 = Gadget activated                              
               Bit 1  $0002 = Previous gadget if up arrow                   
               Bit 2  $0004 = Next gadget if down arrow                     
               Bit 3  $0008 = Previous gadget if left arrow                 
               Bit 4  $0010 = Next gadget if right arrow                    
               Bit 5  $0020 = Enable ESC key (Restore string)               
               Bit 6  $0040 = Put this bit if the gadget musn't be tested   
               Bit 7  $0080 = Password mode = No display caracters          
               Bit 8  $0100 = Display numbers only                          
               Bit 9  $0200 = Freeze gadget                                 
               Bit 10 $0400 = Upper chars only                              
               Bit 11 $0800 = Invisible gadget                              
               Bit 12 $1000 = Overwrite mode                                
               Bit 13 $2000 = Set cursor at the begining of the line        
           Inp1 (TInputText) Pointer to the InputText structure.            
           Cin (STRING) = String to be modified by gadget.                  
  OUT....: /                                                                
  EXPLAIN: Define a InputText gadget and allow you to modify a string.      
  EXAMPLE: Cin:='CHANGE THIS SENTENCE';                                     
           InputText_Define(10,10,143,255,7,12,0,$0027,C1,Cin);             
  NB.....: This gadget use the following keys :                             
           Enter, Delete, Backspace, Begin, End, Right Arrow, Left Arrow.   
  SEEALSO: InPutText_Freeze, InputText_GetMsg                               
 ͼ}

PROCEDURE InputText_Define(X,Y,Siz:Integer; Len:Byte; CoB,Co2:LongInt;Sty:Byte; ID:Word; Var C:TInputText; Var Cin:String);
Var Dy:Integer;                    {*For Clipping*}
    Coo:TCoordinates;

Begin
Log.Add('Create new InputText ('+Cin+')',2);

Coo.X1:=X; Coo.Y1:=Y; Coo.X2:=Coo.X1+Siz; Coo.Y2:=Coo.Y1+HaF+4;
MseZone(C.Pointer,Coo,10,MPText,''); {*Define mouse pointer*}

If Id_Scr1 And $8=$8 Then Begin    {*Window Clipped*}
   Dy:=0;
   X:=X+T_Clip.X1; Y:=Y+T_Clip.Y1-Dy;{*Restore True Coordones*}
   End Else Begin
   Dy:=0;                          {*No Modifs...*}
   End;

If Id And $40<>$40 Then Sys.CommandCount := Sys.CommandCount +1
   Else Id:=Id And ($FFFF-$40);    {*1 Gadget "InputText" de Plus...*}

C.X:=X;                            {*Stocke Valeurs Datas*}

C.Y:=Y;
C.Siz:=Siz;
C.Len:=Len;
C.CoB:=CoB;
C.Co2:=Co2;
C.Sty:=Sty;
C.Cin:=Cin;
C.Freeze:=No;                      {*Gadget non Gris = Fonctionnel de Base*}
C.IDCMP:=$0000;                    {*Pas de Msg Inter Commandes*}
C.Id:=Id;                          {*Dfinition Caractristiques InputText*}
C.Font.Name:=Sys.FontCurrent;            {*Save Used Font*}
C.Font.Size:=Sys.FontCurrentSize;
End;

{ͻ
                            PROCEDURE InputText                             
 ͹
  IN.....: X,Y (INTEGER) = Gadget coordinates.                              
           Size (INTEGER) = Gadget width in pixel.                          
           Len (INTEGER) = Maximum lenght in chars.                         
           CoB (LONGINT) = Background color (When not selected).            
           Co2 (LONGINT) = Background color (When selected).                
           Sty (BYTE) = Design style for the gadget.                        
                        0 = Use double border box                           
                        1 = Use simple border box                           
                        2 = Without any border box                          
           Id (WORD) = Define gadget comportement.                          
               Bit 0  $0001 = Gadget activated                              
               Bit 1  $0002 = Previous gadget if up arrow                   
               Bit 2  $0004 = Next gadget if down arrow                     
               Bit 3  $0008 = Previous gadget if left arrow                 
               Bit 4  $0010 = Next gadget if right arrow                    
               Bit 5  $0020 = Enable ESC key (Restore string)               
               Bit 6  $0040 = Put this bit if the gadget musn't be tested   
               Bit 7  $0080 = Password mode = No display caracters          
               Bit 8  $0100 = Display numbers only                          
               Bit 9  $0200 = Freeze gadget                                 
               Bit 10 $0400 = Upper chars only                              
               Bit 11 $0800 = Invisible gadget                              
               Bit 12 $1000 = Overwrite mode                                
               Bit 13 $2000 = Set cursor at the begining of the line        
           Inp1 (TInputText) Pointer to the InputText structure.            
           Cin (STRING) = String to be modified by gadget.                  
  OUT....: /                                                                
  EXPLAIN: Define and draw an InputText gadget. Allow you to modify a string
  EXAMPLE: Cin:='CHANGE THIS SENTENCE';                                     
           InputText(10,10,143,255,7,12,0,$0027,C1,Cin);                    
  NB.....: This gadget use the following keys :                             
           Enter, Delete, Backspace, Begin, End, Right Arrow, Left Arrow.   
  SEEALSO: InPutText_Freeze, InputText_GetMsg                               
 ͼ}

PROCEDURE InputText(X,Y,Siz,Len:Integer; CoB,Co2:Longint; Sty:Byte; Id:Word; Var C:TInputText; Var Cin:String);
Begin
InputText_Define(X,Y,Siz,Len,CoB,Co2,Sty,ID,C,Cin);
InputText_Draw(C);                 {*Display InputText*}

If BTST(Id,9) Then InPutText_Freeze(Yes,C);{*Freeze InputText*}
End;

{ͻ
                          PROCEDURE InputText_Draw                          
 ͹
  IN.....: Inp1 (Var TInputText) = Pointer to the InputText structure.      
  OUT....: /                                                                
  EXPLAIN: Draw the InputText gadget.                                       
  EXAMPLE: InputText_Draw(Inp1);                                            
  SEEALSO: InputText, Freeze_InputText, InputText_GetMsg                    
 ͼ}

Procedure DISPSB(X,Y:Integer; St:String; C:TInputText);
Var Ox,Oy:Byte;
    MyText:TText;

Begin
Ox:=0; Oy:=1;
Font_Set(C.Font.Name,C.Font.Size);      {*Passe en Fonte pour le Gadget*}

// We need to use the Display_Define method to access the background
// color of the component...

Display_Define(MyText, X+Ox, Y+Oy, C.CoB, VESA_GetColor,
               Sys.FontCurrent,Sys.FontCurrentSize, TJOnLeft,$0001,St);
Display_Draw(MyText);                    // Here component is displayed

Font_Set(Sys.FontPrevious,Sys.FontPreviousSize);      {*Repasse dans la fonte Prcdente*}
End;

{*********************** PREPARE L'AFFICHAGE DU TEXTE ***********************}

Function SHOW_TEXT(C:TInputText; Cin:String):String;
Var I:Byte;
    St:String;
Begin                              {*Dfinit le Texte ou '*' pour Password*}
St:='';
If C.Id And $80=$80                {*Style Password...*}
   Then Begin
      For I:=1 to Length(Cin) do St:=St+'*'; SHOW_TEXT:=St;
      End
   Else SHOW_TEXT:=Cin;            {*Style Normal*}
End;

{************************* AFFICHE LE GADGET COMMAND ************************}

Procedure InputText_Draw(C:TInputText);
Var VP:TViewPortType;
    Res:String;
    X1,Y1,Dx,Dy:Integer;           {*For ViewPort*}
    VX1,VY1,VX2,VY2:Integer;

Begin
If Id_Scr1 And $8=$8 Then Begin    {*Window Clipped*}
   Dx:=0; Dy:=0;
   X1:=C.X-T_Clip.X1; Y1:=C.Y-T_Clip.Y1;

   End Else Begin
   X1:=C.X; Y1:=C.Y; Dx:=0; Dy:=0; {*No Modifs...*}
   End;

If (C.Id And $800)<>$800 Then      {*Visible ?*}
   Begin
   Mse_Hide;                       {*Pattern*}
   If C.Sty=0 Then Bevel (X1+Dx,Y1+Dy,X1+C.Siz+Dx,Y1+4+HaF+Dy, C.CoB, BLRaisedLine, BLLoweredLine,Yes);
   If C.Sty=1 Then Bevel (X1+Dx,Y1+Dy,X1+C.Siz+Dx,Y1+4+HaF+Dy, C.CoB, BLLoweredLine,BLNoLine,Yes);
   If C.Sty=2 Then Bevel (X1+Dx,Y1+Dy,X1+C.Siz+Dx,Y1+4+HaF+Dy, C.CoB);
   Mse_Show;

   VX1:=C.X; VY1:=C.Y; VX2:=C.X+C.Siz; VY2:=C.Y+HaF; {*Restore True Coordones*}

   If Id_Scr1 And $8=$8 Then Begin              {*Window Clipped*}

      If VX1<T_Clip.X1 Then VX1:=T_Clip.X1;     {*Coord ViewPort Gadget*}
      If VY1<T_Clip.Y1 Then VY1:=T_Clip.Y1;
      If VX2>T_Clip.X2 Then VX2:=T_Clip.X2;
      If VY2>=T_Clip.Y2 Then VY2:=T_Clip.Y2-1;
      If (VX2<=VX1) Or (VY2<=VY1) Then Exit;    {*Gadget Totalement Cach...*}
      End;

   VESA_SetColor(CLLineDown);           {*Couleur Noire*}
   VESA_GetViewSettings(VP);            {*Search for current ViewPort*}
   VESA_SetViewPort(VX1+1,VY1+1,VX2-2,VY2+2,ClipOn);
   Res:=SHOW_TEXT(C,C.Cin);             {*Prpare l'Affichage*}
   Mse_Hide;
   If C.Cin<>'' Then DispSB(3,0,Res,C); {*Affiche le Txt si il Existe*}
   Mse_Show;
   VESA_SetViewPort(VP.X1,VP.Y1,VP.X2,VP.Y2,ClipOn);{*Restore Old ViewPort*}
   End;
End;

{ͻ
                         PROCEDURE InputText_Freeze                         
 ͹
  IN.....: On/Off (BOOLEAN) = (On = Enable gadget).                         
           Inp1 (Var TInputText) = Pointer to the InputText structure.      
  OUT....: /                                                                
  EXPLAIN: Enable or disable the InputText gadget.                          
  EXAMPLE: InputText_Freeze(On,Inp1);                                       
  SEEALSO: InputText, InputText_GetMsg                                      
 ͼ}

Procedure InputText_Freeze(Status:Boolean; Var C:TInputText);

Var Xd,Yd:Integer;
    Inv:Boolean;
Begin
If (C.Freeze=Yes) And (Status=Yes)Then Exit;{*Action dja Effectute*}
If (C.Freeze=No)  And (Status=No) Then Exit;
If C.ID And $8=$8 Then Inv:=Yes            {*Invisible Gadget....*}
		  Else Inv:=No;

If Id_Scr1 And $8=$8 Then Begin            {*Window Clipped*}
   Xd:=-T_Clip.X1; Yd:=-T_Clip.Y1;         {*Set Relative Coordones*}

   End Else Begin
   Xd:=0; Yd:=0;                           {*No Modifs...*}
   End;

If Status=Yes Then Begin                   {*Bouton  dsactiver*}
   If Not Inv Then                         {*Bouton Visible ?*}
      Bar_FillGray(C.X+1+Xd,C.Y+Yd,C.X+C.Siz+Xd,C.Y+HaF+3+Yd);
   C.Freeze:=Yes;
   Sys.CommandCount := Sys.CommandCount -1 ; {*1 Commande de Moins*}
   End
   Else Begin                              {*Bouton  Activer*}
(*   Font_Set(C.FontType,C.FontSize);        {*Passe en Fonte pour le Gadget*}
   InputText(C.X,C.Y,C.Siz,C.Len,C.CoB,C.Co2,C.Sty,C.ID+$40,C,C.Cin);
   Font_Set(Sys.FontPrevious,Sys.FontPreviousSize);      {*Repasse dans la fonte Prcdente*}*)
   InputText_Draw(C);                      {*Raffiche le Gadget*}
   C.Freeze:=No;
   Sys.CommandCount := Sys.CommandCount + 1 ; {*1 Commande de plus*}
   End;
End;

{ͻ
                         FUNCTION InputText_GetMsg                          
 ͹
  IN.....: Inp1 (TInputText) = Pointer to the InputText structure.          
           M (Word) = Activation code.                                      
           Cin1 (STRING) = String to be modified.                           
  OUT....: (BYTE) = Message Id as:                                          
               CMNone               No messages                             
               CMModified           Text has been modified                  
  EXPLAIN: Test if the gadget is selected.                                  
  EXAMPLE: If InputText_GetMsg(Inp1,Cin1)=TRUE Then Writeln(Cin1);          
  SEEALSO: InputText, InPutText_Freeze                                      
 ͼ}

Function InputText_GetMsg(Var C:TInputText; Var Cin:String):Byte;

Var Pos:Integer;                {*Position Courante Curseur in String*}
    Ent:Char;                   {*Charactere Touche Prsse*}
    Qtt:Word;                   {*Nombre de Char Entrs*}
    Car:Boolean;                {*Est-ce un Char de Contrle ou non ?*}
    Vent:Integer;               {*Valeur du Char Tap au clavier*}
    X,Y :Word;                  {*Pos X et Y du Requester*}
    Cs  :Longint;               {*Color swapping*}
    X1  :Word;                  {*New Position Pour Curseur*}
    Ga,Mi,Dr:Boolean;           {*Test Boutons Souris*}
    A,PCur:Integer;             {*Boucle et Search Position to Set cursor*}
    CCurs :TKbdLocate;          {*Structure Curseur pour InputText*}
    VP:TViewPortType;           {*Pour ViewPort Courrant*}
    Res:String;                 {*Chaine  Afficher = Rsultat de CIN*}
    OldSt:String;               {*Chane Initiale...*}
    Xc,Yc:Integer;              {*Clipping Relatif pour Curseur*}
    VX1,VY1,VX2,VY2:Integer;    {*True ViewPort for Clipping*}

Procedure DRAW_CURSOR_CO(PX:Integer);{*Affiche Curseur Pour Co_REQUESTER*}
Begin
CCurs.InitCursor(Sys.CursorShape,Sys.CursorBlinkSpeed);     {*Initialise le Curseur*}
CCurs.Locate(PX-Xc,Y+2-Yc);
CCurs.CursorOn;
VESA_SetColor(CLLineDown);
End;

{************************** PROCEDURE PRINCIPALE ****************************}

Begin
CCurs:=TKbdLocate.Create;
{gotoxy(1,1); writeln('Count=',Sys.CommandCount,' ');
gotoxy(1,2); writeln('Pos=',Sys.CommandSearchPos,' ');}

InputText_GetMsg:=CMNone;          {*De Base par Prcautions*}
If C.Freeze=Yes Then Exit;         {*Gadget Gris => Pas de Test*}
If Id_Msg1 And $4=$4 Then Exit;    {*On Bouge un Slider Quelque Part*}
If Id_Msg1 And $4=$4 Then Exit;    {*On Bouge un Slider Quelque Part*}

Mse_Get(X,Y,Ga,Mi,Dr);
MseZone_GetMsg(C.Pointer);         {*Manage mouse pointer*}

				   {*Demande activation Gadget Prsent -DOWN*}
VX1:=C.X; VY1:=C.Y; VX2:=C.X+C.Siz; VY2:=C.Y+HaF+1; {*Restore True Coordonnes*}
If Id_Scr1 And $8=$8 Then Begin    {*Window Clipped*}
   Xc:=T_Clip.X1; Yc:=T_Clip.Y1;          {*Coord pour Cursor*}
   If VX1<T_Clip.X1 Then VX1:=T_Clip.X1;  {*Coord ViewPort Gadget*}
   If VY1<T_Clip.Y1 Then VY1:=T_Clip.Y1;
   If VX2>T_Clip.X2 Then VX2:=T_Clip.X2;
   If VY2>=T_Clip.Y2 Then VY2:=T_Clip.Y2-1;
   If (VX2<=VX1) Or (VY2<=VY1) Then Exit; {*Gadget Totalement Cach...*}
   End Else Begin
   Xc:=0; Yc:=0;                   {*No Modifs...*}
   End;

If Kbd_GetKeyDown(VK_TAB) Then C.Id:=C.Id Or $1;   {*Teste Touche TAB Activation "InputText"*}

If (Id_Gad1 And $1=$1) And (C.Id And $4=$4) Then
   Begin C.Id:=C.Id Or $1; Id_Gad1:=Id_Gad1 And $FFFE; End;

If Id_Gad1 And $2=$2 Then          {*Demande activation Gadget Prsent -UP*}
   If Sys.CommandSearchPos<Sys.CommandCount-2

      Then Sys.CommandSearchPos := Sys.CommandSearchPos + 1
      Else Begin C.Id:=C.Id Or $1; Id_Gad1:=Id_Gad1 And $FFFD; End;

If Ga=True Then                    {*Bouton Gauche Press*}
   If C.Fl1=False Then
      Begin C.Fl1:=True;
      If (X<>C.PM.X) Or (Y<>C.PM.Y) Then Begin C.PM.X:=X; C.PM.Y:=Y; End;
      End
      Else
   Else C.Fl1:=False;

	  {=== GESTION DU Pointeur HAND ===}
				   {*Le Pointeur passe sur le Gadget InputText*}
If (Mse_TestBox(C.X,C.Y,C.X+C.Siz,C.Y+4+HaF,10)=True) {And (Id_Msg1 And $8<>$8)}
   Then Begin Id_Msg1:=Id_Msg1 Or $8; C.IDCMP:=C.IDCMP Or $1; End;

If (Mse_TestBox(C.X,C.Y,C.X+C.Siz,C.Y+4+HaF,10)=False) And
   (C.IDCMP And $1=$1) Then        {*Fin Affichage Pointeur Texte*}
   Begin Id_Msg1:=Id_Msg1 And ($FFFF-$8); C.IDCMP:=C.IDCMP And ($FF-$1); End;

	  {=== GESTION DE LA SELECTION DES GADGETS ===}

If (Mse_TestBox(C.X,C.Y,C.X+C.Siz,C.Y+4+HaF,1)=False) And (C.Id And $1<>$1) Then
   InputText_GetMsg:=CMNone        {*On ne Fait pas Ce Requester*}
   Else If ((C.Id And $1<>$1) And  {*Test si Click dans le Requester*}
      (C.PM.X>=C.X) And (C.PM.X<=C.X+C.Siz) And
      (C.PM.Y>=C.Y) And (C.PM.Y<=C.Y+4+HaF)) Or (C.Id And $1=$1)
      Then Begin                   {*On a cliqu dans le requester*}
   OldSt:=Cin;                     {*Save Initial String*}
   Pos:=(X-C.X-4);                 {*Save & Calcule Delta Pos Mouse*}
   If Pos<0 Then Pos:=0;           {*Correction Borne Infrieure*}
   Cs:=C.CoB; C.Cob:=C.Co2; C.Co2:=Cs;{*Swap des Couleurs de Fond Background*}

   InputText_GetMsg:=CMModified;
   X:=C.X; Y:=C.Y;                 {*Draw Again Requester*}

(*   Font_Set(C.FontType,C.FontSize);        {*Passe en Fonte pour le Gadget*}
   InputText(X-Xd,Y-Yd,C.Siz,C.Len,C.CoB,C.Co2,C.Sty,C.ID+$40,C,Cin);
   Font_Set(Sys.FontPrevious,Sys.FontPreviousSize); {*Repasse dans la fonte Prcdente*}*)
   InputText_Draw(C);              {*Raffiche le Gadget*}
   Inc(X,4); Inc(Y,1);             {*Correct for Draw Text*}

   PCur:=0; A:=1;                  {*Search Numro du char o positionner*}
   While (PCur<Pos) And (A<=Length(Cin)+1) do Begin
      PCur:=VESA_TextWidth(Copy(Cin,1,A));{*Next Char...*}
      Inc(A);
      End;
   Pos:=A-1;                       {*Il faut se placer au "Pos"eme char*}

   If Pos>C.Len Then Pos:=C.Len;   {*Correction borne maximale*}
   If C.Id And $1=$1 Then Pos:=Length(C.Cin)+1;{*Si activ Automatiquement => Fin Txt*}
   Qtt:=Length(Cin);               {*0 Chars Entrs ou plus*}
   X1:=X+VESA_TextWidth(Copy(Cin,1,Pos-1));{*Position Curseur*}
   VESA_MoveTo(X1,Y);                   {*On se Positionne  la Fin du Texte*}

   DRAW_CURSOR_CO(X1);             {*Dplace Curseur au Bon Endroit*}
   C.Id:=C.Id And $FFFE;           {*Gadget ne sera plus activ Automatiquement*}

 {***}

   While Mse_Clicked(1) Do;        {*Debug*}

      Repeat
      Vent:=-1;                    {*Test Out*}
      While Vent=-1 do Begin
      CCurs.CursorOn;              {*Affiche Curseur au Bon Endroit*}
      If Kbd_GetKeyDown(VK_CONTROL) Then VEnt:=13; {*Sortie car Appuie sur CTRL*}
      If Mse_TestBox(C.X,C.Y,C.X+C.Siz,C.Y+4+HaF,10)=True {*TPointer Modifi*}
	 Then Mse_SetPointer(MPText) Else Mse_SetPointer(P_Current);
      If Keypressed Then Begin
	 Ent:=Readkey;

	 Vent:=Ord(Ent);           {*Prend la Valeur du Char ASCII*}
	 End
	 Else If Mse_Clicked(0) Then Vent:=13;
      End;
   Id_Msg1:=Id_Msg1 And ($FFFF-$8); C.IDCMP:=C.IDCMP And ($FF-$1);
 {***}

   Car:=False;                     {*Char Affichable de Base Sauf si Non !*}
{   If (VEnt=13) And (C.Id And $20=$20) Then}        {*ENTER est Press*}
{      Id_Gad1:=Id_Gad1 Or $1;}

   If VEnt=0 Then                  {*Caracteres de Contrle*}
      Begin
      Car:=True;                   {*C'est 1 Char de Contrle => Pas d'Aff*}
      Ent:=Readkey;
      Vent:=Ord(Ent);
      If (VEnt=75) And (C.Id And $8=$8) And (Pos<=1) Then Begin
	 VEnt:=13; Id_Gad1:=Id_Gad1 Or $2;   {*Sortie par Flche Gauche*}
	 Sys.CommandSearchPos:=0;
	 End;
      If (VEnt=77) And (C.Id And $10=$10) And (Pos>=Qtt+1) Then Begin
	 VEnt:=13; Id_Gad1:=Id_Gad1 Or $1;   {*Sortie par Flche Droite*}
	 End;
      If (VEnt=72) And (C.Id And $2=$2) Then Begin
	 VEnt:=13; Id_Gad1:=Id_Gad1 Or $2;   {*Sortie par Flche Haut*}
	 Sys.CommandSearchPos:=0;
	 End;
      If (VEnt=80) And (C.Id And $4=$4) Then Begin
	 VEnt:=13; Id_Gad1:=Id_Gad1 Or $1;   {*Sortie par Flche Bas*}
	 End;
      If (VEnt=77) And (Pos<C.Len) And (Pos<Qtt+1) Then Begin
	 Inc(Pos,1); X1:=X+VESA_TextWidth(Copy(Cin,1,Pos));
         CCurs.CursorOff;
         VESA_MoveTo(X1,Y);                       {*Flche Droite*}
	 End;
      If (VEnt=75) And (Pos>1) Then Begin
	 Dec(Pos,1); X1:=X+VESA_TextWidth(Copy(Cin,1,Pos-1));
         CCurs.CursorOff;
         VESA_MoveTo(X1,Y);                       {*Flche Gauche*}
	 End;
      If (VEnt=83) And (Pos<=Qtt) Then       {*Delete "Suppr"*}
	 Begin
	 Cin:=Copy(Cin,1,Pos-1)+Copy(Cin,Pos+1,Qtt-Pos);
	 VESA_SetColor(CLText);
	 VESA_GetViewSettings(VP);           {*Search for current ViewPort*}
	 VESA_SetViewPort(VX1+1,VY1+1,VX2-2,VY2+1,ClipOn); {*Set ViewPort*}
	 Res:=SHOW_TEXT(C,Cin);              {*Prpare l'Affichage*}
	 If (C.Id And $800)<>$800 Then       {*Visible ?*}
	    DispSB(3,0,Res+' ',C);
	 VESA_SetViewPort(VP.X1,VP.Y1,VP.X2,VP.Y2,ClipOn); {*Restore Normal ViewPort*}
	 DRAW_CURSOR_CO(X1);                 {*Show New Cursor*}
	 Dec(Qtt,1);
	 End;
      If (VEnt=79) Then Pos:=Qtt+1;          {*Goto Fin*}
      If Pos>C.Len Then Pos:=C.Len;          {*Correction Borne Maximale*}
      If (VEnt=71) Then Pos:=1;              {*Goto Debut*}
      End;

   If (VEnt=27) And (C.Id And $20=$20) Then Begin
      Cin:=OldSt;
      Res:=SHOW_TEXT(C,Cin);                 {*ESCAPE Pressed...*}
      VEnt:=13;
      End;

   If (VEnt=8) And (Pos>1) Then              {*Delete BackSpace*}
      Begin
      Cin:=Copy(Cin,1,Pos-2)+Copy(Cin,Pos,Qtt-Pos+1);
      CCurs.CursorOff;
      VESA_SetColor(CLText);
      VESA_GetViewSettings(VP);                   {*Search for current ViewPort*}
      VESA_SetViewPort(VX1+1,VY1+1,VX2-2,VY2+1,ClipOn); {*Set Viewport*}
      Res:=SHOW_TEXT(C,Cin);                 {*Prpare l'Affichage*}
      If (C.Id And $800)<>$800 Then          {*Visible ?*}
	 DispSB(3,0,Res+' ',C);
      VESA_SetViewPort(VP.X1,VP.Y1,VP.X2,VP.Y2,ClipOn); {*Restore Normal ViewPort*}
      X1:=X+VESA_TextWidth(Copy(Cin,1,Pos-1));
      VESA_MoveTo(X1,Y);
      Dec(Qtt,1); Dec(Pos,1);
      End;

   If C.Id And $100=$100
      Then If (VEnt<42) Or (VEnt>57) Then Car:=True   {*Char Pas Affichable*}
				     Else
      Else If (VEnt<32) Or (VEnt>165) Then Car:=True; {*Char Pas Affichable*}

   If BTST(C.Id,10) Then Ent:=Upcase(Ent);            {*Mode Majuscules...*}

   If (Car=False) And (Qtt<C.Len) And
      (VESA_TextWidth(Cin)+LaF*2<C.Siz) Then Begin
      If BTST(C.Id,12)                       {*Overwrite Mode*}
	  Then Begin
	  If Pos>Qtt Then Begin Cin:=Cin+Ent; Inc(Qtt,1) End
		     Else Cin[Pos]:=Ent;
	  End                                {*Insert Mode*}
	  Else Cin:=Copy(Cin,1,Pos-1)+Ent+Copy(Cin,Pos,Qtt-Pos+1);

      CCurs.CursorOff;
      VESA_SetColor(CLText);
      VESA_GetViewSettings(VP);                         {*Search for current ViewPort*}
      VESA_SetViewPort(VX1+4,VY1+1,VX2-2,VY2+1,ClipOn); {*Set Viewport*}
      Res:=SHOW_TEXT(C,Cin);                 {*Prpare l'Affichage*}
      If (C.Id And $800)<>$800 Then          {*Visible ?*}
	 DispSB(0,0,Res,C);
      VESA_SetViewPort(VP.X1,VP.Y1,VP.X2,VP.Y2,ClipOn); {*Restore Normal ViewPort*}
      X1:=X+VESA_TextWidth(Copy(Cin,1,Pos));
      If (Not BTST(C.Id,12)) Then Inc(Qtt,1);      {*1 Char de + & Avance de 1 vers la Dte*}
      Inc(Pos,1);
      End;

   If Pos=C.Len+1 Then Pos:=C.Len; {*Affiche Curseur Max  la Fin*}
   CCurs.CursorOff;
   X1:=X+VESA_TextWidth(Copy(Cin,1,Pos-1));
   DRAW_CURSOR_CO(X1);             {*Show New Cursor*}
   VESA_MoveTo(X1,Y);              {*Positionner Right Place*}

   Until VEnt=13;                  {*Enter = Fin*}

   CCurs.CursorOff;
   Cs:=C.CoB; C.Cob:=C.Co2; C.Co2:=Cs;{*Swap des Couleurs de Fond Background*}
   X:=C.X; Y:=C.Y;                 {*Reinit Coordones*}
   C.Cin:=Cin;                     {*Stocke Nouveau String*}
   InputText_Draw(C);              {*Raffiche le Gadget*}
(*   Font_Set(C.FontType,C.FontSize);        {*Passe en Fonte pour le Gadget*}
   InputText(X-Xd,Y-Yd,C.Siz,C.Len,C.CoB,C.Co2,C.Sty,C.ID+$40,C,Cin);{*Draw Requester*}
   Font_Set(Sys.FontPrevious,Sys.FontPreviousSize); {*Repasse dans la fonte Prcdente*}*)
   End;
CCurs.Free;
End;

{}
{}
{}

{ͻ
                               PROCEDURE Hint                               
 ͹
  IN.....: X1,Y1,X2,Y2 (INTEGER) = Info box coordinates.                    
           Id (BYTES) = Bits definition :                                   
               Bit 0  $0001 = Gadget activated                              
               Bit 1  $0002 = Display infos on the right bottom             
               Bit 2  $0004 = Delay for info                                
           Inf1 (THint) = Pointer to the Hint structure.                    
           Info (STRING) = Message text (Max 255 Chars).                    
  OUT....: /                                                                
  EXPLAIN: Define a help box called when the mouse will be on it.           
  EXAMPLE: Hint(10,50,130,70,$00,'Load the selected file',Inf1);            
  SEEALSO: Hint_GetMsg                                                      
 ͼ}

Procedure Hint(X1,Y1,X2,Y2:Integer; Id:Word; Var I:THint; Info:String);
Var MaxX,A,L:Integer;
    MyContext:TScreenContext;

Begin
Log.Add('Create new Hint ('+Info+')',2);

If Id_Scr1 And $8=$8 Then Begin            {*Window clipped ?*}
   X1:=X1+T_Clip.X1; Y1:=Y1+T_Clip.Y1;     {*Restore true coordinates*}
   X2:=X2+T_Clip.X1; Y2:=Y2+T_Clip.Y1;
   End;

Coord_BoxInScreen(X1,Y1,X2,Y2);            {*Vrifie la Cohrence*}

If Info[Length(Info)]='|' Then Dec(Info[0]);  {*Enleve le dernier | si besoin*}
I.Qtt:=Str_Count(Info,'|');
I.Info:=Info;
I.Id:=Id;
I.Status:=No;
MaxX:=0;
For A:=1 to I.Qtt do
   Begin
   L:=Length(Str_Get(I.Info,A,'|'));
   If MaxX<L Then MaxX:=L;
   End;
I.X1:=X1;                               {*Test box position*}
I.Y1:=Y1;
I.X2:=X2;
I.Y2:=Y2;

Save_Context(MyContext,0);                {!} {*Remplacer tout ce bordel par une fonction qui renvois la taille de la fonte*}
Font_Set(Sys.FontHint,Sys.FontHintSize);
I.SizeX:=MaxX*(LaF+1)+11;               {*Hint size X,Y*}
I.SizeY:=I.Qtt*(HaF)+4;
Font_Set(Sys.FontMain,Sys.FontMainSize);
Restore_Context(MyContext);

Time_InitTimer(I.Time);                 {*Initialise le Timer*}
End;

{ͻ
                            PROCEDURE Hint_Done                             
 ͹
  IN.....: Inf1 (THint) = Pointer to the Hint structure.                    
  OUT....: /                                                                
  EXPLAIN: Kill the Hint gadget.                                            
  NB.....: This procedure is not used frequently.                           
  SEEALSO: Hint, Hint_GetMsg                                                
 ͼ}

Procedure Hint_Done(Var I:THint);
Var Context:TScreenContext;             {*Screen context*}
Begin
If Not I.Status Then Exit;              {*Gadget not displayed => Exit*}
BCLR(Id_Gad1,7);                        {*No hint displayed*}
Save_Context(Context,1);
I.Swap.PutImageToScreen(I.Xd,I.Yd);     {*Refresh Under the Info Box*}
I.Swap.Destroy;
Restore_Context(Context);
I.Status:=No;                           {*Not displayed now*}
End;

{ͻ
                            FUNCTION Hint_GetMsg                            
 ͹
  IN.....: Inf1 (THint) = Pointer to the Hint structure.                    
           M (Word) = Activation code.                                      
  OUT....: (BYTE) = Message Id as:                                          
               CMNone               No messages                             
               CMActivated          Hint displayed                          
  EXPLAIN: Test if the component is selected.                               
  EXAMPLE: If Hint_GetMsg(Inf1)=TRUE Then...                                
  NB.....: Warning this gadgets must be used only with clipped windows.     
  SEEALSO: Hint                                                             
 ͼ}

Function Hint_GetMsg(Var I:THint):Byte;
Var      A:Word;
         Mx,My:Integer;
         wmx,wmy: word;
         Context:TScreenContext;        {*Screen context*}

Begin
Hint_GetMsg:=CMNone;
If Not BTST(I.Id,0) Then Exit;          {*Info Inactivated*}
If Not Sys.DisplayHints Then Exit;      {*Interface does not display Hints*}
If I.Info='' Then Exit;                 {*No text to display*}

Mse_GetPos(wmx,wmy);          {*Get mouse coordinates*}
Mx := wmx; My := wmy;

If (Mx<>I.MOx) Or (My<>I.MOy) Or (Mse_Clicked(1)) Then I.Time.Show:=No; {*Init Timer*}

If BTST(I.Id,2) Then I.TempsOk:=Time_TestTimer(60,I.Time)   {*Must Wait 2 Seconds...*}
   Else I.TempsOk:=True;

If Mse_TestBox(I.X1,I.Y1,I.X2,I.Y2,0)=Yes Then
   Begin
   If (I.Status=No) And (I.TempsOk) And (Not BTST(Id_Gad1,7)) Then
      Begin
      If BTST(I.Id,1) Then Begin I.Xd:=I.X2; I.Yd:=I.Y2; End
                      Else Begin I.Xd:=Mx+8; I.Yd:=My+12; End;
      I.Xf:=I.Xd+I.SizeX; I.Yf:=I.Yd+I.SizeY; {*Set coordinates in struct*}
      Coord_WinInScreen(I.Xd,I.Yd,I.Xf,I.Yf); {*Dplace la Boite le Cas chant*}
      Hint_GetMsg:=CMActivated;
      I.Status:=Yes;
      Save_Context(Context,1);
      I.Swap:=TRefresh.Create;
      I.Swap.GetImageFromScreen(I.Xd,I.Yd,I.Xf,I.Yf); {*Save Under the Info Box*}
      Bevel (I.Xd,I.Yd,I.Xf,I.Yf, CLBgInfo,BLUniformLine,BLNoLine,Yes);
      BSET(Id_Gad1,7);                  {*Prvient MOS...*}
      For A:=1 to I.Qtt do Display(I.Xd+6, I.Yd+HaF*(A-1)+1, CLText, Sys.FontHint,Sys.FontHintSize, Str_Get(I.Info,A,'|'));
      Restore_Context(Context);
      End;
   End
   Else Hint_Done(I);                   {*Kill hint*}

I.MOx:=Mx; I.MOy:=My;                   {*Save Coordonnes Souris*}
End;

{}
{}
{}

{ͻ
                          PROCEDURE Button_Define                           
 ͹
  IN.....: X,Y (INTEGER) = Button coordinates.                              
           Sx (INTEGER) = Horizontal button size in pixels.                 
           Sy (INTEGER) = Vertical button size in pixels :                  
                 If size is set to -1, the size is automatically ajusted    
                 to the current font size.                                  
           CoP (LONGINT) = Text color.                                      
           CoB (LONGINT) = Background color.                                
           Id (BYTE) = Button bits definitions :                            
                 Bit 0  $0001 : 1 = Use image palette to Display Image      
                 Bit 1  $0002 : 1 = Freezed button                          
                 Bit 2  $0004 : 1 = Unvisible button                        
                 Bit 3  $0008 : 1 = Display image in the button :           
                                Only ICO, BMP format are supported.         
                                Path  and filename are the button label.    
                    NB : You can define two BMP images for your button      
                         Example : 'UNPRESS.BMP|PRESSED.BMP'.               
                 Bit 4  $0010 : 1 = Pointer become "Hand" over the button   
                 Bit 5  $0020 : 1 = Constant color when button is clicked.  
                 Bit 6  $0040 : 1 = Text shifted when button is clicked.    
                 Bit 7  $0080 : 1 = Send TRUE after delay on button.        
                 Bit 8  $0100 : 1 = Select button by ENTER key              
                 Bit 9  $0200 : 1 = Do not display the box button           
                 Bit 10 $0400 : 1 = Text underlined                         
                 Bit 11 $0800 : 1 = Text button on left side                
           But1 (TButton) = Pointer to the button structure.                
           Name (STRING) = Button label to be displayed.                    
           MPointer (STRING) = Mouse pointer to use.                        
           StHint (STRING) = Hint text to be displayed.                     
  EXPLAIN: Define and display a button.                                     
  OUT....: /                                                                
  NB.....: In olders versions of MOS, there was possible to define a locked 
           position for a button. Option is not available now.              
  EXAMPLE: Button(10,50,130,-1,0,7,$70,But1,'Open File');                   
           Button(10,70,35, -1,0,7,$18,But2,'C:\MOS\EYE.ICO');              
  SEEALSO: Button, Button_Draw, Button_Freeze, Button_GetMsg                
 ͼ}

Procedure Button_Define(X,Y,Sx,Sy:Integer; CoP,CoB:Longint; Id:Word; Var But:TButton; St,MPointer,StHint:String);
Var Tmp:Integer;                        {*Variable Temporaire pour Calculs*}
    C:TCoordinates;

Begin
Log.Add('Create new Button ('+St+')',2);
If Sy=-1 Then Sy:=Syb;                  {*Taille Y Automatique*}

C.X1:=X; C.Y1:=Y; C.X2:=C.X1+Sx; C.Y2:=C.Y1+Sy;
If BTST(Id,4) Then MPointer:=MPHand;
MseZone(But.Pointer,C,10,MPointer,StHint); {*Define mouse pointer*}

If Id_Scr1 And $8=$8 Then Begin         {*Window Clipped*}
   X:=X+T_Clip.X1;Y:=Y+T_Clip.Y1;       {*Restore True Coordonnes*}
   End;

But.VanillaKey:=0;                      {*Traitement Vanilla Key*}
If Not BTST(Id,3) Then
   Begin
   Tmp:=Pos('_',St);                    {*Recherche Touche d'Activation*}
   If Tmp>0 Then Begin
      Delete(St,Tmp,1);                 {*Vanilla Key Trouve*}
      But.TCT:=St;
      But.VanillaKey:=Tmp;
      End;
   End;

If But.Vanillakey=0 Then But.TCT:=St;
But.Font.Name:=Sys.FontCurrent;         {*Save Used Font*}
But.Font.Size:=Sys.FontCurrentSize;
But.Font.PenColor:=CoP;                 {*Couleurs du Bouton*}
But.Font.BgColor:=CoB;

But.X1:=X;                              {*Build Graphic Button Structure*}
But.Y1:=Y;
But.X2:=X+Sx;                           {*Size X et Y Button...*}
But.Y2:=Y+Sy;
But.Flg_But:=FALSE;                     {*Button Not Activated*}
But.Id:=Id;                             {*Bits Id*}
But.IdIn:=0;
But.ButSp:=0;                           {*Pas un Bouton Spcial de Base*}
But.Ox1:=0; But.Oy1:=0;                 {*Button image parameters reseted*}
But.Ox2:=0; But.Oy2:=0;
End;

{ͻ
                              PROCEDURE Button                              
 ͹
  IN.....: X,Y (INTEGER) = Button coordinates.                              
           Sx (INTEGER) = Horizontal button size in pixels.                 
           Sy (INTEGER) = Vertical button size in pixels :                  
                 If size is set to -1, the size is automatically ajusted    
                 to the current font size.                                  
           CoP (LONGINT) = Text color.                                      
           CoB (LONGINT) = Background color.                                
           Id (BYTE) = Button bits definitions :                            
                 Bit 0  $0001 : 1 = Use image palette to Display Image      
                 Bit 1  $0002 : 1 = Freezed button                          
                 Bit 2  $0004 : 1 = Unvisible button                        
                 Bit 3  $0008 : 1 = Display image in the button :           
                                Only ICO, BMP format are supported.         
                                Path  and filename are the button label.    
                    NB : You can define two BMP images for your button      
                         Example : 'UNPRESS.BMP|PRESSED.BMP'.               
                 Bit 4  $0010 : 1 = Pointer become "Hand" over the button   
                 Bit 5  $0020 : 1 = Constant color when button is clicked.  
                 Bit 6  $0040 : 1 = Text shifted when button is clicked.    
                 Bit 7  $0080 : 1 = Send TRUE after delay on button.        
                 Bit 8  $0100 : 1 = Select button by ENTER key              
                 Bit 9  $0200 : 1 = Do not display the box button           
                 Bit 10 $0400 : 1 = Text underlined                         
                 Bit 11 $0800 : 1 = Text button on left side                
           But1 (TButton) = Pointer to the button structure.                
           Name (STRING) = Button label to be displayed.                    
  EXPLAIN: Define and display a button.                                     
  OUT....: /                                                                
  NB.....: In olders versions of MOS, there was possible to define a locked 
           position for a button. Option is not available now.              
  EXAMPLE: Button(10,50,130,-1,0,7,$70,But1,'Open File');                   
           Button(10,70,35, -1,0,7,$18,But2,'C:\MOS\EYE.ICO');              
  SEEALSO: Button_Define, Button_Draw, Button_Freeze, Button_GetMsg         
 ͼ}

Procedure Button(X,Y,Sx,Sy:Integer; CoP,CoB:Longint; Id:Word; Var But:TButton; St:String);
Begin
Button_Define(X,Y,Sx,Sy,CoP,CoB,Id,But,St,'','');
Button_Draw(But);
End;

{ͻ
                              PROCEDURE Button                              
 ͹
  IN.....: X,Y (INTEGER) = Button coordinates.                              
           Sx (INTEGER) = Horizontal button size in pixels.                 
           Sy (INTEGER) = Vertical button size in pixels :                  
                 If size is set to -1, the size is automatically ajusted    
                 to the current font size.                                  
           CoP (LONGINT) = Text color.                                      
           CoB (LONGINT) = Background color.                                
           Id (BYTE) = Button bits definitions :                            
                 Bit 0  $0001 : 1 = Use image palette to Display Image      
                 Bit 1  $0002 : 1 = Freezed button                          
                 Bit 2  $0004 : 1 = Unvisible button                        
                 Bit 3  $0008 : 1 = Display image in the button :           
                                Only ICO, BMP format are supported.         
                                Path  and filename are the button label.    
                    NB : You can define two BMP images for your button      
                         Example : 'UNPRESS.BMP|PRESSED.BMP'.               
                 Bit 4  $0010 : 1 = Pointer become "Hand" over the button   
                 Bit 5  $0020 : 1 = Constant color when button is clicked.  
                 Bit 6  $0040 : 1 = Text shifted when button is clicked.    
                 Bit 7  $0080 : 1 = Send TRUE after delay on button.        
                 Bit 8  $0100 : 1 = Select button by ENTER key              
                 Bit 9  $0200 : 1 = Do not display the box button           
                 Bit 10 $0400 : 1 = Text underlined                         
                 Bit 11 $0800 : 1 = Text button on left side                
           But1 (TButton) = Pointer to the button structure.                
           Name (STRING) = Button label to be displayed.                    
           MPointer (STRING) = Mouse pointer to use.                        
           StHint (STRING) = Hint text to be displayed.                     
  EXPLAIN: Define and display a button.                                     
  OUT....: /                                                                
  NB.....: In olders versions of MOS, there was possible to define a locked 
           position for a button. Option is not available now.              
  EXAMPLE: Button(10,50,130,-1,0,7,$70,But1,'Open File');                   
           Button(10,70,35, -1,0,7,$18,But2,'C:\MOS\EYE.ICO');              
  SEEALSO: Button_Define, Button_Draw, Button_Freeze, Button_GetMsg         
 ͼ}

Procedure Button(X,Y,Sx,Sy:Integer; CoP,CoB:Longint; Id:Word; Var But:TButton; St,MPointer,Hint:String);
Begin
Button_Define(X,Y,Sx,Sy,CoP,CoB,Id,But,St,MPointer,Hint);
Button_Draw(But);
End;

{ͻ
                           PROCEDURE Button_Draw                            
 ͹
  IN.....: But1 (TButton) = Pointer to a Button structure.                  
  OUT....: /                                                                
  EXPLAIN: Display the specified gadget.                                    
  EXAMPLE: Button_Draw(But1);                                               
  SEEALSO: Button, Button_Freeze, Button_GetMsg                             
 ͼ}

Procedure Button_Draw(B:TButton);
Var Px,Py:Integer;                      {*Pos X,Y des Donnes*}
    X1,Y1,X2,Y2:Integer;
    PGy:Integer;
    Pdx,Pdy:Integer;                    {*Position dbut Texte ou Img*}
    D,Dt:Integer;                       {*Dcalage Affichage quand on Appuie*}
    VX1,VY1,VX2,VY2:Integer;            {*Coordones pour le ViewPort*}
    VP:TViewPortType;                   {*Pour Rtablissement du ViewPort*}
    Name:String;
    Color1,Color2:LongInt;
    Inv:Byte;
    Ox,Oy:Integer;
    Text1:TText;
    Offset:Integer;                     {*Adjust box if don't draw borders*}

Begin
If BTST(B.Id,2) Then Exit;              {*Invisible Button*}

VX1:=B.X1; VY1:=B.Y1; VX2:=B.X2; VY2:=B.Y2; {*Restore True Coordonnes*}

If BTST(Id_Scr1,3) Then Begin           {*Window Clipped*}
   X1:=B.X1-T_Clip.X1; Y1:=B.Y1-T_Clip.Y1;
   X2:=B.X2-T_Clip.X1; Y2:=B.Y2-T_Clip.Y1;
   If Not Coord_RealClipBox(VX1,VY1,VX2,VY2) Then Exit; {*Coord ViewPort Bouton*}
   End Else Begin                       {*No Modifs...*}
   X1:=B.X1; Y1:=B.Y1; X2:=B.X2; Y2:=B.Y2;
   End;

Mse_Hide; Dt:=0;

If B.Flg_But                            {*On Appuie sur le Bouton ?*}
   Then Begin Color1:=Col_SetSaturation(B.Font.BgColor,70); Inv:=BLLoweredLine; D:=1; If BTST(B.Id,6) Then Dt:=1; End
   Else Begin Color1:=B.Font.BgColor; Inv:=BLRaisedLine; D:=0; End;

If BTST(B.Id,5) Then Color1:=B.Font.BgColor; {*Couleur Constante*}

If Not BTST(B.Id,9) Then
   Begin
   Offset:=0;
   Bevel (X1,Y1,X2,Y2, Color1,Inv,BLNoLine,Yes);{*Affiche la Bevel*}
   If B.ButSp=9 Then VESA_PutPixel(X1,Y2,CLLineDown);{*Efface Point Disgracieux*}
   End Else Offset:=1;

VESA_GetViewSettings(VP);               {*Get current ViewPort*}
VESA_SetViewPort(VX1+1,VY1+1,VX2-1,VY2-1,ClipOn);
VESA_SetFillStyle(1,CLCursor+1);

If Pos('|',B.TCT)=0 Then Name:=B.TCT    {*1 seul label*}
   Else                                 {*Get String to Display*}
   If B.Flg_But Then Name:=Str_Get(B.TCT,2,'|') {*Si deux images diffrentes*}
                Else Name:=Str_Get(B.TCT,1,'|');

If BTST(B.Id,3) Then Begin              {*Image Button ICO*}
   If B.Flg_But Then Begin Ox:=B.Ox2; Oy:=B.Oy2; End Else Begin Ox:=B.Ox1; Oy:=B.Oy1; End;
   Py:=((Y2-Y1)-20) Div 2;
   If Py<0 Then Py:=0;
   If Pos('.ICO',Name)>0 Then Show_Icon(X1+Dt+2-Offset,Y1+Dt+7-Offset,Name);
   If Pos('.BMP',Name)>0 Then BMP_Show (X1+Dt+1-Offset,Y1+Dt+1-Offset,X2-1+Offset,Y2-1+Offset,Ox,Oy,Name,$0080);
   End
   Else Begin
   Font_Set(B.Font.Name,B.Font.Size);   {*Passe en Fonte pour le Bouton*}
   If BTST(B.Id,11) Then Px:=5          {*Text Left Justify*}
                    Else Px:=(((X2-X1)-VESA_TextWidth(Name)) Div 2);
   If Px<3 Then Px:=3;
   Py:=(((Y2-Y1)-HaF) Div 2)+4;         {*Texte Bouton*}
   If (B.Flg_But) And (Not BTST(B.Id,5))
      Then Begin Color1:=Col_GetNegative(B.Font.BgColor); Color2:=B.Font.PenColor XOR CLWhite; End
      Else Begin Color1:=B.Font.BgColor; Color2:=B.Font.PenColor; End;
   Pdx:=Px+Dt-1; Pdy:=Py+Dt-6;
   Display_Define(Text1,Pdx,Pdy,Color1,Color2,'',0,TJOnLeft,$0000,B.TCT);
   Display_Draw(Text1);

   VESA_SetColor(Color2);
   If BTST(B.Id,10) Then VESA_Line(Pdx-1, Pdy+HaF+1, Pdx-1+VESA_TextWidth(Name), Pdy+HaF+1);
   If Not ((B.Flg_But) And (BTST(B.Id,6))) Then
   If (B.VanillaKey>0) Then
      Begin                             {*Affiche Underscore...*}
      Px:=Px+VESA_TextWidth(Copy(Name,1,B.VanillaKey-1))-2;
      VESA_Line(Px, Py+HaF-5, Px+LaF+1, Py+HaF-5);
      End;
   Font_Set(Sys.FontPrevious,Sys.FontPreviousSize);   {*Repasse dans la fonte Prcdente*}
   End;

PGy:=((VY2-VY1) Div 2)+D-7;
Case B.ButSp of
     2: DrawGad_LeftArrow(D,PGy);       {*Affiche Gadget Flche Gauche*}
     3: DrawGad_RightArrow(D,PGy);      {*Affiche Gadget Flche Droite*}
     4: DrawGad_UpArrow(D,PGy);         {*Affiche Gadget Flche Haut*}
     5: DrawGad_DownArrow(D,PGy);       {*Affiche Gadget Flche Bas*}
     6: DrawGad_Close(D,PGy);           {*Affiche Gadget Close*}
     7: DrawGad_Swap(D,PGy);            {*Affiche Gadget Swap*}
     8: DrawGad_Extend(D,PGy);          {*Affiche Gadget Extend*}
     9: DrawGad_Size(D,PGy);            {*Affiche Gadget Size*}
     End;

VESA_SetViewPort(VP.X1,VP.Y1,VP.X2,VP.Y2,ClipOn); {*Restore Normal ViewPort*}

If (BTST(B.Id,8)) And (Not BTST(B.Id,9)) Then
   Begin                                {*Bouton prslectionn*}
   VESA_SetColor(CLShadow);
   VESA_Rectangle(X1-1,Y1-1,X2+1,Y2+1);
   End;
Mse_Show;

If BTST(B.Id,1) Then Button_Freeze(Yes,B); {*Freezed Button*}
End;

{ͻ
                          PROCEDURE Button_Freeze                           
 ͹
  IN.....: On/Off (BOOLEAN) = (On = Enable gadget).                         
           But1 (Var TButton) = Pointer to the Button structure.            
  OUT....: /                                                                
  EXPLAIN: Enable or disable the Button gadget.                             
  EXAMPLE: Button_Freeze(On,But1);                                          
  SEEALSO: Button, Button_Draw, Button_GetMsg                               
 ͼ}

Procedure Button_Freeze(Status:Boolean; Var B:TButton);
Var X1,Y1,X2,Y2:Integer;

Begin
X1:=B.X1-T_Clip.X1; Y1:=B.Y1-T_Clip.Y1;
X2:=B.X2-T_Clip.X1; Y2:=B.Y2-T_Clip.Y1;
If Status=Yes                               {*Bouton  dsactiver*}
   Then Begin BSET(B.Id,1); Bar_FillGray(X1+1, Y1+1, X2-1, Y2-1); End
   Else Begin BCLR(B.Id,1); Button_Draw(B);End; {*Bouton  Activer*}
End;

{ͻ
                           FUNCTION Button_GetMsg                           
 ͹
  IN.....: But1 (TButton) = Pointer to the Button structure.                
           M (Word) = Activation code.                                      
  OUT....: (BYTE) = Message Id as:                                          
               CMNone               No messages                             
               CMSelected           Button selected                         
  EXPLAIN: Test if the component is selected.                               
  EXAMPLE: If Button_GetMsg(But1,1)=CMSelected Then...                      
  SEEALSO: Button, Button_Draw, Button_Freeze                               
 ͼ}

Function Button_GetMsg(Var B:TButton; M:Word):Byte;
Var      X,Y:Word;
         Ga,Mi,Dr:Boolean;

Begin
Button_GetMsg:=CMNone;                  {*De Base*}

If BTST(B.Id,1) Then Exit;              {*Button Freezed*}
If Sys.LightBoxMinSized Then Exit;      {*Light Box en-train d'tre trace => Exit*}
If Sys.SlidersActivated>0 Then Exit;    {*Un Slider Dplac quelque part => Exit*}
If BTST(Id_Gad1,14) Then Exit;          {*Un Canvas Dplac quelque part => Exit*}
If Sys.WinMoved Then Exit;
If Sys.WinSized Then Exit;

If (Kbd_GetKeyDown(VK_CONTROL)) And (B.Vanillakey>0) Then
Begin
   BSET(B.IdIn,1);                      {*Accs par Clavier*}
//   If (Kbd_TestKey(B.VaniA, B.VaniS)) And (Not B.Flg_But) Then
   If (Kbd_GetKeyDown(Kbd_GetVkValue(B.TCT[B.VanillaKey]))) And
      (Not B.Flg_But) Then
   Begin
      B.Flg_But:=TRUE;                  {*Bouton Invers !*}
      Button_Draw(B);
   End;
End;

If (Not Kbd_GetKeyDown(VK_CONTROL)) And (B.Vanillakey>0) And (B.Flg_But) And (BTST(B.IdIn,1)) Then
   Begin
   B.Flg_But:=FALSE;
   BCLR(B.IdIn,1);                      {*CTRL Relach*}
   Button_Draw(B);
   Button_GetMsg:=CMSelected;           {*Bouton Slectionn !*}
   End;

If Not Kbd_GetKeyDown(VK_CONTROL) Then BCLR(B.IdIn,1); {*CTRL Relach*}

If (BTST(B.Id,8)) And (Kbd_GetKeyDown(VK_RETURN)) Then Button_GetMsg:=CMSelected; {*ENTER Key*}

Mse_Get(X,Y,Ga,Mi,Dr);                  {*Test pour Bouton Enfonc*}

MseZone_GetMsg(B.Pointer);

If Mse_TestBox(B.X1,B.Y1,B.X2,B.Y2,10) Then
   Begin
   If BTST(B.Id,4) Then                 {*Mouse Pointer sur Bouton ?*}
      Begin BSET(Id_Gad1,5); BSET(B.IdIn,0); End;
   If (Mse_Clicked(M)) And (Not B.Flg_But) Then
      Begin
      B.Flg_But:=TRUE;                  {*Invers !*}
      Sys.ButtonsActivated := Sys.ButtonsActivated + 1;
      Button_Draw(B);
      End;
   End
   Else Begin                           {*On ne passe plus sur le Bouton*}
   If (BTST(B.Id,4)) And (BTST(B.IdIn,0)) Then
      Begin BCLR(Id_Gad1,5); BCLR(B.IdIn,0); End;
   If (B.Flg_But) And (Not BTST(B.IdIn,1)) Then
      Begin B.Flg_But:=FALSE;
      Sys.ButtonsActivated := Sys.ButtonsActivated - 1;
      Button_Draw(B);
      End;
   End;

If (Not Mse_Clicked(M)) And (B.Flg_But) And (Not BTST(B.IdIn,1)) Then
   Begin                                {*Relach !*}
   B.Flg_But:=FALSE;
   Button_GetMsg:=CMSelected;           {*Slectionn !*}
   Sys.ButtonsActivated := Sys.ButtonsActivated - 1;
   Button_Draw(B);
   End;

If Not Mse_Clicked(M) Then Sys.ButtonsActivated:=0;   {!} {*Patch*}

If (Mse_TestDelay) And (B.Flg_But) Then {*Boutons en Continue (Slider)*}
   Begin
   If ((B.ButSp>=2) And (B.ButSp<=5)) Then Button_GetMsg:=CMSelected;
   If BTST(B.Id,7) Then Button_GetMsg:=CMSelected; {*Bouton en continu*}
   End;
End;

{}
{}
{}

{ͻ
                          PROCEDURE Cycler_Define                           
 ͹
  IN.....: X,Y (INTEGER) = Cycler coordinates.                              
           Size (INTEGER) = Horizontal Cycler size in pixels.               
           Num (INTEGER) = Label number to be displayed first.              
           CoP (BYTE) = Text color.                                         
           CoB (BYTE) = Background color.                                   
           Id (BYTE) = Cycler bits definitions :                            
                 Bit 0  $0001 : 1 = Use image palette to Display Image      
                 Bit 1  $0002 : 1 = Freezed Cycler                          
                 Bit 2  $0004 : 1 = Unvisible Cycler                        
                 Bit 3  $0008 : 1 = Display image in the Cycler :           
                                Only ICO, BMP format are supported.         
                                Path  and filename are the button label.    
                 Bit 4  $0010 : 1 = Pointer become "Hand" over the Cycler   
                 Bit 5  $0020 : 1 = Constant color when button is clicked.  
                 Bit 6  $0040 : 1 = Text shifted when button is clicked.    
                 Bit 7  $0080 : 1 = Send TRUE after delay on button.        
                 Bit 8  $0100 : 1 = Select button by ENTER key              
                 Bit 9  $0200 : 1 = Do not display the box button           
                 Bit 10 $0400 : 1 = Text underlined                         
                 Bit 11 $0800 : 1 = Text button on left side (Forced)       
                 Bit 15 $8000 : 1 = Do not display the "Loop" image         
           Cyc1 (TCycler) = Pointer to the Cycler structure.                
           Name (STRING) = Cycler labels to be displayed.                   
           MPointer (STRING) = Mouse pointer to use.                        
           SHint (STRING) = Hint to be displayed.                           
  EXPLAIN: Define a Cycler component.                                       
           A gadget Cycler is a special button that have one or more labels.
  NB.....: Labels must be separated by the '|' caracter.                    
  OUT....: /                                                                
  EXAMPLE: Cycler(10,80,100,1,0,7,$10,Cyc1,'CRUNCH|DECRUNCH|AUTO DETECT|'); 
  SEEALSO: Cycler_Draw, Cycler_Freeze, Cycler_GetMsg                        
 ͼ}

Procedure Cycler_Define(X,Y,Size,Num:Integer; CoP,CoB:LongInt; Id:Word; Var C:TCycler; St,MPointer,SHint:String);
Var Sx,Sy:Word;
    SizeY:Integer;
    Co:Longint;
    Px:Integer;
    St1:String;

Begin
Log.Add('Create new Cycler ('+St+')',2);

If Copy(St,Length(St),1)='|' Then Delete(St,Length(St),1);
C.TCT:=St;
C.Id:=Id;
C.CyclVal:=Num;                         {*Option "Cycler" = Numero du Texte*}

If (Num<=0) Or (Num>Str_Count(St,'|')) Then Num:=1;
St1:=Str_Get(St,C.CyclVal,'|');
If BTST(Id,3) Then
   Begin                                {*Display Image*}
   If BMP_TestFile(St1) Then
      Begin
      BMP_GetInfo(St1,Sx,Sy,Co); Inc(Sy);
      SizeY:=Sy;
      End
      Else SizeY:=35;                   {*35 pour Grand icnes de base*}
   End Else SizeY:=-1;                  {*Display Text*}

If BTST(Id,15) Then Px:=X Else Px:=X+19;
Button_Define(Px,Y,Size,SizeY,CoP,CoB,Id+$0800,C.B,St1,MPointer,SHint);
End;

{ͻ
                              PROCEDURE Cycler                              
 ͹
  IN.....: X,Y (INTEGER) = Cycler coordinates.                              
           Size (INTEGER) = Horizontal Cycler size in pixels.               
           Num (INTEGER) = Label number to be displayed first.              
           CoP (BYTE) = Text color.                                         
           CoB (BYTE) = Background color.                                   
           Id (BYTE) = Cycler bits definitions :                            
                 Bit 0  $0001 : 1 = Use image palette to Display Image      
                 Bit 1  $0002 : 1 = Freezed Cycler                          
                 Bit 2  $0004 : 1 = Unvisible Cycler                        
                 Bit 3  $0008 : 1 = Display image in the Cycler :           
                                Only ICO, BMP format are supported.         
                                Path  and filename are the button label.    
                 Bit 4  $0010 : 1 = Pointer become "Hand" over the Cycler   
                 Bit 5  $0020 : 1 = Constant color when button is clicked.  
                 Bit 6  $0040 : 1 = Text shifted when button is clicked.    
                 Bit 7  $0080 : 1 = Send TRUE after delay on button.        
                 Bit 8  $0100 : 1 = Select button by ENTER key              
                 Bit 9  $0200 : 1 = Do not display the box button           
                 Bit 10 $0400 : 1 = Text underlined                         
                 Bit 11 $0800 : 1 = Text button on left side (Forced)       
                 Bit 15 $8000 : 1 = Do not display the "Loop" image         
           Cyc1 (TCycler) = Pointer to the Cycler structure.                
           Name (STRING) = Cycler labels to be displayed.                   
  EXPLAIN: Define and display a gadget Cycler.                              
           A gadget Cycler is a special button that have one or more labels.
  NB.....: Labels must be separated by the '|' caracter.                    
  OUT....: /                                                                
  EXAMPLE: Cycler(10,80,100,1,0,7,$10,Cyc1,'CRUNCH|DECRUNCH|AUTO DETECT|'); 
  SEEALSO: Cycler_Draw, Cycler_Freeze, Cycler_GetMsg                        
 ͼ}

Procedure Cycler(X,Y,Size,Num:Integer; CoP,CoB:LongInt; Id:Word; Var C:TCycler; St:String);
Begin
Cycler_Define(X,Y,Size,Num,CoP,CoB,Id,C,St,'','');
Button_Draw(C.B);
Cycler_Draw(C);                         {*Affiche le Cycler*}
End;

{ͻ
                              PROCEDURE Cycler                              
 ͹
  IN.....: X,Y (INTEGER) = Cycler coordinates.                              
           Size (INTEGER) = Horizontal Cycler size in pixels.               
           Num (INTEGER) = Label number to be displayed first.              
           CoP (BYTE) = Text color.                                         
           CoB (BYTE) = Background color.                                   
           Id (BYTE) = Cycler bits definitions :                            
                 Bit 0  $0001 : 1 = Use image palette to Display Image      
                 Bit 1  $0002 : 1 = Freezed Cycler                          
                 Bit 2  $0004 : 1 = Unvisible Cycler                        
                 Bit 3  $0008 : 1 = Display image in the Cycler :           
                                Only ICO, BMP format are supported.         
                                Path  and filename are the button label.    
                 Bit 4  $0010 : 1 = Pointer become "Hand" over the Cycler   
                 Bit 5  $0020 : 1 = Constant color when button is clicked.  
                 Bit 6  $0040 : 1 = Text shifted when button is clicked.    
                 Bit 7  $0080 : 1 = Send TRUE after delay on button.        
                 Bit 8  $0100 : 1 = Select button by ENTER key              
                 Bit 9  $0200 : 1 = Do not display the box button           
                 Bit 10 $0400 : 1 = Text underlined                         
                 Bit 11 $0800 : 1 = Text button on left side (Forced)       
                 Bit 15 $8000 : 1 = Do not display the "Loop" image         
           Cyc1 (TCycler) = Pointer to the Cycler structure.                
           Name (STRING) = Cycler labels to be displayed.                   
           MPointer (STRING) = Mouse pointer to use.                        
           SHint (STRING) = Hint to be displayed.                           
  EXPLAIN: Define and display a gadget Cycler.                              
           A gadget Cycler is a special button that have one or more labels.
  NB.....: Labels must be separated by the '|' caracter.                    
  OUT....: /                                                                
  EXAMPLE: Cycler(10,80,100,1,0,7,$10,Cyc1,'CRUNCH|DECRUNCH|AUTO DETECT|'); 
  SEEALSO: Cycler_Draw, Cycler_Freeze, Cycler_GetMsg                        
 ͼ}

Procedure Cycler(X,Y,Size,Num:Integer; CoP,CoB:LongInt; Id:Word; Var C:TCycler; St,MPointer,SHint:String);{*Display extended Cycler*}
Begin
Cycler_Define(X,Y,Size,Num,CoP,CoB,Id,C,St,MPointer,SHint);
Button_Draw(C.B);
Cycler_Draw(C);                         {*Affiche le Cycler*}
End;

{ͻ
                           PROCEDURE Cycler_Draw                            
 ͹
  IN.....: Cyc1 (TCycler) = Pointer to a Cycler structure.                  
  OUT....: /                                                                
  EXPLAIN: Display the specified gadget.                                    
  EXAMPLE: Cycler_Draw(Cyc1);                                               
  SEEALSO: Cycler, Cycler_Freeze, Cycler_GetMsg                             
 ͼ}

Procedure Cycler_Draw(C:TCycler);
Var X1,Y1:Integer;

Begin
If BTST(C.Id,2) Then Exit;              {*Invisible Button*}
Button_Draw(C.B);

If Not BTST(C.B.Id,15) Then
   Begin
   X1:=C.B.X1-T_Clip.X1; Y1:=C.B.Y1-T_Clip.Y1;
   BMP_ShowTransparency(X1-19,Y1,X1+20,Y1+20,0,0,Sys.GetPath(SP_BUTTONS)+Sys.ImgCycler,$0080,CLTransparency);
   End;

If BTST(C.Id,1) Then Cycler_Freeze(Yes,C); {*Freezed Cycler*}
End;

{ͻ
                          PROCEDURE Cycler_Freeze                           
 ͹
  IN.....: On/Off (BOOLEAN) = (On = Enable gadget).                         
           Cyc1 (Var TCycler) = Pointer to the Cycler structure.            
  OUT....: /                                                                
  EXPLAIN: Enable or disable the Cycler gadget.                             
  EXAMPLE: Cycler_Freeze(On,Cyc1);                                          
  SEEALSO: Cycler, Cycler_Draw, Cycler_GetMsg                               
 ͼ}

Procedure Cycler_Freeze(Status:Boolean; Var C:TCycler);
Begin
Button_Freeze(Status,C.B);              {*Utilise le Freeze du bouton*}
End;

{ͻ
                           FUNCTION Cycler_GetMsg                           
 ͹
  IN.....: Cyc1 (TCycler) = Pointer to the Cycler structure.                
           M (Word) = Activation code.                                      
  OUT....: (BYTE) = Message Id as:                                          
               CMNone               No messages                             
               CMSelected           Button selected                         
  EXPLAIN: Test if the gadget is selected.                                  
  EXAMPLE: If Cycler_GetMsg(Cyc1,1)=CMSelected Then...                      
  SEEALSO: Cycler, Cycler_Draw, Cycler_Freeze                               
 ͼ}

Function Cycler_GetMsg(Var C:TCycler; M:Word):Byte;
Var Message:Byte;                       {*Sent message*}
Begin

Cycler_GetMsg:=CMNone;

Message:=Button_GetMsg(C.B,M);
If Message=CMSelected Then              {*Button clicked*}
   Begin

   If Kbd_GetKeyDown(VK_SHIFT) Then Dec(C.CyclVal) Else Inc(C.CyclVal);
   If C.CyclVal>Str_Count(C.TCT,'|') Then C.CyclVal:=1;
   If C.CyclVal<1 Then C.CyclVal:=Str_Count(C.TCT,'|');
   C.B.TCT:=Str_Get(C.TCT,C.CyclVal,'|');
   Cycler_Draw(C);
   Button_Draw(C.B);
   Cycler_GetMsg:=CMSelected;
   End;
If Message=CMMouseOver Then Cycler_GetMsg:=CMMouseOver; {*Mouse over button*}
End;

{*----------------------------- LIGHTBOX -----------------------------------*}

{ͻ
                          FUNCTION LightBox_GetMsg                          
 ͹
  IN.....: LB (TLIGHTBOX) = Record on a variable Light-Box.                 
           M (WORD) = N of the button Souris  Activer.                    
           T (BYTE) = Type of light box (0=Box, 1=Line)                     
  OUT....: LB (TLIGHTBOX) = Record on a variable Light-Box.                 
           (BYTE) = Message Id as:                                          
               CMNone               No messages                             
               CMModified           Box has been defined or modified        
  EXPLAIN: Draw and make bigger a box in dotted on screen.                  
           The coordinates of the box drawed can be read by the fields of   
           the record TLightBox.(X1,Y1,X2,Y2).                              
  EXAMPLE: If GetMsg_LightBox(LB,1)=True Then                               
              Write(LB.X1,' ',LB.Y1,' ',LB.X2,' ',LB.Y2);                   
 ͼ}

Function LightBox_GetMsg(Var LB:TLightBox; M:Word;T:Byte):Byte;
Var X,Y:Word;
    Ga,Mi,Dr:Boolean;

{*********** Draw Box en Pointills ******************}

Procedure LIGHT_BOX_RECTANGLE;                  {*Draw Light Box*}
Var OldStyle: TLineSettingsType;
Begin
VESA_GetLineStyle(OldStyle);                      {*Save Style*}
VESA_SetLineStyle(DottedLn,0,NormWidth);
VESA_SetColor(CLWinBg);

VESA_SetWriteMode(XorPut);
Mse_Hide;
VESA_Rectangle(LB.X1,LB.Y1,LB.X2,LB.Y2);
Mse_Show;
With OldStyle do VESA_SetLineStyle(LineStyle, Pattern, Thickness);  {*Restore Old*}
VESA_SetWriteMode(NormalPut);
End;

{*********** Draw Line en Pointills ******************}

Procedure LIGHT_BOX_LINE;                       {*Draw Light Box*}
Var OldStyle: TLineSettingsType;
Begin
VESA_GetLineStyle(OldStyle);                      {*Save Style*}
VESA_SetLineStyle(DottedLn,0,NormWidth);
VESA_SetColor(CLWinBg);
VESA_SetWriteMode(XorPut);
Mse_Hide;
VESA_Line(LB.X1,LB.Y1,LB.X2,LB.Y2);
Mse_Show;
With OldStyle do VESA_SetLineStyle(LineStyle, Pattern, Thickness);  {*Restore Old*}
VESA_SetWriteMode(NormalPut);
End;

{*********** Draw GetMsg_LightBox ******************}
Procedure DRAW_LIGHT_BOX;
Begin
Case T of
     0 :LIGHT_BOX_RECTANGLE;
     1 :LIGHT_BOX_LINE;
End;
End;


{********************* BOUCLE ET PROCEDURE PRINCIPALE ***********************}

Begin
LightBox_GetMsg:=CMNone;
If Sys.ButtonPressed=Yes Then Exit;                   {*No LightBox with Button*}

Mse_Get(X,Y,Ga,Mi,Dr);
If (Mse_Clicked(M)=True) And (Sys.WinMoved=False) And (Sys.WinSized=False)
Then If Sys.LightBoxActivated=False
        Then Begin                              {*Bouton Prss 1ere Fois*}
             Mse_SetPointer(MPMove);            {*TPointer Dplacement*}
             LB.Xo:=X; LB.Yo:=Y; LB.X1:=X; LB.Y1:=Y; LB.X2:=X; LB.Y2:=Y;
             Sys.LightBoxActivated:=True; Sys.LightBoxMinSized:=False;
             End
        Else If ((LB.Xo<>X) Or (LB.Yo<>Y)) Then
                If (Abs(LB.X1-X)>Sys.LightBoxMinSize) Or (Abs(LB.Y1-Y)>Sys.LightBoxMinSize) Then
                   Begin
                   If Sys.LightBoxMinSized=False Then DRAW_LIGHT_BOX;
                   DRAW_LIGHT_BOX;         {*Clear Old Light Box*}
                   Sys.LightBoxMinSized:=True;
                   LB.Xo:=X; LB.Yo:=Y; LB.X2:=X; LB.Y2:=Y;
                   DRAW_LIGHT_BOX;         {*Draw New Light Box*}
                   End
                   Else If Sys.LightBoxMinSized=True
                        Then Begin DRAW_LIGHT_BOX;
                             LB.Xo:=X; LB.Yo:=Y; LB.X2:=X; LB.Y2:=Y;
                             Sys.LightBoxMinSized:=False;
                             End
                        Else
             Else
Else If Sys.LightBoxActivated=True Then                 {*Bouton Souris Relach*}
        Begin
        Mse_SetPointer(P_Current);              {*TPointer Courrant*}
        If Sys.LightBoxMinSized=True Then DRAW_LIGHT_BOX;
        Sys.LightBoxActivated:=False;
        Sys.LightBoxMinSized:=False;
        If (Abs(LB.X1-X)>Sys.LightBoxMinSize) Or (Abs(LB.Y1-Y)>Sys.LightBoxMinSize) Then
           Begin
           LightBox_GetMsg:=CMModified;
             If T=0 Then   {*Si il s'agit d'un VESA_Rectangle*}
                Begin
                If Lb.X2<Lb.X1 Then Exg(Lb.X1, Lb.X2); {*Coordinates must be Exg*}
                If Lb.Y2<Lb.Y1 Then Exg(Lb.Y1, Lb.Y2);
                End;
           End;
        End;
End;

{ͻ
                          FUNCTION MoveBox_GetMsg                           
 ͹
  IN.....: LB (TLIGHTBOX) = Record on variable Light-Box.                   
           M (WORD) = N of the mouse button to test.                       
  OUT....: (BYTE) = Message Id as:                                          
               CMNone               No messages                             
               CMMoved              Box has been moved                      
  EXPLAIN: Allow you the moving of a box.                                   
  NB.....: The coordinates of box must be defines before the call of the    
           function GetMsg_MoveBox.                                         
  EXAMPLE: LB1.X1:=100; LB1.Y1:=100; LB1.X2:=300; LB1.Y2:=160;              
           If GetMsg_MoveBox(LB1,1)=True Then Write(#7);                    
  SEEALSO: LightBox_GetMsg                                                  
 ͼ}

Function MoveBox_GetMsg(Var LB:TLightBox; M:Word):Byte;
Var X,Y:Word;                           {*Recupere Valeurs Souris*}
    Ga,Mi,Dr:Boolean;
    PM:TPosMse;                         {*Structure Position Souris*}
    First:Boolean;                      {*1er Affichage ou pas*}
    Xa,Ya:Integer;                      {*Coordones pour Comparaison*}
    FClick:Boolean;                     {*Test Mouse*}


Procedure MOVE_FIRST;
Begin
VESA_SetColor(CLWinBg);
VESA_SetWriteMode(XorPut);                   {*Dplace Box with Mouse (XOR)*}
Mse_Hide;
VESA_Rectangle(Lb.X1,Lb.Y1,Lb.X2,Lb.Y2);     {*Efface old Cadre*}
Inc(Lb.X1,(X-Lb.Xo)); Inc(Lb.X2,(X-Lb.Xo)); {*Calcule New Coordones*}
Inc(Lb.Y1,(Y-Lb.Yo)); Inc(Lb.Y2,(Y-Lb.Yo));
Lb.Xo:=X; Lb.Yo:=Y;
VESA_Rectangle(Lb.X1,Lb.Y1,Lb.X2,Lb.Y2);     {*Affiche New Cadre*}
Mse_Show;
VESA_SetWriteMode(NormalPut);
End;


Procedure CLICK_MOVE_BOX;               {*Clique 1ere Fois*}
Begin
Mse_SetPointer(MPMove);                 {*Pointer to Pointer Move Box*}
Mse_SetLimit(X-Lb.X1,Y-Lb.Y1,VESA_GetMaxX-(Lb.X2-X),VESA_GetMaxY-(Lb.Y2-Y));{*Limit Block on Screen*}
First:=True;                            {*1er Affichage ou pas*}
Xa:=Lb.X1; Ya:=Lb.Y1;                   {*Save Old Coordones Box for Move*}
VESA_SetWriteMode(XorPut);
VESA_SetColor(CLWinBg);
Mse_Hide;
VESA_Rectangle(Lb.X1,Lb.Y1,Lb.X2,Lb.Y2);     {*Affiche 1er Cadre*}
Mse_Show;
VESA_SetWriteMode(NormalPut);
Lb.Xo:=X; Lb.Yo:=Y;
End;

{************************ EFFACE DERNIER BOX AFFICHE ************************}

Procedure CLEAR_OLD_CADRE;
Begin                                   {*Efface Dernier Cadre Trac (XOR)*}
Mse_SetPointer(P_Current);              {*Pointer to Pointer Move Box*}
Mse_SetLimit(0,0,VESA_GetMaxX,VESA_GetMaxY);       {*Box Not Bloked on Screen Limits Now*}
VESA_SetWriteMode(XorPut);
VESA_SetColor(CLWinBg);
Mse_Hide;
VESA_Rectangle(Lb.X1,Lb.Y1,Lb.X2,Lb.Y2);     {*Efface Dernier Cadre*}
Mse_Show;
VESA_SetWriteMode(NormalPut);
First:=False;
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
MoveBox_GetMsg:=CMNone;

{gotoxy(1,10); writeln('Fisrt=',First,' ');
gotoxy(1,11); writeln('FClick=',FClick,' ');}

Mse_Get(X,Y,Ga,Mi,Dr);
If Mse_Clicked(M)=False Then FClick:=False;
If (Mse_Clicked(M)=True) And (FClick=False) Then
   Begin PM.X:=X; PM.Y:=Y; FClick:=True; End;   {*Save Coordones Mse*}

If Mse_Clicked(M)=False Then
   Begin
   If (First=True) And (Lb.X1=Xa) And (Lb.Y1=Ya) Then
      CLEAR_OLD_CADRE;                  {*Efface Dernier Cadre Trac (XOR)*}

   If First=True Then
      Begin
      CLEAR_OLD_CADRE;                  {*Efface Dernier Cadre Trac (XOR)*}
      Xa:=Lb.X1; Ya:=Lb.Y1;             {*Correction Bornes*}
      MoveBox_GetMsg:=CMMoved;          {*On a Boug le Box !!!*}
      End
      Else First:=False;                {*Souris Simplement Dclique*}
   End;
                                        {*Dplace Box*}
If ((Mse_Clicked(M)=True) And (First=True)) And ((X<>Lb.Xo) Or (Y<>Lb.Yo)) Then MOVE_FIRST;
If (Mse_TestBox(Lb.X1,Lb.Y1,Lb.X2,Lb.Y2,M)=True) And (First=False)
   And (PM.X>=Lb.X1) And (PM.X<=Lb.X2)
   And (PM.Y>=Lb.Y1) And (PM.Y<=Lb.Y2) Then CLICK_MOVE_BOX;

End;

{ͻ
                               FUNCTION Anim                                
 ͹
  IN.....: A (TAnimate) = Pointer to the Animate structure.                 
           X1,Y1,X2,Y2 (INTEGER) = Annimation coordinates.                  
           Ox,Oy (INTEGER) = X and Y offset for animation.                  
           BName (STRING) = Base name to load animation.                    
              Example: C:\ANIM\FLY\BIRD                                     
              All files must be named as BIRD0000.BMP, BIRD0001.BMP, etc.   
           Id (WORD) = Bits identification:                                 
              See the "BMP_Show" bits definition to use here.               
  OUT....: (BOOLEAN) = TRUE if animation correctly initialised.             
  EXPLAIN: Define an animation using a serie of BMP images.                 
  NB.....: Files must have the BMP suffix and be in the BMP format.         
           BMP filenames must have already 8 caracters.                     
  SEEALSO: Anim_SetParam, Anim_Draw, Anim_Pause                             
 ͼ}

Function Anim(Var A:TAnimate; X1,Y1,X2,Y2,Ox,Oy:Integer; BName:String; Id:Word):Boolean;
Begin
Log.Add('Create new Animation',2);

A.C.X1:=X1;                             {*Set in struct*}
A.C.Y1:=Y1;
A.C.X2:=X2;
A.C.Y2:=Y2;
A.Ox:=Ox;
A.Oy:=Oy;
A.Visible:=Yes;                         {*De base...*}
A.Enabled:=Yes;
A.Cycling:=Yes;
A.Reverse:=No;
A.FrameStep:=1;                         {*1 image per 1*}
A.Frequency:=1;                         {*1 image per call*}
A.FreqIndex:=1;
A.Id:=Id;
A.Index:=0;
A.BaseName:=BName;

A.Count:=File_Count(BName+'*.BMP',FALSE); {*Count how many files in animation*}
A.IndexMin:=0;                          {*Borne Min et Max*}
A.IndexMax:=A.Count;
If A.Count<=0 Then Anim:=FALSE Else Anim:=TRUE;
End;

{ͻ
                          PROCEDURE Anim_SetParam                           
 ͹
  IN.....: A (TAnimate) = Pointer to the Animate structure.                 
           Enabled (BOOLEAN) = Animation enabled or no.                     
           Visible (BOOLEAN) = Animation visible or no.                     
           Cycling (BOOLEAN) = Animation cycling or no.                     
           Reverse (BOOLEAN) = Animation reverse to previous frame.         
  OUT....: /                                                                
  EXPLAIN: Define specific parameters for the TAnimate structure.           
  SEEALSO: Anim                                                             
 ͼ}

Procedure Anim_SetParam(Var A:TAnimate; Enabled,Visible,Cycling,Reverse:Boolean);
Begin
A.Enabled:=Enabled;
A.Visible:=Visible;
A.Cycling:=Cycling;
A.Reverse:=Reverse;
End;

{ͻ
                            PROCEDURE Anim_Draw                             
 ͹
  IN.....: A (TAnimate) = Pointer to the Animate structure.                 
  OUT....: /                                                                
  EXPLAIN: Draw current frame from BMP animation.                           
  SEEALSO: Anim_GetMsg                                                      
 ͼ}

Procedure Anim_Draw(A:TAnimate);
Var FName:String;
    L:Byte;
Begin
If Not A.Visible Then Exit;             {*Not visible*}

L:=Length(A.BaseName)-Str_LastPos('\',A.BaseName); {*Last Pos of '\'*}
FName:=A.BaseName+Str_FillZero(A.Index,8-L)+'.BMP';
If BMP_TestFile(FName) Then BMP_Show(A.C.x1,A.C.y1,A.C.x2,A.C.y2, A.Ox,A.Oy, FName,A.Id);
{If BMP_TestFile(FName) Then
   BMP_ShowTransparency(A.C.x1,A.C.y1,A.C.x2,A.C.y2, A.Ox,A.Oy, FName,A.Id, VESA_SetRGBColor(129,129,129));}
End;

{ͻ
                            FUNCTION Anim_GetMsg                            
 ͹
  IN.....: A (TAnimate) = Pointer to the Animate structure.                 
  OUT....: (BYTE) = Message result as :                                     
               CMNone               No messages                             
               CMFirstFrame         First frame displayed                   
               CMLastFrame          Last frame displayed                    
  EXPLAIN: Display a BMP animation.                                         
  SEEALSO: Anim_Draw, Anim_Pause                                            
 ͼ}

Function Anim_GetMsg(Var A:TAnimate):Byte;
Begin
Anim_GetMsg:=CMNone;
If Not A.Enabled Then Exit;             {*Not enabled*}

If A.FreqIndex>A.Frequency Then A.FreqIndex:=1;
If A.FreqIndex=A.Frequency Then Anim_Draw(A);{*Display current Frame*}

If A.Index=A.IndexMin Then Anim_GetMsg:=CMFirstFrame;{*First frame displayed*}
If A.Index=A.IndexMax Then Anim_GetMsg:=CMLastFrame; {*Last frame displayed*}

If A.FreqIndex=A.Frequency Then A.Index:=A.Index+A.FrameStep; {*Next frame*}
Inc(A.FreqIndex);                       {*Next index if frequency defined*}

If (A.Index<A.IndexMin) And (A.Reverse) Then
   Begin                                {*First frame reached and Reverse mode ?*}
   A.FrameStep:=-A.FrameStep;
   Inc(A.Index,2);
   End;

If A.Index>A.IndexMax Then              {*Last frame reached*}
   Begin

   If A.Reverse Then                    {*Reverse mode ?*}
      Begin
      A.FrameStep:=-A.FrameStep;
      Dec(A.Index,2);
      End
   Else A.Index:=A.IndexMin;            {*Normal mode*}
   If Not A.Cycling Then A.Enabled:=FALSE;
   End;
End;

{ͻ
                            PROCEDURE Anim_Pause                            
 ͹
  IN.....: A (TAnimate) = Pointer to the Animate structure.                 
           Status (BOOLEAN) = TRUE=Pause the animation, FALSE=Run animation 
  OUT....: /                                                                
  EXPLAIN: Pause or run a BMP animation.                                    
  SEEALSO: Anim, Anim_Draw                                                  
 ͼ}

Procedure Anim_Pause(Var A:TAnimate; Status:Boolean);
Begin
A.Enabled:=Not Status;
End;

{ͻ
                             PROCEDURE MseZone                              
 ͹
  IN.....: MZ (TMousePointer) = Pointer to the TMousePointer structure.     
           C (TCoordinates) = Box coordinates.                              
           MBAction (BYTE) = Mouse button to activate the Mouse Zone.       
           PName (STRING) = Mouse pointer file to use.                      
  OUT....: /                                                                
  EXPLAIN: Define a mouse pointer zone.                                     
  SEEALSO: MseZone_GetMsg                                                   
 ͼ}

Procedure MseZone(Var MZ:TMouseZone; C:TCoordinates; MBAction:Byte; PName,SHint:String);
Begin
Log.Add('Create new MouseZone ('+PName+')',2);
MZ.C:=C;
MZ.MBAction:=MBAction;
MZ.Value:=PName;
Hint(C.X1,C.Y1,C.X2,C.Y2, $0005,MZ.Hint,SHint); {*Define hint*}
End;

{ͻ
                          FUNCTION MseZone_GetMsg                           
 ͹
  IN.....: MZ (TMousePointer) = Pointer to the TMousePointer structure.     
  OUT....: (INTEGER) = Returned even else 0 if nothing happend.             
               CMNone               No messages                             
               CMSelected           Zone selected by mouse                  
               CMMouseOver          Mouse is over the zone                  
               CMHintShowed         Hint displayed                          
  EXPLAIN: Manage and get evens from the component.                         
  SEEALSO: MseZone                                                          
 ͼ}

Function MseZone_GetMsg(Var MZ:TMouseZone):Integer;
Begin
MseZone_GetMsg:=CMNone;

If Hint_GetMsg(MZ.Hint)=CMActivated Then MseZone_GetMsg:=CMHintShowed;

If Mse_TestBox(T_Clip.X1+MZ.C.X1, T_Clip.Y1+MZ.C.Y1, T_Clip.X1+MZ.C.X2, T_Clip.Y1+MZ.C.Y2, 10) Then
   Begin
   MseZone_GetMsg:=CMMouseOver;
   If Mse_Clicked(MZ.MBAction) Then MseZone_GetMsg:=CMSelected;
   If Not Sys.OnMouseZone Then Mse_SetPointer(MZ.Value); {*Set new mouse pointer*}
   Sys.OnMouseZone:=Yes;
   End;
End;

{*------------------------ PAS DE PROG PRINCIPAL ---------------------------*}

Begin
End.
